/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var re=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/instantiation/common/instantiation","vs/base/common/async","vs/platform/log/common/log","vs/base/common/uri","vs/base/common/errors","vs/nls","vs/nls!vs/code/electron-browser/sharedProcess/sharedProcessMain","vs/base/common/path","vs/platform/files/common/files","vs/base/common/types","vs/platform/environment/common/environment","vs/base/common/buffer","vs/base/common/arrays","vs/platform/configuration/common/configuration","vs/base/common/resources","vs/base/common/network","vs/platform/telemetry/common/telemetry","vs/platform/storage/common/storage","vs/base/common/cancellation","vs/platform/product/common/productService","vs/platform/userDataSync/common/userDataSync","vs/base/common/strings","vs/base/node/pfs","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/objects","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/uuid","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/json","os","vs/base/common/process","vs/base/common/errorMessage","vs/base/common/map","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/stream","vs/base/common/extpath","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/userDataSync/common/abstractSynchronizer","child_process","vs/platform/externalServices/common/serviceMachineId","vs/platform/extensions/common/extensions","vs/base/common/codicons","vs/base/common/iterator","vs/base/common/jsonFormatter","fs","vs/base/common/semver/semver","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/policy/common/policy","vs/platform/userDataSync/common/content","vs/base/common/decorators","net","vs/base/common/date","vs/base/common/hash","vs/base/common/marshalling","vs/base/parts/ipc/node/ipc.cp","vs/platform/extensions/common/extensionValidator","vs/platform/languagePacks/common/languagePacks","vs/platform/native/electron-sandbox/native","vs/platform/configuration/common/configurationModels","vs/platform/tunnel/common/tunnel","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/common/collections","vs/base/common/functional","vs/base/common/jsonEdit","vs/base/common/processes","vs/base/common/observableValue","vs/base/common/normalization","vs/base/common/severity","vs/base/common/glob","vs/base/node/powershell","vs/base/parts/ipc/common/ipc.net","electron","vs/base/parts/storage/common/storage","vs/base/node/processes","vs/platform/environment/common/environmentService","vs/platform/instantiation/common/extensions","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionRecommendations/common/extensionRecommendations","crypto","vs/platform/files/common/io","vs/platform/instantiation/common/serviceCollection","vs/platform/ipc/electron-sandbox/services","vs/platform/log/common/logIpc","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteHosts","vs/platform/sharedProcess/common/sharedProcessWorkerService","vs/platform/sign/common/sign","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/terminal/common/terminal","vs/platform/theme/common/themeService","vs/platform/userDataSync/common/ignoredExtensions","vs/base/node/zip","vs/platform/extensionManagement/node/extensionManagementService","vs/base/common/assert","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/skipList","vs/base/node/decoder","vs/base/node/macAddress","vs/base/node/ports","vs/base/parts/request/common/request","vs/base/parts/request/browser/request","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/mime","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/console","vs/base/common/uriIpc","vs/base/node/id","vs/base/node/extpath","vs/base/node/ps","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-browser/ipc.mp","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/platform/environment/node/argv","vs/platform/environment/node/argvHelper","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/configRemotes","vs/platform/extensionRecommendations/electron-sandbox/extensionRecommendationsIpc","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/contextkey/common/contextkey","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/ipc/electron-browser/mainProcessService","vs/code/electron-browser/sharedProcess/contrib/localizationsUpdater","vs/code/electron-browser/sharedProcess/contrib/logsDataCleaner","vs/code/electron-browser/sharedProcess/contrib/storageDataCleaner","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/platform/policy/common/policyIpc","vs/code/electron-browser/sharedProcess/contrib/codeCacheCleaner","vs/code/electron-browser/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/languagePacks/node/languagePacks","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/request/browser/requestService","vs/platform/download/common/downloadService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/sharedProcess/electron-browser/sharedProcessWorker","vs/platform/sharedProcess/electron-browser/sharedProcessWorkerService","vs/platform/sharedProcess/node/sharedProcessEnvironmentService","vs/platform/shell/node/shellEnv","vs/platform/sign/node/signService","vs/platform/storage/common/storageIpc","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/browser/1dsAppender","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/terminal/common/requestStore","vs/platform/terminal/electron-sandbox/terminal","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/platform/storage/electron-sandbox/storageService","vs/platform/userDataProfile/electron-sandbox/userDataProfile","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/electron-sandbox/userDataAutoSyncService","vs/platform/windows/node/windowTracker","vs/platform/extensionManagement/node/extensionManagementUtil","vs/code/electron-browser/sharedProcess/contrib/extensionsCleaner","vs/base/parts/ipc/node/ipc.net","vs/platform/remote/node/nodeSocketFactory","vs/platform/tunnel/node/tunnelService","string_decoder","util","minimist","assert","path","graceful-fs","yauzl","yazl","zlib","vs/code/electron-browser/sharedProcess/sharedProcessMain"],se=function(Z){for(var e=[],k=0,t=Z.length;k<t;k++)e[k]=re[Z[k]];return e};define(re[111],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function k(t,T){if(!t)throw new Error(T?`Assertion failed (${T})`:"Assertion Failed")}e.ok=k}),define(re[51],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function k(A){return A?A.replace(/\$\((.*?)\)/g,(I,b)=>` ${b} `).trim():""}e.getCodiconAriaLabel=k;class t{constructor(I,b,P){this.id=I,this.definition=b,this.description=P,t._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return t._allCodicons}}e.Codicon=t,t._allCodicons=[],t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",{fontCharacter:"\\ea71"}),t.closeDirty=new t("close-dirty",{fontCharacter:"\\ea71"}),t.debugBreakpoint=new t("debug-breakpoint",{fontCharacter:"\\ea71"}),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),t.debugHint=new t("debug-hint",{fontCharacter:"\\ea71"}),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circleOutline=new t("circle-outline",{fontCharacter:"\\eabc"}),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolCustomColor=new t("symbol-customcolor",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.circleSmallFilled=new t("circle-small-filled",{fontCharacter:"\\eb8a"}),t.debugStackframeDot=new t("debug-stackframe-dot",t.circleSmallFilled.definition),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLargeOutline=new t("circle-large-outline",{fontCharacter:"\\ebb5"}),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.layout=new t("layout",{fontCharacter:"\\ebeb"}),t.layoutActivitybarLeft=new t("layout-activitybar-left",{fontCharacter:"\\ebec"}),t.layoutActivitybarRight=new t("layout-activitybar-right",{fontCharacter:"\\ebed"}),t.layoutPanelLeft=new t("layout-panel-left",{fontCharacter:"\\ebee"}),t.layoutPanelCenter=new t("layout-panel-center",{fontCharacter:"\\ebef"}),t.layoutPanelJustify=new t("layout-panel-justify",{fontCharacter:"\\ebf0"}),t.layoutPanelRight=new t("layout-panel-right",{fontCharacter:"\\ebf1"}),t.layoutPanel=new t("layout-panel",{fontCharacter:"\\ebf2"}),t.layoutSidebarLeft=new t("layout-sidebar-left",{fontCharacter:"\\ebf3"}),t.layoutSidebarRight=new t("layout-sidebar-right",{fontCharacter:"\\ebf4"}),t.layoutStatusbar=new t("layout-statusbar",{fontCharacter:"\\ebf5"}),t.layoutMenubar=new t("layout-menubar",{fontCharacter:"\\ebf6"}),t.layoutCentered=new t("layout-centered",{fontCharacter:"\\ebf7"}),t.layoutSidebarRightOff=new t("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),t.layoutPanelOff=new t("layout-panel-off",{fontCharacter:"\\ec01"}),t.layoutSidebarLeftOff=new t("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),t.target=new t("target",{fontCharacter:"\\ebf8"}),t.indent=new t("indent",{fontCharacter:"\\ebf9"}),t.recordSmall=new t("record-small",{fontCharacter:"\\ebfa"}),t.errorSmall=new t("error-small",{fontCharacter:"\\ebfb"}),t.arrowCircleDown=new t("arrow-circle-down",{fontCharacter:"\\ebfc"}),t.arrowCircleLeft=new t("arrow-circle-left",{fontCharacter:"\\ebfd"}),t.arrowCircleRight=new t("arrow-circle-right",{fontCharacter:"\\ebfe"}),t.arrowCircleUp=new t("arrow-circle-up",{fontCharacter:"\\ebff"}),t.heartFilled=new t("heart-filled",{fontCharacter:"\\ec04"}),t.map=new t("map",{fontCharacter:"\\ec05"}),t.mapFilled=new t("map-filled",{fontCharacter:"\\ec06"}),t.circleSmall=new t("circle-small",{fontCharacter:"\\ec07"}),t.bellSlash=new t("bell-slash",{fontCharacter:"\\ec08"}),t.bellSlashDot=new t("bell-slash-dot",{fontCharacter:"\\f101"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);function T(A,I){const b=["codicon","codicon-"+A];return I&&b.push("codicon-modifier-"+I),b}e.getClassNamesArray=T;var L;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const I=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function b(E){if(E instanceof t)return["codicon","codicon-"+E.id];const p=I.exec(E.id);if(!p)return b(t.error);const[,C,h]=p,S=["codicon","codicon-"+C];return h&&S.push("codicon-modifier-"+h.substr(1)),S}A.asClassNameArray=b;function P(E){return b(E).join(" ")}A.asClassName=P;function D(E){return"."+b(E).join(".")}A.asCSSSelector=D})(L=e.CSSIcon||(e.CSSIcon={}))}),define(re[75],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.groupBy=e.forEach=void 0;function k(I,b){for(const[P,D]of Object.entries(I))if(b({key:P,value:D})===!1)return}e.forEach=k;function t(I,b){const P=Object.create(null);for(const D of I){const E=b(D);let p=P[E];p||(p=P[E]=[]),p.push(D)}return P}e.groupBy=t;function T(I,b){const P=[],D=[];for(const E of I)b.has(E)||P.push(E);for(const E of b)I.has(E)||D.push(E);return{removed:P,added:D}}e.diffSets=T;function L(I,b){const P=[],D=[];for(const[E,p]of I)b.has(E)||P.push(p);for(const[E,p]of b)I.has(E)||D.push(p);return{removed:P,added:D}}e.diffMaps=L;class A{constructor(){this.map=new Map}add(b,P){let D=this.map.get(b);D||(D=new Set,this.map.set(b,D)),D.add(P)}delete(b,P){const D=this.map.get(b);!D||(D.delete(P),D.size===0&&this.map.delete(b))}forEach(b,P){const D=this.map.get(b);!D||D.forEach(P)}}e.SetMap=A}),define(re[60],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function k(A){return(I,b,P)=>{let D=null,E=null;if(typeof P.value=="function"?(D="value",E=P.value):typeof P.get=="function"&&(D="get",E=P.get),!E)throw new Error("not supported");P[D]=A(E,b)}}e.createDecorator=k;function t(A,I,b){let P=null,D=null;if(typeof b.value=="function"?(P="value",D=b.value,D.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof b.get=="function"&&(P="get",D=b.get),!D)throw new Error("not supported");const E=`$memoize$${I}`;b[P]=function(...p){return this.hasOwnProperty(E)||Object.defineProperty(this,E,{configurable:!1,enumerable:!1,writable:!1,value:D.apply(this,p)}),this[E]}}e.memoize=t;function T(A,I,b){return k((P,D)=>{const E=`$debounce$${D}`,p=`$debounce$result$${D}`;return function(...C){this[p]||(this[p]=b?b():void 0),clearTimeout(this[E]),I&&(this[p]=I(this[p],...C),C=[this[p]]),this[E]=setTimeout(()=>{P.apply(this,C),this[p]=b?b():void 0},A)}})}e.debounce=T;function L(A,I,b){return k((P,D)=>{const E=`$throttle$timer$${D}`,p=`$throttle$result$${D}`,C=`$throttle$lastRun$${D}`,h=`$throttle$pending$${D}`;return function(...S){if(this[p]||(this[p]=b?b():void 0),(this[C]===null||this[C]===void 0)&&(this[C]=-Number.MAX_VALUE),I&&(this[p]=I(this[p],...S)),this[h])return;const w=this[C]+A;w<=Date.now()?(this[C]=Date.now(),P.apply(this,[this[p]]),this[p]=b?b():void 0):(this[h]=!0,this[E]=setTimeout(()=>{this[h]=!1,this[C]=Date.now(),P.apply(this,[this[p]]),this[p]=b?b():void 0},w-Date.now()))}})}e.throttle=L}),define(re[9],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class k{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(r){setTimeout(()=>{throw r.stack?g.isErrorNoTelemetry(r)?new g(r.message+`

`+r.stack):new Error(r.message+`

`+r.stack):r},0)}}addListener(r){return this.listeners.push(r),()=>{this._removeListener(r)}}emit(r){this.listeners.forEach(n=>{n(r)})}_removeListener(r){this.listeners.splice(this.listeners.indexOf(r),1)}setUnexpectedErrorHandler(r){this.unexpectedErrorHandler=r}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(r){this.unexpectedErrorHandler(r),this.emit(r)}onUnexpectedExternalError(r){this.unexpectedErrorHandler(r)}}e.ErrorHandler=k,e.errorHandler=new k;function t(u){e.errorHandler.setUnexpectedErrorHandler(u)}e.setUnexpectedErrorHandler=t;function T(u){b(u)||e.errorHandler.onUnexpectedError(u)}e.onUnexpectedError=T;function L(u){b(u)||e.errorHandler.onUnexpectedExternalError(u)}e.onUnexpectedExternalError=L;function A(u){if(u instanceof Error){const{name:r,message:n}=u,i=u.stacktrace||u.stack;return{$isError:!0,name:r,message:n,stack:i,noTelemetry:g.isErrorNoTelemetry(u)}}return u}e.transformErrorForSerialization=A;const I="Canceled";function b(u){return u instanceof P?!0:u instanceof Error&&u.name===I&&u.message===I}e.isCancellationError=b;class P extends Error{constructor(){super(I);this.name=this.message}}e.CancellationError=P;function D(){const u=new Error(I);return u.name=u.message,u}e.canceled=D;function E(u){return u?new Error(`Illegal argument: ${u}`):new Error("Illegal argument")}e.illegalArgument=E;function p(u){return u?new Error(`Illegal state: ${u}`):new Error("Illegal state")}e.illegalState=p;function C(u){return u?new Error(`readonly property '${u} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=C;function h(u){const r=new Error(`${u} has been disposed`);return r.name="DISPOSED",r}e.disposed=h;function S(u){return u?u.message?u.message:u.stack?u.stack.split(`
`)[0]:String(u):"Error"}e.getErrorMessage=S;class w extends Error{constructor(r){super("NotImplemented");r&&(this.message=r)}}e.NotImplementedError=w;class d extends Error{constructor(r){super("NotSupported");r&&(this.message=r)}}e.NotSupportedError=d;class m extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=m;class g extends Error{constructor(r){super(r);this.name="ErrorNoTelemetry"}static fromError(r){if(r instanceof g)return r;const n=new g;return n.message=r.message,n.stack=r.stack,n}static isErrorNoTelemetry(r){return r.name==="ErrorNoTelemetry"}}e.ErrorNoTelemetry=g;class f extends Error{constructor(r){super(r||"An unexpected bug occurred.");Object.setPrototypeOf(this,f.prototype);debugger}}e.BugIndicatingError=f}),define(re[17],se([0,1,9]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function t(q,ee=0){return q[q.length-(1+ee)]}e.tail=t;function T(q){if(q.length===0)throw new Error("Invalid tail call");return[q.slice(0,q.length-1),q[q.length-1]]}e.tail2=T;function L(q,ee,ne=(oe,le)=>oe===le){if(q===ee)return!0;if(!q||!ee||q.length!==ee.length)return!1;for(let oe=0,le=q.length;oe<le;oe++)if(!ne(q[oe],ee[oe]))return!1;return!0}e.equals=L;function A(q,ee,ne){return I(q.length,oe=>ne(q[oe],ee))}e.binarySearch=A;function I(q,ee){let ne=0,oe=q-1;for(;ne<=oe;){const le=(ne+oe)/2|0,Se=ee(le);if(Se<0)ne=le+1;else if(Se>0)oe=le-1;else return le}return-(ne+1)}e.binarySearch2=I;function b(q,ee){let ne=0,oe=q.length;if(oe===0)return 0;for(;ne<oe;){const le=Math.floor((ne+oe)/2);ee(q[le])?oe=le:ne=le+1}return ne}e.findFirstInSorted=b;function P(q,ee,ne){if(q=q|0,q>=ee.length)throw new TypeError("invalid index");const oe=ee[Math.floor(ee.length*Math.random())],le=[],Se=[],fe=[];for(const pe of ee){const Ce=ne(pe,oe);Ce<0?le.push(pe):Ce>0?Se.push(pe):fe.push(pe)}return q<le.length?P(q,le,ne):q<le.length+fe.length?fe[0]:P(q-(le.length+fe.length),Se,ne)}e.quickSelect=P;function D(q,ee){const ne=[];let oe;for(const le of q.slice(0).sort(ee))!oe||ee(oe[0],le)!==0?(oe=[le],ne.push(oe)):oe.push(le);return ne}e.groupBy=D;function E(q,ee,ne){const oe=[];function le(pe,Ce,be){if(Ce===0&&be.length===0)return;const Ie=oe[oe.length-1];Ie&&Ie.start+Ie.deleteCount===pe?(Ie.deleteCount+=Ce,Ie.toInsert.push(...be)):oe.push({start:pe,deleteCount:Ce,toInsert:be})}let Se=0,fe=0;for(;;){if(Se===q.length){le(Se,0,ee.slice(fe));break}if(fe===ee.length){le(Se,q.length-Se,[]);break}const pe=q[Se],Ce=ee[fe],be=ne(pe,Ce);be===0?(Se+=1,fe+=1):be<0?(le(Se,1,[]),Se+=1):be>0&&(le(Se,0,[Ce]),fe+=1)}return oe}e.sortedDiff=E;function p(q,ee,ne){const oe=E(q,ee,ne),le=[],Se=[];for(const fe of oe)le.push(...q.slice(fe.start,fe.start+fe.deleteCount)),Se.push(...fe.toInsert);return{removed:le,added:Se}}e.delta=p;function C(q,ee,ne){if(ne===0)return[];const oe=q.slice(0,ne).sort(ee);return S(q,ee,oe,ne,q.length),oe}e.top=C;function h(q,ee,ne,oe,le){return ne===0?Promise.resolve([]):new Promise((Se,fe)=>{(async()=>{const pe=q.length,Ce=q.slice(0,ne).sort(ee);for(let be=ne,Ie=Math.min(ne+oe,pe);be<pe;be=Ie,Ie=Math.min(Ie+oe,pe)){if(be>ne&&await new Promise(qe=>setTimeout(qe)),le&&le.isCancellationRequested)throw new k.CancellationError;S(q,ee,Ce,be,Ie)}return Ce})().then(Se,fe)})}e.topAsync=h;function S(q,ee,ne,oe,le){for(const Se=ne.length;oe<le;oe++){const fe=q[oe];if(ee(fe,ne[Se-1])<0){ne.pop();const pe=b(ne,Ce=>ee(fe,Ce)<0);ne.splice(pe,0,fe)}}}function w(q){return q.filter(ee=>!!ee)}e.coalesce=w;function d(q){let ee=0;for(let ne=0;ne<q.length;ne++)q[ne]&&(q[ee]=q[ne],ee+=1);q.length=ee}e.coalesceInPlace=d;function m(q,ee,ne){q.splice(ne,0,q.splice(ee,1)[0])}e.move=m;function g(q){return!Array.isArray(q)||q.length===0}e.isFalsyOrEmpty=g;function f(q){return Array.isArray(q)&&q.length>0}e.isNonEmptyArray=f;function u(q,ee=ne=>ne){const ne=new Set;return q.filter(oe=>{const le=ee(oe);return ne.has(le)?!1:(ne.add(le),!0)})}e.distinct=u;function r(q){const ee=new Set;return ne=>{const oe=q(ne);return ee.has(oe)?!1:(ee.add(oe),!0)}}e.uniqueFilter=r;function n(q,ee){const ne=i(q,ee);if(ne!==-1)return q[ne]}e.findLast=n;function i(q,ee){for(let ne=q.length-1;ne>=0;ne--){const oe=q[ne];if(ee(oe))return ne}return-1}e.lastIndex=i;function a(q,ee){return q.length>0?q[0]:ee}e.firstOrDefault=a;function c(q,ee){return q.length>0?q[q.length-1]:ee}e.lastOrDefault=c;function s(q,ee,ne=(oe,le)=>oe===le){let oe=0;for(let le=0,Se=Math.min(q.length,ee.length);le<Se&&ne(q[le],ee[le]);le++)oe++;return oe}e.commonPrefixLength=s;function o(q){return[].concat(...q)}e.flatten=o;function l(q,ee){let ne=typeof ee=="number"?q:0;typeof ee=="number"?ne=q:(ne=0,ee=q);const oe=[];if(ne<=ee)for(let le=ne;le<ee;le++)oe.push(le);else for(let le=ne;le>ee;le--)oe.push(le);return oe}e.range=l;function v(q,ee,ne){return q.reduce((oe,le)=>(oe[ee(le)]=ne?ne(le):le,oe),Object.create(null))}e.index=v;function y(q,ee){return q.push(ee),()=>O(q,ee)}e.insert=y;function O(q,ee){const ne=q.indexOf(ee);if(ne>-1)return q.splice(ne,1),ee}e.remove=O;function _(q,ee,ne){const oe=q.slice(0,ee),le=q.slice(ee);return oe.concat(ne,le)}e.arrayInsert=_;function F(q,ee){let ne;if(typeof ee=="number"){let oe=ee;ne=()=>{const le=Math.sin(oe++)*179426549;return le-Math.floor(le)}}else ne=Math.random;for(let oe=q.length-1;oe>0;oe-=1){const le=Math.floor(ne()*(oe+1)),Se=q[oe];q[oe]=q[le],q[le]=Se}}e.shuffle=F;function R(q,ee){const ne=q.indexOf(ee);ne>-1&&(q.splice(ne,1),q.unshift(ee))}e.pushToStart=R;function U(q,ee){const ne=q.indexOf(ee);ne>-1&&(q.splice(ne,1),q.push(ee))}e.pushToEnd=U;function M(q,ee){for(const ne of ee)q.push(ne)}e.pushMany=M;function V(q,ee){return Array.isArray(q)?q.map(ee):ee(q)}e.mapArrayOrNot=V;function W(q){return Array.isArray(q)?q:[q]}e.asArray=W;function z(q){return q[Math.floor(Math.random()*q.length)]}e.getRandomElement=z;function te(q,ee){for(const ne of q){const oe=ee(ne);if(oe!==void 0)return oe}}e.mapFind=te;function H(q,ee,ne){const oe=X(q,ee),le=q.length,Se=ne.length;q.length=le+Se;for(let fe=le-1;fe>=oe;fe--)q[fe+Se]=q[fe];for(let fe=0;fe<Se;fe++)q[fe+oe]=ne[fe]}e.insertInto=H;function K(q,ee,ne,oe){const le=X(q,ee),Se=q.splice(le,ne);return H(q,le,oe),Se}e.splice=K;function X(q,ee){return ee<0?Math.max(ee+q.length,0):Math.min(ee,q.length)}var Y;(function(q){function ee(le){return le<0}q.isLessThan=ee;function ne(le){return le>0}q.isGreaterThan=ne;function oe(le){return le===0}q.isNeitherLessOrGreaterThan=oe,q.greaterThan=1,q.lessThan=-1,q.neitherLessOrGreaterThan=0})(Y=e.CompareResult||(e.CompareResult={}));function x(q,ee){return(ne,oe)=>ee(q(ne),q(oe))}e.compareBy=x;function B(...q){return(ee,ne)=>{for(const oe of q){const le=oe(ee,ne);if(!Y.isNeitherLessOrGreaterThan(le))return le}return Y.neitherLessOrGreaterThan}}e.tieBreakComparators=B;const J=(q,ee)=>q-ee;e.numberComparator=J;function N(q,ee){if(q.length===0)return;let ne=q[0];for(let oe=1;oe<q.length;oe++){const le=q[oe];ee(le,ne)>0&&(ne=le)}return ne}e.findMaxBy=N;function $(q,ee){if(q.length===0)return;let ne=q[0];for(let oe=1;oe<q.length;oe++){const le=q[oe];ee(le,ne)>=0&&(ne=le)}return ne}e.findLastMaxBy=$;function j(q,ee){return N(q,(ne,oe)=>-ee(ne,oe))}e.findMinBy=j;class G{constructor(ee){this.items=ee,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(ee){let ne=this.firstIdx;for(;ne<this.items.length&&ee(this.items[ne]);)ne++;const oe=ne===this.firstIdx?null:this.items.slice(this.firstIdx,ne);return this.firstIdx=ne,oe}takeFromEndWhile(ee){let ne=this.lastIdx;for(;ne>=0&&ee(this.items[ne]);)ne--;const oe=ne===this.lastIdx?null:this.items.slice(ne+1,this.lastIdx+1);return this.lastIdx=ne,oe}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const ee=this.items[this.firstIdx];return this.firstIdx++,ee}removeLast(){const ee=this.items[this.lastIdx];return this.lastIdx--,ee}takeCount(ee){const ne=this.items.slice(this.firstIdx,this.firstIdx+ee);return this.firstIdx+=ee,ne}}e.ArrayQueue=G}),define(re[76],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function k(t){const T=this;let L=!1,A;return function(){return L||(L=!0,A=t.apply(T,arguments)),A}}e.once=k}),define(re[52],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var k;(function(t){function T(n){return n&&typeof n=="object"&&typeof n[Symbol.iterator]=="function"}t.is=T;const L=Object.freeze([]);function A(){return L}t.empty=A;function*I(n){yield n}t.single=I;function b(n){return n||L}t.from=b;function P(n){return!n||n[Symbol.iterator]().next().done===!0}t.isEmpty=P;function D(n){return n[Symbol.iterator]().next().value}t.first=D;function E(n,i){for(const a of n)if(i(a))return!0;return!1}t.some=E;function p(n,i){for(const a of n)if(i(a))return a}t.find=p;function*C(n,i){for(const a of n)i(a)&&(yield a)}t.filter=C;function*h(n,i){let a=0;for(const c of n)yield i(c,a++)}t.map=h;function*S(...n){for(const i of n)for(const a of i)yield a}t.concat=S;function*w(n){for(const i of n)for(const a of i)yield a}t.concatNested=w;function d(n,i,a){let c=a;for(const s of n)c=i(c,s);return c}t.reduce=d;function m(n,i){let a=0;for(const c of n)i(c,a++)}t.forEach=m;function*g(n,i,a=n.length){for(i<0&&(i+=n.length),a<0?a+=n.length:a>n.length&&(a=n.length);i<a;i++)yield n[i]}t.slice=g;function f(n,i=Number.POSITIVE_INFINITY){const a=[];if(i===0)return[a,n];const c=n[Symbol.iterator]();for(let s=0;s<i;s++){const o=c.next();if(o.done)return[a,t.empty()];a.push(o.value)}return[a,{[Symbol.iterator](){return c}}]}t.consume=f;function u(n){return f(n)[0]}t.collect=u;function r(n,i,a=(c,s)=>c===s){const c=n[Symbol.iterator](),s=i[Symbol.iterator]();for(;;){const o=c.next(),l=s.next();if(o.done!==l.done)return!1;if(o.done)return!0;if(!a(o.value,l.value))return!1}}t.equals=r})(k=e.Iterable||(e.Iterable={}))}),define(re[34],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var k;(function(r){r[r.None=0]="None",r[r.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=2]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",r[r.InvalidUnicode=4]="InvalidUnicode",r[r.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",r[r.InvalidCharacter=6]="InvalidCharacter"})(k=e.ScanError||(e.ScanError={}));var t;(function(r){r[r.OpenBraceToken=1]="OpenBraceToken",r[r.CloseBraceToken=2]="CloseBraceToken",r[r.OpenBracketToken=3]="OpenBracketToken",r[r.CloseBracketToken=4]="CloseBracketToken",r[r.CommaToken=5]="CommaToken",r[r.ColonToken=6]="ColonToken",r[r.NullKeyword=7]="NullKeyword",r[r.TrueKeyword=8]="TrueKeyword",r[r.FalseKeyword=9]="FalseKeyword",r[r.StringLiteral=10]="StringLiteral",r[r.NumericLiteral=11]="NumericLiteral",r[r.LineCommentTrivia=12]="LineCommentTrivia",r[r.BlockCommentTrivia=13]="BlockCommentTrivia",r[r.LineBreakTrivia=14]="LineBreakTrivia",r[r.Trivia=15]="Trivia",r[r.Unknown=16]="Unknown",r[r.EOF=17]="EOF"})(t=e.SyntaxKind||(e.SyntaxKind={}));var T;(function(r){r[r.InvalidSymbol=1]="InvalidSymbol",r[r.InvalidNumberFormat=2]="InvalidNumberFormat",r[r.PropertyNameExpected=3]="PropertyNameExpected",r[r.ValueExpected=4]="ValueExpected",r[r.ColonExpected=5]="ColonExpected",r[r.CommaExpected=6]="CommaExpected",r[r.CloseBraceExpected=7]="CloseBraceExpected",r[r.CloseBracketExpected=8]="CloseBracketExpected",r[r.EndOfFileExpected=9]="EndOfFileExpected",r[r.InvalidCommentToken=10]="InvalidCommentToken",r[r.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=12]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",r[r.InvalidUnicode=14]="InvalidUnicode",r[r.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",r[r.InvalidCharacter=16]="InvalidCharacter"})(T=e.ParseErrorCode||(e.ParseErrorCode={}));var L;(function(r){r.DEFAULT={allowTrailingComma:!0}})(L=e.ParseOptions||(e.ParseOptions={}));function A(r,n=!1){let i=0;const a=r.length;let c="",s=0,o=16,l=0;function v(M){let V=0,W=0;for(;V<M;){const z=r.charCodeAt(i);if(z>=48&&z<=57)W=W*16+z-48;else if(z>=65&&z<=70)W=W*16+z-65+10;else if(z>=97&&z<=102)W=W*16+z-97+10;else break;i++,V++}return V<M&&(W=-1),W}function y(M){i=M,c="",s=0,o=16,l=0}function O(){const M=i;if(r.charCodeAt(i)===48)i++;else for(i++;i<r.length&&P(r.charCodeAt(i));)i++;if(i<r.length&&r.charCodeAt(i)===46)if(i++,i<r.length&&P(r.charCodeAt(i)))for(i++;i<r.length&&P(r.charCodeAt(i));)i++;else return l=3,r.substring(M,i);let V=i;if(i<r.length&&(r.charCodeAt(i)===69||r.charCodeAt(i)===101))if(i++,(i<r.length&&r.charCodeAt(i)===43||r.charCodeAt(i)===45)&&i++,i<r.length&&P(r.charCodeAt(i))){for(i++;i<r.length&&P(r.charCodeAt(i));)i++;V=i}else l=3;return r.substring(M,V)}function _(){let M="",V=i;for(;;){if(i>=a){M+=r.substring(V,i),l=2;break}const W=r.charCodeAt(i);if(W===34){M+=r.substring(V,i),i++;break}if(W===92){if(M+=r.substring(V,i),i++,i>=a){l=2;break}switch(r.charCodeAt(i++)){case 34:M+='"';break;case 92:M+="\\";break;case 47:M+="/";break;case 98:M+="\b";break;case 102:M+="\f";break;case 110:M+=`
`;break;case 114:M+="\r";break;case 116:M+="	";break;case 117:{const te=v(4);te>=0?M+=String.fromCharCode(te):l=4;break}default:l=5}V=i;continue}if(W>=0&&W<=31)if(b(W)){M+=r.substring(V,i),l=2;break}else l=6;i++}return M}function F(){if(c="",l=0,s=i,i>=a)return s=a,o=17;let M=r.charCodeAt(i);if(I(M)){do i++,c+=String.fromCharCode(M),M=r.charCodeAt(i);while(I(M));return o=15}if(b(M))return i++,c+=String.fromCharCode(M),M===13&&r.charCodeAt(i)===10&&(i++,c+=`
`),o=14;switch(M){case 123:return i++,o=1;case 125:return i++,o=2;case 91:return i++,o=3;case 93:return i++,o=4;case 58:return i++,o=6;case 44:return i++,o=5;case 34:return i++,c=_(),o=10;case 47:{const V=i-1;if(r.charCodeAt(i+1)===47){for(i+=2;i<a&&!b(r.charCodeAt(i));)i++;return c=r.substring(V,i),o=12}if(r.charCodeAt(i+1)===42){i+=2;const W=a-1;let z=!1;for(;i<W;){if(r.charCodeAt(i)===42&&r.charCodeAt(i+1)===47){i+=2,z=!0;break}i++}return z||(i++,l=1),c=r.substring(V,i),o=13}return c+=String.fromCharCode(M),i++,o=16}case 45:if(c+=String.fromCharCode(M),i++,i===a||!P(r.charCodeAt(i)))return o=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return c+=O(),o=11;default:for(;i<a&&R(M);)i++,M=r.charCodeAt(i);if(s!==i){switch(c=r.substring(s,i),c){case"true":return o=8;case"false":return o=9;case"null":return o=7}return o=16}return c+=String.fromCharCode(M),i++,o=16}}function R(M){if(I(M)||b(M))return!1;switch(M){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function U(){let M;do M=F();while(M>=12&&M<=15);return M}return{setPosition:y,getPosition:()=>i,scan:n?U:F,getToken:()=>o,getTokenValue:()=>c,getTokenOffset:()=>s,getTokenLength:()=>i-s,getTokenError:()=>l}}e.createScanner=A;function I(r){return r===32||r===9||r===11||r===12||r===160||r===5760||r>=8192&&r<=8203||r===8239||r===8287||r===12288||r===65279}function b(r){return r===10||r===13||r===8232||r===8233}function P(r){return r>=48&&r<=57}var D;(function(r){r[r.nullCharacter=0]="nullCharacter",r[r.maxAsciiCharacter=127]="maxAsciiCharacter",r[r.lineFeed=10]="lineFeed",r[r.carriageReturn=13]="carriageReturn",r[r.lineSeparator=8232]="lineSeparator",r[r.paragraphSeparator=8233]="paragraphSeparator",r[r.nextLine=133]="nextLine",r[r.space=32]="space",r[r.nonBreakingSpace=160]="nonBreakingSpace",r[r.enQuad=8192]="enQuad",r[r.emQuad=8193]="emQuad",r[r.enSpace=8194]="enSpace",r[r.emSpace=8195]="emSpace",r[r.threePerEmSpace=8196]="threePerEmSpace",r[r.fourPerEmSpace=8197]="fourPerEmSpace",r[r.sixPerEmSpace=8198]="sixPerEmSpace",r[r.figureSpace=8199]="figureSpace",r[r.punctuationSpace=8200]="punctuationSpace",r[r.thinSpace=8201]="thinSpace",r[r.hairSpace=8202]="hairSpace",r[r.zeroWidthSpace=8203]="zeroWidthSpace",r[r.narrowNoBreakSpace=8239]="narrowNoBreakSpace",r[r.ideographicSpace=12288]="ideographicSpace",r[r.mathematicalSpace=8287]="mathematicalSpace",r[r.ogham=5760]="ogham",r[r._=95]="_",r[r.$=36]="$",r[r._0=48]="_0",r[r._1=49]="_1",r[r._2=50]="_2",r[r._3=51]="_3",r[r._4=52]="_4",r[r._5=53]="_5",r[r._6=54]="_6",r[r._7=55]="_7",r[r._8=56]="_8",r[r._9=57]="_9",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.ampersand=38]="ampersand",r[r.asterisk=42]="asterisk",r[r.at=64]="at",r[r.backslash=92]="backslash",r[r.bar=124]="bar",r[r.caret=94]="caret",r[r.closeBrace=125]="closeBrace",r[r.closeBracket=93]="closeBracket",r[r.closeParen=41]="closeParen",r[r.colon=58]="colon",r[r.comma=44]="comma",r[r.dot=46]="dot",r[r.doubleQuote=34]="doubleQuote",r[r.equals=61]="equals",r[r.exclamation=33]="exclamation",r[r.greaterThan=62]="greaterThan",r[r.lessThan=60]="lessThan",r[r.minus=45]="minus",r[r.openBrace=123]="openBrace",r[r.openBracket=91]="openBracket",r[r.openParen=40]="openParen",r[r.percent=37]="percent",r[r.plus=43]="plus",r[r.question=63]="question",r[r.semicolon=59]="semicolon",r[r.singleQuote=39]="singleQuote",r[r.slash=47]="slash",r[r.tilde=126]="tilde",r[r.backspace=8]="backspace",r[r.formFeed=12]="formFeed",r[r.byteOrderMark=65279]="byteOrderMark",r[r.tab=9]="tab",r[r.verticalTab=11]="verticalTab"})(D||(D={}));function E(r,n){const i=[],a=new Object;let c;const s={value:{},offset:0,length:0,type:"object",parent:void 0};let o=!1;function l(v,y,O,_){s.value=v,s.offset=y,s.length=O,s.type=_,s.colonOffset=void 0,c=s}try{g(r,{onObjectBegin:(v,y)=>{if(n<=v)throw a;c=void 0,o=n>v,i.push("")},onObjectProperty:(v,y,O)=>{if(n<y||(l(v,y,O,"property"),i[i.length-1]=v,n<=y+O))throw a},onObjectEnd:(v,y)=>{if(n<=v)throw a;c=void 0,i.pop()},onArrayBegin:(v,y)=>{if(n<=v)throw a;c=void 0,i.push(0)},onArrayEnd:(v,y)=>{if(n<=v)throw a;c=void 0,i.pop()},onLiteralValue:(v,y,O)=>{if(n<y||(l(v,y,O,u(v)),n<=y+O))throw a},onSeparator:(v,y,O)=>{if(n<=y)throw a;if(v===":"&&c&&c.type==="property")c.colonOffset=y,o=!1,c=void 0;else if(v===","){const _=i[i.length-1];typeof _=="number"?i[i.length-1]=_+1:(o=!0,i[i.length-1]=""),c=void 0}}})}catch(v){if(v!==a)throw v}return{path:i,previousNode:c,isAtPropertyKey:o,matches:v=>{let y=0;for(let O=0;y<v.length&&O<i.length;O++)if(v[y]===i[O]||v[y]==="*")y++;else if(v[y]!=="**")return!1;return y===v.length}}}e.getLocation=E;function p(r,n=[],i=L.DEFAULT){let a=null,c=[];const s=[];function o(v){Array.isArray(c)?c.push(v):a!==null&&(c[a]=v)}return g(r,{onObjectBegin:()=>{const v={};o(v),s.push(c),c=v,a=null},onObjectProperty:v=>{a=v},onObjectEnd:()=>{c=s.pop()},onArrayBegin:()=>{const v=[];o(v),s.push(c),c=v,a=null},onArrayEnd:()=>{c=s.pop()},onLiteralValue:o,onError:(v,y,O)=>{n.push({error:v,offset:y,length:O})}},i),c[0]}e.parse=p;function C(r,n=[],i=L.DEFAULT){let a={type:"array",offset:-1,length:-1,children:[],parent:void 0};function c(v){a.type==="property"&&(a.length=v-a.offset,a=a.parent)}function s(v){return a.children.push(v),v}g(r,{onObjectBegin:v=>{a=s({type:"object",offset:v,length:-1,parent:a,children:[]})},onObjectProperty:(v,y,O)=>{a=s({type:"property",offset:y,length:-1,parent:a,children:[]}),a.children.push({type:"string",value:v,offset:y,length:O,parent:a})},onObjectEnd:(v,y)=>{a.length=v+y-a.offset,a=a.parent,c(v+y)},onArrayBegin:(v,y)=>{a=s({type:"array",offset:v,length:-1,parent:a,children:[]})},onArrayEnd:(v,y)=>{a.length=v+y-a.offset,a=a.parent,c(v+y)},onLiteralValue:(v,y,O)=>{s({type:u(v),offset:y,length:O,parent:a,value:v}),c(y+O)},onSeparator:(v,y,O)=>{a.type==="property"&&(v===":"?a.colonOffset=y:v===","&&c(y))},onError:(v,y,O)=>{n.push({error:v,offset:y,length:O})}},i);const l=a.children[0];return l&&delete l.parent,l}e.parseTree=C;function h(r,n){if(!r)return;let i=r;for(const a of n)if(typeof a=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let c=!1;for(const s of i.children)if(Array.isArray(s.children)&&s.children[0].value===a){i=s.children[1],c=!0;break}if(!c)return}else{const c=a;if(i.type!=="array"||c<0||!Array.isArray(i.children)||c>=i.children.length)return;i=i.children[c]}return i}e.findNodeAtLocation=h;function S(r){if(!r.parent||!r.parent.children)return[];const n=S(r.parent);if(r.parent.type==="property"){const i=r.parent.children[0].value;n.push(i)}else if(r.parent.type==="array"){const i=r.parent.children.indexOf(r);i!==-1&&n.push(i)}return n}e.getNodePath=S;function w(r){switch(r.type){case"array":return r.children.map(w);case"object":{const n=Object.create(null);for(const i of r.children){const a=i.children[1];a&&(n[i.children[0].value]=w(a))}return n}case"null":case"string":case"number":case"boolean":return r.value;default:return}}e.getNodeValue=w;function d(r,n,i=!1){return n>=r.offset&&n<r.offset+r.length||i&&n===r.offset+r.length}e.contains=d;function m(r,n,i=!1){if(d(r,n,i)){const a=r.children;if(Array.isArray(a))for(let c=0;c<a.length&&a[c].offset<=n;c++){const s=m(a[c],n,i);if(s)return s}return r}}e.findNodeAtOffset=m;function g(r,n,i=L.DEFAULT){const a=A(r,!1);function c(B){return B?()=>B(a.getTokenOffset(),a.getTokenLength()):()=>!0}function s(B){return B?J=>B(J,a.getTokenOffset(),a.getTokenLength()):()=>!0}const o=c(n.onObjectBegin),l=s(n.onObjectProperty),v=c(n.onObjectEnd),y=c(n.onArrayBegin),O=c(n.onArrayEnd),_=s(n.onLiteralValue),F=s(n.onSeparator),R=c(n.onComment),U=s(n.onError),M=i&&i.disallowComments,V=i&&i.allowTrailingComma;function W(){for(;;){const B=a.scan();switch(a.getTokenError()){case 4:z(14);break;case 5:z(15);break;case 3:z(13);break;case 1:M||z(11);break;case 2:z(12);break;case 6:z(16);break}switch(B){case 12:case 13:M?z(10):R();break;case 16:z(1);break;case 15:case 14:break;default:return B}}}function z(B,J=[],N=[]){if(U(B),J.length+N.length>0){let $=a.getToken();for(;$!==17;){if(J.indexOf($)!==-1){W();break}else if(N.indexOf($)!==-1)break;$=W()}}}function te(B){const J=a.getTokenValue();return B?_(J):l(J),W(),!0}function H(){switch(a.getToken()){case 11:{let B=0;try{B=JSON.parse(a.getTokenValue()),typeof B!="number"&&(z(2),B=0)}catch{z(2)}_(B);break}case 7:_(null);break;case 8:_(!0);break;case 9:_(!1);break;default:return!1}return W(),!0}function K(){return a.getToken()!==10?(z(3,[],[2,5]),!1):(te(!1),a.getToken()===6?(F(":"),W(),x()||z(4,[],[2,5])):z(5,[],[2,5]),!0)}function X(){o(),W();let B=!1;for(;a.getToken()!==2&&a.getToken()!==17;){if(a.getToken()===5){if(B||z(4,[],[]),F(","),W(),a.getToken()===2&&V)break}else B&&z(6,[],[]);K()||z(4,[],[2,5]),B=!0}return v(),a.getToken()!==2?z(7,[2],[]):W(),!0}function Y(){y(),W();let B=!1;for(;a.getToken()!==4&&a.getToken()!==17;){if(a.getToken()===5){if(B||z(4,[],[]),F(","),W(),a.getToken()===4&&V)break}else B&&z(6,[],[]);x()||z(4,[],[4,5]),B=!0}return O(),a.getToken()!==4?z(8,[4],[]):W(),!0}function x(){switch(a.getToken()){case 3:return Y();case 1:return X();case 10:return te(!0);default:return H()}}return W(),a.getToken()===17?i.allowEmptyContent?!0:(z(4,[],[]),!1):x()?(a.getToken()!==17&&z(9,[],[]),!0):(z(4,[],[]),!1)}e.visit=g;function f(r,n){const i=A(r),a=[];let c,s=0,o;do switch(o=i.getPosition(),c=i.scan(),c){case 12:case 13:case 17:s!==o&&a.push(r.substring(s,o)),n!==void 0&&a.push(i.getTokenValue().replace(/[^\r\n]/g,n)),s=i.getPosition();break}while(c!==17);return a.join("")}e.stripComments=f;function u(r){switch(typeof r){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(r){if(Array.isArray(r))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=u}),define(re[53],se([0,1,34]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function t(P,D,E){let p,C,h,S,w;if(D){for(S=D.offset,w=S+D.length,h=S;h>0&&!b(P,h-1);)h--;let o=w;for(;o<P.length&&!b(P,o);)o++;C=P.substring(h,o),p=A(C,E)}else C=P,p=0,h=0,S=0,w=P.length;const d=I(E,P);let m=!1,g=0,f;E.insertSpaces?f=L(" ",E.tabSize||4):f="	";const u=(0,k.createScanner)(C,!1);let r=!1;function n(){return d+L(f,p+g)}function i(){let o=u.scan();for(m=!1;o===15||o===14;)m=m||o===14,o=u.scan();return r=o===16||u.getTokenError()!==0,o}const a=[];function c(o,l,v){!r&&l<w&&v>S&&P.substring(l,v)!==o&&a.push({offset:l,length:v-l,content:o})}let s=i();if(s!==17){const o=u.getTokenOffset()+h,l=L(f,p);c(l,h,o)}for(;s!==17;){let o=u.getTokenOffset()+u.getTokenLength()+h,l=i(),v="";for(;!m&&(l===12||l===13);){const O=u.getTokenOffset()+h;c(" ",o,O),o=u.getTokenOffset()+u.getTokenLength()+h,v=l===12?n():"",l=i()}if(l===2)s!==1&&(g--,v=n());else if(l===4)s!==3&&(g--,v=n());else{switch(s){case 3:case 1:g++,v=n();break;case 5:case 12:v=n();break;case 13:m?v=n():v=" ";break;case 6:v=" ";break;case 10:if(l===6){v="";break}case 7:case 8:case 9:case 11:case 2:case 4:l===12||l===13?v=" ":l!==5&&l!==17&&(r=!0);break;case 16:r=!0;break}m&&(l===12||l===13)&&(v=n())}const y=u.getTokenOffset()+h;c(v,o,y),s=l}return a}e.format=t;function T(P,D){const E=JSON.stringify(P,void 0,D.insertSpaces?D.tabSize||4:"	");return D.eol!==void 0?E.replace(/\r\n|\r|\n/g,D.eol):E}e.toFormattedString=T;function L(P,D){let E="";for(let p=0;p<D;p++)E+=P;return E}function A(P,D){let E=0,p=0;const C=D.tabSize||4;for(;E<P.length;){const h=P.charAt(E);if(h===" ")p++;else if(h==="	")p+=C;else break;E++}return Math.floor(p/C)}function I(P,D){for(let E=0;E<D.length;E++){const p=D.charAt(E);if(p==="\r")return E+1<D.length&&D.charAt(E+1)===`
`?`\r
`:"\r";if(p===`
`)return`
`}return P&&P.eol||`
`}e.getEOL=I;function b(P,D){return`\r
`.indexOf(P.charAt(D))!==-1}e.isEOL=b}),define(re[77],se([0,1,34,53]),function(Z,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function T(P,D,E){return L(P,D,void 0,E)}e.removeProperty=T;function L(P,D,E,p,C){const h=D.slice(),S=[],w=(0,k.parseTree)(P,S);let d,m;for(;h.length>0&&(m=h.pop(),d=(0,k.findNodeAtLocation)(w,h),d===void 0&&E!==void 0);)typeof m=="string"?E={[m]:E}:E=[E];if(d)if(d.type==="object"&&typeof m=="string"&&Array.isArray(d.children)){const g=(0,k.findNodeAtLocation)(d,[m]);if(g!==void 0)if(E===void 0){if(!g.parent)throw new Error("Malformed AST");const f=d.children.indexOf(g.parent);let u,r=g.parent.offset+g.parent.length;if(f>0){const n=d.children[f-1];u=n.offset+n.length}else u=d.offset+1,d.children.length>1&&(r=d.children[1].offset);return A(P,{offset:u,length:r-u,content:""},p)}else return A(P,{offset:g.offset,length:g.length,content:JSON.stringify(E)},p);else{if(E===void 0)return[];const f=`${JSON.stringify(m)}: ${JSON.stringify(E)}`,u=C?C(d.children.map(n=>n.children[0].value)):d.children.length;let r;if(u>0){const n=d.children[u-1];r={offset:n.offset+n.length,length:0,content:","+f}}else d.children.length===0?r={offset:d.offset+1,length:0,content:f}:r={offset:d.offset+1,length:0,content:f+","};return A(P,r,p)}}else if(d.type==="array"&&typeof m=="number"&&Array.isArray(d.children))if(E!==void 0){const g=`${JSON.stringify(E)}`;let f;if(d.children.length===0||m===0)f={offset:d.offset+1,length:0,content:d.children.length===0?g:g+","};else{const u=m===-1||m>d.children.length?d.children.length:m,r=d.children[u-1];f={offset:r.offset+r.length,length:0,content:","+g}}return A(P,f,p)}else{const g=m,f=d.children[g];let u;if(d.children.length===1)u={offset:d.offset+1,length:d.length-2,content:""};else if(d.children.length-1===g){const r=d.children[g-1],n=r.offset+r.length,i=d.offset+d.length;u={offset:n,length:i-2-n,content:""}}else u={offset:f.offset,length:d.children[g+1].offset-f.offset,content:""};return A(P,u,p)}else throw new Error(`Can not add ${typeof m!="number"?"index":"property"} to parent of type ${d.type}`);else{if(E===void 0)throw new Error("Can not delete in empty document");return A(P,{offset:w?w.offset:0,length:w?w.length:0,content:JSON.stringify(E)},p)}}e.setProperty=L;function A(P,D,E){let p=I(P,D),C=D.offset,h=D.offset+D.content.length;if(D.length===0||D.content.length===0){for(;C>0&&!(0,t.isEOL)(p,C-1);)C--;for(;h<p.length&&!(0,t.isEOL)(p,h);)h++}const S=(0,t.format)(p,{offset:C,length:h-C},E);for(let d=S.length-1;d>=0;d--){const m=S[d];p=I(p,m),C=Math.min(C,m.offset),h=Math.max(h,m.offset+m.length),h+=m.content.length-m.length}const w=P.length-(p.length-h)-C;return[{offset:C,length:w,content:p.substring(C,h)}]}e.withFormatting=A;function I(P,D){return P.substring(0,D.offset)+D.content+P.substring(D.offset+D.length)}e.applyEdit=I;function b(P,D){const E=D.slice(0).sort((C,h)=>{const S=C.offset-h.offset;return S===0?C.length-h.length:S});let p=P.length;for(let C=E.length-1;C>=0;C--){const h=E[C];if(h.offset+h.length<=p)P=I(P,h);else throw new Error("Overlapping edit");p=h.offset}return P}e.applyEdits=b}),define(re[112],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class k{constructor(T){this.executor=T,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(T){this._error=T}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(T){return new k(()=>T(this.getValue()))}}e.Lazy=k}),define(re[2],se([0,1,76,52]),function(Z,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const T=!1;let L=null;function A(c){L=c}if(e.setDisposableTracker=A,T){const c="__is_disposable_tracked__";A(new class{trackDisposable(s){const o=new Error("Potentially leaked disposable").stack;setTimeout(()=>{s[c]||console.log(o)},3e3)}setParent(s,o){if(s&&s!==m.None)try{s[c]=!0}catch{}}markAsDisposed(s){if(s&&s!==m.None)try{s[c]=!0}catch{}}markAsSingleton(s){}})}function I(c){return L?.trackDisposable(c),c}function b(c){L?.markAsDisposed(c)}function P(c,s){L?.setParent(c,s)}function D(c,s){if(!!L)for(const o of c)L.setParent(o,s)}function E(c){return L?.markAsSingleton(c),c}e.markAsSingleton=E;class p extends Error{constructor(s){super(`Encountered errors while disposing of store. Errors: [${s.join(", ")}]`);this.errors=s}}e.MultiDisposeError=p;function C(c){return typeof c.dispose=="function"&&c.dispose.length===0}e.isDisposable=C;function h(c){if(t.Iterable.is(c)){const s=[];for(const o of c)if(o)try{o.dispose()}catch(l){s.push(l)}if(s.length===1)throw s[0];if(s.length>1)throw new p(s);return Array.isArray(c)?[]:c}else if(c)return c.dispose(),c}e.dispose=h;function S(...c){const s=w(()=>h(c));return D(c,s),s}e.combinedDisposable=S;function w(c){const s=I({dispose:(0,k.once)(()=>{b(s),c()})});return s}e.toDisposable=w;class d{constructor(){this._toDispose=new Set,this._isDisposed=!1,I(this)}dispose(){this._isDisposed||(b(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{h(this._toDispose.values())}finally{this._toDispose.clear()}}add(s){if(!s)return s;if(s===this)throw new Error("Cannot register a disposable on itself!");return P(s,this),this._isDisposed?d.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(s),s}}e.DisposableStore=d,d.DISABLE_DISPOSED_WARNING=!1;class m{constructor(){this._store=new d,I(this),P(this._store,this)}dispose(){b(this),this._store.dispose()}_register(s){if(s===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(s)}}e.Disposable=m,m.None=Object.freeze({dispose(){}});class g{constructor(){this._isDisposed=!1,I(this)}get value(){return this._isDisposed?void 0:this._value}set value(s){this._isDisposed||s===this._value||(this._value?.dispose(),s&&P(s,this),this._value=s)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,b(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const s=this._value;return this._value=void 0,s&&P(s,null),s}}e.MutableDisposable=g;class f{constructor(s){this._disposable=s,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=f;class u{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,I(this)}set(s){let o=s;return this.unset=()=>o=void 0,this.isset=()=>o!==void 0,this.dispose=()=>{o&&(o(),o=void 0,b(this))},this}}e.SafeDisposable=u;class r{constructor(){this.references=new Map}acquire(s,...o){let l=this.references.get(s);l||(l={counter:0,object:this.createReferencedObject(s,...o)},this.references.set(s,l));const{object:v}=l,y=(0,k.once)(()=>{--l.counter==0&&(this.destroyReferencedObject(s,l.object),this.references.delete(s))});return l.counter++,{object:v,dispose:y}}}e.ReferenceCollection=r;class n{constructor(s){this.referenceCollection=s}async acquire(s,...o){const l=this.referenceCollection.acquire(s,...o);try{return{object:await l.object,dispose:()=>l.dispose()}}catch(v){throw l.dispose(),v}}}e.AsyncReferenceCollection=n;class i{constructor(s){this.object=s}dispose(){}}e.ImmortalReference=i;function a(c){const s=new d;try{c(s)}finally{s.dispose()}}e.disposeOnReturn=a}),define(re[113],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class k{constructor(L){this.element=L,this.next=k.Undefined,this.prev=k.Undefined}}k.Undefined=new k(void 0);class t{constructor(){this._first=k.Undefined,this._last=k.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===k.Undefined}clear(){let L=this._first;for(;L!==k.Undefined;){const A=L.next;L.prev=k.Undefined,L.next=k.Undefined,L=A}this._first=k.Undefined,this._last=k.Undefined,this._size=0}unshift(L){return this._insert(L,!1)}push(L){return this._insert(L,!0)}_insert(L,A){const I=new k(L);if(this._first===k.Undefined)this._first=I,this._last=I;else if(A){const P=this._last;this._last=I,I.prev=P,P.next=I}else{const P=this._first;this._first=I,I.next=P,P.prev=I}this._size+=1;let b=!1;return()=>{b||(b=!0,this._remove(I))}}shift(){if(this._first!==k.Undefined){const L=this._first.element;return this._remove(this._first),L}}pop(){if(this._last!==k.Undefined){const L=this._last.element;return this._remove(this._last),L}}_remove(L){if(L.prev!==k.Undefined&&L.next!==k.Undefined){const A=L.prev;A.next=L.next,L.next.prev=A}else L.prev===k.Undefined&&L.next===k.Undefined?(this._first=k.Undefined,this._last=k.Undefined):L.next===k.Undefined?(this._last=this._last.prev,this._last.next=k.Undefined):L.prev===k.Undefined&&(this._first=this._first.next,this._first.prev=k.Undefined);this._size-=1}*[Symbol.iterator](){let L=this._first;for(;L!==k.Undefined;)yield L.element,L=L.next}}e.LinkedList=t}),function(){function Z(T){const L=[];typeof T=="number"&&L.push("code/timeOrigin",T);function A(b){L.push(b,Date.now())}function I(){const b=[];for(let P=0;P<L.length;P+=2)b.push({name:L[P],startTime:L[P+1]});return b}return{mark:A,getMarks:I}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?Z():{mark(T){performance.mark(T)},getMarks(){let T=performance.timeOrigin;typeof T!="number"&&(T=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const L=[{name:"code/timeOrigin",startTime:Math.round(T)}];for(const A of performance.getEntriesByType("mark"))L.push({name:A.name,startTime:Math.round(T+A.startTime)});return L}};if(typeof process=="object"){const T=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return Z(T)}else return console.trace("perf-util loaded in UNKNOWN environment"),Z()}function k(T){return T.MonacoPerformanceMarks||(T.MonacoPerformanceMarks=e()),T.MonacoPerformanceMarks}var t;typeof global=="object"?t=global:typeof self=="object"?t=self:t={},typeof define=="function"?define("vs/base/common/performance",[],function(){return k(t)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=k(t):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),t.perf=k(t))}(),function(Z,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var k=e();for(var t in k)(typeof exports=="object"?exports:Z)[t]=k[t]}}(typeof self!="undefined"?self:this,function(){return function(Z){var e={};function k(t){if(e[t])return e[t].exports;var T=e[t]={i:t,l:!1,exports:{}};return Z[t].call(T.exports,T,T.exports,k),T.l=!0,T.exports}return k.m=Z,k.c=e,k.d=function(t,T,L){k.o(t,T)||Object.defineProperty(t,T,{enumerable:!0,get:L})},k.r=function(t){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(t,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(t,"__esModule",{value:!0})},k.t=function(t,T){if(1&T&&(t=k(t)),8&T||4&T&&typeof t=="object"&&t&&t.__esModule)return t;var L=Object.create(null);if(k.r(L),Object.defineProperty(L,"default",{enumerable:!0,value:t}),2&T&&typeof t!="string")for(var A in t)k.d(L,A,function(I){return t[I]}.bind(null,A));return L},k.n=function(t){var T=t&&t.__esModule?function(){return t.default}:function(){return t};return k.d(T,"a",T),T},k.o=function(t,T){return Object.prototype.hasOwnProperty.call(t,T)},k.p="",k(k.s=0)}([function(Z,e,k){(function(t){var T;e=Z.exports=N,T=typeof t=="object"&&t.env&&t.env.NODE_DEBUG&&/\bsemver\b/i.test(t.env.NODE_DEBUG)?function(){var ae=Array.prototype.slice.call(arguments,0);ae.unshift("SEMVER"),console.log.apply(console,ae)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var L=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,I=e.re=[],b=e.src=[],P=0,D=P++;b[D]="0|[1-9]\\d*";var E=P++;b[E]="[0-9]+";var p=P++;b[p]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var C=P++;b[C]="("+b[D]+")\\.("+b[D]+")\\.("+b[D]+")";var h=P++;b[h]="("+b[E]+")\\.("+b[E]+")\\.("+b[E]+")";var S=P++;b[S]="(?:"+b[D]+"|"+b[p]+")";var w=P++;b[w]="(?:"+b[E]+"|"+b[p]+")";var d=P++;b[d]="(?:-("+b[S]+"(?:\\."+b[S]+")*))";var m=P++;b[m]="(?:-?("+b[w]+"(?:\\."+b[w]+")*))";var g=P++;b[g]="[0-9A-Za-z-]+";var f=P++;b[f]="(?:\\+("+b[g]+"(?:\\."+b[g]+")*))";var u=P++,r="v?"+b[C]+b[d]+"?"+b[f]+"?";b[u]="^"+r+"$";var n="[v=\\s]*"+b[h]+b[m]+"?"+b[f]+"?",i=P++;b[i]="^"+n+"$";var a=P++;b[a]="((?:<|>)?=?)";var c=P++;b[c]=b[E]+"|x|X|\\*";var s=P++;b[s]=b[D]+"|x|X|\\*";var o=P++;b[o]="[v=\\s]*("+b[s]+")(?:\\.("+b[s]+")(?:\\.("+b[s]+")(?:"+b[d]+")?"+b[f]+"?)?)?";var l=P++;b[l]="[v=\\s]*("+b[c]+")(?:\\.("+b[c]+")(?:\\.("+b[c]+")(?:"+b[m]+")?"+b[f]+"?)?)?";var v=P++;b[v]="^"+b[a]+"\\s*"+b[o]+"$";var y=P++;b[y]="^"+b[a]+"\\s*"+b[l]+"$";var O=P++;b[O]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var _=P++;b[_]="(?:~>?)";var F=P++;b[F]="(\\s*)"+b[_]+"\\s+",I[F]=new RegExp(b[F],"g");var R=P++;b[R]="^"+b[_]+b[o]+"$";var U=P++;b[U]="^"+b[_]+b[l]+"$";var M=P++;b[M]="(?:\\^)";var V=P++;b[V]="(\\s*)"+b[M]+"\\s+",I[V]=new RegExp(b[V],"g");var W=P++;b[W]="^"+b[M]+b[o]+"$";var z=P++;b[z]="^"+b[M]+b[l]+"$";var te=P++;b[te]="^"+b[a]+"\\s*("+n+")$|^$";var H=P++;b[H]="^"+b[a]+"\\s*("+r+")$|^$";var K=P++;b[K]="(\\s*)"+b[a]+"\\s*("+n+"|"+b[o]+")",I[K]=new RegExp(b[K],"g");var X=P++;b[X]="^\\s*("+b[o]+")\\s+-\\s+("+b[o]+")\\s*$";var Y=P++;b[Y]="^\\s*("+b[l]+")\\s+-\\s+("+b[l]+")\\s*$";var x=P++;b[x]="(<|>)?=?\\s*\\*";for(var B=0;B<35;B++)T(B,b[B]),I[B]||(I[B]=new RegExp(b[B]));function J(ae,ue){if(ae instanceof N)return ae;if(typeof ae!="string"||ae.length>L||!(ue?I[i]:I[u]).test(ae))return null;try{return new N(ae,ue)}catch{return null}}function N(ae,ue){if(ae instanceof N){if(ae.loose===ue)return ae;ae=ae.version}else if(typeof ae!="string")throw new TypeError("Invalid Version: "+ae);if(ae.length>L)throw new TypeError("version is longer than "+L+" characters");if(!(this instanceof N))return new N(ae,ue);T("SemVer",ae,ue),this.loose=ue;var he=ae.trim().match(ue?I[i]:I[u]);if(!he)throw new TypeError("Invalid Version: "+ae);if(this.raw=ae,this.major=+he[1],this.minor=+he[2],this.patch=+he[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");he[4]?this.prerelease=he[4].split(".").map(function(Ee){if(/^[0-9]+$/.test(Ee)){var Pe=+Ee;if(Pe>=0&&Pe<A)return Pe}return Ee}):this.prerelease=[],this.build=he[5]?he[5].split("."):[],this.format()}e.parse=J,e.valid=function(ae,ue){var he=J(ae,ue);return he?he.version:null},e.clean=function(ae,ue){var he=J(ae.trim().replace(/^[=v]+/,""),ue);return he?he.version:null},e.SemVer=N,N.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},N.prototype.toString=function(){return this.version},N.prototype.compare=function(ae){return T("SemVer.compare",this.version,this.loose,ae),ae instanceof N||(ae=new N(ae,this.loose)),this.compareMain(ae)||this.comparePre(ae)},N.prototype.compareMain=function(ae){return ae instanceof N||(ae=new N(ae,this.loose)),j(this.major,ae.major)||j(this.minor,ae.minor)||j(this.patch,ae.patch)},N.prototype.comparePre=function(ae){if(ae instanceof N||(ae=new N(ae,this.loose)),this.prerelease.length&&!ae.prerelease.length)return-1;if(!this.prerelease.length&&ae.prerelease.length)return 1;if(!this.prerelease.length&&!ae.prerelease.length)return 0;var ue=0;do{var he=this.prerelease[ue],Ee=ae.prerelease[ue];if(T("prerelease compare",ue,he,Ee),he===void 0&&Ee===void 0)return 0;if(Ee===void 0)return 1;if(he===void 0)return-1;if(he!==Ee)return j(he,Ee)}while(++ue)},N.prototype.inc=function(ae,ue){switch(ae){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ue);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ue);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ue),this.inc("pre",ue);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ue),this.inc("pre",ue);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var he=this.prerelease.length;--he>=0;)typeof this.prerelease[he]=="number"&&(this.prerelease[he]++,he=-2);he===-1&&this.prerelease.push(0)}ue&&(this.prerelease[0]===ue?isNaN(this.prerelease[1])&&(this.prerelease=[ue,0]):this.prerelease=[ue,0]);break;default:throw new Error("invalid increment argument: "+ae)}return this.format(),this.raw=this.version,this},e.inc=function(ae,ue,he,Ee){typeof he=="string"&&(Ee=he,he=void 0);try{return new N(ae,he).inc(ue,Ee).version}catch{return null}},e.diff=function(ae,ue){if(ne(ae,ue))return null;var he=J(ae),Ee=J(ue);if(he.prerelease.length||Ee.prerelease.length){for(var Pe in he)if((Pe==="major"||Pe==="minor"||Pe==="patch")&&he[Pe]!==Ee[Pe])return"pre"+Pe;return"prerelease"}for(var Pe in he)if((Pe==="major"||Pe==="minor"||Pe==="patch")&&he[Pe]!==Ee[Pe])return Pe},e.compareIdentifiers=j;var $=/^[0-9]+$/;function j(ae,ue){var he=$.test(ae),Ee=$.test(ue);return he&&Ee&&(ae=+ae,ue=+ue),he&&!Ee?-1:Ee&&!he?1:ae<ue?-1:ae>ue?1:0}function G(ae,ue,he){return new N(ae,he).compare(new N(ue,he))}function q(ae,ue,he){return G(ae,ue,he)>0}function ee(ae,ue,he){return G(ae,ue,he)<0}function ne(ae,ue,he){return G(ae,ue,he)===0}function oe(ae,ue,he){return G(ae,ue,he)!==0}function le(ae,ue,he){return G(ae,ue,he)>=0}function Se(ae,ue,he){return G(ae,ue,he)<=0}function fe(ae,ue,he,Ee){var Pe;switch(ue){case"===":typeof ae=="object"&&(ae=ae.version),typeof he=="object"&&(he=he.version),Pe=ae===he;break;case"!==":typeof ae=="object"&&(ae=ae.version),typeof he=="object"&&(he=he.version),Pe=ae!==he;break;case"":case"=":case"==":Pe=ne(ae,he,Ee);break;case"!=":Pe=oe(ae,he,Ee);break;case">":Pe=q(ae,he,Ee);break;case">=":Pe=le(ae,he,Ee);break;case"<":Pe=ee(ae,he,Ee);break;case"<=":Pe=Se(ae,he,Ee);break;default:throw new TypeError("Invalid operator: "+ue)}return Pe}function pe(ae,ue){if(ae instanceof pe){if(ae.loose===ue)return ae;ae=ae.value}if(!(this instanceof pe))return new pe(ae,ue);T("comparator",ae,ue),this.loose=ue,this.parse(ae),this.semver===Ce?this.value="":this.value=this.operator+this.semver.version,T("comp",this)}e.rcompareIdentifiers=function(ae,ue){return j(ue,ae)},e.major=function(ae,ue){return new N(ae,ue).major},e.minor=function(ae,ue){return new N(ae,ue).minor},e.patch=function(ae,ue){return new N(ae,ue).patch},e.compare=G,e.compareLoose=function(ae,ue){return G(ae,ue,!0)},e.rcompare=function(ae,ue,he){return G(ue,ae,he)},e.sort=function(ae,ue){return ae.sort(function(he,Ee){return e.compare(he,Ee,ue)})},e.rsort=function(ae,ue){return ae.sort(function(he,Ee){return e.rcompare(he,Ee,ue)})},e.gt=q,e.lt=ee,e.eq=ne,e.neq=oe,e.gte=le,e.lte=Se,e.cmp=fe,e.Comparator=pe;var Ce={};function be(ae,ue){if(ae instanceof be)return ae.loose===ue?ae:new be(ae.raw,ue);if(ae instanceof pe)return new be(ae.value,ue);if(!(this instanceof be))return new be(ae,ue);if(this.loose=ue,this.raw=ae,this.set=ae.split(/\s*\|\|\s*/).map(function(he){return this.parseRange(he.trim())},this).filter(function(he){return he.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ae);this.format()}function Ie(ae){return!ae||ae.toLowerCase()==="x"||ae==="*"}function qe(ae,ue,he,Ee,Pe,Ue,Re,Ne,_e,Te,Me,ie,ce){return((ue=Ie(he)?"":Ie(Ee)?">="+he+".0.0":Ie(Pe)?">="+he+"."+Ee+".0":">="+ue)+" "+(Ne=Ie(_e)?"":Ie(Te)?"<"+(+_e+1)+".0.0":Ie(Me)?"<"+_e+"."+(+Te+1)+".0":ie?"<="+_e+"."+Te+"."+Me+"-"+ie:"<="+Ne)).trim()}function Qe(ae,ue){for(var he=0;he<ae.length;he++)if(!ae[he].test(ue))return!1;if(ue.prerelease.length){for(he=0;he<ae.length;he++)if(T(ae[he].semver),ae[he].semver!==Ce&&ae[he].semver.prerelease.length>0){var Ee=ae[he].semver;if(Ee.major===ue.major&&Ee.minor===ue.minor&&Ee.patch===ue.patch)return!0}return!1}return!0}function Ke(ae,ue,he){try{ue=new be(ue,he)}catch{return!1}return ue.test(ae)}function Ye(ae,ue,he,Ee){var Pe,Ue,Re,Ne,_e;switch(ae=new N(ae,Ee),ue=new be(ue,Ee),he){case">":Pe=q,Ue=Se,Re=ee,Ne=">",_e=">=";break;case"<":Pe=ee,Ue=le,Re=q,Ne="<",_e="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ke(ae,ue,Ee))return!1;for(var Te=0;Te<ue.set.length;++Te){var Me=ue.set[Te],ie=null,ce=null;if(Me.forEach(function(de){de.semver===Ce&&(de=new pe(">=0.0.0")),ie=ie||de,ce=ce||de,Pe(de.semver,ie.semver,Ee)?ie=de:Re(de.semver,ce.semver,Ee)&&(ce=de)}),ie.operator===Ne||ie.operator===_e||(!ce.operator||ce.operator===Ne)&&Ue(ae,ce.semver)||ce.operator===_e&&Re(ae,ce.semver))return!1}return!0}pe.prototype.parse=function(ae){var ue=this.loose?I[te]:I[H],he=ae.match(ue);if(!he)throw new TypeError("Invalid comparator: "+ae);this.operator=he[1],this.operator==="="&&(this.operator=""),he[2]?this.semver=new N(he[2],this.loose):this.semver=Ce},pe.prototype.toString=function(){return this.value},pe.prototype.test=function(ae){return T("Comparator.test",ae,this.loose),this.semver===Ce||(typeof ae=="string"&&(ae=new N(ae,this.loose)),fe(ae,this.operator,this.semver,this.loose))},pe.prototype.intersects=function(ae,ue){if(!(ae instanceof pe))throw new TypeError("a Comparator is required");var he;if(this.operator==="")return he=new be(ae.value,ue),Ke(this.value,he,ue);if(ae.operator==="")return he=new be(this.value,ue),Ke(ae.semver,he,ue);var Ee=!(this.operator!==">="&&this.operator!==">"||ae.operator!==">="&&ae.operator!==">"),Pe=!(this.operator!=="<="&&this.operator!=="<"||ae.operator!=="<="&&ae.operator!=="<"),Ue=this.semver.version===ae.semver.version,Re=!(this.operator!==">="&&this.operator!=="<="||ae.operator!==">="&&ae.operator!=="<="),Ne=fe(this.semver,"<",ae.semver,ue)&&(this.operator===">="||this.operator===">")&&(ae.operator==="<="||ae.operator==="<"),_e=fe(this.semver,">",ae.semver,ue)&&(this.operator==="<="||this.operator==="<")&&(ae.operator===">="||ae.operator===">");return Ee||Pe||Ue&&Re||Ne||_e},e.Range=be,be.prototype.format=function(){return this.range=this.set.map(function(ae){return ae.join(" ").trim()}).join("||").trim(),this.range},be.prototype.toString=function(){return this.range},be.prototype.parseRange=function(ae){var ue=this.loose;ae=ae.trim(),T("range",ae,ue);var he=ue?I[Y]:I[X];ae=ae.replace(he,qe),T("hyphen replace",ae),ae=ae.replace(I[K],"$1$2$3"),T("comparator trim",ae,I[K]),ae=(ae=(ae=ae.replace(I[F],"$1~")).replace(I[V],"$1^")).split(/\s+/).join(" ");var Ee=ue?I[te]:I[H],Pe=ae.split(" ").map(function(Ue){return function(Re,Ne){return T("comp",Re),Re=function(_e,Te){return _e.trim().split(/\s+/).map(function(Me){return function(ie,ce){T("caret",ie,ce);var de=ce?I[z]:I[W];return ie.replace(de,function(ve,ge,we,De,ke){var Le;return T("caret",ie,ve,ge,we,De,ke),Ie(ge)?Le="":Ie(we)?Le=">="+ge+".0.0 <"+(+ge+1)+".0.0":Ie(De)?Le=ge==="0"?">="+ge+"."+we+".0 <"+ge+"."+(+we+1)+".0":">="+ge+"."+we+".0 <"+(+ge+1)+".0.0":ke?(T("replaceCaret pr",ke),ke.charAt(0)!=="-"&&(ke="-"+ke),Le=ge==="0"?we==="0"?">="+ge+"."+we+"."+De+ke+" <"+ge+"."+we+"."+(+De+1):">="+ge+"."+we+"."+De+ke+" <"+ge+"."+(+we+1)+".0":">="+ge+"."+we+"."+De+ke+" <"+(+ge+1)+".0.0"):(T("no pr"),Le=ge==="0"?we==="0"?">="+ge+"."+we+"."+De+" <"+ge+"."+we+"."+(+De+1):">="+ge+"."+we+"."+De+" <"+ge+"."+(+we+1)+".0":">="+ge+"."+we+"."+De+" <"+(+ge+1)+".0.0"),T("caret return",Le),Le})}(Me,Te)}).join(" ")}(Re,Ne),T("caret",Re),Re=function(_e,Te){return _e.trim().split(/\s+/).map(function(Me){return function(ie,ce){var de=ce?I[U]:I[R];return ie.replace(de,function(ve,ge,we,De,ke){var Le;return T("tilde",ie,ve,ge,we,De,ke),Ie(ge)?Le="":Ie(we)?Le=">="+ge+".0.0 <"+(+ge+1)+".0.0":Ie(De)?Le=">="+ge+"."+we+".0 <"+ge+"."+(+we+1)+".0":ke?(T("replaceTilde pr",ke),ke.charAt(0)!=="-"&&(ke="-"+ke),Le=">="+ge+"."+we+"."+De+ke+" <"+ge+"."+(+we+1)+".0"):Le=">="+ge+"."+we+"."+De+" <"+ge+"."+(+we+1)+".0",T("tilde return",Le),Le})}(Me,Te)}).join(" ")}(Re,Ne),T("tildes",Re),Re=function(_e,Te){return T("replaceXRanges",_e,Te),_e.split(/\s+/).map(function(Me){return function(ie,ce){ie=ie.trim();var de=ce?I[y]:I[v];return ie.replace(de,function(ve,ge,we,De,ke,Le){T("xRange",ie,ve,ge,we,De,ke,Le);var Ae=Ie(we),Fe=Ae||Ie(De),$e=Fe||Ie(ke);return ge==="="&&$e&&(ge=""),Ae?ve=ge===">"||ge==="<"?"<0.0.0":"*":ge&&$e?(Fe&&(De=0),$e&&(ke=0),ge===">"?(ge=">=",Fe?(we=+we+1,De=0,ke=0):$e&&(De=+De+1,ke=0)):ge==="<="&&(ge="<",Fe?we=+we+1:De=+De+1),ve=ge+we+"."+De+"."+ke):Fe?ve=">="+we+".0.0 <"+(+we+1)+".0.0":$e&&(ve=">="+we+"."+De+".0 <"+we+"."+(+De+1)+".0"),T("xRange return",ve),ve})}(Me,Te)}).join(" ")}(Re,Ne),T("xrange",Re),Re=function(_e,Te){return T("replaceStars",_e,Te),_e.trim().replace(I[x],"")}(Re,Ne),T("stars",Re),Re}(Ue,ue)}).join(" ").split(/\s+/);return this.loose&&(Pe=Pe.filter(function(Ue){return!!Ue.match(Ee)})),Pe=Pe.map(function(Ue){return new pe(Ue,ue)})},be.prototype.intersects=function(ae,ue){if(!(ae instanceof be))throw new TypeError("a Range is required");return this.set.some(function(he){return he.every(function(Ee){return ae.set.some(function(Pe){return Pe.every(function(Ue){return Ee.intersects(Ue,ue)})})})})},e.toComparators=function(ae,ue){return new be(ae,ue).set.map(function(he){return he.map(function(Ee){return Ee.value}).join(" ").trim().split(" ")})},be.prototype.test=function(ae){if(!ae)return!1;typeof ae=="string"&&(ae=new N(ae,this.loose));for(var ue=0;ue<this.set.length;ue++)if(Qe(this.set[ue],ae))return!0;return!1},e.satisfies=Ke,e.maxSatisfying=function(ae,ue,he){var Ee=null,Pe=null;try{var Ue=new be(ue,he)}catch{return null}return ae.forEach(function(Re){Ue.test(Re)&&(Ee&&Pe.compare(Re)!==-1||(Pe=new N(Ee=Re,he)))}),Ee},e.minSatisfying=function(ae,ue,he){var Ee=null,Pe=null;try{var Ue=new be(ue,he)}catch{return null}return ae.forEach(function(Re){Ue.test(Re)&&(Ee&&Pe.compare(Re)!==1||(Pe=new N(Ee=Re,he)))}),Ee},e.validRange=function(ae,ue){try{return new be(ae,ue).range||"*"}catch{return null}},e.ltr=function(ae,ue,he){return Ye(ae,ue,"<",he)},e.gtr=function(ae,ue,he){return Ye(ae,ue,">",he)},e.outside=Ye,e.prerelease=function(ae,ue){var he=J(ae,ue);return he&&he.prerelease.length?he.prerelease:null},e.intersects=function(ae,ue,he){return ae=new be(ae,he),ue=new be(ue,he),ae.intersects(ue)},e.coerce=function(ae){if(ae instanceof N)return ae;if(typeof ae!="string")return null;var ue=ae.match(I[O]);return ue==null?null:J((ue[1]||"0")+"."+(ue[2]||"0")+"."+(ue[3]||"0"))}}).call(this,k(1))},function(Z,e){var k,t,T=Z.exports={};function L(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function I(w){if(k===setTimeout)return setTimeout(w,0);if((k===L||!k)&&setTimeout)return k=setTimeout,setTimeout(w,0);try{return k(w,0)}catch{try{return k.call(null,w,0)}catch{return k.call(this,w,0)}}}(function(){try{k=typeof setTimeout=="function"?setTimeout:L}catch{k=L}try{t=typeof clearTimeout=="function"?clearTimeout:A}catch{t=A}})();var b,P=[],D=!1,E=-1;function p(){D&&b&&(D=!1,b.length?P=b.concat(P):E=-1,P.length&&C())}function C(){if(!D){var w=I(p);D=!0;for(var d=P.length;d;){for(b=P,P=[];++E<d;)b&&b[E].run();E=-1,d=P.length}b=null,D=!1,function(m){if(t===clearTimeout)return clearTimeout(m);if((t===A||!t)&&clearTimeout)return t=clearTimeout,clearTimeout(m);try{t(m)}catch{try{return t.call(null,m)}catch{return t.call(this,m)}}}(w)}}function h(w,d){this.fun=w,this.array=d}function S(){}T.nextTick=function(w){var d=new Array(arguments.length-1);if(arguments.length>1)for(var m=1;m<arguments.length;m++)d[m-1]=arguments[m];P.push(new h(w,d)),P.length!==1||D||I(C)},h.prototype.run=function(){this.fun.apply(null,this.array)},T.title="browser",T.browser=!0,T.env={},T.argv=[],T.version="",T.versions={},T.on=S,T.addListener=S,T.once=S,T.off=S,T.removeListener=S,T.removeAllListeners=S,T.emit=S,T.prependListener=S,T.prependOnceListener=S,T.listeners=function(w){return[]},T.binding=function(w){throw new Error("process.binding is not supported")},T.cwd=function(){return"/"},T.chdir=function(w){throw new Error("process.chdir is not supported")},T.umask=function(){return 0}}])}),define(re[114],se([0,1]),function(Z,e){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class t{constructor(I,b,P){this.level=I,this.key=b,this.value=P,this.forward=[]}}const T=void 0;class L{constructor(I,b=2**16){this.comparator=I,this[k]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(b)|0),this._header=new t(this._maxLevel,T,T)}get size(){return this._size}clear(){this._header=new t(this._maxLevel,T,T)}has(I){return Boolean(L._search(this,I,this.comparator))}get(I){return L._search(this,I,this.comparator)?.value}set(I,b){return L._insert(this,I,b,this.comparator)&&(this._size+=1),this}delete(I){const b=L._delete(this,I,this.comparator);return b&&(this._size-=1),b}forEach(I,b){let P=this._header.forward[0];for(;P;)I.call(b,P.value,P.key,this),P=P.forward[0]}[(k=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let I=this._header.forward[0];for(;I;)yield[I.key,I.value],I=I.forward[0]}*keys(){let I=this._header.forward[0];for(;I;)yield I.key,I=I.forward[0]}*values(){let I=this._header.forward[0];for(;I;)yield I.value,I=I.forward[0]}toString(){let I="[SkipList]:",b=this._header.forward[0];for(;b;)I+=`node(${b.key}, ${b.value}, lvl:${b.level})`,b=b.forward[0];return I}static _search(I,b,P){let D=I._header;for(let E=I._level-1;E>=0;E--)for(;D.forward[E]&&P(D.forward[E].key,b)<0;)D=D.forward[E];if(D=D.forward[0],D&&P(D.key,b)===0)return D}static _insert(I,b,P,D){const E=[];let p=I._header;for(let C=I._level-1;C>=0;C--){for(;p.forward[C]&&D(p.forward[C].key,b)<0;)p=p.forward[C];E[C]=p}if(p=p.forward[0],p&&D(p.key,b)===0)return p.value=P,!1;{const C=L._randomLevel(I);if(C>I._level){for(let h=I._level;h<C;h++)E[h]=I._header;I._level=C}p=new t(C,b,P);for(let h=0;h<C;h++)p.forward[h]=E[h].forward[h],E[h].forward[h]=p;return!0}}static _randomLevel(I,b=.5){let P=1;for(;Math.random()<b&&P<I._maxLevel;)P+=1;return P}static _delete(I,b,P){const D=[];let E=I._header;for(let p=I._level-1;p>=0;p--){for(;E.forward[p]&&P(E.forward[p].key,b)<0;)E=E.forward[p];D[p]=E}if(E=E.forward[0],!E||P(E.key,b)!==0)return!1;for(let p=0;p<I._level&&D[p].forward[p]===E;p++)D[p].forward[p]=E.forward[p];for(;I._level>0&&I._header.forward[I._level-1]===T;)I._level-=1;return!0}}e.SkipList=L}),define(re[41],se([0,1,9,2]),function(Z,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function T(f){const u=f;return u?typeof u.read=="function":!1}e.isReadable=T;function L(f){const u=f;return u?[u.on,u.pause,u.resume,u.destroy].every(r=>typeof r=="function"):!1}e.isReadableStream=L;function A(f){const u=f;return u?L(u.stream)&&Array.isArray(u.buffer)&&typeof u.ended=="boolean":!1}e.isReadableBufferedStream=A;function I(f,u){return new b(f,u)}e.newWriteableStream=I;class b{constructor(u,r){this.reducer=u,this.options=r,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(u){if(!this.state.destroyed){if(this.state.flowing)this.emitData(u);else if(this.buffer.data.push(u),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(r=>this.pendingWritePromises.push(r))}}error(u){this.state.destroyed||(this.state.flowing?this.emitError(u):this.buffer.error.push(u))}end(u){this.state.destroyed||(typeof u!="undefined"&&this.write(u),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(u){this.listeners.data.slice(0).forEach(r=>r(u))}emitError(u){this.listeners.error.length===0?(0,k.onUnexpectedError)(u):this.listeners.error.slice(0).forEach(r=>r(u))}emitEnd(){this.listeners.end.slice(0).forEach(u=>u())}on(u,r){if(!this.state.destroyed)switch(u){case"data":this.listeners.data.push(r),this.resume();break;case"end":this.listeners.end.push(r),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(r),this.state.flowing&&this.flowErrors();break}}removeListener(u,r){if(this.state.destroyed)return;let n;switch(u){case"data":n=this.listeners.data;break;case"end":n=this.listeners.end;break;case"error":n=this.listeners.error;break}if(n){const i=n.indexOf(r);i>=0&&n.splice(i,1)}}flowData(){if(this.buffer.data.length>0){const u=this.reducer(this.buffer.data);this.emitData(u),this.buffer.data.length=0;const r=[...this.pendingWritePromises];this.pendingWritePromises.length=0,r.forEach(n=>n())}}flowErrors(){if(this.listeners.error.length>0){for(const u of this.buffer.error)this.emitError(u);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function P(f,u){const r=[];let n;for(;(n=f.read())!==null;)r.push(n);return u(r)}e.consumeReadable=P;function D(f,u,r){const n=[];let i;for(;(i=f.read())!==null&&n.length<r;)n.push(i);return i===null&&n.length>0?u(n):{read:()=>{if(n.length>0)return n.shift();if(typeof i!="undefined"){const a=i;return i=void 0,a}return f.read()}}}e.peekReadable=D;function E(f,u){return new Promise((r,n)=>{const i=[];p(f,{onData:a=>{u&&i.push(a)},onError:a=>{u?n(a):r(void 0)},onEnd:()=>{r(u?u(i):void 0)}})})}e.consumeStream=E;function p(f,u){let r=!1;return f.on("error",n=>{r||u.onError(n)}),f.on("end",()=>{r||u.onEnd()}),f.on("data",n=>{r||u.onData(n)}),(0,t.toDisposable)(()=>r=!0)}e.listenStream=p;function C(f,u){return new Promise((r,n)=>{const i=new t.DisposableStore,a=[],c=l=>{if(a.push(l),a.length>u)return i.dispose(),f.pause(),r({stream:f,buffer:a,ended:!1})},s=l=>n(l),o=()=>r({stream:f,buffer:a,ended:!0});i.add((0,t.toDisposable)(()=>f.removeListener("error",s))),f.on("error",s),i.add((0,t.toDisposable)(()=>f.removeListener("end",o))),f.on("end",o),i.add((0,t.toDisposable)(()=>f.removeListener("data",c))),f.on("data",c)})}e.peekStream=C;function h(f,u){const r=I(u);return r.end(f),r}e.toStream=h;function S(){const f=I(()=>{throw new Error("not supported")});return f.end(),f}e.emptyStream=S;function w(f){let u=!1;return{read:()=>u?null:(u=!0,f)}}e.toReadable=w;function d(f,u,r){const n=I(r);return p(f,{onData:i=>n.write(u.data(i)),onError:i=>n.error(u.error?u.error(i):i),onEnd:()=>n.end()}),n}e.transform=d;function m(f,u,r){let n=!1;return{read:()=>{const i=u.read();return n?i:(n=!0,i!==null?r([f,i]):f)}}}e.prefixedReadable=m;function g(f,u,r){let n=!1;const i=I(r);return p(u,{onData:a=>n?i.write(a):(n=!0,i.write(r([f,a]))),onError:a=>i.error(a),onEnd:()=>{n||(n=!0,i.write(f)),i.end()}}),i}e.prefixedStream=g}),define(re[16],se([0,1,41]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const t=typeof Buffer!="undefined";let T,L;class A{constructor(l){this.buffer=l,this.byteLength=this.buffer.byteLength}static alloc(l){return t?new A(Buffer.allocUnsafe(l)):new A(new Uint8Array(l))}static wrap(l){return t&&!Buffer.isBuffer(l)&&(l=Buffer.from(l.buffer,l.byteOffset,l.byteLength)),new A(l)}static fromString(l,v){return!(v?.dontUseNodeBuffer||!1)&&t?new A(Buffer.from(l)):(T||(T=new TextEncoder),new A(T.encode(l)))}static fromByteArray(l){const v=A.alloc(l.length);for(let y=0,O=l.length;y<O;y++)v.buffer[y]=l[y];return v}static concat(l,v){if(typeof v=="undefined"){v=0;for(let _=0,F=l.length;_<F;_++)v+=l[_].byteLength}const y=A.alloc(v);let O=0;for(let _=0,F=l.length;_<F;_++){const R=l[_];y.set(R,O),O+=R.byteLength}return y}clone(){const l=A.alloc(this.byteLength);return l.set(this),l}toString(){return t?this.buffer.toString():(L||(L=new TextDecoder),L.decode(this.buffer))}slice(l,v){return new A(this.buffer.subarray(l,v))}set(l,v){if(l instanceof A)this.buffer.set(l.buffer,v);else if(l instanceof Uint8Array)this.buffer.set(l,v);else if(l instanceof ArrayBuffer)this.buffer.set(new Uint8Array(l),v);else if(ArrayBuffer.isView(l))this.buffer.set(new Uint8Array(l.buffer,l.byteOffset,l.byteLength),v);else throw new Error("Unknown argument 'array'")}readUInt32BE(l){return P(this.buffer,l)}writeUInt32BE(l,v){D(this.buffer,l,v)}readUInt32LE(l){return E(this.buffer,l)}writeUInt32LE(l,v){p(this.buffer,l,v)}readUInt8(l){return C(this.buffer,l)}writeUInt8(l,v){h(this.buffer,l,v)}}e.VSBuffer=A;function I(o,l){return o[l+0]<<0>>>0|o[l+1]<<8>>>0}e.readUInt16LE=I;function b(o,l,v){o[v+0]=l&255,l=l>>>8,o[v+1]=l&255}e.writeUInt16LE=b;function P(o,l){return o[l]*2**24+o[l+1]*2**16+o[l+2]*2**8+o[l+3]}e.readUInt32BE=P;function D(o,l,v){o[v+3]=l,l=l>>>8,o[v+2]=l,l=l>>>8,o[v+1]=l,l=l>>>8,o[v]=l}e.writeUInt32BE=D;function E(o,l){return o[l+0]<<0>>>0|o[l+1]<<8>>>0|o[l+2]<<16>>>0|o[l+3]<<24>>>0}e.readUInt32LE=E;function p(o,l,v){o[v+0]=l&255,l=l>>>8,o[v+1]=l&255,l=l>>>8,o[v+2]=l&255,l=l>>>8,o[v+3]=l&255}e.writeUInt32LE=p;function C(o,l){return o[l]}e.readUInt8=C;function h(o,l,v){o[v]=l}e.writeUInt8=h;function S(o){return k.consumeReadable(o,l=>A.concat(l))}e.readableToBuffer=S;function w(o){return k.toReadable(o)}e.bufferToReadable=w;function d(o){return k.consumeStream(o,l=>A.concat(l))}e.streamToBuffer=d;async function m(o){return o.ended?A.concat(o.buffer):A.concat([...o.buffer,await d(o.stream)])}e.bufferedStreamToBuffer=m;function g(o){return k.toStream(o,l=>A.concat(l))}e.bufferToStream=g;function f(o){return k.transform(o,{data:l=>typeof l=="string"?A.fromString(l):A.wrap(l)},l=>A.concat(l))}e.streamToBufferReadableStream=f;function u(o){return k.newWriteableStream(l=>A.concat(l),o)}e.newWriteableBufferStream=u;function r(o,l){return k.prefixedReadable(o,l,v=>A.concat(v))}e.prefixedBufferReadable=r;function n(o,l){return k.prefixedStream(o,l,v=>A.concat(v))}e.prefixedBufferStream=n;function i(o){let l=0,v=0,y=0;const O=new Uint8Array(Math.floor(o.length/4*3)),_=R=>{switch(v){case 3:O[y++]=l|R,v=0;break;case 2:O[y++]=l|R>>>2,l=R<<6,v=3;break;case 1:O[y++]=l|R>>>4,l=R<<4,v=2;break;default:l=R<<2,v=1}};for(let R=0;R<o.length;R++){const U=o.charCodeAt(R);if(U>=65&&U<=90)_(U-65);else if(U>=97&&U<=122)_(U-97+26);else if(U>=48&&U<=57)_(U-48+52);else if(U===43||U===45)_(62);else if(U===47||U===95)_(63);else{if(U===61)break;throw new SyntaxError(`Unexpected base64 character ${o[R]}`)}}const F=y;for(;v>0;)_(0);return A.wrap(O).slice(0,F)}e.decodeBase64=i;const a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",c="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function s({buffer:o},l=!0,v=!1){const y=v?c:a;let O="";const _=o.byteLength%3;let F=0;for(;F<o.byteLength-_;F+=3){const R=o[F+0],U=o[F+1],M=o[F+2];O+=y[R>>>2],O+=y[(R<<4|U>>>4)&63],O+=y[(U<<2|M>>>6)&63],O+=y[M&63]}if(_===1){const R=o[F+0];O+=y[R>>>2],O+=y[R<<4&63],l&&(O+="==")}else if(_===2){const R=o[F+0],U=o[F+1];O+=y[R>>>2],O+=y[(R<<4|U>>>4)&63],O+=y[U<<2&63],l&&(O+="=")}return O}e.encodeBase64=s}),define(re[14],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function k(o){return Array.isArray(o)}e.isArray=k;function t(o){return typeof o=="string"}e.isString=t;function T(o){return Array.isArray(o)&&o.every(l=>t(l))}e.isStringArray=T;function L(o){return typeof o=="object"&&o!==null&&!Array.isArray(o)&&!(o instanceof RegExp)&&!(o instanceof Date)}e.isObject=L;function A(o){return typeof o=="object"&&(o instanceof Uint8Array||o instanceof Uint16Array||o instanceof Uint32Array||o instanceof Float32Array||o instanceof Float64Array||o instanceof Int8Array||o instanceof Int16Array||o instanceof Int32Array||o instanceof BigInt64Array||o instanceof BigUint64Array||o instanceof Uint8ClampedArray)}e.isTypedArray=A;function I(o){return typeof o=="number"&&!isNaN(o)}e.isNumber=I;function b(o){return!!o&&typeof o[Symbol.iterator]=="function"}e.isIterable=b;function P(o){return o===!0||o===!1}e.isBoolean=P;function D(o){return typeof o=="undefined"}e.isUndefined=D;function E(o){return!p(o)}e.isDefined=E;function p(o){return D(o)||o===null}e.isUndefinedOrNull=p;function C(o,l){if(!o)throw new Error(l?`Unexpected type, expected '${l}'`:"Unexpected type")}e.assertType=C;function h(o){if(p(o))throw new Error("Assertion Failed: argument is undefined or null");return o}e.assertIsDefined=h;function S(...o){const l=[];for(let v=0;v<o.length;v++){const y=o[v];if(p(y))throw new Error(`Assertion Failed: argument at index ${v} is undefined or null`);l.push(y)}return l}e.assertAllDefined=S;const w=Object.prototype.hasOwnProperty;function d(o){if(!L(o))return!1;for(const l in o)if(w.call(o,l))return!1;return!0}e.isEmptyObject=d;function m(o){return typeof o=="function"}e.isFunction=m;function g(...o){return o.length>0&&o.every(m)}e.areFunctions=g;function f(o,l){const v=Math.min(o.length,l.length);for(let y=0;y<v;y++)u(o[y],l[y])}e.validateConstraints=f;function u(o,l){if(t(l)){if(typeof o!==l)throw new Error(`argument does not match constraint: typeof ${l}`)}else if(m(l)){try{if(o instanceof l)return}catch{}if(!p(o)&&o.constructor===l||l.length===1&&l.call(void 0,o)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=u;function r(o){let l=[],v=Object.getPrototypeOf(o);for(;Object.prototype!==v;)l=l.concat(Object.getOwnPropertyNames(v)),v=Object.getPrototypeOf(v);return l}e.getAllPropertyNames=r;function n(o){const l=[];for(const v of r(o))typeof o[v]=="function"&&l.push(v);return l}e.getAllMethodNames=n;function i(o,l){const v=O=>function(){const _=Array.prototype.slice.call(arguments,0);return l(O,_)},y={};for(const O of o)y[O]=v(O);return y}e.createProxyObject=i;function a(o){return o===null?void 0:o}e.withNullAsUndefined=a;function c(o){return typeof o=="undefined"?null:o}e.withUndefinedAsNull=c;function s(o,l="Unreachable"){throw new Error(l)}e.assertNever=s}),define(re[29],se([0,1,14]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function t(h){if(!h||typeof h!="object"||h instanceof RegExp)return h;const S=Array.isArray(h)?[]:{};return Object.keys(h).forEach(w=>{h[w]&&typeof h[w]=="object"?S[w]=t(h[w]):S[w]=h[w]}),S}e.deepClone=t;function T(h){if(!h||typeof h!="object")return h;const S=[h];for(;S.length>0;){const w=S.shift();Object.freeze(w);for(const d in w)if(L.call(w,d)){const m=w[d];typeof m=="object"&&!Object.isFrozen(m)&&!(0,k.isTypedArray)(m)&&S.push(m)}}return h}e.deepFreeze=T;const L=Object.prototype.hasOwnProperty;function A(h,S){return I(h,S,new Set)}e.cloneAndChange=A;function I(h,S,w){if((0,k.isUndefinedOrNull)(h))return h;const d=S(h);if(typeof d!="undefined")return d;if((0,k.isArray)(h)){const m=[];for(const g of h)m.push(I(g,S,w));return m}if((0,k.isObject)(h)){if(w.has(h))throw new Error("Cannot clone recursive data-structure");w.add(h);const m={};for(const g in h)L.call(h,g)&&(m[g]=I(h[g],S,w));return w.delete(h),m}return h}function b(h,S,w=!0){return(0,k.isObject)(h)?((0,k.isObject)(S)&&Object.keys(S).forEach(d=>{d in h?w&&((0,k.isObject)(h[d])&&(0,k.isObject)(S[d])?b(h[d],S[d],w):h[d]=S[d]):h[d]=S[d]}),h):S}e.mixin=b;function P(h,S){if(h===S)return!0;if(h==null||S===null||S===void 0||typeof h!=typeof S||typeof h!="object"||Array.isArray(h)!==Array.isArray(S))return!1;let w,d;if(Array.isArray(h)){if(h.length!==S.length)return!1;for(w=0;w<h.length;w++)if(!P(h[w],S[w]))return!1}else{const m=[];for(d in h)m.push(d);m.sort();const g=[];for(d in S)g.push(d);if(g.sort(),!P(m,g))return!1;for(w=0;w<m.length;w++)if(!P(h[m[w]],S[m[w]]))return!1}return!0}e.equals=P;function D(h){const S=new Set;return JSON.stringify(h,(w,d)=>{if((0,k.isObject)(d)||Array.isArray(d)){if(S.has(d))return"[Circular]";S.add(d)}return d})}e.safeStringify=D;function E(h,S){const w=Object.create(null);return!h||!S||Object.keys(S).forEach(m=>{const g=h[m],f=S[m];P(g,f)||(w[m]=f)}),w}e.distinct=E;function p(h,S){const w=S.toLowerCase(),d=Object.keys(h).find(m=>m.toLowerCase()===w);return d?h[d]:h[S]}e.getCaseInsensitive=p;function C(h,S){const w=Object.create(null);for(const[d,m]of Object.entries(h))S(d,m)&&(w[d]=m);return w}e.filter=C}),define(re[31],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const k=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function t(T){return k.test(T)}e.isUUID=t,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let T;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?T=crypto.getRandomValues.bind(crypto):T=function(I){for(let b=0;b<I.length;b++)I[b]=Math.floor(Math.random()*256);return I};const L=new Uint8Array(16),A=[];for(let I=0;I<256;I++)A.push(I.toString(16).padStart(2,"0"));return function(){T(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let b=0,P="";return P+=A[L[b++]],P+=A[L[b++]],P+=A[L[b++]],P+=A[L[b++]],P+="-",P+=A[L[b++]],P+=A[L[b++]],P+="-",P+=A[L[b++]],P+=A[L[b++]],P+="-",P+=A[L[b++]],P+=A[L[b++]],P+="-",P+=A[L[b++]],P+=A[L[b++]],P+=A[L[b++]],P+=A[L[b++]],P+=A[L[b++]],P+=A[L[b++]],P}}()}),define(re[115],se([0,1,266]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class t{constructor(L="utf8"){this.stringDecoder=new k.StringDecoder(L),this.remaining=null}write(L){const A=[],I=this.remaining?this.remaining+this.stringDecoder.write(L):this.stringDecoder.write(L);if(I.length<1)return A;let b=0,P,D=b;for(;D<I.length;)if(P=I.charCodeAt(D),P===13||P===10){if(A.push(I.substring(b,D)),D++,D<I.length){const E=P;P=I.charCodeAt(D),(E===13&&P===10||E===10&&P===13)&&D++}b=D}else D++;return this.remaining=b<I.length?I.substr(b):null,A}end(){return this.remaining}}e.LineDecoder=t}),define(re[116],se([0,1,35]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const t=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function T(A){const I=A.replace(/\-/g,":").toLowerCase();return!t.has(I)}function L(){const A=(0,k.networkInterfaces)();for(const I in A){const b=A[I];if(b){for(const{mac:P}of b)if(T(P))return P}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=L}),define(re[117],se([0,1,61]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function t(I,b,P,D=1){let E=!1;return new Promise(p=>{const C=setTimeout(()=>{if(!E)return E=!0,p(0)},P);T(I,b,D,h=>{if(!E)return E=!0,clearTimeout(C),p(h)})})}e.findFreePort=t;function T(I,b,P,D){if(b===0)return D(0);const E=new k.Socket;E.once("connect",()=>(A(E),T(I+P,b-1,P,D))),E.once("data",()=>{}),E.once("error",p=>(A(E),p.code!=="ECONNREFUSED"?T(I+P,b-1,P,D):D(I))),E.connect(I,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function L(I,b,P){let D=!1,E,p=1;const C=k.createServer({pauseOnConnect:!0});function h(S,w){D||(D=!0,C.removeAllListeners(),C.close(),E&&clearTimeout(E),w(S))}return new Promise(S=>{E=setTimeout(()=>{h(0,S)},P),C.on("listening",()=>{h(I,S)}),C.on("error",w=>{w&&(w.code==="EADDRINUSE"||w.code==="EACCES")&&p<b?(I++,p++,C.listen(I,"127.0.0.1")):h(0,S)}),C.on("close",()=>{h(0,S)}),C.listen(I,"127.0.0.1")})}e.findFreePortFaster=L;function A(I){try{I.removeAllListeners("connect"),I.removeAllListeners("error"),I.end(),I.destroy(),I.unref()}catch(b){console.error(b)}}}),define(re[118],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OfflineError=e.isOfflineError=void 0;const k="Offline";function t(L){return L instanceof T?!0:L instanceof Error&&L.name===k&&L.message===k}e.isOfflineError=t;class T extends Error{constructor(){super(k);this.name=this.message}}e.OfflineError=T}),define(re[119],se([0,1,16,9,118]),function(Z,e,k,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.request=void 0;function L(b,P){if(!navigator.onLine)throw new T.OfflineError;b.proxyAuthorization&&(b.headers={...b.headers||{},"Proxy-Authorization":b.proxyAuthorization});const D=new XMLHttpRequest;return new Promise((E,p)=>{D.open(b.type||"GET",b.url||"",!0,b.user,b.password),A(D,b),D.responseType="arraybuffer",D.onerror=C=>p(new Error(D.statusText&&"XHR failed: "+D.statusText||"XHR failed")),D.onload=C=>{E({res:{statusCode:D.status,headers:I(D)},stream:(0,k.bufferToStream)(k.VSBuffer.wrap(new Uint8Array(D.response)))})},D.ontimeout=C=>p(new Error(`XHR timeout: ${b.timeout}ms`)),b.timeout&&(D.timeout=b.timeout),D.send(b.data),P.onCancellationRequested(()=>{D.abort(),p((0,t.canceled)())})})}e.request=L;function A(b,P){if(P.headers){e:for(const D in P.headers){switch(D){case"User-Agent":case"Accept-Encoding":case"Content-Length":continue e}b.setRequestHeader(D,P.headers[D])}}}function I(b){const P=Object.create(null);for(const D of b.getAllResponseHeaders().split(/\r\n|\n|\r/g))if(D){const E=D.indexOf(":");P[D.substr(0,E).trim().toLowerCase()]=D.substr(E+1).trim()}return P}}),define(re[120],se([10,11]),function(Z,e){return Z.create("vs/base/common/date",e)}),define(re[62],se([0,1,120]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const t=60,T=t*60,L=T*24,A=L*7,I=L*30,b=L*365;function P(E,p,C){typeof E!="number"&&(E=E.getTime());const h=Math.round((new Date().getTime()-E)/1e3);if(h<-30)return(0,k.localize)(0,null,P(new Date().getTime()+h*1e3,!1));if(h<30)return(0,k.localize)(1,null);let S;return h<t?(S=h,p?S===1?C?(0,k.localize)(2,null,S):(0,k.localize)(3,null,S):C?(0,k.localize)(4,null,S):(0,k.localize)(5,null,S):S===1?C?(0,k.localize)(6,null,S):(0,k.localize)(7,null,S):C?(0,k.localize)(8,null,S):(0,k.localize)(9,null,S)):h<T?(S=Math.floor(h/t),p?S===1?C?(0,k.localize)(10,null,S):(0,k.localize)(11,null,S):C?(0,k.localize)(12,null,S):(0,k.localize)(13,null,S):S===1?C?(0,k.localize)(14,null,S):(0,k.localize)(15,null,S):C?(0,k.localize)(16,null,S):(0,k.localize)(17,null,S)):h<L?(S=Math.floor(h/T),p?S===1?C?(0,k.localize)(18,null,S):(0,k.localize)(19,null,S):C?(0,k.localize)(20,null,S):(0,k.localize)(21,null,S):S===1?C?(0,k.localize)(22,null,S):(0,k.localize)(23,null,S):C?(0,k.localize)(24,null,S):(0,k.localize)(25,null,S)):h<A?(S=Math.floor(h/L),p?S===1?(0,k.localize)(26,null,S):(0,k.localize)(27,null,S):S===1?(0,k.localize)(28,null,S):(0,k.localize)(29,null,S)):h<I?(S=Math.floor(h/A),p?S===1?C?(0,k.localize)(30,null,S):(0,k.localize)(31,null,S):C?(0,k.localize)(32,null,S):(0,k.localize)(33,null,S):S===1?C?(0,k.localize)(34,null,S):(0,k.localize)(35,null,S):C?(0,k.localize)(36,null,S):(0,k.localize)(37,null,S)):h<b?(S=Math.floor(h/I),p?S===1?C?(0,k.localize)(38,null,S):(0,k.localize)(39,null,S):C?(0,k.localize)(40,null,S):(0,k.localize)(41,null,S):S===1?C?(0,k.localize)(42,null,S):(0,k.localize)(43,null,S):C?(0,k.localize)(44,null,S):(0,k.localize)(45,null,S)):(S=Math.floor(h/b),p?S===1?C?(0,k.localize)(46,null,S):(0,k.localize)(47,null,S):C?(0,k.localize)(48,null,S):(0,k.localize)(49,null,S):S===1?C?(0,k.localize)(50,null,S):(0,k.localize)(51,null,S):C?(0,k.localize)(52,null,S):(0,k.localize)(53,null,S))}e.fromNow=P;function D(E){return E.getFullYear()+"-"+String(E.getMonth()+1).padStart(2,"0")+"-"+String(E.getDate()).padStart(2,"0")+"T"+String(E.getHours()).padStart(2,"0")+":"+String(E.getMinutes()).padStart(2,"0")+":"+String(E.getSeconds()).padStart(2,"0")+"."+(E.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=D}),define(re[121],se([10,11]),function(Z,e){return Z.create("vs/base/common/errorMessage",e)}),define(re[37],se([0,1,17,14,121]),function(Z,e,k,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function L(E,p){return p&&(E.stack||E.stacktrace)?T.localize(0,null,I(E),A(E.stack)||A(E.stacktrace)):I(E)}function A(E){return Array.isArray(E)?E.join(`
`):E}function I(E){return typeof E.code=="string"&&typeof E.errno=="number"&&typeof E.syscall=="string"?T.localize(1,null,E.message):E.message||T.localize(2,null)}function b(E=null,p=!1){if(!E)return T.localize(3,null);if(Array.isArray(E)){const C=k.coalesce(E),h=b(C[0],p);return C.length>1?T.localize(4,null,h,C.length):h}if(t.isString(E))return E;if(E.detail){const C=E.detail;if(C.error)return L(C.error,p);if(C.exception)return L(C.exception,p)}return E.stack?L(E,p):E.message?E.message:T.localize(5,null)}e.toErrorMessage=b;function P(E){const p=E;return p instanceof Error&&Array.isArray(p.actions)}e.isErrorWithActions=P;function D(E,p){let C;return typeof E=="string"?C=new Error(E):C=E,C.actions=p,C}e.createErrorWithActions=D}),define(re[122],se([10,11]),function(Z,e){return Z.create("vs/base/common/jsonErrorMessages",e)}),define(re[123],se([0,1,122]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function t(T){switch(T){case 1:return(0,k.localize)(0,null);case 2:return(0,k.localize)(1,null);case 3:return(0,k.localize)(2,null);case 4:return(0,k.localize)(3,null);case 5:return(0,k.localize)(4,null);case 6:return(0,k.localize)(5,null);case 7:return(0,k.localize)(6,null);case 8:return(0,k.localize)(7,null);case 9:return(0,k.localize)(8,null);default:return""}}e.getParseErrorMessage=t}),define(re[124],se([10,11]),function(Z,e){return Z.create("vs/base/common/platform",e)}),define(re[4],se([0,1,124]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=void 0;const t="en";let T=!1,L=!1,A=!1,I=!1,b=!1,P=!1,D=!1,E=!1,p=!1,C,h=t,S,w;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let d;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?d=e.globals.vscode.process:typeof process!="undefined"&&(d=process);const m=typeof d?.versions?.electron=="string",g=m&&d?.type==="renderer";if(typeof navigator=="object"&&!g)w=navigator.userAgent,T=w.indexOf("Windows")>=0,L=w.indexOf("Macintosh")>=0,E=(w.indexOf("Macintosh")>=0||w.indexOf("iPad")>=0||w.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,A=w.indexOf("Linux")>=0,P=!0,C=k.getConfiguredDefaultLocale(k.localize(0,null))||t,h=C;else if(typeof d=="object"){T=d.platform==="win32",L=d.platform==="darwin",A=d.platform==="linux",I=A&&!!d.env.SNAP&&!!d.env.SNAP_REVISION,D=m,p=!!d.env.CI||!!d.env.BUILD_ARTIFACTSTAGINGDIRECTORY,C=t,h=t;const o=d.env.VSCODE_NLS_CONFIG;if(o)try{const l=JSON.parse(o),v=l.availableLanguages["*"];C=l.locale,h=v||t,S=l._translationsConfigFile}catch{}b=!0}else console.error("Unable to resolve platform.");var f;(function(o){o[o.Web=0]="Web",o[o.Mac=1]="Mac",o[o.Linux=2]="Linux",o[o.Windows=3]="Windows"})(f=e.Platform||(e.Platform={}));function u(o){switch(o){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=u;let r=0;L?r=1:T?r=3:A&&(r=2),e.isWindows=T,e.isMacintosh=L,e.isLinux=A,e.isLinuxSnap=I,e.isNative=b,e.isElectron=D,e.isWeb=P,e.isWebWorker=P&&typeof e.globals.importScripts=="function",e.isIOS=E,e.isCI=p,e.platform=r,e.userAgent=w,e.language=h;var n;(function(o){function l(){return e.language}o.value=l;function v(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}o.isDefaultVariant=v;function y(){return e.language==="en"}o.isDefault=y})(n=e.Language||(e.Language={})),e.locale=C,e.translationsConfigFile=S,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const o=[];e.globals.addEventListener("message",v=>{if(v.data&&v.data.vscodeScheduleAsyncWork)for(let y=0,O=o.length;y<O;y++){const _=o[y];if(_.id===v.data.vscodeScheduleAsyncWork){o.splice(y,1),_.callback();return}}});let l=0;return v=>{const y=++l;o.push({id:y,callback:v}),e.globals.postMessage({vscodeScheduleAsyncWork:y},"*")}}return o=>setTimeout(o)})();var i;(function(o){o[o.Windows=1]="Windows",o[o.Macintosh=2]="Macintosh",o[o.Linux=3]="Linux"})(i=e.OperatingSystem||(e.OperatingSystem={})),e.OS=L||E?2:T?1:3;let a=!0,c=!1;function s(){if(!c){c=!0;const o=new Uint8Array(2);o[0]=1,o[1]=2,a=new Uint16Array(o.buffer)[0]===(2<<8)+1}return a}e.isLittleEndian=s,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(re[36],se([0,1,4]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let t;if(typeof k.globals.vscode!="undefined"&&typeof k.globals.vscode.process!="undefined"){const T=k.globals.vscode.process;t={get platform(){return T.platform},get arch(){return T.arch},get env(){return T.env},cwd(){return T.cwd()}}}else typeof process!="undefined"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return k.isWindows?"win32":k.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.platform=t.platform,e.arch=t.arch}),define(re[12],se([0,1,36]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const t=65,T=97,L=90,A=122,I=46,b=47,P=92,D=58,E=63;class p extends Error{constructor(f,u,r){let n;typeof u=="string"&&u.indexOf("not ")===0?(n="must not be",u=u.replace(/^not /,"")):n="must be";const i=f.indexOf(".")!==-1?"property":"argument";let a=`The "${f}" ${i} ${n} of type ${u}`;a+=`. Received type ${typeof r}`;super(a);this.code="ERR_INVALID_ARG_TYPE"}}function C(g,f){if(typeof g!="string")throw new p(f,"string",g)}function h(g){return g===b||g===P}function S(g){return g===b}function w(g){return g>=t&&g<=L||g>=T&&g<=A}function d(g,f,u,r){let n="",i=0,a=-1,c=0,s=0;for(let o=0;o<=g.length;++o){if(o<g.length)s=g.charCodeAt(o);else{if(r(s))break;s=b}if(r(s)){if(!(a===o-1||c===1))if(c===2){if(n.length<2||i!==2||n.charCodeAt(n.length-1)!==I||n.charCodeAt(n.length-2)!==I){if(n.length>2){const l=n.lastIndexOf(u);l===-1?(n="",i=0):(n=n.slice(0,l),i=n.length-1-n.lastIndexOf(u)),a=o,c=0;continue}else if(n.length!==0){n="",i=0,a=o,c=0;continue}}f&&(n+=n.length>0?`${u}..`:"..",i=2)}else n.length>0?n+=`${u}${g.slice(a+1,o)}`:n=g.slice(a+1,o),i=o-a-1;a=o,c=0}else s===I&&c!==-1?++c:c=-1}return n}function m(g,f){if(f===null||typeof f!="object")throw new p("pathObject","Object",f);const u=f.dir||f.root,r=f.base||`${f.name||""}${f.ext||""}`;return u?u===f.root?`${u}${r}`:`${u}${g}${r}`:r}e.win32={resolve(...g){let f="",u="",r=!1;for(let n=g.length-1;n>=-1;n--){let i;if(n>=0){if(i=g[n],C(i,"path"),i.length===0)continue}else f.length===0?i=k.cwd():(i=k.env[`=${f}`]||k.cwd(),(i===void 0||i.slice(0,2).toLowerCase()!==f.toLowerCase()&&i.charCodeAt(2)===P)&&(i=`${f}\\`));const a=i.length;let c=0,s="",o=!1;const l=i.charCodeAt(0);if(a===1)h(l)&&(c=1,o=!0);else if(h(l))if(o=!0,h(i.charCodeAt(1))){let v=2,y=v;for(;v<a&&!h(i.charCodeAt(v));)v++;if(v<a&&v!==y){const O=i.slice(y,v);for(y=v;v<a&&h(i.charCodeAt(v));)v++;if(v<a&&v!==y){for(y=v;v<a&&!h(i.charCodeAt(v));)v++;(v===a||v!==y)&&(s=`\\\\${O}\\${i.slice(y,v)}`,c=v)}}}else c=1;else w(l)&&i.charCodeAt(1)===D&&(s=i.slice(0,2),c=2,a>2&&h(i.charCodeAt(2))&&(o=!0,c=3));if(s.length>0)if(f.length>0){if(s.toLowerCase()!==f.toLowerCase())continue}else f=s;if(r){if(f.length>0)break}else if(u=`${i.slice(c)}\\${u}`,r=o,o&&f.length>0)break}return u=d(u,!r,"\\",h),r?`${f}\\${u}`:`${f}${u}`||"."},normalize(g){C(g,"path");const f=g.length;if(f===0)return".";let u=0,r,n=!1;const i=g.charCodeAt(0);if(f===1)return S(i)?"\\":g;if(h(i))if(n=!0,h(g.charCodeAt(1))){let c=2,s=c;for(;c<f&&!h(g.charCodeAt(c));)c++;if(c<f&&c!==s){const o=g.slice(s,c);for(s=c;c<f&&h(g.charCodeAt(c));)c++;if(c<f&&c!==s){for(s=c;c<f&&!h(g.charCodeAt(c));)c++;if(c===f)return`\\\\${o}\\${g.slice(s)}\\`;c!==s&&(r=`\\\\${o}\\${g.slice(s,c)}`,u=c)}}}else u=1;else w(i)&&g.charCodeAt(1)===D&&(r=g.slice(0,2),u=2,f>2&&h(g.charCodeAt(2))&&(n=!0,u=3));let a=u<f?d(g.slice(u),!n,"\\",h):"";return a.length===0&&!n&&(a="."),a.length>0&&h(g.charCodeAt(f-1))&&(a+="\\"),r===void 0?n?`\\${a}`:a:n?`${r}\\${a}`:`${r}${a}`},isAbsolute(g){C(g,"path");const f=g.length;if(f===0)return!1;const u=g.charCodeAt(0);return h(u)||f>2&&w(u)&&g.charCodeAt(1)===D&&h(g.charCodeAt(2))},join(...g){if(g.length===0)return".";let f,u;for(let i=0;i<g.length;++i){const a=g[i];C(a,"path"),a.length>0&&(f===void 0?f=u=a:f+=`\\${a}`)}if(f===void 0)return".";let r=!0,n=0;if(typeof u=="string"&&h(u.charCodeAt(0))){++n;const i=u.length;i>1&&h(u.charCodeAt(1))&&(++n,i>2&&(h(u.charCodeAt(2))?++n:r=!1))}if(r){for(;n<f.length&&h(f.charCodeAt(n));)n++;n>=2&&(f=`\\${f.slice(n)}`)}return e.win32.normalize(f)},relative(g,f){if(C(g,"from"),C(f,"to"),g===f)return"";const u=e.win32.resolve(g),r=e.win32.resolve(f);if(u===r||(g=u.toLowerCase(),f=r.toLowerCase(),g===f))return"";let n=0;for(;n<g.length&&g.charCodeAt(n)===P;)n++;let i=g.length;for(;i-1>n&&g.charCodeAt(i-1)===P;)i--;const a=i-n;let c=0;for(;c<f.length&&f.charCodeAt(c)===P;)c++;let s=f.length;for(;s-1>c&&f.charCodeAt(s-1)===P;)s--;const o=s-c,l=a<o?a:o;let v=-1,y=0;for(;y<l;y++){const _=g.charCodeAt(n+y);if(_!==f.charCodeAt(c+y))break;_===P&&(v=y)}if(y!==l){if(v===-1)return r}else{if(o>l){if(f.charCodeAt(c+y)===P)return r.slice(c+y+1);if(y===2)return r.slice(c+y)}a>l&&(g.charCodeAt(n+y)===P?v=y:y===2&&(v=3)),v===-1&&(v=0)}let O="";for(y=n+v+1;y<=i;++y)(y===i||g.charCodeAt(y)===P)&&(O+=O.length===0?"..":"\\..");return c+=v,O.length>0?`${O}${r.slice(c,s)}`:(r.charCodeAt(c)===P&&++c,r.slice(c,s))},toNamespacedPath(g){if(typeof g!="string")return g;if(g.length===0)return"";const f=e.win32.resolve(g);if(f.length<=2)return g;if(f.charCodeAt(0)===P){if(f.charCodeAt(1)===P){const u=f.charCodeAt(2);if(u!==E&&u!==I)return`\\\\?\\UNC\\${f.slice(2)}`}}else if(w(f.charCodeAt(0))&&f.charCodeAt(1)===D&&f.charCodeAt(2)===P)return`\\\\?\\${f}`;return g},dirname(g){C(g,"path");const f=g.length;if(f===0)return".";let u=-1,r=0;const n=g.charCodeAt(0);if(f===1)return h(n)?g:".";if(h(n)){if(u=r=1,h(g.charCodeAt(1))){let c=2,s=c;for(;c<f&&!h(g.charCodeAt(c));)c++;if(c<f&&c!==s){for(s=c;c<f&&h(g.charCodeAt(c));)c++;if(c<f&&c!==s){for(s=c;c<f&&!h(g.charCodeAt(c));)c++;if(c===f)return g;c!==s&&(u=r=c+1)}}}}else w(n)&&g.charCodeAt(1)===D&&(u=f>2&&h(g.charCodeAt(2))?3:2,r=u);let i=-1,a=!0;for(let c=f-1;c>=r;--c)if(h(g.charCodeAt(c))){if(!a){i=c;break}}else a=!1;if(i===-1){if(u===-1)return".";i=u}return g.slice(0,i)},basename(g,f){f!==void 0&&C(f,"ext"),C(g,"path");let u=0,r=-1,n=!0,i;if(g.length>=2&&w(g.charCodeAt(0))&&g.charCodeAt(1)===D&&(u=2),f!==void 0&&f.length>0&&f.length<=g.length){if(f===g)return"";let a=f.length-1,c=-1;for(i=g.length-1;i>=u;--i){const s=g.charCodeAt(i);if(h(s)){if(!n){u=i+1;break}}else c===-1&&(n=!1,c=i+1),a>=0&&(s===f.charCodeAt(a)?--a==-1&&(r=i):(a=-1,r=c))}return u===r?r=c:r===-1&&(r=g.length),g.slice(u,r)}for(i=g.length-1;i>=u;--i)if(h(g.charCodeAt(i))){if(!n){u=i+1;break}}else r===-1&&(n=!1,r=i+1);return r===-1?"":g.slice(u,r)},extname(g){C(g,"path");let f=0,u=-1,r=0,n=-1,i=!0,a=0;g.length>=2&&g.charCodeAt(1)===D&&w(g.charCodeAt(0))&&(f=r=2);for(let c=g.length-1;c>=f;--c){const s=g.charCodeAt(c);if(h(s)){if(!i){r=c+1;break}continue}n===-1&&(i=!1,n=c+1),s===I?u===-1?u=c:a!==1&&(a=1):u!==-1&&(a=-1)}return u===-1||n===-1||a===0||a===1&&u===n-1&&u===r+1?"":g.slice(u,n)},format:m.bind(null,"\\"),parse(g){C(g,"path");const f={root:"",dir:"",base:"",ext:"",name:""};if(g.length===0)return f;const u=g.length;let r=0,n=g.charCodeAt(0);if(u===1)return h(n)?(f.root=f.dir=g,f):(f.base=f.name=g,f);if(h(n)){if(r=1,h(g.charCodeAt(1))){let v=2,y=v;for(;v<u&&!h(g.charCodeAt(v));)v++;if(v<u&&v!==y){for(y=v;v<u&&h(g.charCodeAt(v));)v++;if(v<u&&v!==y){for(y=v;v<u&&!h(g.charCodeAt(v));)v++;v===u?r=v:v!==y&&(r=v+1)}}}}else if(w(n)&&g.charCodeAt(1)===D){if(u<=2)return f.root=f.dir=g,f;if(r=2,h(g.charCodeAt(2))){if(u===3)return f.root=f.dir=g,f;r=3}}r>0&&(f.root=g.slice(0,r));let i=-1,a=r,c=-1,s=!0,o=g.length-1,l=0;for(;o>=r;--o){if(n=g.charCodeAt(o),h(n)){if(!s){a=o+1;break}continue}c===-1&&(s=!1,c=o+1),n===I?i===-1?i=o:l!==1&&(l=1):i!==-1&&(l=-1)}return c!==-1&&(i===-1||l===0||l===1&&i===c-1&&i===a+1?f.base=f.name=g.slice(a,c):(f.name=g.slice(a,i),f.base=g.slice(a,c),f.ext=g.slice(i,c))),a>0&&a!==r?f.dir=g.slice(0,a-1):f.dir=f.root,f},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...g){let f="",u=!1;for(let r=g.length-1;r>=-1&&!u;r--){const n=r>=0?g[r]:k.cwd();C(n,"path"),n.length!==0&&(f=`${n}/${f}`,u=n.charCodeAt(0)===b)}return f=d(f,!u,"/",S),u?`/${f}`:f.length>0?f:"."},normalize(g){if(C(g,"path"),g.length===0)return".";const f=g.charCodeAt(0)===b,u=g.charCodeAt(g.length-1)===b;return g=d(g,!f,"/",S),g.length===0?f?"/":u?"./":".":(u&&(g+="/"),f?`/${g}`:g)},isAbsolute(g){return C(g,"path"),g.length>0&&g.charCodeAt(0)===b},join(...g){if(g.length===0)return".";let f;for(let u=0;u<g.length;++u){const r=g[u];C(r,"path"),r.length>0&&(f===void 0?f=r:f+=`/${r}`)}return f===void 0?".":e.posix.normalize(f)},relative(g,f){if(C(g,"from"),C(f,"to"),g===f||(g=e.posix.resolve(g),f=e.posix.resolve(f),g===f))return"";const u=1,r=g.length,n=r-u,i=1,a=f.length-i,c=n<a?n:a;let s=-1,o=0;for(;o<c;o++){const v=g.charCodeAt(u+o);if(v!==f.charCodeAt(i+o))break;v===b&&(s=o)}if(o===c)if(a>c){if(f.charCodeAt(i+o)===b)return f.slice(i+o+1);if(o===0)return f.slice(i+o)}else n>c&&(g.charCodeAt(u+o)===b?s=o:o===0&&(s=0));let l="";for(o=u+s+1;o<=r;++o)(o===r||g.charCodeAt(o)===b)&&(l+=l.length===0?"..":"/..");return`${l}${f.slice(i+s)}`},toNamespacedPath(g){return g},dirname(g){if(C(g,"path"),g.length===0)return".";const f=g.charCodeAt(0)===b;let u=-1,r=!0;for(let n=g.length-1;n>=1;--n)if(g.charCodeAt(n)===b){if(!r){u=n;break}}else r=!1;return u===-1?f?"/":".":f&&u===1?"//":g.slice(0,u)},basename(g,f){f!==void 0&&C(f,"ext"),C(g,"path");let u=0,r=-1,n=!0,i;if(f!==void 0&&f.length>0&&f.length<=g.length){if(f===g)return"";let a=f.length-1,c=-1;for(i=g.length-1;i>=0;--i){const s=g.charCodeAt(i);if(s===b){if(!n){u=i+1;break}}else c===-1&&(n=!1,c=i+1),a>=0&&(s===f.charCodeAt(a)?--a==-1&&(r=i):(a=-1,r=c))}return u===r?r=c:r===-1&&(r=g.length),g.slice(u,r)}for(i=g.length-1;i>=0;--i)if(g.charCodeAt(i)===b){if(!n){u=i+1;break}}else r===-1&&(n=!1,r=i+1);return r===-1?"":g.slice(u,r)},extname(g){C(g,"path");let f=-1,u=0,r=-1,n=!0,i=0;for(let a=g.length-1;a>=0;--a){const c=g.charCodeAt(a);if(c===b){if(!n){u=a+1;break}continue}r===-1&&(n=!1,r=a+1),c===I?f===-1?f=a:i!==1&&(i=1):f!==-1&&(i=-1)}return f===-1||r===-1||i===0||i===1&&f===r-1&&f===u+1?"":g.slice(f,r)},format:m.bind(null,"/"),parse(g){C(g,"path");const f={root:"",dir:"",base:"",ext:"",name:""};if(g.length===0)return f;const u=g.charCodeAt(0)===b;let r;u?(f.root="/",r=1):r=0;let n=-1,i=0,a=-1,c=!0,s=g.length-1,o=0;for(;s>=r;--s){const l=g.charCodeAt(s);if(l===b){if(!c){i=s+1;break}continue}a===-1&&(c=!1,a=s+1),l===I?n===-1?n=s:o!==1&&(o=1):n!==-1&&(o=-1)}if(a!==-1){const l=i===0&&u?1:i;n===-1||o===0||o===1&&n===a-1&&n===i+1?f.base=f.name=g.slice(l,a):(f.name=g.slice(l,n),f.base=g.slice(l,a),f.ext=g.slice(n,a))}return i>0?f.dir=g.slice(0,i-1):u&&(f.dir="/"),f},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=k.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=k.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=k.platform==="win32"?e.win32.join:e.posix.join,e.resolve=k.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=k.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=k.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=k.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=k.platform==="win32"?e.win32.extname:e.posix.extname,e.format=k.platform==="win32"?e.win32.format:e.posix.format,e.parse=k.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=k.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=k.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=k.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(re[125],se([0,1,12]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const t={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},T={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function L(D){const E=(0,k.extname)(D),p=t[E.toLowerCase()];return p!==void 0?p:A(D)}e.getMediaOrTextMime=L;function A(D){const E=(0,k.extname)(D);return T[E.toLowerCase()]}e.getMediaMime=A;function I(D){for(const E in T)if(T[E]===D)return E}e.getExtensionForMimeType=I;const b=/^(.+)\/(.+?)(;.+)?$/;function P(D,E){const p=b.exec(D);return p?`${p[1].toLowerCase()}/${p[2].toLowerCase()}${p[3]??""}`:E?void 0:D}e.normalizeMimeType=P}),define(re[78],se([0,1,4]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var t;(function(I){I[I.stdout=0]="stdout",I[I.stderr=1]="stderr"})(t=e.Source||(e.Source={}));var T;(function(I){I[I.Success=0]="Success",I[I.Unknown=1]="Unknown",I[I.AccessDenied=2]="AccessDenied",I[I.ProcessNotFound=3]="ProcessNotFound"})(T=e.TerminateResponseCode||(e.TerminateResponseCode={}));function L(I,...b){const P=b.reduce((p,C)=>(p[C]=!0,p),{}),D=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(I).filter(p=>!P[p]).forEach(p=>{for(let C=0;C<D.length;C++)if(p.search(D[C])!==-1){delete I[p];break}})}e.sanitizeProcessEnvironment=L;function A(I){!I||(delete I.DEBUG,k.isMacintosh&&delete I.DYLD_LIBRARY_PATH,k.isLinux&&delete I.LD_PRELOAD)}e.removeDangerousEnvVariables=A}),define(re[126],se([0,1,4]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const t=k.globals.performance&&typeof k.globals.performance.now=="function";class T{constructor(A){this._highResolution=t&&A,this._startTime=this._now(),this._stopTime=-1}static create(A=!0){return new T(A)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?k.globals.performance.now():Date.now()}}e.StopWatch=T}),define(re[3],se([0,1,9,76,2,113,126]),function(Z,e,k,t,T,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;const I=!1,b=!1;var P;(function(s){s.None=()=>T.Disposable.None;function o($){if(b){const{onListenerDidAdd:j}=$,G=h.create();let q=0;$.onListenerDidAdd=()=>{++q==2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),G.print()),j?.()}}}function l($){return(j,G=null,q)=>{let ee=!1,ne;return ne=$(oe=>{if(!ee)return ne?ne.dispose():ee=!0,j.call(G,oe)},null,q),ee&&ne.dispose(),ne}}s.once=l;function v($,j,G){return U((q,ee=null,ne)=>$(oe=>q.call(ee,j(oe)),null,ne),G)}s.map=v;function y($,j,G){return U((q,ee=null,ne)=>$(oe=>{j(oe),q.call(ee,oe)},null,ne),G)}s.forEach=y;function O($,j,G){return U((q,ee=null,ne)=>$(oe=>j(oe)&&q.call(ee,oe),null,ne),G)}s.filter=O;function _($){return $}s.signal=_;function F(...$){return(j,G=null,q)=>(0,T.combinedDisposable)(...$.map(ee=>ee(ne=>j.call(G,ne),null,q)))}s.any=F;function R($,j,G,q){let ee=G;return v($,ne=>(ee=j(ee,ne),ee),q)}s.reduce=R;function U($,j){let G;const q={onFirstListenerAdd(){G=$(ee.fire,ee)},onLastListenerRemove(){G?.dispose()}};j||o(q);const ee=new w(q);return j?.add(ee),ee.event}function M($,j,G=100,q=!1,ee,ne){let oe,le,Se,fe=0;const pe={leakWarningThreshold:ee,onFirstListenerAdd(){oe=$(be=>{fe++,le=j(le,be),q&&!Se&&(Ce.fire(le),le=void 0),clearTimeout(Se),Se=setTimeout(()=>{const Ie=le;le=void 0,Se=void 0,(!q||fe>1)&&Ce.fire(Ie),fe=0},G)})},onLastListenerRemove(){oe.dispose()}};ne||o(pe);const Ce=new w(pe);return ne?.add(Ce),Ce.event}s.debounce=M;function V($,j=(q,ee)=>q===ee,G){let q=!0,ee;return O($,ne=>{const oe=q||!j(ne,ee);return q=!1,ee=ne,oe},G)}s.latch=V;function W($,j,G){return[s.filter($,j,G),s.filter($,q=>!j(q),G)]}s.split=W;function z($,j=!1,G=[]){let q=G.slice(),ee=$(le=>{q?q.push(le):oe.fire(le)});const ne=()=>{q?.forEach(le=>oe.fire(le)),q=null},oe=new w({onFirstListenerAdd(){ee||(ee=$(le=>oe.fire(le)))},onFirstListenerDidAdd(){q&&(j?setTimeout(ne):ne())},onLastListenerRemove(){ee&&ee.dispose(),ee=null}});return oe.event}s.buffer=z;class te{constructor(j){this.event=j,this.disposables=new T.DisposableStore}map(j){return new te(v(this.event,j,this.disposables))}forEach(j){return new te(y(this.event,j,this.disposables))}filter(j){return new te(O(this.event,j,this.disposables))}reduce(j,G){return new te(R(this.event,j,G,this.disposables))}latch(){return new te(V(this.event,void 0,this.disposables))}debounce(j,G=100,q=!1,ee){return new te(M(this.event,j,G,q,ee,this.disposables))}on(j,G,q){return this.event(j,G,q)}once(j,G,q){return l(this.event)(j,G,q)}dispose(){this.disposables.dispose()}}function H($){return new te($)}s.chain=H;function K($,j,G=q=>q){const q=(...le)=>oe.fire(G(...le)),ee=()=>$.on(j,q),ne=()=>$.removeListener(j,q),oe=new w({onFirstListenerAdd:ee,onLastListenerRemove:ne});return oe.event}s.fromNodeEventEmitter=K;function X($,j,G=q=>q){const q=(...le)=>oe.fire(G(...le)),ee=()=>$.addEventListener(j,q),ne=()=>$.removeEventListener(j,q),oe=new w({onFirstListenerAdd:ee,onLastListenerRemove:ne});return oe.event}s.fromDOMEventEmitter=X;function Y($){return new Promise(j=>l($)(j))}s.toPromise=Y;function x($,j){return j(void 0),$(G=>j(G))}s.runAndSubscribe=x;function B($,j){let G=null;function q(ne){G?.dispose(),G=new T.DisposableStore,j(ne,G)}q(void 0);const ee=$(ne=>q(ne));return(0,T.toDisposable)(()=>{ee.dispose(),G?.dispose()})}s.runAndSubscribeWithStore=B;class J{constructor(j,G){this.obs=j,this._counter=0,this._hasChanged=!1;const q={onFirstListenerAdd:()=>{j.addObserver(this)},onLastListenerRemove:()=>{j.removeObserver(this)}};G||o(q),this.emitter=new w(q),G&&G.add(this.emitter)}beginUpdate(j){this._counter++}handleChange(j,G){this._hasChanged=!0}endUpdate(j){--this._counter==0&&this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this.obs.get()))}}function N($,j){return new J($,j).emitter.event}s.fromObservable=N})(P=e.Event||(e.Event={}));class D{constructor(o){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${o}_${D._idPool++}`}start(o){this._stopWatch=new A.StopWatch(!0),this._listenerCount=o}stop(){if(this._stopWatch){const o=this._stopWatch.elapsed();this._elapsedOverall+=o,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${o.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}D._idPool=0;let E=-1;function p(s){const o=E;return E=s,{dispose(){E=o}}}e.setGlobalLeakWarningThreshold=p;class C{constructor(o,l=Math.random().toString(18).slice(2,5)){this.customThreshold=o,this.name=l,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(o,l){let v=E;if(typeof this.customThreshold=="number"&&(v=this.customThreshold),v<=0||l<v)return;this._stacks||(this._stacks=new Map);const y=this._stacks.get(o.value)||0;if(this._stacks.set(o.value,y+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=v*.5;let O,_=0;for(const[F,R]of this._stacks)(!O||_<R)&&(O=F,_=R);console.warn(`[${this.name}] potential listener LEAK detected, having ${l} listeners already. MOST frequent listener (${_}):`),console.warn(O)}return()=>{const O=this._stacks.get(o.value)||0;this._stacks.set(o.value,O-1)}}}class h{constructor(o){this.value=o}static create(){return new h(new Error().stack??"")}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class S{constructor(o,l,v){this.callback=o,this.callbackThis=l,this.stack=v,this.subscription=new T.SafeDisposable}invoke(o){this.callback.call(this.callbackThis,o)}}class w{constructor(o){this._disposed=!1,this._options=o,this._leakageMon=E>0?new C(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new D(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(I){const o=Array.from(this._listeners);queueMicrotask(()=>{for(const l of o)l.subscription.isset()&&(l.subscription.unset(),l.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(this),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(o,l,v)=>{this._listeners||(this._listeners=new L.LinkedList);const y=this._listeners.isEmpty();y&&this._options?.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);let O,_;this._leakageMon&&this._listeners.size>=30&&(_=h.create(),O=this._leakageMon.check(_,this._listeners.size+1)),I&&(_=_??h.create());const F=new S(o,l,_),R=this._listeners.push(F);y&&this._options?.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options?.onListenerDidAdd&&this._options.onListenerDidAdd(this,o,l);const U=F.subscription.set(()=>{O?.(),this._disposed||(R(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return v instanceof T.DisposableStore?v.add(U):Array.isArray(v)&&v.push(U),U}),this._event}fire(o){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new m);for(const l of this._listeners)this._deliveryQueue.push(this,l,o);this._perfMon?.start(this._deliveryQueue.size),this._deliveryQueue.deliver(),this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}e.Emitter=w;class d{constructor(){this._queue=new L.LinkedList}get size(){return this._queue.size}push(o,l,v){this._queue.push(new g(o,l,v))}clear(o){const l=new L.LinkedList;for(const v of this._queue)v.emitter!==o&&l.push(v);this._queue=l}deliver(){for(;this._queue.size>0;){const o=this._queue.shift();try{o.listener.invoke(o.event)}catch(l){(0,k.onUnexpectedError)(l)}}}}e.EventDeliveryQueue=d;class m extends d{clear(o){this._queue.clear()}}class g{constructor(o,l,v){this.emitter=o,this.listener=l,this.event=v}}class f extends w{async fireAsync(o,l,v){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new L.LinkedList);for(const y of this._listeners)this._asyncDeliveryQueue.push([y,o]);for(;this._asyncDeliveryQueue.size>0&&!l.isCancellationRequested;){const[y,O]=this._asyncDeliveryQueue.shift(),_=[],F={...O,token:l,waitUntil:R=>{if(Object.isFrozen(_))throw new Error("waitUntil can NOT be called asynchronous");v&&(R=v(R,y.callback)),_.push(R)}};try{y.invoke(F)}catch(R){(0,k.onUnexpectedError)(R);continue}Object.freeze(_),await Promise.allSettled(_).then(R=>{for(const U of R)U.status==="rejected"&&(0,k.onUnexpectedError)(U.reason)})}}}}e.AsyncEmitter=f;class u extends w{constructor(o){super(o);this._isPaused=0,this._eventQueue=new L.LinkedList,this._mergeFn=o?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const o=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(o))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(o){this._listeners&&(this._isPaused!==0?this._eventQueue.push(o):super.fire(o))}}e.PauseableEmitter=u;class r extends u{constructor(o){super(o);this._delay=o.delay??100}fire(o){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(o)}}e.DebounceEmitter=r;class n extends w{constructor(o){super(o);this._queuedEvents=[],this._mergeFn=o?.merge}fire(o){this._queuedEvents.push(o),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(l=>super.fire(l)),this._queuedEvents=[]})}}e.MicrotaskEmitter=n;class i{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new w({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(o){const l={event:o,listener:null};this.events.push(l),this.hasListeners&&this.hook(l);const v=()=>{this.hasListeners&&this.unhook(l);const y=this.events.indexOf(l);this.events.splice(y,1)};return(0,T.toDisposable)((0,t.once)(v))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(o=>this.hook(o))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(o=>this.unhook(o))}hook(o){o.listener=o.event(l=>this.emitter.fire(l))}unhook(o){o.listener&&o.listener.dispose(),o.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=i;class a{constructor(){this.buffers=[]}wrapEvent(o){return(l,v,y)=>o(O=>{const _=this.buffers[this.buffers.length-1];_?_.push(()=>l.call(v,O)):l.call(v,O)},void 0,y)}bufferEvents(o){const l=[];this.buffers.push(l);const v=o();return this.buffers.pop(),l.forEach(y=>y()),v}}e.EventBufferer=a;class c{constructor(){this.listening=!1,this.inputEvent=P.None,this.inputEventListener=T.Disposable.None,this.emitter=new w({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(o){this.inputEvent=o,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=o(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=c}),define(re[23],se([0,1,3]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const t=Object.freeze(function(I,b){const P=setTimeout(I.bind(b),0);return{dispose(){clearTimeout(P)}}});var T;(function(I){function b(P){return P===I.None||P===I.Cancelled||P instanceof L?!0:!P||typeof P!="object"?!1:typeof P.isCancellationRequested=="boolean"&&typeof P.onCancellationRequested=="function"}I.isCancellationToken=b,I.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:k.Event.None}),I.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(T=e.CancellationToken||(e.CancellationToken={}));class L{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?t:(this._emitter||(this._emitter=new k.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class A{constructor(b){this._token=void 0,this._parentListener=void 0,this._parentListener=b&&b.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new L),this._token}cancel(){this._token?this._token instanceof L&&this._token.cancel():this._token=T.Cancelled}dispose(b=!1){b&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof L&&this._token.dispose():this._token=T.None}}e.CancellationTokenSource=A}),define(re[127],se([0,1,23]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class t{constructor(I){this.task=I,this.result=null}get(){if(this.result)return this.result;const I=new k.CancellationTokenSource,b=this.task(I.token);return this.result={promise:b,dispose:()=>{this.result=null,I.cancel(),I.dispose()}},this.result}}e.Cache=t;class T{constructor(I){this.fn=I,this.lastCache=void 0,this.lastArgKey=void 0}get(I){const b=JSON.stringify(I);return this.lastArgKey!==b&&(this.lastArgKey=b,this.lastCache=this.fn(I)),this.lastCache}}e.LRUCachedFunction=T;class L{constructor(I){this.fn=I,this._map=new Map}get cachedValues(){return this._map}get(I){if(this._map.has(I))return this._map.get(I);const b=this.fn(I);return this._map.set(I,b),b}}e.CachedFunction=L}),define(re[79],se([0,1,3,2]),function(Z,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MutableObservableValue=e.staticObservableValue=void 0;const T=A=>({onDidChange:k.Event.None,value:A});e.staticObservableValue=T;class L extends t.Disposable{constructor(I){super();this._value=I,this.changeEmitter=this._register(new k.Emitter),this.onDidChange=this.changeEmitter.event}get value(){return this._value}set value(I){I!==this._value&&(this._value=I,this.changeEmitter.fire(I))}}e.MutableObservableValue=L}),define(re[26],se([0,1,127,112]),function(Z,e,k,t){"use strict";var T;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function L(ie){return!ie||typeof ie!="string"?!0:ie.trim().length===0}e.isFalsyOrWhitespace=L;const A=/{(\d+)}/g;function I(ie,...ce){return ce.length===0?ie:ie.replace(A,function(de,ve){const ge=parseInt(ve,10);return isNaN(ge)||ge<0||ge>=ce.length?de:ce[ge]})}e.format=I;const b=/{([^}]+)}/g;function P(ie,ce){return ie.replace(b,(de,ve)=>ce[ve]??de)}e.format2=P;function D(ie){return ie.replace(/[<>&]/g,function(ce){switch(ce){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ce}})}e.escape=D;function E(ie){return ie.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=E;function p(ie,ce){let de=0;const ve=ce.charCodeAt(0);for(let ge=ie.length-1;ge>=0;ge--)ie.charCodeAt(ge)===ve&&de++;return de}e.count=p;function C(ie,ce,de="\u2026"){return ie.length<=ce?ie:`${ie.substr(0,ce)}${de}`}e.truncate=C;function h(ie,ce=" "){const de=S(ie,ce);return w(de,ce)}e.trim=h;function S(ie,ce){if(!ie||!ce)return ie;const de=ce.length;if(de===0||ie.length===0)return ie;let ve=0;for(;ie.indexOf(ce,ve)===ve;)ve=ve+de;return ie.substring(ve)}e.ltrim=S;function w(ie,ce){if(!ie||!ce)return ie;const de=ce.length,ve=ie.length;if(de===0||ve===0)return ie;let ge=ve,we=-1;for(;we=ie.lastIndexOf(ce,ge-1),!(we===-1||we+de!==ge);){if(we===0)return"";ge=we}return ie.substring(0,ge)}e.rtrim=w;function d(ie){return ie.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=d;function m(ie){return ie.replace(/\*/g,"")}e.stripWildcards=m;function g(ie,ce,de={}){if(!ie)throw new Error("Cannot create regex from empty string");ce||(ie=E(ie)),de.wholeWord&&(/\B/.test(ie.charAt(0))||(ie="\\b"+ie),/\B/.test(ie.charAt(ie.length-1))||(ie=ie+"\\b"));let ve="";return de.global&&(ve+="g"),de.matchCase||(ve+="i"),de.multiline&&(ve+="m"),de.unicode&&(ve+="u"),new RegExp(ie,ve)}e.createRegExp=g;function f(ie){return ie.source==="^"||ie.source==="^$"||ie.source==="$"||ie.source==="^\\s*$"?!1:!!(ie.exec("")&&ie.lastIndex===0)}e.regExpLeadsToEndlessLoop=f;function u(ie){return!!ie.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=u;function r(ie){return(ie.global?"g":"")+(ie.ignoreCase?"i":"")+(ie.multiline?"m":"")+(ie.unicode?"u":"")}e.regExpFlags=r;function n(ie){return ie.split(/\r\n|\r|\n/)}e.splitLines=n;function i(ie){for(let ce=0,de=ie.length;ce<de;ce++){const ve=ie.charCodeAt(ce);if(ve!==32&&ve!==9)return ce}return-1}e.firstNonWhitespaceIndex=i;function a(ie,ce=0,de=ie.length){for(let ve=ce;ve<de;ve++){const ge=ie.charCodeAt(ve);if(ge!==32&&ge!==9)return ie.substring(ce,ve)}return ie.substring(ce,de)}e.getLeadingWhitespace=a;function c(ie,ce=ie.length-1){for(let de=ce;de>=0;de--){const ve=ie.charCodeAt(de);if(ve!==32&&ve!==9)return de}return-1}e.lastNonWhitespaceIndex=c;function s(ie,ce,de){const ve=[];let ge=0;for(const we of ie.matchAll(ce)){if(ve.push(ie.slice(ge,we.index)),we.index===void 0)throw new Error("match.index should be defined");ge=we.index+we[0].length,ve.push(de(we[0],...we.slice(1),we.index,ie,we.groups))}return ve.push(ie.slice(ge)),Promise.all(ve).then(we=>we.join(""))}e.replaceAsync=s;function o(ie,ce){return ie<ce?-1:ie>ce?1:0}e.compare=o;function l(ie,ce,de=0,ve=ie.length,ge=0,we=ce.length){for(;de<ve&&ge<we;de++,ge++){const Le=ie.charCodeAt(de),Ae=ce.charCodeAt(ge);if(Le<Ae)return-1;if(Le>Ae)return 1}const De=ve-de,ke=we-ge;return De<ke?-1:De>ke?1:0}e.compareSubstring=l;function v(ie,ce){return y(ie,ce,0,ie.length,0,ce.length)}e.compareIgnoreCase=v;function y(ie,ce,de=0,ve=ie.length,ge=0,we=ce.length){for(;de<ve&&ge<we;de++,ge++){let Le=ie.charCodeAt(de),Ae=ce.charCodeAt(ge);if(Le===Ae)continue;if(Le>=128||Ae>=128)return l(ie.toLowerCase(),ce.toLowerCase(),de,ve,ge,we);_(Le)&&(Le-=32),_(Ae)&&(Ae-=32);const Fe=Le-Ae;if(Fe!==0)return Fe}const De=ve-de,ke=we-ge;return De<ke?-1:De>ke?1:0}e.compareSubstringIgnoreCase=y;function O(ie){return ie>=48&&ie<=57}e.isAsciiDigit=O;function _(ie){return ie>=97&&ie<=122}e.isLowerAsciiLetter=_;function F(ie){return ie>=65&&ie<=90}e.isUpperAsciiLetter=F;function R(ie,ce){return ie.length===ce.length&&y(ie,ce)===0}e.equalsIgnoreCase=R;function U(ie,ce){const de=ce.length;return ce.length>ie.length?!1:y(ie,ce,0,de)===0}e.startsWithIgnoreCase=U;function M(ie,ce){const de=Math.min(ie.length,ce.length);let ve;for(ve=0;ve<de;ve++)if(ie.charCodeAt(ve)!==ce.charCodeAt(ve))return ve;return de}e.commonPrefixLength=M;function V(ie,ce){const de=Math.min(ie.length,ce.length);let ve;const ge=ie.length-1,we=ce.length-1;for(ve=0;ve<de;ve++)if(ie.charCodeAt(ge-ve)!==ce.charCodeAt(we-ve))return ve;return de}e.commonSuffixLength=V;function W(ie){return 55296<=ie&&ie<=56319}e.isHighSurrogate=W;function z(ie){return 56320<=ie&&ie<=57343}e.isLowSurrogate=z;function te(ie,ce){return(ie-55296<<10)+(ce-56320)+65536}e.computeCodePoint=te;function H(ie,ce,de){const ve=ie.charCodeAt(de);if(W(ve)&&de+1<ce){const ge=ie.charCodeAt(de+1);if(z(ge))return te(ve,ge)}return ve}e.getNextCodePoint=H;function K(ie,ce){const de=ie.charCodeAt(ce-1);if(z(de)&&ce>1){const ve=ie.charCodeAt(ce-2);if(W(ve))return te(ve,de)}return de}class X{constructor(ce,de=0){this._str=ce,this._len=ce.length,this._offset=de}get offset(){return this._offset}setOffset(ce){this._offset=ce}prevCodePoint(){const ce=K(this._str,this._offset);return this._offset-=ce>=65536?2:1,ce}nextCodePoint(){const ce=H(this._str,this._len,this._offset);return this._offset+=ce>=65536?2:1,ce}eol(){return this._offset>=this._len}}e.CodePointIterator=X;class Y{constructor(ce,de=0){this._iterator=new X(ce,de)}get offset(){return this._iterator.offset}nextGraphemeLength(){const ce=Ee.getInstance(),de=this._iterator,ve=de.offset;let ge=ce.getGraphemeBreakType(de.nextCodePoint());for(;!de.eol();){const we=de.offset,De=ce.getGraphemeBreakType(de.nextCodePoint());if(ue(ge,De)){de.setOffset(we);break}ge=De}return de.offset-ve}prevGraphemeLength(){const ce=Ee.getInstance(),de=this._iterator,ve=de.offset;let ge=ce.getGraphemeBreakType(de.prevCodePoint());for(;de.offset>0;){const we=de.offset,De=ce.getGraphemeBreakType(de.prevCodePoint());if(ue(De,ge)){de.setOffset(we);break}ge=De}return ve-de.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=Y;function x(ie,ce){return new Y(ie,ce).nextGraphemeLength()}e.nextCharLength=x;function B(ie,ce){return new Y(ie,ce).prevGraphemeLength()}e.prevCharLength=B;function J(ie,ce){ce>0&&z(ie.charCodeAt(ce))&&ce--;const de=ce+x(ie,ce);return[de-B(ie,de),de]}e.getCharContainingOffset=J;const N=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function $(ie){return N.test(ie)}e.containsRTL=$;const j=/^[\t\n\r\x20-\x7E]*$/;function G(ie){return j.test(ie)}e.isBasicASCII=G,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function q(ie){return e.UNUSUAL_LINE_TERMINATORS.test(ie)}e.containsUnusualLineTerminators=q;function ee(ie){return ie>=11904&&ie<=55215||ie>=63744&&ie<=64255||ie>=65281&&ie<=65374}e.isFullWidthCharacter=ee;function ne(ie){return ie>=127462&&ie<=127487||ie===8986||ie===8987||ie===9200||ie===9203||ie>=9728&&ie<=10175||ie===11088||ie===11093||ie>=127744&&ie<=128591||ie>=128640&&ie<=128764||ie>=128992&&ie<=129008||ie>=129280&&ie<=129535||ie>=129648&&ie<=129782}e.isEmojiImprecise=ne;function oe(ie,ce){if(ie.length<ce)return ie;const de=/\b/g;let ve=0;for(;de.test(ie)&&!(ie.length-de.lastIndex<ce);)ve=de.lastIndex,de.lastIndex+=1;return ie.substring(ve).replace(/^\s/,"")}e.lcut=oe;const le=/\x1B\x5B[12]?K/g,Se=/\x1b\[\d+m/g,fe=/\x1b\[0?m/g;function pe(ie){return ie&&(ie=ie.replace(le,""),ie=ie.replace(Se,""),ie=ie.replace(fe,"")),ie}e.removeAnsiEscapeCodes=pe,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Ce(ie){return!!(ie&&ie.length>0&&ie.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Ce;function be(ie){return Ce(ie)?ie.substr(1):ie}e.stripUTF8BOM=be;function Ie(ie,ce){if(!ie||!ce||ie.length<ce.length)return!1;const de=ce.length,ve=ie.toLowerCase();let ge=0,we=-1;for(;ge<de;){const De=ve.indexOf(ce[ge],we+1);if(De<0)return!1;we=De,ge++}return!0}e.fuzzyContains=Ie;function qe(ie,ce=!1){return ie?(ce&&(ie=ie.replace(/\\./g,"")),ie.toLowerCase()!==ie):!1}e.containsUppercaseCharacter=qe;function Qe(ie){return ie.charAt(0).toUpperCase()+ie.slice(1)}e.uppercaseFirstLetter=Qe;function Ke(ie,ce=1){if(ce===0)return"";let de=-1;do de=ie.indexOf(`
`,de+1),ce--;while(ce>0&&de>=0);return de===-1?ie:(ie[de-1]==="\r"&&de--,ie.substr(0,de))}e.getNLines=Ke;function Ye(ie){const ce=90-65+1;return ie=ie%(2*ce),ie<ce?String.fromCharCode(97+ie):String.fromCharCode(65+ie-ce)}e.singleLetterHash=Ye;function ae(ie){return Ee.getInstance().getGraphemeBreakType(ie)}e.getGraphemeBreakType=ae;function ue(ie,ce){return ie===0?ce!==5&&ce!==7:ie===2&&ce===3?!1:ie===4||ie===2||ie===3||ce===4||ce===2||ce===3?!0:!(ie===8&&(ce===8||ce===9||ce===11||ce===12)||(ie===11||ie===9)&&(ce===9||ce===10)||(ie===12||ie===10)&&ce===10||ce===5||ce===13||ce===7||ie===1||ie===13&&ce===14||ie===6&&ce===6)}var he;(function(ie){ie[ie.Other=0]="Other",ie[ie.Prepend=1]="Prepend",ie[ie.CR=2]="CR",ie[ie.LF=3]="LF",ie[ie.Control=4]="Control",ie[ie.Extend=5]="Extend",ie[ie.Regional_Indicator=6]="Regional_Indicator",ie[ie.SpacingMark=7]="SpacingMark",ie[ie.L=8]="L",ie[ie.V=9]="V",ie[ie.T=10]="T",ie[ie.LV=11]="LV",ie[ie.LVT=12]="LVT",ie[ie.ZWJ=13]="ZWJ",ie[ie.Extended_Pictographic=14]="Extended_Pictographic"})(he=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Ee{constructor(){this._data=Pe()}static getInstance(){return Ee._INSTANCE||(Ee._INSTANCE=new Ee),Ee._INSTANCE}getGraphemeBreakType(ce){if(ce<32)return ce===10?3:ce===13?2:4;if(ce<127)return 0;const de=this._data,ve=de.length/3;let ge=1;for(;ge<=ve;)if(ce<de[3*ge])ge=2*ge;else if(ce>de[3*ge+1])ge=2*ge+1;else return de[3*ge+2];return 0}}Ee._INSTANCE=null;function Pe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ue(ie,ce){if(ie===0)return 0;const de=Re(ie,ce);if(de!==void 0)return de;const ve=new X(ce,ie);return ve.prevCodePoint(),ve.offset}e.getLeftDeleteOffset=Ue;function Re(ie,ce){const de=new X(ce,ie);let ve=de.prevCodePoint();for(;Ne(ve)||ve===65039||ve===8419;){if(de.offset===0)return;ve=de.prevCodePoint()}if(!ne(ve))return;let ge=de.offset;return ge>0&&de.prevCodePoint()===8205&&(ge=de.offset),ge}function Ne(ie){return 127995<=ie&&ie<=127999}var _e;(function(ie){ie[ie.zwj=8205]="zwj",ie[ie.emojiVariantSelector=65039]="emojiVariantSelector",ie[ie.enclosingKeyCap=8419]="enclosingKeyCap"})(_e||(_e={})),e.noBreakWhitespace="\xA0";class Te{constructor(ce){this.confusableDictionary=ce}static getInstance(ce){return Te.cache.get(Array.from(ce))}static getLocales(){return Te._locales.getValue()}isAmbiguous(ce){return this.confusableDictionary.has(ce)}getPrimaryConfusable(ce){return this.confusableDictionary.get(ce)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=Te,T=Te,Te.ambiguousCharacterData=new t.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Te.cache=new k.LRUCachedFunction(ie=>{function ce(Ae){const Fe=new Map;for(let $e=0;$e<Ae.length;$e+=2)Fe.set(Ae[$e],Ae[$e+1]);return Fe}function de(Ae,Fe){const $e=new Map(Ae);for(const[Xe,rt]of Fe)$e.set(Xe,rt);return $e}function ve(Ae,Fe){if(!Ae)return Fe;const $e=new Map;for(const[Xe,rt]of Ae)Fe.has(Xe)&&$e.set(Xe,rt);return $e}const ge=T.ambiguousCharacterData.getValue();let we=ie.filter(Ae=>!Ae.startsWith("_")&&Ae in ge);we.length===0&&(we=["_default"]);let De;for(const Ae of we){const Fe=ce(ge[Ae]);De=ve(De,Fe)}const ke=ce(ge._common),Le=de(ke,De);return new Te(Le)}),Te._locales=new t.Lazy(()=>Object.keys(Te.ambiguousCharacterData.getValue()).filter(ie=>!ie.startsWith("_")));class Me{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(Me.getRawData())),this._data}static isInvisibleCharacter(ce){return Me.getData().has(ce)}static get codePoints(){return Me.getData()}}e.InvisibleCharacters=Me,Me._data=void 0}),define(re[42],se([0,1,12,4,26,14]),function(Z,e,k,t,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function A(c){return c===47||c===92}e.isPathSeparator=A;function I(c){return c.replace(/[\\/]/g,k.posix.sep)}e.toSlashes=I;function b(c){return c.indexOf("/")===-1&&(c=I(c)),/^[a-zA-Z]:(\/|$)/.test(c)&&(c="/"+c),c}e.toPosixPath=b;function P(c,s=k.posix.sep){if(!c)return"";const o=c.length,l=c.charCodeAt(0);if(A(l)){if(A(c.charCodeAt(1))&&!A(c.charCodeAt(2))){let y=3;const O=y;for(;y<o&&!A(c.charCodeAt(y));y++);if(O!==y&&!A(c.charCodeAt(y+1))){for(y+=1;y<o;y++)if(A(c.charCodeAt(y)))return c.slice(0,y+1).replace(/[\\/]/g,s)}}return s}else if(d(l)&&c.charCodeAt(1)===58)return A(c.charCodeAt(2))?c.slice(0,2)+s:c.slice(0,2);let v=c.indexOf("://");if(v!==-1){for(v+=3;v<o;v++)if(A(c.charCodeAt(v)))return c.slice(0,v+1)}return""}e.getRoot=P;function D(c){if(!t.isWindows||!c||c.length<5)return!1;let s=c.charCodeAt(0);if(s!==92||(s=c.charCodeAt(1),s!==92))return!1;let o=2;const l=o;for(;o<c.length&&(s=c.charCodeAt(o),s!==92);o++);return!(l===o||(s=c.charCodeAt(o+1),isNaN(s)||s===92))}e.isUNC=D;const E=/[\\/:\*\?"<>\|]/g,p=/[\\/]/g,C=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function h(c,s=t.isWindows){const o=s?E:p;return!(!c||c.length===0||/^\s+$/.test(c)||(o.lastIndex=0,o.test(c))||s&&C.test(c)||c==="."||c===".."||s&&c[c.length-1]==="."||s&&c.length!==c.trim().length||c.length>255)}e.isValidBasename=h;function S(c,s,o){const l=c===s;return!o||l?l:!c||!s?!1:(0,T.equalsIgnoreCase)(c,s)}e.isEqual=S;function w(c,s,o,l=k.sep){if(c===s)return!0;if(!c||!s||s.length>c.length)return!1;if(o){if(!(0,T.startsWithIgnoreCase)(c,s))return!1;if(s.length===c.length)return!0;let y=s.length;return s.charAt(s.length-1)===l&&y--,c.charAt(y)===l}return s.charAt(s.length-1)!==l&&(s+=l),c.indexOf(s)===0}e.isEqualOrParent=w;function d(c){return c>=65&&c<=90||c>=97&&c<=122}e.isWindowsDriveLetter=d;function m(c,s){return t.isWindows&&c.endsWith(":")&&(c+=k.sep),(0,k.isAbsolute)(c)||(c=(0,k.join)(s,c)),c=(0,k.normalize)(c),t.isWindows?(c=(0,T.rtrim)(c,k.sep),c.endsWith(":")&&(c+=k.sep)):(c=(0,T.rtrim)(c,k.sep),c||(c=k.sep)),c}e.sanitizeFilePath=m;function g(c){const s=(0,k.normalize)(c);return t.isWindows?c.length>3?!1:f(s)&&(c.length===2||s.charCodeAt(2)===92):s===k.posix.sep}e.isRootOrDriveLetter=g;function f(c,s=t.isWindows){return s?d(c.charCodeAt(0))&&c.charCodeAt(1)===58:!1}e.hasDriveLetter=f;function u(c){return f(c)?c[0]:void 0}e.getDriveLetter=u;function r(c,s,o){return s.length>c.length?-1:c===s?0:(o&&(c=c.toLowerCase(),s=s.toLowerCase()),c.indexOf(s))}e.indexOfPath=r;function n(c){const s=c.split(":");let o,l,v;for(const y of s){const O=Number(y);(0,L.isNumber)(O)?l===void 0?l=O:v===void 0&&(v=O):o=o?[o,y].join(":"):y}if(!o)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:o,line:l!==void 0?l:void 0,column:v!==void 0?v:l!==void 0?1:void 0}}e.parseLineAndColumnAware=n;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function a(c,s,o=8){let l="";for(let y=0;y<o;y++)l+=i.charAt(Math.floor(Math.random()*i.length));let v;return s?v=`${s}-${l}`:v=l,c?(0,k.join)(c,v):v}e.randomPath=a}),define(re[63],se([0,1,26]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function t(d){return T(d,0)}e.hash=t;function T(d,m){switch(typeof d){case"object":return d===null?L(349,m):Array.isArray(d)?b(d,m):P(d,m);case"string":return I(d,m);case"boolean":return A(d,m);case"number":return L(d,m);case"undefined":return L(937,m);default:return L(617,m)}}e.doHash=T;function L(d,m){return(m<<5)-m+d|0}e.numberHash=L;function A(d,m){return L(d?433:863,m)}function I(d,m){m=L(149417,m);for(let g=0,f=d.length;g<f;g++)m=L(d.charCodeAt(g),m);return m}e.stringHash=I;function b(d,m){return m=L(104579,m),d.reduce((g,f)=>T(f,g),m)}function P(d,m){return m=L(181387,m),Object.keys(d).sort().reduce((g,f)=>(g=I(f,g),T(d[f],g)),m)}class D{constructor(){this._value=0}get value(){return this._value}hash(m){return this._value=T(m,this._value),this._value}}e.Hasher=D;var E;(function(d){d[d.BLOCK_SIZE=64]="BLOCK_SIZE",d[d.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(E||(E={}));function p(d,m,g=32){const f=g-m,u=~((1<<f)-1);return(d<<m|(u&d)>>>f)>>>0}function C(d,m=0,g=d.byteLength,f=0){for(let u=0;u<g;u++)d[m+u]=f}function h(d,m,g="0"){for(;d.length<m;)d=g+d;return d}function S(d,m=32){return d instanceof ArrayBuffer?Array.from(new Uint8Array(d)).map(g=>g.toString(16).padStart(2,"0")).join(""):h((d>>>0).toString(16),m/4)}e.toHexString=S;class w{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(m){const g=m.length;if(g===0)return;const f=this._buff;let u=this._buffLen,r=this._leftoverHighSurrogate,n,i;for(r!==0?(n=r,i=-1,r=0):(n=m.charCodeAt(0),i=0);;){let a=n;if(k.isHighSurrogate(n))if(i+1<g){const c=m.charCodeAt(i+1);k.isLowSurrogate(c)?(i++,a=k.computeCodePoint(n,c)):a=65533}else{r=n;break}else k.isLowSurrogate(n)&&(a=65533);if(u=this._push(f,u,a),i++,i<g)n=m.charCodeAt(i);else break}this._buffLen=u,this._leftoverHighSurrogate=r}_push(m,g,f){return f<128?m[g++]=f:f<2048?(m[g++]=192|(f&1984)>>>6,m[g++]=128|(f&63)>>>0):f<65536?(m[g++]=224|(f&61440)>>>12,m[g++]=128|(f&4032)>>>6,m[g++]=128|(f&63)>>>0):(m[g++]=240|(f&1835008)>>>18,m[g++]=128|(f&258048)>>>12,m[g++]=128|(f&4032)>>>6,m[g++]=128|(f&63)>>>0),g>=64&&(this._step(),g-=64,this._totalLen+=64,m[0]=m[64+0],m[1]=m[64+1],m[2]=m[64+2]),g}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),S(this._h0)+S(this._h1)+S(this._h2)+S(this._h3)+S(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,C(this._buff,this._buffLen),this._buffLen>56&&(this._step(),C(this._buff));const m=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(m/4294967296),!1),this._buffDV.setUint32(60,m%4294967296,!1),this._step()}_step(){const m=w._bigBlock32,g=this._buffDV;for(let o=0;o<64;o+=4)m.setUint32(o,g.getUint32(o,!1),!1);for(let o=64;o<320;o+=4)m.setUint32(o,p(m.getUint32(o-12,!1)^m.getUint32(o-32,!1)^m.getUint32(o-56,!1)^m.getUint32(o-64,!1),1),!1);let f=this._h0,u=this._h1,r=this._h2,n=this._h3,i=this._h4,a,c,s;for(let o=0;o<80;o++)o<20?(a=u&r|~u&n,c=1518500249):o<40?(a=u^r^n,c=1859775393):o<60?(a=u&r|u&n|r&n,c=2400959708):(a=u^r^n,c=3395469782),s=p(f,5)+a+i+c+m.getUint32(o*4,!1)&4294967295,i=n,n=r,r=p(u,30),u=f,f=s;this._h0=this._h0+f&4294967295,this._h1=this._h1+u&4294967295,this._h2=this._h2+r&4294967295,this._h3=this._h3+n&4294967295,this._h4=this._h4+i&4294967295}}e.StringSHA1=w,w._bigBlock32=new DataView(new ArrayBuffer(320))});var It=this&&this.__classPrivateFieldSet||function(Z,e,k,t,T){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!T:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?T.call(Z,k):T?T.value=k:e.set(Z,k),k},Ge=this&&this.__classPrivateFieldGet||function(Z,e,k,t){if(k==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return k==="m"?t:k==="a"?t.call(Z):t?t.value:e.get(Z)};define(re[38],se([0,1,17,26]),function(Z,e,k,t){"use strict";var T,L,A,I;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function b(c,s,o){let l=c.get(s);return l===void 0&&(l=o,c.set(s,l)),l}e.getOrSet=b;function P(c){const s=[];return c.forEach((o,l)=>{s.push(`${l} => ${o}`)}),`Map(${c.size}) {${s.join(", ")}}`}e.mapToString=P;function D(c){const s=[];return c.forEach(o=>{s.push(o)}),`Set(${c.size}) {${s.join(", ")}}`}e.setToString=D;class E{constructor(){this._value="",this._pos=0}reset(s){return this._value=s,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(s){const o=s.charCodeAt(0),l=this._value.charCodeAt(this._pos);return o-l}value(){return this._value[this._pos]}}e.StringIterator=E;class p{constructor(s=!0){this._caseSensitive=s}reset(s){return this._value=s,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let s=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(s)this._from++;else break;else s=!1;return this}cmp(s){return this._caseSensitive?(0,t.compareSubstring)(s,this._value,0,s.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(s,this._value,0,s.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=p;class C{constructor(s=!0,o=!0){this._splitOnBackslash=s,this._caseSensitive=o}reset(s){this._from=0,this._to=0,this._value=s,this._valueLen=s.length;for(let o=s.length-1;o>=0;o--,this._valueLen--){const l=this._value.charCodeAt(o);if(!(l===47||this._splitOnBackslash&&l===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let s=!0;for(;this._to<this._valueLen;this._to++){const o=this._value.charCodeAt(this._to);if(o===47||this._splitOnBackslash&&o===92)if(s)this._from++;else break;else s=!1}return this}cmp(s){return this._caseSensitive?(0,t.compareSubstring)(s,this._value,0,s.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(s,this._value,0,s.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=C;var h;(function(c){c[c.Scheme=1]="Scheme",c[c.Authority=2]="Authority",c[c.Path=3]="Path",c[c.Query=4]="Query",c[c.Fragment=5]="Fragment"})(h||(h={}));class S{constructor(s,o){this._ignorePathCasing=s,this._ignoreQueryAndFragment=o,this._states=[],this._stateIdx=0}reset(s){return this._value=s,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new C(!1,!this._ignorePathCasing(s)),this._pathIterator.reset(s.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(s)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(s){if(this._states[this._stateIdx]===1)return(0,t.compareIgnoreCase)(s,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,t.compareIgnoreCase)(s,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(s);if(this._states[this._stateIdx]===4)return(0,t.compare)(s,this._value.query);if(this._states[this._stateIdx]===5)return(0,t.compare)(s,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=S;class w{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const s=this.right;return this.right=s.left,s.left=this,this.updateHeight(),s.updateHeight(),s}rotateRight(){const s=this.left;return this.left=s.right,s.right=this,this.updateHeight(),s.updateHeight(),s}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var d;(function(c){c[c.Left=-1]="Left",c[c.Mid=0]="Mid",c[c.Right=1]="Right"})(d||(d={}));class m{constructor(s){this._iter=s}static forUris(s=()=>!1,o=()=>!1){return new m(new S(s,o))}static forPaths(s=!1){return new m(new C(void 0,!s))}static forStrings(){return new m(new E)}static forConfigKeys(){return new m(new p)}clear(){this._root=void 0}fill(s,o){if(o){const l=o.slice(0);(0,k.shuffle)(l);for(const v of l)this.set(v,s)}else{const l=s.slice(0);(0,k.shuffle)(l);for(const v of l)this.set(v[0],v[1])}}set(s,o){const l=this._iter.reset(s);let v;this._root||(this._root=new w,this._root.segment=l.value());const y=[];for(v=this._root;;){const _=l.cmp(v.segment);if(_>0)v.left||(v.left=new w,v.left.segment=l.value()),y.push([-1,v]),v=v.left;else if(_<0)v.right||(v.right=new w,v.right.segment=l.value()),y.push([1,v]),v=v.right;else if(l.hasNext())l.next(),v.mid||(v.mid=new w,v.mid.segment=l.value()),y.push([0,v]),v=v.mid;else break}const O=v.value;v.value=o,v.key=s;for(let _=y.length-1;_>=0;_--){const F=y[_][1];F.updateHeight();const R=F.balanceFactor();if(R<-1||R>1){const U=y[_][0],M=y[_+1][0];if(U===1&&M===1)y[_][1]=F.rotateLeft();else if(U===-1&&M===-1)y[_][1]=F.rotateRight();else if(U===1&&M===-1)F.right=y[_+1][1]=y[_+1][1].rotateRight(),y[_][1]=F.rotateLeft();else if(U===-1&&M===1)F.left=y[_+1][1]=y[_+1][1].rotateLeft(),y[_][1]=F.rotateRight();else throw new Error;if(_>0)switch(y[_-1][0]){case-1:y[_-1][1].left=y[_][1];break;case 1:y[_-1][1].right=y[_][1];break;case 0:y[_-1][1].mid=y[_][1];break}else this._root=y[0][1]}}return O}get(s){return this._getNode(s)?.value}_getNode(s){const o=this._iter.reset(s);let l=this._root;for(;l;){const v=o.cmp(l.segment);if(v>0)l=l.left;else if(v<0)l=l.right;else if(o.hasNext())o.next(),l=l.mid;else break}return l}has(s){const o=this._getNode(s);return!(o?.value===void 0&&o?.mid===void 0)}delete(s){return this._delete(s,!1)}deleteSuperstr(s){return this._delete(s,!0)}_delete(s,o){const l=this._iter.reset(s),v=[];let y=this._root;for(;y;){const O=l.cmp(y.segment);if(O>0)v.push([-1,y]),y=y.left;else if(O<0)v.push([1,y]),y=y.right;else if(l.hasNext())l.next(),v.push([0,y]),y=y.mid;else break}if(!!y){if(o?(y.left=void 0,y.mid=void 0,y.right=void 0,y.height=1):(y.key=void 0,y.value=void 0),!y.mid&&!y.value)if(y.left&&y.right){const O=this._min(y.right),{key:_,value:F,segment:R}=O;this._delete(O.key,!1),y.key=_,y.value=F,y.segment=R}else{const O=y.left??y.right;if(v.length>0){const[_,F]=v[v.length-1];switch(_){case-1:F.left=O;break;case 0:F.mid=O;break;case 1:F.right=O;break}}else this._root=O}for(let O=v.length-1;O>=0;O--){const _=v[O][1];_.updateHeight();const F=_.balanceFactor();if(F>1?(_.right.balanceFactor()>=0||(_.right=_.right.rotateRight()),v[O][1]=_.rotateLeft()):F<-1&&(_.left.balanceFactor()<=0||(_.left=_.left.rotateLeft()),v[O][1]=_.rotateRight()),O>0)switch(v[O-1][0]){case-1:v[O-1][1].left=v[O][1];break;case 1:v[O-1][1].right=v[O][1];break;case 0:v[O-1][1].mid=v[O][1];break}else this._root=v[0][1]}}}_min(s){for(;s.left;)s=s.left;return s}findSubstr(s){const o=this._iter.reset(s);let l=this._root,v;for(;l;){const y=o.cmp(l.segment);if(y>0)l=l.left;else if(y<0)l=l.right;else if(o.hasNext())o.next(),v=l.value||v,l=l.mid;else break}return l&&l.value||v}findSuperstr(s){const o=this._iter.reset(s);let l=this._root;for(;l;){const v=o.cmp(l.segment);if(v>0)l=l.left;else if(v<0)l=l.right;else if(o.hasNext())o.next(),l=l.mid;else return l.mid?this._entries(l.mid):void 0}}forEach(s){for(const[o,l]of this)s(l,o)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(s){!s||(s.left&&(yield*this._entries(s.left)),s.value&&(yield[s.key,s.value]),s.mid&&(yield*this._entries(s.mid)),s.right&&(yield*this._entries(s.right)))}_isBalanced(){const s=o=>{if(!o)return!0;const l=o.balanceFactor();return l<-1||l>1?!1:s(o.left)&&s(o.right)};return s(this._root)}}e.TernarySearchTree=m;class g{constructor(s,o){this.uri=s,this.value=o}}class f{constructor(s,o){this[T]="ResourceMap",s instanceof f?(this.map=new Map(s.map),this.toKey=o??f.defaultToKey):(this.map=new Map,this.toKey=s??f.defaultToKey)}set(s,o){return this.map.set(this.toKey(s),new g(s,o)),this}get(s){return this.map.get(this.toKey(s))?.value}has(s){return this.map.has(this.toKey(s))}get size(){return this.map.size}clear(){this.map.clear()}delete(s){return this.map.delete(this.toKey(s))}forEach(s,o){typeof o!="undefined"&&(s=s.bind(o));for(const[l,v]of this.map)s(v.value,v.uri,this)}*values(){for(const s of this.map.values())yield s.value}*keys(){for(const s of this.map.values())yield s.uri}*entries(){for(const s of this.map.values())yield[s.uri,s.value]}*[(T=Symbol.toStringTag,Symbol.iterator)](){for(const[,s]of this.map)yield[s.uri,s.value]}}e.ResourceMap=f,f.defaultToKey=c=>c.toString();class u{constructor(s,o){this[L]="ResourceSet",!s||typeof s=="function"?this._map=new f(s):(this._map=new f(o),s.forEach(this.add,this))}get size(){return this._map.size}add(s){return this._map.set(s,s),this}clear(){this._map.clear()}delete(s){return this._map.delete(s)}forEach(s,o){this._map.forEach((l,v)=>s.call(o,v,v,this))}has(s){return this._map.has(s)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=u;var r;(function(c){c[c.None=0]="None",c[c.AsOld=1]="AsOld",c[c.AsNew=2]="AsNew"})(r=e.Touch||(e.Touch={}));class n{constructor(){this[A]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(s){return this._map.has(s)}get(s,o=0){const l=this._map.get(s);if(!!l)return o!==0&&this.touch(l,o),l.value}set(s,o,l=0){let v=this._map.get(s);if(v)v.value=o,l!==0&&this.touch(v,l);else{switch(v={key:s,value:o,next:void 0,previous:void 0},l){case 0:this.addItemLast(v);break;case 1:this.addItemFirst(v);break;case 2:this.addItemLast(v);break;default:this.addItemLast(v);break}this._map.set(s,v),this._size++}return this}delete(s){return!!this.remove(s)}remove(s){const o=this._map.get(s);if(!!o)return this._map.delete(s),this.removeItem(o),this._size--,o.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const s=this._head;return this._map.delete(s.key),this.removeItem(s),this._size--,s.value}forEach(s,o){const l=this._state;let v=this._head;for(;v;){if(o?s.bind(o)(v.value,v.key,this):s(v.value,v.key,this),this._state!==l)throw new Error("LinkedMap got modified during iteration.");v=v.next}}keys(){const s=this,o=this._state;let l=this._head;const v={[Symbol.iterator](){return v},next(){if(s._state!==o)throw new Error("LinkedMap got modified during iteration.");if(l){const y={value:l.key,done:!1};return l=l.next,y}else return{value:void 0,done:!0}}};return v}values(){const s=this,o=this._state;let l=this._head;const v={[Symbol.iterator](){return v},next(){if(s._state!==o)throw new Error("LinkedMap got modified during iteration.");if(l){const y={value:l.value,done:!1};return l=l.next,y}else return{value:void 0,done:!0}}};return v}entries(){const s=this,o=this._state;let l=this._head;const v={[Symbol.iterator](){return v},next(){if(s._state!==o)throw new Error("LinkedMap got modified during iteration.");if(l){const y={value:[l.key,l.value],done:!1};return l=l.next,y}else return{value:void 0,done:!0}}};return v}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(s){if(s>=this.size)return;if(s===0){this.clear();return}let o=this._head,l=this.size;for(;o&&l>s;)this._map.delete(o.key),o=o.next,l--;this._head=o,this._size=l,o&&(o.previous=void 0),this._state++}addItemFirst(s){if(!this._head&&!this._tail)this._tail=s;else if(this._head)s.next=this._head,this._head.previous=s;else throw new Error("Invalid list");this._head=s,this._state++}addItemLast(s){if(!this._head&&!this._tail)this._head=s;else if(this._tail)s.previous=this._tail,this._tail.next=s;else throw new Error("Invalid list");this._tail=s,this._state++}removeItem(s){if(s===this._head&&s===this._tail)this._head=void 0,this._tail=void 0;else if(s===this._head){if(!s.next)throw new Error("Invalid list");s.next.previous=void 0,this._head=s.next}else if(s===this._tail){if(!s.previous)throw new Error("Invalid list");s.previous.next=void 0,this._tail=s.previous}else{const o=s.next,l=s.previous;if(!o||!l)throw new Error("Invalid list");o.previous=l,l.next=o}s.next=void 0,s.previous=void 0,this._state++}touch(s,o){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(o!==1&&o!==2)){if(o===1){if(s===this._head)return;const l=s.next,v=s.previous;s===this._tail?(v.next=void 0,this._tail=v):(l.previous=v,v.next=l),s.previous=void 0,s.next=this._head,this._head.previous=s,this._head=s,this._state++}else if(o===2){if(s===this._tail)return;const l=s.next,v=s.previous;s===this._head?(l.previous=void 0,this._head=l):(l.previous=v,v.next=l),s.next=void 0,s.previous=this._tail,this._tail.next=s,this._tail=s,this._state++}}}toJSON(){const s=[];return this.forEach((o,l)=>{s.push([l,o])}),s}fromJSON(s){this.clear();for(const[o,l]of s)this.set(o,l)}}e.LinkedMap=n;class i extends n{constructor(s,o=1){super();this._limit=s,this._ratio=Math.min(Math.max(0,o),1)}get limit(){return this._limit}set limit(s){this._limit=s,this.checkTrim()}get ratio(){return this._ratio}set ratio(s){this._ratio=Math.min(Math.max(0,s),1),this.checkTrim()}get(s,o=2){return super.get(s,o)}peek(s){return super.get(s,0)}set(s,o){return super.set(s,o,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=i;class a{constructor(s){I.set(this,void 0),It(this,I,s,"f")}get size(){return Ge(this,I,"f").size}forEach(s,o){Ge(this,I,"f").forEach(s,o)}get(s){return Ge(this,I,"f").get(s)}has(s){return Ge(this,I,"f").has(s)}entries(){return Ge(this,I,"f").entries()}keys(){return Ge(this,I,"f").keys()}values(){return Ge(this,I,"f").values()}[(I=new WeakMap,Symbol.iterator)](){return Ge(this,I,"f").entries()}}e.ReadonlyMapView=a}),define(re[80],se([0,1,38]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const t=new k.LRUCache(1e4);function T(P){return b(P,"NFC",t)}e.normalizeNFC=T;const L=new k.LRUCache(1e4);function A(P){return b(P,"NFD",L)}e.normalizeNFD=A;const I=/[^\u0000-\u0080]/;function b(P,D,E){if(!P)return P;const p=E.get(P);if(p)return p;let C;return I.test(P)?C=P.normalize(D):C=P,E.set(P,C),C}e.removeAccents=function(){const P=/[\u0300-\u036f]/g;return function(D){return A(D).replace(P,"")}}()}),define(re[81],se([0,1,26]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var t;(function(T){T[T.Ignore=0]="Ignore",T[T.Info=1]="Info",T[T.Warning=2]="Warning",T[T.Error=3]="Error"})(t||(t={})),function(T){const L="error",A="warning",I="warn",b="info",P="ignore";function D(p){return p?k.equalsIgnoreCase(L,p)?T.Error:k.equalsIgnoreCase(A,p)||k.equalsIgnoreCase(I,p)?T.Warning:k.equalsIgnoreCase(b,p)?T.Info:T.Ignore:T.Ignore}T.fromValue=D;function E(p){switch(p){case T.Error:return L;case T.Warning:return A;case T.Info:return b;default:return P}}T.toString=E}(t||(t={})),e.default=t}),define(re[8],se([0,1,12,4]),function(Z,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const T=/^\w[\w\d+.-]*$/,L=/^\//,A=/^\/\//;function I(i,a){if(!i.scheme&&a)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!T.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!L.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(A.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function b(i,a){return!i&&!a?"file":i}function P(i,a){switch(i){case"https":case"http":case"file":a?a[0]!==E&&(a=E+a):a=E;break}return a}const D="",E="/",p=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class C{constructor(a,c,s,o,l,v=!1){typeof a=="object"?(this.scheme=a.scheme||D,this.authority=a.authority||D,this.path=a.path||D,this.query=a.query||D,this.fragment=a.fragment||D):(this.scheme=b(a,v),this.authority=c||D,this.path=P(this.scheme,s||D),this.query=o||D,this.fragment=l||D,I(this,v))}static isUri(a){return a instanceof C?!0:a?typeof a.authority=="string"&&typeof a.fragment=="string"&&typeof a.path=="string"&&typeof a.query=="string"&&typeof a.scheme=="string"&&typeof a.fsPath=="string"&&typeof a.with=="function"&&typeof a.toString=="function":!1}get fsPath(){return g(this,!1)}with(a){if(!a)return this;let{scheme:c,authority:s,path:o,query:l,fragment:v}=a;return c===void 0?c=this.scheme:c===null&&(c=D),s===void 0?s=this.authority:s===null&&(s=D),o===void 0?o=this.path:o===null&&(o=D),l===void 0?l=this.query:l===null&&(l=D),v===void 0?v=this.fragment:v===null&&(v=D),c===this.scheme&&s===this.authority&&o===this.path&&l===this.query&&v===this.fragment?this:new S(c,s,o,l,v)}static parse(a,c=!1){const s=p.exec(a);return s?new S(s[2]||D,n(s[4]||D),n(s[5]||D),n(s[7]||D),n(s[9]||D),c):new S(D,D,D,D,D)}static file(a){let c=D;if(t.isWindows&&(a=a.replace(/\\/g,E)),a[0]===E&&a[1]===E){const s=a.indexOf(E,2);s===-1?(c=a.substring(2),a=E):(c=a.substring(2,s),a=a.substring(s)||E)}return new S("file",c,a,D,D)}static from(a){const c=new S(a.scheme,a.authority,a.path,a.query,a.fragment);return I(c,!0),c}static joinPath(a,...c){if(!a.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let s;return t.isWindows&&a.scheme==="file"?s=C.file(k.win32.join(g(a,!0),...c)).path:s=k.posix.join(a.path,...c),a.with({path:s})}toString(a=!1){return f(this,a)}toJSON(){return this}static revive(a){if(a){if(a instanceof C)return a;{const c=new S(a);return c._formatted=a.external,c._fsPath=a._sep===h?a.fsPath:null,c}}else return a}}e.URI=C;const h=t.isWindows?1:void 0;class S extends C{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=g(this,!1)),this._fsPath}toString(a=!1){return a?f(this,!0):(this._formatted||(this._formatted=f(this,!1)),this._formatted)}toJSON(){const a={$mid:1};return this._fsPath&&(a.fsPath=this._fsPath,a._sep=h),this._formatted&&(a.external=this._formatted),this.path&&(a.path=this.path),this.scheme&&(a.scheme=this.scheme),this.authority&&(a.authority=this.authority),this.query&&(a.query=this.query),this.fragment&&(a.fragment=this.fragment),a}}const w={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function d(i,a){let c,s=-1;for(let o=0;o<i.length;o++){const l=i.charCodeAt(o);if(l>=97&&l<=122||l>=65&&l<=90||l>=48&&l<=57||l===45||l===46||l===95||l===126||a&&l===47)s!==-1&&(c+=encodeURIComponent(i.substring(s,o)),s=-1),c!==void 0&&(c+=i.charAt(o));else{c===void 0&&(c=i.substr(0,o));const v=w[l];v!==void 0?(s!==-1&&(c+=encodeURIComponent(i.substring(s,o)),s=-1),c+=v):s===-1&&(s=o)}}return s!==-1&&(c+=encodeURIComponent(i.substring(s))),c!==void 0?c:i}function m(i){let a;for(let c=0;c<i.length;c++){const s=i.charCodeAt(c);s===35||s===63?(a===void 0&&(a=i.substr(0,c)),a+=w[s]):a!==void 0&&(a+=i[c])}return a!==void 0?a:i}function g(i,a){let c;return i.authority&&i.path.length>1&&i.scheme==="file"?c=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?a?c=i.path.substr(1):c=i.path[1].toLowerCase()+i.path.substr(2):c=i.path,t.isWindows&&(c=c.replace(/\//g,"\\")),c}e.uriToFsPath=g;function f(i,a){const c=a?m:d;let s="",{scheme:o,authority:l,path:v,query:y,fragment:O}=i;if(o&&(s+=o,s+=":"),(l||o==="file")&&(s+=E,s+=E),l){let _=l.indexOf("@");if(_!==-1){const F=l.substr(0,_);l=l.substr(_+1),_=F.indexOf(":"),_===-1?s+=c(F,!1):(s+=c(F.substr(0,_),!1),s+=":",s+=c(F.substr(_+1),!1)),s+="@"}l=l.toLowerCase(),_=l.indexOf(":"),_===-1?s+=c(l,!1):(s+=c(l.substr(0,_),!1),s+=l.substr(_))}if(v){if(v.length>=3&&v.charCodeAt(0)===47&&v.charCodeAt(2)===58){const _=v.charCodeAt(1);_>=65&&_<=90&&(v=`/${String.fromCharCode(_+32)}:${v.substr(3)}`)}else if(v.length>=2&&v.charCodeAt(1)===58){const _=v.charCodeAt(0);_>=65&&_<=90&&(v=`${String.fromCharCode(_+32)}:${v.substr(2)}`)}s+=c(v,!0)}return y&&(s+="?",s+=c(y,!1)),O&&(s+="#",s+=a?O:d(O,!1)),s}function u(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+u(i.substr(3)):i}}const r=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function n(i){return i.match(r)?i.replace(r,a=>u(a)):i}}),define(re[128],se([0,1,8]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function t(P){const D=P;return D&&typeof D.type=="string"&&typeof D.severity=="string"}e.isRemoteConsoleLog=t;function T(P){const D=[];let E;try{const p=JSON.parse(P.arguments),C=p[p.length-1];C&&C.__$stack&&(p.pop(),E=C.__$stack),D.push(...p)}catch{D.push("Unable to log remote console arguments",P.arguments)}return{args:D,stack:E}}e.parse=T;function L(P){if(typeof P!="string")return L(T(P).stack);const D=P;if(D){const E=A(D),p=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(E||"");if(p&&p.length===4)return{uri:k.URI.file(p[1]),line:Number(p[2]),column:Number(p[3])}}}e.getFirstFrame=L;function A(P){if(!P)return P;const D=P.indexOf(`
`);return D===-1?P:P.substring(0,D)}function I(P,D){const{args:E,stack:p}=T(P),C=typeof E[0]=="string"&&E.length===1;let h=A(p);h&&(h=`(${h.trim()})`);let S=[];if(typeof E[0]=="string"?h&&C?S=[`%c[${D}] %c${E[0]} %c${h}`,b("blue"),b(""),b("grey")]:S=[`%c[${D}] %c${E[0]}`,b("blue"),b(""),...E.slice(1)]:S=[`%c[${D}]%`,b("blue"),...E],h&&!C&&S.push(h),typeof console[P.severity]!="function")throw new Error("Unknown console method");console[P.severity].apply(console,S)}e.log=I;function b(P){return`color: ${P}`}}),define(re[64],se([0,1,16,26,8]),function(Z,e,k,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function L(P){return JSON.stringify(P,I)}e.stringify=L;function A(P){let D=JSON.parse(P);return D=b(D),D}e.parse=A;function I(P,D){return D instanceof RegExp?{$mid:2,source:D.source,flags:(0,t.regExpFlags)(D)}:D}function b(P,D=0){if(!P||D>200)return P;if(typeof P=="object"){switch(P.$mid){case 1:return T.URI.revive(P);case 2:return new RegExp(P.source,P.flags);case 14:return new Date(P.source)}if(P instanceof k.VSBuffer||P instanceof Uint8Array)return P;if(Array.isArray(P))for(let E=0;E<P.length;++E)P[E]=b(P[E],D+1);else for(const E in P)Object.hasOwnProperty.call(P,E)&&(P[E]=b(P[E],D+1))}return P}e.revive=b}),define(re[20],se([0,1,4,8]),function(Z,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var T;(function(I){I.inMemory="inmemory",I.vscode="vscode",I.internal="private",I.walkThrough="walkThrough",I.walkThroughSnippet="walkThroughSnippet",I.http="http",I.https="https",I.file="file",I.mailto="mailto",I.untitled="untitled",I.data="data",I.command="command",I.vscodeRemote="vscode-remote",I.vscodeRemoteResource="vscode-remote-resource",I.vscodeUserData="vscode-userdata",I.vscodeCustomEditor="vscode-custom-editor",I.vscodeNotebook="vscode-notebook",I.vscodeNotebookCell="vscode-notebook-cell",I.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",I.vscodeNotebookCellOutput="vscode-notebook-cell-output",I.vscodeInteractive="vscode-interactive",I.vscodeInteractiveInput="vscode-interactive-input",I.vscodeSettings="vscode-settings",I.vscodeWorkspaceTrust="vscode-workspace-trust",I.vscodeTerminal="vscode-terminal",I.webviewPanel="webview-panel",I.vscodeWebview="vscode-webview",I.extension="extension",I.vscodeFileResource="vscode-file",I.tmp="tmp",I.vsls="vsls"})(T=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class L{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${T.vscodeRemoteResource}`}setPreferredWebSchema(b){this._preferredWebSchema=b}setDelegate(b){this._delegate=b}setServerRootPath(b){this._remoteResourcesPath=`${b}/${T.vscodeRemoteResource}`}set(b,P,D){this._hosts[b]=P,this._ports[b]=D}setConnectionToken(b,P){this._connectionTokens[b]=P}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(b){if(this._delegate)return this._delegate(b);const P=b.authority;let D=this._hosts[P];D&&D.indexOf(":")!==-1&&(D=`[${D}]`);const E=this._ports[P],p=this._connectionTokens[P];let C=`path=${encodeURIComponent(b.path)}`;return typeof p=="string"&&(C+=`&${e.connectionTokenQueryName}=${encodeURIComponent(p)}`),t.URI.from({scheme:k.isWeb?this._preferredWebSchema:T.vscodeRemoteResource,authority:`${D}:${E}`,path:this._remoteResourcesPath,query:C})}}e.RemoteAuthorities=new L;class A{asBrowserUri(b,P){const D=this.toUri(b,P);return D.scheme===T.vscodeRemote?e.RemoteAuthorities.rewrite(D):D.scheme===T.file&&(k.isNative||k.isWebWorker&&k.globals.origin===`${T.vscodeFileResource}://${A.FALLBACK_AUTHORITY}`)?D.with({scheme:T.vscodeFileResource,authority:D.authority||A.FALLBACK_AUTHORITY,query:null,fragment:null}):D}asFileUri(b,P){const D=this.toUri(b,P);return D.scheme===T.vscodeFileResource?D.with({scheme:T.file,authority:D.authority!==A.FALLBACK_AUTHORITY?D.authority:null,query:null,fragment:null}):D}toUri(b,P){return t.URI.isUri(b)?b:t.URI.parse(P.toUrl(b))}}A.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new A}),define(re[19],se([0,1,42,20,12,4,26,8]),function(Z,e,k,t,T,L,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function b(C){return(0,I.uriToFsPath)(C,!0)}e.originalFSPath=b;class P{constructor(h){this._ignorePathCasing=h}compare(h,S,w=!1){return h===S?0:(0,A.compare)(this.getComparisonKey(h,w),this.getComparisonKey(S,w))}isEqual(h,S,w=!1){return h===S?!0:!h||!S?!1:this.getComparisonKey(h,w)===this.getComparisonKey(S,w)}getComparisonKey(h,S=!1){return h.with({path:this._ignorePathCasing(h)?h.path.toLowerCase():void 0,fragment:S?null:void 0}).toString()}ignorePathCasing(h){return this._ignorePathCasing(h)}isEqualOrParent(h,S,w=!1){if(h.scheme===S.scheme){if(h.scheme===t.Schemas.file)return k.isEqualOrParent(b(h),b(S),this._ignorePathCasing(h))&&h.query===S.query&&(w||h.fragment===S.fragment);if((0,e.isEqualAuthority)(h.authority,S.authority))return k.isEqualOrParent(h.path,S.path,this._ignorePathCasing(h),"/")&&h.query===S.query&&(w||h.fragment===S.fragment)}return!1}joinPath(h,...S){return I.URI.joinPath(h,...S)}basenameOrAuthority(h){return(0,e.basename)(h)||h.authority}basename(h){return T.posix.basename(h.path)}extname(h){return T.posix.extname(h.path)}dirname(h){if(h.path.length===0)return h;let S;return h.scheme===t.Schemas.file?S=I.URI.file(T.dirname(b(h))).path:(S=T.posix.dirname(h.path),h.authority&&S.length&&S.charCodeAt(0)!==47&&(console.error(`dirname("${h.toString})) resulted in a relative path`),S="/")),h.with({path:S})}normalizePath(h){if(!h.path.length)return h;let S;return h.scheme===t.Schemas.file?S=I.URI.file(T.normalize(b(h))).path:S=T.posix.normalize(h.path),h.with({path:S})}relativePath(h,S){if(h.scheme!==S.scheme||!(0,e.isEqualAuthority)(h.authority,S.authority))return;if(h.scheme===t.Schemas.file){const m=T.relative(b(h),b(S));return L.isWindows?k.toSlashes(m):m}let w=h.path||"/";const d=S.path||"/";if(this._ignorePathCasing(h)){let m=0;for(const g=Math.min(w.length,d.length);m<g&&!(w.charCodeAt(m)!==d.charCodeAt(m)&&w.charAt(m).toLowerCase()!==d.charAt(m).toLowerCase());m++);w=d.substr(0,m)+w.substr(m)}return T.posix.relative(w,d)}resolvePath(h,S){if(h.scheme===t.Schemas.file){const w=I.URI.file(T.resolve(b(h),S));return h.with({authority:w.authority,path:w.path})}return S=k.toPosixPath(S),h.with({path:T.posix.resolve(h.path,S)})}isAbsolutePath(h){return!!h.path&&h.path[0]==="/"}isEqualAuthority(h,S){return h===S||h!==void 0&&S!==void 0&&(0,A.equalsIgnoreCase)(h,S)}hasTrailingPathSeparator(h,S=T.sep){if(h.scheme===t.Schemas.file){const w=b(h);return w.length>k.getRoot(w).length&&w[w.length-1]===S}else{const w=h.path;return w.length>1&&w.charCodeAt(w.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(h.fsPath)}}removeTrailingPathSeparator(h,S=T.sep){return(0,e.hasTrailingPathSeparator)(h,S)?h.with({path:h.path.substr(0,h.path.length-1)}):h}addTrailingPathSeparator(h,S=T.sep){let w=!1;if(h.scheme===t.Schemas.file){const d=b(h);w=d!==void 0&&d.length===k.getRoot(d).length&&d[d.length-1]===S}else{S="/";const d=h.path;w=d.length===1&&d.charCodeAt(d.length-1)===47}return!w&&!(0,e.hasTrailingPathSeparator)(h,S)?h.with({path:h.path+"/"}):h}}e.ExtUri=P,e.extUri=new P(()=>!1),e.extUriBiasedIgnorePathCase=new P(C=>C.scheme===t.Schemas.file?!L.isLinux:!0),e.extUriIgnorePathCase=new P(C=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function D(C,h){const S=[];for(let w=0;w<C.length;w++){const d=h(C[w]);C.some((m,g)=>g===w?!1:(0,e.isEqualOrParent)(d,h(m)))||S.push(C[w])}return S}e.distinctParents=D;var E;(function(C){C.META_DATA_LABEL="label",C.META_DATA_DESCRIPTION="description",C.META_DATA_SIZE="size",C.META_DATA_MIME="mime";function h(S){const w=new Map;S.path.substring(S.path.indexOf(";")+1,S.path.lastIndexOf(";")).split(";").forEach(g=>{const[f,u]=g.split(":");f&&u&&w.set(f,u)});const m=S.path.substring(0,S.path.indexOf(";"));return m&&w.set(C.META_DATA_MIME,m),w}C.parseMetaData=h})(E=e.DataUri||(e.DataUri={}));function p(C,h,S){if(h){let w=C.path;return w&&w[0]!==T.posix.sep&&(w=T.posix.sep+w),C.with({scheme:S,authority:h,path:w})}return C.with({scheme:S})}e.toLocalResource=p}),define(re[6],se([0,1,23,9,3,2,19,4]),function(Z,e,k,t,T,L,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function b(J){return!!J&&typeof J.then=="function"}e.isThenable=b;function P(J){const N=new k.CancellationTokenSource,$=J(N.token),j=new Promise((G,q)=>{const ee=N.token.onCancellationRequested(()=>{ee.dispose(),N.dispose(),q(new t.CancellationError)});Promise.resolve($).then(ne=>{ee.dispose(),N.dispose(),G(ne)},ne=>{ee.dispose(),N.dispose(),q(ne)})});return new class{cancel(){N.cancel()}then(G,q){return j.then(G,q)}catch(G){return this.then(void 0,G)}finally(G){return j.finally(G)}}}e.createCancelablePromise=P;function D(J,N,$){return new Promise((j,G)=>{const q=N.onCancellationRequested(()=>{q.dispose(),j($)});J.then(j,G).finally(()=>q.dispose())})}e.raceCancellation=D;function E(J,N){return new Promise(($,j)=>{const G=N.onCancellationRequested(()=>{G.dispose(),j(new t.CancellationError)});J.then($,j).finally(()=>G.dispose())})}e.raceCancellationError=E;async function p(J){let N=-1;const $=J.map((G,q)=>G.then(ee=>(N=q,ee))),j=await Promise.race($);return J.forEach((G,q)=>{q!==N&&G.cancel()}),j}e.raceCancellablePromises=p;function C(J,N,$){let j;const G=setTimeout(()=>{j?.(void 0),$?.()},N);return Promise.race([J.finally(()=>clearTimeout(G)),new Promise(q=>j=q)])}e.raceTimeout=C;function h(J){return new Promise((N,$)=>{const j=J();b(j)?j.then(N,$):N(j)})}e.asPromise=h;class S{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(N){if(this.activePromise){if(this.queuedPromiseFactory=N,!this.queuedPromise){const $=()=>{this.queuedPromise=null;const j=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,j};this.queuedPromise=new Promise(j=>{this.activePromise.then($,$).then(j)})}return new Promise(($,j)=>{this.queuedPromise.then($,j)})}return this.activePromise=N(),new Promise(($,j)=>{this.activePromise.then(G=>{this.activePromise=null,$(G)},G=>{this.activePromise=null,j(G)})})}}e.Throttler=S;class w{constructor(){this.current=Promise.resolve(null)}queue(N){return this.current=this.current.then(()=>N(),()=>N())}}e.Sequencer=w;class d{constructor(){this.promiseMap=new Map}queue(N,$){const G=(this.promiseMap.get(N)??Promise.resolve()).catch(()=>{}).then($).finally(()=>{this.promiseMap.get(N)===G&&this.promiseMap.delete(N)});return this.promiseMap.set(N,G),G}}e.SequencerByKey=d;const m=(J,N)=>{let $=!0;const j=setTimeout(()=>{$=!1,N()},J);return{isTriggered:()=>$,dispose:()=>{clearTimeout(j),$=!1}}},g=J=>{let N=!0;return queueMicrotask(()=>{N&&(N=!1,J())}),{isTriggered:()=>N,dispose:()=>{N=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class f{constructor(N){this.defaultDelay=N,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(N,$=this.defaultDelay){this.task=N,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((G,q)=>{this.doResolve=G,this.doReject=q}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const G=this.task;return this.task=null,G()}}));const j=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=$===e.MicrotaskDelay?g(j):m($,j),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new t.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=f;class u{constructor(N){this.delayer=new f(N),this.throttler=new S}trigger(N,$){return this.delayer.trigger(()=>this.throttler.queue(N),$)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=u;class r{constructor(){this._isOpen=!1,this._promise=new Promise((N,$)=>{this._completePromise=N})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=r;class n extends r{constructor(N){super();this._timeout=setTimeout(()=>this.open(),N)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=n;function i(J,N){return N?new Promise(($,j)=>{const G=setTimeout(()=>{q.dispose(),$()},J),q=N.onCancellationRequested(()=>{clearTimeout(G),q.dispose(),j(new t.CancellationError)})}):P($=>i(J,$))}e.timeout=i;function a(J,N=0){const $=setTimeout(J,N);return(0,L.toDisposable)(()=>clearTimeout($))}e.disposableTimeout=a;function c(J){const N=[];let $=0;const j=J.length;function G(){return $<j?J[$++]():null}function q(ee){ee!=null&&N.push(ee);const ne=G();return ne?ne.then(q):Promise.resolve(N)}return Promise.resolve(null).then(q)}e.sequence=c;function s(J,N=j=>!!j,$=null){let j=0;const G=J.length,q=()=>{if(j>=G)return Promise.resolve($);const ee=J[j++];return Promise.resolve(ee()).then(oe=>N(oe)?Promise.resolve(oe):q())};return q()}e.first=s;function o(J,N=j=>!!j,$=null){if(J.length===0)return Promise.resolve($);let j=J.length;const G=()=>{j=-1;for(const q of J)q.cancel?.()};return new Promise((q,ee)=>{for(const ne of J)ne.then(oe=>{--j>=0&&N(oe)?(G(),q(oe)):j===0&&q($)}).catch(oe=>{--j>=0&&(G(),ee(oe))})})}e.firstParallel=o;class l{constructor(N){this._size=0,this.maxDegreeOfParalellism=N,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new T.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(N){return this._size++,new Promise(($,j)=>{this.outstandingPromises.push({factory:N,c:$,e:j}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const N=this.outstandingPromises.shift();this.runningPromises++;const $=N.factory();$.then(N.c,N.e),$.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=l;class v extends l{constructor(){super(1)}}e.Queue=v;class y{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const N=new H;return this.drainers.add(N),N.p}isDrained(){for(const[,N]of this.queues)if(N.size>0)return!1;return!0}queueFor(N,$=A.extUri){const j=$.getComparisonKey(N);let G=this.queues.get(j);return G||(G=new v,T.Event.once(G.onDrained)(()=>{G?.dispose(),this.queues.delete(j),this.onDidQueueDrain()}),this.queues.set(j,G)),G}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const N of this.drainers)N.complete();this.drainers.clear()}dispose(){for(const[,N]of this.queues)N.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=y;class O{constructor(N,$){this._token=-1,typeof N=="function"&&typeof $=="number"&&this.setIfNotSet(N,$)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(N,$){this.cancel(),this._token=setTimeout(()=>{this._token=-1,N()},$)}setIfNotSet(N,$){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,N()},$))}}e.TimeoutTimer=O;class _{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(N,$){this.cancel(),this._token=setInterval(()=>{N()},$)}}e.IntervalTimer=_;class F{constructor(N,$){this.timeoutToken=-1,this.runner=N,this.timeout=$,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(N=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,N)}get delay(){return this.timeout}set delay(N){this.timeout=N}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=F;class R{constructor(N,$){$%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${$}ms is not a multiple of 1000ms.`),this.runner=N,this.timeout=$,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(N=this.timeout){N%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${N}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(N/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=R;class U extends F{constructor(N,$){super(N,$);this.units=[]}work(N){this.units.push(N),this.isScheduled()||this.schedule()}doRun(){const N=this.units;this.units=[],this.runner?.(N)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=U;class M extends L.Disposable{constructor(N,$){super();this.options=N,this.handler=$,this.pendingWork=[],this.throttler=this._register(new L.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(N){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+N.length>this.options.maxBufferedWork)return!1}else if(this.pending+N.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...N),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new F(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=M,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=J=>{(0,I.setTimeout0)(()=>{if(N)return;const $=Date.now()+15;J(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,$-Date.now())}}))});let N=!1;return{dispose(){N||(N=!0)}}}:e.runWhenIdle=(J,N)=>{const $=requestIdleCallback(J,typeof N=="number"?{timeout:N}:void 0);let j=!1;return{dispose(){j||(j=!0,cancelIdleCallback($))}}}}();class V{constructor(N){this._didRun=!1,this._executor=()=>{try{this._value=N()}catch($){this._error=$}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=V;async function W(J,N,$){let j;for(let G=0;G<$;G++)try{return await J()}catch(q){j=q,await i(N)}throw j}e.retry=W;class z{hasPending(N){return this._pending?typeof N=="number"?this._pending.taskId===N:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(N,$,j){return this._pending={taskId:N,cancel:()=>j?.(),promise:$},$.then(()=>this.donePending(N),()=>this.donePending(N)),$}donePending(N){this._pending&&N===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const N=this._next;this._next=void 0,N.run().then(N.promiseResolve,N.promiseReject)}}setNext(N){if(this._next)this._next.run=N;else{let $,j;const G=new Promise((q,ee)=>{$=q,j=ee});this._next={run:N,promise:G,promiseResolve:$,promiseReject:j}}return this._next.promise}}e.TaskSequentializer=z;class te{constructor(N,$=()=>Date.now()){this.interval=N,this.nowFn=$,this.lastIncrementTime=0,this.value=0}increment(){const N=this.nowFn();return N-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=N,this.value=0),this.value++,this.value}}e.IntervalCounter=te;class H{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((N,$)=>{this.completeCallback=N,this.errorCallback=$})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(N){return new Promise($=>{this.completeCallback(N),this.resolved=!0,$()})}error(N){return new Promise($=>{this.errorCallback(N),this.rejected=!0,$()})}cancel(){new Promise(N=>{this.errorCallback(new t.CancellationError),this.rejected=!0,N()})}}e.DeferredPromise=H;var K;(function(J){async function N(j){let G;const q=await Promise.all(j.map(ee=>ee.then(ne=>ne,ne=>{G||(G=ne)})));if(typeof G!="undefined")throw G;return q}J.settled=N;function $(j){return new Promise(async(G,q)=>{try{await j(G,q)}catch(ee){q(ee)}})}J.withAsyncBody=$})(K=e.Promises||(e.Promises={}));var X;(function(J){J[J.Initial=0]="Initial",J[J.DoneOK=1]="DoneOK",J[J.DoneError=2]="DoneError"})(X||(X={}));class Y{constructor(N){this._state=0,this._results=[],this._error=null,this._onStateChanged=new T.Emitter,queueMicrotask(async()=>{const $={emitOne:j=>this.emitOne(j),emitMany:j=>this.emitMany(j),reject:j=>this.reject(j)};try{await Promise.resolve(N($)),this.resolve()}catch(j){this.reject(j)}finally{$.emitOne=void 0,$.emitMany=void 0,$.reject=void 0}})}static fromArray(N){return new Y($=>{$.emitMany(N)})}static fromPromise(N){return new Y(async $=>{$.emitMany(await N)})}static fromPromises(N){return new Y(async $=>{await Promise.all(N.map(async j=>$.emitOne(await j)))})}static merge(N){return new Y(async $=>{await Promise.all(N.map(async j=>{for await(const G of j)$.emitOne(G)}))})}[Symbol.asyncIterator](){let N=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(N<this._results.length)return{done:!1,value:this._results[N++]};if(this._state===1)return{done:!0,value:void 0};await T.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(N,$){return new Y(async j=>{for await(const G of N)j.emitOne($(G))})}map(N){return Y.map(this,N)}static filter(N,$){return new Y(async j=>{for await(const G of N)$(G)&&j.emitOne(G)})}filter(N){return Y.filter(this,N)}static coalesce(N){return Y.filter(N,$=>!!$)}coalesce(){return Y.coalesce(this)}static async toPromise(N){const $=[];for await(const j of N)$.push(j);return $}toPromise(){return Y.toPromise(this)}emitOne(N){this._state===0&&(this._results.push(N),this._onStateChanged.fire())}emitMany(N){this._state===0&&(this._results=this._results.concat(N),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(N){this._state===0&&(this._state=2,this._error=N,this._onStateChanged.fire())}}e.AsyncIterableObject=Y,Y.EMPTY=Y.fromArray([]);class x extends Y{constructor(N,$){super($);this._source=N}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=x;function B(J){const N=new k.CancellationTokenSource,$=J(N.token);return new x(N,async j=>{const G=N.token.onCancellationRequested(()=>{G.dispose(),N.dispose(),j.reject(new t.CancellationError)});try{for await(const q of $){if(N.token.isCancellationRequested)return;j.emitOne(q)}G.dispose(),N.dispose()}catch(q){G.dispose(),N.dispose(),j.reject(q)}})}e.createCancelableAsyncIterable=B}),define(re[82],se([0,1,17,6,42,38,12,4,26]),function(Z,e,k,t,T,L,A,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function P(){return Object.create(null)}e.getEmptyExpression=P,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const D="[/\\\\]",E="[^/\\\\]",p=/\//g;function C(H,K){switch(H){case 0:return"";case 1:return`${E}*?`;default:return`(?:${D}|${E}+${D}${K?`|${D}${E}+`:""})*?`}}function h(H,K){if(!H)return[];const X=[];let Y=!1,x=!1,B="";for(const J of H){switch(J){case K:if(!Y&&!x){X.push(B),B="";continue}break;case"{":Y=!0;break;case"}":Y=!1;break;case"[":x=!0;break;case"]":x=!1;break}B+=J}return B&&X.push(B),X}e.splitGlobAware=h;function S(H){if(!H)return"";let K="";const X=h(H,e.GLOB_SPLIT);if(X.every(Y=>Y===e.GLOBSTAR))K=".*";else{let Y=!1;X.forEach((x,B)=>{if(x===e.GLOBSTAR){if(Y)return;K+=C(2,B===X.length-1)}else{let J=!1,N="",$=!1,j="";for(const G of x){if(G!=="}"&&J){N+=G;continue}if($&&(G!=="]"||!j)){let q;G==="-"?q=G:(G==="^"||G==="!")&&!j?q="^":G===e.GLOB_SPLIT?q="":q=(0,b.escapeRegExpCharacters)(G),j+=q;continue}switch(G){case"{":J=!0;continue;case"[":$=!0;continue;case"}":{K+=`(?:${h(N,",").map(ne=>S(ne)).join("|")})`,J=!1,N="";break}case"]":{K+="["+j+"]",$=!1,j="";break}case"?":K+=E;continue;case"*":K+=C(1);continue;default:K+=(0,b.escapeRegExpCharacters)(G)}}B<X.length-1&&(X[B+1]!==e.GLOBSTAR||B+2<X.length)&&(K+=D)}Y=x===e.GLOBSTAR})}return K}const w=/^\*\*\/\*\.[\w\.-]+$/,d=/^\*\*\/([\w\.-]+)\/?$/,m=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,g=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,f=/^\*\*((\/[\w\.-]+)+)\/?$/,u=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,r=new L.LRUCache(1e4),n=function(){return!1},i=function(){return null};function a(H,K){if(!H)return i;let X;typeof H!="string"?X=H.pattern:X=H,X=X.trim();const Y=`${X}_${!!K.trimForExclusions}`;let x=r.get(Y);if(x)return c(x,H);let B;return w.test(X)?x=o(X.substr(4),X):(B=d.exec(s(X,K)))?x=l(B[1],X):(K.trimForExclusions?g:m).test(X)?x=v(X,K):(B=f.exec(s(X,K)))?x=y(B[1].substr(1),X,!0):(B=u.exec(s(X,K)))?x=y(B[1],X,!1):x=O(X),r.set(Y,x),c(x,H)}function c(H,K){if(typeof K=="string")return H;const X=function(Y,x){return(0,T.isEqualOrParent)(Y,K.base,!I.isLinux)?H(Y.substr(K.base.length+1),x):null};return X.allBasenames=H.allBasenames,X.allPaths=H.allPaths,X.basenames=H.basenames,X.patterns=H.patterns,X}function s(H,K){return K.trimForExclusions&&H.endsWith("/**")?H.substr(0,H.length-2):H}function o(H,K){return function(X,Y){return typeof X=="string"&&X.endsWith(H)?K:null}}function l(H,K){const X=`/${H}`,Y=`\\${H}`,x=function(J,N){return typeof J!="string"?null:N?N===H?K:null:J===H||J.endsWith(X)||J.endsWith(Y)?K:null},B=[H];return x.basenames=B,x.patterns=[K],x.allBasenames=B,x}function v(H,K){const X=z(H.slice(1,-1).split(",").map(N=>a(N,K)).filter(N=>N!==i),H),Y=X.length;if(!Y)return i;if(Y===1)return X[0];const x=function(N,$){for(let j=0,G=X.length;j<G;j++)if(X[j](N,$))return H;return null},B=X.find(N=>!!N.allBasenames);B&&(x.allBasenames=B.allBasenames);const J=X.reduce((N,$)=>$.allPaths?N.concat($.allPaths):N,[]);return J.length&&(x.allPaths=J),x}function y(H,K,X){const Y=A.sep===A.posix.sep,x=Y?H:H.replace(p,A.sep),B=A.sep+x,J=A.posix.sep+H;let N;return X?N=function($,j){return typeof $=="string"&&($===x||$.endsWith(B)||!Y&&($===H||$.endsWith(J)))?K:null}:N=function($,j){return typeof $=="string"&&($===x||!Y&&$===H)?K:null},N.allPaths=[(X?"*/":"./")+H],N}function O(H){try{const K=new RegExp(`^${S(H)}$`);return function(X){return K.lastIndex=0,typeof X=="string"&&K.test(X)?H:null}}catch{return i}}function _(H,K,X){return!H||typeof K!="string"?!1:F(H)(K,void 0,X)}e.match=_;function F(H,K={}){if(!H)return n;if(typeof H=="string"||R(H)){const X=a(H,K);if(X===i)return n;const Y=function(x,B){return!!X(x,B)};return X.allBasenames&&(Y.allBasenames=X.allBasenames),X.allPaths&&(Y.allPaths=X.allPaths),Y}return V(H,K)}e.parse=F;function R(H){const K=H;return K?typeof K.base=="string"&&typeof K.pattern=="string":!1}e.isRelativePattern=R;function U(H){return H.allBasenames||[]}e.getBasenameTerms=U;function M(H){return H.allPaths||[]}e.getPathTerms=M;function V(H,K){const X=z(Object.getOwnPropertyNames(H).map(N=>W(N,H[N],K)).filter(N=>N!==i)),Y=X.length;if(!Y)return i;if(!X.some(N=>!!N.requiresSiblings)){if(Y===1)return X[0];const N=function(G,q){let ee;for(let ne=0,oe=X.length;ne<oe;ne++){const le=X[ne](G,q);if(typeof le=="string")return le;(0,t.isThenable)(le)&&(ee||(ee=[]),ee.push(le))}return ee?(async()=>{for(const ne of ee){const oe=await ne;if(typeof oe=="string")return oe}return null})():null},$=X.find(G=>!!G.allBasenames);$&&(N.allBasenames=$.allBasenames);const j=X.reduce((G,q)=>q.allPaths?G.concat(q.allPaths):G,[]);return j.length&&(N.allPaths=j),N}const x=function(N,$,j){let G,q;for(let ee=0,ne=X.length;ee<ne;ee++){const oe=X[ee];oe.requiresSiblings&&j&&($||($=(0,A.basename)(N)),G||(G=$.substr(0,$.length-(0,A.extname)(N).length)));const le=oe(N,$,G,j);if(typeof le=="string")return le;(0,t.isThenable)(le)&&(q||(q=[]),q.push(le))}return q?(async()=>{for(const ee of q){const ne=await ee;if(typeof ne=="string")return ne}return null})():null},B=X.find(N=>!!N.allBasenames);B&&(x.allBasenames=B.allBasenames);const J=X.reduce((N,$)=>$.allPaths?N.concat($.allPaths):N,[]);return J.length&&(x.allPaths=J),x}function W(H,K,X){if(K===!1)return i;const Y=a(H,X);if(Y===i)return i;if(typeof K=="boolean")return Y;if(K){const x=K.when;if(typeof x=="string"){const B=(J,N,$,j)=>{if(!j||!Y(J,N))return null;const G=x.replace("$(basename)",$),q=j(G);return(0,t.isThenable)(q)?q.then(ee=>ee?H:null):q?H:null};return B.requiresSiblings=!0,B}}return Y}function z(H,K){const X=H.filter(N=>!!N.basenames);if(X.length<2)return H;const Y=X.reduce((N,$)=>{const j=$.basenames;return j?N.concat(j):N},[]);let x;if(K){x=[];for(let N=0,$=Y.length;N<$;N++)x.push(K)}else x=X.reduce((N,$)=>{const j=$.patterns;return j?N.concat(j):N},[]);const B=function(N,$){if(typeof N!="string")return null;if(!$){let G;for(G=N.length;G>0;G--){const q=N.charCodeAt(G-1);if(q===47||q===92)break}$=N.substr(G)}const j=Y.indexOf($);return j!==-1?x[j]:null};B.basenames=Y,B.patterns=x,B.allBasenames=Y;const J=H.filter(N=>!N.basenames);return J.push(B),J}function te(H,K){return(0,k.equals)(H,K,(X,Y)=>typeof X=="string"&&typeof Y=="string"?X===Y:typeof X!="string"&&typeof Y!="string"?X.base===Y.base&&X.pattern===Y.pattern:!1)}e.patternsEquals=te}),define(re[129],se([0,1,8]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function t(D){return D.toJSON()}class T{constructor(E){this._uriTransformer=E}transformIncoming(E){const p=this._uriTransformer.transformIncoming(E);return p===E?E:t(k.URI.from(p))}transformOutgoing(E){const p=this._uriTransformer.transformOutgoing(E);return p===E?E:t(k.URI.from(p))}transformOutgoingURI(E){const p=this._uriTransformer.transformOutgoing(E);return p===E?E:k.URI.from(p)}transformOutgoingScheme(E){return this._uriTransformer.transformOutgoingScheme(E)}}e.URITransformer=T,e.DefaultURITransformer=new class{transformIncoming(D){return D}transformOutgoing(D){return D}transformOutgoingURI(D){return D}transformOutgoingScheme(D){return D}};function L(D,E,p){if(!D||p>200)return null;if(typeof D=="object"){if(D instanceof k.URI)return E.transformOutgoing(D);for(const C in D)if(Object.hasOwnProperty.call(D,C)){const h=L(D[C],E,p+1);h!==null&&(D[C]=h)}}return null}function A(D,E){const p=L(D,E,0);return p===null?D:p}e.transformOutgoingURIs=A;function I(D,E,p,C){if(!D||C>200)return null;if(typeof D=="object"){if(D.$mid===1)return p?k.URI.revive(E.transformIncoming(D)):E.transformIncoming(D);for(const h in D)if(Object.hasOwnProperty.call(D,h)){const S=I(D[h],E,p,C+1);S!==null&&(D[h]=S)}}return null}function b(D,E){const p=I(D,E,!1,0);return p===null?D:p}e.transformIncomingURIs=b;function P(D,E){const p=I(D,E,!0,0);return p===null?D:p}e.transformAndReviveIncomingURIs=P}),define(re[130],se([0,1,35,9,38,31,116]),function(Z,e,k,t,T,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(D){return this._virtualMachineOUIs||(this._virtualMachineOUIs=T.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(D)}value(){if(this._value===void 0){let D=0,E=0;const p=(0,k.networkInterfaces)();for(const C in p){const h=p[C];if(h)for(const{mac:S,internal:w}of h)w||(E+=1,this._isVirtualMachineMacAddress(S.toUpperCase())&&(D+=1))}this._value=E>0?D/E:0}return this._value}};let I;async function b(){return I||(I=(async()=>await P()||L.generateUuid())()),I}e.getMachineId=b;async function P(){try{const D=await new Promise((p,C)=>{Z(["crypto"],p,C)}),E=(0,A.getMac)();return D.createHash("sha256").update(E,"utf8").digest("hex")}catch(D){t.onUnexpectedError(D);return}}}),define(re[27],se([0,1,54,35,267,6,42,80,12,4,19,8]),function(Z,e,k,t,T,L,A,I,b,P,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var p;(function(M){M[M.UNLINK=0]="UNLINK",M[M.MOVE=1]="MOVE"})(p=e.RimRafMode||(e.RimRafMode={}));async function C(M,V=p.UNLINK){if((0,A.isRootOrDriveLetter)(M))throw new Error("rimraf - will refuse to recursively delete root");return V===p.UNLINK?S(M):h(M)}async function h(M){try{const V=(0,A.randomPath)((0,t.tmpdir)());try{await k.promises.rename(M,V)}catch{return S(M)}S(V).catch(W=>{})}catch(V){if(V.code!=="ENOENT")throw V}}async function S(M){return(0,T.promisify)(k.rm)(M,{recursive:!0,force:!0,maxRetries:3})}function w(M){if((0,A.isRootOrDriveLetter)(M))throw new Error("rimraf - will refuse to recursively delete root");k.rmSync(M,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=w;async function d(M,V){return f(await(V?m(M):(0,T.promisify)(k.readdir)(M)))}async function m(M){try{return await(0,T.promisify)(k.readdir)(M,{withFileTypes:!0})}catch(z){console.warn("[node.js fs] readdir with filetypes failed with error: ",z)}const V=[],W=await d(M);for(const z of W){let te=!1,H=!1,K=!1;try{const X=await e.Promises.lstat((0,b.join)(M,z));te=X.isFile(),H=X.isDirectory(),K=X.isSymbolicLink()}catch(X){console.warn("[node.js fs] unexpected error from lstat after readdir: ",X)}V.push({name:z,isFile:()=>te,isDirectory:()=>H,isSymbolicLink:()=>K})}return V}function g(M){return f(k.readdirSync(M))}e.readdirSync=g;function f(M){return M.map(V=>typeof V=="string"?P.isMacintosh?(0,I.normalizeNFC)(V):V:(V.name=P.isMacintosh?(0,I.normalizeNFC)(V.name):V.name,V))}async function u(M){const V=await d(M),W=[];for(const z of V)await n.existsDirectory((0,b.join)(M,z))&&W.push(z);return W}function r(M,V=1e3){return new Promise(W=>{let z=!1;const te=setInterval(()=>{z||(z=!0,k.access(M,H=>{z=!1,H&&(clearInterval(te),W(void 0))}))},V)})}e.whenDeleted=r;var n;(function(M){async function V(te){let H;try{if(H=await e.Promises.lstat(te),!H.isSymbolicLink())return{stat:H}}catch{}try{return{stat:await e.Promises.stat(te),symbolicLink:H?.isSymbolicLink()?{dangling:!1}:void 0}}catch(K){if(K.code==="ENOENT"&&H)return{stat:H,symbolicLink:{dangling:!0}};if(P.isWindows&&K.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(te)),symbolicLink:{dangling:!1}}}catch(X){if(X.code==="ENOENT"&&H)return{stat:H,symbolicLink:{dangling:!0}};throw X}throw K}}M.stat=V;async function W(te){try{const{stat:H,symbolicLink:K}=await M.stat(te);return H.isFile()&&K?.dangling!==!0}catch{}return!1}M.existsFile=W;async function z(te){try{const{stat:H,symbolicLink:K}=await M.stat(te);return H.isDirectory()&&K?.dangling!==!0}catch{}return!1}M.existsDirectory=z})(n=e.SymlinkSupport||(e.SymlinkSupport={}));const i=new L.ResourceQueue;function a(M,V,W){return i.queueFor(E.URI.file(M),D.extUriBiasedIgnorePathCase).queue(()=>{const z=l(W);return new Promise((te,H)=>s(M,V,z,K=>K?H(K):te()))})}let c=!0;function s(M,V,W,z){if(!c)return k.writeFile(M,V,{mode:W.mode,flag:W.flag},z);k.open(M,W.flag,W.mode,(te,H)=>{if(te)return z(te);k.writeFile(H,V,K=>{if(K)return k.close(H,()=>z(K));k.fdatasync(H,X=>(X&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",X),c=!1),k.close(H,Y=>z(Y))))})})}function o(M,V,W){const z=l(W);if(!c)return k.writeFileSync(M,V,{mode:z.mode,flag:z.flag});const te=k.openSync(M,z.flag,z.mode);try{k.writeFileSync(te,V);try{k.fdatasyncSync(te)}catch(H){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",H),c=!1}}finally{k.closeSync(te)}}e.writeFileSync=o;function l(M){return M?{mode:typeof M.mode=="number"?M.mode:438,flag:typeof M.flag=="string"?M.flag:"w"}:{mode:438,flag:"w"}}async function v(M,V){if(M!==V)try{await e.Promises.rename(M,V)}catch(W){if(M.toLowerCase()!==V.toLowerCase()&&W.code==="EXDEV"||M.endsWith("."))await y(M,V,{preserveSymlinks:!1}),await C(M,p.MOVE);else throw W}}async function y(M,V,W){return _(M,V,{root:{source:M,target:V},options:W,handledSourcePaths:new Set})}const O=511;async function _(M,V,W){if(W.handledSourcePaths.has(M))return;W.handledSourcePaths.add(M);const{stat:z,symbolicLink:te}=await n.stat(M);if(te){if(W.options.preserveSymlinks)try{return await U(M,V,W)}catch(H){console.warn("[node.js fs] copy of symlink failed: ",H)}if(te.dangling)return}return z.isDirectory()?F(M,V,z.mode&O,W):R(M,V,z.mode&O)}async function F(M,V,W,z){await e.Promises.mkdir(V,{recursive:!0,mode:W});const te=await d(M);for(const H of te)await _((0,b.join)(M,H),(0,b.join)(V,H),z)}async function R(M,V,W){await e.Promises.copyFile(M,V),await e.Promises.chmod(V,W)}async function U(M,V,W){let z=await e.Promises.readlink(M);(0,A.isEqualOrParent)(z,W.root.source,!P.isLinux)&&(z=(0,b.join)(W.root.target,z.substr(W.root.source.length+1))),await e.Promises.symlink(z,V)}e.Promises=new class{get access(){return(0,T.promisify)(k.access)}get stat(){return(0,T.promisify)(k.stat)}get lstat(){return(0,T.promisify)(k.lstat)}get utimes(){return(0,T.promisify)(k.utimes)}get read(){return(M,V,W,z,te)=>new Promise((H,K)=>{k.read(M,V,W,z,te,(X,Y,x)=>X?K(X):H({bytesRead:Y,buffer:x}))})}get readFile(){return(0,T.promisify)(k.readFile)}get write(){return(M,V,W,z,te)=>new Promise((H,K)=>{k.write(M,V,W,z,te,(X,Y,x)=>X?K(X):H({bytesWritten:Y,buffer:x}))})}get appendFile(){return(0,T.promisify)(k.appendFile)}get fdatasync(){return(0,T.promisify)(k.fdatasync)}get truncate(){return(0,T.promisify)(k.truncate)}get rename(){return(0,T.promisify)(k.rename)}get copyFile(){return(0,T.promisify)(k.copyFile)}get open(){return(0,T.promisify)(k.open)}get close(){return(0,T.promisify)(k.close)}get symlink(){return(0,T.promisify)(k.symlink)}get readlink(){return(0,T.promisify)(k.readlink)}get chmod(){return(0,T.promisify)(k.chmod)}get mkdir(){return(0,T.promisify)(k.mkdir)}get unlink(){return(0,T.promisify)(k.unlink)}get rmdir(){return(0,T.promisify)(k.rmdir)}get realpath(){return(0,T.promisify)(k.realpath)}async exists(M){try{return await e.Promises.access(M),!0}catch{return!1}}get readdir(){return d}get readDirsInDir(){return u}get writeFile(){return a}get rm(){return C}get move(){return v}get copy(){return y}}}),define(re[131],se([0,1,54,12,4,26,27]),function(Z,e,k,t,T,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function I(p){if(T.isLinux)return p;const C=(0,t.dirname)(p);if(p===C)return p;const h=((0,t.basename)(p)||p).toLowerCase();try{const w=(0,A.readdirSync)(C).filter(d=>d.toLowerCase()===h);if(w.length===1){const d=I(C);if(d)return(0,t.join)(d,w[0])}else if(w.length>1){const d=w.indexOf(h);if(d>=0){const m=I(C);if(m)return(0,t.join)(m,w[d])}}}catch{}return null}e.realcaseSync=I;async function b(p){if(T.isLinux)return p;const C=(0,t.dirname)(p);if(p===C)return p;const h=((0,t.basename)(p)||p).toLowerCase();try{const w=(await A.Promises.readdir(C)).filter(d=>d.toLowerCase()===h);if(w.length===1){const d=await b(C);if(d)return(0,t.join)(d,w[0])}else if(w.length>1){const d=w.indexOf(h);if(d>=0){const m=await b(C);if(m)return(0,t.join)(m,w[d])}}}catch{}return null}e.realcase=b;async function P(p){try{return await A.Promises.realpath(p)}catch{const h=E(p);return await A.Promises.access(h,k.constants.R_OK),h}}e.realpath=P;function D(p){try{return k.realpathSync(p)}catch{const h=E(p);return k.accessSync(h,k.constants.R_OK),h}}e.realpathSync=D;function E(p){return(0,L.rtrim)((0,t.normalize)(p),t.sep)}}),define(re[83],se([0,1,35,12,27]),function(Z,e,k,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const L=/^\d+$/,A=/^Microsoft.PowerShell_.*/,I=/^Microsoft.PowerShellPreview_.*/;var b;(function(f){f[f.x64=0]="x64",f[f.x86=1]="x86",f[f.ARM=2]="ARM"})(b||(b={}));let P;switch(process.arch){case"ia32":case"x32":P=1;break;case"arm":case"arm64":P=2;break;default:P=0;break}let D;process.env.PROCESSOR_ARCHITEW6432?D=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?D=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?D=1:D=0;class E{constructor(u,r,n){this.exePath=u,this.displayName=r,this.knownToExist=n}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await T.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function p({useAlternateBitness:f=!1}={}){return f?P===0?process.env["ProgramFiles(x86)"]||null:D===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function C({useAlternateBitness:f=!1,findPreview:u=!1}={}){const r=p({useAlternateBitness:f});if(!r)return null;const n=t.join(r,"PowerShell");if(!await T.SymlinkSupport.existsDirectory(n))return null;let i=-1,a=null;for(const o of await T.Promises.readdir(n)){let l=-1;if(u){const y=o.indexOf("-");if(y<0)continue;const O=o.substring(0,y);if(!L.test(O)||o.substring(y+1)!=="preview")continue;l=parseInt(O,10)}else{if(!L.test(o))continue;l=parseInt(o,10)}if(l<=i)continue;const v=t.join(n,o,"pwsh.exe");!await T.SymlinkSupport.existsFile(v)||(a=v,i=l)}if(!a)return null;const c=r.includes("x86")?" (x86)":"",s=u?" Preview":"";return new E(a,`PowerShell${s}${c}`,!0)}async function h({findPreview:f}={}){if(!process.env.LOCALAPPDATA)return null;const u=t.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await T.SymlinkSupport.existsDirectory(u))return null;const{pwshMsixDirRegex:r,pwshMsixName:n}=f?{pwshMsixDirRegex:I,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:A,pwshMsixName:"PowerShell (Store)"};for(const i of await T.Promises.readdir(u))if(r.test(i)){const a=t.join(u,i,"pwsh.exe");return new E(a,n)}return null}function S(){const f=t.join(k.homedir(),".dotnet","tools","pwsh.exe");return new E(f,".NET Core PowerShell Global Tool")}function w(){const f=t.join(process.env.windir,P===1&&D!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new E(f,"Windows PowerShell",!0)}async function*d(){let f=await C();f&&(yield f),f=await C({useAlternateBitness:!0}),f&&(yield f),f=await h(),f&&(yield f),f=S(),f&&(yield f),f=await C({findPreview:!0}),f&&(yield f),f=await h({findPreview:!0}),f&&(yield f),f=await C({useAlternateBitness:!0,findPreview:!0}),f&&(yield f),f=w(),f&&(yield f)}async function*m(){for await(const f of d())await f.exists()&&(yield f)}e.enumeratePowerShellInstallations=m;async function g(){for await(const f of m())return f;return null}e.getFirstAvailablePowerShellInstallation=g}),define(re[132],se([0,1,48,20]),function(Z,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function T(A){return new Promise((I,b)=>{let P;const D=new Map;function E(C,h,S,w,d){const m=D.get(h);if(C===A||m){const g={name:p(S),cmd:S,pid:C,ppid:h,load:w,mem:d};D.set(C,g),C===A&&(P=g),m&&(m.children||(m.children=[]),m.children.push(g),m.children.length>1&&(m.children=m.children.sort((f,u)=>f.pid-u.pid)))}}function p(C){const h=/--vscode-window-kind=shared-process/,S=/--vscode-window-kind=issue-reporter/,w=/--vscode-window-kind=process-explorer/,d=/--utility-sub-type=network/,m=/--vscode-utility-kind=extensionHost/,g=/--crashes-directory/,f=/\\pipe\\winpty-control/,u=/conhost\.exe/,r=/--type=([a-zA-Z-]+)/;if(g.exec(C))return"electron-crash-reporter";if(f.exec(C))return"winpty-process";if(u.exec(C))return"console-window-host (Windows internal process)";let n=r.exec(C);if(n&&n.length===2){if(n[1]==="renderer")return h.exec(C)?"shared-process":S.exec(C)?"issue-reporter":w.exec(C)?"process-explorer":"window";if(n[1]==="utility"){if(d.exec(C))return"utility-network-service";if(m.exec(C))return"extension-host"}return n[1]}const i=/[a-zA-Z-]+\.js/g;let a="";do n=i.exec(C),n&&(a+=n+" ");while(n);return a&&C.indexOf("node ")<0&&C.indexOf("node.exe")<0?`electron_node ${a}`:C}if(process.platform==="win32"){const C=h=>h.indexOf("\\\\?\\")===0||h.indexOf("\\??\\")===0?h.substr(4):h.indexOf('"\\\\?\\')===0||h.indexOf('"\\??\\')===0?'"'+h.substr(5):h;new Promise((h,S)=>{Z(["windows-process-tree"],h,S)}).then(h=>{h.getProcessList(A,S=>{if(!S){b(new Error(`Root process ${A} not found`));return}h.getProcessCpuUsage(S,w=>{const d=new Map;w.forEach(m=>{const g=C(m.commandLine||"");d.set(m.pid,{name:p(g),cmd:g,pid:m.pid,ppid:m.ppid,load:m.cpu||0,mem:m.memory||0})}),P=d.get(A),P?(d.forEach(m=>{const g=d.get(m.ppid);g&&(g.children||(g.children=[]),g.children.push(m))}),d.forEach(m=>{m.children&&(m.children=m.children.sort((g,f)=>g.pid-f.pid))}),I(P)):b(new Error(`Root process ${A} not found`))})},h.ProcessDataFlag.CommandLine|h.ProcessDataFlag.Memory)})}else{let C=function(){let h=[P];const S=[];for(;h.length;){const d=h.shift();d&&(S.push(d.pid),d.children&&(h=h.concat(d.children)))}let w=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",Z).fsPath);w+=" "+S.join(" "),(0,k.exec)(w,{},(d,m,g)=>{if(d||g)b(d||new Error(g.toString()));else{const f=m.toString().split(`
`);for(let u=0;u<S.length;u++){const r=D.get(S[u]);r.load=parseFloat(f[u])}if(!P){b(new Error(`Root process ${A} not found`));return}I(P)}})};(0,k.exec)("which ps",{},(h,S,w)=>{if(h||w)if(process.platform!=="linux")b(h||new Error(w.toString()));else{const d=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/ps.sh",Z).fsPath);(0,k.exec)(d,{},(m,g,f)=>{m||f?b(m||new Error(f.toString())):(L(g,E),C())})}else{const d=S.toString().trim(),m="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,k.exec)(`${d} ${m}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(g,f,u)=>{g||u&&!u.includes("screen size is bogus")?b(g||new Error(u.toString())):(L(f,E),process.platform==="linux"?C():P?I(P):b(new Error(`Root process ${A} not found`)))})}})}})}e.listProcesses=T;function L(A,I){const b=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,P=A.toString().split(`
`);for(const D of P){const E=b.exec(D.trim());E&&E.length===6&&I(parseInt(E[1]),parseInt(E[2]),E[5],parseFloat(E[3]),parseFloat(E[4]))}}});var me=this&&this.__decorate||function(Z,e,k,t){var T=arguments.length,L=T<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,k):t,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate(Z,e,k,t);else for(var I=Z.length-1;I>=0;I--)(A=Z[I])&&(L=(T<3?A(L):T>3?A(e,k,L):A(e,k))||L);return T>3&&L&&Object.defineProperty(e,k,L),L};define(re[39],se([0,1,17,6,16,23,60,9,3,2,64,26,14]),function(Z,e,k,t,T,L,A,I,b,P,D,E,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var C;(function(H){H[H.Promise=100]="Promise",H[H.PromiseCancel=101]="PromiseCancel",H[H.EventListen=102]="EventListen",H[H.EventDispose=103]="EventDispose"})(C=e.RequestType||(e.RequestType={}));function h(H){switch(H){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var S;(function(H){H[H.Initialize=200]="Initialize",H[H.PromiseSuccess=201]="PromiseSuccess",H[H.PromiseError=202]="PromiseError",H[H.PromiseErrorObj=203]="PromiseErrorObj",H[H.EventFire=204]="EventFire"})(S=e.ResponseType||(e.ResponseType={}));function w(H){switch(H){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var d;(function(H){H[H.Uninitialized=0]="Uninitialized",H[H.Idle=1]="Idle"})(d||(d={}));class m{constructor(K){this.buffer=K,this.pos=0}read(K){const X=this.buffer.slice(this.pos,this.pos+K);return this.pos+=X.byteLength,X}}class g{constructor(){this.buffers=[]}get buffer(){return T.VSBuffer.concat(this.buffers)}write(K){this.buffers.push(K)}}var f;(function(H){H[H.Undefined=0]="Undefined",H[H.String=1]="String",H[H.Buffer=2]="Buffer",H[H.VSBuffer=3]="VSBuffer",H[H.Array=4]="Array",H[H.Object=5]="Object"})(f||(f={}));function u(H){const K=T.VSBuffer.alloc(4);return K.writeUInt32BE(H,0),K}function r(H){return H.read(4).readUInt32BE(0)}function n(H){const K=T.VSBuffer.alloc(1);return K.writeUInt8(H,0),K}const i={Undefined:n(f.Undefined),String:n(f.String),Buffer:n(f.Buffer),VSBuffer:n(f.VSBuffer),Array:n(f.Array),Object:n(f.Object)},a=typeof Buffer!="undefined";function c(H,K){if(typeof K=="undefined")H.write(i.Undefined);else if(typeof K=="string"){const X=T.VSBuffer.fromString(K);H.write(i.String),H.write(u(X.byteLength)),H.write(X)}else if(a&&Buffer.isBuffer(K)){const X=T.VSBuffer.wrap(K);H.write(i.Buffer),H.write(u(X.byteLength)),H.write(X)}else if(K instanceof T.VSBuffer)H.write(i.VSBuffer),H.write(u(K.byteLength)),H.write(K);else if(Array.isArray(K)){H.write(i.Array),H.write(u(K.length));for(const X of K)c(H,X)}else{const X=T.VSBuffer.fromString(JSON.stringify(K));H.write(i.Object),H.write(u(X.byteLength)),H.write(X)}}function s(H){switch(H.read(1).readUInt8(0)){case f.Undefined:return;case f.String:return H.read(r(H)).toString();case f.Buffer:return H.read(r(H)).buffer;case f.VSBuffer:return H.read(r(H));case f.Array:{const X=r(H),Y=[];for(let x=0;x<X;x++)Y.push(s(H));return Y}case f.Object:return JSON.parse(H.read(r(H)).toString())}}class o{constructor(K,X,Y=null,x=1e3){this.protocol=K,this.ctx=X,this.logger=Y,this.timeoutDelay=x,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(B=>this.onRawMessage(B)),this.sendResponse({type:200})}registerChannel(K,X){this.channels.set(K,X),setTimeout(()=>this.flushPendingRequests(K),0)}sendResponse(K){switch(K.type){case 200:{const X=this.send([K.type]);this.logger?.logOutgoing(X,0,1,w(K.type));return}case 201:case 202:case 204:case 203:{const X=this.send([K.type,K.id],K.data);this.logger?.logOutgoing(X,K.id,1,w(K.type),K.data);return}}}send(K,X=void 0){const Y=new g;return c(Y,K),c(Y,X),this.sendBuffer(Y.buffer)}sendBuffer(K){try{return this.protocol.send(K),K.byteLength}catch{return 0}}onRawMessage(K){const X=new m(K),Y=s(X),x=s(X),B=Y[0];switch(B){case 100:return this.logger?.logIncoming(K.byteLength,Y[1],1,`${h(B)}: ${Y[2]}.${Y[3]}`,x),this.onPromise({type:B,id:Y[1],channelName:Y[2],name:Y[3],arg:x});case 102:return this.logger?.logIncoming(K.byteLength,Y[1],1,`${h(B)}: ${Y[2]}.${Y[3]}`,x),this.onEventListen({type:B,id:Y[1],channelName:Y[2],name:Y[3],arg:x});case 101:return this.logger?.logIncoming(K.byteLength,Y[1],1,`${h(B)}`),this.disposeActiveRequest({type:B,id:Y[1]});case 103:return this.logger?.logIncoming(K.byteLength,Y[1],1,`${h(B)}`),this.disposeActiveRequest({type:B,id:Y[1]})}}onPromise(K){const X=this.channels.get(K.channelName);if(!X){this.collectPendingRequest(K);return}const Y=new L.CancellationTokenSource;let x;try{x=X.call(this.ctx,K.name,K.arg,Y.token)}catch(N){x=Promise.reject(N)}const B=K.id;x.then(N=>{this.sendResponse({id:B,data:N,type:201}),this.activeRequests.delete(K.id)},N=>{N instanceof Error?this.sendResponse({id:B,data:{message:N.message,name:N.name,stack:N.stack?N.stack.split?N.stack.split(`
`):N.stack:void 0},type:202}):this.sendResponse({id:B,data:N,type:203}),this.activeRequests.delete(K.id)});const J=(0,P.toDisposable)(()=>Y.cancel());this.activeRequests.set(K.id,J)}onEventListen(K){const X=this.channels.get(K.channelName);if(!X){this.collectPendingRequest(K);return}const Y=K.id,B=X.listen(this.ctx,K.name,K.arg)(J=>this.sendResponse({id:Y,data:J,type:204}));this.activeRequests.set(K.id,B)}disposeActiveRequest(K){const X=this.activeRequests.get(K.id);X&&(X.dispose(),this.activeRequests.delete(K.id))}collectPendingRequest(K){let X=this.pendingRequests.get(K.channelName);X||(X=[],this.pendingRequests.set(K.channelName,X));const Y=setTimeout(()=>{console.error(`Unknown channel: ${K.channelName}`),K.type===100&&this.sendResponse({id:K.id,data:{name:"Unknown channel",message:`Channel name '${K.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);X.push({request:K,timeoutTimer:Y})}flushPendingRequests(K){const X=this.pendingRequests.get(K);if(X){for(const Y of X)switch(clearTimeout(Y.timeoutTimer),Y.request.type){case 100:this.onPromise(Y.request);break;case 102:this.onEventListen(Y.request);break}this.pendingRequests.delete(K)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,P.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=o;var l;(function(H){H[H.LocalSide=0]="LocalSide",H[H.OtherSide=1]="OtherSide"})(l=e.RequestInitiator||(e.RequestInitiator={}));class v{constructor(K,X=null){this.protocol=K,this.isDisposed=!1,this.state=d.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new b.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(Y=>this.onBuffer(Y)),this.logger=X}getChannel(K){const X=this;return{call(Y,x,B){return X.isDisposed?Promise.reject(I.canceled()):X.requestPromise(K,Y,x,B)},listen(Y,x){return X.isDisposed?b.Event.None:X.requestEvent(K,Y,x)}}}requestPromise(K,X,Y,x=L.CancellationToken.None){const B=this.lastRequestId++,N={id:B,type:100,channelName:K,name:X,arg:Y};if(x.isCancellationRequested)return Promise.reject(I.canceled());let $;return new Promise((G,q)=>{if(x.isCancellationRequested)return q(I.canceled());const ee=()=>{const Se=fe=>{switch(fe.type){case 201:this.handlers.delete(B),G(fe.data);break;case 202:{this.handlers.delete(B);const pe=new Error(fe.data.message);pe.stack=fe.data.stack,pe.name=fe.data.name,q(pe);break}case 203:this.handlers.delete(B),q(fe.data);break}};this.handlers.set(B,Se),this.sendRequest(N)};let ne=null;this.state===d.Idle?ee():(ne=(0,t.createCancelablePromise)(Se=>this.whenInitialized()),ne.then(()=>{ne=null,ee()}));const oe=()=>{ne?(ne.cancel(),ne=null):this.sendRequest({id:B,type:101}),q(I.canceled())},le=x.onCancellationRequested(oe);$=(0,P.combinedDisposable)((0,P.toDisposable)(oe),le),this.activeRequests.add($)}).finally(()=>{this.activeRequests.delete($)})}requestEvent(K,X,Y){const x=this.lastRequestId++,J={id:x,type:102,channelName:K,name:X,arg:Y};let N=null;const $=new b.Emitter({onFirstListenerAdd:()=>{N=(0,t.createCancelablePromise)(G=>this.whenInitialized()),N.then(()=>{N=null,this.activeRequests.add($),this.sendRequest(J)})},onLastListenerRemove:()=>{N?(N.cancel(),N=null):(this.activeRequests.delete($),this.sendRequest({id:x,type:103}))}}),j=G=>$.fire(G.data);return this.handlers.set(x,j),$.event}sendRequest(K){switch(K.type){case 100:case 102:{const X=this.send([K.type,K.id,K.channelName,K.name],K.arg);this.logger?.logOutgoing(X,K.id,0,`${h(K.type)}: ${K.channelName}.${K.name}`,K.arg);return}case 101:case 103:{const X=this.send([K.type,K.id]);this.logger?.logOutgoing(X,K.id,0,h(K.type));return}}}send(K,X=void 0){const Y=new g;return c(Y,K),c(Y,X),this.sendBuffer(Y.buffer)}sendBuffer(K){try{return this.protocol.send(K),K.byteLength}catch{return 0}}onBuffer(K){const X=new m(K),Y=s(X),x=s(X),B=Y[0];switch(B){case 200:return this.logger?.logIncoming(K.byteLength,0,0,w(B)),this.onResponse({type:Y[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(K.byteLength,Y[1],0,w(B),x),this.onResponse({type:Y[0],id:Y[1],data:x})}}onResponse(K){if(K.type===200){this.state=d.Idle,this._onDidInitialize.fire();return}this.handlers.get(K.id)?.(K)}get onDidInitializePromise(){return b.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===d.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,P.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}me([A.memoize],v.prototype,"onDidInitializePromise",null),e.ChannelClient=v;class y{constructor(K){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new b.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new b.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,K(({protocol:X,onDidClientDisconnect:Y})=>{b.Event.once(X.onMessage)(B=>{const J=new m(B),N=s(J),$=new o(X,N),j=new v(X);this.channels.forEach((q,ee)=>$.registerChannel(ee,q));const G={channelServer:$,channelClient:j,ctx:N};this._connections.add(G),this._onDidAddConnection.fire(G),Y(()=>{$.dispose(),j.dispose(),this._connections.delete(G),this._onDidRemoveConnection.fire(G)})})})}get connections(){const K=[];return this._connections.forEach(X=>K.push(X)),K}getChannel(K,X){const Y=this;return{call(x,B,J){let N;if((0,p.isFunction)(X)){const j=(0,k.getRandomElement)(Y.connections.filter(X));N=j?Promise.resolve(j):b.Event.toPromise(b.Event.filter(Y.onDidAddConnection,X))}else N=X.routeCall(Y,x,B);const $=N.then(j=>j.channelClient.getChannel(K));return _($).call(x,B,J)},listen(x,B){if((0,p.isFunction)(X))return Y.getMulticastEvent(K,X,x,B);const J=X.routeEvent(Y,x,B).then(N=>N.channelClient.getChannel(K));return _(J).listen(x,B)}}}getMulticastEvent(K,X,Y,x){const B=this;let J=new P.DisposableStore;const N=new b.Emitter({onFirstListenerAdd:()=>{J=new P.DisposableStore;const $=new b.EventMultiplexer,j=new Map,G=ee=>{const oe=ee.channelClient.getChannel(K).listen(Y,x),le=$.add(oe);j.set(ee,le)},q=ee=>{const ne=j.get(ee);!ne||(ne.dispose(),j.delete(ee))};B.connections.filter(X).forEach(G),b.Event.filter(B.onDidAddConnection,X)(G,void 0,J),B.onDidRemoveConnection(q,void 0,J),$.event(N.fire,N,J),J.add($)},onLastListenerRemove:()=>{J.dispose()}});return N.event}registerChannel(K,X){this.channels.set(K,X),this._connections.forEach(Y=>{Y.channelServer.registerChannel(K,X)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=y;class O{constructor(K,X,Y=null){const x=new g;c(x,X),K.send(x.buffer),this.channelClient=new v(K,Y),this.channelServer=new o(K,X,Y)}getChannel(K){return this.channelClient.getChannel(K)}registerChannel(K,X){this.channelServer.registerChannel(K,X)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=O;function _(H){return{call(K,X,Y){return H.then(x=>x.call(K,X,Y))},listen(K,X){const Y=new b.Relay;return H.then(x=>Y.input=x.listen(K,X)),Y.event}}}e.getDelayedChannel=_;function F(H){let K=!1;return{call(X,Y,x){return K?H.call(X,Y,x):(0,t.timeout)(0).then(()=>K=!0).then(()=>H.call(X,Y,x))},listen(X,Y){if(K)return H.listen(X,Y);const x=new b.Relay;return(0,t.timeout)(0).then(()=>K=!0).then(()=>x.input=H.listen(X,Y)),x.event}}}e.getNextTickChannel=F;class R{constructor(K){this.fn=K}routeCall(K){return this.route(K)}routeEvent(K){return this.route(K)}async route(K){for(const X of K.connections)if(await Promise.resolve(this.fn(X.ctx)))return Promise.resolve(X);return await b.Event.toPromise(K.onDidAddConnection),await this.route(K)}}e.StaticRouter=R;var U;(function(H){function K(B,J){const N=B,$=J&&J.disableMarshalling,j=new Map;for(const G in N)Y(G)&&j.set(G,b.Event.buffer(N[G],!0));return new class{listen(G,q,ee){const ne=j.get(q);if(ne)return ne;if(x(q)){const oe=N[q];if(typeof oe=="function")return oe.call(N,ee)}throw new Error(`Event not found: ${q}`)}call(G,q,ee){const ne=N[q];if(typeof ne=="function"){if(!$&&Array.isArray(ee))for(let oe=0;oe<ee.length;oe++)ee[oe]=(0,D.revive)(ee[oe]);return ne.apply(N,ee)}throw new Error(`Method not found: ${q}`)}}}H.fromService=K;function X(B,J){const N=J&&J.disableMarshalling;return new Proxy({},{get($,j){if(typeof j=="string")return J?.properties?.has(j)?J.properties.get(j):x(j)?function(G){return B.listen(j,G)}:Y(j)?B.listen(j):async function(...G){let q;J&&!(0,p.isUndefinedOrNull)(J.context)?q=[J.context,...G]:q=G;const ee=await B.call(j,q);return N?ee:(0,D.revive)(ee)};throw new Error(`Property not found: ${String(j)}`)}})}H.toService=X;function Y(B){return B[0]==="o"&&B[1]==="n"&&E.isUpperAsciiLetter(B.charCodeAt(2))}function x(B){return/^onDynamic/.test(B)&&E.isUpperAsciiLetter(B.charCodeAt(9))}})(U=e.ProxyChannel||(e.ProxyChannel={}));const M=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function V(H){if(Array.isArray(H))return H;if(H&&typeof H=="object"&&typeof H.toString=="function"){const K=H.toString();if(K!=="[object Object]")return K}return H}function W(H){return Array.isArray(H)?H.map(V):V(H)}function z(H,K,X,Y,x,B,J){J=W(J);const N=M[x],$=N[Y%N.length];let j=[`%c[${H}]%c[${String(K).padStart(7," ")}]%c[len: ${String(X).padStart(5," ")}]%c${String(Y).padStart(5," ")} - ${B}`,"color: darkgreen","color: grey","color: grey",`color: ${$}`];/\($/.test(B)?(j=j.concat(J),j.push(")")):j.push(J),console.log.apply(console,j)}e.logWithColors=z;class te{constructor(K,X){this._outgoingPrefix=K,this._incomingPrefix=X,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(K,X,Y,x,B){this._totalOutgoing+=K,z(this._outgoingPrefix,this._totalOutgoing,K,X,Y,x,B)}logIncoming(K,X,Y,x,B){this._totalIncoming+=K,z(this._incomingPrefix,this._totalIncoming,K,X,Y,x,B)}}e.IPCLogger=te}),define(re[133],se([0,1,16,3,39]),function(Z,e,k,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class L{constructor(b){this.port=b,this.onMessage=t.Event.fromDOMEventEmitter(this.port,"message",P=>k.VSBuffer.wrap(P.data)),b.start()}send(b){this.port.postMessage(b.buffer)}disconnect(){this.port.close()}}e.Protocol=L;class A extends T.IPCClient{constructor(b,P){const D=new L(b);super(D,P);this.protocol=D}dispose(){this.protocol.disconnect()}}e.Client=A}),define(re[84],se([0,1,16,3,2,39]),function(Z,e,k,t,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var A;(function(a){a.Created="created",a.Read="read",a.Write="write",a.Open="open",a.Error="error",a.Close="close",a.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",a.NodeEndReceived="nodeEndReceived",a.NodeEndSent="nodeEndSent",a.NodeDrainBegin="nodeDrainBegin",a.NodeDrainEnd="nodeDrainEnd",a.zlibInflateError="zlibInflateError",a.zlibInflateData="zlibInflateData",a.zlibInflateInitialWrite="zlibInflateInitialWrite",a.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",a.zlibInflateWrite="zlibInflateWrite",a.zlibInflateFlushFired="zlibInflateFlushFired",a.zlibDeflateError="zlibDeflateError",a.zlibDeflateData="zlibDeflateData",a.zlibDeflateWrite="zlibDeflateWrite",a.zlibDeflateFlushFired="zlibDeflateFlushFired",a.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",a.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",a.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",a.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",a.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",a.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",a.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",a.ProtocolHeaderRead="protocolHeaderRead",a.ProtocolMessageRead="protocolMessageRead",a.ProtocolHeaderWrite="protocolHeaderWrite",a.ProtocolMessageWrite="protocolMessageWrite",a.ProtocolWrite="protocolWrite"})(A=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var I;(function(a){a.enableDiagnostics=!1,a.records=[];const c=new WeakMap;let s=0;function o(v,y){if(!c.has(v)){const O=String(++s);c.set(v,O)}return c.get(v)}function l(v,y,O,_){if(!a.enableDiagnostics)return;const F=o(v,y);if(_ instanceof k.VSBuffer||_ instanceof Uint8Array||_ instanceof ArrayBuffer||ArrayBuffer.isView(_)){const R=k.VSBuffer.alloc(_.byteLength);R.set(_),a.records.push({timestamp:Date.now(),id:F,label:y,type:O,buff:R})}else a.records.push({timestamp:Date.now(),id:F,label:y,type:O,data:_})}a.traceSocketEvent=l})(I=e.SocketDiagnostics||(e.SocketDiagnostics={}));var b;(function(a){a[a.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",a[a.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(b=e.SocketCloseEventType||(e.SocketCloseEventType={}));let P=null;function D(){return P||(P=k.VSBuffer.alloc(0)),P}class E{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(c){this._chunks.push(c),this._totalLength+=c.byteLength}read(c){return this._read(c,!0)}peek(c){return this._read(c,!1)}_read(c,s){if(c===0)return D();if(c>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===c){const y=this._chunks[0];return s&&(this._chunks.shift(),this._totalLength-=c),y}if(this._chunks[0].byteLength>c){const y=this._chunks[0].slice(0,c);return s&&(this._chunks[0]=this._chunks[0].slice(c),this._totalLength-=c),y}const o=k.VSBuffer.alloc(c);let l=0,v=0;for(;c>0;){const y=this._chunks[v];if(y.byteLength>c){const O=y.slice(0,c);o.set(O,l),l+=c,s&&(this._chunks[v]=y.slice(c),this._totalLength-=c),c-=c}else o.set(y,l),l+=y.byteLength,s?(this._chunks.shift(),this._totalLength-=y.byteLength):v++,c-=y.byteLength}return o}}e.ChunkStream=E;var p;(function(a){a[a.None=0]="None",a[a.Regular=1]="Regular",a[a.Control=2]="Control",a[a.Ack=3]="Ack",a[a.Disconnect=5]="Disconnect",a[a.ReplayRequest=6]="ReplayRequest",a[a.Pause=7]="Pause",a[a.Resume=8]="Resume"})(p||(p={}));function C(a){switch(a){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting"}}var h;(function(a){a[a.HeaderLength=13]="HeaderLength",a[a.AcknowledgeTime=2e3]="AcknowledgeTime",a[a.TimeoutTime=2e4]="TimeoutTime",a[a.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",a[a.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(h=e.ProtocolConstants||(e.ProtocolConstants={}));class S{constructor(c,s,o,l){this.type=c,this.id=s,this.ack=o,this.data=l,this.writtenTime=0}get size(){return this.data.byteLength}}class w extends T.Disposable{constructor(c){super();this._onMessage=this._register(new t.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=c,this._isDisposed=!1,this._incomingData=new E,this._register(this._socket.onData(s=>this.acceptChunk(s))),this.lastReadTime=Date.now()}acceptChunk(c){if(!(!c||c.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(c);this._incomingData.byteLength>=this._state.readLen;){const s=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=s.readUInt32BE(9),this._state.messageType=s.readUInt8(0),this._state.id=s.readUInt32BE(1),this._state.ack=s.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:C(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const o=this._state.messageType,l=this._state.id,v=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",s),this._onMessage.fire(new S(o,l,v,s)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class d{constructor(c){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=c,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(c){if(this._isDisposed)return;c.writtenTime=Date.now(),this.lastWriteTime=Date.now();const s=k.VSBuffer.alloc(13);s.writeUInt8(c.type,0),s.writeUInt32BE(c.id,1),s.writeUInt32BE(c.ack,5),s.writeUInt32BE(c.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:C(c.type),id:c.id,ack:c.ack,messageSize:c.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",c.data),this._writeSoon(s,c.data)}_bufferAdd(c,s){const o=this._totalLength===0;return this._data.push(c,s),this._totalLength+=c.byteLength+s.byteLength,o}_bufferTake(){const c=k.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,c}_writeSoon(c,s){this._bufferAdd(c,s)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const c=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:c.byteLength}),this._socket.write(c)}}class m extends T.Disposable{constructor(c){super();this._onMessage=new t.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new t.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=c,this._socketWriter=this._register(new d(this._socket)),this._socketReader=this._register(new w(this._socket)),this._register(this._socketReader.onMessage(s=>{s.type===1&&this._onMessage.fire(s.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(c){this._socketWriter.write(new S(1,0,0,c))}}e.Protocol=m;class g extends L.IPCClient{constructor(c,s,o=null){super(c,s,o);this.protocol=c}static fromSocket(c,s){return new g(new m(c),s)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const c=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),c.end()}}e.Client=g;class f{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new t.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(c){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(c):this._emitter.fire(c):this._bufferedMessages.push(c)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=f;class u{constructor(c){this.data=c,this.next=null}}class r{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){const c=[];let s=0,o=this._first;for(;o;)c[s++]=o.data,o=o.next;return c}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(c){const s=new u(c);if(!this._first){this._first=s,this._last=s;return}this._last.next=s,this._last=s}}class n{constructor(){this.lastRuns=[];const c=Date.now();for(let s=0;s<n._HISTORY_LENGTH;s++)this.lastRuns[s]=c-1e3*s;setInterval(()=>{for(let s=n._HISTORY_LENGTH;s>=1;s--)this.lastRuns[s]=this.lastRuns[s-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return n._INSTANCE||(n._INSTANCE=new n),n._INSTANCE}load(){const c=Date.now(),s=(1+n._HISTORY_LENGTH)*1e3;let o=0;for(let l=0;l<n._HISTORY_LENGTH;l++)c-this.lastRuns[l]<=s&&o++;return 1-o/n._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}n._HISTORY_LENGTH=10,n._INSTANCE=null;class i{constructor(c,s=null,o=n.getInstance()){this._onControlMessage=new f,this.onControlMessage=this._onControlMessage.event,this._onMessage=new f,this.onMessage=this._onMessage.event,this._onDidDispose=new f,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new f,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new f,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=o,this._isReconnecting=!1,this._outgoingUnackMsg=new r,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=c,this._socketWriter=new d(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new w(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(l=>this._receiveMessage(l))),this._socketDisposables.push(this._socket.onClose(l=>this._onSocketClose.fire(l))),s&&this._socketReader.acceptChunk(s)}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._socketDisposables=(0,T.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const c=new S(5,0,0,D());this._socketWriter.write(c),this._socketWriter.flush()}sendPause(){const c=new S(7,0,0,D());this._socketWriter.write(c)}sendResume(){const c=new S(8,0,0,D());this._socketWriter.write(c)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(c,s){this._isReconnecting=!0,this._socketDisposables=(0,T.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=c,this._socketWriter=new d(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new w(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(o=>this._receiveMessage(o))),this._socketDisposables.push(this._socket.onClose(o=>this._onSocketClose.fire(o))),this._socketReader.acceptChunk(s)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const c=new S(3,0,this._incomingAckId,D());this._socketWriter.write(c);const s=this._outgoingUnackMsg.toArray();for(let o=0,l=s.length;o<l;o++)this._socketWriter.write(s[o]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(c){if(c.ack>this._outgoingAckId){this._outgoingAckId=c.ack;do{const s=this._outgoingUnackMsg.peek();if(s&&s.id<=c.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(c.type){case 0:break;case 1:{if(c.id>this._incomingMsgId)if(c.id!==this._incomingMsgId+1){const s=Date.now();s-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=s,this._socketWriter.write(new S(6,0,0,D())))}else this._incomingMsgId=c.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(c.data);break}case 2:{this._onControlMessage.fire(c.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const s=this._outgoingUnackMsg.toArray();for(let o=0,l=s.length;o<l;o++)this._socketWriter.write(s[o]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(c){const s=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const o=new S(1,s,this._incomingAckId,c);this._outgoingUnackMsg.push(o),this._isReconnecting||(this._socketWriter.write(o),this._recvAckCheck())}sendControl(c){const s=new S(2,0,0,c);this._socketWriter.write(s)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const c=Date.now()-this._incomingMsgLastTime;if(c>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-c+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const c=this._outgoingUnackMsg.peek(),s=Date.now()-c.writtenTime,o=Date.now()-this._socketReader.lastReadTime,l=Date.now()-this._lastSocketTimeoutTime;if(s>=2e4&&o>=2e4&&l>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire(void 0);return}const v=Math.max(2e4-s,2e4-o,2e4-l,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},v)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const c=new S(3,0,this._incomingAckId,D());this._socketWriter.write(c)}}e.PersistentProtocol=i}),define(re[134],se([0,1,85,3,39,133]),function(Z,e,k,t,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;class A extends T.IPCServer{static getOnDidClientConnect(){const b=t.Event.fromNodeEventEmitter(k.ipcRenderer,"vscode:createMessageChannel",(P,D)=>D);return t.Event.map(b,P=>{const{port1:D,port2:E}=new MessageChannel,C={protocol:new L.Protocol(D),onDidClientDisconnect:t.Event.fromDOMEventEmitter(D,"close")};return k.ipcRenderer.postMessage("vscode:createMessageChannelResult",P,[E]),C})}constructor(){super(A.getOnDidClientConnect())}}e.Server=A}),define(re[86],se([0,1,6,3,2,14]),function(Z,e,k,t,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var A;(function(E){E[E.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(A=e.StorageHint||(e.StorageHint={}));function I(E){const p=E;return p?.changed instanceof Map||p?.deleted instanceof Set}e.isStorageItemsChangeEvent=I;var b;(function(E){E[E.None=0]="None",E[E.Initialized=1]="Initialized",E[E.Closed=2]="Closed"})(b=e.StorageState||(e.StorageState={}));class P extends T.Disposable{constructor(p,C=Object.create(null)){super();this.database=p,this.options=C,this._onDidChangeStorage=this._register(new t.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=b.None,this.cache=new Map,this.flushDelayer=new k.ThrottledDelayer(P.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(p=>this.onDidChangeItemsExternal(p)))}onDidChangeItemsExternal(p){p.changed?.forEach((C,h)=>this.accept(h,C)),p.deleted?.forEach(C=>this.accept(C,void 0))}accept(p,C){if(this.state===b.Closed)return;let h=!1;(0,L.isUndefinedOrNull)(C)?h=this.cache.delete(p):this.cache.get(p)!==C&&(this.cache.set(p,C),h=!0),h&&this._onDidChangeStorage.fire(p)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===b.None&&(this.state=b.Initialized,this.options.hint!==A.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(p,C){const h=this.cache.get(p);return(0,L.isUndefinedOrNull)(h)?C:h}getBoolean(p,C){const h=this.get(p);return(0,L.isUndefinedOrNull)(h)?C:h==="true"}getNumber(p,C){const h=this.get(p);return(0,L.isUndefinedOrNull)(h)?C:parseInt(h,10)}async set(p,C){if(this.state===b.Closed)return;if((0,L.isUndefinedOrNull)(C))return this.delete(p);const h=String(C);if(this.cache.get(p)!==h)return this.cache.set(p,h),this.pendingInserts.set(p,h),this.pendingDeletes.delete(p),this._onDidChangeStorage.fire(p),this.doFlush()}async delete(p){if(!(this.state===b.Closed||!this.cache.delete(p)))return this.pendingDeletes.has(p)||this.pendingDeletes.add(p),this.pendingInserts.delete(p),this._onDidChangeStorage.fire(p),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=b.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const p={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(p).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(p){if(!!this.hasPending)return this.doFlush(p)}async doFlush(p){return this.flushDelayer.trigger(()=>this.flushPending(),p)}async whenFlushed(){if(!!this.hasPending)return new Promise(p=>this.whenFlushedCallbacks.push(p))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=P,P.DEFAULT_FLUSH_DELAY=100;class D{constructor(){this.onDidChangeItemsExternal=t.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(p){p.insert?.forEach((C,h)=>this.items.set(h,C)),p.delete?.forEach(C=>this.items.delete(C))}async close(){}}e.InMemoryStorageDatabase=D}),define(re[135],se([10,11]),function(Z,e){return Z.create("vs/base/node/processes",e)}),define(re[87],se([0,1,48,42,20,29,12,4,36,78,14,115,27,135]),function(Z,e,k,t,T,L,A,I,b,P,D,E,p,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return P.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return P.TerminateResponseCode}});function h(u){switch(u){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function S(u,r){if(I.isWindows)try{const n={stdio:["pipe","pipe","ignore"]};r&&(n.cwd=r);const i=k.execFile("taskkill",["/T","/F","/PID",u.pid.toString()],n);return new Promise(a=>{i.once("error",c=>{a({success:!1,error:c})}),i.once("exit",(c,s)=>{a(c===0?{success:!0}:{success:!1,code:c!==null?c:1})})})}catch(n){return Promise.resolve({success:!1,error:n,code:n.status?h(n.status):1})}else if(I.isLinux||I.isMacintosh)try{const n=T.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",Z).fsPath;return new Promise(i=>{k.execFile(n,[u.pid.toString()],{encoding:"utf8",shell:!0},(a,c,s)=>{i(a?{success:!1,error:a}:{success:!0})})})}catch(n){return Promise.resolve({success:!1,error:n})}else u.kill("SIGKILL");return Promise.resolve({success:!0})}function w(u=b.env){return u.comspec||"cmd.exe"}e.getWindowsShell=w;class d{constructor(r,n,i,a){if(n!==void 0&&i!==void 0&&a!==void 0)this.cmd=r,this.args=n,this.shell=i,this.options=a;else{const c=r;this.cmd=c.command,this.shell=c.isShellCommand,this.args=c.args.slice(0),this.options=c.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const c=Object.create(null);Object.keys(b.env).forEach(s=>{c[s]=b.env[s]}),Object.keys(this.options.env).forEach(s=>{c[s]=this.options.env[s]}),this.options.env=c}}getSanitizedCommand(){let r=this.cmd.toLowerCase();const n=r.lastIndexOf(A.sep);return n!==-1&&(r=r.substring(n+1)),d.WellKnowCommands[r]?r:"other"}start(r){return I.isWindows&&(this.options&&this.options.cwd&&t.isUNC(this.options.cwd)||!this.options&&t.isUNC(b.cwd()))?Promise.reject(new Error(C.localize(0,null))):this.useExec().then(n=>{let i,a;const c=new Promise((s,o)=>{i=s,a=o});if(n){let s=this.cmd;this.args&&(s=s+" "+this.args.join(" ")),this.childProcess=k.exec(s,this.options,(o,l,v)=>{this.childProcess=null;const y=o;y&&y.killed?a({killed:this.terminateRequested,stdout:l.toString(),stderr:v.toString()}):this.handleExec(i,r,o,l,v)})}else{let s=null;const o=l=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(l,i,r,a);const v={terminated:this.terminateRequested};D.isNumber(l)&&(v.cmdCode=l),i(v)};if(this.shell&&I.isWindows){const l=L.deepClone(this.options);l.windowsVerbatimArguments=!0,l.detached=!1;let v=!1,y=!1;const O=[];let _=this.ensureQuotes(this.cmd);O.push(_.value),v=_.quoted,this.args&&this.args.forEach(R=>{_=this.ensureQuotes(R),O.push(_.value),y=y&&_.quoted});const F=["/s","/c"];v?y?F.push('"'+O.join(" ")+'"'):O.length>1?F.push('"'+O[0]+'" '+O.slice(1).join(" ")):F.push('"'+O[0]+'"'):F.push(O.join(" ")),s=k.spawn(w(),F,l)}else this.cmd&&(s=k.spawn(this.cmd,this.args,this.options));s&&(this.childProcess=s,this.childProcessPromise=Promise.resolve(s),this.pidResolve&&(this.pidResolve(D.isNumber(s.pid)?s.pid:-1),this.pidResolve=void 0),s.on("error",l=>{this.childProcess=null,a({terminated:this.terminateRequested,error:l})}),s.pid&&(this.childProcess.on("close",o),this.handleSpawn(s,i,r,a,!0)))}return c})}handleClose(r,n,i,a){}ensureQuotes(r){return d.regexp.test(r)?{value:'"'+r+'"',quoted:!0}:{value:r,quoted:r.length>0&&r[0]==='"'&&r[r.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(r=>r.pid,r=>-1):new Promise(r=>{this.pidResolve=r})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(r=>(this.terminateRequested=!0,S(r,this.options.cwd).then(n=>(n.success&&(this.childProcess=null),n))),r=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(r=>{if(!this.shell||!I.isWindows)return r(!1);const n=k.spawn(w(),["/s","/c"]);n.on("error",i=>r(!0)),n.on("exit",i=>r(!1))})}}e.AbstractProcess=d,d.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},d.regexp=/^[^"].* .*[^"]/;class m extends d{constructor(r,n,i,a){super(r,n,i,a);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(r,n,i,a,c){[a,c].forEach((s,o)=>{const l=new E.LineDecoder;l.write(s).forEach(O=>{n({line:O,source:o===0?0:1})});const y=l.end();y&&n({line:y,source:o===0?0:1})}),r({terminated:this.terminateRequested,error:i})}handleSpawn(r,n,i,a,c){const s=new E.LineDecoder,o=new E.LineDecoder;r.stdout.on("data",l=>{s.write(l).forEach(y=>i({line:y,source:0}))}),r.stderr.on("data",l=>{o.write(l).forEach(y=>i({line:y,source:1}))}),this.stdoutLineDecoder=s,this.stderrLineDecoder=o}handleClose(r,n,i,a){const c=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;c&&i({line:c,source:0});const s=this.stderrLineDecoder?this.stderrLineDecoder.end():null;s&&i({line:s,source:1})}}e.LineProcess=m;function g(u){let r=[],n=!1;const i=function(a){if(n){r.push(a);return}(!u.send(a,s=>{if(s&&console.error(s),n=!1,r.length>0){const o=r.slice(0);r=[],o.forEach(l=>i(l))}})||I.isWindows)&&(n=!0)};return{send:i}}e.createQueuedSender=g;var f;(function(u){async function r(n,i,a){if(A.isAbsolute(n))return n;if(i===void 0&&(i=b.cwd()),A.dirname(n)!=="."||(a===void 0&&D.isString(b.env.PATH)&&(a=b.env.PATH.split(A.delimiter)),a===void 0||a.length===0))return A.join(i,n);async function s(o){if(await p.Promises.exists(o)){let l;try{l=await p.Promises.stat(o)}catch(v){v.message.startsWith("EACCES")&&(l=await p.Promises.lstat(o))}return l?!l.isDirectory():!1}return!1}for(const o of a){let l;if(A.isAbsolute(o)?l=A.join(o,n):l=A.join(i,o,n),await s(l))return l;let v=l+".com";if(await s(v)||(v=l+".exe",await s(v)))return v}return A.join(i,n)}u.findExecutable=r})(f=e.win32||(e.win32={}))}),define(re[136],se([0,1,35,4,83,87]),function(Z,e,k,t,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function A(C,h){return C===1?t.isWindows?E():L.getWindowsShell(h):P(C,h)}e.getSystemShell=A;function I(C,h){return C===1?t.isWindows?p(h):L.getWindowsShell(h):P(C,h)}e.getSystemShellSync=I;let b=null;function P(C,h){if(t.isLinux&&C===2||t.isMacintosh&&C===3)return"/bin/bash";if(!b){let S;if(t.isWindows)S="/bin/bash";else{if(S=h.SHELL,!S)try{S=(0,k.userInfo)().shell}catch{}S||(S="sh"),S==="/bin/false"&&(S="/bin/bash")}b=S}return b}let D=null;async function E(){return D||(D=(await(0,T.getFirstAvailablePowerShellInstallation)()).exePath),D}function p(C){if(D)return D;const h=t.isWindows&&parseFloat((0,k.release)())>=10,S=C.hasOwnProperty("PROCESSOR_ARCHITEW6432"),w=`${C.windir}\\${S?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return h?w:L.getWindowsShell(C)}}),define(re[65],se([0,1,48,6,16,23,128,9,3,2,29,87,78,39]),function(Z,e,k,t,T,L,A,I,b,P,D,E,p,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class h extends C.ChannelServer{constructor(d){super({send:m=>{try{process.send?.(m.buffer.toString("base64"))}catch{}},onMessage:b.Event.fromNodeEventEmitter(process,"message",m=>T.VSBuffer.wrap(Buffer.from(m,"base64")))},d);process.once("disconnect",()=>this.dispose())}}e.Server=h;class S{constructor(d,m){this.modulePath=d,this.options=m,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new b.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const g=m&&m.timeout?m.timeout:6e4;this.disposeDelayer=new t.Delayer(g),this.child=null,this._client=null}getChannel(d){const m=this;return{call(g,f,u){return m.requestPromise(d,g,f,u)},listen(g,f){return m.requestEvent(d,g,f)}}}requestPromise(d,m,g,f=L.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(f.isCancellationRequested)return Promise.reject(I.canceled());this.disposeDelayer.cancel();const u=this.getCachedChannel(d),r=(0,t.createCancelablePromise)(a=>u.call(m,g,a)),n=f.onCancellationRequested(()=>r.cancel()),i=(0,P.toDisposable)(()=>r.cancel());return this.activeRequests.add(i),r.finally(()=>{n.dispose(),this.activeRequests.delete(i),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),r}requestEvent(d,m,g){if(!this.disposeDelayer)return b.Event.None;this.disposeDelayer.cancel();let f;const u=new b.Emitter({onFirstListenerAdd:()=>{f=this.getCachedChannel(d).listen(m,g)(u.fire,u),this.activeRequests.add(f)},onLastListenerRemove:()=>{this.activeRequests.delete(f),f.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return u.event}get client(){if(!this._client){const d=this.options&&this.options.args?this.options.args:[],m=Object.create(null);m.env={...(0,D.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(m.env={...m.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(m.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(m.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(m.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),m.execArgv===void 0&&(m.execArgv=process.execArgv.filter(c=>!/^--inspect(-brk)?=/.test(c))),(0,p.removeDangerousEnvVariables)(m.env),this.child=(0,k.fork)(this.modulePath,d,m);const g=new b.Emitter;b.Event.fromNodeEventEmitter(this.child,"message",c=>c)(c=>{if((0,A.isRemoteConsoleLog)(c)){(0,A.log)(c,`IPC Library: ${this.options.serverName}`);return}g.fire(T.VSBuffer.wrap(Buffer.from(c,"base64")))});const u=this.options.useQueue?(0,E.createQueuedSender)(this.child):this.child,r=c=>this.child&&this.child.connected&&u.send(c.buffer.toString("base64")),n=g.event,i={send:r,onMessage:n};this._client=new C.ChannelClient(i);const a=()=>this.disposeClient();process.once("exit",a),this.child.on("error",c=>console.warn('IPC "'+this.options.serverName+'" errored with '+c)),this.child.on("exit",(c,s)=>{process.removeListener("exit",a),this.activeRequests.forEach(o=>(0,P.dispose)(o)),this.activeRequests.clear(),c!==0&&s!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+c+" and signal "+s),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:c,signal:s})})}return this._client}getCachedChannel(d){let m=this.channels.get(d);return m||(m=this.client.getChannel(d),this.channels.set(d,m)),m}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=S}),define(re[137],se([10,11]),function(Z,e){return Z.create("vs/base/node/zip",e)}),define(re[138],se([10,11]),function(Z,e){return Z.create("vs/platform/configuration/common/configurationRegistry",e)}),define(re[139],se([10,11]),function(Z,e){return Z.create("vs/platform/environment/node/argv",e)}),define(re[140],se([10,11]),function(Z,e){return Z.create("vs/platform/environment/node/argvHelper",e)}),define(re[141],se([10,11]),function(Z,e){return Z.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(re[142],se([10,11]),function(Z,e){return Z.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(re[143],se([10,11]),function(Z,e){return Z.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(re[144],se([10,11]),function(Z,e){return Z.create("vs/platform/extensionManagement/electron-sandbox/extensionTipsService",e)}),define(re[145],se([10,11]),function(Z,e){return Z.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(re[146],se([10,11]),function(Z,e){return Z.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(re[147],se([10,11]),function(Z,e){return Z.create("vs/platform/extensions/common/extensionValidator",e)}),define(re[148],se([10,11]),function(Z,e){return Z.create("vs/platform/files/common/fileService",e)}),define(re[149],se([10,11]),function(Z,e){return Z.create("vs/platform/files/common/files",e)}),define(re[150],se([10,11]),function(Z,e){return Z.create("vs/platform/files/common/io",e)}),define(re[151],se([10,11]),function(Z,e){return Z.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(re[152],se([10,11]),function(Z,e){return Z.create("vs/platform/languagePacks/common/languagePacks",e)}),define(re[153],se([10,11]),function(Z,e){return Z.create("vs/platform/request/common/request",e)}),define(re[154],se([10,11]),function(Z,e){return Z.create("vs/platform/shell/node/shellEnv",e)}),define(re[155],se([10,11]),function(Z,e){return Z.create("vs/platform/telemetry/common/telemetryService",e)}),define(re[156],se([10,11]),function(Z,e){return Z.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(re[157],se([10,11]),function(Z,e){return Z.create("vs/platform/terminal/common/terminalProfiles",e)}),define(re[158],se([10,11]),function(Z,e){return Z.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(re[159],se([10,11]),function(Z,e){return Z.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(re[160],se([10,11]),function(Z,e){return Z.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(re[161],se([10,11]),function(Z,e){return Z.create("vs/platform/userDataSync/common/settingsSync",e)}),define(re[162],se([10,11]),function(Z,e){return Z.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(re[163],se([10,11]),function(Z,e){return Z.create("vs/platform/userDataSync/common/userDataSync",e)}),define(re[164],se([10,11]),function(Z,e){return Z.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(re[88],se([0,1,62,60,20,12,36,19,8]),function(Z,e,k,t,T,L,A,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class P{constructor(S,w,d){this._args=S,this.paths=w,this.productService=d,this.editSessionId=this.args.editSessionId}get appRoot(){return(0,L.dirname)(T.FileAccess.asFileUri("",Z).fsPath)}get userHome(){return b.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return b.URI.file((0,L.join)(this.userDataPath,"User"))}get tmpDir(){return b.URI.file(this.paths.tmpDir)}get cacheHome(){return b.URI.file(this.userDataPath)}get stateResource(){return(0,I.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,I.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const S=(0,k.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,L.join)(this.userDataPath,"logs",S)}return this.args.logsPath}get userDataSyncLogResource(){return b.URI.file((0,L.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,I.joinPath)(b.URI.file((0,L.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,I.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,I.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,I.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const S=A.env.VSCODE_PORTABLE;return S?b.URI.file((0,L.join)(S,"argv.json")):(0,I.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return b.URI.file((0,L.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,L.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const S=this.args["builtin-extensions-dir"];return S?(0,L.resolve)(S):(0,L.normalize)((0,L.join)(T.FileAccess.asFileUri("",Z).fsPath,"..","extensions"))}get extensionsDownloadPath(){const S=this.args["extensions-download-dir"];return S?(0,L.resolve)(S):(0,L.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const S=this.args["extensions-dir"];if(S)return(0,L.resolve)(S);const w=A.env.VSCODE_EXTENSIONS;if(w)return w;const d=A.env.VSCODE_PORTABLE;return d?(0,L.join)(d,"extensions"):(0,I.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const S=this.args.extensionDevelopmentPath;if(Array.isArray(S))return S.map(w=>/^[^:/?#]+?:\/\//.test(w)?b.URI.parse(w):b.URI.file((0,L.normalize)(w)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(S=>S==="ui"||S==="workspace"||S==="web"?S:"workspace")}get extensionTestsLocationURI(){const S=this.args.extensionTestsPath;if(S)return/^[^:/?#]+?:\/\//.test(S)?b.URI.parse(S):b.URI.file((0,L.normalize)(S))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const S=this.args["disable-extension"];if(S){if(typeof S=="string")return[S];if(Array.isArray(S)&&S.length>0)return S}return!1}get debugExtensionHost(){return D(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!A.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,I.joinPath)(b.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return b.URI.file((0,L.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const S=A.env.VSCODE_PORTABLE;return S?b.URI.file((0,L.join)(S,"policy.json")):(0,I.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get args(){return this._args}}me([t.memoize],P.prototype,"appRoot",null),me([t.memoize],P.prototype,"userHome",null),me([t.memoize],P.prototype,"userDataPath",null),me([t.memoize],P.prototype,"appSettingsHome",null),me([t.memoize],P.prototype,"tmpDir",null),me([t.memoize],P.prototype,"cacheHome",null),me([t.memoize],P.prototype,"stateResource",null),me([t.memoize],P.prototype,"userRoamingDataHome",null),me([t.memoize],P.prototype,"userDataSyncHome",null),me([t.memoize],P.prototype,"userDataSyncLogResource",null),me([t.memoize],P.prototype,"sync",null),me([t.memoize],P.prototype,"machineSettingsResource",null),me([t.memoize],P.prototype,"workspaceStorageHome",null),me([t.memoize],P.prototype,"localHistoryHome",null),me([t.memoize],P.prototype,"keyboardLayoutResource",null),me([t.memoize],P.prototype,"argvResource",null),me([t.memoize],P.prototype,"isExtensionDevelopment",null),me([t.memoize],P.prototype,"untitledWorkspacesHome",null),me([t.memoize],P.prototype,"installSourcePath",null),me([t.memoize],P.prototype,"builtinExtensionsPath",null),me([t.memoize],P.prototype,"extensionsPath",null),me([t.memoize],P.prototype,"extensionDevelopmentLocationURI",null),me([t.memoize],P.prototype,"extensionDevelopmentKind",null),me([t.memoize],P.prototype,"extensionTestsLocationURI",null),me([t.memoize],P.prototype,"debugExtensionHost",null),me([t.memoize],P.prototype,"serviceMachineIdResource",null),me([t.memoize],P.prototype,"telemetryLogResource",null),me([t.memoize],P.prototype,"disableWorkspaceTrust",null),me([t.memoize],P.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=P;function D(h,S){return C(h["inspect-extensions"],h["inspect-brk-extensions"],5870,S,h.debugId,h.extensionEnvironment)}e.parseExtensionHostPort=D;function E(h,S){return C(h["inspect-search"],h["inspect-brk-search"],5876,S,h.extensionEnvironment)}e.parseSearchPort=E;function p(h,S){return C(h["inspect-ptyhost"],h["inspect-brk-ptyhost"],5877,S,h.extensionEnvironment)}e.parsePtyHostPort=p;function C(h,S,w,d,m,g){const u=Number(S||h)||(d?null:w),r=u?Boolean(!!S):!1;let n;if(g)try{n=JSON.parse(g)}catch{}return{port:u,break:r,debugId:m,env:n}}}),define(re[165],se([0,1,268,4,139]),function(Z,e,k,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const L={o:(0,T.localize)(0,null),e:(0,T.localize)(1,null),t:(0,T.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,T.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,T.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,T.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,T.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,T.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,T.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,T.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,T.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,T.localize)(11,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,T.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,T.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,T.localize)(14,null)},category:{type:"string",cat:"e",description:(0,T.localize)(15,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,T.localize)(16,null)},"pre-release":{type:"boolean",cat:"e",description:(0,T.localize)(17,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,T.localize)(18,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,T.localize)(19,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,T.localize)(20,null)},verbose:{type:"boolean",cat:"t",description:(0,T.localize)(21,null)},log:{type:"string",cat:"t",args:"level",description:(0,T.localize)(22,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,T.localize)(23,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,T.localize)(24,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,T.localize)(25,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,T.localize)(26,null)},sync:{type:"string",cat:"t",description:(0,T.localize)(27,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,T.localize)(28,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,T.localize)(29,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,T.localize)(30,null)},"ms-enable-electron-run-as-node":{type:"boolean"},"max-memory":{type:"string",cat:"t",description:(0,T.localize)(31,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,T.localize)(32,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},_:{type:"string[]"}};const A={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function I(h,S,w=A){const d={},m=["_"],g=[];for(const n in S){const i=S[n];i.alias&&(d[n]=i.alias),i.type==="string"||i.type==="string[]"?(m.push(n),i.deprecates&&m.push(...i.deprecates)):i.type==="boolean"&&(g.push(n),i.deprecates&&g.push(...i.deprecates))}const f=k(h,{string:m,boolean:g,alias:d}),u={},r=f;u._=f._.map(n=>String(n)).filter(n=>n.length>0),delete r._;for(const n in S){const i=S[n];i.alias&&delete r[i.alias];let a=r[n];if(i.deprecates)for(const c of i.deprecates)r.hasOwnProperty(c)&&(a||(a=r[c],a&&w.onDeprecatedOption(c,i.deprecationMessage||(0,T.localize)(33,null,n))),delete r[c]);if(typeof a!="undefined"){if(i.type==="string[]"){if(Array.isArray(a)||(a=[a]),!i.allowEmptyValue){const c=a.filter(s=>s.length>0);c.length!==a.length&&(w.onEmptyValue(n),a=c.length>0?c:void 0)}}else i.type==="string"&&(Array.isArray(a)?(a=a.pop(),w.onMultipleValues(n,a)):!a&&!i.allowEmptyValue&&(w.onEmptyValue(n),a=void 0));u[n]=a,i.deprecationMessage&&w.onDeprecatedOption(n,i.deprecationMessage)}delete r[n]}for(const n in r)w.onUnknownOption(n);return u}e.parseArgs=I;function b(h,S){let w="";return S.args&&(Array.isArray(S.args)?w=` <${S.args.join("> <")}>`:w=` <${S.args}>`),S.alias?`-${S.alias} --${h}${w}`:`--${h}${w}`}function P(h,S){let w=0;const d=[];for(const u in h){const r=h[u],n=b(u,r);w=Math.max(w,n.length),d.push([n,r.description])}const m=w+2+1;if(S-m<25)return d.reduce((u,r)=>u.concat([`  ${r[0]}`,`      ${r[1]}`]),[]);const g=S-m-1,f=[];for(const u of d){const r=u[0],n=E(u[1],g),i=D(m-r.length-2);f.push("  "+r+i+n[0]);for(let a=1;a<n.length;a++)f.push(D(m)+n[a])}return f}e.formatOptions=P;function D(h){return" ".repeat(h)}function E(h,S){const w=[];for(;h.length;){const d=h.length<S?h.length:h.lastIndexOf(" ",S),m=h.slice(0,d).trim();h=h.slice(d),w.push(m)}return w}function p(h,S,w,d,m){const g=process.stdout.isTTY&&process.stdout.columns||80,f=m?.noInputFiles!==!0?`[${(0,T.localize)(34,null)}...]`:"",u=[`${h} ${w}`];u.push(""),u.push(`${(0,T.localize)(35,null)}: ${S} [${(0,T.localize)(36,null)}]${f}`),u.push(""),m?.noPipe!==!0&&(t.isWindows?u.push((0,T.localize)(37,null,S)):u.push((0,T.localize)(38,null,S)),u.push(""));const r={};for(const n in d){const i=d[n];if(i.description&&i.cat){let a=r[i.cat];a||(r[i.cat]=a={}),a[n]=i}}for(const n in r){const i=n,a=r[i];a&&(u.push(L[i]),u.push(...P(a,g)),u.push(""))}return u.join(`
`)}e.buildHelpMessage=p;function C(h,S){return`${h||(0,T.localize)(39,null)}
${S||(0,T.localize)(40,null)}
${process.arch}`}e.buildVersionMessage=C}),define(re[166],se([0,1,269,140,165]),function(Z,e,k,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const L=2048;function A(p,C){const h={onUnknownOption:w=>{console.warn((0,t.localize)(0,null,w))},onMultipleValues:(w,d)=>{console.warn((0,t.localize)(1,null,w,d))},onEmptyValue:w=>{console.warn((0,t.localize)(2,null,w))},onDeprecatedOption:(w,d)=>{console.warn((0,t.localize)(3,null,w,d))}},S=(0,T.parseArgs)(p,T.OPTIONS,C?h:void 0);return S.goto&&S._.forEach(w=>k(/^(\w:)?[^:]+(:\d*){0,2}$/.test(w),(0,t.localize)(4,null))),S["max-memory"]&&k(parseInt(S["max-memory"])>=L,`The max-memory argument cannot be specified lower than ${L} MB.`),S}function I(p){const C=p.findIndex(h=>!/^-/.test(h));if(C>-1)return[...p.slice(0,C),...p.slice(C+1)]}function b(p){let[,...C]=p;process.env.VSCODE_DEV&&(C=I(C)||[]);const h=!E(process.env);return A(C,h)}e.parseMainProcessArgv=b;function P(p){const[,,...C]=p;return A(C,!0)}e.parseCLIProcessArgv=P;function D(p,...C){const h=p.indexOf("--");return h===-1?p.push(...C):p.splice(h,0,...C),p}e.addArg=D;function E(p){return p.VSCODE_CLI==="1"}e.isLaunchedFromCli=E}),function(){"use strict";function Z(e,k,t,T){function L(I){const b=A(I),P=[b];return e.isAbsolute(b)||P.unshift(T),e.resolve(...P)}function A(I){const b=process.env.VSCODE_PORTABLE;if(b)return e.join(b,"user-data");let P=process.env.VSCODE_APPDATA;if(P)return e.join(P,t);const D=I["user-data-dir"];if(D)return D;switch(process.platform){case"win32":if(P=process.env.APPDATA,!P){const E=process.env.USERPROFILE;if(typeof E!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");P=e.join(E,"AppData","Roaming")}break;case"darwin":P=e.join(k.homedir(),"Library","Application Support");break;case"linux":P=process.env.XDG_CONFIG_HOME||e.join(k.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(P,t)}return{getUserDataPath:L}}if(typeof define=="function")define(re[167],se([0,270,35,20,19,36]),function(e,k,t,T,L,A){const I=L.dirname(T.FileAccess.asFileUri("",e)),b=e.__$__nodeRequire(L.joinPath(I,"package.json").fsPath);return Z(k,t,b.name,A.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),k=require("path"),t=require("os");module.exports=Z(k,t,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(re[168],se([0,1,35,88,167]),function(Z,e,k,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class L extends t.AbstractNativeEnvironmentService{constructor(I,b){super(I,{homeDir:(0,k.homedir)(),tmpDir:(0,k.tmpdir)(),userDataDir:(0,T.getUserDataPath)(I)},b)}}e.NativeEnvironmentService=L}),define(re[169],se([0,1,8]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemotes=e.getDomainsOfRemotes=e.AllowedSecondLevelDomains=void 0;const t=/^([^@:]+@)?([^:]+):/,T=/^([^@:]+@)?([^:]+):(.+)$/,L=/^([^@]+@)?([^:]+)(:\d+)?$/,A=/([^@:.]+\.[^@:.]+)(:\d+)?$/,I=/^\s*url\s*=\s*(.+\S)\s*$/mg,b=/[^.]/g;e.AllowedSecondLevelDomains=["github.com","bitbucket.org","visualstudio.com","gitlab.com","heroku.com","azurewebsites.net","ibm.com","amazon.com","amazonaws.com","cloudapp.net","rhcloud.com","google.com","azure.com"];function P(w){const d=w.match(A);return d?d[1]:null}function D(w){if(w.indexOf("://")===-1){const d=w.match(t);return d?P(d[2]):null}try{const d=k.URI.parse(w);if(d.authority)return P(d.authority)}catch{}return null}function E(w,d){const m=new Set;let g;for(;g=I.exec(w);){const u=D(g[1]);u&&m.add(u)}const f=new Set(d);return Array.from(m).map(u=>f.has(u)?u:u.replace(b,"a"))}e.getDomainsOfRemotes=E;function p(w){const d=w.match(L);return d?d[2]:null}function C(w,d,m){return w&&d?(m&&d.endsWith(".git")&&(d=d.substr(0,d.length-4)),d.indexOf("/")===0?`${w}${d}`:`${w}/${d}`):null}function h(w,d){if(w.indexOf("://")===-1){const m=w.match(T);if(m)return C(m[2],m[3],d)}try{const m=k.URI.parse(w);if(m.authority)return C(p(m.authority),m.path,d)}catch{}return null}function S(w,d=!1){const m=[];let g;for(;g=I.exec(w);){const f=h(g[1],d);f&&m.push(f)}return m}e.getRemotes=S}),define(re[170],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class k{constructor(L){this.channel=L}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(L,A,I,b){return this.channel.call("promptImportantExtensionsInstallNotification",[L,A,I,b])}promptWorkspaceRecommendations(L){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=k;class t{constructor(L){this.service=L}listen(L,A){throw new Error(`Event not found: ${A}`)}call(L,A,I){switch(A){case"promptImportantExtensionsInstallNotification":return this.service.promptImportantExtensionsInstallNotification(I[0],I[1],I[2],I[3])}throw new Error(`Call not found: ${A}`)}}e.ExtensionRecommendationNotificationServiceChannel=t}),define(re[66],se([0,1,19,81,147,55]),function(Z,e,k,t,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,I=/^-(\d{4})(\d{2})(\d{2})$/;function b(d){return d=d.trim(),d==="*"||A.test(d)}e.isValidVersionStr=b;function P(d){if(!b(d))return null;if(d=d.trim(),d==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const m=d.match(A);return m?{hasCaret:m[1]==="^",hasGreaterEquals:m[1]===">=",majorBase:m[2]==="x"?0:parseInt(m[2],10),majorMustEqual:m[2]!=="x",minorBase:m[4]==="x"?0:parseInt(m[4],10),minorMustEqual:m[4]!=="x",patchBase:m[6]==="x"?0:parseInt(m[6],10),patchMustEqual:m[6]!=="x",preRelease:m[8]||null}:null}e.parseVersion=P;function D(d){if(!d)return null;const m=d.majorBase,g=d.majorMustEqual,f=d.minorBase;let u=d.minorMustEqual;const r=d.patchBase;let n=d.patchMustEqual;d.hasCaret&&(m===0||(u=!1),n=!1);let i=0;if(d.preRelease){const a=I.exec(d.preRelease);if(a){const[,c,s,o]=a;i=Date.UTC(Number(c),Number(s)-1,Number(o))}}return{majorBase:m,majorMustEqual:g,minorBase:f,minorMustEqual:u,patchBase:r,patchMustEqual:n,isMinimum:d.hasGreaterEquals,notBefore:i}}e.normalizeVersion=D;function E(d,m,g){let f;typeof d=="string"?f=D(P(d)):f=d;let u;m instanceof Date?u=m.getTime():typeof m=="string"&&(u=new Date(m).getTime());let r;if(typeof g=="string"?r=D(P(g)):r=g,!f||!r)return!1;const n=f.majorBase,i=f.minorBase,a=f.patchBase;let c=r.majorBase,s=r.minorBase,o=r.patchBase;const l=r.notBefore;let v=r.majorMustEqual,y=r.minorMustEqual,O=r.patchMustEqual;return r.isMinimum?n>c?!0:n<c?!1:i>s?!0:i<s||u&&u<l?!1:a>=o:(n===1&&c===0&&(!v||!y||!O)&&(c=1,s=0,o=0,v=!0,y=!1,O=!1),n<c?!1:n>c?!v:i<s?!1:i>s?!y:a<o?!1:a>o?!O:!(u&&u<l))}e.isValidVersion=E;function p(d,m,g,f,u){const r=[];if(typeof f.publisher!="undefined"&&typeof f.publisher!="string")return r.push([t.default.Error,T.localize(0,null)]),r;if(typeof f.name!="string")return r.push([t.default.Error,T.localize(1,null,"name")]),r;if(typeof f.version!="string")return r.push([t.default.Error,T.localize(2,null,"version")]),r;if(!f.engines)return r.push([t.default.Error,T.localize(3,null,"engines")]),r;if(typeof f.engines.vscode!="string")return r.push([t.default.Error,T.localize(4,null,"engines.vscode")]),r;if(typeof f.extensionDependencies!="undefined"&&!w(f.extensionDependencies))return r.push([t.default.Error,T.localize(5,null,"extensionDependencies")]),r;if(typeof f.activationEvents!="undefined"){if(!w(f.activationEvents))return r.push([t.default.Error,T.localize(6,null,"activationEvents")]),r;if(typeof f.main=="undefined"&&typeof f.browser=="undefined")return r.push([t.default.Error,T.localize(7,null,"activationEvents","main")]),r}if(typeof f.extensionKind!="undefined"&&typeof f.main=="undefined"&&r.push([t.default.Warning,T.localize(8,null,"extensionKind")]),typeof f.main!="undefined"){if(typeof f.main!="string")return r.push([t.default.Error,T.localize(9,null,"main")]),r;{const a=(0,k.joinPath)(g,f.main);(0,k.isEqualOrParent)(a,g)||r.push([t.default.Warning,T.localize(10,null,a.path,g.path)])}if(typeof f.activationEvents=="undefined")return r.push([t.default.Error,T.localize(11,null,"activationEvents","main")]),r}if(typeof f.browser!="undefined"){if(typeof f.browser!="string")return r.push([t.default.Error,T.localize(12,null,"browser")]),r;{const a=(0,k.joinPath)(g,f.browser);(0,k.isEqualOrParent)(a,g)||r.push([t.default.Warning,T.localize(13,null,a.path,g.path)])}if(typeof f.activationEvents=="undefined")return r.push([t.default.Error,T.localize(14,null,"activationEvents","browser")]),r}if(!L.valid(f.version))return r.push([t.default.Error,T.localize(15,null)]),r;const n=[];if(!C(d,m,f,u,n))for(const a of n)r.push([t.default.Error,a]);return r}e.validateExtensionManifest=p;function C(d,m,g,f,u){return f||typeof g.main=="undefined"&&typeof g.browser=="undefined"?!0:S(d,m,g.engines.vscode,u)}e.isValidExtensionVersion=C;function h(d,m,g){return d==="*"||S(m,g,d)}e.isEngineValid=h;function S(d,m,g,f=[]){const u=D(P(g));if(!u)return f.push(T.localize(16,null,g)),!1;if(u.majorBase===0){if(!u.majorMustEqual||!u.minorMustEqual)return f.push(T.localize(17,null,g)),!1}else if(!u.majorMustEqual)return f.push(T.localize(18,null,g)),!1;return E(d,m,u)?!0:(f.push(T.localize(19,null,d,g)),!1)}function w(d){if(!Array.isArray(d))return!1;for(let m=0,g=d.length;m<g;m++)if(typeof d[m]!="string")return!1;return!0}}),define(re[49],se([0,1,16,31]),function(Z,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function T(L,A,I){let b=I&&I.get("storage.serviceMachineId",-1)||null;if(b)return b;try{const D=(await A.readFile(L.serviceMachineIdResource)).value.toString();b=(0,t.isUUID)(D)?D:null}catch{b=null}if(!b){b=(0,t.generateUuid)();try{await A.writeFile(L.serviceMachineIdResource,k.VSBuffer.fromString(b))}catch{}}return I?.store("storage.serviceMachineId",b,-1,1),b}e.getServiceMachineId=T}),define(re[56],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class k{constructor(T,L=[],A=!1){this.ctor=T,this.staticArguments=L,this.supportsDelayedInstantiation=A}}e.SyncDescriptor=k}),define(re[89],se([0,1,56]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const t=[];function T(A,I,b){I instanceof k.SyncDescriptor||(I=new k.SyncDescriptor(I,[],b)),t.push([A,I])}e.registerSingleton=T;function L(){return t}e.getSingletonServiceDescriptors=L}),define(re[171],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class k{constructor(L){this.incoming=new Map,this.outgoing=new Map,this.data=L}}e.Node=k;class t{constructor(L){this._hashFn=L,this._nodes=new Map}roots(){const L=[];for(const A of this._nodes.values())A.outgoing.size===0&&L.push(A);return L}insertEdge(L,A){const I=this.lookupOrInsertNode(L),b=this.lookupOrInsertNode(A);I.outgoing.set(this._hashFn(A),b),b.incoming.set(this._hashFn(L),I)}removeNode(L){const A=this._hashFn(L);this._nodes.delete(A);for(const I of this._nodes.values())I.outgoing.delete(A),I.incoming.delete(A)}lookupOrInsertNode(L){const A=this._hashFn(L);let I=this._nodes.get(A);return I||(I=new k(L),this._nodes.set(A,I)),I}lookup(L){return this._nodes.get(this._hashFn(L))}isEmpty(){return this._nodes.size===0}toString(){const L=[];for(const[A,I]of this._nodes)L.push(`${A}, (incoming)[${[...I.incoming.keys()].join(", ")}], (outgoing)[${[...I.outgoing.keys()].join(",")}]`);return L.join(`
`)}findCycleSlow(){for(const[L,A]of this._nodes){const I=new Set([L]),b=this._findCycle(A,I);if(b)return b}}_findCycle(L,A){for(const[I,b]of L.outgoing){if(A.has(I))return[...A,I].join(" -> ");A.add(I);const P=this._findCycle(b,A);if(P)return P;A.delete(I)}}}e.Graph=t}),define(re[5],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var k;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function I(b){return b[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=I})(k=e._util||(e._util={})),e.IInstantiationService=T("instantiationService");function t(A,I,b){I[k.DI_TARGET]===I?I[k.DI_DEPENDENCIES].push({id:A,index:b}):(I[k.DI_DEPENDENCIES]=[{id:A,index:b}],I[k.DI_TARGET]=I)}function T(A){if(k.serviceIds.has(A))return k.serviceIds.get(A);const I=function(b,P,D){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(I,b,D)};return I.toString=()=>A,k.serviceIds.set(A,I),I}e.createDecorator=T;function L(A){return A}e.refineServiceDecorator=L}),define(re[172],se([0,1,5]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,k.createDecorator)("checksumService")}),define(re[18],se([0,1,14,8,5]),function(Z,e,k,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,T.createDecorator)("configurationService");function L(d){return d&&typeof d=="object"&&(!d.overrideIdentifier||typeof d.overrideIdentifier=="string")&&(!d.resource||d.resource instanceof t.URI)}e.isConfigurationOverrides=L;function A(d){return d&&typeof d=="object"&&(!d.overrideIdentifiers||k.isArray(d.overrideIdentifiers))&&!d.overrideIdentifier&&(!d.resource||d.resource instanceof t.URI)}e.isConfigurationUpdateOverrides=A;var I;(function(d){d[d.USER=1]="USER",d[d.USER_LOCAL=2]="USER_LOCAL",d[d.USER_REMOTE=3]="USER_REMOTE",d[d.WORKSPACE=4]="WORKSPACE",d[d.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",d[d.DEFAULT=6]="DEFAULT",d[d.MEMORY=7]="MEMORY"})(I=e.ConfigurationTarget||(e.ConfigurationTarget={}));function b(d){switch(d){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=b;function P(d,m){const g=Object.create(null);for(const f in d)D(g,f,d[f],m);return g}e.toValuesTree=P;function D(d,m,g,f){const u=m.split("."),r=u.pop();let n=d;for(let i=0;i<u.length;i++){const a=u[i];let c=n[a];switch(typeof c){case"undefined":c=n[a]=Object.create(null);break;case"object":break;default:f(`Ignoring ${m} as ${u.slice(0,i+1).join(".")} is ${JSON.stringify(c)}`);return}n=c}if(typeof n=="object"&&n!==null)try{n[r]=g}catch{f(`Ignoring ${m} as ${u.join(".")} is ${JSON.stringify(n)}`)}else f(`Ignoring ${m} as ${u.join(".")} is ${JSON.stringify(n)}`)}e.addToValueTree=D;function E(d,m){const g=m.split(".");p(d,g)}e.removeFromValueTree=E;function p(d,m){const g=m.shift();if(m.length===0){delete d[g];return}if(Object.keys(d).indexOf(g)!==-1){const f=d[g];typeof f=="object"&&!Array.isArray(f)&&(p(f,m),Object.keys(f).length===0&&delete d[g])}}function C(d,m,g){function f(n,i){let a=n;for(const c of i){if(typeof a!="object"||a===null)return;a=a[c]}return a}const u=m.split("."),r=f(d,u);return typeof r=="undefined"?g:r}e.getConfigurationValue=C;function h(d,m,g){Object.keys(m).forEach(f=>{f!=="__proto__"&&(f in d?k.isObject(d[f])&&k.isObject(m[f])?h(d[f],m[f],g):g&&(d[f]=m[f]):d[f]=m[f])})}e.merge=h;function S(d,m,g){const f=d.inspect(m),u=d.inspect(g);return typeof f.userValue!="undefined"||typeof f.workspaceValue!="undefined"||typeof f.workspaceFolderValue!="undefined"?f.value:typeof u.userValue!="undefined"||typeof u.workspaceValue!="undefined"||typeof u.workspaceFolderValue!="undefined"?u.value:f.defaultValue}e.getMigratedSettingValue=S;function w(d){return d.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=w}),define(re[173],se([0,1,4,26,5]),function(Z,e,k,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const L=new Map;L.set("false",!1),L.set("true",!0),L.set("isMac",k.isMacintosh),L.set("isLinux",k.isLinux),L.set("isWindows",k.isWindows),L.set("isWeb",k.isWeb),L.set("isMacNative",k.isMacintosh&&!k.isWeb),L.set("isEdge",k.isEdge),L.set("isFirefox",k.isFirefox),L.set("isChrome",k.isChrome),L.set("isSafari",k.isSafari);const A=Object.prototype.hasOwnProperty;var I;(function(F){F[F.False=0]="False",F[F.True=1]="True",F[F.Defined=2]="Defined",F[F.Not=3]="Not",F[F.Equals=4]="Equals",F[F.NotEquals=5]="NotEquals",F[F.And=6]="And",F[F.Regex=7]="Regex",F[F.NotRegex=8]="NotRegex",F[F.Or=9]="Or",F[F.In=10]="In",F[F.NotIn=11]="NotIn",F[F.Greater=12]="Greater",F[F.GreaterEquals=13]="GreaterEquals",F[F.Smaller=14]="Smaller",F[F.SmallerEquals=15]="SmallerEquals"})(I=e.ContextKeyExprType||(e.ContextKeyExprType={}));class b{static false(){return E.INSTANCE}static true(){return p.INSTANCE}static has(R){return C.create(R)}static equals(R,U){return h.create(R,U)}static notEquals(R,U){return d.create(R,U)}static regex(R,U){return i.create(R,U)}static in(R,U){return S.create(R,U)}static not(R){return m.create(R)}static and(...R){return s.create(R,null)}static or(...R){return o.create(R,null,!0)}static greater(R,U){return f.create(R,U)}static greaterEquals(R,U){return u.create(R,U)}static smaller(R,U){return r.create(R,U)}static smallerEquals(R,U){return n.create(R,U)}static deserialize(R,U=!1){if(!!R)return this._deserializeOrExpression(R,U)}static _deserializeOrExpression(R,U){const M=R.split("||");return o.create(M.map(V=>this._deserializeAndExpression(V,U)),null,!0)}static _deserializeAndExpression(R,U){const M=R.split("&&");return s.create(M.map(V=>this._deserializeOne(V,U)),null)}static _deserializeOne(R,U){if(R=R.trim(),R.indexOf("!=")>=0){const M=R.split("!=");return d.create(M[0].trim(),this._deserializeValue(M[1],U))}if(R.indexOf("==")>=0){const M=R.split("==");return h.create(M[0].trim(),this._deserializeValue(M[1],U))}if(R.indexOf("=~")>=0){const M=R.split("=~");return i.create(M[0].trim(),this._deserializeRegexValue(M[1],U))}if(R.indexOf(" in ")>=0){const M=R.split(" in ");return S.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(R)){const M=R.split(">=");return u.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(R)){const M=R.split(">");return f.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(R)){const M=R.split("<=");return n.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(R)){const M=R.split("<");return r.create(M[0].trim(),M[1].trim())}return/^\!\s*/.test(R)?m.create(R.substr(1).trim()):C.create(R)}static _deserializeValue(R,U){if(R=R.trim(),R==="true")return!0;if(R==="false")return!1;const M=/^'([^']*)'$/.exec(R);return M?M[1].trim():R}static _deserializeRegexValue(R,U){if((0,t.isFalsyOrWhitespace)(R)){if(U)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}const M=R.indexOf("/"),V=R.lastIndexOf("/");if(M===V||M<0){if(U)throw new Error(`bad regexp-value '${R}', missing /-enclosure`);return console.warn(`bad regexp-value '${R}', missing /-enclosure`),null}const W=R.slice(M+1,V),z=R[V+1]==="i"?"i":"";try{return new RegExp(W,z)}catch(te){if(U)throw new Error(`bad regexp-value '${R}', parse error: ${te}`);return console.warn(`bad regexp-value '${R}', parse error: ${te}`),null}}}e.ContextKeyExpr=b;function P(F,R){const U=F?F.substituteConstants():void 0,M=R?R.substituteConstants():void 0;return!U&&!M?!0:!U||!M?!1:U.equals(M)}e.expressionsAreEqualWithConstantSubstitution=P;function D(F,R){return F.cmp(R)}class E{constructor(){this.type=0}cmp(R){return this.type-R.type}equals(R){return R.type===this.type}substituteConstants(){return this}evaluate(R){return!1}serialize(){return"false"}keys(){return[]}map(R){return this}negate(){return p.INSTANCE}}e.ContextKeyFalseExpr=E,E.INSTANCE=new E;class p{constructor(){this.type=1}cmp(R){return this.type-R.type}equals(R){return R.type===this.type}substituteConstants(){return this}evaluate(R){return!0}serialize(){return"true"}keys(){return[]}map(R){return this}negate(){return E.INSTANCE}}e.ContextKeyTrueExpr=p,p.INSTANCE=new p;class C{constructor(R,U){this.key=R,this.negated=U,this.type=2}static create(R,U=null){const M=L.get(R);return typeof M=="boolean"?M?p.INSTANCE:E.INSTANCE:new C(R,U)}cmp(R){return R.type!==this.type?this.type-R.type:v(this.key,R.key)}equals(R){return R.type===this.type?this.key===R.key:!1}substituteConstants(){const R=L.get(this.key);return typeof R=="boolean"?R?p.INSTANCE:E.INSTANCE:this}evaluate(R){return!!R.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(R){return R.mapDefined(this.key)}negate(){return this.negated||(this.negated=m.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=C;class h{constructor(R,U,M){this.key=R,this.value=U,this.negated=M,this.type=4}static create(R,U,M=null){if(typeof U=="boolean")return U?C.create(R,M):m.create(R,M);const V=L.get(R);return typeof V=="boolean"?U===(V?"true":"false")?p.INSTANCE:E.INSTANCE:new h(R,U,M)}cmp(R){return R.type!==this.type?this.type-R.type:y(this.key,this.value,R.key,R.value)}equals(R){return R.type===this.type?this.key===R.key&&this.value===R.value:!1}substituteConstants(){const R=L.get(this.key);if(typeof R=="boolean"){const U=R?"true":"false";return this.value===U?p.INSTANCE:E.INSTANCE}return this}evaluate(R){return R.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(R){return R.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=d.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=h;class S{constructor(R,U){this.key=R,this.valueKey=U,this.type=10,this.negated=null}static create(R,U){return new S(R,U)}cmp(R){return R.type!==this.type?this.type-R.type:y(this.key,this.valueKey,R.key,R.valueKey)}equals(R){return R.type===this.type?this.key===R.key&&this.valueKey===R.valueKey:!1}substituteConstants(){return this}evaluate(R){const U=R.getValue(this.valueKey),M=R.getValue(this.key);return Array.isArray(U)?U.includes(M):typeof M=="string"&&typeof U=="object"&&U!==null?A.call(U,M):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(R){return R.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=w.create(this)),this.negated}}e.ContextKeyInExpr=S;class w{constructor(R){this._actual=R,this.type=11}static create(R){return new w(R)}cmp(R){return R.type!==this.type?this.type-R.type:this._actual.cmp(R._actual)}equals(R){return R.type===this.type?this._actual.equals(R._actual):!1}substituteConstants(){return this}evaluate(R){return!this._actual.evaluate(R)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(R){return new w(this._actual.map(R))}negate(){return this._actual}}e.ContextKeyNotInExpr=w;class d{constructor(R,U,M){this.key=R,this.value=U,this.negated=M,this.type=5}static create(R,U,M=null){if(typeof U=="boolean")return U?m.create(R,M):C.create(R,M);const V=L.get(R);return typeof V=="boolean"?U===(V?"true":"false")?E.INSTANCE:p.INSTANCE:new d(R,U,M)}cmp(R){return R.type!==this.type?this.type-R.type:y(this.key,this.value,R.key,R.value)}equals(R){return R.type===this.type?this.key===R.key&&this.value===R.value:!1}substituteConstants(){const R=L.get(this.key);if(typeof R=="boolean"){const U=R?"true":"false";return this.value===U?E.INSTANCE:p.INSTANCE}return this}evaluate(R){return R.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(R){return R.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=h.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=d;class m{constructor(R,U){this.key=R,this.negated=U,this.type=3}static create(R,U=null){const M=L.get(R);return typeof M=="boolean"?M?E.INSTANCE:p.INSTANCE:new m(R,U)}cmp(R){return R.type!==this.type?this.type-R.type:v(this.key,R.key)}equals(R){return R.type===this.type?this.key===R.key:!1}substituteConstants(){const R=L.get(this.key);return typeof R=="boolean"?R?E.INSTANCE:p.INSTANCE:this}evaluate(R){return!R.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(R){return R.mapNot(this.key)}negate(){return this.negated||(this.negated=C.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=m;function g(F,R){if(typeof F=="string"){const U=parseFloat(F);isNaN(U)||(F=U)}return typeof F=="string"||typeof F=="number"?R(F):E.INSTANCE}class f{constructor(R,U,M){this.key=R,this.value=U,this.negated=M,this.type=12}static create(R,U,M=null){return g(U,V=>new f(R,V,M))}cmp(R){return R.type!==this.type?this.type-R.type:y(this.key,this.value,R.key,R.value)}equals(R){return R.type===this.type?this.key===R.key&&this.value===R.value:!1}substituteConstants(){return this}evaluate(R){return typeof this.value=="string"?!1:parseFloat(R.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(R){return R.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=n.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=f;class u{constructor(R,U,M){this.key=R,this.value=U,this.negated=M,this.type=13}static create(R,U,M=null){return g(U,V=>new u(R,V,M))}cmp(R){return R.type!==this.type?this.type-R.type:y(this.key,this.value,R.key,R.value)}equals(R){return R.type===this.type?this.key===R.key&&this.value===R.value:!1}substituteConstants(){return this}evaluate(R){return typeof this.value=="string"?!1:parseFloat(R.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(R){return R.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=r.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=u;class r{constructor(R,U,M){this.key=R,this.value=U,this.negated=M,this.type=14}static create(R,U,M=null){return g(U,V=>new r(R,V,M))}cmp(R){return R.type!==this.type?this.type-R.type:y(this.key,this.value,R.key,R.value)}equals(R){return R.type===this.type?this.key===R.key&&this.value===R.value:!1}substituteConstants(){return this}evaluate(R){return typeof this.value=="string"?!1:parseFloat(R.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(R){return R.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=u.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=r;class n{constructor(R,U,M){this.key=R,this.value=U,this.negated=M,this.type=15}static create(R,U,M=null){return g(U,V=>new n(R,V,M))}cmp(R){return R.type!==this.type?this.type-R.type:y(this.key,this.value,R.key,R.value)}equals(R){return R.type===this.type?this.key===R.key&&this.value===R.value:!1}substituteConstants(){return this}evaluate(R){return typeof this.value=="string"?!1:parseFloat(R.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(R){return R.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=f.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=n;class i{constructor(R,U){this.key=R,this.regexp=U,this.type=7,this.negated=null}static create(R,U){return new i(R,U)}cmp(R){if(R.type!==this.type)return this.type-R.type;if(this.key<R.key)return-1;if(this.key>R.key)return 1;const U=this.regexp?this.regexp.source:"",M=R.regexp?R.regexp.source:"";return U<M?-1:U>M?1:0}equals(R){if(R.type===this.type){const U=this.regexp?this.regexp.source:"",M=R.regexp?R.regexp.source:"";return this.key===R.key&&U===M}return!1}substituteConstants(){return this}evaluate(R){const U=R.getValue(this.key);return this.regexp?this.regexp.test(U):!1}serialize(){const R=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${R}`}keys(){return[this.key]}map(R){return R.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=a.create(this)),this.negated}}e.ContextKeyRegexExpr=i;class a{constructor(R){this._actual=R,this.type=8}static create(R){return new a(R)}cmp(R){return R.type!==this.type?this.type-R.type:this._actual.cmp(R._actual)}equals(R){return R.type===this.type?this._actual.equals(R._actual):!1}substituteConstants(){return this}evaluate(R){return!this._actual.evaluate(R)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(R){return new a(this._actual.map(R))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=a;function c(F){let R=null;for(let U=0,M=F.length;U<M;U++){const V=F[U].substituteConstants();if(F[U]!==V&&R===null){R=[];for(let W=0;W<U;W++)R[W]=F[W]}R!==null&&(R[U]=V)}return R===null?F:R}class s{constructor(R,U){this.expr=R,this.negated=U,this.type=6}static create(R,U){return s._normalizeArr(R,U)}cmp(R){if(R.type!==this.type)return this.type-R.type;if(this.expr.length<R.expr.length)return-1;if(this.expr.length>R.expr.length)return 1;for(let U=0,M=this.expr.length;U<M;U++){const V=D(this.expr[U],R.expr[U]);if(V!==0)return V}return 0}equals(R){if(R.type===this.type){if(this.expr.length!==R.expr.length)return!1;for(let U=0,M=this.expr.length;U<M;U++)if(!this.expr[U].equals(R.expr[U]))return!1;return!0}return!1}substituteConstants(){const R=c(this.expr);return R===this.expr?this:s.create(R,this.negated)}evaluate(R){for(let U=0,M=this.expr.length;U<M;U++)if(!this.expr[U].evaluate(R))return!1;return!0}static _normalizeArr(R,U){const M=[];let V=!1;for(const W of R)if(!!W){if(W.type===1){V=!0;continue}if(W.type===0)return E.INSTANCE;if(W.type===6){M.push(...W.expr);continue}M.push(W)}if(M.length===0&&V)return p.INSTANCE;if(M.length!==0){if(M.length===1)return M[0];M.sort(D);for(let W=1;W<M.length;W++)M[W-1].equals(M[W])&&(M.splice(W,1),W--);if(M.length===1)return M[0];for(;M.length>1;){const W=M[M.length-1];if(W.type!==9)break;M.pop();const z=M.pop(),te=M.length===0,H=o.create(W.expr.map(K=>s.create([K,z],null)),null,te);H&&(M.push(H),M.sort(D))}return M.length===1?M[0]:new s(M,U)}}serialize(){return this.expr.map(R=>R.serialize()).join(" && ")}keys(){const R=[];for(const U of this.expr)R.push(...U.keys());return R}map(R){return new s(this.expr.map(U=>U.map(R)),null)}negate(){if(!this.negated){const R=[];for(const U of this.expr)R.push(U.negate());this.negated=o.create(R,this,!0)}return this.negated}}class o{constructor(R,U){this.expr=R,this.negated=U,this.type=9}static create(R,U,M){return o._normalizeArr(R,U,M)}cmp(R){if(R.type!==this.type)return this.type-R.type;if(this.expr.length<R.expr.length)return-1;if(this.expr.length>R.expr.length)return 1;for(let U=0,M=this.expr.length;U<M;U++){const V=D(this.expr[U],R.expr[U]);if(V!==0)return V}return 0}equals(R){if(R.type===this.type){if(this.expr.length!==R.expr.length)return!1;for(let U=0,M=this.expr.length;U<M;U++)if(!this.expr[U].equals(R.expr[U]))return!1;return!0}return!1}substituteConstants(){const R=c(this.expr);return R===this.expr?this:o.create(R,this.negated,!1)}evaluate(R){for(let U=0,M=this.expr.length;U<M;U++)if(this.expr[U].evaluate(R))return!0;return!1}static _normalizeArr(R,U,M){let V=[],W=!1;if(R){for(let z=0,te=R.length;z<te;z++){const H=R[z];if(!!H){if(H.type===0){W=!0;continue}if(H.type===1)return p.INSTANCE;if(H.type===9){V=V.concat(H.expr);continue}V.push(H)}}if(V.length===0&&W)return E.INSTANCE;V.sort(D)}if(V.length!==0){if(V.length===1)return V[0];for(let z=1;z<V.length;z++)V[z-1].equals(V[z])&&(V.splice(z,1),z--);if(V.length===1)return V[0];if(M){for(let z=0;z<V.length;z++)for(let te=z+1;te<V.length;te++)O(V[z],V[te])&&(V.splice(te,1),te--);if(V.length===1)return V[0]}return new o(V,U)}}serialize(){return this.expr.map(R=>R.serialize()).join(" || ")}keys(){const R=[];for(const U of this.expr)R.push(...U.keys());return R}map(R){return new o(this.expr.map(U=>U.map(R)),null)}negate(){if(!this.negated){const R=[];for(const U of this.expr)R.push(U.negate());for(;R.length>1;){const U=R.shift(),M=R.shift(),V=[];for(const z of _(U))for(const te of _(M))V.push(s.create([z,te],null));const W=R.length===0;R.unshift(o.create(V,null,W))}this.negated=R[0]}return this.negated}}class l extends C{constructor(R,U,M){super(R,null);this._defaultValue=U,typeof M=="object"?l._info.push({...M,key:R}):M!==!0&&l._info.push({key:R,description:M,type:U!=null?typeof U:void 0})}static all(){return l._info.values()}bindTo(R){return R.createKey(this.key,this._defaultValue)}getValue(R){return R.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(R){return h.create(this.key,R)}notEqualsTo(R){return d.create(this.key,R)}}e.RawContextKey=l,l._info=[],e.IContextKeyService=(0,T.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function v(F,R){return F<R?-1:F>R?1:0}function y(F,R,U,M){return F<U?-1:F>U?1:R<M?-1:R>M?1:0}function O(F,R){if(R.type===6&&F.type!==9&&F.type!==6){for(const V of R.expr)if(F.equals(V))return!0}const U=F.negate(),M=_(U).concat(_(R));M.sort(D);for(let V=0;V<M.length;V++){const z=M[V].negate();for(let te=V+1;te<M.length;te++){const H=M[te];if(z.equals(H))return!0}}return!1}e.implies=O;function _(F){return F.type===9?F.expr:[F]}}),define(re[90],se([0,1,5]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,k.createDecorator)(e.ID);function t(L){return!!L.hostName&&!!L.errorMessage}e.isRemoteDiagnosticError=t;class T{async getPerformanceInfo(A,I){return{}}async getSystemInfo(A,I){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(A,I){return""}async getWorkspaceFileExtensions(A){return{extensions:[]}}async reportWorkspaceStats(A){}}e.NullDiagnosticsService=T}),define(re[91],se([0,1,5]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,k.createDecorator)("downloadService")}),define(re[15],se([0,1,5]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,k.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,k.refineServiceDecorator)(e.IEnvironmentService)}),define(re[30],se([0,1,142,5]),function(Z,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IServerExtensionManagementService=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function T(d){switch(d){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=T;function L(d){switch(d){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=L;function A(d,m){switch(d){case 3:return m==="x64"?"win32-x64":m==="ia32"?"win32-ia32":m==="arm64"?"win32-arm64":"unknown";case 2:return m==="x64"?"linux-x64":m==="arm64"?"linux-arm64":m==="arm"?"linux-armhf":"unknown";case"alpine":return m==="x64"?"alpine-x64":m==="arm64"?"alpine-arm64":"unknown";case 1:return m==="x64"?"darwin-x64":m==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=A;function I(d,m){return m==="web"&&!d.includes("web")}e.isNotWebExtensionInWebTargetPlatform=I;function b(d,m,g){return I(m,g)?!1:d==="undefined"||d==="universal"?!0:d==="unknown"?!1:d===g?!0:P(g).includes(d)}e.isTargetPlatformCompatible=b;function P(d){switch(d){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=P;function D(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(!d.uuid||typeof d.uuid=="string")}e.isIExtensionIdentifier=D;var E;(function(d){d[d.NoneOrRelevance=0]="NoneOrRelevance",d[d.LastUpdatedDate=1]="LastUpdatedDate",d[d.Title=2]="Title",d[d.PublisherName=3]="PublisherName",d[d.InstallCount=4]="InstallCount",d[d.PublishedDate=10]="PublishedDate",d[d.AverageRating=6]="AverageRating",d[d.WeightedRating=12]="WeightedRating"})(E=e.SortBy||(e.SortBy={}));var p;(function(d){d[d.Default=0]="Default",d[d.Ascending=1]="Ascending",d[d.Descending=2]="Descending"})(p=e.SortOrder||(e.SortOrder={}));var C;(function(d){d.Install="install",d.Uninstall="uninstall"})(C=e.StatisticType||(e.StatisticType={}));var h;(function(d){d[d.None=1]="None",d[d.Install=2]="Install",d[d.Update=3]="Update",d[d.Migrate=4]="Migrate"})(h=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,t.createDecorator)("extensionGalleryService");var S;(function(d){d.Unsupported="Unsupported",d.Deprecated="Deprecated",d.Malicious="Malicious",d.Incompatible="Incompatible",d.IncompatiblePreRelease="IncompatiblePreRelease",d.IncompatibleTargetPlatform="IncompatibleTargetPlatform",d.ReleaseVersionNotFound="ReleaseVersionNotFound",d.Invalid="Invalid",d.Download="Download",d.Extract="Extract",d.Delete="Delete",d.Rename="Rename",d.CorruptZip="CorruptZip",d.IncompleteZip="IncompleteZip",d.Internal="Internal"})(S=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class w extends Error{constructor(m,g){super(m);this.code=g,this.name=g}}e.ExtensionManagementError=w,e.IExtensionManagementService=(0,t.createDecorator)("extensionManagementService"),e.IServerExtensionManagementService=(0,t.refineServiceDecorator)(e.IExtensionManagementService),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,t.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,t.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,k.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,k.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,t.createDecorator)("IExtensionManagementCLIService")}),define(re[174],se([0,1,3,2,64,29,8,129,30]),function(Z,e,k,t,T,L,A,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function P(w,d){return A.URI.revive(d?d.transformIncoming(w):w)}function D(w,d){return d?d.transformOutgoingURI(w):w}function E(w,d){d=d||I.DefaultURITransformer;const m=w.manifest;return{...(0,I.transformAndReviveIncomingURIs)({...w,manifest:void 0},d),manifest:m}}function p(w,d){return d?(0,L.cloneAndChange)(w,m=>m instanceof A.URI?d.transformOutgoingURI(m):void 0):w}class C{constructor(d,m){this.service=d,this.getUriTransformer=m,this.onInstallExtension=k.Event.buffer(d.onInstallExtension,!0),this.onDidInstallExtensions=k.Event.buffer(d.onDidInstallExtensions,!0),this.onUninstallExtension=k.Event.buffer(d.onUninstallExtension,!0),this.onDidUninstallExtension=k.Event.buffer(d.onDidUninstallExtension,!0)}listen(d,m){const g=this.getUriTransformer(d);switch(m){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtensions":return k.Event.map(this.onDidInstallExtensions,f=>f.map(u=>({...u,local:u.local?p(u.local,g):u.local})));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(d,m,g){const f=this.getUriTransformer(d);switch(m){case"zip":return this.service.zip(E(g[0],f)).then(u=>D(u,f));case"unzip":return this.service.unzip(P(g[0],f));case"install":return this.service.install(P(g[0],f),(0,T.revive)(g[1]));case"getManifest":return this.service.getManifest(P(g[0],f));case"getTargetPlatform":return this.service.getTargetPlatform();case"canInstall":return this.service.canInstall(g[0]);case"installFromGallery":return this.service.installFromGallery(g[0],(0,T.revive)(g[1]));case"uninstall":return this.service.uninstall(E(g[0],f),(0,T.revive)(g[1]));case"reinstallFromGallery":return this.service.reinstallFromGallery(E(g[0],f));case"getInstalled":return this.service.getInstalled(g[0],A.URI.revive(g[1])).then(u=>u.map(r=>p(r,f)));case"getMetadata":return this.service.getMetadata(E(g[0],f));case"updateMetadata":return this.service.updateMetadata(E(g[0],f),g[1]).then(u=>p(u,f));case"updateExtensionScope":return this.service.updateExtensionScope(E(g[0],f),g[1]).then(u=>p(u,f));case"getExtensionsControlManifest":return this.service.getExtensionsControlManifest()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=C;class h extends t.Disposable{constructor(d){super();this.channel=d,this._onInstallExtension=this._register(new k.Emitter),this._onDidInstallExtensions=this._register(new k.Emitter),this._onUninstallExtension=this._register(new k.Emitter),this._onDidUninstallExtension=this._register(new k.Emitter),this._register(this.channel.listen("onInstallExtension")(m=>this._onInstallExtension.fire({identifier:m.identifier,source:this.isUriComponents(m.source)?A.URI.revive(m.source):m.source,profileLocation:A.URI.revive(m.profileLocation)}))),this._register(this.channel.listen("onDidInstallExtensions")(m=>this._onDidInstallExtensions.fire(m.map(g=>({...g,local:g.local?E(g.local,null):g.local,source:this.isUriComponents(g.source)?A.URI.revive(g.source):g.source,profileLocation:A.URI.revive(g.profileLocation)}))))),this._register(this.channel.listen("onUninstallExtension")(m=>this._onUninstallExtension.fire({identifier:m.identifier,profileLocation:A.URI.revive(m.profileLocation)}))),this._register(this.channel.listen("onDidUninstallExtension")(m=>this._onDidUninstallExtension.fire({...m,profileLocation:A.URI.revive(m.profileLocation)})))}get onInstallExtension(){return this._onInstallExtension.event}get onDidInstallExtensions(){return this._onDidInstallExtensions.event}get onUninstallExtension(){return this._onUninstallExtension.event}get onDidUninstallExtension(){return this._onDidUninstallExtension.event}isUriComponents(d){return d?typeof d.path=="string"&&typeof d.scheme=="string":!1}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=this.channel.call("getTargetPlatform")),this._targetPlatformPromise}async canInstall(d){const m=await this.getTargetPlatform();return d.allTargetPlatforms.some(g=>(0,b.isTargetPlatformCompatible)(g,d.allTargetPlatforms,m))}zip(d){return Promise.resolve(this.channel.call("zip",[d]).then(m=>A.URI.revive(m)))}unzip(d){return Promise.resolve(this.channel.call("unzip",[d]))}install(d,m){return Promise.resolve(this.channel.call("install",[d,m])).then(g=>E(g,null))}getManifest(d){return Promise.resolve(this.channel.call("getManifest",[d]))}installFromGallery(d,m){return Promise.resolve(this.channel.call("installFromGallery",[d,m])).then(g=>E(g,null))}uninstall(d,m){return Promise.resolve(this.channel.call("uninstall",[d,m]))}reinstallFromGallery(d){return Promise.resolve(this.channel.call("reinstallFromGallery",[d]))}getInstalled(d=null,m){return Promise.resolve(this.channel.call("getInstalled",[d,m])).then(g=>g.map(f=>E(f,null)))}getMetadata(d){return Promise.resolve(this.channel.call("getMetadata",[d]))}updateMetadata(d,m){return Promise.resolve(this.channel.call("updateMetadata",[d,m])).then(g=>E(g,null))}updateExtensionScope(d,m){return Promise.resolve(this.channel.call("updateExtensionScope",[d,m])).then(g=>E(g,null))}getExtensionsControlManifest(){return Promise.resolve(this.channel.call("getExtensionsControlManifest"))}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=h;class S{constructor(d){this.service=d}listen(d,m){throw new Error("Invalid listen")}call(d,m,g){switch(m){case"getConfigBasedTips":return this.service.getConfigBasedTips(A.URI.revive(g[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=S}),define(re[92],se([0,1,5]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var t;(function(A){A[A.FILE=1]="FILE",A[A.WORKSPACE=2]="WORKSPACE",A[A.EXE=3]="EXE"})(t=e.RecommendationSource||(e.RecommendationSource={}));function T(A){switch(A){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=T;var L;(function(A){A.Ignored="ignored",A.Cancelled="cancelled",A.TooMany="toomany",A.IncompatibleWindow="incompatibleWindow",A.Accepted="reacted"})(L=e.RecommendationsNotificationResult||(e.RecommendationsNotificationResult={})),e.IExtensionRecommendationNotificationService=(0,k.createDecorator)("IExtensionRecommendationNotificationService")}),define(re[13],se([0,1,38,12,26,14,8,149,5]),function(Z,e,k,t,T,L,A,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,b.createDecorator)("fileService");function P(z){return z.create===!0}e.isFileOpenForWriteOptions=P;var D;(function(z){z[z.Unknown=0]="Unknown",z[z.File=1]="File",z[z.Directory=2]="Directory",z[z.SymbolicLink=64]="SymbolicLink"})(D=e.FileType||(e.FileType={}));var E;(function(z){z[z.Readonly=1]="Readonly"})(E=e.FilePermission||(e.FilePermission={}));var p;(function(z){z[z.FileReadWrite=2]="FileReadWrite",z[z.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",z[z.FileReadStream=16]="FileReadStream",z[z.FileFolderCopy=8]="FileFolderCopy",z[z.PathCaseSensitive=1024]="PathCaseSensitive",z[z.Readonly=2048]="Readonly",z[z.Trash=4096]="Trash",z[z.FileWriteUnlock=8192]="FileWriteUnlock",z[z.FileAtomicRead=16384]="FileAtomicRead",z[z.FileClone=32768]="FileClone"})(p=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function C(z){return!!(z.capabilities&2)}e.hasReadWriteCapability=C;function h(z){return!!(z.capabilities&8)}e.hasFileFolderCopyCapability=h;function S(z){return!!(z.capabilities&32768)}e.hasFileCloneCapability=S;function w(z){return!!(z.capabilities&4)}e.hasOpenReadWriteCloseCapability=w;function d(z){return!!(z.capabilities&16)}e.hasFileReadStreamCapability=d;function m(z){return C(z)?!!(z.capabilities&16384):!1}e.hasFileAtomicReadCapability=m;var g;(function(z){z.FileExists="EntryExists",z.FileNotFound="EntryNotFound",z.FileNotADirectory="EntryNotADirectory",z.FileIsADirectory="EntryIsADirectory",z.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",z.FileTooLarge="EntryTooLarge",z.FileWriteLocked="EntryWriteLocked",z.NoPermissions="NoPermissions",z.Unavailable="Unavailable",z.Unknown="Unknown"})(g=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class f extends Error{constructor(te,H){super(te);this.code=H}}e.FileSystemProviderError=f;function u(z,te){const H=new f(z.toString(),te);return n(H,te),H}e.createFileSystemProviderError=u;function r(z){return z||u((0,I.localize)(0,null),g.Unknown)}e.ensureFileSystemProviderError=r;function n(z,te){return z.name=te?`${te} (FileSystemError)`:"FileSystemError",z}e.markAsFileSystemProviderError=n;function i(z){if(!z)return g.Unknown;if(z instanceof f)return z.code;const te=/^(.+) \(FileSystemError\)$/.exec(z.name);if(!te)return g.Unknown;switch(te[1]){case g.FileExists:return g.FileExists;case g.FileIsADirectory:return g.FileIsADirectory;case g.FileNotADirectory:return g.FileNotADirectory;case g.FileNotFound:return g.FileNotFound;case g.FileExceedsMemoryLimit:return g.FileExceedsMemoryLimit;case g.FileTooLarge:return g.FileTooLarge;case g.FileWriteLocked:return g.FileWriteLocked;case g.NoPermissions:return g.NoPermissions;case g.Unavailable:return g.Unavailable}return g.Unknown}e.toFileSystemProviderErrorCode=i;function a(z){if(z instanceof y)return z.fileOperationResult;switch(i(z)){case g.FileNotFound:return 1;case g.FileIsADirectory:return 0;case g.FileNotADirectory:return 10;case g.FileWriteLocked:return 5;case g.NoPermissions:return 6;case g.FileExists:return 4;case g.FileExceedsMemoryLimit:return 9;case g.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=a;var c;(function(z){z[z.CREATE=0]="CREATE",z[z.DELETE=1]="DELETE",z[z.MOVE=2]="MOVE",z[z.COPY=3]="COPY",z[z.WRITE=4]="WRITE"})(c=e.FileOperation||(e.FileOperation={}));class s{constructor(te,H,K){this.resource=te,this.operation=H,this.target=K}isOperation(te){return this.operation===te}}e.FileOperationEvent=s;var o;(function(z){z[z.UPDATED=0]="UPDATED",z[z.ADDED=1]="ADDED",z[z.DELETED=2]="DELETED"})(o=e.FileChangeType||(e.FileChangeType={}));class l{constructor(te,H){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=te;const K=new Map;for(const X of te){const Y=K.get(X.type);switch(Y?Y.push([X.resource,X]):K.set(X.type,[[X.resource,X]]),X.type){case 1:this.rawAdded.push(X.resource);break;case 0:this.rawUpdated.push(X.resource);break;case 2:this.rawDeleted.push(X.resource);break}}for(const[X,Y]of K)switch(X){case 1:this.added=k.TernarySearchTree.forUris(()=>H),this.added.fill(Y);break;case 0:this.updated=k.TernarySearchTree.forUris(()=>H),this.updated.fill(Y);break;case 2:this.deleted=k.TernarySearchTree.forUris(()=>H),this.deleted.fill(Y);break}}contains(te,...H){return this.doContains(te,{includeChildren:!1},...H)}affects(te,...H){return this.doContains(te,{includeChildren:!0},...H)}doContains(te,H,...K){if(!te)return!1;const X=K.length>0;return!!((!X||K.includes(1))&&(this.added?.get(te)||H.includeChildren&&this.added?.findSuperstr(te))||(!X||K.includes(0))&&(this.updated?.get(te)||H.includeChildren&&this.updated?.findSuperstr(te))||(!X||K.includes(2))&&(this.deleted?.findSubstr(te)||H.includeChildren&&this.deleted?.findSuperstr(te)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=l;function v(z,te,H){return!z||!te||z===te||te.length>z.length?!1:(te.charAt(te.length-1)!==t.sep&&(te+=t.sep),H?(0,T.startsWithIgnoreCase)(z,te):z.indexOf(te)===0)}e.isParent=v;class y extends Error{constructor(te,H,K){super(te);this.fileOperationResult=H,this.options=K}}e.FileOperationError=y;class O extends y{constructor(te,H,K){super(te,2,K);this.stat=H}}e.NotModifiedSinceFileOperationError=O;var _;(function(z){z[z.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",z[z.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",z[z.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",z[z.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",z[z.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",z[z.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",z[z.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",z[z.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",z[z.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",z[z.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",z[z.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",z[z.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(_=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var F;(function(z){z[z.FILE=0]="FILE",z[z.FOLDER=1]="FOLDER",z[z.ROOT_FOLDER=2]="ROOT_FOLDER"})(F=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function R(z){if(!(typeof z.size!="number"||typeof z.mtime!="number"))return z.mtime.toString(29)+z.size.toString(31)}e.etag=R;async function U(z,te){if(!te.hasProvider(A.URI.from({scheme:z.scheme})))return new Promise(H=>{const K=te.onDidChangeFileSystemProviderRegistrations(X=>{X.scheme===z.scheme&&X.added&&(K.dispose(),H())})})}e.whenProviderRegistered=U,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class M{static formatSize(te){return(0,L.isNumber)(te)||(te=0),te<M.KB?(0,I.localize)(1,null,te.toFixed(0)):te<M.MB?(0,I.localize)(2,null,(te/M.KB).toFixed(2)):te<M.GB?(0,I.localize)(3,null,(te/M.MB).toFixed(2)):te<M.TB?(0,I.localize)(4,null,(te/M.GB).toFixed(2)):(0,I.localize)(5,null,(te/M.TB).toFixed(2))}}e.ByteSize=M,M.KB=1024,M.MB=M.KB*M.KB,M.GB=M.MB*M.KB,M.TB=M.GB*M.KB;var V;(function(z){z[z.IA32=0]="IA32",z[z.OTHER=1]="OTHER"})(V=e.Arch||(e.Arch={}));function W(z){return{maxFileSize:z===0?300*M.MB:16*M.GB,maxHeapSize:z===0?700*M.MB:2*700*M.MB}}e.getPlatformLimits=W});var Q=this&&this.__param||function(Z,e){return function(k,t){e(k,t,Z)}};define(re[175],se([0,1,93,41,13]),function(Z,e,k,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let L=class{constructor(I){this.fileService=I}async checksum(I){const b=(await this.fileService.readFileStream(I)).value;return new Promise((P,D)=>{const E=(0,k.createHash)("md5");(0,t.listenStream)(b,{onData:p=>E.update(p.buffer),onError:p=>D(p),onEnd:()=>P(E.digest("base64").replace(/=+$/,""))})})}};L=me([Q(0,T.IFileService)],L),e.ChecksumService=L}),define(re[176],se([0,1,16,37,9,3,2,41,8,31,13]),function(Z,e,k,t,T,L,A,I,b,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class E extends A.Disposable{constructor(C,h){super();this.channel=C,this.extraCapabilities=h,this.onDidChangeCapabilities=L.Event.None,this._onDidChange=this._register(new L.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new L.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,P.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384|32768,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(C){return this.channel.call("stat",[C])}readdir(C){return this.channel.call("readdir",[C])}async readFile(C,h){const{buffer:S}=await this.channel.call("readFile",[C,h]);return S}readFileStream(C,h,S){const w=(0,I.newWriteableStream)(m=>k.VSBuffer.concat(m.map(g=>k.VSBuffer.wrap(g))).buffer),d=this.channel.listen("readFileStream",[C,h])(m=>{if(m instanceof k.VSBuffer)w.write(m.buffer);else{if(m==="end")w.end();else{let g=m;g instanceof Error||(g=(0,D.createFileSystemProviderError)((0,t.toErrorMessage)(g),D.FileSystemProviderErrorCode.Unknown)),w.error(g),w.end()}d.dispose()}});return S.onCancellationRequested(()=>{w.error((0,T.canceled)()),w.end(),d.dispose()}),w}writeFile(C,h,S){return this.channel.call("writeFile",[C,k.VSBuffer.wrap(h),S])}open(C,h){return this.channel.call("open",[C,h])}close(C){return this.channel.call("close",[C])}async read(C,h,S,w,d){const[m,g]=await this.channel.call("read",[C,h,d]);return S.set(m.buffer.slice(0,g),w),g}write(C,h,S,w,d){return this.channel.call("write",[C,h,k.VSBuffer.wrap(S),w,d])}mkdir(C){return this.channel.call("mkdir",[C])}delete(C,h){return this.channel.call("delete",[C,h])}rename(C,h,S){return this.channel.call("rename",[C,h,S])}copy(C,h,S){return this.channel.call("copy",[C,h,S])}cloneFile(C,h){return this.channel.call("cloneFile",[C,h])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(C=>{if(Array.isArray(C)){const h=C;this._onDidChange.fire(h.map(S=>({resource:b.URI.revive(S.resource),type:S.type})))}else{const h=C;this._onDidWatchError.fire(h)}}))}watch(C,h){const S=(0,P.generateUuid)();return this.channel.call("watch",[this.sessionId,S,C,h]),(0,A.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,S]))}}e.DiskFileSystemProviderClient=E}),define(re[94],se([0,1,16,9,150,13]),function(Z,e,k,t,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function A(D,E,p,C,h,S){let w;try{await I(D,E,p,C,h,S)}catch(d){w=d}finally{w&&h.errorTransformer&&(w=h.errorTransformer(w)),typeof w!="undefined"&&p.error(w),p.end()}}e.readFileIntoStream=A;async function I(D,E,p,C,h,S){b(S);const w=await D.open(E,{create:!1});try{b(S);let d=0,m=0,g=h&&typeof h.length=="number"?h.length:void 0,f=k.VSBuffer.alloc(Math.min(h.bufferSize,typeof g=="number"?g:h.bufferSize)),u=h&&typeof h.position=="number"?h.position:0,r=0;do m=await D.read(w,u,f.buffer,r,f.byteLength-r),u+=m,r+=m,d+=m,typeof g=="number"&&(g-=m),r===f.byteLength&&(await p.write(C(f)),f=k.VSBuffer.alloc(Math.min(h.bufferSize,typeof g=="number"?g:h.bufferSize)),r=0);while(m>0&&(typeof g!="number"||g>0)&&b(S)&&P(d,h));if(r>0){let n=r;typeof g=="number"&&(n=Math.min(r,g)),p.write(C(f.slice(0,n)))}}catch(d){throw(0,L.ensureFileSystemProviderError)(d)}finally{await D.close(w)}}function b(D){if(D.isCancellationRequested)throw(0,t.canceled)();return!0}function P(D,E){if(E?.limits){if(typeof E.limits.memory=="number"&&D>E.limits.memory)throw(0,L.createFileSystemProviderError)((0,T.localize)(0,null),L.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof E.limits.size=="number"&&D>E.limits.size)throw(0,L.createFileSystemProviderError)((0,T.localize)(1,null),L.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(re[57],se([0,1,82,2,12,4,8,13]),function(Z,e,k,t,T,L,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function b(d){return d.recursive===!0}e.isRecursiveWatchRequest=b;class P extends t.Disposable{constructor(m,g,f,u){super();this.onFileChanges=m,this.onLogMessage=g,this.verboseLogging=f,this.options=u,this.watcherDisposables=this._register(new t.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const m=new t.DisposableStore;this.watcherDisposables.value=m,this.watcher=this.createWatcher(m),this.watcher.setVerboseLogging(this.verboseLogging),m.add(this.watcher.onDidChangeFile(g=>this.onFileChanges(g))),m.add(this.watcher.onDidLogMessage(g=>this.onLogMessage(g))),m.add(this.watcher.onDidError(g=>this.onError(g)))}onError(m){this.options.restartOnError?this.restartCounter<P.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${m}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${m}`):this.error(m)}restart(m){this.restartCounter++,this.init(),this.watch(m)}async watch(m){this.requests=m,await this.watcher?.watch(m)}async setVerboseLogging(m){this.verboseLogging=m,await this.watcher?.setVerboseLogging(m)}error(m){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${m}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=P,P.MAX_RESTARTS=5;class D extends P{constructor(m,g,f){super(m,g,f,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=D;class E extends P{constructor(m,g,f){super(m,g,f,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=E;function p(d){return d.map(m=>({type:m.type,resource:A.URI.file(m.path)}))}e.toFileChanges=p;function C(d){const m=new w;for(const g of d)m.processEvent(g);return m.coalesce()}e.coalesceEvents=C;function h(d,m){return typeof m=="string"&&!m.startsWith(k.GLOBSTAR)&&!(0,T.isAbsolute)(m)?{base:d,pattern:m}:m}e.normalizeWatcherPattern=h;function S(d,m){const g=[];for(const f of m)g.push((0,k.parse)(h(d,f)));return g}e.parseWatcherPatterns=S;class w{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(m){return L.isLinux?m.path:m.path.toLowerCase()}processEvent(m){const g=this.mapPathToChange.get(this.toKey(m));let f=!1;if(g){const u=g.type,r=m.type;g.path!==m.path&&(m.type===2||m.type===1)?f=!0:u===1&&r===2?(this.mapPathToChange.delete(this.toKey(m)),this.coalesced.delete(g)):u===2&&r===1?g.type=0:u===1&&r===0||(g.type=r)}else f=!0;f&&(this.coalesced.add(m),this.mapPathToChange.set(this.toKey(m),m))}coalesce(){const m=[],g=[];return Array.from(this.coalesced).filter(f=>f.type!==2?(m.push(f),!1):!0).sort((f,u)=>f.path.length-u.path.length).filter(f=>g.some(u=>(0,I.isParent)(f.path,u,!L.isLinux))?!1:(g.push(f.path),!0)).concat(m)}}}),define(re[177],se([0,1,54,6,23,42,2,80,12,4,131,27,57]),function(Z,e,k,t,T,L,A,I,b,P,D,E,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class C extends A.Disposable{constructor(w,d,m,g){super();this.request=w,this.onDidFilesChange=d,this.onLogMessage=m,this.verboseLogging=g,this.throttledFileChangesWorker=new t.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},f=>this.onDidFilesChange(f)),this.fileChangesDelayer=this._register(new t.ThrottledDelayer(C.FILE_CHANGES_HANDLER_DELAY)),this.fileChangesBuffer=[],this.excludes=(0,p.parseWatcherPatterns)(this.request.path,this.request.excludes),this.includes=this.request.includes?(0,p.parseWatcherPatterns)(this.request.path,this.request.includes):void 0,this.cts=new T.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const w=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const d=await E.Promises.stat(w);this._register(await this.doWatch(w,d.isDirectory()))}catch(w){w.code!=="ENOENT"?this.error(w):this.trace(w)}}async normalizePath(w){let d=w.path;try{d=await E.Promises.realpath(w.path),w.path===d&&(d=await(0,D.realcase)(w.path)??w.path),w.path!==d&&this.trace(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${w.path}, real: ${d})`)}catch{}return d}async doWatch(w,d){if(P.isMacintosh&&(0,L.isEqualOrParent)(w,"/Volumes/",!0))return this.error(`Refusing to watch ${w} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),A.Disposable.None;const m=new T.CancellationTokenSource(this.cts.token),g=new A.DisposableStore;try{const f=(0,b.basename)(w),u=(0,k.watch)(w);g.add((0,A.toDisposable)(()=>{u.removeAllListeners(),u.close()})),this.trace(`Started watching: '${w}'`);const r=new Set;if(d)try{for(const i of await E.Promises.readdir(w))r.add(i)}catch(i){this.error(i)}const n=new Map;g.add((0,A.toDisposable)(()=>{for(const[,i]of n)i.dispose();n.clear()})),u.on("error",(i,a)=>{this.error(`Failed to watch ${w} for changes using fs.watch() (${i}, ${a})`),this.dispose()}),u.on("change",(i,a)=>{if(m.token.isCancellationRequested)return;this.trace(`[raw] ["${i}"] ${a}`);let c="";if(a&&(c=a.toString(),P.isMacintosh&&(c=(0,I.normalizeNFC)(c))),!(!c||i!=="change"&&i!=="rename"))if(d)if(i==="rename"){n.get(c)?.dispose();const s=setTimeout(async()=>{if(n.delete(c),c===f&&!await E.Promises.exists(w)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const o=await this.existsChildStrictCase((0,b.join)(w,c));if(m.token.isCancellationRequested)return;let l;o?r.has(c)?l=0:(l=1,r.add(c)):(r.delete(c),l=2),this.onFileChange({path:(0,b.join)(this.request.path,c),type:l})},C.FILE_DELETE_HANDLER_DELAY);n.set(c,(0,A.toDisposable)(()=>clearTimeout(s)))}else{let s;r.has(c)?s=0:(s=1,r.add(c)),this.onFileChange({path:(0,b.join)(this.request.path,c),type:s})}else if(i==="rename"||c!==f){const s=setTimeout(async()=>{const o=await E.Promises.exists(w);m.token.isCancellationRequested||(o?(this.onFileChange({path:this.request.path,type:0},!0),g.add(await this.doWatch(w,!1))):(await this.onFileChange({path:this.request.path,type:2},!0),this.dispose()))},C.FILE_DELETE_HANDLER_DELAY);g.clear(),g.add((0,A.toDisposable)(()=>clearTimeout(s)))}else this.onFileChange({path:this.request.path,type:0},!0)})}catch(f){await E.Promises.exists(w)&&!m.token.isCancellationRequested&&this.error(`Failed to watch ${w} for changes using fs.watch() (${f.toString()})`)}return(0,A.toDisposable)(()=>{m.dispose(!0),g.dispose()})}async onFileChange(w,d=!1){if(!this.cts.token.isCancellationRequested){this.verboseLogging&&this.trace(`${w.type===1?"[ADDED]":w.type===2?"[DELETED]":"[CHANGED]"} ${w.path}`),!d&&this.excludes.some(m=>m(w.path))?this.verboseLogging&&this.trace(` >> ignored (excluded) ${w.path}`):!d&&this.includes&&this.includes.length>0&&!this.includes.some(m=>m(w.path))?this.verboseLogging&&this.trace(` >> ignored (not included) ${w.path}`):this.fileChangesBuffer.push(w);try{await this.fileChangesDelayer.trigger(async()=>{const m=this.fileChangesBuffer;this.fileChangesBuffer=[];const g=(0,p.coalesceEvents)(m);if(g.length>0){if(this.verboseLogging)for(const u of g)this.trace(`>> normalized ${u.type===1?"[ADDED]":u.type===2?"[DELETED]":"[CHANGED]"} ${u.path}`);this.throttledFileChangesWorker.work(g)?this.throttledFileChangesWorker.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesWorker.pending}, most recent change: ${g[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${g.length}, most recent change: ${g[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}})}catch{}}}async existsChildStrictCase(w){if(P.isLinux)return E.Promises.exists(w);try{const d=(0,b.basename)(w);return(await E.Promises.readdir((0,b.dirname)(w))).some(g=>g===d)}catch(d){return this.trace(d),!1}}setVerboseLogging(w){this.verboseLogging=w}error(w){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${w}`})}warn(w){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${w}`})}trace(w){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${w}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=C,C.FILE_DELETE_HANDLER_DELAY=100,C.FILE_CHANGES_HANDLER_DELAY=50;async function h(S,w,d,m,g=512){const f=await E.Promises.open(S,"r"),u=Buffer.allocUnsafe(g),r=new T.CancellationTokenSource(m);let n,i=!1;const a={path:S,excludes:[],recursive:!1},c=new C(a,s=>{(async()=>{for(const{type:o}of s)if(o===0){if(i)return;i=!0;try{for(;!r.token.isCancellationRequested;){const{bytesRead:l}=await E.Promises.read(f,u,0,g,null);if(!l||r.token.isCancellationRequested)break;w(u.slice(0,l))}}catch(l){n=new Error(l),r.dispose(!0)}finally{i=!1}}})()});return await c.ready,d(),new Promise((s,o)=>{r.token.onCancellationRequested(async()=>{c.dispose();try{await E.Promises.close(f)}catch(l){n=new Error(l)}n?o(n):s()})})}e.watchFileContents=h}),define(re[178],se([0,1,3,82,2,4,177]),function(Z,e,k,t,T,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class I extends T.Disposable{constructor(){super(...arguments);this._onDidChangeFile=this._register(new k.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new k.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=k.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(P){const D=this.normalizeRequests(P),E=D.filter(C=>{const h=this.watchers.get(C.path);return h?!(0,t.patternsEquals)(h.request.excludes,C.excludes)||!(0,t.patternsEquals)(h.request.includes,C.includes):!0}),p=Array.from(this.watchers.values()).filter(({request:C})=>!D.find(h=>h.path===C.path&&(0,t.patternsEquals)(h.excludes,C.excludes)&&(0,t.patternsEquals)(h.includes,C.includes))).map(({request:C})=>C.path);E.length&&this.trace(`Request to start watching: ${E.map(C=>`${C.path} (excludes: ${C.excludes.length>0?C.excludes:"<none>"}, includes: ${C.includes&&C.includes.length>0?JSON.stringify(C.includes):"<all>"})`).join(",")}`),p.length&&this.trace(`Request to stop watching: ${p.join(",")}`);for(const C of p)this.stopWatching(C);for(const C of E)this.startWatching(C)}startWatching(P){const D=new A.NodeJSFileWatcherLibrary(P,p=>this._onDidChangeFile.fire(p),p=>this._onDidLogMessage.fire(p),this.verboseLogging),E={request:P,instance:D};this.watchers.set(P.path,E)}async stop(){for(const[P]of this.watchers)this.stopWatching(P);this.watchers.clear()}stopWatching(P){const D=this.watchers.get(P);D&&(this.watchers.delete(P),D.instance.dispose())}normalizeRequests(P){const D=new Map;for(const E of P){const p=L.isLinux?E.path:E.path.toLowerCase();D.set(p,E)}return Array.from(D.values())}async setVerboseLogging(P){this.verboseLogging=P;for(const[,D]of this.watchers)D.instance.setVerboseLogging(P)}trace(P){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(P)})}toMessage(P,D){return D?`[File Watcher (node.js)] ${P} (path: ${D.request.path})`:`[File Watcher (node.js)] ${P}`}}e.NodeJSWatcher=I}),define(re[179],se([0,1,57,178]),function(Z,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class T extends k.AbstractNonRecursiveWatcherClient{constructor(A,I,b){super(A,I,b);this.init()}createWatcher(){return new t.NodeJSWatcher}}e.NodeJSWatcherClient=T}),define(re[180],se([0,1,20,39,65,57]),function(Z,e,k,t,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class A extends L.AbstractUniversalWatcherClient{constructor(b,P,D){super(b,P,D);this.init()}createWatcher(b){const P=b.add(new T.Client(k.FileAccess.asFileUri("bootstrap-fork",Z).fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return b.add(P.onDidProcessExit(({code:D,signal:E})=>this.onError(`terminated by itself with code ${D}, signal: ${E}`))),t.ProxyChannel.toService((0,t.getNextTickChannel)(P.getChannel("watcher")))}}e.UniversalWatcherClient=A}),define(re[95],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class k{constructor(...T){this._entries=new Map;for(const[L,A]of T)this.set(L,A)}set(T,L){const A=this._entries.get(T);return this._entries.set(T,L),A}has(T){return this._entries.has(T)}get(T){return this._entries.get(T)}}e.ServiceCollection=k}),define(re[181],se([0,1,6,9,56,171,5,95]),function(Z,e,k,t,T,L,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const b=!1;class P extends Error{constructor(h){super("cyclic dependency between services");this.message=h.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${h.toString()}`}}class D{constructor(h=new I.ServiceCollection,S=!1,w){this._activeInstantiations=new Set,this._services=h,this._strict=S,this._parent=w,this._services.set(A.IInstantiationService,this)}createChild(h){return new D(h,this._strict,this)}invokeFunction(h,...S){const w=p.traceInvocation(h);let d=!1;try{return h({get:g=>{if(d)throw(0,t.illegalState)("service accessor is only valid during the invocation of its target method");const f=this._getOrCreateServiceInstance(g,w);if(!f)throw new Error(`[invokeFunction] unknown service '${g}'`);return f}},...S)}finally{d=!0,w.stop()}}createInstance(h,...S){let w,d;return h instanceof T.SyncDescriptor?(w=p.traceCreation(h.ctor),d=this._createInstance(h.ctor,h.staticArguments.concat(S),w)):(w=p.traceCreation(h),d=this._createInstance(h,S,w)),w.stop(),d}_createInstance(h,S=[],w){const d=A._util.getServiceDependencies(h).sort((f,u)=>f.index-u.index),m=[];for(const f of d){const u=this._getOrCreateServiceInstance(f.id,w);u||this._throwIfStrict(`[createInstance] ${h.name} depends on UNKNOWN service ${f.id}.`,!1),m.push(u)}const g=d.length>0?d[0].index:S.length;if(S.length!==g){console.trace(`[createInstance] First service dependency of ${h.name} at position ${g+1} conflicts with ${S.length} static arguments`);const f=g-S.length;f>0?S=S.concat(new Array(f)):S=S.slice(0,g)}return new h(...[...S,...m])}_setServiceInstance(h,S){if(this._services.get(h)instanceof T.SyncDescriptor)this._services.set(h,S);else if(this._parent)this._parent._setServiceInstance(h,S);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(h){const S=this._services.get(h);return!S&&this._parent?this._parent._getServiceInstanceOrDescriptor(h):S}_getOrCreateServiceInstance(h,S){const w=this._getServiceInstanceOrDescriptor(h);return w instanceof T.SyncDescriptor?this._safeCreateAndCacheServiceInstance(h,w,S.branch(h,!0)):(S.branch(h,!1),w)}_safeCreateAndCacheServiceInstance(h,S,w){if(this._activeInstantiations.has(h))throw new Error(`illegal state - RECURSIVELY instantiating service '${h}'`);this._activeInstantiations.add(h);try{return this._createAndCacheServiceInstance(h,S,w)}finally{this._activeInstantiations.delete(h)}}_createAndCacheServiceInstance(h,S,w){const d=new L.Graph(f=>f.id.toString());let m=0;const g=[{id:h,desc:S,_trace:w}];for(;g.length;){const f=g.pop();if(d.lookupOrInsertNode(f),m++>1e3)throw new P(d);for(const u of A._util.getServiceDependencies(f.desc.ctor)){const r=this._getServiceInstanceOrDescriptor(u.id);if(r||this._throwIfStrict(`[createInstance] ${h} depends on ${u.id} which is NOT registered.`,!0),r instanceof T.SyncDescriptor){const n={id:u.id,desc:r,_trace:f._trace.branch(u.id,!0)};d.insertEdge(f,n),g.push(n)}}}for(;;){const f=d.roots();if(f.length===0){if(!d.isEmpty())throw new P(d);break}for(const{data:u}of f){if(this._getServiceInstanceOrDescriptor(u.id)instanceof T.SyncDescriptor){const n=this._createServiceInstanceWithOwner(u.id,u.desc.ctor,u.desc.staticArguments,u.desc.supportsDelayedInstantiation,u._trace);this._setServiceInstance(u.id,n)}d.removeNode(u)}}return this._getServiceInstanceOrDescriptor(h)}_createServiceInstanceWithOwner(h,S,w=[],d,m){if(this._services.get(h)instanceof T.SyncDescriptor)return this._createServiceInstance(S,w,d,m);if(this._parent)return this._parent._createServiceInstanceWithOwner(h,S,w,d,m);throw new Error(`illegalState - creating UNKNOWN service instance ${S.name}`)}_createServiceInstance(h,S=[],w,d){if(w){const m=new k.IdleValue(()=>this._createInstance(h,S,d));return new Proxy(Object.create(null),{get(g,f){if(f in g)return g[f];const u=m.value;let r=u[f];return typeof r!="function"||(r=r.bind(u),g[f]=r),r},set(g,f,u){return m.value[f]=u,!0}})}else return this._createInstance(h,S,d)}_throwIfStrict(h,S){if(S&&console.warn(S),this._strict)throw new Error(h)}}e.InstantiationService=D;var E;(function(C){C[C.Creation=0]="Creation",C[C.Invocation=1]="Invocation",C[C.Branch=2]="Branch"})(E||(E={}));class p{constructor(h,S){this.type=h,this.name=S,this._start=Date.now(),this._dep=[]}static traceInvocation(h){return b?new p(1,h.name||h.toString().substring(0,42).replace(/\n/g,"")):p._None}static traceCreation(h){return b?new p(0,h.name):p._None}branch(h,S){const w=new p(2,h.toString());return this._dep.push([h,S,w]),w}stop(){const h=Date.now()-this._start;p._totals+=h;let S=!1;function w(m,g){const f=[],u=new Array(m+1).join("	");for(const[r,n,i]of g._dep)if(n&&i){S=!0,f.push(`${u}CREATES -> ${r}`);const a=w(m+1,i);a&&f.push(a)}else f.push(`${u}uses -> ${r}`);return f.join(`
`)}const d=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${w(1,this)}`,`DONE, took ${h.toFixed(2)}ms (grand total ${p._totals.toFixed(2)}ms)`];(h>2||S)&&console.log(d.join(`
`))}}e.Trace=p,p._None=new class extends p{constructor(){super(-1,null)}stop(){}branch(){return this}},p._totals=0}),define(re[182],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MessagePortMainProcessService=void 0;class k{constructor(T,L){this.server=T,this.router=L}getChannel(T){return this.server.getChannel(T,this.router)}registerChannel(T,L){this.server.registerChannel(T,L)}}e.MessagePortMainProcessService=k}),define(re[96],se([0,1,39,56,89,5]),function(Z,e,k,t,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerSharedProcessRemoteService=e.ISharedProcessService=e.registerMainProcessRemoteService=e.IMainProcessService=void 0;class A{constructor(C,h,S){const w=S.getChannel(C);return I(h)?new h.channelClientCtor(w):k.ProxyChannel.toService(w,h?.proxyOptions)}}function I(p){return!!p?.channelClientCtor}e.IMainProcessService=(0,L.createDecorator)("mainProcessService");let b=class extends A{constructor(C,h,S){super(C,h,S)}};b=me([Q(2,e.IMainProcessService)],b);function P(p,C,h){(0,T.registerSingleton)(p,new t.SyncDescriptor(b,[C,h],h?.supportsDelayedInstantiation))}e.registerMainProcessRemoteService=P,e.ISharedProcessService=(0,L.createDecorator)("sharedProcessService");let D=class extends A{constructor(C,h,S){super(C,h,S)}};D=me([Q(2,e.ISharedProcessService)],D);function E(p,C,h){(0,T.registerSingleton)(p,new t.SyncDescriptor(D,[C,h],h?.supportsDelayedInstantiation))}e.registerSharedProcessRemoteService=E}),define(re[67],se([0,1,23,2,4,152,30,5]),function(Z,e,k,t,T,L,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=void 0,e.ILanguagePackService=(0,I.createDecorator)("languagePackService");let b=class extends t.Disposable{constructor(D){super();this.extensionGalleryService=D}async getAvailableLanguages(){const D=new k.CancellationTokenSource;setTimeout(()=>D.cancel(),1e3);let E;try{E=await this.extensionGalleryService.query({text:'category:"language packs"',pageSize:20},D.token)}catch{return[]}const C=E.firstPage.filter(h=>h.properties.localizedLanguages?.length&&h.tags.some(S=>S.startsWith("lp-"))).map(h=>{const S=h.properties.localizedLanguages?.[0],w=h.tags.find(m=>m.startsWith("lp-")).split("lp-")[1];return{...this.createQuickPickItem({locale:w,label:S}),extensionId:h.identifier.id,galleryExtension:h}});return C.push({...this.createQuickPickItem({locale:"en",label:"English"}),extensionId:"default"}),C}createQuickPickItem(D){const E=D.label??D.locale;let p=D.locale!==D.label?D.locale:void 0;return D.locale.toLowerCase()===T.language.toLowerCase()&&(p||(p=""),p+=(0,L.localize)(0,null)),{id:D.locale,label:E,description:p}}};b=me([Q(0,A.IExtensionGalleryService)],b),e.LanguagePackBaseService=b}),define(re[183],se([0,1,2,67]),function(Z,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let T=class extends k.Disposable{constructor(A){super();this.localizationsService=A,this.updateLocalizations()}updateLocalizations(){this.localizationsService.update()}};T=me([Q(0,t.ILanguagePackService)],T),e.LocalizationsUpdater=T}),define(re[7],se([0,1,37,3,2,4,5]),function(Z,e,k,t,T,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,A.createDecorator)("logService"),e.ILoggerService=(0,A.createDecorator)("loggerService");function I(){return new Date().toISOString()}var b;(function(n){n[n.Trace=0]="Trace",n[n.Debug=1]="Debug",n[n.Info=2]="Info",n[n.Warning=3]="Warning",n[n.Error=4]="Error",n[n.Critical=5]="Critical",n[n.Off=6]="Off"})(b=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=b.Info;function P(n,i,a){switch(i){case b.Trace:n.trace(a);break;case b.Debug:n.debug(a);break;case b.Info:n.info(a);break;case b.Warning:n.warn(a);break;case b.Error:n.error(a);break;case b.Critical:n.critical(a);break;default:throw new Error("Invalid log level")}}e.log=P;function D(n){let i="";for(let a=0;a<n.length;a++){let c=n[a];if(typeof c=="object")try{c=JSON.stringify(c)}catch{}i+=(a>0?" ":"")+c}return i}e.format=D;class E extends T.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new t.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(i){this.level!==i&&(this.level=i,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=E;class p extends E{constructor(i){super();this.logAlways=i}checkLogLevel(i){return this.logAlways||this.getLevel()<=i}trace(i,...a){this.checkLogLevel(b.Trace)&&this.log(b.Trace,D([i,...a]))}debug(i,...a){this.checkLogLevel(b.Debug)&&this.log(b.Debug,D([i,...a]))}info(i,...a){this.checkLogLevel(b.Info)&&this.log(b.Info,D([i,...a]))}warn(i,...a){this.checkLogLevel(b.Warning)&&this.log(b.Warning,D([i,...a]))}error(i,...a){if(this.checkLogLevel(b.Error))if(i instanceof Error){const c=Array.prototype.slice.call(arguments);c[0]=i.stack,this.log(b.Error,D(c))}else this.log(b.Error,D([i,...a]))}critical(i,...a){this.checkLogLevel(b.Critical)&&this.log(b.Critical,D([i,...a]))}flush(){}}e.AbstractMessageLogger=p;class C extends E{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i),this.useColors=!L.isWindows}trace(i,...a){this.getLevel()<=b.Trace&&(this.useColors?console.log(`[90m[main ${I()}][0m`,i,...a):console.log(`[main ${I()}]`,i,...a))}debug(i,...a){this.getLevel()<=b.Debug&&(this.useColors?console.log(`[90m[main ${I()}][0m`,i,...a):console.log(`[main ${I()}]`,i,...a))}info(i,...a){this.getLevel()<=b.Info&&(this.useColors?console.log(`[90m[main ${I()}][0m`,i,...a):console.log(`[main ${I()}]`,i,...a))}warn(i,...a){this.getLevel()<=b.Warning&&(this.useColors?console.warn(`[93m[main ${I()}][0m`,i,...a):console.warn(`[main ${I()}]`,i,...a))}error(i,...a){this.getLevel()<=b.Error&&(this.useColors?console.error(`[91m[main ${I()}][0m`,i,...a):console.error(`[main ${I()}]`,i,...a))}critical(i,...a){this.getLevel()<=b.Critical&&(this.useColors?console.error(`[90m[main ${I()}][0m`,i,...a):console.error(`[main ${I()}]`,i,...a))}dispose(){}flush(){}}e.ConsoleMainLogger=C;class h extends E{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i)}trace(i,...a){this.getLevel()<=b.Trace&&console.log("%cTRACE","color: #888",i,...a)}debug(i,...a){this.getLevel()<=b.Debug&&console.log("%cDEBUG","background: #eee; color: #888",i,...a)}info(i,...a){this.getLevel()<=b.Info&&console.log("%c INFO","color: #33f",i,...a)}warn(i,...a){this.getLevel()<=b.Warning&&console.log("%c WARN","color: #993",i,...a)}error(i,...a){this.getLevel()<=b.Error&&console.log("%c  ERR","color: #f33",i,...a)}critical(i,...a){this.getLevel()<=b.Critical&&console.log("%cCRITI","background: #f33; color: white",i,...a)}dispose(){}flush(){}}e.ConsoleLogger=h;class S extends E{constructor(i,a=e.DEFAULT_LOG_LEVEL){super();this.adapter=i,this.setLevel(a)}trace(i,...a){this.getLevel()<=b.Trace&&this.adapter.log(b.Trace,[this.extractMessage(i),...a])}debug(i,...a){this.getLevel()<=b.Debug&&this.adapter.log(b.Debug,[this.extractMessage(i),...a])}info(i,...a){this.getLevel()<=b.Info&&this.adapter.log(b.Info,[this.extractMessage(i),...a])}warn(i,...a){this.getLevel()<=b.Warning&&this.adapter.log(b.Warning,[this.extractMessage(i),...a])}error(i,...a){this.getLevel()<=b.Error&&this.adapter.log(b.Error,[this.extractMessage(i),...a])}critical(i,...a){this.getLevel()<=b.Critical&&this.adapter.log(b.Critical,[this.extractMessage(i),...a])}extractMessage(i){return typeof i=="string"?i:(0,k.toErrorMessage)(i,this.getLevel()<=b.Trace)}dispose(){}flush(){}}e.AdapterLogger=S;class w extends E{constructor(i){super();this.logServices=i,i.length&&this.setLevel(i[0].getLevel())}setLevel(i){for(const a of this.logServices)a.setLevel(i);super.setLevel(i)}trace(i,...a){for(const c of this.logServices)c.trace(i,...a)}debug(i,...a){for(const c of this.logServices)c.debug(i,...a)}info(i,...a){for(const c of this.logServices)c.info(i,...a)}warn(i,...a){for(const c of this.logServices)c.warn(i,...a)}error(i,...a){for(const c of this.logServices)c.error(i,...a)}critical(i,...a){for(const c of this.logServices)c.critical(i,...a)}flush(){for(const i of this.logServices)i.flush()}dispose(){for(const i of this.logServices)i.dispose()}}e.MultiplexLogService=w;class d extends T.Disposable{constructor(i){super();this.logger=i,this._register(i)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(i){this.logger.setLevel(i)}getLevel(){return this.logger.getLevel()}trace(i,...a){this.logger.trace(i,...a)}debug(i,...a){this.logger.debug(i,...a)}info(i,...a){this.logger.info(i,...a)}warn(i,...a){this.logger.warn(i,...a)}error(i,...a){this.logger.error(i,...a)}critical(i,...a){this.logger.critical(i,...a)}flush(){this.logger.flush()}}e.LogService=d;class m extends T.Disposable{constructor(i,a){super();this.logLevel=i,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(a(c=>{this.logLevel=c,this.logLevelChangeableLoggers.forEach(s=>s.setLevel(c))}))}getLogger(i){return this.loggers.get(i.toString())}createLogger(i,a){let c=this.loggers.get(i.toString());return c||(c=this.doCreateLogger(i,a?.always?b.Trace:this.logLevel,a),this.loggers.set(i.toString(),c),a?.always||this.logLevelChangeableLoggers.push(c)),c}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(i=>i.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=m;class g{constructor(){this.onDidChangeLogLevel=new t.Emitter().event}setLevel(i){}getLevel(){return b.Info}trace(i,...a){}debug(i,...a){}info(i,...a){}warn(i,...a){}error(i,...a){}critical(i,...a){}dispose(){}flush(){}}e.NullLogService=g;function f(n){if(n.verbose)return b.Trace;if(typeof n.logLevel=="string"){const i=u(n.logLevel.toLowerCase());if(i!==void 0)return i}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=f;function u(n){switch(n){case"trace":return b.Trace;case"debug":return b.Debug;case"info":return b.Info;case"warn":return b.Warning;case"error":return b.Error;case"critical":return b.Critical;case"off":return b.Off}}e.parseLogLevel=u;function r(n){switch(n){case b.Trace:return"trace";case b.Debug:return"debug";case b.Info:return"info";case b.Warning:return"warn";case b.Error:return"error";case b.Critical:return"critical";case b.Off:return"off"}}e.LogLevelToString=r}),define(re[184],se([0,1,6,9,2,12,27,15,7]),function(Z,e,k,t,T,L,A,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let P=class extends T.Disposable{constructor(E,p){super();this.environmentService=E,this.logService=p,this._register(new k.RunOnceScheduler(()=>{this.cleanUpOldLogs()},10*1e3)).schedule()}async cleanUpOldLogs(){this.logService.trace("[logs cleanup]: Starting to clean up old logs.");try{const E=(0,L.basename)(this.environmentService.logsPath),p=(0,L.dirname)(this.environmentService.logsPath),S=(await A.Promises.readdir(p)).filter(d=>/^\d{8}T\d{6}$/.test(d)).sort().filter(d=>d!==E),w=S.slice(0,Math.max(0,S.length-9));w.length>0&&(this.logService.trace(`[logs cleanup]: Removing log folders '${w.join(", ")}'`),await Promise.all(w.map(d=>A.Promises.rm((0,L.join)(p,d)))))}catch(E){(0,t.onUnexpectedError)(E)}}};P=me([Q(0,I.IEnvironmentService),Q(1,b.ILogService)],P),e.LogsDataCleaner=P}),define(re[185],se([0,1,6,9,2,12,27,15,7]),function(Z,e,k,t,T,L,A,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDataCleaner=void 0;let P=class mt extends T.Disposable{constructor(E,p,C){super();this.backupWorkspacesPath=E,this.environmentService=p,this.logService=C,this._register(new k.RunOnceScheduler(()=>{this.cleanUpStorage()},30*1e3)).schedule()}async cleanUpStorage(){this.logService.trace("[storage cleanup]: Starting to clean up storage folders.");try{const E=await A.Promises.readFile(this.backupWorkspacesPath,"utf8"),C=JSON.parse(E).emptyWorkspaceInfos.map(S=>S.backupFolder),h=await A.Promises.readdir(this.environmentService.workspaceStorageHome.fsPath);await Promise.all(h.map(async S=>{S.length===mt.NON_EMPTY_WORKSPACE_ID_LENGTH||S===mt.EXTENSION_DEV_EMPTY_WINDOW_ID||C.indexOf(S)>=0||(this.logService.trace(`[storage cleanup]: Deleting workspace storage folder ${S}.`),await A.Promises.rm((0,L.join)(this.environmentService.workspaceStorageHome.fsPath,S)))}))}catch(E){(0,t.onUnexpectedError)(E)}}};P.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4,P.EXTENSION_DEV_EMPTY_WINDOW_ID="ext-dev",P=me([Q(1,I.INativeEnvironmentService),Q(2,b.ILogService)],P),e.StorageDataCleaner=P}),define(re[186],se([0,1,17,6,9,3,2,12,57,7]),function(Z,e,k,t,T,L,A,I,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class D extends A.Disposable{constructor(p,C){super();this.logService=p,this.options=C,this._onDidChangeFile=this._register(new L.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new L.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new t.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new t.ThrottledDelayer(0))}watch(p,C){return C.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(p,C):this.watchNonRecursive(p,C)}watchUniversal(p,C){const h={path:this.toFilePath(p),excludes:C.excludes,includes:C.includes,recursive:C.recursive},S=(0,k.insert)(this.universalPathsToWatch,h);return this.refreshUniversalWatchers(),(0,A.toDisposable)(()=>{S(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(p=>(0,T.onUnexpectedError)(p))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(C=>this._onDidChangeFile.fire((0,b.toFileChanges)(C)),C=>this.onWatcherLogMessage(C),this.logService.getLevel()===P.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===P.LogLevel.Trace)})));const p=this.options?.watcher?.recursive?.usePolling;if(p===!0)for(const C of this.universalPathsToWatch)(0,b.isRecursiveWatchRequest)(C)&&(C.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(p))for(const C of this.universalPathsToWatch)(0,b.isRecursiveWatchRequest)(C)&&p.includes(C.path)&&(C.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(p,C){const h={path:this.toFilePath(p),excludes:C.excludes,includes:C.includes,recursive:!1},S=(0,k.insert)(this.nonRecursivePathsToWatch,h);return this.refreshNonRecursiveWatchers(),(0,A.toDisposable)(()=>{S(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(p=>(0,T.onUnexpectedError)(p))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(p=>this._onDidChangeFile.fire((0,b.toFileChanges)(p)),p=>this.onWatcherLogMessage(p),this.logService.getLevel()===P.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===P.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(p){p.type==="error"&&this._onDidWatchError.fire(p.message),this.logService[p.type](p.message)}toFilePath(p){return(0,I.normalize)(p.fsPath)}}e.AbstractDiskFileSystemProvider=D}),define(re[187],se([0,1,17,6,16,23,3,63,52,2,38,20,188,19,41,148,13,94,7]),function(Z,e,k,t,T,L,A,I,b,P,D,E,p,C,h,S,w,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let g=class extends P.Disposable{constructor(u){super();this.logService=u,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new A.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new A.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new A.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new A.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new A.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new A.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new t.ResourceQueue)}registerProvider(u,r){if(this.provider.has(u))throw new Error(`A filesystem provider for the scheme '${u}' is already registered.`);(0,p.mark)(`code/registerFilesystem/${u}`);const n=new P.DisposableStore;return this.provider.set(u,r),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:u,provider:r}),n.add(r.onDidChangeFile(i=>this._onDidFilesChange.fire(new w.FileChangesEvent(i,!this.isPathCaseSensitive(r))))),typeof r.onDidWatchError=="function"&&n.add(r.onDidWatchError(i=>this._onDidWatchError.fire(new Error(i)))),n.add(r.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:r,scheme:u}))),(0,P.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:u,provider:r}),this.provider.delete(u),(0,P.dispose)(n)})}getProvider(u){return this.provider.get(u)}async activateProvider(u){const r=[];this._onWillActivateFileSystemProvider.fire({scheme:u,join(n){r.push(n)}}),!this.provider.has(u)&&await t.Promises.settled(r)}async canHandleResource(u){return await this.activateProvider(u.scheme),this.hasProvider(u)}hasProvider(u){return this.provider.has(u.scheme)}hasCapability(u,r){const n=this.provider.get(u.scheme);return!!(n&&n.capabilities&r)}listCapabilities(){return b.Iterable.map(this.provider,([u,r])=>({scheme:u,capabilities:r.capabilities}))}async withProvider(u){if(!(0,C.isAbsolutePath)(u))throw new w.FileOperationError((0,S.localize)(0,null,this.resourceForError(u)),8);await this.activateProvider(u.scheme);const r=this.provider.get(u.scheme);if(!r){const n=new Error;throw n.name="ENOPRO",n.message=(0,S.localize)(1,null,u.toString()),n}return r}async withReadProvider(u){const r=await this.withProvider(u);if((0,w.hasOpenReadWriteCloseCapability)(r)||(0,w.hasReadWriteCapability)(r)||(0,w.hasFileReadStreamCapability)(r))return r;throw new Error(`Filesystem provider for scheme '${u.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(u){const r=await this.withProvider(u);if((0,w.hasOpenReadWriteCloseCapability)(r)||(0,w.hasReadWriteCapability)(r))return r;throw new Error(`Filesystem provider for scheme '${u.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(u,r){try{return await this.doResolveFile(u,r)}catch(n){throw(0,w.toFileSystemProviderErrorCode)(n)===w.FileSystemProviderErrorCode.FileNotFound?new w.FileOperationError((0,S.localize)(2,null,this.resourceForError(u)),1):(0,w.ensureFileSystemProviderError)(n)}}async doResolveFile(u,r){const n=await this.withProvider(u),i=this.isPathCaseSensitive(n),a=r?.resolveTo,c=r?.resolveSingleChildDescendants,s=r?.resolveMetadata,o=await n.stat(u);let l;return this.toFileStat(n,u,o,void 0,!!s,(v,y)=>(l||(l=D.TernarySearchTree.forUris(()=>!i),l.set(u,!0),a&&l.fill(!0,a)),l.get(v.resource)||l.findSuperstr(v.resource.with({query:null,fragment:null}))?!0:v.isDirectory&&c?y===1:!1))}async toFileStat(u,r,n,i,a,c){const{providerExtUri:s}=this.getExtUri(u),o={resource:r,name:s.basename(r),isFile:(n.type&w.FileType.File)!=0,isDirectory:(n.type&w.FileType.Directory)!=0,isSymbolicLink:(n.type&w.FileType.SymbolicLink)!=0,mtime:n.mtime,ctime:n.ctime,size:n.size,readonly:Boolean((n.permissions??0)&w.FilePermission.Readonly)||Boolean(u.capabilities&2048),etag:(0,w.etag)({mtime:n.mtime,size:n.size}),children:void 0};if(o.isDirectory&&c(o,i)){try{const l=await u.readdir(r),v=await t.Promises.settled(l.map(async([y,O])=>{try{const _=s.joinPath(r,y),F=a?await u.stat(_):{type:O};return await this.toFileStat(u,_,F,l.length,a,c)}catch(_){return this.logService.trace(_),null}}));o.children=(0,k.coalesce)(v)}catch(l){this.logService.trace(l),o.children=[]}return o}return o}async resolveAll(u){return t.Promises.settled(u.map(async r=>{try{return{stat:await this.doResolveFile(r.resource,r.options),success:!0}}catch(n){return this.logService.trace(n),{stat:void 0,success:!1}}}))}async stat(u){const r=await this.withProvider(u),n=await r.stat(u);return this.toFileStat(r,u,n,void 0,!0,()=>!1)}async exists(u){const r=await this.withProvider(u);try{return!!await r.stat(u)}catch{return!1}}async canCreateFile(u,r){try{await this.doValidateCreateFile(u,r)}catch(n){return n}return!0}async doValidateCreateFile(u,r){if(!r?.overwrite&&await this.exists(u))throw new w.FileOperationError((0,S.localize)(3,null,this.resourceForError(u)),3,r)}async createFile(u,r=T.VSBuffer.fromString(""),n){await this.doValidateCreateFile(u,n);const i=await this.writeFile(u,r);return this._onDidRunOperation.fire(new w.FileOperationEvent(u,0,i)),i}async writeFile(u,r,n){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(u),u),{providerExtUri:a}=this.getExtUri(i);try{await this.validateWriteFile(i,u,n)||await this.mkdirp(i,a.dirname(u));let s;if((0,w.hasReadWriteCapability)(i)&&!(r instanceof T.VSBuffer))if((0,h.isReadableStream)(r)){const o=await(0,h.peekStream)(r,3);o.ended?s=T.VSBuffer.concat(o.buffer):s=o}else s=(0,h.peekReadable)(r,o=>T.VSBuffer.concat(o),3);else s=r;!(0,w.hasOpenReadWriteCloseCapability)(i)||(0,w.hasReadWriteCapability)(i)&&s instanceof T.VSBuffer?await this.doWriteUnbuffered(i,u,n,s):await this.doWriteBuffered(i,u,n,s instanceof T.VSBuffer?(0,T.bufferToReadable)(s):s),this._onDidRunOperation.fire(new w.FileOperationEvent(u,4))}catch(c){throw new w.FileOperationError((0,S.localize)(4,null,this.resourceForError(u),(0,w.ensureFileSystemProviderError)(c).toString()),(0,w.toFileOperationResult)(c),n)}return this.resolve(u,{resolveMetadata:!0})}async validateWriteFile(u,r,n){if(!!n?.unlock&&!(u.capabilities&8192))throw new Error((0,S.localize)(5,null,this.resourceForError(r)));let a;try{a=await u.stat(r)}catch{return}if((a.type&w.FileType.Directory)!=0)throw new w.FileOperationError((0,S.localize)(6,null,this.resourceForError(r)),0,n);if(this.throwIfFileIsReadonly(r,a),typeof n?.mtime=="number"&&typeof n.etag=="string"&&n.etag!==w.ETAG_DISABLED&&typeof a.mtime=="number"&&typeof a.size=="number"&&n.mtime<a.mtime&&n.etag!==(0,w.etag)({mtime:n.mtime,size:a.size}))throw new w.FileOperationError((0,S.localize)(7,null),3,n);return a}async readFile(u,r,n){const i=await this.withReadProvider(u);return r?.atomic?this.doReadFileAtomic(i,u,r,n):this.doReadFile(i,u,r,n)}async doReadFileAtomic(u,r,n,i){return new Promise((a,c)=>{this.writeQueue.queueFor(r,this.getExtUri(u).providerExtUri).queue(async()=>{try{const s=await this.doReadFile(u,r,n,i);a(s)}catch(s){c(s)}})})}async doReadFile(u,r,n,i){const a=await this.doReadFileStream(u,r,{...n,preferUnbuffered:!0},i);return{...a,value:await(0,T.streamToBuffer)(a.value)}}async readFileStream(u,r,n){const i=await this.withReadProvider(u);return this.doReadFileStream(i,u,r,n)}async doReadFileStream(u,r,n,i){const a=new L.CancellationTokenSource(i),c=this.validateReadFile(r,n).then(o=>o,o=>{throw a.cancel(),o});let s;try{return typeof n?.etag=="string"&&n.etag!==w.ETAG_DISABLED&&await c,n?.atomic&&(0,w.hasFileAtomicReadCapability)(u)||!((0,w.hasOpenReadWriteCloseCapability)(u)||(0,w.hasFileReadStreamCapability)(u))||(0,w.hasReadWriteCapability)(u)&&n?.preferUnbuffered?s=this.readFileUnbuffered(u,r,n):(0,w.hasFileReadStreamCapability)(u)?s=this.readFileStreamed(u,r,a.token,n):s=this.readFileBuffered(u,r,a.token,n),{...await c,value:s}}catch(o){s&&await(0,h.consumeStream)(s);const l=(0,S.localize)(8,null,this.resourceForError(r),(0,w.ensureFileSystemProviderError)(o).toString());throw o instanceof w.NotModifiedSinceFileOperationError?new w.NotModifiedSinceFileOperationError(l,o.stat,n):new w.FileOperationError(l,(0,w.toFileOperationResult)(o),n)}}readFileStreamed(u,r,n,i=Object.create(null)){const a=u.readFileStream(r,i,n);return(0,h.transform)(a,{data:c=>c instanceof T.VSBuffer?c:T.VSBuffer.wrap(c),error:c=>new w.FileOperationError((0,S.localize)(9,null,this.resourceForError(r),(0,w.ensureFileSystemProviderError)(c).toString()),(0,w.toFileOperationResult)(c),i)},c=>T.VSBuffer.concat(c))}readFileBuffered(u,r,n,i=Object.create(null)){const a=(0,T.newWriteableBufferStream)();return(0,d.readFileIntoStream)(u,r,a,c=>c,{...i,bufferSize:this.BUFFER_SIZE,errorTransformer:c=>new w.FileOperationError((0,S.localize)(10,null,this.resourceForError(r),(0,w.ensureFileSystemProviderError)(c).toString()),(0,w.toFileOperationResult)(c),i)},n),a}readFileUnbuffered(u,r,n){const i=(0,h.newWriteableStream)(a=>T.VSBuffer.concat(a));return(async()=>{try{let a;n?.atomic&&(0,w.hasFileAtomicReadCapability)(u)?a=await u.readFile(r,{atomic:!0}):a=await u.readFile(r),typeof n?.position=="number"&&(a=a.slice(n.position)),typeof n?.length=="number"&&(a=a.slice(0,n.length)),this.validateReadFileLimits(r,a.byteLength,n),i.end(T.VSBuffer.wrap(a))}catch(a){i.error(a),i.end()}})(),i}async validateReadFile(u,r){const n=await this.resolve(u,{resolveMetadata:!0});if(n.isDirectory)throw new w.FileOperationError((0,S.localize)(11,null,this.resourceForError(u)),0,r);if(typeof r?.etag=="string"&&r.etag!==w.ETAG_DISABLED&&r.etag===n.etag)throw new w.NotModifiedSinceFileOperationError((0,S.localize)(12,null),n,r);return this.validateReadFileLimits(u,n.size,r),n}validateReadFileLimits(u,r,n){if(n?.limits){let i;if(typeof n.limits.memory=="number"&&r>n.limits.memory&&(i=9),typeof n.limits.size=="number"&&r>n.limits.size&&(i=7),typeof i=="number")throw new w.FileOperationError((0,S.localize)(13,null,this.resourceForError(u)),i)}}async canMove(u,r,n){return this.doCanMoveCopy(u,r,"move",n)}async canCopy(u,r,n){return this.doCanMoveCopy(u,r,"copy",n)}async doCanMoveCopy(u,r,n,i){if(u.toString()!==r.toString())try{const a=n==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(u),u):await this.withReadProvider(u),c=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r);await this.doValidateMoveCopy(a,u,c,r,n,i)}catch(a){return a}return!0}async move(u,r,n){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(u),u),a=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r),c=await this.doMoveCopy(i,u,a,r,"move",!!n),s=await this.resolve(r,{resolveMetadata:!0});return this._onDidRunOperation.fire(new w.FileOperationEvent(u,c==="move"?2:3,s)),s}async copy(u,r,n){const i=await this.withReadProvider(u),a=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r),c=await this.doMoveCopy(i,u,a,r,"copy",!!n),s=await this.resolve(r,{resolveMetadata:!0});return this._onDidRunOperation.fire(new w.FileOperationEvent(u,c==="copy"?3:2,s)),s}async doMoveCopy(u,r,n,i,a,c){if(r.toString()===i.toString())return a;const{exists:s,isSameResourceWithDifferentPathCase:o}=await this.doValidateMoveCopy(u,r,n,i,a,c);if(s&&!o&&c&&await this.del(i,{recursive:!0}),await this.mkdirp(n,this.getExtUri(n).providerExtUri.dirname(i)),a==="copy"){if(u===n&&(0,w.hasFileFolderCopyCapability)(u))await u.copy(r,i,{overwrite:c});else{const l=await this.resolve(r);l.isDirectory?await this.doCopyFolder(u,l,n,i):await this.doCopyFile(u,r,n,i)}return a}else return u===n?(await u.rename(r,i,{overwrite:c}),a):(await this.doMoveCopy(u,r,n,i,"copy",c),await this.del(r,{recursive:!0}),"copy")}async doCopyFile(u,r,n,i){if((0,w.hasOpenReadWriteCloseCapability)(u)&&(0,w.hasOpenReadWriteCloseCapability)(n))return this.doPipeBuffered(u,r,n,i);if((0,w.hasOpenReadWriteCloseCapability)(u)&&(0,w.hasReadWriteCapability)(n))return this.doPipeBufferedToUnbuffered(u,r,n,i);if((0,w.hasReadWriteCapability)(u)&&(0,w.hasOpenReadWriteCloseCapability)(n))return this.doPipeUnbufferedToBuffered(u,r,n,i);if((0,w.hasReadWriteCapability)(u)&&(0,w.hasReadWriteCapability)(n))return this.doPipeUnbuffered(u,r,n,i)}async doCopyFolder(u,r,n,i){await n.mkdir(i),Array.isArray(r.children)&&await t.Promises.settled(r.children.map(async a=>{const c=this.getExtUri(n).providerExtUri.joinPath(i,a.name);return a.isDirectory?this.doCopyFolder(u,await this.resolve(a.resource),n,c):this.doCopyFile(u,a.resource,n,c)}))}async doValidateMoveCopy(u,r,n,i,a,c){let s=!1;if(u===n){const{providerExtUri:l,isPathCaseSensitive:v}=this.getExtUri(u);if(v||(s=l.isEqual(r,i)),s&&a==="copy")throw new Error((0,S.localize)(14,null,this.resourceForError(r),this.resourceForError(i)));if(!s&&l.isEqualOrParent(i,r))throw new Error((0,S.localize)(15,null,this.resourceForError(r),this.resourceForError(i)))}const o=await this.exists(i);if(o&&!s){if(!c)throw new w.FileOperationError((0,S.localize)(16,null,this.resourceForError(r),this.resourceForError(i)),4);if(u===n){const{providerExtUri:l}=this.getExtUri(u);if(l.isEqualOrParent(r,i))throw new Error((0,S.localize)(17,null,this.resourceForError(r),this.resourceForError(i)))}}return{exists:o,isSameResourceWithDifferentPathCase:s}}getExtUri(u){const r=this.isPathCaseSensitive(u);return{providerExtUri:r?C.extUri:C.extUriIgnorePathCase,isPathCaseSensitive:r}}isPathCaseSensitive(u){return!!(u.capabilities&1024)}async createFolder(u){const r=this.throwIfFileSystemIsReadonly(await this.withProvider(u),u);await this.mkdirp(r,u);const n=await this.resolve(u,{resolveMetadata:!0});return this._onDidRunOperation.fire(new w.FileOperationEvent(u,0,n)),n}async mkdirp(u,r){const n=[],{providerExtUri:i}=this.getExtUri(u);for(;!i.isEqual(r,i.dirname(r));)try{if(((await u.stat(r)).type&w.FileType.Directory)==0)throw new Error((0,S.localize)(18,null,this.resourceForError(r)));break}catch(a){if((0,w.toFileSystemProviderErrorCode)(a)!==w.FileSystemProviderErrorCode.FileNotFound)throw a;n.push(i.basename(r)),r=i.dirname(r)}for(let a=n.length-1;a>=0;a--){r=i.joinPath(r,n[a]);try{await u.mkdir(r)}catch(c){if((0,w.toFileSystemProviderErrorCode)(c)!==w.FileSystemProviderErrorCode.FileExists)throw c}}}async canDelete(u,r){try{await this.doValidateDelete(u,r)}catch(n){return n}return!0}async doValidateDelete(u,r){const n=this.throwIfFileSystemIsReadonly(await this.withProvider(u),u);if(!!r?.useTrash&&!(n.capabilities&4096))throw new Error((0,S.localize)(19,null,this.resourceForError(u)));let a;try{a=await n.stat(u)}catch{}if(a)this.throwIfFileIsReadonly(u,a);else throw new w.FileOperationError((0,S.localize)(20,null,this.resourceForError(u)),1);if(!!!r?.recursive){const s=await this.resolve(u);if(s.isDirectory&&Array.isArray(s.children)&&s.children.length>0)throw new Error((0,S.localize)(21,null,this.resourceForError(u)))}return n}async del(u,r){const n=await this.doValidateDelete(u,r),i=!!r?.useTrash,a=!!r?.recursive;await n.delete(u,{recursive:a,useTrash:i}),this._onDidRunOperation.fire(new w.FileOperationEvent(u,1))}async cloneFile(u,r){const n=await this.withProvider(u),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r);if(n===i&&this.getExtUri(n).providerExtUri.isEqual(u,r))return;if(n===i&&(0,w.hasFileCloneCapability)(n))return n.cloneFile(u,r);await this.mkdirp(i,this.getExtUri(i).providerExtUri.dirname(r));const a=this.writeQueue.queueFor(u,this.getExtUri(n).providerExtUri);return n===i&&(0,w.hasFileFolderCopyCapability)(n)?a.queue(()=>n.copy(u,r,{overwrite:!0})):a.queue(()=>this.doCopyFile(n,u,i,r))}watch(u,r={recursive:!1,excludes:[]}){const n=new P.DisposableStore;let i=!1,a=()=>{i=!0};return n.add((0,P.toDisposable)(()=>a())),(async()=>{try{const c=await this.doWatch(u,r);i?(0,P.dispose)(c):a=()=>(0,P.dispose)(c)}catch(c){this.logService.error(c)}})(),n}async doWatch(u,r){const n=await this.withProvider(u),i=(0,I.hash)([this.getExtUri(n).providerExtUri.getComparisonKey(u),r]);let a=this.activeWatchers.get(i);return a||(a={count:0,disposable:n.watch(u,r)},this.activeWatchers.set(i,a)),a.count+=1,(0,P.toDisposable)(()=>{a&&(a.count--,a.count===0&&((0,P.dispose)(a.disposable),this.activeWatchers.delete(i)))})}dispose(){super.dispose();for(const[,u]of this.activeWatchers)(0,P.dispose)(u.disposable);this.activeWatchers.clear()}async doWriteBuffered(u,r,n,i){return this.writeQueue.queueFor(r,this.getExtUri(u).providerExtUri).queue(async()=>{const a=await u.open(r,{create:!0,unlock:n?.unlock??!1});try{(0,h.isReadableStream)(i)||(0,h.isReadableBufferedStream)(i)?await this.doWriteStreamBufferedQueued(u,a,i):await this.doWriteReadableBufferedQueued(u,a,i)}catch(c){throw(0,w.ensureFileSystemProviderError)(c)}finally{await u.close(a)}})}async doWriteStreamBufferedQueued(u,r,n){let i=0,a;if((0,h.isReadableBufferedStream)(n)){if(n.buffer.length>0){const c=T.VSBuffer.concat(n.buffer);await this.doWriteBuffer(u,r,c,c.byteLength,i,0),i+=c.byteLength}if(n.ended)return;a=n.stream}else a=n;return new Promise((c,s)=>{(0,h.listenStream)(a,{onData:async o=>{a.pause();try{await this.doWriteBuffer(u,r,o,o.byteLength,i,0)}catch(l){return s(l)}i+=o.byteLength,setTimeout(()=>a.resume())},onError:o=>s(o),onEnd:()=>c()})})}async doWriteReadableBufferedQueued(u,r,n){let i=0,a;for(;(a=n.read())!==null;)await this.doWriteBuffer(u,r,a,a.byteLength,i,0),i+=a.byteLength}async doWriteBuffer(u,r,n,i,a,c){let s=0;for(;s<i;)s+=await u.write(r,a+s,n.buffer,c+s,i-s)}async doWriteUnbuffered(u,r,n,i){return this.writeQueue.queueFor(r,this.getExtUri(u).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(u,r,n,i))}async doWriteUnbufferedQueued(u,r,n,i){let a;i instanceof T.VSBuffer?a=i:(0,h.isReadableStream)(i)?a=await(0,T.streamToBuffer)(i):(0,h.isReadableBufferedStream)(i)?a=await(0,T.bufferedStreamToBuffer)(i):a=(0,T.readableToBuffer)(i),await u.writeFile(r,a.buffer,{create:!0,overwrite:!0,unlock:n?.unlock??!1})}async doPipeBuffered(u,r,n,i){return this.writeQueue.queueFor(i,this.getExtUri(n).providerExtUri).queue(()=>this.doPipeBufferedQueued(u,r,n,i))}async doPipeBufferedQueued(u,r,n,i){let a,c;try{a=await u.open(r,{create:!1}),c=await n.open(i,{create:!0,unlock:!1});const s=T.VSBuffer.alloc(this.BUFFER_SIZE);let o=0,l=0,v=0;do v=await u.read(a,o,s.buffer,l,s.byteLength-l),await this.doWriteBuffer(n,c,s,v,o,l),o+=v,l+=v,l===s.byteLength&&(l=0);while(v>0)}catch(s){throw(0,w.ensureFileSystemProviderError)(s)}finally{await t.Promises.settled([typeof a=="number"?u.close(a):Promise.resolve(),typeof c=="number"?n.close(c):Promise.resolve()])}}async doPipeUnbuffered(u,r,n,i){return this.writeQueue.queueFor(i,this.getExtUri(n).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(u,r,n,i))}async doPipeUnbufferedQueued(u,r,n,i){return n.writeFile(i,await u.readFile(r),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(u,r,n,i){return this.writeQueue.queueFor(i,this.getExtUri(n).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(u,r,n,i))}async doPipeUnbufferedToBufferedQueued(u,r,n,i){const a=await n.open(i,{create:!0,unlock:!1});try{const c=await u.readFile(r);await this.doWriteBuffer(n,a,T.VSBuffer.wrap(c),c.byteLength,0,0)}catch(c){throw(0,w.ensureFileSystemProviderError)(c)}finally{await n.close(a)}}async doPipeBufferedToUnbuffered(u,r,n,i){const a=await(0,T.streamToBuffer)(this.readFileBuffered(u,r,L.CancellationToken.None));await this.doWriteUnbuffered(n,i,void 0,a)}throwIfFileSystemIsReadonly(u,r){if(u.capabilities&2048)throw new w.FileOperationError((0,S.localize)(22,null,this.resourceForError(r)),6);return u}throwIfFileIsReadonly(u,r){if((r.permissions??0)&w.FilePermission.Readonly)throw new w.FileOperationError((0,S.localize)(23,null,this.resourceForError(u)),6)}resourceForError(u){return u.scheme===E.Schemas.file?u.fsPath:u.toString(!0)}};g=me([Q(0,m.ILogService)],g),e.FileService=g}),define(re[189],se([0,1,54,271,6,38,16,3,42,2,12,4,19,41,27,151,13,94,186,37,180,179]),function(Z,e,k,t,T,L,A,I,b,P,D,E,p,C,h,S,w,d,m,g,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,t.gracefulify)(k)}catch(n){console.error(`Error enabling graceful-fs: ${(0,g.toErrorMessage)(n)}`)}})();class r extends m.AbstractDiskFileSystemProvider{constructor(i,a){super(i,a);this.onDidChangeCapabilities=I.Event.None,this.resourceLocks=new L.ResourceMap(c=>p.extUriBiasedIgnorePathCase.getComparisonKey(c)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map,this.canFlush=!0}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384|32768,E.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(i){try{const{stat:a,symbolicLink:c}=await h.SymlinkSupport.stat(this.toFilePath(i));return{type:this.toType(a,c),ctime:a.birthtime.getTime(),mtime:a.mtime.getTime(),size:a.size}}catch(a){throw this.toFileSystemProviderError(a)}}async readdir(i){try{const a=await h.Promises.readdir(this.toFilePath(i),{withFileTypes:!0}),c=[];return await Promise.all(a.map(async s=>{try{let o;s.isSymbolicLink()?o=(await this.stat((0,p.joinPath)(i,s.name))).type:o=this.toType(s),c.push([s.name,o])}catch(o){this.logService.trace(o)}})),c}catch(a){throw this.toFileSystemProviderError(a)}}toType(i,a){let c;return a?.dangling?c=w.FileType.Unknown:i.isFile()?c=w.FileType.File:i.isDirectory()?c=w.FileType.Directory:c=w.FileType.Unknown,a&&(c|=w.FileType.SymbolicLink),c}async createResourceLock(i){const a=this.toFilePath(i);this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${a})`);let c;for(;c=this.resourceLocks.get(i);)this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${a})`),await c.wait();const s=new T.Barrier;return this.resourceLocks.set(i,s),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${a})`),(0,P.toDisposable)(()=>{this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${a})`),this.resourceLocks.get(i)===s&&(this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${a})`),this.resourceLocks.delete(i)),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${a})`),s.open()})}async readFile(i,a){let c;try{a?.atomic&&(this.logService.trace(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(i)})`),c=await this.createResourceLock(i));const s=this.toFilePath(i);return await h.Promises.readFile(s)}catch(s){throw this.toFileSystemProviderError(s)}finally{c?.dispose()}}readFileStream(i,a,c){const s=(0,C.newWriteableStream)(o=>A.VSBuffer.concat(o.map(l=>A.VSBuffer.wrap(l))).buffer);return(0,d.readFileIntoStream)(this,i,s,o=>o.buffer,{...a,bufferSize:256*1024},c),s}async writeFile(i,a,c){let s;try{const o=this.toFilePath(i);if(!c.create||!c.overwrite){if(await h.Promises.exists(o)){if(!c.overwrite)throw(0,w.createFileSystemProviderError)((0,S.localize)(0,null),w.FileSystemProviderErrorCode.FileExists)}else if(!c.create)throw(0,w.createFileSystemProviderError)((0,S.localize)(1,null),w.FileSystemProviderErrorCode.FileNotFound)}s=await this.open(i,{create:!0,unlock:c.unlock}),await this.write(s,0,a,0,a.byteLength)}catch(o){throw await this.toFileSystemProviderWriteError(i,o)}finally{typeof s=="number"&&await this.close(s)}}async open(i,a){const c=this.toFilePath(i);let s;(0,w.isFileOpenForWriteOptions)(a)&&(s=await this.createResourceLock(i));let o;try{if((0,w.isFileOpenForWriteOptions)(a)&&a.unlock)try{const{stat:v}=await h.SymlinkSupport.stat(c);v.mode&128||await h.Promises.chmod(c,v.mode|128)}catch(v){this.logService.trace(v)}let l;if((0,w.isFileOpenForWriteOptions)(a)){if(E.isWindows)try{await h.Promises.truncate(c,0),l="r+"}catch(v){v.code!=="ENOENT"&&this.logService.trace(v)}l||(l="w")}else l="r";o=await h.Promises.open(c,l)}catch(l){throw s?.dispose(),(0,w.isFileOpenForWriteOptions)(a)?await this.toFileSystemProviderWriteError(i,l):this.toFileSystemProviderError(l)}if(this.mapHandleToPos.set(o,0),(0,w.isFileOpenForWriteOptions)(a)&&this.writeHandles.set(o,i),s){const l=this.mapHandleToLock.get(o);this.logService.trace(`[Disk FileSystemProvider]: open() - storing lock for handle ${o} (${c})`),this.mapHandleToLock.set(o,s),l&&(this.logService.trace(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${o} (${c})`),l.dispose())}return o}async close(i){const a=this.mapHandleToLock.get(i);try{if(this.mapHandleToPos.delete(i),this.writeHandles.delete(i)&&this.canFlush)try{await h.Promises.fdatasync(i)}catch(c){this.canFlush=!1,this.logService.error(c)}return await h.Promises.close(i)}catch(c){throw this.toFileSystemProviderError(c)}finally{a&&(this.mapHandleToLock.get(i)===a&&(this.logService.trace(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${i}`),this.mapHandleToLock.delete(i)),this.logService.trace(`[Disk FileSystemProvider]: close() - disposing lock for handle ${i}`),a.dispose())}}async read(i,a,c,s,o){const l=this.normalizePos(i,a);let v=null;try{v=(await h.Promises.read(i,c,s,o,l)).bytesRead}catch(y){throw this.toFileSystemProviderError(y)}finally{this.updatePos(i,l,v)}return v}normalizePos(i,a){return a===this.mapHandleToPos.get(i)?null:a}updatePos(i,a,c){const s=this.mapHandleToPos.get(i);typeof s=="number"&&(typeof a=="number"||(typeof c=="number"?this.mapHandleToPos.set(i,s+c):this.mapHandleToPos.delete(i)))}async write(i,a,c,s,o){return(0,T.retry)(()=>this.doWrite(i,a,c,s,o),100,3)}async doWrite(i,a,c,s,o){const l=this.normalizePos(i,a);let v=null;try{v=(await h.Promises.write(i,c,s,o,l)).bytesWritten}catch(y){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(i),y)}finally{this.updatePos(i,l,v)}return v}async mkdir(i){try{await h.Promises.mkdir(this.toFilePath(i))}catch(a){throw this.toFileSystemProviderError(a)}}async delete(i,a){try{const c=this.toFilePath(i);a.recursive?await h.Promises.rm(c,h.RimRafMode.MOVE):await h.Promises.unlink(c)}catch(c){throw this.toFileSystemProviderError(c)}}async rename(i,a,c){const s=this.toFilePath(i),o=this.toFilePath(a);if(s!==o)try{await this.validateTargetDeleted(i,a,"move",c.overwrite),await h.Promises.move(s,o)}catch(l){throw(l.code==="EINVAL"||l.code==="EBUSY"||l.code==="ENAMETOOLONG")&&(l=new Error((0,S.localize)(2,null,(0,D.basename)(s),(0,D.basename)((0,D.dirname)(o)),l.toString()))),this.toFileSystemProviderError(l)}}async copy(i,a,c){const s=this.toFilePath(i),o=this.toFilePath(a);if(s!==o)try{await this.validateTargetDeleted(i,a,"copy",c.overwrite),await h.Promises.copy(s,o,{preserveSymlinks:!0})}catch(l){throw(l.code==="EINVAL"||l.code==="EBUSY"||l.code==="ENAMETOOLONG")&&(l=new Error((0,S.localize)(3,null,(0,D.basename)(s),(0,D.basename)((0,D.dirname)(o)),l.toString()))),this.toFileSystemProviderError(l)}}async validateTargetDeleted(i,a,c,s){const o=this.toFilePath(i),l=this.toFilePath(a);let v=!1;if(!!(this.capabilities&1024)||(v=(0,b.isEqual)(o,l,!0)),v&&c==="copy")throw(0,w.createFileSystemProviderError)((0,S.localize)(4,null),w.FileSystemProviderErrorCode.FileExists);if(!v&&await h.Promises.exists(l)){if(!s)throw(0,w.createFileSystemProviderError)((0,S.localize)(5,null),w.FileSystemProviderErrorCode.FileExists);await this.delete(a,{recursive:!0,useTrash:!1})}}async cloneFile(i,a){return this.doCloneFile(i,a,!1)}async doCloneFile(i,a,c){const s=this.toFilePath(i),o=this.toFilePath(a),l=!!(this.capabilities&1024);if((0,b.isEqual)(s,o,!l))return;const v=new P.DisposableStore;try{const[y,O]=await Promise.all([this.createResourceLock(i),this.createResourceLock(a)]);v.add(y),v.add(O),c&&await h.Promises.mkdir((0,D.dirname)(o),{recursive:!0}),await h.Promises.copyFile(s,o)}catch(y){if(y.code==="ENOENT"&&!c)return this.doCloneFile(i,a,!0);throw this.toFileSystemProviderError(y)}finally{v.dispose()}}createUniversalWatcher(i,a,c){return new f.UniversalWatcherClient(s=>i(s),s=>a(s),c)}createNonRecursiveWatcher(i,a,c){return new u.NodeJSWatcherClient(s=>i(s),s=>a(s),c)}toFileSystemProviderError(i){if(i instanceof w.FileSystemProviderError)return i;let a;switch(i.code){case"ENOENT":a=w.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":a=w.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":a=w.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":a=w.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":a=w.FileSystemProviderErrorCode.NoPermissions;break;default:a=w.FileSystemProviderErrorCode.Unknown}return(0,w.createFileSystemProviderError)(i,a)}async toFileSystemProviderWriteError(i,a){let c=this.toFileSystemProviderError(a);if(i&&c.code===w.FileSystemProviderErrorCode.NoPermissions)try{const{stat:s}=await h.SymlinkSupport.stat(this.toFilePath(i));s.mode&128||(c=(0,w.createFileSystemProviderError)(a,w.FileSystemProviderErrorCode.FileWriteLocked))}catch(s){this.logService.trace(s)}return c}}e.DiskFileSystemProvider=r}),define(re[97],se([0,1,3,8,7]),function(Z,e,k,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class L{constructor(p){this.service=p,this.onDidChangeLogLevel=k.Event.buffer(p.onDidChangeLogLevel,!0)}listen(p,C){switch(C){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${C}`)}async call(p,C,h){switch(C){case"setLevel":return this.service.setLevel(h)}throw new Error(`Call not found: ${C}`)}}e.LogLevelChannel=L;class A{constructor(p){this.channel=p}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(p){A.setLevel(this.channel,p)}static setLevel(p,C){return p.call("setLevel",C)}}e.LogLevelChannelClient=A;class I{constructor(p){this.loggerService=p,this.loggers=new Map}listen(p,C){throw new Error(`Event not found: ${C}`)}async call(p,C,h){switch(C){case"createLogger":this.createLogger(t.URI.revive(h[0]),h[1]);return;case"log":return this.log(t.URI.revive(h[0]),h[1]);case"consoleLog":return this.consoleLog(h[0],h[1])}throw new Error(`Call not found: ${C}`)}createLogger(p,C){this.loggers.set(p.toString(),this.loggerService.createLogger(p,C))}consoleLog(p,C){let h=console.log;switch(p){case T.LogLevel.Error:h=console.error;break;case T.LogLevel.Warning:h=console.warn;break;case T.LogLevel.Info:h=console.info;break}h.call(console,...C)}log(p,C){const h=this.loggers.get(p.toString());if(!h)throw new Error("Create the logger before logging");for(const[S,w]of C)(0,T.log)(h,S,w)}}e.LoggerChannel=I;class b extends T.AbstractLoggerService{constructor(p,C,h){super(p,C);this.channel=h}createConsoleMainLogger(){return new T.AdapterLogger({log:(p,C)=>{this.channel.call("consoleLog",[p,C])}})}doCreateLogger(p,C,h){return new P(this.channel,p,C,h)}}e.LoggerChannelClient=b;class P extends T.AbstractMessageLogger{constructor(p,C,h,S){super(S?.always);this.channel=p,this.file=C,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(h),this.channel.call("createLogger",[C,S]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(p,C){const h=[[p,C]];this.isLoggerCreated?this.doLog(h):this.buffer.push(...h)}doLog(p){this.channel.call("log",[this.file,p])}}class D extends T.LogService{constructor(p,C){super(C);this.parent=p,this._register(p.onDidChangeLogLevel(h=>C.setLevel(h)))}setLevel(p){super.setLevel(p),this.parent.setLevel(p)}}e.FollowerLogService=D}),define(re[68],se([0,1,5]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,k.createDecorator)("nativeHostService")}),define(re[58],se([0,1,3,52,2,5]),function(Z,e,k,t,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,L.createDecorator)("policy");class A extends T.Disposable{constructor(){super(...arguments);this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new k.Emitter),this.onDidChange=this._onDidChange.event}async registerPolicyDefinitions(P){const D=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...P,...this.policyDefinitions},D!==Object.keys(this.policyDefinitions).length&&await this.initializePolicies(P),t.Iterable.reduce(this.policies.entries(),(E,[p,C])=>({...E,[p]:C}),{})}getPolicyValue(P){return this.policies.get(P)}serialize(){return t.Iterable.reduce(Object.entries(this.policyDefinitions),(P,[D,E])=>({...P,[D]:{definition:E,value:this.policies.get(D)}}),{})}}e.AbstractPolicyService=A;class I{constructor(){this.onDidChange=k.Event.None}async registerPolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=I}),define(re[190],se([0,1,3,2,58]),function(Z,e,k,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class L{constructor(b){this.service=b,this.disposables=new t.DisposableStore}listen(b,P){switch(P){case"onDidChange":return k.Event.map(this.service.onDidChange,D=>D.reduce((E,p)=>({...E,[p]:this.service.getPolicyValue(p)??null}),{}),this.disposables)}throw new Error(`Event not found: ${P}`)}call(b,P,D){switch(P){case"registerPolicyDefinitions":return this.service.registerPolicyDefinitions(D)}throw new Error(`Call not found: ${P}`)}dispose(){this.disposables.dispose()}}e.PolicyChannel=L;class A extends T.AbstractPolicyService{constructor(b,P){super();this.channel=P;for(const D in b){const{definition:E,value:p}=b[D];this.policyDefinitions[D]=E,p!==void 0&&this.policies.set(D,p)}this.channel.listen("onDidChange")(D=>{for(const E in D){const p=D[E];p===null?this.policies.delete(E):this.policies.set(E,p)}this._onDidChange.fire(Object.keys(D))})}async initializePolicies(b){const P=await this.channel.call("registerPolicyDefinitions",b);for(const D in P)this.policies.set(D,P[D])}}e.PolicyChannelClient=A}),define(re[98],se([0,1,20,4,36,19]),function(Z,e,k,t,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let A;if(typeof t.globals.vscode!="undefined"&&typeof t.globals.vscode.context!="undefined"){const I=t.globals.vscode.context.configuration();if(I)A=I.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof Z?.__$__nodeRequire=="function"){const I=(0,L.dirname)(k.FileAccess.asFileUri("",Z));A=Z.__$__nodeRequire((0,L.joinPath)(I,"product.json").fsPath);const b=Z.__$__nodeRequire((0,L.joinPath)(I,"package.json").fsPath);T.env.VSCODE_DEV&&Object.assign(A,{nameShort:`${A.nameShort} Dev`,nameLong:`${A.nameLong} Dev`,dataFolderName:`${A.dataFolderName}-dev`,serverDataFolderName:A.serverDataFolderName?`${A.serverDataFolderName}-dev`:void 0}),Object.assign(A,{version:b.version})}else A={},Object.keys(A).length===0&&Object.assign(A,{version:"1.67.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=A}),define(re[24],se([0,1,5]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,k.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(re[191],se([0,1,6,9,2,12,27,7,24]),function(Z,e,k,t,T,L,A,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeCacheCleaner=void 0;let P=class extends T.Disposable{constructor(E,p,C){super();this.productService=p,this.logService=C,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,E&&this._register(new k.RunOnceScheduler(()=>{this.cleanUpCodeCaches(E)},30*1e3)).schedule()}async cleanUpCodeCaches(E){this.logService.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const p=Date.now(),C=(0,L.dirname)(E),h=(0,L.basename)(E),S=await A.Promises.readdir(C);await Promise.all(S.map(async w=>{if(w===h)return;const d=(0,L.join)(C,w),m=await A.Promises.stat(d);if(m.isDirectory()&&p-m.mtime.getTime()>this._DataMaxAge)return this.logService.trace(`[code cache cleanup]: Removing code cache folder ${w}.`),A.Promises.rm(d)}))}catch(p){(0,t.onUnexpectedError)(p)}}};P=me([Q(1,b.IProductService),Q(2,I.ILogService)],P),e.CodeCacheCleaner=P}),define(re[192],se([0,1,6,9,2,12,27,15,7,24]),function(Z,e,k,t,T,L,A,I,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let D=class extends T.Disposable{constructor(p,C,h){super();this.environmentService=p,this.logService=C,this.productService=h,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.environmentService.isBuilt&&this._register(new k.RunOnceScheduler(()=>{this.cleanUpLanguagePackCache()},40*1e3)).schedule()}async cleanUpLanguagePackCache(){this.logService.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const p=Object.create(null),C=JSON.parse(await A.Promises.readFile((0,L.join)(this.environmentService.userDataPath,"languagepacks.json"),"utf8"));for(const m of Object.keys(C)){const g=C[m];p[`${g.hash}.${m}`]=!0}const h=(0,L.join)(this.environmentService.userDataPath,"clp");if(!await A.Promises.exists(h))return;const w=await A.Promises.readdir(h);for(const m of w){if(p[m]){this.logService.trace(`[language pack cache cleanup]: Skipping folder ${m}. Language pack still in use.`);continue}this.logService.trace(`[language pack cache cleanup]: Removing unused language pack: ${m}`),await A.Promises.rm((0,L.join)(h,m))}const d=Date.now();for(const m of Object.keys(p)){const g=(0,L.join)(h,m),f=await A.Promises.readdir(g);for(const u of f){if(u==="tcf.json")continue;const r=(0,L.join)(g,u),n=await A.Promises.stat(r);n.isDirectory()&&d-n.mtime.getTime()>this._DataMaxAge&&(this.logService.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,L.join)(m,u)}`),await A.Promises.rm(r))}}}catch(p){(0,t.onUnexpectedError)(p)}}};D=me([Q(0,I.INativeEnvironmentService),Q(1,b.ILogService),Q(2,P.IProductService)],D),e.LanguagePackCachedDataCleaner=D}),define(re[193],se([0,1,12,5]),function(Z,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.IV8InspectProfilingService=void 0,e.IV8InspectProfilingService=(0,t.createDecorator)("IV8InspectProfilingService");var T;(function(L){function A(I,b="noAbsolutePaths"){for(const P of I.nodes)P.callFrame&&P.callFrame.url&&((0,k.isAbsolute)(P.callFrame.url)||/^\w[\w\d+.-]*:\/\/\//.test(P.callFrame.url))&&(P.callFrame.url=(0,k.join)(b,(0,k.basename)(P.callFrame.url)));return I}L.rewriteAbsolutePaths=A})(T=e.Utils||(e.Utils={}))}),define(re[194],se([0,1,31]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InspectProfilingService=void 0;class t{constructor(){this._sessions=new Map}async startProfiling(L){const I=await(await new Promise((P,D)=>{Z(["v8-inspect-profiler"],P,D)})).startProfiling({port:L.port,checkForPaused:!0}),b=(0,k.generateUuid)();return this._sessions.set(b,I),b}async stopProfiling(L){const A=this._sessions.get(L);if(!A)throw new Error(`UNKNOWN session '${L}'`);const I=await A.stop();return this._sessions.delete(L),I.profile}}e.InspectProfilingService=t}),define(re[40],se([0,1,111,14]),function(Z,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class T{constructor(){this.data=new Map}add(A,I){k.ok(t.isString(A)),k.ok(t.isObject(I)),k.ok(!this.data.has(A),"There is already an extension with this id"),this.data.set(A,I)}knows(A){return this.data.has(A)}as(A){return this.data.get(A)||null}}e.Registry=new T}),define(re[99],se([0,1,3,40]),function(Z,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function T(I){return I.length>0&&I.charAt(I.length-1)==="#"?I.substring(0,I.length-1):I}class L{constructor(){this._onDidChangeSchema=new k.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(b,P){this.schemasById[T(b)]=P,this._onDidChangeSchema.fire(b)}notifySchemaChanged(b){this._onDidChangeSchema.fire(b)}getSchemaContributions(){return{schemas:this.schemasById}}}const A=new L;t.Registry.add(e.Extensions.JSONContribution,A)}),define(re[43],se([0,1,17,3,14,138,18,99,40]),function(Z,e,k,t,T,L,A,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var P;(function(u){u.Multiline="multilineText",u.Singleline="singlelineText"})(P=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var D;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.MACHINE=2]="MACHINE",u[u.WINDOW=3]="WINDOW",u[u.RESOURCE=4]="RESOURCE",u[u.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",u[u.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(D=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const E=b.Registry.as(I.Extensions.JSONContribution);class p{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new t.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new t.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:L.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},E.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(r,n=!0){this.registerConfigurations([r],n)}registerConfigurations(r,n=!0){const i=this.doRegisterConfigurations(r,n);E.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:i})}deregisterConfigurations(r){const n=this.doDeregisterConfigurations(r);E.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n})}updateConfigurations({add:r,remove:n}){const i=[];i.push(...this.doDeregisterConfigurations(n)),i.push(...this.doRegisterConfigurations(r,!1)),E.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,k.distinct)(i)})}registerDefaultConfigurations(r){const n=[],i=[];for(const{overrides:a,source:c}of r)for(const s in a)if(n.push(s),e.OVERRIDE_PROPERTY_REGEX.test(s)){const o=this.configurationDefaultsOverrides.get(s),l=o?.valuesSources??new Map;if(c)for(const _ of Object.keys(a[s]))l.set(_,c);const v={...o?.value||{},...a[s]};this.configurationDefaultsOverrides.set(s,{source:c,value:v,valuesSources:l});const y=(0,A.getLanguageTagSettingPlainKey)(s),O={type:"object",default:v,description:L.localize(1,null,y),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:v,source:T.isString(c)?void 0:c,defaultValueSource:c};i.push(...S(s)),this.configurationProperties[s]=O,this.defaultLanguageConfigurationOverridesNode.properties[s]=O}else{this.configurationDefaultsOverrides.set(s,{value:a[s],source:c});const o=this.configurationProperties[s];o&&(this.updatePropertyDefaultValue(s,o),this.updateSchema(s,o))}this.registerOverrideIdentifiers(i),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n,defaultsOverrides:!0})}deregisterDefaultConfigurations(r){const n=[];for(const{overrides:i,source:a}of r)for(const c in i){const s=this.configurationDefaultsOverrides.get(c),o=T.isString(a)?a:a?.id,l=T.isString(s?.source)?s?.source:s?.source?.id;if(o===l)if(n.push(c),this.configurationDefaultsOverrides.delete(c),e.OVERRIDE_PROPERTY_REGEX.test(c))delete this.configurationProperties[c],delete this.defaultLanguageConfigurationOverridesNode.properties[c];else{const v=this.configurationProperties[c];v&&(this.updatePropertyDefaultValue(c,v),this.updateSchema(c,v))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...r){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(r){for(const n of r)this.overrideIdentifiers.add(n);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(r,n){const i=[];return r.forEach(a=>{i.push(...this.validateAndRegisterProperties(a,n,a.extensionInfo,a.restrictedProperties)),this.configurationContributors.push(a),this.registerJSONConfiguration(a)}),i}doDeregisterConfigurations(r){const n=[],i=a=>{if(a.properties)for(const c in a.properties){n.push(c);const s=this.configurationProperties[c];s?.policy?.name&&this.policyConfigurations.delete(s.policy.name),delete this.configurationProperties[c],this.removeFromSchema(c,a.properties[c])}a.allOf?.forEach(c=>i(c))};for(const a of r){i(a);const c=this.configurationContributors.indexOf(a);c!==-1&&this.configurationContributors.splice(c,1)}return n}validateAndRegisterProperties(r,n=!0,i,a,c=3){c=T.isUndefinedOrNull(r.scope)?c:r.scope;const s=[],o=r.properties;if(o)for(const v in o){const y=o[v];if(n&&g(v,y)){delete o[v];continue}if(y.source=i,y.defaultDefaultValue=o[v].default,this.updatePropertyDefaultValue(v,y),e.OVERRIDE_PROPERTY_REGEX.test(v)?y.scope=void 0:(y.scope=T.isUndefinedOrNull(y.scope)?c:y.scope,y.restricted=T.isUndefinedOrNull(y.restricted)?!!a?.includes(v):y.restricted),o[v].hasOwnProperty("included")&&!o[v].included){this.excludedConfigurationProperties[v]=o[v],delete o[v];continue}else this.configurationProperties[v]=o[v],o[v].policy?.name&&this.policyConfigurations.set(o[v].policy.name,v);!o[v].deprecationMessage&&o[v].markdownDeprecationMessage&&(o[v].deprecationMessage=o[v].markdownDeprecationMessage),s.push(v)}const l=r.allOf;if(l)for(const v of l)s.push(...this.validateAndRegisterProperties(v,n,i,a,c));return s}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(r){const n=i=>{const a=i.properties;if(a)for(const s in a)this.updateSchema(s,a[s]);i.allOf?.forEach(n)};n(r)}updateSchema(r,n){switch(e.allSettings.properties[r]=n,n.scope){case 1:e.applicationSettings.properties[r]=n;break;case 2:e.machineSettings.properties[r]=n;break;case 6:e.machineOverridableSettings.properties[r]=n;break;case 3:e.windowSettings.properties[r]=n;break;case 4:e.resourceSettings.properties[r]=n;break;case 5:e.resourceSettings.properties[r]=n,this.resourceLanguageSettingsSchema.properties[r]=n;break}}removeFromSchema(r,n){switch(delete e.allSettings.properties[r],n.scope){case 1:delete e.applicationSettings.properties[r];break;case 2:delete e.machineSettings.properties[r];break;case 6:delete e.machineOverridableSettings.properties[r];break;case 3:delete e.windowSettings.properties[r];break;case 4:case 5:delete e.resourceSettings.properties[r],delete this.resourceLanguageSettingsSchema.properties[r];break}}updateOverridePropertyPatternKey(){for(const r of this.overrideIdentifiers.values()){const n=`[${r}]`,i={type:"object",description:L.localize(2,null),errorMessage:L.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(n,i),e.allSettings.properties[n]=i,e.applicationSettings.properties[n]=i,e.machineSettings.properties[n]=i,e.machineOverridableSettings.properties[n]=i,e.windowSettings.properties[n]=i,e.resourceSettings.properties[n]=i}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const r={type:"object",description:L.localize(4,null),errorMessage:L.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(r,n){const i=this.configurationDefaultsOverrides.get(r);let a=i?.value,c=i?.source;T.isUndefined(a)&&(a=n.defaultDefaultValue,c=void 0),T.isUndefined(a)&&(a=d(n.type)),n.default=a,n.defaultValueSource=c}}const C="\\[([^\\]]+)\\]",h=new RegExp(C,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${C})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function S(u){const r=[];if(e.OVERRIDE_PROPERTY_REGEX.test(u)){let n=h.exec(u);for(;n?.length;){const i=n[1].trim();i&&r.push(i),n=h.exec(u)}}return(0,k.distinct)(r)}e.overrideIdentifiersFromKey=S;function w(u){return u.reduce((r,n)=>`${r}[${n}]`,"")}e.keyFromOverrideIdentifiers=w;function d(u){switch(Array.isArray(u)?u[0]:u){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=d;const m=new p;b.Registry.add(e.Extensions.Configuration,m);function g(u,r){return u.trim()?e.OVERRIDE_PROPERTY_REGEX.test(u)?L.localize(7,null,u):m.getConfigurationProperties()[u]!==void 0?L.localize(8,null,u):r.policy?.name&&m.getPolicyConfigurations().get(r.policy?.name)!==void 0?L.localize(9,null,u,r.policy?.name,m.getPolicyConfigurations().get(r.policy?.name)):null:L.localize(6,null)}e.validateProperty=g;function f(){const u=[],r=m.getConfigurationProperties();for(const n of Object.keys(r))u.push([n,r[n].scope]);return u.push(["launch",4]),u.push(["task",4]),u}e.getScopes=f}),define(re[69],se([0,1,17,3,34,2,38,29,14,8,18,43,40]),function(Z,e,k,t,T,L,A,I,b,P,D,E,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class C{constructor(n={},i=[],a=[]){this._contents=n,this._keys=i,this._overrides=a,this.frozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}isFrozen(){return this.frozen}getValue(n){return n?(0,D.getConfigurationValue)(this.contents,n):this.contents}getOverrideValue(n,i){const a=this.getContentsForOverrideIdentifer(i);return a?n?(0,D.getConfigurationValue)(a,n):a:void 0}getKeysForOverrideIdentifier(n){const i=[];for(const a of this.overrides)a.identifiers.includes(n)&&i.push(...a.keys);return k.distinct(i)}getAllOverrideIdentifiers(){const n=[];for(const i of this.overrides)n.push(...i.identifiers);return k.distinct(n)}override(n){let i=this.overrideConfigurations.get(n);return i||(i=this.createOverrideConfigurationModel(n),this.overrideConfigurations.set(n,i)),i}merge(...n){const i=I.deepClone(this.contents),a=I.deepClone(this.overrides),c=[...this.keys];for(const s of n)if(!s.isEmpty()){this.mergeContents(i,s.contents);for(const o of s.overrides){const[l]=a.filter(v=>k.equals(v.identifiers,o.identifiers));l?(this.mergeContents(l.contents,o.contents),l.keys.push(...o.keys),l.keys=k.distinct(l.keys)):a.push(I.deepClone(o))}for(const o of s.keys)c.indexOf(o)===-1&&c.push(o)}return new C(i,c,a)}freeze(){return this.frozen=!0,this}clone(){return new C(I.deepClone(this.contents),[...this.keys],I.deepClone(this.overrides))}createOverrideConfigurationModel(n){const i=this.getContentsForOverrideIdentifer(n);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const a={};for(const c of k.distinct([...Object.keys(this.contents),...Object.keys(i)])){let s=this.contents[c];const o=i[c];o&&(typeof s=="object"&&typeof o=="object"?(s=I.deepClone(s),this.mergeContents(s,o)):s=o),a[c]=s}return new C(a,this.keys,this.overrides)}mergeContents(n,i){for(const a of Object.keys(i)){if(a in n&&b.isObject(n[a])&&b.isObject(i[a])){this.mergeContents(n[a],i[a]);continue}n[a]=I.deepClone(i[a])}}checkAndFreeze(n){return this.frozen&&!Object.isFrozen(n)?I.deepFreeze(n):n}getContentsForOverrideIdentifer(n){let i=null,a=null;const c=s=>{s&&(a?this.mergeContents(a,s):a=I.deepClone(s))};for(const s of this.overrides)k.equals(s.identifiers,[n])?i=s.contents:s.identifiers.includes(n)&&c(s.contents);return c(i),a}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(n,i){this.addKey(n),(0,D.addToValueTree)(this.contents,n,i,a=>{throw new Error(a)})}removeValue(n){this.removeKey(n)&&(0,D.removeFromValueTree)(this.contents,n)}addKey(n){let i=this.keys.length;for(let a=0;a<i;a++)n.indexOf(this.keys[a])===0&&(i=a);this.keys.splice(i,1,n)}removeKey(n){const i=this.keys.indexOf(n);return i!==-1?(this.keys.splice(i,1),!0):!1}}e.ConfigurationModel=C;class h{constructor(n){this._name=n,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new C}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(n,i){if(!b.isUndefinedOrNull(n)){const a=this.doParseContent(n);this.parseRaw(a,i)}}reparse(n){this._raw&&this.parseRaw(this._raw,n)}parseRaw(n,i){this._raw=n;const{contents:a,keys:c,overrides:s,restricted:o}=this.doParseRaw(n,i);this._configurationModel=new C(a,c,s),this._restrictedConfigurations=o||[]}doParseContent(n){let i={},a=null,c=[];const s=[],o=[];function l(y){Array.isArray(c)?c.push(y):a!==null&&(c[a]=y)}const v={onObjectBegin:()=>{const y={};l(y),s.push(c),c=y,a=null},onObjectProperty:y=>{a=y},onObjectEnd:()=>{c=s.pop()},onArrayBegin:()=>{const y=[];l(y),s.push(c),c=y,a=null},onArrayEnd:()=>{c=s.pop()},onLiteralValue:l,onError:(y,O,_)=>{o.push({error:y,offset:O,length:_})}};if(n)try{T.visit(n,v),i=c[0]||{}}catch(y){console.error(`Error while parsing settings file ${this._name}: ${y}`),this._parseErrors=[y]}return i}doParseRaw(n,i){const a=p.Registry.as(E.Extensions.Configuration).getConfigurationProperties(),c=this.filter(n,a,!0,i);n=c.raw;const s=(0,D.toValuesTree)(n,v=>console.error(`Conflict in settings file ${this._name}: ${v}`)),o=Object.keys(n),l=this.toOverrides(n,v=>console.error(`Conflict in settings file ${this._name}: ${v}`));return{contents:s,keys:o,overrides:l,restricted:c.restricted}}filter(n,i,a,c){if(!c?.scopes&&!c?.skipRestricted)return{raw:n,restricted:[]};const s={},o=[];for(const l in n)if(E.OVERRIDE_PROPERTY_REGEX.test(l)&&a){const v=this.filter(n[l],i,!1,c);s[l]=v.raw,o.push(...v.restricted)}else{const v=i[l],y=v?typeof v.scope!="undefined"?v.scope:3:void 0;v?.restricted&&o.push(l),(y===void 0||c.scopes===void 0||c.scopes.includes(y))&&(c.skipRestricted&&v?.restricted||(s[l]=n[l]))}return{raw:s,restricted:o}}toOverrides(n,i){const a=[];for(const c of Object.keys(n))if(E.OVERRIDE_PROPERTY_REGEX.test(c)){const s={};for(const o in n[c])s[o]=n[c][o];a.push({identifiers:(0,E.overrideIdentifiersFromKey)(c),keys:Object.keys(s),contents:(0,D.toValuesTree)(s,i)})}return a}}e.ConfigurationModelParser=h;class S extends L.Disposable{constructor(n,i,a,c){super();this.userSettingsResource=n,this.scopes=i,this.fileService=c,this._onDidChange=this._register(new t.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new h(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(a.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(t.Event.any(t.Event.filter(this.fileService.onDidFilesChange,s=>s.contains(this.userSettingsResource)),t.Event.filter(this.fileService.onDidRunOperation,s=>(s.isOperation(0)||s.isOperation(3)||s.isOperation(1)||s.isOperation(4))&&a.isEqual(s.resource,n)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const n=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(n.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new C}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=S;class w{constructor(n,i,a,c,s=new C,o=new C,l=new A.ResourceMap,v=new C,y=new A.ResourceMap,O=!0){this._defaultConfiguration=n,this._policyConfiguration=i,this._applicationConfiguration=a,this._localUserConfiguration=c,this._remoteUserConfiguration=s,this._workspaceConfiguration=o,this._folderConfigurations=l,this._memoryConfiguration=v,this._memoryConfigurationByResource=y,this._freeze=O,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new A.ResourceMap,this._userConfiguration=null}getValue(n,i,a){return this.getConsolidatedConfigurationModel(n,i,a).getValue(n)}updateValue(n,i,a={}){let c;a.resource?(c=this._memoryConfigurationByResource.get(a.resource),c||(c=new C,this._memoryConfigurationByResource.set(a.resource,c))):c=this._memoryConfiguration,i===void 0?c.removeValue(n):c.setValue(n,i),a.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(n,i,a){const c=this.getConsolidatedConfigurationModel(n,i,a),s=this.getFolderConfigurationModelForResource(i.resource,a),o=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,l=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(n):this._defaultConfiguration.freeze().getValue(n),v=this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration.freeze().getValue(n),y=this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze().getValue(n),O=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(n):this.userConfiguration.freeze().getValue(n),_=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(n):this.localUserConfiguration.freeze().getValue(n),F=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(n):this.remoteUserConfiguration.freeze().getValue(n),R=a?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(n):this._workspaceConfiguration.freeze().getValue(n):void 0,U=s?i.overrideIdentifier?s.freeze().override(i.overrideIdentifier).getValue(n):s.freeze().getValue(n):void 0,M=i.overrideIdentifier?o.override(i.overrideIdentifier).getValue(n):o.getValue(n),V=c.getValue(n),W=k.distinct(c.overrides.map(z=>z.identifiers).flat()).filter(z=>c.getOverrideValue(n,z)!==void 0);return{defaultValue:l,policyValue:v,applicationValue:y,userValue:O,userLocalValue:_,userRemoteValue:F,workspaceValue:R,workspaceFolderValue:U,memoryValue:M,value:V,default:l!==void 0?{value:this._defaultConfiguration.freeze().getValue(n),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(n,i.overrideIdentifier):void 0}:void 0,policy:v!==void 0?{value:v}:void 0,application:y!==void 0?{value:y,override:i.overrideIdentifier?this.applicationConfiguration.freeze().getOverrideValue(n,i.overrideIdentifier):void 0}:void 0,user:O!==void 0?{value:this.userConfiguration.freeze().getValue(n),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(n,i.overrideIdentifier):void 0}:void 0,userLocal:_!==void 0?{value:this.localUserConfiguration.freeze().getValue(n),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(n,i.overrideIdentifier):void 0}:void 0,userRemote:F!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(n),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(n,i.overrideIdentifier):void 0}:void 0,workspace:R!==void 0?{value:this._workspaceConfiguration.freeze().getValue(n),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(n,i.overrideIdentifier):void 0}:void 0,workspaceFolder:U!==void 0?{value:s?.freeze().getValue(n),override:i.overrideIdentifier?s?.freeze().getOverrideValue(n,i.overrideIdentifier):void 0}:void 0,memory:M!==void 0?{value:o.getValue(n),override:i.overrideIdentifier?o.getOverrideValue(n,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:W.length?W:void 0}}keys(n){const i=this.getFolderConfigurationModelForResource(void 0,n);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(n){this._defaultConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(n){this._policyConfiguration=n}updateApplicationConfiguration(n){this._applicationConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(n){this._localUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(n){this._remoteUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(n){this._workspaceConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(n,i){this._folderConfigurations.set(n,i),this._foldersConsolidatedConfigurations.delete(n)}deleteFolderConfiguration(n){this.folderConfigurations.delete(n),this._foldersConsolidatedConfigurations.delete(n)}compareAndUpdateDefaultConfiguration(n,i){const a=[];if(!i){const{added:c,updated:s,removed:o}=f(this._defaultConfiguration,n);i=[...c,...s,...o]}for(const c of i)for(const s of(0,E.overrideIdentifiersFromKey)(c)){const o=this._defaultConfiguration.getKeysForOverrideIdentifier(s),l=n.getKeysForOverrideIdentifier(s),v=[...l.filter(y=>o.indexOf(y)===-1),...o.filter(y=>l.indexOf(y)===-1),...o.filter(y=>!I.equals(this._defaultConfiguration.override(s).getValue(y),n.override(s).getValue(y)))];a.push([s,v])}return this.updateDefaultConfiguration(n),{keys:i,overrides:a}}compareAndUpdatePolicyConfiguration(n){const{added:i,updated:a,removed:c}=f(this._policyConfiguration,n),s=[...i,...a,...c];return s.length&&this.updatePolicyConfiguration(n),{keys:s,overrides:[]}}compareAndUpdateApplicationConfiguration(n){const{added:i,updated:a,removed:c,overrides:s}=f(this.applicationConfiguration,n),o=[...i,...a,...c];return o.length&&this.updateApplicationConfiguration(n),{keys:o,overrides:s}}compareAndUpdateLocalUserConfiguration(n){const{added:i,updated:a,removed:c,overrides:s}=f(this.localUserConfiguration,n),o=[...i,...a,...c];return o.length&&this.updateLocalUserConfiguration(n),{keys:o,overrides:s}}compareAndUpdateRemoteUserConfiguration(n){const{added:i,updated:a,removed:c,overrides:s}=f(this.remoteUserConfiguration,n),o=[...i,...a,...c];return o.length&&this.updateRemoteUserConfiguration(n),{keys:o,overrides:s}}compareAndUpdateWorkspaceConfiguration(n){const{added:i,updated:a,removed:c,overrides:s}=f(this.workspaceConfiguration,n),o=[...i,...a,...c];return o.length&&this.updateWorkspaceConfiguration(n),{keys:o,overrides:s}}compareAndUpdateFolderConfiguration(n,i){const a=this.folderConfigurations.get(n),{added:c,updated:s,removed:o,overrides:l}=f(a,i),v=[...c,...s,...o];return(v.length||!a)&&this.updateFolderConfiguration(n,i),{keys:v,overrides:l}}compareAndDeleteFolderConfiguration(n){const i=this.folderConfigurations.get(n);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:a,updated:c,removed:s,overrides:o}=f(i,void 0);return{keys:[...a,...c,...s],overrides:o}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(n,i,a){let c=this.getConsolidatedConfigurationModelForResource(i,a);return i.overrideIdentifier&&(c=c.override(i.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(n)!==void 0&&(c=c.merge(this._policyConfiguration)),c}getConsolidatedConfigurationModelForResource({resource:n},i){let a=this.getWorkspaceConsolidatedConfiguration();if(i&&n){const c=i.getFolder(n);c&&(a=this.getFolderConsolidatedConfiguration(c.uri)||a);const s=this._memoryConfigurationByResource.get(n);s&&(a=a.merge(s))}return a}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(n){let i=this._foldersConsolidatedConfigurations.get(n);if(!i){const a=this.getWorkspaceConsolidatedConfiguration(),c=this._folderConfigurations.get(n);c?(i=a.merge(c),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(n,i)):i=a}return i}getFolderConfigurationModelForResource(n,i){if(i&&n){const a=i.getFolder(n);if(a)return this._folderConfigurations.get(a.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((n,i)=>{const{contents:a,overrides:c,keys:s}=this._folderConfigurations.get(i);return n.push([i,{contents:a,overrides:c,keys:s}]),n},[])}}allKeys(){const n=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>n.add(i)),this.userConfiguration.freeze().keys.forEach(i=>n.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>n.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(a=>n.add(a))),[...n.values()]}allOverrideIdentifiers(){const n=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>n.add(i)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>n.add(i)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>n.add(i)),this._folderConfigurations.forEach(i=>i.freeze().getAllOverrideIdentifiers().forEach(a=>n.add(a))),[...n.values()]}getAllKeysForOverrideIdentifier(n){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(n).forEach(a=>i.add(a)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(a=>i.add(a)),this._workspaceConfiguration.getKeysForOverrideIdentifier(n).forEach(a=>i.add(a)),this._folderConfigurations.forEach(a=>a.getKeysForOverrideIdentifier(n).forEach(c=>i.add(c))),[...i.values()]}static parse(n){const i=this.parseConfigurationModel(n.defaults),a=this.parseConfigurationModel(n.policy),c=this.parseConfigurationModel(n.application),s=this.parseConfigurationModel(n.user),o=this.parseConfigurationModel(n.workspace),l=n.folders.reduce((v,y)=>(v.set(P.URI.revive(y[0]),this.parseConfigurationModel(y[1])),v),new A.ResourceMap);return new w(i,a,c,s,new C,o,l,new C,new A.ResourceMap,!1)}static parseConfigurationModel(n){return new C(n.contents,n.keys,n.overrides).freeze()}}e.Configuration=w;function d(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const n=new Set,i=new Map;for(const c of r)c.keys.forEach(s=>n.add(s)),c.overrides.forEach(([s,o])=>{const l=(0,A.getOrSet)(i,s,new Set);o.forEach(v=>l.add(v))});const a=[];return i.forEach((c,s)=>a.push([s,[...c.values()]])),{keys:[...n.values()],overrides:a}}e.mergeChanges=d;class m{constructor(n,i,a,c){this.change=n,this.previous=i,this.currentConfiguraiton=a,this.currentWorkspace=c,this._previousConfiguration=void 0;const s=new Set;n.keys.forEach(l=>s.add(l)),n.overrides.forEach(([,l])=>l.forEach(v=>s.add(v))),this.affectedKeys=[...s.values()];const o=new C;this.affectedKeys.forEach(l=>o.setValue(l,{})),this.affectedKeysTree=o.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=w.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(n,i){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,n)){if(i){const a=this.previousConfiguration?this.previousConfiguration.getValue(n,i,this.previous?.workspace):void 0,c=this.currentConfiguraiton.getValue(n,i,this.currentWorkspace);return!I.equals(a,c)}return!0}return!1}doesAffectedKeysTreeContains(n,i){let a=(0,D.toValuesTree)({[i]:!0},()=>{}),c;for(;typeof a=="object"&&(c=Object.keys(a)[0]);){if(n=n[c],!n)return!1;a=a[c]}return!0}}e.ConfigurationChangeEvent=m;class g extends m{constructor(n,i,a,c){super({keys:n.allKeys(),overrides:[]},void 0,n,i);this.source=a,this.sourceConfig=c}}e.AllKeysConfigurationChangeEvent=g;function f(r,n){const{added:i,removed:a,updated:c}=u(n,r),s=[],o=r?.getAllOverrideIdentifiers()||[],l=n?.getAllOverrideIdentifiers()||[];if(n){const v=l.filter(y=>!o.includes(y));for(const y of v)s.push([y,n.getKeysForOverrideIdentifier(y)])}if(r){const v=o.filter(y=>!l.includes(y));for(const y of v)s.push([y,r.getKeysForOverrideIdentifier(y)])}if(n&&r){for(const v of o)if(l.includes(v)){const y=u({contents:r.getOverrideValue(void 0,v)||{},keys:r.getKeysForOverrideIdentifier(v)},{contents:n.getOverrideValue(void 0,v)||{},keys:n.getKeysForOverrideIdentifier(v)});s.push([v,[...y.added,...y.removed,...y.updated]])}}return{added:i,removed:a,updated:c,overrides:s}}function u(r,n){const i=r?n?r.keys.filter(s=>n.keys.indexOf(s)===-1):[...r.keys]:[],a=n?r?n.keys.filter(s=>r.keys.indexOf(s)===-1):[...n.keys]:[],c=[];if(r&&n){for(const s of n.keys)if(r.keys.indexOf(s)!==-1){const o=(0,D.getConfigurationValue)(n.contents,s),l=(0,D.getConfigurationValue)(r.contents,s);I.equals(o,l)||c.push(s)}}return{added:i,removed:a,updated:c}}}),define(re[195],se([0,1,17,3,2,29,14,18,69,43,7,58,40]),function(Z,e,k,t,T,L,A,I,b,P,D,E,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfigurationModel=e.DefaultConfiguration=void 0;class C extends T.Disposable{constructor(){super(...arguments);this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event}get configurationModel(){return this._configurationModel||(this._configurationModel=new h(this.getConfigurationDefaultOverrides())),this._configurationModel}async initialize(){return this._configurationModel=void 0,this._register(p.Registry.as(P.Extensions.Configuration).onDidUpdateConfiguration(({properties:m,defaultsOverrides:g})=>this.onDidUpdateConfiguration(m,g))),this.configurationModel}reload(){return this._configurationModel=void 0,this.configurationModel}onDidUpdateConfiguration(m,g){this._configurationModel=void 0,this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:m})}getConfigurationDefaultOverrides(){return{}}}e.DefaultConfiguration=C;class h extends b.ConfigurationModel{constructor(m={}){const g=p.Registry.as(P.Extensions.Configuration).getConfigurationProperties(),f=Object.keys(g),u=Object.create(null),r=[];for(const n in g){const i=m[n],a=i!==void 0?i:g[n].default;(0,I.addToValueTree)(u,n,a,c=>console.error(`Conflict in default settings: ${c}`))}for(const n of Object.keys(u))P.OVERRIDE_PROPERTY_REGEX.test(n)&&r.push({identifiers:(0,P.overrideIdentifiersFromKey)(n),keys:Object.keys(u[n]),contents:(0,I.toValuesTree)(u[n],i=>console.error(`Conflict in default settings file: ${i}`))});super(u,f,r)}}e.DefaultConfigurationModel=h;class S{constructor(){this.onDidChangeConfiguration=t.Event.None,this.configurationModel=new b.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=S;let w=class extends T.Disposable{constructor(m,g,f){super();this.defaultConfiguration=m,this.policyService=g,this.logService=f,this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new b.ConfigurationModel}get configurationModel(){return this._configurationModel}async initialize(){return this.update(await this.registerPolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(m=>this.onDidChangePolicies(m))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:m})=>this.update(await this.registerPolicyDefinitions(m),!0))),this._configurationModel}async registerPolicyDefinitions(m){const g={},f=[],u=p.Registry.as(P.Extensions.Configuration).getConfigurationProperties();for(const r of m){const n=u[r];if(!n){f.push(r);continue}if(n.policy){if(n.type!=="string"&&n.type!=="number"){this.logService.warn(`Policy ${n.policy.name} has unsupported type ${n.type}`);continue}f.push(r),g[n.policy.name]={type:n.type}}}return(0,A.isEmptyObject)(g)||await this.policyService.registerPolicyDefinitions(g),f}onDidChangePolicies(m){const g=p.Registry.as(P.Extensions.Configuration).getPolicyConfigurations(),f=(0,k.coalesce)(m.map(u=>g.get(u)));this.update(f,!0)}update(m,g){const f=p.Registry.as(P.Extensions.Configuration).getConfigurationProperties(),u=[],r=this._configurationModel.isEmpty();for(const n of m){const i=f[n]?.policy?.name;if(i){const a=this.policyService.getPolicyValue(i);(r?a!==void 0:!(0,L.equals)(this._configurationModel.getValue(n),a))&&u.push([n,a])}else this._configurationModel.getValue(n)!==void 0&&u.push([n,void 0])}if(u.length){const n=this._configurationModel;this._configurationModel=new b.ConfigurationModel;for(const i of n.keys)this._configurationModel.setValue(i,n.getValue(i));for(const[i,a]of u)a===void 0?this._configurationModel.removeValue(i):this._configurationModel.setValue(i,a);g&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};w=me([Q(1,E.IPolicyService),Q(2,D.ILogService)],w),e.PolicyConfiguration=w}),define(re[196],se([0,1,6,3,2,19,18,69,195,58]),function(Z,e,k,t,T,L,A,I,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class D extends T.Disposable{constructor(p,C,h,S){super();this.settingsResource=p,this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new b.DefaultConfiguration),this.policyConfiguration=h instanceof P.NullPolicyService?new b.NullPolicyConfiguration:this._register(new b.PolicyConfiguration(this.defaultConfiguration,h,S)),this.userConfiguration=this._register(new I.UserSettings(this.settingsResource,void 0,L.extUriBiasedIgnorePathCase,C)),this.configuration=new I.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,new I.ConfigurationModel,new I.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new k.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:w,properties:d})=>this.onDidDefaultConfigurationChange(w,d))),this._register(this.policyConfiguration.onDidChangeConfiguration(w=>this.onDidPolicyConfigurationChange(w))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[p,C,h]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new I.Configuration(p,C,new I.ConfigurationModel,h)}getConfigurationData(){return this.configuration.toData()}getValue(p,C){const h=typeof p=="string"?p:void 0,S=(0,A.isConfigurationOverrides)(p)?p:(0,A.isConfigurationOverrides)(C)?C:{};return this.configuration.getValue(h,S,void 0)}updateValue(p,C,h,S){return Promise.reject(new Error("not supported"))}inspect(p){return this.configuration.inspect(p,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const p=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(p)}onDidChangeUserConfiguration(p){const C=this.configuration.toData(),h=this.configuration.compareAndUpdateLocalUserConfiguration(p);this.trigger(h,C,1)}onDidDefaultConfigurationChange(p,C){const h=this.configuration.toData(),S=this.configuration.compareAndUpdateDefaultConfiguration(p,C);this.trigger(S,h,6)}onDidPolicyConfigurationChange(p){const C=this.configuration.toData(),h=this.configuration.compareAndUpdatePolicyConfiguration(p);this.trigger(h,C,6)}trigger(p,C,h){const S=new I.ConfigurationChangeEvent(p,{data:C},this.configuration);S.source=h,S.sourceConfig=this.getTargetConfiguration(h),this._onDidChangeConfiguration.fire(S)}getTargetConfiguration(p){switch(p){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=D}),define(re[197],se([0,1,9,5]),function(Z,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,t.createDecorator)("remoteAuthorityResolverService");var T;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound"})(T=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class L extends k.ErrorNoTelemetry{constructor(I,b=T.Unknown,P){super(I);this._message=I,this._code=b,this._detail=P,this.isHandled=b===T.NotAvailable&&P===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,L.prototype)}static isTemporarilyNotAvailable(I){return I instanceof L&&I._code===T.TemporarilyNotAvailable}static isNoResolverFound(I){return I instanceof L&&I._code===T.NoResolverFound}static isHandled(I){return I instanceof L&&I.isHandled}}e.RemoteAuthorityResolverError=L}),define(re[100],se([0,1,20]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function t(P){return P.scheme===k.Schemas.vscodeRemote?P.authority:void 0}e.getRemoteAuthority=t;function T(P){if(!P)return;const D=P.indexOf("+");return D<0?P:P.substr(0,D)}e.getRemoteName=T;function L(P){return`/${P.quality??"oss"}-${P.commit??"dev"}`}e.getRemoteServerRootPath=L;function A(P){const{host:D,port:E}=b(P);if(typeof E=="undefined")throw new Error("Remote authority doesn't contain a port!");return{host:D,port:E}}e.parseAuthorityWithPort=A;function I(P,D){let{host:E,port:p}=b(P);return typeof p=="undefined"&&(p=D),{host:E,port:p}}e.parseAuthorityWithOptionalPort=I;function b(P){const D=P.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(D)return{host:D[1],port:parseInt(D[2],10)};const E=P.match(/^(\[[0-9a-z:]+\])$/);if(E)return{host:E[1],port:void 0};const p=P.match(/(.*):(\d+)$/);return p?{host:p[1],port:parseInt(p[2],10)}:{host:P,port:void 0}}}),define(re[50],se([0,1,26,5,100]),function(Z,e,k,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function L(h){if(typeof h=="object"&&h!==null&&h.supported!==!0)return h.description}e.getWorkspaceSupportTypeMessage=L;function A(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(!h.uuid||typeof h.uuid=="string")}e.isIExtensionIdentifier=A,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var I;(function(h){h[h.System=0]="System",h[h.User=1]="User"})(I=e.ExtensionType||(e.ExtensionType={}));var b;(function(h){h.WIN32_X64="win32-x64",h.WIN32_IA32="win32-ia32",h.WIN32_ARM64="win32-arm64",h.LINUX_X64="linux-x64",h.LINUX_ARM64="linux-arm64",h.LINUX_ARMHF="linux-armhf",h.ALPINE_X64="alpine-x64",h.ALPINE_ARM64="alpine-arm64",h.DARWIN_X64="darwin-x64",h.DARWIN_ARM64="darwin-arm64",h.WEB="web",h.UNIVERSAL="universal",h.UNKNOWN="unknown",h.UNDEFINED="undefined"})(b=e.TargetPlatform||(e.TargetPlatform={}));class P{constructor(S){this.value=S,this._lower=S.toLowerCase()}static equals(S,w){if(typeof S=="undefined"||S===null)return typeof w=="undefined"||w===null;if(typeof w=="undefined"||w===null)return!1;if(typeof S=="string"||typeof w=="string"){const d=typeof S=="string"?S:S.value,m=typeof w=="string"?w:w.value;return k.equalsIgnoreCase(d,m)}return S._lower===w._lower}static toKey(S){return typeof S=="string"?S.toLowerCase():S._lower}}e.ExtensionIdentifier=P;function D(h){return E(h)}e.isApplicationScopedExtension=D;function E(h){return h.contributes&&h.contributes.localizations?h.contributes.localizations.length>0:!1}e.isLanguagePackExtension=E;function p(h){return h.contributes&&h.contributes.authentication?h.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=p;function C(h,S){if(S){const w=`onResolveRemoteAuthority:${(0,T.getRemoteName)(S)}`;return h.activationEvents?.indexOf(w)!==-1}return!1}e.isResolverExtension=C,e.IBuiltinExtensionsScannerService=(0,t.createDecorator)("IBuiltinExtensionsScannerService")}),define(re[32],se([0,1,26,30,50,4,8,9,36]),function(Z,e,k,t,T,L,A,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function P(i,a){return i.uuid&&a.uuid?i.uuid===a.uuid:i.id===a.id?!0:(0,k.compareIgnoreCase)(i.id,a.id)===0}e.areSameExtensions=P;const D=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class E{constructor(a,c,s="undefined"){this.version=c,this.targetPlatform=s,this.id=a.id}static create(a){const c=a.manifest?a.manifest.version:a.version,s=a.manifest?a.targetPlatform:a.properties.targetPlatform;return new E(a.identifier,c,s)}static parse(a){const c=D.exec(a);return c&&c[1]&&c[2]?new E({id:c[1]},c[2],c[4]||void 0):null}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(a){return a instanceof E?P(this,a)&&this.version===a.version&&this.targetPlatform===a.targetPlatform:!1}}e.ExtensionKey=E;const p=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function C(i){const a=p.exec(i);return a&&a[1]?[S(a[1]),a[2]]:[S(i),void 0]}e.getIdAndVersion=C;function h(i,a){return`${i}.${a}`}e.getExtensionId=h;function S(i){return i.toLocaleLowerCase()}e.adoptToGalleryExtensionId=S;function w(i,a){return S(h(i,a))}e.getGalleryExtensionId=w;function d(i,a){const c=[],s=o=>{for(const l of c)if(l.some(v=>P(a(v),a(o))))return l;return null};for(const o of i){const l=s(o);l?l.push(o):c.push([o])}return c}e.groupByExtension=d;function m(i){return{id:i.identifier.id,name:i.manifest.name,galleryId:null,publisherId:i.publisherId,publisherName:i.manifest.publisher,publisherDisplayName:i.publisherDisplayName,dependencies:i.manifest.extensionDependencies&&i.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=m;function g(i){return{id:i.identifier.id,name:i.name,galleryId:i.identifier.uuid,publisherId:i.publisherId,publisherName:i.publisher,publisherDisplayName:i.publisherDisplayName,isPreReleaseVersion:i.properties.isPreReleaseVersion,dependencies:!!(i.properties.dependencies&&i.properties.dependencies.length>0),...i.telemetryData}}e.getGalleryExtensionTelemetryData=g,e.BetterMergeId=new T.ExtensionIdentifier("pprice.better-merge");function f(i){const a=new Set;if(i.malicious)for(const c of i.malicious)a.add(c.id);return a}e.getMaliciousExtensionsSet=f;function u(i,a){const c=[],s=a.manifest.extensionDependencies?.slice(0)??[];for(;s.length;){const o=s.shift();if(o&&c.every(l=>!P(l.identifier,{id:o}))){const l=i.filter(v=>P(v.identifier,{id:o}));l.length===1&&(c.push(l[0]),s.push(...l[0].manifest.extensionDependencies?.slice(0)??[]))}}return c}e.getExtensionDependencies=u;async function r(i,a){if(!L.isLinux)return!1;let c;try{c=(await i.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{c=(await i.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(o){a.debug("Error while getting the os-release file.",(0,I.getErrorMessage)(o))}}return!!c&&(c.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=r;async function n(i,a){const c=await r(i,a),s=(0,t.getTargetPlatform)(c?"alpine":L.platform,b.arch);return a.debug("ComputeTargetPlatform:",s),s}e.computeTargetPlatform=n}),define(re[198],se([0,1,23,32]),function(Z,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.migrateUnsupportedExtensions=void 0;async function T(L,A,I,b,P){try{const D=await L.getExtensionsControlManifest();if(!D.deprecated)return;const E=await L.getInstalled(1);for(const[p,C]of Object.entries(D.deprecated)){if(!C?.extension)continue;const{id:h,autoMigrate:S,preRelease:w}=C.extension;if(!S)continue;const d=E.find(g=>(0,t.areSameExtensions)(g.identifier,{id:p}));if(!d)continue;const m=(await A.getExtensions([{id:h,preRelease:w}],{targetPlatform:await L.getTargetPlatform(),compatible:!0},k.CancellationToken.None))[0];if(!m){P.info(`Skipping migrating '${d.identifier.id}' extension because, the comaptible target '${h}' extension is not found`);continue}try{P.info(`Migrating '${d.identifier.id}' extension to '${h}' extension...`);const g=!b.getDisabledExtensions().some(u=>(0,t.areSameExtensions)(u,d.identifier));await L.uninstall(d),P.info(`Uninstalled the unsupported extension '${d.identifier.id}'`);let f=E.find(u=>(0,t.areSameExtensions)(u.identifier,{id:h}));(!f||!f.isPreReleaseVersion&&g)&&(f=await L.installFromGallery(m,{installPreReleaseVersion:!0,isMachineScoped:d.isMachineScoped,operation:4}),P.info(`Installed the pre-release extension '${f.identifier.id}'`),g||(await b.disableExtension(f.identifier),P.info(`Disabled the pre-release extension '${f.identifier.id}' because the unsupported extension '${d.identifier.id}' is disabled`)),S.storage&&(I.addToMigrationList((0,t.getExtensionId)(d.manifest.publisher,d.manifest.name),(0,t.getExtensionId)(f.manifest.publisher,f.manifest.name)),P.info("Added pre-release extension to the storage migration list"))),P.info(`Migrated '${d.identifier.id}' extension to '${h}' extension.`)}catch(g){P.error(g)}}}catch(D){P.error(D)}}e.migrateUnsupportedExtensions=T}),define(re[199],se([0,1,6,9,2,4,19,55,8,31,27,15,30,32,13,7]),function(Z,e,k,t,T,L,A,I,b,P,D,E,p,C,h,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let w=class extends T.Disposable{constructor(m,g,f,u){super();this.fileService=g,this.extensionGalleryService=f,this.logService=u,this.extensionsDownloadDir=b.URI.file(m.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(m,g){await this.cleanUpPromise;const f=this.getName(m),u=(0,A.joinPath)(this.extensionsDownloadDir,f);if(!await this.fileService.exists(u)){const r=(0,A.joinPath)(this.extensionsDownloadDir,`.${(0,P.generateUuid)()}`);await this.fileService.exists(r)||await this.extensionGalleryService.download(m,r,g);try{await this.rename(r,u,Date.now()+2*60*1e3)}catch(n){try{await this.fileService.del(r)}catch{}if(n.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",m.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,t.getErrorMessage)(n)}. Deleted the vsix from downloaded location`,r.path),n}}return u}async delete(m){await this.cleanUpPromise,await this.fileService.del(m)}async rename(m,g,f){try{await D.Promises.rename(m.fsPath,g.fsPath)}catch(u){if(L.isWindows&&u&&u.code==="EPERM"&&Date.now()<f)return this.logService.info(`Failed renaming ${m} to ${g} with 'EPERM' error. Trying again...`),this.rename(m,g,f);throw u}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const m=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(m.children){const g=[],f=[];for(const n of m.children){const i=C.ExtensionKey.parse(n.name);i&&f.push([i,n])}const u=(0,C.groupByExtension)(f,([n])=>n),r=[];for(const n of u)n.sort((i,a)=>I.rcompare(i[0].version,a[0].version)),g.push(...n.slice(1).map(i=>i[1].resource)),r.push(n[0][1]);r.sort((n,i)=>n.mtime-i.mtime),g.push(...r.slice(0,Math.max(0,r.length-this.cache)).map(n=>n.resource)),await k.Promises.settled(g.map(n=>(this.logService.trace("Deleting vsix from cache",n.path),this.fileService.del(n))))}}catch(m){this.logService.error(m)}}getName(m){return this.cache?C.ExtensionKey.create(m).toString().toLowerCase():(0,P.generateUuid)()}};w=me([Q(0,E.INativeEnvironmentService),Q(1,h.IFileService),Q(2,p.IExtensionGalleryService),Q(3,S.ILogService)],w),e.ExtensionsDownloader=w}),define(re[200],se([0,1,2,12,27,50]),function(Z,e,k,t,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class A extends k.Disposable{constructor(b,P){super();this.environmentService=b,this.extensionsManifestCache=(0,t.join)(this.environmentService.userDataPath,L.MANIFEST_CACHE_FOLDER,L.USER_MANIFEST_CACHE_FILE),this._register(P.onDidInstallExtensions(D=>this.onDidInstallExtensions(D))),this._register(P.onDidUninstallExtension(D=>this.onDidUnInstallExtension(D)))}onDidInstallExtensions(b){b.some(P=>!!P.local)&&this.invalidate()}onDidUnInstallExtension(b){b.error||this.invalidate()}invalidate(){T.Promises.rm(this.extensionsManifestCache,T.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=A}),define(re[201],se([0,1,93,17,6,2,20,12,27,15,30,32,7,67]),function(Z,e,k,t,T,L,A,I,b,P,D,E,p,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0;let h=class extends C.LanguagePackBaseService{constructor(m,g,f,u){super(f);this.extensionManagementService=m,this.logService=u,this.cache=this._register(new S(g,u)),this.extensionManagementService.registerParticipant({postInstall:async r=>this.postInstallExtension(r),postUninstall:async r=>this.postUninstallExtension(r)})}async getInstalledLanguages(){const m=await this.cache.getLanguagePacks(),g=Object.keys(m).map(f=>{const u=m[f];return{...this.createQuickPickItem({locale:f,label:u.label}),extensionId:u.extensions[0].extensionIdentifier.id}});return g.push({...this.createQuickPickItem({locale:"en",label:"English"}),extensionId:"default"}),g}async postInstallExtension(m){m&&m.manifest&&m.manifest.contributes&&m.manifest.contributes.localizations&&m.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",m.identifier.id),await this.update())}async postUninstallExtension(m){const g=await this.cache.getLanguagePacks();Object.keys(g).some(f=>g[f]&&g[f].extensions.some(u=>(0,E.areSameExtensions)(u.extensionIdentifier,m.identifier)))&&(this.logService.info("Removing language packs from the extension",m.identifier.id),await this.update())}async update(){const[m,g]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),f=await this.cache.update(g);return!(0,t.equals)(Object.keys(m),Object.keys(f))}};h=me([Q(0,D.IExtensionManagementService),Q(1,P.INativeEnvironmentService),Q(2,D.IExtensionGalleryService),Q(3,p.ILogService)],h),e.NativeLanguagePackService=h;let S=class extends L.Disposable{constructor(m,g){super();this.logService=g,this.languagePacks={},this.languagePacksFilePath=(0,I.join)(m.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new T.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(m){return this.withLanguagePacks(g=>{Object.keys(g).forEach(f=>delete g[f]),this.createLanguagePacksFromExtensions(g,...m)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(m,...g){for(const f of g)f&&f.manifest&&f.manifest.contributes&&f.manifest.contributes.localizations&&f.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(m,f);Object.keys(m).forEach(f=>this.updateHash(m[f]))}createLanguagePacksFromExtension(m,g){const f=g.identifier,u=g.manifest.contributes&&g.manifest.contributes.localizations?g.manifest.contributes.localizations:[];for(const r of u)if(g.location.scheme===A.Schemas.file&&w(r)){let n=m[r.languageId];n||(n={hash:"",extensions:[],translations:{},label:r.localizedLanguageName??r.languageName},m[r.languageId]=n);const i=n.extensions.filter(a=>(0,E.areSameExtensions)(a.extensionIdentifier,f))[0];i?i.version=g.manifest.version:n.extensions.push({extensionIdentifier:f,version:g.manifest.version});for(const a of r.translations)n.translations[a.id]=(0,I.join)(g.location.fsPath,a.path)}}updateHash(m){if(m){const g=(0,k.createHash)("md5");for(const f of m.extensions)g.update(f.extensionIdentifier.uuid||f.extensionIdentifier.id).update(f.version);m.hash=g.digest("hex")}}withLanguagePacks(m=()=>null){return this.languagePacksFileLimiter.queue(()=>{let g=null;return b.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,f=>f.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(f)).then(f=>{try{return JSON.parse(f)}catch{return{}}}).then(f=>(g=m(f),f)).then(f=>{for(const r of Object.keys(f))f[r]||delete f[r];this.languagePacks=f,this.initializedCache=!0;const u=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",u),b.Promises.writeFile(this.languagePacksFilePath,u)}).then(()=>g,f=>this.logService.error(f))})}};S=me([Q(0,P.INativeEnvironmentService),Q(1,p.ILogService)],S);function w(d){if(typeof d.languageId!="string"||!Array.isArray(d.translations)||d.translations.length===0)return!1;for(const m of d.translations)if(typeof m.id!="string"||typeof m.path!="string")return!1;return!(d.languageName&&typeof d.languageName!="string"||d.localizedLanguageName&&typeof d.localizedLanguageName!="string")}}),define(re[202],se([0,1,6,16,23,9,3,2,31,84,197,100]),function(Z,e,k,t,T,L,A,I,b,P,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const p=30*1e3;var C;(function(x){x[x.Management=1]="Management",x[x.ExtensionHost=2]="ExtensionHost",x[x.Tunnel=3]="Tunnel"})(C=e.ConnectionType||(e.ConnectionType={}));function h(x){switch(x){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function S(x){const B=new T.CancellationTokenSource;return setTimeout(()=>B.cancel(),x),B.token}function w(x,B){if(x.isCancellationRequested||B.isCancellationRequested)return T.CancellationToken.Cancelled;const J=new T.CancellationTokenSource;return x.onCancellationRequested(()=>J.cancel()),B.onCancellationRequested(()=>J.cancel()),J.token}class d{constructor(B){this._state="pending",this._disposables=new I.DisposableStore,this.promise=new Promise((J,N)=>{this._resolvePromise=J,this._rejectPromise=N}),B.isCancellationRequested?this._timeout():this._disposables.add(B.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(B){this._state==="pending"?this._disposables.add(B):B.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const B=new Error("Time limit reached");return B.code="ETIMEDOUT",B.syscall="connect",B}resolve(B){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(B))}reject(B){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(B))}}function m(x,B){const J=new d(B);return J.registerDisposable(x.onControlMessage(N=>{const $=JSON.parse(N.toString()),j=te($);j?J.reject(j):J.resolve($)})),J.promise}function g(x,B,J,N,$,j,G,q){const ee=new d(q);return B.connect(J,N,$,j,G,(ne,oe)=>{ee.didTimeout?(ne&&x.error(ne),oe?.dispose()):ne||!oe?ee.reject(ne):ee.resolve(oe)}),ee.promise}function f(x,B){const J=new d(B);return x.then(N=>{J.didTimeout||J.resolve(N)},N=>{J.didTimeout||J.reject(N)}),J.promise}async function u(x,B,J,N){const $=X(x,B);x.logService.trace(`${$} 1/6. invoking socketFactory.connect().`);let j;try{j=await g(x.logService,x.socketFactory,x.host,x.port,(0,E.getRemoteServerRootPath)(x),`reconnectionToken=${x.reconnectionToken}&reconnection=${x.reconnectionProtocol?"true":"false"}`,`renderer-${h(B)}-${x.reconnectionToken}`,N)}catch(oe){throw x.logService.error(`${$} socketFactory.connect() failed or timed out. Error:`),x.logService.error(oe),oe}x.logService.trace(`${$} 2/6. socketFactory.connect() was successful.`);let G,q;x.reconnectionProtocol?(x.reconnectionProtocol.beginAcceptReconnection(j,null),G=x.reconnectionProtocol,q=!1):(G=new P.PersistentProtocol(j,null),q=!0),x.logService.trace(`${$} 3/6. sending AuthRequest control message.`);const ee=await f(x.signService.createNewMessage((0,b.generateUuid)()),N),ne={type:"auth",auth:x.connectionToken||"00000000000000000000",data:ee.data};G.sendControl(t.VSBuffer.fromString(JSON.stringify(ne)));try{const oe=await m(G,w(N,S(1e4)));if(oe.type!=="sign"||typeof oe.data!="string"){const pe=new Error("Unexpected handshake message");throw pe.code="VSCODE_CONNECTION_ERROR",pe}if(x.logService.trace(`${$} 4/6. received SignRequest control message.`),!await f(x.signService.validate(ee,oe.signedData),N)){const pe=new Error("Refused to connect to unsupported server");throw pe.code="VSCODE_CONNECTION_ERROR",pe}const Se=await f(x.signService.sign(oe.data),N),fe={type:"connectionType",commit:x.commit,signedData:Se,desiredConnectionType:B};return J&&(fe.args=J),x.logService.trace(`${$} 5/6. sending ConnectionTypeRequest control message.`),G.sendControl(t.VSBuffer.fromString(JSON.stringify(fe))),{protocol:G,ownsProtocol:q}}catch(oe){throw oe&&oe.code==="ETIMEDOUT"&&(x.logService.error(`${$} the handshake timed out. Error:`),x.logService.error(oe)),oe&&oe.code==="VSCODE_CONNECTION_ERROR"&&(x.logService.error(`${$} received error control message when negotiating connection. Error:`),x.logService.error(oe)),q&&z(G),oe}}async function r(x,B,J,N){const $=Date.now(),j=X(x,B),{protocol:G,ownsProtocol:q}=await u(x,B,J,N),ee=new d(N);return ee.registerDisposable(G.onControlMessage(ne=>{const oe=JSON.parse(ne.toString()),le=te(oe);le?(x.logService.error(`${j} received error control message when negotiating connection. Error:`),x.logService.error(le),q&&z(G),ee.reject(le)):(x.reconnectionProtocol&&x.reconnectionProtocol.endAcceptReconnection(),x.logService.trace(`${j} 6/6. handshake finished, connection is up and running after ${Y($)}!`),ee.resolve({protocol:G,firstMessage:oe}))})),ee.promise}async function n(x,B){const{protocol:J}=await r(x,1,void 0,B);return{protocol:J}}async function i(x,B,J){const{protocol:N,firstMessage:$}=await r(x,2,B,J),j=$&&$.debugPort;return{protocol:N,debugPort:j}}async function a(x,B,J){const N=Date.now(),$=X(x,3),{protocol:j}=await u(x,3,B,J);return x.logService.trace(`${$} 6/6. handshake finished, connection is up and running after ${Y(N)}!`),j}async function c(x,B,J){const{host:N,port:$,connectionToken:j}=await x.addressProvider.getAddress();return{commit:x.commit,quality:x.quality,host:N,port:$,connectionToken:j,reconnectionToken:B,reconnectionProtocol:J,socketFactory:x.socketFactory,signService:x.signService,logService:x.logService}}async function s(x,B,J){try{const N=(0,b.generateUuid)(),$=await c(x,N,null),{protocol:j}=await n($,T.CancellationToken.None);return new V(x,B,J,N,j)}catch(N){throw x.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),x.logService.error(N),M.triggerPermanentFailure(0,0,D.RemoteAuthorityResolverError.isHandled(N)),N}}e.connectRemoteAgentManagement=s;async function o(x,B){try{const J=(0,b.generateUuid)(),N=await c(x,J,null),{protocol:$,debugPort:j}=await i(N,B,T.CancellationToken.None);return new W(x,B,J,$,j)}catch(J){throw x.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),x.logService.error(J),M.triggerPermanentFailure(0,0,D.RemoteAuthorityResolverError.isHandled(J)),J}}e.connectRemoteAgentExtensionHost=o;async function l(x,B,J){const N=await c(x,(0,b.generateUuid)(),null);return await a(N,{host:B,port:J},T.CancellationToken.None)}e.connectRemoteAgentTunnel=l;function v(x){return(0,k.createCancelablePromise)(B=>new Promise((J,N)=>{const $=setTimeout(J,x*1e3);B.onCancellationRequested(()=>{clearTimeout($),J()})}))}var y;(function(x){x[x.ConnectionLost=0]="ConnectionLost",x[x.ReconnectionWait=1]="ReconnectionWait",x[x.ReconnectionRunning=2]="ReconnectionRunning",x[x.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",x[x.ConnectionGain=4]="ConnectionGain"})(y=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class O{constructor(B,J){this.reconnectionToken=B,this.millisSinceLastIncomingData=J,this.type=0}}e.ConnectionLostEvent=O;class _{constructor(B,J,N,$){this.reconnectionToken=B,this.millisSinceLastIncomingData=J,this.durationSeconds=N,this.cancellableTimer=$,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=_;class F{constructor(B,J,N){this.reconnectionToken=B,this.millisSinceLastIncomingData=J,this.attempt=N,this.type=2}}e.ReconnectionRunningEvent=F;class R{constructor(B,J,N){this.reconnectionToken=B,this.millisSinceLastIncomingData=J,this.attempt=N,this.type=4}}e.ConnectionGainEvent=R;class U{constructor(B,J,N,$){this.reconnectionToken=B,this.millisSinceLastIncomingData=J,this.attempt=N,this.handled=$,this.type=3}}e.ReconnectionPermanentFailureEvent=U;class M extends I.Disposable{constructor(B,J,N,$,j){super();this._connectionType=B,this._options=J,this.reconnectionToken=N,this.protocol=$,this._reconnectionFailureIsFatal=j,this._onDidStateChange=this._register(new A.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._permanentFailure=!1,this._isReconnecting=!1,this._onDidStateChange.fire(new R(this.reconnectionToken,0,0)),this._register($.onSocketClose(G=>{const q=K(this._connectionType,this.reconnectionToken,!0);G?G.type===0?(this._options.logService.info(`${q} received socket close event (hadError: ${G.hadError}).`),G.error&&this._options.logService.error(G.error)):(this._options.logService.info(`${q} received socket close event (wasClean: ${G.wasClean}, code: ${G.code}, reason: ${G.reason}).`),G.event&&this._options.logService.error(G.event)):this._options.logService.info(`${q} received socket close event.`),this._beginReconnecting()})),this._register($.onSocketTimeout(()=>{const G=K(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${G} received socket timeout event.`),this._beginReconnecting()})),M._instances.push(this),this._register((0,I.toDisposable)(()=>{const G=M._instances.indexOf(this);G>=0&&M._instances.splice(G,1)})),this._isPermanentFailure&&this._gotoPermanentFailure(M._permanentFailureMillisSinceLastIncomingData,M._permanentFailureAttempt,M._permanentFailureHandled)}static triggerPermanentFailure(B,J,N){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=B,this._permanentFailureAttempt=J,this._permanentFailureHandled=N,this._instances.forEach($=>$._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(B=>B._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(B=>B._pauseSocketWriting())}get _isPermanentFailure(){return this._permanentFailure||M._permanentFailure}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(this._isPermanentFailure)return;const B=K(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${B} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new O(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const J=[0,5,5,10,10,10,10,10,30];let N=-1;do{N++;const $=N<J.length?J[N]:J[J.length-1];try{if($>0){const G=v($);this._onDidStateChange.fire(new _(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),$,G)),this._options.logService.info(`${B} waiting for ${$} seconds before reconnecting...`);try{await G}catch{}}if(this._isPermanentFailure){this._options.logService.error(`${B} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),N+1)),this._options.logService.info(`${B} resolving connection...`);const j=await c(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${B} connecting to ${j.host}:${j.port}...`),await this._reconnect(j,S(p)),this._options.logService.info(`${B} reconnected!`),this._onDidStateChange.fire(new R(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),N+1));break}catch(j){if(j.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${B} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(j),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),N+1,!1);break}if(N>360){this._options.logService.error(`${B} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(j),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),N+1,!1);break}if(D.RemoteAuthorityResolverError.isTemporarilyNotAvailable(j)){this._options.logService.info(`${B} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(j);continue}if((j.code==="ETIMEDOUT"||j.code==="ENETUNREACH"||j.code==="ECONNREFUSED"||j.code==="ECONNRESET")&&j.syscall==="connect"){this._options.logService.info(`${B} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(j);continue}if((0,L.isCancellationError)(j)){this._options.logService.info(`${B} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(j);continue}if(j instanceof D.RemoteAuthorityResolverError){this._options.logService.error(`${B} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(j),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),N+1,D.RemoteAuthorityResolverError.isHandled(j));break}this._options.logService.error(`${B} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(j),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),N+1,!1);break}}while(!this._isPermanentFailure)}_onReconnectionPermanentFailure(B,J,N){this._reconnectionFailureIsFatal?M.triggerPermanentFailure(B,J,N):this._gotoPermanentFailure(B,J,N)}_gotoPermanentFailure(B,J,N){this._onDidStateChange.fire(new U(this.reconnectionToken,B,J,N)),z(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=M,M._permanentFailure=!1,M._permanentFailureMillisSinceLastIncomingData=0,M._permanentFailureAttempt=0,M._permanentFailureHandled=!1,M._instances=[];class V extends M{constructor(B,J,N,$,j){super(1,B,$,j,!0);this.client=this._register(new P.Client(j,{remoteAuthority:J,clientId:N},B.ipcLogger))}async _reconnect(B,J){await n(B,J)}}e.ManagementPersistentConnection=V;class W extends M{constructor(B,J,N,$,j){super(2,B,N,$,!1);this._startArguments=J,this.debugPort=j}async _reconnect(B,J){await i(B,this._startArguments,J)}}e.ExtensionHostPersistentConnection=W;function z(x){try{x.acceptDisconnect();const B=x.getSocket();x.dispose(),B.dispose()}catch(B){(0,L.onUnexpectedError)(B)}}function te(x){if(x&&x.type==="error"){const B=new Error(`Connection error: ${x.reason}`);return B.code="VSCODE_CONNECTION_ERROR",B}return null}function H(x,B){for(;x.length<B;)x+=" ";return x}function K(x,B,J){return`[remote-connection][${H(h(x),13)}][${B.substr(0,5)}\u2026][${J?"reconnect":"initial"}]`}function X(x,B){return`${K(B,x.reconnectionToken,!!x.reconnectionProtocol)}[${x.host}:${x.port}]`}function Y(x){return`${Date.now()-x} ms`}}),define(re[203],se([0,1,5]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessTunnelChannelName=e.ISharedProcessTunnelService=void 0,e.ISharedProcessTunnelService=(0,k.createDecorator)("sharedProcessTunnelService"),e.ipcSharedProcessTunnelChannelName="sharedProcessTunnel"}),define(re[204],se([0,1,119,18,7]),function(Z,e,k,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let L=class{constructor(I,b){this.configurationService=I,this.logService=b}async request(I,b){this.logService.trace("RequestService#request (browser) - begin",I.url),I.proxyAuthorization||(I.proxyAuthorization=this.configurationService.getValue("http.proxyAuthorization"));try{const P=await(0,k.request)(I,b);return this.logService.trace("RequestService#request (browser) - success",I.url),P}catch(P){throw this.logService.error("RequestService#request (browser) - error",I.url,P),P}}async resolveProxy(I){}};L=me([Q(0,t.IConfigurationService),Q(1,T.ILogService)],L),e.RequestService=L}),define(re[44],se([0,1,16,153,43,5,40]),function(Z,e,k,t,T,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,L.createDecorator)("requestService");function I(S){return S.res.statusCode&&S.res.statusCode>=200&&S.res.statusCode<300||S.res.statusCode===1223}e.isSuccess=I;function b(S){return S.res.statusCode===204}async function P(S){return b(S)?null:(await(0,k.streamToBuffer)(S.stream)).toString()}e.asText=P;async function D(S){if(!I(S))throw new Error("Server returned "+S.res.statusCode);return P(S)}e.asTextOrError=D;async function E(S){if(!I(S))throw new Error("Server returned "+S.res.statusCode);if(b(S))return null;const d=(await(0,k.streamToBuffer)(S.stream)).toString();try{return JSON.parse(d)}catch(m){throw m.message+=`:
`+d,m}}e.asJson=E;function p(S){h(S)}e.updateProxyConfigurationsScope=p;let C;function h(S){const w=A.Registry.as(T.Extensions.Configuration),d=C;C={id:"http",order:15,title:(0,t.localize)(0,null),type:"object",scope:S,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,t.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,t.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,t.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,t.localize)(4,null),(0,t.localize)(5,null),(0,t.localize)(6,null),(0,t.localize)(7,null)],default:"override",description:(0,t.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,t.localize)(9,null),restricted:!0}}},w.updateConfigurations({add:[C],remove:d?[d]:[]})}h(2)}),define(re[205],se([0,1,23,20,13,44]),function(Z,e,k,t,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let A=class{constructor(b,P){this.requestService=b,this.fileService=P}async download(b,P,D=k.CancellationToken.None){if(b.scheme===t.Schemas.file||b.scheme===t.Schemas.vscodeRemote){await this.fileService.copy(b,P);return}const E={type:"GET",url:b.toString(!0)},p=await this.requestService.request(E,D);if(p.res.statusCode===200)await this.fileService.writeFile(P,p.stream);else{const C=await(0,L.asTextOrError)(p);throw new Error(`Expected 200, got back ${p.res.statusCode} instead.

${C}`)}}};A=me([Q(0,L.IRequestService),Q(1,T.IFileService)],A),e.DownloadService=A}),define(re[206],se([0,1,17,23,75,2,19,169,13,7,24,44]),function(Z,e,k,t,T,L,A,I,b,P,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let p=class extends L.Disposable{constructor(h,S,w,d){super();this.fileService=h,this.productService=S,this.requestService=w,this.logService=d,this.allConfigBasedTips=new Map,this.productService.configBasedExtensionTips&&(0,T.forEach)(this.productService.configBasedExtensionTips,({value:m})=>this.allConfigBasedTips.set(m.configPath,m))}getConfigBasedTips(h){return this.getValidConfigBasedTips(h)}getAllWorkspacesTips(){return this.fetchWorkspacesTips()}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async getValidConfigBasedTips(h){const S=[];for(const[w,d]of this.allConfigBasedTips)if(!(d.configScheme&&d.configScheme!==h.scheme))try{const m=await this.fileService.readFile((0,A.joinPath)(h,w)),g=new Map;(0,T.forEach)(d.recommendations,({key:u,value:r})=>{if((0,k.isNonEmptyArray)(r.remotes))for(const n of r.remotes)g.set(n,{extensionId:u,extensionName:r.name,configName:d.configName,important:!!r.important,isExtensionPack:!!r.isExtensionPack,whenNotInstalled:r.whenNotInstalled});else S.push({extensionId:u,extensionName:r.name,configName:d.configName,important:!!r.important,isExtensionPack:!!r.isExtensionPack,whenNotInstalled:r.whenNotInstalled})});const f=(0,I.getDomainsOfRemotes)(m.value.toString(),[...g.keys()]);for(const u of f){const r=g.get(u);r&&S.push(r)}}catch{}return S}async fetchWorkspacesTips(){if(!this.productService.extensionsGallery?.recommendationsUrl)return[];try{const h=await this.requestService.request({type:"GET",url:this.productService.extensionsGallery?.recommendationsUrl},t.CancellationToken.None);if(h.res.statusCode!==200)return[];const S=await(0,E.asJson)(h);return S?S.workspaceRecommendations||[]:[]}catch(h){return this.logService.error(h),[]}}};p=me([Q(0,b.IFileService),Q(1,D.IProductService),Q(2,E.IRequestService),Q(3,P.ILogService)],p),e.ExtensionTipsService=p}),define(re[101],se([0,1,63,5]),function(Z,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessWorkerChannelName=e.ISharedProcessWorkerService=e.hash=void 0;function T(L){return(0,k.hash)({moduleId:L.process.moduleId,windowId:L.reply.windowId})}e.hash=T,e.ISharedProcessWorkerService=(0,t.createDecorator)("sharedProcessWorkerService"),e.ipcSharedProcessWorkerChannelName="sharedProcessWorker"}),define(re[207],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerMessages=void 0;var k;(function(t){t.Spawn="vscode:shared-process->shared-process-worker=spawn",t.Terminate="vscode:shared-process->shared-process-worker=terminate",t.SelfTerminated="vscode:shared-process-worker->shared-process=selfTerminated",t.Ready="vscode:shared-process-worker->shared-process=ready",t.Ack="vscode:shared-process-worker->shared-process=ack",t.Trace="vscode:shared-process-worker->shared-process=trace",t.Info="vscode:shared-process-worker->shared-process=info",t.Warn="vscode:shared-process-worker->shared-process=warn",t.Error="vscode:shared-process-worker->shared-process=error"})(k=e.SharedProcessWorkerMessages||(e.SharedProcessWorkerMessages={}))}),define(re[208],se([0,1,85,6,23,3,2,20,31,7,101,207]),function(Z,e,k,t,T,L,A,I,b,P,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerService=void 0;let p=class{constructor(S){this.logService=S,this.workers=new Map,this.processeDisposables=new Map,this.processResolvers=new Map}async createWorker(S){const w=`window: ${S.reply.windowId}, moduleId: ${S.process.moduleId}`;this.logService.trace(`SharedProcess: createWorker (${w})`);const d=(0,D.hash)(S);this.processeDisposables.has(d)&&(this.logService.warn(`SharedProcess: createWorker found an existing worker that will be terminated (${w})`),this.doDisposeWorker(S));const m=new T.CancellationTokenSource;let g,f,u;this.processeDisposables.set(d,a=>{m.dispose(!0),g?.terminate(S,T.CancellationToken.None),f?.close(),u?.close(),this.processeDisposables.delete(d);const c=this.processResolvers.get(d);c&&(this.processResolvers.delete(d),c({reason:a}))}),g=await this.getOrCreateWebWorker(S);const r=new Promise(a=>{this.processResolvers.set(d,a)});if(m.token.isCancellationRequested)return r;const{port1:n,port2:i}=new MessageChannel;return f=n,u=i,await g.spawn(S,u,m.token),m.token.isCancellationRequested||(this.logService.trace(`SharedProcess: createWorker sending message port back to window (${w})`),k.ipcRenderer.postMessage("vscode:relaySharedProcessWorkerMessageChannel",S,[f])),r}getOrCreateWebWorker(S){let w=this.workers.get(S.process.moduleId);if(!w){this.logService.trace(`SharedProcess: creating new web worker (${S.process.moduleId})`);const d=new C(S.process.type,this.logService);w=d.init(),d.onDidProcessSelfTerminate(({configuration:m,reason:g})=>{this.doDisposeWorker(m,g)}),this.workers.set(S.process.moduleId,w)}return w}async disposeWorker(S){return this.doDisposeWorker(S)}doDisposeWorker(S,w){const d=this.processeDisposables.get((0,D.hash)(S));d&&(this.logService.trace(`SharedProcess: disposeWorker (window: ${S.reply.windowId}, moduleId: ${S.process.moduleId})`),d(w))}};p=me([Q(0,P.ILogService)],p),e.SharedProcessWorkerService=p;class C extends A.Disposable{constructor(S,w){super();this.type=S,this.logService=w,this._onDidProcessSelfTerminate=this._register(new L.Emitter),this.onDidProcessSelfTerminate=this._onDidProcessSelfTerminate.event,this.workerReady=this.doInit(),this.mapMessageNonceToPendingMessageResolve=new Map}async init(){return await this.workerReady,this}doInit(){const S=new t.DeferredPromise,w=new Worker("../../../base/worker/workerMain.js",{name:`Shared Process Worker (${this.type})`});return w.onerror=d=>{this.logService.error(`SharedProcess: worker error (${this.type})`,d.message)},w.onmessageerror=d=>{this.logService.error(`SharedProcess: worker message error (${this.type})`,d)},w.onmessage=d=>{const{id:m,message:g,configuration:f,nonce:u}=d.data;switch(m){case E.SharedProcessWorkerMessages.Ready:S.complete(w);break;case E.SharedProcessWorkerMessages.Ack:if(u){const r=this.mapMessageNonceToPendingMessageResolve.get(u);r&&(this.mapMessageNonceToPendingMessageResolve.delete(u),r())}break;case E.SharedProcessWorkerMessages.SelfTerminated:f&&g&&this._onDidProcessSelfTerminate.fire({configuration:f,reason:JSON.parse(g)});break;case E.SharedProcessWorkerMessages.Trace:this.logService.trace(`SharedProcess (worker, ${this.type}):`,g);break;case E.SharedProcessWorkerMessages.Info:g&&this.logService.info(g);break;case E.SharedProcessWorkerMessages.Warn:this.logService.warn(`SharedProcess (worker, ${this.type}):`,g);break;case E.SharedProcessWorkerMessages.Error:this.logService.error(`SharedProcess (worker, ${this.type}):`,g);break;default:this.logService.warn(`SharedProcess: unexpected worker message (${this.type})`,d)}},w.postMessage("vs/platform/sharedProcess/electron-browser/sharedProcessWorkerMain"),S.p}async send(S,w,d){const m=await this.workerReady;if(!w.isCancellationRequested)return new Promise(g=>{const f=(0,b.generateUuid)();this.mapMessageNonceToPendingMessageResolve.set(f,g);const u={...S,nonce:f};d?m.postMessage(u,[d]):m.postMessage(u),w.onCancellationRequested(()=>{this.mapMessageNonceToPendingMessageResolve.delete(f)&&g()})})}spawn(S,w,d){const m={id:E.SharedProcessWorkerMessages.Spawn,configuration:S,environment:{bootstrapPath:I.FileAccess.asFileUri("bootstrap-fork",Z).fsPath}};return this.send(m,d,w)}terminate(S,w){const d={id:E.SharedProcessWorkerMessages.Terminate,configuration:S};return this.send(d,w)}}}),define(re[209],se([0,1,60,20,168]),function(Z,e,k,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessEnvironmentService=void 0;class L extends T.NativeEnvironmentService{get userRoamingDataHome(){return this.appSettingsHome.with({scheme:t.Schemas.vscodeUserData})}}me([k.memoize],L.prototype,"userRoamingDataHome",null),e.SharedProcessEnvironmentService=L}),define(re[210],se([0,1,48,12,154,23,37,9,4,31,136,166,6]),function(Z,e,k,t,T,L,A,I,b,P,D,E,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const C=1e4;let h;async function S(d,m,g){return m["force-disable-user-env"]?(d.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):b.isWindows?(d.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,E.isLaunchedFromCli)(g)&&!m["force-user-env"]?(d.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,E.isLaunchedFromCli)(g)?d.trace("resolveShellEnv(): running (--force-user-env)"):d.trace("resolveShellEnv(): running (macOS/Linux)"),h||(h=p.Promises.withAsyncBody(async(f,u)=>{const r=new L.CancellationTokenSource,n=setTimeout(()=>{r.dispose(!0),u(new Error((0,T.localize)(0,null)))},C);try{f(await w(d,r.token))}catch(i){!(0,I.isCancellationError)(i)&&!r.token.isCancellationRequested?u(new Error((0,T.localize)(1,null,(0,A.toErrorMessage)(i)))):f({})}finally{clearTimeout(n),r.dispose()}})),h)}e.getResolvedShellEnv=S;async function w(d,m){const g=process.env.ELECTRON_RUN_AS_NODE;d.trace("getUnixShellEnvironment#runAsNode",g);const f=process.env.ELECTRON_NO_ATTACH_CONSOLE;d.trace("getUnixShellEnvironment#noAttach",f);const u=(0,P.generateUuid)().replace(/-/g,"").substr(0,12),r=new RegExp(u+"(.*)"+u),n={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};d.trace("getUnixShellEnvironment#env",n);const i=await(0,D.getSystemShell)(b.OS,n);return d.trace("getUnixShellEnvironment#shell",i),new Promise((a,c)=>{if(m.isCancellationRequested)return c((0,I.canceled)());const s=(0,t.basename)(i);let o,l;const v=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(s)?(o=`& '${process.execPath}' ${v} -p '''${u}'' + JSON.stringify(process.env) + ''${u}'''`,l=["-Login","-Command"]):(o=`'${process.execPath}' ${v} -p '"${u}" + JSON.stringify(process.env) + "${u}"'`,s==="tcsh"?l=["-ic"]:l=["-ilc"]),d.trace("getUnixShellEnvironment#spawn",JSON.stringify(l),o);const y=(0,k.spawn)(i,[...l,o],{detached:!0,stdio:["ignore","pipe","pipe"],env:n});m.onCancellationRequested(()=>(y.kill(),c((0,I.canceled)()))),y.on("error",F=>{d.error("getUnixShellEnvironment#errorChildProcess",(0,A.toErrorMessage)(F)),c(F)});const O=[];y.stdout.on("data",F=>O.push(F));const _=[];y.stderr.on("data",F=>_.push(F)),y.on("close",(F,R)=>{const U=Buffer.concat(O).toString("utf8");d.trace("getUnixShellEnvironment#raw",U);const M=Buffer.concat(_).toString("utf8");if(M.trim()&&d.trace("getUnixShellEnvironment#stderr",M),F||R)return c(new Error((0,T.localize)(2,null,F,R)));const V=r.exec(U),W=V?V[1]:"{}";try{const z=JSON.parse(W);g?z.ELECTRON_RUN_AS_NODE=g:delete z.ELECTRON_RUN_AS_NODE,f?z.ELECTRON_NO_ATTACH_CONSOLE=f:delete z.ELECTRON_NO_ATTACH_CONSOLE,delete z.XDG_RUNTIME_DIR,d.trace("getUnixShellEnvironment#result",z),a(z)}catch(z){d.error("getUnixShellEnvironment#errorCaught",(0,A.toErrorMessage)(z)),c(z)}})})}}),define(re[102],se([0,1,5]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,k.createDecorator)(e.SIGN_SERVICE_ID)}),define(re[211],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class k{constructor(){this.validators=new Map}vsda(){return new Promise((T,L)=>Z(["vsda"],T,L))}async createNewMessage(T){try{const L=await this.vsda(),A=new L.validator;if(A){const I=String(k._nextId++);return this.validators.set(I,A),{id:I,data:A.createNewMessage(T)}}}catch{}return{id:"",data:T}}async validate(T,L){if(!T.id)return!0;const A=this.validators.get(T.id);if(!A)return!1;this.validators.delete(T.id);try{return A.validate(L)==="ok"}catch{return!1}}async sign(T){try{const L=await this.vsda(),A=new L.signer;if(A)return A.sign(T)}catch{}return T}}e.SignService=k,k._nextId=1}),define(re[212],se([0,1,3,2]),function(Z,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspaceStorageDatabaseClient=e.ProfileStorageDatabaseClient=e.ApplicationStorageDatabaseClient=void 0;class T extends t.Disposable{constructor(D,E,p){super();this.channel=D,this.profile=E,this.workspace=p}async getItems(){const D={profile:this.profile,workspace:this.workspace},E=await this.channel.call("getItems",D);return new Map(E)}updateItems(D){const E={profile:this.profile,workspace:this.workspace};return D.insert&&(E.insert=Array.from(D.insert.entries())),D.delete&&(E.delete=Array.from(D.delete.values())),this.channel.call("updateItems",E)}}class L extends T{constructor(D,E){super(D,E,void 0);this._onDidChangeItemsExternal=this._register(new k.Emitter),this.onDidChangeItemsExternal=this._onDidChangeItemsExternal.event,this.registerListeners()}registerListeners(){this._register(this.channel.listen("onDidChangeStorage",{profile:this.profile})(D=>this.onDidChangeStorage(D)))}onDidChangeStorage(D){(Array.isArray(D.changed)||Array.isArray(D.deleted))&&this._onDidChangeItemsExternal.fire({changed:D.changed?new Map(D.changed):void 0,deleted:D.deleted?new Set(D.deleted):void 0})}}class A extends L{constructor(D){super(D,void 0)}async close(){this.dispose()}}e.ApplicationStorageDatabaseClient=A;class I extends L{constructor(D,E){super(D,E)}async close(){this.dispose()}}e.ProfileStorageDatabaseClient=I;class b extends T{constructor(D,E){super(D,void 0,E);this.onDidChangeItemsExternal=k.Event.None}async close(){this.dispose()}}e.WorkspaceStorageDatabaseClient=b}),define(re[213],se([0,1,4,36,8,31]),function(Z,e,k,t,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function A(P){if(k.platform===2&&/^penguin(\.|$)/i.test(P))return"chromebook"}async function I(P,D,E,p,C,h,S,w,d,m){const g=Object.create(null);g["common.machineId"]=S,g.sessionID=(0,L.generateUuid)()+Date.now(),g.commitHash=C,g.version=h,g["common.platformVersion"]=(D||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),g["common.platform"]=(0,k.PlatformToString)(k.platform),g["common.nodePlatform"]=t.platform,g["common.nodeArch"]=p,g["common.product"]=m||"desktop";const f=b(w||[]);f&&(g["common.msftInternal"]=f);let u=0;const r=Date.now();Object.defineProperties(g,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-r,enumerable:!0},"common.sequence":{get:()=>u++,enumerable:!0}}),k.isLinuxSnap&&(g["common.snap"]="true");const n=A(E);n&&(g["common.platformDetail"]=n);try{const i=await P.readFile(T.URI.file(d));g["common.source"]=i.value.toString().slice(0,30)}catch{}return g}e.resolveCommonProperties=I;function b(P){const D=t.env.USERDNSDOMAIN;if(!D)return!1;const E=D.toLowerCase();return P.some(p=>E===p)}e.verifyMicrosoftInternalDomain=b}),define(re[21],se([0,1,5]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,k.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,k.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var t;(function(L){L[L.NONE=0]="NONE",L[L.CRASH=1]="CRASH",L[L.ERROR=2]="ERROR",L[L.USAGE=3]="USAGE"})(t=e.TelemetryLevel||(e.TelemetryLevel={}));var T;(function(L){L.OFF="off",L.CRASH="crash",L.ERROR="error",L.ON="all"})(T=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(re[214],se([0,1,35,52,6,34,20,12,4,8,130,27,132,90,13,24,21]),function(Z,e,k,t,T,L,A,I,b,P,D,E,p,C,h,S,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const d=new Map;async function m(n,i){const a=`${n}::${i.join(":")}`,c=d.get(a);if(c)return c;const s=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],o=new Map,l=new Map,v=2e4;function y(_,F,R,U){const M=F.substring(_.length+1);return T.Promises.withAsyncBody(async V=>{let W;try{W=await E.Promises.readdir(F,{withFileTypes:!0})}catch{V();return}if(U.count>=v){U.count+=W.length,U.maxReached=!0,V();return}let z=W.length;if(z===0){V();return}let te=W;U.count+W.length>v&&(U.maxReached=!0,z=v-U.count,te=W.slice(0,z)),U.count+=W.length;for(const H of te)if(H.isDirectory()){if(R.includes(H.name)||await y(_,(0,I.join)(F,H.name),R,U),--z==0){V();return}}else{const K=H.name.lastIndexOf(".");if(K>=0){const X=H.name.substring(K+1);X&&o.set(X,(o.get(X)??0)+1)}for(const X of s)X.relativePathPattern?.test(M)!==!1&&X.filePattern.test(H.name)&&l.set(X.tag,(l.get(X.tag)??0)+1);if(--z==0){V();return}}})}const O=T.Promises.withAsyncBody(async _=>{const F={count:0,maxReached:!1};await y(n,n,i,F);const R=await u(n);_({configFiles:g(l),fileTypes:g(o),fileCount:F.count,maxFilesReached:F.maxReached,launchConfigFiles:R})});return d.set(a,O),O}e.collectWorkspaceStats=m;function g(n){return[...t.Iterable.map(n.entries(),([i,a])=>({name:i,count:a}))].sort((i,a)=>a.count-i.count)}function f(){const n={os:`${k.type()} ${k.arch()} ${k.release()}`,memory:`${(k.totalmem()/h.ByteSize.GB).toFixed(2)}GB (${(k.freemem()/h.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(D.virtualMachineHint.value()*100)}%`},i=k.cpus();return i&&i.length>0&&(n.cpus=`${i[0].model} (${i.length} x ${i[0].speed})`),n}e.getMachineInfo=f;async function u(n){try{const i=new Map,a=(0,I.join)(n,".vscode","launch.json"),c=await E.Promises.readFile(a),s=[],o=(0,L.parse)(c.toString(),s);if(s.length)return console.log(`Unable to parse ${a}`),[];if((0,L.getNodeType)(o)==="object"&&o.configurations)for(const l of o.configurations){const v=l.type;v&&(i.has(v)?i.set(v,i.get(v)+1):i.set(v,1))}return g(i)}catch{return[]}}e.collectLaunchConfigs=u;let r=class{constructor(i,a){this.telemetryService=i,this.productService=a}formatMachineInfo(i){const a=[];return a.push(`OS Version:       ${i.os}`),a.push(`CPUs:             ${i.cpus}`),a.push(`Memory (System):  ${i.memory}`),a.push(`VM:               ${i.vmHint}`),a.join(`
`)}formatEnvironment(i){const a=[];a.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),a.push(`OS Version:       ${k.type()} ${k.arch()} ${k.release()}`);const c=k.cpus();return c&&c.length>0&&a.push(`CPUs:             ${c[0].model} (${c.length} x ${c[0].speed})`),a.push(`Memory (System):  ${(k.totalmem()/h.ByteSize.GB).toFixed(2)}GB (${(k.freemem()/h.ByteSize.GB).toFixed(2)}GB free)`),b.isWindows||a.push(`Load (avg):       ${k.loadavg().map(s=>Math.round(s)).join(", ")}`),a.push(`VM:               ${Math.round(D.virtualMachineHint.value()*100)}%`),a.push(`Screen Reader:    ${i.screenReader?"yes":"no"}`),a.push(`Process Argv:     ${i.mainArguments.join(" ")}`),a.push(`GPU Status:       ${this.expandGPUFeatures(i.gpuFeatureStatus)}`),a.join(`
`)}async getPerformanceInfo(i,a){return Promise.all([(0,p.listProcesses)(i.mainPID),this.formatWorkspaceMetadata(i)]).then(async c=>{let[s,o]=c,l=this.formatProcessList(i,s);return a.forEach(v=>{if((0,C.isRemoteDiagnosticError)(v))l+=`
${v.errorMessage}`,o+=`
${v.errorMessage}`;else if(l+=`

Remote: ${v.hostName}`,v.processes&&(l+=`
${this.formatProcessList(i,v.processes)}`),v.workspaceMetadata){o+=`
|  Remote: ${v.hostName}`;for(const y of Object.keys(v.workspaceMetadata)){const O=v.workspaceMetadata[y];let _=`${O.fileCount} files`;O.maxFilesReached&&(_=`more than ${_}`),o+=`|    Folder (${y}): ${_}`,o+=this.formatWorkspaceStats(O)}}}),{processInfo:l,workspaceInfo:o}})}async getSystemInfo(i,a){const{memory:c,vmHint:s,os:o,cpus:l}=f(),v={os:o,memory:c,cpus:l,vmHint:s,processArgs:`${i.mainArguments.join(" ")}`,gpuStatus:i.gpuFeatureStatus,screenReader:`${i.screenReader?"yes":"no"}`,remoteData:a};return b.isWindows||(v.load=`${k.loadavg().map(y=>Math.round(y)).join(", ")}`),b.isLinux&&(v.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(v)}async getDiagnostics(i,a){const c=[];return(0,p.listProcesses)(i.mainPID).then(async s=>(c.push(""),c.push(this.formatEnvironment(i)),c.push(""),c.push(this.formatProcessList(i,s)),i.windows.some(o=>o.folderURIs&&o.folderURIs.length>0&&!o.remoteAuthority)&&(c.push(""),c.push("Workspace Stats: "),c.push(await this.formatWorkspaceMetadata(i))),a.forEach(o=>{if((0,C.isRemoteDiagnosticError)(o))c.push(`
${o.errorMessage}`);else if(c.push(`

`),c.push(`Remote:           ${o.hostName}`),c.push(this.formatMachineInfo(o.machineInfo)),o.processes&&c.push(this.formatProcessList(i,o.processes)),o.workspaceMetadata)for(const l of Object.keys(o.workspaceMetadata)){const v=o.workspaceMetadata[l];let y=`${v.fileCount} files`;v.maxFilesReached&&(y=`more than ${y}`),c.push(`Folder (${l}): ${y}`),c.push(this.formatWorkspaceStats(v))}}),c.push(""),c.push(""),c.join(`
`)))}formatWorkspaceStats(i){const a=[],c=60;let s=0;const o=(O,_)=>{const F=` ${O}(${_})`;s+F.length>c?(a.push(l),l="|                 ",s=l.length):s+=F.length,l+=F};let l="|      File types:";const v=10,y=i.fileTypes.length>v?v:i.fileTypes.length;for(let O=0;O<y;O++){const _=i.fileTypes[O];o(_.name,_.count)}if(a.push(l),i.configFiles.length>=0&&(l="|      Conf files:",s=0,i.configFiles.forEach(O=>{o(O.name,O.count)}),a.push(l)),i.launchConfigFiles.length>0){let O="|      Launch Configs:";i.launchConfigFiles.forEach(_=>{O+=_.count>1?` ${_.name}(${_.count})`:` ${_.name}`}),a.push(O)}return a.join(`
`)}expandGPUFeatures(i){const a=Math.max(...Object.keys(i).map(c=>c.length));return Object.keys(i).map(c=>`${c}:  ${" ".repeat(a-c.length)}  ${i[c]}`).join(`
                  `)}formatWorkspaceMetadata(i){const a=[],c=[];return i.windows.forEach(s=>{s.folderURIs.length===0||!!s.remoteAuthority||(a.push(`|  Window (${s.title})`),s.folderURIs.forEach(o=>{const l=P.URI.revive(o);if(l.scheme===A.Schemas.file){const v=l.fsPath;c.push(m(v,["node_modules",".git"]).then(y=>{let O=`${y.fileCount} files`;y.maxFilesReached&&(O=`more than ${O}`),a.push(`|    Folder (${(0,I.basename)(v)}): ${O}`),a.push(this.formatWorkspaceStats(y))}).catch(y=>{a.push(`|      Error: Unable to collect workspace stats for folder ${v} (${y.toString()})`)}))}else a.push(`|    Folder (${l.toString()}): Workspace stats not available.`)}))}),Promise.all(c).then(s=>a.join(`
`)).catch(s=>`Unable to collect workspace stats: ${s}`)}formatProcessList(i,a){const c=new Map;i.windows.forEach(o=>c.set(o.pid,o.title));const s=[];return s.push("CPU %	Mem MB	   PID	Process"),a&&this.formatProcessItem(i.mainPID,c,s,a,0),s.join(`
`)}formatProcessItem(i,a,c,s,o){const l=o===0;let v;l?v=s.pid===i?`${this.productService.applicationName} main`:"remote agent":(v=`${"  ".repeat(o)} ${s.name}`,s.name==="window"&&(v=`${v} (${a.get(s.pid)})`));const y=process.platform==="win32"?s.mem:k.totalmem()*(s.mem/100);c.push(`${s.load.toFixed(0).padStart(5," ")}	${(y/h.ByteSize.MB).toFixed(0).padStart(6," ")}	${s.pid.toFixed(0).padStart(6," ")}	${v}`),Array.isArray(s.children)&&s.children.forEach(O=>this.formatProcessItem(i,a,c,O,o+1))}async getWorkspaceFileExtensions(i){const a=new Set;for(const{uri:c}of i.folders){const s=P.URI.revive(c);if(s.scheme!==A.Schemas.file)continue;const o=s.fsPath;try{(await m(o,["node_modules",".git"])).fileTypes.forEach(v=>a.add(v.name))}catch{}}return{extensions:[...a]}}async reportWorkspaceStats(i){for(const{uri:a}of i.folders){const c=P.URI.revive(a);if(c.scheme!==A.Schemas.file)continue;const s=c.fsPath;try{const o=await m(s,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":i.telemetryId,rendererSessionId:i.rendererSessionId}),o.fileTypes.forEach(l=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:i.rendererSessionId,type:l.name,count:l.count})}),o.launchConfigFiles.forEach(l=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:i.rendererSessionId,type:l.name,count:l.count})}),o.configFiles.forEach(l=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:i.rendererSessionId,type:l.name,count:l.count})})}catch{}}}};r=me([Q(0,w.ITelemetryService),Q(1,S.IProductService)],r),e.DiagnosticsService=r}),define(re[103],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class k{constructor(L){this.appenders=L}listen(L,A){throw new Error(`Event not found: ${A}`)}call(L,A,{eventName:I,data:b}){return this.appenders.forEach(P=>P.log(I,b)),Promise.resolve(null)}}e.TelemetryAppenderChannel=k;class t{constructor(L){this.channel=L}log(L,A){return this.channel.call("log",{eventName:L,data:A}).then(void 0,I=>`Failed to log telemetry: ${console.warn(I)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=t}),define(re[45],se([0,1,29,79,14,18,21]),function(Z,e,k,t,T,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPiiPathsFromEnvironment=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class I{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=(0,t.staticObservableValue)(0)}publicLog(f,u){return Promise.resolve(void 0)}publicLog2(f,u){return this.publicLog(f,u)}publicLogError(f,u){return Promise.resolve(void 0)}publicLogError2(f,u){return this.publicLogError(f,u)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=I,e.NullTelemetryService=new I;class b{async publicLog(f,u,r){}async publicLogError(f,u,r){}}e.NullEndpointTelemetryService=b,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function P(g,f){return f.onDidChangeConfiguration(u=>{u.source!==6&&g.publicLog2("updateConfiguration",{configurationSource:(0,L.ConfigurationTargetToString)(u.source),configurationKeys:w(u.sourceConfig)})})}e.configurationTelemetry=P;function D(g,f){return!(f.disableTelemetry||!g.enableTelemetry||f.extensionTestsLocationURI)}e.supportsTelemetry=D;function E(g){const f=g.getValue(A.TELEMETRY_SETTING_ID),u=g.getValue("telemetry.enableCrashReporter");if(g.getValue(A.TELEMETRY_OLD_SETTING_ID)===!1||u===!1)return 0;switch(f??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=E;function p(g){const f={},u={},r={};S(g,r);for(let n in r){n=n.length>150?n.substr(n.length-149):n;const i=r[n];typeof i=="number"?u[n]=i:typeof i=="boolean"?u[n]=i?1:0:typeof i=="string"?(i.length>8192&&console.warn(`Telemetry property: ${n} has been trimmed to 8192, the original length is ${i.length}`),f[n]=i.substring(0,8191)):typeof i!="undefined"&&i!==null&&(f[n]=i)}return{properties:f,measurements:u}}e.validateTelemetryData=p;const C=["ssh-remote","dev-container","attached-container","wsl","tunneling"];function h(g){if(!g)return"none";for(const f of C)if(g.startsWith(`${f}+`))return f;return"other"}e.cleanRemoteAuthority=h;function S(g,f,u=0,r){if(!!g)for(const n of Object.getOwnPropertyNames(g)){const i=g[n],a=r?r+n:n;Array.isArray(i)?f[a]=(0,k.safeStringify)(i):i instanceof Date?f[a]=i.toISOString():(0,T.isObject)(i)?u<2?S(i,f,u+1,a+"."):f[a]=(0,k.safeStringify)(i):f[a]=i}}function w(g){if(!g)return[];const f=[];return d(f,"",g),f}function d(g,f,u){u&&typeof u=="object"&&!Array.isArray(u)?Object.keys(u).forEach(r=>d(g,f?`${f}.${r}`:r,u[r])):g.push(f)}function m(g){return[g.appRoot,g.extensionsPath,g.userHome.fsPath,g.tmpDir.fsPath,g.userDataPath]}e.getPiiPathsFromEnvironment=m}),define(re[215],se([0,1,49,45]),function(Z,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function T(L,A,I,b,P,D,E){const p={"X-Market-Client-Id":`VSCode ${L}`,"User-Agent":`VSCode ${L} (${A.nameShort})`},C=await(0,k.getServiceMachineId)(I,P,D),{sessionId:h}=await E.getTelemetryInfo();return(0,t.supportsTelemetry)(A,I)&&(0,t.getTelemetryLevel)(b)===3&&(p["X-Market-User-Id"]=C,p["VSCode-SessionId"]=h),p}e.resolveMarketplaceHeaders=T}),define(re[216],se([0,1,9,29,45]),function(Z,e,k,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const L="https://mobile.events.data.microsoft.com/OneCollector/1.0";async function A(b,P){const D=await new Promise((S,w)=>{Z(["@microsoft/1ds-core-js"],S,w)}),E=await new Promise((S,w)=>{Z(["@microsoft/1ds-post-js"],S,w)}),p=new D.AppInsightsCore,C=new E.PostChannel,h={instrumentationKey:b,endpointUrl:L,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[C]]};if(P){h.extensionConfig={};const S={alwaysUseXhrOverride:!0,httpXHROverride:P};h.extensionConfig[C.identifier]=S}return p.initialize(h,[]),p.addTelemetryInitializer(S=>{S.ext=S.ext??{},S.ext.utc=S.ext.utc??{},S.ext.utc.flags=8462029}),p}class I{constructor(P,D,E,p){this._eventPrefix=P,this._defaultData=D,this._xhrOverride=p,this.endPointUrl=L,this._defaultData||(this._defaultData={}),typeof E=="function"?this._aiCoreOrKey=E():this._aiCoreOrKey=E,this._asyncAiCore=null}_withAIClient(P){if(!!this._aiCoreOrKey){if(typeof this._aiCoreOrKey!="string"){P(this._aiCoreOrKey);return}this._asyncAiCore||(this._asyncAiCore=A(this._aiCoreOrKey,this._xhrOverride)),this._asyncAiCore.then(D=>{P(D)},D=>{(0,k.onUnexpectedError)(D),console.error(D)})}}log(P,D){if(!this._aiCoreOrKey)return;D=(0,t.mixin)(D,this._defaultData),D=(0,T.validateTelemetryData)(D);const E=this._eventPrefix+"/"+P;try{this._withAIClient(p=>p.track({name:E,baseData:{name:E,properties:D?.properties,measurements:D?.measurements}}))}catch{}}flush(){return this._aiCoreOrKey?new Promise(P=>{this._withAIClient(D=>{D.unload(!0,()=>{this._aiCoreOrKey=void 0,P(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=I}),define(re[217],se([0,1,216]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemWebAppender=void 0;class t extends k.AbstractOneDataSystemAppender{constructor(L,A,I){super(L,A,I);fetch(this.endPointUrl,{method:"POST"}).catch(b=>{this._aiCoreOrKey=void 0})}}e.OneDataSystemWebAppender=t}),define(re[104],se([0,1,2,15,7,45]),function(Z,e,k,t,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let A=class extends k.Disposable{constructor(b,P,D=""){super();this.prefix=D;const E=b.getLogger(P.telemetryLogResource);E?this.logger=this._register(E):(this.logger=this._register(b.createLogger(P.telemetryLogResource)),this.logger.info("The below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.logger.info("==========================================================="))}flush(){return Promise.resolve(void 0)}log(b,P){this.logger.trace(`${this.prefix}telemetry/${b}`,(0,L.validateTelemetryData)(P))}};A=me([Q(0,T.ILoggerService),Q(1,t.IEnvironmentService)],A),e.TelemetryLogAppender=A}),define(re[105],se([0,1,2,29,79,4,26,155,18,43,98,24,40,21,45]),function(Z,e,k,t,T,L,A,I,b,P,D,E,p,C,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let S=class{constructor(m,g,f){this._configurationService=g,this._productService=f,this._experimentProperties={},this.telemetryLevel=new T.MutableObservableValue(3),this._disposables=new k.DisposableStore,this._cleanupPatterns=[],this._appenders=m.appenders,this._commonProperties=m.commonProperties||Promise.resolve({}),this._piiPaths=m.piiPaths||[],this._sendErrorTelemetry=!!m.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(const u of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,A.escapeRegExpCharacters)(u),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables)}setExperimentProperty(m,g){this._experimentProperties[m]=g}_updateTelemetryLevel(){let m=(0,h.getTelemetryLevel)(this._configurationService);const g=this._productService.enabledTelemetryLevels;if(g){this._sendErrorTelemetry=this.sendErrorTelemetry?g.error:!1;const f=g.usage?3:g.error?2:0;m=Math.min(m,f)}this.telemetryLevel.value=m}get sendErrorTelemetry(){return this._sendErrorTelemetry}async getTelemetryInfo(){const m=await this._commonProperties,g=m.sessionID,f=m["common.machineId"],u=m["common.firstSessionDate"],r=m["common.msftInternal"];return{sessionId:g,machineId:f,firstSessionDate:u,msftInternal:r}}dispose(){this._disposables.dispose()}_log(m,g,f,u){return this.telemetryLevel.value<g?Promise.resolve(void 0):this._commonProperties.then(r=>{f=(0,t.mixin)(f,r),f=(0,t.mixin)(f,this._experimentProperties),f=(0,t.cloneAndChange)(f,n=>{if(typeof n=="string")return this._cleanupInfo(n,u)}),this._appenders.forEach(n=>n.log(m,f))},r=>{console.error(r)})}publicLog(m,g,f){return this._log(m,3,g,f)}publicLog2(m,g,f){return this.publicLog(m,g,f)}publicLogError(m,g){return this._sendErrorTelemetry?this._log(m,2,g,!0):Promise.resolve(void 0)}publicLogError2(m,g){return this.publicLogError(m,g)}_anonymizeFilePaths(m){let g=m;const f=[];for(const i of this._cleanupPatterns)for(;;){const a=i.exec(m);if(!a)break;f.push([a.index,i.lastIndex])}const u=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,r=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let n=0;for(g="";;){const i=r.exec(m);if(!i)break;!u.test(i[0])&&f.every(([a,c])=>i.index<a||i.index>=c)&&(g+=m.substring(n,i.index)+"<REDACTED: user-file-path>",n=r.lastIndex)}return n<m.length&&(g+=m.substr(n)),g}_removePropertiesWithPossibleUserInfo(m){if(!m)return m;const g=m.toLowerCase(),f=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-.]+/}];for(const u of f)if(u.regex.test(g))return`<REDACTED: ${u.label}>`;return m}_cleanupInfo(m,g){let f=m;g&&(f=this._anonymizeFilePaths(f));for(const u of this._cleanupPatterns)f=f.replace(u,"");return f=this._removePropertiesWithPossibleUserInfo(f),f}};S.IDLE_START_EVENT_NAME="UserIdleStart",S.IDLE_STOP_EVENT_NAME="UserIdleStop",S=me([Q(1,b.IConfigurationService),Q(2,E.IProductService)],S),e.TelemetryService=S;function w(){const d=(0,I.localize)(0,null,D.default.nameLong),m=D.default.privacyStatementUrl?(0,I.localize)(2,null,"https://aka.ms/vscode-telemetry",D.default.privacyStatementUrl):(0,I.localize)(1,null,"https://aka.ms/vscode-telemetry"),g=L.isWeb?"":(0,I.localize)(3,null),f=(0,I.localize)(4,null),u=(0,I.localize)(5,null),r=(0,I.localize)(6,null),n=(0,I.localize)(7,null),i=`
|       | ${f} | ${u} | ${r} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,a=(0,I.localize)(8,null);return`
${d} ${m} ${g}

&nbsp;

${n}
${i}

&nbsp;

${a}
`}p.Registry.as(P.Extensions.Configuration).registerConfiguration({id:C.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,I.localize)(9,null),properties:{[C.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,I.localize)(10,null),(0,I.localize)(11,null),(0,I.localize)(12,null),(0,I.localize)(13,null)],markdownDescription:w(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),p.Registry.as(P.Extensions.Configuration).registerConfiguration({id:C.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,I.localize)(14,null),properties:{[C.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:D.default.privacyStatementUrl?(0,I.localize)(16,null,D.default.nameLong,D.default.privacyStatementUrl):(0,I.localize)(15,null,D.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,I.localize)(17,null,`\`#${C.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(re[218],se([0,1,9,29,45]),function(Z,e,k,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AppInsightsAppender=void 0;async function L(I){const b=await new Promise((D,E)=>{Z(["applicationinsights"],D,E)});let P;return b.defaultClient?(P=new b.TelemetryClient(I),P.channel.setUseDiskRetryCaching(!0)):(b.setup(I).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),P=b.defaultClient),I.indexOf("AIF-")===0&&(P.config.endpointUrl="https://mobile.events.data.microsoft.com/collect/v1"),P}class A{constructor(b,P,D){this._eventPrefix=b,this._defaultData=P,this._defaultData||(this._defaultData=Object.create(null)),typeof D=="function"?this._aiClient=D():this._aiClient=D,this._asyncAIClient=null}_withAIClient(b){if(!!this._aiClient){if(typeof this._aiClient!="string"){b(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=L(this._aiClient)),this._asyncAIClient.then(P=>{b(P)},P=>{(0,k.onUnexpectedError)(P),console.error(P)})}}log(b,P){if(!!this._aiClient){P=(0,t.mixin)(P,this._defaultData),P=(0,T.validateTelemetryData)(P);try{this._withAIClient(D=>D.trackEvent({name:this._eventPrefix+"/"+b,properties:P.properties,measurements:P.measurements}))}catch{}}}flush(){return this._aiClient?new Promise(b=>{this._withAIClient(P=>{try{P.flush({callback:()=>{this._aiClient=void 0,b(void 0)}})}catch{}})}):Promise.resolve(void 0)}}e.AppInsightsAppender=A}),define(re[219],se([0,1,20,65,18,15,7,24,21,103,104,105]),function(Z,e,k,t,T,L,A,I,b,P,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let p=class{constructor(h,S,w,d,m){this.configurationService=h,this.telemetryService=S,this.loggerService=w,this.environmentService=d,this.productService=m,this.customTelemetryServices=new Map}async getCustomTelemetryService(h){if(!this.customTelemetryServices.has(h.id)){const{machineId:S,sessionId:w}=await this.telemetryService.getTelemetryInfo(),d=Object.create(null);d["common.vscodemachineid"]=S,d["common.vscodesessionid"]=w;const m=[h.id,JSON.stringify(d),h.aiKey],f=new t.Client(k.FileAccess.asFileUri("bootstrap-fork",Z).fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:m,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),u=[new P.TelemetryAppenderClient(f),new D.TelemetryLogAppender(this.loggerService,this.environmentService,`[${h.id}] `)];this.customTelemetryServices.set(h.id,new E.TelemetryService({appenders:u,sendErrorTelemetry:h.sendErrorTelemetry},this.configurationService,this.productService))}return this.customTelemetryServices.get(h.id)}async publicLog(h,S,w){await(await this.getCustomTelemetryService(h)).publicLog(S,w)}async publicLogError(h,S,w){await(await this.getCustomTelemetryService(h)).publicLogError(S,w)}};p=me([Q(0,T.IConfigurationService),Q(1,b.ITelemetryService),Q(2,A.ILoggerService),Q(3,L.IEnvironmentService),Q(4,I.IProductService)],p),e.CustomEndpointTelemetryService=p}),define(re[220],se([0,1,6,23,3,2,7]),function(Z,e,k,t,T,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let I=class extends L.Disposable{constructor(P,D){super();this._logService=D,this._lastRequestId=0,this._pendingRequests=new Map,this._pendingRequestDisposables=new Map,this._onCreateRequest=this._register(new T.Emitter),this.onCreateRequest=this._onCreateRequest.event,this._timeout=P===void 0?15e3:P}createRequest(P){return new Promise((D,E)=>{const p=++this._lastRequestId;this._pendingRequests.set(p,D),this._onCreateRequest.fire({requestId:p,...P});const C=new t.CancellationTokenSource;(0,k.timeout)(this._timeout,C.token).then(()=>E(`Request ${p} timed out (${this._timeout}ms)`)),this._pendingRequestDisposables.set(p,[(0,L.toDisposable)(()=>C.cancel())])})}acceptReply(P,D){const E=this._pendingRequests.get(P);E?(this._pendingRequests.delete(P),(0,L.dispose)(this._pendingRequestDisposables.get(P)||[]),this._pendingRequestDisposables.delete(P),E(D)):this._logService.warn(`RequestStore#acceptReply was called without receiving a matching request ${P}`)}};I=me([Q(1,A.ILogService)],I),e.RequestStore=I}),define(re[106],se([0,1,5]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.ProcessPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalLogConstants=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var t;(function(d){d.Shell="terminal.integrated.shell.",d.ShellArgs="terminal.integrated.shellArgs.",d.DefaultProfile="terminal.integrated.defaultProfile.",d.Profiles="terminal.integrated.profiles."})(t=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var T;(function(d){d.ShellLinux="terminal.integrated.shell.linux",d.ShellMacOs="terminal.integrated.shell.osx",d.ShellWindows="terminal.integrated.shell.windows",d.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",d.AutomationShellLinux="terminal.integrated.automationShell.linux",d.AutomationShellMacOs="terminal.integrated.automationShell.osx",d.AutomationShellWindows="terminal.integrated.automationShell.windows",d.AutomationProfileLinux="terminal.integrated.automationProfile.linux",d.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",d.AutomationProfileWindows="terminal.integrated.automationProfile.windows",d.ShellArgsLinux="terminal.integrated.shellArgs.linux",d.ShellArgsMacOs="terminal.integrated.shellArgs.osx",d.ShellArgsWindows="terminal.integrated.shellArgs.windows",d.ProfilesWindows="terminal.integrated.profiles.windows",d.ProfilesMacOs="terminal.integrated.profiles.osx",d.ProfilesLinux="terminal.integrated.profiles.linux",d.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",d.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",d.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",d.UseWslProfiles="terminal.integrated.useWslProfiles",d.TabsEnabled="terminal.integrated.tabs.enabled",d.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",d.TabsHideCondition="terminal.integrated.tabs.hideCondition",d.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",d.TabsShowActions="terminal.integrated.tabs.showActions",d.TabsLocation="terminal.integrated.tabs.location",d.TabsFocusMode="terminal.integrated.tabs.focusMode",d.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",d.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",d.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",d.CopyOnSelection="terminal.integrated.copyOnSelection",d.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",d.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",d.FontFamily="terminal.integrated.fontFamily",d.FontSize="terminal.integrated.fontSize",d.LetterSpacing="terminal.integrated.letterSpacing",d.LineHeight="terminal.integrated.lineHeight",d.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",d.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",d.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",d.BellDuration="terminal.integrated.bellDuration",d.FontWeight="terminal.integrated.fontWeight",d.FontWeightBold="terminal.integrated.fontWeightBold",d.CursorBlinking="terminal.integrated.cursorBlinking",d.CursorStyle="terminal.integrated.cursorStyle",d.CursorWidth="terminal.integrated.cursorWidth",d.Scrollback="terminal.integrated.scrollback",d.DetectLocale="terminal.integrated.detectLocale",d.DefaultLocation="terminal.integrated.defaultLocation",d.GpuAcceleration="terminal.integrated.gpuAcceleration",d.TerminalTitleSeparator="terminal.integrated.tabs.separator",d.TerminalTitle="terminal.integrated.tabs.title",d.TerminalDescription="terminal.integrated.tabs.description",d.RightClickBehavior="terminal.integrated.rightClickBehavior",d.Cwd="terminal.integrated.cwd",d.ConfirmOnExit="terminal.integrated.confirmOnExit",d.ConfirmOnKill="terminal.integrated.confirmOnKill",d.EnableBell="terminal.integrated.enableBell",d.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",d.AllowChords="terminal.integrated.allowChords",d.AllowMnemonics="terminal.integrated.allowMnemonics",d.EnvMacOs="terminal.integrated.env.osx",d.EnvLinux="terminal.integrated.env.linux",d.EnvWindows="terminal.integrated.env.windows",d.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",d.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",d.ShowExitAlert="terminal.integrated.showExitAlert",d.SplitCwd="terminal.integrated.splitCwd",d.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",d.WordSeparators="terminal.integrated.wordSeparators",d.EnableFileLinks="terminal.integrated.enableFileLinks",d.UnicodeVersion="terminal.integrated.unicodeVersion",d.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",d.LocalEchoEnabled="terminal.integrated.localEchoEnabled",d.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",d.LocalEchoStyle="terminal.integrated.localEchoStyle",d.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",d.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",d.CustomGlyphs="terminal.integrated.customGlyphs",d.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",d.InheritEnv="terminal.integrated.inheritEnv",d.ShowLinkHover="terminal.integrated.showLinkHover",d.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",d.AutoReplies="terminal.integrated.autoReplies",d.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",d.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",d.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",d.ShellIntegrationDecorationIcon="terminal.integrated.shellIntegration.decorationIcon",d.ShellIntegrationDecorationIconError="terminal.integrated.shellIntegration.decorationIconError",d.ShellIntegrationDecorationIconSuccess="terminal.integrated.shellIntegration.decorationIconSuccess",d.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history"})(T=e.TerminalSettingId||(e.TerminalSettingId={}));var L;(function(d){d.FileName="ptyhost"})(L=e.TerminalLogConstants||(e.TerminalLogConstants={}));var A;(function(d){d.PowerShell="pwsh",d.Bash="bash",d.Fish="fish",d.Sh="sh",d.Csh="csh",d.Ksh="ksh",d.Zsh="zsh"})(A=e.PosixShellType||(e.PosixShellType={}));var I;(function(d){d.CommandPrompt="cmd",d.PowerShell="pwsh",d.Wsl="wsl",d.GitBash="gitbash"})(I=e.WindowsShellType||(e.WindowsShellType={}));var b;(function(d){d[d.Api=0]="Api",d[d.Process=1]="Process",d[d.Sequence=2]="Sequence",d[d.Config=3]="Config"})(b=e.TitleEventSource||(e.TitleEventSource={}));var P;(function(d){d.LocalPty="localPty",d.PtyHost="ptyHost",d.Log="log",d.Heartbeat="heartbeat"})(P=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,k.createDecorator)("ptyService");var D;(function(d){d.Cwd="cwd",d.InitialCwd="initialCwd",d.FixedDimensions="fixedDimensions",d.Title="title",d.ShellType="shellType",d.HasChildProcesses="hasChildProcesses",d.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",d.OverrideDimensions="overrideDimensions",d.FailedShellIntegrationActivation="failedShellIntegrationActivation",d.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(D=e.ProcessPropertyType||(e.ProcessPropertyType={}));var E;(function(d){d[d.BeatInterval=5e3]="BeatInterval",d[d.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",d[d.SecondWaitMultiplier=1]="SecondWaitMultiplier",d[d.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(E=e.HeartbeatConstants||(e.HeartbeatConstants={}));var p;(function(d){d[d.Panel=1]="Panel",d[d.Editor=2]="Editor"})(p=e.TerminalLocation||(e.TerminalLocation={}));var C;(function(d){d.TerminalView="view",d.Editor="editor"})(C=e.TerminalLocationString||(e.TerminalLocationString={}));var h;(function(d){d[d.GraceTime=6e4]="GraceTime",d[d.ShortGraceTime=6e3]="ShortGraceTime"})(h=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var S;(function(d){d[d.HighWatermarkChars=1e5]="HighWatermarkChars",d[d.LowWatermarkChars=5e3]="LowWatermarkChars",d[d.CharCountAckSize=5e3]="CharCountAckSize"})(S=e.FlowControlConstants||(e.FlowControlConstants={}));var w;(function(d){d.GitBash="Git Bash",d.Pwsh="PowerShell"})(w=e.ProfileSource||(e.ProfileSource={}))}),define(re[221],se([0,1,5]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=void 0,e.ILocalPtyService=(0,k.createDecorator)("localPtyService")}),define(re[222],se([0,1,35,20,29,12,4,36,26,14,27]),function(Z,e,k,t,T,L,A,I,b,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shellIntegrationArgs=e.ShellIntegrationExecutable=e.getShellIntegrationInjection=e.findExecutable=e.getWindowsBuildNumber=void 0;function E(){const f=/(\d+)\.(\d+)\.(\d+)/g.exec(k.release());let u=0;return f&&f.length===4&&(u=parseInt(f[3])),u}e.getWindowsBuildNumber=E;async function p(f,u,r,n=I.env,i=D.Promises.exists){if(L.isAbsolute(f))return await i(f)?f:void 0;if(u===void 0&&(u=I.cwd()),L.dirname(f)!=="."){const o=L.join(u,f);return await i(o)?o:void 0}const c=(0,T.getCaseInsensitive)(n,"PATH");if(r===void 0&&(0,P.isString)(c)&&(r=c.split(L.delimiter)),r===void 0||r.length===0){const o=L.join(u,f);return await i(o)?o:void 0}for(const o of r){let l;if(L.isAbsolute(o)?l=L.join(o,f):l=L.join(u,o,f),await i(l))return l;if(A.isWindows){let v=l+".com";if(await i(v)||(v=l+".exe",await i(v)))return v}}const s=L.join(u,f);return await i(s)?s:void 0}e.findExecutable=p;function C(f,u,r){if(!u.enabled||!f.executable||f.isFeatureTerminal||f.hideFromUser||f.ignoreShellIntegration)return;const n=f.args,i=I.platform==="win32"?L.basename(f.executable).toLowerCase():L.basename(f.executable),a=L.dirname(t.FileAccess.asFileUri("",Z).fsPath);let c;const s={VSCODE_INJECTION:"1"};if(A.isWindows){if(i==="pwsh.exe")return!n||m(n)?c=e.shellIntegrationArgs.get(h.WindowsPwsh):d(n)&&(c=e.shellIntegrationArgs.get(h.WindowsPwshLogin)),c?(c&&(c=[...c],c[c.length-1]=(0,b.format)(c[c.length-1],a,"")),{newArgs:c,envMixin:s}):void 0;r.warn(`Shell integration cannot be enabled for executable "${f.executable}" and args`,f.args);return}switch(i){case"bash":return!n||n.length===0?c=e.shellIntegrationArgs.get(h.Bash):g(n)&&(s.VSCODE_SHELL_LOGIN="1",c=e.shellIntegrationArgs.get(h.Bash)),c?(c=[...c],c[c.length-1]=(0,b.format)(c[c.length-1],a),{newArgs:c,envMixin:s}):void 0;case"pwsh":return!n||m(n)?c=e.shellIntegrationArgs.get(h.Pwsh):d(n)&&(c=e.shellIntegrationArgs.get(h.PwshLogin)),c?(c=[...c],c[c.length-1]=(0,b.format)(c[c.length-1],a,""),{newArgs:c,envMixin:s}):void 0;case"zsh":{if(!n||n.length===0?c=e.shellIntegrationArgs.get(h.Zsh):g(n)?c=e.shellIntegrationArgs.get(h.ZshLogin):(n===e.shellIntegrationArgs.get(h.Zsh)||n===e.shellIntegrationArgs.get(h.ZshLogin))&&(c=n),!c)return;c=[...c],c[c.length-1]=(0,b.format)(c[c.length-1],a);const o=L.join(k.tmpdir(),"vscode-zsh");s.ZDOTDIR=o;const l=[];return l.push({source:L.join(a,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:L.join(o,".zshrc")}),l.push({source:L.join(a,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:L.join(o,".zprofile")}),l.push({source:L.join(a,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:L.join(o,".zshenv")}),l.push({source:L.join(a,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:L.join(o,".zlogin")}),{newArgs:c,envMixin:s,filesToCopy:l}}}r.warn(`Shell integration cannot be enabled for executable "${f.executable}" and args`,f.args)}e.getShellIntegrationInjection=C;var h;(function(f){f.WindowsPwsh="windows-pwsh",f.WindowsPwshLogin="windows-pwsh-login",f.Pwsh="pwsh",f.PwshLogin="pwsh-login",f.Zsh="zsh",f.ZshLogin="zsh-login",f.Bash="bash"})(h=e.ShellIntegrationExecutable||(e.ShellIntegrationExecutable={})),e.shellIntegrationArgs=new Map,e.shellIntegrationArgs.set(h.WindowsPwsh,["-noexit","-command",'. "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1"{1}']),e.shellIntegrationArgs.set(h.WindowsPwshLogin,["-l","-noexit","-command",'. "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1"{1}']),e.shellIntegrationArgs.set(h.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),e.shellIntegrationArgs.set(h.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),e.shellIntegrationArgs.set(h.Zsh,["-i"]),e.shellIntegrationArgs.set(h.ZshLogin,["-il"]),e.shellIntegrationArgs.set(h.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const S=["-login","-l"],w=["-nol","-nologo"];function d(f){return typeof f=="string"?S.includes(f.toLowerCase()):f.length===1&&S.includes(f[0].toLowerCase())||f.length===2&&(S.includes(f[0].toLowerCase())||S.includes(f[1].toLowerCase()))&&(w.includes(f[0].toLowerCase())||w.includes(f[1].toLowerCase()))}function m(f){return typeof f=="string"?w.includes(f.toLowerCase()):f.length===0||f?.length===1&&w.includes(f[0].toLowerCase())}function g(f){return f==="string"&&S.includes(f.toLowerCase())||typeof f!="string"&&f.length===1&&S.includes(f[0].toLowerCase())}}),define(re[223],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var k;(function(L){L.DARK="dark",L.LIGHT="light",L.HIGH_CONTRAST_DARK="hcDark",L.HIGH_CONTRAST_LIGHT="hcLight"})(k=e.ColorScheme||(e.ColorScheme={}));function t(L){return L===k.HIGH_CONTRAST_DARK||L===k.HIGH_CONTRAST_LIGHT}e.isHighContrast=t;function T(L){return L===k.DARK||L===k.HIGH_CONTRAST_DARK}e.isDark=T}),define(re[107],se([0,1,51,3,2,5,40,223]),function(Z,e,k,t,T,L,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,L.createDecorator)("themeService");var b;(function(w){function d(m){return m&&typeof m=="object"&&typeof m.id=="string"}w.isThemeColor=d})(b=e.ThemeColor||(e.ThemeColor={}));function P(w){return{id:w}}e.themeColorFromId=P;var D;(function(w){function d(a){return a&&typeof a=="object"&&typeof a.id=="string"&&(typeof a.color=="undefined"||b.isThemeColor(a.color))}w.isThemeIcon=d;const m=new RegExp(`^\\$\\((${k.CSSIcon.iconNameExpression}(?:${k.CSSIcon.iconModifierExpression})?)\\)$`);function g(a){const c=m.exec(a);if(!c)return;const[,s]=c;return{id:s}}w.fromString=g;function f(a){return{id:a}}w.fromId=f;function u(a,c){let s=a.id;const o=s.lastIndexOf("~");return o!==-1&&(s=s.substring(0,o)),c&&(s=`${s}~${c}`),{id:s}}w.modify=u;function r(a){const c=a.id.lastIndexOf("~");if(c!==-1)return a.id.substring(c+1)}w.getModifier=r;function n(a,c){return a.id===c.id&&a.color?.id===c.color?.id}w.isEqual=n;function i(a,c){return{id:a.id,color:c?P(c):void 0}}w.asThemeIcon=i,w.asClassNameArray=k.CSSIcon.asClassNameArray,w.asClassName=k.CSSIcon.asClassName,w.asCSSSelector=k.CSSIcon.asCSSSelector})(D=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=k.Codicon.file,e.FolderThemeIcon=k.Codicon.folder;function E(w){switch(w){case I.ColorScheme.DARK:return"vs-dark";case I.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case I.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=E,e.Extensions={ThemingContribution:"base.contributions.theming"};class p{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new t.Emitter}onColorThemeChange(d){return this.themingParticipants.push(d),this.onThemingParticipantAddedEmitter.fire(d),(0,T.toDisposable)(()=>{const m=this.themingParticipants.indexOf(d);this.themingParticipants.splice(m,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}const C=new p;A.Registry.add(e.Extensions.ThemingContribution,C);function h(w){return C.onColorThemeChange(w)}e.registerThemingParticipant=h;class S extends T.Disposable{constructor(d){super();this.themeService=d,this.theme=d.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(m=>this.onThemeChange(m)))}onThemeChange(d){this.theme=d,this.updateStyles()}updateStyles(){}getColor(d,m){let g=this.theme.getColor(d);return g&&m&&(g=m(g,this.theme)),g?g.toString():null}}e.Themable=S}),define(re[224],se([0,1,51,8,157,107]),function(Z,e,k,t,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUriComponents=e.terminalIconsEqual=e.terminalProfileArgsMatch=e.createProfileSchemaEnums=void 0;function A(p,C){const h=[{name:null,description:(0,T.localize)(0,null)}];return h.push(...p.map(S=>({name:S.profileName,description:I(S)}))),C&&h.push(...C.map(S=>({name:S.title,description:b(S)}))),{values:h.map(S=>S.name),markdownDescriptions:h.map(S=>S.description)}}e.createProfileSchemaEnums=A;function I(p){let C=`$(${L.ThemeIcon.isThemeIcon(p.icon)?p.icon.id:p.icon?p.icon:k.Codicon.terminal.id}) ${p.profileName}
- path: ${p.path}`;return p.args&&(typeof p.args=="string"?C+=`
- args: "${p.args}"`:C+=`
- args: [${p.args.length===0?"":`'${p.args.join("','")}'`}]`),p.overrideName!==void 0&&(C+=`
- overrideName: ${p.overrideName}`),p.color&&(C+=`
- color: ${p.color}`),p.env&&(C+=`
- env: ${JSON.stringify(p.env)}`),C}function b(p){return`$(${L.ThemeIcon.isThemeIcon(p.icon)?p.icon.id:p.icon?p.icon:k.Codicon.terminal.id}) ${p.title}
- extensionIdentifier: ${p.extensionIdentifier}`}function P(p,C){if(!p&&!C)return!0;if(typeof p=="string"&&typeof C=="string")return p===C;if(Array.isArray(p)&&Array.isArray(C)){if(p.length!==C.length)return!1;for(let h=0;h<p.length;h++)if(p[h]!==C[h])return!1;return!0}return!1}e.terminalProfileArgsMatch=P;function D(p,C){if(!p&&!C)return!0;if(!p||!C)return!1;if(L.ThemeIcon.isThemeIcon(p)&&L.ThemeIcon.isThemeIcon(C))return p.id===C.id&&p.color===C.color;if(typeof p=="object"&&p&&"light"in p&&"dark"in p&&typeof C=="object"&&C&&"light"in C&&"dark"in C){const h=p,S=C;if((t.URI.isUri(h.light)||E(h.light))&&(t.URI.isUri(h.dark)||E(h.dark))&&(t.URI.isUri(S.light)||E(S.light))&&(t.URI.isUri(S.dark)||E(S.dark)))return h.light.path===S.light.path&&h.dark.path===S.dark.path}if(t.URI.isUri(p)&&t.URI.isUri(C)||E(p)||E(C)){const h=p,S=C;return h.path===S.path&&h.scheme===S.scheme}return!1}e.terminalIconsEqual=D;function E(p){return p?typeof p.path=="string"&&typeof p.scheme=="string":!1}e.isUriComponents=E}),define(re[225],se([0,1,51,156,43,40,224]),function(Z,e,k,t,T,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=void 0;const I={args:{description:(0,t.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,t.localize)(1,null),type:"boolean"},icon:{description:(0,t.localize)(2,null),type:"string",enum:Array.from(k.Codicon.getAll(),f=>f.id),markdownEnumDescriptions:Array.from(k.Codicon.getAll(),f=>`$(${f.id})`)},color:{description:(0,t.localize)(3,null),type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},env:{markdownDescription:(0,t.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},b={type:"object",required:["path"],properties:{path:{description:(0,t.localize)(5,null),type:["string","array"],items:{type:"string"}},...I}},P={type:"object",required:["path"],properties:{path:{description:(0,t.localize)(6,null),type:["string"],items:{type:"string"}},...I}},D=(0,t.localize)(7,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),E=(0,t.localize)(8,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),p=(0,t.localize)(9,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),C=(0,t.localize)(10,null,"`#terminal.integrated.automationProfile.linux#`"),h=(0,t.localize)(11,null,"`#terminal.integrated.automationProfile.osx#`"),S=(0,t.localize)(12,null,"`#terminal.integrated.automationProfile.windows#`"),w={id:"terminal",order:100,title:(0,t.localize)(13,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(14,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:C},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(15,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:h},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(16,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:S},["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(17,null,"`#terminal.integrated.automationShell.linux#`"),type:["object","null"],default:null,anyOf:[{type:"null"},P],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(18,null,"`#terminal.integrated.automationShell.osx#`"),type:["object","null"],default:null,anyOf:[{type:"null"},P],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(19,null,"`#terminal.integrated.automationShell.windows#`"),type:["object","null"],default:null,anyOf:[{type:"null"},P],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(20,null),type:["string","null"],default:null,markdownDeprecationMessage:D},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(21,null),type:["string","null"],default:null,markdownDeprecationMessage:E},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(22,null),type:["string","null"],default:null,markdownDeprecationMessage:p},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(23,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:D},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(24,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:E},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(25,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,t.localize)(26,null)}},{type:"string",markdownDescription:(0,t.localize)(27,null)}],default:[],markdownDeprecationMessage:p},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(28,null,"`source`","`path`","`args`","`null`",'`"Ubuntu-20.04 (WSL)": null`'),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,t.localize)(29,null),enum:["PowerShell","Git Bash"]},...I}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,t.localize)(30,null),type:"string"},id:{description:(0,t.localize)(31,null),type:"string"},title:{description:(0,t.localize)(32,null),type:"string"},...I}},{type:"null"},b]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(33,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,t.localize)(34,null),type:"string"},id:{description:(0,t.localize)(35,null),type:"string"},title:{description:(0,t.localize)(36,null),type:"string"},...I}},{type:"null"},b]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(37,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,t.localize)(38,null),type:"string"},id:{description:(0,t.localize)(39,null),type:"string"},title:{description:(0,t.localize)(40,null),type:"string"},...I}},{type:"null"},b]}},["terminal.integrated.useWslProfiles"]:{description:(0,t.localize)(41,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,t.localize)(42,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,t.localize)(43,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,t.localize)(44,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{description:(0,t.localize)(45,null,"`terminal.integrated.confirmOnKill`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function d(){L.Registry.as(T.Extensions.Configuration).registerConfiguration(w),g()}e.registerTerminalPlatformConfiguration=d;let m;function g(f,u){const r=L.Registry.as(T.Extensions.Configuration);let n;f&&(n=(0,A.createProfileSchemaEnums)(f?.profiles,u));const i=m;m={id:"terminal",order:100,title:(0,t.localize)(46,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(47,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:f?.os===3?n?.values:void 0,markdownEnumDescriptions:f?.os===3?n?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(48,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:f?.os===2?n?.values:void 0,markdownEnumDescriptions:f?.os===2?n?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(49,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:f?.os===1?n?.values:void 0,markdownEnumDescriptions:f?.os===1?n?.markdownDescriptions:void 0}}},r.updateConfigurations({add:[m],remove:i?[i]:[]})}e.registerTerminalDefaultProfileConfiguration=g}),define(re[226],se([0,1,48,51,12,4,27,83,222,107]),function(Z,e,k,t,T,L,A,I,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let D,E=!0;function p(n,i,a,c,s=process.env,o,l,v,y){return o=o||{existsFile:A.SymlinkSupport.existsFile,readFile:A.Promises.readFile},L.isWindows?C(a,o,s,l,c.getValue("terminal.integrated.useWslProfiles")!==!1,n&&typeof n=="object"?{...n}:c.getValue("terminal.integrated.profiles.windows"),typeof i=="string"?i:c.getValue("terminal.integrated.defaultProfile.windows"),y,v):f(o,l,a,n&&typeof n=="object"?{...n}:c.getValue(L.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof i=="string"?i:c.getValue(L.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),y,v,s)}e.detectAvailableProfiles=p;async function C(n,i,a,c,s,o,l,v,y){const O=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),_=`${process.env.windir}\\${O?"Sysnative":"System32"}`;let F=!1;(0,b.getWindowsBuildNumber)()>=16299&&(F=!0),await w(v);const R=new Map;n&&(R.set("PowerShell",{source:"PowerShell",icon:t.Codicon.terminalPowershell,isAutoDetected:!0}),R.set("Windows PowerShell",{path:`${_}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:t.Codicon.terminalPowershell,isAutoDetected:!0}),R.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),R.set("Cygwin",{path:[`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`],args:["--login"],isAutoDetected:!0}),R.set("Command Prompt",{path:`${_}\\cmd.exe`,icon:t.Codicon.terminalCmd,isAutoDetected:!0})),u(o,R);const U=await h(R.entries(),l,i,a,c,y);if(n||!n&&s)try{const M=await m(`${_}\\${F?"wsl":"bash"}.exe`,l);for(const V of M)(!o||!(V.profileName in o))&&U.push(V)}catch{E&&(c?.info("WSL is not installed, so could not detect WSL profiles"),E=!1)}return U}async function h(n,i,a,c=process.env,s,o){const l=[];for(const[v,y]of n){if(y===null)continue;let O,_,F;if("source"in y){const M=D?.get(y.source);if(!M)continue;O=M.paths,_=y.args||M.args,y.icon?F=S(y.icon):M.icon&&(F=M.icon)}else O=Array.isArray(y.path)?y.path:[y.path],_=L.isWindows||Array.isArray(y.args)?y.args:void 0,F=S(y.icon);const R=await o?.(O)||O.slice(),U=await r(v,i,R,a,c,_,y.env,y.overrideName,y.isAutoDetected,s);U?(U.isAutoDetected=y.isAutoDetected,U.icon=F,U.color=y.color,l.push(U)):s?.debug("Terminal profile not validated",v,O)}return s?.debug("Validated terminal profiles",l),l}function S(n){return typeof n=="string"?{id:n}:n}async function w(n){D&&!n||(D=new Map,D.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`,`${process.env.AllUsersProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login"]}),D.set("PowerShell",{profileName:"PowerShell",paths:n||await d(),icon:P.ThemeIcon.asThemeIcon(t.Codicon.terminalPowershell)}))}async function d(){const n=[];for await(const i of(0,I.enumeratePowerShellInstallations)())n.push(i.exePath);return n}async function m(n,i){const a=[],c=await new Promise((l,v)=>{k.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(y,O)=>{if(y)return v("Problem occurred when getting wsl distros");l(O)})});if(!c)return[];const s=new RegExp(/[\r?\n]/),o=c.split(s).filter(l=>l.trim().length>0&&l!=="");for(const l of o){if(l===""||l.startsWith("docker-desktop"))continue;const v=`${l} (WSL)`,y={profileName:v,path:n,args:["-d",`${l}`],isDefault:v===i,icon:g(l),isAutoDetected:!1};a.push(y)}return a}function g(n){return n.includes("Ubuntu")?P.ThemeIcon.asThemeIcon(t.Codicon.terminalUbuntu):n.includes("Debian")?P.ThemeIcon.asThemeIcon(t.Codicon.terminalDebian):P.ThemeIcon.asThemeIcon(t.Codicon.terminalLinux)}async function f(n,i,a,c,s,o,l,v){const y=new Map;if(a){const O=(await n.readFile("/etc/shells")).toString(),_=o||O.split(`
`).filter(R=>R.trim().indexOf("#")!==0&&R.trim().length>0),F=new Map;for(const R of _){let U=(0,T.basename)(R),M=F.get(U)||0;M++,M>1&&(U=`${U} (${M})`),F.set(U,M),y.set(U,{path:R,isAutoDetected:!0})}}return u(c,y),await h(y.entries(),s,n,v,i,l)}function u(n,i){if(!!n)for(const[a,c]of Object.entries(n))c===null||!("path"in c)&&!("source"in c)?i.delete(a):(c.icon=c.icon||i.get(a)?.icon,i.set(a,c))}async function r(n,i,a,c,s,o,l,v,y,O){if(a.length===0)return Promise.resolve(void 0);const _=a.shift();if(_==="")return r(n,i,a,c,s,o,l,v,y);const F={profileName:n,path:_,args:o,env:l,overrideName:v,isAutoDetected:y,isDefault:n===i};if((0,T.basename)(_)===_){const U=s.PATH?s.PATH.split(T.delimiter):void 0,M=await(0,b.findExecutable)(_,void 0,U,void 0,c.existsFile);return M?(F.path=M,F.isFromPath=!0,F):r(n,i,a,c,s,o)}return await c.existsFile((0,T.normalize)(_))?F:r(n,i,a,c,s,o,l,v,y)}}),define(re[227],se([0,1,3,2,20,4,39,65,18,15,88,210,7,97,220,106,225,226]),function(Z,e,k,t,T,L,A,I,b,P,D,E,p,C,h,S,w,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var m;(function(u){u[u.MaxRestarts=5]="MaxRestarts"})(m||(m={}));let g=0,f=class extends t.Disposable{constructor(r,n,i,a){super();this._reconnectConstants=r,this._configurationService=n,this._environmentService=i,this._logService=a,this._restartCount=0,this._isResponsive=!0,this._isDisposed=!1,this._onPtyHostExit=this._register(new k.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new k.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new k.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new k.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new k.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new k.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessReady=this._register(new k.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new k.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessOrphanQuestion=this._register(new k.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._onDidRequestDetach=this._register(new k.Emitter),this.onDidRequestDetach=this._onDidRequestDetach.event,this._onDidChangeProperty=this._register(new k.Emitter),this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=this._register(new k.Emitter),this.onProcessExit=this._onProcessExit.event,(0,w.registerTerminalPlatformConfiguration)(),this._shellEnv=this._resolveShellEnv(),this._register((0,t.toDisposable)(()=>this._disposePtyHost())),this._resolveVariablesRequestStore=this._register(new h.RequestStore(void 0,this._logService)),this._resolveVariablesRequestStore.onCreateRequest(this._onPtyHostRequestResolveVariables.fire,this._onPtyHostRequestResolveVariables),[this._client,this._proxy]=this._startPtyHost(),this._register(this._configurationService.onDidChangeConfiguration(async c=>{c.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this._refreshIgnoreProcessNames()}))}initialize(){this._refreshIgnoreProcessNames()}get _ignoreProcessNames(){return this._configurationService.getValue("terminal.integrated.ignoreProcessNames")}async _refreshIgnoreProcessNames(){return this._proxy.refreshIgnoreProcessNames?.(this._ignoreProcessNames)}async _resolveShellEnv(){if(L.isWindows)return process.env;try{return await(0,E.getResolvedShellEnv)(this._logService,{_:[]},process.env)}catch(r){return this._logService.error("ptyHost was unable to resolve shell environment",r),{}}}_startPtyHost(){const r={serverName:"Pty Host",args:["--type=ptyHost","--logsPath",this._environmentService.logsPath],env:{VSCODE_LAST_PTY_ID:g,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this._reconnectConstants.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this._reconnectConstants.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this._reconnectConstants.scrollback}},n=(0,D.parsePtyHostPort)(this._environmentService.args,this._environmentService.isBuilt);n&&(n.break&&n.port?r.debugBrk=n.port:!n.break&&n.port&&(r.debug=n.port));const i=new I.Client(T.FileAccess.asFileUri("bootstrap-fork",Z).fsPath,r);this._onPtyHostStart.fire(),A.ProxyChannel.toService(i.getChannel(S.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(),this._register(i.onDidProcessExit(o=>{this._onPtyHostExit.fire(o.code),this._isDisposed||(this._restartCount<=m.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${o.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${o.code}, giving up`))}));const c=i.getChannel(S.TerminalIpcChannels.Log);C.LogLevelChannelClient.setLevel(c,this._logService.getLevel()),this._register(this._logService.onDidChangeLogLevel(()=>{C.LogLevelChannelClient.setLevel(c,this._logService.getLevel())}));const s=A.ProxyChannel.toService(i.getChannel(S.TerminalIpcChannels.PtyHost));return this._register(s.onProcessData(o=>this._onProcessData.fire(o))),this._register(s.onProcessReady(o=>this._onProcessReady.fire(o))),this._register(s.onProcessExit(o=>this._onProcessExit.fire(o))),this._register(s.onDidChangeProperty(o=>this._onDidChangeProperty.fire(o))),this._register(s.onProcessReplay(o=>this._onProcessReplay.fire(o))),this._register(s.onProcessOrphanQuestion(o=>this._onProcessOrphanQuestion.fire(o))),this._register(s.onDidRequestDetach(o=>this._onDidRequestDetach.fire(o))),[i,s]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(r,n,i,a,c,s,o,l,v,y,O){const _=setTimeout(()=>this._handleUnresponsiveCreateProcess(),S.HeartbeatConstants.CreateProcessTimeout),F=await this._proxy.createProcess(r,n,i,a,c,s,o,l,v,y,O);return clearTimeout(_),g=Math.max(g,F),F}updateTitle(r,n,i){return this._proxy.updateTitle(r,n,i)}updateIcon(r,n,i){return this._proxy.updateIcon(r,n,i)}attachToProcess(r){return this._proxy.attachToProcess(r)}detachFromProcess(r){return this._proxy.detachFromProcess(r)}listProcesses(){return this._proxy.listProcesses()}reduceConnectionGraceTime(){return this._proxy.reduceConnectionGraceTime()}start(r){return this._proxy.start(r)}shutdown(r,n){return this._proxy.shutdown(r,n)}input(r,n){return this._proxy.input(r,n)}processBinary(r,n){return this._proxy.processBinary(r,n)}resize(r,n,i){return this._proxy.resize(r,n,i)}acknowledgeDataEvent(r,n){return this._proxy.acknowledgeDataEvent(r,n)}setUnicodeVersion(r,n){return this._proxy.setUnicodeVersion(r,n)}getInitialCwd(r){return this._proxy.getInitialCwd(r)}getCwd(r){return this._proxy.getCwd(r)}getLatency(r){return this._proxy.getLatency(r)}orphanQuestionReply(r){return this._proxy.orphanQuestionReply(r)}installAutoReply(r,n){return this._proxy.installAutoReply(r,n)}uninstallAllAutoReplies(){return this._proxy.uninstallAllAutoReplies()}uninstallAutoReply(r){return this._proxy.uninstallAutoReply(r)}getDefaultSystemShell(r){return this._proxy.getDefaultSystemShell(r)}async getProfiles(r,n,i,a=!1){const c=await this._shellEnv;return(0,d.detectAvailableProfiles)(n,i,a,this._configurationService,c,void 0,this._logService,this._resolveVariables.bind(this,r))}getEnvironment(){return this._proxy.getEnvironment()}getWslPath(r){return this._proxy.getWslPath(r)}setTerminalLayoutInfo(r){return this._proxy.setTerminalLayoutInfo(r)}async getTerminalLayoutInfo(r){return await this._proxy.getTerminalLayoutInfo(r)}async requestDetachInstance(r,n){return this._proxy.requestDetachInstance(r,n)}async acceptDetachInstanceReply(r,n){return this._proxy.acceptDetachInstanceReply(r,n)}async serializeTerminalState(r){return this._proxy.serializeTerminalState(r)}async reviveTerminalProcesses(r,n){return this._proxy.reviveTerminalProcesses(r,n)}async refreshProperty(r,n){return this._proxy.refreshProperty(r,n)}async updateProperty(r,n,i){return this._proxy.updateProperty(r,n,i)}async restartPtyHost(){this._isResponsive=!0,this._disposePtyHost(),[this._client,this._proxy]=this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll?.(),this._client.dispose()}_handleHeartbeat(){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),S.HeartbeatConstants.BeatInterval*S.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._isResponsive=!0,this._onPtyHostResponsive.fire())}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${S.HeartbeatConstants.BeatInterval*S.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),S.HeartbeatConstants.BeatInterval*S.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(S.HeartbeatConstants.BeatInterval*S.HeartbeatConstants.FirstWaitMultiplier+S.HeartbeatConstants.BeatInterval*S.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._isResponsive=!1,this._onPtyHostUnresponsive.fire())}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${S.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._isResponsive&&(this._isResponsive=!1,this._onPtyHostUnresponsive.fire())}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(r,n){return this._resolveVariablesRequestStore.createRequest({workspaceId:r,originalText:n})}async acceptPtyHostResolvedVariables(r,n){this._resolveVariablesRequestStore.acceptReply(r,n)}};f=me([Q(1,b.IConfigurationService),Q(2,P.IEnvironmentService),Q(3,p.ILogService)],f),e.PtyHostService=f}),define(re[70],se([0,1,3,4,5,7]),function(Z,e,k,t,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,T.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,T.createDecorator)("sharedTunnelsService");var A;(function(S){S.Http="http",S.Https="https"})(A=e.TunnelProtocol||(e.TunnelProtocol={}));var I;(function(S){S.ConstantPrivate="constantPrivate",S.Private="private",S.Public="public"})(I=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var b;(function(S){S[S.Notify=1]="Notify",S[S.OpenBrowser=2]="OpenBrowser",S[S.OpenPreview=3]="OpenPreview",S[S.Silent=4]="Silent",S[S.Ignore=5]="Ignore",S[S.OpenBrowserOnce=6]="OpenBrowserOnce"})(b=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function P(S){if(S.scheme!=="http"&&S.scheme!=="https")return;const w=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(S.authority);if(!!w)return{address:w[1],port:+w[2]}}e.extractLocalHostUriMetaDataForPortMapping=P,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function D(S){return e.LOCALHOST_ADDRESSES.indexOf(S)>=0}e.isLocalhost=D,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function E(S){return e.ALL_INTERFACES_ADDRESSES.indexOf(S)>=0}e.isAllInterfaces=E;function p(S,w){return w?w!==1&&S<1024:!t.isWindows&&S<1024}e.isPortPrivileged=p;class C{constructor(w,d,m){this.remoteAddress=w,this.localAddress=d,this._dispose=m,this._onDispose=new k.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=C;let h=class{constructor(w){this.logService=w,this._onTunnelOpened=new k.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new k.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new k.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(w){return this._tunnelProvider=w,w?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(w){this._canElevate=w.elevation,this._privacyOptions=w.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const w=[],d=Array.from(this._tunnels.values());for(const m of d){const g=Array.from(m.values());for(const f of g){const u=await f.value;u&&w.push(u)}}return w}async dispose(){for(const w of this._tunnels.values()){for(const{value:d}of w.values())await d.then(m=>m?.dispose());w.clear()}this._tunnels.clear()}openTunnel(w,d,m,g,f=!1,u,r){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${d}:${m} on local port ${g}.`),!w)return;if(d||(d="localhost"),this._tunnelProvider&&this._factoryInProgress.has(m)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const n=this.retainOrCreateTunnel(w,d,m,g,f,u,r);return n?n.then(i=>{if(!i){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(d,m);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const a=this.makeTunnel(i);return(i.tunnelRemoteHost!==d||i.tunnelRemotePort!==m)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(a),a}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),n)}makeTunnel(w){return{tunnelRemotePort:w.tunnelRemotePort,tunnelRemoteHost:w.tunnelRemoteHost,tunnelLocalPort:w.tunnelLocalPort,localAddress:w.localAddress,privacy:w.privacy,protocol:w.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${w.tunnelRemoteHost}:${w.tunnelRemotePort} `);const d=this._tunnels.get(w.tunnelRemoteHost);if(d){const m=d.get(w.tunnelRemotePort);m&&(m.refcount--,await this.tryDisposeTunnel(w.tunnelRemoteHost,w.tunnelRemotePort,m))}}}}async tryDisposeTunnel(w,d,m){if(m.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${w}:${d}.`);const g=m.value.then(async f=>{f&&(await f.dispose(!0),this._onTunnelClosed.fire({host:f.tunnelRemoteHost,port:f.tunnelRemotePort}))});return this._tunnels.has(w)&&this._tunnels.get(w).delete(d),g}}async closeTunnel(w,d){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${w}:${d} `);const m=this._tunnels.get(w);if(m&&m.has(d)){const g=m.get(d);g.refcount=0,await this.tryDisposeTunnel(w,d,g)}}addTunnelToMap(w,d,m){this._tunnels.has(w)||this._tunnels.set(w,new Map),this._tunnels.get(w).set(d,{refcount:1,value:m})}async removeEmptyTunnelFromMap(w,d){const m=this._tunnels.get(w);m&&(await m.get(d)||m.delete(d),m.size===0&&this._tunnels.delete(w))}getTunnelFromMap(w,d){const m=[w];D(w)?(m.push(...e.LOCALHOST_ADDRESSES),m.push(...e.ALL_INTERFACES_ADDRESSES)):E(w)&&m.push(...e.ALL_INTERFACES_ADDRESSES);const g=m.map(f=>this._tunnels.get(f));for(const f of g){const u=f?.get(d);if(u)return u}}canTunnel(w){return!!P(w)}createWithProvider(w,d,m,g,f,u,r){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${d}:${m} on local port ${g}.`);const n=m;this._factoryInProgress.add(n);const a={elevationRequired:f?p(g===void 0?m:g):!1},c={remoteAddress:{host:d,port:m},localAddressPort:g,privacy:u,public:u?u!==I.Private:void 0,protocol:r},s=w.forwardPort(c,a);return s?(this.addTunnelToMap(d,m,s),s.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(n)})):this._factoryInProgress.delete(n),s}};h=me([Q(0,L.ILogService)],h),e.AbstractTunnelService=h}),define(re[228],se([0,1,7,70,2,9,6]),function(Z,e,k,t,T,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessTunnelService=void 0;class I extends T.Disposable{constructor(){super();this._address=null,this._addressPromise=null}async getAddress(){return this._address?this._address:(this._addressPromise||(this._addressPromise=new A.DeferredPromise),this._addressPromise.p)}setAddress(D){this._address=D,this._addressPromise&&(this._addressPromise.complete(D),this._addressPromise=null)}setTunnel(D){this._register(D)}}let b=class Pt extends T.Disposable{constructor(D,E){super();this._tunnelService=D,this._logService=E,this._tunnels=new Map,this._disposedTunnels=new Set}dispose(){super.dispose(),this._tunnels.forEach(D=>D.dispose())}async createTunnel(){return{id:String(++Pt._lastId)}}async startTunnel(D,E,p,C,h,S){const w=new I,d=await Promise.resolve(this._tunnelService.openTunnel(D,w,p,C,h,S));if(!d)throw this._logService.info(`[SharedProcessTunnelService] Could not create a tunnel to ${p}:${C} (remote).`),w.dispose(),new Error("Could not create tunnel");if(this._disposedTunnels.has(E))throw this._disposedTunnels.delete(E),w.dispose(),await d.dispose(),(0,L.canceled)();return w.setTunnel(d),this._tunnels.set(E,w),this._logService.info(`[SharedProcessTunnelService] Created tunnel ${E}: ${d.localAddress} (local) to ${p}:${C} (remote).`),{tunnelLocalPort:d.tunnelLocalPort,localAddress:d.localAddress}}async setAddress(D,E){const p=this._tunnels.get(D);!p||p.setAddress(E)}async destroyTunnel(D){const E=this._tunnels.get(D);if(E){this._logService.info(`[SharedProcessTunnelService] Disposing tunnel ${D}.`),this._tunnels.delete(D),await E.dispose();return}this._disposedTunnels.add(D)}};b._lastId=0,b=me([Q(0,t.ISharedTunnelsService),Q(1,k.ILogService)],b),e.SharedProcessTunnelService=b}),define(re[33],se([0,1,5]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,k.createDecorator)("IUriIdentityService")}),define(re[229],se([0,1,3,2,8,15,32,13,7,33]),function(Z,e,k,t,T,L,A,I,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;let D=class extends t.Disposable{constructor(p,C,h,S,w){super();this.extensionsManagementService=p,this.logService=S,this.uriIdentityService=w,this._onDidChangeExtensionsByAnotherSource=this._register(new k.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled().then(m=>{this.installedExtensions=m.map(g=>g.identifier),this.startTimestamp=Date.now()}),this._register(p.onInstallExtension(m=>this.onInstallExtension(m))),this._register(p.onDidInstallExtensions(m=>this.onDidInstallExtensions(m))),this._register(p.onDidUninstallExtension(m=>this.onDidUninstallExtension(m)));const d=T.URI.file(h.extensionsPath);this._register(C.watch(d)),this._register(k.Event.filter(C.onDidFilesChange,m=>m.rawChanges.some(g=>this.doesChangeAffects(g,d)))(()=>this.onDidChange()))}doesChangeAffects(p,C){return p.type!==1&&p.type!==2||!this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(p.resource),C)?!1:this.uriIdentityService.extUri.isEqual(p.resource,this.uriIdentityService.extUri.joinPath(C,".obsolete"))?!0:!this.uriIdentityService.extUri.basename(p.resource).startsWith(".")}onInstallExtension(p){this.addInstallingExtension(p.identifier)}onDidInstallExtensions(p){for(const C of p)this.removeInstallingExtension(C.identifier),C.local&&this.addInstalledExtension(C.identifier)}onDidUninstallExtension(p){p.error||this.removeInstalledExtension(p.identifier)}addInstallingExtension(p){this.removeInstallingExtension(p),this.installingExtensions.push(p)}removeInstallingExtension(p){this.installingExtensions=this.installingExtensions.filter(C=>!(0,A.areSameExtensions)(C,p))}addInstalledExtension(p){this.installedExtensions&&(this.removeInstalledExtension(p),this.installedExtensions.push(p))}removeInstalledExtension(p){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(C=>!(0,A.areSameExtensions)(C,p)))}async onDidChange(){if(this.installedExtensions){const p=await this.extensionsManagementService.getInstalled(),C=p.filter(S=>[...this.installingExtensions,...this.installedExtensions].some(w=>(0,A.areSameExtensions)(w,S.identifier))?!1:S.installedTimestamp&&S.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",S.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",S.identifier.id),!1)),h=this.installedExtensions.filter(S=>this.installingExtensions.some(w=>(0,A.areSameExtensions)(w,S))?!1:p.every(w=>!(0,A.areSameExtensions)(w.identifier,S))?(this.logService.info("Detected extension removed from another source",S.id),!0):!1);this.installedExtensions=p.map(S=>S.identifier),(C.length||h.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:C,removed:h})}}};D=me([Q(1,I.IFileService),Q(2,L.INativeEnvironmentService),Q(3,b.ILogService),Q(4,P.IUriIdentityService)],D),e.ExtensionsWatcher=D}),define(re[230],se([0,1,33,89,13,19,114,3,2]),function(Z,e,k,t,T,L,A,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class P{constructor(p){this.uri=p,this.time=P._clock++}touch(){return this.time=P._clock++,this}}P._clock=0;let D=class{constructor(p){this._fileService=p,this._dispooables=new b.DisposableStore,this._limit=2**16;const C=new Map,h=S=>{let w=C.get(S.scheme);return w===void 0&&(w=p.hasProvider(S)&&!this._fileService.hasCapability(S,1024),C.set(S.scheme,w)),w};this._dispooables.add(I.Event.any(p.onDidChangeFileSystemProviderRegistrations,p.onDidChangeFileSystemProviderCapabilities)(S=>{C.delete(S.scheme)})),this.extUri=new L.ExtUri(h),this._canonicalUris=new A.SkipList((S,w)=>this.extUri.compare(S,w,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(p){this._fileService.hasProvider(p)&&(p=(0,L.normalizePath)(p));const C=this._canonicalUris.get(p);return C?C.touch().uri.with({fragment:p.fragment}):(this._canonicalUris.set(p,new P(p)),this._checkTrim(),p)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const p=[...this._canonicalUris.entries()].sort((h,S)=>h[1].touch<S[1].touch?1:h[1].touch>S[1].touch?-1:0);P._clock=0,this._canonicalUris.clear();const C=this._limit*.5;for(let h=0;h<C;h++)this._canonicalUris.set(p[h][0],p[h][1].touch())}};D=me([Q(0,T.IFileService)],D),e.UriIdentityService=D,(0,t.registerSingleton)(k.IUriIdentityService,D,!0)}),define(re[231],se([0,1,3,2,13,41,38,16]),function(Z,e,k,t,T,L,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileUserDataProvider=void 0;class b extends t.Disposable{constructor(D,E,p,C){super();this.fileSystemScheme=D,this.fileSystemProvider=E,this.userDataScheme=p,this.logService=C,this.onDidChangeCapabilities=this.fileSystemProvider.onDidChangeCapabilities,this._onDidChangeFile=this._register(new k.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.watchResources=A.TernarySearchTree.forUris(()=>!(this.capabilities&1024)),this._register(this.fileSystemProvider.onDidChangeFile(h=>this.handleFileChanges(h)))}get capabilities(){return this.fileSystemProvider.capabilities&~4}watch(D,E){this.watchResources.set(D,D);const p=this.fileSystemProvider.watch(this.toFileSystemResource(D),E);return(0,t.toDisposable)(()=>{this.watchResources.delete(D),p.dispose()})}stat(D){return this.fileSystemProvider.stat(this.toFileSystemResource(D))}mkdir(D){return this.fileSystemProvider.mkdir(this.toFileSystemResource(D))}rename(D,E,p){return this.fileSystemProvider.rename(this.toFileSystemResource(D),this.toFileSystemResource(E),p)}readFile(D){return this.fileSystemProvider.readFile(this.toFileSystemResource(D),{atomic:!0})}readFileStream(D,E,p){const C=(0,L.newWriteableStream)(h=>I.VSBuffer.concat(h.map(S=>I.VSBuffer.wrap(S))).buffer);return(async()=>{try{const h=await this.readFile(D);C.end(h)}catch(h){C.error(h),C.end()}})(),C}readdir(D){return this.fileSystemProvider.readdir(this.toFileSystemResource(D))}writeFile(D,E,p){return this.fileSystemProvider.writeFile(this.toFileSystemResource(D),E,p)}delete(D,E){return this.fileSystemProvider.delete(this.toFileSystemResource(D),E)}copy(D,E,p){if((0,T.hasFileFolderCopyCapability)(this.fileSystemProvider))return this.fileSystemProvider.copy(this.toFileSystemResource(D),this.toFileSystemResource(E),p);throw new Error("copy not supported")}handleFileChanges(D){const E=[];for(const p of D){if(p.resource.scheme!==this.fileSystemScheme)continue;const C=this.toUserDataResource(p.resource);this.watchResources.findSubstr(C)&&E.push({resource:C,type:p.type})}E.length&&(this.logService.debug("User data changed"),this._onDidChangeFile.fire(E))}toFileSystemResource(D){return D.with({scheme:this.fileSystemScheme})}toUserDataResource(D){return D.with({scheme:this.userDataScheme})}}e.FileUserDataProvider=b}),define(re[28],se([0,1,63,3,2,19,14,8,158,15,13,5,7]),function(Z,e,k,t,T,L,A,I,b,P,D,E,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=e.toUserDataProfile=e.EXTENSIONS_RESOURCE_NAME=e.reviveProfile=e.IUserDataProfilesService=e.PROFILES_ENABLEMENT_CONFIG=e.isUserDataProfile=void 0;function C(d){const m=d;return!!(m&&typeof m=="object"&&typeof m.id=="string"&&typeof m.isDefault=="boolean"&&typeof m.name=="string"&&I.URI.isUri(m.location)&&I.URI.isUri(m.globalStorageHome)&&I.URI.isUri(m.settingsResource)&&I.URI.isUri(m.keybindingsResource)&&I.URI.isUri(m.tasksResource)&&I.URI.isUri(m.snippetsHome)&&((0,A.isUndefined)(m.extensionsResource)||I.URI.isUri(m.extensionsResource)))}e.isUserDataProfile=C,e.PROFILES_ENABLEMENT_CONFIG="workbench.experimental.settingsProfiles.enabled",e.IUserDataProfilesService=(0,E.createDecorator)("IUserDataProfilesService");function h(d,m){return{id:d.id,isDefault:d.isDefault,name:d.name,location:I.URI.revive(d.location).with({scheme:m}),globalStorageHome:I.URI.revive(d.globalStorageHome).with({scheme:m}),settingsResource:I.URI.revive(d.settingsResource).with({scheme:m}),keybindingsResource:I.URI.revive(d.keybindingsResource).with({scheme:m}),tasksResource:I.URI.revive(d.tasksResource).with({scheme:m}),snippetsHome:I.URI.revive(d.snippetsHome).with({scheme:m}),extensionsResource:I.URI.revive(d.extensionsResource)?.with({scheme:m})}}e.reviveProfile=h,e.EXTENSIONS_RESOURCE_NAME="extensions.json";function S(d,m,g){return{id:(0,k.hash)(m.toString()).toString(16),name:d,location:m,isDefault:!1,globalStorageHome:(0,L.joinPath)(m,"globalStorage"),settingsResource:(0,L.joinPath)(m,"settings.json"),keybindingsResource:(0,L.joinPath)(m,"keybindings.json"),tasksResource:(0,L.joinPath)(m,"tasks.json"),snippetsHome:(0,L.joinPath)(m,"snippets"),extensionsResource:(0,L.joinPath)(m,e.EXTENSIONS_RESOURCE_NAME),useDefaultFlags:g}}e.toUserDataProfile=S;let w=class extends T.Disposable{constructor(m,g,f){super();this.environmentService=m,this.fileService=g,this.logService=f,this._defaultProfile=this.createDefaultUserDataProfile(!1),this._onDidChangeProfiles=this._register(new t.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this.profilesHome=(0,L.joinPath)(this.environmentService.userRoamingDataHome,"profiles")}get defaultProfile(){return this.profiles[0]??this._defaultProfile}get profiles(){return[]}newProfile(m,g){return S(m,(0,L.joinPath)(this.profilesHome,(0,k.hash)(m).toString(16)),g)}createDefaultUserDataProfile(m){const g=S((0,b.localize)(0,null),this.environmentService.userRoamingDataHome);return{...g,isDefault:!0,extensionsResource:m?g.extensionsResource:void 0}}createProfile(m,g){throw new Error("Not implemented")}setProfileForWorkspace(m,g){throw new Error("Not implemented")}getProfile(m){throw new Error("Not implemented")}removeProfile(m){throw new Error("Not implemented")}};w=me([Q(0,P.IEnvironmentService),Q(1,D.IFileService),Q(2,p.ILogService)],w),e.UserDataProfilesService=w}),define(re[46],se([0,1,6,16,2,38,8,32,13,5,7,33,28]),function(Z,e,k,t,T,L,A,I,b,P,D,E,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=e.IExtensionsProfileScannerService=void 0,e.IExtensionsProfileScannerService=(0,P.createDecorator)("IExtensionsProfileScannerService");let C=class extends T.Disposable{constructor(S,w,d,m){super();this.fileService=S,this.uriIdentityService=w,this.userDataProfilesService=d,this.logService=m,this.resourcesAccessQueueMap=new L.ResourceMap,this.migratePromise=this.migrate()}async migrate(){await Promise.all(this.userDataProfilesService.profiles.map(async S=>{if(!!S.extensionsResource)try{let w=!1;const d=JSON.parse((await this.fileService.readFile(S.extensionsResource)).value.toString());for(const m of d)if(!!m.location&&!m.version)try{const g=(await this.fileService.readFile(this.uriIdentityService.extUri.joinPath(A.URI.revive(m.location),"package.json"))).value.toString();m.version=JSON.parse(g).version,w=!0}catch{}w&&await this.fileService.writeFile(S.extensionsResource,t.VSBuffer.fromString(JSON.stringify(d)))}catch{}}))}scanProfileExtensions(S){return this.withProfileExtensions(S)}addExtensionsToProfile(S,w){return this.withProfileExtensions(w,d=>(d=d.filter(m=>S.some(([g])=>!(0,I.areSameExtensions)(m.identifier,g.identifier))),d.push(...S.map(([m,g])=>({identifier:m.identifier,version:m.manifest.version,location:m.location,metadata:g}))),d))}removeExtensionFromProfile(S,w){return this.withProfileExtensions(w,d=>d.filter(m=>!(0,I.areSameExtensions)(m.identifier,S)))}async withProfileExtensions(S,w){return await this.migratePromise,this.getResourceAccessQueue(S).queue(async()=>{let d=[];try{const m=await this.fileService.readFile(S),g=JSON.parse(m.value.toString());for(const f of g){if(!f.identifier){this.logService.info("Ignoring invalid extension while scanning. Identifier does not exist.",f);continue}if(!f.location){this.logService.info("Ignoring invalid extension while scanning. Location does not exist.",f);continue}if(!f.version){this.logService.info("Ignoring invalid extension while scanning. Version does not exist.",f);continue}d.push({identifier:f.identifier,location:A.URI.revive(f.location),version:f.version,metadata:f.metadata})}}catch(m){m.fileOperationResult!==1&&this.logService.error(m)}if(w){d=w(d);const m=d.map(g=>({identifier:g.identifier,version:g.version,location:g.location.toJSON(),metadata:g.metadata}));await this.fileService.writeFile(S,t.VSBuffer.fromString(JSON.stringify(m)))}return d})}getResourceAccessQueue(S){let w=this.resourcesAccessQueueMap.get(S);return w||(w=new k.Queue,this.resourcesAccessQueueMap.set(S,w)),w}};C=me([Q(0,b.IFileService),Q(1,E.IUriIdentityService),Q(2,p.IUserDataProfilesService),Q(3,D.ILogService)],C),e.ExtensionsProfileScannerService=C}),define(re[232],se([0,1,17,6,23,9,3,2,4,8,141,30,32,46,7,24,21,33,28]),function(Z,e,k,t,T,L,A,I,b,P,D,E,p,C,h,S,w,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=void 0;let g=class extends I.Disposable{constructor(s,o,l,v,y,O,_){super();this.userDataProfilesService=s,this.uriIdenityService=o,this.galleryService=l,this.extensionsProfileScannerService=v,this.telemetryService=y,this.logService=O,this.productService=_,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new A.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new A.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new A.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new A.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,I.toDisposable)(()=>{this.installingExtensions.forEach(F=>F.cancel()),this.uninstallingExtensions.forEach(F=>F.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(s){const o=await this.getTargetPlatform();return s.allTargetPlatforms.some(l=>(0,E.isTargetPlatformCompatible)(l,s.allTargetPlatforms,o))}async installFromGallery(s,o={}){try{if(!this.galleryService.isEnabled())throw new E.ExtensionManagementError(D.localize(0,null),E.ExtensionManagementErrorCode.Internal);const l=await this.checkAndGetCompatibleVersion(s,!!o.installGivenVersion,!!o.installPreReleaseVersion);return await this.installExtension(l.manifest,l.extension,o)}catch(l){throw r(this.telemetryService,"extensionGallery:install",{extensionData:(0,p.getGalleryExtensionTelemetryData)(s),error:l}),this.logService.error("Failed to install extension.",s.identifier.id),this.logService.error(l),u(l)}}async uninstall(s,o={}){return this.logService.trace("ExtensionManagementService#uninstall",s.identifier.id),this.unininstallExtension(s,o)}async reinstallFromGallery(s){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",s.identifier.id),!this.galleryService.isEnabled())throw new Error(D.localize(1,null));const o=await this.getTargetPlatform(),[l]=await this.galleryService.getExtensions([{...s.identifier,preRelease:s.preRelease}],{targetPlatform:o,compatible:!0},T.CancellationToken.None);if(!l)throw new Error(D.localize(2,null));await this.createDefaultUninstallExtensionTask(s,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(l)}getExtensionsControlManifest(){const s=new Date().getTime();return(!this.extensionsControlManifest||s-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=s),this.extensionsControlManifest}registerParticipant(s){this.participants.push(s)}async installExtension(s,o,l){if(!P.URI.isUri(o)){const F=this.installingExtensions.get(p.ExtensionKey.create(o).toString());if(F){this.logService.info("Extensions is already requested to install",o.identifier.id);const R=this.createWaitUntilInstallExtensionTaskIsFinishedTask(F,l),{local:U}=await R.waitUntilTaskIsFinished();return U}l={...l,installOnlyNewlyAddedFromExtensionPack:!0}}const v=[],y=[],O=this.createInstallExtensionTask(s,o,l);P.URI.isUri(o)||this.installingExtensions.set(p.ExtensionKey.create(o).toString(),O),this._onInstallExtension.fire({identifier:O.identifier,source:o,profileLocation:l.profileLocation}),this.logService.info("Installing extension:",O.identifier.id),v.push({task:O,manifest:s});let _=!1;try{if(l.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",O.identifier.id);else try{const R=await this.getAllDepsAndPackExtensionsToInstall(O.identifier,s,!!l.installOnlyNewlyAddedFromExtensionPack,!!l.installPreReleaseVersion,l.profileLocation);for(const{gallery:U,manifest:M}of R){_=_||!!M.extensionDependencies?.some(W=>(0,p.areSameExtensions)({id:W},O.identifier));const V=p.ExtensionKey.create(U).toString();if(this.installingExtensions.has(V))this.logService.info("Extension is already requested to install",U.identifier.id);else{const W=this.createInstallExtensionTask(M,U,{...l,donotIncludePackAndDependencies:!0});this.installingExtensions.set(V,W),this._onInstallExtension.fire({identifier:W.identifier,source:U,profileLocation:l.profileLocation}),this.logService.info("Installing extension:",W.identifier.id),v.push({task:W,manifest:M})}}}catch(R){if(P.URI.isUri(O.source))(0,k.isNonEmptyArray)(s.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",O.identifier.id,R.message),(0,k.isNonEmptyArray)(s.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",O.identifier.id,R.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",O.identifier.id),R}const F=v.reduce((R,{task:U,manifest:M})=>(R.set(U.identifier.id.toLowerCase(),{task:U,manifest:M}),R),new Map);for(;F.size;){let R;const U=[...F.values()].filter(({manifest:M})=>!M.extensionDependencies?.some(V=>F.has(V.toLowerCase())));U.length?R=F.size===1?U:U.filter(({task:M})=>!(M===O&&!_)):(this.logService.info("Found extensions with circular dependencies",U.map(({task:M})=>M.identifier.id)),R=[...F.values()]),await this.joinAllSettled(R.map(async({task:M})=>{const V=new Date().getTime();try{const{local:W}=await M.run();if(await this.joinAllSettled(this.participants.map(z=>z.postInstall(W,M.source,l,T.CancellationToken.None))),!P.URI.isUri(M.source)){const z=M.operation===3,te=z?void 0:(new Date().getTime()-M.source.lastUpdated)/1e3;if(r(this.telemetryService,z?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,p.getGalleryExtensionTelemetryData)(M.source),duration:new Date().getTime()-V,durationSinceUpdate:te}),b.isWeb&&M.operation!==3)try{await this.galleryService.reportStatistic(W.manifest.publisher,W.manifest.name,W.manifest.version,"install")}catch{}}y.push({local:W,identifier:M.identifier,operation:M.operation,source:M.source,context:l.context,profileLocation:l.profileLocation,applicationScoped:W.isApplicationScoped})}catch(W){throw P.URI.isUri(M.source)||r(this.telemetryService,M.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,p.getGalleryExtensionTelemetryData)(M.source),duration:new Date().getTime()-V,error:W}),this.logService.error("Error while installing the extension:",M.identifier.id),W}finally{F.delete(M.identifier.id.toLowerCase())}}))}return y.forEach(({identifier:R})=>this.logService.info("Extension installed successfully:",R.id)),this._onDidInstallExtensions.fire(y),y.filter(({identifier:R})=>(0,p.areSameExtensions)(R,O.identifier))[0].local}catch(F){if(v.forEach(({task:R})=>R.cancel()),y.length)try{const R=await Promise.allSettled(y.map(({local:U})=>this.createUninstallExtensionTask(U,{versionOnly:!0},l.profileLocation).run()));for(let U=0;U<R.length;U++){const M=R[U],{identifier:V}=y[U];M.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",V.id):this.logService.warn("Rollback: Error while uninstalling extension",V.id,(0,L.getErrorMessage)(M.reason))}}catch(R){this.logService.warn("Error while rolling back extensions",(0,L.getErrorMessage)(R),y.map(({identifier:U})=>U.id))}throw this._onDidInstallExtensions.fire(v.map(({task:R})=>({identifier:R.identifier,operation:2,source:R.source,context:l.context,profileLocation:l.profileLocation}))),F}finally{for(const{task:F}of v)if(!P.URI.isUri(F.source)){const R=p.ExtensionKey.create(F.source).toString();this.installingExtensions.delete(R)||this.logService.warn("Installation task is not found in the cache",R)}}}async joinAllSettled(s){const o=[],l=[],v=await Promise.allSettled(s);for(const y of v)y.status==="fulfilled"?o.push(y.value):l.push(y.reason);if(l.length)throw f(l);return o}async getAllDepsAndPackExtensionsToInstall(s,o,l,v,y){if(!this.galleryService.isEnabled())return[];let O=await this.getInstalled(void 0,y);const _=[s,...O.map(U=>U.identifier)],F=[],R=async(U,M)=>{const V=M.extensionDependencies||[],W=[...V];if(M.extensionPack){const z=l?O.find(te=>(0,p.areSameExtensions)(te.identifier,U)):void 0;for(const te of M.extensionPack)z&&z.manifest.extensionPack&&z.manifest.extensionPack.some(H=>(0,p.areSameExtensions)({id:H},{id:te}))||W.every(H=>!(0,p.areSameExtensions)({id:H},{id:te}))&&W.push(te)}if(W.length){const z=[..._,...F.map(H=>H.gallery.identifier)],te=W.filter(H=>z.every(K=>!(0,p.areSameExtensions)(K,{id:H})));if(te.length){const H=await this.galleryService.getExtensions(te.map(K=>({id:K,preRelease:v})),T.CancellationToken.None);for(const K of H){if(z.find(x=>(0,p.areSameExtensions)(x,K.identifier)))continue;const X=V.some(x=>(0,p.areSameExtensions)({id:x},K.identifier));let Y;try{Y=await this.checkAndGetCompatibleVersion(K,!1,v)}catch(x){if(x instanceof E.ExtensionManagementError&&x.code===E.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!X){this.logService.info("Skipping the packed extension as it cannot be installed",K.identifier.id);continue}else throw x}F.push({gallery:Y.extension,manifest:Y.manifest}),await R(Y.extension.identifier,Y.manifest)}}}};return await R(s,o),O=await this.getInstalled(void 0,y),F.filter(U=>!O.some(M=>(0,p.areSameExtensions)(M.identifier,U.gallery.identifier)))}async checkAndGetCompatibleVersion(s,o,l){const v=await this.getExtensionsControlManifest();if((0,p.getMaliciousExtensionsSet)(v).has(s.identifier.id))throw new E.ExtensionManagementError(D.localize(3,null,s.identifier.id),E.ExtensionManagementErrorCode.Malicious);if(!await this.canInstall(s)){const _=await this.getTargetPlatform();throw new E.ExtensionManagementError(D.localize(4,null,s.identifier.id,this.productService.nameLong,(0,E.TargetPlatformToString)(_)),E.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const y=await this.getCompatibleVersion(s,o,l);if(y){if(l&&!o&&s.hasPreReleaseVersion&&!y.properties.isPreReleaseVersion)throw new E.ExtensionManagementError(D.localize(5,null,s.identifier.id,this.productService.nameLong,this.productService.version),E.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!l&&s.properties.isPreReleaseVersion&&(await this.galleryService.getExtensions([s.identifier],T.CancellationToken.None))[0]?new E.ExtensionManagementError(D.localize(6,null,s.identifier.id),E.ExtensionManagementErrorCode.ReleaseVersionNotFound):new E.ExtensionManagementError(D.localize(7,null,s.identifier.id,this.productService.nameLong,this.productService.version),E.ExtensionManagementErrorCode.Incompatible);this.logService.info("Getting Manifest...",y.identifier.id);const O=await this.galleryService.getManifest(y,T.CancellationToken.None);if(O===null)throw new E.ExtensionManagementError(`Missing manifest for extension ${s.identifier.id}`,E.ExtensionManagementErrorCode.Invalid);if(O.version!==y.version)throw new E.ExtensionManagementError(`Cannot install '${s.identifier.id}' extension because of version mismatch in Marketplace`,E.ExtensionManagementErrorCode.Invalid);return{extension:y,manifest:O}}async getCompatibleVersion(s,o,l){const v=await this.getTargetPlatform();let y=null;return!o&&s.hasPreReleaseVersion&&s.properties.isPreReleaseVersion!==l&&(y=(await this.galleryService.getExtensions([{...s.identifier,preRelease:l}],{targetPlatform:v,compatible:!0},T.CancellationToken.None))[0]||null),!y&&await this.galleryService.isExtensionCompatible(s,l,v)&&(y=s),y||(o?y=(await this.galleryService.getExtensions([{...s.identifier,version:s.version}],{targetPlatform:v,compatible:!0},T.CancellationToken.None))[0]||null:y=await this.galleryService.getCompatibleExtension(s,l,v)),y}async unininstallExtension(s,o){const l=R=>`${R.id.toLowerCase()}${o.profileLocation?`@${o.profileLocation.toString()}`:""}`,v=this.uninstallingExtensions.get(l(s.identifier));if(v)return this.logService.info("Extensions is already requested to uninstall",s.identifier.id),v.waitUntilTaskIsFinished();const y=(R,U)=>{const M=this.createUninstallExtensionTask(R,U,o.profileLocation);return this.uninstallingExtensions.set(l(M.extension.identifier),M),o.profileLocation?this.logService.info("Uninstalling extension from the profile:",`${R.identifier.id}@${R.manifest.version}`,o.profileLocation.toString()):this.logService.info("Uninstalling extension:",`${R.identifier.id}@${R.manifest.version}`),this._onUninstallExtension.fire({identifier:R.identifier,profileLocation:o.profileLocation,applicationScoped:R.isApplicationScoped}),M},O=(R,U)=>{U?o.profileLocation?this.logService.error("Failed to uninstall extension from the profile:",`${R.identifier.id}@${R.manifest.version}`,o.profileLocation.toString(),U.message):this.logService.error("Failed to uninstall extension:",`${R.identifier.id}@${R.manifest.version}`,U.message):o.profileLocation?this.logService.info("Successfully uninstalled extension from the profile",`${R.identifier.id}@${R.manifest.version}`,o.profileLocation.toString()):this.logService.info("Successfully uninstalled extension:",`${R.identifier.id}@${R.manifest.version}`),r(this.telemetryService,"extensionGallery:uninstall",{extensionData:(0,p.getLocalExtensionTelemetryData)(R),error:U}),this._onDidUninstallExtension.fire({identifier:R.identifier,version:R.manifest.version,error:U?.code,profileLocation:o.profileLocation,applicationScoped:R.isApplicationScoped})},_=[],F=[];try{_.push(y(s,o));const R=await this.getInstalled(1,o.profileLocation);if(o.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",`${s.identifier.id}@${s.manifest.version}`);else{const U=this.getAllPackExtensionsToUninstall(s,R);for(const M of U)this.uninstallingExtensions.has(l(M.identifier))?this.logService.info("Extensions is already requested to uninstall",M.identifier.id):_.push(y(M,o))}o.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",`${s.identifier.id}@${s.manifest.version}`):this.checkForDependents(_.map(U=>U.extension),R,s),await this.joinAllSettled(_.map(async U=>{try{if(await U.run(),await this.joinAllSettled(this.participants.map(M=>M.postUninstall(U.extension,o,T.CancellationToken.None))),U.extension.identifier.uuid)try{await this.galleryService.reportStatistic(U.extension.manifest.publisher,U.extension.manifest.name,U.extension.manifest.version,"uninstall")}catch{}O(U.extension)}catch(M){const V=M instanceof E.ExtensionManagementError?M:new E.ExtensionManagementError((0,L.getErrorMessage)(M),E.ExtensionManagementErrorCode.Internal);throw O(U.extension,V),V}finally{F.push(U)}}))}catch(R){const U=R instanceof E.ExtensionManagementError?R:new E.ExtensionManagementError((0,L.getErrorMessage)(R),E.ExtensionManagementErrorCode.Internal);for(const M of _){try{M.cancel()}catch{}F.includes(M)||O(M.extension,U)}throw U}finally{for(const R of _)this.uninstallingExtensions.delete(l(R.extension.identifier))||this.logService.warn("Uninstallation task is not found in the cache",R.extension.identifier.id)}}checkForDependents(s,o,l){for(const v of s){const y=this.getDependents(v,o);if(y.length){const O=y.filter(_=>!s.some(F=>(0,p.areSameExtensions)(F.identifier,_.identifier)));if(O.length)throw new Error(this.getDependentsErrorMessage(v,O,l))}}}getDependentsErrorMessage(s,o,l){return l===s?o.length===1?D.localize(8,null,l.manifest.displayName||l.manifest.name,o[0].manifest.displayName||o[0].manifest.name):o.length===2?D.localize(9,null,l.manifest.displayName||l.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):D.localize(10,null,l.manifest.displayName||l.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):o.length===1?D.localize(11,null,l.manifest.displayName||l.manifest.name,s.manifest.displayName||s.manifest.name,o[0].manifest.displayName||o[0].manifest.name):o.length===2?D.localize(12,null,l.manifest.displayName||l.manifest.name,s.manifest.displayName||s.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):D.localize(13,null,l.manifest.displayName||l.manifest.name,s.manifest.displayName||s.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name)}getAllPackExtensionsToUninstall(s,o,l=[]){if(l.indexOf(s)!==-1)return[];l.push(s);const v=s.manifest.extensionPack?s.manifest.extensionPack:[];if(v.length){const y=o.filter(_=>!_.isBuiltin&&v.some(F=>(0,p.areSameExtensions)({id:F},_.identifier))),O=[];for(const _ of y)O.push(...this.getAllPackExtensionsToUninstall(_,o,l));return[...y,...O]}return[]}getDependents(s,o){return o.filter(l=>l.manifest.extensionDependencies&&l.manifest.extensionDependencies.some(v=>(0,p.areSameExtensions)({id:v},s.identifier)))}async updateControlCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const s=await this.galleryService.getExtensionsControlManifest();return this.logService.trace("ExtensionManagementService.refreshControlCache",s),s}catch{return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{}}}}createInstallExtensionTask(s,o,l){const v=this.createDefaultInstallExtensionTask(s,o,l);return l.profileLocation&&this.userDataProfilesService.defaultProfile.extensionsResource?new i(v,l.profileLocation,this.userDataProfilesService.defaultProfile.extensionsResource,this.extensionsProfileScannerService):v}createWaitUntilInstallExtensionTaskIsFinishedTask(s,o){return!o.profileLocation||!this.userDataProfilesService.defaultProfile.extensionsResource||s instanceof i&&this.uriIdenityService.extUri.isEqual(s.profileLocation,o.profileLocation)?s:new i(s,o.profileLocation,this.userDataProfilesService.defaultProfile.extensionsResource,this.extensionsProfileScannerService)}createUninstallExtensionTask(s,o,l){return l&&this.userDataProfilesService.defaultProfile.extensionsResource?new a(s,l,this.userDataProfilesService,this.extensionsProfileScannerService):this.createDefaultUninstallExtensionTask(s,o)}};g=me([Q(0,m.IUserDataProfilesService),Q(1,d.IUriIdentityService),Q(2,E.IExtensionGalleryService),Q(3,C.IExtensionsProfileScannerService),Q(4,w.ITelemetryService),Q(5,h.ILogService),Q(6,S.IProductService)],g),e.AbstractExtensionManagementService=g;function f(c){const s=Array.isArray(c)?c:[c];return s.length===1?s[0]instanceof Error?s[0]:new Error(s[0]):s.reduce((o,l)=>new Error(`${o.message}${o.message?",":""}${l instanceof Error?l.message:l}`),new Error(""))}e.joinErrors=f;function u(c){if(c instanceof E.ExtensionManagementError)return c;const s=new E.ExtensionManagementError(c.message,E.ExtensionManagementErrorCode.Internal);return s.stack=c.stack,s}function r(c,s,{extensionData:o,duration:l,error:v,durationSinceUpdate:y}){const O=v?v instanceof E.ExtensionManagementError?v.code:E.ExtensionManagementErrorCode.Internal:void 0;c.publicLog(s,{...o,success:!v,duration:l,errorcode:O,durationSinceUpdate:y})}e.reportTelemetry=r;class n{constructor(){this.barrier=new t.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,t.createCancelablePromise)(s=>this.doRun(s))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,t.createCancelablePromise)(s=>new Promise((o,l)=>{const v=s.onCancellationRequested(()=>{v.dispose(),l(new L.CancellationError)})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=n;class i{constructor(s,o,l,v){this.task=s,this.profileLocation=o,this.defaultProfileLocation=l,this.extensionsProfileScannerService=v,this.identifier=this.task.identifier,this.source=this.task.source,this.operation=this.task.operation,this.promise=this.waitAndAddExtensionToProfile()}async waitAndAddExtensionToProfile(){const s=await this.task.waitUntilTaskIsFinished(),o=s.local.isApplicationScoped?this.defaultProfileLocation:this.profileLocation;return await this.extensionsProfileScannerService.addExtensionsToProfile([[s.local,s.metadata]],o),s}async run(){return await this.task.run(),this.promise}waitUntilTaskIsFinished(){return this.promise}cancel(){return this.task.cancel()}}class a extends n{constructor(s,o,l,v){super();this.extension=s,this.profileLocation=o,this.userDataProfilesService=l,this.extensionsProfileScannerService=v}async doRun(s){const o=[];o.push(this.extensionsProfileScannerService.removeExtensionFromProfile(this.extension.identifier,this.profileLocation)),this.extension.isApplicationScoped&&this.userDataProfilesService.defaultProfile.extensionsResource&&o.push(this.extensionsProfileScannerService.removeExtensionFromProfile(this.extension.identifier,this.userDataProfilesService.defaultProfile.extensionsResource)),await Promise.all(o)}}}),define(re[71],se([0,1,17,6,29,16,9,34,123,2,20,12,4,19,55,81,14,8,143,15,32,50,66,13,5,7,24,3,64,46,28]),function(Z,e,k,t,T,L,A,I,b,P,D,E,p,C,h,S,w,d,m,g,f,u,r,n,i,a,c,s,o,l,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var y;(function(V){function W(z,te){if(z===te)return!0;const H=Object.keys(z),K=new Set;for(const X of Object.keys(te))K.add(X);if(H.length!==K.size)return!1;for(const X of H){if(z[X]!==te[X])return!1;K.delete(X)}return K.size===0}V.equals=W})(y=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,i.createDecorator)("IExtensionsScannerService");let O=class extends P.Disposable{constructor(W,z,te,H,K,X,Y,x,B,J){super();this.systemExtensionsLocation=W,this.userExtensionsLocation=z,this.extensionsControlLocation=te,this.cacheLocation=H,this.userDataProfilesService=K,this.extensionsProfileScannerService=X,this.fileService=Y,this.logService=x,this.environmentService=B,this.productService=J,this._onDidChangeCache=this._register(new s.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.obsoleteFile=(0,C.joinPath)(this.userExtensionsLocation,".obsolete"),this.systemExtensionsCachedScanner=this._register(new R((0,C.joinPath)(this.cacheLocation,u.BUILTIN_MANIFEST_CACHE_FILE),this.obsoleteFile,this.extensionsProfileScannerService,this.fileService,this.logService)),this.userExtensionsCachedScanner=this._register(new R((0,C.joinPath)(this.cacheLocation,u.USER_MANIFEST_CACHE_FILE),this.obsoleteFile,this.extensionsProfileScannerService,this.fileService,this.logService)),this.extensionsScanner=this._register(new F(this.obsoleteFile,this.extensionsProfileScannerService,this.fileService,this.logService)),this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(0))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(1)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,f.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions(W,z){const[te,H]=await Promise.all([this.scanSystemExtensions(W),this.scanUserExtensions(z)]),K=await this.scanExtensionsUnderDevelopment(W,[...te,...H]);return this.dedupExtensions(te,H,K,await this.getTargetPlatform(),!0)}async scanSystemExtensions(W){const z=[];z.push(this.scanDefaultSystemExtensions(!!W.useCache,W.language)),z.push(this.scanDevSystemExtensions(W.language,!!W.checkControlFile));const[te,H]=await Promise.all(z);return this.applyScanOptions([...te,...H],0,W,!1)}async scanUserExtensions(W){this.logService.trace("Started scanning user extensions");const z=await this.createExtensionScannerInput(W.profileLocation??this.userExtensionsLocation,!!W.profileLocation,1,!W.includeUninstalled,W.language);let H=await(W.useCache&&!z.devMode&&z.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner).scanExtensions(z);return H=await this.applyScanOptions(H,1,W,!0),this.logService.trace("Scanned user extensions:",H.length),H}async scanExtensionsUnderDevelopment(W,z){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const te=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(H=>H.scheme===D.Schemas.file).map(async H=>{const K=await this.createExtensionScannerInput(H,!1,1,!0,W.language,!1);return(await this.extensionsScanner.scanOneOrMultipleExtensions(K)).map(Y=>(Y.type=z.find(x=>(0,f.areSameExtensions)(x.identifier,Y.identifier))?.type??Y.type,this.extensionsScanner.validate(Y,K)))}))).flat();return this.applyScanOptions(te,"development",W,!0)}return[]}async scanExistingExtension(W,z,te){const H=await this.createExtensionScannerInput(W,!1,z,!0,te.language),K=await this.extensionsScanner.scanExtension(H);return!K||!te.includeInvalid&&!K.isValid?null:K}async scanOneOrMultipleExtensions(W,z,te){const H=await this.createExtensionScannerInput(W,!1,z,!0,te.language),K=await this.extensionsScanner.scanOneOrMultipleExtensions(H);return this.applyScanOptions(K,z,te,!0)}async scanMetadata(W){const z=(0,C.joinPath)(W,"package.json"),te=(await this.fileService.readFile(z)).value.toString();return JSON.parse(te).__metadata}async updateMetadata(W,z){const te=(0,C.joinPath)(W,"package.json"),H=(await this.fileService.readFile(te)).value.toString(),K=JSON.parse(H);z.isMachineScoped=z.isMachineScoped||void 0,z.isBuiltin=z.isBuiltin||void 0,z.installedTimestamp=z.installedTimestamp||void 0,K.__metadata={...K.__metadata,...z},await this.fileService.writeFile((0,C.joinPath)(W,"package.json"),L.VSBuffer.fromString(JSON.stringify(K,null,"	")))}async applyScanOptions(W,z,te,H){return te.includeAllVersions||(W=this.dedupExtensions(z===0?W:void 0,z===1?W:void 0,z==="development"?W:void 0,await this.getTargetPlatform(),H)),te.includeInvalid||(W=W.filter(K=>K.isValid)),W.sort((K,X)=>{const Y=E.basename(K.location.fsPath),x=E.basename(X.location.fsPath);return Y<x?-1:Y>x?1:0})}dedupExtensions(W,z,te,H,K){const X=(x,B)=>{if(x.isValid&&!B.isValid)return!1;if(x.isValid===B.isValid){if(K&&h.gt(x.manifest.version,B.manifest.version))return this.logService.debug(`Skipping extension ${B.location.path} with lower version ${B.manifest.version} in favour of ${x.location.path} with version ${x.manifest.version}`),!1;if(h.eq(x.manifest.version,B.manifest.version)){if(x.type===0)return this.logService.debug(`Skipping extension ${B.location.path} in favour of system extension ${x.location.path} with same version`),!1;if(x.targetPlatform===H)return this.logService.debug(`Skipping extension ${B.location.path} from different target platform ${B.targetPlatform}`),!1}}return x.type===0?this.logService.debug(`Overwriting system extension ${x.location.path} with ${B.location.path}.`):this.logService.warn(`Overwriting user extension ${x.location.path} with ${B.location.path}.`),!0},Y=new Map;return W?.forEach(x=>{const B=u.ExtensionIdentifier.toKey(x.identifier.id),J=Y.get(B);(!J||X(J,x))&&Y.set(B,x)}),z?.forEach(x=>{const B=u.ExtensionIdentifier.toKey(x.identifier.id),J=Y.get(B);if(!J&&W&&x.type===0){this.logService.debug(`Skipping obsolete system extension ${x.location.path}.`);return}(!J||X(J,x))&&Y.set(B,x)}),te?.forEach(x=>{const B=u.ExtensionIdentifier.toKey(x.identifier.id),J=Y.get(B);(!J||X(J,x))&&Y.set(B,x),Y.set(B,x)}),[...Y.values()]}async scanDefaultSystemExtensions(W,z){this.logService.trace("Started scanning system extensions");const te=await this.createExtensionScannerInput(this.systemExtensionsLocation,!1,0,!0,z),K=await(W&&!te.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(te);return this.logService.trace("Scanned system extensions:",K.length),K}async scanDevSystemExtensions(W,z){const te=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!te?.length)return[];this.logService.trace("Started scanning dev system extensions");const H=z?await this.getBuiltInExtensionControl():{},K=[],X=d.URI.file(E.normalize(E.join(D.FileAccess.asFileUri("",Z).fsPath,"..",".build","builtInExtensions")));for(const x of te){const B=H[x.name]||"marketplace";switch(B){case"disabled":break;case"marketplace":K.push((0,C.joinPath)(X,x.name));break;default:K.push(d.URI.file(B));break}}const Y=await Promise.all(K.map(async x=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput(x,!1,0,!0,W))));return this.logService.trace("Scanned dev system extensions:",Y.length),(0,k.coalesce)(Y)}async getBuiltInExtensionControl(){try{const W=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse(W.value.toString())}catch{return{}}}async createExtensionScannerInput(W,z,te,H,K,X=!0){const Y=await this.getTranslations(K??p.language),x=await this.getMtime(W),B=this.userDataProfilesService.defaultProfile.extensionsResource,J=B?await this.getMtime(B):void 0;return new _(W,x,B,J,z,te,H,X,this.productService.version,this.productService.date,this.productService.commit,!this.environmentService.isBuilt,K,Y)}async getMtime(W){try{const z=await this.fileService.stat(W);if(typeof z.mtime=="number")return z.mtime}catch{}}};O=me([Q(4,v.IUserDataProfilesService),Q(5,l.IExtensionsProfileScannerService),Q(6,n.IFileService),Q(7,a.ILogService),Q(8,g.IEnvironmentService),Q(9,c.IProductService)],O),e.AbstractExtensionsScannerService=O;class _{constructor(W,z,te,H,K,X,Y,x,B,J,N,$,j,G){this.location=W,this.mtime=z,this.applicationExtensionslocation=te,this.applicationExtensionslocationMtime=H,this.profile=K,this.type=X,this.excludeObsolete=Y,this.validate=x,this.productVersion=B,this.productDate=J,this.productCommit=N,this.devMode=$,this.language=j,this.translations=G}static createNlsConfiguration(W){return{language:W.language,pseudo:W.language==="pseudo",devMode:W.devMode,translations:W.translations}}static equals(W,z){return(0,C.isEqual)(W.location,z.location)&&W.mtime===z.mtime&&(0,C.isEqual)(W.applicationExtensionslocation,z.applicationExtensionslocation)&&W.applicationExtensionslocationMtime===z.applicationExtensionslocationMtime&&W.profile===z.profile&&W.type===z.type&&W.excludeObsolete===z.excludeObsolete&&W.validate===z.validate&&W.productVersion===z.productVersion&&W.productDate===z.productDate&&W.productCommit===z.productCommit&&W.devMode===z.devMode&&W.language===z.language&&y.equals(W.translations,z.translations)}}class F extends P.Disposable{constructor(W,z,te,H){super();this.obsoleteFile=W,this.extensionsProfileScannerService=z,this.fileService=te,this.logService=H}async scanExtensions(W){const z=W.profile?await this.scanExtensionsFromProfile(W):await this.scanExtensionsFromLocation(W);let te={};if(W.excludeObsolete&&W.type===1)try{const H=(await this.fileService.readFile(this.obsoleteFile)).value.toString();te=JSON.parse(H)}catch{}return(0,w.isEmptyObject)(te)?z:z.filter(H=>!te[f.ExtensionKey.create(H).toString()])}async scanExtensionsFromLocation(W){const z=await this.fileService.resolve(W.location);if(!z.children?.length)return[];const te=await Promise.all(z.children.map(async H=>{if(!H.isDirectory||W.type===1&&(0,C.basename)(H.resource).indexOf(".")===0)return null;const K=new _(H.resource,W.mtime,W.applicationExtensionslocation,W.applicationExtensionslocationMtime,W.profile,W.type,W.excludeObsolete,W.validate,W.productVersion,W.productDate,W.productCommit,W.devMode,W.language,W.translations);return this.scanExtension(K)}));return(0,k.coalesce)(te)}async scanExtensionsFromProfile(W){const z=await this.scanExtensionsFromProfileResource(W.location,()=>!0,W),te=await this.scanApplicationExtensions(W);return[...z,...te]}async scanApplicationExtensions(W){return W.applicationExtensionslocation?this.scanExtensionsFromProfileResource(W.applicationExtensionslocation,z=>!!z.metadata?.isApplicationScoped,W):[]}async scanExtensionsFromProfileResource(W,z,te){const H=await this.extensionsProfileScannerService.scanProfileExtensions(W);if(!H.length)return[];const K=await Promise.all(H.map(async X=>{if(z(X)){const Y=new _(X.location,te.mtime,te.applicationExtensionslocation,te.applicationExtensionslocationMtime,te.profile,te.type,te.excludeObsolete,te.validate,te.productVersion,te.productDate,te.productCommit,te.devMode,te.language,te.translations);return this.scanExtension(Y,X.metadata)}return null}));return(0,k.coalesce)(K)}async scanOneOrMultipleExtensions(W){try{if(await this.fileService.exists((0,C.joinPath)(W.location,"package.json"))){const z=await this.scanExtension(W);return z?[z]:[]}else return await this.scanExtensions(W)}catch(z){return this.logService.error(`Error scanning extensions at ${W.location.path}:`,(0,A.getErrorMessage)(z)),[]}}async scanExtension(W,z){try{let te=await this.scanExtensionManifest(W.location);if(te){te.publisher||(te.publisher=u.UNDEFINED_PUBLISHER),z=z??te.__metadata,delete te.__metadata;const H=(0,f.getGalleryExtensionId)(te.publisher,te.name),K=z?.id?{id:H,uuid:z.id}:{id:H},X=z?.isSystem?0:W.type,Y=X===0||!!z?.isBuiltin;te=await this.translateManifest(W.location,te,_.createNlsConfiguration(W));const x={type:X,identifier:K,manifest:te,location:W.location,isBuiltin:Y,targetPlatform:z?.targetPlatform??"undefined",metadata:z,isValid:!0,validations:[]};return W.validate?this.validate(x,W):x}}catch(te){W.type!==0&&this.logService.error(te)}return null}validate(W,z){let te=!0;const H=(0,r.validateExtensionManifest)(z.productVersion,z.productDate,z.location,W.manifest,W.isBuiltin);for(const[K,X]of H)K===S.default.Error&&(te=!1,this.logService.error(this.formatMessage(z.location,X)));return W.isValid=te,W.validations=H,W}async scanExtensionManifest(W){const z=(0,C.joinPath)(W,"package.json");let te;try{te=(await this.fileService.readFile(z)).value.toString()}catch(K){return(0,n.toFileOperationResult)(K)!==1&&this.logService.error(this.formatMessage(W,(0,m.localize)(0,null,z.path,K.message))),null}let H;try{H=JSON.parse(te)}catch{const X=[];(0,I.parse)(te,X);for(const Y of X)this.logService.error(this.formatMessage(W,(0,m.localize)(1,null,z.path,Y.offset,Y.length,(0,b.getParseErrorMessage)(Y.error))));return null}return(0,I.getNodeType)(H)!=="object"?(this.logService.error(this.formatMessage(W,(0,m.localize)(2,null,z.path))),null):H}async translateManifest(W,z,te){const H=await this.getLocalizedMessages(W,z,te);if(H)try{const K=[],X=await this.resolveOriginalMessageBundle(H.default,K);if(K.length>0)return K.forEach(x=>{this.logService.error(this.formatMessage(W,(0,m.localize)(3,null,H.default?.path,(0,b.getParseErrorMessage)(x.error))))}),z;if((0,I.getNodeType)(H)!=="object")return this.logService.error(this.formatMessage(W,(0,m.localize)(4,null,H.default?.path))),z;const Y=H.values||Object.create(null);this.replaceNLStrings(te.pseudo,z,Y,X,W)}catch{}return z}async getLocalizedMessages(W,z,te){const H=(0,C.joinPath)(W,"package.nls.json"),K=(B,J)=>{J.forEach(N=>{this.logService.error(this.formatMessage(W,(0,m.localize)(5,null,B?.path,(0,b.getParseErrorMessage)(N.error))))})},X=B=>{this.logService.error(this.formatMessage(W,(0,m.localize)(6,null,B?.path)))},Y=`${z.publisher}.${z.name}`,x=te.translations[Y];if(x)try{const B=d.URI.file(x),J=(await this.fileService.readFile(B)).value.toString(),N=[],$=(0,I.parse)(J,N);return N.length>0?(K(B,N),{values:void 0,default:H}):(0,I.getNodeType)($)!=="object"?(X(B),{values:void 0,default:H}):{values:$.contents?$.contents.package:void 0,default:H}}catch{return{values:void 0,default:H}}else{if(!await this.fileService.exists(H))return;let J;try{J=await this.findMessageBundles(W,te)}catch{return}if(!J.localized)return{values:void 0,default:J.original};try{const N=(await this.fileService.readFile(J.localized)).value.toString(),$=[],j=(0,I.parse)(N,$);return $.length>0?(K(J.localized,$),{values:void 0,default:J.original}):(0,I.getNodeType)(j)!=="object"?(X(J.localized),{values:void 0,default:J.original}):{values:j,default:J.original}}catch{return{values:void 0,default:J.original}}}}async resolveOriginalMessageBundle(W,z){if(W)try{const te=(await this.fileService.readFile(W)).value.toString();return(0,I.parse)(te,z)}catch{return null}else return null}findMessageBundles(W,z){return new Promise((te,H)=>{const K=X=>{const Y=(0,C.joinPath)(W,`package.nls.${X}.json`);this.fileService.exists(Y).then(x=>{x&&te({localized:Y,original:(0,C.joinPath)(W,"package.nls.json")});const B=X.lastIndexOf("-");B===-1?te({localized:(0,C.joinPath)(W,"package.nls.json"),original:null}):(X=X.substring(0,B),K(X))})};if(z.devMode||z.pseudo||!z.language)return te({localized:(0,C.joinPath)(W,"package.nls.json"),original:null});K(z.language)})}replaceNLStrings(W,z,te,H,K){const X=(Y,x,B)=>{const J=Y[x];if((0,w.isString)(J)){const N=J,$=N.length;if($>1&&N[0]==="%"&&N[$-1]==="%"){const j=N.substr(1,$-2);let G=te[j];G===void 0&&H&&(G=H[j]);let q=typeof G=="string"?G:typeof G?.message=="string"?G.message:void 0;q!==void 0?(W&&(q="\uFF3B"+q.replace(/[aouei]/g,"$&$&")+"\uFF3D"),Y[x]=B&&(x==="title"||x==="category")&&H?{value:q,original:H[j]}:q):this.logService.warn(this.formatMessage(K,(0,m.localize)(7,null,j)))}}else if((0,w.isObject)(J))for(const N in J)J.hasOwnProperty(N)&&(N==="commands"?X(J,N,!0):X(J,N,B));else if((0,w.isArray)(J))for(let N=0;N<J.length;N++)X(J,N,B)};for(const Y in z)z.hasOwnProperty(Y)&&X(z,Y)}formatMessage(W,z){return`[${W.path}]: ${z}`}}class R extends F{constructor(W,z,te,H,K){super(z,te,H,K);this.cacheFile=W,this.cacheValidatorThrottler=this._register(new t.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new s.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions(W){const z=await this.readExtensionCache();if(this.input=W,z&&z.input&&_.equals(z.input,this.input))return this.cacheValidatorThrottler.trigger(()=>this.validateCache()),z.result.map(H=>(H.location=d.URI.revive(H.location),H));const te=await super.scanExtensions(W);return await this.writeExtensionCache({input:W,result:te}),te}async readExtensionCache(){try{const W=await this.fileService.readFile(this.cacheFile),z=JSON.parse(W.value.toString());return{result:z.result,input:(0,o.revive)(z.input)}}catch(W){this.logService.debug("Error while reading the extension cache file:",this.cacheFile.path,(0,A.getErrorMessage)(W))}return null}async writeExtensionCache(W){try{await this.fileService.writeFile(this.cacheFile,L.VSBuffer.fromString(JSON.stringify(W)))}catch(z){this.logService.debug("Error while writing the extension cache file:",this.cacheFile.path,(0,A.getErrorMessage)(z))}}async validateCache(){if(!this.input)return;const W=await this.readExtensionCache();if(!W)return;const z=W.result,te=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!T.equals(te,z))try{await this.fileService.del(this.cacheFile),this._onDidChangeCache.fire()}catch(H){this.logService.error(H)}}}function U(V,W){const z=(0,f.getExtensionId)(V.manifest.publisher,V.manifest.name);return{id:z,identifier:new u.ExtensionIdentifier(z),isBuiltin:V.type===0,isUserBuiltin:V.type===1&&V.isBuiltin,isUnderDevelopment:W,extensionLocation:V.location,uuid:V.identifier.uuid,targetPlatform:V.targetPlatform,...V.manifest}}e.toExtensionDescription=U;class M extends O{constructor(W,z,te,H,K,X,Y,x,B,J){super(W,z,(0,C.joinPath)(te,".vscode-oss-dev","extensions","control.json"),(0,C.joinPath)(H,u.MANIFEST_CACHE_FOLDER),K,X,Y,x,B,J);this.translationsPromise=(async()=>{if(p.translationsConfigFile)try{const N=await this.fileService.readFile(d.URI.file(p.translationsConfigFile));return JSON.parse(N.value.toString())}catch{}return Object.create(null)})()}getTranslations(W){return this.translationsPromise}}e.NativeExtensionsScannerService=M}),define(re[233],se([0,1,48,6,37,3,2,20,12,27,7,28]),function(Z,e,k,t,T,L,A,I,b,P,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let p=class extends A.Disposable{constructor(h,S){super();this.userDataProfilesService=h,this.logService=S,this.processesLimiter=new t.Limiter(5)}async postUninstall(h){const S=this.parseScript(h,"uninstall");return S&&(this.logService.info(h.identifier.id,h.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(S.script,"uninstall",S.args,!0,h).then(()=>this.logService.info(h.identifier.id,h.manifest.version,"Finished running post uninstall script"),w=>this.logService.error(h.identifier.id,h.manifest.version,`Failed to run post uninstall script: ${w}`)))),P.Promises.rm(this.getExtensionStoragePath(h)).then(void 0,w=>this.logService.error("Error while removing extension storage path",w))}parseScript(h,S){const w=`vscode:${S}`;if(h.location.scheme===I.Schemas.file&&h.manifest&&h.manifest.scripts&&typeof h.manifest.scripts[w]=="string"){const d=h.manifest.scripts[w].split(" ");return d.length<2||d[0]!=="node"||!d[1]?(this.logService.warn(h.identifier.id,h.manifest.version,`${w} should be a node script`),null):{script:(0,b.join)(h.location.fsPath,d[1]),args:d.slice(2)||[]}}return null}runLifecycleHook(h,S,w,d,m){return new Promise((g,f)=>{const u=this.start(h,S,w,m);let r;const n=i=>{r&&(clearTimeout(r),r=null),i?f(i):g(void 0)};u.on("error",i=>{n((0,T.toErrorMessage)(i)||"Unknown")}),u.on("exit",(i,a)=>{n(i?`post-${S} process exited with code ${i}`:void 0)}),d&&(r=setTimeout(()=>{r=null,u.kill(),f("timed out")},5e3))})}start(h,S,w,d){const m={silent:!0,execArgv:void 0},g=(0,k.fork)(h,[`--type=extension-post-${S}`,...w],m);g.stdout.setEncoding("utf8"),g.stderr.setEncoding("utf8");const f=L.Event.fromNodeEventEmitter(g.stdout,"data"),u=L.Event.fromNodeEventEmitter(g.stderr,"data");f(i=>this.logService.info(d.identifier.id,d.manifest.version,`post-${S}`,i)),u(i=>this.logService.error(d.identifier.id,d.manifest.version,`post-${S}`,i));const r=L.Event.any(L.Event.map(f,i=>({data:`%c${i}`,format:[""]})),L.Event.map(u,i=>({data:`%c${i}`,format:["color: red"]})));return L.Event.debounce(r,(i,a)=>i?{data:i.data+a.data,format:[...i.format,...a.format]}:{data:a.data,format:a.format},100)(i=>{console.group(d.identifier.id),console.log(i.data,...i.format),console.groupEnd()}),g}getExtensionStoragePath(h){return(0,b.join)(this.userDataProfilesService.defaultProfile.globalStorageHome.fsPath,h.identifier.id.toLowerCase())}};p=me([Q(0,E.IUserDataProfilesService),Q(1,D.ILogService)],p),e.ExtensionsLifecycle=p}),define(re[234],se([0,1,8,15,46,71,13,7,24,28]),function(Z,e,k,t,T,L,A,I,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let D=class extends L.NativeExtensionsScannerService{constructor(p,C,h,S,w,d){super(k.URI.file(w.builtinExtensionsPath),k.URI.file(w.extensionsPath),w.userHome,k.URI.file(w.userDataPath),p,C,h,S,w,d)}};D=me([Q(0,P.IUserDataProfilesService),Q(1,T.IExtensionsProfileScannerService),Q(2,A.IFileService),Q(3,I.ILogService),Q(4,t.INativeEnvironmentService),Q(5,b.IProductService)],D),e.ExtensionsScannerService=D}),define(re[22],se([0,1,6,3,2,188,14,86,5,28]),function(Z,e,k,t,T,L,A,I,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const D="__$__targetStorageMarker";e.IStorageService=(0,b.createDecorator)("storageService");var E;(function(m){m[m.NONE=0]="NONE",m[m.SHUTDOWN=1]="SHUTDOWN"})(E=e.WillSaveStateReason||(e.WillSaveStateReason={}));var p;(function(m){m[m.APPLICATION=-1]="APPLICATION",m[m.PROFILE=0]="PROFILE",m[m.WORKSPACE=1]="WORKSPACE"})(p=e.StorageScope||(e.StorageScope={}));var C;(function(m){m[m.USER=0]="USER",m[m.MACHINE=1]="MACHINE"})(C=e.StorageTarget||(e.StorageTarget={}));class h extends T.Disposable{constructor(g={flushInterval:h.DEFAULT_FLUSH_INTERVAL}){super();this.options=g,this._onDidChangeValue=this._register(new t.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new t.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new t.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new k.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new T.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,k.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,T.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,L.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,L.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(g,f){if(f===D){switch(g){case-1:this._applicationKeyTargets=void 0;break;case 0:this._profileKeyTargets=void 0;break;case 1:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:g})}else this._onDidChangeValue.fire({scope:g,key:f,target:this.getKeyTargets(g)[f]})}emitWillSaveState(g){this._onWillSaveState.fire({reason:g})}get(g,f,u){return this.getStorage(f)?.get(g,u)}getBoolean(g,f,u){return this.getStorage(f)?.getBoolean(g,u)}getNumber(g,f,u){return this.getStorage(f)?.getNumber(g,u)}store(g,f,u,r){if((0,A.isUndefinedOrNull)(f)){this.remove(g,u);return}this.withPausedEmitters(()=>{this.updateKeyTarget(g,u,r),this.getStorage(u)?.set(g,f)})}remove(g,f){this.withPausedEmitters(()=>{this.updateKeyTarget(g,f,void 0),this.getStorage(f)?.delete(g)})}withPausedEmitters(g){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{g()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(g,f){const u=[],r=this.getKeyTargets(g);for(const n of Object.keys(r))r[n]===f&&u.push(n);return u}updateKeyTarget(g,f,u){const r=this.getKeyTargets(f);typeof u=="number"?r[g]!==u&&(r[g]=u,this.getStorage(f)?.set(D,JSON.stringify(r))):typeof r[g]=="number"&&(delete r[g],this.getStorage(f)?.set(D,JSON.stringify(r)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(0)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(-1)),this._applicationKeyTargets}getKeyTargets(g){switch(g){case-1:return this.applicationKeyTargets;case 0:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(g){const f=this.get(D,g);if(f)try{return JSON.parse(f)}catch{}return Object.create(null)}isNew(g){return this.getBoolean(e.IS_NEW_KEY,g)===!0}async flush(g=E.NONE){this._onWillSaveState.fire({reason:g});const f=this.getStorage(-1),u=this.getStorage(0),r=this.getStorage(1);switch(g){case E.NONE:await k.Promises.settled([f?.whenFlushed()??Promise.resolve(),u?.whenFlushed()??Promise.resolve(),r?.whenFlushed()??Promise.resolve()]);break;case E.SHUTDOWN:await k.Promises.settled([f?.flush(0)??Promise.resolve(),u?.flush(0)??Promise.resolve(),r?.flush(0)??Promise.resolve()]);break}}async log(){const g=this.getStorage(-1)?.items??new Map,f=this.getStorage(0)?.items??new Map,u=this.getStorage(1)?.items??new Map;return d(g,f,u,this.getLogDetails(-1)??"",this.getLogDetails(0)??"",this.getLogDetails(1)??"")}async switch(g,f){return this.emitWillSaveState(E.NONE),(0,P.isUserDataProfile)(g)?this.switchToProfile(g,f):this.switchToWorkspace(g,f)}canSwitchProfile(g,f){return!(g.id===f.id||S(f)&&S(g))}switchData(g,f,u,r){this.withPausedEmitters(()=>{if(r)for(const[n,i]of g)f.set(n,i);else{const n=new Set;for(const[i,a]of g)n.add(i),f.get(i)!==a&&this.emitDidChangeValue(u,i);for(const[i]of f.items)n.has(i)||this.emitDidChangeValue(u,i)}})}}e.AbstractStorageService=h,h.DEFAULT_FLUSH_INTERVAL=60*1e3;function S(m){return m.isDefault||!!m.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=S;class w extends h{constructor(){super();this.applicationStorage=this._register(new I.Storage(new I.InMemoryStorageDatabase)),this.profileStorage=this._register(new I.Storage(new I.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new I.Storage(new I.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(g=>this.emitDidChangeValue(1,g))),this._register(this.profileStorage.onDidChangeStorage(g=>this.emitDidChangeValue(0,g))),this._register(this.applicationStorage.onDidChangeStorage(g=>this.emitDidChangeValue(-1,g)))}getStorage(g){switch(g){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(g){switch(g){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}}e.InMemoryStorageService=w;async function d(m,g,f,u,r,n){const i=_=>{try{return JSON.parse(_)}catch{return _}},a=new Map,c=new Map;m.forEach((_,F)=>{a.set(F,_),c.set(F,i(_))});const s=new Map,o=new Map;g.forEach((_,F)=>{s.set(F,_),o.set(F,i(_))});const l=new Map,v=new Map;f.forEach((_,F)=>{l.set(F,_),v.set(F,i(_))}),console.group(u!==r?`Storage: Application (path: ${u})`:`Storage: Application & Profile (path: ${u}, default profile)`);const y=[];if(a.forEach((_,F)=>{y.push({key:F,value:_})}),console.table(y),console.groupEnd(),console.log(c),u!==r){console.group(`Storage: Profile (path: ${r}, profile specific)`);const _=[];s.forEach((F,R)=>{_.push({key:R,value:F})}),console.table(_),console.groupEnd(),console.log(o)}console.group(`Storage: Workspace (path: ${n})`);const O=[];l.forEach((_,F)=>{O.push({key:F,value:_})}),console.table(O),console.groupEnd(),console.log(v)}e.logStorage=d}),define(re[235],se([0,1,3,2,14,30,32,22]),function(Z,e,k,t,T,L,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let b=class extends t.Disposable{constructor(E,p){super();this._onDidChangeEnablement=new k.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this.storageManger=this._register(new P(E)),this._register(this.storageManger.onDidChange(C=>this._onDidChangeEnablement.fire({extensions:C,source:"storage"}))),this._register(p.onDidInstallExtensions(C=>C.forEach(({local:h,operation:S})=>{h&&S===4&&this._removeFromDisabledExtensions(h.identifier)})))}async enableExtension(E,p){return this._removeFromDisabledExtensions(E)?(this._onDidChangeEnablement.fire({extensions:[E],source:p}),!0):!1}async disableExtension(E,p){return this._addToDisabledExtensions(E)?(this._onDidChangeEnablement.fire({extensions:[E],source:p}),!0):!1}getDisabledExtensions(){return this._getExtensions(L.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}_addToDisabledExtensions(E){const p=this.getDisabledExtensions();return p.every(C=>!(0,A.areSameExtensions)(C,E))?(p.push(E),this._setDisabledExtensions(p),!0):!1}_removeFromDisabledExtensions(E){const p=this.getDisabledExtensions();for(let C=0;C<p.length;C++){const h=p[C];if((0,A.areSameExtensions)(h,E))return p.splice(C,1),this._setDisabledExtensions(p),!0}return!1}_setDisabledExtensions(E){this._setExtensions(L.DISABLED_EXTENSIONS_STORAGE_PATH,E)}_getExtensions(E){return this.storageManger.get(E,0)}_setExtensions(E,p){this.storageManger.set(E,p,0)}};b=me([Q(0,I.IStorageService),Q(1,L.IExtensionManagementService)],b),e.GlobalExtensionEnablementService=b;class P extends t.Disposable{constructor(E){super();this.storageService=E,this.storage=Object.create(null),this._onDidChange=this._register(new k.Emitter),this.onDidChange=this._onDidChange.event,this._register(E.onDidChangeValue(p=>this.onDidStorageChange(p)))}get(E,p){let C;return p===0?((0,T.isUndefinedOrNull)(this.storage[E])&&(this.storage[E]=this._get(E,p)),C=this.storage[E]):C=this._get(E,p),JSON.parse(C)}set(E,p,C){const h=JSON.stringify(p.map(({id:w,uuid:d})=>({id:w,uuid:d})));this._get(E,C)!==h&&(C===0&&(p.length?this.storage[E]=h:delete this.storage[E]),this._set(E,p.length?h:void 0,C))}onDidStorageChange(E){if(E.scope===0&&!(0,T.isUndefinedOrNull)(this.storage[E.key])&&this._get(E.key,E.scope)!==this.storage[E.key]){const C=this.get(E.key,E.scope);delete this.storage[E.key];const h=this.get(E.key,E.scope),S=C.filter(d=>!h.some(m=>(0,A.areSameExtensions)(d,m))),w=h.filter(d=>!C.some(m=>(0,A.areSameExtensions)(m,d)));(S.length||w.length)&&this._onDidChange.fire([...S,...w])}}_get(E,p){return this.storageService.get(E,p,"[]")}_set(E,p,C){p?this.storageService.store(E,p,C,1):this.storageService.remove(E,C)}}e.StorageManager=P}),define(re[236],se([0,1,17,23,9,4,36,14,8,18,15,30,32,66,13,7,24,44,215,22,21]),function(Z,e,k,t,T,L,A,I,b,P,D,E,p,C,h,S,w,d,m,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const u=L.isWeb?"web":(0,E.getTargetPlatform)(L.platform,A.arch);var r;(function(N){N[N.None=0]="None",N[N.IncludeVersions=1]="IncludeVersions",N[N.IncludeFiles=2]="IncludeFiles",N[N.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",N[N.IncludeSharedAccounts=8]="IncludeSharedAccounts",N[N.IncludeVersionProperties=16]="IncludeVersionProperties",N[N.ExcludeNonValidated=32]="ExcludeNonValidated",N[N.IncludeInstallationTargets=64]="IncludeInstallationTargets",N[N.IncludeAssetUri=128]="IncludeAssetUri",N[N.IncludeStatistics=256]="IncludeStatistics",N[N.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",N[N.Unpublished=4096]="Unpublished",N[N.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(r||(r={}));function n(...N){return String(N.reduce(($,j)=>$|j,0))}var i;(function(N){N[N.Tag=1]="Tag",N[N.ExtensionId=4]="ExtensionId",N[N.Category=5]="Category",N[N.ExtensionName=7]="ExtensionName",N[N.Target=8]="Target",N[N.Featured=9]="Featured",N[N.SearchText=10]="SearchText",N[N.ExcludeWithFlags=12]="ExcludeWithFlags"})(i||(i={}));const a={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},c={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},o={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:r.None,criteria:[],assetTypes:[]};class l{constructor($=o){this.state=$}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage($,j=this.state.pageSize){return new l({...this.state,pageNumber:$,pageSize:j})}withFilter($,...j){const G=[...this.state.criteria,...j.length?j.map(q=>({filterType:$,value:q})):[{filterType:$}]];return new l({...this.state,criteria:G})}withSortBy($){return new l({...this.state,sortBy:$})}withSortOrder($){return new l({...this.state,sortOrder:$})}withFlags(...$){return new l({...this.state,flags:$.reduce((j,G)=>j|G,0)})}withAssetTypes(...$){return new l({...this.state,assetTypes:$})}withSource($){return new l({...this.state,source:$})}get raw(){const{criteria:$,pageNumber:j,pageSize:G,sortBy:q,sortOrder:ee,flags:ne,assetTypes:oe}=this.state;return{filters:[{criteria:$,pageNumber:j,pageSize:G,sortBy:q,sortOrder:ee}],assetTypes:oe,flags:ne}}get searchText(){const $=this.state.criteria.filter(j=>j.filterType===i.SearchText)[0];return $&&$.value?$.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map($=>String($.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.state.source,searchTextLength:this.searchText.length}}}function v(N,$){const j=(N||[]).filter(G=>G.statisticName===$)[0];return j?j.value:0}function y(N){const $="Microsoft.VisualStudio.Code.Translation.";return N.files.filter(G=>G.assetType.indexOf($)===0).reduce((G,q)=>{const ee=F(N,q.assetType);return ee&&G.push([q.assetType.substring($.length),ee]),G},[])}function O(N){if(N.properties){const $=N.properties.filter(q=>q.key===a.Repository),j=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),G=$.filter(q=>j.test(q.value))[0];return G?{uri:G.value,fallbackUri:G.value}:null}return F(N,a.Repository)}function _(N){return{uri:`${N.fallbackAssetUri}/${a.VSIX}?redirect=true${N.targetPlatform?`&targetPlatform=${N.targetPlatform}`:""}`,fallbackUri:`${N.fallbackAssetUri}/${a.VSIX}${N.targetPlatform?`?targetPlatform=${N.targetPlatform}`:""}`}}function F(N,$){return N.files.filter(G=>G.assetType===$)[0]?{uri:`${N.assetUri}/${$}${N.targetPlatform?`?targetPlatform=${N.targetPlatform}`:""}`,fallbackUri:`${N.fallbackAssetUri}/${$}${N.targetPlatform?`?targetPlatform=${N.targetPlatform}`:""}`}:null}function R(N,$){const j=N.properties?N.properties.filter(q=>q.key===$):[],G=j.length>0&&j[0].value;return G?G.split(",").map(q=>(0,p.adoptToGalleryExtensionId)(q)):[]}function U(N){const $=N.properties?N.properties.filter(j=>j.key===c.Engine):[];return $.length>0&&$[0].value||""}function M(N){const $=N.properties?N.properties.filter(j=>j.key===c.PreRelease):[];return $.length>0&&$[0].value==="true"}function V(N){const $=N.properties?N.properties.filter(G=>G.key===c.LocalizedLanguages):[],j=$.length>0&&$[0].value||"";return j?j.split(","):[]}function W(N){return N.properties?.find($=>$.key===c.SponsorLink)?.value}function z(N){return N.indexOf("preview")!==-1}function te(N){return N.targetPlatform?(0,E.toTargetPlatform)(N.targetPlatform):"undefined"}function H(N){const $=(0,k.distinct)(N.versions.map(te)),j=!!N.tags?.includes(E.WEB_EXTENSION_TAG),G=$.indexOf("web");return j?G===-1&&$.push("web"):G!==-1&&$.splice(G,1),$}function K(N,$){const j=(0,E.getFallbackTargetPlarforms)($);for(let G=0;G<N.length;G++){const q=N[G];if(q.version===N[G-1]?.version){let ee=G;const ne=te(q);if(ne===$)for(;ee>0&&N[ee-1].version===q.version;)ee--;else if(j.includes(ne))for(;ee>0&&N[ee-1].version===q.version&&te(N[ee-1])!==$;)ee--;ee!==G&&(N.splice(G,1),N.splice(ee,0,q))}}return N}e.sortExtensionVersions=K;function X(N,$,j){N.telemetryData={index:$,querySource:j}}function Y(N,$,j){const G=N.versions[0],q={manifest:F($,a.Manifest),readme:F($,a.Details),changelog:F($,a.Changelog),license:F($,a.License),repository:O($),download:_($),icon:F($,a.Icon),coreTranslations:y($)};return{identifier:{id:(0,p.getGalleryExtensionId)(N.publisher.publisherName,N.extensionName),uuid:N.extensionId},name:N.extensionName,version:$.version,displayName:N.displayName,publisherId:N.publisher.publisherId,publisher:N.publisher.publisherName,publisherDisplayName:N.publisher.displayName,publisherDomain:N.publisher.domain?{link:N.publisher.domain,verified:!!N.publisher.isDomainVerified}:void 0,publisherSponsorLink:W(G),description:N.shortDescription||"",installCount:v(N.statistics,"install"),rating:v(N.statistics,"averagerating"),ratingCount:v(N.statistics,"ratingcount"),categories:N.categories||[],tags:N.tags||[],releaseDate:Date.parse(N.releaseDate),lastUpdated:Date.parse(N.lastUpdated),allTargetPlatforms:j,assets:q,properties:{dependencies:R($,c.Dependency),extensionPack:R($,c.ExtensionPack),engine:U($),localizedLanguages:V($),targetPlatform:te($),isPreReleaseVersion:M($)},hasPreReleaseVersion:M(G),hasReleaseVersion:!0,preview:z(N.flags)}}let x=class{constructor($,j,G,q,ee,ne,oe,le){this.requestService=j,this.logService=G,this.environmentService=q,this.telemetryService=ee,this.fileService=ne,this.productService=oe,this.configurationService=le;const Se=oe.extensionsGallery;this.extensionsGalleryUrl=Se&&Se.serviceUrl,this.extensionsControlUrl=Se&&Se.controlUrl,this.commonHeadersPromise=(0,m.resolveMarketplaceHeaders)(oe.version,oe,this.environmentService,this.configurationService,this.fileService,$,this.telemetryService)}api($=""){return`${this.extensionsGalleryUrl}${$}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions($,j,G){const q=t.CancellationToken.isCancellationToken(j)?{}:j,ee=t.CancellationToken.isCancellationToken(j)?j:G,ne=[],oe=[],le=[],Se=[];let fe=!0;for(const be of $){be.uuid?oe.push(be.uuid):ne.push(be.id);const Ie=!!(be.version||be.preRelease);le.push({id:be.id,uuid:be.uuid,includePreRelease:Ie}),be.version&&Se.push({id:be.id,uuid:be.uuid,version:be.version}),fe=fe&&!!be.hasPreRelease&&!Ie}if(!oe.length&&!ne.length)return[];let pe=new l().withPage(1,$.length);oe.length&&(pe=pe.withFilter(i.ExtensionId,...oe)),ne.length&&(pe=pe.withFilter(i.ExtensionName,...ne)),(q.queryAllVersions||fe)&&(pe=pe.withFlags(pe.flags,r.IncludeVersions)),q.source&&(pe=pe.withSource(q.source));const{extensions:Ce}=await this.queryGalleryExtensions(pe,{targetPlatform:q.targetPlatform??u,includePreRelease:le,versions:Se,compatible:!!q.compatible},ee);return q.source&&Ce.forEach((be,Ie)=>X(be,Ie,q.source)),Ce}async getCompatibleExtension($,j,G){if((0,E.isNotWebExtensionInWebTargetPlatform)($.allTargetPlatforms,G))return null;if(await this.isExtensionCompatible($,j,G))return $;const q=new l().withFlags(r.IncludeVersions).withPage(1,1).withFilter(i.ExtensionId,$.identifier.uuid),{extensions:ee}=await this.queryGalleryExtensions(q,{targetPlatform:G,compatible:!0,includePreRelease:j},t.CancellationToken.None);return ee[0]||null}async isExtensionCompatible($,j,G){if(!(0,E.isTargetPlatformCompatible)($.properties.targetPlatform,$.allTargetPlatforms,G)||!j&&$.properties.isPreReleaseVersion)return!1;let q=$.properties.engine;if(!q){const ee=await this.getManifest($,t.CancellationToken.None);if(!ee)throw new Error("Manifest was not found");q=ee.engines.vscode}return(0,C.isEngineValid)(q,this.productService.version,this.productService.date)}async isValidVersion($,j,G,q,ee){if(!(0,E.isTargetPlatformCompatible)(te($),q,ee)||j!=="any"&&M($)!==(j==="prerelease"))return!1;if(G)try{const ne=await this.getEngine($);if(!(0,C.isEngineValid)(ne,this.productService.version,this.productService.date))return!1}catch(ne){return this.logService.error(`Error while getting the engine for the version ${$.version}.`,(0,T.getErrorMessage)(ne)),!1}return!0}async query($,j){if(!this.isEnabled())throw new Error("No extension gallery service configured.");let G=$.text||"";const q=$.pageSize??50;let ee=new l().withPage(1,q);G?(G=G.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(fe,pe,Ce)=>(ee=ee.withFilter(i.Category,Ce||pe),"")),G=G.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(fe,pe,Ce)=>(ee=ee.withFilter(i.Tag,Ce||pe),"")),G=G.replace(/\bfeatured(\s+|\b|$)/g,()=>(ee=ee.withFilter(i.Featured),"")),G=G.trim(),G&&(G=G.length<200?G:G.substring(0,200),ee=ee.withFilter(i.SearchText,G)),ee=ee.withSortBy(0)):$.ids?ee=ee.withFilter(i.ExtensionId,...$.ids):$.names?ee=ee.withFilter(i.ExtensionName,...$.names):ee=ee.withSortBy(4),typeof $.sortBy=="number"&&(ee=ee.withSortBy($.sortBy)),typeof $.sortOrder=="number"&&(ee=ee.withSortOrder($.sortOrder)),$.source&&(ee=ee.withSource($.source));const ne=async(fe,pe)=>{const{extensions:Ce,total:be}=await this.queryGalleryExtensions(fe,{targetPlatform:u,compatible:!1,includePreRelease:!!$.includePreRelease},pe);return Ce.forEach((Ie,qe)=>X(Ie,(fe.pageNumber-1)*fe.pageSize+qe,$.source)),{extensions:Ce,total:be}},{extensions:oe,total:le}=await ne(ee,j),Se=async(fe,pe)=>{if(pe.isCancellationRequested)throw new T.CancellationError;const{extensions:Ce}=await ne(ee.withPage(fe+1),pe);return Ce};return{firstPage:oe,total:le,pageSize:ee.pageSize,getPage:Se}}async queryGalleryExtensions($,j,G){const q=$.flags;!!($.flags&r.IncludeLatestVersionOnly)&&!!($.flags&r.IncludeVersions)&&($=$.withFlags($.flags&~r.IncludeVersions,r.IncludeLatestVersionOnly)),!($.flags&r.IncludeLatestVersionOnly)&&!($.flags&r.IncludeVersions)&&($=$.withFlags($.flags,r.IncludeLatestVersionOnly)),j.versions?.length&&($=$.withFlags($.flags&~r.IncludeLatestVersionOnly,r.IncludeVersions)),$=$.withFlags($.flags,r.IncludeAssetUri,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeStatistics,r.IncludeVersionProperties);const{galleryExtensions:ee,total:ne}=await this.queryRawGalleryExtensions($,G);if(!($.flags&r.IncludeLatestVersionOnly)){const fe=[];for(const pe of ee){const Ce=await this.toGalleryExtensionWithCriteria(pe,j);Ce&&fe.push(Ce)}return{extensions:fe,total:ne}}const le=[],Se=new Map;for(let fe=0;fe<ee.length;fe++){const pe=ee[fe],Ce={id:(0,p.getGalleryExtensionId)(pe.publisher.publisherName,pe.extensionName),uuid:pe.extensionId},be=(0,I.isBoolean)(j.includePreRelease)?j.includePreRelease:!!j.includePreRelease.find(qe=>(0,p.areSameExtensions)(qe,Ce))?.includePreRelease;if(j.compatible&&(0,E.isNotWebExtensionInWebTargetPlatform)(H(pe),j.targetPlatform))continue;const Ie=await this.toGalleryExtensionWithCriteria(pe,j);!Ie||Ie.properties.isPreReleaseVersion&&(!be||!Ie.hasReleaseVersion)||!Ie.properties.isPreReleaseVersion&&Ie.properties.targetPlatform!==j.targetPlatform&&Ie.hasPreReleaseVersion?Se.set(pe.extensionId,fe):le.push([fe,Ie])}if(Se.size){const fe=new Date().getTime(),pe=new l().withFlags(q&~r.IncludeLatestVersionOnly,r.IncludeVersions).withPage(1,Se.size).withFilter(i.ExtensionId,...Se.keys()),{extensions:Ce}=await this.queryGalleryExtensions(pe,j,G);this.telemetryService.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-fe,count:Se.size});for(const be of Ce){const Ie=Se.get(be.identifier.uuid);le.push([Ie,be])}}return{extensions:le.sort((fe,pe)=>fe[0]-pe[0]).map(([,fe])=>fe),total:ne}}async toGalleryExtensionWithCriteria($,j){const G={id:(0,p.getGalleryExtensionId)($.publisher.publisherName,$.extensionName),uuid:$.extensionId},q=j.versions?.find(le=>(0,p.areSameExtensions)(le,G))?.version,ee=(0,I.isBoolean)(j.includePreRelease)?j.includePreRelease:!!j.includePreRelease.find(le=>(0,p.areSameExtensions)(le,G))?.includePreRelease,ne=H($),oe=K($.versions,j.targetPlatform);if(j.compatible&&(0,E.isNotWebExtensionInWebTargetPlatform)(ne,j.targetPlatform))return null;for(let le=0;le<oe.length;le++){const Se=oe[le];if(!(q&&Se.version!==q)){if(await this.isValidVersion(Se,ee?"any":"release",j.compatible,ne,j.targetPlatform))return Y($,Se,ne);if(q&&Se.version===q)return null}}return q||j.compatible?null:Y($,$.versions[0],ne)}async queryRawGalleryExtensions($,j){if(!this.isEnabled())throw new Error("No extension gallery service configured.");$=$.withFlags($.flags,r.ExcludeNonValidated).withFilter(i.Target,"Microsoft.VisualStudio.Code").withFilter(i.ExcludeWithFlags,n(r.Unpublished));const G=await this.commonHeadersPromise,q=JSON.stringify($.raw),ee={...G,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(q.length)},ne=new Date().getTime();let oe,le,Se=0;try{if(oe=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:q,headers:ee},j),oe.res.statusCode&&oe.res.statusCode>=400&&oe.res.statusCode<500)return{galleryExtensions:[],total:Se};const fe=await(0,d.asJson)(oe);if(fe){const pe=fe.results[0],Ce=pe.extensions,be=pe.resultMetadata&&pe.resultMetadata.filter(Ie=>Ie.metadataType==="ResultCount")[0];return Se=be&&be.metadataItems.filter(Ie=>Ie.name==="TotalCount")[0].count||0,{galleryExtensions:Ce,total:Se}}return{galleryExtensions:[],total:Se}}catch(fe){throw le=fe,fe}finally{this.telemetryService.publicLog2("galleryService:query",{...$.telemetryData,requestBodySize:String(q.length),duration:new Date().getTime()-ne,success:!!oe&&(0,d.isSuccess)(oe),responseBodySize:oe?.res.headers["Content-Length"],statusCode:oe?String(oe.res.statusCode):void 0,errorCode:le?(0,T.isCancellationError)(le)?"canceled":(0,T.getErrorMessage)(le).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(Se)})}}async reportStatistic($,j,G,q){if(!this.isEnabled())return;const ee=L.isWeb?this.api(`/itemName/${$}.${j}/version/${G}/statType/${q==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${$}/extensions/${j}/${G}/stats?statType=${q}`),ne=L.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",le={...await this.commonHeadersPromise,Accept:ne};try{await this.requestService.request({type:"POST",url:ee,headers:le},t.CancellationToken.None)}catch{}}async download($,j,G){this.logService.trace("ExtensionGalleryService#download",$.identifier.id);const q=(0,p.getGalleryExtensionTelemetryData)($),ee=new Date().getTime(),ne=fe=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...q,duration:fe}),oe=G===2?"install":G===3?"update":"",le=oe?{uri:`${$.assets.download.uri}${b.URI.parse($.assets.download.uri).query?"&":"?"}${oe}=true`,fallbackUri:`${$.assets.download.fallbackUri}${b.URI.parse($.assets.download.fallbackUri).query?"&":"?"}${oe}=true`}:$.assets.download,Se=await this.getAsset(le);await this.fileService.writeFile(j,Se.stream),ne(new Date().getTime()-ee)}async getReadme($,j){if($.assets.readme){const G=await this.getAsset($.assets.readme,{},j);return await(0,d.asTextOrError)(G)||""}return""}async getManifest($,j){if($.assets.manifest){const G=await this.getAsset($.assets.manifest,{},j),q=await(0,d.asTextOrError)(G);return q?JSON.parse(q):null}return null}async getManifestFromRawExtensionVersion($,j){const G=F($,a.Manifest);if(!G)throw new Error("Manifest was not found");const q={"Accept-Encoding":"gzip"},ee=await this.getAsset(G,{headers:q});return await(0,d.asJson)(ee)}async getCoreTranslation($,j){const G=$.assets.coreTranslations.filter(q=>q[0]===j.toUpperCase())[0];if(G){const q=await this.getAsset(G[1]),ee=await(0,d.asTextOrError)(q);return ee?JSON.parse(ee):null}return null}async getChangelog($,j){if($.assets.changelog){const G=await this.getAsset($.assets.changelog,{},j);return await(0,d.asTextOrError)(G)||""}return""}async getAllCompatibleVersions($,j,G){let q=new l().withFlags(r.IncludeVersions,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeVersionProperties).withPage(1,1);$.identifier.uuid?q=q.withFilter(i.ExtensionId,$.identifier.uuid):q=q.withFilter(i.ExtensionName,$.identifier.id);const{galleryExtensions:ee}=await this.queryRawGalleryExtensions(q,t.CancellationToken.None);if(!ee.length)return[];const ne=H(ee[0]);if((0,E.isNotWebExtensionInWebTargetPlatform)(ne,G))return[];const oe=[];await Promise.all(ee[0].versions.map(async fe=>{try{await this.isValidVersion(fe,j?"any":"release",!0,ne,G)&&oe.push(fe)}catch{}}));const le=[],Se=new Set;for(const fe of K(oe,G))Se.has(fe.version)||(Se.add(fe.version),le.push({version:fe.version,date:fe.lastUpdated,isPreReleaseVersion:M(fe)}));return le}async getAsset($,j={},G=t.CancellationToken.None){const q=await this.commonHeadersPromise,ee={type:"GET"},ne={...q,...j.headers||{}};j={...j,...ee,headers:ne};const oe=$.uri,le=$.fallbackUri,Se={...j,url:oe};try{const fe=await this.requestService.request(Se,G);if(fe.res.statusCode===200)return fe;const pe=await(0,d.asTextOrError)(fe);throw new Error(`Expected 200, got back ${fe.res.statusCode} instead.

${pe}`)}catch(fe){if((0,T.isCancellationError)(fe))throw fe;const pe=(0,T.getErrorMessage)(fe);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:oe,message:pe});const Ce={...j,url:le};return this.requestService.request(Ce,G)}}async getEngine($){let j=U($);if(!j){const G=await this.getManifestFromRawExtensionVersion($,t.CancellationToken.None);if(!G)throw new Error("Manifest was not found");j=G.engines.vscode}return j}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[],deprecated:{}};const $=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},t.CancellationToken.None);if($.res.statusCode!==200)throw new Error("Could not get extensions report.");const j=await(0,d.asJson)($),G=[],q={};if(j){for(const ee of j.malicious)G.push({id:ee});if(j.migrateToPreRelease)for(const[ee,ne]of Object.entries(j.migrateToPreRelease))(!ne.engine||(0,C.isEngineValid)(ne.engine,this.productService.version,this.productService.date))&&(q[ee.toLowerCase()]={disallowInstall:!0,extension:{id:ne.id,displayName:ne.displayName,autoMigrate:{storage:!!ne.migrateStorage},preRelease:!0}});if(j.deprecated)for(const[ee,ne]of Object.entries(j.deprecated))ne&&(q[ee.toLowerCase()]=(0,I.isBoolean)(ne)?{}:ne)}return{malicious:G,deprecated:q}}};x=me([Q(1,d.IRequestService),Q(2,S.ILogService),Q(3,D.IEnvironmentService),Q(4,f.ITelemetryService),Q(5,h.IFileService),Q(6,w.IProductService),Q(7,P.IConfigurationService)],x);let B=class extends x{constructor($,j,G,q,ee,ne,oe,le){super($,j,G,q,ee,ne,oe,le)}};B=me([Q(0,g.IStorageService),Q(1,d.IRequestService),Q(2,S.ILogService),Q(3,D.IEnvironmentService),Q(4,f.ITelemetryService),Q(5,h.IFileService),Q(6,w.IProductService),Q(7,P.IConfigurationService)],B),e.ExtensionGalleryService=B;let J=class extends x{constructor($,j,G,q,ee,ne,oe){super(void 0,$,j,G,q,ee,ne,oe)}};J=me([Q(0,d.IRequestService),Q(1,S.ILogService),Q(2,D.IEnvironmentService),Q(3,f.ITelemetryService),Q(4,h.IFileService),Q(5,w.IProductService),Q(6,P.IConfigurationService)],J),e.ExtensionGalleryServiceWithNoStorageService=J}),define(re[72],se([0,1,5,3,2,22,32,24,17,7,14]),function(Z,e,k,t,T,L,A,I,b,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStorageService=e.IExtensionStorageService=void 0,e.IExtensionStorageService=(0,k.createDecorator)("IExtensionStorageService");const E=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let p=class Je extends T.Disposable{constructor(h,S,w){super();this.storageService=h,this.productService=S,this.logService=w,this._onDidChangeExtensionStorageToSync=this._register(new t.Emitter),this.onDidChangeExtensionStorageToSync=this._onDidChangeExtensionStorageToSync.event,this.extensionsWithKeysForSync=Je.readAllExtensionsWithKeysForSync(h),this._register(this.storageService.onDidChangeValue(d=>this.onDidChangeStorageValue(d)))}static toKey(h){return`extensionKeys/${(0,A.adoptToGalleryExtensionId)(h.id)}@${h.version}`}static fromKey(h){const S=E.exec(h);if(S&&S[1])return{id:S[1],version:S[2]}}static async removeOutdatedExtensionVersions(h,S){const w=await h.getInstalled(),d=[];for(const[m,g]of Je.readAllExtensionsWithKeysForSync(S)){const f=w.find(u=>(0,A.areSameExtensions)(u.identifier,{id:m}))?.manifest.version;for(const u of g)f!==u&&d.push(Je.toKey({id:m,version:u}))}for(const m of d)S.remove(m,0)}static readAllExtensionsWithKeysForSync(h){const S=new Map,w=h.keys(0,1);for(const d of w){const m=Je.fromKey(d);if(m){let g=S.get(m.id.toLowerCase());g||S.set(m.id.toLowerCase(),g=[]),g.push(m.version)}}return S}onDidChangeStorageValue(h){if(h.scope!==0)return;if(this.extensionsWithKeysForSync.has(h.key.toLowerCase())){this._onDidChangeExtensionStorageToSync.fire();return}const S=Je.fromKey(h.key);if(S){if(this.storageService.get(h.key,0)===void 0)this.extensionsWithKeysForSync.delete(S.id.toLowerCase());else{let w=this.extensionsWithKeysForSync.get(S.id.toLowerCase());w||this.extensionsWithKeysForSync.set(S.id.toLowerCase(),w=[]),w.push(S.version),this._onDidChangeExtensionStorageToSync.fire()}return}}getExtensionId(h){if((0,D.isString)(h))return h;const S=h.manifest?h.manifest.publisher:h.publisher,w=h.manifest?h.manifest.name:h.name;return(0,A.getExtensionId)(S,w)}getExtensionState(h,S){const w=this.getExtensionId(h),d=this.storageService.get(w,S?0:1);if(d)try{return JSON.parse(d)}catch(m){this.logService.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${w}, global: ${S}): ${m}`)}}setExtensionState(h,S,w){const d=this.getExtensionId(h);S===void 0?this.storageService.remove(d,w?0:1):this.storageService.store(d,JSON.stringify(S),w?0:1,1)}setKeysForSync(h,S){this.storageService.store(Je.toKey(h),JSON.stringify(S),0,1)}getKeysForSync(h){const S=this.productService.extensionSyncedKeys?.[h.id.toLowerCase()],w=this.storageService.get(Je.toKey(h),0),d=w?JSON.parse(w):void 0;return d&&S?(0,b.distinct)([...d,...S]):d||S}addToMigrationList(h,S){if(h!==S){const w=this.migrationList.filter(d=>!d.includes(h)&&!d.includes(S));w.push([h,S]),this.migrationList=w}}getSourceExtensionToMigrate(h){const S=this.migrationList.find(([,w])=>h===w);return S?S[0]:void 0}get migrationList(){const h=this.storageService.get("extensionStorage.migrationList",-1,"[]");try{const S=JSON.parse(h);if((0,D.isArray)(S))return S}catch{}return[]}set migrationList(h){h.length?this.storageService.store("extensionStorage.migrationList",JSON.stringify(h),-1,1):this.storageService.remove("extensionStorage.migrationList",-1)}};p=me([Q(0,L.IStorageService),Q(1,I.IProductService),Q(2,P.ILogService)],p),e.ExtensionStorageService=p}),define(re[237],se([0,1,17,6,75,3,12,4,36,8,144,15,30,32,206,92,13,7,68,24,44,22,21]),function(Z,e,k,t,T,L,A,I,b,P,D,E,p,C,h,S,w,d,m,g,f,u,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;const n="extensionTips/promptedExecutableTips",i="extensionTips/lastPromptedMediumImpExeTime";let a=class extends h.ExtensionTipsService{constructor(s,o,l,v,y,O,_,F,R,U){super(_,F,R,U);this.environmentService=s,this.telemetryService=o,this.extensionManagementService=l,this.storageService=v,this.nativeHostService=y,this.extensionRecommendationNotificationService=O,this.highImportanceExecutableTips=new Map,this.mediumImportanceExecutableTips=new Map,this.allOtherExecutableTips=new Map,this.highImportanceTipsByExe=new Map,this.mediumImportanceTipsByExe=new Map,F.exeBasedExtensionTips&&(0,T.forEach)(F.exeBasedExtensionTips,({key:M,value:V})=>{const W=[],z=[],te=[];(0,T.forEach)(V.recommendations,({key:H,value:K})=>{K.important?V.important?W.push({extensionId:H,extensionName:K.name,isExtensionPack:!!K.isExtensionPack}):z.push({extensionId:H,extensionName:K.name,isExtensionPack:!!K.isExtensionPack}):te.push({extensionId:H,extensionName:K.name,isExtensionPack:!!K.isExtensionPack})}),W.length&&this.highImportanceExecutableTips.set(M,{exeFriendlyName:V.friendlyName,windowsPath:V.windowsPath,recommendations:W}),z.length&&this.mediumImportanceExecutableTips.set(M,{exeFriendlyName:V.friendlyName,windowsPath:V.windowsPath,recommendations:z}),te.length&&this.allOtherExecutableTips.set(M,{exeFriendlyName:V.friendlyName,windowsPath:V.windowsPath,recommendations:te})}),(0,t.timeout)(3e3).then(async()=>{await this.collectTips(),this.promptHighImportanceExeBasedTip(),this.promptMediumImportanceExeBasedTip()})}async getImportantExecutableBasedTips(){const s=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),o=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips);return[...s,...o]}getOtherExecutableBasedTips(){return this.getValidExecutableBasedExtensionTips(this.allOtherExecutableTips)}async collectTips(){const s=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),o=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips),l=await this.extensionManagementService.getInstalled();this.highImportanceTipsByExe=this.groupImportantTipsByExe(s,l),this.mediumImportanceTipsByExe=this.groupImportantTipsByExe(o,l)}groupImportantTipsByExe(s,o){const l=new Map;s.forEach(F=>l.set(F.extensionId.toLowerCase(),F));const{installed:v,uninstalled:y}=this.groupByInstalled([...l.keys()],o);for(const F of v){const R=l.get(F);R&&this.telemetryService.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:F,exeName:R.exeName})}for(const F of y){const R=l.get(F);R&&this.telemetryService.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:F,exeName:R.exeName})}const O=this.getPromptedExecutableTips(),_=new Map;for(const F of y){const R=l.get(F);if(R&&(!O[R.exeName]||!O[R.exeName].includes(R.extensionId))){let U=_.get(R.exeName);U||(U=[],_.set(R.exeName,U)),U.push(R)}}return _}promptHighImportanceExeBasedTip(){if(this.highImportanceTipsByExe.size===0)return;const[s,o]=[...this.highImportanceTipsByExe.entries()][0];this.promptExeRecommendations(o).then(l=>{switch(l){case"reacted":this.addToRecommendedExecutables(o[0].exeName,o);break;case"ignored":this.highImportanceTipsByExe.delete(s);break;case"incompatibleWindow":{const v=L.Event.once(L.Event.latch(L.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(v(()=>this.promptHighImportanceExeBasedTip()));break}case"toomany":{const v=this._register((0,t.disposableTimeout)(()=>{v.dispose(),this.promptHighImportanceExeBasedTip()},60*60*1e3));break}}})}promptMediumImportanceExeBasedTip(){if(this.mediumImportanceTipsByExe.size===0)return;const s=this.getLastPromptedMediumExeTime(),o=Date.now()-s,l=7*24*60*60*1e3;if(o<l){const O=this._register((0,t.disposableTimeout)(()=>{O.dispose(),this.promptMediumImportanceExeBasedTip()},l-o));return}const[v,y]=[...this.mediumImportanceTipsByExe.entries()][0];this.promptExeRecommendations(y).then(O=>{switch(O){case"reacted":{this.updateLastPromptedMediumExeTime(Date.now()),this.mediumImportanceTipsByExe.delete(v),this.addToRecommendedExecutables(y[0].exeName,y);const _=this._register((0,t.disposableTimeout)(()=>{_.dispose(),this.promptMediumImportanceExeBasedTip()},l));break}case"ignored":this.mediumImportanceTipsByExe.delete(v),this.promptMediumImportanceExeBasedTip();break;case"incompatibleWindow":{const _=L.Event.once(L.Event.latch(L.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(_(()=>this.promptMediumImportanceExeBasedTip()));break}case"toomany":{const _=this._register((0,t.disposableTimeout)(()=>{_.dispose(),this.promptMediumImportanceExeBasedTip()},60*60*1e3));break}}})}async promptExeRecommendations(s){const o=await this.extensionManagementService.getInstalled(1),l=s.filter(y=>!y.whenNotInstalled||y.whenNotInstalled.every(O=>o.every(_=>!(0,C.areSameExtensions)(_.identifier,{id:O})))).map(({extensionId:y})=>y.toLowerCase()),v=(0,D.localize)(0,null,s[0].exeFriendlyName);return this.extensionRecommendationNotificationService.promptImportantExtensionsInstallNotification(l,v,`@exe:"${s[0].exeName}"`,3)}getLastPromptedMediumExeTime(){let s=this.storageService.getNumber(i,-1);return s||(s=Date.now(),this.updateLastPromptedMediumExeTime(s)),s}updateLastPromptedMediumExeTime(s){this.storageService.store(i,s,-1,1)}getPromptedExecutableTips(){return JSON.parse(this.storageService.get(n,-1,"{}"))}addToRecommendedExecutables(s,o){const l=this.getPromptedExecutableTips();l[s]=o.map(({extensionId:v})=>v.toLowerCase()),this.storageService.store(n,JSON.stringify(l),-1,0)}groupByInstalled(s,o){const l=[],v=[],y=o.reduce((O,_)=>(O.add(_.identifier.id.toLowerCase()),O),new Set);return s.forEach(O=>{y.has(O.toLowerCase())?l.push(O):v.push(O)}),{installed:l,uninstalled:v}}async getValidExecutableBasedExtensionTips(s){const o=[],l=new Map;for(const v of s.keys()){const y=s.get(v);if(!y||!(0,k.isNonEmptyArray)(y.recommendations))continue;const O=[];I.isWindows?y.windowsPath&&O.push(y.windowsPath.replace("%USERPROFILE%",b.env.USERPROFILE).replace("%ProgramFiles(x86)%",b.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",b.env.ProgramFiles).replace("%APPDATA%",b.env.APPDATA).replace("%WINDIR%",b.env.WINDIR)):(O.push((0,A.join)("/usr/local/bin",v)),O.push((0,A.join)("/usr/bin",v)),O.push((0,A.join)(this.environmentService.userHome.fsPath,v)));for(const _ of O){let F=l.get(_);if(F===void 0&&(F=await this.fileService.exists(P.URI.file(_)),l.set(_,F)),F)for(const{extensionId:R,extensionName:U,isExtensionPack:M,whenNotInstalled:V}of y.recommendations)o.push({extensionId:R,extensionName:U,isExtensionPack:M,exeName:v,exeFriendlyName:y.exeFriendlyName,windowsPath:y.windowsPath,whenNotInstalled:V})}}return o}};a=me([Q(0,E.INativeEnvironmentService),Q(1,r.ITelemetryService),Q(2,p.IExtensionManagementService),Q(3,u.IStorageService),Q(4,m.INativeHostService),Q(5,S.IExtensionRecommendationNotificationService),Q(6,w.IFileService),Q(7,g.IProductService),Q(8,f.IRequestService),Q(9,d.ILogService)],a),e.ExtensionTipsService=a}),define(re[238],se([0,1,6,2,19,86,22,212]),function(Z,e,k,t,T,L,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeStorageService=void 0;class b extends A.AbstractStorageService{constructor(D,{defaultProfile:E,currentProfile:p},C,h){super();this.mainProcessService=C,this.environmentService=h,this.profileStorageProfile=void 0,this.profileStorageDisposables=this._register(new t.DisposableStore),this.workspaceStorage=void 0,this.workspaceStorageId=void 0,this.workspaceStorageDisposables=this._register(new t.DisposableStore),this.applicationStorageProfile=E,this.applicationStorage=this.createApplicationStorage(),this.profileStorage=this.createProfileStorage(p),this.workspaceStorage=this.createWorkspaceStorage(D)}createApplicationStorage(){const D=this._register(new I.ApplicationStorageDatabaseClient(this.mainProcessService.getChannel("storage"))),E=this._register(new L.Storage(D));return this._register(E.onDidChangeStorage(p=>this.emitDidChangeValue(-1,p))),E}createProfileStorage(D){this.profileStorageDisposables.clear(),this.profileStorageProfile=D;let E;if((0,A.isProfileUsingDefaultStorage)(D))E=this.applicationStorage;else{const p=this.profileStorageDisposables.add(new I.ProfileStorageDatabaseClient(this.mainProcessService.getChannel("storage"),D));E=this.profileStorageDisposables.add(new L.Storage(p))}return this.profileStorageDisposables.add(E.onDidChangeStorage(p=>this.emitDidChangeValue(0,p))),E}createWorkspaceStorage(D){this.workspaceStorageDisposables.clear(),this.workspaceStorageId=D?.id;let E;if(D){const p=this.workspaceStorageDisposables.add(new I.WorkspaceStorageDatabaseClient(this.mainProcessService.getChannel("storage"),D));E=this.workspaceStorageDisposables.add(new L.Storage(p)),this.workspaceStorageDisposables.add(E.onDidChangeStorage(C=>this.emitDidChangeValue(1,C)))}return E}async doInitialize(){await k.Promises.settled([this.applicationStorage.init(),this.profileStorage.init(),this.workspaceStorage?.init()??Promise.resolve()])}getStorage(D){switch(D){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(D){switch(D){case-1:return this.applicationStorageProfile.globalStorageHome.fsPath;case 0:return this.profileStorageProfile?.globalStorageHome.fsPath;default:return this.workspaceStorageId?`${(0,T.joinPath)(this.environmentService.workspaceStorageHome,this.workspaceStorageId,"state.vscdb").fsPath}`:void 0}}async close(){this.stopFlushWhenIdle(),this.emitWillSaveState(A.WillSaveStateReason.SHUTDOWN),await k.Promises.settled([this.applicationStorage.close(),this.profileStorage.close(),this.workspaceStorage?.close()??Promise.resolve()])}async switchToProfile(D,E){if(this.profileStorageProfile&&!this.canSwitchProfile(this.profileStorageProfile,D))return;const p=this.profileStorage,C=p.items;p!==this.applicationStorage&&await p.close(),this.profileStorage=this.createProfileStorage(D),await this.profileStorage.init(),this.switchData(C,this.profileStorage,0,E)}async switchToWorkspace(D,E){const p=this.workspaceStorage,C=p?.items??new Map;await p?.close(),this.workspaceStorage=this.createWorkspaceStorage(D),await this.workspaceStorage.init(),this.switchData(C,this.workspaceStorage,1,E)}}e.NativeStorageService=b}),define(re[239],se([0,1,15,13,96,7,28]),function(Z,e,k,t,T,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesNativeService=void 0;let I=class extends A.UserDataProfilesService{constructor(P,D,E,p,C){super(E,p,C);this._profiles=[],this.channel=D.getChannel("userDataProfiles"),this._profiles=P.map(h=>(0,A.reviveProfile)(h,this.profilesHome.scheme)),this._register(this.channel.listen("onDidChangeProfiles")(h=>{const S=h.added.map(d=>(0,A.reviveProfile)(d,this.profilesHome.scheme)),w=h.removed.map(d=>(0,A.reviveProfile)(d,this.profilesHome.scheme));this._profiles=h.all.map(d=>(0,A.reviveProfile)(d,this.profilesHome.scheme)),this._onDidChangeProfiles.fire({added:S,removed:w,all:this.profiles})}))}get profiles(){return this._profiles}async createProfile(P,D){const E=await this.channel.call("createProfile",[P,D]);return(0,A.reviveProfile)(E,this.profilesHome.scheme)}async setProfileForWorkspace(P,D){const E=await this.channel.call("setProfileForWorkspace",[P,D]);return(0,A.reviveProfile)(E,this.profilesHome.scheme)}removeProfile(P){return this.channel.call("removeProfile",[P])}};I=me([Q(1,T.IMainProcessService),Q(2,k.IEnvironmentService),Q(3,t.IFileService),Q(4,L.ILogService)],I),e.UserDataProfilesNativeService=I}),define(re[59],se([0,1,77]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function t(A,I,b,P){const D=(0,k.setProperty)(A,I,b,P)[0];return D&&(A=A.substring(0,D.offset)+D.content+A.substring(D.offset+D.length)),A}e.edit=t;function T(A,I,b){let P=b;for(;P>=0;){if(A.charAt(P)===I.charAt(I.length-1)&&I.length===1)return P+1;if(P--,I.length===2&&P>=0&&A.charAt(P)===I.charAt(0))return P+2}return 0}e.getLineStartOffset=T;function L(A,I,b){let P=b;for(;P>=0;)if(A.charAt(P)===I.charAt(I.length-1)&&I.length===1||(P++,I.length===2&&P>=0&&A.charAt(P)===I.charAt(1)))return P;return A.length-1}e.getLineEndOffset=L}),define(re[240],se([0,1,29,55,14]),function(Z,e,k,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function L(p,C,h,S,w){const d=[],m=[],g=[];if(!C){const _=p.filter(({identifier:F})=>w.every(R=>R.toLowerCase()!==F.id.toLowerCase()));return{local:{added:d,removed:m,updated:g},remote:_.length>0?{added:_,updated:[],removed:[],all:_}:null}}p=p.map(D),C=C.map(D),h=h?h.map(D):null;const f=new Map,u=_=>{_.uuid&&f.set(_.id.toLowerCase(),_.uuid)};p.forEach(({identifier:_})=>u(_)),C.forEach(({identifier:_})=>u(_)),h?.forEach(({identifier:_})=>u(_));const r=_=>{const F=_.identifier.uuid||f.get(_.identifier.id.toLowerCase());return F?`uuid:${F}`:`id:${_.identifier.id.toLowerCase()}`},n=(_,F)=>(_.set(r(F),F),_),i=p.reduce(n,new Map),a=C.reduce(n,new Map),c=C.reduce((_,F)=>{const R=r(F);F=(0,k.deepClone)(F);const U=i.get(R);return U&&(U.installed&&(F.installed=!0),F.version||(F.version=U.version)),n(_,F)},new Map),s=h?h.reduce(n,new Map):null,o=S.reduce(n,new Map),l=w.reduce((_,F)=>{const R=f.get(F.toLowerCase());return _.add(R?`uuid:${R}`:`id:${F.toLowerCase()}`)},new Set),v=A(i,a,l);if(v.added.size>0||v.removed.size>0||v.updated.size>0){const _=A(s,i,l),F=A(s,a,l),R=(U,M)=>{const V=i.get(U);if(V){const W=a.get(U),z=M?W:V;return{...z,version:W.version&&(!V.installed||t.gt(W.version,V.version))?W.version:V.version,state:I(V,W,s?.get(U)),preRelease:(0,T.isUndefined)(z.preRelease)?V.preRelease:V.installed?z.preRelease:W.preRelease}}};for(const U of F.removed.values()){const M=i.get(U);M&&m.push(M.identifier)}for(const U of F.added.values())if(_.added.has(U)){if(v.updated.has(U)){const M=R(U,!0);M&&(g.push(E(M,U)),c.set(U,M))}}else{const M=a.get(U);M.installed&&d.push(E(M,U))}for(const U of F.updated.values()){const M=R(U,!0);M&&(g.push(E(M,U)),c.set(U,M))}for(const U of _.added.values())F.added.has(U)||c.set(U,i.get(U));for(const U of _.updated.values())if(!F.removed.has(U)&&!F.updated.has(U)){const M=R(U,!1);M&&(c.get(U)?.installed&&(M.installed=!0),c.set(U,M))}for(const U of _.removed.values())!o.has(U)&&!F.updated.has(U)&&s?.get(U)?.installed&&c.delete(U)}const y=[],O=A(a,c,new Set,{checkInstalledProperty:!0,checkVersionProperty:!0});return(O.added.size>0||O.updated.size>0||O.removed.size>0)&&c.forEach((_,F)=>y.push(E(_,F))),{local:{added:d,removed:m,updated:g},remote:y.length?{added:[...O.added].map(_=>c.get(_)),updated:[...O.updated].map(_=>c.get(_)),removed:[...O.removed].map(_=>a.get(_)),all:y}:null}}e.merge=L;function A(p,C,h,{checkInstalledProperty:S,checkVersionProperty:w}={checkInstalledProperty:!1,checkVersionProperty:!1}){const d=p?[...p.keys()].filter(r=>!h.has(r)):[],m=[...C.keys()].filter(r=>!h.has(r)),g=m.filter(r=>d.indexOf(r)===-1).reduce((r,n)=>(r.add(n),r),new Set),f=d.filter(r=>m.indexOf(r)===-1).reduce((r,n)=>(r.add(n),r),new Set),u=new Set;for(const r of d){if(f.has(r))continue;const n=p.get(r),i=C.get(r);(!i||n.disabled!==i.disabled||n.installed&&i.installed&&n.preRelease!==i.preRelease||!P(n.state,i.state)||w&&n.version!==i.version||S&&n.installed!==i.installed)&&u.add(r)}return{added:g,removed:f,updated:u}}function I(p,C,h){const S=p.state,w=C.state,d=h?.state;if(!C.version||S&&t.gt(p.version,C.version))return S;if(w&&t.gt(C.version,p.version)||!S)return w;if(!w)return S;const m=(0,k.deepClone)(S),g=d?b(d,w):{added:Object.keys(w).reduce((u,r)=>(u.add(r),u),new Set),removed:new Set,updated:new Set},f=d?b(d,S):{added:Object.keys(S).reduce((u,r)=>(u.add(r),u),new Set),removed:new Set,updated:new Set};for(const u of[...g.added.values(),...g.updated.values()])m[u]=w[u];for(const u of g.removed.values())f.updated.has(u)||delete m[u];return m}function b(p,C){const h=Object.keys(p),S=Object.keys(C),w=S.filter(g=>h.indexOf(g)===-1).reduce((g,f)=>(g.add(f),g),new Set),d=h.filter(g=>S.indexOf(g)===-1).reduce((g,f)=>(g.add(f),g),new Set),m=new Set;for(const g of h){if(d.has(g))continue;const f=p[g],u=C[g];(0,k.equals)(f,u)||m.add(g)}return{added:w,removed:d,updated:m}}function P(p={},C={}){const{added:h,removed:S,updated:w}=b(p,C);return h.size===0&&S.size===0&&w.size===0}function D(p){return{...p,disabled:!!p.disabled,installed:!!p.installed}}function E(p,C){const h={identifier:{id:p.identifier.id,uuid:C.startsWith("uuid:")?C.substring("uuid:".length):void 0},preRelease:!!p.preRelease};return p.version&&(h.version=p.version),p.disabled&&(h.disabled=!0),p.installed&&(h.installed=!0),p.state&&(h.state=p.state),h}}),define(re[108],se([0,1,17,18,5]),function(Z,e,k,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,T.createDecorator)("IIgnoredExtensionsManagementService");let L=class{constructor(I){this.configurationService=I}hasToNeverSyncExtension(I){return this.getConfiguredIgnoredExtensions().includes(I.toLowerCase())}hasToAlwaysSyncExtension(I){return this.getConfiguredIgnoredExtensions().includes(`-${I.toLowerCase()}`)}updateIgnoredExtensions(I,b){let P=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(D=>D.toLowerCase());return P=P.filter(D=>D!==I&&D!==`-${I}`),b&&P.push(I.toLowerCase()),this.configurationService.updateValue("settingsSync.ignoredExtensions",P.length?P:void 0,1)}updateSynchronizedExtensions(I,b){let P=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(D=>D.toLowerCase());return P=P.filter(D=>D!==I&&D!==`-${I}`),b&&P.push(`-${I.toLowerCase()}`),this.configurationService.updateValue("settingsSync.ignoredExtensions",P.length?P:void 0,1)}getIgnoredExtensions(I){const b=I.filter(p=>p.isMachineScoped).map(p=>p.identifier.id.toLowerCase()),P=this.getConfiguredIgnoredExtensions().map(p=>p.toLowerCase()),D=[],E=[];if(Array.isArray(P))for(const p of P)p.startsWith("-")?E.push(p.substring(1)):D.push(p);return(0,k.distinct)([...b,...D].filter(p=>E.indexOf(p)===-1))}getConfiguredIgnoredExtensions(){let I=this.configurationService.inspect("settingsSync.ignoredExtensions").userValue;return I!==void 0||(I=this.configurationService.inspect("sync.ignoredExtensions").userValue,I!==void 0)?I:(this.configurationService.getValue("settingsSync.ignoredExtensions")||[]).map(b=>b.toLowerCase())}};L=me([Q(0,t.IConfigurationService)],L),e.IgnoredExtensionsManagementService=L}),define(re[241],se([0,1,17,34,29,173,59]),function(Z,e,k,t,T,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=e.parseKeybindings=void 0;function I(f){return(0,t.parse)(f)||[]}e.parseKeybindings=I;async function b(f,u,r,n,i){const a=I(f),c=I(u),s=r?I(r):null,o=[...a,...c,...s||[]].map(W=>W.key),l=await i.resolveUserBindings(o),v=D(a,c,s,l);if(!v.hasLocalForwarded&&!v.hasRemoteForwarded)return{mergeContent:f,hasChanges:!1,hasConflicts:!1};if(!v.hasLocalForwarded&&v.hasRemoteForwarded)return{mergeContent:u,hasChanges:!0,hasConflicts:!1};if(v.hasLocalForwarded&&!v.hasRemoteForwarded)return{mergeContent:f,hasChanges:!0,hasConflicts:!1};const y=p(a),O=p(c),_=s?p(s):null,F=h(y,O,l),R=_?h(_,y,l):{added:[...y.keys()].reduce((W,z)=>(W.add(z),W),new Set),removed:new Set,updated:new Set},U=_?h(_,O,l):{added:[...O.keys()].reduce((W,z)=>(W.add(z),W),new Set),removed:new Set,updated:new Set},M=P(F,R,U);let V=f;for(const W of M.removed.values())M.conflicts.has(W)||(V=m(V,W,n));for(const W of M.added.values()){if(M.conflicts.has(W))continue;const z=O.get(W);if(z.some(te=>te.command!==`-${W}`&&v.conflicts.has(l[te.key]))){M.conflicts.add(W);continue}V=d(V,z,n)}for(const W of M.updated.values()){if(M.conflicts.has(W))continue;const z=O.get(W);if(z.some(te=>te.command!==`-${W}`&&v.conflicts.has(l[te.key]))){M.conflicts.add(W);continue}V=g(V,W,z,n)}return{mergeContent:V,hasChanges:!0,hasConflicts:M.conflicts.size>0}}e.merge=b;function P(f,u,r){const n=new Set,i=new Set,a=new Set,c=new Set;for(const s of u.removed.values())r.updated.has(s)&&c.add(s);for(const s of r.removed.values())c.has(s)||(u.updated.has(s)?c.add(s):i.add(s));for(const s of u.added.values())c.has(s)||r.added.has(s)&&f.updated.has(s)&&c.add(s);for(const s of r.added.values())c.has(s)||(u.added.has(s)?f.updated.has(s)&&c.add(s):n.add(s));for(const s of u.updated.values())c.has(s)||r.updated.has(s)&&f.updated.has(s)&&c.add(s);for(const s of r.updated.values())c.has(s)||(u.updated.has(s)?f.updated.has(s)&&c.add(s):a.add(s));return{added:n,removed:i,updated:a,conflicts:c}}function D(f,u,r,n){const i=new Set,a=E(f,n),c=E(u,n),s=r?E(r,n):null,o=C(a,c);if(o.added.size===0&&o.removed.size===0&&o.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:i,removed:i,updated:i,conflicts:i};const l=s?C(s,a):{added:[...a.keys()].reduce((R,U)=>(R.add(U),R),new Set),removed:new Set,updated:new Set};if(l.added.size===0&&l.removed.size===0&&l.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:i,removed:i,updated:i,conflicts:i};const v=s?C(s,c):{added:[...c.keys()].reduce((R,U)=>(R.add(U),R),new Set),removed:new Set,updated:new Set};if(v.added.size===0&&v.removed.size===0&&v.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:i,removed:i,updated:i,conflicts:i};const{added:y,removed:O,updated:_,conflicts:F}=P(o,l,v);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:y,removed:O,updated:_,conflicts:F}}function E(f,u){const r=new Map;for(const n of f){const i=u[n.key];let a=r.get(i);a||(a=[],r.set(i,a)),a.push(n)}return r}function p(f){const u=new Map;for(const r of f){const n=r.command[0]==="-"?r.command.substring(1):r.command;let i=u.get(n);i||(i=[],u.set(n,i)),i.push(r)}return u}function C(f,u){const r=[...f.keys()],n=[...u.keys()],i=n.filter(s=>r.indexOf(s)===-1).reduce((s,o)=>(s.add(o),s),new Set),a=r.filter(s=>n.indexOf(s)===-1).reduce((s,o)=>(s.add(o),s),new Set),c=new Set;for(const s of r){if(a.has(s))continue;const o=f.get(s).map(v=>({...v,key:s})),l=u.get(s).map(v=>({...v,key:s}));(0,k.equals)(o,l,(v,y)=>w(v,y))||c.add(s)}return{added:i,removed:a,updated:c}}function h(f,u,r){const n=[...f.keys()],i=[...u.keys()],a=i.filter(o=>n.indexOf(o)===-1).reduce((o,l)=>(o.add(l),o),new Set),c=n.filter(o=>i.indexOf(o)===-1).reduce((o,l)=>(o.add(l),o),new Set),s=new Set;for(const o of n){if(c.has(o))continue;const l=f.get(o).map(y=>({...y,key:r[y.key]})),v=u.get(o).map(y=>({...y,key:r[y.key]}));S(l,v)||s.add(o)}return{added:a,removed:c,updated:s}}function S(f,u){return!(!(0,k.equals)(f.filter(({command:r})=>r[0]!=="-"),u.filter(({command:r})=>r[0]!=="-"),(r,n)=>w(r,n))||!(0,k.equals)(f.filter(({command:r})=>r[0]==="-"),u.filter(({command:r})=>r[0]==="-"),(r,n)=>w(r,n)))}function w(f,u){if(f.command!==u.command||f.key!==u.key)return!1;const r=L.ContextKeyExpr.deserialize(f.when),n=L.ContextKeyExpr.deserialize(u.when);return!(r&&!n||!r&&n||r&&n&&!r.equals(n)||!T.equals(f.args,u.args))}function d(f,u,r){for(const n of u)f=A.edit(f,[-1],n,r);return f}function m(f,u,r){const n=I(f);for(let i=n.length-1;i>=0;i--)(n[i].command===u||n[i].command===`-${u}`)&&(f=A.edit(f,[i],void 0,r));return f}function g(f,u,r,n){const i=I(f),a=i.findIndex(c=>c.command===u||c.command===`-${u}`);for(let c=i.length-1;c>=0;c--)(i[c].command===u||i[c].command===`-${u}`)&&(f=A.edit(f,[c],void 0,n));for(let c=r.length-1;c>=0;c--)f=A.edit(f,[a],r[c],n);return f}}),define(re[242],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function k(L,A,I){const b={},P={},D=new Set;if(!A)return{local:{added:b,updated:P,removed:[...D.values()]},remote:{added:L,updated:{},removed:[]},conflicts:[]};const E=t(L,A);if(E.added.size===0&&E.removed.size===0&&E.updated.size===0)return{local:{added:b,updated:P,removed:[...D.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const p=t(I,L),C=t(I,A),h={},S={},w=new Set,d=new Set;for(const m of p.removed.values())C.updated.has(m)?b[m]=A[m]:w.add(m);for(const m of C.removed.values())d.has(m)||(p.updated.has(m)?d.add(m):D.add(m));for(const m of p.updated.values())d.has(m)||(C.updated.has(m)?E.updated.has(m)&&d.add(m):S[m]=L[m]);for(const m of C.updated.values())d.has(m)||(p.updated.has(m)?E.updated.has(m)&&d.add(m):L[m]!==void 0&&(P[m]=A[m]));for(const m of p.added.values())d.has(m)||(C.added.has(m)?E.updated.has(m)&&d.add(m):h[m]=L[m]);for(const m of C.added.values())d.has(m)||(p.added.has(m)?E.updated.has(m)&&d.add(m):b[m]=A[m]);return{local:{added:b,removed:[...D.values()],updated:P},remote:{added:h,removed:[...w.values()],updated:S},conflicts:[...d.values()]}}e.merge=k;function t(L,A){const I=L?Object.keys(L):[],b=A?Object.keys(A):[],P=b.filter(p=>I.indexOf(p)===-1).reduce((p,C)=>(p.add(C),p),new Set),D=I.filter(p=>b.indexOf(p)===-1).reduce((p,C)=>(p.add(C),p),new Set),E=new Set;for(const p of I){if(D.has(p))continue;const C=L[p],h=A[p];C!==h&&E.add(p)}return{added:P,removed:D,updated:E}}function T(L,A){const{added:I,removed:b,updated:P}=t(L,A);return I.size===0&&b.size===0&&P.size===0}e.areSame=T}),define(re[25],se([0,1,17,19,14,163,43,30,5,99,40]),function(Z,e,k,t,T,L,A,I,b,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSyncResourceFromLocalPreview=e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataSyncService=e.IUserDataSyncEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.getLastSyncResourceUri=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.USER_DATA_SYNC_CONFIGURATION_SCOPE=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function E(){const s=D.Registry.as(A.Extensions.Configuration).getConfigurationProperties();return Object.keys(s).filter(o=>!!s[o].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=E;function p(){const s=D.Registry.as(A.Extensions.Configuration).getConfigurationProperties(),o=Object.keys(s).filter(y=>!!s[y].ignoreSync),l=Object.keys(s).filter(y=>s[y].scope===2||s[y].scope===6),v=E();return(0,k.distinct)([e.CONFIGURATION_SYNC_STORE_KEY,...o,...l,...v])}e.getDefaultIgnoredSettings=p,e.USER_DATA_SYNC_CONFIGURATION_SCOPE="settingsSync";function C(){const s="vscode://schemas/ignoredSettings",o=D.Registry.as(A.Extensions.Configuration);o.registerConfiguration({id:"settingsSync",order:30,title:(0,L.localize)(0,null),type:"object",properties:{"settingsSync.keybindingsPerPlatform":{type:"boolean",description:(0,L.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,L.localize)(2,null),items:[{type:"string",pattern:I.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,L.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,L.localize)(4,null),default:[],scope:1,$ref:s,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const l=D.Registry.as(P.Extensions.JSONContribution),v=()=>{const y=E(),O=p().filter(U=>U!==e.CONFIGURATION_SYNC_STORE_KEY),_=Object.keys(A.allSettings.properties).filter(U=>O.indexOf(U)===-1),F=O.filter(U=>y.indexOf(U)===-1),R={items:{type:"string",enum:[..._,...F.map(U=>`-${U}`)]}};l.registerSchema(s,R)};return o.onDidUpdateConfiguration(()=>v())}e.registerConfiguration=C;function h(s){return s&&(0,T.isObject)(s)&&(0,T.isString)(s.id)&&(0,T.isArray)(s.scopes)}e.isAuthenticationProvider=h;var S;(function(s){s.Settings="settings",s.Keybindings="keybindings",s.Snippets="snippets",s.Tasks="tasks",s.Extensions="extensions",s.GlobalState="globalState"})(S=e.SyncResource||(e.SyncResource={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","tasks","extensions","globalState"];function w(s,o,l){return l.joinPath(o.userDataSyncHome,s,`lastSync${s}.json`)}e.getLastSyncResourceUri=w,e.IUserDataSyncStoreManagementService=(0,b.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,b.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=(0,b.createDecorator)("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function d(s){const o={};return o[e.HEADER_EXECUTION_ID]=s,o}e.createSyncHeaders=d;var m;(function(s){s.Unauthorized="Unauthorized",s.Conflict="Conflict",s.Gone="Gone",s.PreconditionFailed="PreconditionFailed",s.TooLarge="TooLarge",s.UpgradeRequired="UpgradeRequired",s.PreconditionRequired="PreconditionRequired",s.TooManyRequests="RemoteTooManyRequests",s.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",s.RequestFailed="RequestFailed",s.RequestCanceled="RequestCanceled",s.RequestTimeout="RequestTimeout",s.RequestProtocolNotSupported="RequestProtocolNotSupported",s.RequestPathNotEscaped="RequestPathNotEscaped",s.RequestHeadersNotObject="RequestHeadersNotObject",s.NoRef="NoRef",s.EmptyResponse="EmptyResponse",s.TurnedOff="TurnedOff",s.SessionExpired="SessionExpired",s.ServiceChanged="ServiceChanged",s.DefaultServiceChanged="DefaultServiceChanged",s.LocalTooManyRequests="LocalTooManyRequests",s.LocalPreconditionFailed="LocalPreconditionFailed",s.LocalInvalidContent="LocalInvalidContent",s.LocalError="LocalError",s.IncompatibleLocalContent="IncompatibleLocalContent",s.IncompatibleRemoteContent="IncompatibleRemoteContent",s.UnresolvedConflicts="UnresolvedConflicts",s.Unknown="Unknown"})(m=e.UserDataSyncErrorCode||(e.UserDataSyncErrorCode={}));class g extends Error{constructor(o,l,v,y){super(o);this.code=l,this.resource=v,this.operationId=y,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=g;class f extends g{constructor(o,l,v,y,O){super(o,v,void 0,O);this.url=l,this.serverCode=y}}e.UserDataSyncStoreError=f;class u extends g{constructor(o,l){super(o,l)}}e.UserDataAutoSyncError=u,function(s){function o(l){if(l instanceof s)return l;const v=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(l.name);if(v&&v[1]){const y=v[2]==="unknown"?void 0:v[2],O=v[3]==="unknown"?void 0:v[3];return new s(l.message,v[1],y,O)}return new s(l.message,"Unknown")}s.toUserDataSyncError=o}(g=e.UserDataSyncError||(e.UserDataSyncError={}));var r;(function(s){s.Uninitialized="uninitialized",s.Idle="idle",s.Syncing="syncing",s.HasConflicts="hasConflicts"})(r=e.SyncStatus||(e.SyncStatus={}));var n;(function(s){s[s.None=0]="None",s[s.Added=1]="Added",s[s.Modified=2]="Modified",s[s.Deleted=3]="Deleted"})(n=e.Change||(e.Change={}));var i;(function(s){s.Preview="preview",s.Conflict="conflict",s.Accepted="accepted"})(i=e.MergeState||(e.MergeState={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function a(s){return`sync.enable.${s}`}e.getEnablementKey=a,e.IUserDataSyncEnablementService=(0,b.createDecorator)("IUserDataSyncEnablementService"),e.IUserDataSyncService=(0,b.createDecorator)("IUserDataSyncService"),e.IUserDataAutoSyncService=(0,b.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,b.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,b.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview";function c(s,o){if(s.scheme!==e.USER_DATA_SYNC_SCHEME)return s=s.with({scheme:o.userDataSyncHome.scheme}),e.ALL_SYNC_RESOURCES.filter(l=>(0,t.isEqualOrParent)(s,(0,t.joinPath)(o.userDataSyncHome,l,e.PREVIEW_DIR_NAME)))[0]}e.getSyncResourceFromLocalPreview=c}),define(re[47],se([0,1,17,6,16,23,3,34,2,26,14,8,159,18,15,13,7,49,22,21,33,25,28]),function(Z,e,k,t,T,L,A,I,b,P,D,E,p,C,h,S,w,d,m,g,f,u,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.isSyncData=void 0;function n(o){return!!(o&&o.version!==void 0&&typeof o.version=="number"&&o.content!==void 0&&typeof o.content=="string"&&(Object.keys(o).length===2||Object.keys(o).length===3&&o.machineId!==void 0&&typeof o.machineId=="string"))}e.isSyncData=n;let i=class extends b.Disposable{constructor(l,v,y,O,_,F,R,U,M,V,W){super();this.resource=l,this.fileService=v,this.environmentService=y,this.userDataSyncStoreService=_,this.userDataSyncBackupStoreService=F,this.userDataSyncEnablementService=R,this.telemetryService=U,this.logService=M,this.configurationService=V,this.syncPreviewPromise=null,this._status="idle",this._onDidChangStatus=this._register(new A.Emitter),this.onDidChangeStatus=this._onDidChangStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new A.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this.localChangeTriggerThrottler=new t.ThrottledDelayer(50),this._onDidChangeLocal=this._register(new A.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this.hasSyncResourceStateVersionChanged=!1,this.syncHeaders={},this.syncResourceLogLabel=(0,P.uppercaseFirstLetter)(this.resource),this.extUri=W.extUri,this.syncFolder=this.extUri.joinPath(y.userDataSyncHome,l),this.syncPreviewFolder=this.extUri.joinPath(this.syncFolder,u.PREVIEW_DIR_NAME),this.lastSyncResource=(0,u.getLastSyncResourceUri)(l,y,this.extUri),this.currentMachineIdPromise=(0,d.getServiceMachineId)(y,v,O)}get status(){return this._status}get conflicts(){return this._conflicts}triggerLocalChange(){this.localChangeTriggerThrottler.trigger(()=>this.doTriggerLocalChange())}async doTriggerLocalChange(){if(this.status==="hasConflicts"){this.logService.info(`${this.syncResourceLogLabel}: In conflicts state and local change detected. Syncing again...`);const l=await this.syncPreviewPromise;this.syncPreviewPromise=null;const v=await this.performSync(l.remoteUserData,l.lastSyncUserData,!0,this.getUserDataSyncConfiguration());this.setStatus(v)}else{this.logService.trace(`${this.syncResourceLogLabel}: Checking for local changes...`);const l=await this.getLastSyncUserData();(l?await this.hasRemoteChanged(l):!0)&&this._onDidChangeLocal.fire()}}setStatus(l){this._status!==l&&(this._status=l,this._onDidChangStatus.fire(l))}async sync(l,v={}){await this._sync(l,!0,this.getUserDataSyncConfiguration(),v)}async preview(l,v,y={}){return this._sync(l,!1,v,y)}async apply(l,v={}){try{this.syncHeaders={...v};const y=await this.doApply(l);return this.setStatus(y),this.syncPreviewPromise}finally{this.syncHeaders={}}}async _sync(l,v,y,O){try{if(this.syncHeaders={...O},this.status==="hasConflicts")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.syncPreviewPromise;if(this.status==="syncing")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.syncPreviewPromise;this.logService.trace(`${this.syncResourceLogLabel}: Started synchronizing ${this.resource.toLowerCase()}...`),this.setStatus("syncing");let _="idle";try{const F=await this.getLastSyncUserData(),R=await this.getLatestRemoteUserData(l,F);return _=await this.performSync(R,F,v,y),_==="hasConflicts"?this.logService.info(`${this.syncResourceLogLabel}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):_==="idle"&&this.logService.trace(`${this.syncResourceLogLabel}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise||null}finally{this.setStatus(_)}}finally{this.syncHeaders={}}}async replace(l){const v=await this.resolveContent(l);if(!v)return!1;const y=this.parseSyncData(v);if(!y)return!1;await this.stop();try{this.logService.trace(`${this.syncResourceLogLabel}: Started resetting ${this.resource.toLowerCase()}...`),this.setStatus("syncing");const O=await this.getLastSyncUserData(),_=await this.getLatestRemoteUserData(null,O),F=await this.isRemoteDataFromCurrentMachine(_),R=await this.generateSyncPreview({ref:_.ref,syncData:y},O,F,this.getUserDataSyncConfiguration(),L.CancellationToken.None),U=[];for(const M of R){const V=await this.getAcceptResult(M,M.remoteResource,void 0,L.CancellationToken.None),{remoteChange:W}=await this.getAcceptResult(M,M.previewResource,M.remoteContent,L.CancellationToken.None);U.push([M,{...V,remoteChange:W!==0?W:2}])}await this.applyResult(_,O,U,!1),this.logService.info(`${this.syncResourceLogLabel}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.setStatus("idle")}return!0}async isRemoteDataFromCurrentMachine(l){const v=await this.currentMachineIdPromise;return!!l.syncData?.machineId&&l.syncData.machineId===v}async getLatestRemoteUserData(l,v){if(v){const y=l&&l.latest?l.latest[this.resource]:void 0;if(v.ref===y||y===void 0&&v.syncData===null)return v}return this.getRemoteUserData(v)}async performSync(l,v,y,O){if(l.syncData&&l.syncData.version>this.version)throw this.telemetryService.publicLog2("sync/incompatible",{source:this.resource}),new u.UserDataSyncError((0,p.localize)(0,null,this.resource,this.version,l.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.doSync(l,v,y,O)}catch(_){if(_ instanceof u.UserDataSyncError)switch(_.code){case"LocalPreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize ${this.syncResourceLogLabel} as there is a new local version available. Synchronizing again...`),this.performSync(l,v,y,O);case"Conflict":case"PreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),l=await this.getRemoteUserData(null),v=await this.getLastSyncUserData(),this.performSync(l,v,y,O)}throw _}}async doSync(l,v,y,O){try{this.syncPreviewPromise||(this.syncPreviewPromise=(0,t.createCancelablePromise)(F=>this.doGenerateSyncResourcePreview(l,v,y,O,F)));const _=await this.syncPreviewPromise;return this.updateConflicts(_.resourcePreviews),_.resourcePreviews.some(({mergeState:F})=>F==="conflict")?"hasConflicts":y?await this.doApply(!1):"syncing"}catch(_){throw this.syncPreviewPromise=null,_}}async merge(l){return await this.updateSyncResourcePreview(l,async v=>{const y=await this.getMergeResult(v,L.CancellationToken.None);await this.fileService.writeFile(v.previewResource,T.VSBuffer.fromString(y?.content||""));const O=y&&!y.hasConflicts?await this.getAcceptResult(v,v.previewResource,void 0,L.CancellationToken.None):void 0;return v.acceptResult=O,v.mergeState=y.hasConflicts?"conflict":O?"accepted":"preview",v.localChange=O?O.localChange:y.localChange,v.remoteChange=O?O.remoteChange:y.remoteChange,v}),this.syncPreviewPromise}async accept(l,v){return await this.updateSyncResourcePreview(l,async y=>{const O=await this.getAcceptResult(y,l,v,L.CancellationToken.None);return y.acceptResult=O,y.mergeState="accepted",y.localChange=O.localChange,y.remoteChange=O.remoteChange,y}),this.syncPreviewPromise}async discard(l){return await this.updateSyncResourcePreview(l,async v=>{const y=await this.getMergeResult(v,L.CancellationToken.None);return await this.fileService.writeFile(v.previewResource,T.VSBuffer.fromString(y.content||"")),v.acceptResult=void 0,v.mergeState="preview",v.localChange=y.localChange,v.remoteChange=y.remoteChange,v}),this.syncPreviewPromise}async updateSyncResourcePreview(l,v){if(!this.syncPreviewPromise)return;let y=await this.syncPreviewPromise;const O=y.resourcePreviews.findIndex(({localResource:_,remoteResource:F,previewResource:R})=>this.extUri.isEqual(_,l)||this.extUri.isEqual(F,l)||this.extUri.isEqual(R,l));O!==-1&&(this.syncPreviewPromise=(0,t.createCancelablePromise)(async _=>{const F=[...y.resourcePreviews];return F[O]=await v(F[O]),{...y,resourcePreviews:F}}),y=await this.syncPreviewPromise,this.updateConflicts(y.resourcePreviews),y.resourcePreviews.some(({mergeState:_})=>_==="conflict")?this.setStatus("hasConflicts"):this.setStatus("syncing"))}async doApply(l){if(!this.syncPreviewPromise)return"idle";const v=await this.syncPreviewPromise;return v.resourcePreviews.some(({mergeState:y})=>y==="conflict")?"hasConflicts":v.resourcePreviews.some(({mergeState:y})=>y!=="accepted")?"syncing":(await this.applyResult(v.remoteUserData,v.lastSyncUserData,v.resourcePreviews.map(y=>[y,y.acceptResult]),l),this.syncPreviewPromise=null,await this.clearPreviewFolder(),"idle")}async clearPreviewFolder(){try{await this.fileService.del(this.syncPreviewFolder,{recursive:!0})}catch{}}updateConflicts(l){const v=l.filter(({mergeState:y})=>y==="conflict");(0,k.equals)(this._conflicts,v,(y,O)=>this.extUri.isEqual(y.previewResource,O.previewResource))||(this._conflicts=v,this._onDidChangeConflicts.fire(v))}async hasPreviouslySynced(){const l=await this.getLastSyncUserData();return!!l&&l.syncData!==null}async getRemoteSyncResourceHandles(){return(await this.userDataSyncStoreService.getAllRefs(this.resource)).map(({created:v,ref:y})=>({created:v,uri:this.toRemoteBackupResource(y)}))}async getLocalSyncResourceHandles(){return(await this.userDataSyncBackupStoreService.getAllRefs(this.resource)).map(({created:v,ref:y})=>({created:v,uri:this.toLocalBackupResource(y)}))}toRemoteBackupResource(l){return E.URI.from({scheme:u.USER_DATA_SYNC_SCHEME,authority:"remote-backup",path:`/${this.resource}/${l}`})}toLocalBackupResource(l){return E.URI.from({scheme:u.USER_DATA_SYNC_SCHEME,authority:"local-backup",path:`/${this.resource}/${l}`})}async getMachineId({uri:l}){const v=this.extUri.basename(l);if(this.extUri.isEqual(l,this.toRemoteBackupResource(v))){const{content:y}=await this.getUserData(v);if(y)return this.parseSyncData(y)?.machineId}}async resolveContent(l){const v=this.extUri.basename(l);if(this.extUri.isEqual(l,this.toRemoteBackupResource(v))){const{content:y}=await this.getUserData(v);return y}return this.extUri.isEqual(l,this.toLocalBackupResource(v))?this.userDataSyncBackupStoreService.resolveContent(this.resource,v):null}async resolvePreviewContent(l){const v=this.syncPreviewPromise?await this.syncPreviewPromise:null;if(v)for(const y of v.resourcePreviews){if(this.extUri.isEqual(y.acceptedResource,l))return y.acceptResult?y.acceptResult.content:null;if(this.extUri.isEqual(y.remoteResource,l))return y.remoteContent;if(this.extUri.isEqual(y.localResource,l))return y.localContent;if(this.extUri.isEqual(y.baseResource,l))return y.baseContent}return null}async resetLocal(){try{await this.fileService.del(this.lastSyncResource)}catch{}}async doGenerateSyncResourcePreview(l,v,y,O,_){const F=await this.isRemoteDataFromCurrentMachine(l),R=await this.generateSyncPreview(l,v,F,O,_),U=[];for(const M of R){const V=M.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"accepted"});if(M.localChange===0&&M.remoteChange===0)U.push({...M,acceptedResource:V,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const W=y?await this.getMergeResult(M,_):void 0;if(_.isCancellationRequested)break;await this.fileService.writeFile(M.previewResource,T.VSBuffer.fromString(W?.content||""));const z=W&&!W.hasConflicts?await this.getAcceptResult(M,M.previewResource,void 0,_):void 0;U.push({...M,acceptResult:z,mergeState:W?.hasConflicts?"conflict":z?"accepted":"preview",localChange:z?z.localChange:W?W.localChange:M.localChange,remoteChange:z?z.remoteChange:W?W.remoteChange:M.remoteChange})}}return{remoteUserData:l,lastSyncUserData:v,resourcePreviews:U,isLastSyncFromCurrentMachine:F}}async getLastSyncUserData(){try{const l=await this.fileService.readFile(this.lastSyncResource),v=JSON.parse(l.value.toString()),y=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource);if(this.hasSyncResourceStateVersionChanged=v.version&&y&&v.version!==y,this.hasSyncResourceStateVersionChanged)return this.logService.info(`${this.syncResourceLogLabel}: Reset last sync state because last sync state version ${v.version} is not compatible with current sync state version ${y}.`),await this.resetLocal(),null;const O=v;if(O.content===null)return{ref:v.ref,syncData:null};const _=JSON.parse(O.content);if(n(_))return{...v,syncData:_,content:void 0}}catch(l){l instanceof S.FileOperationError&&l.fileOperationResult===1||this.logService.error(l)}return null}async updateLastSyncUserData(l,v={}){if(v.ref||v.content||v.version)throw new Error("Cannot have core properties as additional");const y=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource),O={ref:l.ref,content:l.syncData?JSON.stringify(l.syncData):null,version:y,...v};await this.fileService.writeFile(this.lastSyncResource,T.VSBuffer.fromString(JSON.stringify(O)))}async getRemoteUserData(l){const{ref:v,content:y}=await this.getUserData(l);let O=null;return y!==null&&(O=this.parseSyncData(y)),{ref:v,syncData:O}}parseSyncData(l){try{const v=JSON.parse(l);if(n(v))return v}catch(v){this.logService.error(v)}throw new u.UserDataSyncError((0,p.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async getUserData(l){if((0,D.isString)(l)){const v=await this.userDataSyncStoreService.resolveContent(this.resource,l);return{ref:l,content:v}}else{const v=l?{ref:l.ref,content:l.syncData?JSON.stringify(l.syncData):null}:null;return this.userDataSyncStoreService.read(this.resource,v,this.syncHeaders)}}async updateRemoteUserData(l,v){const y=await this.currentMachineIdPromise,O={version:this.version,machineId:y,content:l};return v=await this.userDataSyncStoreService.write(this.resource,JSON.stringify(O),v,this.syncHeaders),{ref:v,syncData:O}}async backupLocal(l){const v={version:this.version,content:l};return this.userDataSyncBackupStoreService.backup(this.resource,JSON.stringify(v))}async stop(){this.status!=="idle"&&(this.logService.trace(`${this.syncResourceLogLabel}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise&&(this.syncPreviewPromise.cancel(),this.syncPreviewPromise=null),this.updateConflicts([]),await this.clearPreviewFolder(),this.setStatus("idle"),this.logService.info(`${this.syncResourceLogLabel}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}getUserDataSyncConfiguration(){return this.configurationService.getValue(u.USER_DATA_SYNC_CONFIGURATION_SCOPE)}};i=me([Q(1,S.IFileService),Q(2,h.IEnvironmentService),Q(3,m.IStorageService),Q(4,u.IUserDataSyncStoreService),Q(5,u.IUserDataSyncBackupStoreService),Q(6,u.IUserDataSyncEnablementService),Q(7,g.ITelemetryService),Q(8,u.IUserDataSyncLogService),Q(9,C.IConfigurationService),Q(10,f.IUriIdentityService)],i),e.AbstractSynchroniser=i;let a=class extends i{constructor(l,v,y,O,_,F,R,U,M,V,W,z){super(v,y,O,_,F,R,U,M,V,W,z);this.file=l,this._register(this.fileService.watch(this.extUri.dirname(l))),this._register(this.fileService.onDidFilesChange(te=>this.onFileChanges(te)))}async getLocalFileContent(){try{return await this.fileService.readFile(this.file)}catch{return null}}async updateLocalFileContent(l,v,y){try{v?await this.fileService.writeFile(this.file,T.VSBuffer.fromString(l),y?void 0:v):await this.fileService.createFile(this.file,T.VSBuffer.fromString(l),{overwrite:y})}catch(O){throw O instanceof S.FileOperationError&&O.fileOperationResult===1||O instanceof S.FileOperationError&&O.fileOperationResult===3?new u.UserDataSyncError(O.message,"LocalPreconditionFailed"):O}}onFileChanges(l){!l.contains(this.file)||this.triggerLocalChange()}};a=me([Q(2,S.IFileService),Q(3,h.IEnvironmentService),Q(4,m.IStorageService),Q(5,u.IUserDataSyncStoreService),Q(6,u.IUserDataSyncBackupStoreService),Q(7,u.IUserDataSyncEnablementService),Q(8,g.ITelemetryService),Q(9,u.IUserDataSyncLogService),Q(10,C.IConfigurationService),Q(11,f.IUriIdentityService)],a),e.AbstractFileSynchroniser=a;let c=class extends a{constructor(l,v,y,O,_,F,R,U,M,V,W,z,te){super(l,v,y,O,_,F,R,U,M,V,z,te);this.userDataSyncUtilService=W,this._formattingOptions=void 0}hasErrors(l,v){const y=[],O=(0,I.parse)(l,y,{allowEmptyContent:!0,allowTrailingComma:!0});return y.length>0||!(0,D.isUndefined)(O)&&v!==Array.isArray(O)}getFormattingOptions(){return this._formattingOptions||(this._formattingOptions=this.userDataSyncUtilService.resolveFormattingOptions(this.file)),this._formattingOptions}};c=me([Q(2,S.IFileService),Q(3,h.IEnvironmentService),Q(4,m.IStorageService),Q(5,u.IUserDataSyncStoreService),Q(6,u.IUserDataSyncBackupStoreService),Q(7,u.IUserDataSyncEnablementService),Q(8,g.ITelemetryService),Q(9,u.IUserDataSyncLogService),Q(10,u.IUserDataSyncUtilService),Q(11,C.IConfigurationService),Q(12,f.IUriIdentityService)],c),e.AbstractJsonFileSynchroniser=c;let s=class{constructor(l,v,y,O,_,F){this.resource=l,this.userDataProfilesService=v,this.environmentService=y,this.logService=O,this.fileService=_,this.extUri=F.extUri,this.lastSyncResource=(0,u.getLastSyncResourceUri)(this.resource,y,this.extUri)}async initialize({ref:l,content:v}){if(!v){this.logService.info("Remote content does not exist.",this.resource);return}const y=this.parseSyncData(v);if(!!y)try{await this.doInitialize({ref:l,syncData:y})}catch(O){this.logService.error(O)}}parseSyncData(l){try{const v=JSON.parse(l);if(n(v))return v}catch(v){this.logService.error(v)}this.logService.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async updateLastSyncUserData(l,v={}){const y={ref:l.ref,content:l.syncData?JSON.stringify(l.syncData):null,...v};await this.fileService.writeFile(this.lastSyncResource,T.VSBuffer.fromString(JSON.stringify(y)))}};s=me([Q(1,r.IUserDataProfilesService),Q(2,h.IEnvironmentService),Q(3,w.ILogService),Q(4,S.IFileService),Q(5,f.IUriIdentityService)],s),e.AbstractInitializer=s}),define(re[243],se([0,1,6,23,9,3,53,26,8,18,15,30,32,72,13,7,22,21,33,28,47,240,108,25]),function(Z,e,k,t,T,L,A,I,b,P,D,E,p,C,h,S,w,d,m,g,f,u,r,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.ExtensionsSynchroniser=void 0;async function i(s,o){const l=JSON.parse(s.content);if(s.version===1||s.version===2){const v=(await o.getInstalled(0)).filter(y=>y.isBuiltin);for(const y of l)s.version===1&&(y.enabled===!1&&(y.disabled=!0),delete y.enabled),s.version===2&&v.every(O=>!(0,p.areSameExtensions)(O.identifier,y.identifier))&&(y.installed=!0)}return l}let a=class vt extends f.AbstractSynchroniser{constructor(o,l,v,y,O,_,F,R,U,M,V,W,z,te,H){super("extensions",l,o,v,y,O,W,z,U,V,H);this.extensionManagementService=_,this.extensionEnablementService=F,this.ignoredExtensionsManagementService=R,this.extensionGalleryService=M,this.extensionStorageService=te,this.version=5,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"extensions.json"),this.baseResource=this.previewResource.with({scheme:n.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:n.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:n.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:n.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(L.Event.any(L.Event.filter(this.extensionManagementService.onDidInstallExtensions,K=>K.some(({local:X})=>!!X)),L.Event.filter(this.extensionManagementService.onDidUninstallExtension,K=>!K.error),this.extensionEnablementService.onDidChangeEnablement,this.extensionStorageService.onDidChangeExtensionStorageToSync)(()=>this.triggerLocalChange()))}async generateSyncPreview(o,l){const v=o.syncData?await i(o.syncData,this.extensionManagementService):null,y=l?.skippedExtensions||[],O=l?.syncData?await i(l.syncData,this.extensionManagementService):null,_=await this.extensionManagementService.getInstalled(void 0),F=this.getLocalExtensions(_),R=this.ignoredExtensionsManagementService.getIgnoredExtensions(_);v?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote extensions with local extensions...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:U,remote:M}=(0,u.merge)(F,v,O,y,R),V={local:U,remote:M,content:this.getPreviewContent(F,U.added,U.updated,U.removed),localChange:U.added.length>0||U.removed.length>0||U.updated.length>0?2:0,remoteChange:M!==null?2:0},W=this.stringify(F,!1);return[{skippedExtensions:y,baseResource:this.baseResource,baseContent:O?this.stringify(O,!1):W,localResource:this.localResource,localContent:W,localExtensions:F,remoteResource:this.remoteResource,remoteContent:v?this.stringify(v,!1):null,previewResource:this.previewResource,previewResult:V,localChange:V.localChange,remoteChange:V.remoteChange,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(o){const l=o.syncData?await i(o.syncData,this.extensionManagementService):null,v=await this.extensionManagementService.getInstalled(void 0),y=this.getLocalExtensions(v),O=this.ignoredExtensionsManagementService.getIgnoredExtensions(v),{remote:_}=(0,u.merge)(y,l,l,o.skippedExtensions||[],O);return _!==null}getPreviewContent(o,l,v,y){const O=[...l,...v],_=new Set,F=R=>{_.add(R.id.toLowerCase()),R.uuid&&_.add(R.uuid)};O.forEach(({identifier:R})=>F(R)),y.forEach(F);for(const R of o)_.has(R.identifier.id.toLowerCase())||R.identifier.uuid&&_.has(R.identifier.uuid)||O.push(R);return this.stringify(O,!1)}async getMergeResult(o,l){return{...o.previewResult,hasConflicts:!1}}async getAcceptResult(o,l,v,y){if(this.extUri.isEqual(l,this.localResource))return this.acceptLocal(o);if(this.extUri.isEqual(l,this.remoteResource))return this.acceptRemote(o);if(this.extUri.isEqual(l,this.previewResource))return o.previewResult;throw new Error(`Invalid Resource: ${l.toString()}`)}async acceptLocal(o){const l=await this.extensionManagementService.getInstalled(),v=this.ignoredExtensionsManagementService.getIgnoredExtensions(l),y=(0,u.merge)(o.localExtensions,null,null,o.skippedExtensions,v),{local:O,remote:_}=y;return{content:o.localContent,local:O,remote:_,localChange:O.added.length>0||O.removed.length>0||O.updated.length>0?2:0,remoteChange:_!==null?2:0}}async acceptRemote(o){const l=await this.extensionManagementService.getInstalled(),v=this.ignoredExtensionsManagementService.getIgnoredExtensions(l),y=o.remoteContent?JSON.parse(o.remoteContent):null;if(y!==null){const O=(0,u.merge)(o.localExtensions,y,o.localExtensions,[],v),{local:_,remote:F}=O;return{content:o.remoteContent,local:_,remote:F,localChange:_.added.length>0||_.removed.length>0||_.updated.length>0?2:0,remoteChange:F!==null?2:0}}else return{content:o.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async applyResult(o,l,v,y){let{skippedExtensions:O,localExtensions:_}=v[0][0];const{local:F,remote:R,localChange:U,remoteChange:M}=v[0][1];if(U===0&&M===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing extensions.`),U!==0&&(await this.backupLocal(JSON.stringify(_)),O=await this.updateLocalExtensions(F.added,F.removed,F.updated,O)),R){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote extensions...`);const V=JSON.stringify(R.all);o=await this.updateRemoteUserData(V,y?null:o.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote extensions.${R.added.length?` Added: ${JSON.stringify(R.added.map(W=>W.identifier.id))}.`:""}${R.updated.length?` Updated: ${JSON.stringify(R.updated.map(W=>W.identifier.id))}.`:""}${R.removed.length?` Removed: ${JSON.stringify(R.removed.map(W=>W.identifier.id))}.`:""}`)}l?.ref!==o.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized extensions...`),await this.updateLastSyncUserData(o,{skippedExtensions:O}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized extensions.${O.length?` Skipped: ${JSON.stringify(O.map(V=>V.identifier.id))}.`:""}`))}async getAssociatedResources({uri:o}){return[{resource:this.extUri.joinPath(o,"extensions.json"),comparableResource:vt.EXTENSIONS_DATA_URI}]}async resolveContent(o){if(this.extUri.isEqual(o,vt.EXTENSIONS_DATA_URI)){const v=await this.extensionManagementService.getInstalled(),y=this.ignoredExtensionsManagementService.getIgnoredExtensions(v),O=this.getLocalExtensions(v).filter(_=>!y.some(F=>(0,p.areSameExtensions)({id:F},_.identifier)));return this.stringify(O,!0)}if(this.extUri.isEqual(this.remoteResource,o)||this.extUri.isEqual(this.baseResource,o)||this.extUri.isEqual(this.localResource,o)||this.extUri.isEqual(this.acceptedResource,o)){const v=await this.resolvePreviewContent(o);return v&&this.stringify(JSON.parse(v),!0)}let l=await super.resolveContent(o);if(l)return l;if(l=await super.resolveContent(this.extUri.dirname(o)),l){const v=this.parseSyncData(l);if(v)switch(this.extUri.basename(o)){case"extensions.json":return this.stringify(this.parseExtensions(v),!0)}}return null}stringify(o,l){return o.sort((v,y)=>!v.identifier.uuid&&y.identifier.uuid?-1:v.identifier.uuid&&!y.identifier.uuid?1:(0,I.compare)(v.identifier.id,y.identifier.id)),l?(0,A.toFormattedString)(o,{}):JSON.stringify(o)}async hasLocalData(){try{const o=await this.extensionManagementService.getInstalled();if(this.getLocalExtensions(o).some(v=>v.installed||v.disabled))return!0}catch{}return!1}async updateLocalExtensions(o,l,v,y){const O=[],_=[],F=await this.extensionManagementService.getInstalled();if(l.length){const U=F.filter(({identifier:M,isBuiltin:V})=>!V&&l.some(W=>(0,p.areSameExtensions)(M,W)));await k.Promises.settled(U.map(async M=>{this.logService.trace(`${this.syncResourceLogLabel}: Uninstalling local extension...`,M.identifier.id),await this.extensionManagementService.uninstall(M,{donotIncludePack:!0,donotCheckDependents:!0}),this.logService.info(`${this.syncResourceLogLabel}: Uninstalled local extension.`,M.identifier.id),O.push(M.identifier)}))}(o.length||v.length)&&await k.Promises.settled([...o,...v].map(async U=>{const M=F.find(W=>(0,p.areSameExtensions)(W.identifier,U.identifier));if(M&&M.isBuiltin){U.state&&M.manifest.version===U.version&&this.updateExtensionState(U.state,M,M.manifest.version),this.extensionEnablementService.getDisabledExtensions().some(z=>(0,p.areSameExtensions)(z,U.identifier))!==!!U.disabled&&(U.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,U.identifier.id),await this.extensionEnablementService.disableExtension(U.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,U.identifier.id)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,U.identifier.id),await this.extensionEnablementService.enableExtension(U.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,U.identifier.id))),O.push(U.identifier);return}const V=(await this.extensionGalleryService.getExtensions([{...U.identifier,preRelease:U.preRelease}],t.CancellationToken.None))[0];if(U.state&&(M?M.manifest.version===U.version:!!V)&&this.updateExtensionState(U.state,M||V,M?.manifest.version),V)try{this.extensionEnablementService.getDisabledExtensions().some(z=>(0,p.areSameExtensions)(z,U.identifier))!==!!U.disabled&&(U.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,U.identifier.id,V.version),await this.extensionEnablementService.disableExtension(V.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,U.identifier.id,V.version)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,U.identifier.id,V.version),await this.extensionEnablementService.enableExtension(V.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,U.identifier.id,V.version))),(!M||M.preRelease!==U.preRelease)&&(await this.extensionManagementService.canInstall(V)?(this.logService.trace(`${this.syncResourceLogLabel}: Installing extension...`,U.identifier.id,V.version),await this.extensionManagementService.installFromGallery(V,{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installPreReleaseVersion:U.preRelease}),this.logService.info(`${this.syncResourceLogLabel}: Installed extension.`,U.identifier.id,V.version),O.push(V.identifier)):(this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because it cannot be installed.`,V.displayName||V.identifier.id),_.push(U)))}catch(W){_.push(U),W instanceof E.ExtensionManagementError&&[E.ExtensionManagementErrorCode.Incompatible,E.ExtensionManagementErrorCode.IncompatiblePreRelease,E.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(W.code)?this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the compatible extension is not found.`,V.displayName||V.identifier.id):(this.logService.error(W),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension`,V.displayName||V.identifier.id))}else _.push(U),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the extension is not found.`,U.identifier.id)}));const R=[];for(const U of y)O.some(M=>(0,p.areSameExtensions)(M,U.identifier))||R.push(U);for(const U of _)R.some(M=>(0,p.areSameExtensions)(M.identifier,U.identifier))||R.push(U);return R}updateExtensionState(o,l,v){const y=this.extensionStorageService.getExtensionState(l,!0)||{},O=v?this.extensionStorageService.getKeysForSync({id:l.identifier.id,version:v}):void 0;O?O.forEach(_=>{y[_]=o[_]}):Object.keys(o).forEach(_=>y[_]=o[_]),this.extensionStorageService.setExtensionState(l,y,!0)}parseExtensions(o){return JSON.parse(o.content)}getLocalExtensions(o){const l=this.extensionEnablementService.getDisabledExtensions();return o.map(v=>{const{identifier:y,isBuiltin:O,manifest:_,preRelease:F}=v,R={identifier:y,preRelease:F,version:_.version};l.some(U=>(0,p.areSameExtensions)(U,y))&&(R.disabled=!0),O||(R.installed=!0);try{const U=this.extensionStorageService.getKeysForSync({id:y.id,version:_.version});if(U){const M=this.extensionStorageService.getExtensionState(v,!0)||{};R.state=Object.keys(M).reduce((V,W)=>(U.includes(W)&&(V[W]=M[W]),V),{})}}catch(U){this.logService.info(`${this.syncResourceLogLabel}: Error while parsing extension state`,(0,T.getErrorMessage)(U))}return R})}};a.EXTENSIONS_DATA_URI=b.URI.from({scheme:n.USER_DATA_SYNC_SCHEME,authority:"extensions",path:"/extensions.json"}),a=me([Q(0,D.IEnvironmentService),Q(1,h.IFileService),Q(2,w.IStorageService),Q(3,n.IUserDataSyncStoreService),Q(4,n.IUserDataSyncBackupStoreService),Q(5,E.IExtensionManagementService),Q(6,E.IGlobalExtensionEnablementService),Q(7,r.IIgnoredExtensionsManagementService),Q(8,n.IUserDataSyncLogService),Q(9,E.IExtensionGalleryService),Q(10,P.IConfigurationService),Q(11,n.IUserDataSyncEnablementService),Q(12,d.ITelemetryService),Q(13,C.IExtensionStorageService),Q(14,m.IUriIdentityService)],a),e.ExtensionsSynchroniser=a;let c=class extends f.AbstractInitializer{constructor(o,l,v,y,O,_,F){super("extensions",y,O,_,v,F);this.extensionManagementService=o,this.ignoredExtensionsManagementService=l}async parseExtensions(o){return o.syncData?await i(o.syncData,this.extensionManagementService):null}generatePreview(o,l){const v=[],y=[],O=[];for(const _ of o){if(this.ignoredExtensionsManagementService.hasToNeverSyncExtension(_.identifier.id))continue;const F=l.find(R=>(0,p.areSameExtensions)(R.identifier,_.identifier));F?(v.push(F),_.disabled&&O.push(_.identifier)):_.installed&&(y.push({..._.identifier,preRelease:!!_.preRelease}),_.disabled&&O.push(_.identifier))}return{installedExtensions:v,newExtensions:y,disabledExtensions:O,remoteExtensions:o}}};c=me([Q(0,E.IExtensionManagementService),Q(1,r.IIgnoredExtensionsManagementService),Q(2,h.IFileService),Q(3,g.IUserDataProfilesService),Q(4,D.IEnvironmentService),Q(5,S.ILogService),Q(6,m.IUriIdentityService)],c),e.AbstractExtensionsInitializer=c}),define(re[244],se([0,1,29,25]),function(Z,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function T(I,b,P,D,E){if(!b)return{remote:Object.keys(I).length>0?I:null,local:{added:{},removed:[],updated:{}}};const p=L(I,b);if(p.added.size===0&&p.removed.size===0&&p.updated.size===0)return{remote:null,local:{added:{},removed:[],updated:{}}};const C=P?L(P,b):{added:Object.keys(b).reduce((m,g)=>(m.add(g),m),new Set),removed:new Set,updated:new Set},h=P?L(P,I):{added:Object.keys(I).reduce((m,g)=>(m.add(g),m),new Set),removed:new Set,updated:new Set},S={added:{},removed:[],updated:{}},w=k.deepClone(b),d=!P;for(const m of h.added.values())m!==t.SYNC_SERVICE_URL_TYPE&&d&&C.added.has(m)||(w[m]=I[m]);for(const m of h.updated.values())w[m]=I[m];for(const m of h.removed.values())D.unregistered.includes(m)||delete w[m];for(const m of C.added.values()){const g=b[m];if(D.machine.includes(m)){E.info(`GlobalState: Skipped adding ${m} in local storage because it is declared as machine scoped.`);continue}if(P&&h.added.has(m))continue;const f=I[m];f&&f.value===g.value||m===t.SYNC_SERVICE_URL_TYPE&&d&&h.added.has(m)||(f?S.updated[m]=g:S.added[m]=g)}for(const m of C.updated.values()){const g=b[m];if(D.machine.includes(m)){E.info(`GlobalState: Skipped updating ${m} in local storage because it is declared as machine scoped.`);continue}if(h.updated.has(m)||h.removed.has(m))continue;const f=I[m];f&&f.value===g.value||(S.updated[m]=g)}for(const m of C.removed.values()){if(D.machine.includes(m)){E.trace(`GlobalState: Skipped removing ${m} in local storage because it is declared as machine scoped.`);continue}h.updated.has(m)||h.removed.has(m)||S.removed.push(m)}return{local:S,remote:A(w,b)?null:w}}e.merge=T;function L(I,b){const P=Object.keys(I),D=Object.keys(b),E=D.filter(h=>P.indexOf(h)===-1).reduce((h,S)=>(h.add(S),h),new Set),p=P.filter(h=>D.indexOf(h)===-1).reduce((h,S)=>(h.add(S),h),new Set),C=new Set;for(const h of P){if(p.has(h))continue;const S=I[h],w=b[h];k.equals(S,w)||C.add(h)}return{added:E,removed:p,updated:C}}function A(I,b){const{added:P,removed:D,updated:E}=L(I,b);return P.size===0&&D.size===0&&E.size===0}}),define(re[245],se([0,1,16,9,3,34,53,4,8,31,18,15,13,7,49,22,21,33,47,59,244,25,28]),function(Z,e,k,t,T,L,A,I,b,P,D,E,p,C,h,S,w,d,m,g,f,u,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.GlobalStateSynchroniser=void 0;const n="globalState.argv.",i=["locale"];function a(v,y){const O=v.storage?Object.keys(v.storage).sort():[],_={};return O.forEach(F=>_[F]=v.storage[F]),v.storage=_,y?(0,A.toFormattedString)(v,{}):JSON.stringify(v)}const c=1;let s=class pt extends m.AbstractSynchroniser{constructor(y,O,_,F,R,U,M,V,W,z){super("globalState",y,R,W,O,_,U,M,F,V,z);this.storageService=W,this.version=c,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"globalState.json"),this.baseResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(y.watch(this.extUri.dirname(this.environmentService.argvResource))),this._register(T.Event.any(T.Event.filter(y.onDidFilesChange,te=>te.contains(this.environmentService.argvResource)),T.Event.filter(W.onDidChangeValue,te=>te.scope===0&&te.target!==void 0?te.target===0:W.keys(0,0).includes(te.key)),this.storageService.onDidChangeTarget)(()=>this.triggerLocalChange()))}async generateSyncPreview(y,O,_){const F=y.syncData?JSON.parse(y.syncData.content):null;O=O===null&&_?y:O;const R=O&&O.syncData?JSON.parse(O.syncData.content):null,U=await this.getLocalGlobalState();F?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote ui state with local ui state...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const M=this.getStorageKeys(R),{local:V,remote:W}=(0,f.merge)(U.storage,F?F.storage:null,R?R.storage:null,M,this.logService),z={content:null,local:V,remote:W,localChange:Object.keys(V.added).length>0||Object.keys(V.updated).length>0||V.removed.length>0?2:0,remoteChange:W!==null?2:0},te=a(U,!1);return[{baseResource:this.baseResource,baseContent:R?a(R,!1):te,localResource:this.localResource,localContent:te,localUserData:U,remoteResource:this.remoteResource,remoteContent:F?a(F,!1):null,previewResource:this.previewResource,previewResult:z,localChange:z.localChange,remoteChange:z.remoteChange,acceptedResource:this.acceptedResource,storageKeys:M}]}async hasRemoteChanged(y){const O=y.syncData?JSON.parse(y.syncData.content):null;if(O===null)return!0;const _=await this.getLocalGlobalState(),F=this.getStorageKeys(O),{remote:R}=(0,f.merge)(_.storage,O.storage,O.storage,F,this.logService);return R!==null}async getMergeResult(y,O){return{...y.previewResult,hasConflicts:!1}}async getAcceptResult(y,O,_,F){if(this.extUri.isEqual(O,this.localResource))return this.acceptLocal(y);if(this.extUri.isEqual(O,this.remoteResource))return this.acceptRemote(y);if(this.extUri.isEqual(O,this.previewResource))return y.previewResult;throw new Error(`Invalid Resource: ${O.toString()}`)}async acceptLocal(y){return{content:y.localContent,local:{added:{},removed:[],updated:{}},remote:y.localUserData.storage,localChange:0,remoteChange:2}}async acceptRemote(y){if(y.remoteContent!==null){const O=JSON.parse(y.remoteContent),{local:_,remote:F}=(0,f.merge)(y.localUserData.storage,O.storage,null,y.storageKeys,this.logService);return{content:y.remoteContent,local:_,remote:F,localChange:Object.keys(_.added).length>0||Object.keys(_.updated).length>0||_.removed.length>0?2:0,remoteChange:F!==null?2:0}}else return{content:y.remoteContent,local:{added:{},removed:[],updated:{}},remote:null,localChange:0,remoteChange:0}}async applyResult(y,O,_,F){const{localUserData:R}=_[0][0],{local:U,remote:M,localChange:V,remoteChange:W}=_[0][1];if(V===0&&W===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing ui state.`),V!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local ui state...`),await this.backupLocal(JSON.stringify(R)),await this.writeLocalGlobalState(U),this.logService.info(`${this.syncResourceLogLabel}: Updated local ui state`)),W!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote ui state...`);const z=JSON.stringify({storage:M});y=await this.updateRemoteUserData(z,F?null:y.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote ui state`)}O?.ref!==y.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized ui state...`),await this.updateLastSyncUserData(y),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized ui state`))}async getAssociatedResources({uri:y}){return[{resource:this.extUri.joinPath(y,"globalState.json"),comparableResource:pt.GLOBAL_STATE_DATA_URI}]}async resolveContent(y){if(this.extUri.isEqual(y,pt.GLOBAL_STATE_DATA_URI)){const _=await this.getLocalGlobalState();return a(_,!0)}if(this.extUri.isEqual(this.remoteResource,y)||this.extUri.isEqual(this.baseResource,y)||this.extUri.isEqual(this.localResource,y)||this.extUri.isEqual(this.acceptedResource,y)){const _=await this.resolvePreviewContent(y);return _&&a(JSON.parse(_),!0)}let O=await super.resolveContent(y);if(O)return O;if(O=await super.resolveContent(this.extUri.dirname(y)),O){const _=this.parseSyncData(O);if(_)switch(this.extUri.basename(y)){case"globalState.json":return a(JSON.parse(_.content),!0)}}return null}async hasLocalData(){try{const{storage:y}=await this.getLocalGlobalState();if(Object.keys(y).length>1||y[`${n}.locale`]?.value!=="en")return!0}catch{}return!1}async getLocalGlobalState(){const y={},O=await this.getLocalArgvContent(),_=(0,L.parse)(O);for(const F of i)_[F]!==void 0&&(y[`${n}${F}`]={version:1,value:_[F]});for(const F of this.storageService.keys(0,0)){const R=this.storageService.get(F,0);R&&(y[F]={version:1,value:R})}return{storage:y}}async getLocalArgvContent(){try{this.logService.debug("GlobalStateSync#getLocalArgvContent",this.environmentService.argvResource);const y=await this.fileService.readFile(this.environmentService.argvResource);return this.logService.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.environmentService.argvResource),y.value.toString()}catch(y){this.logService.debug((0,t.getErrorMessage)(y))}return"{}"}async writeLocalGlobalState({added:y,removed:O,updated:_}){const F={},R={},U=(V,W)=>{for(const z of V){if(z.startsWith(n)){F[z.substring(n.length)]=W?W[z].value:void 0;continue}if(W){const te=W[z];te.value!==String(this.storageService.get(z,0))&&(R[z]=te.value)}else this.storageService.get(z,0)!==void 0&&(R[z]=void 0)}};if(U(Object.keys(y),y),U(Object.keys(_),_),U(O),Object.keys(F).length&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.updateArgv(F),this.logService.info(`${this.syncResourceLogLabel}: Updated locale`)),Object.keys(R).length){this.logService.trace(`${this.syncResourceLogLabel}: Updating global state...`);for(const V of Object.keys(R))this.storageService.store(V,R[V],0,0);this.logService.info(`${this.syncResourceLogLabel}: Updated global state`,Object.keys(R))}}async updateArgv(y){const O=await this.getLocalArgvContent();let _=O;for(const F of Object.keys(y))_=(0,g.edit)(_,[F],y[F],{});O!==_&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.fileService.writeFile(this.environmentService.argvResource,k.VSBuffer.fromString(_)),this.logService.info(`${this.syncResourceLogLabel}: Updated locale.`))}getStorageKeys(y){const O=this.storageService.keys(0,0),_=this.storageService.keys(0,1),F=[...O,..._],R=y?.storage?Object.keys(y.storage).filter(U=>!U.startsWith(n)&&!F.includes(U)&&this.storageService.get(U,0)!==void 0):[];if(!I.isWeb){const U=[...u.ALL_SYNC_RESOURCES.map(M=>(0,u.getEnablementKey)(M)),u.SYNC_SERVICE_URL_TYPE];R.push(...U),_.push(...U)}return{user:O,machine:_,unregistered:R}}};s.GLOBAL_STATE_DATA_URI=b.URI.from({scheme:u.USER_DATA_SYNC_SCHEME,authority:"globalState",path:"/globalState.json"}),s=me([Q(0,p.IFileService),Q(1,u.IUserDataSyncStoreService),Q(2,u.IUserDataSyncBackupStoreService),Q(3,u.IUserDataSyncLogService),Q(4,E.IEnvironmentService),Q(5,u.IUserDataSyncEnablementService),Q(6,w.ITelemetryService),Q(7,D.IConfigurationService),Q(8,S.IStorageService),Q(9,d.IUriIdentityService)],s),e.GlobalStateSynchroniser=s;let o=class extends m.AbstractInitializer{constructor(y,O,_,F,R,U){super("globalState",_,F,R,O,U);this.storageService=y}async doInitialize(y){const O=y.syncData?JSON.parse(y.syncData.content):null;if(!O){this.logService.info("Skipping initializing global state because remote global state does not exist.");return}const _={},F={};for(const R of Object.keys(O.storage))R.startsWith(n)?_[R.substring(n.length)]=O.storage[R].value:this.storageService.get(R,0)===void 0&&(F[R]=O.storage[R].value);if(Object.keys(_).length){let R="{}";try{R=(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch{}for(const U of Object.keys(_))R=(0,g.edit)(R,[U],_[U],{});await this.fileService.writeFile(this.environmentService.argvResource,k.VSBuffer.fromString(R))}if(Object.keys(F).length)for(const R of Object.keys(F))this.storageService.store(R,F[R],0,0)}};o=me([Q(0,S.IStorageService),Q(1,p.IFileService),Q(2,r.IUserDataProfilesService),Q(3,E.IEnvironmentService),Q(4,u.IUserDataSyncLogService),Q(5,d.IUriIdentityService)],o),e.GlobalStateInitializer=o;let l=class{constructor(y,O,_,F,R){this.userDataSyncStoreClient=y,this.storageService=O,this.environmentService=_,this.fileService=F,this.logService=R}getSyncStoreType(y){return this.parseGlobalState(y)?.storage[u.SYNC_SERVICE_URL_TYPE]?.value}async sync(y){const O=(0,u.createSyncHeaders)((0,P.generateUuid)());try{return await this.doSync(y,O)}catch(_){if(_ instanceof u.UserDataSyncError)switch(_.code){case"PreconditionFailed":return this.logService.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.doSync(y,O)}throw _}}async doSync(y,O){const _=await this.userDataSyncStoreClient.read("globalState",null,O),F=this.parseGlobalState(_)||{storage:{}};F.storage[u.SYNC_SERVICE_URL_TYPE]={value:y,version:c};const R=await(0,h.getServiceMachineId)(this.environmentService,this.fileService,this.storageService),U={version:c,machineId:R,content:a(F,!1)};await this.userDataSyncStoreClient.write("globalState",JSON.stringify(U),_.ref,O)}parseGlobalState({content:y}){if(!y)return null;const O=JSON.parse(y);if((0,m.isSyncData)(O))return O?JSON.parse(O.content):null;throw new Error("Invalid remote data")}};l=me([Q(1,S.IStorageService),Q(2,E.IEnvironmentService),Q(3,p.IFileService),Q(4,C.ILogService)],l),e.UserDataSyncStoreTypeSynchronizer=l}),define(re[246],se([0,1,17,16,3,34,4,14,160,18,15,13,22,21,33,28,47,241,25]),function(Z,e,k,t,T,L,A,I,b,P,D,E,p,C,h,S,w,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function g(r,n,i){try{const a=JSON.parse(r);if(!n)return(0,I.isUndefined)(a.all)?null:a.all;switch(A.OS){case 2:return(0,I.isUndefined)(a.mac)?null:a.mac;case 3:return(0,I.isUndefined)(a.linux)?null:a.linux;case 1:return(0,I.isUndefined)(a.windows)?null:a.windows}}catch(a){return i.error(a),null}}e.getKeybindingsContentFromSyncContent=g;let f=class extends w.AbstractJsonFileSynchroniser{constructor(n,i,a,c,s,o,l,v,y,O,_,F){super(l.defaultProfile.keybindingsResource,"keybindings",o,v,y,n,i,s,_,a,O,c,F);this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"keybindings.json"),this.baseResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(T.Event.filter(c.onDidChangeConfiguration,R=>R.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async generateSyncPreview(n,i,a,c){const s=n.syncData?g(n.syncData.content,c.keybindingsPerPlatform??this.syncKeybindingsPerPlatform(),this.logService):null;i=i===null&&a?n:i;const o=i?this.getKeybindingsContentFromLastSyncUserData(i):null,l=await this.getLocalFileContent(),v=await this.getFormattingOptions();let y=null,O=!1,_=!1,F=!1;if(s){let M=l?l.value.toString():"[]";if(M=M||"[]",this.hasErrors(M,!0))throw new m.UserDataSyncError((0,b.localize)(0,null),"LocalInvalidContent",this.resource);if(!o||o!==M||o!==s){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote keybindings with local keybindings...`);const V=await(0,d.merge)(M,s,o,v,this.userDataSyncUtilService);V.hasChanges&&(y=V.mergeContent,F=V.hasConflicts,O=F||V.mergeContent!==M,_=F||V.mergeContent!==s)}}else l&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),y=l.value.toString(),_=!0);const R={content:y,localChange:O?l?2:1:0,remoteChange:_?2:0,hasConflicts:F},U=l?l.value.toString():null;return[{fileContent:l,baseResource:this.baseResource,baseContent:o!==null?o:U,localResource:this.localResource,localContent:U,localChange:R.localChange,remoteResource:this.remoteResource,remoteContent:s,remoteChange:R.remoteChange,previewResource:this.previewResource,previewResult:R,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(n){const i=this.getKeybindingsContentFromLastSyncUserData(n);if(i===null)return!0;const a=await this.getLocalFileContent(),c=a?a.value.toString():"",s=await this.getFormattingOptions(),o=await(0,d.merge)(c||"[]",i,i,s,this.userDataSyncUtilService);return o.hasConflicts||o.mergeContent!==i}async getMergeResult(n,i){return n.previewResult}async getAcceptResult(n,i,a,c){if(this.extUri.isEqual(i,this.localResource))return{content:n.fileContent?n.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(i,this.remoteResource))return{content:n.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(i,this.previewResource))return a===void 0?{content:n.previewResult.content,localChange:n.previewResult.localChange,remoteChange:n.previewResult.remoteChange}:{content:a,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${i.toString()}`)}async applyResult(n,i,a,c){const{fileContent:s}=a[0][0];let{content:o,localChange:l,remoteChange:v}=a[0][1];if(l===0&&v===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing keybindings.`),o!==null&&(o=o.trim(),o=o||"[]",this.hasErrors(o,!0)))throw new m.UserDataSyncError((0,b.localize)(1,null),"LocalInvalidContent",this.resource);if(l!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local keybindings...`),s&&await this.backupLocal(this.toSyncContent(s.value.toString())),await this.updateLocalFileContent(o||"[]",s,c),this.logService.info(`${this.syncResourceLogLabel}: Updated local keybindings`)),v!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote keybindings...`);const y=this.toSyncContent(o||"[]",n.syncData?.content);n=await this.updateRemoteUserData(y,c?null:n.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote keybindings`)}try{await this.fileService.del(this.previewResource)}catch{}i?.ref!==n.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized keybindings...`),await this.updateLastSyncUserData(n,{platformSpecific:this.syncKeybindingsPerPlatform()}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized keybindings`))}async hasLocalData(){try{const n=await this.getLocalFileContent();if(n){const i=(0,L.parse)(n.value.toString());if((0,k.isNonEmptyArray)(i))return!0}}catch(n){if(n.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:n}){const i=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(n,"keybindings.json"),comparableResource:i}]}async resolveContent(n){if(this.extUri.isEqual(this.remoteResource,n)||this.extUri.isEqual(this.baseResource,n)||this.extUri.isEqual(this.localResource,n)||this.extUri.isEqual(this.acceptedResource,n))return this.resolvePreviewContent(n);let i=await super.resolveContent(n);if(i)return i;if(i=await super.resolveContent(this.extUri.dirname(n)),i){const a=this.parseSyncData(i);if(a)switch(this.extUri.basename(n)){case"keybindings.json":return g(a.content,this.syncKeybindingsPerPlatform(),this.logService)}}return null}getKeybindingsContentFromLastSyncUserData(n){return!n.syncData||n.platformSpecific!==void 0&&n.platformSpecific!==this.syncKeybindingsPerPlatform()?null:g(n.syncData.content,this.syncKeybindingsPerPlatform(),this.logService)}toSyncContent(n,i){let a={};try{a=JSON.parse(i||"{}")}catch(c){this.logService.error(c)}switch(this.syncKeybindingsPerPlatform()?delete a.all:a.all=n,A.OS){case 2:a.mac=n;break;case 3:a.linux=n;break;case 1:a.windows=n;break}return JSON.stringify(a)}syncKeybindingsPerPlatform(){return!!this.configurationService.getValue("settingsSync.keybindingsPerPlatform")}};f=me([Q(0,m.IUserDataSyncStoreService),Q(1,m.IUserDataSyncBackupStoreService),Q(2,m.IUserDataSyncLogService),Q(3,P.IConfigurationService),Q(4,m.IUserDataSyncEnablementService),Q(5,E.IFileService),Q(6,S.IUserDataProfilesService),Q(7,D.IEnvironmentService),Q(8,p.IStorageService),Q(9,m.IUserDataSyncUtilService),Q(10,C.ITelemetryService),Q(11,h.IUriIdentityService)],f),e.KeybindingsSynchroniser=f;let u=class extends w.AbstractInitializer{constructor(n,i,a,c,s){super("keybindings",i,a,c,n,s)}async doInitialize(n){const i=n.syncData?this.getKeybindingsContentFromSyncContent(n.syncData.content):null;if(!i){this.logService.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing keybindings because local keybindings exist.");return}await this.fileService.writeFile(this.userDataProfilesService.defaultProfile.keybindingsResource,t.VSBuffer.fromString(i)),await this.updateLastSyncUserData(n)}async isEmpty(){try{const n=await this.fileService.readFile(this.userDataProfilesService.defaultProfile.settingsResource),i=(0,L.parse)(n.value.toString());return!(0,k.isNonEmptyArray)(i)}catch(n){return n.fileOperationResult===1}}getKeybindingsContentFromSyncContent(n){try{return g(n,!0,this.logService)}catch(i){return this.logService.error(i),null}}};u=me([Q(0,E.IFileService),Q(1,S.IUserDataProfilesService),Q(2,D.IEnvironmentService),Q(3,m.IUserDataSyncLogService),Q(4,h.IUriIdentityService)],u),e.KeybindingsInitializer=u}),define(re[247],se([0,1,17,34,77,53,29,59,25]),function(Z,e,k,t,T,L,A,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.areSame=e.merge=e.updateIgnoredSettings=e.removeComments=e.getIgnoredSettings=void 0;function P(o,l,v){let y=[];v?y=E(v):y=D(l);const O=[],_=[...(0,b.getDisallowedIgnoredSettings)()];if(Array.isArray(y))for(const F of y)F.startsWith("-")?_.push(F.substring(1)):O.push(F);return(0,k.distinct)([...o,...O].filter(F=>_.indexOf(F)===-1))}e.getIgnoredSettings=P;function D(o){let l=o.inspect("settingsSync.ignoredSettings").userValue;return l!==void 0||(l=o.inspect("sync.ignoredSettings").userValue,l!==void 0)?l:o.getValue("settingsSync.ignoredSettings")||[]}function E(o){const l=(0,t.parse)(o);return l?l["settingsSync.ignoredSettings"]||l["sync.ignoredSettings"]||[]:[]}function p(o,l){const v=(0,t.parse)(o)||{};let y="{}";for(const O of Object.keys(v)){const _=(0,T.setProperty)(y,[O],v[O],l);y=(0,T.applyEdits)(y,_)}return y}e.removeComments=p;function C(o,l,v,y){if(v.length){const O=s(l),_=(0,t.parse)(l)||{},F=(0,t.parse)(o);if(!F)return o;const R=[];for(const U of v){const M=_[U],V=F[U];M===void 0?o=I.edit(o,[U],void 0,y):V!==void 0?o=I.edit(o,[U],M,y):R.push(r(U,O))}R.sort((U,M)=>U.startOffset-M.startOffset),R.forEach(U=>o=m(U.setting.key,l,o,y))}return o}e.updateIgnoredSettings=C;function h(o,l,v,y,O,_){const F=C(o,l,y,_),R=v!==F,U=v!==l;if(!R&&!U)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(R&&!U)return{conflictsSettings:[],localContent:null,remoteContent:F,hasConflicts:!1};if(U&&!R)return{conflictsSettings:[],localContent:C(l,o,y,_),remoteContent:null,hasConflicts:!1};if(v===null&&w(o)){const G=S(o,l,y)?null:C(l,o,y,_);return{conflictsSettings:[],localContent:G,remoteContent:null,hasConflicts:!1}}let M=o,V=l;const W=(0,t.parse)(o),z=(0,t.parse)(l),te=v?(0,t.parse)(v):null,H=y.reduce((G,q)=>(G.add(q),G),new Set),K=d(W,z,H),X=d(te,W,H),Y=d(te,z,H),x=new Map,B=new Set,J=G=>{B.add(G);const q=O.filter(({key:ee})=>ee===G)[0];q?(M=I.edit(M,[G],q.value,_),V=I.edit(V,[G],q.value,_)):x.set(G,{key:G,localValue:W[G],remoteValue:z[G]})};for(const G of X.removed.values())Y.updated.has(G)?J(G):V=I.edit(V,[G],void 0,_);for(const G of Y.removed.values())B.has(G)||(X.updated.has(G)?J(G):M=I.edit(M,[G],void 0,_));for(const G of X.updated.values())B.has(G)||(Y.updated.has(G)?K.updated.has(G)&&J(G):V=I.edit(V,[G],W[G],_));for(const G of Y.updated.values())B.has(G)||(X.updated.has(G)?K.updated.has(G)&&J(G):M=I.edit(M,[G],z[G],_));for(const G of X.added.values())B.has(G)||(Y.added.has(G)?K.updated.has(G)&&J(G):V=m(G,M,V,_));for(const G of Y.added.values())B.has(G)||(X.added.has(G)?K.updated.has(G)&&J(G):M=m(G,V,M,_));const N=x.size>0||!S(M,V,y),$=N||!S(M,o,[]),j=N||!S(V,l,[]);return{localContent:$?M:null,remoteContent:j?V:null,conflictsSettings:[...x.values()],hasConflicts:N}}e.merge=h;function S(o,l,v){if(o===l)return!0;const y=(0,t.parse)(o),O=(0,t.parse)(l),_=v.reduce((U,M)=>(U.add(M),U),new Set),F=s(o).filter(U=>!(U.setting&&_.has(U.setting.key))),R=s(l).filter(U=>!(U.setting&&_.has(U.setting.key)));if(F.length!==R.length)return!1;for(let U=0;U<F.length;U++){const M=F[U],V=R[U];if(M.setting&&V.setting){if(M.setting.key!==V.setting.key||!A.equals(y[M.setting.key],O[M.setting.key]))return!1}else if(!M.setting&&!V.setting){if(M.value!==V.value)return!1}else return!1}return!0}e.areSame=S;function w(o){return o?s(o).length===0:!0}e.isEmpty=w;function d(o,l,v){const y=o?Object.keys(o).filter(U=>!v.has(U)):[],O=Object.keys(l).filter(U=>!v.has(U)),_=O.filter(U=>y.indexOf(U)===-1).reduce((U,M)=>(U.add(M),U),new Set),F=y.filter(U=>O.indexOf(U)===-1).reduce((U,M)=>(U.add(M),U),new Set),R=new Set;if(o)for(const U of y){if(F.has(U))continue;const M=o[U],V=l[U];A.equals(M,V)||R.add(U)}return{added:_,removed:F,updated:R}}function m(o,l,v,y){const O=(0,t.parse)(l),_=s(l),F=s(v),R=g(o,_,F);return f(v,o,O[o],R,F,y)}e.addSetting=m;function g(o,l,v){const y=l.findIndex(_=>_.setting?.key===o),O=l[y-1];if(O){if(O.setting){const F=r(O.setting.key,v);if(F)return{index:v.indexOf(F),insertAfter:!0}}else{const F=n(y,l);if(F){const R=r(F.setting.key,v);if(R){const U=i(v.indexOf(R),v),M=a(l,F,l[y]);if(U){const V=a(v,R,U),W=c(M,V);return W?{index:v.indexOf(W),insertAfter:!0}:{index:v.indexOf(U),insertAfter:!1}}else{const V=a(v,R,v[v.length-1]),W=c(M,V);return W?{index:v.indexOf(W),insertAfter:!0}:{index:v.length-1,insertAfter:!0}}}}}const _=l[y+1];if(_)if(_.setting){const F=r(_.setting.key,v);if(F)return{index:v.indexOf(F),insertAfter:!1}}else{const F=i(y,l);if(F){const R=r(F.setting.key,v);if(R){const U=n(v.indexOf(R),v),M=a(l,l[y],F);if(U){const V=a(v,U,R),W=c(M.reverse(),V.reverse());return W?{index:v.indexOf(W),insertAfter:!1}:{index:v.indexOf(U),insertAfter:!0}}else{const V=a(v,v[0],R),W=c(M.reverse(),V.reverse());return W?{index:v.indexOf(W),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:v.length-1,insertAfter:!0}}function f(o,l,v,y,O,_){let F;return y.index===-1?F=(0,T.setProperty)(o,[l],v,_):F=u(o,l,v,y,O,_).map(R=>(0,T.withFormatting)(o,R,_)[0]),(0,T.applyEdits)(o,F)}function u(o,l,v,y,O,_){const F=`${JSON.stringify(l)}: ${JSON.stringify(v)}`,R=(0,L.getEOL)(_,o),U=O[y.index];if(y.insertAfter){const M=[];if(U.setting)M.push({offset:U.endOffset,length:0,content:","+F});else{const V=i(y.index,O),W=n(y.index,O),z=W?.setting?.commaOffset;W&&z===void 0&&M.push({offset:W.endOffset,length:0,content:","});const te=z!==void 0&&z>U.endOffset;M.push({offset:te?z+1:U.endOffset,length:0,content:V?R+F+",":R+F})}return M}else{if(U.setting)return[{offset:U.startOffset,length:0,content:F+","}];const M=(O[y.index-1]&&!O[y.index-1].setting?R:"")+F+(i(y.index,O)?",":"")+R;return[{offset:U.startOffset,length:0,content:M}]}}function r(o,l){return l.filter(v=>v.setting?.key===o)[0]}function n(o,l){for(let v=o-1;v>=0;v--)if(l[v].setting)return l[v]}function i(o,l){for(let v=o+1;v<l.length;v++)if(l[v].setting)return l[v]}function a(o,l,v){const y=o.indexOf(l),O=o.indexOf(v);return o.filter((_,F)=>y<F&&F<O)}function c(o,l){if(o.length&&l.length){let v=0;for(;v<l.length&&v<o.length;v++)if(o[v].value!==l[v].value)return l[v-1];return l[v-1]}}function s(o){const l=[];let v=-1,y,O;const _={onObjectBegin:F=>{v++},onObjectProperty:(F,R,U)=>{v===0&&(y=R,O=F)},onObjectEnd:(F,R)=>{v--,v===0&&l.push({startOffset:y,endOffset:F+R,value:o.substring(y,F+R),setting:{key:O,commaOffset:void 0}})},onArrayBegin:(F,R)=>{v++},onArrayEnd:(F,R)=>{v--,v===0&&l.push({startOffset:y,endOffset:F+R,value:o.substring(y,F+R),setting:{key:O,commaOffset:void 0}})},onLiteralValue:(F,R,U)=>{v===0&&l.push({startOffset:y,endOffset:R+U,value:o.substring(y,R+U),setting:{key:O,commaOffset:void 0}})},onSeparator:(F,R,U)=>{if(v===0&&F===","){let M=l.length-1;for(;M>=0&&!l[M].setting;M--);const V=l[M];V&&l.splice(M,1,{startOffset:V.startOffset,endOffset:V.endOffset,value:V.value,setting:{key:V.setting.key,commaOffset:R}})}},onComment:(F,R)=>{v===0&&l.push({startOffset:F,endOffset:F+R,value:o.substring(F,F+R)})}};return(0,t.visit)(o,_),l}}),define(re[248],se([0,1,16,3,161,18,69,15,30,13,22,21,33,28,47,59,247,25]),function(Z,e,k,t,T,L,A,I,b,P,D,E,p,C,h,S,w,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function m(r){return r&&r.settings&&typeof r.settings=="string"&&Object.keys(r).length===1}function g(r){const n=JSON.parse(r);return m(n)?n:{settings:r}}e.parseSettingsSyncContent=g;let f=class extends h.AbstractJsonFileSynchroniser{constructor(n,i,a,c,s,o,l,v,y,O,_,F,R){super(i.defaultProfile.settingsResource,"settings",n,a,c,s,o,O,_,l,v,y,R);this.extensionManagementService=F,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"settings.json"),this.baseResource=this.previewResource.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._defaultIgnoredSettings=void 0}async getRemoteUserDataSyncConfiguration(n){const i=await this.getLastSyncUserData(),a=await this.getLatestRemoteUserData(n,i),c=this.getSettingsSyncContent(a),s=new A.ConfigurationModelParser(d.USER_DATA_SYNC_CONFIGURATION_SCOPE);return c?.settings&&s.parse(c.settings),s.configurationModel.getValue(d.USER_DATA_SYNC_CONFIGURATION_SCOPE)||{}}async generateSyncPreview(n,i,a){const c=await this.getLocalFileContent(),s=await this.getFormattingOptions(),o=this.getSettingsSyncContent(n);i=i===null&&a?n:i;const l=i?this.getSettingsSyncContent(i):null,v=await this.getIgnoredSettings();let y=null,O=!1,_=!1,F=!1;if(o){let M=c?c.value.toString().trim():"{}";M=M||"{}",this.validateContent(M),this.logService.trace(`${this.syncResourceLogLabel}: Merging remote settings with local settings...`);const V=(0,w.merge)(M,o.settings,l?l.settings:null,v,[],s);y=V.localContent||V.remoteContent,O=V.localContent!==null,_=V.remoteContent!==null,F=V.hasConflicts}else c&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote settings does not exist. Synchronizing settings for the first time.`),y=c.value.toString().trim()||"{}",this.validateContent(y),_=!0);const R={content:y,localChange:O?2:0,remoteChange:_?2:0,hasConflicts:F},U=c?c.value.toString():null;return[{fileContent:c,baseResource:this.baseResource,baseContent:l?l.settings:U,localResource:this.localResource,localContent:U,localChange:R.localChange,remoteResource:this.remoteResource,remoteContent:o?o.settings:null,remoteChange:R.remoteChange,previewResource:this.previewResource,previewResult:R,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(n){const i=this.getSettingsSyncContent(n);if(i===null)return!0;const a=await this.getLocalFileContent(),c=a?a.value.toString().trim():"",s=await this.getIgnoredSettings(),o=await this.getFormattingOptions();return(0,w.merge)(c||"{}",i.settings,i.settings,s,[],o).remoteContent!==null}async getMergeResult(n,i){const a=await this.getFormattingOptions(),c=await this.getIgnoredSettings();return{...n.previewResult,content:n.previewResult.content?(0,w.updateIgnoredSettings)(n.previewResult.content,"{}",c,a):null}}async getAcceptResult(n,i,a,c){const s=await this.getFormattingOptions(),o=await this.getIgnoredSettings();if(this.extUri.isEqual(i,this.localResource))return{content:n.fileContent?(0,w.updateIgnoredSettings)(n.fileContent.value.toString(),"{}",o,s):null,localChange:0,remoteChange:2};if(this.extUri.isEqual(i,this.remoteResource))return{content:n.remoteContent!==null?(0,w.updateIgnoredSettings)(n.remoteContent,n.fileContent?n.fileContent.value.toString():"{}",o,s):null,localChange:2,remoteChange:0};if(this.extUri.isEqual(i,this.previewResource))return a===void 0?{content:n.previewResult.content,localChange:n.previewResult.localChange,remoteChange:n.previewResult.remoteChange}:{content:a!==null?(0,w.updateIgnoredSettings)(a,n.fileContent?n.fileContent.value.toString():"{}",o,s):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${i.toString()}`)}async applyResult(n,i,a,c){const{fileContent:s}=a[0][0];let{content:o,localChange:l,remoteChange:v}=a[0][1];if(l===0&&v===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing settings.`),o=o?o.trim():"{}",o=o||"{}",this.validateContent(o),l!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local settings...`),s&&await this.backupLocal(JSON.stringify(this.toSettingsSyncContent(s.value.toString()))),await this.updateLocalFileContent(o,s,c),await this.configurationService.reloadConfiguration(2),this.logService.info(`${this.syncResourceLogLabel}: Updated local settings`)),v!==0){const y=await this.getFormattingOptions(),O=this.getSettingsSyncContent(n),_=await this.getIgnoredSettings(o);o=(0,w.updateIgnoredSettings)(o,O?O.settings:"{}",_,y),this.logService.trace(`${this.syncResourceLogLabel}: Updating remote settings...`),n=await this.updateRemoteUserData(JSON.stringify(this.toSettingsSyncContent(o)),c?null:n.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote settings`)}try{await this.fileService.del(this.previewResource)}catch{}i?.ref!==n.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized settings...`),await this.updateLastSyncUserData(n),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized settings`))}async hasLocalData(){try{const n=await this.getLocalFileContent();if(n){const i=await this.getFormattingOptions(),a=(0,S.edit)(n.value.toString(),[d.CONFIGURATION_SYNC_STORE_KEY],void 0,i);return!(0,w.isEmpty)(a)}}catch(n){if(n.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:n}){const i=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(n,"settings.json"),comparableResource:i}]}async resolveContent(n){if(this.extUri.isEqual(this.remoteResource,n)||this.extUri.isEqual(this.localResource,n)||this.extUri.isEqual(this.acceptedResource,n)||this.extUri.isEqual(this.baseResource,n))return this.resolvePreviewContent(n);let i=await super.resolveContent(n);if(i)return i;if(i=await super.resolveContent(this.extUri.dirname(n)),i){const a=this.parseSyncData(i);if(a){const c=this.parseSettingsSyncContent(a.content);if(c)switch(this.extUri.basename(n)){case"settings.json":return c.settings}}}return null}async resolvePreviewContent(n){let i=await super.resolvePreviewContent(n);if(i){const a=await this.getFormattingOptions(),c=await this.getIgnoredSettings();i=(0,w.updateIgnoredSettings)(i,"{}",c,a)}return i}getSettingsSyncContent(n){return n.syncData?this.parseSettingsSyncContent(n.syncData.content):null}parseSettingsSyncContent(n){try{return g(n)}catch(i){this.logService.error(i)}return null}toSettingsSyncContent(n){return{settings:n}}async getIgnoredSettings(n){if(!this._defaultIgnoredSettings){this._defaultIgnoredSettings=this.userDataSyncUtilService.resolveDefaultIgnoredSettings();const a=t.Event.any(t.Event.filter(this.extensionManagementService.onDidInstallExtensions,c=>c.some(({local:s})=>!!s)),t.Event.filter(this.extensionManagementService.onDidUninstallExtension,c=>!c.error))(()=>{a.dispose(),this._defaultIgnoredSettings=void 0})}const i=await this._defaultIgnoredSettings;return(0,w.getIgnoredSettings)(i,this.configurationService,n)}validateContent(n){if(this.hasErrors(n,!1))throw new d.UserDataSyncError((0,T.localize)(0,null),"LocalInvalidContent",this.resource)}};f=me([Q(0,P.IFileService),Q(1,C.IUserDataProfilesService),Q(2,I.IEnvironmentService),Q(3,D.IStorageService),Q(4,d.IUserDataSyncStoreService),Q(5,d.IUserDataSyncBackupStoreService),Q(6,d.IUserDataSyncLogService),Q(7,d.IUserDataSyncUtilService),Q(8,L.IConfigurationService),Q(9,d.IUserDataSyncEnablementService),Q(10,E.ITelemetryService),Q(11,b.IExtensionManagementService),Q(12,p.IUriIdentityService)],f),e.SettingsSynchroniser=f;let u=class extends h.AbstractInitializer{constructor(n,i,a,c,s){super("settings",i,a,c,n,s)}async doInitialize(n){const i=n.syncData?this.parseSettingsSyncContent(n.syncData.content):null;if(!i){this.logService.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing settings because local settings exist.");return}await this.fileService.writeFile(this.userDataProfilesService.defaultProfile.settingsResource,k.VSBuffer.fromString(i.settings)),await this.updateLastSyncUserData(n)}async isEmpty(){try{const n=await this.fileService.readFile(this.userDataProfilesService.defaultProfile.settingsResource);return(0,w.isEmpty)(n.value.toString().trim())}catch(n){return n.fileOperationResult===1}}parseSettingsSyncContent(n){try{return g(n)}catch(i){this.logService.error(i)}return null}};u=me([Q(0,P.IFileService),Q(1,C.IUserDataProfilesService),Q(2,I.IEnvironmentService),Q(3,d.IUserDataSyncLogService),Q(4,p.IUriIdentityService)],u),e.SettingsInitializer=u}),define(re[249],se([0,1,16,3,29,18,15,13,22,21,33,28,47,242,25]),function(Z,e,k,t,T,L,A,I,b,P,D,E,p,C,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=void 0;let S=class extends p.AbstractSynchroniser{constructor(m,g,f,u,r,n,i,a,c,s,o){super("snippets",g,m,u,r,n,c,s,i,a,o);this.version=1,this.snippetsFolder=f.defaultProfile.snippetsHome,this._register(this.fileService.watch(m.userRoamingDataHome)),this._register(this.fileService.watch(this.snippetsFolder)),this._register(t.Event.filter(this.fileService.onDidFilesChange,l=>l.affects(this.snippetsFolder))(()=>this.triggerLocalChange()))}async generateSyncPreview(m,g,f){const u=await this.getSnippetsFileContents(),r=this.toSnippetsContents(u),n=m.syncData?this.parseSnippets(m.syncData):null;g=g===null&&f?m:g;const i=g&&g.syncData?this.parseSnippets(g.syncData):null;n?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote snippets with local snippets...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const a=(0,C.merge)(r,n,i);return this.getResourcePreviews(a,u,n||{},i||{})}async hasRemoteChanged(m){const g=m.syncData?this.parseSnippets(m.syncData):null;if(g===null)return!0;const f=await this.getSnippetsFileContents(),u=this.toSnippetsContents(f),r=(0,C.merge)(u,g,g);return Object.keys(r.remote.added).length>0||Object.keys(r.remote.updated).length>0||r.remote.removed.length>0||r.conflicts.length>0}async getMergeResult(m,g){return m.previewResult}async getAcceptResult(m,g,f,u){if(this.extUri.isEqualOrParent(g,this.syncPreviewFolder.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:m.fileContent?m.fileContent.value.toString():null,localChange:0,remoteChange:m.fileContent?m.remoteContent!==null?2:1:3};if(this.extUri.isEqualOrParent(g,this.syncPreviewFolder.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:m.remoteContent,localChange:m.remoteContent!==null?m.fileContent?2:1:3,remoteChange:0};if(this.extUri.isEqualOrParent(g,this.syncPreviewFolder))return f===void 0?{content:m.previewResult.content,localChange:m.previewResult.localChange,remoteChange:m.previewResult.remoteChange}:{content:f,localChange:f===null?m.fileContent!==null?3:0:2,remoteChange:f===null?m.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${g.toString()}`)}async applyResult(m,g,f,u){const r=f.map(([n,i])=>({...n,acceptResult:i}));r.every(({localChange:n,remoteChange:i})=>n===0&&i===0)&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing snippets.`),r.some(({localChange:n})=>n!==0)&&(await this.updateLocalBackup(r),await this.updateLocalSnippets(r,u)),r.some(({remoteChange:n})=>n!==0)&&(m=await this.updateRemoteSnippets(r,m,u)),g?.ref!==m.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized snippets...`),await this.updateLastSyncUserData(m),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized snippets`));for(const{previewResource:n}of r)try{await this.fileService.del(n)}catch{}}getResourcePreviews(m,g,f,u){const r=new Map;for(const n of Object.keys(m.local.added)){const i={content:m.local.added[n],hasConflicts:!1,localChange:1,remoteChange:0};r.set(n,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:null,fileContent:null,localResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:f[n],previewResource:this.extUri.joinPath(this.syncPreviewFolder,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const n of Object.keys(m.local.updated)){const i={content:m.local.updated[n],hasConflicts:!1,localChange:2,remoteChange:0},a=g[n]?g[n].value.toString():null;r.set(n,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:u[n]??a,localResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:g[n],localContent:a,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:f[n],previewResource:this.extUri.joinPath(this.syncPreviewFolder,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const n of m.local.removed){const i={content:null,hasConflicts:!1,localChange:3,remoteChange:0},a=g[n]?g[n].value.toString():null;r.set(n,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:u[n]??a,localResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:g[n],localContent:a,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const n of Object.keys(m.remote.added)){const i={content:m.remote.added[n],hasConflicts:!1,localChange:0,remoteChange:1},a=g[n]?g[n].value.toString():null;r.set(n,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:u[n]??a,localResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:g[n],localContent:a,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const n of Object.keys(m.remote.updated)){const i={content:m.remote.updated[n],hasConflicts:!1,localChange:0,remoteChange:2},a=g[n]?g[n].value.toString():null;r.set(n,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:u[n]??a,localResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:g[n],localContent:a,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:f[n],previewResource:this.extUri.joinPath(this.syncPreviewFolder,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const n of m.remote.removed){const i={content:null,hasConflicts:!1,localChange:0,remoteChange:3};r.set(n,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:u[n]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:f[n],previewResource:this.extUri.joinPath(this.syncPreviewFolder,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const n of m.conflicts){const i={content:g[n]?g[n].value.toString():null,hasConflicts:!0,localChange:g[n]?2:1,remoteChange:f[n]?2:1},a=g[n]?g[n].value.toString():null;r.set(n,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:u[n]??a,localResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:g[n]||null,localContent:a,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:f[n]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const n of Object.keys(g))if(!r.has(n)){const i={content:g[n]?g[n].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0},a=g[n]?g[n].value.toString():null;r.set(n,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:u[n]??a,localResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:g[n]||null,localContent:a,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:f[n]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...r.values()]}async getAssociatedResources({uri:m}){const g=await super.resolveContent(m);if(g){const f=this.parseSyncData(g);if(f){const u=this.parseSnippets(f),r=[];for(const n of Object.keys(u)){const i=this.extUri.joinPath(m,n),a=this.extUri.joinPath(this.snippetsFolder,n),c=await this.fileService.exists(a);r.push({resource:i,comparableResource:c?a:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"})})}return r}}return[]}async resolveContent(m){if(this.extUri.isEqualOrParent(m,this.syncPreviewFolder.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.extUri.isEqualOrParent(m,this.syncPreviewFolder.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.extUri.isEqualOrParent(m,this.syncPreviewFolder.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}))||this.extUri.isEqualOrParent(m,this.syncPreviewFolder.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})))return this.resolvePreviewContent(m);let g=await super.resolveContent(m);if(g)return g;if(g=await super.resolveContent(this.extUri.dirname(m)),g){const f=this.parseSyncData(g);if(f)return this.parseSnippets(f)[this.extUri.basename(m)]||null}return null}async hasLocalData(){try{const m=await this.getSnippetsFileContents();if(Object.keys(m).length)return!0}catch{}return!1}async updateLocalBackup(m){const g={};for(const f of m)f.fileContent&&(g[this.extUri.basename(f.localResource)]=f.fileContent);await this.backupLocal(JSON.stringify(this.toSnippetsContents(g)))}async updateLocalSnippets(m,g){for(const{fileContent:f,acceptResult:u,localResource:r,remoteResource:n,localChange:i}of m)if(i!==0){const a=n?this.extUri.basename(n):this.extUri.basename(r),c=this.extUri.joinPath(this.snippetsFolder,a);i===3?(this.logService.trace(`${this.syncResourceLogLabel}: Deleting snippet...`,this.extUri.basename(c)),await this.fileService.del(c),this.logService.info(`${this.syncResourceLogLabel}: Deleted snippet`,this.extUri.basename(c))):i===1?(this.logService.trace(`${this.syncResourceLogLabel}: Creating snippet...`,this.extUri.basename(c)),await this.fileService.createFile(c,k.VSBuffer.fromString(u.content),{overwrite:g}),this.logService.info(`${this.syncResourceLogLabel}: Created snippet`,this.extUri.basename(c))):(this.logService.trace(`${this.syncResourceLogLabel}: Updating snippet...`,this.extUri.basename(c)),await this.fileService.writeFile(c,k.VSBuffer.fromString(u.content),g?void 0:f),this.logService.info(`${this.syncResourceLogLabel}: Updated snippet`,this.extUri.basename(c)))}}async updateRemoteSnippets(m,g,f){const u=g.syncData?this.parseSnippets(g.syncData):{},r=(0,T.deepClone)(u);for(const{acceptResult:n,localResource:i,remoteResource:a,remoteChange:c}of m)if(c!==0){const s=i?this.extUri.basename(i):this.extUri.basename(a);c===3?delete r[s]:r[s]=n.content}return(0,C.areSame)(u,r)||(this.logService.trace(`${this.syncResourceLogLabel}: Updating remote snippets...`),g=await this.updateRemoteUserData(JSON.stringify(r),f?null:g.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote snippets`)),g}parseSnippets(m){return JSON.parse(m.content)}toSnippetsContents(m){const g={};for(const f of Object.keys(m))g[f]=m[f].value.toString();return g}async getSnippetsFileContents(){const m={};let g;try{g=await this.fileService.resolve(this.snippetsFolder)}catch(f){if(f instanceof I.FileOperationError&&f.fileOperationResult===1)return m;throw f}for(const f of g.children||[]){const u=f.resource,r=this.extUri.extname(u);if(r===".json"||r===".code-snippets"){const n=this.extUri.relativePath(this.snippetsFolder,u),i=await this.fileService.readFile(u);m[n]=i}}return m}};S=me([Q(0,A.IEnvironmentService),Q(1,I.IFileService),Q(2,E.IUserDataProfilesService),Q(3,b.IStorageService),Q(4,h.IUserDataSyncStoreService),Q(5,h.IUserDataSyncBackupStoreService),Q(6,h.IUserDataSyncLogService),Q(7,L.IConfigurationService),Q(8,h.IUserDataSyncEnablementService),Q(9,P.ITelemetryService),Q(10,D.IUriIdentityService)],S),e.SnippetsSynchroniser=S;let w=class extends p.AbstractInitializer{constructor(m,g,f,u,r){super("snippets",g,f,u,m,r)}async doInitialize(m){const g=m.syncData?JSON.parse(m.syncData.content):null;if(!g){this.logService.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing snippets because local snippets exist.");return}for(const u of Object.keys(g)){const r=g[u];if(r){const n=this.extUri.joinPath(this.userDataProfilesService.defaultProfile.snippetsHome,u);await this.fileService.createFile(n,k.VSBuffer.fromString(r)),this.logService.info("Created snippet",this.extUri.basename(n))}}await this.updateLastSyncUserData(m)}async isEmpty(){try{return!(await this.fileService.resolve(this.userDataProfilesService.defaultProfile.snippetsHome)).children?.length}catch(m){return m.fileOperationResult===1}}};w=me([Q(0,I.IFileService),Q(1,E.IUserDataProfilesService),Q(2,A.IEnvironmentService),Q(3,h.IUserDataSyncLogService),Q(4,D.IUriIdentityService)],w),e.SnippetsInitializer=w}),define(re[250],se([0,1,16,18,15,13,22,21,33,28,47,25]),function(Z,e,k,t,T,L,A,I,b,P,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TasksInitializer=e.TasksSynchroniser=e.getTasksContentFromSyncContent=void 0;function p(w,d){try{return JSON.parse(w).tasks}catch(m){return d.error(m),null}}e.getTasksContentFromSyncContent=p;let C=class extends D.AbstractFileSynchroniser{constructor(d,m,g,f,u,r,n,i,a,c,s){super(s.defaultProfile.tasksResource,"tasks",r,n,i,d,m,u,a,g,f,c);this.version=1,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"tasks.json"),this.baseResource=this.previewResource.with({scheme:E.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:E.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:E.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:E.USER_DATA_SYNC_SCHEME,authority:"accepted"})}async generateSyncPreview(d,m,g,f){const u=d.syncData?p(d.syncData.content,this.logService):null;m=m===null&&g?d:m;const r=m?.syncData?p(m.syncData.content,this.logService):null,n=await this.getLocalFileContent();let i=null,a=!1,c=!1,s=!1;if(u){const v=n?n.value.toString():null;if(!r||r!==v||r!==u){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote tasks with local tasks...`);const y=S(v,u,r);i=y.content,s=y.hasConflicts,a=y.hasLocalChanged,c=y.hasRemoteChanged}}else n&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote tasks does not exist. Synchronizing tasks for the first time.`),i=n.value.toString(),c=!0);const o={content:i,localChange:a?n?2:1:0,remoteChange:c?2:0,hasConflicts:s},l=n?n.value.toString():null;return[{fileContent:n,baseResource:this.baseResource,baseContent:r!==null?r:l,localResource:this.localResource,localContent:l,localChange:o.localChange,remoteResource:this.remoteResource,remoteContent:u,remoteChange:o.remoteChange,previewResource:this.previewResource,previewResult:o,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(d){const m=d?.syncData?p(d.syncData.content,this.logService):null;if(m===null)return!0;const g=await this.getLocalFileContent(),f=g?g.value.toString():null,u=S(f,m,m);return u.hasLocalChanged||u.hasRemoteChanged}async getMergeResult(d,m){return d.previewResult}async getAcceptResult(d,m,g,f){if(this.extUri.isEqual(m,this.localResource))return{content:d.fileContent?d.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(m,this.remoteResource))return{content:d.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(m,this.previewResource))return g===void 0?{content:d.previewResult.content,localChange:d.previewResult.localChange,remoteChange:d.previewResult.remoteChange}:{content:g,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${m.toString()}`)}async applyResult(d,m,g,f){const{fileContent:u}=g[0][0],{content:r,localChange:n,remoteChange:i}=g[0][1];if(n===0&&i===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing tasks.`),n!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local tasks...`),u&&await this.backupLocal(JSON.stringify(this.toTasksSyncContent(u.value.toString()))),await this.updateLocalFileContent(r||"{}",u,f),this.logService.info(`${this.syncResourceLogLabel}: Updated local tasks`)),i!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote tasks...`);const a=JSON.stringify(this.toTasksSyncContent(r||"{}"));d=await this.updateRemoteUserData(a,f?null:d.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote tasks`)}try{await this.fileService.del(this.previewResource)}catch{}m?.ref!==d.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized tasks...`),await this.updateLastSyncUserData(d),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized tasks`))}async hasLocalData(){return this.fileService.exists(this.file)}async getAssociatedResources({uri:d}){const m=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(d,"tasks.json"),comparableResource:m}]}async resolveContent(d){if(this.extUri.isEqual(this.remoteResource,d)||this.extUri.isEqual(this.baseResource,d)||this.extUri.isEqual(this.localResource,d)||this.extUri.isEqual(this.acceptedResource,d))return this.resolvePreviewContent(d);let m=await super.resolveContent(d);if(m)return m;if(m=await super.resolveContent(this.extUri.dirname(d)),m){const g=this.parseSyncData(m);if(g)switch(this.extUri.basename(d)){case"tasks.json":return p(g.content,this.logService)}}return null}toTasksSyncContent(d){return{tasks:d}}};C=me([Q(0,E.IUserDataSyncStoreService),Q(1,E.IUserDataSyncBackupStoreService),Q(2,E.IUserDataSyncLogService),Q(3,t.IConfigurationService),Q(4,E.IUserDataSyncEnablementService),Q(5,L.IFileService),Q(6,T.IEnvironmentService),Q(7,A.IStorageService),Q(8,I.ITelemetryService),Q(9,b.IUriIdentityService),Q(10,P.IUserDataProfilesService)],C),e.TasksSynchroniser=C;let h=class extends D.AbstractInitializer{constructor(d,m,g,f,u){super("tasks",m,g,f,d,u);this.tasksResource=this.userDataProfilesService.defaultProfile.tasksResource}async doInitialize(d){const m=d.syncData?p(d.syncData.content,this.logService):null;if(!m){this.logService.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing tasks because local tasks exist.");return}await this.fileService.writeFile(this.tasksResource,k.VSBuffer.fromString(m)),await this.updateLastSyncUserData(d)}async isEmpty(){return this.fileService.exists(this.tasksResource)}};h=me([Q(0,L.IFileService),Q(1,P.IUserDataProfilesService),Q(2,T.IEnvironmentService),Q(3,E.IUserDataSyncLogService),Q(4,b.IUriIdentityService)],h),e.TasksInitializer=h;function S(w,d,m){if(w===null&&d===null&&m===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(w===d)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const g=m!==w,f=m!==d;return!g&&!f?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:g&&!f?{content:w,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:f&&!g?{content:d,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:w,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(re[73],se([0,1,3,2,5,25]),function(Z,e,k,t,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,T.createDecorator)("IUserDataSyncAccountService");let A=class extends t.Disposable{constructor(b,P){super();this.userDataSyncStoreService=b,this.logService=P,this._onDidChangeAccount=this._register(new k.Emitter),this.onDidChangeAccount=this._onDidChangeAccount.event,this._onTokenFailed=this._register(new k.Emitter),this.onTokenFailed=this._onTokenFailed.event,this.wasTokenFailed=!1,this._register(b.onTokenFailed(()=>{this.logService.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.wasTokenFailed),this.updateAccount(void 0),this._onTokenFailed.fire(this.wasTokenFailed),this.wasTokenFailed=!0})),this._register(b.onTokenSucceed(()=>this.wasTokenFailed=!1))}get account(){return this._account}async updateAccount(b){(b&&this._account?b.token!==this._account.token||b.authenticationProviderId!==this._account.authenticationProviderId:b!==this._account)&&(this._account=b,this._account&&this.userDataSyncStoreService.setAuthToken(this._account.token,this._account.authenticationProviderId),this._onDidChangeAccount.fire(b))}};A=me([Q(0,L.IUserDataSyncStoreService),Q(1,L.IUserDataSyncLogService)],A),e.UserDataSyncAccountService=A}),define(re[251],se([0,1,6,16,62,2,19,18,15,13,25]),function(Z,e,k,t,T,L,A,I,b,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let E=class extends L.Disposable{constructor(C,h,S,w){super();this.environmentService=C,this.fileService=h,this.configurationService=S,this.logService=w,D.ALL_SYNC_RESOURCES.forEach(d=>this.cleanUpBackup(d))}async getAllRefs(C){const h=(0,A.joinPath)(this.environmentService.userDataSyncHome,C),S=await this.fileService.resolve(h);return S.children?S.children.filter(d=>d.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(d.name)).sort().reverse().map(d=>({ref:d.name,created:this.getCreationTime(d)})):[]}async resolveContent(C,h){if(!h){const S=await this.getAllRefs(C);S.length&&(h=S[S.length-1].ref)}if(h){const S=(0,A.joinPath)(this.environmentService.userDataSyncHome,C,h);return(await this.fileService.readFile(S)).value.toString()}return null}async backup(C,h){const S=(0,A.joinPath)(this.environmentService.userDataSyncHome,C),w=(0,A.joinPath)(S,`${(0,T.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.fileService.writeFile(w,t.VSBuffer.fromString(h))}catch(d){this.logService.error(d)}try{this.cleanUpBackup(C)}catch{}}async cleanUpBackup(C){const h=(0,A.joinPath)(this.environmentService.userDataSyncHome,C);try{try{if(!await this.fileService.exists(h))return}catch{return}const S=await this.fileService.resolve(h);if(S.children){const w=S.children.filter(f=>f.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(f.name)).sort(),d=1e3*60*60*24*(this.configurationService.getValue("sync.localBackupDuration")||30);let m=w.filter(f=>Date.now()-this.getCreationTime(f)>d);const g=w.length-m.length;g<10&&(m=m.slice(10-g)),await k.Promises.settled(m.map(async f=>{this.logService.info("Deleting from backup",f.resource.path),await this.fileService.del(f.resource)}))}}catch(S){this.logService.error(S)}}getCreationTime(C){return C.ctime||new Date(parseInt(C.name.substring(0,4)),parseInt(C.name.substring(4,6))-1,parseInt(C.name.substring(6,8)),parseInt(C.name.substring(9,11)),parseInt(C.name.substring(11,13)),parseInt(C.name.substring(13,15))).getTime()}};E=me([Q(0,b.IEnvironmentService),Q(1,P.IFileService),Q(2,I.IConfigurationService),Q(3,D.IUserDataSyncLogService)],E),e.UserDataSyncBackupStoreService=E}),define(re[252],se([0,1,3,2,4,15,22,21,25]),function(Z,e,k,t,T,L,A,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncEnablementService=void 0;const P="sync.enable";let D=class extends t.Disposable{constructor(p,C,h,S){super();this.storageService=p,this.telemetryService=C,this.environmentService=h,this.userDataSyncStoreManagementService=S,this._onDidChangeEnablement=new k.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this._onDidChangeResourceEnablement=new k.Emitter,this.onDidChangeResourceEnablement=this._onDidChangeResourceEnablement.event,this._register(p.onDidChangeValue(w=>this.onDidStorageChange(w)))}isEnabled(){switch(this.environmentService.sync){case"on":return!0;case"off":return!1}return this.storageService.getBoolean(P,-1,!1)}canToggleEnablement(){return this.userDataSyncStoreManagementService.userDataSyncStore!==void 0&&this.environmentService.sync===void 0}setEnablement(p){p&&!this.canToggleEnablement()||(this.telemetryService.publicLog2(P,{enabled:p}),this.storageService.store(P,p,-1,1))}isResourceEnabled(p){return this.storageService.getBoolean((0,b.getEnablementKey)(p),-1,!0)}setResourceEnablement(p,C){if(this.isResourceEnabled(p)!==C){const h=(0,b.getEnablementKey)(p);this.storeResourceEnablement(h,C)}}getResourceSyncStateVersion(p){}storeResourceEnablement(p,C){this.storageService.store(p,C,-1,T.isWeb?0:1)}onDidStorageChange(p){if(p.scope!==-1)return;if(P===p.key){this._onDidChangeEnablement.fire(this.isEnabled());return}const C=b.ALL_SYNC_RESOURCES.filter(h=>(0,b.getEnablementKey)(h)===p.key)[0];if(C){this._onDidChangeResourceEnablement.fire([C,this.isResourceEnabled(C)]);return}}};D=me([Q(0,A.IStorageService),Q(1,I.ITelemetryService),Q(2,L.IEnvironmentService),Q(3,b.IUserDataSyncStoreManagementService)],D),e.UserDataSyncEnablementService=D}),define(re[253],se([0,1,2,8]),function(Z,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class T{constructor(p){this.service=p}listen(p,C){switch(C){case"onError":return this.service.onError}throw new Error(`Event not found: ${C}`)}call(p,C,h){switch(C){case"triggerSync":return this.service.triggerSync(h[0],h[1],h[2]);case"turnOn":return this.service.turnOn();case"turnOff":return this.service.turnOff(h[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=T;class L{constructor(p){this.service=p}listen(p,C){throw new Error(`Event not found: ${C}`)}call(p,C,h){switch(C){case"resolveDefaultIgnoredSettings":return this.service.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.service.resolveUserBindings(h[0]);case"resolveFormattingOptions":return this.service.resolveFormattingOptions(t.URI.revive(h[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=L;class A{constructor(p){this.channel=p}async resolveDefaultIgnoredSettings(){return this.channel.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(p){return this.channel.call("resolveUserKeybindings",[p])}async resolveFormattingOptions(p){return this.channel.call("resolveFormattingOptions",[p])}}e.UserDataSyncUtilServiceClient=A;class I{constructor(p){this.service=p}listen(p,C){switch(C){case"onDidChange":return this.service.onDidChange}throw new Error(`Event not found: ${C}`)}async call(p,C,h){switch(C){case"getMachines":return this.service.getMachines();case"addCurrentMachine":return this.service.addCurrentMachine();case"removeCurrentMachine":return this.service.removeCurrentMachine();case"renameMachine":return this.service.renameMachine(h[0],h[1]);case"setEnablements":return this.service.setEnablements(h)}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=I;class b{constructor(p){this.service=p}listen(p,C){switch(C){case"onDidChangeAccount":return this.service.onDidChangeAccount;case"onTokenFailed":return this.service.onTokenFailed}throw new Error(`Event not found: ${C}`)}call(p,C,h){switch(C){case"_getInitialData":return Promise.resolve(this.service.account);case"updateAccount":return this.service.updateAccount(h)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=b;class P{constructor(p){this.service=p}listen(p,C){switch(C){case"onDidChangeUserDataSyncStore":return this.service.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${C}`)}call(p,C,h){switch(C){case"switch":return this.service.switch(h[0]);case"getPreviousUserDataSyncStore":return this.service.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=P;class D extends k.Disposable{constructor(p){super();this.channel=p,this.onDidChangeUserDataSyncStore=this.channel.listen("onDidChangeUserDataSyncStore")}async switch(p){return this.channel.call("switch",[p])}async getPreviousUserDataSyncStore(){const p=await this.channel.call("getPreviousUserDataSyncStore");return this.revive(p)}revive(p){return{url:t.URI.revive(p.url),type:p.type,defaultUrl:t.URI.revive(p.defaultUrl),insidersUrl:t.URI.revive(p.insidersUrl),stableUrl:t.URI.revive(p.stableUrl),canSwitch:p.canSwitch,authenticationProviders:p.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=D}),define(re[254],se([0,1,15,7]),function(Z,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let T=class extends t.AbstractLogger{constructor(A,I){super();this.logger=this._register(A.createLogger(I.userDataSyncLogResource,{name:"settingssync"}))}trace(A,...I){this.logger.trace(A,...I)}debug(A,...I){this.logger.debug(A,...I)}info(A,...I){this.logger.info(A,...I)}warn(A,...I){this.logger.warn(A,...I)}error(A,...I){this.logger.error(A,...I)}critical(A,...I){this.logger.critical(A,...I)}flush(){this.logger.flush()}};T=me([Q(0,t.ILoggerService),Q(1,k.IEnvironmentService)],T),e.UserDataSyncLogService=T}),define(re[74],se([0,1,3,2,4,26,164,15,13,5,24,49,22,25]),function(Z,e,k,t,T,L,A,I,b,P,D,E,p,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.isWebPlatform=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,P.createDecorator)("IUserDataSyncMachinesService");const h="sync.currentMachineName",S="Safari",w="Chrome",d="Edge",m="Firefox",g="Android";function f(n){switch(n){case S:case w:case d:case m:case g:case(0,T.PlatformToString)(0):return!0}return!1}e.isWebPlatform=f;function u(){return T.isSafari?S:T.isChrome?w:T.isEdge?d:T.isFirefox?m:T.isAndroid?g:(0,T.PlatformToString)(T.isWeb?0:T.platform)}let r=class nt extends t.Disposable{constructor(i,a,c,s,o,l){super();this.storageService=c,this.userDataSyncStoreService=s,this.logService=o,this.productService=l,this._onDidChange=this._register(new k.Emitter),this.onDidChange=this._onDidChange.event,this.userData=null,this.currentMachineIdPromise=(0,E.getServiceMachineId)(i,a,c)}async getMachines(i){const a=await this.currentMachineIdPromise;return(await this.readMachinesData(i)).machines.map(s=>({...s,isCurrent:s.id===a}))}async addCurrentMachine(i){const a=await this.currentMachineIdPromise,c=await this.readMachinesData(i);c.machines.some(({id:s})=>s===a)||(c.machines.push({id:a,name:this.computeCurrentMachineName(c.machines),platform:u()}),await this.writeMachinesData(c))}async removeCurrentMachine(i){const a=await this.currentMachineIdPromise,c=await this.readMachinesData(i),s=c.machines.filter(({id:o})=>o!==a);s.length!==c.machines.length&&(c.machines=s,await this.writeMachinesData(c))}async renameMachine(i,a,c){const s=await this.readMachinesData(c),o=s.machines.find(({id:l})=>l===i);if(o){o.name=a,await this.writeMachinesData(s);const l=await this.currentMachineIdPromise;i===l&&this.storageService.store(h,a,-1,1)}}async setEnablements(i){const a=await this.readMachinesData();for(const[c,s]of i){const o=a.machines.find(l=>l.id===c);o&&(o.disabled=s?void 0:!0)}await this.writeMachinesData(a)}computeCurrentMachineName(i){const a=this.storageService.get(h,-1);if(a)return a;const c=`${this.productService.embedderIdentifier?`${this.productService.embedderIdentifier} - `:""}${u()} (${this.productService.nameShort})`,s=new RegExp(`${(0,L.escapeRegExpCharacters)(c)}\\s#(\\d+)`);let o=0;for(const l of i){const v=s.exec(l.name),y=v?parseInt(v[1]):0;o=y>o?y:o}return`${c} #${o+1}`}async readMachinesData(i){this.userData=await this.readUserData(i);const a=this.parse(this.userData);if(a.version!==nt.VERSION)throw new Error((0,A.localize)(0,null,this.productService.nameLong));return a}async writeMachinesData(i){const a=JSON.stringify(i),c=await this.userDataSyncStoreService.write(nt.RESOURCE,a,this.userData?.ref||null);this.userData={ref:c,content:a},this._onDidChange.fire()}async readUserData(i){if(this.userData){const a=i&&i.latest?i.latest[nt.RESOURCE]:void 0;if(this.userData.ref===a)return this.userData;if(a===void 0&&this.userData.content===null)return this.userData}return this.userDataSyncStoreService.read(nt.RESOURCE,this.userData)}parse(i){if(i.content!==null)try{return JSON.parse(i.content)}catch(a){this.logService.error(a)}return{version:nt.VERSION,machines:[]}}};r.VERSION=1,r.RESOURCE="machines",r=me([Q(0,I.IEnvironmentService),Q(1,b.IFileService),Q(2,p.IStorageService),Q(3,C.IUserDataSyncStoreService),Q(4,C.IUserDataSyncLogService),Q(5,D.IProductService)],r),e.UserDataSyncMachinesService=r}),define(re[255],se([0,1,6,62,37,9,3,2,4,19,8,162,24,22,21,25,73,74]),function(Z,e,k,t,T,L,A,I,b,P,D,E,p,C,h,S,w,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;const m="sync.disableMachineEventually",g="sync.sessionId",f="sync.storeUrl",u="sync.productQuality";let r=class extends I.Disposable{constructor(a,c,s,o,l,v,y,O,_,F){super();this.userDataSyncStoreManagementService=c,this.userDataSyncStoreService=s,this.userDataSyncEnablementService=o,this.userDataSyncService=l,this.logService=v,this.userDataSyncAccountService=y,this.telemetryService=O,this.userDataSyncMachinesService=_,this.storageService=F,this.autoSync=this._register(new I.MutableDisposable),this.successiveFailures=0,this.lastSyncTriggerTime=void 0,this.suspendUntilRestart=!1,this._onError=this._register(new A.Emitter),this.onError=this._onError.event,this.sources=[],this.syncTriggerDelayer=this._register(new k.ThrottledDelayer(this.getSyncTriggerDelayTime())),this.lastSyncUrl=this.syncUrl,this.syncUrl=c.userDataSyncStore?.url,this.previousProductQuality=this.productQuality,this.productQuality=a.quality,this.syncUrl&&(this.logService.info("Using settings sync service",this.syncUrl.toString()),this._register(c.onDidChangeUserDataSyncStore(()=>{(0,P.isEqual)(this.syncUrl,c.userDataSyncStore?.url)||(this.lastSyncUrl=this.syncUrl,this.syncUrl=c.userDataSyncStore?.url,this.syncUrl&&this.logService.info("Using settings sync service",this.syncUrl.toString()))})),this.userDataSyncEnablementService.isEnabled()?this.logService.info("Auto Sync is enabled."):this.logService.info("Auto Sync is disabled."),this.updateAutoSync(),this.hasToDisableMachineEventually()&&this.disableMachineEventually(),this._register(y.onDidChangeAccount(()=>this.updateAutoSync())),this._register(s.onDidChangeDonotMakeRequestsUntil(()=>this.updateAutoSync())),this._register(l.onDidChangeLocal(R=>this.triggerSync([R],!1,!1))),this._register(A.Event.filter(this.userDataSyncEnablementService.onDidChangeResourceEnablement,([,R])=>R)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this._register(this.userDataSyncStoreManagementService.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}get syncUrl(){const a=this.storageService.get(f,-1);return a?D.URI.parse(a):void 0}set syncUrl(a){a?this.storageService.store(f,a.toString(),-1,1):this.storageService.remove(f,-1)}get productQuality(){return this.storageService.get(u,-1)}set productQuality(a){a?this.storageService.store(u,a,-1,1):this.storageService.remove(u,-1)}updateAutoSync(){const{enabled:a,message:c}=this.isAutoSyncEnabled();a?this.autoSync.value===void 0&&(this.autoSync.value=new n(this.lastSyncUrl,1e3*60*5,this.userDataSyncStoreManagementService,this.userDataSyncStoreService,this.userDataSyncService,this.userDataSyncMachinesService,this.logService,this.storageService),this.autoSync.value.register(this.autoSync.value.onDidStartSync(()=>this.lastSyncTriggerTime=new Date().getTime())),this.autoSync.value.register(this.autoSync.value.onDidFinishSync(s=>this.onDidFinishSync(s))),this.startAutoSync()&&this.autoSync.value.start()):(this.syncTriggerDelayer.cancel(),this.autoSync.value!==void 0?(c&&this.logService.info(c),this.autoSync.clear()):c&&this.userDataSyncEnablementService.isEnabled()&&this.logService.info(c))}startAutoSync(){return!0}isAutoSyncEnabled(){return this.userDataSyncEnablementService.isEnabled()?this.userDataSyncAccountService.account?this.userDataSyncStoreService.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,t.toLocalISOString)(this.userDataSyncStoreService.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.suspendUntilRestart?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.stopDisableMachineEventually(),this.lastSyncUrl=this.syncUrl,this.updateEnablement(!0)}async turnOff(a,c,s){try{this.userDataSyncAccountService.account&&!s&&await this.userDataSyncMachinesService.removeCurrentMachine(),this.updateEnablement(!1),this.storageService.remove(g,-1),a?(this.telemetryService.publicLog2("sync/turnOffEveryWhere"),await this.userDataSyncService.reset()):await this.userDataSyncService.resetLocal()}catch(o){if(c)this.logService.error(o),this.updateEnablement(!1);else throw o}}updateEnablement(a){this.userDataSyncEnablementService.isEnabled()!==a&&(this.userDataSyncEnablementService.setEnablement(a),this.updateAutoSync())}hasProductQualityChanged(){return!!this.previousProductQuality&&!!this.productQuality&&this.previousProductQuality!==this.productQuality}async onDidFinishSync(a){if(!a){this.successiveFailures=0;return}const c=S.UserDataSyncError.toUserDataSyncError(a);c instanceof S.UserDataAutoSyncError&&this.telemetryService.publicLog2("autosync/error",{code:c.code,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()}),c.code==="SessionExpired"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current session is expired")):c.code==="TurnedOff"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):c.code==="LocalTooManyRequests"?(this.suspendUntilRestart=!0,this.logService.info("Auto Sync: Suspended sync because of making too many requests to server"),this.updateAutoSync()):c.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because of making too many requests to server")):c.code==="UpgradeRequired"||c.code==="Gone"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):c.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${c.resource} content with newer version than of client. Requires client upgrade.`)):c.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${c.resource} content with older version than of client. Requires server reset.`)):c.code==="ServiceChanged"||c.code==="DefaultServiceChanged"?b.isWeb&&c.code==="DefaultServiceChanged"&&!this.hasProductQualityChanged()?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.logService.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.logService.error(c),this.successiveFailures++),this._onError.fire(c)}async disableMachineEventually(){this.storageService.store(m,!0,-1,1),await(0,k.timeout)(1e3*60*10),!!this.hasToDisableMachineEventually()&&(this.stopDisableMachineEventually(),!this.userDataSyncEnablementService.isEnabled()&&this.userDataSyncAccountService.account&&await this.userDataSyncMachinesService.removeCurrentMachine())}hasToDisableMachineEventually(){return this.storageService.getBoolean(m,-1,!1)}stopDisableMachineEventually(){this.storageService.remove(m,-1)}async triggerSync(a,c,s){if(this.autoSync.value===void 0)return this.syncTriggerDelayer.cancel();if(c&&this.lastSyncTriggerTime&&Math.round((new Date().getTime()-this.lastSyncTriggerTime)/1e3)<10){this.logService.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.sources.push(...a),this.syncTriggerDelayer.trigger(async()=>{this.logService.trace("activity sources",...this.sources),this.telemetryService.publicLog2("sync/triggered",{sources:this.sources}),this.sources=[],this.autoSync.value&&await this.autoSync.value.sync("Activity",s)},this.successiveFailures?this.getSyncTriggerDelayTime()*1*Math.min(Math.pow(2,this.successiveFailures),60):this.getSyncTriggerDelayTime())}getSyncTriggerDelayTime(){return 2e3}};r=me([Q(0,p.IProductService),Q(1,S.IUserDataSyncStoreManagementService),Q(2,S.IUserDataSyncStoreService),Q(3,S.IUserDataSyncEnablementService),Q(4,S.IUserDataSyncService),Q(5,S.IUserDataSyncLogService),Q(6,w.IUserDataSyncAccountService),Q(7,h.ITelemetryService),Q(8,d.IUserDataSyncMachinesService),Q(9,C.IStorageService)],r),e.UserDataAutoSyncService=r;class n extends I.Disposable{constructor(a,c,s,o,l,v,y,O){super();this.lastSyncUrl=a,this.interval=c,this.userDataSyncStoreManagementService=s,this.userDataSyncStoreService=o,this.userDataSyncService=l,this.userDataSyncMachinesService=v,this.logService=y,this.storageService=O,this.intervalHandler=this._register(new I.MutableDisposable),this._onDidStartSync=this._register(new A.Emitter),this.onDidStartSync=this._onDidStartSync.event,this._onDidFinishSync=this._register(new A.Emitter),this.onDidFinishSync=this._onDidFinishSync.event,this.manifest=null}start(){this._register(this.onDidFinishSync(()=>this.waitUntilNextIntervalAndSync())),this._register((0,I.toDisposable)(()=>{this.syncPromise&&(this.syncPromise.cancel(),this.logService.info("Auto sync: Cancelled sync that is in progress"),this.syncPromise=void 0),this.syncTask&&this.syncTask.stop(),this.logService.info("Auto Sync: Stopped")})),this.logService.info("Auto Sync: Started"),this.sync(n.INTERVAL_SYNCING,!1)}waitUntilNextIntervalAndSync(){this.intervalHandler.value=(0,k.disposableTimeout)(()=>this.sync(n.INTERVAL_SYNCING,!1),this.interval)}sync(a,c){const s=(0,k.createCancelablePromise)(async o=>{if(this.syncPromise)try{this.logService.debug("Auto Sync: Waiting until sync is finished."),await this.syncPromise}catch(l){if((0,L.isCancellationError)(l))return}return this.doSync(a,c,o)});return this.syncPromise=s,this.syncPromise.finally(()=>this.syncPromise=void 0),this.syncPromise}hasSyncServiceChanged(){return this.lastSyncUrl!==void 0&&!(0,P.isEqual)(this.lastSyncUrl,this.userDataSyncStoreManagementService.userDataSyncStore?.url)}async hasDefaultServiceChanged(){const a=await this.userDataSyncStoreManagementService.getPreviousUserDataSyncStore(),c=this.userDataSyncStoreManagementService.userDataSyncStore;return!!c&&!!a&&(!(0,P.isEqual)(c.defaultUrl,a.defaultUrl)||!(0,P.isEqual)(c.insidersUrl,a.insidersUrl)||!(0,P.isEqual)(c.stableUrl,a.stableUrl))}async doSync(a,c,s){this.logService.info(`Auto Sync: Triggered by ${a}`),this._onDidStartSync.fire();let o;try{if(this.syncTask=await this.userDataSyncService.createSyncTask(this.manifest,c),s.isCancellationRequested)return;if(this.manifest=this.syncTask.manifest,this.manifest===null&&await this.userDataSyncService.hasPreviouslySynced())throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new S.UserDataAutoSyncError((0,E.localize)(0,null),"DefaultServiceChanged"):new S.UserDataAutoSyncError((0,E.localize)(1,null),"ServiceChanged"):new S.UserDataAutoSyncError((0,E.localize)(2,null),"TurnedOff");const l=this.storageService.get(g,-1);if(l&&this.manifest&&l!==this.manifest.session)throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new S.UserDataAutoSyncError((0,E.localize)(3,null),"DefaultServiceChanged"):new S.UserDataAutoSyncError((0,E.localize)(4,null),"ServiceChanged"):new S.UserDataAutoSyncError((0,E.localize)(5,null),"SessionExpired");const v=await this.userDataSyncMachinesService.getMachines(this.manifest||void 0);if(s.isCancellationRequested)return;const y=v.find(O=>O.isCurrent);if(y?.disabled)throw new S.UserDataAutoSyncError((0,E.localize)(6,null),"TurnedOff");if(await this.syncTask.run(),this.manifest===null)try{this.manifest=await this.userDataSyncStoreService.manifest(null)}catch(O){throw new S.UserDataAutoSyncError((0,T.toErrorMessage)(O),O instanceof S.UserDataSyncError?O.code:"Unknown")}if(this.manifest&&this.manifest.session!==l&&this.storageService.store(g,this.manifest.session,-1,1),s.isCancellationRequested)return;y||await this.userDataSyncMachinesService.addCurrentMachine(this.manifest||void 0)}catch(l){this.logService.error(l),o=l}this._onDidFinishSync.fire(o)}register(a){return super._register(a)}}n.INTERVAL_SYNCING="Interval"}),define(re[256],se([0,1,17,6,37,3,2,19,14,31,18,30,5,22,21,243,245,246,248,249,250,25]),function(Z,e,k,t,T,L,A,I,b,P,D,E,p,C,h,S,w,d,m,g,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const r="sync.lastSyncTime";let n=class extends A.Disposable{constructor(o,l,v,y,O,_,F,R){super();this.userDataSyncStoreService=o,this.userDataSyncStoreManagementService=l,this.instantiationService=v,this.configurationService=y,this.logService=O,this.telemetryService=_,this.storageService=F,this.userDataSyncEnablementService=R,this._status="uninitialized",this._onDidChangeStatus=this._register(new L.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._onDidChangeLocal=this._register(new L.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new L.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._syncErrors=[],this._onSyncErrors=this._register(new L.Emitter),this.onSyncErrors=this._onSyncErrors.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new L.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onDidResetLocal=this._register(new L.Emitter),this.onDidResetLocal=this._onDidResetLocal.event,this._onDidResetRemote=this._register(new L.Emitter),this.onDidResetRemote=this._onDidResetRemote.event,this.synchronizers=this._register(new A.MutableDisposable),this.updateStatus([]),this._lastSyncTime=this.storageService.getNumber(r,-1,void 0)}get status(){return this._status}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}async createSyncTask(o,l){this.checkEnablement();const v=(0,P.generateUuid)();try{const R=(0,u.createSyncHeaders)(v);l&&(R["Cache-Control"]="no-cache"),o=await this.userDataSyncStoreService.manifest(o,R)}catch(R){const U=u.UserDataSyncError.toUserDataSyncError(R);throw this.reportUserDataSyncError(U,v),U}const y=!1,O=this,_=this.getEnabledSynchronizers();let F;return{manifest:o,async run(){if(y)throw new Error("Can run a task only once");return F=(0,t.createCancelablePromise)(R=>O.sync(_,o,v,R)),F.finally(()=>F=void 0)},async stop(){if(F&&F.cancel(),O.status!=="idle")return O.stop(_)}}}async createManualSyncTask(){if(this.checkEnablement(),this.userDataSyncEnablementService.isEnabled())throw new u.UserDataSyncError("Cannot start manual sync when sync is enabled","LocalError");const o=(0,P.generateUuid)(),l=(0,u.createSyncHeaders)(o);let v;try{v=await this.userDataSyncStoreService.manifest(null,l)}catch(_){const F=u.UserDataSyncError.toUserDataSyncError(_);throw this.reportUserDataSyncError(F,o),F}await this.resetLocal();const y=this.getEnabledSynchronizers(),O=async()=>{await this.stop(y),await this.resetLocal()};return new i(o,v,l,y,O,this.configurationService,this.logService)}async sync(o,l,v,y){if(y.isCancellationRequested||!o.length)return;const O=new Date().getTime();this._syncErrors=[];try{this.logService.trace("Sync started."),this.status!=="hasConflicts"&&this.setStatus("syncing");const _=(0,u.createSyncHeaders)(v);for(const F of o){if(y.isCancellationRequested||!this.userDataSyncEnablementService.isResourceEnabled(F.resource))return;try{await F.sync(l,_)}catch(R){let U=!1;if(R instanceof u.UserDataSyncError)switch(R.code){case"TooLarge":R=new u.UserDataSyncError(R.message,R.code,F.resource),U=!0;break;case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":U=!0;break}const M=u.UserDataSyncError.toUserDataSyncError(R);if(this.reportUserDataSyncError(M,v),U)throw M;this.logService.error(R),this.logService.error(`${F.resource}: ${(0,T.toErrorMessage)(R)}`),this._syncErrors.push([F.resource,M])}}this.logService.info(`Sync done. Took ${new Date().getTime()-O}ms`),this.updateLastSyncTime()}catch(_){const F=u.UserDataSyncError.toUserDataSyncError(_);throw this.reportUserDataSyncError(F,v),F}finally{this.updateStatus(o),this._onSyncErrors.fire(this._syncErrors)}}async stop(o){if(this.status!=="idle")for(const l of o)try{l.status!=="idle"&&await l.stop()}catch(v){this.logService.error(v)}}async replace(o){this.checkEnablement(),await this.performSynchronizerAction(async l=>{if(await l.replace(o))return!0})}async accept(o,l,v,y){this.checkEnablement(),await this.performSynchronizerAction(async O=>{if(O.resource===o)return await O.accept(l,v),y&&await O.apply(!1,(0,u.createSyncHeaders)((0,P.generateUuid)())),!0})}async resolveContent(o){return this.performSynchronizerAction(async l=>{const v=await l.resolveContent(o);if(v)return v})}async getRemoteSyncResourceHandles(o){return await this.performSynchronizerAction(async v=>{if(v.resource===o)return v.getRemoteSyncResourceHandles()})||[]}async getLocalSyncResourceHandles(o){return await this.performSynchronizerAction(async v=>{if(v.resource===o)return v.getLocalSyncResourceHandles()})||[]}async getAssociatedResources(o,l){return await this.performSynchronizerAction(async y=>{if(y.resource===o)return y.getAssociatedResources(l)})||[]}async getMachineId(o,l){return await this.performSynchronizerAction(async y=>{if(y.resource===o)return await y.getMachineId(l)||null})||void 0}async hasLocalData(){return!!await this.performSynchronizerAction(async l=>{if(l.resource!=="globalState"&&await l.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.performSynchronizerAction(async l=>{if(await l.hasPreviouslySynced())return!0})}async reset(){this.checkEnablement(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.checkEnablement();try{await this.userDataSyncStoreService.clear(),this.logService.info("Cleared data on server")}catch(o){this.logService.error(o)}this._onDidResetRemote.fire()}async resetLocal(){if(this.checkEnablement(),this.storageService.remove(r,-1),this.synchronizers.value){for(const o of this.synchronizers.value.enabled)try{await o.resetLocal()}catch(l){this.logService.error(`${o.resource}: ${(0,T.toErrorMessage)(l)}`),this.logService.error(l)}this.synchronizers.value=void 0}this._onDidResetLocal.fire(),this.logService.info("Did reset the local sync state.")}async performSynchronizerAction(o){const l=new A.DisposableStore;try{const v=this.synchronizers.value||l.add(this.instantiationService.createInstance(a,()=>{},()=>{},()=>{})),y=[...v.enabled,...v.disabled.map(O=>l.add(v.createSynchronizer(O)))];for(const O of y){const _=await o(O);if(!(0,b.isUndefined)(_))return _}return null}finally{l.dispose()}}setStatus(o){const l=this._status;this._status!==o&&(this._status=o,this._onDidChangeStatus.fire(o),l==="hasConflicts"&&this.updateLastSyncTime())}updateStatus(o){this.updateConflicts(o);const l=this.computeStatus(o);this.setStatus(l)}updateConflicts(o){const l=this.computeConflicts(o);(0,k.equals)(this._conflicts,l,([v,y],[O,_])=>v===v&&(0,k.equals)(y,_,(F,R)=>(0,I.isEqual)(F.previewResource,R.previewResource)))||(this._conflicts=this.computeConflicts(o),this._onDidChangeConflicts.fire(l))}computeConflicts(o){return o.filter(l=>l.status==="hasConflicts").map(l=>[l.resource,l.conflicts.map(c)])}computeStatus(o){return this.userDataSyncStoreManagementService.userDataSyncStore?o.some(l=>l.status==="hasConflicts")?"hasConflicts":o.some(l=>l.status==="syncing")?"syncing":"idle":"uninitialized"}updateLastSyncTime(){this.status==="idle"&&(this._lastSyncTime=new Date().getTime(),this.storageService.store(r,this._lastSyncTime,-1,1),this._onDidChangeLastSyncTime.fire(this._lastSyncTime))}reportUserDataSyncError(o,l){this.telemetryService.publicLog2("sync/error",{code:o.code,serverCode:o instanceof u.UserDataSyncStoreError?String(o.serverCode):void 0,url:o instanceof u.UserDataSyncStoreError?o.url:void 0,resource:o.resource,executionId:l,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()})}getEnabledSynchronizers(){return this.synchronizers.value||(this.synchronizers.value=this.instantiationService.createInstance(a,o=>this.updateStatus(o),o=>this.updateConflicts(o),o=>this._onDidChangeLocal.fire(o))),this.synchronizers.value.enabled}checkEnablement(){if(!this.userDataSyncStoreManagementService.userDataSyncStore)throw new Error("Not enabled")}};n=me([Q(0,u.IUserDataSyncStoreService),Q(1,u.IUserDataSyncStoreManagementService),Q(2,p.IInstantiationService),Q(3,D.IConfigurationService),Q(4,u.IUserDataSyncLogService),Q(5,h.ITelemetryService),Q(6,C.IStorageService),Q(7,u.IUserDataSyncEnablementService)],n),e.UserDataSyncService=n;class i extends A.Disposable{constructor(o,l,v,y,O,_,F){super();this.id=o,this.manifest=l,this.syncHeaders=v,this.synchronisers=y,this.onStop=O,this.configurationService=_,this.logService=F,this.synchronizingResources=[],this._onSynchronizeResources=this._register(new L.Emitter),this.onSynchronizeResources=this._onSynchronizeResources.event,this.isDisposed=!1}get status(){return this.synchronisers.some(o=>o.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(o=>o.status==="syncing")?"syncing":"idle"}async preview(){try{if(this.isDisposed)throw new Error("Disposed");return this.previewsPromise||(this.previewsPromise=(0,t.createCancelablePromise)(o=>this.getPreviews(o))),this.previews||(this.previews=await this.previewsPromise),this.previews}catch(o){throw this.logService.error(o),o}}async accept(o,l){try{return await this.performAction(o,v=>v.accept(o,l))}catch(v){throw this.logService.error(v),v}}async merge(o){try{return o?await this.performAction(o,l=>l.merge(o)):await this.mergeAll()}catch(l){throw this.logService.error(l),l}}async discard(o){try{return await this.performAction(o,l=>l.discard(o))}catch(l){throw this.logService.error(l),l}}async discardConflicts(){try{if(!this.previews)throw new Error("Missing preview. Create preview and try again.");if(this.synchronizingResources.length)throw new Error("Cannot discard while synchronizing resources");const o=[];for(const[,l]of this.previews)for(const v of l.resourcePreviews)v.mergeState==="conflict"&&o.push(v.previewResource);for(const l of o)await this.discard(l);return this.previews}catch(o){throw this.logService.error(o),o}}async apply(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");const o=[];for(const[l,v]of this.previews){this.synchronizingResources.push([l,v.resourcePreviews.map(_=>_.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const y=this.synchronisers.find(_=>_.resource===l);for(const _ of v.resourcePreviews)(_.localChange!==0||_.remoteChange!==0)&&_.mergeState==="preview"&&await y.merge(_.previewResource);const O=await y.apply(!1,this.syncHeaders);O&&o.push(this.toSyncResourcePreview(y.resource,O)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(_=>_[0]===l),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=o,this.previews}catch(o){throw this.logService.error(o),o}}async pull(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[o,l]of this.previews){this.synchronizingResources.push([o,l.resourcePreviews.map(y=>y.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const v=this.synchronisers.find(y=>y.resource===o);for(const y of l.resourcePreviews)await v.accept(y.remoteResource);await v.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(y=>y[0]===o),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(o){throw this.logService.error(o),o}}async push(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[o,l]of this.previews){this.synchronizingResources.push([o,l.resourcePreviews.map(y=>y.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const v=this.synchronisers.find(y=>y.resource===o);for(const y of l.resourcePreviews)await v.accept(y.localResource);await v.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(y=>y[0]===o),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(o){throw this.logService.error(o),o}}async stop(){await this.onStop(),this.reset()}async performAction(o,l){if(!this.previews)throw new Error("Missing preview. Create preview and try again.");const v=this.previews.findIndex(([,V])=>V.resourcePreviews.some(({localResource:W,previewResource:z,remoteResource:te})=>(0,I.isEqual)(o,W)||(0,I.isEqual)(o,z)||(0,I.isEqual)(o,te)));if(v===-1)return this.previews;const[y,O]=this.previews[v],_=O.resourcePreviews.find(({localResource:V,remoteResource:W,previewResource:z})=>(0,I.isEqual)(V,o)||(0,I.isEqual)(W,o)||(0,I.isEqual)(z,o));if(!_)return this.previews;let F=this.synchronizingResources.find(V=>V[0]===y);F||(F=[y,[]],this.synchronizingResources.push(F)),F[1].some(V=>(0,I.isEqual)(V,_.localResource))||(F[1].push(_.localResource),this._onSynchronizeResources.fire(this.synchronizingResources));const R=this.synchronisers.find(V=>V.resource===this.previews[v][0]),U=await l(R);U?this.previews.splice(v,1,this.toSyncResourcePreview(R.resource,U)):this.previews.splice(v,1);const M=this.synchronizingResources.findIndex(V=>V[0]===y);return this.synchronizingResources[M][1].splice(F[1].findIndex(V=>(0,I.isEqual)(V,_.localResource)),1),F[1].length||(this.synchronizingResources.splice(M,1),this._onSynchronizeResources.fire(this.synchronizingResources)),this.previews}async mergeAll(){if(!this.previews)throw new Error("You need to create preview before merging or applying");if(this.synchronizingResources.length)throw new Error("Cannot merge or apply while synchronizing resources");const o=[];for(const[l,v]of this.previews){this.synchronizingResources.push([l,v.resourcePreviews.map(_=>_.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const y=this.synchronisers.find(_=>_.resource===l);let O=v;for(const _ of v.resourcePreviews)(_.localChange!==0||_.remoteChange!==0)&&_.mergeState==="preview"&&(O=await y.merge(_.previewResource));O&&o.push(this.toSyncResourcePreview(y.resource,O)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(_=>_[0]===l),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=o,this.previews}async getPreviews(o){const l=[],v=await this.getUserDataSyncConfiguration();for(const y of this.synchronisers){if(o.isCancellationRequested)return[];const O=await y.preview(this.manifest,v,this.syncHeaders);O&&l.push(this.toSyncResourcePreview(y.resource,O))}return l}async getUserDataSyncConfiguration(){const o=this.configurationService.getValue(u.USER_DATA_SYNC_CONFIGURATION_SCOPE),l=this.synchronisers.find(v=>v instanceof m.SettingsSynchroniser);if(l){const v=await l.getRemoteUserDataSyncConfiguration(this.manifest);return{...o,...v}}return o}toSyncResourcePreview(o,l){return[o,{isLastSyncFromCurrentMachine:l.isLastSyncFromCurrentMachine,resourcePreviews:l.resourcePreviews.map(c)}]}reset(){this.previewsPromise&&(this.previewsPromise.cancel(),this.previewsPromise=void 0),this.previews=void 0,this.synchronizingResources=[]}dispose(){this.reset(),this.isDisposed=!0}}let a=class extends A.Disposable{constructor(o,l,v,y,O,_,F){super();this.onDidChangeStatus=o,this.onDidChangeConflicts=l,this.onDidChangeLocal=v,this.userDataSyncEnablementService=y,this.instantiationService=O,this.extensionGalleryService=_,this.logService=F,this._enabled=[],this._register(y.onDidChangeResourceEnablement(([R,U])=>this.onDidChangeResourceEnablement(R,U))),this._register((0,A.toDisposable)(()=>this._enabled.splice(0,this._enabled.length).forEach(([,,R])=>R.dispose())));for(const R of u.ALL_SYNC_RESOURCES)y.isResourceEnabled(R)&&this.registerSynchronizer(R)}get enabled(){return this._enabled.sort((o,l)=>o[1]-l[1]).map(([o])=>o)}get disabled(){return u.ALL_SYNC_RESOURCES.filter(o=>!this.userDataSyncEnablementService.isResourceEnabled(o))}onDidChangeResourceEnablement(o,l){l?this.registerSynchronizer(o):this.deRegisterSynchronizer(o)}registerSynchronizer(o){if(this._enabled.some(([O])=>O.resource===o))return;if(o==="extensions"&&!this.extensionGalleryService.isEnabled()){this.logService.info("Skipping extensions sync because gallery is not configured");return}const l=new A.DisposableStore,v=l.add(this.createSynchronizer(o));l.add(v.onDidChangeStatus(()=>this.onDidChangeStatus(this.enabled))),l.add(v.onDidChangeConflicts(()=>this.onDidChangeConflicts(this.enabled))),l.add(v.onDidChangeLocal(()=>this.onDidChangeLocal(o)));const y=this.getOrder(o);this._enabled.push([v,y,l])}deRegisterSynchronizer(o){const l=this._enabled.findIndex(([v])=>v.resource===o);if(l!==-1){const v=this._enabled.splice(l,1);for(const[y,,O]of v){if(y.status!=="idle"){const _=y.conflicts.length>0;y.stop(),_&&this.onDidChangeConflicts(this.enabled),this.onDidChangeStatus(this.enabled)}O.dispose()}}}createSynchronizer(o){switch(o){case"settings":return this.instantiationService.createInstance(m.SettingsSynchroniser);case"keybindings":return this.instantiationService.createInstance(d.KeybindingsSynchroniser);case"snippets":return this.instantiationService.createInstance(g.SnippetsSynchroniser);case"tasks":return this.instantiationService.createInstance(f.TasksSynchroniser);case"globalState":return this.instantiationService.createInstance(w.GlobalStateSynchroniser);case"extensions":return this.instantiationService.createInstance(S.ExtensionsSynchroniser)}}getOrder(o){switch(o){case"settings":return 0;case"keybindings":return 1;case"snippets":return 2;case"tasks":return 3;case"globalState":return 4;case"extensions":return 5}}};a=me([Q(3,u.IUserDataSyncEnablementService),Q(4,p.IInstantiationService),Q(5,E.IExtensionGalleryService),Q(6,u.IUserDataSyncLogService)],a);function c(s){return{baseResource:s.baseResource,localResource:s.localResource,previewResource:s.previewResource,remoteResource:s.remoteResource,acceptedResource:s.acceptedResource,localChange:s.localChange,remoteChange:s.remoteChange,mergeState:s.mergeState}}}),define(re[257],se([0,1,3,2,14,8,25]),function(Z,e,k,t,T,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;class I{constructor(E,p){this.service=E,this.logService=p,this.manualSyncTasks=new Map,this.onManualSynchronizeResources=new k.Emitter}listen(E,p){switch(p){case"onDidChangeStatus":return this.service.onDidChangeStatus;case"onDidChangeConflicts":return this.service.onDidChangeConflicts;case"onDidChangeLocal":return this.service.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.service.onDidChangeLastSyncTime;case"onSyncErrors":return this.service.onSyncErrors;case"onDidResetLocal":return this.service.onDidResetLocal;case"onDidResetRemote":return this.service.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.onManualSynchronizeResources.event}throw new Error(`Event not found: ${p}`)}async call(E,p,C){try{return await this._call(E,p,C)}catch(h){throw this.logService.error(h),h}}async _call(E,p,C){switch(p){case"_getInitialData":return Promise.resolve([this.service.status,this.service.conflicts,this.service.lastSyncTime]);case"replace":return this.service.replace(L.URI.revive(C[0]));case"reset":return this.service.reset();case"resetRemote":return this.service.resetRemote();case"resetLocal":return this.service.resetLocal();case"hasPreviouslySynced":return this.service.hasPreviouslySynced();case"hasLocalData":return this.service.hasLocalData();case"accept":return this.service.accept(C[0],L.URI.revive(C[1]),C[2],C[3]);case"resolveContent":return this.service.resolveContent(L.URI.revive(C[0]));case"getLocalSyncResourceHandles":return this.service.getLocalSyncResourceHandles(C[0]);case"getRemoteSyncResourceHandles":return this.service.getRemoteSyncResourceHandles(C[0]);case"getAssociatedResources":return this.service.getAssociatedResources(C[0],{created:C[1].created,uri:L.URI.revive(C[1].uri)});case"getMachineId":return this.service.getMachineId(C[0],{created:C[1].created,uri:L.URI.revive(C[1].uri)});case"createManualSyncTask":return this.createManualSyncTask()}if(p.startsWith("manualSync/")){const h=p.substring("manualSync/".length),S=C[0],w=this.getManualSyncTask(S);switch(C=C.slice(1),h){case"preview":return w.preview();case"accept":return w.accept(L.URI.revive(C[0]),C[1]);case"merge":return w.merge(L.URI.revive(C[0]));case"discard":return w.discard(L.URI.revive(C[0]));case"discardConflicts":return w.discardConflicts();case"apply":return w.apply();case"pull":return w.pull();case"push":return w.push();case"stop":return w.stop();case"_getStatus":return w.status;case"dispose":return this.disposeManualSyncTask(w)}}throw new Error("Invalid call")}getManualSyncTask(E){const p=this.manualSyncTasks.get(this.createKey(E));if(!p)throw new Error(`Manual sync taks not found: ${E}`);return p.manualSyncTask}async createManualSyncTask(){const E=new t.DisposableStore,p=E.add(await this.service.createManualSyncTask());return E.add(p.onSynchronizeResources(C=>this.onManualSynchronizeResources.fire({manualSyncTaskId:p.id,data:C}))),this.manualSyncTasks.set(this.createKey(p.id),{manualSyncTask:p,disposables:E}),{id:p.id,manifest:p.manifest,status:p.status}}disposeManualSyncTask(E){E.dispose();const p=this.createKey(E.id);this.manualSyncTasks.get(p)?.disposables.dispose(),this.manualSyncTasks.delete(p)}createKey(E){return`manualSyncTask-${E}`}}e.UserDataSyncChannel=I;class b extends t.Disposable{constructor(E){super();this._status="uninitialized",this._onDidChangeStatus=this._register(new k.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new k.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new k.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onSyncErrors=this._register(new k.Emitter),this.onSyncErrors=this._onSyncErrors.event,this.channel={call(p,C,h){return E.call(p,C,h).then(null,S=>{throw A.UserDataSyncError.toUserDataSyncError(S)})},listen(p,C){return E.listen(p,C)}},this.channel.call("_getInitialData").then(([p,C,h])=>{this.updateStatus(p),this.updateConflicts(C),h&&this.updateLastSyncTime(h),this._register(this.channel.listen("onDidChangeStatus")(S=>this.updateStatus(S))),this._register(this.channel.listen("onDidChangeLastSyncTime")(S=>this.updateLastSyncTime(S)))}),this._register(this.channel.listen("onDidChangeConflicts")(p=>this.updateConflicts(p))),this._register(this.channel.listen("onSyncErrors")(p=>this._onSyncErrors.fire(p.map(([C,h])=>[C,A.UserDataSyncError.toUserDataSyncError(h)]))))}get status(){return this._status}get onDidChangeLocal(){return this.channel.listen("onDidChangeLocal")}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}get onDidResetLocal(){return this.channel.listen("onDidResetLocal")}get onDidResetRemote(){return this.channel.listen("onDidResetRemote")}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const{id:E,manifest:p,status:C}=await this.channel.call("createManualSyncTask"),h=this,S=new P(E,p,C,{async call(w,d,m){return h.channel.call(`manualSync/${w}`,[E,...(0,T.isArray)(d)?d:[d]],m)},listen(w,d){return k.Event.map(k.Event.filter(h.channel.listen(`manualSync/${w}`,d),m=>!S.isDiposed()&&m.manualSyncTaskId===E),m=>m.data)}});return S}replace(E){return this.channel.call("replace",[E])}reset(){return this.channel.call("reset")}resetRemote(){return this.channel.call("resetRemote")}resetLocal(){return this.channel.call("resetLocal")}hasPreviouslySynced(){return this.channel.call("hasPreviouslySynced")}hasLocalData(){return this.channel.call("hasLocalData")}accept(E,p,C,h){return this.channel.call("accept",[E,p,C,h])}resolveContent(E){return this.channel.call("resolveContent",[E])}async getLocalSyncResourceHandles(E){return(await this.channel.call("getLocalSyncResourceHandles",[E])).map(({created:C,uri:h})=>({created:C,uri:L.URI.revive(h)}))}async getRemoteSyncResourceHandles(E){return(await this.channel.call("getRemoteSyncResourceHandles",[E])).map(({created:C,uri:h})=>({created:C,uri:L.URI.revive(h)}))}async getAssociatedResources(E,p){return(await this.channel.call("getAssociatedResources",[E,p])).map(({resource:h,comparableResource:S})=>({resource:L.URI.revive(h),comparableResource:L.URI.revive(S)}))}async getMachineId(E,p){return this.channel.call("getMachineId",[E,p])}async updateStatus(E){this._status=E,this._onDidChangeStatus.fire(E)}async updateConflicts(E){this._conflicts=E.map(([p,C])=>[p,C.map(h=>({...h,baseResource:L.URI.revive(h.baseResource),localResource:L.URI.revive(h.localResource),remoteResource:L.URI.revive(h.remoteResource),previewResource:L.URI.revive(h.previewResource)}))]),this._onDidChangeConflicts.fire(this._conflicts)}updateLastSyncTime(E){this._lastSyncTime!==E&&(this._lastSyncTime=E,this._onDidChangeLastSyncTime.fire(E))}}e.UserDataSyncChannelClient=b;class P extends t.Disposable{constructor(E,p,C,h){super();this.id=E,this.manifest=p,this._disposed=!1,this._status=C;const S=this;this.channel={async call(w,d,m){try{const g=await h.call(w,d,m);return S.isDiposed()||(S._status=await h.call("_getStatus")),g}catch(g){throw A.UserDataSyncError.toUserDataSyncError(g)}},listen(w,d){return h.listen(w,d)}}}get onSynchronizeResources(){return this.channel.listen("onSynchronizeResources")}get status(){return this._status}async preview(){const E=await this.channel.call("preview");return this.deserializePreviews(E)}async accept(E,p){const C=await this.channel.call("accept",[E,p]);return this.deserializePreviews(C)}async merge(E){const p=await this.channel.call("merge",[E]);return this.deserializePreviews(p)}async discard(E){const p=await this.channel.call("discard",[E]);return this.deserializePreviews(p)}async discardConflicts(){const E=await this.channel.call("discardConflicts");return this.deserializePreviews(E)}async apply(){const E=await this.channel.call("apply");return this.deserializePreviews(E)}pull(){return this.channel.call("pull")}push(){return this.channel.call("push")}stop(){return this.channel.call("stop")}isDiposed(){return this._disposed}dispose(){this._disposed=!0,this.channel.call("dispose")}deserializePreviews(E){return E.map(([p,C])=>[p,{isLastSyncFromCurrentMachine:C.isLastSyncFromCurrentMachine,resourcePreviews:C.resourcePreviews.map(h=>({...h,baseResource:L.URI.revive(h.baseResource),localResource:L.URI.revive(h.localResource),remoteResource:L.URI.revive(h.remoteResource),previewResource:L.URI.revive(h.previewResource),acceptedResource:L.URI.revive(h.acceptedResource)}))}])}}}),define(re[258],se([0,1,6,23,9,3,2,125,4,19,14,8,31,18,15,13,24,44,49,22,25]),function(Z,e,k,t,T,L,A,I,b,P,D,E,p,C,h,S,w,d,m,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const u="sync.previous.store",r="sync.donot-make-requests-until",n="sync.user-session-id",i="sync.machine-session-id",a=100,c=1e3*60*5;let s=class extends A.Disposable{constructor(_,F,R){super();this.productService=_,this.configurationService=F,this.storageService=R,this._onDidChangeUserDataSyncStore=this._register(new L.Emitter),this.onDidChangeUserDataSyncStore=this._onDidChangeUserDataSyncStore.event,this.updateUserDataSyncStore(),this._register(L.Event.filter(R.onDidChangeValue,U=>U.key===f.SYNC_SERVICE_URL_TYPE&&U.scope===-1&&this.userDataSyncStoreType!==this.userDataSyncStore?.type)(()=>this.updateUserDataSyncStore()))}get userDataSyncStore(){return this._userDataSyncStore}get userDataSyncStoreType(){return this.storageService.get(f.SYNC_SERVICE_URL_TYPE,-1)}set userDataSyncStoreType(_){this.storageService.store(f.SYNC_SERVICE_URL_TYPE,_,-1,b.isWeb?0:1)}updateUserDataSyncStore(){this._userDataSyncStore=this.toUserDataSyncStore(this.productService[f.CONFIGURATION_SYNC_STORE_KEY],this.configurationService.getValue(f.CONFIGURATION_SYNC_STORE_KEY)),this._onDidChangeUserDataSyncStore.fire()}toUserDataSyncStore(_,F){_=b.isWeb&&_?.web?{..._,..._.web}:_;const R={..._||{},...F||{}};if(R&&(0,D.isString)(R.url)&&(0,D.isObject)(R.authenticationProviders)&&Object.keys(R.authenticationProviders).every(U=>(0,D.isArray)(R.authenticationProviders[U].scopes))){const U=R,M=!!U.canSwitch&&!F?.url,V=U.url===U.insidersUrl?"insiders":"stable",W=(M?this.userDataSyncStoreType:void 0)||V,z=F?.url||(W==="insiders"?U.insidersUrl:W==="stable"?U.stableUrl:U.url);return{url:E.URI.parse(z),type:W,defaultType:V,defaultUrl:E.URI.parse(U.url),stableUrl:E.URI.parse(U.stableUrl),insidersUrl:E.URI.parse(U.insidersUrl),canSwitch:M,authenticationProviders:Object.keys(U.authenticationProviders).reduce((te,H)=>(te.push({id:H,scopes:U.authenticationProviders[H].scopes}),te),[])}}}};s=me([Q(0,w.IProductService),Q(1,C.IConfigurationService),Q(2,g.IStorageService)],s),e.AbstractUserDataSyncStoreManagementService=s;let o=class extends s{constructor(_,F,R){super(_,F,R);const U=this.storageService.get(u,-1);U&&(this.previousConfigurationSyncStore=JSON.parse(U));const M=this.productService[f.CONFIGURATION_SYNC_STORE_KEY];M?this.storageService.store(u,JSON.stringify(M),-1,1):this.storageService.remove(u,-1)}async switch(_){_!==this.userDataSyncStoreType&&(this.userDataSyncStoreType=_,this.updateUserDataSyncStore())}async getPreviousUserDataSyncStore(){return this.toUserDataSyncStore(this.previousConfigurationSyncStore)}};o=me([Q(0,w.IProductService),Q(1,C.IConfigurationService),Q(2,g.IStorageService)],o),e.UserDataSyncStoreManagementService=o;let l=class extends A.Disposable{constructor(_,F,R,U,M,V,W){super();this.requestService=R,this.logService=U,this.storageService=W,this._onTokenFailed=this._register(new L.Emitter),this.onTokenFailed=this._onTokenFailed.event,this._onTokenSucceed=this._register(new L.Emitter),this.onTokenSucceed=this._onTokenSucceed.event,this._donotMakeRequestsUntil=void 0,this._onDidChangeDonotMakeRequestsUntil=this._register(new L.Emitter),this.onDidChangeDonotMakeRequestsUntil=this._onDidChangeDonotMakeRequestsUntil.event,this.resetDonotMakeRequestsUntilPromise=void 0,this.updateUserDataSyncStoreUrl(_),this.commonHeadersPromise=(0,m.getServiceMachineId)(M,V,W).then(z=>{const te={"X-Client-Name":`${F.applicationName}${b.isWeb?"-web":""}`,"X-Client-Version":F.version};return F.commit&&(te["X-Client-Commit"]=F.commit),te}),this.session=new y(a,c,this.requestService,this.logService),this.initDonotMakeRequestsUntil(),this._register((0,A.toDisposable)(()=>{this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0)}))}get donotMakeRequestsUntil(){return this._donotMakeRequestsUntil}setAuthToken(_,F){this.authToken={token:_,type:F}}updateUserDataSyncStoreUrl(_){this.userDataSyncStoreUrl=_?(0,P.joinPath)(_,"v1"):void 0}initDonotMakeRequestsUntil(){const _=this.storageService.getNumber(r,-1);_&&Date.now()<_&&this.setDonotMakeRequestsUntil(new Date(_))}setDonotMakeRequestsUntil(_){this._donotMakeRequestsUntil?.getTime()!==_?.getTime()&&(this._donotMakeRequestsUntil=_,this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0),this._donotMakeRequestsUntil?(this.storageService.store(r,this._donotMakeRequestsUntil.getTime(),-1,1),this.resetDonotMakeRequestsUntilPromise=(0,k.createCancelablePromise)(F=>(0,k.timeout)(this._donotMakeRequestsUntil.getTime()-Date.now(),F).then(()=>this.setDonotMakeRequestsUntil(void 0))),this.resetDonotMakeRequestsUntilPromise.then(null,F=>null)):this.storageService.remove(r,-1),this._onDidChangeDonotMakeRequestsUntil.fire())}async getAllRefs(_){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const F=(0,P.joinPath)(this.userDataSyncStoreUrl,"resource",_),R={},U=await this.request(F.toString(),{type:"GET",headers:R},[],t.CancellationToken.None);return(await(0,d.asJson)(U)||[]).map(({url:V,created:W})=>({ref:(0,P.relativePath)(F,F.with({path:V})),created:W*1e3}))}async resolveContent(_,F){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const R=(0,P.joinPath)(this.userDataSyncStoreUrl,"resource",_,F).toString(),U={};U["Cache-Control"]="no-cache";const M=await this.request(R,{type:"GET",headers:U},[],t.CancellationToken.None);return await(0,d.asTextOrError)(M)}async delete(_,F){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const R=F!==null?(0,P.joinPath)(this.userDataSyncStoreUrl,"resource",_,F).toString():(0,P.joinPath)(this.userDataSyncStoreUrl,"resource",_).toString(),U={};await this.request(R,{type:"DELETE",headers:U},[],t.CancellationToken.None)}async read(_,F,R={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const U=(0,P.joinPath)(this.userDataSyncStoreUrl,"resource",_,"latest").toString();R={...R},R["Cache-Control"]="no-cache",F&&(R["If-None-Match"]=F.ref);const M=await this.request(U,{type:"GET",headers:R},[304],t.CancellationToken.None);let V=null;if(M.res.statusCode===304&&(V=F),V===null){const W=M.res.headers.etag;if(!W)throw new f.UserDataSyncStoreError("Server did not return the ref",U,"NoRef",M.res.statusCode,M.res.headers[f.HEADER_OPERATION_ID]);const z=await(0,d.asTextOrError)(M);if(!z&&M.res.statusCode===304)throw new f.UserDataSyncStoreError("Empty response",U,"EmptyResponse",M.res.statusCode,M.res.headers[f.HEADER_OPERATION_ID]);V={ref:W,content:z}}return V}async write(_,F,R,U={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const M=(0,P.joinPath)(this.userDataSyncStoreUrl,"resource",_).toString();U={...U},U["Content-Type"]=I.Mimes.text,R&&(U["If-Match"]=R);const V=await this.request(M,{type:"POST",data:F,headers:U},[],t.CancellationToken.None),W=V.res.headers.etag;if(!W)throw new f.UserDataSyncStoreError("Server did not return the ref",M,"NoRef",V.res.statusCode,V.res.headers[f.HEADER_OPERATION_ID]);return W}async manifest(_,F={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const R=(0,P.joinPath)(this.userDataSyncStoreUrl,"manifest").toString();F={...F},F["Content-Type"]="application/json",_&&(F["If-None-Match"]=_.ref);const U=await this.request(R,{type:"GET",headers:F},[304],t.CancellationToken.None);let M=null;if(U.res.statusCode===304&&(M=_),!M){const W=U.res.headers.etag;if(!W)throw new f.UserDataSyncStoreError("Server did not return the ref",R,"NoRef",U.res.statusCode,U.res.headers[f.HEADER_OPERATION_ID]);const z=await(0,d.asTextOrError)(U);if(!z&&U.res.statusCode===304)throw new f.UserDataSyncStoreError("Empty response",R,"EmptyResponse",U.res.statusCode,U.res.headers[f.HEADER_OPERATION_ID]);z&&(M={...JSON.parse(z),ref:W})}const V=this.storageService.get(n,-1);return V&&M&&V!==M.session&&this.clearSession(),M===null&&V&&this.clearSession(),M&&this.storageService.store(n,M.session,-1,1),M}async clear(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const _=(0,P.joinPath)(this.userDataSyncStoreUrl,"resource").toString(),F={"Content-Type":I.Mimes.text};await this.request(_,{type:"DELETE",headers:F},[],t.CancellationToken.None),this.clearSession()}clearSession(){this.storageService.remove(n,-1),this.storageService.remove(i,-1)}async request(_,F,R,U){if(!this.authToken)throw new f.UserDataSyncStoreError("No Auth Token Available",_,"Unauthorized",void 0,void 0);if(this._donotMakeRequestsUntil&&Date.now()<this._donotMakeRequestsUntil.getTime())throw new f.UserDataSyncStoreError(`${F.type} request '${_}' failed because of too many requests (429).`,_,"TooManyRequestsAndRetryAfter",void 0,void 0);this.setDonotMakeRequestsUntil(void 0);const M=await this.commonHeadersPromise;F.headers={...F.headers||{},...M,"X-Account-Type":this.authToken.type,authorization:`Bearer ${this.authToken.token}`},this.addSessionHeaders(F.headers),this.logService.trace("Sending request to server",{url:_,type:F.type,headers:{...F.headers,authorization:void 0}});let V;try{V=await this.session.request(_,F,U)}catch(H){if(!(H instanceof f.UserDataSyncStoreError)){let K="RequestFailed";const X=(0,T.getErrorMessage)(H).toLowerCase();X.includes("xhr timeout")?K="RequestTimeout":X.includes("protocol")&&X.includes("not supported")?K="RequestProtocolNotSupported":X.includes("request path contains unescaped characters")?K="RequestPathNotEscaped":X.includes("headers must be an object")?K="RequestHeadersNotObject":(0,T.isCancellationError)(H)&&(K="RequestCanceled"),H=new f.UserDataSyncStoreError(`Connection refused for the request '${_}'.`,_,K,void 0,void 0)}throw this.logService.info("Request failed",_),H}const W=V.res.headers[f.HEADER_OPERATION_ID],z={url:_,status:V.res.statusCode,"execution-id":F.headers[f.HEADER_EXECUTION_ID],"operation-id":W},te=(0,d.isSuccess)(V)||V.res.statusCode&&R.indexOf(V.res.statusCode)!==-1;if(te?this.logService.trace("Request succeeded",z):this.logService.info("Request failed",z),V.res.statusCode===401)throw this.authToken=void 0,this._onTokenFailed.fire(),new f.UserDataSyncStoreError(`Request '${_}' failed because of Unauthorized (401).`,_,"Unauthorized",V.res.statusCode,W);if(this._onTokenSucceed.fire(),V.res.statusCode===409)throw new f.UserDataSyncStoreError(`${F.type} request '${_}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,_,"Conflict",V.res.statusCode,W);if(V.res.statusCode===410)throw new f.UserDataSyncStoreError(`${F.type} request '${_}' failed because the requested resource is not longer available (410).`,_,"Gone",V.res.statusCode,W);if(V.res.statusCode===412)throw new f.UserDataSyncStoreError(`${F.type} request '${_}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,_,"PreconditionFailed",V.res.statusCode,W);if(V.res.statusCode===413)throw new f.UserDataSyncStoreError(`${F.type} request '${_}' failed because of too large payload (413).`,_,"TooLarge",V.res.statusCode,W);if(V.res.statusCode===426)throw new f.UserDataSyncStoreError(`${F.type} request '${_}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,_,"UpgradeRequired",V.res.statusCode,W);if(V.res.statusCode===429){const H=V.res.headers["retry-after"];throw H?(this.setDonotMakeRequestsUntil(new Date(Date.now()+parseInt(H)*1e3)),new f.UserDataSyncStoreError(`${F.type} request '${_}' failed because of too many requests (429).`,_,"TooManyRequestsAndRetryAfter",V.res.statusCode,W)):new f.UserDataSyncStoreError(`${F.type} request '${_}' failed because of too many requests (429).`,_,"RemoteTooManyRequests",V.res.statusCode,W)}if(!te)throw new f.UserDataSyncStoreError("Server returned "+V.res.statusCode,_,"Unknown",V.res.statusCode,W);return V}addSessionHeaders(_){let F=this.storageService.get(i,-1);F===void 0&&(F=(0,p.generateUuid)(),this.storageService.store(i,F,-1,1)),_["X-Machine-Session-Id"]=F;const R=this.storageService.get(n,-1);R!==void 0&&(_["X-User-Session-Id"]=R)}};l=me([Q(1,w.IProductService),Q(2,d.IRequestService),Q(3,f.IUserDataSyncLogService),Q(4,h.IEnvironmentService),Q(5,S.IFileService),Q(6,g.IStorageService)],l),e.UserDataSyncStoreClient=l;let v=class extends l{constructor(_,F,R,U,M,V,W){super(_.userDataSyncStore?.url,F,R,U,M,V,W);this._register(_.onDidChangeUserDataSyncStore(()=>this.updateUserDataSyncStoreUrl(_.userDataSyncStore?.url)))}};v=me([Q(0,f.IUserDataSyncStoreManagementService),Q(1,w.IProductService),Q(2,d.IRequestService),Q(3,f.IUserDataSyncLogService),Q(4,h.IEnvironmentService),Q(5,S.IFileService),Q(6,g.IStorageService)],v),e.UserDataSyncStoreService=v;class y{constructor(_,F,R,U){this.limit=_,this.interval=F,this.requestService=R,this.logService=U,this.requests=[],this.startTime=void 0}request(_,F,R){if(this.isExpired()&&this.reset(),F.url=_,this.requests.length>=this.limit)throw this.logService.info("Too many requests",...this.requests),new f.UserDataSyncStoreError(`Too many requests. Only ${this.limit} requests allowed in ${this.interval/(1e3*60)} minutes.`,_,"LocalTooManyRequests",void 0,void 0);return this.startTime=this.startTime||new Date,this.requests.push(_),this.requestService.request(F,R)}isExpired(){return this.startTime!==void 0&&new Date().getTime()-this.startTime.getTime()>this.interval}reset(){this.requests=[],this.startTime=void 0}}e.RequestsSession=y}),define(re[259],se([0,1,3,68,24,22,21,255,25,73,74]),function(Z,e,k,t,T,L,A,I,b,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let E=class extends I.UserDataAutoSyncService{constructor(C,h,S,w,d,m,g,f,u,r,n){super(C,h,S,w,d,g,f,u,r,n);this._register(k.Event.debounce(k.Event.any(k.Event.map(m.onDidFocusWindow,()=>"windowFocus"),k.Event.map(m.onDidOpenWindow,()=>"windowOpen")),(i,a)=>i?[...i,a]:[a],1e3)(i=>this.triggerSync(i,!0,!1)))}};E=me([Q(0,T.IProductService),Q(1,b.IUserDataSyncStoreManagementService),Q(2,b.IUserDataSyncStoreService),Q(3,b.IUserDataSyncEnablementService),Q(4,b.IUserDataSyncService),Q(5,t.INativeHostService),Q(6,b.IUserDataSyncLogService),Q(7,P.IUserDataSyncAccountService),Q(8,A.ITelemetryService),Q(9,D.IUserDataSyncMachinesService),Q(10,L.IStorageService)],E),e.UserDataAutoSyncService=E}),define(re[260],se([0,1,6,3,2]),function(Z,e,k,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class L extends T.Disposable{constructor({onDidOpenWindow:I,onDidFocusWindow:b,getActiveWindowId:P}){super();this.disposables=this._register(new T.DisposableStore),t.Event.latch(t.Event.any(I,b))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,k.createCancelablePromise)(()=>P()),(async()=>{try{const E=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:E}catch{}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(I){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=I}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=L}),define(re[109],se([0,1,54,6,12,14,27,137,272,273]),function(Z,e,k,t,T,L,A,I,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class D extends Error{constructor(r,n){let i=n.message;switch(r){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i);this.type=r,this.cause=n}}e.ExtractError=D;function E(u){const r=u.externalFileAttributes>>16||33188;return[448,56,7].map(n=>r&n).reduce((n,i)=>n+i,r&61440)}function p(u){if(u instanceof D)return u;let r;return/end of central directory record signature not found/.test(u.message)&&(r="CorruptZip"),new D(r,u)}function C(u,r,n,i,a,c){const s=T.dirname(r),o=T.join(i,s);if(!o.startsWith(i))return Promise.reject(new Error(I.localize(0,null,r)));const l=T.join(i,r);let v;return c.onCancellationRequested(()=>{v&&v.destroy()}),Promise.resolve(A.Promises.mkdir(o,{recursive:!0})).then(()=>new Promise((y,O)=>{if(!c.isCancellationRequested)try{v=(0,k.createWriteStream)(l,{mode:n}),v.once("close",()=>y()),v.once("error",O),u.once("error",O),u.pipe(v)}catch(_){O(_)}}))}function h(u,r,n,i){let a=(0,t.createCancelablePromise)(()=>Promise.resolve()),c=0;return i.onCancellationRequested(()=>{a.cancel(),u.close()}),new Promise((s,o)=>{const l=new t.Sequencer,v=y=>{y.isCancellationRequested||(c++,u.readEntry())};u.once("error",o),u.once("close",()=>a.then(()=>{i.isCancellationRequested||u.entryCount===c?s():o(new D("Incomplete",new Error(I.localize(1,null,c,u.entryCount))))},o)),u.readEntry(),u.on("entry",y=>{if(i.isCancellationRequested)return;if(!n.sourcePathRegex.test(y.fileName)){v(i);return}const O=y.fileName.replace(n.sourcePathRegex,"");if(/\/$/.test(O)){const R=T.join(r,O);a=(0,t.createCancelablePromise)(U=>A.Promises.mkdir(R,{recursive:!0}).then(()=>v(U)).then(void 0,o));return}const _=w(u,y),F=E(y);a=(0,t.createCancelablePromise)(R=>l.queue(()=>_.then(U=>C(U,O,F,r,n,R).then(()=>v(R)))).then(null,o))})})}function S(u,r=!1){return new Promise((n,i)=>{(0,b.open)(u,r?{lazyEntries:!0}:void 0,(a,c)=>{a?i(p(a)):n((0,L.assertIsDefined)(c))})})}function w(u,r){return new Promise((n,i)=>{u.openReadStream(r,(a,c)=>{a?i(p(a)):n((0,L.assertIsDefined)(c))})})}function d(u,r){return new Promise((n,i)=>{const a=new P.ZipFile;r.forEach(s=>{s.contents?a.addBuffer(typeof s.contents=="string"?Buffer.from(s.contents,"utf8"):s.contents,s.path):s.localPath&&a.addFile(s.localPath,s.path)}),a.end();const c=(0,k.createWriteStream)(u);a.outputStream.pipe(c),a.outputStream.once("error",i),c.once("error",i),c.once("finish",()=>n(u))})}e.zip=d;function m(u,r,n={},i){const a=new RegExp(n.sourcePath?`^${n.sourcePath}`:"");let c=S(u,!0);return n.overwrite&&(c=c.then(s=>A.Promises.rm(r).then(()=>s))),c.then(s=>h(s,r,{sourcePathRegex:a},i))}e.extract=m;function g(u,r){return S(u).then(n=>new Promise((i,a)=>{n.on("entry",c=>{c.fileName===r&&w(n,c).then(s=>i(s),s=>a(s))}),n.once("close",()=>a(new Error(I.localize(2,null,r))))}))}function f(u,r){return g(u,r).then(n=>new Promise((i,a)=>{const c=[];n.once("error",a),n.on("data",s=>c.push(s)),n.on("end",()=>i(Buffer.concat(c)))}))}e.buffer=f}),define(re[261],se([0,1,109,146]),function(Z,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function T(L){return(0,k.buffer)(L,"extension/package.json").then(A=>{try{return JSON.parse(A.toString("utf8"))}catch{throw new Error((0,t.localize)(0,null))}})}e.getManifest=T}),define(re[110],se([0,1,6,37,9,2,20,12,4,19,55,14,8,31,27,109,145,91,15,232,30,32,46,71,199,233,261,200,229,50,66,13,5,7,24,21,33,28]),function(Z,e,k,t,T,L,A,I,b,P,D,E,p,C,h,S,w,d,m,g,f,u,r,n,i,a,c,s,o,l,v,y,O,_,F,R,U,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementService=e.INativeServerExtensionManagementService=void 0,e.INativeServerExtensionManagementService=(0,O.refineServiceDecorator)(f.IServerExtensionManagementService);let V=class extends g.AbstractExtensionManagementService{constructor(Y,x,B,J,N,$,j,G,q,ee,ne,oe){super(oe,ne,Y,$,x,B,ee);this.environmentService=J,this.extensionsScannerService=N,this.downloadService=j,this.fileService=q;const le=this._register(G.createInstance(a.ExtensionsLifecycle));this.extensionsScanner=this._register(G.createInstance(W,fe=>le.postUninstall(fe))),this.manifestCache=this._register(new s.ExtensionsManifestCache(J,this)),this.extensionsDownloader=this._register(G.createInstance(i.ExtensionsDownloader));const Se=this._register(new o.ExtensionsWatcher(this,q,J,B,ne));this._register(Se.onDidChangeExtensionsByAnotherSource(({added:fe,removed:pe})=>{fe.length&&this._onDidInstallExtensions.fire(fe.map(Ce=>({identifier:Ce.identifier,operation:1,local:Ce}))),pe.forEach(Ce=>this._onDidUninstallExtension.fire({identifier:Ce}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,u.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async zip(Y){this.logService.trace("ExtensionManagementService#zip",Y.identifier.id);const x=await this.collectFiles(Y),B=await(0,S.zip)((0,P.joinPath)(this.environmentService.tmpDir,(0,C.generateUuid)()).fsPath,x);return p.URI.file(B)}async unzip(Y){return this.logService.trace("ExtensionManagementService#unzip",Y.toString()),(await this.install(Y)).identifier}async getManifest(Y){const x=await this.downloadVsix(Y),B=I.resolve(x.fsPath);return(0,c.getManifest)(B)}getInstalled(Y,x){return this.extensionsScanner.scanExtensions(Y??null,x)}getAllUserInstalled(){return this.extensionsScanner.scanUserExtensions(!1)}async install(Y,x={}){this.logService.trace("ExtensionManagementService#install",Y.toString());const B=await this.downloadVsix(Y),J=await(0,c.getManifest)(I.resolve(B.fsPath));if(J.engines&&J.engines.vscode&&!(0,v.isEngineValid)(J.engines.vscode,this.productService.version,this.productService.date))throw new Error(w.localize(0,null,(0,u.getGalleryExtensionId)(J.publisher,J.name),this.productService.version));return this.installExtension(J,B,x)}getMetadata(Y){return this.extensionsScannerService.scanMetadata(Y.location)}async updateMetadata(Y,x){this.logService.trace("ExtensionManagementService#updateMetadata",Y.identifier.id);const B={...x};return x.isPreReleaseVersion&&(B.preRelease=!0),Y=await this.extensionsScanner.updateMetadata(Y,B),this.manifestCache.invalidate(),Y}async updateExtensionScope(Y,x){return this.logService.trace("ExtensionManagementService#updateExtensionScope",Y.identifier.id),Y=await this.extensionsScanner.updateMetadata(Y,{isMachineScoped:x}),this.manifestCache.invalidate(),Y}removeUninstalledExtensions(Y){return this.extensionsScanner.cleanUp(Y)}async downloadVsix(Y){if(Y.scheme===A.Schemas.file)return Y;const x=(0,P.joinPath)(this.environmentService.tmpDir,(0,C.generateUuid)());return await this.downloadService.download(Y,x),x}createDefaultInstallExtensionTask(Y,x,B){return p.URI.isUri(x)?new H(Y,x,B,this.galleryService,this.extensionsScanner,this.logService):new te(Y,x,B,this.extensionsDownloader,this.extensionsScanner,this.logService)}createDefaultUninstallExtensionTask(Y,x){return new K(Y,x,this.extensionsScanner)}async collectFiles(Y){const x=async J=>{let N=await h.Promises.readdir(J);N=N.map(G=>I.join(J,G));const $=await Promise.all(N.map(G=>h.Promises.stat(G)));let j=Promise.resolve([]);return $.forEach((G,q)=>{const ee=N[q];G.isFile()&&(j=j.then(ne=>[...ne,ee])),G.isDirectory()&&(j=j.then(ne=>x(ee).then(oe=>[...ne,...oe])))}),j};return(await x(Y.location.fsPath)).map(J=>({path:`extension/${I.relative(Y.location.fsPath,J)}`,localPath:J}))}};V=me([Q(0,f.IExtensionGalleryService),Q(1,R.ITelemetryService),Q(2,_.ILogService),Q(3,m.INativeEnvironmentService),Q(4,n.IExtensionsScannerService),Q(5,r.IExtensionsProfileScannerService),Q(6,d.IDownloadService),Q(7,O.IInstantiationService),Q(8,y.IFileService),Q(9,F.IProductService),Q(10,U.IUriIdentityService),Q(11,M.IUserDataProfilesService)],V),e.ExtensionManagementService=V;let W=class extends L.Disposable{constructor(Y,x,B,J){super();this.beforeRemovingExtension=Y,this.fileService=x,this.extensionsScannerService=B,this.logService=J,this.uninstalledPath=(0,P.joinPath)(this.extensionsScannerService.userExtensionsLocation,".obsolete").fsPath,this.uninstalledFileLimiter=new k.Queue}async cleanUp(Y){await this.removeUninstalledExtensions(),Y&&await this.removeOutdatedExtensions()}async scanExtensions(Y,x){const B={includeInvalid:!0,profileLocation:x};let J=[];return Y===null||Y===0?J.push(...await this.extensionsScannerService.scanAllExtensions({includeInvalid:!0},B)):Y===1&&J.push(...await this.extensionsScannerService.scanUserExtensions(B)),J=Y!==null?J.filter(N=>N.type===Y):J,Promise.all(J.map(N=>this.toLocalExtension(N)))}async scanUserExtensions(Y){const x=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!Y,includeInvalid:!0});return Promise.all(x.map(B=>this.toLocalExtension(B)))}async extractUserExtension(Y,x,B,J){const N=Y.toString(),$=I.join(this.extensionsScannerService.userExtensionsLocation.fsPath,`.${(0,C.generateUuid)()}`),j=I.join(this.extensionsScannerService.userExtensionsLocation.fsPath,N);try{await h.Promises.rm(j)}catch{throw new f.ExtensionManagementError(w.localize(1,null,j,Y.id),f.ExtensionManagementErrorCode.Delete)}await this.extractAtLocation(Y,x,$,J),B={...B,installedTimestamp:Date.now()},await this.extensionsScannerService.updateMetadata(p.URI.file($),B);try{await this.rename(Y,$,j,Date.now()+2*60*1e3),this.logService.info("Renamed to",j)}catch(G){try{await h.Promises.rm($)}catch{}if(G.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",Y.id);else throw this.logService.info(`Rename failed because of ${(0,T.getErrorMessage)(G)}. Deleted from extracted location`,$),G}return this.scanLocalExtension(p.URI.file(j),1)}async updateMetadata(Y,x){return await this.extensionsScannerService.updateMetadata(Y.location,x),this.scanLocalExtension(Y.location,Y.type)}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...Y){const x=Y.map(B=>u.ExtensionKey.create(B));await this.withUninstalledExtensions(B=>{x.forEach(J=>B[J.toString()]=!0)})}async setInstalled(Y){await this.withUninstalledExtensions(J=>delete J[Y.toString()]);const B=(await this.scanUserExtensions(!0)).find(J=>u.ExtensionKey.create(J).equals(Y))||null;return B?this.updateMetadata(B,{installedTimestamp:Date.now()}):null}async removeExtension(Y,x){this.logService.trace(`Deleting ${x} extension from disk`,Y.identifier.id,Y.location.fsPath),await h.Promises.rm(Y.location.fsPath),this.logService.info("Deleted from disk",Y.identifier.id,Y.location.fsPath)}async removeUninstalledExtension(Y){await this.removeExtension(Y,"uninstalled"),await this.withUninstalledExtensions(x=>delete x[u.ExtensionKey.create(Y).toString()])}async withUninstalledExtensions(Y){return this.uninstalledFileLimiter.queue(async()=>{let x;try{x=await h.Promises.readFile(this.uninstalledPath,"utf8")}catch(J){if(J.code!=="ENOENT")throw J}let B={};if(x)try{B=JSON.parse(x)}catch{}return Y&&(Y(B),Object.keys(B).length?await h.Promises.writeFile(this.uninstalledPath,JSON.stringify(B)):await h.Promises.rm(this.uninstalledPath)),B})}async extractAtLocation(Y,x,B,J){this.logService.trace(`Started extracting the extension from ${x} to ${B}`);try{await h.Promises.rm(B)}catch(N){throw new f.ExtensionManagementError(this.joinErrors(N).message,f.ExtensionManagementErrorCode.Delete)}try{await(0,S.extract)(x,B,{sourcePath:"extension",overwrite:!0},J),this.logService.info(`Extracted extension to ${B}:`,Y.id)}catch(N){try{await h.Promises.rm(B)}catch{}let $=f.ExtensionManagementErrorCode.Extract;throw N instanceof S.ExtractError&&(N.type==="CorruptZip"?$=f.ExtensionManagementErrorCode.CorruptZip:N.type==="Incomplete"&&($=f.ExtensionManagementErrorCode.IncompleteZip)),new f.ExtensionManagementError(N.message,$)}}async rename(Y,x,B,J){try{await h.Promises.rename(x,B)}catch(N){if(b.isWindows&&N&&N.code==="EPERM"&&Date.now()<J)return this.logService.info(`Failed renaming ${x} to ${B} with 'EPERM' error. Trying again...`,Y.id),this.rename(Y,x,B,J);throw new f.ExtensionManagementError(N.message||w.localize(2,null,x,B),N.code||f.ExtensionManagementErrorCode.Rename)}}async scanLocalExtension(Y,x){const B=await this.extensionsScannerService.scanExistingExtension(Y,x,{includeInvalid:!0});if(B)return this.toLocalExtension(B);throw new Error(w.localize(3,null,Y.path))}async toLocalExtension(Y){const x=await this.fileService.resolve(Y.location);let B,J;return x.children&&(B=x.children.find(({name:N})=>/^readme(\.txt|\.md|)$/i.test(N))?.resource,J=x.children.find(({name:N})=>/^changelog(\.txt|\.md|)$/i.test(N))?.resource),{identifier:Y.identifier,type:Y.type,isBuiltin:Y.isBuiltin||!!Y.metadata?.isBuiltin,location:Y.location,manifest:Y.manifest,targetPlatform:Y.targetPlatform,validations:Y.validations,isValid:Y.isValid,readmeUrl:B,changelogUrl:J,publisherDisplayName:Y.metadata?.publisherDisplayName||null,publisherId:Y.metadata?.publisherId||null,isApplicationScoped:!!Y.metadata?.isApplicationScoped,isMachineScoped:!!Y.metadata?.isMachineScoped,isPreReleaseVersion:!!Y.metadata?.isPreReleaseVersion,preRelease:!!Y.metadata?.preRelease,installedTimestamp:Y.metadata?.installedTimestamp,updated:!!Y.metadata?.updated}}async removeUninstalledExtensions(){const Y=await this.getUninstalledExtensions(),x=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),B=new Set;for(const $ of x)Y[u.ExtensionKey.create($).toString()]||B.add($.identifier.id.toLowerCase());const J=(0,u.groupByExtension)(x,$=>$.identifier);await k.Promises.settled(J.map(async $=>{const j=$.sort((G,q)=>D.rcompare(G.manifest.version,q.manifest.version))[0];B.has(j.identifier.id.toLowerCase())||await this.beforeRemovingExtension(await this.toLocalExtension(j))}));const N=x.filter($=>Y[u.ExtensionKey.create($).toString()]);await k.Promises.settled(N.map($=>this.removeUninstalledExtension($)))}async removeOutdatedExtensions(){const Y=await this.extensionsScannerService.scanSystemExtensions({}),x=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),B=[],J=await this.extensionsScannerService.getTargetPlatform(),N=(0,u.groupByExtension)(x,$=>$.identifier);for(const $ of N)if($.length>1&&B.push(...$.sort((j,G)=>{const q=D.rcompare(j.manifest.version,G.manifest.version);return q!==0?q:j.targetPlatform===J?-1:1}).slice(1)),$[0].type===0){const j=Y.find(G=>(0,u.areSameExtensions)(G.identifier,$[0].identifier));(!j||D.gte(j.manifest.version,$[0].manifest.version))&&B.push($[0])}await k.Promises.settled(B.map($=>this.removeExtension($,"outdated")))}joinErrors(Y){const x=Array.isArray(Y)?Y:[Y];return x.length===1?x[0]instanceof Error?x[0]:new Error(x[0]):x.reduce((B,J)=>new Error(`${B.message}${B.message?",":""}${J instanceof Error?J.message:J}`),new Error(""))}};W=me([Q(1,y.IFileService),Q(2,n.IExtensionsScannerService),Q(3,_.ILogService)],W);class z extends g.AbstractExtensionTask{constructor(Y,x,B,J,N){super();this.identifier=Y,this.source=x,this.options=B,this.extensionsScanner=J,this.logService=N,this._operation=2}get operation(){return(0,E.isUndefined)(this.options.operation)?this._operation:this.options.operation}async installExtension(Y,x){try{const B=await this.unsetUninstalledAndGetLocal(Y.key);if(B)return Y.metadata?this.extensionsScanner.updateMetadata(B,Y.metadata):B}catch{throw b.isMacintosh?new f.ExtensionManagementError(w.localize(4,null),f.ExtensionManagementErrorCode.Internal):new f.ExtensionManagementError(w.localize(5,null),f.ExtensionManagementErrorCode.Internal)}return this.extract(Y,x)}async unsetUninstalledAndGetLocal(Y){if(!await this.isUninstalled(Y))return null;this.logService.trace("Removing the extension from uninstalled list:",Y.id);const B=await this.extensionsScanner.setInstalled(Y);return this.logService.info("Removed the extension from uninstalled list:",Y.id),B}async isUninstalled(Y){return!!(await this.extensionsScanner.getUninstalledExtensions())[Y.toString()]}async extract({zipPath:Y,key:x,metadata:B},J){const N=await this.extensionsScanner.extractUserExtension(x,Y,B,J);return this.logService.info("Extracting completed.",x.id),N}}class te extends z{constructor(Y,x,B,J,N,$){super(x.identifier,x,B,N,$);this.manifest=Y,this.gallery=x,this.extensionsDownloader=J}async doRun(Y){const B=(await this.extensionsScanner.scanExtensions(null,void 0)).find($=>(0,u.areSameExtensions)($.identifier,this.gallery.identifier));B&&(this._operation=3);const J={id:this.gallery.identifier.uuid,publisherId:this.gallery.publisherId,publisherDisplayName:this.gallery.publisherDisplayName,targetPlatform:this.gallery.properties.targetPlatform,isApplicationScoped:(0,l.isApplicationScopedExtension)(this.manifest),isMachineScoped:this.options.isMachineScoped||B?.isMachineScoped,isBuiltin:this.options.isBuiltin||B?.isBuiltin,isSystem:B?.type===0?!0:void 0,updated:!!B,isPreReleaseVersion:this.gallery.properties.isPreReleaseVersion,preRelease:this.gallery.properties.isPreReleaseVersion||((0,E.isBoolean)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:B?.preRelease)};if(B?.manifest.version===this.gallery.version)return{local:await this.extensionsScanner.updateMetadata(B,J),metadata:J};const N=await this.downloadExtension(this.gallery,this._operation);try{const $=await this.installExtension({zipPath:N,key:u.ExtensionKey.create(this.gallery),metadata:J},Y);return B&&!this.options.profileLocation&&(B.targetPlatform!==$.targetPlatform||D.neq(B.manifest.version,$.manifest.version))&&await this.extensionsScanner.setUninstalled(B),{local:$,metadata:J}}catch($){throw await this.deleteDownloadedVSIX(N),$}}async deleteDownloadedVSIX(Y){try{await this.extensionsDownloader.delete(p.URI.file(Y))}catch(x){this.logService.warn("Error while deleting the downloaded vsix",Y.toString(),(0,T.getErrorMessage)(x))}}async downloadExtension(Y,x){let B;try{this.logService.trace("Started downloading extension:",Y.identifier.id),B=(await this.extensionsDownloader.downloadExtension(Y,x)).fsPath,this.logService.info("Downloaded extension:",Y.identifier.id,B)}catch(J){throw new f.ExtensionManagementError((0,g.joinErrors)(J).message,f.ExtensionManagementErrorCode.Download)}try{return await(0,c.getManifest)(B),B}catch(J){throw await this.deleteDownloadedVSIX(B),new f.ExtensionManagementError((0,g.joinErrors)(J).message,f.ExtensionManagementErrorCode.Invalid)}}}class H extends z{constructor(Y,x,B,J,N,$){super({id:(0,u.getGalleryExtensionId)(Y.publisher,Y.name)},x,B,N,$);this.manifest=Y,this.location=x,this.galleryService=J}async doRun(Y){const x=new u.ExtensionKey(this.identifier,this.manifest.version),J=(await this.extensionsScanner.scanExtensions(1,void 0)).find(j=>(0,u.areSameExtensions)(this.identifier,j.identifier)),N=await this.getMetadata(this.identifier.id,this.manifest.version,Y);if(N.isApplicationScoped=(0,l.isApplicationScopedExtension)(this.manifest),N.isMachineScoped=this.options.isMachineScoped||J?.isMachineScoped,N.isBuiltin=this.options.isBuiltin||J?.isBuiltin,J)if(this._operation=3,x.equals(new u.ExtensionKey(J.identifier,J.manifest.version)))try{await this.extensionsScanner.removeExtension(J,"existing")}catch{throw new Error(w.localize(6,null,this.manifest.displayName||this.manifest.name))}else!this.options.profileLocation&&D.gt(J.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(J);else{const j=await this.unsetUninstalledAndGetLocal(x);if(j)try{await this.extensionsScanner.removeExtension(j,"existing")}catch{throw new Error(w.localize(7,null,this.manifest.displayName||this.manifest.name))}}return{local:await this.installExtension({zipPath:I.resolve(this.location.fsPath),key:x,metadata:N},Y),metadata:N}}async getMetadata(Y,x,B){try{let[J]=await this.galleryService.getExtensions([{id:Y,version:x}],B);if(J||([J]=await this.galleryService.getExtensions([{id:Y}],B)),J)return{id:J.identifier.uuid,publisherDisplayName:J.publisherDisplayName,publisherId:J.publisherId,isPreReleaseVersion:J.properties.isPreReleaseVersion,preRelease:J.properties.isPreReleaseVersion||this.options.installPreReleaseVersion}}catch{}return{}}}class K extends g.AbstractExtensionTask{constructor(Y,x,B){super();this.extension=Y,this.options=x,this.extensionsScanner=B}async doRun(Y){const x=[],B=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const J=u.ExtensionKey.create(this.extension);x.push(...B.filter(N=>J.equals(u.ExtensionKey.create(N))))}else x.push(...B.filter(J=>(0,u.areSameExtensions)(J.identifier,this.extension.identifier)));if(!x.length)throw new Error(w.localize(8,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...x),this.options.remove)for(const J of x)try{Y.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(J)}catch(N){throw new Error(w.localize(9,null,(0,t.toErrorMessage)(N)))}}}}),define(re[262],se([0,1,2,30,32,46,72,198,110,50,5,7,22,33,28]),function(Z,e,k,t,T,L,A,I,b,P,D,E,p,C,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsCleaner=void 0;const S={versionOnly:!0,donotIncludePack:!0,donotCheckDependents:!0};let w=class extends k.Disposable{constructor(g,f,u,r,n,i,a,c){super();this.userDataProfilesService=f,g.removeUninstalledExtensions(this.userDataProfilesService.profiles.length===0),(0,I.migrateUnsupportedExtensions)(g,u,r,n,c),A.ExtensionStorageService.removeOutdatedExtensionVersions(g,a),this._register(i.createInstance(d))}};w=me([Q(0,b.INativeServerExtensionManagementService),Q(1,h.IUserDataProfilesService),Q(2,t.IExtensionGalleryService),Q(3,A.IExtensionStorageService),Q(4,t.IGlobalExtensionEnablementService),Q(5,D.IInstantiationService),Q(6,p.IStorageService),Q(7,E.ILogService)],w),e.ExtensionsCleaner=w;let d=class extends k.Disposable{constructor(g,f,u,r,n){super();this.extensionManagementService=g,this.userDataProfilesService=f,this.extensionsProfileScannerService=u,this.uriIdentityService=r,this.logService=n,this.profileExtensionsLocations=new Map,this.profileModeDisposables=this._register(new k.MutableDisposable),this.onDidChangeProfiles({added:this.userDataProfilesService.profiles,removed:[],all:this.userDataProfilesService.profiles})}async onDidChangeProfiles({added:g,removed:f,all:u}){try{await Promise.all(f.map(r=>r.extensionsResource?this.removeExtensionsFromProfile(r.extensionsResource):Promise.resolve()))}catch(r){this.logService.error(r)}if(u.length===0){this.profileModeDisposables.clear();const r=this._register(this.userDataProfilesService.onDidChangeProfiles(()=>{r.dispose(),this.onDidChangeProfiles({added:this.userDataProfilesService.profiles,removed:[],all:this.userDataProfilesService.profiles})}));return}try{g.length&&(await Promise.all(g.map(r=>r.extensionsResource?this.populateExtensionsFromProfile(r.extensionsResource):Promise.resolve())),this.profileModeDisposables.value||(this.profileModeDisposables.value=new k.DisposableStore,this.profileModeDisposables.value.add((0,k.toDisposable)(()=>this.profileExtensionsLocations.clear())),this.profileModeDisposables.value.add(this.userDataProfilesService.onDidChangeProfiles(r=>this.onDidChangeProfiles(r))),this.profileModeDisposables.value.add(this.extensionManagementService.onDidInstallExtensions(r=>this.onDidInstallExtensions(r))),this.profileModeDisposables.value.add(this.extensionManagementService.onDidUninstallExtension(r=>this.onDidUninstallExtension(r))),await this.uninstallExtensionsNotInProfiles()))}catch(r){this.logService.error(r)}}async uninstallExtensionsNotInProfiles(){const f=(await this.extensionManagementService.getAllUserInstalled()).filter(u=>!this.profileExtensionsLocations.has(this.getKey(u.identifier,u.manifest.version)));f.length&&await Promise.all(f.map(u=>this.extensionManagementService.uninstall(u,S)))}async onDidInstallExtensions(g){for(const{local:f,profileLocation:u}of g)!f||!u||this.addExtensionWithKey(this.getKey(f.identifier,f.manifest.version),u)}async onDidUninstallExtension(g){!g.profileLocation||!g.version||this.removeExtensionWithKey(this.getKey(g.identifier,g.version),g.profileLocation)&&await this.uninstallExtensions([{identifier:g.identifier,version:g.version}])}async populateExtensionsFromProfile(g){const f=await this.extensionsProfileScannerService.scanProfileExtensions(g);for(const u of f)this.addExtensionWithKey(this.getKey(u.identifier,u.version),g)}async removeExtensionsFromProfile(g){const f=[];for(const u of[...this.profileExtensionsLocations.keys()]){if(!this.removeExtensionWithKey(u,g))continue;const r=this.fromKey(u);r&&f.push(r)}f.length&&await this.uninstallExtensions(f)}addExtensionWithKey(g,f){let u=this.profileExtensionsLocations.get(g);u||(u=[],this.profileExtensionsLocations.set(g,u)),u.push(f)}removeExtensionWithKey(g,f){const u=this.profileExtensionsLocations.get(g);if(u){const r=u.findIndex(n=>this.uriIdentityService.extUri.isEqual(n,f));r>-1&&u.splice(r,1)}return u?.length?!1:(this.profileExtensionsLocations.delete(g),!0)}async uninstallExtensions(g){const u=(await this.extensionManagementService.getAllUserInstalled()).filter(r=>g.some(n=>this.getKey(r.identifier,r.manifest.version)===this.getKey(n.identifier,n.version)));u.length&&await Promise.all(u.map(r=>this.extensionManagementService.uninstall(r,S)))}getKey(g,f){return`${P.ExtensionIdentifier.toKey(g.id)}@${f}`}fromKey(g){const[f,u]=(0,T.getIdAndVersion)(g);return u?{identifier:{id:f},version:u}:void 0}};d=me([Q(0,b.INativeServerExtensionManagementService),Q(1,h.IUserDataProfilesService),Q(2,L.IExtensionsProfileScannerService),Q(3,C.IUriIdentityService),Q(4,E.ILogService)],d)}),define(re[263],se([0,1,93,61,35,16,9,3,2,12,4,31,39,84,274]),function(Z,e,k,t,T,L,A,I,b,P,D,E,p,C,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class S{constructor(y,O=""){this.debugLabel=O,this.socket=y,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=_=>{if(this.traceSocketEvent("error",{code:_?.code,message:_?.message}),_){if(_.code==="EPIPE")return;(0,A.onUnexpectedError)(_)}},this.socket.on("error",this._errorListener)}traceSocketEvent(y,O){C.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,y,O)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(y){const O=_=>{this.traceSocketEvent("read",_),y(L.VSBuffer.wrap(_))};return this.socket.on("data",O),{dispose:()=>this.socket.off("data",O)}}onClose(y){const O=_=>{this.traceSocketEvent("close",{hadError:_}),y({type:0,hadError:_,error:void 0})};return this.socket.on("close",O),{dispose:()=>this.socket.off("close",O)}}onEnd(y){const O=()=>{this.traceSocketEvent("nodeEndReceived"),y()};return this.socket.on("end",O),{dispose:()=>this.socket.off("end",O)}}write(y){if(!this.socket.destroyed)try{this.traceSocketEvent("write",y),this.socket.write(y.buffer,O=>{if(O){if(O.code==="EPIPE")return;(0,A.onUnexpectedError)(O)}})}catch(O){if(O.code==="EPIPE")return;(0,A.onUnexpectedError)(O)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((y,O)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),y();return}const _=()=>{this.socket.off("close",_),this.socket.off("end",_),this.socket.off("error",_),this.socket.off("timeout",_),this.socket.off("drain",_),this.traceSocketEvent("nodeDrainEnd"),y()};this.socket.on("close",_),this.socket.on("end",_),this.socket.on("error",_),this.socket.on("timeout",_),this.socket.on("drain",_)})}}e.NodeSocket=S;var w;(function(v){v[v.MinHeaderByteSize=2]="MinHeaderByteSize"})(w||(w={}));var d;(function(v){v[v.PeekHeader=1]="PeekHeader",v[v.ReadHeader=2]="ReadHeader",v[v.ReadBody=3]="ReadBody",v[v.Fin=4]="Fin"})(d||(d={}));class m extends b.Disposable{constructor(y,O,_,F){super();this._onData=this._register(new I.Emitter),this._onClose=this._register(new I.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=y,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:O,inflateBytesLength:_?.byteLength||0,recordInflateBytes:F}),this._flowManager=this._register(new g(this,O,_,F,this._onData,(R,U)=>this._write(R,U))),this._register(this._flowManager.onError(R=>{console.error(R),(0,A.onUnexpectedError)(R),this._onClose.fire({type:0,hadError:!0,error:R})})),this._incomingData=new C.ChunkStream,this._register(this.socket.onData(R=>this._acceptChunk(R))),this._register(this.socket.onClose(R=>this._onClose.fire(R)))}get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(y,O){this.socket.traceSocketEvent(y,O)}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(y){return this._onData.event(y)}onClose(y){return this._onClose.event(y)}onEnd(y){return this.socket.onEnd(y)}write(y){this._flowManager.writeMessage(y)}_write(y,O){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",y);let _=2;y.byteLength<126?_+=0:y.byteLength<2**16?_+=2:_+=8;const F=L.VSBuffer.alloc(_);if(O?F.writeUInt8(194,0):F.writeUInt8(130,0),y.byteLength<126)F.writeUInt8(y.byteLength,1);else if(y.byteLength<2**16){F.writeUInt8(126,1);let R=1;F.writeUInt8(y.byteLength>>>8&255,++R),F.writeUInt8(y.byteLength>>>0&255,++R)}else{F.writeUInt8(127,1);let R=1;F.writeUInt8(0,++R),F.writeUInt8(0,++R),F.writeUInt8(0,++R),F.writeUInt8(0,++R),F.writeUInt8(y.byteLength>>>24&255,++R),F.writeUInt8(y.byteLength>>>16&255,++R),F.writeUInt8(y.byteLength>>>8&255,++R),F.writeUInt8(y.byteLength>>>0&255,++R)}this.socket.write(L.VSBuffer.concat([F,y]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(y){if(y.byteLength!==0){for(this._incomingData.acceptChunk(y);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const O=this._incomingData.peek(this._state.readLen),_=O.readUInt8(0),F=(_&128)>>>7,R=(_&64)>>>6,U=O.readUInt8(1),M=(U&128)>>>7,V=U&127;this._state.state=2,this._state.readLen=2+(M?4:0)+(V===126?2:0)+(V===127?8:0),this._state.fin=F,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(R)),this._state.firstFrameOfMessage=Boolean(F),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const O=this._incomingData.read(this._state.readLen),_=O.readUInt8(1),F=(_&128)>>>7;let R=_&127,U=1;R===126?R=O.readUInt8(++U)*2**8+O.readUInt8(++U):R===127&&(R=O.readUInt8(++U)*0+O.readUInt8(++U)*0+O.readUInt8(++U)*0+O.readUInt8(++U)*0+O.readUInt8(++U)*2**24+O.readUInt8(++U)*2**16+O.readUInt8(++U)*2**8+O.readUInt8(++U));let M=0;F&&(M=O.readUInt8(++U)*2**24+O.readUInt8(++U)*2**16+O.readUInt8(++U)*2**8+O.readUInt8(++U)),this._state.state=3,this._state.readLen=R,this._state.mask=M,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const O=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",O),r(O,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",O),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(O,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await I.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=m;class g extends b.Disposable{constructor(y,O,_,F,R,U){super();this._tracer=y,this._onData=R,this._writeFn=U,this._onError=this._register(new I.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new I.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,O?(this._zlibInflateStream=this._register(new f(this._tracer,F,_,{windowBits:15})),this._zlibDeflateStream=this._register(new u(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(M=>this._onError.fire(M))),this._register(this._zlibDeflateStream.onError(M=>this._onError.fire(M)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:L.VSBuffer.alloc(0)}writeMessage(y){this._writeQueue.push(y),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const y=this._writeQueue.shift();if(this._zlibDeflateStream){const O=await this._deflateMessage(this._zlibDeflateStream,y);this._writeFn(O,!0)}else this._writeFn(y,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(y,O){return new Promise((_,F)=>{y.write(O),y.flush(R=>_(R))})}acceptFrame(y,O,_){this._readQueue.push({data:y,isCompressed:O,isLastFrameOfMessage:_}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const y=this._readQueue.shift();if(this._zlibInflateStream&&y.isCompressed){const O=await this._inflateFrame(this._zlibInflateStream,y.data,y.isLastFrameOfMessage);this._onData.fire(O)}else this._onData.fire(y.data)}this._isProcessingReadQueue=!1}}_inflateFrame(y,O,_){return new Promise((F,R)=>{y.write(O),_&&y.write(L.VSBuffer.fromByteArray([0,0,255,255])),y.flush(U=>F(U))})}}class f extends b.Disposable{constructor(y,O,_,F){super();this._tracer=y,this._recordInflateBytes=O,this._onError=this._register(new I.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=h.createInflateRaw(F),this._zlibInflate.on("error",R=>{this._tracer.traceSocketEvent("zlibInflateError",{message:R?.message,code:R?.code}),this._onError.fire(R)}),this._zlibInflate.on("data",R=>{this._tracer.traceSocketEvent("zlibInflateData",R),this._pendingInflateData.push(L.VSBuffer.wrap(R))}),_&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",_.buffer),this._zlibInflate.write(_.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}get recordedInflateBytes(){return this._recordInflateBytes?L.VSBuffer.concat(this._recordedInflateBytes):L.VSBuffer.alloc(0)}write(y){this._recordInflateBytes&&this._recordedInflateBytes.push(y.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",y),this._zlibInflate.write(y.buffer)}flush(y){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const O=L.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,y(O)})}}class u extends b.Disposable{constructor(y,O){super();this._tracer=y,this._onError=this._register(new I.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=h.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",_=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:_?.message,code:_?.code}),this._onError.fire(_)}),this._zlibDeflate.on("data",_=>{this._tracer.traceSocketEvent("zlibDeflateData",_),this._pendingDeflateData.push(L.VSBuffer.wrap(_))})}write(y){this._tracer.traceSocketEvent("zlibDeflateWrite",y.buffer),this._zlibDeflate.write(y.buffer)}flush(y){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let O=L.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,O=O.slice(0,O.byteLength-4),y(O)})}}function r(v,y){if(y===0)return;const O=v.byteLength>>>2;for(let V=0;V<O;V++){const W=v.readUInt32BE(V*4);v.writeUInt32BE(W^y,V*4)}const _=O*4,F=v.byteLength-_,R=y>>>24&255,U=y>>>16&255,M=y>>>8&255;F>=1&&v.writeUInt8(v.readUInt8(_)^R,_),F>=2&&v.writeUInt8(v.readUInt8(_+1)^U,_+1),F>=3&&v.writeUInt8(v.readUInt8(_+2)^M,_+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const n={[2]:107,[1]:103};function i(){const v=(0,E.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${v}-sock`;let y;return e.XDG_RUNTIME_DIR?y=(0,P.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${v}.sock`):y=(0,P.join)((0,T.tmpdir)(),`vscode-ipc-${v}.sock`),c(y),y}e.createRandomIPCHandle=i;function a(v,y,O){const _=(0,k.createHash)("md5").update(v).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${_}-${O}-${y}-sock`;let F;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?F=(0,P.join)(e.XDG_RUNTIME_DIR,`vscode-${_.substr(0,8)}-${O}-${y}.sock`):F=(0,P.join)(v,`${O}-${y}.sock`),c(F),F}e.createStaticIPCHandle=a;function c(v){const y=n[D.platform];typeof y=="number"&&v.length>=y&&console.warn(`WARNING: IPC handle "${v}" is longer than ${y} chars, try a shorter --user-data-dir`)}class s extends p.IPCServer{constructor(y){super(s.toClientConnectionEvent(y));this.server=y}static toClientConnectionEvent(y){const O=I.Event.fromNodeEventEmitter(y,"connection");return I.Event.map(O,_=>({protocol:new C.Protocol(new S(_,"ipc-server-connection")),onDidClientDisconnect:I.Event.once(I.Event.fromNodeEventEmitter(_,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=s;function o(v){return new Promise((y,O)=>{const _=(0,t.createServer)();_.on("error",O),_.listen(v,()=>{_.removeListener("error",O),y(new s(_))})})}e.serve=o;function l(v,y){return new Promise((O,_)=>{const F=(0,t.createConnection)(v,()=>{F.removeListener("error",_),O(C.Client.fromSocket(new S(F,`ipc-client${y}`),y))});F.once("error",_)})}e.connect=l}),define(re[264],se([0,1,61,263]),function(Z,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(T,L,A,I,b,P){const D=p=>P(p,void 0),E=k.createConnection({host:T,port:L},()=>{E.removeListener("error",D);const p=Buffer.alloc(16);for(let w=0;w<16;w++)p[w]=Math.round(Math.random()*256);const C=p.toString("base64"),h=[`GET ws://${/:/.test(T)?`[${T}]`:T}:${L}${A}?${I}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${C}`];E.write(h.join(`\r
`)+`\r
\r
`);const S=w=>{w.toString().indexOf(`\r
\r
`)>=0&&(E.off("data",S),P(void 0,new t.NodeSocket(E,b)))};E.on("data",S)});E.setNoDelay(!0),E.once("error",D)}}}),define(re[265],se([0,1,61,117,264,6,2,18,7,24,202,70,102]),function(Z,e,k,t,T,L,A,I,b,P,D,E,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function C(m,g,f,u,r){let n;for(let i=3;i&&(n&&n.dispose(),n=await new h(m,g,f,u,r).waitForReady(),!(r&&t.BROWSER_RESTRICTED_PORTS[r]||!t.BROWSER_RESTRICTED_PORTS[n.tunnelLocalPort]));i--);return n}class h extends A.Disposable{constructor(g,f,u,r,n){super();this.defaultTunnelHost=f,this.suggestedLocalPort=n,this.privacy=E.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=g,this._server=k.createServer(),this._barrier=new L.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=i=>this._onConnection(i),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=r,this.tunnelRemoteHost=u}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(f=>{f()})}async waitForReady(){let g=await(0,t.findFreePortFaster)(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),f=null;return this._server.listen(g,this.defaultTunnelHost),await this._barrier.wait(),f=this._server.address(),f||(g=0,this._server.listen(g,this.defaultTunnelHost),await this._barrier.wait(),f=this._server.address()),this.tunnelLocalPort=f.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${f.port}`,this}async _onConnection(g){g.pause();const f=(0,E.isLocalhost)(this.tunnelRemoteHost)||(0,E.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,u=await(0,D.connectRemoteAgentTunnel)(this._options,f,this.tunnelRemotePort),r=u.getSocket().socket,n=u.readEntireBuffer();u.dispose(),n.byteLength>0&&g.write(n.buffer),g.on("end",()=>{g.localAddress&&this._socketsDispose.delete(g.localAddress),r.end()}),g.on("close",()=>r.end()),g.on("error",()=>{g.localAddress&&this._socketsDispose.delete(g.localAddress),r.destroy()}),r.on("end",()=>g.end()),r.on("close",()=>g.end()),r.on("error",()=>{g.destroy()}),g.pipe(r),r.pipe(g),g.localAddress&&this._socketsDispose.set(g.localAddress,()=>{g.end(),r.end()})}}let S=class extends E.AbstractTunnelService{constructor(g,f,u,r,n){super(f);this.socketFactory=g,this.signService=u,this.productService=r,this.configurationService=n}get defaultTunnelHost(){const g=this.configurationService.getValue("remote.localPortHost");return!g||g==="localhost"?"127.0.0.1":"0.0.0.0"}retainOrCreateTunnel(g,f,u,r,n,i,a){const c=this.getTunnelFromMap(f,u);if(c)return++c.refcount,c.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,f,u,r,n,i,a);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${f}:${u} on local port ${r}.`);const s={commit:this.productService.commit,quality:this.productService.quality,socketFactory:this.socketFactory,addressProvider:g,signService:this.signService,logService:this.logService,ipcLogger:null},o=C(s,this.defaultTunnelHost,f,u,r);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(f,u,o),o}}};S=me([Q(1,b.ILogService),Q(2,p.ISignService),Q(3,P.IProductService),Q(4,I.IConfigurationService)],S),e.BaseTunnelService=S;let w=class extends S{constructor(g,f,u,r){super(T.nodeSocketFactory,g,f,u,r)}};w=me([Q(0,b.ILogService),Q(1,p.ISignService),Q(2,P.IProductService),Q(3,I.IConfigurationService)],w),e.TunnelService=w;let d=class extends A.Disposable{constructor(g,f,u,r){super();this.logService=g,this.productService=f,this.signService=u,this.configurationService=r,this._tunnelServices=new Map}async openTunnel(g,f,u,r,n,i,a,c){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${u}:${r} on local port ${n}.`),!this._tunnelServices.has(g)){const s=new w(this.logService,this.signService,this.productService,this.configurationService);this._register(s),this._tunnelServices.set(g,s),s.onTunnelClosed(async()=>{(await s.tunnels).length===0&&(s.dispose(),this._tunnelServices.delete(g))})}return this._tunnelServices.get(g).openTunnel(f,u,r,n,i,a,c)}};d=me([Q(0,b.ILogService),Q(1,P.IProductService),Q(2,p.ISignService),Q(3,I.IConfigurationService)],d),e.SharedTunnelsService=d}),define(re[275],se([0,1,85,35,37,9,2,20,19,8,39,134,191,262,192,183,184,185,172,175,18,196,90,214,91,205,15,209,235,236,30,174,237,110,92,170,13,187,189,56,5,181,95,182,96,67,201,7,97,68,98,24,204,44,22,238,213,21,103,104,105,45,218,219,106,221,227,72,108,25,73,251,253,254,74,252,256,257,258,259,260,102,211,70,265,203,228,101,208,33,230,4,231,176,194,193,71,234,28,46,190,58,239,217]),function(Z,e,k,t,T,L,A,I,b,P,D,E,p,C,h,S,w,d,m,g,f,u,r,n,i,a,c,s,o,l,v,y,O,_,F,R,U,M,V,W,z,te,H,K,X,Y,x,B,J,N,$,j,G,q,ee,ne,oe,le,Se,fe,pe,Ce,be,Ie,qe,Qe,Ke,Ye,ae,ue,he,Ee,Pe,Ue,Re,Ne,_e,Te,Me,ie,ce,de,ve,ge,we,De,ke,Le,Ae,Fe,$e,Xe,rt,St,Dt,yt,Rt,kt,Lt,wt,Tt,Et,At,_t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class Ot extends A.Disposable{constructor(ye){super();this.configuration=ye,this.server=this._register(new E.Server),this.sharedProcessWorkerService=void 0,this.registerListeners()}registerListeners(){const ye=()=>this.dispose();process.once("exit",ye),k.ipcRenderer.once("vscode:electron-main->shared-process=exit",ye);const Oe="vscode:electron-main->shared-process=disposeWorker",ze=(xe,Ze)=>this.onDisposeWorker(Ze);k.ipcRenderer.on(Oe,ze),this._register((0,A.toDisposable)(()=>k.ipcRenderer.removeListener(Oe,ze)))}onDisposeWorker(ye){this.sharedProcessWorkerService?.disposeWorker(ye)}async open(){const ye=await this.initServices();(0,ue.registerConfiguration)(),ye.invokeFunction(Oe=>{const ze=Oe.get(B.ILogService);ze.trace("sharedProcess configuration",JSON.stringify(this.configuration)),this.initChannels(Oe),this.registerErrorHandler(ze)}),this._register((0,A.combinedDisposable)(ye.createInstance(p.CodeCacheCleaner,this.configuration.codeCachePath),ye.createInstance(h.LanguagePackCachedDataCleaner),ye.createInstance(d.StorageDataCleaner,this.configuration.backupWorkspacesPath),ye.createInstance(w.LogsDataCleaner),ye.createInstance(S.LocalizationsUpdater),ye.createInstance(C.ExtensionsCleaner)))}async initServices(){const ye=new H.ServiceCollection,Oe={_serviceBrand:void 0,...$.default};ye.set(j.IProductService,Oe);const ze=new D.StaticRouter(He=>He==="main"),xe=new K.MessagePortMainProcessService(this.server,ze);ye.set(X.IMainProcessService,xe);const Ze=this.configuration.policiesData?new Tt.PolicyChannelClient(this.configuration.policiesData,xe.getChannel("policy")):new Et.NullPolicyService;ye.set(Et.IPolicyService,Ze);const We=new s.SharedProcessEnvironmentService(this.configuration.args,Oe);ye.set(c.INativeEnvironmentService,We);const at=new J.LogLevelChannelClient(this.server.getChannel("logLevel",ze)),et=new J.LoggerChannelClient(this.configuration.logLevel,at.onDidChangeLogLevel,xe.getChannel("logger"));ye.set(B.ILoggerService,et);const ut=this._register(new B.MultiplexLogService([this._register(new B.ConsoleLogger(this.configuration.logLevel)),this._register(et.createLogger((0,b.joinPath)(P.URI.file(We.logsPath),"sharedprocess.log"),{name:"sharedprocess"}))])),je=this._register(new J.FollowerLogService(at,ut));ye.set(B.ILogService,je),this.sharedProcessWorkerService=new Ae.SharedProcessWorkerService(je),ye.set(Le.ISharedProcessWorkerService,this.sharedProcessWorkerService);const Be=this._register(new M.FileService(je));ye.set(U.IFileService,Be);const ht=this._register(new V.DiskFileSystemProvider(je));Be.registerProvider(I.Schemas.file,ht);const dt=this._register(new rt.FileUserDataProvider(I.Schemas.file,this._register(new St.DiskFileSystemProviderClient(xe.getChannel(St.LOCAL_FILE_SYSTEM_CHANNEL_NAME),{pathCaseSensitive:Xe.isLinux})),I.Schemas.vscodeUserData,je));Be.registerProvider(I.Schemas.vscodeUserData,dt);const tt=this._register(new At.UserDataProfilesNativeService(this.configuration.profiles,xe,We,Be,je));ye.set(Lt.IUserDataProfilesService,tt);const Ve=this._register(new u.ConfigurationService(tt.defaultProfile.settingsResource,Be,Ze,je));ye.set(f.IConfigurationService,Ve);const st=new ne.NativeStorageService(void 0,{defaultProfile:tt.defaultProfile,currentProfile:tt.defaultProfile},xe,We);ye.set(ee.IStorageService,st),this._register((0,A.toDisposable)(()=>st.flush())),await Promise.all([Ve.initialize(),st.initialize()]),ye.set(Fe.IUriIdentityService,new $e.UriIdentityService(Be)),ye.set(q.IRequestService,new W.SyncDescriptor(G.RequestService)),ye.set(m.IChecksumService,new W.SyncDescriptor(g.ChecksumService)),ye.set(yt.IV8InspectProfilingService,new W.SyncDescriptor(Dt.InspectProfilingService));const ct=D.ProxyChannel.toService(xe.getChannel("nativeHost"),{context:this.configuration.windowId});ye.set(N.INativeHostService,ct),ye.set(i.IDownloadService,new W.SyncDescriptor(a.DownloadService));const ft=this._register(new ce.ActiveWindowManager(ct)),Mt=new D.StaticRouter(He=>ft.getActiveClientId().then(gt=>He===gt));ye.set(F.IExtensionRecommendationNotificationService,new R.ExtensionRecommendationNotificationServiceChannelClient(this.server.getChannel("extensionRecommendationNotification",Mt)));let lt;const it=[];if((0,Ce.supportsTelemetry)(Oe,We)){const He=new fe.TelemetryLogAppender(et,We);it.push(He);const{installSourcePath:gt}=We;if(Ve.getValue("telemetry.internalTesting")&&Oe.aiConfig?.ariaKey){const ot=new _t.OneDataSystemWebAppender("monacoworkbench",null,Oe.aiConfig.ariaKey);this._register((0,A.toDisposable)(()=>ot.flush())),it.push(ot)}else if(Oe.aiConfig&&Oe.aiConfig.asimovKey){const ot=new be.AppInsightsAppender("monacoworkbench",null,Oe.aiConfig.asimovKey);this._register((0,A.toDisposable)(()=>ot.flush())),it.push(ot)}lt=new pe.TelemetryService({appenders:it,commonProperties:(0,oe.resolveCommonProperties)(Be,(0,t.release)(),(0,t.hostname)(),process.arch,Oe.commit,Oe.version,this.configuration.machineId,Oe.msftInternalDomains,gt),sendErrorTelemetry:!0,piiPaths:(0,Ce.getPiiPathsFromEnvironment)(We)},Ve,Oe)}else{lt=Ce.NullTelemetryService;const He=Ce.NullAppender;it.push(He)}this.server.registerChannel("telemetryAppender",new Se.TelemetryAppenderChannel(it)),ye.set(le.ITelemetryService,lt);const Ft=new Ie.CustomEndpointTelemetryService(Ve,lt,et,We,Oe);ye.set(le.ICustomEndpointTelemetryService,Ft),ye.set(wt.IExtensionsProfileScannerService,new W.SyncDescriptor(wt.ExtensionsProfileScannerService)),ye.set(Rt.IExtensionsScannerService,new W.SyncDescriptor(kt.ExtensionsScannerService)),ye.set(_.INativeServerExtensionManagementService,new W.SyncDescriptor(_.ExtensionManagementService)),ye.set(v.IExtensionGalleryService,new W.SyncDescriptor(l.ExtensionGalleryService)),ye.set(v.IExtensionTipsService,new W.SyncDescriptor(O.ExtensionTipsService)),ye.set(Y.ILanguagePackService,new W.SyncDescriptor(x.NativeLanguagePackService)),ye.set(r.IDiagnosticsService,new W.SyncDescriptor(n.DiagnosticsService)),ye.set(he.IUserDataSyncAccountService,new W.SyncDescriptor(he.UserDataSyncAccountService)),ye.set(ue.IUserDataSyncLogService,new W.SyncDescriptor(Ue.UserDataSyncLogService)),ye.set(ue.IUserDataSyncUtilService,new Pe.UserDataSyncUtilServiceClient(this.server.getChannel("userDataSyncUtil",He=>He.ctx!=="main"))),ye.set(v.IGlobalExtensionEnablementService,new W.SyncDescriptor(o.GlobalExtensionEnablementService)),ye.set(ae.IIgnoredExtensionsManagementService,new W.SyncDescriptor(ae.IgnoredExtensionsManagementService)),ye.set(Ye.IExtensionStorageService,new W.SyncDescriptor(Ye.ExtensionStorageService)),ye.set(ue.IUserDataSyncStoreManagementService,new W.SyncDescriptor(Me.UserDataSyncStoreManagementService)),ye.set(ue.IUserDataSyncStoreService,new W.SyncDescriptor(Me.UserDataSyncStoreService)),ye.set(Re.IUserDataSyncMachinesService,new W.SyncDescriptor(Re.UserDataSyncMachinesService)),ye.set(ue.IUserDataSyncBackupStoreService,new W.SyncDescriptor(Ee.UserDataSyncBackupStoreService)),ye.set(ue.IUserDataSyncEnablementService,new W.SyncDescriptor(Ne.UserDataSyncEnablementService)),ye.set(ue.IUserDataSyncService,new W.SyncDescriptor(_e.UserDataSyncService));const Ct=new Ke.PtyHostService({graceTime:6e4,shortGraceTime:6e3,scrollback:Ve.getValue("terminal.integrated.persistentSessionScrollback")??100},Ve,We,je);return Ct.initialize(),ye.set(Qe.ILocalPtyService,this._register(Ct)),ye.set(de.ISignService,new W.SyncDescriptor(ve.SignService)),ye.set(ge.ISharedTunnelsService,new W.SyncDescriptor(we.SharedTunnelsService)),ye.set(De.ISharedProcessTunnelService,new W.SyncDescriptor(ke.SharedProcessTunnelService)),new te.InstantiationService(ye)}initChannels(ye){const Oe=new y.ExtensionManagementChannel(ye.get(v.IExtensionManagementService),()=>null);this.server.registerChannel("extensions",Oe);const ze=D.ProxyChannel.fromService(ye.get(Y.ILanguagePackService));this.server.registerChannel("languagePacks",ze);const xe=D.ProxyChannel.fromService(ye.get(r.IDiagnosticsService));this.server.registerChannel("diagnostics",xe);const Ze=new y.ExtensionTipsChannel(ye.get(v.IExtensionTipsService));this.server.registerChannel("extensionTipsService",Ze);const We=D.ProxyChannel.fromService(ye.get(m.IChecksumService));this.server.registerChannel("checksum",We);const at=D.ProxyChannel.fromService(ye.get(yt.IV8InspectProfilingService));this.server.registerChannel("v8InspectProfiling",at);const et=new Pe.UserDataSyncMachinesServiceChannel(ye.get(Re.IUserDataSyncMachinesService));this.server.registerChannel("userDataSyncMachines",et);const ut=D.ProxyChannel.fromService(ye.get(le.ICustomEndpointTelemetryService));this.server.registerChannel("customEndpointTelemetry",ut);const je=new Pe.UserDataSyncAccountServiceChannel(ye.get(he.IUserDataSyncAccountService));this.server.registerChannel("userDataSyncAccount",je);const Be=new Pe.UserDataSyncStoreManagementServiceChannel(ye.get(ue.IUserDataSyncStoreManagementService));this.server.registerChannel("userDataSyncStoreManagement",Be);const ht=new Te.UserDataSyncChannel(ye.get(ue.IUserDataSyncService),ye.get(B.ILogService));this.server.registerChannel("userDataSync",ht);const dt=this._register(ye.get(z.IInstantiationService).createInstance(ie.UserDataAutoSyncService)),tt=new Pe.UserDataAutoSyncChannel(dt);this.server.registerChannel("userDataAutoSync",tt);const Ve=ye.get(Qe.ILocalPtyService),st=D.ProxyChannel.fromService(Ve);this.server.registerChannel(qe.TerminalIpcChannels.LocalPty,st);const ct=D.ProxyChannel.fromService(ye.get(De.ISharedProcessTunnelService));this.server.registerChannel(De.ipcSharedProcessTunnelChannelName,ct);const ft=D.ProxyChannel.fromService(ye.get(Le.ISharedProcessWorkerService));this.server.registerChannel(Le.ipcSharedProcessWorkerChannelName,ft)}registerErrorHandler(ye){window.addEventListener("unhandledrejection",Oe=>{(0,L.onUnexpectedError)(Oe.reason),Oe.preventDefault()}),(0,L.setUnexpectedErrorHandler)(Oe=>{const ze=(0,T.toErrorMessage)(Oe,!0);!ze||ye.error(`[uncaught exception in sharedProcess]: ${ze}`)})}}async function Ut(bt){const ye=new Ot(bt);k.ipcRenderer.send("vscode:shared-process->electron-main=ipc-ready"),await ye.open(),k.ipcRenderer.send("vscode:shared-process->electron-main=init-done")}e.main=Ut})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/594ef48f32812d72d824ae855cb7a8be674f9704/core/vs/code/electron-browser/sharedProcess/sharedProcessMain.js.map
