/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var J=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/base/common/uri","vs/base/common/async","vs/base/common/path","vs/nls!vs/code/electron-main/main","vs/base/common/network","vs/base/common/types","vs/nls","electron","vs/platform/files/common/files","vs/base/common/resources","vs/platform/configuration/common/configuration","vs/base/common/errors","vs/base/common/buffer","vs/platform/product/common/productService","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/common/cancellation","vs/base/node/pfs","vs/platform/workspace/common/workspace","vs/base/common/arrays","vs/platform/environment/electron-main/environmentMainService","os","fs","vs/base/common/extpath","vs/base/common/uuid","vs/base/common/strings","vs/platform/windows/electron-main/windows","vs/base/common/map","vs/base/common/labels","vs/platform/telemetry/common/telemetry","vs/base/common/process","vs/platform/policy/common/policy","vs/base/parts/ipc/electron-main/ipcMain","vs/platform/environment/common/environment","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/errorMessage","child_process","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/platform/state/electron-main/state","vs/platform/update/common/update","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/functional","vs/base/common/json","vs/base/common/objects","vs/base/common/decorators","vs/platform/dialogs/electron-main/dialogMainService","vs/base/common/iterator","vs/base/common/stream","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/platform/theme/electron-main/themeMainService","vs/platform/native/electron-main/nativeHostMainService","crypto","net","vs/base/common/hash","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/credentials/common/credentials","vs/platform/files/common/watcher","vs/base/common/performance","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/platform/uriIdentity/common/uriIdentity","vs/platform/window/common/window","vs/platform/userDataProfile/electron-main/userDataProfile","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/processes","vs/base/common/stopwatch","vs/base/common/normalization","vs/base/node/id","vs/base/node/processes","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/sign/common/sign","vs/platform/storage/electron-main/storageMainService","vs/platform/workspaces/common/workspaces","vs/base/parts/ipc/node/ipc.net","vs/platform/update/electron-main/abstractUpdateService","vs/base/node/ports","vs/base/common/observableValue","vs/base/common/glob","vs/base/node/extpath","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","vs/platform/encryption/common/encryptionService","vs/platform/externalTerminal/common/externalTerminal","vs/platform/files/common/io","vs/platform/log/common/bufferLog","vs/platform/log/node/spdlogLog","vs/platform/configuration/common/configurationModels","vs/platform/shell/node/shellEnv","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/storage/common/storage","vs/platform/window/electron-main/window","vs/platform/windows/electron-main/windowsFinder","vs/platform/workspaces/electron-main/workspaces","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/platform/launch/electron-main/launchMainService","vs/base/common/assert","vs/base/common/codicons","vs/base/common/color","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/skipList","vs/base/node/crypto","vs/base/node/decoder","string_decoder","vs/base/node/macAddress","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/contextmenu/electron-main/contextmenu","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/cache","vs/base/common/console","vs/base/common/uriIpc","util","vs/base/node/powershell","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/storage/node/storage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/windows/electron-main/window","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/encryption/node/encryptionMainService","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/environment/node/wait","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/credentials/common/credentialsMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/fileLog","vs/platform/log/common/logIpc","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/request/node/proxy","url","vs/platform/sign/node/signService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/state/node/state","vs/platform/state/node/stateService","vs/platform/state/electron-main/stateMainService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/telemetryService","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/protocol/electron-main/protocolMainService","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/code/electron-main/auth","vs/platform/credentials/electron-main/credentialsMainService","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/node/userDataProfile","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/policy/node/nativePolicyService","zlib","vs/platform/backup/electron-main/backupMainService","vs/platform/remote/node/nodeSocketFactory","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/tunnel/node/tunnelService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/windows/electron-main/window","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","minimist","assert","path","graceful-fs","vscode-policy-watcher","vs/code/electron-main/main"],Z=function(z){for(var e=[],b=0,t=z.length;b<t;b++)e[b]=J[z[b]];return e};define(J[114],Z([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function b(t,R){if(!t)throw new Error(R?`Assertion failed (${R})`:"Assertion Failed")}e.ok=b}),define(J[115],Z([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function b(D){return D?D.replace(/\$\((.*?)\)/g,(y,f)=>` ${f} `).trim():""}e.getCodiconAriaLabel=b;class t{constructor(y,f,v){this.id=y,this.definition=f,this.description=v,t._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return t._allCodicons}}e.Codicon=t,t._allCodicons=[],t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",{fontCharacter:"\\ea71"}),t.closeDirty=new t("close-dirty",{fontCharacter:"\\ea71"}),t.debugBreakpoint=new t("debug-breakpoint",{fontCharacter:"\\ea71"}),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),t.debugHint=new t("debug-hint",{fontCharacter:"\\ea71"}),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circleOutline=new t("circle-outline",{fontCharacter:"\\eabc"}),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolCustomColor=new t("symbol-customcolor",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.circleSmallFilled=new t("circle-small-filled",{fontCharacter:"\\eb8a"}),t.debugStackframeDot=new t("debug-stackframe-dot",t.circleSmallFilled.definition),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLargeOutline=new t("circle-large-outline",{fontCharacter:"\\ebb5"}),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.layout=new t("layout",{fontCharacter:"\\ebeb"}),t.layoutActivitybarLeft=new t("layout-activitybar-left",{fontCharacter:"\\ebec"}),t.layoutActivitybarRight=new t("layout-activitybar-right",{fontCharacter:"\\ebed"}),t.layoutPanelLeft=new t("layout-panel-left",{fontCharacter:"\\ebee"}),t.layoutPanelCenter=new t("layout-panel-center",{fontCharacter:"\\ebef"}),t.layoutPanelJustify=new t("layout-panel-justify",{fontCharacter:"\\ebf0"}),t.layoutPanelRight=new t("layout-panel-right",{fontCharacter:"\\ebf1"}),t.layoutPanel=new t("layout-panel",{fontCharacter:"\\ebf2"}),t.layoutSidebarLeft=new t("layout-sidebar-left",{fontCharacter:"\\ebf3"}),t.layoutSidebarRight=new t("layout-sidebar-right",{fontCharacter:"\\ebf4"}),t.layoutStatusbar=new t("layout-statusbar",{fontCharacter:"\\ebf5"}),t.layoutMenubar=new t("layout-menubar",{fontCharacter:"\\ebf6"}),t.layoutCentered=new t("layout-centered",{fontCharacter:"\\ebf7"}),t.layoutSidebarRightOff=new t("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),t.layoutPanelOff=new t("layout-panel-off",{fontCharacter:"\\ec01"}),t.layoutSidebarLeftOff=new t("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),t.target=new t("target",{fontCharacter:"\\ebf8"}),t.indent=new t("indent",{fontCharacter:"\\ebf9"}),t.recordSmall=new t("record-small",{fontCharacter:"\\ebfa"}),t.errorSmall=new t("error-small",{fontCharacter:"\\ebfb"}),t.arrowCircleDown=new t("arrow-circle-down",{fontCharacter:"\\ebfc"}),t.arrowCircleLeft=new t("arrow-circle-left",{fontCharacter:"\\ebfd"}),t.arrowCircleRight=new t("arrow-circle-right",{fontCharacter:"\\ebfe"}),t.arrowCircleUp=new t("arrow-circle-up",{fontCharacter:"\\ebff"}),t.heartFilled=new t("heart-filled",{fontCharacter:"\\ec04"}),t.map=new t("map",{fontCharacter:"\\ec05"}),t.mapFilled=new t("map-filled",{fontCharacter:"\\ec06"}),t.circleSmall=new t("circle-small",{fontCharacter:"\\ec07"}),t.bellSlash=new t("bell-slash",{fontCharacter:"\\ec08"}),t.bellSlashDot=new t("bell-slash-dot",{fontCharacter:"\\f101"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);function R(D,y){const f=["codicon","codicon-"+D];return y&&f.push("codicon-modifier-"+y),f}e.getClassNamesArray=R;var L;(function(D){D.iconNameSegment="[A-Za-z0-9]+",D.iconNameExpression="[A-Za-z0-9-]+",D.iconModifierExpression="~[A-Za-z]+",D.iconNameCharacter="[A-Za-z0-9~-]";const y=new RegExp(`^(${D.iconNameExpression})(${D.iconModifierExpression})?$`);function f(P){if(P instanceof t)return["codicon","codicon-"+P.id];const S=y.exec(P.id);if(!S)return f(t.error);const[,w,u]=S,m=["codicon","codicon-"+w];return u&&m.push("codicon-modifier-"+u.substr(1)),m}D.asClassNameArray=f;function v(P){return f(P).join(" ")}D.asClassName=v;function E(P){return"."+f(P).join(".")}D.asCSSSelector=E})(L=e.CSSIcon||(e.CSSIcon={}))}),define(J[116],Z([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Color=e.HSVA=e.HSLA=e.RGBA=void 0;function b(y,f){const v=Math.pow(10,f);return Math.round(y*v)/v}class t{constructor(f,v,E,P=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,f))|0,this.g=Math.min(255,Math.max(0,v))|0,this.b=Math.min(255,Math.max(0,E))|0,this.a=b(Math.max(Math.min(1,P),0),3)}static equals(f,v){return f.r===v.r&&f.g===v.g&&f.b===v.b&&f.a===v.a}}e.RGBA=t;class R{constructor(f,v,E,P){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,f),0)|0,this.s=b(Math.max(Math.min(1,v),0),3),this.l=b(Math.max(Math.min(1,E),0),3),this.a=b(Math.max(Math.min(1,P),0),3)}static equals(f,v){return f.h===v.h&&f.s===v.s&&f.l===v.l&&f.a===v.a}static fromRGBA(f){const v=f.r/255,E=f.g/255,P=f.b/255,S=f.a,w=Math.max(v,E,P),u=Math.min(v,E,P);let m=0,g=0;const I=(u+w)/2,p=w-u;if(p>0){switch(g=Math.min(I<=.5?p/(2*I):p/(2-2*I),1),w){case v:m=(E-P)/p+(E<P?6:0);break;case E:m=(P-v)/p+2;break;case P:m=(v-E)/p+4;break}m*=60,m=Math.round(m)}return new R(m,g,I,S)}static _hue2rgb(f,v,E){return E<0&&(E+=1),E>1&&(E-=1),E<1/6?f+(v-f)*6*E:E<1/2?v:E<2/3?f+(v-f)*(2/3-E)*6:f}static toRGBA(f){const v=f.h/360,{s:E,l:P,a:S}=f;let w,u,m;if(E===0)w=u=m=P;else{const g=P<.5?P*(1+E):P+E-P*E,I=2*P-g;w=R._hue2rgb(I,g,v+1/3),u=R._hue2rgb(I,g,v),m=R._hue2rgb(I,g,v-1/3)}return new t(Math.round(w*255),Math.round(u*255),Math.round(m*255),S)}}e.HSLA=R;class L{constructor(f,v,E,P){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,f),0)|0,this.s=b(Math.max(Math.min(1,v),0),3),this.v=b(Math.max(Math.min(1,E),0),3),this.a=b(Math.max(Math.min(1,P),0),3)}static equals(f,v){return f.h===v.h&&f.s===v.s&&f.v===v.v&&f.a===v.a}static fromRGBA(f){const v=f.r/255,E=f.g/255,P=f.b/255,S=Math.max(v,E,P),w=Math.min(v,E,P),u=S-w,m=S===0?0:u/S;let g;return u===0?g=0:S===v?g=((E-P)/u%6+6)%6:S===E?g=(P-v)/u+2:g=(v-E)/u+4,new L(Math.round(g*60),m,S,f.a)}static toRGBA(f){const{h:v,s:E,v:P,a:S}=f,w=P*E,u=w*(1-Math.abs(v/60%2-1)),m=P-w;let[g,I,p]=[0,0,0];return v<60?(g=w,I=u):v<120?(g=u,I=w):v<180?(I=w,p=u):v<240?(I=u,p=w):v<300?(g=u,p=w):v<=360&&(g=w,p=u),g=Math.round((g+m)*255),I=Math.round((I+m)*255),p=Math.round((p+m)*255),new t(g,I,p,S)}}e.HSVA=L;class D{constructor(f){if(f)if(f instanceof t)this.rgba=f;else if(f instanceof R)this._hsla=f,this.rgba=R.toRGBA(f);else if(f instanceof L)this._hsva=f,this.rgba=L.toRGBA(f);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}static fromHex(f){return D.Format.CSS.parseHex(f)||D.red}get hsla(){return this._hsla?this._hsla:R.fromRGBA(this.rgba)}get hsva(){return this._hsva?this._hsva:L.fromRGBA(this.rgba)}equals(f){return!!f&&t.equals(this.rgba,f.rgba)&&R.equals(this.hsla,f.hsla)&&L.equals(this.hsva,f.hsva)}getRelativeLuminance(){const f=D._relativeLuminanceForComponent(this.rgba.r),v=D._relativeLuminanceForComponent(this.rgba.g),E=D._relativeLuminanceForComponent(this.rgba.b),P=.2126*f+.7152*v+.0722*E;return b(P,4)}static _relativeLuminanceForComponent(f){const v=f/255;return v<=.03928?v/12.92:Math.pow((v+.055)/1.055,2.4)}getContrastRatio(f){const v=this.getRelativeLuminance(),E=f.getRelativeLuminance();return v>E?(v+.05)/(E+.05):(E+.05)/(v+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(f){const v=this.getRelativeLuminance(),E=f.getRelativeLuminance();return v>E}isDarkerThan(f){const v=this.getRelativeLuminance(),E=f.getRelativeLuminance();return v<E}lighten(f){return new D(new R(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*f,this.hsla.a))}darken(f){return new D(new R(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*f,this.hsla.a))}transparent(f){const{r:v,g:E,b:P,a:S}=this.rgba;return new D(new t(v,E,P,S*f))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new D(new t(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(f){const v=f.rgba,E=this.rgba.a,P=v.a,S=E+P*(1-E);if(S<1e-6)return D.transparent;const w=this.rgba.r*E/S+v.r*P*(1-E)/S,u=this.rgba.g*E/S+v.g*P*(1-E)/S,m=this.rgba.b*E/S+v.b*P*(1-E)/S;return new D(new t(w,u,m,S))}makeOpaque(f){if(this.isOpaque()||f.rgba.a!==1)return this;const{r:v,g:E,b:P,a:S}=this.rgba;return new D(new t(f.rgba.r-S*(f.rgba.r-v),f.rgba.g-S*(f.rgba.g-E),f.rgba.b-S*(f.rgba.b-P),1))}flatten(...f){const v=f.reduceRight((E,P)=>D._flatten(P,E));return D._flatten(this,v)}static _flatten(f,v){const E=1-f.rgba.a;return new D(new t(E*v.rgba.r+f.rgba.a*f.rgba.r,E*v.rgba.g+f.rgba.a*f.rgba.g,E*v.rgba.b+f.rgba.a*f.rgba.b))}toString(){return this._toString||(this._toString=D.Format.CSS.format(this)),this._toString}static getLighterColor(f,v,E){if(f.isLighterThan(v))return f;E=E||.5;const P=f.getRelativeLuminance(),S=v.getRelativeLuminance();return E=E*(S-P)/S,f.lighten(E)}static getDarkerColor(f,v,E){if(f.isDarkerThan(v))return f;E=E||.5;const P=f.getRelativeLuminance(),S=v.getRelativeLuminance();return E=E*(P-S)/P,f.darken(E)}}e.Color=D,D.white=new D(new t(255,255,255,1)),D.black=new D(new t(0,0,0,1)),D.red=new D(new t(255,0,0,1)),D.blue=new D(new t(0,0,255,1)),D.green=new D(new t(0,255,0,1)),D.cyan=new D(new t(0,255,255,1)),D.lightgrey=new D(new t(211,211,211,1)),D.transparent=new D(new t(0,0,0,0)),function(y){let f;(function(v){let E;(function(P){function S(n){return n.rgba.a===1?`rgb(${n.rgba.r}, ${n.rgba.g}, ${n.rgba.b})`:y.Format.CSS.formatRGBA(n)}P.formatRGB=S;function w(n){return`rgba(${n.rgba.r}, ${n.rgba.g}, ${n.rgba.b}, ${+n.rgba.a.toFixed(2)})`}P.formatRGBA=w;function u(n){return n.hsla.a===1?`hsl(${n.hsla.h}, ${(n.hsla.s*100).toFixed(2)}%, ${(n.hsla.l*100).toFixed(2)}%)`:y.Format.CSS.formatHSLA(n)}P.formatHSL=u;function m(n){return`hsla(${n.hsla.h}, ${(n.hsla.s*100).toFixed(2)}%, ${(n.hsla.l*100).toFixed(2)}%, ${n.hsla.a.toFixed(2)})`}P.formatHSLA=m;function g(n){const r=n.toString(16);return r.length!==2?"0"+r:r}function I(n){return`#${g(n.rgba.r)}${g(n.rgba.g)}${g(n.rgba.b)}`}P.formatHex=I;function p(n,r=!1){return r&&n.rgba.a===1?y.Format.CSS.formatHex(n):`#${g(n.rgba.r)}${g(n.rgba.g)}${g(n.rgba.b)}${g(Math.round(n.rgba.a*255))}`}P.formatHexA=p;function d(n){return n.isOpaque()?y.Format.CSS.formatHex(n):y.Format.CSS.formatRGBA(n)}P.format=d;function h(n){const r=n.length;if(r===0||n.charCodeAt(0)!==35)return null;if(r===7){const i=16*l(n.charCodeAt(1))+l(n.charCodeAt(2)),s=16*l(n.charCodeAt(3))+l(n.charCodeAt(4)),o=16*l(n.charCodeAt(5))+l(n.charCodeAt(6));return new y(new t(i,s,o,1))}if(r===9){const i=16*l(n.charCodeAt(1))+l(n.charCodeAt(2)),s=16*l(n.charCodeAt(3))+l(n.charCodeAt(4)),o=16*l(n.charCodeAt(5))+l(n.charCodeAt(6)),a=16*l(n.charCodeAt(7))+l(n.charCodeAt(8));return new y(new t(i,s,o,a/255))}if(r===4){const i=l(n.charCodeAt(1)),s=l(n.charCodeAt(2)),o=l(n.charCodeAt(3));return new y(new t(16*i+i,16*s+s,16*o+o))}if(r===5){const i=l(n.charCodeAt(1)),s=l(n.charCodeAt(2)),o=l(n.charCodeAt(3)),a=l(n.charCodeAt(4));return new y(new t(16*i+i,16*s+s,16*o+o,(16*a+a)/255))}return null}P.parseHex=h;function l(n){switch(n){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(E=v.CSS||(v.CSS={}))})(f=y.Format||(y.Format={}))}(D=e.Color||(e.Color={}))}),define(J[51],Z([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function b(D){return(y,f,v)=>{let E=null,P=null;if(typeof v.value=="function"?(E="value",P=v.value):typeof v.get=="function"&&(E="get",P=v.get),!P)throw new Error("not supported");v[E]=D(P,f)}}e.createDecorator=b;function t(D,y,f){let v=null,E=null;if(typeof f.value=="function"?(v="value",E=f.value,E.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof f.get=="function"&&(v="get",E=f.get),!E)throw new Error("not supported");const P=`$memoize$${y}`;f[v]=function(...S){return this.hasOwnProperty(P)||Object.defineProperty(this,P,{configurable:!1,enumerable:!1,writable:!1,value:E.apply(this,S)}),this[P]}}e.memoize=t;function R(D,y,f){return b((v,E)=>{const P=`$debounce$${E}`,S=`$debounce$result$${E}`;return function(...w){this[S]||(this[S]=f?f():void 0),clearTimeout(this[P]),y&&(this[S]=y(this[S],...w),w=[this[S]]),this[P]=setTimeout(()=>{v.apply(this,w),this[S]=f?f():void 0},D)}})}e.debounce=R;function L(D,y,f){return b((v,E)=>{const P=`$throttle$timer$${E}`,S=`$throttle$result$${E}`,w=`$throttle$lastRun$${E}`,u=`$throttle$pending$${E}`;return function(...m){if(this[S]||(this[S]=f?f():void 0),(this[w]===null||this[w]===void 0)&&(this[w]=-Number.MAX_VALUE),y&&(this[S]=y(this[S],...m)),this[u])return;const g=this[w]+D;g<=Date.now()?(this[w]=Date.now(),v.apply(this,[this[S]]),this[S]=f?f():void 0):(this[u]=!0,this[P]=setTimeout(()=>{this[u]=!1,this[w]=Date.now(),v.apply(this,[this[S]]),this[S]=f?f():void 0},g-Date.now()))}})}e.throttle=L}),define(J[18],Z([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class b{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(n){setTimeout(()=>{throw n.stack?d.isErrorNoTelemetry(n)?new d(n.message+`

`+n.stack):new Error(n.message+`

`+n.stack):n},0)}}addListener(n){return this.listeners.push(n),()=>{this._removeListener(n)}}emit(n){this.listeners.forEach(r=>{r(n)})}_removeListener(n){this.listeners.splice(this.listeners.indexOf(n),1)}setUnexpectedErrorHandler(n){this.unexpectedErrorHandler=n}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(n){this.unexpectedErrorHandler(n),this.emit(n)}onUnexpectedExternalError(n){this.unexpectedErrorHandler(n)}}e.ErrorHandler=b,e.errorHandler=new b;function t(l){e.errorHandler.setUnexpectedErrorHandler(l)}e.setUnexpectedErrorHandler=t;function R(l){f(l)||e.errorHandler.onUnexpectedError(l)}e.onUnexpectedError=R;function L(l){f(l)||e.errorHandler.onUnexpectedExternalError(l)}e.onUnexpectedExternalError=L;function D(l){if(l instanceof Error){const{name:n,message:r}=l,i=l.stacktrace||l.stack;return{$isError:!0,name:n,message:r,stack:i,noTelemetry:d.isErrorNoTelemetry(l)}}return l}e.transformErrorForSerialization=D;const y="Canceled";function f(l){return l instanceof v?!0:l instanceof Error&&l.name===y&&l.message===y}e.isCancellationError=f;class v extends Error{constructor(){super(y);this.name=this.message}}e.CancellationError=v;function E(){const l=new Error(y);return l.name=l.message,l}e.canceled=E;function P(l){return l?new Error(`Illegal argument: ${l}`):new Error("Illegal argument")}e.illegalArgument=P;function S(l){return l?new Error(`Illegal state: ${l}`):new Error("Illegal state")}e.illegalState=S;function w(l){return l?new Error(`readonly property '${l} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=w;function u(l){const n=new Error(`${l} has been disposed`);return n.name="DISPOSED",n}e.disposed=u;function m(l){return l?l.message?l.message:l.stack?l.stack.split(`
`)[0]:String(l):"Error"}e.getErrorMessage=m;class g extends Error{constructor(n){super("NotImplemented");n&&(this.message=n)}}e.NotImplementedError=g;class I extends Error{constructor(n){super("NotSupported");n&&(this.message=n)}}e.NotSupportedError=I;class p extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=p;class d extends Error{constructor(n){super(n);this.name="ErrorNoTelemetry"}static fromError(n){if(n instanceof d)return n;const r=new d;return r.message=n.message,r.stack=n.stack,r}static isErrorNoTelemetry(n){return n.name==="ErrorNoTelemetry"}}e.ErrorNoTelemetry=d;class h extends Error{constructor(n){super(n||"An unexpected bug occurred.");Object.setPrototypeOf(this,h.prototype);debugger}}e.BugIndicatingError=h}),define(J[25],Z([0,1,18]),function(z,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function t(_,$=0){return _[_.length-(1+$)]}e.tail=t;function R(_){if(_.length===0)throw new Error("Invalid tail call");return[_.slice(0,_.length-1),_[_.length-1]]}e.tail2=R;function L(_,$,G=(ie,ae)=>ie===ae){if(_===$)return!0;if(!_||!$||_.length!==$.length)return!1;for(let ie=0,ae=_.length;ie<ae;ie++)if(!G(_[ie],$[ie]))return!1;return!0}e.equals=L;function D(_,$,G){return y(_.length,ie=>G(_[ie],$))}e.binarySearch=D;function y(_,$){let G=0,ie=_-1;for(;G<=ie;){const ae=(G+ie)/2|0,me=$(ae);if(me<0)G=ae+1;else if(me>0)ie=ae-1;else return ae}return-(G+1)}e.binarySearch2=y;function f(_,$){let G=0,ie=_.length;if(ie===0)return 0;for(;G<ie;){const ae=Math.floor((G+ie)/2);$(_[ae])?ie=ae:G=ae+1}return G}e.findFirstInSorted=f;function v(_,$,G){if(_=_|0,_>=$.length)throw new TypeError("invalid index");const ie=$[Math.floor($.length*Math.random())],ae=[],me=[],fe=[];for(const Pe of $){const Ee=G(Pe,ie);Ee<0?ae.push(Pe):Ee>0?me.push(Pe):fe.push(Pe)}return _<ae.length?v(_,ae,G):_<ae.length+fe.length?fe[0]:v(_-(ae.length+fe.length),me,G)}e.quickSelect=v;function E(_,$){const G=[];let ie;for(const ae of _.slice(0).sort($))!ie||$(ie[0],ae)!==0?(ie=[ae],G.push(ie)):ie.push(ae);return G}e.groupBy=E;function P(_,$,G){const ie=[];function ae(Pe,Ee,ke){if(Ee===0&&ke.length===0)return;const Oe=ie[ie.length-1];Oe&&Oe.start+Oe.deleteCount===Pe?(Oe.deleteCount+=Ee,Oe.toInsert.push(...ke)):ie.push({start:Pe,deleteCount:Ee,toInsert:ke})}let me=0,fe=0;for(;;){if(me===_.length){ae(me,0,$.slice(fe));break}if(fe===$.length){ae(me,_.length-me,[]);break}const Pe=_[me],Ee=$[fe],ke=G(Pe,Ee);ke===0?(me+=1,fe+=1):ke<0?(ae(me,1,[]),me+=1):ke>0&&(ae(me,0,[Ee]),fe+=1)}return ie}e.sortedDiff=P;function S(_,$,G){const ie=P(_,$,G),ae=[],me=[];for(const fe of ie)ae.push(..._.slice(fe.start,fe.start+fe.deleteCount)),me.push(...fe.toInsert);return{removed:ae,added:me}}e.delta=S;function w(_,$,G){if(G===0)return[];const ie=_.slice(0,G).sort($);return m(_,$,ie,G,_.length),ie}e.top=w;function u(_,$,G,ie,ae){return G===0?Promise.resolve([]):new Promise((me,fe)=>{(async()=>{const Pe=_.length,Ee=_.slice(0,G).sort($);for(let ke=G,Oe=Math.min(G+ie,Pe);ke<Pe;ke=Oe,Oe=Math.min(Oe+ie,Pe)){if(ke>G&&await new Promise(Ue=>setTimeout(Ue)),ae&&ae.isCancellationRequested)throw new b.CancellationError;m(_,$,Ee,ke,Oe)}return Ee})().then(me,fe)})}e.topAsync=u;function m(_,$,G,ie,ae){for(const me=G.length;ie<ae;ie++){const fe=_[ie];if($(fe,G[me-1])<0){G.pop();const Pe=f(G,Ee=>$(fe,Ee)<0);G.splice(Pe,0,fe)}}}function g(_){return _.filter($=>!!$)}e.coalesce=g;function I(_){let $=0;for(let G=0;G<_.length;G++)_[G]&&(_[$]=_[G],$+=1);_.length=$}e.coalesceInPlace=I;function p(_,$,G){_.splice(G,0,_.splice($,1)[0])}e.move=p;function d(_){return!Array.isArray(_)||_.length===0}e.isFalsyOrEmpty=d;function h(_){return Array.isArray(_)&&_.length>0}e.isNonEmptyArray=h;function l(_,$=G=>G){const G=new Set;return _.filter(ie=>{const ae=$(ie);return G.has(ae)?!1:(G.add(ae),!0)})}e.distinct=l;function n(_){const $=new Set;return G=>{const ie=_(G);return $.has(ie)?!1:($.add(ie),!0)}}e.uniqueFilter=n;function r(_,$){const G=i(_,$);if(G!==-1)return _[G]}e.findLast=r;function i(_,$){for(let G=_.length-1;G>=0;G--){const ie=_[G];if($(ie))return G}return-1}e.lastIndex=i;function s(_,$){return _.length>0?_[0]:$}e.firstOrDefault=s;function o(_,$){return _.length>0?_[_.length-1]:$}e.lastOrDefault=o;function a(_,$,G=(ie,ae)=>ie===ae){let ie=0;for(let ae=0,me=Math.min(_.length,$.length);ae<me&&G(_[ae],$[ae]);ae++)ie++;return ie}e.commonPrefixLength=a;function c(_){return[].concat(..._)}e.flatten=c;function C(_,$){let G=typeof $=="number"?_:0;typeof $=="number"?G=_:(G=0,$=_);const ie=[];if(G<=$)for(let ae=G;ae<$;ae++)ie.push(ae);else for(let ae=G;ae>$;ae--)ie.push(ae);return ie}e.range=C;function k(_,$,G){return _.reduce((ie,ae)=>(ie[$(ae)]=G?G(ae):ae,ie),Object.create(null))}e.index=k;function M(_,$){return _.push($),()=>T(_,$)}e.insert=M;function T(_,$){const G=_.indexOf($);if(G>-1)return _.splice(G,1),$}e.remove=T;function F(_,$,G){const ie=_.slice(0,$),ae=_.slice($);return ie.concat(G,ae)}e.arrayInsert=F;function q(_,$){let G;if(typeof $=="number"){let ie=$;G=()=>{const ae=Math.sin(ie++)*179426549;return ae-Math.floor(ae)}}else G=Math.random;for(let ie=_.length-1;ie>0;ie-=1){const ae=Math.floor(G()*(ie+1)),me=_[ie];_[ie]=_[ae],_[ae]=me}}e.shuffle=q;function te(_,$){const G=_.indexOf($);G>-1&&(_.splice(G,1),_.unshift($))}e.pushToStart=te;function ne(_,$){const G=_.indexOf($);G>-1&&(_.splice(G,1),_.push($))}e.pushToEnd=ne;function Q(_,$){for(const G of $)_.push(G)}e.pushMany=Q;function se(_,$){return Array.isArray(_)?_.map($):$(_)}e.mapArrayOrNot=se;function ce(_){return Array.isArray(_)?_:[_]}e.asArray=ce;function H(_){return _[Math.floor(Math.random()*_.length)]}e.getRandomElement=H;function oe(_,$){for(const G of _){const ie=$(G);if(ie!==void 0)return ie}}e.mapFind=oe;function W(_,$,G){const ie=B(_,$),ae=_.length,me=G.length;_.length=ae+me;for(let fe=ae-1;fe>=ie;fe--)_[fe+me]=_[fe];for(let fe=0;fe<me;fe++)_[fe+ie]=G[fe]}e.insertInto=W;function U(_,$,G,ie){const ae=B(_,$),me=_.splice(ae,G);return W(_,ae,ie),me}e.splice=U;function B(_,$){return $<0?Math.max($+_.length,0):Math.min($,_.length)}var X;(function(_){function $(ae){return ae<0}_.isLessThan=$;function G(ae){return ae>0}_.isGreaterThan=G;function ie(ae){return ae===0}_.isNeitherLessOrGreaterThan=ie,_.greaterThan=1,_.lessThan=-1,_.neitherLessOrGreaterThan=0})(X=e.CompareResult||(e.CompareResult={}));function j(_,$){return(G,ie)=>$(_(G),_(ie))}e.compareBy=j;function Y(..._){return($,G)=>{for(const ie of _){const ae=ie($,G);if(!X.isNeitherLessOrGreaterThan(ae))return ae}return X.neitherLessOrGreaterThan}}e.tieBreakComparators=Y;const x=(_,$)=>_-$;e.numberComparator=x;function A(_,$){if(_.length===0)return;let G=_[0];for(let ie=1;ie<_.length;ie++){const ae=_[ie];$(ae,G)>0&&(G=ae)}return G}e.findMaxBy=A;function O(_,$){if(_.length===0)return;let G=_[0];for(let ie=1;ie<_.length;ie++){const ae=_[ie];$(ae,G)>=0&&(G=ae)}return G}e.findLastMaxBy=O;function N(_,$){return A(_,(G,ie)=>-$(G,ie))}e.findMinBy=N;class V{constructor($){this.items=$,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile($){let G=this.firstIdx;for(;G<this.items.length&&$(this.items[G]);)G++;const ie=G===this.firstIdx?null:this.items.slice(this.firstIdx,G);return this.firstIdx=G,ie}takeFromEndWhile($){let G=this.lastIdx;for(;G>=0&&$(this.items[G]);)G--;const ie=G===this.lastIdx?null:this.items.slice(G+1,this.lastIdx+1);return this.lastIdx=G,ie}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const $=this.items[this.firstIdx];return this.firstIdx++,$}removeLast(){const $=this.items[this.lastIdx];return this.lastIdx--,$}takeCount($){const G=this.items.slice(this.firstIdx,this.firstIdx+$);return this.firstIdx+=$,G}}e.ArrayQueue=V}),define(J[48],Z([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function b(t){const R=this;let L=!1,D;return function(){return L||(L=!0,D=t.apply(R,arguments)),D}}e.once=b}),define(J[53],Z([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var b;(function(t){function R(r){return r&&typeof r=="object"&&typeof r[Symbol.iterator]=="function"}t.is=R;const L=Object.freeze([]);function D(){return L}t.empty=D;function*y(r){yield r}t.single=y;function f(r){return r||L}t.from=f;function v(r){return!r||r[Symbol.iterator]().next().done===!0}t.isEmpty=v;function E(r){return r[Symbol.iterator]().next().value}t.first=E;function P(r,i){for(const s of r)if(i(s))return!0;return!1}t.some=P;function S(r,i){for(const s of r)if(i(s))return s}t.find=S;function*w(r,i){for(const s of r)i(s)&&(yield s)}t.filter=w;function*u(r,i){let s=0;for(const o of r)yield i(o,s++)}t.map=u;function*m(...r){for(const i of r)for(const s of i)yield s}t.concat=m;function*g(r){for(const i of r)for(const s of i)yield s}t.concatNested=g;function I(r,i,s){let o=s;for(const a of r)o=i(o,a);return o}t.reduce=I;function p(r,i){let s=0;for(const o of r)i(o,s++)}t.forEach=p;function*d(r,i,s=r.length){for(i<0&&(i+=r.length),s<0?s+=r.length:s>r.length&&(s=r.length);i<s;i++)yield r[i]}t.slice=d;function h(r,i=Number.POSITIVE_INFINITY){const s=[];if(i===0)return[s,r];const o=r[Symbol.iterator]();for(let a=0;a<i;a++){const c=o.next();if(c.done)return[s,t.empty()];s.push(c.value)}return[s,{[Symbol.iterator](){return o}}]}t.consume=h;function l(r){return h(r)[0]}t.collect=l;function n(r,i,s=(o,a)=>o===a){const o=r[Symbol.iterator](),a=i[Symbol.iterator]();for(;;){const c=o.next(),C=a.next();if(c.done!==C.done)return!1;if(c.done)return!0;if(!s(c.value,C.value))return!1}}t.equals=n})(b=e.Iterable||(e.Iterable={}))}),define(J[49],Z([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var b;(function(n){n[n.None=0]="None",n[n.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=2]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",n[n.InvalidUnicode=4]="InvalidUnicode",n[n.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",n[n.InvalidCharacter=6]="InvalidCharacter"})(b=e.ScanError||(e.ScanError={}));var t;(function(n){n[n.OpenBraceToken=1]="OpenBraceToken",n[n.CloseBraceToken=2]="CloseBraceToken",n[n.OpenBracketToken=3]="OpenBracketToken",n[n.CloseBracketToken=4]="CloseBracketToken",n[n.CommaToken=5]="CommaToken",n[n.ColonToken=6]="ColonToken",n[n.NullKeyword=7]="NullKeyword",n[n.TrueKeyword=8]="TrueKeyword",n[n.FalseKeyword=9]="FalseKeyword",n[n.StringLiteral=10]="StringLiteral",n[n.NumericLiteral=11]="NumericLiteral",n[n.LineCommentTrivia=12]="LineCommentTrivia",n[n.BlockCommentTrivia=13]="BlockCommentTrivia",n[n.LineBreakTrivia=14]="LineBreakTrivia",n[n.Trivia=15]="Trivia",n[n.Unknown=16]="Unknown",n[n.EOF=17]="EOF"})(t=e.SyntaxKind||(e.SyntaxKind={}));var R;(function(n){n[n.InvalidSymbol=1]="InvalidSymbol",n[n.InvalidNumberFormat=2]="InvalidNumberFormat",n[n.PropertyNameExpected=3]="PropertyNameExpected",n[n.ValueExpected=4]="ValueExpected",n[n.ColonExpected=5]="ColonExpected",n[n.CommaExpected=6]="CommaExpected",n[n.CloseBraceExpected=7]="CloseBraceExpected",n[n.CloseBracketExpected=8]="CloseBracketExpected",n[n.EndOfFileExpected=9]="EndOfFileExpected",n[n.InvalidCommentToken=10]="InvalidCommentToken",n[n.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=12]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",n[n.InvalidUnicode=14]="InvalidUnicode",n[n.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",n[n.InvalidCharacter=16]="InvalidCharacter"})(R=e.ParseErrorCode||(e.ParseErrorCode={}));var L;(function(n){n.DEFAULT={allowTrailingComma:!0}})(L=e.ParseOptions||(e.ParseOptions={}));function D(n,r=!1){let i=0;const s=n.length;let o="",a=0,c=16,C=0;function k(Q){let se=0,ce=0;for(;se<Q;){const H=n.charCodeAt(i);if(H>=48&&H<=57)ce=ce*16+H-48;else if(H>=65&&H<=70)ce=ce*16+H-65+10;else if(H>=97&&H<=102)ce=ce*16+H-97+10;else break;i++,se++}return se<Q&&(ce=-1),ce}function M(Q){i=Q,o="",a=0,c=16,C=0}function T(){const Q=i;if(n.charCodeAt(i)===48)i++;else for(i++;i<n.length&&v(n.charCodeAt(i));)i++;if(i<n.length&&n.charCodeAt(i)===46)if(i++,i<n.length&&v(n.charCodeAt(i)))for(i++;i<n.length&&v(n.charCodeAt(i));)i++;else return C=3,n.substring(Q,i);let se=i;if(i<n.length&&(n.charCodeAt(i)===69||n.charCodeAt(i)===101))if(i++,(i<n.length&&n.charCodeAt(i)===43||n.charCodeAt(i)===45)&&i++,i<n.length&&v(n.charCodeAt(i))){for(i++;i<n.length&&v(n.charCodeAt(i));)i++;se=i}else C=3;return n.substring(Q,se)}function F(){let Q="",se=i;for(;;){if(i>=s){Q+=n.substring(se,i),C=2;break}const ce=n.charCodeAt(i);if(ce===34){Q+=n.substring(se,i),i++;break}if(ce===92){if(Q+=n.substring(se,i),i++,i>=s){C=2;break}switch(n.charCodeAt(i++)){case 34:Q+='"';break;case 92:Q+="\\";break;case 47:Q+="/";break;case 98:Q+="\b";break;case 102:Q+="\f";break;case 110:Q+=`
`;break;case 114:Q+="\r";break;case 116:Q+="	";break;case 117:{const oe=k(4);oe>=0?Q+=String.fromCharCode(oe):C=4;break}default:C=5}se=i;continue}if(ce>=0&&ce<=31)if(f(ce)){Q+=n.substring(se,i),C=2;break}else C=6;i++}return Q}function q(){if(o="",C=0,a=i,i>=s)return a=s,c=17;let Q=n.charCodeAt(i);if(y(Q)){do i++,o+=String.fromCharCode(Q),Q=n.charCodeAt(i);while(y(Q));return c=15}if(f(Q))return i++,o+=String.fromCharCode(Q),Q===13&&n.charCodeAt(i)===10&&(i++,o+=`
`),c=14;switch(Q){case 123:return i++,c=1;case 125:return i++,c=2;case 91:return i++,c=3;case 93:return i++,c=4;case 58:return i++,c=6;case 44:return i++,c=5;case 34:return i++,o=F(),c=10;case 47:{const se=i-1;if(n.charCodeAt(i+1)===47){for(i+=2;i<s&&!f(n.charCodeAt(i));)i++;return o=n.substring(se,i),c=12}if(n.charCodeAt(i+1)===42){i+=2;const ce=s-1;let H=!1;for(;i<ce;){if(n.charCodeAt(i)===42&&n.charCodeAt(i+1)===47){i+=2,H=!0;break}i++}return H||(i++,C=1),o=n.substring(se,i),c=13}return o+=String.fromCharCode(Q),i++,c=16}case 45:if(o+=String.fromCharCode(Q),i++,i===s||!v(n.charCodeAt(i)))return c=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=T(),c=11;default:for(;i<s&&te(Q);)i++,Q=n.charCodeAt(i);if(a!==i){switch(o=n.substring(a,i),o){case"true":return c=8;case"false":return c=9;case"null":return c=7}return c=16}return o+=String.fromCharCode(Q),i++,c=16}}function te(Q){if(y(Q)||f(Q))return!1;switch(Q){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function ne(){let Q;do Q=q();while(Q>=12&&Q<=15);return Q}return{setPosition:M,getPosition:()=>i,scan:r?ne:q,getToken:()=>c,getTokenValue:()=>o,getTokenOffset:()=>a,getTokenLength:()=>i-a,getTokenError:()=>C}}e.createScanner=D;function y(n){return n===32||n===9||n===11||n===12||n===160||n===5760||n>=8192&&n<=8203||n===8239||n===8287||n===12288||n===65279}function f(n){return n===10||n===13||n===8232||n===8233}function v(n){return n>=48&&n<=57}var E;(function(n){n[n.nullCharacter=0]="nullCharacter",n[n.maxAsciiCharacter=127]="maxAsciiCharacter",n[n.lineFeed=10]="lineFeed",n[n.carriageReturn=13]="carriageReturn",n[n.lineSeparator=8232]="lineSeparator",n[n.paragraphSeparator=8233]="paragraphSeparator",n[n.nextLine=133]="nextLine",n[n.space=32]="space",n[n.nonBreakingSpace=160]="nonBreakingSpace",n[n.enQuad=8192]="enQuad",n[n.emQuad=8193]="emQuad",n[n.enSpace=8194]="enSpace",n[n.emSpace=8195]="emSpace",n[n.threePerEmSpace=8196]="threePerEmSpace",n[n.fourPerEmSpace=8197]="fourPerEmSpace",n[n.sixPerEmSpace=8198]="sixPerEmSpace",n[n.figureSpace=8199]="figureSpace",n[n.punctuationSpace=8200]="punctuationSpace",n[n.thinSpace=8201]="thinSpace",n[n.hairSpace=8202]="hairSpace",n[n.zeroWidthSpace=8203]="zeroWidthSpace",n[n.narrowNoBreakSpace=8239]="narrowNoBreakSpace",n[n.ideographicSpace=12288]="ideographicSpace",n[n.mathematicalSpace=8287]="mathematicalSpace",n[n.ogham=5760]="ogham",n[n._=95]="_",n[n.$=36]="$",n[n._0=48]="_0",n[n._1=49]="_1",n[n._2=50]="_2",n[n._3=51]="_3",n[n._4=52]="_4",n[n._5=53]="_5",n[n._6=54]="_6",n[n._7=55]="_7",n[n._8=56]="_8",n[n._9=57]="_9",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.ampersand=38]="ampersand",n[n.asterisk=42]="asterisk",n[n.at=64]="at",n[n.backslash=92]="backslash",n[n.bar=124]="bar",n[n.caret=94]="caret",n[n.closeBrace=125]="closeBrace",n[n.closeBracket=93]="closeBracket",n[n.closeParen=41]="closeParen",n[n.colon=58]="colon",n[n.comma=44]="comma",n[n.dot=46]="dot",n[n.doubleQuote=34]="doubleQuote",n[n.equals=61]="equals",n[n.exclamation=33]="exclamation",n[n.greaterThan=62]="greaterThan",n[n.lessThan=60]="lessThan",n[n.minus=45]="minus",n[n.openBrace=123]="openBrace",n[n.openBracket=91]="openBracket",n[n.openParen=40]="openParen",n[n.percent=37]="percent",n[n.plus=43]="plus",n[n.question=63]="question",n[n.semicolon=59]="semicolon",n[n.singleQuote=39]="singleQuote",n[n.slash=47]="slash",n[n.tilde=126]="tilde",n[n.backspace=8]="backspace",n[n.formFeed=12]="formFeed",n[n.byteOrderMark=65279]="byteOrderMark",n[n.tab=9]="tab",n[n.verticalTab=11]="verticalTab"})(E||(E={}));function P(n,r){const i=[],s=new Object;let o;const a={value:{},offset:0,length:0,type:"object",parent:void 0};let c=!1;function C(k,M,T,F){a.value=k,a.offset=M,a.length=T,a.type=F,a.colonOffset=void 0,o=a}try{d(n,{onObjectBegin:(k,M)=>{if(r<=k)throw s;o=void 0,c=r>k,i.push("")},onObjectProperty:(k,M,T)=>{if(r<M||(C(k,M,T,"property"),i[i.length-1]=k,r<=M+T))throw s},onObjectEnd:(k,M)=>{if(r<=k)throw s;o=void 0,i.pop()},onArrayBegin:(k,M)=>{if(r<=k)throw s;o=void 0,i.push(0)},onArrayEnd:(k,M)=>{if(r<=k)throw s;o=void 0,i.pop()},onLiteralValue:(k,M,T)=>{if(r<M||(C(k,M,T,l(k)),r<=M+T))throw s},onSeparator:(k,M,T)=>{if(r<=M)throw s;if(k===":"&&o&&o.type==="property")o.colonOffset=M,c=!1,o=void 0;else if(k===","){const F=i[i.length-1];typeof F=="number"?i[i.length-1]=F+1:(c=!0,i[i.length-1]=""),o=void 0}}})}catch(k){if(k!==s)throw k}return{path:i,previousNode:o,isAtPropertyKey:c,matches:k=>{let M=0;for(let T=0;M<k.length&&T<i.length;T++)if(k[M]===i[T]||k[M]==="*")M++;else if(k[M]!=="**")return!1;return M===k.length}}}e.getLocation=P;function S(n,r=[],i=L.DEFAULT){let s=null,o=[];const a=[];function c(k){Array.isArray(o)?o.push(k):s!==null&&(o[s]=k)}return d(n,{onObjectBegin:()=>{const k={};c(k),a.push(o),o=k,s=null},onObjectProperty:k=>{s=k},onObjectEnd:()=>{o=a.pop()},onArrayBegin:()=>{const k=[];c(k),a.push(o),o=k,s=null},onArrayEnd:()=>{o=a.pop()},onLiteralValue:c,onError:(k,M,T)=>{r.push({error:k,offset:M,length:T})}},i),o[0]}e.parse=S;function w(n,r=[],i=L.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(k){s.type==="property"&&(s.length=k-s.offset,s=s.parent)}function a(k){return s.children.push(k),k}d(n,{onObjectBegin:k=>{s=a({type:"object",offset:k,length:-1,parent:s,children:[]})},onObjectProperty:(k,M,T)=>{s=a({type:"property",offset:M,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:k,offset:M,length:T,parent:s})},onObjectEnd:(k,M)=>{s.length=k+M-s.offset,s=s.parent,o(k+M)},onArrayBegin:(k,M)=>{s=a({type:"array",offset:k,length:-1,parent:s,children:[]})},onArrayEnd:(k,M)=>{s.length=k+M-s.offset,s=s.parent,o(k+M)},onLiteralValue:(k,M,T)=>{a({type:l(k),offset:M,length:T,parent:s,value:k}),o(M+T)},onSeparator:(k,M,T)=>{s.type==="property"&&(k===":"?s.colonOffset=M:k===","&&o(M))},onError:(k,M,T)=>{r.push({error:k,offset:M,length:T})}},i);const C=s.children[0];return C&&delete C.parent,C}e.parseTree=w;function u(n,r){if(!n)return;let i=n;for(const s of r)if(typeof s=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let o=!1;for(const a of i.children)if(Array.isArray(a.children)&&a.children[0].value===s){i=a.children[1],o=!0;break}if(!o)return}else{const o=s;if(i.type!=="array"||o<0||!Array.isArray(i.children)||o>=i.children.length)return;i=i.children[o]}return i}e.findNodeAtLocation=u;function m(n){if(!n.parent||!n.parent.children)return[];const r=m(n.parent);if(n.parent.type==="property"){const i=n.parent.children[0].value;r.push(i)}else if(n.parent.type==="array"){const i=n.parent.children.indexOf(n);i!==-1&&r.push(i)}return r}e.getNodePath=m;function g(n){switch(n.type){case"array":return n.children.map(g);case"object":{const r=Object.create(null);for(const i of n.children){const s=i.children[1];s&&(r[i.children[0].value]=g(s))}return r}case"null":case"string":case"number":case"boolean":return n.value;default:return}}e.getNodeValue=g;function I(n,r,i=!1){return r>=n.offset&&r<n.offset+n.length||i&&r===n.offset+n.length}e.contains=I;function p(n,r,i=!1){if(I(n,r,i)){const s=n.children;if(Array.isArray(s))for(let o=0;o<s.length&&s[o].offset<=r;o++){const a=p(s[o],r,i);if(a)return a}return n}}e.findNodeAtOffset=p;function d(n,r,i=L.DEFAULT){const s=D(n,!1);function o(Y){return Y?()=>Y(s.getTokenOffset(),s.getTokenLength()):()=>!0}function a(Y){return Y?x=>Y(x,s.getTokenOffset(),s.getTokenLength()):()=>!0}const c=o(r.onObjectBegin),C=a(r.onObjectProperty),k=o(r.onObjectEnd),M=o(r.onArrayBegin),T=o(r.onArrayEnd),F=a(r.onLiteralValue),q=a(r.onSeparator),te=o(r.onComment),ne=a(r.onError),Q=i&&i.disallowComments,se=i&&i.allowTrailingComma;function ce(){for(;;){const Y=s.scan();switch(s.getTokenError()){case 4:H(14);break;case 5:H(15);break;case 3:H(13);break;case 1:Q||H(11);break;case 2:H(12);break;case 6:H(16);break}switch(Y){case 12:case 13:Q?H(10):te();break;case 16:H(1);break;case 15:case 14:break;default:return Y}}}function H(Y,x=[],A=[]){if(ne(Y),x.length+A.length>0){let O=s.getToken();for(;O!==17;){if(x.indexOf(O)!==-1){ce();break}else if(A.indexOf(O)!==-1)break;O=ce()}}}function oe(Y){const x=s.getTokenValue();return Y?F(x):C(x),ce(),!0}function W(){switch(s.getToken()){case 11:{let Y=0;try{Y=JSON.parse(s.getTokenValue()),typeof Y!="number"&&(H(2),Y=0)}catch{H(2)}F(Y);break}case 7:F(null);break;case 8:F(!0);break;case 9:F(!1);break;default:return!1}return ce(),!0}function U(){return s.getToken()!==10?(H(3,[],[2,5]),!1):(oe(!1),s.getToken()===6?(q(":"),ce(),j()||H(4,[],[2,5])):H(5,[],[2,5]),!0)}function B(){c(),ce();let Y=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(Y||H(4,[],[]),q(","),ce(),s.getToken()===2&&se)break}else Y&&H(6,[],[]);U()||H(4,[],[2,5]),Y=!0}return k(),s.getToken()!==2?H(7,[2],[]):ce(),!0}function X(){M(),ce();let Y=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(Y||H(4,[],[]),q(","),ce(),s.getToken()===4&&se)break}else Y&&H(6,[],[]);j()||H(4,[],[4,5]),Y=!0}return T(),s.getToken()!==4?H(8,[4],[]):ce(),!0}function j(){switch(s.getToken()){case 3:return X();case 1:return B();case 10:return oe(!0);default:return W()}}return ce(),s.getToken()===17?i.allowEmptyContent?!0:(H(4,[],[]),!1):j()?(s.getToken()!==17&&H(9,[],[]),!0):(H(4,[],[]),!1)}e.visit=d;function h(n,r){const i=D(n),s=[];let o,a=0,c;do switch(c=i.getPosition(),o=i.scan(),o){case 12:case 13:case 17:a!==c&&s.push(n.substring(a,c)),r!==void 0&&s.push(i.getTokenValue().replace(/[^\r\n]/g,r)),a=i.getPosition();break}while(o!==17);return s.join("")}e.stripComments=h;function l(n){switch(typeof n){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(n){if(Array.isArray(n))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=l}),define(J[117],Z([0,1,49]),function(z,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function t(v,E,P){let S,w,u,m,g;if(E){for(m=E.offset,g=m+E.length,u=m;u>0&&!f(v,u-1);)u--;let c=g;for(;c<v.length&&!f(v,c);)c++;w=v.substring(u,c),S=D(w,P)}else w=v,S=0,u=0,m=0,g=v.length;const I=y(P,v);let p=!1,d=0,h;P.insertSpaces?h=L(" ",P.tabSize||4):h="	";const l=(0,b.createScanner)(w,!1);let n=!1;function r(){return I+L(h,S+d)}function i(){let c=l.scan();for(p=!1;c===15||c===14;)p=p||c===14,c=l.scan();return n=c===16||l.getTokenError()!==0,c}const s=[];function o(c,C,k){!n&&C<g&&k>m&&v.substring(C,k)!==c&&s.push({offset:C,length:k-C,content:c})}let a=i();if(a!==17){const c=l.getTokenOffset()+u,C=L(h,S);o(C,u,c)}for(;a!==17;){let c=l.getTokenOffset()+l.getTokenLength()+u,C=i(),k="";for(;!p&&(C===12||C===13);){const T=l.getTokenOffset()+u;o(" ",c,T),c=l.getTokenOffset()+l.getTokenLength()+u,k=C===12?r():"",C=i()}if(C===2)a!==1&&(d--,k=r());else if(C===4)a!==3&&(d--,k=r());else{switch(a){case 3:case 1:d++,k=r();break;case 5:case 12:k=r();break;case 13:p?k=r():k=" ";break;case 6:k=" ";break;case 10:if(C===6){k="";break}case 7:case 8:case 9:case 11:case 2:case 4:C===12||C===13?k=" ":C!==5&&C!==17&&(n=!0);break;case 16:n=!0;break}p&&(C===12||C===13)&&(k=r())}const M=l.getTokenOffset()+u;o(k,c,M),a=C}return s}e.format=t;function R(v,E){const P=JSON.stringify(v,void 0,E.insertSpaces?E.tabSize||4:"	");return E.eol!==void 0?P.replace(/\r\n|\r|\n/g,E.eol):P}e.toFormattedString=R;function L(v,E){let P="";for(let S=0;S<E;S++)P+=v;return P}function D(v,E){let P=0,S=0;const w=E.tabSize||4;for(;P<v.length;){const u=v.charAt(P);if(u===" ")S++;else if(u==="	")S+=w;else break;P++}return Math.floor(S/w)}function y(v,E){for(let P=0;P<E.length;P++){const S=E.charAt(P);if(S==="\r")return P+1<E.length&&E.charAt(P+1)===`
`?`\r
`:"\r";if(S===`
`)return`
`}return v&&v.eol||`
`}e.getEOL=y;function f(v,E){return`\r
`.indexOf(v.charAt(E))!==-1}e.isEOL=f}),define(J[118],Z([0,1,49,117]),function(z,e,b,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function R(v,E,P){return L(v,E,void 0,P)}e.removeProperty=R;function L(v,E,P,S,w){const u=E.slice(),m=[],g=(0,b.parseTree)(v,m);let I,p;for(;u.length>0&&(p=u.pop(),I=(0,b.findNodeAtLocation)(g,u),I===void 0&&P!==void 0);)typeof p=="string"?P={[p]:P}:P=[P];if(I)if(I.type==="object"&&typeof p=="string"&&Array.isArray(I.children)){const d=(0,b.findNodeAtLocation)(I,[p]);if(d!==void 0)if(P===void 0){if(!d.parent)throw new Error("Malformed AST");const h=I.children.indexOf(d.parent);let l,n=d.parent.offset+d.parent.length;if(h>0){const r=I.children[h-1];l=r.offset+r.length}else l=I.offset+1,I.children.length>1&&(n=I.children[1].offset);return D(v,{offset:l,length:n-l,content:""},S)}else return D(v,{offset:d.offset,length:d.length,content:JSON.stringify(P)},S);else{if(P===void 0)return[];const h=`${JSON.stringify(p)}: ${JSON.stringify(P)}`,l=w?w(I.children.map(r=>r.children[0].value)):I.children.length;let n;if(l>0){const r=I.children[l-1];n={offset:r.offset+r.length,length:0,content:","+h}}else I.children.length===0?n={offset:I.offset+1,length:0,content:h}:n={offset:I.offset+1,length:0,content:h+","};return D(v,n,S)}}else if(I.type==="array"&&typeof p=="number"&&Array.isArray(I.children))if(P!==void 0){const d=`${JSON.stringify(P)}`;let h;if(I.children.length===0||p===0)h={offset:I.offset+1,length:0,content:I.children.length===0?d:d+","};else{const l=p===-1||p>I.children.length?I.children.length:p,n=I.children[l-1];h={offset:n.offset+n.length,length:0,content:","+d}}return D(v,h,S)}else{const d=p,h=I.children[d];let l;if(I.children.length===1)l={offset:I.offset+1,length:I.length-2,content:""};else if(I.children.length-1===d){const n=I.children[d-1],r=n.offset+n.length,i=I.offset+I.length;l={offset:r,length:i-2-r,content:""}}else l={offset:h.offset,length:I.children[d+1].offset-h.offset,content:""};return D(v,l,S)}else throw new Error(`Can not add ${typeof p!="number"?"index":"property"} to parent of type ${I.type}`);else{if(P===void 0)throw new Error("Can not delete in empty document");return D(v,{offset:g?g.offset:0,length:g?g.length:0,content:JSON.stringify(P)},S)}}e.setProperty=L;function D(v,E,P){let S=y(v,E),w=E.offset,u=E.offset+E.content.length;if(E.length===0||E.content.length===0){for(;w>0&&!(0,t.isEOL)(S,w-1);)w--;for(;u<S.length&&!(0,t.isEOL)(S,u);)u++}const m=(0,t.format)(S,{offset:w,length:u-w},P);for(let I=m.length-1;I>=0;I--){const p=m[I];S=y(S,p),w=Math.min(w,p.offset),u=Math.max(u,p.offset+p.length),u+=p.content.length-p.length}const g=v.length-(S.length-u)-w;return[{offset:w,length:g,content:S.substring(w,u)}]}e.withFormatting=D;function y(v,E){return v.substring(0,E.offset)+E.content+v.substring(E.offset+E.length)}e.applyEdit=y;function f(v,E){const P=E.slice(0).sort((w,u)=>{const m=w.offset-u.offset;return m===0?w.length-u.length:m});let S=v.length;for(let w=P.length-1;w>=0;w--){const u=P[w];if(u.offset+u.length<=S)v=y(v,u);else throw new Error("Overlapping edit");S=u.offset}return v}e.applyEdits=f}),define(J[119],Z([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class b{constructor(R){this.executor=R,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(R){this._error=R}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(R){return new b(()=>R(this.getValue()))}}e.Lazy=b}),define(J[2],Z([0,1,48,53]),function(z,e,b,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const R=!1;let L=null;function D(o){L=o}if(e.setDisposableTracker=D,R){const o="__is_disposable_tracked__";D(new class{trackDisposable(a){const c=new Error("Potentially leaked disposable").stack;setTimeout(()=>{a[o]||console.log(c)},3e3)}setParent(a,c){if(a&&a!==p.None)try{a[o]=!0}catch{}}markAsDisposed(a){if(a&&a!==p.None)try{a[o]=!0}catch{}}markAsSingleton(a){}})}function y(o){return L?.trackDisposable(o),o}function f(o){L?.markAsDisposed(o)}function v(o,a){L?.setParent(o,a)}function E(o,a){if(!!L)for(const c of o)L.setParent(c,a)}function P(o){return L?.markAsSingleton(o),o}e.markAsSingleton=P;class S extends Error{constructor(a){super(`Encountered errors while disposing of store. Errors: [${a.join(", ")}]`);this.errors=a}}e.MultiDisposeError=S;function w(o){return typeof o.dispose=="function"&&o.dispose.length===0}e.isDisposable=w;function u(o){if(t.Iterable.is(o)){const a=[];for(const c of o)if(c)try{c.dispose()}catch(C){a.push(C)}if(a.length===1)throw a[0];if(a.length>1)throw new S(a);return Array.isArray(o)?[]:o}else if(o)return o.dispose(),o}e.dispose=u;function m(...o){const a=g(()=>u(o));return E(o,a),a}e.combinedDisposable=m;function g(o){const a=y({dispose:(0,b.once)(()=>{f(a),o()})});return a}e.toDisposable=g;class I{constructor(){this._toDispose=new Set,this._isDisposed=!1,y(this)}dispose(){this._isDisposed||(f(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{u(this._toDispose.values())}finally{this._toDispose.clear()}}add(a){if(!a)return a;if(a===this)throw new Error("Cannot register a disposable on itself!");return v(a,this),this._isDisposed?I.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(a),a}}e.DisposableStore=I,I.DISABLE_DISPOSED_WARNING=!1;class p{constructor(){this._store=new I,y(this),v(this._store,this)}dispose(){f(this),this._store.dispose()}_register(a){if(a===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(a)}}e.Disposable=p,p.None=Object.freeze({dispose(){}});class d{constructor(){this._isDisposed=!1,y(this)}get value(){return this._isDisposed?void 0:this._value}set value(a){this._isDisposed||a===this._value||(this._value?.dispose(),a&&v(a,this),this._value=a)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,f(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const a=this._value;return this._value=void 0,a&&v(a,null),a}}e.MutableDisposable=d;class h{constructor(a){this._disposable=a,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=h;class l{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,y(this)}set(a){let c=a;return this.unset=()=>c=void 0,this.isset=()=>c!==void 0,this.dispose=()=>{c&&(c(),c=void 0,f(this))},this}}e.SafeDisposable=l;class n{constructor(){this.references=new Map}acquire(a,...c){let C=this.references.get(a);C||(C={counter:0,object:this.createReferencedObject(a,...c)},this.references.set(a,C));const{object:k}=C,M=(0,b.once)(()=>{--C.counter==0&&(this.destroyReferencedObject(a,C.object),this.references.delete(a))});return C.counter++,{object:k,dispose:M}}}e.ReferenceCollection=n;class r{constructor(a){this.referenceCollection=a}async acquire(a,...c){const C=this.referenceCollection.acquire(a,...c);try{return{object:await C.object,dispose:()=>C.dispose()}}catch(k){throw C.dispose(),k}}}e.AsyncReferenceCollection=r;class i{constructor(a){this.object=a}dispose(){}}e.ImmortalReference=i;function s(o){const a=new I;try{o(a)}finally{a.dispose()}}e.disposeOnReturn=s}),define(J[120],Z([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class b{constructor(L){this.element=L,this.next=b.Undefined,this.prev=b.Undefined}}b.Undefined=new b(void 0);class t{constructor(){this._first=b.Undefined,this._last=b.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===b.Undefined}clear(){let L=this._first;for(;L!==b.Undefined;){const D=L.next;L.prev=b.Undefined,L.next=b.Undefined,L=D}this._first=b.Undefined,this._last=b.Undefined,this._size=0}unshift(L){return this._insert(L,!1)}push(L){return this._insert(L,!0)}_insert(L,D){const y=new b(L);if(this._first===b.Undefined)this._first=y,this._last=y;else if(D){const v=this._last;this._last=y,y.prev=v,v.next=y}else{const v=this._first;this._first=y,y.next=v,v.prev=y}this._size+=1;let f=!1;return()=>{f||(f=!0,this._remove(y))}}shift(){if(this._first!==b.Undefined){const L=this._first.element;return this._remove(this._first),L}}pop(){if(this._last!==b.Undefined){const L=this._last.element;return this._remove(this._last),L}}_remove(L){if(L.prev!==b.Undefined&&L.next!==b.Undefined){const D=L.prev;D.next=L.next,L.next.prev=D}else L.prev===b.Undefined&&L.next===b.Undefined?(this._first=b.Undefined,this._last=b.Undefined):L.next===b.Undefined?(this._last=this._last.prev,this._last.next=b.Undefined):L.prev===b.Undefined&&(this._first=this._first.next,this._first.prev=b.Undefined);this._size-=1}*[Symbol.iterator](){let L=this._first;for(;L!==b.Undefined;)yield L.element,L=L.next}}e.LinkedList=t}),function(){function z(R){const L=[];typeof R=="number"&&L.push("code/timeOrigin",R);function D(f){L.push(f,Date.now())}function y(){const f=[];for(let v=0;v<L.length;v+=2)f.push({name:L[v],startTime:L[v+1]});return f}return{mark:D,getMarks:y}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?z():{mark(R){performance.mark(R)},getMarks(){let R=performance.timeOrigin;typeof R!="number"&&(R=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const L=[{name:"code/timeOrigin",startTime:Math.round(R)}];for(const D of performance.getEntriesByType("mark"))L.push({name:D.name,startTime:Math.round(R+D.startTime)});return L}};if(typeof process=="object"){const R=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return z(R)}else return console.trace("perf-util loaded in UNKNOWN environment"),z()}function b(R){return R.MonacoPerformanceMarks||(R.MonacoPerformanceMarks=e()),R.MonacoPerformanceMarks}var t;typeof global=="object"?t=global:typeof self=="object"?t=self:t={},typeof define=="function"?define("vs/base/common/performance",[],function(){return b(t)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=b(t):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),t.perf=b(t))}(),define(J[121],Z([0,1]),function(z,e){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class t{constructor(y,f,v){this.level=y,this.key=f,this.value=v,this.forward=[]}}const R=void 0;class L{constructor(y,f=2**16){this.comparator=y,this[b]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(f)|0),this._header=new t(this._maxLevel,R,R)}get size(){return this._size}clear(){this._header=new t(this._maxLevel,R,R)}has(y){return Boolean(L._search(this,y,this.comparator))}get(y){return L._search(this,y,this.comparator)?.value}set(y,f){return L._insert(this,y,f,this.comparator)&&(this._size+=1),this}delete(y){const f=L._delete(this,y,this.comparator);return f&&(this._size-=1),f}forEach(y,f){let v=this._header.forward[0];for(;v;)y.call(f,v.value,v.key,this),v=v.forward[0]}[(b=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let y=this._header.forward[0];for(;y;)yield[y.key,y.value],y=y.forward[0]}*keys(){let y=this._header.forward[0];for(;y;)yield y.key,y=y.forward[0]}*values(){let y=this._header.forward[0];for(;y;)yield y.value,y=y.forward[0]}toString(){let y="[SkipList]:",f=this._header.forward[0];for(;f;)y+=`node(${f.key}, ${f.value}, lvl:${f.level})`,f=f.forward[0];return y}static _search(y,f,v){let E=y._header;for(let P=y._level-1;P>=0;P--)for(;E.forward[P]&&v(E.forward[P].key,f)<0;)E=E.forward[P];if(E=E.forward[0],E&&v(E.key,f)===0)return E}static _insert(y,f,v,E){const P=[];let S=y._header;for(let w=y._level-1;w>=0;w--){for(;S.forward[w]&&E(S.forward[w].key,f)<0;)S=S.forward[w];P[w]=S}if(S=S.forward[0],S&&E(S.key,f)===0)return S.value=v,!1;{const w=L._randomLevel(y);if(w>y._level){for(let u=y._level;u<w;u++)P[u]=y._header;y._level=w}S=new t(w,f,v);for(let u=0;u<w;u++)S.forward[u]=P[u].forward[u],P[u].forward[u]=S;return!0}}static _randomLevel(y,f=.5){let v=1;for(;Math.random()<f&&v<y._maxLevel;)v+=1;return v}static _delete(y,f,v){const E=[];let P=y._header;for(let S=y._level-1;S>=0;S--){for(;P.forward[S]&&v(P.forward[S].key,f)<0;)P=P.forward[S];E[S]=P}if(P=P.forward[0],!P||v(P.key,f)!==0)return!1;for(let S=0;S<y._level&&E[S].forward[S]===P;S++)E[S].forward[S]=P.forward[S];for(;y._level>0&&y._header.forward[y._level-1]===R;)y._level-=1;return!0}}e.SkipList=L}),define(J[54],Z([0,1,18,2]),function(z,e,b,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function R(h){const l=h;return l?typeof l.read=="function":!1}e.isReadable=R;function L(h){const l=h;return l?[l.on,l.pause,l.resume,l.destroy].every(n=>typeof n=="function"):!1}e.isReadableStream=L;function D(h){const l=h;return l?L(l.stream)&&Array.isArray(l.buffer)&&typeof l.ended=="boolean":!1}e.isReadableBufferedStream=D;function y(h,l){return new f(h,l)}e.newWriteableStream=y;class f{constructor(l,n){this.reducer=l,this.options=n,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(l){if(!this.state.destroyed){if(this.state.flowing)this.emitData(l);else if(this.buffer.data.push(l),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(n=>this.pendingWritePromises.push(n))}}error(l){this.state.destroyed||(this.state.flowing?this.emitError(l):this.buffer.error.push(l))}end(l){this.state.destroyed||(typeof l!="undefined"&&this.write(l),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(l){this.listeners.data.slice(0).forEach(n=>n(l))}emitError(l){this.listeners.error.length===0?(0,b.onUnexpectedError)(l):this.listeners.error.slice(0).forEach(n=>n(l))}emitEnd(){this.listeners.end.slice(0).forEach(l=>l())}on(l,n){if(!this.state.destroyed)switch(l){case"data":this.listeners.data.push(n),this.resume();break;case"end":this.listeners.end.push(n),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(n),this.state.flowing&&this.flowErrors();break}}removeListener(l,n){if(this.state.destroyed)return;let r;switch(l){case"data":r=this.listeners.data;break;case"end":r=this.listeners.end;break;case"error":r=this.listeners.error;break}if(r){const i=r.indexOf(n);i>=0&&r.splice(i,1)}}flowData(){if(this.buffer.data.length>0){const l=this.reducer(this.buffer.data);this.emitData(l),this.buffer.data.length=0;const n=[...this.pendingWritePromises];this.pendingWritePromises.length=0,n.forEach(r=>r())}}flowErrors(){if(this.listeners.error.length>0){for(const l of this.buffer.error)this.emitError(l);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function v(h,l){const n=[];let r;for(;(r=h.read())!==null;)n.push(r);return l(n)}e.consumeReadable=v;function E(h,l,n){const r=[];let i;for(;(i=h.read())!==null&&r.length<n;)r.push(i);return i===null&&r.length>0?l(r):{read:()=>{if(r.length>0)return r.shift();if(typeof i!="undefined"){const s=i;return i=void 0,s}return h.read()}}}e.peekReadable=E;function P(h,l){return new Promise((n,r)=>{const i=[];S(h,{onData:s=>{l&&i.push(s)},onError:s=>{l?r(s):n(void 0)},onEnd:()=>{n(l?l(i):void 0)}})})}e.consumeStream=P;function S(h,l){let n=!1;return h.on("error",r=>{n||l.onError(r)}),h.on("end",()=>{n||l.onEnd()}),h.on("data",r=>{n||l.onData(r)}),(0,t.toDisposable)(()=>n=!0)}e.listenStream=S;function w(h,l){return new Promise((n,r)=>{const i=new t.DisposableStore,s=[],o=C=>{if(s.push(C),s.length>l)return i.dispose(),h.pause(),n({stream:h,buffer:s,ended:!1})},a=C=>r(C),c=()=>n({stream:h,buffer:s,ended:!0});i.add((0,t.toDisposable)(()=>h.removeListener("error",a))),h.on("error",a),i.add((0,t.toDisposable)(()=>h.removeListener("end",c))),h.on("end",c),i.add((0,t.toDisposable)(()=>h.removeListener("data",o))),h.on("data",o)})}e.peekStream=w;function u(h,l){const n=y(l);return n.end(h),n}e.toStream=u;function m(){const h=y(()=>{throw new Error("not supported")});return h.end(),h}e.emptyStream=m;function g(h){let l=!1;return{read:()=>l?null:(l=!0,h)}}e.toReadable=g;function I(h,l,n){const r=y(n);return S(h,{onData:i=>r.write(l.data(i)),onError:i=>r.error(l.error?l.error(i):i),onEnd:()=>r.end()}),r}e.transform=I;function p(h,l,n){let r=!1;return{read:()=>{const i=l.read();return r?i:(r=!0,i!==null?n([h,i]):h)}}}e.prefixedReadable=p;function d(h,l,n){let r=!1;const i=y(n);return S(l,{onData:s=>r?i.write(s):(r=!0,i.write(n([h,s]))),onError:s=>i.error(s),onEnd:()=>{r||(r=!0,i.write(h)),i.end()}}),i}e.prefixedStream=d}),define(J[19],Z([0,1,54]),function(z,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const t=typeof Buffer!="undefined";let R,L;class D{constructor(C){this.buffer=C,this.byteLength=this.buffer.byteLength}static alloc(C){return t?new D(Buffer.allocUnsafe(C)):new D(new Uint8Array(C))}static wrap(C){return t&&!Buffer.isBuffer(C)&&(C=Buffer.from(C.buffer,C.byteOffset,C.byteLength)),new D(C)}static fromString(C,k){return!(k?.dontUseNodeBuffer||!1)&&t?new D(Buffer.from(C)):(R||(R=new TextEncoder),new D(R.encode(C)))}static fromByteArray(C){const k=D.alloc(C.length);for(let M=0,T=C.length;M<T;M++)k.buffer[M]=C[M];return k}static concat(C,k){if(typeof k=="undefined"){k=0;for(let F=0,q=C.length;F<q;F++)k+=C[F].byteLength}const M=D.alloc(k);let T=0;for(let F=0,q=C.length;F<q;F++){const te=C[F];M.set(te,T),T+=te.byteLength}return M}clone(){const C=D.alloc(this.byteLength);return C.set(this),C}toString(){return t?this.buffer.toString():(L||(L=new TextDecoder),L.decode(this.buffer))}slice(C,k){return new D(this.buffer.subarray(C,k))}set(C,k){if(C instanceof D)this.buffer.set(C.buffer,k);else if(C instanceof Uint8Array)this.buffer.set(C,k);else if(C instanceof ArrayBuffer)this.buffer.set(new Uint8Array(C),k);else if(ArrayBuffer.isView(C))this.buffer.set(new Uint8Array(C.buffer,C.byteOffset,C.byteLength),k);else throw new Error("Unknown argument 'array'")}readUInt32BE(C){return v(this.buffer,C)}writeUInt32BE(C,k){E(this.buffer,C,k)}readUInt32LE(C){return P(this.buffer,C)}writeUInt32LE(C,k){S(this.buffer,C,k)}readUInt8(C){return w(this.buffer,C)}writeUInt8(C,k){u(this.buffer,C,k)}}e.VSBuffer=D;function y(c,C){return c[C+0]<<0>>>0|c[C+1]<<8>>>0}e.readUInt16LE=y;function f(c,C,k){c[k+0]=C&255,C=C>>>8,c[k+1]=C&255}e.writeUInt16LE=f;function v(c,C){return c[C]*2**24+c[C+1]*2**16+c[C+2]*2**8+c[C+3]}e.readUInt32BE=v;function E(c,C,k){c[k+3]=C,C=C>>>8,c[k+2]=C,C=C>>>8,c[k+1]=C,C=C>>>8,c[k]=C}e.writeUInt32BE=E;function P(c,C){return c[C+0]<<0>>>0|c[C+1]<<8>>>0|c[C+2]<<16>>>0|c[C+3]<<24>>>0}e.readUInt32LE=P;function S(c,C,k){c[k+0]=C&255,C=C>>>8,c[k+1]=C&255,C=C>>>8,c[k+2]=C&255,C=C>>>8,c[k+3]=C&255}e.writeUInt32LE=S;function w(c,C){return c[C]}e.readUInt8=w;function u(c,C,k){c[k]=C}e.writeUInt8=u;function m(c){return b.consumeReadable(c,C=>D.concat(C))}e.readableToBuffer=m;function g(c){return b.toReadable(c)}e.bufferToReadable=g;function I(c){return b.consumeStream(c,C=>D.concat(C))}e.streamToBuffer=I;async function p(c){return c.ended?D.concat(c.buffer):D.concat([...c.buffer,await I(c.stream)])}e.bufferedStreamToBuffer=p;function d(c){return b.toStream(c,C=>D.concat(C))}e.bufferToStream=d;function h(c){return b.transform(c,{data:C=>typeof C=="string"?D.fromString(C):D.wrap(C)},C=>D.concat(C))}e.streamToBufferReadableStream=h;function l(c){return b.newWriteableStream(C=>D.concat(C),c)}e.newWriteableBufferStream=l;function n(c,C){return b.prefixedReadable(c,C,k=>D.concat(k))}e.prefixedBufferReadable=n;function r(c,C){return b.prefixedStream(c,C,k=>D.concat(k))}e.prefixedBufferStream=r;function i(c){let C=0,k=0,M=0;const T=new Uint8Array(Math.floor(c.length/4*3)),F=te=>{switch(k){case 3:T[M++]=C|te,k=0;break;case 2:T[M++]=C|te>>>2,C=te<<6,k=3;break;case 1:T[M++]=C|te>>>4,C=te<<4,k=2;break;default:C=te<<2,k=1}};for(let te=0;te<c.length;te++){const ne=c.charCodeAt(te);if(ne>=65&&ne<=90)F(ne-65);else if(ne>=97&&ne<=122)F(ne-97+26);else if(ne>=48&&ne<=57)F(ne-48+52);else if(ne===43||ne===45)F(62);else if(ne===47||ne===95)F(63);else{if(ne===61)break;throw new SyntaxError(`Unexpected base64 character ${c[te]}`)}}const q=M;for(;k>0;)F(0);return D.wrap(T).slice(0,q)}e.decodeBase64=i;const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function a({buffer:c},C=!0,k=!1){const M=k?o:s;let T="";const F=c.byteLength%3;let q=0;for(;q<c.byteLength-F;q+=3){const te=c[q+0],ne=c[q+1],Q=c[q+2];T+=M[te>>>2],T+=M[(te<<4|ne>>>4)&63],T+=M[(ne<<2|Q>>>6)&63],T+=M[Q&63]}if(F===1){const te=c[q+0];T+=M[te>>>2],T+=M[te<<4&63],C&&(T+="==")}else if(F===2){const te=c[q+0],ne=c[q+1];T+=M[te>>>2],T+=M[(te<<4|ne>>>4)&63],T+=M[ne<<2&63],C&&(T+="=")}return T}e.encodeBase64=a}),define(J[12],Z([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function b(c){return Array.isArray(c)}e.isArray=b;function t(c){return typeof c=="string"}e.isString=t;function R(c){return Array.isArray(c)&&c.every(C=>t(C))}e.isStringArray=R;function L(c){return typeof c=="object"&&c!==null&&!Array.isArray(c)&&!(c instanceof RegExp)&&!(c instanceof Date)}e.isObject=L;function D(c){return typeof c=="object"&&(c instanceof Uint8Array||c instanceof Uint16Array||c instanceof Uint32Array||c instanceof Float32Array||c instanceof Float64Array||c instanceof Int8Array||c instanceof Int16Array||c instanceof Int32Array||c instanceof BigInt64Array||c instanceof BigUint64Array||c instanceof Uint8ClampedArray)}e.isTypedArray=D;function y(c){return typeof c=="number"&&!isNaN(c)}e.isNumber=y;function f(c){return!!c&&typeof c[Symbol.iterator]=="function"}e.isIterable=f;function v(c){return c===!0||c===!1}e.isBoolean=v;function E(c){return typeof c=="undefined"}e.isUndefined=E;function P(c){return!S(c)}e.isDefined=P;function S(c){return E(c)||c===null}e.isUndefinedOrNull=S;function w(c,C){if(!c)throw new Error(C?`Unexpected type, expected '${C}'`:"Unexpected type")}e.assertType=w;function u(c){if(S(c))throw new Error("Assertion Failed: argument is undefined or null");return c}e.assertIsDefined=u;function m(...c){const C=[];for(let k=0;k<c.length;k++){const M=c[k];if(S(M))throw new Error(`Assertion Failed: argument at index ${k} is undefined or null`);C.push(M)}return C}e.assertAllDefined=m;const g=Object.prototype.hasOwnProperty;function I(c){if(!L(c))return!1;for(const C in c)if(g.call(c,C))return!1;return!0}e.isEmptyObject=I;function p(c){return typeof c=="function"}e.isFunction=p;function d(...c){return c.length>0&&c.every(p)}e.areFunctions=d;function h(c,C){const k=Math.min(c.length,C.length);for(let M=0;M<k;M++)l(c[M],C[M])}e.validateConstraints=h;function l(c,C){if(t(C)){if(typeof c!==C)throw new Error(`argument does not match constraint: typeof ${C}`)}else if(p(C)){try{if(c instanceof C)return}catch{}if(!S(c)&&c.constructor===C||C.length===1&&C.call(void 0,c)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=l;function n(c){let C=[],k=Object.getPrototypeOf(c);for(;Object.prototype!==k;)C=C.concat(Object.getOwnPropertyNames(k)),k=Object.getPrototypeOf(k);return C}e.getAllPropertyNames=n;function r(c){const C=[];for(const k of n(c))typeof c[k]=="function"&&C.push(k);return C}e.getAllMethodNames=r;function i(c,C){const k=T=>function(){const F=Array.prototype.slice.call(arguments,0);return C(T,F)},M={};for(const T of c)M[T]=k(T);return M}e.createProxyObject=i;function s(c){return c===null?void 0:c}e.withNullAsUndefined=s;function o(c){return typeof c=="undefined"?null:c}e.withUndefinedAsNull=o;function a(c,C="Unreachable"){throw new Error(C)}e.assertNever=a}),define(J[50],Z([0,1,12]),function(z,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function t(u){if(!u||typeof u!="object"||u instanceof RegExp)return u;const m=Array.isArray(u)?[]:{};return Object.keys(u).forEach(g=>{u[g]&&typeof u[g]=="object"?m[g]=t(u[g]):m[g]=u[g]}),m}e.deepClone=t;function R(u){if(!u||typeof u!="object")return u;const m=[u];for(;m.length>0;){const g=m.shift();Object.freeze(g);for(const I in g)if(L.call(g,I)){const p=g[I];typeof p=="object"&&!Object.isFrozen(p)&&!(0,b.isTypedArray)(p)&&m.push(p)}}return u}e.deepFreeze=R;const L=Object.prototype.hasOwnProperty;function D(u,m){return y(u,m,new Set)}e.cloneAndChange=D;function y(u,m,g){if((0,b.isUndefinedOrNull)(u))return u;const I=m(u);if(typeof I!="undefined")return I;if((0,b.isArray)(u)){const p=[];for(const d of u)p.push(y(d,m,g));return p}if((0,b.isObject)(u)){if(g.has(u))throw new Error("Cannot clone recursive data-structure");g.add(u);const p={};for(const d in u)L.call(u,d)&&(p[d]=y(u[d],m,g));return g.delete(u),p}return u}function f(u,m,g=!0){return(0,b.isObject)(u)?((0,b.isObject)(m)&&Object.keys(m).forEach(I=>{I in u?g&&((0,b.isObject)(u[I])&&(0,b.isObject)(m[I])?f(u[I],m[I],g):u[I]=m[I]):u[I]=m[I]}),u):m}e.mixin=f;function v(u,m){if(u===m)return!0;if(u==null||m===null||m===void 0||typeof u!=typeof m||typeof u!="object"||Array.isArray(u)!==Array.isArray(m))return!1;let g,I;if(Array.isArray(u)){if(u.length!==m.length)return!1;for(g=0;g<u.length;g++)if(!v(u[g],m[g]))return!1}else{const p=[];for(I in u)p.push(I);p.sort();const d=[];for(I in m)d.push(I);if(d.sort(),!v(p,d))return!1;for(g=0;g<p.length;g++)if(!v(u[p[g]],m[p[g]]))return!1}return!0}e.equals=v;function E(u){const m=new Set;return JSON.stringify(u,(g,I)=>{if((0,b.isObject)(I)||Array.isArray(I)){if(m.has(I))return"[Circular]";m.add(I)}return I})}e.safeStringify=E;function P(u,m){const g=Object.create(null);return!u||!m||Object.keys(m).forEach(p=>{const d=u[p],h=m[p];v(d,h)||(g[p]=h)}),g}e.distinct=P;function S(u,m){const g=m.toLowerCase(),I=Object.keys(u).find(p=>p.toLowerCase()===g);return I?u[I]:u[m]}e.getCaseInsensitive=S;function w(u,m){const g=Object.create(null);for(const[I,p]of Object.entries(u))m(I,p)&&(g[I]=p);return g}e.filter=w}),define(J[30],Z([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const b=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function t(R){return b.test(R)}e.isUUID=t,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let R;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?R=crypto.getRandomValues.bind(crypto):R=function(y){for(let f=0;f<y.length;f++)y[f]=Math.floor(Math.random()*256);return y};const L=new Uint8Array(16),D=[];for(let y=0;y<256;y++)D.push(y.toString(16).padStart(2,"0"));return function(){R(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let f=0,v="";return v+=D[L[f++]],v+=D[L[f++]],v+=D[L[f++]],v+=D[L[f++]],v+="-",v+=D[L[f++]],v+=D[L[f++]],v+="-",v+=D[L[f++]],v+=D[L[f++]],v+="-",v+=D[L[f++]],v+=D[L[f++]],v+="-",v+=D[L[f++]],v+=D[L[f++]],v+=D[L[f++]],v+=D[L[f++]],v+=D[L[f++]],v+=D[L[f++]],v}}()}),define(J[122],Z([0,1,63,28,48]),function(z,e,b,t,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function L(D,y){if(await new Promise((E,P)=>{const S=t.createReadStream(D),w=b.createHash("sha1");S.pipe(w);const u=(0,R.once)((m,g)=>{S.removeAllListeners(),w.removeAllListeners(),m?P(m):E(g)});S.once("error",u),S.once("end",u),w.once("error",u),w.once("data",m=>u(void 0,m.toString("hex")))})!==y)throw new Error("Hash mismatch")}e.checksum=L}),define(J[123],Z([0,1,124]),function(z,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class t{constructor(L="utf8"){this.stringDecoder=new b.StringDecoder(L),this.remaining=null}write(L){const D=[],y=this.remaining?this.remaining+this.stringDecoder.write(L):this.stringDecoder.write(L);if(y.length<1)return D;let f=0,v,E=f;for(;E<y.length;)if(v=y.charCodeAt(E),v===13||v===10){if(D.push(y.substring(f,E)),E++,E<y.length){const P=v;v=y.charCodeAt(E),(P===13&&v===10||P===10&&v===13)&&E++}f=E}else E++;return this.remaining=f<y.length?y.substr(f):null,D}end(){return this.remaining}}e.LineDecoder=t}),define(J[125],Z([0,1,27]),function(z,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const t=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function R(D){const y=D.replace(/\-/g,":").toLowerCase();return!t.has(y)}function L(){const D=(0,b.networkInterfaces)();for(const y in D){const f=D[y];if(f){for(const{mac:v}of f)if(R(v))return v}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=L}),define(J[90],Z([0,1,64]),function(z,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function t(y,f,v,E=1){let P=!1;return new Promise(S=>{const w=setTimeout(()=>{if(!P)return P=!0,S(0)},v);R(y,f,E,u=>{if(!P)return P=!0,clearTimeout(w),S(u)})})}e.findFreePort=t;function R(y,f,v,E){if(f===0)return E(0);const P=new b.Socket;P.once("connect",()=>(D(P),R(y+v,f-1,v,E))),P.once("data",()=>{}),P.once("error",S=>(D(P),S.code!=="ECONNREFUSED"?R(y+v,f-1,v,E):E(y))),P.connect(y,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function L(y,f,v){let E=!1,P,S=1;const w=b.createServer({pauseOnConnect:!0});function u(m,g){E||(E=!0,w.removeAllListeners(),w.close(),P&&clearTimeout(P),g(m))}return new Promise(m=>{P=setTimeout(()=>{u(0,m)},v),w.on("listening",()=>{u(y,m)}),w.on("error",g=>{g&&(g.code==="EADDRINUSE"||g.code==="EACCES")&&S<f?(y++,S++,w.listen(y,"127.0.0.1")):u(0,m)}),w.on("close",()=>{u(0,m)}),w.listen(y,"127.0.0.1")})}e.findFreePortFaster=L;function D(y){try{y.removeAllListeners("connect"),y.removeAllListeners("error"),y.end(),y.destroy(),y.unref()}catch(f){console.error(f)}}}),define(J[126],Z([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(J[127],Z([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class b{constructor(R,L){this.sender=R,this.onMessage=L}send(R){try{this.sender.send("vscode:message",R.buffer)}catch{}}disconnect(){this.sender.send("vscode:disconnect",null)}}e.Protocol=b}),define(J[38],Z([0,1,14,18]),function(z,e,b,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.validatedIpcMain=void 0;class R{constructor(){this.mapListenerToWrapper=new WeakMap}on(D,y){const f=(v,...E)=>{this.validateEvent(D,v)&&y(v,...E)};return this.mapListenerToWrapper.set(y,f),b.ipcMain.on(D,f),this}once(D,y){return b.ipcMain.once(D,(f,...v)=>{this.validateEvent(D,f)&&y(f,...v)}),this}handle(D,y){return b.ipcMain.handle(D,(f,...v)=>this.validateEvent(D,f)?y(f,...v):Promise.reject(`Invalid channel '${D}' or sender for ipcMain.handle() usage.`)),this}removeHandler(D){return b.ipcMain.removeHandler(D),this}removeListener(D,y){const f=this.mapListenerToWrapper.get(y);return f&&(b.ipcMain.removeListener(D,f),this.mapListenerToWrapper.delete(y)),this}validateEvent(D,y){if(!D||!D.startsWith("vscode:"))return(0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${D}' because the channel is unknown.`),!1;const f=y.senderFrame,v=f.url;if(!v)return!0;let E="unknown";try{E=new URL(v).host}catch{return(0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${D}' because of a malformed URL '${v}'.`),!1}return E!=="vscode-app"?((0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${D}' because of a bad origin of '${E}'.`),!1):f.parent!==null?((0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${D}' because sender of origin '${E}' is not a main frame.`),!1):!0}}e.validatedIpcMain=new R}),define(J[128],Z([0,1,14,38,12,126]),function(z,e,b,t,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function D(){t.validatedIpcMain.on(L.CONTEXT_MENU_CHANNEL,(f,v,E,P,S)=>{const w=y(f,P,E);w.popup({window:(0,R.withNullAsUndefined)(b.BrowserWindow.fromWebContents(f.sender)),x:S?S.x:void 0,y:S?S.y:void 0,positioningItem:S?S.positioningItem:void 0,callback:()=>{w&&f.sender.send(L.CONTEXT_MENU_CLOSE_CHANNEL,v)}})})}e.registerContextMenuListener=D;function y(f,v,E){const P=new b.Menu;return E.forEach(S=>{let w;S.type==="separator"?w=new b.MenuItem({type:S.type}):Array.isArray(S.submenu)?w=new b.MenuItem({submenu:y(f,v,S.submenu),label:S.label}):w=new b.MenuItem({label:S.label,type:S.type,accelerator:S.accelerator,checked:S.checked,enabled:S.enabled,visible:S.visible,click:(u,m,g)=>f.sender.send(v,S.id,g)}),P.append(w)}),P}}),define(J[129],Z([13,10]),function(z,e){return z.create("vs/base/common/date",e)}),define(J[130],Z([0,1,129]),function(z,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const t=60,R=t*60,L=R*24,D=L*7,y=L*30,f=L*365;function v(P,S,w){typeof P!="number"&&(P=P.getTime());const u=Math.round((new Date().getTime()-P)/1e3);if(u<-30)return(0,b.localize)(0,null,v(new Date().getTime()+u*1e3,!1));if(u<30)return(0,b.localize)(1,null);let m;return u<t?(m=u,S?m===1?w?(0,b.localize)(2,null,m):(0,b.localize)(3,null,m):w?(0,b.localize)(4,null,m):(0,b.localize)(5,null,m):m===1?w?(0,b.localize)(6,null,m):(0,b.localize)(7,null,m):w?(0,b.localize)(8,null,m):(0,b.localize)(9,null,m)):u<R?(m=Math.floor(u/t),S?m===1?w?(0,b.localize)(10,null,m):(0,b.localize)(11,null,m):w?(0,b.localize)(12,null,m):(0,b.localize)(13,null,m):m===1?w?(0,b.localize)(14,null,m):(0,b.localize)(15,null,m):w?(0,b.localize)(16,null,m):(0,b.localize)(17,null,m)):u<L?(m=Math.floor(u/R),S?m===1?w?(0,b.localize)(18,null,m):(0,b.localize)(19,null,m):w?(0,b.localize)(20,null,m):(0,b.localize)(21,null,m):m===1?w?(0,b.localize)(22,null,m):(0,b.localize)(23,null,m):w?(0,b.localize)(24,null,m):(0,b.localize)(25,null,m)):u<D?(m=Math.floor(u/L),S?m===1?(0,b.localize)(26,null,m):(0,b.localize)(27,null,m):m===1?(0,b.localize)(28,null,m):(0,b.localize)(29,null,m)):u<y?(m=Math.floor(u/D),S?m===1?w?(0,b.localize)(30,null,m):(0,b.localize)(31,null,m):w?(0,b.localize)(32,null,m):(0,b.localize)(33,null,m):m===1?w?(0,b.localize)(34,null,m):(0,b.localize)(35,null,m):w?(0,b.localize)(36,null,m):(0,b.localize)(37,null,m)):u<f?(m=Math.floor(u/y),S?m===1?w?(0,b.localize)(38,null,m):(0,b.localize)(39,null,m):w?(0,b.localize)(40,null,m):(0,b.localize)(41,null,m):m===1?w?(0,b.localize)(42,null,m):(0,b.localize)(43,null,m):w?(0,b.localize)(44,null,m):(0,b.localize)(45,null,m)):(m=Math.floor(u/f),S?m===1?w?(0,b.localize)(46,null,m):(0,b.localize)(47,null,m):w?(0,b.localize)(48,null,m):(0,b.localize)(49,null,m):m===1?w?(0,b.localize)(50,null,m):(0,b.localize)(51,null,m):w?(0,b.localize)(52,null,m):(0,b.localize)(53,null,m))}e.fromNow=v;function E(P){return P.getFullYear()+"-"+String(P.getMonth()+1).padStart(2,"0")+"-"+String(P.getDate()).padStart(2,"0")+"T"+String(P.getHours()).padStart(2,"0")+":"+String(P.getMinutes()).padStart(2,"0")+":"+String(P.getSeconds()).padStart(2,"0")+"."+(P.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=E}),define(J[131],Z([13,10]),function(z,e){return z.create("vs/base/common/errorMessage",e)}),define(J[41],Z([0,1,25,12,131]),function(z,e,b,t,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function L(P,S){return S&&(P.stack||P.stacktrace)?R.localize(0,null,y(P),D(P.stack)||D(P.stacktrace)):y(P)}function D(P){return Array.isArray(P)?P.join(`
`):P}function y(P){return typeof P.code=="string"&&typeof P.errno=="number"&&typeof P.syscall=="string"?R.localize(1,null,P.message):P.message||R.localize(2,null)}function f(P=null,S=!1){if(!P)return R.localize(3,null);if(Array.isArray(P)){const w=b.coalesce(P),u=f(w[0],S);return w.length>1?R.localize(4,null,u,w.length):u}if(t.isString(P))return P;if(P.detail){const w=P.detail;if(w.error)return L(w.error,S);if(w.exception)return L(w.exception,S)}return P.stack?L(P,S):P.message?P.message:R.localize(5,null)}e.toErrorMessage=f;function v(P){const S=P;return S instanceof Error&&Array.isArray(S.actions)}e.isErrorWithActions=v;function E(P,S){let w;return typeof P=="string"?w=new Error(P):w=P,w.actions=S,w}e.createErrorWithActions=E}),define(J[132],Z([13,10]),function(z,e){return z.create("vs/base/common/platform",e)}),define(J[4],Z([0,1,132]),function(z,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=void 0;const t="en";let R=!1,L=!1,D=!1,y=!1,f=!1,v=!1,E=!1,P=!1,S=!1,w,u=t,m,g;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let I;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?I=e.globals.vscode.process:typeof process!="undefined"&&(I=process);const p=typeof I?.versions?.electron=="string",d=p&&I?.type==="renderer";if(typeof navigator=="object"&&!d)g=navigator.userAgent,R=g.indexOf("Windows")>=0,L=g.indexOf("Macintosh")>=0,P=(g.indexOf("Macintosh")>=0||g.indexOf("iPad")>=0||g.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,D=g.indexOf("Linux")>=0,v=!0,w=b.getConfiguredDefaultLocale(b.localize(0,null))||t,u=w;else if(typeof I=="object"){R=I.platform==="win32",L=I.platform==="darwin",D=I.platform==="linux",y=D&&!!I.env.SNAP&&!!I.env.SNAP_REVISION,E=p,S=!!I.env.CI||!!I.env.BUILD_ARTIFACTSTAGINGDIRECTORY,w=t,u=t;const c=I.env.VSCODE_NLS_CONFIG;if(c)try{const C=JSON.parse(c),k=C.availableLanguages["*"];w=C.locale,u=k||t,m=C._translationsConfigFile}catch{}f=!0}else console.error("Unable to resolve platform.");var h;(function(c){c[c.Web=0]="Web",c[c.Mac=1]="Mac",c[c.Linux=2]="Linux",c[c.Windows=3]="Windows"})(h=e.Platform||(e.Platform={}));function l(c){switch(c){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=l;let n=0;L?n=1:R?n=3:D&&(n=2),e.isWindows=R,e.isMacintosh=L,e.isLinux=D,e.isLinuxSnap=y,e.isNative=f,e.isElectron=E,e.isWeb=v,e.isWebWorker=v&&typeof e.globals.importScripts=="function",e.isIOS=P,e.isCI=S,e.platform=n,e.userAgent=g,e.language=u;var r;(function(c){function C(){return e.language}c.value=C;function k(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}c.isDefaultVariant=k;function M(){return e.language==="en"}c.isDefault=M})(r=e.Language||(e.Language={})),e.locale=w,e.translationsConfigFile=m,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const c=[];e.globals.addEventListener("message",k=>{if(k.data&&k.data.vscodeScheduleAsyncWork)for(let M=0,T=c.length;M<T;M++){const F=c[M];if(F.id===k.data.vscodeScheduleAsyncWork){c.splice(M,1),F.callback();return}}});let C=0;return k=>{const M=++C;c.push({id:M,callback:k}),e.globals.postMessage({vscodeScheduleAsyncWork:M},"*")}}return c=>setTimeout(c)})();var i;(function(c){c[c.Windows=1]="Windows",c[c.Macintosh=2]="Macintosh",c[c.Linux=3]="Linux"})(i=e.OperatingSystem||(e.OperatingSystem={})),e.OS=L||P?2:R?1:3;let s=!0,o=!1;function a(){if(!o){o=!0;const c=new Uint8Array(2);c[0]=1,c[1]=2,s=new Uint16Array(c.buffer)[0]===(2<<8)+1}return s}e.isLittleEndian=a,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(J[36],Z([0,1,4]),function(z,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let t;if(typeof b.globals.vscode!="undefined"&&typeof b.globals.vscode.process!="undefined"){const R=b.globals.vscode.process;t={get platform(){return R.platform},get arch(){return R.arch},get env(){return R.env},cwd(){return R.cwd()}}}else typeof process!="undefined"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return b.isWindows?"win32":b.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.platform=t.platform,e.arch=t.arch}),define(J[9],Z([0,1,36]),function(z,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const t=65,R=97,L=90,D=122,y=46,f=47,v=92,E=58,P=63;class S extends Error{constructor(h,l,n){let r;typeof l=="string"&&l.indexOf("not ")===0?(r="must not be",l=l.replace(/^not /,"")):r="must be";const i=h.indexOf(".")!==-1?"property":"argument";let s=`The "${h}" ${i} ${r} of type ${l}`;s+=`. Received type ${typeof n}`;super(s);this.code="ERR_INVALID_ARG_TYPE"}}function w(d,h){if(typeof d!="string")throw new S(h,"string",d)}function u(d){return d===f||d===v}function m(d){return d===f}function g(d){return d>=t&&d<=L||d>=R&&d<=D}function I(d,h,l,n){let r="",i=0,s=-1,o=0,a=0;for(let c=0;c<=d.length;++c){if(c<d.length)a=d.charCodeAt(c);else{if(n(a))break;a=f}if(n(a)){if(!(s===c-1||o===1))if(o===2){if(r.length<2||i!==2||r.charCodeAt(r.length-1)!==y||r.charCodeAt(r.length-2)!==y){if(r.length>2){const C=r.lastIndexOf(l);C===-1?(r="",i=0):(r=r.slice(0,C),i=r.length-1-r.lastIndexOf(l)),s=c,o=0;continue}else if(r.length!==0){r="",i=0,s=c,o=0;continue}}h&&(r+=r.length>0?`${l}..`:"..",i=2)}else r.length>0?r+=`${l}${d.slice(s+1,c)}`:r=d.slice(s+1,c),i=c-s-1;s=c,o=0}else a===y&&o!==-1?++o:o=-1}return r}function p(d,h){if(h===null||typeof h!="object")throw new S("pathObject","Object",h);const l=h.dir||h.root,n=h.base||`${h.name||""}${h.ext||""}`;return l?l===h.root?`${l}${n}`:`${l}${d}${n}`:n}e.win32={resolve(...d){let h="",l="",n=!1;for(let r=d.length-1;r>=-1;r--){let i;if(r>=0){if(i=d[r],w(i,"path"),i.length===0)continue}else h.length===0?i=b.cwd():(i=b.env[`=${h}`]||b.cwd(),(i===void 0||i.slice(0,2).toLowerCase()!==h.toLowerCase()&&i.charCodeAt(2)===v)&&(i=`${h}\\`));const s=i.length;let o=0,a="",c=!1;const C=i.charCodeAt(0);if(s===1)u(C)&&(o=1,c=!0);else if(u(C))if(c=!0,u(i.charCodeAt(1))){let k=2,M=k;for(;k<s&&!u(i.charCodeAt(k));)k++;if(k<s&&k!==M){const T=i.slice(M,k);for(M=k;k<s&&u(i.charCodeAt(k));)k++;if(k<s&&k!==M){for(M=k;k<s&&!u(i.charCodeAt(k));)k++;(k===s||k!==M)&&(a=`\\\\${T}\\${i.slice(M,k)}`,o=k)}}}else o=1;else g(C)&&i.charCodeAt(1)===E&&(a=i.slice(0,2),o=2,s>2&&u(i.charCodeAt(2))&&(c=!0,o=3));if(a.length>0)if(h.length>0){if(a.toLowerCase()!==h.toLowerCase())continue}else h=a;if(n){if(h.length>0)break}else if(l=`${i.slice(o)}\\${l}`,n=c,c&&h.length>0)break}return l=I(l,!n,"\\",u),n?`${h}\\${l}`:`${h}${l}`||"."},normalize(d){w(d,"path");const h=d.length;if(h===0)return".";let l=0,n,r=!1;const i=d.charCodeAt(0);if(h===1)return m(i)?"\\":d;if(u(i))if(r=!0,u(d.charCodeAt(1))){let o=2,a=o;for(;o<h&&!u(d.charCodeAt(o));)o++;if(o<h&&o!==a){const c=d.slice(a,o);for(a=o;o<h&&u(d.charCodeAt(o));)o++;if(o<h&&o!==a){for(a=o;o<h&&!u(d.charCodeAt(o));)o++;if(o===h)return`\\\\${c}\\${d.slice(a)}\\`;o!==a&&(n=`\\\\${c}\\${d.slice(a,o)}`,l=o)}}}else l=1;else g(i)&&d.charCodeAt(1)===E&&(n=d.slice(0,2),l=2,h>2&&u(d.charCodeAt(2))&&(r=!0,l=3));let s=l<h?I(d.slice(l),!r,"\\",u):"";return s.length===0&&!r&&(s="."),s.length>0&&u(d.charCodeAt(h-1))&&(s+="\\"),n===void 0?r?`\\${s}`:s:r?`${n}\\${s}`:`${n}${s}`},isAbsolute(d){w(d,"path");const h=d.length;if(h===0)return!1;const l=d.charCodeAt(0);return u(l)||h>2&&g(l)&&d.charCodeAt(1)===E&&u(d.charCodeAt(2))},join(...d){if(d.length===0)return".";let h,l;for(let i=0;i<d.length;++i){const s=d[i];w(s,"path"),s.length>0&&(h===void 0?h=l=s:h+=`\\${s}`)}if(h===void 0)return".";let n=!0,r=0;if(typeof l=="string"&&u(l.charCodeAt(0))){++r;const i=l.length;i>1&&u(l.charCodeAt(1))&&(++r,i>2&&(u(l.charCodeAt(2))?++r:n=!1))}if(n){for(;r<h.length&&u(h.charCodeAt(r));)r++;r>=2&&(h=`\\${h.slice(r)}`)}return e.win32.normalize(h)},relative(d,h){if(w(d,"from"),w(h,"to"),d===h)return"";const l=e.win32.resolve(d),n=e.win32.resolve(h);if(l===n||(d=l.toLowerCase(),h=n.toLowerCase(),d===h))return"";let r=0;for(;r<d.length&&d.charCodeAt(r)===v;)r++;let i=d.length;for(;i-1>r&&d.charCodeAt(i-1)===v;)i--;const s=i-r;let o=0;for(;o<h.length&&h.charCodeAt(o)===v;)o++;let a=h.length;for(;a-1>o&&h.charCodeAt(a-1)===v;)a--;const c=a-o,C=s<c?s:c;let k=-1,M=0;for(;M<C;M++){const F=d.charCodeAt(r+M);if(F!==h.charCodeAt(o+M))break;F===v&&(k=M)}if(M!==C){if(k===-1)return n}else{if(c>C){if(h.charCodeAt(o+M)===v)return n.slice(o+M+1);if(M===2)return n.slice(o+M)}s>C&&(d.charCodeAt(r+M)===v?k=M:M===2&&(k=3)),k===-1&&(k=0)}let T="";for(M=r+k+1;M<=i;++M)(M===i||d.charCodeAt(M)===v)&&(T+=T.length===0?"..":"\\..");return o+=k,T.length>0?`${T}${n.slice(o,a)}`:(n.charCodeAt(o)===v&&++o,n.slice(o,a))},toNamespacedPath(d){if(typeof d!="string")return d;if(d.length===0)return"";const h=e.win32.resolve(d);if(h.length<=2)return d;if(h.charCodeAt(0)===v){if(h.charCodeAt(1)===v){const l=h.charCodeAt(2);if(l!==P&&l!==y)return`\\\\?\\UNC\\${h.slice(2)}`}}else if(g(h.charCodeAt(0))&&h.charCodeAt(1)===E&&h.charCodeAt(2)===v)return`\\\\?\\${h}`;return d},dirname(d){w(d,"path");const h=d.length;if(h===0)return".";let l=-1,n=0;const r=d.charCodeAt(0);if(h===1)return u(r)?d:".";if(u(r)){if(l=n=1,u(d.charCodeAt(1))){let o=2,a=o;for(;o<h&&!u(d.charCodeAt(o));)o++;if(o<h&&o!==a){for(a=o;o<h&&u(d.charCodeAt(o));)o++;if(o<h&&o!==a){for(a=o;o<h&&!u(d.charCodeAt(o));)o++;if(o===h)return d;o!==a&&(l=n=o+1)}}}}else g(r)&&d.charCodeAt(1)===E&&(l=h>2&&u(d.charCodeAt(2))?3:2,n=l);let i=-1,s=!0;for(let o=h-1;o>=n;--o)if(u(d.charCodeAt(o))){if(!s){i=o;break}}else s=!1;if(i===-1){if(l===-1)return".";i=l}return d.slice(0,i)},basename(d,h){h!==void 0&&w(h,"ext"),w(d,"path");let l=0,n=-1,r=!0,i;if(d.length>=2&&g(d.charCodeAt(0))&&d.charCodeAt(1)===E&&(l=2),h!==void 0&&h.length>0&&h.length<=d.length){if(h===d)return"";let s=h.length-1,o=-1;for(i=d.length-1;i>=l;--i){const a=d.charCodeAt(i);if(u(a)){if(!r){l=i+1;break}}else o===-1&&(r=!1,o=i+1),s>=0&&(a===h.charCodeAt(s)?--s==-1&&(n=i):(s=-1,n=o))}return l===n?n=o:n===-1&&(n=d.length),d.slice(l,n)}for(i=d.length-1;i>=l;--i)if(u(d.charCodeAt(i))){if(!r){l=i+1;break}}else n===-1&&(r=!1,n=i+1);return n===-1?"":d.slice(l,n)},extname(d){w(d,"path");let h=0,l=-1,n=0,r=-1,i=!0,s=0;d.length>=2&&d.charCodeAt(1)===E&&g(d.charCodeAt(0))&&(h=n=2);for(let o=d.length-1;o>=h;--o){const a=d.charCodeAt(o);if(u(a)){if(!i){n=o+1;break}continue}r===-1&&(i=!1,r=o+1),a===y?l===-1?l=o:s!==1&&(s=1):l!==-1&&(s=-1)}return l===-1||r===-1||s===0||s===1&&l===r-1&&l===n+1?"":d.slice(l,r)},format:p.bind(null,"\\"),parse(d){w(d,"path");const h={root:"",dir:"",base:"",ext:"",name:""};if(d.length===0)return h;const l=d.length;let n=0,r=d.charCodeAt(0);if(l===1)return u(r)?(h.root=h.dir=d,h):(h.base=h.name=d,h);if(u(r)){if(n=1,u(d.charCodeAt(1))){let k=2,M=k;for(;k<l&&!u(d.charCodeAt(k));)k++;if(k<l&&k!==M){for(M=k;k<l&&u(d.charCodeAt(k));)k++;if(k<l&&k!==M){for(M=k;k<l&&!u(d.charCodeAt(k));)k++;k===l?n=k:k!==M&&(n=k+1)}}}}else if(g(r)&&d.charCodeAt(1)===E){if(l<=2)return h.root=h.dir=d,h;if(n=2,u(d.charCodeAt(2))){if(l===3)return h.root=h.dir=d,h;n=3}}n>0&&(h.root=d.slice(0,n));let i=-1,s=n,o=-1,a=!0,c=d.length-1,C=0;for(;c>=n;--c){if(r=d.charCodeAt(c),u(r)){if(!a){s=c+1;break}continue}o===-1&&(a=!1,o=c+1),r===y?i===-1?i=c:C!==1&&(C=1):i!==-1&&(C=-1)}return o!==-1&&(i===-1||C===0||C===1&&i===o-1&&i===s+1?h.base=h.name=d.slice(s,o):(h.name=d.slice(s,i),h.base=d.slice(s,o),h.ext=d.slice(i,o))),s>0&&s!==n?h.dir=d.slice(0,s-1):h.dir=h.root,h},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...d){let h="",l=!1;for(let n=d.length-1;n>=-1&&!l;n--){const r=n>=0?d[n]:b.cwd();w(r,"path"),r.length!==0&&(h=`${r}/${h}`,l=r.charCodeAt(0)===f)}return h=I(h,!l,"/",m),l?`/${h}`:h.length>0?h:"."},normalize(d){if(w(d,"path"),d.length===0)return".";const h=d.charCodeAt(0)===f,l=d.charCodeAt(d.length-1)===f;return d=I(d,!h,"/",m),d.length===0?h?"/":l?"./":".":(l&&(d+="/"),h?`/${d}`:d)},isAbsolute(d){return w(d,"path"),d.length>0&&d.charCodeAt(0)===f},join(...d){if(d.length===0)return".";let h;for(let l=0;l<d.length;++l){const n=d[l];w(n,"path"),n.length>0&&(h===void 0?h=n:h+=`/${n}`)}return h===void 0?".":e.posix.normalize(h)},relative(d,h){if(w(d,"from"),w(h,"to"),d===h||(d=e.posix.resolve(d),h=e.posix.resolve(h),d===h))return"";const l=1,n=d.length,r=n-l,i=1,s=h.length-i,o=r<s?r:s;let a=-1,c=0;for(;c<o;c++){const k=d.charCodeAt(l+c);if(k!==h.charCodeAt(i+c))break;k===f&&(a=c)}if(c===o)if(s>o){if(h.charCodeAt(i+c)===f)return h.slice(i+c+1);if(c===0)return h.slice(i+c)}else r>o&&(d.charCodeAt(l+c)===f?a=c:c===0&&(a=0));let C="";for(c=l+a+1;c<=n;++c)(c===n||d.charCodeAt(c)===f)&&(C+=C.length===0?"..":"/..");return`${C}${h.slice(i+a)}`},toNamespacedPath(d){return d},dirname(d){if(w(d,"path"),d.length===0)return".";const h=d.charCodeAt(0)===f;let l=-1,n=!0;for(let r=d.length-1;r>=1;--r)if(d.charCodeAt(r)===f){if(!n){l=r;break}}else n=!1;return l===-1?h?"/":".":h&&l===1?"//":d.slice(0,l)},basename(d,h){h!==void 0&&w(h,"ext"),w(d,"path");let l=0,n=-1,r=!0,i;if(h!==void 0&&h.length>0&&h.length<=d.length){if(h===d)return"";let s=h.length-1,o=-1;for(i=d.length-1;i>=0;--i){const a=d.charCodeAt(i);if(a===f){if(!r){l=i+1;break}}else o===-1&&(r=!1,o=i+1),s>=0&&(a===h.charCodeAt(s)?--s==-1&&(n=i):(s=-1,n=o))}return l===n?n=o:n===-1&&(n=d.length),d.slice(l,n)}for(i=d.length-1;i>=0;--i)if(d.charCodeAt(i)===f){if(!r){l=i+1;break}}else n===-1&&(r=!1,n=i+1);return n===-1?"":d.slice(l,n)},extname(d){w(d,"path");let h=-1,l=0,n=-1,r=!0,i=0;for(let s=d.length-1;s>=0;--s){const o=d.charCodeAt(s);if(o===f){if(!r){l=s+1;break}continue}n===-1&&(r=!1,n=s+1),o===y?h===-1?h=s:i!==1&&(i=1):h!==-1&&(i=-1)}return h===-1||n===-1||i===0||i===1&&h===n-1&&h===l+1?"":d.slice(h,n)},format:p.bind(null,"/"),parse(d){w(d,"path");const h={root:"",dir:"",base:"",ext:"",name:""};if(d.length===0)return h;const l=d.charCodeAt(0)===f;let n;l?(h.root="/",n=1):n=0;let r=-1,i=0,s=-1,o=!0,a=d.length-1,c=0;for(;a>=n;--a){const C=d.charCodeAt(a);if(C===f){if(!o){i=a+1;break}continue}s===-1&&(o=!1,s=a+1),C===y?r===-1?r=a:c!==1&&(c=1):r!==-1&&(c=-1)}if(s!==-1){const C=i===0&&l?1:i;r===-1||c===0||c===1&&r===s-1&&r===i+1?h.base=h.name=d.slice(C,s):(h.name=d.slice(C,r),h.base=d.slice(C,s),h.ext=d.slice(r,s))}return i>0?h.dir=d.slice(0,i-1):l&&(h.dir="/"),h},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=b.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=b.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=b.platform==="win32"?e.win32.join:e.posix.join,e.resolve=b.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=b.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=b.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=b.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=b.platform==="win32"?e.win32.extname:e.posix.extname,e.format=b.platform==="win32"?e.win32.format:e.posix.format,e.parse=b.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=b.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=b.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=b.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(J[77],Z([0,1,4]),function(z,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var t;(function(y){y[y.stdout=0]="stdout",y[y.stderr=1]="stderr"})(t=e.Source||(e.Source={}));var R;(function(y){y[y.Success=0]="Success",y[y.Unknown=1]="Unknown",y[y.AccessDenied=2]="AccessDenied",y[y.ProcessNotFound=3]="ProcessNotFound"})(R=e.TerminateResponseCode||(e.TerminateResponseCode={}));function L(y,...f){const v=f.reduce((S,w)=>(S[w]=!0,S),{}),E=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(y).filter(S=>!v[S]).forEach(S=>{for(let w=0;w<E.length;w++)if(S.search(E[w])!==-1){delete y[S];break}})}e.sanitizeProcessEnvironment=L;function D(y){!y||(delete y.DEBUG,b.isMacintosh&&delete y.DYLD_LIBRARY_PATH,b.isLinux&&delete y.LD_PRELOAD)}e.removeDangerousEnvVariables=D}),define(J[78],Z([0,1,4]),function(z,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const t=b.globals.performance&&typeof b.globals.performance.now=="function";class R{constructor(D){this._highResolution=t&&D,this._startTime=this._now(),this._stopTime=-1}static create(D=!0){return new R(D)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?b.globals.performance.now():Date.now()}}e.StopWatch=R}),define(J[3],Z([0,1,18,48,2,120,78]),function(z,e,b,t,R,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;const y=!1,f=!1;var v;(function(a){a.None=()=>R.Disposable.None;function c(O){if(f){const{onListenerDidAdd:N}=O,V=u.create();let _=0;O.onListenerDidAdd=()=>{++_==2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),V.print()),N?.()}}}function C(O){return(N,V=null,_)=>{let $=!1,G;return G=O(ie=>{if(!$)return G?G.dispose():$=!0,N.call(V,ie)},null,_),$&&G.dispose(),G}}a.once=C;function k(O,N,V){return ne((_,$=null,G)=>O(ie=>_.call($,N(ie)),null,G),V)}a.map=k;function M(O,N,V){return ne((_,$=null,G)=>O(ie=>{N(ie),_.call($,ie)},null,G),V)}a.forEach=M;function T(O,N,V){return ne((_,$=null,G)=>O(ie=>N(ie)&&_.call($,ie),null,G),V)}a.filter=T;function F(O){return O}a.signal=F;function q(...O){return(N,V=null,_)=>(0,R.combinedDisposable)(...O.map($=>$(G=>N.call(V,G),null,_)))}a.any=q;function te(O,N,V,_){let $=V;return k(O,G=>($=N($,G),$),_)}a.reduce=te;function ne(O,N){let V;const _={onFirstListenerAdd(){V=O($.fire,$)},onLastListenerRemove(){V?.dispose()}};N||c(_);const $=new g(_);return N?.add($),$.event}function Q(O,N,V=100,_=!1,$,G){let ie,ae,me,fe=0;const Pe={leakWarningThreshold:$,onFirstListenerAdd(){ie=O(ke=>{fe++,ae=N(ae,ke),_&&!me&&(Ee.fire(ae),ae=void 0),clearTimeout(me),me=setTimeout(()=>{const Oe=ae;ae=void 0,me=void 0,(!_||fe>1)&&Ee.fire(Oe),fe=0},V)})},onLastListenerRemove(){ie.dispose()}};G||c(Pe);const Ee=new g(Pe);return G?.add(Ee),Ee.event}a.debounce=Q;function se(O,N=(_,$)=>_===$,V){let _=!0,$;return T(O,G=>{const ie=_||!N(G,$);return _=!1,$=G,ie},V)}a.latch=se;function ce(O,N,V){return[a.filter(O,N,V),a.filter(O,_=>!N(_),V)]}a.split=ce;function H(O,N=!1,V=[]){let _=V.slice(),$=O(ae=>{_?_.push(ae):ie.fire(ae)});const G=()=>{_?.forEach(ae=>ie.fire(ae)),_=null},ie=new g({onFirstListenerAdd(){$||($=O(ae=>ie.fire(ae)))},onFirstListenerDidAdd(){_&&(N?setTimeout(G):G())},onLastListenerRemove(){$&&$.dispose(),$=null}});return ie.event}a.buffer=H;class oe{constructor(N){this.event=N,this.disposables=new R.DisposableStore}map(N){return new oe(k(this.event,N,this.disposables))}forEach(N){return new oe(M(this.event,N,this.disposables))}filter(N){return new oe(T(this.event,N,this.disposables))}reduce(N,V){return new oe(te(this.event,N,V,this.disposables))}latch(){return new oe(se(this.event,void 0,this.disposables))}debounce(N,V=100,_=!1,$){return new oe(Q(this.event,N,V,_,$,this.disposables))}on(N,V,_){return this.event(N,V,_)}once(N,V,_){return C(this.event)(N,V,_)}dispose(){this.disposables.dispose()}}function W(O){return new oe(O)}a.chain=W;function U(O,N,V=_=>_){const _=(...ae)=>ie.fire(V(...ae)),$=()=>O.on(N,_),G=()=>O.removeListener(N,_),ie=new g({onFirstListenerAdd:$,onLastListenerRemove:G});return ie.event}a.fromNodeEventEmitter=U;function B(O,N,V=_=>_){const _=(...ae)=>ie.fire(V(...ae)),$=()=>O.addEventListener(N,_),G=()=>O.removeEventListener(N,_),ie=new g({onFirstListenerAdd:$,onLastListenerRemove:G});return ie.event}a.fromDOMEventEmitter=B;function X(O){return new Promise(N=>C(O)(N))}a.toPromise=X;function j(O,N){return N(void 0),O(V=>N(V))}a.runAndSubscribe=j;function Y(O,N){let V=null;function _(G){V?.dispose(),V=new R.DisposableStore,N(G,V)}_(void 0);const $=O(G=>_(G));return(0,R.toDisposable)(()=>{$.dispose(),V?.dispose()})}a.runAndSubscribeWithStore=Y;class x{constructor(N,V){this.obs=N,this._counter=0,this._hasChanged=!1;const _={onFirstListenerAdd:()=>{N.addObserver(this)},onLastListenerRemove:()=>{N.removeObserver(this)}};V||c(_),this.emitter=new g(_),V&&V.add(this.emitter)}beginUpdate(N){this._counter++}handleChange(N,V){this._hasChanged=!0}endUpdate(N){--this._counter==0&&this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this.obs.get()))}}function A(O,N){return new x(O,N).emitter.event}a.fromObservable=A})(v=e.Event||(e.Event={}));class E{constructor(c){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${c}_${E._idPool++}`}start(c){this._stopWatch=new D.StopWatch(!0),this._listenerCount=c}stop(){if(this._stopWatch){const c=this._stopWatch.elapsed();this._elapsedOverall+=c,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${c.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}E._idPool=0;let P=-1;function S(a){const c=P;return P=a,{dispose(){P=c}}}e.setGlobalLeakWarningThreshold=S;class w{constructor(c,C=Math.random().toString(18).slice(2,5)){this.customThreshold=c,this.name=C,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(c,C){let k=P;if(typeof this.customThreshold=="number"&&(k=this.customThreshold),k<=0||C<k)return;this._stacks||(this._stacks=new Map);const M=this._stacks.get(c.value)||0;if(this._stacks.set(c.value,M+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=k*.5;let T,F=0;for(const[q,te]of this._stacks)(!T||F<te)&&(T=q,F=te);console.warn(`[${this.name}] potential listener LEAK detected, having ${C} listeners already. MOST frequent listener (${F}):`),console.warn(T)}return()=>{const T=this._stacks.get(c.value)||0;this._stacks.set(c.value,T-1)}}}class u{constructor(c){this.value=c}static create(){return new u(new Error().stack??"")}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class m{constructor(c,C,k){this.callback=c,this.callbackThis=C,this.stack=k,this.subscription=new R.SafeDisposable}invoke(c){this.callback.call(this.callbackThis,c)}}class g{constructor(c){this._disposed=!1,this._options=c,this._leakageMon=P>0?new w(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new E(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(y){const c=Array.from(this._listeners);queueMicrotask(()=>{for(const C of c)C.subscription.isset()&&(C.subscription.unset(),C.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(this),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(c,C,k)=>{this._listeners||(this._listeners=new L.LinkedList);const M=this._listeners.isEmpty();M&&this._options?.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);let T,F;this._leakageMon&&this._listeners.size>=30&&(F=u.create(),T=this._leakageMon.check(F,this._listeners.size+1)),y&&(F=F??u.create());const q=new m(c,C,F),te=this._listeners.push(q);M&&this._options?.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options?.onListenerDidAdd&&this._options.onListenerDidAdd(this,c,C);const ne=q.subscription.set(()=>{T?.(),this._disposed||(te(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return k instanceof R.DisposableStore?k.add(ne):Array.isArray(k)&&k.push(ne),ne}),this._event}fire(c){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new p);for(const C of this._listeners)this._deliveryQueue.push(this,C,c);this._perfMon?.start(this._deliveryQueue.size),this._deliveryQueue.deliver(),this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}e.Emitter=g;class I{constructor(){this._queue=new L.LinkedList}get size(){return this._queue.size}push(c,C,k){this._queue.push(new d(c,C,k))}clear(c){const C=new L.LinkedList;for(const k of this._queue)k.emitter!==c&&C.push(k);this._queue=C}deliver(){for(;this._queue.size>0;){const c=this._queue.shift();try{c.listener.invoke(c.event)}catch(C){(0,b.onUnexpectedError)(C)}}}}e.EventDeliveryQueue=I;class p extends I{clear(c){this._queue.clear()}}class d{constructor(c,C,k){this.emitter=c,this.listener=C,this.event=k}}class h extends g{async fireAsync(c,C,k){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new L.LinkedList);for(const M of this._listeners)this._asyncDeliveryQueue.push([M,c]);for(;this._asyncDeliveryQueue.size>0&&!C.isCancellationRequested;){const[M,T]=this._asyncDeliveryQueue.shift(),F=[],q={...T,token:C,waitUntil:te=>{if(Object.isFrozen(F))throw new Error("waitUntil can NOT be called asynchronous");k&&(te=k(te,M.callback)),F.push(te)}};try{M.invoke(q)}catch(te){(0,b.onUnexpectedError)(te);continue}Object.freeze(F),await Promise.allSettled(F).then(te=>{for(const ne of te)ne.status==="rejected"&&(0,b.onUnexpectedError)(ne.reason)})}}}}e.AsyncEmitter=h;class l extends g{constructor(c){super(c);this._isPaused=0,this._eventQueue=new L.LinkedList,this._mergeFn=c?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const c=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(c))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(c){this._listeners&&(this._isPaused!==0?this._eventQueue.push(c):super.fire(c))}}e.PauseableEmitter=l;class n extends l{constructor(c){super(c);this._delay=c.delay??100}fire(c){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(c)}}e.DebounceEmitter=n;class r extends g{constructor(c){super(c);this._queuedEvents=[],this._mergeFn=c?.merge}fire(c){this._queuedEvents.push(c),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(C=>super.fire(C)),this._queuedEvents=[]})}}e.MicrotaskEmitter=r;class i{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new g({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(c){const C={event:c,listener:null};this.events.push(C),this.hasListeners&&this.hook(C);const k=()=>{this.hasListeners&&this.unhook(C);const M=this.events.indexOf(C);this.events.splice(M,1)};return(0,R.toDisposable)((0,t.once)(k))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(c=>this.hook(c))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(c=>this.unhook(c))}hook(c){c.listener=c.event(C=>this.emitter.fire(C))}unhook(c){c.listener&&c.listener.dispose(),c.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=i;class s{constructor(){this.buffers=[]}wrapEvent(c){return(C,k,M)=>c(T=>{const F=this.buffers[this.buffers.length-1];F?F.push(()=>C.call(k,T)):C.call(k,T)},void 0,M)}bufferEvents(c){const C=[];this.buffers.push(C);const k=c();return this.buffers.pop(),C.forEach(M=>M()),k}}e.EventBufferer=s;class o{constructor(){this.listening=!1,this.inputEvent=v.None,this.inputEventListener=R.Disposable.None,this.emitter=new g({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(c){this.inputEvent=c,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=c(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=o}),define(J[22],Z([0,1,3]),function(z,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const t=Object.freeze(function(y,f){const v=setTimeout(y.bind(f),0);return{dispose(){clearTimeout(v)}}});var R;(function(y){function f(v){return v===y.None||v===y.Cancelled||v instanceof L?!0:!v||typeof v!="object"?!1:typeof v.isCancellationRequested=="boolean"&&typeof v.onCancellationRequested=="function"}y.isCancellationToken=f,y.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:b.Event.None}),y.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(R=e.CancellationToken||(e.CancellationToken={}));class L{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?t:(this._emitter||(this._emitter=new b.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class D{constructor(f){this._token=void 0,this._parentListener=void 0,this._parentListener=f&&f.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new L),this._token}cancel(){this._token?this._token instanceof L&&this._token.cancel():this._token=R.Cancelled}dispose(f=!1){f&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof L&&this._token.dispose():this._token=R.None}}e.CancellationTokenSource=D}),define(J[133],Z([0,1,22]),function(z,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class t{constructor(y){this.task=y,this.result=null}get(){if(this.result)return this.result;const y=new b.CancellationTokenSource,f=this.task(y.token);return this.result={promise:f,dispose:()=>{this.result=null,y.cancel(),y.dispose()}},this.result}}e.Cache=t;class R{constructor(y){this.fn=y,this.lastCache=void 0,this.lastArgKey=void 0}get(y){const f=JSON.stringify(y);return this.lastArgKey!==f&&(this.lastArgKey=f,this.lastCache=this.fn(y)),this.lastCache}}e.LRUCachedFunction=R;class L{constructor(y){this.fn=y,this._map=new Map}get cachedValues(){return this._map}get(y){if(this._map.has(y))return this._map.get(y);const f=this.fn(y);return this._map.set(y,f),f}}e.CachedFunction=L}),define(J[91],Z([0,1,3,2]),function(z,e,b,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MutableObservableValue=e.staticObservableValue=void 0;const R=D=>({onDidChange:b.Event.None,value:D});e.staticObservableValue=R;class L extends t.Disposable{constructor(y){super();this._value=y,this.changeEmitter=this._register(new b.Emitter),this.onDidChange=this.changeEmitter.event}get value(){return this._value}set value(y){y!==this._value&&(this._value=y,this.changeEmitter.fire(y))}}e.MutableObservableValue=L}),define(J[31],Z([0,1,133,119]),function(z,e,b,t){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function L(K){return!K||typeof K!="string"?!0:K.trim().length===0}e.isFalsyOrWhitespace=L;const D=/{(\d+)}/g;function y(K,...re){return re.length===0?K:K.replace(D,function(ue,ge){const ye=parseInt(ge,10);return isNaN(ye)||ye<0||ye>=re.length?ue:re[ye]})}e.format=y;const f=/{([^}]+)}/g;function v(K,re){return K.replace(f,(ue,ge)=>re[ge]??ue)}e.format2=v;function E(K){return K.replace(/[<>&]/g,function(re){switch(re){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return re}})}e.escape=E;function P(K){return K.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=P;function S(K,re){let ue=0;const ge=re.charCodeAt(0);for(let ye=K.length-1;ye>=0;ye--)K.charCodeAt(ye)===ge&&ue++;return ue}e.count=S;function w(K,re,ue="\u2026"){return K.length<=re?K:`${K.substr(0,re)}${ue}`}e.truncate=w;function u(K,re=" "){const ue=m(K,re);return g(ue,re)}e.trim=u;function m(K,re){if(!K||!re)return K;const ue=re.length;if(ue===0||K.length===0)return K;let ge=0;for(;K.indexOf(re,ge)===ge;)ge=ge+ue;return K.substring(ge)}e.ltrim=m;function g(K,re){if(!K||!re)return K;const ue=re.length,ge=K.length;if(ue===0||ge===0)return K;let ye=ge,Re=-1;for(;Re=K.lastIndexOf(re,ye-1),!(Re===-1||Re+ue!==ye);){if(Re===0)return"";ye=Re}return K.substring(0,ye)}e.rtrim=g;function I(K){return K.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=I;function p(K){return K.replace(/\*/g,"")}e.stripWildcards=p;function d(K,re,ue={}){if(!K)throw new Error("Cannot create regex from empty string");re||(K=P(K)),ue.wholeWord&&(/\B/.test(K.charAt(0))||(K="\\b"+K),/\B/.test(K.charAt(K.length-1))||(K=K+"\\b"));let ge="";return ue.global&&(ge+="g"),ue.matchCase||(ge+="i"),ue.multiline&&(ge+="m"),ue.unicode&&(ge+="u"),new RegExp(K,ge)}e.createRegExp=d;function h(K){return K.source==="^"||K.source==="^$"||K.source==="$"||K.source==="^\\s*$"?!1:!!(K.exec("")&&K.lastIndex===0)}e.regExpLeadsToEndlessLoop=h;function l(K){return!!K.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=l;function n(K){return(K.global?"g":"")+(K.ignoreCase?"i":"")+(K.multiline?"m":"")+(K.unicode?"u":"")}e.regExpFlags=n;function r(K){return K.split(/\r\n|\r|\n/)}e.splitLines=r;function i(K){for(let re=0,ue=K.length;re<ue;re++){const ge=K.charCodeAt(re);if(ge!==32&&ge!==9)return re}return-1}e.firstNonWhitespaceIndex=i;function s(K,re=0,ue=K.length){for(let ge=re;ge<ue;ge++){const ye=K.charCodeAt(ge);if(ye!==32&&ye!==9)return K.substring(re,ge)}return K.substring(re,ue)}e.getLeadingWhitespace=s;function o(K,re=K.length-1){for(let ue=re;ue>=0;ue--){const ge=K.charCodeAt(ue);if(ge!==32&&ge!==9)return ue}return-1}e.lastNonWhitespaceIndex=o;function a(K,re,ue){const ge=[];let ye=0;for(const Re of K.matchAll(re)){if(ge.push(K.slice(ye,Re.index)),Re.index===void 0)throw new Error("match.index should be defined");ye=Re.index+Re[0].length,ge.push(ue(Re[0],...Re.slice(1),Re.index,K,Re.groups))}return ge.push(K.slice(ye)),Promise.all(ge).then(Re=>Re.join(""))}e.replaceAsync=a;function c(K,re){return K<re?-1:K>re?1:0}e.compare=c;function C(K,re,ue=0,ge=K.length,ye=0,Re=re.length){for(;ue<ge&&ye<Re;ue++,ye++){const et=K.charCodeAt(ue),He=re.charCodeAt(ye);if(et<He)return-1;if(et>He)return 1}const qe=ge-ue,it=Re-ye;return qe<it?-1:qe>it?1:0}e.compareSubstring=C;function k(K,re){return M(K,re,0,K.length,0,re.length)}e.compareIgnoreCase=k;function M(K,re,ue=0,ge=K.length,ye=0,Re=re.length){for(;ue<ge&&ye<Re;ue++,ye++){let et=K.charCodeAt(ue),He=re.charCodeAt(ye);if(et===He)continue;if(et>=128||He>=128)return C(K.toLowerCase(),re.toLowerCase(),ue,ge,ye,Re);F(et)&&(et-=32),F(He)&&(He-=32);const Xe=et-He;if(Xe!==0)return Xe}const qe=ge-ue,it=Re-ye;return qe<it?-1:qe>it?1:0}e.compareSubstringIgnoreCase=M;function T(K){return K>=48&&K<=57}e.isAsciiDigit=T;function F(K){return K>=97&&K<=122}e.isLowerAsciiLetter=F;function q(K){return K>=65&&K<=90}e.isUpperAsciiLetter=q;function te(K,re){return K.length===re.length&&M(K,re)===0}e.equalsIgnoreCase=te;function ne(K,re){const ue=re.length;return re.length>K.length?!1:M(K,re,0,ue)===0}e.startsWithIgnoreCase=ne;function Q(K,re){const ue=Math.min(K.length,re.length);let ge;for(ge=0;ge<ue;ge++)if(K.charCodeAt(ge)!==re.charCodeAt(ge))return ge;return ue}e.commonPrefixLength=Q;function se(K,re){const ue=Math.min(K.length,re.length);let ge;const ye=K.length-1,Re=re.length-1;for(ge=0;ge<ue;ge++)if(K.charCodeAt(ye-ge)!==re.charCodeAt(Re-ge))return ge;return ue}e.commonSuffixLength=se;function ce(K){return 55296<=K&&K<=56319}e.isHighSurrogate=ce;function H(K){return 56320<=K&&K<=57343}e.isLowSurrogate=H;function oe(K,re){return(K-55296<<10)+(re-56320)+65536}e.computeCodePoint=oe;function W(K,re,ue){const ge=K.charCodeAt(ue);if(ce(ge)&&ue+1<re){const ye=K.charCodeAt(ue+1);if(H(ye))return oe(ge,ye)}return ge}e.getNextCodePoint=W;function U(K,re){const ue=K.charCodeAt(re-1);if(H(ue)&&re>1){const ge=K.charCodeAt(re-2);if(ce(ge))return oe(ge,ue)}return ue}class B{constructor(re,ue=0){this._str=re,this._len=re.length,this._offset=ue}get offset(){return this._offset}setOffset(re){this._offset=re}prevCodePoint(){const re=U(this._str,this._offset);return this._offset-=re>=65536?2:1,re}nextCodePoint(){const re=W(this._str,this._len,this._offset);return this._offset+=re>=65536?2:1,re}eol(){return this._offset>=this._len}}e.CodePointIterator=B;class X{constructor(re,ue=0){this._iterator=new B(re,ue)}get offset(){return this._iterator.offset}nextGraphemeLength(){const re=Le.getInstance(),ue=this._iterator,ge=ue.offset;let ye=re.getGraphemeBreakType(ue.nextCodePoint());for(;!ue.eol();){const Re=ue.offset,qe=re.getGraphemeBreakType(ue.nextCodePoint());if(De(ye,qe)){ue.setOffset(Re);break}ye=qe}return ue.offset-ge}prevGraphemeLength(){const re=Le.getInstance(),ue=this._iterator,ge=ue.offset;let ye=re.getGraphemeBreakType(ue.prevCodePoint());for(;ue.offset>0;){const Re=ue.offset,qe=re.getGraphemeBreakType(ue.prevCodePoint());if(De(qe,ye)){ue.setOffset(Re);break}ye=qe}return ge-ue.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=X;function j(K,re){return new X(K,re).nextGraphemeLength()}e.nextCharLength=j;function Y(K,re){return new X(K,re).prevGraphemeLength()}e.prevCharLength=Y;function x(K,re){re>0&&H(K.charCodeAt(re))&&re--;const ue=re+j(K,re);return[ue-Y(K,ue),ue]}e.getCharContainingOffset=x;const A=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function O(K){return A.test(K)}e.containsRTL=O;const N=/^[\t\n\r\x20-\x7E]*$/;function V(K){return N.test(K)}e.isBasicASCII=V,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function _(K){return e.UNUSUAL_LINE_TERMINATORS.test(K)}e.containsUnusualLineTerminators=_;function $(K){return K>=11904&&K<=55215||K>=63744&&K<=64255||K>=65281&&K<=65374}e.isFullWidthCharacter=$;function G(K){return K>=127462&&K<=127487||K===8986||K===8987||K===9200||K===9203||K>=9728&&K<=10175||K===11088||K===11093||K>=127744&&K<=128591||K>=128640&&K<=128764||K>=128992&&K<=129008||K>=129280&&K<=129535||K>=129648&&K<=129782}e.isEmojiImprecise=G;function ie(K,re){if(K.length<re)return K;const ue=/\b/g;let ge=0;for(;ue.test(K)&&!(K.length-ue.lastIndex<re);)ge=ue.lastIndex,ue.lastIndex+=1;return K.substring(ge).replace(/^\s/,"")}e.lcut=ie;const ae=/\x1B\x5B[12]?K/g,me=/\x1b\[\d+m/g,fe=/\x1b\[0?m/g;function Pe(K){return K&&(K=K.replace(ae,""),K=K.replace(me,""),K=K.replace(fe,"")),K}e.removeAnsiEscapeCodes=Pe,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Ee(K){return!!(K&&K.length>0&&K.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Ee;function ke(K){return Ee(K)?K.substr(1):K}e.stripUTF8BOM=ke;function Oe(K,re){if(!K||!re||K.length<re.length)return!1;const ue=re.length,ge=K.toLowerCase();let ye=0,Re=-1;for(;ye<ue;){const qe=ge.indexOf(re[ye],Re+1);if(qe<0)return!1;Re=qe,ye++}return!0}e.fuzzyContains=Oe;function Ue(K,re=!1){return K?(re&&(K=K.replace(/\\./g,"")),K.toLowerCase()!==K):!1}e.containsUppercaseCharacter=Ue;function le(K){return K.charAt(0).toUpperCase()+K.slice(1)}e.uppercaseFirstLetter=le;function he(K,re=1){if(re===0)return"";let ue=-1;do ue=K.indexOf(`
`,ue+1),re--;while(re>0&&ue>=0);return ue===-1?K:(K[ue-1]==="\r"&&ue--,K.substr(0,ue))}e.getNLines=he;function pe(K){const re=90-65+1;return K=K%(2*re),K<re?String.fromCharCode(97+K):String.fromCharCode(65+K-re)}e.singleLetterHash=pe;function Ie(K){return Le.getInstance().getGraphemeBreakType(K)}e.getGraphemeBreakType=Ie;function De(K,re){return K===0?re!==5&&re!==7:K===2&&re===3?!1:K===4||K===2||K===3||re===4||re===2||re===3?!0:!(K===8&&(re===8||re===9||re===11||re===12)||(K===11||K===9)&&(re===9||re===10)||(K===12||K===10)&&re===10||re===5||re===13||re===7||K===1||K===13&&re===14||K===6&&re===6)}var Je;(function(K){K[K.Other=0]="Other",K[K.Prepend=1]="Prepend",K[K.CR=2]="CR",K[K.LF=3]="LF",K[K.Control=4]="Control",K[K.Extend=5]="Extend",K[K.Regional_Indicator=6]="Regional_Indicator",K[K.SpacingMark=7]="SpacingMark",K[K.L=8]="L",K[K.V=9]="V",K[K.T=10]="T",K[K.LV=11]="LV",K[K.LVT=12]="LVT",K[K.ZWJ=13]="ZWJ",K[K.Extended_Pictographic=14]="Extended_Pictographic"})(Je=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Le{constructor(){this._data=Be()}static getInstance(){return Le._INSTANCE||(Le._INSTANCE=new Le),Le._INSTANCE}getGraphemeBreakType(re){if(re<32)return re===10?3:re===13?2:4;if(re<127)return 0;const ue=this._data,ge=ue.length/3;let ye=1;for(;ye<=ge;)if(re<ue[3*ye])ye=2*ye;else if(re>ue[3*ye+1])ye=2*ye+1;else return ue[3*ye+2];return 0}}Le._INSTANCE=null;function Be(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ae(K,re){if(K===0)return 0;const ue=Ye(K,re);if(ue!==void 0)return ue;const ge=new B(re,K);return ge.prevCodePoint(),ge.offset}e.getLeftDeleteOffset=Ae;function Ye(K,re){const ue=new B(re,K);let ge=ue.prevCodePoint();for(;Qe(ge)||ge===65039||ge===8419;){if(ue.offset===0)return;ge=ue.prevCodePoint()}if(!G(ge))return;let ye=ue.offset;return ye>0&&ue.prevCodePoint()===8205&&(ye=ue.offset),ye}function Qe(K){return 127995<=K&&K<=127999}var Ze;(function(K){K[K.zwj=8205]="zwj",K[K.emojiVariantSelector=65039]="emojiVariantSelector",K[K.enclosingKeyCap=8419]="enclosingKeyCap"})(Ze||(Ze={})),e.noBreakWhitespace="\xA0";class ze{constructor(re){this.confusableDictionary=re}static getInstance(re){return ze.cache.get(Array.from(re))}static getLocales(){return ze._locales.getValue()}isAmbiguous(re){return this.confusableDictionary.has(re)}getPrimaryConfusable(re){return this.confusableDictionary.get(re)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=ze,R=ze,ze.ambiguousCharacterData=new t.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),ze.cache=new b.LRUCachedFunction(K=>{function re(He){const Xe=new Map;for(let xe=0;xe<He.length;xe+=2)Xe.set(He[xe],He[xe+1]);return Xe}function ue(He,Xe){const xe=new Map(He);for(const[at,ct]of Xe)xe.set(at,ct);return xe}function ge(He,Xe){if(!He)return Xe;const xe=new Map;for(const[at,ct]of He)Xe.has(at)&&xe.set(at,ct);return xe}const ye=R.ambiguousCharacterData.getValue();let Re=K.filter(He=>!He.startsWith("_")&&He in ye);Re.length===0&&(Re=["_default"]);let qe;for(const He of Re){const Xe=re(ye[He]);qe=ge(qe,Xe)}const it=re(ye._common),et=ue(it,qe);return new ze(et)}),ze._locales=new t.Lazy(()=>Object.keys(ze.ambiguousCharacterData.getValue()).filter(K=>!K.startsWith("_")));class je{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(je.getRawData())),this._data}static isInvisibleCharacter(re){return je.getData().has(re)}static get codePoints(){return je.getData()}}e.InvisibleCharacters=je,je._data=void 0}),define(J[29],Z([0,1,9,4,31,12]),function(z,e,b,t,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function D(o){return o===47||o===92}e.isPathSeparator=D;function y(o){return o.replace(/[\\/]/g,b.posix.sep)}e.toSlashes=y;function f(o){return o.indexOf("/")===-1&&(o=y(o)),/^[a-zA-Z]:(\/|$)/.test(o)&&(o="/"+o),o}e.toPosixPath=f;function v(o,a=b.posix.sep){if(!o)return"";const c=o.length,C=o.charCodeAt(0);if(D(C)){if(D(o.charCodeAt(1))&&!D(o.charCodeAt(2))){let M=3;const T=M;for(;M<c&&!D(o.charCodeAt(M));M++);if(T!==M&&!D(o.charCodeAt(M+1))){for(M+=1;M<c;M++)if(D(o.charCodeAt(M)))return o.slice(0,M+1).replace(/[\\/]/g,a)}}return a}else if(I(C)&&o.charCodeAt(1)===58)return D(o.charCodeAt(2))?o.slice(0,2)+a:o.slice(0,2);let k=o.indexOf("://");if(k!==-1){for(k+=3;k<c;k++)if(D(o.charCodeAt(k)))return o.slice(0,k+1)}return""}e.getRoot=v;function E(o){if(!t.isWindows||!o||o.length<5)return!1;let a=o.charCodeAt(0);if(a!==92||(a=o.charCodeAt(1),a!==92))return!1;let c=2;const C=c;for(;c<o.length&&(a=o.charCodeAt(c),a!==92);c++);return!(C===c||(a=o.charCodeAt(c+1),isNaN(a)||a===92))}e.isUNC=E;const P=/[\\/:\*\?"<>\|]/g,S=/[\\/]/g,w=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function u(o,a=t.isWindows){const c=a?P:S;return!(!o||o.length===0||/^\s+$/.test(o)||(c.lastIndex=0,c.test(o))||a&&w.test(o)||o==="."||o===".."||a&&o[o.length-1]==="."||a&&o.length!==o.trim().length||o.length>255)}e.isValidBasename=u;function m(o,a,c){const C=o===a;return!c||C?C:!o||!a?!1:(0,R.equalsIgnoreCase)(o,a)}e.isEqual=m;function g(o,a,c,C=b.sep){if(o===a)return!0;if(!o||!a||a.length>o.length)return!1;if(c){if(!(0,R.startsWithIgnoreCase)(o,a))return!1;if(a.length===o.length)return!0;let M=a.length;return a.charAt(a.length-1)===C&&M--,o.charAt(M)===C}return a.charAt(a.length-1)!==C&&(a+=C),o.indexOf(a)===0}e.isEqualOrParent=g;function I(o){return o>=65&&o<=90||o>=97&&o<=122}e.isWindowsDriveLetter=I;function p(o,a){return t.isWindows&&o.endsWith(":")&&(o+=b.sep),(0,b.isAbsolute)(o)||(o=(0,b.join)(a,o)),o=(0,b.normalize)(o),t.isWindows?(o=(0,R.rtrim)(o,b.sep),o.endsWith(":")&&(o+=b.sep)):(o=(0,R.rtrim)(o,b.sep),o||(o=b.sep)),o}e.sanitizeFilePath=p;function d(o){const a=(0,b.normalize)(o);return t.isWindows?o.length>3?!1:h(a)&&(o.length===2||a.charCodeAt(2)===92):a===b.posix.sep}e.isRootOrDriveLetter=d;function h(o,a=t.isWindows){return a?I(o.charCodeAt(0))&&o.charCodeAt(1)===58:!1}e.hasDriveLetter=h;function l(o){return h(o)?o[0]:void 0}e.getDriveLetter=l;function n(o,a,c){return a.length>o.length?-1:o===a?0:(c&&(o=o.toLowerCase(),a=a.toLowerCase()),o.indexOf(a))}e.indexOfPath=n;function r(o){const a=o.split(":");let c,C,k;for(const M of a){const T=Number(M);(0,L.isNumber)(T)?C===void 0?C=T:k===void 0&&(k=T):c=c?[c,M].join(":"):M}if(!c)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:c,line:C!==void 0?C:void 0,column:k!==void 0?k:C!==void 0?1:void 0}}e.parseLineAndColumnAware=r;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function s(o,a,c=8){let C="";for(let M=0;M<c;M++)C+=i.charAt(Math.floor(Math.random()*i.length));let k;return a?k=`${a}-${C}`:k=C,o?(0,b.join)(o,k):k}e.randomPath=s}),define(J[65],Z([0,1,31]),function(z,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function t(I){return R(I,0)}e.hash=t;function R(I,p){switch(typeof I){case"object":return I===null?L(349,p):Array.isArray(I)?f(I,p):v(I,p);case"string":return y(I,p);case"boolean":return D(I,p);case"number":return L(I,p);case"undefined":return L(937,p);default:return L(617,p)}}e.doHash=R;function L(I,p){return(p<<5)-p+I|0}e.numberHash=L;function D(I,p){return L(I?433:863,p)}function y(I,p){p=L(149417,p);for(let d=0,h=I.length;d<h;d++)p=L(I.charCodeAt(d),p);return p}e.stringHash=y;function f(I,p){return p=L(104579,p),I.reduce((d,h)=>R(h,d),p)}function v(I,p){return p=L(181387,p),Object.keys(I).sort().reduce((d,h)=>(d=y(h,d),R(I[h],d)),p)}class E{constructor(){this._value=0}get value(){return this._value}hash(p){return this._value=R(p,this._value),this._value}}e.Hasher=E;var P;(function(I){I[I.BLOCK_SIZE=64]="BLOCK_SIZE",I[I.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(P||(P={}));function S(I,p,d=32){const h=d-p,l=~((1<<h)-1);return(I<<p|(l&I)>>>h)>>>0}function w(I,p=0,d=I.byteLength,h=0){for(let l=0;l<d;l++)I[p+l]=h}function u(I,p,d="0"){for(;I.length<p;)I=d+I;return I}function m(I,p=32){return I instanceof ArrayBuffer?Array.from(new Uint8Array(I)).map(d=>d.toString(16).padStart(2,"0")).join(""):u((I>>>0).toString(16),p/4)}e.toHexString=m;class g{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(p){const d=p.length;if(d===0)return;const h=this._buff;let l=this._buffLen,n=this._leftoverHighSurrogate,r,i;for(n!==0?(r=n,i=-1,n=0):(r=p.charCodeAt(0),i=0);;){let s=r;if(b.isHighSurrogate(r))if(i+1<d){const o=p.charCodeAt(i+1);b.isLowSurrogate(o)?(i++,s=b.computeCodePoint(r,o)):s=65533}else{n=r;break}else b.isLowSurrogate(r)&&(s=65533);if(l=this._push(h,l,s),i++,i<d)r=p.charCodeAt(i);else break}this._buffLen=l,this._leftoverHighSurrogate=n}_push(p,d,h){return h<128?p[d++]=h:h<2048?(p[d++]=192|(h&1984)>>>6,p[d++]=128|(h&63)>>>0):h<65536?(p[d++]=224|(h&61440)>>>12,p[d++]=128|(h&4032)>>>6,p[d++]=128|(h&63)>>>0):(p[d++]=240|(h&1835008)>>>18,p[d++]=128|(h&258048)>>>12,p[d++]=128|(h&4032)>>>6,p[d++]=128|(h&63)>>>0),d>=64&&(this._step(),d-=64,this._totalLen+=64,p[0]=p[64+0],p[1]=p[64+1],p[2]=p[64+2]),d}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),m(this._h0)+m(this._h1)+m(this._h2)+m(this._h3)+m(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,w(this._buff,this._buffLen),this._buffLen>56&&(this._step(),w(this._buff));const p=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(p/4294967296),!1),this._buffDV.setUint32(60,p%4294967296,!1),this._step()}_step(){const p=g._bigBlock32,d=this._buffDV;for(let c=0;c<64;c+=4)p.setUint32(c,d.getUint32(c,!1),!1);for(let c=64;c<320;c+=4)p.setUint32(c,S(p.getUint32(c-12,!1)^p.getUint32(c-32,!1)^p.getUint32(c-56,!1)^p.getUint32(c-64,!1),1),!1);let h=this._h0,l=this._h1,n=this._h2,r=this._h3,i=this._h4,s,o,a;for(let c=0;c<80;c++)c<20?(s=l&n|~l&r,o=1518500249):c<40?(s=l^n^r,o=1859775393):c<60?(s=l&n|l&r|n&r,o=2400959708):(s=l^n^r,o=3395469782),a=S(h,5)+s+i+o+p.getUint32(c*4,!1)&4294967295,i=r,r=n,n=S(l,30),l=h,h=a;this._h0=this._h0+h&4294967295,this._h1=this._h1+l&4294967295,this._h2=this._h2+n&4294967295,this._h3=this._h3+r&4294967295,this._h4=this._h4+i&4294967295}}e.StringSHA1=g,g._bigBlock32=new DataView(new ArrayBuffer(320))});var At=this&&this.__classPrivateFieldSet||function(z,e,b,t,R){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!R)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?z!==e||!R:!e.has(z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?R.call(z,b):R?R.value=b:e.set(z,b),b},st=this&&this.__classPrivateFieldGet||function(z,e,b,t){if(b==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?z!==e||!t:!e.has(z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?t:b==="a"?t.call(z):t?t.value:e.get(z)};define(J[33],Z([0,1,25,31]),function(z,e,b,t){"use strict";var R,L,D,y;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function f(o,a,c){let C=o.get(a);return C===void 0&&(C=c,o.set(a,C)),C}e.getOrSet=f;function v(o){const a=[];return o.forEach((c,C)=>{a.push(`${C} => ${c}`)}),`Map(${o.size}) {${a.join(", ")}}`}e.mapToString=v;function E(o){const a=[];return o.forEach(c=>{a.push(c)}),`Set(${o.size}) {${a.join(", ")}}`}e.setToString=E;class P{constructor(){this._value="",this._pos=0}reset(a){return this._value=a,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(a){const c=a.charCodeAt(0),C=this._value.charCodeAt(this._pos);return c-C}value(){return this._value[this._pos]}}e.StringIterator=P;class S{constructor(a=!0){this._caseSensitive=a}reset(a){return this._value=a,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let a=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(a)this._from++;else break;else a=!1;return this}cmp(a){return this._caseSensitive?(0,t.compareSubstring)(a,this._value,0,a.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(a,this._value,0,a.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=S;class w{constructor(a=!0,c=!0){this._splitOnBackslash=a,this._caseSensitive=c}reset(a){this._from=0,this._to=0,this._value=a,this._valueLen=a.length;for(let c=a.length-1;c>=0;c--,this._valueLen--){const C=this._value.charCodeAt(c);if(!(C===47||this._splitOnBackslash&&C===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let a=!0;for(;this._to<this._valueLen;this._to++){const c=this._value.charCodeAt(this._to);if(c===47||this._splitOnBackslash&&c===92)if(a)this._from++;else break;else a=!1}return this}cmp(a){return this._caseSensitive?(0,t.compareSubstring)(a,this._value,0,a.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(a,this._value,0,a.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=w;var u;(function(o){o[o.Scheme=1]="Scheme",o[o.Authority=2]="Authority",o[o.Path=3]="Path",o[o.Query=4]="Query",o[o.Fragment=5]="Fragment"})(u||(u={}));class m{constructor(a,c){this._ignorePathCasing=a,this._ignoreQueryAndFragment=c,this._states=[],this._stateIdx=0}reset(a){return this._value=a,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new w(!1,!this._ignorePathCasing(a)),this._pathIterator.reset(a.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(a)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(a){if(this._states[this._stateIdx]===1)return(0,t.compareIgnoreCase)(a,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,t.compareIgnoreCase)(a,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(a);if(this._states[this._stateIdx]===4)return(0,t.compare)(a,this._value.query);if(this._states[this._stateIdx]===5)return(0,t.compare)(a,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=m;class g{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const a=this.right;return this.right=a.left,a.left=this,this.updateHeight(),a.updateHeight(),a}rotateRight(){const a=this.left;return this.left=a.right,a.right=this,this.updateHeight(),a.updateHeight(),a}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var I;(function(o){o[o.Left=-1]="Left",o[o.Mid=0]="Mid",o[o.Right=1]="Right"})(I||(I={}));class p{constructor(a){this._iter=a}static forUris(a=()=>!1,c=()=>!1){return new p(new m(a,c))}static forPaths(a=!1){return new p(new w(void 0,!a))}static forStrings(){return new p(new P)}static forConfigKeys(){return new p(new S)}clear(){this._root=void 0}fill(a,c){if(c){const C=c.slice(0);(0,b.shuffle)(C);for(const k of C)this.set(k,a)}else{const C=a.slice(0);(0,b.shuffle)(C);for(const k of C)this.set(k[0],k[1])}}set(a,c){const C=this._iter.reset(a);let k;this._root||(this._root=new g,this._root.segment=C.value());const M=[];for(k=this._root;;){const F=C.cmp(k.segment);if(F>0)k.left||(k.left=new g,k.left.segment=C.value()),M.push([-1,k]),k=k.left;else if(F<0)k.right||(k.right=new g,k.right.segment=C.value()),M.push([1,k]),k=k.right;else if(C.hasNext())C.next(),k.mid||(k.mid=new g,k.mid.segment=C.value()),M.push([0,k]),k=k.mid;else break}const T=k.value;k.value=c,k.key=a;for(let F=M.length-1;F>=0;F--){const q=M[F][1];q.updateHeight();const te=q.balanceFactor();if(te<-1||te>1){const ne=M[F][0],Q=M[F+1][0];if(ne===1&&Q===1)M[F][1]=q.rotateLeft();else if(ne===-1&&Q===-1)M[F][1]=q.rotateRight();else if(ne===1&&Q===-1)q.right=M[F+1][1]=M[F+1][1].rotateRight(),M[F][1]=q.rotateLeft();else if(ne===-1&&Q===1)q.left=M[F+1][1]=M[F+1][1].rotateLeft(),M[F][1]=q.rotateRight();else throw new Error;if(F>0)switch(M[F-1][0]){case-1:M[F-1][1].left=M[F][1];break;case 1:M[F-1][1].right=M[F][1];break;case 0:M[F-1][1].mid=M[F][1];break}else this._root=M[0][1]}}return T}get(a){return this._getNode(a)?.value}_getNode(a){const c=this._iter.reset(a);let C=this._root;for(;C;){const k=c.cmp(C.segment);if(k>0)C=C.left;else if(k<0)C=C.right;else if(c.hasNext())c.next(),C=C.mid;else break}return C}has(a){const c=this._getNode(a);return!(c?.value===void 0&&c?.mid===void 0)}delete(a){return this._delete(a,!1)}deleteSuperstr(a){return this._delete(a,!0)}_delete(a,c){const C=this._iter.reset(a),k=[];let M=this._root;for(;M;){const T=C.cmp(M.segment);if(T>0)k.push([-1,M]),M=M.left;else if(T<0)k.push([1,M]),M=M.right;else if(C.hasNext())C.next(),k.push([0,M]),M=M.mid;else break}if(!!M){if(c?(M.left=void 0,M.mid=void 0,M.right=void 0,M.height=1):(M.key=void 0,M.value=void 0),!M.mid&&!M.value)if(M.left&&M.right){const T=this._min(M.right),{key:F,value:q,segment:te}=T;this._delete(T.key,!1),M.key=F,M.value=q,M.segment=te}else{const T=M.left??M.right;if(k.length>0){const[F,q]=k[k.length-1];switch(F){case-1:q.left=T;break;case 0:q.mid=T;break;case 1:q.right=T;break}}else this._root=T}for(let T=k.length-1;T>=0;T--){const F=k[T][1];F.updateHeight();const q=F.balanceFactor();if(q>1?(F.right.balanceFactor()>=0||(F.right=F.right.rotateRight()),k[T][1]=F.rotateLeft()):q<-1&&(F.left.balanceFactor()<=0||(F.left=F.left.rotateLeft()),k[T][1]=F.rotateRight()),T>0)switch(k[T-1][0]){case-1:k[T-1][1].left=k[T][1];break;case 1:k[T-1][1].right=k[T][1];break;case 0:k[T-1][1].mid=k[T][1];break}else this._root=k[0][1]}}}_min(a){for(;a.left;)a=a.left;return a}findSubstr(a){const c=this._iter.reset(a);let C=this._root,k;for(;C;){const M=c.cmp(C.segment);if(M>0)C=C.left;else if(M<0)C=C.right;else if(c.hasNext())c.next(),k=C.value||k,C=C.mid;else break}return C&&C.value||k}findSuperstr(a){const c=this._iter.reset(a);let C=this._root;for(;C;){const k=c.cmp(C.segment);if(k>0)C=C.left;else if(k<0)C=C.right;else if(c.hasNext())c.next(),C=C.mid;else return C.mid?this._entries(C.mid):void 0}}forEach(a){for(const[c,C]of this)a(C,c)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(a){!a||(a.left&&(yield*this._entries(a.left)),a.value&&(yield[a.key,a.value]),a.mid&&(yield*this._entries(a.mid)),a.right&&(yield*this._entries(a.right)))}_isBalanced(){const a=c=>{if(!c)return!0;const C=c.balanceFactor();return C<-1||C>1?!1:a(c.left)&&a(c.right)};return a(this._root)}}e.TernarySearchTree=p;class d{constructor(a,c){this.uri=a,this.value=c}}class h{constructor(a,c){this[R]="ResourceMap",a instanceof h?(this.map=new Map(a.map),this.toKey=c??h.defaultToKey):(this.map=new Map,this.toKey=a??h.defaultToKey)}set(a,c){return this.map.set(this.toKey(a),new d(a,c)),this}get(a){return this.map.get(this.toKey(a))?.value}has(a){return this.map.has(this.toKey(a))}get size(){return this.map.size}clear(){this.map.clear()}delete(a){return this.map.delete(this.toKey(a))}forEach(a,c){typeof c!="undefined"&&(a=a.bind(c));for(const[C,k]of this.map)a(k.value,k.uri,this)}*values(){for(const a of this.map.values())yield a.value}*keys(){for(const a of this.map.values())yield a.uri}*entries(){for(const a of this.map.values())yield[a.uri,a.value]}*[(R=Symbol.toStringTag,Symbol.iterator)](){for(const[,a]of this.map)yield[a.uri,a.value]}}e.ResourceMap=h,h.defaultToKey=o=>o.toString();class l{constructor(a,c){this[L]="ResourceSet",!a||typeof a=="function"?this._map=new h(a):(this._map=new h(c),a.forEach(this.add,this))}get size(){return this._map.size}add(a){return this._map.set(a,a),this}clear(){this._map.clear()}delete(a){return this._map.delete(a)}forEach(a,c){this._map.forEach((C,k)=>a.call(c,k,k,this))}has(a){return this._map.has(a)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=l;var n;(function(o){o[o.None=0]="None",o[o.AsOld=1]="AsOld",o[o.AsNew=2]="AsNew"})(n=e.Touch||(e.Touch={}));class r{constructor(){this[D]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(a){return this._map.has(a)}get(a,c=0){const C=this._map.get(a);if(!!C)return c!==0&&this.touch(C,c),C.value}set(a,c,C=0){let k=this._map.get(a);if(k)k.value=c,C!==0&&this.touch(k,C);else{switch(k={key:a,value:c,next:void 0,previous:void 0},C){case 0:this.addItemLast(k);break;case 1:this.addItemFirst(k);break;case 2:this.addItemLast(k);break;default:this.addItemLast(k);break}this._map.set(a,k),this._size++}return this}delete(a){return!!this.remove(a)}remove(a){const c=this._map.get(a);if(!!c)return this._map.delete(a),this.removeItem(c),this._size--,c.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const a=this._head;return this._map.delete(a.key),this.removeItem(a),this._size--,a.value}forEach(a,c){const C=this._state;let k=this._head;for(;k;){if(c?a.bind(c)(k.value,k.key,this):a(k.value,k.key,this),this._state!==C)throw new Error("LinkedMap got modified during iteration.");k=k.next}}keys(){const a=this,c=this._state;let C=this._head;const k={[Symbol.iterator](){return k},next(){if(a._state!==c)throw new Error("LinkedMap got modified during iteration.");if(C){const M={value:C.key,done:!1};return C=C.next,M}else return{value:void 0,done:!0}}};return k}values(){const a=this,c=this._state;let C=this._head;const k={[Symbol.iterator](){return k},next(){if(a._state!==c)throw new Error("LinkedMap got modified during iteration.");if(C){const M={value:C.value,done:!1};return C=C.next,M}else return{value:void 0,done:!0}}};return k}entries(){const a=this,c=this._state;let C=this._head;const k={[Symbol.iterator](){return k},next(){if(a._state!==c)throw new Error("LinkedMap got modified during iteration.");if(C){const M={value:[C.key,C.value],done:!1};return C=C.next,M}else return{value:void 0,done:!0}}};return k}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(a){if(a>=this.size)return;if(a===0){this.clear();return}let c=this._head,C=this.size;for(;c&&C>a;)this._map.delete(c.key),c=c.next,C--;this._head=c,this._size=C,c&&(c.previous=void 0),this._state++}addItemFirst(a){if(!this._head&&!this._tail)this._tail=a;else if(this._head)a.next=this._head,this._head.previous=a;else throw new Error("Invalid list");this._head=a,this._state++}addItemLast(a){if(!this._head&&!this._tail)this._head=a;else if(this._tail)a.previous=this._tail,this._tail.next=a;else throw new Error("Invalid list");this._tail=a,this._state++}removeItem(a){if(a===this._head&&a===this._tail)this._head=void 0,this._tail=void 0;else if(a===this._head){if(!a.next)throw new Error("Invalid list");a.next.previous=void 0,this._head=a.next}else if(a===this._tail){if(!a.previous)throw new Error("Invalid list");a.previous.next=void 0,this._tail=a.previous}else{const c=a.next,C=a.previous;if(!c||!C)throw new Error("Invalid list");c.previous=C,C.next=c}a.next=void 0,a.previous=void 0,this._state++}touch(a,c){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(c!==1&&c!==2)){if(c===1){if(a===this._head)return;const C=a.next,k=a.previous;a===this._tail?(k.next=void 0,this._tail=k):(C.previous=k,k.next=C),a.previous=void 0,a.next=this._head,this._head.previous=a,this._head=a,this._state++}else if(c===2){if(a===this._tail)return;const C=a.next,k=a.previous;a===this._head?(C.previous=void 0,this._head=C):(C.previous=k,k.next=C),a.next=void 0,a.previous=this._tail,this._tail.next=a,this._tail=a,this._state++}}}toJSON(){const a=[];return this.forEach((c,C)=>{a.push([C,c])}),a}fromJSON(a){this.clear();for(const[c,C]of a)this.set(c,C)}}e.LinkedMap=r;class i extends r{constructor(a,c=1){super();this._limit=a,this._ratio=Math.min(Math.max(0,c),1)}get limit(){return this._limit}set limit(a){this._limit=a,this.checkTrim()}get ratio(){return this._ratio}set ratio(a){this._ratio=Math.min(Math.max(0,a),1),this.checkTrim()}get(a,c=2){return super.get(a,c)}peek(a){return super.get(a,0)}set(a,c){return super.set(a,c,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=i;class s{constructor(a){y.set(this,void 0),At(this,y,a,"f")}get size(){return st(this,y,"f").size}forEach(a,c){st(this,y,"f").forEach(a,c)}get(a){return st(this,y,"f").get(a)}has(a){return st(this,y,"f").has(a)}entries(){return st(this,y,"f").entries()}keys(){return st(this,y,"f").keys()}values(){return st(this,y,"f").values()}[(y=new WeakMap,Symbol.iterator)](){return st(this,y,"f").entries()}}e.ReadonlyMapView=s}),define(J[79],Z([0,1,33]),function(z,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const t=new b.LRUCache(1e4);function R(v){return f(v,"NFC",t)}e.normalizeNFC=R;const L=new b.LRUCache(1e4);function D(v){return f(v,"NFD",L)}e.normalizeNFD=D;const y=/[^\u0000-\u0080]/;function f(v,E,P){if(!v)return v;const S=P.get(v);if(S)return S;let w;return y.test(v)?w=v.normalize(E):w=v,P.set(v,w),w}e.removeAccents=function(){const v=/[\u0300-\u036f]/g;return function(E){return D(E).replace(v,"")}}()}),define(J[7],Z([0,1,9,4]),function(z,e,b,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const R=/^\w[\w\d+.-]*$/,L=/^\//,D=/^\/\//;function y(i,s){if(!i.scheme&&s)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!R.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!L.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(D.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function f(i,s){return!i&&!s?"file":i}function v(i,s){switch(i){case"https":case"http":case"file":s?s[0]!==P&&(s=P+s):s=P;break}return s}const E="",P="/",S=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class w{constructor(s,o,a,c,C,k=!1){typeof s=="object"?(this.scheme=s.scheme||E,this.authority=s.authority||E,this.path=s.path||E,this.query=s.query||E,this.fragment=s.fragment||E):(this.scheme=f(s,k),this.authority=o||E,this.path=v(this.scheme,a||E),this.query=c||E,this.fragment=C||E,y(this,k))}static isUri(s){return s instanceof w?!0:s?typeof s.authority=="string"&&typeof s.fragment=="string"&&typeof s.path=="string"&&typeof s.query=="string"&&typeof s.scheme=="string"&&typeof s.fsPath=="string"&&typeof s.with=="function"&&typeof s.toString=="function":!1}get fsPath(){return d(this,!1)}with(s){if(!s)return this;let{scheme:o,authority:a,path:c,query:C,fragment:k}=s;return o===void 0?o=this.scheme:o===null&&(o=E),a===void 0?a=this.authority:a===null&&(a=E),c===void 0?c=this.path:c===null&&(c=E),C===void 0?C=this.query:C===null&&(C=E),k===void 0?k=this.fragment:k===null&&(k=E),o===this.scheme&&a===this.authority&&c===this.path&&C===this.query&&k===this.fragment?this:new m(o,a,c,C,k)}static parse(s,o=!1){const a=S.exec(s);return a?new m(a[2]||E,r(a[4]||E),r(a[5]||E),r(a[7]||E),r(a[9]||E),o):new m(E,E,E,E,E)}static file(s){let o=E;if(t.isWindows&&(s=s.replace(/\\/g,P)),s[0]===P&&s[1]===P){const a=s.indexOf(P,2);a===-1?(o=s.substring(2),s=P):(o=s.substring(2,a),s=s.substring(a)||P)}return new m("file",o,s,E,E)}static from(s){const o=new m(s.scheme,s.authority,s.path,s.query,s.fragment);return y(o,!0),o}static joinPath(s,...o){if(!s.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let a;return t.isWindows&&s.scheme==="file"?a=w.file(b.win32.join(d(s,!0),...o)).path:a=b.posix.join(s.path,...o),s.with({path:a})}toString(s=!1){return h(this,s)}toJSON(){return this}static revive(s){if(s){if(s instanceof w)return s;{const o=new m(s);return o._formatted=s.external,o._fsPath=s._sep===u?s.fsPath:null,o}}else return s}}e.URI=w;const u=t.isWindows?1:void 0;class m extends w{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=d(this,!1)),this._fsPath}toString(s=!1){return s?h(this,!0):(this._formatted||(this._formatted=h(this,!1)),this._formatted)}toJSON(){const s={$mid:1};return this._fsPath&&(s.fsPath=this._fsPath,s._sep=u),this._formatted&&(s.external=this._formatted),this.path&&(s.path=this.path),this.scheme&&(s.scheme=this.scheme),this.authority&&(s.authority=this.authority),this.query&&(s.query=this.query),this.fragment&&(s.fragment=this.fragment),s}}const g={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function I(i,s){let o,a=-1;for(let c=0;c<i.length;c++){const C=i.charCodeAt(c);if(C>=97&&C<=122||C>=65&&C<=90||C>=48&&C<=57||C===45||C===46||C===95||C===126||s&&C===47)a!==-1&&(o+=encodeURIComponent(i.substring(a,c)),a=-1),o!==void 0&&(o+=i.charAt(c));else{o===void 0&&(o=i.substr(0,c));const k=g[C];k!==void 0?(a!==-1&&(o+=encodeURIComponent(i.substring(a,c)),a=-1),o+=k):a===-1&&(a=c)}}return a!==-1&&(o+=encodeURIComponent(i.substring(a))),o!==void 0?o:i}function p(i){let s;for(let o=0;o<i.length;o++){const a=i.charCodeAt(o);a===35||a===63?(s===void 0&&(s=i.substr(0,o)),s+=g[a]):s!==void 0&&(s+=i[o])}return s!==void 0?s:i}function d(i,s){let o;return i.authority&&i.path.length>1&&i.scheme==="file"?o=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?s?o=i.path.substr(1):o=i.path[1].toLowerCase()+i.path.substr(2):o=i.path,t.isWindows&&(o=o.replace(/\//g,"\\")),o}e.uriToFsPath=d;function h(i,s){const o=s?p:I;let a="",{scheme:c,authority:C,path:k,query:M,fragment:T}=i;if(c&&(a+=c,a+=":"),(C||c==="file")&&(a+=P,a+=P),C){let F=C.indexOf("@");if(F!==-1){const q=C.substr(0,F);C=C.substr(F+1),F=q.indexOf(":"),F===-1?a+=o(q,!1):(a+=o(q.substr(0,F),!1),a+=":",a+=o(q.substr(F+1),!1)),a+="@"}C=C.toLowerCase(),F=C.indexOf(":"),F===-1?a+=o(C,!1):(a+=o(C.substr(0,F),!1),a+=C.substr(F))}if(k){if(k.length>=3&&k.charCodeAt(0)===47&&k.charCodeAt(2)===58){const F=k.charCodeAt(1);F>=65&&F<=90&&(k=`/${String.fromCharCode(F+32)}:${k.substr(3)}`)}else if(k.length>=2&&k.charCodeAt(1)===58){const F=k.charCodeAt(0);F>=65&&F<=90&&(k=`${String.fromCharCode(F+32)}:${k.substr(2)}`)}a+=o(k,!0)}return M&&(a+="?",a+=o(M,!1)),T&&(a+="#",a+=s?T:I(T,!1)),a}function l(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+l(i.substr(3)):i}}const n=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(i){return i.match(n)?i.replace(n,s=>l(s)):i}}),define(J[134],Z([0,1,7]),function(z,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function t(v){const E=v;return E&&typeof E.type=="string"&&typeof E.severity=="string"}e.isRemoteConsoleLog=t;function R(v){const E=[];let P;try{const S=JSON.parse(v.arguments),w=S[S.length-1];w&&w.__$stack&&(S.pop(),P=w.__$stack),E.push(...S)}catch{E.push("Unable to log remote console arguments",v.arguments)}return{args:E,stack:P}}e.parse=R;function L(v){if(typeof v!="string")return L(R(v).stack);const E=v;if(E){const P=D(E),S=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(P||"");if(S&&S.length===4)return{uri:b.URI.file(S[1]),line:Number(S[2]),column:Number(S[3])}}}e.getFirstFrame=L;function D(v){if(!v)return v;const E=v.indexOf(`
`);return E===-1?v:v.substring(0,E)}function y(v,E){const{args:P,stack:S}=R(v),w=typeof P[0]=="string"&&P.length===1;let u=D(S);u&&(u=`(${u.trim()})`);let m=[];if(typeof P[0]=="string"?u&&w?m=[`%c[${E}] %c${P[0]} %c${u}`,f("blue"),f(""),f("grey")]:m=[`%c[${E}] %c${P[0]}`,f("blue"),f(""),...P.slice(1)]:m=[`%c[${E}]%`,f("blue"),...P],u&&!w&&m.push(u),typeof console[v.severity]!="function")throw new Error("Unknown console method");console[v.severity].apply(console,m)}e.log=y;function f(v){return`color: ${v}`}}),define(J[66],Z([0,1,19,31,7]),function(z,e,b,t,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function L(v){return JSON.stringify(v,y)}e.stringify=L;function D(v){let E=JSON.parse(v);return E=f(E),E}e.parse=D;function y(v,E){return E instanceof RegExp?{$mid:2,source:E.source,flags:(0,t.regExpFlags)(E)}:E}function f(v,E=0){if(!v||E>200)return v;if(typeof v=="object"){switch(v.$mid){case 1:return R.URI.revive(v);case 2:return new RegExp(v.source,v.flags);case 14:return new Date(v.source)}if(v instanceof b.VSBuffer||v instanceof Uint8Array)return v;if(Array.isArray(v))for(let P=0;P<v.length;++P)v[P]=f(v[P],E+1);else for(const P in v)Object.hasOwnProperty.call(v,P)&&(v[P]=f(v[P],E+1))}return v}e.revive=f}),define(J[11],Z([0,1,4,7]),function(z,e,b,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var R;(function(y){y.inMemory="inmemory",y.vscode="vscode",y.internal="private",y.walkThrough="walkThrough",y.walkThroughSnippet="walkThroughSnippet",y.http="http",y.https="https",y.file="file",y.mailto="mailto",y.untitled="untitled",y.data="data",y.command="command",y.vscodeRemote="vscode-remote",y.vscodeRemoteResource="vscode-remote-resource",y.vscodeUserData="vscode-userdata",y.vscodeCustomEditor="vscode-custom-editor",y.vscodeNotebook="vscode-notebook",y.vscodeNotebookCell="vscode-notebook-cell",y.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",y.vscodeNotebookCellOutput="vscode-notebook-cell-output",y.vscodeInteractive="vscode-interactive",y.vscodeInteractiveInput="vscode-interactive-input",y.vscodeSettings="vscode-settings",y.vscodeWorkspaceTrust="vscode-workspace-trust",y.vscodeTerminal="vscode-terminal",y.webviewPanel="webview-panel",y.vscodeWebview="vscode-webview",y.extension="extension",y.vscodeFileResource="vscode-file",y.tmp="tmp",y.vsls="vsls"})(R=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class L{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${R.vscodeRemoteResource}`}setPreferredWebSchema(f){this._preferredWebSchema=f}setDelegate(f){this._delegate=f}setServerRootPath(f){this._remoteResourcesPath=`${f}/${R.vscodeRemoteResource}`}set(f,v,E){this._hosts[f]=v,this._ports[f]=E}setConnectionToken(f,v){this._connectionTokens[f]=v}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(f){if(this._delegate)return this._delegate(f);const v=f.authority;let E=this._hosts[v];E&&E.indexOf(":")!==-1&&(E=`[${E}]`);const P=this._ports[v],S=this._connectionTokens[v];let w=`path=${encodeURIComponent(f.path)}`;return typeof S=="string"&&(w+=`&${e.connectionTokenQueryName}=${encodeURIComponent(S)}`),t.URI.from({scheme:b.isWeb?this._preferredWebSchema:R.vscodeRemoteResource,authority:`${E}:${P}`,path:this._remoteResourcesPath,query:w})}}e.RemoteAuthorities=new L;class D{asBrowserUri(f,v){const E=this.toUri(f,v);return E.scheme===R.vscodeRemote?e.RemoteAuthorities.rewrite(E):E.scheme===R.file&&(b.isNative||b.isWebWorker&&b.globals.origin===`${R.vscodeFileResource}://${D.FALLBACK_AUTHORITY}`)?E.with({scheme:R.vscodeFileResource,authority:E.authority||D.FALLBACK_AUTHORITY,query:null,fragment:null}):E}asFileUri(f,v){const E=this.toUri(f,v);return E.scheme===R.vscodeFileResource?E.with({scheme:R.file,authority:E.authority!==D.FALLBACK_AUTHORITY?E.authority:null,query:null,fragment:null}):E}toUri(f,v){return t.URI.isUri(f)?f:t.URI.parse(v.toUrl(f))}}D.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new D}),define(J[16],Z([0,1,29,11,9,4,31,7]),function(z,e,b,t,R,L,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function f(w){return(0,y.uriToFsPath)(w,!0)}e.originalFSPath=f;class v{constructor(u){this._ignorePathCasing=u}compare(u,m,g=!1){return u===m?0:(0,D.compare)(this.getComparisonKey(u,g),this.getComparisonKey(m,g))}isEqual(u,m,g=!1){return u===m?!0:!u||!m?!1:this.getComparisonKey(u,g)===this.getComparisonKey(m,g)}getComparisonKey(u,m=!1){return u.with({path:this._ignorePathCasing(u)?u.path.toLowerCase():void 0,fragment:m?null:void 0}).toString()}ignorePathCasing(u){return this._ignorePathCasing(u)}isEqualOrParent(u,m,g=!1){if(u.scheme===m.scheme){if(u.scheme===t.Schemas.file)return b.isEqualOrParent(f(u),f(m),this._ignorePathCasing(u))&&u.query===m.query&&(g||u.fragment===m.fragment);if((0,e.isEqualAuthority)(u.authority,m.authority))return b.isEqualOrParent(u.path,m.path,this._ignorePathCasing(u),"/")&&u.query===m.query&&(g||u.fragment===m.fragment)}return!1}joinPath(u,...m){return y.URI.joinPath(u,...m)}basenameOrAuthority(u){return(0,e.basename)(u)||u.authority}basename(u){return R.posix.basename(u.path)}extname(u){return R.posix.extname(u.path)}dirname(u){if(u.path.length===0)return u;let m;return u.scheme===t.Schemas.file?m=y.URI.file(R.dirname(f(u))).path:(m=R.posix.dirname(u.path),u.authority&&m.length&&m.charCodeAt(0)!==47&&(console.error(`dirname("${u.toString})) resulted in a relative path`),m="/")),u.with({path:m})}normalizePath(u){if(!u.path.length)return u;let m;return u.scheme===t.Schemas.file?m=y.URI.file(R.normalize(f(u))).path:m=R.posix.normalize(u.path),u.with({path:m})}relativePath(u,m){if(u.scheme!==m.scheme||!(0,e.isEqualAuthority)(u.authority,m.authority))return;if(u.scheme===t.Schemas.file){const p=R.relative(f(u),f(m));return L.isWindows?b.toSlashes(p):p}let g=u.path||"/";const I=m.path||"/";if(this._ignorePathCasing(u)){let p=0;for(const d=Math.min(g.length,I.length);p<d&&!(g.charCodeAt(p)!==I.charCodeAt(p)&&g.charAt(p).toLowerCase()!==I.charAt(p).toLowerCase());p++);g=I.substr(0,p)+g.substr(p)}return R.posix.relative(g,I)}resolvePath(u,m){if(u.scheme===t.Schemas.file){const g=y.URI.file(R.resolve(f(u),m));return u.with({authority:g.authority,path:g.path})}return m=b.toPosixPath(m),u.with({path:R.posix.resolve(u.path,m)})}isAbsolutePath(u){return!!u.path&&u.path[0]==="/"}isEqualAuthority(u,m){return u===m||u!==void 0&&m!==void 0&&(0,D.equalsIgnoreCase)(u,m)}hasTrailingPathSeparator(u,m=R.sep){if(u.scheme===t.Schemas.file){const g=f(u);return g.length>b.getRoot(g).length&&g[g.length-1]===m}else{const g=u.path;return g.length>1&&g.charCodeAt(g.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(u.fsPath)}}removeTrailingPathSeparator(u,m=R.sep){return(0,e.hasTrailingPathSeparator)(u,m)?u.with({path:u.path.substr(0,u.path.length-1)}):u}addTrailingPathSeparator(u,m=R.sep){let g=!1;if(u.scheme===t.Schemas.file){const I=f(u);g=I!==void 0&&I.length===b.getRoot(I).length&&I[I.length-1]===m}else{m="/";const I=u.path;g=I.length===1&&I.charCodeAt(I.length-1)===47}return!g&&!(0,e.hasTrailingPathSeparator)(u,m)?u.with({path:u.path+"/"}):u}}e.ExtUri=v,e.extUri=new v(()=>!1),e.extUriBiasedIgnorePathCase=new v(w=>w.scheme===t.Schemas.file?!L.isLinux:!0),e.extUriIgnorePathCase=new v(w=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function E(w,u){const m=[];for(let g=0;g<w.length;g++){const I=u(w[g]);w.some((p,d)=>d===g?!1:(0,e.isEqualOrParent)(I,u(p)))||m.push(w[g])}return m}e.distinctParents=E;var P;(function(w){w.META_DATA_LABEL="label",w.META_DATA_DESCRIPTION="description",w.META_DATA_SIZE="size",w.META_DATA_MIME="mime";function u(m){const g=new Map;m.path.substring(m.path.indexOf(";")+1,m.path.lastIndexOf(";")).split(";").forEach(d=>{const[h,l]=d.split(":");h&&l&&g.set(h,l)});const p=m.path.substring(0,m.path.indexOf(";"));return p&&g.set(w.META_DATA_MIME,p),g}w.parseMetaData=u})(P=e.DataUri||(e.DataUri={}));function S(w,u,m){if(u){let g=w.path;return g&&g[0]!==R.posix.sep&&(g=R.posix.sep+g),w.with({scheme:m,authority:u,path:g})}return w.with({scheme:m})}e.toLocalResource=S}),define(J[8],Z([0,1,22,18,3,2,16,4]),function(z,e,b,t,R,L,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function f(x){return!!x&&typeof x.then=="function"}e.isThenable=f;function v(x){const A=new b.CancellationTokenSource,O=x(A.token),N=new Promise((V,_)=>{const $=A.token.onCancellationRequested(()=>{$.dispose(),A.dispose(),_(new t.CancellationError)});Promise.resolve(O).then(G=>{$.dispose(),A.dispose(),V(G)},G=>{$.dispose(),A.dispose(),_(G)})});return new class{cancel(){A.cancel()}then(V,_){return N.then(V,_)}catch(V){return this.then(void 0,V)}finally(V){return N.finally(V)}}}e.createCancelablePromise=v;function E(x,A,O){return new Promise((N,V)=>{const _=A.onCancellationRequested(()=>{_.dispose(),N(O)});x.then(N,V).finally(()=>_.dispose())})}e.raceCancellation=E;function P(x,A){return new Promise((O,N)=>{const V=A.onCancellationRequested(()=>{V.dispose(),N(new t.CancellationError)});x.then(O,N).finally(()=>V.dispose())})}e.raceCancellationError=P;async function S(x){let A=-1;const O=x.map((V,_)=>V.then($=>(A=_,$))),N=await Promise.race(O);return x.forEach((V,_)=>{_!==A&&V.cancel()}),N}e.raceCancellablePromises=S;function w(x,A,O){let N;const V=setTimeout(()=>{N?.(void 0),O?.()},A);return Promise.race([x.finally(()=>clearTimeout(V)),new Promise(_=>N=_)])}e.raceTimeout=w;function u(x){return new Promise((A,O)=>{const N=x();f(N)?N.then(A,O):A(N)})}e.asPromise=u;class m{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(A){if(this.activePromise){if(this.queuedPromiseFactory=A,!this.queuedPromise){const O=()=>{this.queuedPromise=null;const N=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,N};this.queuedPromise=new Promise(N=>{this.activePromise.then(O,O).then(N)})}return new Promise((O,N)=>{this.queuedPromise.then(O,N)})}return this.activePromise=A(),new Promise((O,N)=>{this.activePromise.then(V=>{this.activePromise=null,O(V)},V=>{this.activePromise=null,N(V)})})}}e.Throttler=m;class g{constructor(){this.current=Promise.resolve(null)}queue(A){return this.current=this.current.then(()=>A(),()=>A())}}e.Sequencer=g;class I{constructor(){this.promiseMap=new Map}queue(A,O){const V=(this.promiseMap.get(A)??Promise.resolve()).catch(()=>{}).then(O).finally(()=>{this.promiseMap.get(A)===V&&this.promiseMap.delete(A)});return this.promiseMap.set(A,V),V}}e.SequencerByKey=I;const p=(x,A)=>{let O=!0;const N=setTimeout(()=>{O=!1,A()},x);return{isTriggered:()=>O,dispose:()=>{clearTimeout(N),O=!1}}},d=x=>{let A=!0;return queueMicrotask(()=>{A&&(A=!1,x())}),{isTriggered:()=>A,dispose:()=>{A=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class h{constructor(A){this.defaultDelay=A,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(A,O=this.defaultDelay){this.task=A,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((V,_)=>{this.doResolve=V,this.doReject=_}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const V=this.task;return this.task=null,V()}}));const N=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=O===e.MicrotaskDelay?d(N):p(O,N),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new t.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=h;class l{constructor(A){this.delayer=new h(A),this.throttler=new m}trigger(A,O){return this.delayer.trigger(()=>this.throttler.queue(A),O)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=l;class n{constructor(){this._isOpen=!1,this._promise=new Promise((A,O)=>{this._completePromise=A})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=n;class r extends n{constructor(A){super();this._timeout=setTimeout(()=>this.open(),A)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=r;function i(x,A){return A?new Promise((O,N)=>{const V=setTimeout(()=>{_.dispose(),O()},x),_=A.onCancellationRequested(()=>{clearTimeout(V),_.dispose(),N(new t.CancellationError)})}):v(O=>i(x,O))}e.timeout=i;function s(x,A=0){const O=setTimeout(x,A);return(0,L.toDisposable)(()=>clearTimeout(O))}e.disposableTimeout=s;function o(x){const A=[];let O=0;const N=x.length;function V(){return O<N?x[O++]():null}function _($){$!=null&&A.push($);const G=V();return G?G.then(_):Promise.resolve(A)}return Promise.resolve(null).then(_)}e.sequence=o;function a(x,A=N=>!!N,O=null){let N=0;const V=x.length,_=()=>{if(N>=V)return Promise.resolve(O);const $=x[N++];return Promise.resolve($()).then(ie=>A(ie)?Promise.resolve(ie):_())};return _()}e.first=a;function c(x,A=N=>!!N,O=null){if(x.length===0)return Promise.resolve(O);let N=x.length;const V=()=>{N=-1;for(const _ of x)_.cancel?.()};return new Promise((_,$)=>{for(const G of x)G.then(ie=>{--N>=0&&A(ie)?(V(),_(ie)):N===0&&_(O)}).catch(ie=>{--N>=0&&(V(),$(ie))})})}e.firstParallel=c;class C{constructor(A){this._size=0,this.maxDegreeOfParalellism=A,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new R.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(A){return this._size++,new Promise((O,N)=>{this.outstandingPromises.push({factory:A,c:O,e:N}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const A=this.outstandingPromises.shift();this.runningPromises++;const O=A.factory();O.then(A.c,A.e),O.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=C;class k extends C{constructor(){super(1)}}e.Queue=k;class M{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const A=new W;return this.drainers.add(A),A.p}isDrained(){for(const[,A]of this.queues)if(A.size>0)return!1;return!0}queueFor(A,O=D.extUri){const N=O.getComparisonKey(A);let V=this.queues.get(N);return V||(V=new k,R.Event.once(V.onDrained)(()=>{V?.dispose(),this.queues.delete(N),this.onDidQueueDrain()}),this.queues.set(N,V)),V}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const A of this.drainers)A.complete();this.drainers.clear()}dispose(){for(const[,A]of this.queues)A.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=M;class T{constructor(A,O){this._token=-1,typeof A=="function"&&typeof O=="number"&&this.setIfNotSet(A,O)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(A,O){this.cancel(),this._token=setTimeout(()=>{this._token=-1,A()},O)}setIfNotSet(A,O){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,A()},O))}}e.TimeoutTimer=T;class F{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(A,O){this.cancel(),this._token=setInterval(()=>{A()},O)}}e.IntervalTimer=F;class q{constructor(A,O){this.timeoutToken=-1,this.runner=A,this.timeout=O,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(A=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,A)}get delay(){return this.timeout}set delay(A){this.timeout=A}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=q;class te{constructor(A,O){O%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${O}ms is not a multiple of 1000ms.`),this.runner=A,this.timeout=O,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(A=this.timeout){A%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${A}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(A/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=te;class ne extends q{constructor(A,O){super(A,O);this.units=[]}work(A){this.units.push(A),this.isScheduled()||this.schedule()}doRun(){const A=this.units;this.units=[],this.runner?.(A)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=ne;class Q extends L.Disposable{constructor(A,O){super();this.options=A,this.handler=O,this.pendingWork=[],this.throttler=this._register(new L.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(A){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+A.length>this.options.maxBufferedWork)return!1}else if(this.pending+A.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...A),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new q(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=Q,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=x=>{(0,y.setTimeout0)(()=>{if(A)return;const O=Date.now()+15;x(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,O-Date.now())}}))});let A=!1;return{dispose(){A||(A=!0)}}}:e.runWhenIdle=(x,A)=>{const O=requestIdleCallback(x,typeof A=="number"?{timeout:A}:void 0);let N=!1;return{dispose(){N||(N=!0,cancelIdleCallback(O))}}}}();class se{constructor(A){this._didRun=!1,this._executor=()=>{try{this._value=A()}catch(O){this._error=O}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=se;async function ce(x,A,O){let N;for(let V=0;V<O;V++)try{return await x()}catch(_){N=_,await i(A)}throw N}e.retry=ce;class H{hasPending(A){return this._pending?typeof A=="number"?this._pending.taskId===A:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(A,O,N){return this._pending={taskId:A,cancel:()=>N?.(),promise:O},O.then(()=>this.donePending(A),()=>this.donePending(A)),O}donePending(A){this._pending&&A===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const A=this._next;this._next=void 0,A.run().then(A.promiseResolve,A.promiseReject)}}setNext(A){if(this._next)this._next.run=A;else{let O,N;const V=new Promise((_,$)=>{O=_,N=$});this._next={run:A,promise:V,promiseResolve:O,promiseReject:N}}return this._next.promise}}e.TaskSequentializer=H;class oe{constructor(A,O=()=>Date.now()){this.interval=A,this.nowFn=O,this.lastIncrementTime=0,this.value=0}increment(){const A=this.nowFn();return A-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=A,this.value=0),this.value++,this.value}}e.IntervalCounter=oe;class W{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((A,O)=>{this.completeCallback=A,this.errorCallback=O})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(A){return new Promise(O=>{this.completeCallback(A),this.resolved=!0,O()})}error(A){return new Promise(O=>{this.errorCallback(A),this.rejected=!0,O()})}cancel(){new Promise(A=>{this.errorCallback(new t.CancellationError),this.rejected=!0,A()})}}e.DeferredPromise=W;var U;(function(x){async function A(N){let V;const _=await Promise.all(N.map($=>$.then(G=>G,G=>{V||(V=G)})));if(typeof V!="undefined")throw V;return _}x.settled=A;function O(N){return new Promise(async(V,_)=>{try{await N(V,_)}catch($){_($)}})}x.withAsyncBody=O})(U=e.Promises||(e.Promises={}));var B;(function(x){x[x.Initial=0]="Initial",x[x.DoneOK=1]="DoneOK",x[x.DoneError=2]="DoneError"})(B||(B={}));class X{constructor(A){this._state=0,this._results=[],this._error=null,this._onStateChanged=new R.Emitter,queueMicrotask(async()=>{const O={emitOne:N=>this.emitOne(N),emitMany:N=>this.emitMany(N),reject:N=>this.reject(N)};try{await Promise.resolve(A(O)),this.resolve()}catch(N){this.reject(N)}finally{O.emitOne=void 0,O.emitMany=void 0,O.reject=void 0}})}static fromArray(A){return new X(O=>{O.emitMany(A)})}static fromPromise(A){return new X(async O=>{O.emitMany(await A)})}static fromPromises(A){return new X(async O=>{await Promise.all(A.map(async N=>O.emitOne(await N)))})}static merge(A){return new X(async O=>{await Promise.all(A.map(async N=>{for await(const V of N)O.emitOne(V)}))})}[Symbol.asyncIterator](){let A=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(A<this._results.length)return{done:!1,value:this._results[A++]};if(this._state===1)return{done:!0,value:void 0};await R.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(A,O){return new X(async N=>{for await(const V of A)N.emitOne(O(V))})}map(A){return X.map(this,A)}static filter(A,O){return new X(async N=>{for await(const V of A)O(V)&&N.emitOne(V)})}filter(A){return X.filter(this,A)}static coalesce(A){return X.filter(A,O=>!!O)}coalesce(){return X.coalesce(this)}static async toPromise(A){const O=[];for await(const N of A)O.push(N);return O}toPromise(){return X.toPromise(this)}emitOne(A){this._state===0&&(this._results.push(A),this._onStateChanged.fire())}emitMany(A){this._state===0&&(this._results=this._results.concat(A),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(A){this._state===0&&(this._state=2,this._error=A,this._onStateChanged.fire())}}e.AsyncIterableObject=X,X.EMPTY=X.fromArray([]);class j extends X{constructor(A,O){super(O);this._source=A}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=j;function Y(x){const A=new b.CancellationTokenSource,O=x(A.token);return new j(A,async N=>{const V=A.token.onCancellationRequested(()=>{V.dispose(),A.dispose(),N.reject(new t.CancellationError)});try{for await(const _ of O){if(A.token.isCancellationRequested)return;N.emitOne(_)}V.dispose(),A.dispose()}catch(_){V.dispose(),A.dispose(),N.reject(_)}})}e.createCancelableAsyncIterable=Y}),define(J[92],Z([0,1,25,8,29,33,9,4,31]),function(z,e,b,t,R,L,D,y,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function v(){return Object.create(null)}e.getEmptyExpression=v,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const E="[/\\\\]",P="[^/\\\\]",S=/\//g;function w(W,U){switch(W){case 0:return"";case 1:return`${P}*?`;default:return`(?:${E}|${P}+${E}${U?`|${E}${P}+`:""})*?`}}function u(W,U){if(!W)return[];const B=[];let X=!1,j=!1,Y="";for(const x of W){switch(x){case U:if(!X&&!j){B.push(Y),Y="";continue}break;case"{":X=!0;break;case"}":X=!1;break;case"[":j=!0;break;case"]":j=!1;break}Y+=x}return Y&&B.push(Y),B}e.splitGlobAware=u;function m(W){if(!W)return"";let U="";const B=u(W,e.GLOB_SPLIT);if(B.every(X=>X===e.GLOBSTAR))U=".*";else{let X=!1;B.forEach((j,Y)=>{if(j===e.GLOBSTAR){if(X)return;U+=w(2,Y===B.length-1)}else{let x=!1,A="",O=!1,N="";for(const V of j){if(V!=="}"&&x){A+=V;continue}if(O&&(V!=="]"||!N)){let _;V==="-"?_=V:(V==="^"||V==="!")&&!N?_="^":V===e.GLOB_SPLIT?_="":_=(0,f.escapeRegExpCharacters)(V),N+=_;continue}switch(V){case"{":x=!0;continue;case"[":O=!0;continue;case"}":{U+=`(?:${u(A,",").map(G=>m(G)).join("|")})`,x=!1,A="";break}case"]":{U+="["+N+"]",O=!1,N="";break}case"?":U+=P;continue;case"*":U+=w(1);continue;default:U+=(0,f.escapeRegExpCharacters)(V)}}Y<B.length-1&&(B[Y+1]!==e.GLOBSTAR||Y+2<B.length)&&(U+=E)}X=j===e.GLOBSTAR})}return U}const g=/^\*\*\/\*\.[\w\.-]+$/,I=/^\*\*\/([\w\.-]+)\/?$/,p=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,d=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,h=/^\*\*((\/[\w\.-]+)+)\/?$/,l=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,n=new L.LRUCache(1e4),r=function(){return!1},i=function(){return null};function s(W,U){if(!W)return i;let B;typeof W!="string"?B=W.pattern:B=W,B=B.trim();const X=`${B}_${!!U.trimForExclusions}`;let j=n.get(X);if(j)return o(j,W);let Y;return g.test(B)?j=c(B.substr(4),B):(Y=I.exec(a(B,U)))?j=C(Y[1],B):(U.trimForExclusions?d:p).test(B)?j=k(B,U):(Y=h.exec(a(B,U)))?j=M(Y[1].substr(1),B,!0):(Y=l.exec(a(B,U)))?j=M(Y[1],B,!1):j=T(B),n.set(X,j),o(j,W)}function o(W,U){if(typeof U=="string")return W;const B=function(X,j){return(0,R.isEqualOrParent)(X,U.base,!y.isLinux)?W(X.substr(U.base.length+1),j):null};return B.allBasenames=W.allBasenames,B.allPaths=W.allPaths,B.basenames=W.basenames,B.patterns=W.patterns,B}function a(W,U){return U.trimForExclusions&&W.endsWith("/**")?W.substr(0,W.length-2):W}function c(W,U){return function(B,X){return typeof B=="string"&&B.endsWith(W)?U:null}}function C(W,U){const B=`/${W}`,X=`\\${W}`,j=function(x,A){return typeof x!="string"?null:A?A===W?U:null:x===W||x.endsWith(B)||x.endsWith(X)?U:null},Y=[W];return j.basenames=Y,j.patterns=[U],j.allBasenames=Y,j}function k(W,U){const B=H(W.slice(1,-1).split(",").map(A=>s(A,U)).filter(A=>A!==i),W),X=B.length;if(!X)return i;if(X===1)return B[0];const j=function(A,O){for(let N=0,V=B.length;N<V;N++)if(B[N](A,O))return W;return null},Y=B.find(A=>!!A.allBasenames);Y&&(j.allBasenames=Y.allBasenames);const x=B.reduce((A,O)=>O.allPaths?A.concat(O.allPaths):A,[]);return x.length&&(j.allPaths=x),j}function M(W,U,B){const X=D.sep===D.posix.sep,j=X?W:W.replace(S,D.sep),Y=D.sep+j,x=D.posix.sep+W;let A;return B?A=function(O,N){return typeof O=="string"&&(O===j||O.endsWith(Y)||!X&&(O===W||O.endsWith(x)))?U:null}:A=function(O,N){return typeof O=="string"&&(O===j||!X&&O===W)?U:null},A.allPaths=[(B?"*/":"./")+W],A}function T(W){try{const U=new RegExp(`^${m(W)}$`);return function(B){return U.lastIndex=0,typeof B=="string"&&U.test(B)?W:null}}catch{return i}}function F(W,U,B){return!W||typeof U!="string"?!1:q(W)(U,void 0,B)}e.match=F;function q(W,U={}){if(!W)return r;if(typeof W=="string"||te(W)){const B=s(W,U);if(B===i)return r;const X=function(j,Y){return!!B(j,Y)};return B.allBasenames&&(X.allBasenames=B.allBasenames),B.allPaths&&(X.allPaths=B.allPaths),X}return se(W,U)}e.parse=q;function te(W){const U=W;return U?typeof U.base=="string"&&typeof U.pattern=="string":!1}e.isRelativePattern=te;function ne(W){return W.allBasenames||[]}e.getBasenameTerms=ne;function Q(W){return W.allPaths||[]}e.getPathTerms=Q;function se(W,U){const B=H(Object.getOwnPropertyNames(W).map(A=>ce(A,W[A],U)).filter(A=>A!==i)),X=B.length;if(!X)return i;if(!B.some(A=>!!A.requiresSiblings)){if(X===1)return B[0];const A=function(V,_){let $;for(let G=0,ie=B.length;G<ie;G++){const ae=B[G](V,_);if(typeof ae=="string")return ae;(0,t.isThenable)(ae)&&($||($=[]),$.push(ae))}return $?(async()=>{for(const G of $){const ie=await G;if(typeof ie=="string")return ie}return null})():null},O=B.find(V=>!!V.allBasenames);O&&(A.allBasenames=O.allBasenames);const N=B.reduce((V,_)=>_.allPaths?V.concat(_.allPaths):V,[]);return N.length&&(A.allPaths=N),A}const j=function(A,O,N){let V,_;for(let $=0,G=B.length;$<G;$++){const ie=B[$];ie.requiresSiblings&&N&&(O||(O=(0,D.basename)(A)),V||(V=O.substr(0,O.length-(0,D.extname)(A).length)));const ae=ie(A,O,V,N);if(typeof ae=="string")return ae;(0,t.isThenable)(ae)&&(_||(_=[]),_.push(ae))}return _?(async()=>{for(const $ of _){const G=await $;if(typeof G=="string")return G}return null})():null},Y=B.find(A=>!!A.allBasenames);Y&&(j.allBasenames=Y.allBasenames);const x=B.reduce((A,O)=>O.allPaths?A.concat(O.allPaths):A,[]);return x.length&&(j.allPaths=x),j}function ce(W,U,B){if(U===!1)return i;const X=s(W,B);if(X===i)return i;if(typeof U=="boolean")return X;if(U){const j=U.when;if(typeof j=="string"){const Y=(x,A,O,N)=>{if(!N||!X(x,A))return null;const V=j.replace("$(basename)",O),_=N(V);return(0,t.isThenable)(_)?_.then($=>$?W:null):_?W:null};return Y.requiresSiblings=!0,Y}}return X}function H(W,U){const B=W.filter(A=>!!A.basenames);if(B.length<2)return W;const X=B.reduce((A,O)=>{const N=O.basenames;return N?A.concat(N):A},[]);let j;if(U){j=[];for(let A=0,O=X.length;A<O;A++)j.push(U)}else j=B.reduce((A,O)=>{const N=O.patterns;return N?A.concat(N):A},[]);const Y=function(A,O){if(typeof A!="string")return null;if(!O){let V;for(V=A.length;V>0;V--){const _=A.charCodeAt(V-1);if(_===47||_===92)break}O=A.substr(V)}const N=X.indexOf(O);return N!==-1?j[N]:null};Y.basenames=X,Y.patterns=j,Y.allBasenames=X;const x=W.filter(A=>!A.basenames);return x.push(Y),x}function oe(W,U){return(0,b.equals)(W,U,(B,X)=>typeof B=="string"&&typeof X=="string"?B===X:typeof B!="string"&&typeof X!="string"?B.base===X.base&&B.pattern===X.pattern:!1)}e.patternsEquals=oe}),define(J[34],Z([0,1,25,29,9,4,16,31]),function(z,e,b,t,R,L,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function f(i,s){const{os:o,tildify:a,relative:c}=s;if(c){const M=v(i,c,o);if(typeof M=="string")return M}let C=i.fsPath;if(o===1&&!L.isWindows?C=C.replace(/\//g,"\\"):o!==1&&L.isWindows&&(C=C.replace(/\\/g,"/")),o!==1&&a?.userHome){const M=a.userHome.fsPath;let T;i.scheme!==a.userHome.scheme&&i.path.startsWith(R.posix.sep)?T=a.userHome.with({path:i.path}).fsPath:T=i.fsPath,C=S(T,M,o)}return(o===1?R.win32:R.posix).normalize(E(C,o===1))}e.getPathLabel=f;function v(i,s,o){const a=o===1?R.win32:R.posix,c=o===3?D.extUri:D.extUriIgnorePathCase,C=s.getWorkspace(),k=(0,b.firstOrDefault)(C.folders);if(!k)return;i.scheme!==k.uri.scheme&&i.path.startsWith(R.posix.sep)&&(i=k.uri.with({path:i.path}));const M=s.getWorkspaceFolder(i);if(!M)return;let T;if(c.isEqual(M.uri,i)?T="":T=c.relativePath(M.uri,i)??"",T&&(T=a.normalize(T)),C.folders.length>1&&!s.noPrefix){const F=M.name?M.name:c.basenameOrAuthority(M.uri);T=T?`${F} \u2022 ${T}`:F}return T}function E(i,s=L.isWindows){return(0,t.hasDriveLetter)(i,s)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=E;let P=Object.create(null);function S(i,s,o=L.OS){if(o===1||!i||!s)return i;let a=P.original===s?P.normalized:void 0;a||(a=s,L.isWindows&&(a=(0,t.toSlashes)(a)),a=`${(0,y.rtrim)(a,R.posix.sep)}${R.posix.sep}`,P={original:s,normalized:a});let c=i;return L.isWindows&&(c=(0,t.toSlashes)(c)),(o===3?c.startsWith(a):(0,y.startsWithIgnoreCase)(c,a))?`~/${c.substr(a.length)}`:i}e.tildify=S;function w(i,s){return i.replace(/^~($|\/|\\)/,`${s}$1`)}e.untildify=w;const u="\u2026",m="\\\\",g="~";function I(i,s=R.sep){const o=new Array(i.length);let a=!1;for(let c=0;c<i.length;c++){const C=i[c];if(C===""){o[c]=`.${s}`;continue}if(!C){o[c]=C;continue}a=!0;let k="",M=C;M.indexOf(m)===0?(k=M.substr(0,M.indexOf(m)+m.length),M=M.substr(M.indexOf(m)+m.length)):M.indexOf(s)===0?(k=M.substr(0,M.indexOf(s)+s.length),M=M.substr(M.indexOf(s)+s.length)):M.indexOf(g)===0&&(k=M.substr(0,M.indexOf(g)+g.length),M=M.substr(M.indexOf(g)+g.length));const T=M.split(s);for(let F=1;a&&F<=T.length;F++)for(let q=T.length-F;a&&q>=0;q--){a=!1;let te=T.slice(q,q+F).join(s);for(let ne=0;!a&&ne<i.length;ne++)if(ne!==c&&i[ne]&&i[ne].indexOf(te)>-1){const Q=q+F===T.length,se=q>0&&i[ne].indexOf(s)>-1?s+te:te,ce=i[ne].endsWith(se);a=!Q||ce}if(!a){let ne="";(T[0].endsWith(":")||k!=="")&&(q===1&&(q=0,F++,te=T[0]+s+te),q>0&&(ne=T[0]+s),ne=k+ne),q>0&&(ne=ne+u+s),ne=ne+te,q+F<T.length&&(ne=ne+s+u),o[c]=ne}}a&&(o[c]=C)}return o}e.shorten=I;var p;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(p||(p={}));function d(i,s=Object.create(null)){const o=[];let a=!1,c="";for(const C of i)if(C==="$"||a&&C==="{")c&&o.push({value:c,type:p.TEXT}),c="",a=!0;else if(C==="}"&&a){const k=s[c];if(typeof k=="string")k.length&&o.push({value:k,type:p.VARIABLE});else if(k){const M=o[o.length-1];(!M||M.type!==p.SEPARATOR)&&o.push({value:k.label,type:p.SEPARATOR})}c="",a=!1}else c+=C;return c&&!a&&o.push({value:c,type:p.TEXT}),o.filter((C,k)=>{if(C.type===p.SEPARATOR){const M=o[k-1],T=o[k+1];return[M,T].every(F=>F&&(F.type===p.VARIABLE||F.type===p.TEXT)&&F.value.length>0)}return!0}).map(C=>C.value).join("")}e.template=d;function h(i,s){return L.isMacintosh||s?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,L.isMacintosh?"&":"&&"):i.replace(/&&|&/g,o=>o==="&"?"&&":"&")}e.mnemonicMenuLabel=h;function l(i,s){return L.isMacintosh||s?i.replace(/\(&&\w\)|&&/g,""):L.isWindows?i.replace(/&&|&/g,o=>o==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=l;function n(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=n;function r(i){const s=i.indexOf("/")!==-1?R.posix:R.win32,o=s.basename(i),a=s.dirname(i);return o.length?{name:o,parentPath:a}:{name:a,parentPath:""}}e.splitName=r}),define(J[135],Z([0,1,7]),function(z,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function t(E){return E.toJSON()}class R{constructor(P){this._uriTransformer=P}transformIncoming(P){const S=this._uriTransformer.transformIncoming(P);return S===P?P:t(b.URI.from(S))}transformOutgoing(P){const S=this._uriTransformer.transformOutgoing(P);return S===P?P:t(b.URI.from(S))}transformOutgoingURI(P){const S=this._uriTransformer.transformOutgoing(P);return S===P?P:b.URI.from(S)}transformOutgoingScheme(P){return this._uriTransformer.transformOutgoingScheme(P)}}e.URITransformer=R,e.DefaultURITransformer=new class{transformIncoming(E){return E}transformOutgoing(E){return E}transformOutgoingURI(E){return E}transformOutgoingScheme(E){return E}};function L(E,P,S){if(!E||S>200)return null;if(typeof E=="object"){if(E instanceof b.URI)return P.transformOutgoing(E);for(const w in E)if(Object.hasOwnProperty.call(E,w)){const u=L(E[w],P,S+1);u!==null&&(E[w]=u)}}return null}function D(E,P){const S=L(E,P,0);return S===null?E:S}e.transformOutgoingURIs=D;function y(E,P,S,w){if(!E||w>200)return null;if(typeof E=="object"){if(E.$mid===1)return S?b.URI.revive(P.transformIncoming(E)):P.transformIncoming(E);for(const u in E)if(Object.hasOwnProperty.call(E,u)){const m=y(E[u],P,S,w+1);m!==null&&(E[u]=m)}}return null}function f(E,P){const S=y(E,P,!1,0);return S===null?E:S}e.transformIncomingURIs=f;function v(E,P){const S=y(E,P,!0,0);return S===null?E:S}e.transformAndReviveIncomingURIs=v}),define(J[80],Z([0,1,27,18,33,30,125]),function(z,e,b,t,R,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(E){return this._virtualMachineOUIs||(this._virtualMachineOUIs=R.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(E)}value(){if(this._value===void 0){let E=0,P=0;const S=(0,b.networkInterfaces)();for(const w in S){const u=S[w];if(u)for(const{mac:m,internal:g}of u)g||(P+=1,this._isVirtualMachineMacAddress(m.toUpperCase())&&(E+=1))}this._value=P>0?E/P:0}return this._value}};let y;async function f(){return y||(y=(async()=>await v()||L.generateUuid())()),y}e.getMachineId=f;async function v(){try{const E=await new Promise((S,w)=>{z(["crypto"],S,w)}),P=(0,D.getMac)();return E.createHash("sha256").update(P,"utf8").digest("hex")}catch(E){t.onUnexpectedError(E);return}}}),define(J[23],Z([0,1,28,27,136,8,29,79,9,4,16,7]),function(z,e,b,t,R,L,D,y,f,v,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var S;(function(Q){Q[Q.UNLINK=0]="UNLINK",Q[Q.MOVE=1]="MOVE"})(S=e.RimRafMode||(e.RimRafMode={}));async function w(Q,se=S.UNLINK){if((0,D.isRootOrDriveLetter)(Q))throw new Error("rimraf - will refuse to recursively delete root");return se===S.UNLINK?m(Q):u(Q)}async function u(Q){try{const se=(0,D.randomPath)((0,t.tmpdir)());try{await b.promises.rename(Q,se)}catch{return m(Q)}m(se).catch(ce=>{})}catch(se){if(se.code!=="ENOENT")throw se}}async function m(Q){return(0,R.promisify)(b.rm)(Q,{recursive:!0,force:!0,maxRetries:3})}function g(Q){if((0,D.isRootOrDriveLetter)(Q))throw new Error("rimraf - will refuse to recursively delete root");b.rmSync(Q,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=g;async function I(Q,se){return h(await(se?p(Q):(0,R.promisify)(b.readdir)(Q)))}async function p(Q){try{return await(0,R.promisify)(b.readdir)(Q,{withFileTypes:!0})}catch(H){console.warn("[node.js fs] readdir with filetypes failed with error: ",H)}const se=[],ce=await I(Q);for(const H of ce){let oe=!1,W=!1,U=!1;try{const B=await e.Promises.lstat((0,f.join)(Q,H));oe=B.isFile(),W=B.isDirectory(),U=B.isSymbolicLink()}catch(B){console.warn("[node.js fs] unexpected error from lstat after readdir: ",B)}se.push({name:H,isFile:()=>oe,isDirectory:()=>W,isSymbolicLink:()=>U})}return se}function d(Q){return h(b.readdirSync(Q))}e.readdirSync=d;function h(Q){return Q.map(se=>typeof se=="string"?v.isMacintosh?(0,y.normalizeNFC)(se):se:(se.name=v.isMacintosh?(0,y.normalizeNFC)(se.name):se.name,se))}async function l(Q){const se=await I(Q),ce=[];for(const H of se)await r.existsDirectory((0,f.join)(Q,H))&&ce.push(H);return ce}function n(Q,se=1e3){return new Promise(ce=>{let H=!1;const oe=setInterval(()=>{H||(H=!0,b.access(Q,W=>{H=!1,W&&(clearInterval(oe),ce(void 0))}))},se)})}e.whenDeleted=n;var r;(function(Q){async function se(oe){let W;try{if(W=await e.Promises.lstat(oe),!W.isSymbolicLink())return{stat:W}}catch{}try{return{stat:await e.Promises.stat(oe),symbolicLink:W?.isSymbolicLink()?{dangling:!1}:void 0}}catch(U){if(U.code==="ENOENT"&&W)return{stat:W,symbolicLink:{dangling:!0}};if(v.isWindows&&U.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(oe)),symbolicLink:{dangling:!1}}}catch(B){if(B.code==="ENOENT"&&W)return{stat:W,symbolicLink:{dangling:!0}};throw B}throw U}}Q.stat=se;async function ce(oe){try{const{stat:W,symbolicLink:U}=await Q.stat(oe);return W.isFile()&&U?.dangling!==!0}catch{}return!1}Q.existsFile=ce;async function H(oe){try{const{stat:W,symbolicLink:U}=await Q.stat(oe);return W.isDirectory()&&U?.dangling!==!0}catch{}return!1}Q.existsDirectory=H})(r=e.SymlinkSupport||(e.SymlinkSupport={}));const i=new L.ResourceQueue;function s(Q,se,ce){return i.queueFor(P.URI.file(Q),E.extUriBiasedIgnorePathCase).queue(()=>{const H=C(ce);return new Promise((oe,W)=>a(Q,se,H,U=>U?W(U):oe()))})}let o=!0;function a(Q,se,ce,H){if(!o)return b.writeFile(Q,se,{mode:ce.mode,flag:ce.flag},H);b.open(Q,ce.flag,ce.mode,(oe,W)=>{if(oe)return H(oe);b.writeFile(W,se,U=>{if(U)return b.close(W,()=>H(U));b.fdatasync(W,B=>(B&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",B),o=!1),b.close(W,X=>H(X))))})})}function c(Q,se,ce){const H=C(ce);if(!o)return b.writeFileSync(Q,se,{mode:H.mode,flag:H.flag});const oe=b.openSync(Q,H.flag,H.mode);try{b.writeFileSync(oe,se);try{b.fdatasyncSync(oe)}catch(W){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",W),o=!1}}finally{b.closeSync(oe)}}e.writeFileSync=c;function C(Q){return Q?{mode:typeof Q.mode=="number"?Q.mode:438,flag:typeof Q.flag=="string"?Q.flag:"w"}:{mode:438,flag:"w"}}async function k(Q,se){if(Q!==se)try{await e.Promises.rename(Q,se)}catch(ce){if(Q.toLowerCase()!==se.toLowerCase()&&ce.code==="EXDEV"||Q.endsWith("."))await M(Q,se,{preserveSymlinks:!1}),await w(Q,S.MOVE);else throw ce}}async function M(Q,se,ce){return F(Q,se,{root:{source:Q,target:se},options:ce,handledSourcePaths:new Set})}const T=511;async function F(Q,se,ce){if(ce.handledSourcePaths.has(Q))return;ce.handledSourcePaths.add(Q);const{stat:H,symbolicLink:oe}=await r.stat(Q);if(oe){if(ce.options.preserveSymlinks)try{return await ne(Q,se,ce)}catch(W){console.warn("[node.js fs] copy of symlink failed: ",W)}if(oe.dangling)return}return H.isDirectory()?q(Q,se,H.mode&T,ce):te(Q,se,H.mode&T)}async function q(Q,se,ce,H){await e.Promises.mkdir(se,{recursive:!0,mode:ce});const oe=await I(Q);for(const W of oe)await F((0,f.join)(Q,W),(0,f.join)(se,W),H)}async function te(Q,se,ce){await e.Promises.copyFile(Q,se),await e.Promises.chmod(se,ce)}async function ne(Q,se,ce){let H=await e.Promises.readlink(Q);(0,D.isEqualOrParent)(H,ce.root.source,!v.isLinux)&&(H=(0,f.join)(ce.root.target,H.substr(ce.root.source.length+1))),await e.Promises.symlink(H,se)}e.Promises=new class{get access(){return(0,R.promisify)(b.access)}get stat(){return(0,R.promisify)(b.stat)}get lstat(){return(0,R.promisify)(b.lstat)}get utimes(){return(0,R.promisify)(b.utimes)}get read(){return(Q,se,ce,H,oe)=>new Promise((W,U)=>{b.read(Q,se,ce,H,oe,(B,X,j)=>B?U(B):W({bytesRead:X,buffer:j}))})}get readFile(){return(0,R.promisify)(b.readFile)}get write(){return(Q,se,ce,H,oe)=>new Promise((W,U)=>{b.write(Q,se,ce,H,oe,(B,X,j)=>B?U(B):W({bytesWritten:X,buffer:j}))})}get appendFile(){return(0,R.promisify)(b.appendFile)}get fdatasync(){return(0,R.promisify)(b.fdatasync)}get truncate(){return(0,R.promisify)(b.truncate)}get rename(){return(0,R.promisify)(b.rename)}get copyFile(){return(0,R.promisify)(b.copyFile)}get open(){return(0,R.promisify)(b.open)}get close(){return(0,R.promisify)(b.close)}get symlink(){return(0,R.promisify)(b.symlink)}get readlink(){return(0,R.promisify)(b.readlink)}get chmod(){return(0,R.promisify)(b.chmod)}get mkdir(){return(0,R.promisify)(b.mkdir)}get unlink(){return(0,R.promisify)(b.unlink)}get rmdir(){return(0,R.promisify)(b.rmdir)}get realpath(){return(0,R.promisify)(b.realpath)}async exists(Q){try{return await e.Promises.access(Q),!0}catch{return!1}}get readdir(){return I}get readDirsInDir(){return l}get writeFile(){return s}get rm(){return w}get move(){return k}get copy(){return M}}}),define(J[93],Z([0,1,28,9,4,31,23]),function(z,e,b,t,R,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function y(S){if(R.isLinux)return S;const w=(0,t.dirname)(S);if(S===w)return S;const u=((0,t.basename)(S)||S).toLowerCase();try{const g=(0,D.readdirSync)(w).filter(I=>I.toLowerCase()===u);if(g.length===1){const I=y(w);if(I)return(0,t.join)(I,g[0])}else if(g.length>1){const I=g.indexOf(u);if(I>=0){const p=y(w);if(p)return(0,t.join)(p,g[I])}}}catch{}return null}e.realcaseSync=y;async function f(S){if(R.isLinux)return S;const w=(0,t.dirname)(S);if(S===w)return S;const u=((0,t.basename)(S)||S).toLowerCase();try{const g=(await D.Promises.readdir(w)).filter(I=>I.toLowerCase()===u);if(g.length===1){const I=await f(w);if(I)return(0,t.join)(I,g[0])}else if(g.length>1){const I=g.indexOf(u);if(I>=0){const p=await f(w);if(p)return(0,t.join)(p,g[I])}}}catch{}return null}e.realcase=f;async function v(S){try{return await D.Promises.realpath(S)}catch{const u=P(S);return await D.Promises.access(u,b.constants.R_OK),u}}e.realpath=v;function E(S){try{return b.realpathSync(S)}catch{const u=P(S);return b.accessSync(u,b.constants.R_OK),u}}e.realpathSync=E;function P(S){return(0,L.rtrim)((0,t.normalize)(S),t.sep)}}),define(J[137],Z([0,1,27,9,23]),function(z,e,b,t,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const L=/^\d+$/,D=/^Microsoft.PowerShell_.*/,y=/^Microsoft.PowerShellPreview_.*/;var f;(function(h){h[h.x64=0]="x64",h[h.x86=1]="x86",h[h.ARM=2]="ARM"})(f||(f={}));let v;switch(process.arch){case"ia32":case"x32":v=1;break;case"arm":case"arm64":v=2;break;default:v=0;break}let E;process.env.PROCESSOR_ARCHITEW6432?E=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?E=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?E=1:E=0;class P{constructor(l,n,r){this.exePath=l,this.displayName=n,this.knownToExist=r}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await R.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function S({useAlternateBitness:h=!1}={}){return h?v===0?process.env["ProgramFiles(x86)"]||null:E===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function w({useAlternateBitness:h=!1,findPreview:l=!1}={}){const n=S({useAlternateBitness:h});if(!n)return null;const r=t.join(n,"PowerShell");if(!await R.SymlinkSupport.existsDirectory(r))return null;let i=-1,s=null;for(const c of await R.Promises.readdir(r)){let C=-1;if(l){const M=c.indexOf("-");if(M<0)continue;const T=c.substring(0,M);if(!L.test(T)||c.substring(M+1)!=="preview")continue;C=parseInt(T,10)}else{if(!L.test(c))continue;C=parseInt(c,10)}if(C<=i)continue;const k=t.join(r,c,"pwsh.exe");!await R.SymlinkSupport.existsFile(k)||(s=k,i=C)}if(!s)return null;const o=n.includes("x86")?" (x86)":"",a=l?" Preview":"";return new P(s,`PowerShell${a}${o}`,!0)}async function u({findPreview:h}={}){if(!process.env.LOCALAPPDATA)return null;const l=t.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await R.SymlinkSupport.existsDirectory(l))return null;const{pwshMsixDirRegex:n,pwshMsixName:r}=h?{pwshMsixDirRegex:y,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:D,pwshMsixName:"PowerShell (Store)"};for(const i of await R.Promises.readdir(l))if(n.test(i)){const s=t.join(l,i,"pwsh.exe");return new P(s,r)}return null}function m(){const h=t.join(b.homedir(),".dotnet","tools","pwsh.exe");return new P(h,".NET Core PowerShell Global Tool")}function g(){const h=t.join(process.env.windir,v===1&&E!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new P(h,"Windows PowerShell",!0)}async function*I(){let h=await w();h&&(yield h),h=await w({useAlternateBitness:!0}),h&&(yield h),h=await u(),h&&(yield h),h=m(),h&&(yield h),h=await w({findPreview:!0}),h&&(yield h),h=await u({findPreview:!0}),h&&(yield h),h=await w({useAlternateBitness:!0,findPreview:!0}),h&&(yield h),h=g(),h&&(yield h)}async function*p(){for await(const h of I())await h.exists()&&(yield h)}e.enumeratePowerShellInstallations=p;async function d(){for await(const h of p())return h;return null}e.getFirstAvailablePowerShellInstallation=d}),define(J[94],Z([0,1,42,11]),function(z,e,b,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function R(D){return new Promise((y,f)=>{let v;const E=new Map;function P(w,u,m,g,I){const p=E.get(u);if(w===D||p){const d={name:S(m),cmd:m,pid:w,ppid:u,load:g,mem:I};E.set(w,d),w===D&&(v=d),p&&(p.children||(p.children=[]),p.children.push(d),p.children.length>1&&(p.children=p.children.sort((h,l)=>h.pid-l.pid)))}}function S(w){const u=/--vscode-window-kind=shared-process/,m=/--vscode-window-kind=issue-reporter/,g=/--vscode-window-kind=process-explorer/,I=/--utility-sub-type=network/,p=/--vscode-utility-kind=extensionHost/,d=/--crashes-directory/,h=/\\pipe\\winpty-control/,l=/conhost\.exe/,n=/--type=([a-zA-Z-]+)/;if(d.exec(w))return"electron-crash-reporter";if(h.exec(w))return"winpty-process";if(l.exec(w))return"console-window-host (Windows internal process)";let r=n.exec(w);if(r&&r.length===2){if(r[1]==="renderer")return u.exec(w)?"shared-process":m.exec(w)?"issue-reporter":g.exec(w)?"process-explorer":"window";if(r[1]==="utility"){if(I.exec(w))return"utility-network-service";if(p.exec(w))return"extension-host"}return r[1]}const i=/[a-zA-Z-]+\.js/g;let s="";do r=i.exec(w),r&&(s+=r+" ");while(r);return s&&w.indexOf("node ")<0&&w.indexOf("node.exe")<0?`electron_node ${s}`:w}if(process.platform==="win32"){const w=u=>u.indexOf("\\\\?\\")===0||u.indexOf("\\??\\")===0?u.substr(4):u.indexOf('"\\\\?\\')===0||u.indexOf('"\\??\\')===0?'"'+u.substr(5):u;new Promise((u,m)=>{z(["windows-process-tree"],u,m)}).then(u=>{u.getProcessList(D,m=>{if(!m){f(new Error(`Root process ${D} not found`));return}u.getProcessCpuUsage(m,g=>{const I=new Map;g.forEach(p=>{const d=w(p.commandLine||"");I.set(p.pid,{name:S(d),cmd:d,pid:p.pid,ppid:p.ppid,load:p.cpu||0,mem:p.memory||0})}),v=I.get(D),v?(I.forEach(p=>{const d=I.get(p.ppid);d&&(d.children||(d.children=[]),d.children.push(p))}),I.forEach(p=>{p.children&&(p.children=p.children.sort((d,h)=>d.pid-h.pid))}),y(v)):f(new Error(`Root process ${D} not found`))})},u.ProcessDataFlag.CommandLine|u.ProcessDataFlag.Memory)})}else{let w=function(){let u=[v];const m=[];for(;u.length;){const I=u.shift();I&&(m.push(I.pid),I.children&&(u=u.concat(I.children)))}let g=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",z).fsPath);g+=" "+m.join(" "),(0,b.exec)(g,{},(I,p,d)=>{if(I||d)f(I||new Error(d.toString()));else{const h=p.toString().split(`
`);for(let l=0;l<m.length;l++){const n=E.get(m[l]);n.load=parseFloat(h[l])}if(!v){f(new Error(`Root process ${D} not found`));return}y(v)}})};(0,b.exec)("which ps",{},(u,m,g)=>{if(u||g)if(process.platform!=="linux")f(u||new Error(g.toString()));else{const I=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/ps.sh",z).fsPath);(0,b.exec)(I,{},(p,d,h)=>{p||h?f(p||new Error(h.toString())):(L(d,P),w())})}else{const I=m.toString().trim(),p="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,b.exec)(`${I} ${p}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(d,h,l)=>{d||l&&!l.includes("screen size is bogus")?f(d||new Error(l.toString())):(L(h,P),process.platform==="linux"?w():v?y(v):f(new Error(`Root process ${D} not found`)))})}})}})}e.listProcesses=R;function L(D,y){const f=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,v=D.toString().split(`
`);for(const E of v){const P=f.exec(E.trim());P&&P.length===6&&y(parseInt(P[1]),parseInt(P[2]),P[5],parseFloat(P[3]),parseFloat(P[4]))}}});var de=this&&this.__decorate||function(z,e,b,t){var R=arguments.length,L=R<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,b):t,D;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate(z,e,b,t);else for(var y=z.length-1;y>=0;y--)(D=z[y])&&(L=(R<3?D(L):R>3?D(e,b,L):D(e,b))||L);return R>3&&L&&Object.defineProperty(e,b,L),L};define(J[43],Z([0,1,25,8,19,22,51,18,3,2,66,31,12]),function(z,e,b,t,R,L,D,y,f,v,E,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var w;(function(W){W[W.Promise=100]="Promise",W[W.PromiseCancel=101]="PromiseCancel",W[W.EventListen=102]="EventListen",W[W.EventDispose=103]="EventDispose"})(w=e.RequestType||(e.RequestType={}));function u(W){switch(W){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var m;(function(W){W[W.Initialize=200]="Initialize",W[W.PromiseSuccess=201]="PromiseSuccess",W[W.PromiseError=202]="PromiseError",W[W.PromiseErrorObj=203]="PromiseErrorObj",W[W.EventFire=204]="EventFire"})(m=e.ResponseType||(e.ResponseType={}));function g(W){switch(W){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var I;(function(W){W[W.Uninitialized=0]="Uninitialized",W[W.Idle=1]="Idle"})(I||(I={}));class p{constructor(U){this.buffer=U,this.pos=0}read(U){const B=this.buffer.slice(this.pos,this.pos+U);return this.pos+=B.byteLength,B}}class d{constructor(){this.buffers=[]}get buffer(){return R.VSBuffer.concat(this.buffers)}write(U){this.buffers.push(U)}}var h;(function(W){W[W.Undefined=0]="Undefined",W[W.String=1]="String",W[W.Buffer=2]="Buffer",W[W.VSBuffer=3]="VSBuffer",W[W.Array=4]="Array",W[W.Object=5]="Object"})(h||(h={}));function l(W){const U=R.VSBuffer.alloc(4);return U.writeUInt32BE(W,0),U}function n(W){return W.read(4).readUInt32BE(0)}function r(W){const U=R.VSBuffer.alloc(1);return U.writeUInt8(W,0),U}const i={Undefined:r(h.Undefined),String:r(h.String),Buffer:r(h.Buffer),VSBuffer:r(h.VSBuffer),Array:r(h.Array),Object:r(h.Object)},s=typeof Buffer!="undefined";function o(W,U){if(typeof U=="undefined")W.write(i.Undefined);else if(typeof U=="string"){const B=R.VSBuffer.fromString(U);W.write(i.String),W.write(l(B.byteLength)),W.write(B)}else if(s&&Buffer.isBuffer(U)){const B=R.VSBuffer.wrap(U);W.write(i.Buffer),W.write(l(B.byteLength)),W.write(B)}else if(U instanceof R.VSBuffer)W.write(i.VSBuffer),W.write(l(U.byteLength)),W.write(U);else if(Array.isArray(U)){W.write(i.Array),W.write(l(U.length));for(const B of U)o(W,B)}else{const B=R.VSBuffer.fromString(JSON.stringify(U));W.write(i.Object),W.write(l(B.byteLength)),W.write(B)}}function a(W){switch(W.read(1).readUInt8(0)){case h.Undefined:return;case h.String:return W.read(n(W)).toString();case h.Buffer:return W.read(n(W)).buffer;case h.VSBuffer:return W.read(n(W));case h.Array:{const B=n(W),X=[];for(let j=0;j<B;j++)X.push(a(W));return X}case h.Object:return JSON.parse(W.read(n(W)).toString())}}class c{constructor(U,B,X=null,j=1e3){this.protocol=U,this.ctx=B,this.logger=X,this.timeoutDelay=j,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(Y=>this.onRawMessage(Y)),this.sendResponse({type:200})}registerChannel(U,B){this.channels.set(U,B),setTimeout(()=>this.flushPendingRequests(U),0)}sendResponse(U){switch(U.type){case 200:{const B=this.send([U.type]);this.logger?.logOutgoing(B,0,1,g(U.type));return}case 201:case 202:case 204:case 203:{const B=this.send([U.type,U.id],U.data);this.logger?.logOutgoing(B,U.id,1,g(U.type),U.data);return}}}send(U,B=void 0){const X=new d;return o(X,U),o(X,B),this.sendBuffer(X.buffer)}sendBuffer(U){try{return this.protocol.send(U),U.byteLength}catch{return 0}}onRawMessage(U){const B=new p(U),X=a(B),j=a(B),Y=X[0];switch(Y){case 100:return this.logger?.logIncoming(U.byteLength,X[1],1,`${u(Y)}: ${X[2]}.${X[3]}`,j),this.onPromise({type:Y,id:X[1],channelName:X[2],name:X[3],arg:j});case 102:return this.logger?.logIncoming(U.byteLength,X[1],1,`${u(Y)}: ${X[2]}.${X[3]}`,j),this.onEventListen({type:Y,id:X[1],channelName:X[2],name:X[3],arg:j});case 101:return this.logger?.logIncoming(U.byteLength,X[1],1,`${u(Y)}`),this.disposeActiveRequest({type:Y,id:X[1]});case 103:return this.logger?.logIncoming(U.byteLength,X[1],1,`${u(Y)}`),this.disposeActiveRequest({type:Y,id:X[1]})}}onPromise(U){const B=this.channels.get(U.channelName);if(!B){this.collectPendingRequest(U);return}const X=new L.CancellationTokenSource;let j;try{j=B.call(this.ctx,U.name,U.arg,X.token)}catch(A){j=Promise.reject(A)}const Y=U.id;j.then(A=>{this.sendResponse({id:Y,data:A,type:201}),this.activeRequests.delete(U.id)},A=>{A instanceof Error?this.sendResponse({id:Y,data:{message:A.message,name:A.name,stack:A.stack?A.stack.split?A.stack.split(`
`):A.stack:void 0},type:202}):this.sendResponse({id:Y,data:A,type:203}),this.activeRequests.delete(U.id)});const x=(0,v.toDisposable)(()=>X.cancel());this.activeRequests.set(U.id,x)}onEventListen(U){const B=this.channels.get(U.channelName);if(!B){this.collectPendingRequest(U);return}const X=U.id,Y=B.listen(this.ctx,U.name,U.arg)(x=>this.sendResponse({id:X,data:x,type:204}));this.activeRequests.set(U.id,Y)}disposeActiveRequest(U){const B=this.activeRequests.get(U.id);B&&(B.dispose(),this.activeRequests.delete(U.id))}collectPendingRequest(U){let B=this.pendingRequests.get(U.channelName);B||(B=[],this.pendingRequests.set(U.channelName,B));const X=setTimeout(()=>{console.error(`Unknown channel: ${U.channelName}`),U.type===100&&this.sendResponse({id:U.id,data:{name:"Unknown channel",message:`Channel name '${U.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);B.push({request:U,timeoutTimer:X})}flushPendingRequests(U){const B=this.pendingRequests.get(U);if(B){for(const X of B)switch(clearTimeout(X.timeoutTimer),X.request.type){case 100:this.onPromise(X.request);break;case 102:this.onEventListen(X.request);break}this.pendingRequests.delete(U)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,v.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=c;var C;(function(W){W[W.LocalSide=0]="LocalSide",W[W.OtherSide=1]="OtherSide"})(C=e.RequestInitiator||(e.RequestInitiator={}));class k{constructor(U,B=null){this.protocol=U,this.isDisposed=!1,this.state=I.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new f.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(X=>this.onBuffer(X)),this.logger=B}getChannel(U){const B=this;return{call(X,j,Y){return B.isDisposed?Promise.reject(y.canceled()):B.requestPromise(U,X,j,Y)},listen(X,j){return B.isDisposed?f.Event.None:B.requestEvent(U,X,j)}}}requestPromise(U,B,X,j=L.CancellationToken.None){const Y=this.lastRequestId++,A={id:Y,type:100,channelName:U,name:B,arg:X};if(j.isCancellationRequested)return Promise.reject(y.canceled());let O;return new Promise((V,_)=>{if(j.isCancellationRequested)return _(y.canceled());const $=()=>{const me=fe=>{switch(fe.type){case 201:this.handlers.delete(Y),V(fe.data);break;case 202:{this.handlers.delete(Y);const Pe=new Error(fe.data.message);Pe.stack=fe.data.stack,Pe.name=fe.data.name,_(Pe);break}case 203:this.handlers.delete(Y),_(fe.data);break}};this.handlers.set(Y,me),this.sendRequest(A)};let G=null;this.state===I.Idle?$():(G=(0,t.createCancelablePromise)(me=>this.whenInitialized()),G.then(()=>{G=null,$()}));const ie=()=>{G?(G.cancel(),G=null):this.sendRequest({id:Y,type:101}),_(y.canceled())},ae=j.onCancellationRequested(ie);O=(0,v.combinedDisposable)((0,v.toDisposable)(ie),ae),this.activeRequests.add(O)}).finally(()=>{this.activeRequests.delete(O)})}requestEvent(U,B,X){const j=this.lastRequestId++,x={id:j,type:102,channelName:U,name:B,arg:X};let A=null;const O=new f.Emitter({onFirstListenerAdd:()=>{A=(0,t.createCancelablePromise)(V=>this.whenInitialized()),A.then(()=>{A=null,this.activeRequests.add(O),this.sendRequest(x)})},onLastListenerRemove:()=>{A?(A.cancel(),A=null):(this.activeRequests.delete(O),this.sendRequest({id:j,type:103}))}}),N=V=>O.fire(V.data);return this.handlers.set(j,N),O.event}sendRequest(U){switch(U.type){case 100:case 102:{const B=this.send([U.type,U.id,U.channelName,U.name],U.arg);this.logger?.logOutgoing(B,U.id,0,`${u(U.type)}: ${U.channelName}.${U.name}`,U.arg);return}case 101:case 103:{const B=this.send([U.type,U.id]);this.logger?.logOutgoing(B,U.id,0,u(U.type));return}}}send(U,B=void 0){const X=new d;return o(X,U),o(X,B),this.sendBuffer(X.buffer)}sendBuffer(U){try{return this.protocol.send(U),U.byteLength}catch{return 0}}onBuffer(U){const B=new p(U),X=a(B),j=a(B),Y=X[0];switch(Y){case 200:return this.logger?.logIncoming(U.byteLength,0,0,g(Y)),this.onResponse({type:X[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(U.byteLength,X[1],0,g(Y),j),this.onResponse({type:X[0],id:X[1],data:j})}}onResponse(U){if(U.type===200){this.state=I.Idle,this._onDidInitialize.fire();return}this.handlers.get(U.id)?.(U)}get onDidInitializePromise(){return f.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===I.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,v.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}de([D.memoize],k.prototype,"onDidInitializePromise",null),e.ChannelClient=k;class M{constructor(U){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new f.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new f.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,U(({protocol:B,onDidClientDisconnect:X})=>{f.Event.once(B.onMessage)(Y=>{const x=new p(Y),A=a(x),O=new c(B,A),N=new k(B);this.channels.forEach((_,$)=>O.registerChannel($,_));const V={channelServer:O,channelClient:N,ctx:A};this._connections.add(V),this._onDidAddConnection.fire(V),X(()=>{O.dispose(),N.dispose(),this._connections.delete(V),this._onDidRemoveConnection.fire(V)})})})}get connections(){const U=[];return this._connections.forEach(B=>U.push(B)),U}getChannel(U,B){const X=this;return{call(j,Y,x){let A;if((0,S.isFunction)(B)){const N=(0,b.getRandomElement)(X.connections.filter(B));A=N?Promise.resolve(N):f.Event.toPromise(f.Event.filter(X.onDidAddConnection,B))}else A=B.routeCall(X,j,Y);const O=A.then(N=>N.channelClient.getChannel(U));return F(O).call(j,Y,x)},listen(j,Y){if((0,S.isFunction)(B))return X.getMulticastEvent(U,B,j,Y);const x=B.routeEvent(X,j,Y).then(A=>A.channelClient.getChannel(U));return F(x).listen(j,Y)}}}getMulticastEvent(U,B,X,j){const Y=this;let x=new v.DisposableStore;const A=new f.Emitter({onFirstListenerAdd:()=>{x=new v.DisposableStore;const O=new f.EventMultiplexer,N=new Map,V=$=>{const ie=$.channelClient.getChannel(U).listen(X,j),ae=O.add(ie);N.set($,ae)},_=$=>{const G=N.get($);!G||(G.dispose(),N.delete($))};Y.connections.filter(B).forEach(V),f.Event.filter(Y.onDidAddConnection,B)(V,void 0,x),Y.onDidRemoveConnection(_,void 0,x),O.event(A.fire,A,x),x.add(O)},onLastListenerRemove:()=>{x.dispose()}});return A.event}registerChannel(U,B){this.channels.set(U,B),this._connections.forEach(X=>{X.channelServer.registerChannel(U,B)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=M;class T{constructor(U,B,X=null){const j=new d;o(j,B),U.send(j.buffer),this.channelClient=new k(U,X),this.channelServer=new c(U,B,X)}getChannel(U){return this.channelClient.getChannel(U)}registerChannel(U,B){this.channelServer.registerChannel(U,B)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=T;function F(W){return{call(U,B,X){return W.then(j=>j.call(U,B,X))},listen(U,B){const X=new f.Relay;return W.then(j=>X.input=j.listen(U,B)),X.event}}}e.getDelayedChannel=F;function q(W){let U=!1;return{call(B,X,j){return U?W.call(B,X,j):(0,t.timeout)(0).then(()=>U=!0).then(()=>W.call(B,X,j))},listen(B,X){if(U)return W.listen(B,X);const j=new f.Relay;return(0,t.timeout)(0).then(()=>U=!0).then(()=>j.input=W.listen(B,X)),j.event}}}e.getNextTickChannel=q;class te{constructor(U){this.fn=U}routeCall(U){return this.route(U)}routeEvent(U){return this.route(U)}async route(U){for(const B of U.connections)if(await Promise.resolve(this.fn(B.ctx)))return Promise.resolve(B);return await f.Event.toPromise(U.onDidAddConnection),await this.route(U)}}e.StaticRouter=te;var ne;(function(W){function U(Y,x){const A=Y,O=x&&x.disableMarshalling,N=new Map;for(const V in A)X(V)&&N.set(V,f.Event.buffer(A[V],!0));return new class{listen(V,_,$){const G=N.get(_);if(G)return G;if(j(_)){const ie=A[_];if(typeof ie=="function")return ie.call(A,$)}throw new Error(`Event not found: ${_}`)}call(V,_,$){const G=A[_];if(typeof G=="function"){if(!O&&Array.isArray($))for(let ie=0;ie<$.length;ie++)$[ie]=(0,E.revive)($[ie]);return G.apply(A,$)}throw new Error(`Method not found: ${_}`)}}}W.fromService=U;function B(Y,x){const A=x&&x.disableMarshalling;return new Proxy({},{get(O,N){if(typeof N=="string")return x?.properties?.has(N)?x.properties.get(N):j(N)?function(V){return Y.listen(N,V)}:X(N)?Y.listen(N):async function(...V){let _;x&&!(0,S.isUndefinedOrNull)(x.context)?_=[x.context,...V]:_=V;const $=await Y.call(N,_);return A?$:(0,E.revive)($)};throw new Error(`Property not found: ${String(N)}`)}})}W.toService=B;function X(Y){return Y[0]==="o"&&Y[1]==="n"&&P.isUpperAsciiLetter(Y.charCodeAt(2))}function j(Y){return/^onDynamic/.test(Y)&&P.isUpperAsciiLetter(Y.charCodeAt(9))}})(ne=e.ProxyChannel||(e.ProxyChannel={}));const Q=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function se(W){if(Array.isArray(W))return W;if(W&&typeof W=="object"&&typeof W.toString=="function"){const U=W.toString();if(U!=="[object Object]")return U}return W}function ce(W){return Array.isArray(W)?W.map(se):se(W)}function H(W,U,B,X,j,Y,x){x=ce(x);const A=Q[j],O=A[X%A.length];let N=[`%c[${W}]%c[${String(U).padStart(7," ")}]%c[len: ${String(B).padStart(5," ")}]%c${String(X).padStart(5," ")} - ${Y}`,"color: darkgreen","color: grey","color: grey",`color: ${O}`];/\($/.test(Y)?(N=N.concat(x),N.push(")")):N.push(x),console.log.apply(console,N)}e.logWithColors=H;class oe{constructor(U,B){this._outgoingPrefix=U,this._incomingPrefix=B,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(U,B,X,j,Y){this._totalOutgoing+=U,H(this._outgoingPrefix,this._totalOutgoing,U,B,X,j,Y)}logIncoming(U,B,X,j,Y){this._totalIncoming+=U,H(this._incomingPrefix,this._totalIncoming,U,B,X,j,Y)}}e.IPCLogger=oe}),define(J[138],Z([0,1,19,3,43]),function(z,e,b,t,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class L{constructor(f){this.port=f,this.onMessage=t.Event.fromDOMEventEmitter(this.port,"message",v=>b.VSBuffer.wrap(v.data)),f.start()}send(f){this.port.postMessage(f.buffer)}disconnect(){this.port.close()}}e.Protocol=L;class D extends R.IPCClient{constructor(f,v){const E=new L(f);super(E,v);this.protocol=E}dispose(){this.protocol.disconnect()}}e.Client=D}),define(J[95],Z([0,1,19,3,2,43]),function(z,e,b,t,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var D;(function(s){s.Created="created",s.Read="read",s.Write="write",s.Open="open",s.Error="error",s.Close="close",s.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",s.NodeEndReceived="nodeEndReceived",s.NodeEndSent="nodeEndSent",s.NodeDrainBegin="nodeDrainBegin",s.NodeDrainEnd="nodeDrainEnd",s.zlibInflateError="zlibInflateError",s.zlibInflateData="zlibInflateData",s.zlibInflateInitialWrite="zlibInflateInitialWrite",s.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",s.zlibInflateWrite="zlibInflateWrite",s.zlibInflateFlushFired="zlibInflateFlushFired",s.zlibDeflateError="zlibDeflateError",s.zlibDeflateData="zlibDeflateData",s.zlibDeflateWrite="zlibDeflateWrite",s.zlibDeflateFlushFired="zlibDeflateFlushFired",s.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",s.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",s.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",s.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",s.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",s.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",s.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",s.ProtocolHeaderRead="protocolHeaderRead",s.ProtocolMessageRead="protocolMessageRead",s.ProtocolHeaderWrite="protocolHeaderWrite",s.ProtocolMessageWrite="protocolMessageWrite",s.ProtocolWrite="protocolWrite"})(D=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var y;(function(s){s.enableDiagnostics=!1,s.records=[];const o=new WeakMap;let a=0;function c(k,M){if(!o.has(k)){const T=String(++a);o.set(k,T)}return o.get(k)}function C(k,M,T,F){if(!s.enableDiagnostics)return;const q=c(k,M);if(F instanceof b.VSBuffer||F instanceof Uint8Array||F instanceof ArrayBuffer||ArrayBuffer.isView(F)){const te=b.VSBuffer.alloc(F.byteLength);te.set(F),s.records.push({timestamp:Date.now(),id:q,label:M,type:T,buff:te})}else s.records.push({timestamp:Date.now(),id:q,label:M,type:T,data:F})}s.traceSocketEvent=C})(y=e.SocketDiagnostics||(e.SocketDiagnostics={}));var f;(function(s){s[s.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",s[s.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(f=e.SocketCloseEventType||(e.SocketCloseEventType={}));let v=null;function E(){return v||(v=b.VSBuffer.alloc(0)),v}class P{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(o){this._chunks.push(o),this._totalLength+=o.byteLength}read(o){return this._read(o,!0)}peek(o){return this._read(o,!1)}_read(o,a){if(o===0)return E();if(o>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===o){const M=this._chunks[0];return a&&(this._chunks.shift(),this._totalLength-=o),M}if(this._chunks[0].byteLength>o){const M=this._chunks[0].slice(0,o);return a&&(this._chunks[0]=this._chunks[0].slice(o),this._totalLength-=o),M}const c=b.VSBuffer.alloc(o);let C=0,k=0;for(;o>0;){const M=this._chunks[k];if(M.byteLength>o){const T=M.slice(0,o);c.set(T,C),C+=o,a&&(this._chunks[k]=M.slice(o),this._totalLength-=o),o-=o}else c.set(M,C),C+=M.byteLength,a?(this._chunks.shift(),this._totalLength-=M.byteLength):k++,o-=M.byteLength}return c}}e.ChunkStream=P;var S;(function(s){s[s.None=0]="None",s[s.Regular=1]="Regular",s[s.Control=2]="Control",s[s.Ack=3]="Ack",s[s.Disconnect=5]="Disconnect",s[s.ReplayRequest=6]="ReplayRequest",s[s.Pause=7]="Pause",s[s.Resume=8]="Resume"})(S||(S={}));function w(s){switch(s){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting"}}var u;(function(s){s[s.HeaderLength=13]="HeaderLength",s[s.AcknowledgeTime=2e3]="AcknowledgeTime",s[s.TimeoutTime=2e4]="TimeoutTime",s[s.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",s[s.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(u=e.ProtocolConstants||(e.ProtocolConstants={}));class m{constructor(o,a,c,C){this.type=o,this.id=a,this.ack=c,this.data=C,this.writtenTime=0}get size(){return this.data.byteLength}}class g extends R.Disposable{constructor(o){super();this._onMessage=this._register(new t.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=o,this._isDisposed=!1,this._incomingData=new P,this._register(this._socket.onData(a=>this.acceptChunk(a))),this.lastReadTime=Date.now()}acceptChunk(o){if(!(!o||o.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(o);this._incomingData.byteLength>=this._state.readLen;){const a=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=a.readUInt32BE(9),this._state.messageType=a.readUInt8(0),this._state.id=a.readUInt32BE(1),this._state.ack=a.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:w(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const c=this._state.messageType,C=this._state.id,k=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",a),this._onMessage.fire(new m(c,C,k,a)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class I{constructor(o){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=o,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(o){if(this._isDisposed)return;o.writtenTime=Date.now(),this.lastWriteTime=Date.now();const a=b.VSBuffer.alloc(13);a.writeUInt8(o.type,0),a.writeUInt32BE(o.id,1),a.writeUInt32BE(o.ack,5),a.writeUInt32BE(o.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:w(o.type),id:o.id,ack:o.ack,messageSize:o.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",o.data),this._writeSoon(a,o.data)}_bufferAdd(o,a){const c=this._totalLength===0;return this._data.push(o,a),this._totalLength+=o.byteLength+a.byteLength,c}_bufferTake(){const o=b.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,o}_writeSoon(o,a){this._bufferAdd(o,a)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const o=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:o.byteLength}),this._socket.write(o)}}class p extends R.Disposable{constructor(o){super();this._onMessage=new t.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new t.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=o,this._socketWriter=this._register(new I(this._socket)),this._socketReader=this._register(new g(this._socket)),this._register(this._socketReader.onMessage(a=>{a.type===1&&this._onMessage.fire(a.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(o){this._socketWriter.write(new m(1,0,0,o))}}e.Protocol=p;class d extends L.IPCClient{constructor(o,a,c=null){super(o,a,c);this.protocol=o}static fromSocket(o,a){return new d(new p(o),a)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const o=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),o.end()}}e.Client=d;class h{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new t.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(o){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(o):this._emitter.fire(o):this._bufferedMessages.push(o)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=h;class l{constructor(o){this.data=o,this.next=null}}class n{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){const o=[];let a=0,c=this._first;for(;c;)o[a++]=c.data,c=c.next;return o}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(o){const a=new l(o);if(!this._first){this._first=a,this._last=a;return}this._last.next=a,this._last=a}}class r{constructor(){this.lastRuns=[];const o=Date.now();for(let a=0;a<r._HISTORY_LENGTH;a++)this.lastRuns[a]=o-1e3*a;setInterval(()=>{for(let a=r._HISTORY_LENGTH;a>=1;a--)this.lastRuns[a]=this.lastRuns[a-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return r._INSTANCE||(r._INSTANCE=new r),r._INSTANCE}load(){const o=Date.now(),a=(1+r._HISTORY_LENGTH)*1e3;let c=0;for(let C=0;C<r._HISTORY_LENGTH;C++)o-this.lastRuns[C]<=a&&c++;return 1-c/r._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}r._HISTORY_LENGTH=10,r._INSTANCE=null;class i{constructor(o,a=null,c=r.getInstance()){this._onControlMessage=new h,this.onControlMessage=this._onControlMessage.event,this._onMessage=new h,this.onMessage=this._onMessage.event,this._onDidDispose=new h,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new h,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new h,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=c,this._isReconnecting=!1,this._outgoingUnackMsg=new n,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=o,this._socketWriter=new I(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new g(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(C=>this._receiveMessage(C))),this._socketDisposables.push(this._socket.onClose(C=>this._onSocketClose.fire(C))),a&&this._socketReader.acceptChunk(a)}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._socketDisposables=(0,R.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const o=new m(5,0,0,E());this._socketWriter.write(o),this._socketWriter.flush()}sendPause(){const o=new m(7,0,0,E());this._socketWriter.write(o)}sendResume(){const o=new m(8,0,0,E());this._socketWriter.write(o)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(o,a){this._isReconnecting=!0,this._socketDisposables=(0,R.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=o,this._socketWriter=new I(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new g(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(c=>this._receiveMessage(c))),this._socketDisposables.push(this._socket.onClose(c=>this._onSocketClose.fire(c))),this._socketReader.acceptChunk(a)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const o=new m(3,0,this._incomingAckId,E());this._socketWriter.write(o);const a=this._outgoingUnackMsg.toArray();for(let c=0,C=a.length;c<C;c++)this._socketWriter.write(a[c]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(o){if(o.ack>this._outgoingAckId){this._outgoingAckId=o.ack;do{const a=this._outgoingUnackMsg.peek();if(a&&a.id<=o.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(o.type){case 0:break;case 1:{if(o.id>this._incomingMsgId)if(o.id!==this._incomingMsgId+1){const a=Date.now();a-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=a,this._socketWriter.write(new m(6,0,0,E())))}else this._incomingMsgId=o.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(o.data);break}case 2:{this._onControlMessage.fire(o.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const a=this._outgoingUnackMsg.toArray();for(let c=0,C=a.length;c<C;c++)this._socketWriter.write(a[c]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(o){const a=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const c=new m(1,a,this._incomingAckId,o);this._outgoingUnackMsg.push(c),this._isReconnecting||(this._socketWriter.write(c),this._recvAckCheck())}sendControl(o){const a=new m(2,0,0,o);this._socketWriter.write(a)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const o=Date.now()-this._incomingMsgLastTime;if(o>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-o+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const o=this._outgoingUnackMsg.peek(),a=Date.now()-o.writtenTime,c=Date.now()-this._socketReader.lastReadTime,C=Date.now()-this._lastSocketTimeoutTime;if(a>=2e4&&c>=2e4&&C>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire(void 0);return}const k=Math.max(2e4-a,2e4-c,2e4-C,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},k)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const o=new m(3,0,this._incomingAckId,E());this._socketWriter.write(o)}}e.PersistentProtocol=i}),define(J[139],Z([0,1,38,19,3,2,43,127]),function(z,e,b,t,R,L,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function f(E,P){const S=R.Event.fromNodeEventEmitter(b.validatedIpcMain,P,(u,m)=>({event:u,message:m})),w=R.Event.filter(S,({event:u})=>u.sender.id===E);return R.Event.map(w,({message:u})=>u&&t.VSBuffer.wrap(u))}class v extends D.IPCServer{constructor(){super(v.getOnDidClientConnect())}static getOnDidClientConnect(){const P=R.Event.fromNodeEventEmitter(b.validatedIpcMain,"vscode:hello",({sender:S})=>S);return R.Event.map(P,S=>{const w=S.id,u=v.Clients.get(w);u&&u.dispose();const m=new R.Emitter;v.Clients.set(w,(0,L.toDisposable)(()=>m.fire()));const g=f(w,"vscode:message"),I=R.Event.any(R.Event.signal(f(w,"vscode:disconnect")),m.event);return{protocol:new y.Protocol(S,g),onDidClientDisconnect:I}})}}e.Server=v,v.Clients=new Map}),define(J[96],Z([0,1,38,3,30,138]),function(z,e,b,t,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class D extends L.Client{constructor(v,E){super({addEventListener:(P,S)=>v.addListener(P,S),removeEventListener:(P,S)=>v.removeListener(P,S),postMessage:P=>v.postMessage(P),start:()=>v.start(),close:()=>v.close()},E)}}e.Client=D;async function y(f){if(f.isDestroyed()||f.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const v=(0,R.generateUuid)();f.webContents.send("vscode:createMessageChannel",v);const E=t.Event.fromNodeEventEmitter(b.validatedIpcMain,"vscode:createMessageChannelResult",(S,w)=>({nonce:w,port:S.ports[0]})),{port:P}=await t.Event.toPromise(t.Event.once(t.Event.filter(E,S=>S.nonce===v)));return P}e.connect=y}),define(J[97],Z([0,1,8,3,2,12]),function(z,e,b,t,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var D;(function(P){P[P.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(D=e.StorageHint||(e.StorageHint={}));function y(P){const S=P;return S?.changed instanceof Map||S?.deleted instanceof Set}e.isStorageItemsChangeEvent=y;var f;(function(P){P[P.None=0]="None",P[P.Initialized=1]="Initialized",P[P.Closed=2]="Closed"})(f=e.StorageState||(e.StorageState={}));class v extends R.Disposable{constructor(S,w=Object.create(null)){super();this.database=S,this.options=w,this._onDidChangeStorage=this._register(new t.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=f.None,this.cache=new Map,this.flushDelayer=new b.ThrottledDelayer(v.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(S=>this.onDidChangeItemsExternal(S)))}onDidChangeItemsExternal(S){S.changed?.forEach((w,u)=>this.accept(u,w)),S.deleted?.forEach(w=>this.accept(w,void 0))}accept(S,w){if(this.state===f.Closed)return;let u=!1;(0,L.isUndefinedOrNull)(w)?u=this.cache.delete(S):this.cache.get(S)!==w&&(this.cache.set(S,w),u=!0),u&&this._onDidChangeStorage.fire(S)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===f.None&&(this.state=f.Initialized,this.options.hint!==D.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(S,w){const u=this.cache.get(S);return(0,L.isUndefinedOrNull)(u)?w:u}getBoolean(S,w){const u=this.get(S);return(0,L.isUndefinedOrNull)(u)?w:u==="true"}getNumber(S,w){const u=this.get(S);return(0,L.isUndefinedOrNull)(u)?w:parseInt(u,10)}async set(S,w){if(this.state===f.Closed)return;if((0,L.isUndefinedOrNull)(w))return this.delete(S);const u=String(w);if(this.cache.get(S)!==u)return this.cache.set(S,u),this.pendingInserts.set(S,u),this.pendingDeletes.delete(S),this._onDidChangeStorage.fire(S),this.doFlush()}async delete(S){if(!(this.state===f.Closed||!this.cache.delete(S)))return this.pendingDeletes.has(S)||this.pendingDeletes.add(S),this.pendingInserts.delete(S),this._onDidChangeStorage.fire(S),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=f.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const S={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(S).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(S){if(!!this.hasPending)return this.doFlush(S)}async doFlush(S){return this.flushDelayer.trigger(()=>this.flushPending(),S)}async whenFlushed(){if(!!this.hasPending)return new Promise(S=>this.whenFlushedCallbacks.push(S))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=v,v.DEFAULT_FLUSH_DELAY=100;class E{constructor(){this.onDidChangeItemsExternal=t.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(S){S.insert?.forEach((w,u)=>this.items.set(u,w)),S.delete?.forEach(w=>this.items.delete(w))}async close(){}}e.InMemoryStorageDatabase=E}),define(J[140],Z([0,1,8,3,33,9,23]),function(z,e,b,t,R,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class y{constructor(E,P=Object.create(null)){this.path=E,this.options=P,this.name=(0,L.basename)(this.path),this.logger=new f(this.options.logging),this.whenConnected=this.connect(this.path)}get onDidChangeItemsExternal(){return t.Event.None}async getItems(){const E=await this.whenConnected,P=new Map;return(await this.all(E,"SELECT * FROM ItemTable")).forEach(w=>P.set(w.key,w.value)),this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] getItems(): ${P.size} rows`),P}async updateItems(E){const P=await this.whenConnected;return this.doUpdateItems(P,E)}doUpdateItems(E,P){return this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] updateItems(): insert(${P.insert?(0,R.mapToString)(P.insert):"0"}), delete(${P.delete?(0,R.setToString)(P.delete):"0"})`),this.transaction(E,()=>{const S=P.insert,w=P.delete;if(S&&S.size>0){const u=[];u.push([]);let m=0;S.forEach((g,I)=>{let p=u[m];p.length>y.MAX_HOST_PARAMETERS&&(m++,p=[],u.push(p)),p.push(I,g)}),u.forEach(g=>{this.prepare(E,`INSERT INTO ItemTable VALUES ${new Array(g.length/2).fill("(?,?)").join(",")}`,I=>I.run(g),()=>{const I=[];let p=0;return S.forEach((d,h)=>{I.push(h),p+=d.length}),`Keys: ${I.join(", ")} Length: ${p}`})})}if(w&&w.size){const u=[];u.push([]);let m=0;w.forEach(g=>{let I=u[m];I.length>y.MAX_HOST_PARAMETERS&&(m++,I=[],u.push(I)),I.push(g)}),u.forEach(g=>{this.prepare(E,`DELETE FROM ItemTable WHERE key IN (${new Array(g.length).fill("?").join(",")})`,I=>I.run(g),()=>{const I=[];return w.forEach(p=>{I.push(p)}),`Keys: ${I.join(", ")}`})})}})}async close(E){this.logger.trace(`[storage ${this.name}] close()`);const P=await this.whenConnected;return this.doClose(P,E)}doClose(E,P){return new Promise((S,w)=>{E.db.close(u=>(u&&this.handleSQLiteError(E,`[storage ${this.name}] close(): ${u}`),this.path===y.IN_MEMORY_PATH?S():!E.isErroneous&&!E.isInMemory?this.backup().then(S,m=>(this.logger.error(`[storage ${this.name}] backup(): ${m}`),S())):typeof P=="function"?D.Promises.unlink(this.path).then(()=>this.doConnect(this.path).then(m=>{const g=()=>this.doClose(m,void 0);return this.doUpdateItems(m,{insert:P()}).then(()=>g(),I=>(g(),Promise.reject(I)))})).then(S,w):w(u||new Error("Database has errors or is in-memory without recovery option"))))})}backup(){const E=this.toBackupPath(this.path);return D.Promises.copy(this.path,E,{preserveSymlinks:!1})}toBackupPath(E){return`${E}.backup`}async checkIntegrity(E){this.logger.trace(`[storage ${this.name}] checkIntegrity(full: ${E})`);const P=await this.whenConnected,S=await this.get(P,E?"PRAGMA integrity_check":"PRAGMA quick_check"),w=E?S.integrity_check:S.quick_check;return P.isErroneous?`${w} (last error: ${P.lastError})`:P.isInMemory?`${w} (in-memory!)`:w}async connect(E,P=!0){this.logger.trace(`[storage ${this.name}] open(${E}, retryOnBusy: ${P})`);try{return await this.doConnect(E)}catch(S){if(this.logger.error(`[storage ${this.name}] open(): Unable to open DB due to ${S}`),S.code==="SQLITE_BUSY"&&P)return await(0,b.timeout)(y.BUSY_OPEN_TIMEOUT),this.connect(E,!1);try{await D.Promises.unlink(E);try{await D.Promises.rename(this.toBackupPath(E),E)}catch{}return await this.doConnect(E)}catch(w){return this.logger.error(`[storage ${this.name}] open(): Unable to use backup due to ${w}`),this.doConnect(y.IN_MEMORY_PATH)}}}handleSQLiteError(E,P){E.isErroneous=!0,E.lastError=P,this.logger.error(P)}doConnect(E){return new Promise((P,S)=>{new Promise((w,u)=>{z(["@vscode/sqlite3"],w,u)}).then(w=>{const u={db:new(this.logger.isTracing?w.verbose().Database:w.Database)(E,m=>m?u.db&&m.code!=="SQLITE_CANTOPEN"?u.db.close(()=>S(m)):S(m):this.exec(u,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>P(u),g=>u.db.close(()=>S(g)))),isInMemory:E===y.IN_MEMORY_PATH};u.db.on("error",m=>this.handleSQLiteError(u,`[storage ${this.name}] Error (event): ${m}`)),this.logger.isTracing&&u.db.on("trace",m=>this.logger.trace(`[storage ${this.name}] Trace (event): ${m}`))},S)})}exec(E,P){return new Promise((S,w)=>{E.db.exec(P,u=>u?(this.handleSQLiteError(E,`[storage ${this.name}] exec(): ${u}`),w(u)):S())})}get(E,P){return new Promise((S,w)=>{E.db.get(P,(u,m)=>u?(this.handleSQLiteError(E,`[storage ${this.name}] get(): ${u}`),w(u)):S(m))})}all(E,P){return new Promise((S,w)=>{E.db.all(P,(u,m)=>u?(this.handleSQLiteError(E,`[storage ${this.name}] all(): ${u}`),w(u)):S(m))})}transaction(E,P){return new Promise((S,w)=>{E.db.serialize(()=>{E.db.run("BEGIN TRANSACTION"),P(),E.db.run("END TRANSACTION",u=>u?(this.handleSQLiteError(E,`[storage ${this.name}] transaction(): ${u}`),w(u)):S())})})}prepare(E,P,S,w){const u=E.db.prepare(P),m=g=>{this.handleSQLiteError(E,`[storage ${this.name}] prepare(): ${g} (${P}). Details: ${w()}`)};u.on("error",m),S(u),u.finalize(g=>{g&&m(g),u.removeListener("error",m)})}}e.SQLiteStorageDatabase=y,y.IN_MEMORY_PATH=":memory:",y.BUSY_OPEN_TIMEOUT=2e3,y.MAX_HOST_PARAMETERS=256;class f{constructor(E){E&&typeof E.logTrace=="function"&&process.env[f.VSCODE_TRACE_STORAGE]&&(this.logTrace=E.logTrace),E&&typeof E.logError=="function"&&(this.logError=E.logError)}get isTracing(){return!!this.logTrace}trace(E){this.logTrace?.(E)}error(E){this.logError?.(E)}}f.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}),define(J[141],Z([13,10]),function(z,e){return z.create("vs/base/node/processes",e)}),define(J[81],Z([0,1,42,29,11,50,9,4,36,77,12,123,23,141]),function(z,e,b,t,R,L,D,y,f,v,E,P,S,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return v.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return v.TerminateResponseCode}});function u(l){switch(l){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function m(l,n){if(y.isWindows)try{const r={stdio:["pipe","pipe","ignore"]};n&&(r.cwd=n);const i=b.execFile("taskkill",["/T","/F","/PID",l.pid.toString()],r);return new Promise(s=>{i.once("error",o=>{s({success:!1,error:o})}),i.once("exit",(o,a)=>{s(o===0?{success:!0}:{success:!1,code:o!==null?o:1})})})}catch(r){return Promise.resolve({success:!1,error:r,code:r.status?u(r.status):1})}else if(y.isLinux||y.isMacintosh)try{const r=R.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",z).fsPath;return new Promise(i=>{b.execFile(r,[l.pid.toString()],{encoding:"utf8",shell:!0},(s,o,a)=>{i(s?{success:!1,error:s}:{success:!0})})})}catch(r){return Promise.resolve({success:!1,error:r})}else l.kill("SIGKILL");return Promise.resolve({success:!0})}function g(l=f.env){return l.comspec||"cmd.exe"}e.getWindowsShell=g;class I{constructor(n,r,i,s){if(r!==void 0&&i!==void 0&&s!==void 0)this.cmd=n,this.args=r,this.shell=i,this.options=s;else{const o=n;this.cmd=o.command,this.shell=o.isShellCommand,this.args=o.args.slice(0),this.options=o.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const o=Object.create(null);Object.keys(f.env).forEach(a=>{o[a]=f.env[a]}),Object.keys(this.options.env).forEach(a=>{o[a]=this.options.env[a]}),this.options.env=o}}getSanitizedCommand(){let n=this.cmd.toLowerCase();const r=n.lastIndexOf(D.sep);return r!==-1&&(n=n.substring(r+1)),I.WellKnowCommands[n]?n:"other"}start(n){return y.isWindows&&(this.options&&this.options.cwd&&t.isUNC(this.options.cwd)||!this.options&&t.isUNC(f.cwd()))?Promise.reject(new Error(w.localize(0,null))):this.useExec().then(r=>{let i,s;const o=new Promise((a,c)=>{i=a,s=c});if(r){let a=this.cmd;this.args&&(a=a+" "+this.args.join(" ")),this.childProcess=b.exec(a,this.options,(c,C,k)=>{this.childProcess=null;const M=c;M&&M.killed?s({killed:this.terminateRequested,stdout:C.toString(),stderr:k.toString()}):this.handleExec(i,n,c,C,k)})}else{let a=null;const c=C=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(C,i,n,s);const k={terminated:this.terminateRequested};E.isNumber(C)&&(k.cmdCode=C),i(k)};if(this.shell&&y.isWindows){const C=L.deepClone(this.options);C.windowsVerbatimArguments=!0,C.detached=!1;let k=!1,M=!1;const T=[];let F=this.ensureQuotes(this.cmd);T.push(F.value),k=F.quoted,this.args&&this.args.forEach(te=>{F=this.ensureQuotes(te),T.push(F.value),M=M&&F.quoted});const q=["/s","/c"];k?M?q.push('"'+T.join(" ")+'"'):T.length>1?q.push('"'+T[0]+'" '+T.slice(1).join(" ")):q.push('"'+T[0]+'"'):q.push(T.join(" ")),a=b.spawn(g(),q,C)}else this.cmd&&(a=b.spawn(this.cmd,this.args,this.options));a&&(this.childProcess=a,this.childProcessPromise=Promise.resolve(a),this.pidResolve&&(this.pidResolve(E.isNumber(a.pid)?a.pid:-1),this.pidResolve=void 0),a.on("error",C=>{this.childProcess=null,s({terminated:this.terminateRequested,error:C})}),a.pid&&(this.childProcess.on("close",c),this.handleSpawn(a,i,n,s,!0)))}return o})}handleClose(n,r,i,s){}ensureQuotes(n){return I.regexp.test(n)?{value:'"'+n+'"',quoted:!0}:{value:n,quoted:n.length>0&&n[0]==='"'&&n[n.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(n=>n.pid,n=>-1):new Promise(n=>{this.pidResolve=n})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(n=>(this.terminateRequested=!0,m(n,this.options.cwd).then(r=>(r.success&&(this.childProcess=null),r))),n=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(n=>{if(!this.shell||!y.isWindows)return n(!1);const r=b.spawn(g(),["/s","/c"]);r.on("error",i=>n(!0)),r.on("exit",i=>n(!1))})}}e.AbstractProcess=I,I.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},I.regexp=/^[^"].* .*[^"]/;class p extends I{constructor(n,r,i,s){super(n,r,i,s);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(n,r,i,s,o){[s,o].forEach((a,c)=>{const C=new P.LineDecoder;C.write(a).forEach(T=>{r({line:T,source:c===0?0:1})});const M=C.end();M&&r({line:M,source:c===0?0:1})}),n({terminated:this.terminateRequested,error:i})}handleSpawn(n,r,i,s,o){const a=new P.LineDecoder,c=new P.LineDecoder;n.stdout.on("data",C=>{a.write(C).forEach(M=>i({line:M,source:0}))}),n.stderr.on("data",C=>{c.write(C).forEach(M=>i({line:M,source:1}))}),this.stdoutLineDecoder=a,this.stderrLineDecoder=c}handleClose(n,r,i,s){const o=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;o&&i({line:o,source:0});const a=this.stderrLineDecoder?this.stderrLineDecoder.end():null;a&&i({line:a,source:1})}}e.LineProcess=p;function d(l){let n=[],r=!1;const i=function(s){if(r){n.push(s);return}(!l.send(s,a=>{if(a&&console.error(a),r=!1,n.length>0){const c=n.slice(0);n=[],c.forEach(C=>i(C))}})||y.isWindows)&&(r=!0)};return{send:i}}e.createQueuedSender=d;var h;(function(l){async function n(r,i,s){if(D.isAbsolute(r))return r;if(i===void 0&&(i=f.cwd()),D.dirname(r)!=="."||(s===void 0&&E.isString(f.env.PATH)&&(s=f.env.PATH.split(D.delimiter)),s===void 0||s.length===0))return D.join(i,r);async function a(c){if(await S.Promises.exists(c)){let C;try{C=await S.Promises.stat(c)}catch(k){k.message.startsWith("EACCES")&&(C=await S.Promises.lstat(c))}return C?!C.isDirectory():!1}return!1}for(const c of s){let C;if(D.isAbsolute(c)?C=D.join(c,r):C=D.join(i,c,r),await a(C))return C;let k=C+".com";if(await a(k)||(k=C+".exe",await a(k)))return k}return D.join(i,r)}l.findExecutable=n})(h=e.win32||(e.win32={}))}),define(J[142],Z([0,1,27,4,137,81]),function(z,e,b,t,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function D(w,u){return w===1?t.isWindows?P():L.getWindowsShell(u):v(w,u)}e.getSystemShell=D;function y(w,u){return w===1?t.isWindows?S(u):L.getWindowsShell(u):v(w,u)}e.getSystemShellSync=y;let f=null;function v(w,u){if(t.isLinux&&w===2||t.isMacintosh&&w===3)return"/bin/bash";if(!f){let m;if(t.isWindows)m="/bin/bash";else{if(m=u.SHELL,!m)try{m=(0,b.userInfo)().shell}catch{}m||(m="sh"),m==="/bin/false"&&(m="/bin/bash")}f=m}return f}let E=null;async function P(){return E||(E=(await(0,R.getFirstAvailablePowerShellInstallation)()).exePath),E}function S(w){if(E)return E;const u=t.isWindows&&parseFloat((0,b.release)())>=10,m=w.hasOwnProperty("PROCESSOR_ARCHITEW6432"),g=`${w.windir}\\${m?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return u?g:L.getWindowsShell(w)}}),define(J[143],Z([0,1,42,8,19,22,134,18,3,2,50,81,77,43]),function(z,e,b,t,R,L,D,y,f,v,E,P,S,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class u extends w.ChannelServer{constructor(I){super({send:p=>{try{process.send?.(p.buffer.toString("base64"))}catch{}},onMessage:f.Event.fromNodeEventEmitter(process,"message",p=>R.VSBuffer.wrap(Buffer.from(p,"base64")))},I);process.once("disconnect",()=>this.dispose())}}e.Server=u;class m{constructor(I,p){this.modulePath=I,this.options=p,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new f.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const d=p&&p.timeout?p.timeout:6e4;this.disposeDelayer=new t.Delayer(d),this.child=null,this._client=null}getChannel(I){const p=this;return{call(d,h,l){return p.requestPromise(I,d,h,l)},listen(d,h){return p.requestEvent(I,d,h)}}}requestPromise(I,p,d,h=L.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(h.isCancellationRequested)return Promise.reject(y.canceled());this.disposeDelayer.cancel();const l=this.getCachedChannel(I),n=(0,t.createCancelablePromise)(s=>l.call(p,d,s)),r=h.onCancellationRequested(()=>n.cancel()),i=(0,v.toDisposable)(()=>n.cancel());return this.activeRequests.add(i),n.finally(()=>{r.dispose(),this.activeRequests.delete(i),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),n}requestEvent(I,p,d){if(!this.disposeDelayer)return f.Event.None;this.disposeDelayer.cancel();let h;const l=new f.Emitter({onFirstListenerAdd:()=>{h=this.getCachedChannel(I).listen(p,d)(l.fire,l),this.activeRequests.add(h)},onLastListenerRemove:()=>{this.activeRequests.delete(h),h.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return l.event}get client(){if(!this._client){const I=this.options&&this.options.args?this.options.args:[],p=Object.create(null);p.env={...(0,E.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(p.env={...p.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(p.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(p.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(p.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),p.execArgv===void 0&&(p.execArgv=process.execArgv.filter(o=>!/^--inspect(-brk)?=/.test(o))),(0,S.removeDangerousEnvVariables)(p.env),this.child=(0,b.fork)(this.modulePath,I,p);const d=new f.Emitter;f.Event.fromNodeEventEmitter(this.child,"message",o=>o)(o=>{if((0,D.isRemoteConsoleLog)(o)){(0,D.log)(o,`IPC Library: ${this.options.serverName}`);return}d.fire(R.VSBuffer.wrap(Buffer.from(o,"base64")))});const l=this.options.useQueue?(0,P.createQueuedSender)(this.child):this.child,n=o=>this.child&&this.child.connected&&l.send(o.buffer.toString("base64")),r=d.event,i={send:n,onMessage:r};this._client=new w.ChannelClient(i);const s=()=>this.disposeClient();process.once("exit",s),this.child.on("error",o=>console.warn('IPC "'+this.options.serverName+'" errored with '+o)),this.child.on("exit",(o,a)=>{process.removeListener("exit",s),this.activeRequests.forEach(c=>(0,v.dispose)(c)),this.activeRequests.clear(),o!==0&&a!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+o+" and signal "+a),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:o,signal:a})})}return this._client}getCachedChannel(I){let p=this.channels.get(I);return p||(p=this.client.getChannel(I),this.channels.set(I,p)),p}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=m}),define(J[144],Z([13,10]),function(z,e){return z.create("vs/code/electron-main/app",e)}),define(J[145],Z([13,10]),function(z,e){return z.create("vs/platform/configuration/common/configurationRegistry",e)}),define(J[146],Z([13,10]),function(z,e){return z.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(J[147],Z([13,10]),function(z,e){return z.create("vs/platform/environment/node/argv",e)}),define(J[148],Z([13,10]),function(z,e){return z.create("vs/platform/environment/node/argvHelper",e)}),define(J[149],Z([13,10]),function(z,e){return z.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(J[150],Z([13,10]),function(z,e){return z.create("vs/platform/files/common/fileService",e)}),define(J[151],Z([13,10]),function(z,e){return z.create("vs/platform/files/common/files",e)}),define(J[152],Z([13,10]),function(z,e){return z.create("vs/platform/files/common/io",e)}),define(J[153],Z([13,10]),function(z,e){return z.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(J[154],Z([13,10]),function(z,e){return z.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(J[155],Z([13,10]),function(z,e){return z.create("vs/platform/issue/electron-main/issueMainService",e)}),define(J[156],Z([13,10]),function(z,e){return z.create("vs/platform/menubar/electron-main/menubar",e)}),define(J[157],Z([13,10]),function(z,e){return z.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(J[158],Z([13,10]),function(z,e){return z.create("vs/platform/request/common/request",e)}),define(J[159],Z([13,10]),function(z,e){return z.create("vs/platform/shell/node/shellEnv",e)}),define(J[160],Z([13,10]),function(z,e){return z.create("vs/platform/telemetry/common/telemetryService",e)}),define(J[161],Z([13,10]),function(z,e){return z.create("vs/platform/update/common/update.config.contribution",e)}),define(J[162],Z([13,10]),function(z,e){return z.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(J[163],Z([13,10]),function(z,e){return z.create("vs/platform/windows/electron-main/window",e)}),define(J[164],Z([13,10]),function(z,e){return z.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(J[165],Z([13,10]),function(z,e){return z.create("vs/platform/workspace/common/workspace",e)}),define(J[166],Z([13,10]),function(z,e){return z.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(J[167],Z([13,10]),function(z,e){return z.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(J[168],Z([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isWorkspaceBackupInfo=e.isFolderBackupInfo=void 0;function b(R){return R&&R.hasOwnProperty("folderUri")}e.isFolderBackupInfo=b;function t(R){return R&&R.hasOwnProperty("workspace")}e.isWorkspaceBackupInfo=t}),define(J[169],Z([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEmptyWindowBackupInfo=void 0;function b(t){return typeof t?.backupFolder=="string"}e.isEmptyWindowBackupInfo=b}),define(J[170],Z([0,1,3,2]),function(z,e,b,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class R{constructor(){this._onCloseEmitter=new b.Emitter,this._onReloadEmitter=new b.Emitter,this._onTerminateEmitter=new b.Emitter,this._onAttachEmitter=new b.Emitter}call(y,f,v){switch(f){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:v[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:v[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:v[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:v[0],port:v[1],subId:v[2]}))}throw new Error("Method not implemented.")}listen(y,f,v){switch(f){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=R,R.ChannelName="extensionhostdebugservice";class L extends t.Disposable{constructor(y){super();this.channel=y}reload(y){this.channel.call("reload",[y])}get onReload(){return this.channel.listen("reload")}close(y){this.channel.call("close",[y])}get onClose(){return this.channel.listen("close")}attachSession(y,f,v){this.channel.call("attach",[y,f,v])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(y,f){this.channel.call("terminate",[y,f])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(y,f){return this.channel.call("openExtensionDevelopmentHostWindow",[y,f])}}e.ExtensionHostDebugChannelClient=L}),define(J[171],Z([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=void 0;class b{constructor(R){this.machineId=R}encryption(){return new Promise((R,L)=>z(["vscode-encrypt"],R,L))}async encrypt(R){try{return(await this.encryption()).encrypt(this.machineId,R)}catch{return R}}async decrypt(R){try{return(await this.encryption()).decrypt(this.machineId,R)}catch{return R}}}e.EncryptionMainService=b}),define(J[172],Z([0,1,130,51,11,9,36,16,7]),function(z,e,b,t,R,L,D,y,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class v{constructor(m,g,I){this._args=m,this.paths=g,this.productService=I,this.editSessionId=this.args.editSessionId}get appRoot(){return(0,L.dirname)(R.FileAccess.asFileUri("",z).fsPath)}get userHome(){return f.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return f.URI.file((0,L.join)(this.userDataPath,"User"))}get tmpDir(){return f.URI.file(this.paths.tmpDir)}get cacheHome(){return f.URI.file(this.userDataPath)}get stateResource(){return(0,y.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,y.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const m=(0,b.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,L.join)(this.userDataPath,"logs",m)}return this.args.logsPath}get userDataSyncLogResource(){return f.URI.file((0,L.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,y.joinPath)(f.URI.file((0,L.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,y.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,y.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,y.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const m=D.env.VSCODE_PORTABLE;return m?f.URI.file((0,L.join)(m,"argv.json")):(0,y.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return f.URI.file((0,L.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,L.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const m=this.args["builtin-extensions-dir"];return m?(0,L.resolve)(m):(0,L.normalize)((0,L.join)(R.FileAccess.asFileUri("",z).fsPath,"..","extensions"))}get extensionsDownloadPath(){const m=this.args["extensions-download-dir"];return m?(0,L.resolve)(m):(0,L.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const m=this.args["extensions-dir"];if(m)return(0,L.resolve)(m);const g=D.env.VSCODE_EXTENSIONS;if(g)return g;const I=D.env.VSCODE_PORTABLE;return I?(0,L.join)(I,"extensions"):(0,y.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const m=this.args.extensionDevelopmentPath;if(Array.isArray(m))return m.map(g=>/^[^:/?#]+?:\/\//.test(g)?f.URI.parse(g):f.URI.file((0,L.normalize)(g)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(m=>m==="ui"||m==="workspace"||m==="web"?m:"workspace")}get extensionTestsLocationURI(){const m=this.args.extensionTestsPath;if(m)return/^[^:/?#]+?:\/\//.test(m)?f.URI.parse(m):f.URI.file((0,L.normalize)(m))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const m=this.args["disable-extension"];if(m){if(typeof m=="string")return[m];if(Array.isArray(m)&&m.length>0)return m}return!1}get debugExtensionHost(){return E(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!D.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,y.joinPath)(f.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return f.URI.file((0,L.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const m=D.env.VSCODE_PORTABLE;return m?f.URI.file((0,L.join)(m,"policy.json")):(0,y.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get args(){return this._args}}de([t.memoize],v.prototype,"appRoot",null),de([t.memoize],v.prototype,"userHome",null),de([t.memoize],v.prototype,"userDataPath",null),de([t.memoize],v.prototype,"appSettingsHome",null),de([t.memoize],v.prototype,"tmpDir",null),de([t.memoize],v.prototype,"cacheHome",null),de([t.memoize],v.prototype,"stateResource",null),de([t.memoize],v.prototype,"userRoamingDataHome",null),de([t.memoize],v.prototype,"userDataSyncHome",null),de([t.memoize],v.prototype,"userDataSyncLogResource",null),de([t.memoize],v.prototype,"sync",null),de([t.memoize],v.prototype,"machineSettingsResource",null),de([t.memoize],v.prototype,"workspaceStorageHome",null),de([t.memoize],v.prototype,"localHistoryHome",null),de([t.memoize],v.prototype,"keyboardLayoutResource",null),de([t.memoize],v.prototype,"argvResource",null),de([t.memoize],v.prototype,"isExtensionDevelopment",null),de([t.memoize],v.prototype,"untitledWorkspacesHome",null),de([t.memoize],v.prototype,"installSourcePath",null),de([t.memoize],v.prototype,"builtinExtensionsPath",null),de([t.memoize],v.prototype,"extensionsPath",null),de([t.memoize],v.prototype,"extensionDevelopmentLocationURI",null),de([t.memoize],v.prototype,"extensionDevelopmentKind",null),de([t.memoize],v.prototype,"extensionTestsLocationURI",null),de([t.memoize],v.prototype,"debugExtensionHost",null),de([t.memoize],v.prototype,"serviceMachineIdResource",null),de([t.memoize],v.prototype,"telemetryLogResource",null),de([t.memoize],v.prototype,"disableWorkspaceTrust",null),de([t.memoize],v.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=v;function E(u,m){return w(u["inspect-extensions"],u["inspect-brk-extensions"],5870,m,u.debugId,u.extensionEnvironment)}e.parseExtensionHostPort=E;function P(u,m){return w(u["inspect-search"],u["inspect-brk-search"],5876,m,u.extensionEnvironment)}e.parseSearchPort=P;function S(u,m){return w(u["inspect-ptyhost"],u["inspect-brk-ptyhost"],5877,m,u.extensionEnvironment)}e.parsePtyHostPort=S;function w(u,m,g,I,p,d){const l=Number(m||u)||(I?null:g),n=l?Boolean(!!m):!1;let r;if(d)try{r=JSON.parse(d)}catch{}return{port:l,break:n,debugId:p,env:r}}}),define(J[98],Z([0,1,257,4,147]),function(z,e,b,t,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const L={o:(0,R.localize)(0,null),e:(0,R.localize)(1,null),t:(0,R.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,R.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,R.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,R.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,R.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,R.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,R.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,R.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,R.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,R.localize)(11,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,R.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,R.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,R.localize)(14,null)},category:{type:"string",cat:"e",description:(0,R.localize)(15,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,R.localize)(16,null)},"pre-release":{type:"boolean",cat:"e",description:(0,R.localize)(17,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,R.localize)(18,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,R.localize)(19,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,R.localize)(20,null)},verbose:{type:"boolean",cat:"t",description:(0,R.localize)(21,null)},log:{type:"string",cat:"t",args:"level",description:(0,R.localize)(22,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,R.localize)(23,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,R.localize)(24,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,R.localize)(25,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,R.localize)(26,null)},sync:{type:"string",cat:"t",description:(0,R.localize)(27,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,R.localize)(28,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,R.localize)(29,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,R.localize)(30,null)},"ms-enable-electron-run-as-node":{type:"boolean"},"max-memory":{type:"string",cat:"t",description:(0,R.localize)(31,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,R.localize)(32,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},_:{type:"string[]"}};const D={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function y(u,m,g=D){const I={},p=["_"],d=[];for(const r in m){const i=m[r];i.alias&&(I[r]=i.alias),i.type==="string"||i.type==="string[]"?(p.push(r),i.deprecates&&p.push(...i.deprecates)):i.type==="boolean"&&(d.push(r),i.deprecates&&d.push(...i.deprecates))}const h=b(u,{string:p,boolean:d,alias:I}),l={},n=h;l._=h._.map(r=>String(r)).filter(r=>r.length>0),delete n._;for(const r in m){const i=m[r];i.alias&&delete n[i.alias];let s=n[r];if(i.deprecates)for(const o of i.deprecates)n.hasOwnProperty(o)&&(s||(s=n[o],s&&g.onDeprecatedOption(o,i.deprecationMessage||(0,R.localize)(33,null,r))),delete n[o]);if(typeof s!="undefined"){if(i.type==="string[]"){if(Array.isArray(s)||(s=[s]),!i.allowEmptyValue){const o=s.filter(a=>a.length>0);o.length!==s.length&&(g.onEmptyValue(r),s=o.length>0?o:void 0)}}else i.type==="string"&&(Array.isArray(s)?(s=s.pop(),g.onMultipleValues(r,s)):!s&&!i.allowEmptyValue&&(g.onEmptyValue(r),s=void 0));l[r]=s,i.deprecationMessage&&g.onDeprecatedOption(r,i.deprecationMessage)}delete n[r]}for(const r in n)g.onUnknownOption(r);return l}e.parseArgs=y;function f(u,m){let g="";return m.args&&(Array.isArray(m.args)?g=` <${m.args.join("> <")}>`:g=` <${m.args}>`),m.alias?`-${m.alias} --${u}${g}`:`--${u}${g}`}function v(u,m){let g=0;const I=[];for(const l in u){const n=u[l],r=f(l,n);g=Math.max(g,r.length),I.push([r,n.description])}const p=g+2+1;if(m-p<25)return I.reduce((l,n)=>l.concat([`  ${n[0]}`,`      ${n[1]}`]),[]);const d=m-p-1,h=[];for(const l of I){const n=l[0],r=P(l[1],d),i=E(p-n.length-2);h.push("  "+n+i+r[0]);for(let s=1;s<r.length;s++)h.push(E(p)+r[s])}return h}e.formatOptions=v;function E(u){return" ".repeat(u)}function P(u,m){const g=[];for(;u.length;){const I=u.length<m?u.length:u.lastIndexOf(" ",m),p=u.slice(0,I).trim();u=u.slice(I),g.push(p)}return g}function S(u,m,g,I,p){const d=process.stdout.isTTY&&process.stdout.columns||80,h=p?.noInputFiles!==!0?`[${(0,R.localize)(34,null)}...]`:"",l=[`${u} ${g}`];l.push(""),l.push(`${(0,R.localize)(35,null)}: ${m} [${(0,R.localize)(36,null)}]${h}`),l.push(""),p?.noPipe!==!0&&(t.isWindows?l.push((0,R.localize)(37,null,m)):l.push((0,R.localize)(38,null,m)),l.push(""));const n={};for(const r in I){const i=I[r];if(i.description&&i.cat){let s=n[i.cat];s||(n[i.cat]=s={}),s[r]=i}}for(const r in n){const i=r,s=n[i];s&&(l.push(L[i]),l.push(...v(s,d)),l.push(""))}return l.join(`
`)}e.buildHelpMessage=S;function w(u,m){return`${u||(0,R.localize)(39,null)}
${m||(0,R.localize)(40,null)}
${process.arch}`}e.buildVersionMessage=w}),define(J[173],Z([0,1,64,170,98]),function(z,e,b,t,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class L extends t.ExtensionHostDebugBroadcastChannel{constructor(y){super();this.windowsMainService=y}call(y,f,v){return f==="openExtensionDevelopmentHostWindow"?this.openExtensionDevelopmentHostWindow(v[0],v[1]):super.call(y,f,v)}async openExtensionDevelopmentHostWindow(y,f){const v=(0,R.parseArgs)(y,R.OPTIONS);v.debugRenderer=f;const E=v.extensionDevelopmentPath;if(!E)return{success:!1};const[P]=this.windowsMainService.openExtensionDevelopmentHostWindow(E,{context:5,cli:v});if(!f)return{success:!0};const S=P.win;if(!S)return{success:!0};const w=S.webContents.debugger;let u=w.isAttached()?1/0:0;const m=(0,b.createServer)(g=>{u++==0&&w.attach();let I=!1;const p=l=>{I||g.write(JSON.stringify(l)+"\0")},d=(l,n,r,i)=>p({method:n,params:r,sessionId:i});S.on("close",()=>{w.removeListener("message",d),g.end(),I=!0}),w.addListener("message",d);let h=Buffer.alloc(0);g.on("data",l=>{h=Buffer.concat([h,l]);for(let n=h.indexOf(0);n!==-1;n=h.indexOf(0)){let r;try{const i=h.slice(0,n).toString("utf8");h=h.slice(n+1),r=JSON.parse(i)}catch(i){console.error("error reading cdp line",i)}w.sendCommand(r.method,r.params,r.sessionId).then(i=>p({id:r.id,sessionId:r.sessionId,result:i})).catch(i=>p({id:r.id,sessionId:r.sessionId,error:{code:0,message:i.message}}))}}),g.on("error",l=>{console.error("error on cdp pipe:",l)}),g.on("close",()=>{I=!0,--u==0&&w.detach()})});return await new Promise(g=>m.listen(0,g)),S.on("close",()=>m.close()),{rendererDebugPort:m.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=L}),define(J[55],Z([0,1,258,148,98]),function(z,e,b,t,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const L=2048;function D(S,w){const u={onUnknownOption:g=>{console.warn((0,t.localize)(0,null,g))},onMultipleValues:(g,I)=>{console.warn((0,t.localize)(1,null,g,I))},onEmptyValue:g=>{console.warn((0,t.localize)(2,null,g))},onDeprecatedOption:(g,I)=>{console.warn((0,t.localize)(3,null,g,I))}},m=(0,R.parseArgs)(S,R.OPTIONS,w?u:void 0);return m.goto&&m._.forEach(g=>b(/^(\w:)?[^:]+(:\d*){0,2}$/.test(g),(0,t.localize)(4,null))),m["max-memory"]&&b(parseInt(m["max-memory"])>=L,`The max-memory argument cannot be specified lower than ${L} MB.`),m}function y(S){const w=S.findIndex(u=>!/^-/.test(u));if(w>-1)return[...S.slice(0,w),...S.slice(w+1)]}function f(S){let[,...w]=S;process.env.VSCODE_DEV&&(w=y(w)||[]);const u=!P(process.env);return D(w,u)}e.parseMainProcessArgv=f;function v(S){const[,,...w]=S;return D(w,!0)}e.parseCLIProcessArgv=v;function E(S,...w){const u=S.indexOf("--");return u===-1?S.push(...w):S.splice(u,0,...w),S}e.addArg=E;function P(S){return S.VSCODE_CLI==="1"}e.isLaunchedFromCli=P}),function(){"use strict";function z(e,b,t,R){function L(y){const f=D(y),v=[f];return e.isAbsolute(f)||v.unshift(R),e.resolve(...v)}function D(y){const f=process.env.VSCODE_PORTABLE;if(f)return e.join(f,"user-data");let v=process.env.VSCODE_APPDATA;if(v)return e.join(v,t);const E=y["user-data-dir"];if(E)return E;switch(process.platform){case"win32":if(v=process.env.APPDATA,!v){const P=process.env.USERPROFILE;if(typeof P!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");v=e.join(P,"AppData","Roaming")}break;case"darwin":v=e.join(b.homedir(),"Library","Application Support");break;case"linux":v=process.env.XDG_CONFIG_HOME||e.join(b.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(v,t)}return{getUserDataPath:L}}if(typeof define=="function")define(J[174],Z([0,259,27,11,16,36]),function(e,b,t,R,L,D){const y=L.dirname(R.FileAccess.asFileUri("",e)),f=e.__$__nodeRequire(L.joinPath(y,"package.json").fsPath);return z(b,t,f.name,D.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),b=require("path"),t=require("os");module.exports=z(b,t,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(J[175],Z([0,1,27,172,174]),function(z,e,b,t,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class L extends t.AbstractNativeEnvironmentService{constructor(y,f){super(y,{homeDir:(0,b.homedir)(),tmpDir:(0,b.tmpdir)(),userDataDir:(0,R.getUserDataPath)(y)},f)}}e.NativeEnvironmentService=L}),define(J[176],Z([0,1,28,27,29]),function(z,e,b,t,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFile=void 0;function L(D){const y=(0,R.randomPath)((0,t.tmpdir)());try{return(0,b.writeFileSync)(y,""),D&&console.log(`Marker file for --wait created: ${y}`),y}catch(f){D&&console.error(`Failed to create marker file for --wait: ${f}`);return}}e.createWaitMarkerFile=L}),define(J[177],Z([0,1,19,30]),function(z,e,b,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function R(L,D,y){let f=y&&y.get("storage.serviceMachineId",-1)||null;if(f)return f;try{const E=(await D.readFile(L.serviceMachineIdResource)).value.toString();f=(0,t.isUUID)(E)?E:null}catch{f=null}if(!f){f=(0,t.generateUuid)();try{await D.writeFile(L.serviceMachineIdResource,b.VSBuffer.fromString(f))}catch{}}return y?.store("storage.serviceMachineId",f,-1,1),f}e.getServiceMachineId=R}),define(J[67],Z([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class b{constructor(R,L=[],D=!1){this.ctor=R,this.staticArguments=L,this.supportsDelayedInstantiation=D}}e.SyncDescriptor=b}),define(J[178],Z([0,1,67]),function(z,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const t=[];function R(D,y,f){y instanceof b.SyncDescriptor||(y=new b.SyncDescriptor(y,[],f)),t.push([D,y])}e.registerSingleton=R;function L(){return t}e.getSingletonServiceDescriptors=L}),define(J[179],Z([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class b{constructor(L){this.incoming=new Map,this.outgoing=new Map,this.data=L}}e.Node=b;class t{constructor(L){this._hashFn=L,this._nodes=new Map}roots(){const L=[];for(const D of this._nodes.values())D.outgoing.size===0&&L.push(D);return L}insertEdge(L,D){const y=this.lookupOrInsertNode(L),f=this.lookupOrInsertNode(D);y.outgoing.set(this._hashFn(D),f),f.incoming.set(this._hashFn(L),y)}removeNode(L){const D=this._hashFn(L);this._nodes.delete(D);for(const y of this._nodes.values())y.outgoing.delete(D),y.incoming.delete(D)}lookupOrInsertNode(L){const D=this._hashFn(L);let y=this._nodes.get(D);return y||(y=new b(L),this._nodes.set(D,y)),y}lookup(L){return this._nodes.get(this._hashFn(L))}isEmpty(){return this._nodes.size===0}toString(){const L=[];for(const[D,y]of this._nodes)L.push(`${D}, (incoming)[${[...y.incoming.keys()].join(", ")}], (outgoing)[${[...y.outgoing.keys()].join(",")}]`);return L.join(`
`)}findCycleSlow(){for(const[L,D]of this._nodes){const y=new Set([L]),f=this._findCycle(D,y);if(f)return f}}_findCycle(L,D){for(const[y,f]of L.outgoing){if(D.has(y))return[...D,y].join(" -> ");D.add(y);const v=this._findCycle(f,D);if(v)return v;D.delete(y)}}}e.Graph=t}),define(J[5],Z([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var b;(function(D){D.serviceIds=new Map,D.DI_TARGET="$di$target",D.DI_DEPENDENCIES="$di$dependencies";function y(f){return f[D.DI_DEPENDENCIES]||[]}D.getServiceDependencies=y})(b=e._util||(e._util={})),e.IInstantiationService=R("instantiationService");function t(D,y,f){y[b.DI_TARGET]===y?y[b.DI_DEPENDENCIES].push({id:D,index:f}):(y[b.DI_DEPENDENCIES]=[{id:D,index:f}],y[b.DI_TARGET]=y)}function R(D){if(b.serviceIds.has(D))return b.serviceIds.get(D);const y=function(f,v,E){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(y,f,E)};return y.toString=()=>D,b.serviceIds.set(D,y),y}e.createDecorator=R;function L(D){return D}e.refineServiceDecorator=L}),define(J[56],Z([0,1,5]),function(z,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBackupMainService=void 0,e.IBackupMainService=(0,b.createDecorator)("backupMainService")}),define(J[17],Z([0,1,12,7,5]),function(z,e,b,t,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,R.createDecorator)("configurationService");function L(I){return I&&typeof I=="object"&&(!I.overrideIdentifier||typeof I.overrideIdentifier=="string")&&(!I.resource||I.resource instanceof t.URI)}e.isConfigurationOverrides=L;function D(I){return I&&typeof I=="object"&&(!I.overrideIdentifiers||b.isArray(I.overrideIdentifiers))&&!I.overrideIdentifier&&(!I.resource||I.resource instanceof t.URI)}e.isConfigurationUpdateOverrides=D;var y;(function(I){I[I.USER=1]="USER",I[I.USER_LOCAL=2]="USER_LOCAL",I[I.USER_REMOTE=3]="USER_REMOTE",I[I.WORKSPACE=4]="WORKSPACE",I[I.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",I[I.DEFAULT=6]="DEFAULT",I[I.MEMORY=7]="MEMORY"})(y=e.ConfigurationTarget||(e.ConfigurationTarget={}));function f(I){switch(I){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=f;function v(I,p){const d=Object.create(null);for(const h in I)E(d,h,I[h],p);return d}e.toValuesTree=v;function E(I,p,d,h){const l=p.split("."),n=l.pop();let r=I;for(let i=0;i<l.length;i++){const s=l[i];let o=r[s];switch(typeof o){case"undefined":o=r[s]=Object.create(null);break;case"object":break;default:h(`Ignoring ${p} as ${l.slice(0,i+1).join(".")} is ${JSON.stringify(o)}`);return}r=o}if(typeof r=="object"&&r!==null)try{r[n]=d}catch{h(`Ignoring ${p} as ${l.join(".")} is ${JSON.stringify(r)}`)}else h(`Ignoring ${p} as ${l.join(".")} is ${JSON.stringify(r)}`)}e.addToValueTree=E;function P(I,p){const d=p.split(".");S(I,d)}e.removeFromValueTree=P;function S(I,p){const d=p.shift();if(p.length===0){delete I[d];return}if(Object.keys(I).indexOf(d)!==-1){const h=I[d];typeof h=="object"&&!Array.isArray(h)&&(S(h,p),Object.keys(h).length===0&&delete I[d])}}function w(I,p,d){function h(r,i){let s=r;for(const o of i){if(typeof s!="object"||s===null)return;s=s[o]}return s}const l=p.split("."),n=h(I,l);return typeof n=="undefined"?d:n}e.getConfigurationValue=w;function u(I,p,d){Object.keys(p).forEach(h=>{h!=="__proto__"&&(h in I?b.isObject(I[h])&&b.isObject(p[h])?u(I[h],p[h],d):d&&(I[h]=p[h]):I[h]=p[h])})}e.merge=u;function m(I,p,d){const h=I.inspect(p),l=I.inspect(d);return typeof h.userValue!="undefined"||typeof h.workspaceValue!="undefined"||typeof h.workspaceFolderValue!="undefined"?h.value:typeof l.userValue!="undefined"||typeof l.workspaceValue!="undefined"||typeof l.workspaceFolderValue!="undefined"?l.value:h.defaultValue}e.getMigratedSettingValue=m;function g(I){return I.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=g}),define(J[68],Z([0,1,5]),function(z,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryCredentialsProvider=e.ICredentialsMainService=e.ICredentialsService=void 0,e.ICredentialsService=(0,b.createDecorator)("credentialsService"),e.ICredentialsMainService=(0,b.createDecorator)("credentialsMainService");class t{constructor(){this.secretVault={}}async getPassword(L,D){return this.secretVault[L]?.[D]??null}async setPassword(L,D,y){this.secretVault[L]=this.secretVault[L]??{},this.secretVault[L][D]=y}async deletePassword(L,D){return this.secretVault[L]?.[D]?(delete this.secretVault[L][D],Object.keys(this.secretVault[L]).length===0&&delete this.secretVault[L],!0):!1}async findPassword(L){return JSON.stringify(this.secretVault[L])??null}async findCredentials(L){const D=[];for(const y of Object.keys(this.secretVault[L]||{}))D.push({account:y,password:this.secretVault[L][y]});return D}async clear(){this.secretVault={}}}e.InMemoryCredentialsProvider=t}),define(J[82],Z([0,1,5]),function(z,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,b.createDecorator)(e.ID);function t(L){return!!L.hostName&&!!L.errorMessage}e.isRemoteDiagnosticError=t;class R{async getPerformanceInfo(D,y){return{}}async getSystemInfo(D,y){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(D,y){return""}async getWorkspaceFileExtensions(D){return{extensions:[]}}async reportWorkspaceStats(D){}}e.NullDiagnosticsService=R}),define(J[99],Z([0,1,5]),function(z,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,b.createDecorator)("encryptionMainService")}),define(J[39],Z([0,1,5]),function(z,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,b.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,b.refineServiceDecorator)(e.IEnvironmentService)}),define(J[180],Z([0,1,5]),function(z,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionUrlTrustService=void 0,e.IExtensionUrlTrustService=(0,b.createDecorator)("extensionUrlTrustService")}),define(J[181],Z([0,1,5]),function(z,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcExtensionHostStarterChannelName=e.IExtensionHostStarter=void 0,e.IExtensionHostStarter=(0,b.createDecorator)("extensionHostStarter"),e.ipcExtensionHostStarterChannelName="extensionHostStarter"}),define(J[100],Z([0,1,5]),function(z,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,b.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,b.createDecorator)("externalTerminal")}),define(J[182],Z([0,1,42,11,9,4,77,23,81,149,100]),function(z,e,b,t,R,L,D,y,f,v,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const P=v.localize(0,null);class S{async getDefaultTerminalForPlatforms(){return{windows:w.getDefaultTerminalWindows(),linux:await m.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class w extends S{openTerminal(h,l){return this.spawnTerminal(b,h,f.getWindowsShell(),l)}spawnTerminal(h,l,n,r){const i=l.windowsExec||w.getDefaultTerminalWindows();r&&r[1]===":"&&(r=r[0].toUpperCase()+r.substr(1));const s=R.basename(i).toLowerCase();if(s==="cmder"||s==="cmder.exe")return h.spawn(i,r?[r]:void 0),Promise.resolve(void 0);const o=["/c","start","/wait"];return i.indexOf(" ")>=0&&o.push('""'),o.push(i),(s==="wt"||s==="wt.exe")&&o.push("-d ."),new Promise((a,c)=>{const C=g(process),k=h.spawn(n,o,{cwd:r,env:C});k.on("error",c),k.on("exit",()=>a())})}runInTerminal(h,l,n,r,i){const s="windowsExec"in i&&i.windowsExec?i.windowsExec:w.getDefaultTerminalWindows();return new Promise((o,a)=>{const c=`"${l} - ${P}"`,C=`""${n.join('" "')}" & pause"`,k=["/c","start",c,"/wait",s,"/c",C],M=Object.assign({},g(process),r);Object.keys(M).filter(q=>M[q]===null).forEach(q=>delete M[q]);const T={cwd:l,env:M,windowsVerbatimArguments:!0};b.spawn(w.CMD,k,T).on("error",q=>{a(I(q))}),o(void 0)})}static getDefaultTerminalWindows(){if(!w._DEFAULT_TERMINAL_WINDOWS){const h=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");w._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${h?"Sysnative":"System32"}\\cmd.exe`}return w._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=w,w.CMD="cmd.exe";class u extends S{openTerminal(h,l){return this.spawnTerminal(b,h,l)}runInTerminal(h,l,n,r,i){const s=i.osxExec||E.DEFAULT_TERMINAL_OSX;return new Promise((o,a)=>{if(s===E.DEFAULT_TERMINAL_OSX||s==="iTerm.app"){const c=s===E.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",k=[t.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${c}.scpt`,z).fsPath,"-t",h||P,"-w",l];for(const F of n)k.push("-a"),k.push(F);if(r){const F=Object.assign({},g(process),r);for(const q in F){const te=F[q];te===null?(k.push("-u"),k.push(q)):(k.push("-e"),k.push(`${q}=${te}`))}}let M="";const T=b.spawn(u.OSASCRIPT,k);T.on("error",F=>{a(I(F))}),T.stderr.on("data",F=>{M+=F.toString()}),T.on("exit",F=>{if(F===0)o(void 0);else if(M){const q=M.split(`
`,1);a(new Error(q[0]))}else a(new Error(v.localize(1,null,c,F)))})}else a(new Error(v.localize(2,null,s)))})}spawnTerminal(h,l,n){const r=l.osxExec||E.DEFAULT_TERMINAL_OSX;return new Promise((i,s)=>{const o=["-a",r];n&&o.push(n);const a=g(process),c=h.spawn("/usr/bin/open",o,{cwd:n,env:a});c.on("error",s),c.on("exit",()=>i())})}}e.MacExternalTerminalService=u,u.OSASCRIPT="/usr/bin/osascript";class m extends S{openTerminal(h,l){return this.spawnTerminal(b,h,l)}runInTerminal(h,l,n,r,i){const s=i.linuxExec?Promise.resolve(i.linuxExec):m.getDefaultTerminalLinuxReady();return new Promise((o,a)=>{const c=[];s.then(C=>{C.indexOf("gnome-terminal")>=0?c.push("-x"):c.push("-e"),c.push("bash"),c.push("-c");const k=`${p(n)}; echo; read -p "${m.WAIT_MESSAGE}" -n1;`;c.push(`''${k}''`);const M=Object.assign({},g(process),r);Object.keys(M).filter(te=>M[te]===null).forEach(te=>delete M[te]);const T={cwd:l,env:M};let F="";const q=b.spawn(C,c,T);q.on("error",te=>{a(I(te))}),q.stderr.on("data",te=>{F+=te.toString()}),q.on("exit",te=>{if(te===0)o(void 0);else if(F){const ne=F.split(`
`,1);a(new Error(ne[0]))}else a(new Error(v.localize(4,null,C,te)))})})})}static async getDefaultTerminalLinuxReady(){if(!m._DEFAULT_TERMINAL_LINUX_READY)if(!L.isLinux)m._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const h=await y.Promises.exists("/etc/debian_version");m._DEFAULT_TERMINAL_LINUX_READY=new Promise(l=>{h?l("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?l("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?l("konsole"):process.env.COLORTERM?l(process.env.COLORTERM):process.env.TERM?l(process.env.TERM):l("xterm")})}return m._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(h,l,n){const r=l.linuxExec?Promise.resolve(l.linuxExec):m.getDefaultTerminalLinuxReady();return new Promise((i,s)=>{r.then(o=>{const a=g(process),c=h.spawn(o,[],{cwd:n,env:a});c.on("error",s),c.on("exit",()=>i())})})}}e.LinuxExternalTerminalService=m,m.WAIT_MESSAGE=v.localize(3,null);function g(d){const h={...d.env};return(0,D.sanitizeProcessEnvironment)(h),h}function I(d){return"errno"in d&&d.errno==="ENOENT"&&"path"in d&&typeof d.path=="string"?new Error(v.localize(5,null,d.path)):d}function p(d){let h="";for(const l of d)l.indexOf(" ")>=0?h+='"'+l+'"':h+=l,h+=" ";return h}}),define(J[15],Z([0,1,33,9,31,12,7,151,5]),function(z,e,b,t,R,L,D,y,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,f.createDecorator)("fileService");function v(H){return H.create===!0}e.isFileOpenForWriteOptions=v;var E;(function(H){H[H.Unknown=0]="Unknown",H[H.File=1]="File",H[H.Directory=2]="Directory",H[H.SymbolicLink=64]="SymbolicLink"})(E=e.FileType||(e.FileType={}));var P;(function(H){H[H.Readonly=1]="Readonly"})(P=e.FilePermission||(e.FilePermission={}));var S;(function(H){H[H.FileReadWrite=2]="FileReadWrite",H[H.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",H[H.FileReadStream=16]="FileReadStream",H[H.FileFolderCopy=8]="FileFolderCopy",H[H.PathCaseSensitive=1024]="PathCaseSensitive",H[H.Readonly=2048]="Readonly",H[H.Trash=4096]="Trash",H[H.FileWriteUnlock=8192]="FileWriteUnlock",H[H.FileAtomicRead=16384]="FileAtomicRead",H[H.FileClone=32768]="FileClone"})(S=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function w(H){return!!(H.capabilities&2)}e.hasReadWriteCapability=w;function u(H){return!!(H.capabilities&8)}e.hasFileFolderCopyCapability=u;function m(H){return!!(H.capabilities&32768)}e.hasFileCloneCapability=m;function g(H){return!!(H.capabilities&4)}e.hasOpenReadWriteCloseCapability=g;function I(H){return!!(H.capabilities&16)}e.hasFileReadStreamCapability=I;function p(H){return w(H)?!!(H.capabilities&16384):!1}e.hasFileAtomicReadCapability=p;var d;(function(H){H.FileExists="EntryExists",H.FileNotFound="EntryNotFound",H.FileNotADirectory="EntryNotADirectory",H.FileIsADirectory="EntryIsADirectory",H.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",H.FileTooLarge="EntryTooLarge",H.FileWriteLocked="EntryWriteLocked",H.NoPermissions="NoPermissions",H.Unavailable="Unavailable",H.Unknown="Unknown"})(d=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class h extends Error{constructor(oe,W){super(oe);this.code=W}}e.FileSystemProviderError=h;function l(H,oe){const W=new h(H.toString(),oe);return r(W,oe),W}e.createFileSystemProviderError=l;function n(H){return H||l((0,y.localize)(0,null),d.Unknown)}e.ensureFileSystemProviderError=n;function r(H,oe){return H.name=oe?`${oe} (FileSystemError)`:"FileSystemError",H}e.markAsFileSystemProviderError=r;function i(H){if(!H)return d.Unknown;if(H instanceof h)return H.code;const oe=/^(.+) \(FileSystemError\)$/.exec(H.name);if(!oe)return d.Unknown;switch(oe[1]){case d.FileExists:return d.FileExists;case d.FileIsADirectory:return d.FileIsADirectory;case d.FileNotADirectory:return d.FileNotADirectory;case d.FileNotFound:return d.FileNotFound;case d.FileExceedsMemoryLimit:return d.FileExceedsMemoryLimit;case d.FileTooLarge:return d.FileTooLarge;case d.FileWriteLocked:return d.FileWriteLocked;case d.NoPermissions:return d.NoPermissions;case d.Unavailable:return d.Unavailable}return d.Unknown}e.toFileSystemProviderErrorCode=i;function s(H){if(H instanceof M)return H.fileOperationResult;switch(i(H)){case d.FileNotFound:return 1;case d.FileIsADirectory:return 0;case d.FileNotADirectory:return 10;case d.FileWriteLocked:return 5;case d.NoPermissions:return 6;case d.FileExists:return 4;case d.FileExceedsMemoryLimit:return 9;case d.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=s;var o;(function(H){H[H.CREATE=0]="CREATE",H[H.DELETE=1]="DELETE",H[H.MOVE=2]="MOVE",H[H.COPY=3]="COPY",H[H.WRITE=4]="WRITE"})(o=e.FileOperation||(e.FileOperation={}));class a{constructor(oe,W,U){this.resource=oe,this.operation=W,this.target=U}isOperation(oe){return this.operation===oe}}e.FileOperationEvent=a;var c;(function(H){H[H.UPDATED=0]="UPDATED",H[H.ADDED=1]="ADDED",H[H.DELETED=2]="DELETED"})(c=e.FileChangeType||(e.FileChangeType={}));class C{constructor(oe,W){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=oe;const U=new Map;for(const B of oe){const X=U.get(B.type);switch(X?X.push([B.resource,B]):U.set(B.type,[[B.resource,B]]),B.type){case 1:this.rawAdded.push(B.resource);break;case 0:this.rawUpdated.push(B.resource);break;case 2:this.rawDeleted.push(B.resource);break}}for(const[B,X]of U)switch(B){case 1:this.added=b.TernarySearchTree.forUris(()=>W),this.added.fill(X);break;case 0:this.updated=b.TernarySearchTree.forUris(()=>W),this.updated.fill(X);break;case 2:this.deleted=b.TernarySearchTree.forUris(()=>W),this.deleted.fill(X);break}}contains(oe,...W){return this.doContains(oe,{includeChildren:!1},...W)}affects(oe,...W){return this.doContains(oe,{includeChildren:!0},...W)}doContains(oe,W,...U){if(!oe)return!1;const B=U.length>0;return!!((!B||U.includes(1))&&(this.added?.get(oe)||W.includeChildren&&this.added?.findSuperstr(oe))||(!B||U.includes(0))&&(this.updated?.get(oe)||W.includeChildren&&this.updated?.findSuperstr(oe))||(!B||U.includes(2))&&(this.deleted?.findSubstr(oe)||W.includeChildren&&this.deleted?.findSuperstr(oe)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=C;function k(H,oe,W){return!H||!oe||H===oe||oe.length>H.length?!1:(oe.charAt(oe.length-1)!==t.sep&&(oe+=t.sep),W?(0,R.startsWithIgnoreCase)(H,oe):H.indexOf(oe)===0)}e.isParent=k;class M extends Error{constructor(oe,W,U){super(oe);this.fileOperationResult=W,this.options=U}}e.FileOperationError=M;class T extends M{constructor(oe,W,U){super(oe,2,U);this.stat=W}}e.NotModifiedSinceFileOperationError=T;var F;(function(H){H[H.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",H[H.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",H[H.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",H[H.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",H[H.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",H[H.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",H[H.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",H[H.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",H[H.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",H[H.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",H[H.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",H[H.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(F=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var q;(function(H){H[H.FILE=0]="FILE",H[H.FOLDER=1]="FOLDER",H[H.ROOT_FOLDER=2]="ROOT_FOLDER"})(q=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function te(H){if(!(typeof H.size!="number"||typeof H.mtime!="number"))return H.mtime.toString(29)+H.size.toString(31)}e.etag=te;async function ne(H,oe){if(!oe.hasProvider(D.URI.from({scheme:H.scheme})))return new Promise(W=>{const U=oe.onDidChangeFileSystemProviderRegistrations(B=>{B.scheme===H.scheme&&B.added&&(U.dispose(),W())})})}e.whenProviderRegistered=ne,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class Q{static formatSize(oe){return(0,L.isNumber)(oe)||(oe=0),oe<Q.KB?(0,y.localize)(1,null,oe.toFixed(0)):oe<Q.MB?(0,y.localize)(2,null,(oe/Q.KB).toFixed(2)):oe<Q.GB?(0,y.localize)(3,null,(oe/Q.MB).toFixed(2)):oe<Q.TB?(0,y.localize)(4,null,(oe/Q.GB).toFixed(2)):(0,y.localize)(5,null,(oe/Q.TB).toFixed(2))}}e.ByteSize=Q,Q.KB=1024,Q.MB=Q.KB*Q.KB,Q.GB=Q.MB*Q.KB,Q.TB=Q.GB*Q.KB;var se;(function(H){H[H.IA32=0]="IA32",H[H.OTHER=1]="OTHER"})(se=e.Arch||(e.Arch={}));function ce(H){return{maxFileSize:H===0?300*Q.MB:16*Q.GB,maxHeapSize:H===0?700*Q.MB:2*700*Q.MB}}e.getPlatformLimits=ce}),define(J[183],Z([0,1,19,41,18,3,2,54,7,30,15]),function(z,e,b,t,R,L,D,y,f,v,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class P extends D.Disposable{constructor(w,u){super();this.channel=w,this.extraCapabilities=u,this.onDidChangeCapabilities=L.Event.None,this._onDidChange=this._register(new L.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new L.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,v.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384|32768,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(w){return this.channel.call("stat",[w])}readdir(w){return this.channel.call("readdir",[w])}async readFile(w,u){const{buffer:m}=await this.channel.call("readFile",[w,u]);return m}readFileStream(w,u,m){const g=(0,y.newWriteableStream)(p=>b.VSBuffer.concat(p.map(d=>b.VSBuffer.wrap(d))).buffer),I=this.channel.listen("readFileStream",[w,u])(p=>{if(p instanceof b.VSBuffer)g.write(p.buffer);else{if(p==="end")g.end();else{let d=p;d instanceof Error||(d=(0,E.createFileSystemProviderError)((0,t.toErrorMessage)(d),E.FileSystemProviderErrorCode.Unknown)),g.error(d),g.end()}I.dispose()}});return m.onCancellationRequested(()=>{g.error((0,R.canceled)()),g.end(),I.dispose()}),g}writeFile(w,u,m){return this.channel.call("writeFile",[w,b.VSBuffer.wrap(u),m])}open(w,u){return this.channel.call("open",[w,u])}close(w){return this.channel.call("close",[w])}async read(w,u,m,g,I){const[p,d]=await this.channel.call("read",[w,u,I]);return m.set(p.buffer.slice(0,d),g),d}write(w,u,m,g,I){return this.channel.call("write",[w,u,b.VSBuffer.wrap(m),g,I])}mkdir(w){return this.channel.call("mkdir",[w])}delete(w,u){return this.channel.call("delete",[w,u])}rename(w,u,m){return this.channel.call("rename",[w,u,m])}copy(w,u,m){return this.channel.call("copy",[w,u,m])}cloneFile(w,u){return this.channel.call("cloneFile",[w,u])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(w=>{if(Array.isArray(w)){const u=w;this._onDidChange.fire(u.map(m=>({resource:f.URI.revive(m.resource),type:m.type})))}else{const u=w;this._onDidWatchError.fire(u)}}))}watch(w,u){const m=(0,v.generateUuid)();return this.channel.call("watch",[this.sessionId,m,w,u]),(0,D.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,m]))}}e.DiskFileSystemProviderClient=P}),define(J[101],Z([0,1,19,18,152,15]),function(z,e,b,t,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function D(E,P,S,w,u,m){let g;try{await y(E,P,S,w,u,m)}catch(I){g=I}finally{g&&u.errorTransformer&&(g=u.errorTransformer(g)),typeof g!="undefined"&&S.error(g),S.end()}}e.readFileIntoStream=D;async function y(E,P,S,w,u,m){f(m);const g=await E.open(P,{create:!1});try{f(m);let I=0,p=0,d=u&&typeof u.length=="number"?u.length:void 0,h=b.VSBuffer.alloc(Math.min(u.bufferSize,typeof d=="number"?d:u.bufferSize)),l=u&&typeof u.position=="number"?u.position:0,n=0;do p=await E.read(g,l,h.buffer,n,h.byteLength-n),l+=p,n+=p,I+=p,typeof d=="number"&&(d-=p),n===h.byteLength&&(await S.write(w(h)),h=b.VSBuffer.alloc(Math.min(u.bufferSize,typeof d=="number"?d:u.bufferSize)),n=0);while(p>0&&(typeof d!="number"||d>0)&&f(m)&&v(I,u));if(n>0){let r=n;typeof d=="number"&&(r=Math.min(n,d)),S.write(w(h.slice(0,r)))}}catch(I){throw(0,L.ensureFileSystemProviderError)(I)}finally{await E.close(g)}}function f(E){if(E.isCancellationRequested)throw(0,t.canceled)();return!0}function v(E,P){if(P?.limits){if(typeof P.limits.memory=="number"&&E>P.limits.memory)throw(0,L.createFileSystemProviderError)((0,R.localize)(0,null),L.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof P.limits.size=="number"&&E>P.limits.size)throw(0,L.createFileSystemProviderError)((0,R.localize)(1,null),L.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(J[69],Z([0,1,92,2,9,4,7,15]),function(z,e,b,t,R,L,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function f(I){return I.recursive===!0}e.isRecursiveWatchRequest=f;class v extends t.Disposable{constructor(p,d,h,l){super();this.onFileChanges=p,this.onLogMessage=d,this.verboseLogging=h,this.options=l,this.watcherDisposables=this._register(new t.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const p=new t.DisposableStore;this.watcherDisposables.value=p,this.watcher=this.createWatcher(p),this.watcher.setVerboseLogging(this.verboseLogging),p.add(this.watcher.onDidChangeFile(d=>this.onFileChanges(d))),p.add(this.watcher.onDidLogMessage(d=>this.onLogMessage(d))),p.add(this.watcher.onDidError(d=>this.onError(d)))}onError(p){this.options.restartOnError?this.restartCounter<v.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${p}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${p}`):this.error(p)}restart(p){this.restartCounter++,this.init(),this.watch(p)}async watch(p){this.requests=p,await this.watcher?.watch(p)}async setVerboseLogging(p){this.verboseLogging=p,await this.watcher?.setVerboseLogging(p)}error(p){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${p}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=v,v.MAX_RESTARTS=5;class E extends v{constructor(p,d,h){super(p,d,h,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=E;class P extends v{constructor(p,d,h){super(p,d,h,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=P;function S(I){return I.map(p=>({type:p.type,resource:D.URI.file(p.path)}))}e.toFileChanges=S;function w(I){const p=new g;for(const d of I)p.processEvent(d);return p.coalesce()}e.coalesceEvents=w;function u(I,p){return typeof p=="string"&&!p.startsWith(b.GLOBSTAR)&&!(0,R.isAbsolute)(p)?{base:I,pattern:p}:p}e.normalizeWatcherPattern=u;function m(I,p){const d=[];for(const h of p)d.push((0,b.parse)(u(I,h)));return d}e.parseWatcherPatterns=m;class g{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(p){return L.isLinux?p.path:p.path.toLowerCase()}processEvent(p){const d=this.mapPathToChange.get(this.toKey(p));let h=!1;if(d){const l=d.type,n=p.type;d.path!==p.path&&(p.type===2||p.type===1)?h=!0:l===1&&n===2?(this.mapPathToChange.delete(this.toKey(p)),this.coalesced.delete(d)):l===2&&n===1?d.type=0:l===1&&n===0||(d.type=n)}else h=!0;h&&(this.coalesced.add(p),this.mapPathToChange.set(this.toKey(p),p))}coalesce(){const p=[],d=[];return Array.from(this.coalesced).filter(h=>h.type!==2?(p.push(h),!1):!0).sort((h,l)=>h.path.length-l.path.length).filter(h=>d.some(l=>(0,y.isParent)(h.path,l,!L.isLinux))?!1:(d.push(h.path),!0)).concat(p)}}}),define(J[184],Z([0,1,28,8,22,29,2,79,9,4,93,23,69]),function(z,e,b,t,R,L,D,y,f,v,E,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class w extends D.Disposable{constructor(g,I,p,d){super();this.request=g,this.onDidFilesChange=I,this.onLogMessage=p,this.verboseLogging=d,this.throttledFileChangesWorker=new t.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},h=>this.onDidFilesChange(h)),this.fileChangesDelayer=this._register(new t.ThrottledDelayer(w.FILE_CHANGES_HANDLER_DELAY)),this.fileChangesBuffer=[],this.excludes=(0,S.parseWatcherPatterns)(this.request.path,this.request.excludes),this.includes=this.request.includes?(0,S.parseWatcherPatterns)(this.request.path,this.request.includes):void 0,this.cts=new R.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const g=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const I=await P.Promises.stat(g);this._register(await this.doWatch(g,I.isDirectory()))}catch(g){g.code!=="ENOENT"?this.error(g):this.trace(g)}}async normalizePath(g){let I=g.path;try{I=await P.Promises.realpath(g.path),g.path===I&&(I=await(0,E.realcase)(g.path)??g.path),g.path!==I&&this.trace(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${g.path}, real: ${I})`)}catch{}return I}async doWatch(g,I){if(v.isMacintosh&&(0,L.isEqualOrParent)(g,"/Volumes/",!0))return this.error(`Refusing to watch ${g} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),D.Disposable.None;const p=new R.CancellationTokenSource(this.cts.token),d=new D.DisposableStore;try{const h=(0,f.basename)(g),l=(0,b.watch)(g);d.add((0,D.toDisposable)(()=>{l.removeAllListeners(),l.close()})),this.trace(`Started watching: '${g}'`);const n=new Set;if(I)try{for(const i of await P.Promises.readdir(g))n.add(i)}catch(i){this.error(i)}const r=new Map;d.add((0,D.toDisposable)(()=>{for(const[,i]of r)i.dispose();r.clear()})),l.on("error",(i,s)=>{this.error(`Failed to watch ${g} for changes using fs.watch() (${i}, ${s})`),this.dispose()}),l.on("change",(i,s)=>{if(p.token.isCancellationRequested)return;this.trace(`[raw] ["${i}"] ${s}`);let o="";if(s&&(o=s.toString(),v.isMacintosh&&(o=(0,y.normalizeNFC)(o))),!(!o||i!=="change"&&i!=="rename"))if(I)if(i==="rename"){r.get(o)?.dispose();const a=setTimeout(async()=>{if(r.delete(o),o===h&&!await P.Promises.exists(g)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const c=await this.existsChildStrictCase((0,f.join)(g,o));if(p.token.isCancellationRequested)return;let C;c?n.has(o)?C=0:(C=1,n.add(o)):(n.delete(o),C=2),this.onFileChange({path:(0,f.join)(this.request.path,o),type:C})},w.FILE_DELETE_HANDLER_DELAY);r.set(o,(0,D.toDisposable)(()=>clearTimeout(a)))}else{let a;n.has(o)?a=0:(a=1,n.add(o)),this.onFileChange({path:(0,f.join)(this.request.path,o),type:a})}else if(i==="rename"||o!==h){const a=setTimeout(async()=>{const c=await P.Promises.exists(g);p.token.isCancellationRequested||(c?(this.onFileChange({path:this.request.path,type:0},!0),d.add(await this.doWatch(g,!1))):(await this.onFileChange({path:this.request.path,type:2},!0),this.dispose()))},w.FILE_DELETE_HANDLER_DELAY);d.clear(),d.add((0,D.toDisposable)(()=>clearTimeout(a)))}else this.onFileChange({path:this.request.path,type:0},!0)})}catch(h){await P.Promises.exists(g)&&!p.token.isCancellationRequested&&this.error(`Failed to watch ${g} for changes using fs.watch() (${h.toString()})`)}return(0,D.toDisposable)(()=>{p.dispose(!0),d.dispose()})}async onFileChange(g,I=!1){if(!this.cts.token.isCancellationRequested){this.verboseLogging&&this.trace(`${g.type===1?"[ADDED]":g.type===2?"[DELETED]":"[CHANGED]"} ${g.path}`),!I&&this.excludes.some(p=>p(g.path))?this.verboseLogging&&this.trace(` >> ignored (excluded) ${g.path}`):!I&&this.includes&&this.includes.length>0&&!this.includes.some(p=>p(g.path))?this.verboseLogging&&this.trace(` >> ignored (not included) ${g.path}`):this.fileChangesBuffer.push(g);try{await this.fileChangesDelayer.trigger(async()=>{const p=this.fileChangesBuffer;this.fileChangesBuffer=[];const d=(0,S.coalesceEvents)(p);if(d.length>0){if(this.verboseLogging)for(const l of d)this.trace(`>> normalized ${l.type===1?"[ADDED]":l.type===2?"[DELETED]":"[CHANGED]"} ${l.path}`);this.throttledFileChangesWorker.work(d)?this.throttledFileChangesWorker.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesWorker.pending}, most recent change: ${d[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${d.length}, most recent change: ${d[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}})}catch{}}}async existsChildStrictCase(g){if(v.isLinux)return P.Promises.exists(g);try{const I=(0,f.basename)(g);return(await P.Promises.readdir((0,f.dirname)(g))).some(d=>d===I)}catch(I){return this.trace(I),!1}}setVerboseLogging(g){this.verboseLogging=g}error(g){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${g}`})}warn(g){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${g}`})}trace(g){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${g}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=w,w.FILE_DELETE_HANDLER_DELAY=100,w.FILE_CHANGES_HANDLER_DELAY=50;async function u(m,g,I,p,d=512){const h=await P.Promises.open(m,"r"),l=Buffer.allocUnsafe(d),n=new R.CancellationTokenSource(p);let r,i=!1;const s={path:m,excludes:[],recursive:!1},o=new w(s,a=>{(async()=>{for(const{type:c}of a)if(c===0){if(i)return;i=!0;try{for(;!n.token.isCancellationRequested;){const{bytesRead:C}=await P.Promises.read(h,l,0,d,null);if(!C||n.token.isCancellationRequested)break;g(l.slice(0,C))}}catch(C){r=new Error(C),n.dispose(!0)}finally{i=!1}}})()});return await o.ready,I(),new Promise((a,c)=>{n.token.onCancellationRequested(async()=>{o.dispose();try{await P.Promises.close(h)}catch(C){r=new Error(C)}r?c(r):a()})})}e.watchFileContents=u}),define(J[185],Z([0,1,3,92,2,4,184]),function(z,e,b,t,R,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class y extends R.Disposable{constructor(){super(...arguments);this._onDidChangeFile=this._register(new b.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new b.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=b.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(v){const E=this.normalizeRequests(v),P=E.filter(w=>{const u=this.watchers.get(w.path);return u?!(0,t.patternsEquals)(u.request.excludes,w.excludes)||!(0,t.patternsEquals)(u.request.includes,w.includes):!0}),S=Array.from(this.watchers.values()).filter(({request:w})=>!E.find(u=>u.path===w.path&&(0,t.patternsEquals)(u.excludes,w.excludes)&&(0,t.patternsEquals)(u.includes,w.includes))).map(({request:w})=>w.path);P.length&&this.trace(`Request to start watching: ${P.map(w=>`${w.path} (excludes: ${w.excludes.length>0?w.excludes:"<none>"}, includes: ${w.includes&&w.includes.length>0?JSON.stringify(w.includes):"<all>"})`).join(",")}`),S.length&&this.trace(`Request to stop watching: ${S.join(",")}`);for(const w of S)this.stopWatching(w);for(const w of P)this.startWatching(w)}startWatching(v){const E=new D.NodeJSFileWatcherLibrary(v,S=>this._onDidChangeFile.fire(S),S=>this._onDidLogMessage.fire(S),this.verboseLogging),P={request:v,instance:E};this.watchers.set(v.path,P)}async stop(){for(const[v]of this.watchers)this.stopWatching(v);this.watchers.clear()}stopWatching(v){const E=this.watchers.get(v);E&&(this.watchers.delete(v),E.instance.dispose())}normalizeRequests(v){const E=new Map;for(const P of v){const S=L.isLinux?P.path:P.path.toLowerCase();E.set(S,P)}return Array.from(E.values())}async setVerboseLogging(v){this.verboseLogging=v;for(const[,E]of this.watchers)E.instance.setVerboseLogging(v)}trace(v){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(v)})}toMessage(v,E){return E?`[File Watcher (node.js)] ${v} (path: ${E.request.path})`:`[File Watcher (node.js)] ${v}`}}e.NodeJSWatcher=y}),define(J[186],Z([0,1,69,185]),function(z,e,b,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class R extends b.AbstractNonRecursiveWatcherClient{constructor(D,y,f){super(D,y,f);this.init()}createWatcher(){return new t.NodeJSWatcher}}e.NodeJSWatcherClient=R}),define(J[187],Z([0,1,11,43,143,69]),function(z,e,b,t,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class D extends L.AbstractUniversalWatcherClient{constructor(f,v,E){super(f,v,E);this.init()}createWatcher(f){const v=f.add(new R.Client(b.FileAccess.asFileUri("bootstrap-fork",z).fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return f.add(v.onDidProcessExit(({code:E,signal:P})=>this.onError(`terminated by itself with code ${E}, signal: ${P}`))),t.ProxyChannel.toService((0,t.getNextTickChannel)(v.getChannel("watcher")))}}e.UniversalWatcherClient=D}),define(J[83],Z([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class b{constructor(...R){this._entries=new Map;for(const[L,D]of R)this.set(L,D)}set(R,L){const D=this._entries.get(R);return this._entries.set(R,L),D}has(R){return this._entries.has(R)}get(R){return this._entries.get(R)}}e.ServiceCollection=b}),define(J[188],Z([0,1,8,18,67,179,5,83]),function(z,e,b,t,R,L,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const f=!1;class v extends Error{constructor(u){super("cyclic dependency between services");this.message=u.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${u.toString()}`}}class E{constructor(u=new y.ServiceCollection,m=!1,g){this._activeInstantiations=new Set,this._services=u,this._strict=m,this._parent=g,this._services.set(D.IInstantiationService,this)}createChild(u){return new E(u,this._strict,this)}invokeFunction(u,...m){const g=S.traceInvocation(u);let I=!1;try{return u({get:d=>{if(I)throw(0,t.illegalState)("service accessor is only valid during the invocation of its target method");const h=this._getOrCreateServiceInstance(d,g);if(!h)throw new Error(`[invokeFunction] unknown service '${d}'`);return h}},...m)}finally{I=!0,g.stop()}}createInstance(u,...m){let g,I;return u instanceof R.SyncDescriptor?(g=S.traceCreation(u.ctor),I=this._createInstance(u.ctor,u.staticArguments.concat(m),g)):(g=S.traceCreation(u),I=this._createInstance(u,m,g)),g.stop(),I}_createInstance(u,m=[],g){const I=D._util.getServiceDependencies(u).sort((h,l)=>h.index-l.index),p=[];for(const h of I){const l=this._getOrCreateServiceInstance(h.id,g);l||this._throwIfStrict(`[createInstance] ${u.name} depends on UNKNOWN service ${h.id}.`,!1),p.push(l)}const d=I.length>0?I[0].index:m.length;if(m.length!==d){console.trace(`[createInstance] First service dependency of ${u.name} at position ${d+1} conflicts with ${m.length} static arguments`);const h=d-m.length;h>0?m=m.concat(new Array(h)):m=m.slice(0,d)}return new u(...[...m,...p])}_setServiceInstance(u,m){if(this._services.get(u)instanceof R.SyncDescriptor)this._services.set(u,m);else if(this._parent)this._parent._setServiceInstance(u,m);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(u){const m=this._services.get(u);return!m&&this._parent?this._parent._getServiceInstanceOrDescriptor(u):m}_getOrCreateServiceInstance(u,m){const g=this._getServiceInstanceOrDescriptor(u);return g instanceof R.SyncDescriptor?this._safeCreateAndCacheServiceInstance(u,g,m.branch(u,!0)):(m.branch(u,!1),g)}_safeCreateAndCacheServiceInstance(u,m,g){if(this._activeInstantiations.has(u))throw new Error(`illegal state - RECURSIVELY instantiating service '${u}'`);this._activeInstantiations.add(u);try{return this._createAndCacheServiceInstance(u,m,g)}finally{this._activeInstantiations.delete(u)}}_createAndCacheServiceInstance(u,m,g){const I=new L.Graph(h=>h.id.toString());let p=0;const d=[{id:u,desc:m,_trace:g}];for(;d.length;){const h=d.pop();if(I.lookupOrInsertNode(h),p++>1e3)throw new v(I);for(const l of D._util.getServiceDependencies(h.desc.ctor)){const n=this._getServiceInstanceOrDescriptor(l.id);if(n||this._throwIfStrict(`[createInstance] ${u} depends on ${l.id} which is NOT registered.`,!0),n instanceof R.SyncDescriptor){const r={id:l.id,desc:n,_trace:h._trace.branch(l.id,!0)};I.insertEdge(h,r),d.push(r)}}}for(;;){const h=I.roots();if(h.length===0){if(!I.isEmpty())throw new v(I);break}for(const{data:l}of h){if(this._getServiceInstanceOrDescriptor(l.id)instanceof R.SyncDescriptor){const r=this._createServiceInstanceWithOwner(l.id,l.desc.ctor,l.desc.staticArguments,l.desc.supportsDelayedInstantiation,l._trace);this._setServiceInstance(l.id,r)}I.removeNode(l)}}return this._getServiceInstanceOrDescriptor(u)}_createServiceInstanceWithOwner(u,m,g=[],I,p){if(this._services.get(u)instanceof R.SyncDescriptor)return this._createServiceInstance(m,g,I,p);if(this._parent)return this._parent._createServiceInstanceWithOwner(u,m,g,I,p);throw new Error(`illegalState - creating UNKNOWN service instance ${m.name}`)}_createServiceInstance(u,m=[],g,I){if(g){const p=new b.IdleValue(()=>this._createInstance(u,m,I));return new Proxy(Object.create(null),{get(d,h){if(h in d)return d[h];const l=p.value;let n=l[h];return typeof n!="function"||(n=n.bind(l),d[h]=n),n},set(d,h,l){return p.value[h]=l,!0}})}else return this._createInstance(u,m,I)}_throwIfStrict(u,m){if(m&&console.warn(m),this._strict)throw new Error(u)}}e.InstantiationService=E;var P;(function(w){w[w.Creation=0]="Creation",w[w.Invocation=1]="Invocation",w[w.Branch=2]="Branch"})(P||(P={}));class S{constructor(u,m){this.type=u,this.name=m,this._start=Date.now(),this._dep=[]}static traceInvocation(u){return f?new S(1,u.name||u.toString().substring(0,42).replace(/\n/g,"")):S._None}static traceCreation(u){return f?new S(0,u.name):S._None}branch(u,m){const g=new S(2,u.toString());return this._dep.push([u,m,g]),g}stop(){const u=Date.now()-this._start;S._totals+=u;let m=!1;function g(p,d){const h=[],l=new Array(p+1).join("	");for(const[n,r,i]of d._dep)if(r&&i){m=!0,h.push(`${l}CREATES -> ${n}`);const s=g(p+1,i);s&&h.push(s)}else h.push(`${l}uses -> ${n}`);return h.join(`
`)}const I=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${g(1,this)}`,`DONE, took ${u.toFixed(2)}ms (grand total ${S._totals.toFixed(2)}ms)`];(u>2||m)&&console.log(I.join(`
`))}}e.Trace=S,S._None=new class extends S{constructor(){super(-1,null)}stop(){}branch(){return this}},S._totals=0}),define(J[6],Z([0,1,41,3,2,4,5]),function(z,e,b,t,R,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,D.createDecorator)("logService"),e.ILoggerService=(0,D.createDecorator)("loggerService");function y(){return new Date().toISOString()}var f;(function(r){r[r.Trace=0]="Trace",r[r.Debug=1]="Debug",r[r.Info=2]="Info",r[r.Warning=3]="Warning",r[r.Error=4]="Error",r[r.Critical=5]="Critical",r[r.Off=6]="Off"})(f=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=f.Info;function v(r,i,s){switch(i){case f.Trace:r.trace(s);break;case f.Debug:r.debug(s);break;case f.Info:r.info(s);break;case f.Warning:r.warn(s);break;case f.Error:r.error(s);break;case f.Critical:r.critical(s);break;default:throw new Error("Invalid log level")}}e.log=v;function E(r){let i="";for(let s=0;s<r.length;s++){let o=r[s];if(typeof o=="object")try{o=JSON.stringify(o)}catch{}i+=(s>0?" ":"")+o}return i}e.format=E;class P extends R.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new t.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(i){this.level!==i&&(this.level=i,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=P;class S extends P{constructor(i){super();this.logAlways=i}checkLogLevel(i){return this.logAlways||this.getLevel()<=i}trace(i,...s){this.checkLogLevel(f.Trace)&&this.log(f.Trace,E([i,...s]))}debug(i,...s){this.checkLogLevel(f.Debug)&&this.log(f.Debug,E([i,...s]))}info(i,...s){this.checkLogLevel(f.Info)&&this.log(f.Info,E([i,...s]))}warn(i,...s){this.checkLogLevel(f.Warning)&&this.log(f.Warning,E([i,...s]))}error(i,...s){if(this.checkLogLevel(f.Error))if(i instanceof Error){const o=Array.prototype.slice.call(arguments);o[0]=i.stack,this.log(f.Error,E(o))}else this.log(f.Error,E([i,...s]))}critical(i,...s){this.checkLogLevel(f.Critical)&&this.log(f.Critical,E([i,...s]))}flush(){}}e.AbstractMessageLogger=S;class w extends P{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i),this.useColors=!L.isWindows}trace(i,...s){this.getLevel()<=f.Trace&&(this.useColors?console.log(`[90m[main ${y()}][0m`,i,...s):console.log(`[main ${y()}]`,i,...s))}debug(i,...s){this.getLevel()<=f.Debug&&(this.useColors?console.log(`[90m[main ${y()}][0m`,i,...s):console.log(`[main ${y()}]`,i,...s))}info(i,...s){this.getLevel()<=f.Info&&(this.useColors?console.log(`[90m[main ${y()}][0m`,i,...s):console.log(`[main ${y()}]`,i,...s))}warn(i,...s){this.getLevel()<=f.Warning&&(this.useColors?console.warn(`[93m[main ${y()}][0m`,i,...s):console.warn(`[main ${y()}]`,i,...s))}error(i,...s){this.getLevel()<=f.Error&&(this.useColors?console.error(`[91m[main ${y()}][0m`,i,...s):console.error(`[main ${y()}]`,i,...s))}critical(i,...s){this.getLevel()<=f.Critical&&(this.useColors?console.error(`[90m[main ${y()}][0m`,i,...s):console.error(`[main ${y()}]`,i,...s))}dispose(){}flush(){}}e.ConsoleMainLogger=w;class u extends P{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i)}trace(i,...s){this.getLevel()<=f.Trace&&console.log("%cTRACE","color: #888",i,...s)}debug(i,...s){this.getLevel()<=f.Debug&&console.log("%cDEBUG","background: #eee; color: #888",i,...s)}info(i,...s){this.getLevel()<=f.Info&&console.log("%c INFO","color: #33f",i,...s)}warn(i,...s){this.getLevel()<=f.Warning&&console.log("%c WARN","color: #993",i,...s)}error(i,...s){this.getLevel()<=f.Error&&console.log("%c  ERR","color: #f33",i,...s)}critical(i,...s){this.getLevel()<=f.Critical&&console.log("%cCRITI","background: #f33; color: white",i,...s)}dispose(){}flush(){}}e.ConsoleLogger=u;class m extends P{constructor(i,s=e.DEFAULT_LOG_LEVEL){super();this.adapter=i,this.setLevel(s)}trace(i,...s){this.getLevel()<=f.Trace&&this.adapter.log(f.Trace,[this.extractMessage(i),...s])}debug(i,...s){this.getLevel()<=f.Debug&&this.adapter.log(f.Debug,[this.extractMessage(i),...s])}info(i,...s){this.getLevel()<=f.Info&&this.adapter.log(f.Info,[this.extractMessage(i),...s])}warn(i,...s){this.getLevel()<=f.Warning&&this.adapter.log(f.Warning,[this.extractMessage(i),...s])}error(i,...s){this.getLevel()<=f.Error&&this.adapter.log(f.Error,[this.extractMessage(i),...s])}critical(i,...s){this.getLevel()<=f.Critical&&this.adapter.log(f.Critical,[this.extractMessage(i),...s])}extractMessage(i){return typeof i=="string"?i:(0,b.toErrorMessage)(i,this.getLevel()<=f.Trace)}dispose(){}flush(){}}e.AdapterLogger=m;class g extends P{constructor(i){super();this.logServices=i,i.length&&this.setLevel(i[0].getLevel())}setLevel(i){for(const s of this.logServices)s.setLevel(i);super.setLevel(i)}trace(i,...s){for(const o of this.logServices)o.trace(i,...s)}debug(i,...s){for(const o of this.logServices)o.debug(i,...s)}info(i,...s){for(const o of this.logServices)o.info(i,...s)}warn(i,...s){for(const o of this.logServices)o.warn(i,...s)}error(i,...s){for(const o of this.logServices)o.error(i,...s)}critical(i,...s){for(const o of this.logServices)o.critical(i,...s)}flush(){for(const i of this.logServices)i.flush()}dispose(){for(const i of this.logServices)i.dispose()}}e.MultiplexLogService=g;class I extends R.Disposable{constructor(i){super();this.logger=i,this._register(i)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(i){this.logger.setLevel(i)}getLevel(){return this.logger.getLevel()}trace(i,...s){this.logger.trace(i,...s)}debug(i,...s){this.logger.debug(i,...s)}info(i,...s){this.logger.info(i,...s)}warn(i,...s){this.logger.warn(i,...s)}error(i,...s){this.logger.error(i,...s)}critical(i,...s){this.logger.critical(i,...s)}flush(){this.logger.flush()}}e.LogService=I;class p extends R.Disposable{constructor(i,s){super();this.logLevel=i,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(s(o=>{this.logLevel=o,this.logLevelChangeableLoggers.forEach(a=>a.setLevel(o))}))}getLogger(i){return this.loggers.get(i.toString())}createLogger(i,s){let o=this.loggers.get(i.toString());return o||(o=this.doCreateLogger(i,s?.always?f.Trace:this.logLevel,s),this.loggers.set(i.toString(),o),s?.always||this.logLevelChangeableLoggers.push(o)),o}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(i=>i.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=p;class d{constructor(){this.onDidChangeLogLevel=new t.Emitter().event}setLevel(i){}getLevel(){return f.Info}trace(i,...s){}debug(i,...s){}info(i,...s){}warn(i,...s){}error(i,...s){}critical(i,...s){}dispose(){}flush(){}}e.NullLogService=d;function h(r){if(r.verbose)return f.Trace;if(typeof r.logLevel=="string"){const i=l(r.logLevel.toLowerCase());if(i!==void 0)return i}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=h;function l(r){switch(r){case"trace":return f.Trace;case"debug":return f.Debug;case"info":return f.Info;case"warn":return f.Warning;case"error":return f.Error;case"critical":return f.Critical;case"off":return f.Off}}e.parseLogLevel=l;function n(r){switch(r){case f.Trace:return"trace";case f.Debug:return"debug";case f.Info:return"info";case f.Warning:return"warn";case f.Error:return"error";case f.Critical:return"critical";case f.Off:return"off"}}e.LogLevelToString=n});var ee=this&&this.__param||function(z,e){return function(b,t){e(b,t,z)}};define(J[189],Z([0,1,68,3,2,6,4]),function(z,e,b,t,R,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseCredentialsMainService=void 0;let y=class St extends R.Disposable{constructor(v){super();this.logService=v,this._onDidChangePassword=this._register(new t.Emitter),this.onDidChangePassword=this._onDidChangePassword.event}async getPassword(v,E){let P;try{P=await this.withKeytar()}catch{return null}const S=await P.getPassword(v,E);if(S)try{let{content:w,hasNextChunk:u}=JSON.parse(S);if(!w||!u)return S;let m=1;for(;u;){const g=await P.getPassword(v,`${E}-${m}`),I=JSON.parse(g);w+=I.content,u=I.hasNextChunk,m++}return w}catch{return S}return S}async setPassword(v,E,P){let S;try{S=await this.withKeytar()}catch(m){throw this.surfaceKeytarLoadError?.(m),m}const w=3,u=async(m,g,I)=>{let p=0,d;for(;p<w;)try{await S.setPassword(m,g,I);return}catch(h){d=h,this.logService.warn("Error attempting to set a password: ",h?.message??h),p++,await new Promise(l=>setTimeout(l,200))}throw d};if(D.isWindows&&P.length>St.MAX_PASSWORD_LENGTH){let m=0,g=0,I=!0;for(;I;){const p=P.substring(m,m+St.PASSWORD_CHUNK_SIZE);m+=St.PASSWORD_CHUNK_SIZE,I=P.length-m>0;const d={content:p,hasNextChunk:I};await u(v,g?`${E}-${g}`:E,JSON.stringify(d)),g++}}else await u(v,E,P);this._onDidChangePassword.fire({service:v,account:E})}async deletePassword(v,E){let P;try{P=await this.withKeytar()}catch(u){throw this.surfaceKeytarLoadError?.(u),u}const S=await P.getPassword(v,E);if(!S)return!1;const w=await P.deletePassword(v,E);try{let{content:u,hasNextChunk:m}=JSON.parse(S);if(u&&m){let g=1;for(;m;){const I=`${E}-${g}`,p=await P.getPassword(v,I);await P.deletePassword(v,I),m=JSON.parse(p).hasNextChunk,g++}}}catch{}return w&&this._onDidChangePassword.fire({service:v,account:E}),w}async findPassword(v){let E;try{E=await this.withKeytar()}catch{return null}return E.findPassword(v)}async findCredentials(v){let E;try{E=await this.withKeytar()}catch{return[]}return E.findCredentials(v)}clear(){return this._keytarCache instanceof b.InMemoryCredentialsProvider?this._keytarCache.clear():Promise.resolve()}};y.MAX_PASSWORD_LENGTH=2500,y.PASSWORD_CHUNK_SIZE=y.MAX_PASSWORD_LENGTH-100,y=de([ee(0,L.ILogService)],y),e.BaseCredentialsMainService=y}),define(J[190],Z([0,1,25,8,18,3,2,9,69,6]),function(z,e,b,t,R,L,D,y,f,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class E extends D.Disposable{constructor(S,w){super();this.logService=S,this.options=w,this._onDidChangeFile=this._register(new L.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new L.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new t.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new t.ThrottledDelayer(0))}watch(S,w){return w.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(S,w):this.watchNonRecursive(S,w)}watchUniversal(S,w){const u={path:this.toFilePath(S),excludes:w.excludes,includes:w.includes,recursive:w.recursive},m=(0,b.insert)(this.universalPathsToWatch,u);return this.refreshUniversalWatchers(),(0,D.toDisposable)(()=>{m(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(S=>(0,R.onUnexpectedError)(S))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(w=>this._onDidChangeFile.fire((0,f.toFileChanges)(w)),w=>this.onWatcherLogMessage(w),this.logService.getLevel()===v.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===v.LogLevel.Trace)})));const S=this.options?.watcher?.recursive?.usePolling;if(S===!0)for(const w of this.universalPathsToWatch)(0,f.isRecursiveWatchRequest)(w)&&(w.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(S))for(const w of this.universalPathsToWatch)(0,f.isRecursiveWatchRequest)(w)&&S.includes(w.path)&&(w.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(S,w){const u={path:this.toFilePath(S),excludes:w.excludes,includes:w.includes,recursive:!1},m=(0,b.insert)(this.nonRecursivePathsToWatch,u);return this.refreshNonRecursiveWatchers(),(0,D.toDisposable)(()=>{m(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(S=>(0,R.onUnexpectedError)(S))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(S=>this._onDidChangeFile.fire((0,f.toFileChanges)(S)),S=>this.onWatcherLogMessage(S),this.logService.getLevel()===v.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===v.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(S){S.type==="error"&&this._onDidWatchError.fire(S.message),this.logService[S.type](S.message)}toFilePath(S){return(0,y.normalize)(S.fsPath)}}e.AbstractDiskFileSystemProvider=E}),define(J[191],Z([0,1,25,8,19,22,3,65,53,2,33,11,70,16,54,150,15,101,6]),function(z,e,b,t,R,L,D,y,f,v,E,P,S,w,u,m,g,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let d=class extends v.Disposable{constructor(l){super();this.logService=l,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new D.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new D.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new D.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new D.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new D.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new D.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new t.ResourceQueue)}registerProvider(l,n){if(this.provider.has(l))throw new Error(`A filesystem provider for the scheme '${l}' is already registered.`);(0,S.mark)(`code/registerFilesystem/${l}`);const r=new v.DisposableStore;return this.provider.set(l,n),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:l,provider:n}),r.add(n.onDidChangeFile(i=>this._onDidFilesChange.fire(new g.FileChangesEvent(i,!this.isPathCaseSensitive(n))))),typeof n.onDidWatchError=="function"&&r.add(n.onDidWatchError(i=>this._onDidWatchError.fire(new Error(i)))),r.add(n.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:n,scheme:l}))),(0,v.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:l,provider:n}),this.provider.delete(l),(0,v.dispose)(r)})}getProvider(l){return this.provider.get(l)}async activateProvider(l){const n=[];this._onWillActivateFileSystemProvider.fire({scheme:l,join(r){n.push(r)}}),!this.provider.has(l)&&await t.Promises.settled(n)}async canHandleResource(l){return await this.activateProvider(l.scheme),this.hasProvider(l)}hasProvider(l){return this.provider.has(l.scheme)}hasCapability(l,n){const r=this.provider.get(l.scheme);return!!(r&&r.capabilities&n)}listCapabilities(){return f.Iterable.map(this.provider,([l,n])=>({scheme:l,capabilities:n.capabilities}))}async withProvider(l){if(!(0,w.isAbsolutePath)(l))throw new g.FileOperationError((0,m.localize)(0,null,this.resourceForError(l)),8);await this.activateProvider(l.scheme);const n=this.provider.get(l.scheme);if(!n){const r=new Error;throw r.name="ENOPRO",r.message=(0,m.localize)(1,null,l.toString()),r}return n}async withReadProvider(l){const n=await this.withProvider(l);if((0,g.hasOpenReadWriteCloseCapability)(n)||(0,g.hasReadWriteCapability)(n)||(0,g.hasFileReadStreamCapability)(n))return n;throw new Error(`Filesystem provider for scheme '${l.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(l){const n=await this.withProvider(l);if((0,g.hasOpenReadWriteCloseCapability)(n)||(0,g.hasReadWriteCapability)(n))return n;throw new Error(`Filesystem provider for scheme '${l.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(l,n){try{return await this.doResolveFile(l,n)}catch(r){throw(0,g.toFileSystemProviderErrorCode)(r)===g.FileSystemProviderErrorCode.FileNotFound?new g.FileOperationError((0,m.localize)(2,null,this.resourceForError(l)),1):(0,g.ensureFileSystemProviderError)(r)}}async doResolveFile(l,n){const r=await this.withProvider(l),i=this.isPathCaseSensitive(r),s=n?.resolveTo,o=n?.resolveSingleChildDescendants,a=n?.resolveMetadata,c=await r.stat(l);let C;return this.toFileStat(r,l,c,void 0,!!a,(k,M)=>(C||(C=E.TernarySearchTree.forUris(()=>!i),C.set(l,!0),s&&C.fill(!0,s)),C.get(k.resource)||C.findSuperstr(k.resource.with({query:null,fragment:null}))?!0:k.isDirectory&&o?M===1:!1))}async toFileStat(l,n,r,i,s,o){const{providerExtUri:a}=this.getExtUri(l),c={resource:n,name:a.basename(n),isFile:(r.type&g.FileType.File)!=0,isDirectory:(r.type&g.FileType.Directory)!=0,isSymbolicLink:(r.type&g.FileType.SymbolicLink)!=0,mtime:r.mtime,ctime:r.ctime,size:r.size,readonly:Boolean((r.permissions??0)&g.FilePermission.Readonly)||Boolean(l.capabilities&2048),etag:(0,g.etag)({mtime:r.mtime,size:r.size}),children:void 0};if(c.isDirectory&&o(c,i)){try{const C=await l.readdir(n),k=await t.Promises.settled(C.map(async([M,T])=>{try{const F=a.joinPath(n,M),q=s?await l.stat(F):{type:T};return await this.toFileStat(l,F,q,C.length,s,o)}catch(F){return this.logService.trace(F),null}}));c.children=(0,b.coalesce)(k)}catch(C){this.logService.trace(C),c.children=[]}return c}return c}async resolveAll(l){return t.Promises.settled(l.map(async n=>{try{return{stat:await this.doResolveFile(n.resource,n.options),success:!0}}catch(r){return this.logService.trace(r),{stat:void 0,success:!1}}}))}async stat(l){const n=await this.withProvider(l),r=await n.stat(l);return this.toFileStat(n,l,r,void 0,!0,()=>!1)}async exists(l){const n=await this.withProvider(l);try{return!!await n.stat(l)}catch{return!1}}async canCreateFile(l,n){try{await this.doValidateCreateFile(l,n)}catch(r){return r}return!0}async doValidateCreateFile(l,n){if(!n?.overwrite&&await this.exists(l))throw new g.FileOperationError((0,m.localize)(3,null,this.resourceForError(l)),3,n)}async createFile(l,n=R.VSBuffer.fromString(""),r){await this.doValidateCreateFile(l,r);const i=await this.writeFile(l,n);return this._onDidRunOperation.fire(new g.FileOperationEvent(l,0,i)),i}async writeFile(l,n,r){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),{providerExtUri:s}=this.getExtUri(i);try{await this.validateWriteFile(i,l,r)||await this.mkdirp(i,s.dirname(l));let a;if((0,g.hasReadWriteCapability)(i)&&!(n instanceof R.VSBuffer))if((0,u.isReadableStream)(n)){const c=await(0,u.peekStream)(n,3);c.ended?a=R.VSBuffer.concat(c.buffer):a=c}else a=(0,u.peekReadable)(n,c=>R.VSBuffer.concat(c),3);else a=n;!(0,g.hasOpenReadWriteCloseCapability)(i)||(0,g.hasReadWriteCapability)(i)&&a instanceof R.VSBuffer?await this.doWriteUnbuffered(i,l,r,a):await this.doWriteBuffered(i,l,r,a instanceof R.VSBuffer?(0,R.bufferToReadable)(a):a),this._onDidRunOperation.fire(new g.FileOperationEvent(l,4))}catch(o){throw new g.FileOperationError((0,m.localize)(4,null,this.resourceForError(l),(0,g.ensureFileSystemProviderError)(o).toString()),(0,g.toFileOperationResult)(o),r)}return this.resolve(l,{resolveMetadata:!0})}async validateWriteFile(l,n,r){if(!!r?.unlock&&!(l.capabilities&8192))throw new Error((0,m.localize)(5,null,this.resourceForError(n)));let s;try{s=await l.stat(n)}catch{return}if((s.type&g.FileType.Directory)!=0)throw new g.FileOperationError((0,m.localize)(6,null,this.resourceForError(n)),0,r);if(this.throwIfFileIsReadonly(n,s),typeof r?.mtime=="number"&&typeof r.etag=="string"&&r.etag!==g.ETAG_DISABLED&&typeof s.mtime=="number"&&typeof s.size=="number"&&r.mtime<s.mtime&&r.etag!==(0,g.etag)({mtime:r.mtime,size:s.size}))throw new g.FileOperationError((0,m.localize)(7,null),3,r);return s}async readFile(l,n,r){const i=await this.withReadProvider(l);return n?.atomic?this.doReadFileAtomic(i,l,n,r):this.doReadFile(i,l,n,r)}async doReadFileAtomic(l,n,r,i){return new Promise((s,o)=>{this.writeQueue.queueFor(n,this.getExtUri(l).providerExtUri).queue(async()=>{try{const a=await this.doReadFile(l,n,r,i);s(a)}catch(a){o(a)}})})}async doReadFile(l,n,r,i){const s=await this.doReadFileStream(l,n,{...r,preferUnbuffered:!0},i);return{...s,value:await(0,R.streamToBuffer)(s.value)}}async readFileStream(l,n,r){const i=await this.withReadProvider(l);return this.doReadFileStream(i,l,n,r)}async doReadFileStream(l,n,r,i){const s=new L.CancellationTokenSource(i),o=this.validateReadFile(n,r).then(c=>c,c=>{throw s.cancel(),c});let a;try{return typeof r?.etag=="string"&&r.etag!==g.ETAG_DISABLED&&await o,r?.atomic&&(0,g.hasFileAtomicReadCapability)(l)||!((0,g.hasOpenReadWriteCloseCapability)(l)||(0,g.hasFileReadStreamCapability)(l))||(0,g.hasReadWriteCapability)(l)&&r?.preferUnbuffered?a=this.readFileUnbuffered(l,n,r):(0,g.hasFileReadStreamCapability)(l)?a=this.readFileStreamed(l,n,s.token,r):a=this.readFileBuffered(l,n,s.token,r),{...await o,value:a}}catch(c){a&&await(0,u.consumeStream)(a);const C=(0,m.localize)(8,null,this.resourceForError(n),(0,g.ensureFileSystemProviderError)(c).toString());throw c instanceof g.NotModifiedSinceFileOperationError?new g.NotModifiedSinceFileOperationError(C,c.stat,r):new g.FileOperationError(C,(0,g.toFileOperationResult)(c),r)}}readFileStreamed(l,n,r,i=Object.create(null)){const s=l.readFileStream(n,i,r);return(0,u.transform)(s,{data:o=>o instanceof R.VSBuffer?o:R.VSBuffer.wrap(o),error:o=>new g.FileOperationError((0,m.localize)(9,null,this.resourceForError(n),(0,g.ensureFileSystemProviderError)(o).toString()),(0,g.toFileOperationResult)(o),i)},o=>R.VSBuffer.concat(o))}readFileBuffered(l,n,r,i=Object.create(null)){const s=(0,R.newWriteableBufferStream)();return(0,I.readFileIntoStream)(l,n,s,o=>o,{...i,bufferSize:this.BUFFER_SIZE,errorTransformer:o=>new g.FileOperationError((0,m.localize)(10,null,this.resourceForError(n),(0,g.ensureFileSystemProviderError)(o).toString()),(0,g.toFileOperationResult)(o),i)},r),s}readFileUnbuffered(l,n,r){const i=(0,u.newWriteableStream)(s=>R.VSBuffer.concat(s));return(async()=>{try{let s;r?.atomic&&(0,g.hasFileAtomicReadCapability)(l)?s=await l.readFile(n,{atomic:!0}):s=await l.readFile(n),typeof r?.position=="number"&&(s=s.slice(r.position)),typeof r?.length=="number"&&(s=s.slice(0,r.length)),this.validateReadFileLimits(n,s.byteLength,r),i.end(R.VSBuffer.wrap(s))}catch(s){i.error(s),i.end()}})(),i}async validateReadFile(l,n){const r=await this.resolve(l,{resolveMetadata:!0});if(r.isDirectory)throw new g.FileOperationError((0,m.localize)(11,null,this.resourceForError(l)),0,n);if(typeof n?.etag=="string"&&n.etag!==g.ETAG_DISABLED&&n.etag===r.etag)throw new g.NotModifiedSinceFileOperationError((0,m.localize)(12,null),r,n);return this.validateReadFileLimits(l,r.size,n),r}validateReadFileLimits(l,n,r){if(r?.limits){let i;if(typeof r.limits.memory=="number"&&n>r.limits.memory&&(i=9),typeof r.limits.size=="number"&&n>r.limits.size&&(i=7),typeof i=="number")throw new g.FileOperationError((0,m.localize)(13,null,this.resourceForError(l)),i)}}async canMove(l,n,r){return this.doCanMoveCopy(l,n,"move",r)}async canCopy(l,n,r){return this.doCanMoveCopy(l,n,"copy",r)}async doCanMoveCopy(l,n,r,i){if(l.toString()!==n.toString())try{const s=r==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l):await this.withReadProvider(l),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n);await this.doValidateMoveCopy(s,l,o,n,r,i)}catch(s){return s}return!0}async move(l,n,r){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n),o=await this.doMoveCopy(i,l,s,n,"move",!!r),a=await this.resolve(n,{resolveMetadata:!0});return this._onDidRunOperation.fire(new g.FileOperationEvent(l,o==="move"?2:3,a)),a}async copy(l,n,r){const i=await this.withReadProvider(l),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n),o=await this.doMoveCopy(i,l,s,n,"copy",!!r),a=await this.resolve(n,{resolveMetadata:!0});return this._onDidRunOperation.fire(new g.FileOperationEvent(l,o==="copy"?3:2,a)),a}async doMoveCopy(l,n,r,i,s,o){if(n.toString()===i.toString())return s;const{exists:a,isSameResourceWithDifferentPathCase:c}=await this.doValidateMoveCopy(l,n,r,i,s,o);if(a&&!c&&o&&await this.del(i,{recursive:!0}),await this.mkdirp(r,this.getExtUri(r).providerExtUri.dirname(i)),s==="copy"){if(l===r&&(0,g.hasFileFolderCopyCapability)(l))await l.copy(n,i,{overwrite:o});else{const C=await this.resolve(n);C.isDirectory?await this.doCopyFolder(l,C,r,i):await this.doCopyFile(l,n,r,i)}return s}else return l===r?(await l.rename(n,i,{overwrite:o}),s):(await this.doMoveCopy(l,n,r,i,"copy",o),await this.del(n,{recursive:!0}),"copy")}async doCopyFile(l,n,r,i){if((0,g.hasOpenReadWriteCloseCapability)(l)&&(0,g.hasOpenReadWriteCloseCapability)(r))return this.doPipeBuffered(l,n,r,i);if((0,g.hasOpenReadWriteCloseCapability)(l)&&(0,g.hasReadWriteCapability)(r))return this.doPipeBufferedToUnbuffered(l,n,r,i);if((0,g.hasReadWriteCapability)(l)&&(0,g.hasOpenReadWriteCloseCapability)(r))return this.doPipeUnbufferedToBuffered(l,n,r,i);if((0,g.hasReadWriteCapability)(l)&&(0,g.hasReadWriteCapability)(r))return this.doPipeUnbuffered(l,n,r,i)}async doCopyFolder(l,n,r,i){await r.mkdir(i),Array.isArray(n.children)&&await t.Promises.settled(n.children.map(async s=>{const o=this.getExtUri(r).providerExtUri.joinPath(i,s.name);return s.isDirectory?this.doCopyFolder(l,await this.resolve(s.resource),r,o):this.doCopyFile(l,s.resource,r,o)}))}async doValidateMoveCopy(l,n,r,i,s,o){let a=!1;if(l===r){const{providerExtUri:C,isPathCaseSensitive:k}=this.getExtUri(l);if(k||(a=C.isEqual(n,i)),a&&s==="copy")throw new Error((0,m.localize)(14,null,this.resourceForError(n),this.resourceForError(i)));if(!a&&C.isEqualOrParent(i,n))throw new Error((0,m.localize)(15,null,this.resourceForError(n),this.resourceForError(i)))}const c=await this.exists(i);if(c&&!a){if(!o)throw new g.FileOperationError((0,m.localize)(16,null,this.resourceForError(n),this.resourceForError(i)),4);if(l===r){const{providerExtUri:C}=this.getExtUri(l);if(C.isEqualOrParent(n,i))throw new Error((0,m.localize)(17,null,this.resourceForError(n),this.resourceForError(i)))}}return{exists:c,isSameResourceWithDifferentPathCase:a}}getExtUri(l){const n=this.isPathCaseSensitive(l);return{providerExtUri:n?w.extUri:w.extUriIgnorePathCase,isPathCaseSensitive:n}}isPathCaseSensitive(l){return!!(l.capabilities&1024)}async createFolder(l){const n=this.throwIfFileSystemIsReadonly(await this.withProvider(l),l);await this.mkdirp(n,l);const r=await this.resolve(l,{resolveMetadata:!0});return this._onDidRunOperation.fire(new g.FileOperationEvent(l,0,r)),r}async mkdirp(l,n){const r=[],{providerExtUri:i}=this.getExtUri(l);for(;!i.isEqual(n,i.dirname(n));)try{if(((await l.stat(n)).type&g.FileType.Directory)==0)throw new Error((0,m.localize)(18,null,this.resourceForError(n)));break}catch(s){if((0,g.toFileSystemProviderErrorCode)(s)!==g.FileSystemProviderErrorCode.FileNotFound)throw s;r.push(i.basename(n)),n=i.dirname(n)}for(let s=r.length-1;s>=0;s--){n=i.joinPath(n,r[s]);try{await l.mkdir(n)}catch(o){if((0,g.toFileSystemProviderErrorCode)(o)!==g.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(l,n){try{await this.doValidateDelete(l,n)}catch(r){return r}return!0}async doValidateDelete(l,n){const r=this.throwIfFileSystemIsReadonly(await this.withProvider(l),l);if(!!n?.useTrash&&!(r.capabilities&4096))throw new Error((0,m.localize)(19,null,this.resourceForError(l)));let s;try{s=await r.stat(l)}catch{}if(s)this.throwIfFileIsReadonly(l,s);else throw new g.FileOperationError((0,m.localize)(20,null,this.resourceForError(l)),1);if(!!!n?.recursive){const a=await this.resolve(l);if(a.isDirectory&&Array.isArray(a.children)&&a.children.length>0)throw new Error((0,m.localize)(21,null,this.resourceForError(l)))}return r}async del(l,n){const r=await this.doValidateDelete(l,n),i=!!n?.useTrash,s=!!n?.recursive;await r.delete(l,{recursive:s,useTrash:i}),this._onDidRunOperation.fire(new g.FileOperationEvent(l,1))}async cloneFile(l,n){const r=await this.withProvider(l),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n);if(r===i&&this.getExtUri(r).providerExtUri.isEqual(l,n))return;if(r===i&&(0,g.hasFileCloneCapability)(r))return r.cloneFile(l,n);await this.mkdirp(i,this.getExtUri(i).providerExtUri.dirname(n));const s=this.writeQueue.queueFor(l,this.getExtUri(r).providerExtUri);return r===i&&(0,g.hasFileFolderCopyCapability)(r)?s.queue(()=>r.copy(l,n,{overwrite:!0})):s.queue(()=>this.doCopyFile(r,l,i,n))}watch(l,n={recursive:!1,excludes:[]}){const r=new v.DisposableStore;let i=!1,s=()=>{i=!0};return r.add((0,v.toDisposable)(()=>s())),(async()=>{try{const o=await this.doWatch(l,n);i?(0,v.dispose)(o):s=()=>(0,v.dispose)(o)}catch(o){this.logService.error(o)}})(),r}async doWatch(l,n){const r=await this.withProvider(l),i=(0,y.hash)([this.getExtUri(r).providerExtUri.getComparisonKey(l),n]);let s=this.activeWatchers.get(i);return s||(s={count:0,disposable:r.watch(l,n)},this.activeWatchers.set(i,s)),s.count+=1,(0,v.toDisposable)(()=>{s&&(s.count--,s.count===0&&((0,v.dispose)(s.disposable),this.activeWatchers.delete(i)))})}dispose(){super.dispose();for(const[,l]of this.activeWatchers)(0,v.dispose)(l.disposable);this.activeWatchers.clear()}async doWriteBuffered(l,n,r,i){return this.writeQueue.queueFor(n,this.getExtUri(l).providerExtUri).queue(async()=>{const s=await l.open(n,{create:!0,unlock:r?.unlock??!1});try{(0,u.isReadableStream)(i)||(0,u.isReadableBufferedStream)(i)?await this.doWriteStreamBufferedQueued(l,s,i):await this.doWriteReadableBufferedQueued(l,s,i)}catch(o){throw(0,g.ensureFileSystemProviderError)(o)}finally{await l.close(s)}})}async doWriteStreamBufferedQueued(l,n,r){let i=0,s;if((0,u.isReadableBufferedStream)(r)){if(r.buffer.length>0){const o=R.VSBuffer.concat(r.buffer);await this.doWriteBuffer(l,n,o,o.byteLength,i,0),i+=o.byteLength}if(r.ended)return;s=r.stream}else s=r;return new Promise((o,a)=>{(0,u.listenStream)(s,{onData:async c=>{s.pause();try{await this.doWriteBuffer(l,n,c,c.byteLength,i,0)}catch(C){return a(C)}i+=c.byteLength,setTimeout(()=>s.resume())},onError:c=>a(c),onEnd:()=>o()})})}async doWriteReadableBufferedQueued(l,n,r){let i=0,s;for(;(s=r.read())!==null;)await this.doWriteBuffer(l,n,s,s.byteLength,i,0),i+=s.byteLength}async doWriteBuffer(l,n,r,i,s,o){let a=0;for(;a<i;)a+=await l.write(n,s+a,r.buffer,o+a,i-a)}async doWriteUnbuffered(l,n,r,i){return this.writeQueue.queueFor(n,this.getExtUri(l).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(l,n,r,i))}async doWriteUnbufferedQueued(l,n,r,i){let s;i instanceof R.VSBuffer?s=i:(0,u.isReadableStream)(i)?s=await(0,R.streamToBuffer)(i):(0,u.isReadableBufferedStream)(i)?s=await(0,R.bufferedStreamToBuffer)(i):s=(0,R.readableToBuffer)(i),await l.writeFile(n,s.buffer,{create:!0,overwrite:!0,unlock:r?.unlock??!1})}async doPipeBuffered(l,n,r,i){return this.writeQueue.queueFor(i,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeBufferedQueued(l,n,r,i))}async doPipeBufferedQueued(l,n,r,i){let s,o;try{s=await l.open(n,{create:!1}),o=await r.open(i,{create:!0,unlock:!1});const a=R.VSBuffer.alloc(this.BUFFER_SIZE);let c=0,C=0,k=0;do k=await l.read(s,c,a.buffer,C,a.byteLength-C),await this.doWriteBuffer(r,o,a,k,c,C),c+=k,C+=k,C===a.byteLength&&(C=0);while(k>0)}catch(a){throw(0,g.ensureFileSystemProviderError)(a)}finally{await t.Promises.settled([typeof s=="number"?l.close(s):Promise.resolve(),typeof o=="number"?r.close(o):Promise.resolve()])}}async doPipeUnbuffered(l,n,r,i){return this.writeQueue.queueFor(i,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(l,n,r,i))}async doPipeUnbufferedQueued(l,n,r,i){return r.writeFile(i,await l.readFile(n),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(l,n,r,i){return this.writeQueue.queueFor(i,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(l,n,r,i))}async doPipeUnbufferedToBufferedQueued(l,n,r,i){const s=await r.open(i,{create:!0,unlock:!1});try{const o=await l.readFile(n);await this.doWriteBuffer(r,s,R.VSBuffer.wrap(o),o.byteLength,0,0)}catch(o){throw(0,g.ensureFileSystemProviderError)(o)}finally{await r.close(s)}}async doPipeBufferedToUnbuffered(l,n,r,i){const s=await(0,R.streamToBuffer)(this.readFileBuffered(l,n,L.CancellationToken.None));await this.doWriteUnbuffered(r,i,void 0,s)}throwIfFileSystemIsReadonly(l,n){if(l.capabilities&2048)throw new g.FileOperationError((0,m.localize)(22,null,this.resourceForError(n)),6);return l}throwIfFileIsReadonly(l,n){if((n.permissions??0)&g.FilePermission.Readonly)throw new g.FileOperationError((0,m.localize)(23,null,this.resourceForError(l)),6)}resourceForError(l){return l.scheme===P.Schemas.file?l.fsPath:l.toString(!0)}};d=de([ee(0,p.ILogService)],d),e.FileService=d}),define(J[84],Z([0,1,28,260,8,33,19,3,29,2,9,4,16,54,23,154,15,101,190,41,187,186]),function(z,e,b,t,R,L,D,y,f,v,E,P,S,w,u,m,g,I,p,d,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,t.gracefulify)(b)}catch(r){console.error(`Error enabling graceful-fs: ${(0,d.toErrorMessage)(r)}`)}})();class n extends p.AbstractDiskFileSystemProvider{constructor(i,s){super(i,s);this.onDidChangeCapabilities=y.Event.None,this.resourceLocks=new L.ResourceMap(o=>S.extUriBiasedIgnorePathCase.getComparisonKey(o)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map,this.canFlush=!0}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384|32768,P.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(i){try{const{stat:s,symbolicLink:o}=await u.SymlinkSupport.stat(this.toFilePath(i));return{type:this.toType(s,o),ctime:s.birthtime.getTime(),mtime:s.mtime.getTime(),size:s.size}}catch(s){throw this.toFileSystemProviderError(s)}}async readdir(i){try{const s=await u.Promises.readdir(this.toFilePath(i),{withFileTypes:!0}),o=[];return await Promise.all(s.map(async a=>{try{let c;a.isSymbolicLink()?c=(await this.stat((0,S.joinPath)(i,a.name))).type:c=this.toType(a),o.push([a.name,c])}catch(c){this.logService.trace(c)}})),o}catch(s){throw this.toFileSystemProviderError(s)}}toType(i,s){let o;return s?.dangling?o=g.FileType.Unknown:i.isFile()?o=g.FileType.File:i.isDirectory()?o=g.FileType.Directory:o=g.FileType.Unknown,s&&(o|=g.FileType.SymbolicLink),o}async createResourceLock(i){const s=this.toFilePath(i);this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${s})`);let o;for(;o=this.resourceLocks.get(i);)this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${s})`),await o.wait();const a=new R.Barrier;return this.resourceLocks.set(i,a),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${s})`),(0,v.toDisposable)(()=>{this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${s})`),this.resourceLocks.get(i)===a&&(this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${s})`),this.resourceLocks.delete(i)),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${s})`),a.open()})}async readFile(i,s){let o;try{s?.atomic&&(this.logService.trace(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(i)})`),o=await this.createResourceLock(i));const a=this.toFilePath(i);return await u.Promises.readFile(a)}catch(a){throw this.toFileSystemProviderError(a)}finally{o?.dispose()}}readFileStream(i,s,o){const a=(0,w.newWriteableStream)(c=>D.VSBuffer.concat(c.map(C=>D.VSBuffer.wrap(C))).buffer);return(0,I.readFileIntoStream)(this,i,a,c=>c.buffer,{...s,bufferSize:256*1024},o),a}async writeFile(i,s,o){let a;try{const c=this.toFilePath(i);if(!o.create||!o.overwrite){if(await u.Promises.exists(c)){if(!o.overwrite)throw(0,g.createFileSystemProviderError)((0,m.localize)(0,null),g.FileSystemProviderErrorCode.FileExists)}else if(!o.create)throw(0,g.createFileSystemProviderError)((0,m.localize)(1,null),g.FileSystemProviderErrorCode.FileNotFound)}a=await this.open(i,{create:!0,unlock:o.unlock}),await this.write(a,0,s,0,s.byteLength)}catch(c){throw await this.toFileSystemProviderWriteError(i,c)}finally{typeof a=="number"&&await this.close(a)}}async open(i,s){const o=this.toFilePath(i);let a;(0,g.isFileOpenForWriteOptions)(s)&&(a=await this.createResourceLock(i));let c;try{if((0,g.isFileOpenForWriteOptions)(s)&&s.unlock)try{const{stat:k}=await u.SymlinkSupport.stat(o);k.mode&128||await u.Promises.chmod(o,k.mode|128)}catch(k){this.logService.trace(k)}let C;if((0,g.isFileOpenForWriteOptions)(s)){if(P.isWindows)try{await u.Promises.truncate(o,0),C="r+"}catch(k){k.code!=="ENOENT"&&this.logService.trace(k)}C||(C="w")}else C="r";c=await u.Promises.open(o,C)}catch(C){throw a?.dispose(),(0,g.isFileOpenForWriteOptions)(s)?await this.toFileSystemProviderWriteError(i,C):this.toFileSystemProviderError(C)}if(this.mapHandleToPos.set(c,0),(0,g.isFileOpenForWriteOptions)(s)&&this.writeHandles.set(c,i),a){const C=this.mapHandleToLock.get(c);this.logService.trace(`[Disk FileSystemProvider]: open() - storing lock for handle ${c} (${o})`),this.mapHandleToLock.set(c,a),C&&(this.logService.trace(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${c} (${o})`),C.dispose())}return c}async close(i){const s=this.mapHandleToLock.get(i);try{if(this.mapHandleToPos.delete(i),this.writeHandles.delete(i)&&this.canFlush)try{await u.Promises.fdatasync(i)}catch(o){this.canFlush=!1,this.logService.error(o)}return await u.Promises.close(i)}catch(o){throw this.toFileSystemProviderError(o)}finally{s&&(this.mapHandleToLock.get(i)===s&&(this.logService.trace(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${i}`),this.mapHandleToLock.delete(i)),this.logService.trace(`[Disk FileSystemProvider]: close() - disposing lock for handle ${i}`),s.dispose())}}async read(i,s,o,a,c){const C=this.normalizePos(i,s);let k=null;try{k=(await u.Promises.read(i,o,a,c,C)).bytesRead}catch(M){throw this.toFileSystemProviderError(M)}finally{this.updatePos(i,C,k)}return k}normalizePos(i,s){return s===this.mapHandleToPos.get(i)?null:s}updatePos(i,s,o){const a=this.mapHandleToPos.get(i);typeof a=="number"&&(typeof s=="number"||(typeof o=="number"?this.mapHandleToPos.set(i,a+o):this.mapHandleToPos.delete(i)))}async write(i,s,o,a,c){return(0,R.retry)(()=>this.doWrite(i,s,o,a,c),100,3)}async doWrite(i,s,o,a,c){const C=this.normalizePos(i,s);let k=null;try{k=(await u.Promises.write(i,o,a,c,C)).bytesWritten}catch(M){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(i),M)}finally{this.updatePos(i,C,k)}return k}async mkdir(i){try{await u.Promises.mkdir(this.toFilePath(i))}catch(s){throw this.toFileSystemProviderError(s)}}async delete(i,s){try{const o=this.toFilePath(i);s.recursive?await u.Promises.rm(o,u.RimRafMode.MOVE):await u.Promises.unlink(o)}catch(o){throw this.toFileSystemProviderError(o)}}async rename(i,s,o){const a=this.toFilePath(i),c=this.toFilePath(s);if(a!==c)try{await this.validateTargetDeleted(i,s,"move",o.overwrite),await u.Promises.move(a,c)}catch(C){throw(C.code==="EINVAL"||C.code==="EBUSY"||C.code==="ENAMETOOLONG")&&(C=new Error((0,m.localize)(2,null,(0,E.basename)(a),(0,E.basename)((0,E.dirname)(c)),C.toString()))),this.toFileSystemProviderError(C)}}async copy(i,s,o){const a=this.toFilePath(i),c=this.toFilePath(s);if(a!==c)try{await this.validateTargetDeleted(i,s,"copy",o.overwrite),await u.Promises.copy(a,c,{preserveSymlinks:!0})}catch(C){throw(C.code==="EINVAL"||C.code==="EBUSY"||C.code==="ENAMETOOLONG")&&(C=new Error((0,m.localize)(3,null,(0,E.basename)(a),(0,E.basename)((0,E.dirname)(c)),C.toString()))),this.toFileSystemProviderError(C)}}async validateTargetDeleted(i,s,o,a){const c=this.toFilePath(i),C=this.toFilePath(s);let k=!1;if(!!(this.capabilities&1024)||(k=(0,f.isEqual)(c,C,!0)),k&&o==="copy")throw(0,g.createFileSystemProviderError)((0,m.localize)(4,null),g.FileSystemProviderErrorCode.FileExists);if(!k&&await u.Promises.exists(C)){if(!a)throw(0,g.createFileSystemProviderError)((0,m.localize)(5,null),g.FileSystemProviderErrorCode.FileExists);await this.delete(s,{recursive:!0,useTrash:!1})}}async cloneFile(i,s){return this.doCloneFile(i,s,!1)}async doCloneFile(i,s,o){const a=this.toFilePath(i),c=this.toFilePath(s),C=!!(this.capabilities&1024);if((0,f.isEqual)(a,c,!C))return;const k=new v.DisposableStore;try{const[M,T]=await Promise.all([this.createResourceLock(i),this.createResourceLock(s)]);k.add(M),k.add(T),o&&await u.Promises.mkdir((0,E.dirname)(c),{recursive:!0}),await u.Promises.copyFile(a,c)}catch(M){if(M.code==="ENOENT"&&!o)return this.doCloneFile(i,s,!0);throw this.toFileSystemProviderError(M)}finally{k.dispose()}}createUniversalWatcher(i,s,o){return new h.UniversalWatcherClient(a=>i(a),a=>s(a),o)}createNonRecursiveWatcher(i,s,o){return new l.NodeJSWatcherClient(a=>i(a),a=>s(a),o)}toFileSystemProviderError(i){if(i instanceof g.FileSystemProviderError)return i;let s;switch(i.code){case"ENOENT":s=g.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":s=g.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":s=g.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":s=g.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":s=g.FileSystemProviderErrorCode.NoPermissions;break;default:s=g.FileSystemProviderErrorCode.Unknown}return(0,g.createFileSystemProviderError)(i,s)}async toFileSystemProviderWriteError(i,s){let o=this.toFileSystemProviderError(s);if(i&&o.code===g.FileSystemProviderErrorCode.NoPermissions)try{const{stat:a}=await u.SymlinkSupport.stat(this.toFilePath(i));a.mode&128||(o=(0,g.createFileSystemProviderError)(s,g.FileSystemProviderErrorCode.FileWriteLocked))}catch(a){this.logService.trace(a)}return o}}e.DiskFileSystemProvider=n}),define(J[192],Z([0,1,3,84,2,19,54,22]),function(z,e,b,t,R,L,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSessionFileWatcher=e.AbstractDiskFileSystemProviderChannel=void 0;class f extends R.Disposable{constructor(P,S){super();this.provider=P,this.logService=S,this.sessionToWatcher=new Map,this.watchRequests=new Map}call(P,S,w){const u=this.getUriTransformer(P);switch(S){case"stat":return this.stat(u,w[0]);case"readdir":return this.readdir(u,w[0]);case"open":return this.open(u,w[0],w[1]);case"close":return this.close(w[0]);case"read":return this.read(w[0],w[1],w[2]);case"readFile":return this.readFile(u,w[0],w[1]);case"write":return this.write(w[0],w[1],w[2],w[3],w[4]);case"writeFile":return this.writeFile(u,w[0],w[1],w[2]);case"rename":return this.rename(u,w[0],w[1],w[2]);case"copy":return this.copy(u,w[0],w[1],w[2]);case"cloneFile":return this.cloneFile(u,w[0],w[1]);case"mkdir":return this.mkdir(u,w[0]);case"delete":return this.delete(u,w[0],w[1]);case"watch":return this.watch(u,w[0],w[1],w[2],w[3]);case"unwatch":return this.unwatch(w[0],w[1])}throw new Error(`IPC Command ${S} not found`)}listen(P,S,w){const u=this.getUriTransformer(P);switch(S){case"fileChange":return this.onFileChange(u,w[0]);case"readFileStream":return this.onReadFileStream(u,w[0],w[1])}throw new Error(`Unknown event ${S}`)}stat(P,S){const w=this.transformIncoming(P,S,!0);return this.provider.stat(w)}readdir(P,S){const w=this.transformIncoming(P,S);return this.provider.readdir(w)}async readFile(P,S,w){const u=this.transformIncoming(P,S,!0),m=await this.provider.readFile(u,w);return L.VSBuffer.wrap(m)}onReadFileStream(P,S,w){const u=this.transformIncoming(P,S,!0),m=new y.CancellationTokenSource,g=new b.Emitter({onLastListenerRemove:()=>{m.cancel()}}),I=this.provider.readFileStream(u,w,m.token);return(0,D.listenStream)(I,{onData:p=>g.fire(L.VSBuffer.wrap(p)),onError:p=>g.fire(p),onEnd:()=>{g.fire("end"),g.dispose(),m.dispose()}}),g.event}writeFile(P,S,w,u){const m=this.transformIncoming(P,S);return this.provider.writeFile(m,w.buffer,u)}open(P,S,w){const u=this.transformIncoming(P,S,!0);return this.provider.open(u,w)}close(P){return this.provider.close(P)}async read(P,S,w){const u=L.VSBuffer.alloc(w),m=0,g=await this.provider.read(P,S,u.buffer,m,w);return[u,g]}write(P,S,w,u,m){return this.provider.write(P,S,w.buffer,u,m)}mkdir(P,S){const w=this.transformIncoming(P,S);return this.provider.mkdir(w)}delete(P,S,w){const u=this.transformIncoming(P,S);return this.provider.delete(u,w)}rename(P,S,w,u){const m=this.transformIncoming(P,S),g=this.transformIncoming(P,w);return this.provider.rename(m,g,u)}copy(P,S,w,u){const m=this.transformIncoming(P,S),g=this.transformIncoming(P,w);return this.provider.copy(m,g,u)}cloneFile(P,S,w){const u=this.transformIncoming(P,S),m=this.transformIncoming(P,w);return this.provider.cloneFile(u,m)}onFileChange(P,S){const w=new b.Emitter({onFirstListenerAdd:()=>{this.sessionToWatcher.set(S,this.createSessionFileWatcher(P,w))},onLastListenerRemove:()=>{(0,R.dispose)(this.sessionToWatcher.get(S)),this.sessionToWatcher.delete(S)}});return w.event}async watch(P,S,w,u,m){const g=this.sessionToWatcher.get(S);if(g){const I=this.transformIncoming(P,u),p=g.watch(w,I,m);this.watchRequests.set(S+w,p)}}async unwatch(P,S){const w=P+S,u=this.watchRequests.get(w);u&&((0,R.dispose)(u),this.watchRequests.delete(w))}dispose(){super.dispose();for(const[,P]of this.watchRequests)P.dispose();this.watchRequests.clear();for(const[,P]of this.sessionToWatcher)P.dispose();this.sessionToWatcher.clear()}}e.AbstractDiskFileSystemProviderChannel=f;class v extends R.Disposable{constructor(P,S,w,u){super();this.uriTransformer=P,this.logService=w,this.environmentService=u,this.watcherRequests=new Map,this.fileWatcher=this._register(new t.DiskFileSystemProvider(this.logService,{watcher:{recursive:this.getRecursiveWatcherOptions(this.environmentService)}})),this.registerListeners(S)}registerListeners(P){const S=this._register(new b.Emitter);this._register(S.event(w=>{P.fire(w.map(u=>({resource:this.uriTransformer.transformOutgoingURI(u.resource),type:u.type})))})),this._register(this.fileWatcher.onDidChangeFile(w=>S.fire(w))),this._register(this.fileWatcher.onDidWatchError(w=>P.fire(w)))}getRecursiveWatcherOptions(P){}getExtraExcludes(P){}watch(P,S,w){const u=this.getExtraExcludes(this.environmentService);return Array.isArray(u)&&(w.excludes=[...w.excludes,...u]),this.watcherRequests.set(P,this.fileWatcher.watch(S,w)),(0,R.toDisposable)(()=>{(0,R.dispose)(this.watcherRequests.get(P)),this.watcherRequests.delete(P)})}dispose(){super.dispose();for(const[,P]of this.watcherRequests)P.dispose();this.watcherRequests.clear()}}e.AbstractSessionFileWatcher=v}),define(J[193],Z([0,1,14,153,4,7,15,9,192,135]),function(z,e,b,t,R,L,D,y,f,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderChannel=void 0;class E extends f.AbstractDiskFileSystemProviderChannel{constructor(w,u,m){super(w,u);this.environmentService=m}getUriTransformer(w){return v.DefaultURITransformer}transformIncoming(w,u){return L.URI.revive(u)}async delete(w,u,m){if(!m.useTrash)return super.delete(w,u,m);const g=this.transformIncoming(w,u),I=(0,y.normalize)(g.fsPath);try{await b.shell.trashItem(I)}catch{throw(0,D.createFileSystemProviderError)(R.isWindows?(0,t.localize)(0,null,(0,y.basename)(I)):(0,t.localize)(1,null,(0,y.basename)(I)),D.FileSystemProviderErrorCode.Unknown)}}createSessionFileWatcher(w,u){return new P(w,u,this.logService,this.environmentService)}}e.DiskFileSystemProviderChannel=E;class P extends f.AbstractSessionFileWatcher{watch(w,u,m){if(m.recursive)throw(0,D.createFileSystemProviderError)("Recursive file watching is not supported from main process for performance reasons.",D.FileSystemProviderErrorCode.Unavailable);return super.watch(w,u,m)}}}),define(J[102],Z([0,1,6]),function(z,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogService=void 0;function t(L,D){switch(D){case b.LogLevel.Trace:return L.trace;case b.LogLevel.Debug:return L.debug;case b.LogLevel.Info:return L.info;case b.LogLevel.Warning:return L.warn;case b.LogLevel.Error:return L.error;case b.LogLevel.Critical:return L.critical;default:throw new Error("Invalid log level")}}class R extends b.AbstractLogger{constructor(D=b.DEFAULT_LOG_LEVEL){super();this.buffer=[],this._logger=void 0,this.setLevel(D),this._register(this.onDidChangeLogLevel(y=>{this._logger?.setLevel(y)}))}set logger(D){this._logger=D;for(const{level:y,args:f}of this.buffer)t(D,y).apply(D,f);this.buffer=[]}_log(D,...y){this._logger?t(this._logger,D).apply(this._logger,y):this.getLevel()<=D&&this.buffer.push({level:D,args:y})}trace(D,...y){this._log(b.LogLevel.Trace,D,...y)}debug(D,...y){this._log(b.LogLevel.Debug,D,...y)}info(D,...y){this._log(b.LogLevel.Info,D,...y)}warn(D,...y){this._log(b.LogLevel.Warning,D,...y)}error(D,...y){this._log(b.LogLevel.Error,D,...y)}critical(D,...y){this._log(b.LogLevel.Critical,D,...y)}dispose(){this._logger&&this._logger.dispose()}flush(){this._logger&&this._logger.flush()}}e.BufferLogService=R}),define(J[194],Z([0,1,8,19,16,15,5,102,6]),function(z,e,b,t,R,L,D,y,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileLoggerService=e.FileLogger=void 0;const v=5*L.ByteSize.MB;let E=class extends f.AbstractLogger{constructor(w,u,m,g,I){super();this.name=w,this.resource=u,this.donotUseFormatters=g,this.fileService=I,this.backupIndex=1,this.setLevel(m),this.queue=this._register(new b.Queue),this.initializePromise=this.initialize()}trace(){this.getLevel()<=f.LogLevel.Trace&&this._log(f.LogLevel.Trace,(0,f.format)(arguments))}debug(){this.getLevel()<=f.LogLevel.Debug&&this._log(f.LogLevel.Debug,(0,f.format)(arguments))}info(){this.getLevel()<=f.LogLevel.Info&&this._log(f.LogLevel.Info,(0,f.format)(arguments))}warn(){this.getLevel()<=f.LogLevel.Warning&&this._log(f.LogLevel.Warning,(0,f.format)(arguments))}error(){if(this.getLevel()<=f.LogLevel.Error){const w=arguments[0];if(w instanceof Error){const u=Array.prototype.slice.call(arguments);u[0]=w.stack,this._log(f.LogLevel.Error,(0,f.format)(u))}else this._log(f.LogLevel.Error,(0,f.format)(arguments))}}critical(){this.getLevel()<=f.LogLevel.Critical&&this._log(f.LogLevel.Critical,(0,f.format)(arguments))}flush(){}async initialize(){try{await this.fileService.createFile(this.resource)}catch(w){if(w.fileOperationResult!==3)throw w}}_log(w,u){this.queue.queue(async()=>{await this.initializePromise;let m=await this.loadContent();m.length>v&&(await this.fileService.writeFile(this.getBackupResource(),t.VSBuffer.fromString(m)),m=""),this.donotUseFormatters?m+=u:m+=`[${this.getCurrentTimestamp()}] [${this.name}] [${this.stringifyLogLevel(w)}] ${u}
`,await this.fileService.writeFile(this.resource,t.VSBuffer.fromString(m))})}getCurrentTimestamp(){const w=g=>g<10?`0${g}`:g,u=g=>g<10?`00${g}`:g<100?`0${g}`:g,m=new Date;return`${m.getFullYear()}-${w(m.getMonth()+1)}-${w(m.getDate())} ${w(m.getHours())}:${w(m.getMinutes())}:${w(m.getSeconds())}.${u(m.getMilliseconds())}`}getBackupResource(){return this.backupIndex=this.backupIndex>5?1:this.backupIndex,(0,R.joinPath)((0,R.dirname)(this.resource),`${(0,R.basename)(this.resource)}_${this.backupIndex++}`)}async loadContent(){try{return(await this.fileService.readFile(this.resource)).value.toString()}catch{return""}}stringifyLogLevel(w){switch(w){case f.LogLevel.Critical:return"critical";case f.LogLevel.Debug:return"debug";case f.LogLevel.Error:return"error";case f.LogLevel.Info:return"info";case f.LogLevel.Trace:return"trace";case f.LogLevel.Warning:return"warning"}return""}};E=de([ee(4,L.IFileService)],E),e.FileLogger=E;let P=class extends f.AbstractLoggerService{constructor(w,u,m){super(w.getLevel(),w.onDidChangeLogLevel);this.instantiationService=u,this.fileService=m}doCreateLogger(w,u,m){const g=new y.BufferLogService(u);return(0,L.whenProviderRegistered)(w,this.fileService).then(()=>g.logger=this.instantiationService.createInstance(E,m?.name||(0,R.basename)(w),w,g.getLevel(),!!m?.donotUseFormatters)),g}};P=de([ee(0,f.ILogService),ee(1,D.IInstantiationService),ee(2,L.IFileService)],P),e.FileLoggerService=P}),define(J[195],Z([0,1,3,7,6]),function(z,e,b,t,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class L{constructor(S){this.service=S,this.onDidChangeLogLevel=b.Event.buffer(S.onDidChangeLogLevel,!0)}listen(S,w){switch(w){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${w}`)}async call(S,w,u){switch(w){case"setLevel":return this.service.setLevel(u)}throw new Error(`Call not found: ${w}`)}}e.LogLevelChannel=L;class D{constructor(S){this.channel=S}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(S){D.setLevel(this.channel,S)}static setLevel(S,w){return S.call("setLevel",w)}}e.LogLevelChannelClient=D;class y{constructor(S){this.loggerService=S,this.loggers=new Map}listen(S,w){throw new Error(`Event not found: ${w}`)}async call(S,w,u){switch(w){case"createLogger":this.createLogger(t.URI.revive(u[0]),u[1]);return;case"log":return this.log(t.URI.revive(u[0]),u[1]);case"consoleLog":return this.consoleLog(u[0],u[1])}throw new Error(`Call not found: ${w}`)}createLogger(S,w){this.loggers.set(S.toString(),this.loggerService.createLogger(S,w))}consoleLog(S,w){let u=console.log;switch(S){case R.LogLevel.Error:u=console.error;break;case R.LogLevel.Warning:u=console.warn;break;case R.LogLevel.Info:u=console.info;break}u.call(console,...w)}log(S,w){const u=this.loggers.get(S.toString());if(!u)throw new Error("Create the logger before logging");for(const[m,g]of w)(0,R.log)(u,m,g)}}e.LoggerChannel=y;class f extends R.AbstractLoggerService{constructor(S,w,u){super(S,w);this.channel=u}createConsoleMainLogger(){return new R.AdapterLogger({log:(S,w)=>{this.channel.call("consoleLog",[S,w])}})}doCreateLogger(S,w,u){return new v(this.channel,S,w,u)}}e.LoggerChannelClient=f;class v extends R.AbstractMessageLogger{constructor(S,w,u,m){super(m?.always);this.channel=S,this.file=w,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(u),this.channel.call("createLogger",[w,m]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(S,w){const u=[[S,w]];this.isLoggerCreated?this.doLog(u):this.buffer.push(...u)}doLog(S){this.channel.call("log",[this.file,S])}}class E extends R.LogService{constructor(S,w){super(w);this.parent=S,this._register(S.onDidChangeLogLevel(u=>w.setLevel(u)))}setLevel(S){super.setLevel(S),this.parent.setLevel(S)}}e.FollowerLogService=E}),define(J[103],Z([0,1,15,6]),function(z,e,b,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;async function R(y,f,v,E,P){try{const S=await new Promise((u,m)=>{z(["spdlog"],u,m)});S.setFlushOn(t.LogLevel.Trace);const w=await S.createAsyncRotatingLogger(y,f,v,E);return P&&w.clearFormatters(),w}catch(S){console.error(S)}return null}function L(y,f,v){switch(f){case t.LogLevel.Trace:y.trace(v);break;case t.LogLevel.Debug:y.debug(v);break;case t.LogLevel.Info:y.info(v);break;case t.LogLevel.Warning:y.warn(v);break;case t.LogLevel.Error:y.error(v);break;case t.LogLevel.Critical:y.critical(v);break;default:throw new Error("Invalid log level")}}class D extends t.AbstractMessageLogger{constructor(f,v,E,P,S){super();this.buffer=[],this.setLevel(S),this._loggerCreationPromise=this._createSpdLogLogger(f,v,E,P),this._register(this.onDidChangeLogLevel(w=>{this._logger?.setLevel(w)}))}async _createSpdLogLogger(f,v,E,P){const S=E?6:1,w=30/S*b.ByteSize.MB,u=await R(f,v,w,S,P);if(u){this._logger=u,this._logger.setLevel(this.getLevel());for(const{level:m,message:g}of this.buffer)L(this._logger,m,g);this.buffer=[]}}log(f,v){this._logger?L(this._logger,f,v):this.getLevel()<=f&&this.buffer.push({level:f,message:v})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=D}),define(J[196],Z([0,1,11,16,30,15,194,6,103]),function(z,e,b,t,R,L,D,y,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;let v=class extends y.AbstractLoggerService{constructor(P,S){super(P.getLevel(),P.onDidChangeLogLevel);this.fileService=S}doCreateLogger(P,S,w){return P.scheme===b.Schemas.file?new f.SpdLogLogger(w?.name||(0,R.generateUuid)(),P.fsPath,!w?.donotRotate,!!w?.donotUseFormatters,S):new D.FileLogger(w?.name??(0,t.basename)(P),P,S,!!w?.donotUseFormatters,this.fileService)}};v=de([ee(0,y.ILogService),ee(1,L.IFileService)],v),e.LoggerService=v}),define(J[197],Z([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function b(D){return D.submenu!==void 0}e.isMenubarMenuItemSubmenu=b;function t(D){return D.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=t;function R(D){return D.uri!==void 0}e.isMenubarMenuItemRecentAction=R;function L(D){return!b(D)&&!t(D)&&!R(D)}e.isMenubarMenuItemAction=L}),define(J[37],Z([0,1,3,53,2,5]),function(z,e,b,t,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,L.createDecorator)("policy");class D extends R.Disposable{constructor(){super(...arguments);this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new b.Emitter),this.onDidChange=this._onDidChange.event}async registerPolicyDefinitions(v){const E=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...v,...this.policyDefinitions},E!==Object.keys(this.policyDefinitions).length&&await this.initializePolicies(v),t.Iterable.reduce(this.policies.entries(),(P,[S,w])=>({...P,[S]:w}),{})}getPolicyValue(v){return this.policies.get(v)}serialize(){return t.Iterable.reduce(Object.entries(this.policyDefinitions),(v,[E,P])=>({...v,[E]:{definition:P,value:this.policies.get(E)}}),{})}}e.AbstractPolicyService=D;class y{constructor(){this.onDidChange=b.Event.None}async registerPolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=y}),define(J[198],Z([0,1,8,3,53,12,15,6,37]),function(z,e,b,t,R,L,D,y,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FilePolicyService=void 0;function v(P,S){const w=[];for(const u of R.Iterable.concat(P.keys(),S.keys()))P.get(u)!==S.get(u)&&w.push(u);return w}let E=class extends f.AbstractPolicyService{constructor(S,w,u){super();this.file=S,this.fileService=w,this.logService=u,this.throttledDelayer=this._register(new b.ThrottledDelayer(500));const m=t.Event.filter(w.onDidFilesChange,g=>g.affects(S));this._register(w.watch(S)),this._register(m(()=>this.throttledDelayer.trigger(()=>this.refresh())))}async initializePolicies(S){await this.refresh()}async read(){const S=new Map;try{const w=await this.fileService.readFile(this.file),u=JSON.parse(w.value.toString());if(!(0,L.isObject)(u))throw new Error("Policy file isn't a JSON object");for(const m of Object.keys(u))this.policyDefinitions[m]&&S.set(m,u[m])}catch(w){w.fileOperationResult!==1&&this.logService.error("[FilePolicyService] Failed to read policies",w)}return S}async refresh(){const S=await this.read(),w=v(this.policies,S);this.policies=S,w.length>0&&this._onDidChange.fire(w)}};E=de([ee(1,D.IFileService),ee(2,y.ILogService)],E),e.FilePolicyService=E}),define(J[199],Z([0,1,3,2,37]),function(z,e,b,t,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class L{constructor(f){this.service=f,this.disposables=new t.DisposableStore}listen(f,v){switch(v){case"onDidChange":return b.Event.map(this.service.onDidChange,E=>E.reduce((P,S)=>({...P,[S]:this.service.getPolicyValue(S)??null}),{}),this.disposables)}throw new Error(`Event not found: ${v}`)}call(f,v,E){switch(v){case"registerPolicyDefinitions":return this.service.registerPolicyDefinitions(E)}throw new Error(`Call not found: ${v}`)}dispose(){this.disposables.dispose()}}e.PolicyChannel=L;class D extends R.AbstractPolicyService{constructor(f,v){super();this.channel=v;for(const E in f){const{definition:P,value:S}=f[E];this.policyDefinitions[E]=P,S!==void 0&&this.policies.set(E,S)}this.channel.listen("onDidChange")(E=>{for(const P in E){const S=E[P];S===null?this.policies.delete(P):this.policies.set(P,S)}this._onDidChange.fire(Object.keys(E))})}async initializePolicies(f){const v=await this.channel.call("registerPolicyDefinitions",f);for(const E in v)this.policies.set(E,v[E])}}e.PolicyChannelClient=D}),define(J[57],Z([0,1,11,4,36,16]),function(z,e,b,t,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let D;if(typeof t.globals.vscode!="undefined"&&typeof t.globals.vscode.context!="undefined"){const y=t.globals.vscode.context.configuration();if(y)D=y.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof z?.__$__nodeRequire=="function"){const y=(0,L.dirname)(b.FileAccess.asFileUri("",z));D=z.__$__nodeRequire((0,L.joinPath)(y,"product.json").fsPath);const f=z.__$__nodeRequire((0,L.joinPath)(y,"package.json").fsPath);R.env.VSCODE_DEV&&Object.assign(D,{nameShort:`${D.nameShort} Dev`,nameLong:`${D.nameLong} Dev`,dataFolderName:`${D.dataFolderName}-dev`,serverDataFolderName:D.serverDataFolderName?`${D.serverDataFolderName}-dev`:void 0}),Object.assign(D,{version:f.version})}else D={},Object.keys(D).length===0&&Object.assign(D,{version:"1.67.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=D}),define(J[20],Z([0,1,5]),function(z,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,b.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(J[200],Z([0,1,63,6,20]),function(z,e,b,t,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionUrlTrustService=void 0;let L=class{constructor(y,f){this.productService=y,this.logService=f,this.trustedExtensionUrlPublicKeys=new Map}async isExtensionUrlTrusted(y,f){if(!this.productService.trustedExtensionUrlPublicKeys)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const v=/^(.*)#([^#]+)$/.exec(f);if(!v)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",f),!1;const[,E,P]=v;let S=this.trustedExtensionUrlPublicKeys.get(y);if(!S){if(S=this.productService.trustedExtensionUrlPublicKeys[y],!S||S.length===0)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",y),!1;this.trustedExtensionUrlPublicKeys.set(y,[...S])}const w=Buffer.from(decodeURIComponent(P),"base64");if(w.length<=6)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",f),!1;const u=w.slice(0,6),m=w.readUIntBE(0,6),g=Date.now()-m;if(g<0||g>36e5)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",f),!1;const I=w.slice(6),p=b.createVerify("SHA256");p.write(u),p.write(Buffer.from(E)),p.end();for(let d=0;d<S.length;d++){let h=S[d];if(h!==null){if(typeof h=="string")try{h=b.createPublicKey({key:Buffer.from(h,"base64"),format:"der",type:"spki"}),S[d]=h}catch(l){this.logService.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${d+1} for ${y}:`,l),S[d]=null;continue}if(p.verify(h,I))return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",f),!0}}return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",f),!1}};L=de([ee(0,R.IProductService),ee(1,t.ILogService)],L),e.ExtensionUrlTrustService=L}),define(J[58],Z([0,1,5]),function(z,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,b.createDecorator)("protocolMainService")}),define(J[44],Z([0,1,114,12]),function(z,e,b,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class R{constructor(){this.data=new Map}add(D,y){b.ok(t.isString(D)),b.ok(t.isObject(y)),b.ok(!this.data.has(D),"There is already an extension with this id"),this.data.set(D,y)}knows(D){return this.data.has(D)}as(D){return this.data.get(D)||null}}e.Registry=new R}),define(J[201],Z([0,1,3,44]),function(z,e,b,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function R(y){return y.length>0&&y.charAt(y.length-1)==="#"?y.substring(0,y.length-1):y}class L{constructor(){this._onDidChangeSchema=new b.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(f,v){this.schemasById[R(f)]=v,this._onDidChangeSchema.fire(f)}notifySchemaChanged(f){this._onDidChangeSchema.fire(f)}getSchemaContributions(){return{schemas:this.schemasById}}}const D=new L;t.Registry.add(e.Extensions.JSONContribution,D)}),define(J[59],Z([0,1,25,3,12,145,17,201,44]),function(z,e,b,t,R,L,D,y,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var v;(function(l){l.Multiline="multilineText",l.Singleline="singlelineText"})(v=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var E;(function(l){l[l.APPLICATION=1]="APPLICATION",l[l.MACHINE=2]="MACHINE",l[l.WINDOW=3]="WINDOW",l[l.RESOURCE=4]="RESOURCE",l[l.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",l[l.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(E=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const P=f.Registry.as(y.Extensions.JSONContribution);class S{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new t.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new t.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:L.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(n,r=!0){this.registerConfigurations([n],r)}registerConfigurations(n,r=!0){const i=this.doRegisterConfigurations(n,r);P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:i})}deregisterConfigurations(n){const r=this.doDeregisterConfigurations(n);P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r})}updateConfigurations({add:n,remove:r}){const i=[];i.push(...this.doDeregisterConfigurations(r)),i.push(...this.doRegisterConfigurations(n,!1)),P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,b.distinct)(i)})}registerDefaultConfigurations(n){const r=[],i=[];for(const{overrides:s,source:o}of n)for(const a in s)if(r.push(a),e.OVERRIDE_PROPERTY_REGEX.test(a)){const c=this.configurationDefaultsOverrides.get(a),C=c?.valuesSources??new Map;if(o)for(const F of Object.keys(s[a]))C.set(F,o);const k={...c?.value||{},...s[a]};this.configurationDefaultsOverrides.set(a,{source:o,value:k,valuesSources:C});const M=(0,D.getLanguageTagSettingPlainKey)(a),T={type:"object",default:k,description:L.localize(1,null,M),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:k,source:R.isString(o)?void 0:o,defaultValueSource:o};i.push(...m(a)),this.configurationProperties[a]=T,this.defaultLanguageConfigurationOverridesNode.properties[a]=T}else{this.configurationDefaultsOverrides.set(a,{value:s[a],source:o});const c=this.configurationProperties[a];c&&(this.updatePropertyDefaultValue(a,c),this.updateSchema(a,c))}this.registerOverrideIdentifiers(i),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:!0})}deregisterDefaultConfigurations(n){const r=[];for(const{overrides:i,source:s}of n)for(const o in i){const a=this.configurationDefaultsOverrides.get(o),c=R.isString(s)?s:s?.id,C=R.isString(a?.source)?a?.source:a?.source?.id;if(c===C)if(r.push(o),this.configurationDefaultsOverrides.delete(o),e.OVERRIDE_PROPERTY_REGEX.test(o))delete this.configurationProperties[o],delete this.defaultLanguageConfigurationOverridesNode.properties[o];else{const k=this.configurationProperties[o];k&&(this.updatePropertyDefaultValue(o,k),this.updateSchema(o,k))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...n){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(n){for(const r of n)this.overrideIdentifiers.add(r);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(n,r){const i=[];return n.forEach(s=>{i.push(...this.validateAndRegisterProperties(s,r,s.extensionInfo,s.restrictedProperties)),this.configurationContributors.push(s),this.registerJSONConfiguration(s)}),i}doDeregisterConfigurations(n){const r=[],i=s=>{if(s.properties)for(const o in s.properties){r.push(o);const a=this.configurationProperties[o];a?.policy?.name&&this.policyConfigurations.delete(a.policy.name),delete this.configurationProperties[o],this.removeFromSchema(o,s.properties[o])}s.allOf?.forEach(o=>i(o))};for(const s of n){i(s);const o=this.configurationContributors.indexOf(s);o!==-1&&this.configurationContributors.splice(o,1)}return r}validateAndRegisterProperties(n,r=!0,i,s,o=3){o=R.isUndefinedOrNull(n.scope)?o:n.scope;const a=[],c=n.properties;if(c)for(const k in c){const M=c[k];if(r&&d(k,M)){delete c[k];continue}if(M.source=i,M.defaultDefaultValue=c[k].default,this.updatePropertyDefaultValue(k,M),e.OVERRIDE_PROPERTY_REGEX.test(k)?M.scope=void 0:(M.scope=R.isUndefinedOrNull(M.scope)?o:M.scope,M.restricted=R.isUndefinedOrNull(M.restricted)?!!s?.includes(k):M.restricted),c[k].hasOwnProperty("included")&&!c[k].included){this.excludedConfigurationProperties[k]=c[k],delete c[k];continue}else this.configurationProperties[k]=c[k],c[k].policy?.name&&this.policyConfigurations.set(c[k].policy.name,k);!c[k].deprecationMessage&&c[k].markdownDeprecationMessage&&(c[k].deprecationMessage=c[k].markdownDeprecationMessage),a.push(k)}const C=n.allOf;if(C)for(const k of C)a.push(...this.validateAndRegisterProperties(k,r,i,s,o));return a}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(n){const r=i=>{const s=i.properties;if(s)for(const a in s)this.updateSchema(a,s[a]);i.allOf?.forEach(r)};r(n)}updateSchema(n,r){switch(e.allSettings.properties[n]=r,r.scope){case 1:e.applicationSettings.properties[n]=r;break;case 2:e.machineSettings.properties[n]=r;break;case 6:e.machineOverridableSettings.properties[n]=r;break;case 3:e.windowSettings.properties[n]=r;break;case 4:e.resourceSettings.properties[n]=r;break;case 5:e.resourceSettings.properties[n]=r,this.resourceLanguageSettingsSchema.properties[n]=r;break}}removeFromSchema(n,r){switch(delete e.allSettings.properties[n],r.scope){case 1:delete e.applicationSettings.properties[n];break;case 2:delete e.machineSettings.properties[n];break;case 6:delete e.machineOverridableSettings.properties[n];break;case 3:delete e.windowSettings.properties[n];break;case 4:case 5:delete e.resourceSettings.properties[n],delete this.resourceLanguageSettingsSchema.properties[n];break}}updateOverridePropertyPatternKey(){for(const n of this.overrideIdentifiers.values()){const r=`[${n}]`,i={type:"object",description:L.localize(2,null),errorMessage:L.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(r,i),e.allSettings.properties[r]=i,e.applicationSettings.properties[r]=i,e.machineSettings.properties[r]=i,e.machineOverridableSettings.properties[r]=i,e.windowSettings.properties[r]=i,e.resourceSettings.properties[r]=i}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const n={type:"object",description:L.localize(4,null),errorMessage:L.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(n,r){const i=this.configurationDefaultsOverrides.get(n);let s=i?.value,o=i?.source;R.isUndefined(s)&&(s=r.defaultDefaultValue,o=void 0),R.isUndefined(s)&&(s=I(r.type)),r.default=s,r.defaultValueSource=o}}const w="\\[([^\\]]+)\\]",u=new RegExp(w,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${w})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function m(l){const n=[];if(e.OVERRIDE_PROPERTY_REGEX.test(l)){let r=u.exec(l);for(;r?.length;){const i=r[1].trim();i&&n.push(i),r=u.exec(l)}}return(0,b.distinct)(n)}e.overrideIdentifiersFromKey=m;function g(l){return l.reduce((n,r)=>`${n}[${r}]`,"")}e.keyFromOverrideIdentifiers=g;function I(l){switch(Array.isArray(l)?l[0]:l){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=I;const p=new S;f.Registry.add(e.Extensions.Configuration,p);function d(l,n){return l.trim()?e.OVERRIDE_PROPERTY_REGEX.test(l)?L.localize(7,null,l):p.getConfigurationProperties()[l]!==void 0?L.localize(8,null,l):n.policy?.name&&p.getPolicyConfigurations().get(n.policy?.name)!==void 0?L.localize(9,null,l,n.policy?.name,p.getPolicyConfigurations().get(n.policy?.name)):null:L.localize(6,null)}e.validateProperty=d;function h(){const l=[],n=p.getConfigurationProperties();for(const r of Object.keys(n))l.push([r,n[r].scope]);return l.push(["launch",4]),l.push(["task",4]),l}e.getScopes=h}),define(J[104],Z([0,1,25,3,49,2,33,50,12,7,17,59,44]),function(z,e,b,t,R,L,D,y,f,v,E,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class w{constructor(r={},i=[],s=[]){this._contents=r,this._keys=i,this._overrides=s,this.frozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}isFrozen(){return this.frozen}getValue(r){return r?(0,E.getConfigurationValue)(this.contents,r):this.contents}getOverrideValue(r,i){const s=this.getContentsForOverrideIdentifer(i);return s?r?(0,E.getConfigurationValue)(s,r):s:void 0}getKeysForOverrideIdentifier(r){const i=[];for(const s of this.overrides)s.identifiers.includes(r)&&i.push(...s.keys);return b.distinct(i)}getAllOverrideIdentifiers(){const r=[];for(const i of this.overrides)r.push(...i.identifiers);return b.distinct(r)}override(r){let i=this.overrideConfigurations.get(r);return i||(i=this.createOverrideConfigurationModel(r),this.overrideConfigurations.set(r,i)),i}merge(...r){const i=y.deepClone(this.contents),s=y.deepClone(this.overrides),o=[...this.keys];for(const a of r)if(!a.isEmpty()){this.mergeContents(i,a.contents);for(const c of a.overrides){const[C]=s.filter(k=>b.equals(k.identifiers,c.identifiers));C?(this.mergeContents(C.contents,c.contents),C.keys.push(...c.keys),C.keys=b.distinct(C.keys)):s.push(y.deepClone(c))}for(const c of a.keys)o.indexOf(c)===-1&&o.push(c)}return new w(i,o,s)}freeze(){return this.frozen=!0,this}clone(){return new w(y.deepClone(this.contents),[...this.keys],y.deepClone(this.overrides))}createOverrideConfigurationModel(r){const i=this.getContentsForOverrideIdentifer(r);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const s={};for(const o of b.distinct([...Object.keys(this.contents),...Object.keys(i)])){let a=this.contents[o];const c=i[o];c&&(typeof a=="object"&&typeof c=="object"?(a=y.deepClone(a),this.mergeContents(a,c)):a=c),s[o]=a}return new w(s,this.keys,this.overrides)}mergeContents(r,i){for(const s of Object.keys(i)){if(s in r&&f.isObject(r[s])&&f.isObject(i[s])){this.mergeContents(r[s],i[s]);continue}r[s]=y.deepClone(i[s])}}checkAndFreeze(r){return this.frozen&&!Object.isFrozen(r)?y.deepFreeze(r):r}getContentsForOverrideIdentifer(r){let i=null,s=null;const o=a=>{a&&(s?this.mergeContents(s,a):s=y.deepClone(a))};for(const a of this.overrides)b.equals(a.identifiers,[r])?i=a.contents:a.identifiers.includes(r)&&o(a.contents);return o(i),s}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(r,i){this.addKey(r),(0,E.addToValueTree)(this.contents,r,i,s=>{throw new Error(s)})}removeValue(r){this.removeKey(r)&&(0,E.removeFromValueTree)(this.contents,r)}addKey(r){let i=this.keys.length;for(let s=0;s<i;s++)r.indexOf(this.keys[s])===0&&(i=s);this.keys.splice(i,1,r)}removeKey(r){const i=this.keys.indexOf(r);return i!==-1?(this.keys.splice(i,1),!0):!1}}e.ConfigurationModel=w;class u{constructor(r){this._name=r,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new w}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(r,i){if(!f.isUndefinedOrNull(r)){const s=this.doParseContent(r);this.parseRaw(s,i)}}reparse(r){this._raw&&this.parseRaw(this._raw,r)}parseRaw(r,i){this._raw=r;const{contents:s,keys:o,overrides:a,restricted:c}=this.doParseRaw(r,i);this._configurationModel=new w(s,o,a),this._restrictedConfigurations=c||[]}doParseContent(r){let i={},s=null,o=[];const a=[],c=[];function C(M){Array.isArray(o)?o.push(M):s!==null&&(o[s]=M)}const k={onObjectBegin:()=>{const M={};C(M),a.push(o),o=M,s=null},onObjectProperty:M=>{s=M},onObjectEnd:()=>{o=a.pop()},onArrayBegin:()=>{const M=[];C(M),a.push(o),o=M,s=null},onArrayEnd:()=>{o=a.pop()},onLiteralValue:C,onError:(M,T,F)=>{c.push({error:M,offset:T,length:F})}};if(r)try{R.visit(r,k),i=o[0]||{}}catch(M){console.error(`Error while parsing settings file ${this._name}: ${M}`),this._parseErrors=[M]}return i}doParseRaw(r,i){const s=S.Registry.as(P.Extensions.Configuration).getConfigurationProperties(),o=this.filter(r,s,!0,i);r=o.raw;const a=(0,E.toValuesTree)(r,k=>console.error(`Conflict in settings file ${this._name}: ${k}`)),c=Object.keys(r),C=this.toOverrides(r,k=>console.error(`Conflict in settings file ${this._name}: ${k}`));return{contents:a,keys:c,overrides:C,restricted:o.restricted}}filter(r,i,s,o){if(!o?.scopes&&!o?.skipRestricted)return{raw:r,restricted:[]};const a={},c=[];for(const C in r)if(P.OVERRIDE_PROPERTY_REGEX.test(C)&&s){const k=this.filter(r[C],i,!1,o);a[C]=k.raw,c.push(...k.restricted)}else{const k=i[C],M=k?typeof k.scope!="undefined"?k.scope:3:void 0;k?.restricted&&c.push(C),(M===void 0||o.scopes===void 0||o.scopes.includes(M))&&(o.skipRestricted&&k?.restricted||(a[C]=r[C]))}return{raw:a,restricted:c}}toOverrides(r,i){const s=[];for(const o of Object.keys(r))if(P.OVERRIDE_PROPERTY_REGEX.test(o)){const a={};for(const c in r[o])a[c]=r[o][c];s.push({identifiers:(0,P.overrideIdentifiersFromKey)(o),keys:Object.keys(a),contents:(0,E.toValuesTree)(a,i)})}return s}}e.ConfigurationModelParser=u;class m extends L.Disposable{constructor(r,i,s,o){super();this.userSettingsResource=r,this.scopes=i,this.fileService=o,this._onDidChange=this._register(new t.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new u(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(t.Event.any(t.Event.filter(this.fileService.onDidFilesChange,a=>a.contains(this.userSettingsResource)),t.Event.filter(this.fileService.onDidRunOperation,a=>(a.isOperation(0)||a.isOperation(3)||a.isOperation(1)||a.isOperation(4))&&s.isEqual(a.resource,r)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const r=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(r.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new w}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=m;class g{constructor(r,i,s,o,a=new w,c=new w,C=new D.ResourceMap,k=new w,M=new D.ResourceMap,T=!0){this._defaultConfiguration=r,this._policyConfiguration=i,this._applicationConfiguration=s,this._localUserConfiguration=o,this._remoteUserConfiguration=a,this._workspaceConfiguration=c,this._folderConfigurations=C,this._memoryConfiguration=k,this._memoryConfigurationByResource=M,this._freeze=T,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new D.ResourceMap,this._userConfiguration=null}getValue(r,i,s){return this.getConsolidatedConfigurationModel(r,i,s).getValue(r)}updateValue(r,i,s={}){let o;s.resource?(o=this._memoryConfigurationByResource.get(s.resource),o||(o=new w,this._memoryConfigurationByResource.set(s.resource,o))):o=this._memoryConfiguration,i===void 0?o.removeValue(r):o.setValue(r,i),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(r,i,s){const o=this.getConsolidatedConfigurationModel(r,i,s),a=this.getFolderConfigurationModelForResource(i.resource,s),c=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,C=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this._defaultConfiguration.freeze().getValue(r),k=this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration.freeze().getValue(r),M=this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze().getValue(r),T=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this.userConfiguration.freeze().getValue(r),F=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this.localUserConfiguration.freeze().getValue(r),q=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this.remoteUserConfiguration.freeze().getValue(r),te=s?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this._workspaceConfiguration.freeze().getValue(r):void 0,ne=a?i.overrideIdentifier?a.freeze().override(i.overrideIdentifier).getValue(r):a.freeze().getValue(r):void 0,Q=i.overrideIdentifier?c.override(i.overrideIdentifier).getValue(r):c.getValue(r),se=o.getValue(r),ce=b.distinct(o.overrides.map(H=>H.identifiers).flat()).filter(H=>o.getOverrideValue(r,H)!==void 0);return{defaultValue:C,policyValue:k,applicationValue:M,userValue:T,userLocalValue:F,userRemoteValue:q,workspaceValue:te,workspaceFolderValue:ne,memoryValue:Q,value:se,default:C!==void 0?{value:this._defaultConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,policy:k!==void 0?{value:k}:void 0,application:M!==void 0?{value:M,override:i.overrideIdentifier?this.applicationConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,user:T!==void 0?{value:this.userConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,userLocal:F!==void 0?{value:this.localUserConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,userRemote:q!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,workspace:te!==void 0?{value:this._workspaceConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,workspaceFolder:ne!==void 0?{value:a?.freeze().getValue(r),override:i.overrideIdentifier?a?.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,memory:Q!==void 0?{value:c.getValue(r),override:i.overrideIdentifier?c.getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:ce.length?ce:void 0}}keys(r){const i=this.getFolderConfigurationModelForResource(void 0,r);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(r){this._defaultConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(r){this._policyConfiguration=r}updateApplicationConfiguration(r){this._applicationConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(r){this._localUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(r){this._remoteUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(r){this._workspaceConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(r,i){this._folderConfigurations.set(r,i),this._foldersConsolidatedConfigurations.delete(r)}deleteFolderConfiguration(r){this.folderConfigurations.delete(r),this._foldersConsolidatedConfigurations.delete(r)}compareAndUpdateDefaultConfiguration(r,i){const s=[];if(!i){const{added:o,updated:a,removed:c}=h(this._defaultConfiguration,r);i=[...o,...a,...c]}for(const o of i)for(const a of(0,P.overrideIdentifiersFromKey)(o)){const c=this._defaultConfiguration.getKeysForOverrideIdentifier(a),C=r.getKeysForOverrideIdentifier(a),k=[...C.filter(M=>c.indexOf(M)===-1),...c.filter(M=>C.indexOf(M)===-1),...c.filter(M=>!y.equals(this._defaultConfiguration.override(a).getValue(M),r.override(a).getValue(M)))];s.push([a,k])}return this.updateDefaultConfiguration(r),{keys:i,overrides:s}}compareAndUpdatePolicyConfiguration(r){const{added:i,updated:s,removed:o}=h(this._policyConfiguration,r),a=[...i,...s,...o];return a.length&&this.updatePolicyConfiguration(r),{keys:a,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:i,updated:s,removed:o,overrides:a}=h(this.applicationConfiguration,r),c=[...i,...s,...o];return c.length&&this.updateApplicationConfiguration(r),{keys:c,overrides:a}}compareAndUpdateLocalUserConfiguration(r){const{added:i,updated:s,removed:o,overrides:a}=h(this.localUserConfiguration,r),c=[...i,...s,...o];return c.length&&this.updateLocalUserConfiguration(r),{keys:c,overrides:a}}compareAndUpdateRemoteUserConfiguration(r){const{added:i,updated:s,removed:o,overrides:a}=h(this.remoteUserConfiguration,r),c=[...i,...s,...o];return c.length&&this.updateRemoteUserConfiguration(r),{keys:c,overrides:a}}compareAndUpdateWorkspaceConfiguration(r){const{added:i,updated:s,removed:o,overrides:a}=h(this.workspaceConfiguration,r),c=[...i,...s,...o];return c.length&&this.updateWorkspaceConfiguration(r),{keys:c,overrides:a}}compareAndUpdateFolderConfiguration(r,i){const s=this.folderConfigurations.get(r),{added:o,updated:a,removed:c,overrides:C}=h(s,i),k=[...o,...a,...c];return(k.length||!s)&&this.updateFolderConfiguration(r,i),{keys:k,overrides:C}}compareAndDeleteFolderConfiguration(r){const i=this.folderConfigurations.get(r);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:s,updated:o,removed:a,overrides:c}=h(i,void 0);return{keys:[...s,...o,...a],overrides:c}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(r,i,s){let o=this.getConsolidatedConfigurationModelForResource(i,s);return i.overrideIdentifier&&(o=o.override(i.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(r)!==void 0&&(o=o.merge(this._policyConfiguration)),o}getConsolidatedConfigurationModelForResource({resource:r},i){let s=this.getWorkspaceConsolidatedConfiguration();if(i&&r){const o=i.getFolder(r);o&&(s=this.getFolderConsolidatedConfiguration(o.uri)||s);const a=this._memoryConfigurationByResource.get(r);a&&(s=s.merge(a))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(r){let i=this._foldersConsolidatedConfigurations.get(r);if(!i){const s=this.getWorkspaceConsolidatedConfiguration(),o=this._folderConfigurations.get(r);o?(i=s.merge(o),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(r,i)):i=s}return i}getFolderConfigurationModelForResource(r,i){if(i&&r){const s=i.getFolder(r);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((r,i)=>{const{contents:s,overrides:o,keys:a}=this._folderConfigurations.get(i);return r.push([i,{contents:s,overrides:o,keys:a}]),r},[])}}allKeys(){const r=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>r.add(i)),this.userConfiguration.freeze().keys.forEach(i=>r.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>r.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(s=>r.add(s))),[...r.values()]}allOverrideIdentifiers(){const r=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>r.add(i)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>r.add(i)),this._folderConfigurations.forEach(i=>i.freeze().getAllOverrideIdentifiers().forEach(s=>r.add(s))),[...r.values()]}getAllKeysForOverrideIdentifier(r){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(r).forEach(s=>i.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(s=>i.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(r).forEach(s=>i.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(r).forEach(o=>i.add(o))),[...i.values()]}static parse(r){const i=this.parseConfigurationModel(r.defaults),s=this.parseConfigurationModel(r.policy),o=this.parseConfigurationModel(r.application),a=this.parseConfigurationModel(r.user),c=this.parseConfigurationModel(r.workspace),C=r.folders.reduce((k,M)=>(k.set(v.URI.revive(M[0]),this.parseConfigurationModel(M[1])),k),new D.ResourceMap);return new g(i,s,o,a,new w,c,C,new w,new D.ResourceMap,!1)}static parseConfigurationModel(r){return new w(r.contents,r.keys,r.overrides).freeze()}}e.Configuration=g;function I(...n){if(n.length===0)return{keys:[],overrides:[]};if(n.length===1)return n[0];const r=new Set,i=new Map;for(const o of n)o.keys.forEach(a=>r.add(a)),o.overrides.forEach(([a,c])=>{const C=(0,D.getOrSet)(i,a,new Set);c.forEach(k=>C.add(k))});const s=[];return i.forEach((o,a)=>s.push([a,[...o.values()]])),{keys:[...r.values()],overrides:s}}e.mergeChanges=I;class p{constructor(r,i,s,o){this.change=r,this.previous=i,this.currentConfiguraiton=s,this.currentWorkspace=o,this._previousConfiguration=void 0;const a=new Set;r.keys.forEach(C=>a.add(C)),r.overrides.forEach(([,C])=>C.forEach(k=>a.add(k))),this.affectedKeys=[...a.values()];const c=new w;this.affectedKeys.forEach(C=>c.setValue(C,{})),this.affectedKeysTree=c.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=g.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(r,i){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,r)){if(i){const s=this.previousConfiguration?this.previousConfiguration.getValue(r,i,this.previous?.workspace):void 0,o=this.currentConfiguraiton.getValue(r,i,this.currentWorkspace);return!y.equals(s,o)}return!0}return!1}doesAffectedKeysTreeContains(r,i){let s=(0,E.toValuesTree)({[i]:!0},()=>{}),o;for(;typeof s=="object"&&(o=Object.keys(s)[0]);){if(r=r[o],!r)return!1;s=s[o]}return!0}}e.ConfigurationChangeEvent=p;class d extends p{constructor(r,i,s,o){super({keys:r.allKeys(),overrides:[]},void 0,r,i);this.source=s,this.sourceConfig=o}}e.AllKeysConfigurationChangeEvent=d;function h(n,r){const{added:i,removed:s,updated:o}=l(r,n),a=[],c=n?.getAllOverrideIdentifiers()||[],C=r?.getAllOverrideIdentifiers()||[];if(r){const k=C.filter(M=>!c.includes(M));for(const M of k)a.push([M,r.getKeysForOverrideIdentifier(M)])}if(n){const k=c.filter(M=>!C.includes(M));for(const M of k)a.push([M,n.getKeysForOverrideIdentifier(M)])}if(r&&n){for(const k of c)if(C.includes(k)){const M=l({contents:n.getOverrideValue(void 0,k)||{},keys:n.getKeysForOverrideIdentifier(k)},{contents:r.getOverrideValue(void 0,k)||{},keys:r.getKeysForOverrideIdentifier(k)});a.push([k,[...M.added,...M.removed,...M.updated]])}}return{added:i,removed:s,updated:o,overrides:a}}function l(n,r){const i=n?r?n.keys.filter(a=>r.keys.indexOf(a)===-1):[...n.keys]:[],s=r?n?r.keys.filter(a=>n.keys.indexOf(a)===-1):[...r.keys]:[],o=[];if(n&&r){for(const a of r.keys)if(n.keys.indexOf(a)!==-1){const c=(0,E.getConfigurationValue)(r.contents,a),C=(0,E.getConfigurationValue)(n.contents,a);y.equals(c,C)||o.push(a)}}return{added:i,removed:s,updated:o}}}),define(J[202],Z([0,1,25,3,2,50,12,17,104,59,6,37,44]),function(z,e,b,t,R,L,D,y,f,v,E,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfigurationModel=e.DefaultConfiguration=void 0;class w extends R.Disposable{constructor(){super(...arguments);this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event}get configurationModel(){return this._configurationModel||(this._configurationModel=new u(this.getConfigurationDefaultOverrides())),this._configurationModel}async initialize(){return this._configurationModel=void 0,this._register(S.Registry.as(v.Extensions.Configuration).onDidUpdateConfiguration(({properties:p,defaultsOverrides:d})=>this.onDidUpdateConfiguration(p,d))),this.configurationModel}reload(){return this._configurationModel=void 0,this.configurationModel}onDidUpdateConfiguration(p,d){this._configurationModel=void 0,this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:p})}getConfigurationDefaultOverrides(){return{}}}e.DefaultConfiguration=w;class u extends f.ConfigurationModel{constructor(p={}){const d=S.Registry.as(v.Extensions.Configuration).getConfigurationProperties(),h=Object.keys(d),l=Object.create(null),n=[];for(const r in d){const i=p[r],s=i!==void 0?i:d[r].default;(0,y.addToValueTree)(l,r,s,o=>console.error(`Conflict in default settings: ${o}`))}for(const r of Object.keys(l))v.OVERRIDE_PROPERTY_REGEX.test(r)&&n.push({identifiers:(0,v.overrideIdentifiersFromKey)(r),keys:Object.keys(l[r]),contents:(0,y.toValuesTree)(l[r],i=>console.error(`Conflict in default settings file: ${i}`))});super(l,h,n)}}e.DefaultConfigurationModel=u;class m{constructor(){this.onDidChangeConfiguration=t.Event.None,this.configurationModel=new f.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=m;let g=class extends R.Disposable{constructor(p,d,h){super();this.defaultConfiguration=p,this.policyService=d,this.logService=h,this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new f.ConfigurationModel}get configurationModel(){return this._configurationModel}async initialize(){return this.update(await this.registerPolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(p=>this.onDidChangePolicies(p))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:p})=>this.update(await this.registerPolicyDefinitions(p),!0))),this._configurationModel}async registerPolicyDefinitions(p){const d={},h=[],l=S.Registry.as(v.Extensions.Configuration).getConfigurationProperties();for(const n of p){const r=l[n];if(!r){h.push(n);continue}if(r.policy){if(r.type!=="string"&&r.type!=="number"){this.logService.warn(`Policy ${r.policy.name} has unsupported type ${r.type}`);continue}h.push(n),d[r.policy.name]={type:r.type}}}return(0,D.isEmptyObject)(d)||await this.policyService.registerPolicyDefinitions(d),h}onDidChangePolicies(p){const d=S.Registry.as(v.Extensions.Configuration).getPolicyConfigurations(),h=(0,b.coalesce)(p.map(l=>d.get(l)));this.update(h,!0)}update(p,d){const h=S.Registry.as(v.Extensions.Configuration).getConfigurationProperties(),l=[],n=this._configurationModel.isEmpty();for(const r of p){const i=h[r]?.policy?.name;if(i){const s=this.policyService.getPolicyValue(i);(n?s!==void 0:!(0,L.equals)(this._configurationModel.getValue(r),s))&&l.push([r,s])}else this._configurationModel.getValue(r)!==void 0&&l.push([r,void 0])}if(l.length){const r=this._configurationModel;this._configurationModel=new f.ConfigurationModel;for(const i of r.keys)this._configurationModel.setValue(i,r.getValue(i));for(const[i,s]of l)s===void 0?this._configurationModel.removeValue(i):this._configurationModel.setValue(i,s);d&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};g=de([ee(1,P.IPolicyService),ee(2,E.ILogService)],g),e.PolicyConfiguration=g}),define(J[203],Z([0,1,8,3,2,16,17,104,202,37]),function(z,e,b,t,R,L,D,y,f,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class E extends R.Disposable{constructor(S,w,u,m){super();this.settingsResource=S,this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new f.DefaultConfiguration),this.policyConfiguration=u instanceof v.NullPolicyService?new f.NullPolicyConfiguration:this._register(new f.PolicyConfiguration(this.defaultConfiguration,u,m)),this.userConfiguration=this._register(new y.UserSettings(this.settingsResource,void 0,L.extUriBiasedIgnorePathCase,w)),this.configuration=new y.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,new y.ConfigurationModel,new y.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new b.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:g,properties:I})=>this.onDidDefaultConfigurationChange(g,I))),this._register(this.policyConfiguration.onDidChangeConfiguration(g=>this.onDidPolicyConfigurationChange(g))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[S,w,u]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new y.Configuration(S,w,new y.ConfigurationModel,u)}getConfigurationData(){return this.configuration.toData()}getValue(S,w){const u=typeof S=="string"?S:void 0,m=(0,D.isConfigurationOverrides)(S)?S:(0,D.isConfigurationOverrides)(w)?w:{};return this.configuration.getValue(u,m,void 0)}updateValue(S,w,u,m){return Promise.reject(new Error("not supported"))}inspect(S){return this.configuration.inspect(S,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const S=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(S)}onDidChangeUserConfiguration(S){const w=this.configuration.toData(),u=this.configuration.compareAndUpdateLocalUserConfiguration(S);this.trigger(u,w,1)}onDidDefaultConfigurationChange(S,w){const u=this.configuration.toData(),m=this.configuration.compareAndUpdateDefaultConfiguration(S,w);this.trigger(m,u,6)}onDidPolicyConfigurationChange(S){const w=this.configuration.toData(),u=this.configuration.compareAndUpdatePolicyConfiguration(S);this.trigger(u,w,6)}trigger(S,w,u){const m=new y.ConfigurationChangeEvent(S,{data:w},this.configuration);m.source=u,m.sourceConfig=this.getTargetConfiguration(u),this._onDidChangeConfiguration.fire(m)}getTargetConfiguration(S){switch(S){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=E}),define(J[204],Z([0,1,18,5]),function(z,e,b,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,t.createDecorator)("remoteAuthorityResolverService");var R;(function(D){D.Unknown="Unknown",D.NotAvailable="NotAvailable",D.TemporarilyNotAvailable="TemporarilyNotAvailable",D.NoResolverFound="NoResolverFound"})(R=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class L extends b.ErrorNoTelemetry{constructor(y,f=R.Unknown,v){super(y);this._message=y,this._code=f,this._detail=v,this.isHandled=f===R.NotAvailable&&v===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,L.prototype)}static isTemporarilyNotAvailable(y){return y instanceof L&&y._code===R.TemporarilyNotAvailable}static isNoResolverFound(y){return y instanceof L&&y._code===R.NoResolverFound}static isHandled(y){return y instanceof L&&y.isHandled}}e.RemoteAuthorityResolverError=L}),define(J[71],Z([0,1,11]),function(z,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function t(v){return v.scheme===b.Schemas.vscodeRemote?v.authority:void 0}e.getRemoteAuthority=t;function R(v){if(!v)return;const E=v.indexOf("+");return E<0?v:v.substr(0,E)}e.getRemoteName=R;function L(v){return`/${v.quality??"oss"}-${v.commit??"dev"}`}e.getRemoteServerRootPath=L;function D(v){const{host:E,port:P}=f(v);if(typeof P=="undefined")throw new Error("Remote authority doesn't contain a port!");return{host:E,port:P}}e.parseAuthorityWithPort=D;function y(v,E){let{host:P,port:S}=f(v);return typeof S=="undefined"&&(S=E),{host:P,port:S}}e.parseAuthorityWithOptionalPort=y;function f(v){const E=v.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(E)return{host:E[1],port:parseInt(E[2],10)};const P=v.match(/^(\[[0-9a-z:]+\])$/);if(P)return{host:P[1],port:void 0};const S=v.match(/(.*):(\d+)$/);return S?{host:S[1],port:parseInt(S[2],10)}:{host:v,port:void 0}}}),define(J[205],Z([0,1,8,19,22,18,3,2,30,95,204,71]),function(z,e,b,t,R,L,D,y,f,v,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const S=30*1e3;var w;(function(j){j[j.Management=1]="Management",j[j.ExtensionHost=2]="ExtensionHost",j[j.Tunnel=3]="Tunnel"})(w=e.ConnectionType||(e.ConnectionType={}));function u(j){switch(j){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function m(j){const Y=new R.CancellationTokenSource;return setTimeout(()=>Y.cancel(),j),Y.token}function g(j,Y){if(j.isCancellationRequested||Y.isCancellationRequested)return R.CancellationToken.Cancelled;const x=new R.CancellationTokenSource;return j.onCancellationRequested(()=>x.cancel()),Y.onCancellationRequested(()=>x.cancel()),x.token}class I{constructor(Y){this._state="pending",this._disposables=new y.DisposableStore,this.promise=new Promise((x,A)=>{this._resolvePromise=x,this._rejectPromise=A}),Y.isCancellationRequested?this._timeout():this._disposables.add(Y.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(Y){this._state==="pending"?this._disposables.add(Y):Y.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const Y=new Error("Time limit reached");return Y.code="ETIMEDOUT",Y.syscall="connect",Y}resolve(Y){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(Y))}reject(Y){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(Y))}}function p(j,Y){const x=new I(Y);return x.registerDisposable(j.onControlMessage(A=>{const O=JSON.parse(A.toString()),N=oe(O);N?x.reject(N):x.resolve(O)})),x.promise}function d(j,Y,x,A,O,N,V,_){const $=new I(_);return Y.connect(x,A,O,N,V,(G,ie)=>{$.didTimeout?(G&&j.error(G),ie?.dispose()):G||!ie?$.reject(G):$.resolve(ie)}),$.promise}function h(j,Y){const x=new I(Y);return j.then(A=>{x.didTimeout||x.resolve(A)},A=>{x.didTimeout||x.reject(A)}),x.promise}async function l(j,Y,x,A){const O=B(j,Y);j.logService.trace(`${O} 1/6. invoking socketFactory.connect().`);let N;try{N=await d(j.logService,j.socketFactory,j.host,j.port,(0,P.getRemoteServerRootPath)(j),`reconnectionToken=${j.reconnectionToken}&reconnection=${j.reconnectionProtocol?"true":"false"}`,`renderer-${u(Y)}-${j.reconnectionToken}`,A)}catch(ie){throw j.logService.error(`${O} socketFactory.connect() failed or timed out. Error:`),j.logService.error(ie),ie}j.logService.trace(`${O} 2/6. socketFactory.connect() was successful.`);let V,_;j.reconnectionProtocol?(j.reconnectionProtocol.beginAcceptReconnection(N,null),V=j.reconnectionProtocol,_=!1):(V=new v.PersistentProtocol(N,null),_=!0),j.logService.trace(`${O} 3/6. sending AuthRequest control message.`);const $=await h(j.signService.createNewMessage((0,f.generateUuid)()),A),G={type:"auth",auth:j.connectionToken||"00000000000000000000",data:$.data};V.sendControl(t.VSBuffer.fromString(JSON.stringify(G)));try{const ie=await p(V,g(A,m(1e4)));if(ie.type!=="sign"||typeof ie.data!="string"){const Pe=new Error("Unexpected handshake message");throw Pe.code="VSCODE_CONNECTION_ERROR",Pe}if(j.logService.trace(`${O} 4/6. received SignRequest control message.`),!await h(j.signService.validate($,ie.signedData),A)){const Pe=new Error("Refused to connect to unsupported server");throw Pe.code="VSCODE_CONNECTION_ERROR",Pe}const me=await h(j.signService.sign(ie.data),A),fe={type:"connectionType",commit:j.commit,signedData:me,desiredConnectionType:Y};return x&&(fe.args=x),j.logService.trace(`${O} 5/6. sending ConnectionTypeRequest control message.`),V.sendControl(t.VSBuffer.fromString(JSON.stringify(fe))),{protocol:V,ownsProtocol:_}}catch(ie){throw ie&&ie.code==="ETIMEDOUT"&&(j.logService.error(`${O} the handshake timed out. Error:`),j.logService.error(ie)),ie&&ie.code==="VSCODE_CONNECTION_ERROR"&&(j.logService.error(`${O} received error control message when negotiating connection. Error:`),j.logService.error(ie)),_&&H(V),ie}}async function n(j,Y,x,A){const O=Date.now(),N=B(j,Y),{protocol:V,ownsProtocol:_}=await l(j,Y,x,A),$=new I(A);return $.registerDisposable(V.onControlMessage(G=>{const ie=JSON.parse(G.toString()),ae=oe(ie);ae?(j.logService.error(`${N} received error control message when negotiating connection. Error:`),j.logService.error(ae),_&&H(V),$.reject(ae)):(j.reconnectionProtocol&&j.reconnectionProtocol.endAcceptReconnection(),j.logService.trace(`${N} 6/6. handshake finished, connection is up and running after ${X(O)}!`),$.resolve({protocol:V,firstMessage:ie}))})),$.promise}async function r(j,Y){const{protocol:x}=await n(j,1,void 0,Y);return{protocol:x}}async function i(j,Y,x){const{protocol:A,firstMessage:O}=await n(j,2,Y,x),N=O&&O.debugPort;return{protocol:A,debugPort:N}}async function s(j,Y,x){const A=Date.now(),O=B(j,3),{protocol:N}=await l(j,3,Y,x);return j.logService.trace(`${O} 6/6. handshake finished, connection is up and running after ${X(A)}!`),N}async function o(j,Y,x){const{host:A,port:O,connectionToken:N}=await j.addressProvider.getAddress();return{commit:j.commit,quality:j.quality,host:A,port:O,connectionToken:N,reconnectionToken:Y,reconnectionProtocol:x,socketFactory:j.socketFactory,signService:j.signService,logService:j.logService}}async function a(j,Y,x){try{const A=(0,f.generateUuid)(),O=await o(j,A,null),{protocol:N}=await r(O,R.CancellationToken.None);return new se(j,Y,x,A,N)}catch(A){throw j.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),j.logService.error(A),Q.triggerPermanentFailure(0,0,E.RemoteAuthorityResolverError.isHandled(A)),A}}e.connectRemoteAgentManagement=a;async function c(j,Y){try{const x=(0,f.generateUuid)(),A=await o(j,x,null),{protocol:O,debugPort:N}=await i(A,Y,R.CancellationToken.None);return new ce(j,Y,x,O,N)}catch(x){throw j.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),j.logService.error(x),Q.triggerPermanentFailure(0,0,E.RemoteAuthorityResolverError.isHandled(x)),x}}e.connectRemoteAgentExtensionHost=c;async function C(j,Y,x){const A=await o(j,(0,f.generateUuid)(),null);return await s(A,{host:Y,port:x},R.CancellationToken.None)}e.connectRemoteAgentTunnel=C;function k(j){return(0,b.createCancelablePromise)(Y=>new Promise((x,A)=>{const O=setTimeout(x,j*1e3);Y.onCancellationRequested(()=>{clearTimeout(O),x()})}))}var M;(function(j){j[j.ConnectionLost=0]="ConnectionLost",j[j.ReconnectionWait=1]="ReconnectionWait",j[j.ReconnectionRunning=2]="ReconnectionRunning",j[j.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",j[j.ConnectionGain=4]="ConnectionGain"})(M=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class T{constructor(Y,x){this.reconnectionToken=Y,this.millisSinceLastIncomingData=x,this.type=0}}e.ConnectionLostEvent=T;class F{constructor(Y,x,A,O){this.reconnectionToken=Y,this.millisSinceLastIncomingData=x,this.durationSeconds=A,this.cancellableTimer=O,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=F;class q{constructor(Y,x,A){this.reconnectionToken=Y,this.millisSinceLastIncomingData=x,this.attempt=A,this.type=2}}e.ReconnectionRunningEvent=q;class te{constructor(Y,x,A){this.reconnectionToken=Y,this.millisSinceLastIncomingData=x,this.attempt=A,this.type=4}}e.ConnectionGainEvent=te;class ne{constructor(Y,x,A,O){this.reconnectionToken=Y,this.millisSinceLastIncomingData=x,this.attempt=A,this.handled=O,this.type=3}}e.ReconnectionPermanentFailureEvent=ne;class Q extends y.Disposable{constructor(Y,x,A,O,N){super();this._connectionType=Y,this._options=x,this.reconnectionToken=A,this.protocol=O,this._reconnectionFailureIsFatal=N,this._onDidStateChange=this._register(new D.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._permanentFailure=!1,this._isReconnecting=!1,this._onDidStateChange.fire(new te(this.reconnectionToken,0,0)),this._register(O.onSocketClose(V=>{const _=U(this._connectionType,this.reconnectionToken,!0);V?V.type===0?(this._options.logService.info(`${_} received socket close event (hadError: ${V.hadError}).`),V.error&&this._options.logService.error(V.error)):(this._options.logService.info(`${_} received socket close event (wasClean: ${V.wasClean}, code: ${V.code}, reason: ${V.reason}).`),V.event&&this._options.logService.error(V.event)):this._options.logService.info(`${_} received socket close event.`),this._beginReconnecting()})),this._register(O.onSocketTimeout(()=>{const V=U(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${V} received socket timeout event.`),this._beginReconnecting()})),Q._instances.push(this),this._register((0,y.toDisposable)(()=>{const V=Q._instances.indexOf(this);V>=0&&Q._instances.splice(V,1)})),this._isPermanentFailure&&this._gotoPermanentFailure(Q._permanentFailureMillisSinceLastIncomingData,Q._permanentFailureAttempt,Q._permanentFailureHandled)}static triggerPermanentFailure(Y,x,A){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=Y,this._permanentFailureAttempt=x,this._permanentFailureHandled=A,this._instances.forEach(O=>O._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(Y=>Y._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(Y=>Y._pauseSocketWriting())}get _isPermanentFailure(){return this._permanentFailure||Q._permanentFailure}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(this._isPermanentFailure)return;const Y=U(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${Y} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new T(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const x=[0,5,5,10,10,10,10,10,30];let A=-1;do{A++;const O=A<x.length?x[A]:x[x.length-1];try{if(O>0){const V=k(O);this._onDidStateChange.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),O,V)),this._options.logService.info(`${Y} waiting for ${O} seconds before reconnecting...`);try{await V}catch{}}if(this._isPermanentFailure){this._options.logService.error(`${Y} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new q(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),A+1)),this._options.logService.info(`${Y} resolving connection...`);const N=await o(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${Y} connecting to ${N.host}:${N.port}...`),await this._reconnect(N,m(S)),this._options.logService.info(`${Y} reconnected!`),this._onDidStateChange.fire(new te(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),A+1));break}catch(N){if(N.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${Y} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(N),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),A+1,!1);break}if(A>360){this._options.logService.error(`${Y} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(N),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),A+1,!1);break}if(E.RemoteAuthorityResolverError.isTemporarilyNotAvailable(N)){this._options.logService.info(`${Y} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(N);continue}if((N.code==="ETIMEDOUT"||N.code==="ENETUNREACH"||N.code==="ECONNREFUSED"||N.code==="ECONNRESET")&&N.syscall==="connect"){this._options.logService.info(`${Y} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(N);continue}if((0,L.isCancellationError)(N)){this._options.logService.info(`${Y} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(N);continue}if(N instanceof E.RemoteAuthorityResolverError){this._options.logService.error(`${Y} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(N),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),A+1,E.RemoteAuthorityResolverError.isHandled(N));break}this._options.logService.error(`${Y} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(N),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),A+1,!1);break}}while(!this._isPermanentFailure)}_onReconnectionPermanentFailure(Y,x,A){this._reconnectionFailureIsFatal?Q.triggerPermanentFailure(Y,x,A):this._gotoPermanentFailure(Y,x,A)}_gotoPermanentFailure(Y,x,A){this._onDidStateChange.fire(new ne(this.reconnectionToken,Y,x,A)),H(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=Q,Q._permanentFailure=!1,Q._permanentFailureMillisSinceLastIncomingData=0,Q._permanentFailureAttempt=0,Q._permanentFailureHandled=!1,Q._instances=[];class se extends Q{constructor(Y,x,A,O,N){super(1,Y,O,N,!0);this.client=this._register(new v.Client(N,{remoteAuthority:x,clientId:A},Y.ipcLogger))}async _reconnect(Y,x){await r(Y,x)}}e.ManagementPersistentConnection=se;class ce extends Q{constructor(Y,x,A,O,N){super(2,Y,A,O,!1);this._startArguments=x,this.debugPort=N}async _reconnect(Y,x){await i(Y,this._startArguments,x)}}e.ExtensionHostPersistentConnection=ce;function H(j){try{j.acceptDisconnect();const Y=j.getSocket();j.dispose(),Y.dispose()}catch(Y){(0,L.onUnexpectedError)(Y)}}function oe(j){if(j&&j.type==="error"){const Y=new Error(`Connection error: ${j.reason}`);return Y.code="VSCODE_CONNECTION_ERROR",Y}return null}function W(j,Y){for(;j.length<Y;)j+=" ";return j}function U(j,Y,x){return`[remote-connection][${W(u(j),13)}][${Y.substr(0,5)}\u2026][${x?"reconnect":"initial"}]`}function B(j,Y){return`${U(Y,j.reconnectionToken,!!j.reconnectionProtocol)}[${j.host}:${j.port}]`}function X(j){return`${Date.now()-j} ms`}}),define(J[60],Z([0,1,19,158,59,5,44]),function(z,e,b,t,R,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,L.createDecorator)("requestService");function y(m){return m.res.statusCode&&m.res.statusCode>=200&&m.res.statusCode<300||m.res.statusCode===1223}e.isSuccess=y;function f(m){return m.res.statusCode===204}async function v(m){return f(m)?null:(await(0,b.streamToBuffer)(m.stream)).toString()}e.asText=v;async function E(m){if(!y(m))throw new Error("Server returned "+m.res.statusCode);return v(m)}e.asTextOrError=E;async function P(m){if(!y(m))throw new Error("Server returned "+m.res.statusCode);if(f(m))return null;const I=(await(0,b.streamToBuffer)(m.stream)).toString();try{return JSON.parse(I)}catch(p){throw p.message+=`:
`+I,p}}e.asJson=P;function S(m){u(m)}e.updateProxyConfigurationsScope=S;let w;function u(m){const g=D.Registry.as(R.Extensions.Configuration),I=w;w={id:"http",order:15,title:(0,t.localize)(0,null),type:"object",scope:m,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,t.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,t.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,t.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,t.localize)(4,null),(0,t.localize)(5,null),(0,t.localize)(6,null),(0,t.localize)(7,null)],default:"override",description:(0,t.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,t.localize)(9,null),restricted:!0}}},g.updateConfigurations({add:[w],remove:I?[I]:[]})}u(2)}),define(J[206],Z([0,1,207,12]),function(z,e,b,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function R(D,y){return D.protocol==="http:"?y.HTTP_PROXY||y.http_proxy||null:D.protocol==="https:"&&(y.HTTPS_PROXY||y.https_proxy||y.HTTP_PROXY||y.http_proxy)||null}async function L(D,y,f={}){const v=(0,b.parse)(D),E=f.proxyUrl||R(v,y);if(!E)return null;const P=(0,b.parse)(E);if(!/^https?:$/.test(P.protocol||""))return null;const S={host:P.hostname||"",port:P.port||(P.protocol==="https"?"443":"80"),auth:P.auth,rejectUnauthorized:(0,t.isBoolean)(f.strictSSL)?f.strictSSL:!0};return v.protocol==="http:"?new(await new Promise((w,u)=>{z(["http-proxy-agent"],w,u)}))(S):new(await new Promise((w,u)=>{z(["https-proxy-agent"],w,u)}))(S)}e.getProxyAgent=L}),define(J[105],Z([0,1,42,9,159,22,41,18,4,30,142,55,8]),function(z,e,b,t,R,L,D,y,f,v,E,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const w=1e4;let u;async function m(I,p,d){return p["force-disable-user-env"]?(I.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):f.isWindows?(I.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,P.isLaunchedFromCli)(d)&&!p["force-user-env"]?(I.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,P.isLaunchedFromCli)(d)?I.trace("resolveShellEnv(): running (--force-user-env)"):I.trace("resolveShellEnv(): running (macOS/Linux)"),u||(u=S.Promises.withAsyncBody(async(h,l)=>{const n=new L.CancellationTokenSource,r=setTimeout(()=>{n.dispose(!0),l(new Error((0,R.localize)(0,null)))},w);try{h(await g(I,n.token))}catch(i){!(0,y.isCancellationError)(i)&&!n.token.isCancellationRequested?l(new Error((0,R.localize)(1,null,(0,D.toErrorMessage)(i)))):h({})}finally{clearTimeout(r),n.dispose()}})),u)}e.getResolvedShellEnv=m;async function g(I,p){const d=process.env.ELECTRON_RUN_AS_NODE;I.trace("getUnixShellEnvironment#runAsNode",d);const h=process.env.ELECTRON_NO_ATTACH_CONSOLE;I.trace("getUnixShellEnvironment#noAttach",h);const l=(0,v.generateUuid)().replace(/-/g,"").substr(0,12),n=new RegExp(l+"(.*)"+l),r={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};I.trace("getUnixShellEnvironment#env",r);const i=await(0,E.getSystemShell)(f.OS,r);return I.trace("getUnixShellEnvironment#shell",i),new Promise((s,o)=>{if(p.isCancellationRequested)return o((0,y.canceled)());const a=(0,t.basename)(i);let c,C;const k=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(a)?(c=`& '${process.execPath}' ${k} -p '''${l}'' + JSON.stringify(process.env) + ''${l}'''`,C=["-Login","-Command"]):(c=`'${process.execPath}' ${k} -p '"${l}" + JSON.stringify(process.env) + "${l}"'`,a==="tcsh"?C=["-ic"]:C=["-ilc"]),I.trace("getUnixShellEnvironment#spawn",JSON.stringify(C),c);const M=(0,b.spawn)(i,[...C,c],{detached:!0,stdio:["ignore","pipe","pipe"],env:r});p.onCancellationRequested(()=>(M.kill(),o((0,y.canceled)()))),M.on("error",q=>{I.error("getUnixShellEnvironment#errorChildProcess",(0,D.toErrorMessage)(q)),o(q)});const T=[];M.stdout.on("data",q=>T.push(q));const F=[];M.stderr.on("data",q=>F.push(q)),M.on("close",(q,te)=>{const ne=Buffer.concat(T).toString("utf8");I.trace("getUnixShellEnvironment#raw",ne);const Q=Buffer.concat(F).toString("utf8");if(Q.trim()&&I.trace("getUnixShellEnvironment#stderr",Q),q||te)return o(new Error((0,R.localize)(2,null,q,te)));const se=n.exec(ne),ce=se?se[1]:"{}";try{const H=JSON.parse(ce);d?H.ELECTRON_RUN_AS_NODE=d:delete H.ELECTRON_RUN_AS_NODE,h?H.ELECTRON_NO_ATTACH_CONSOLE=h:delete H.ELECTRON_NO_ATTACH_CONSOLE,delete H.XDG_RUNTIME_DIR,I.trace("getUnixShellEnvironment#result",H),s(H)}catch(H){I.error("getUnixShellEnvironment#errorCaught",(0,D.toErrorMessage)(H)),o(H)}})})}}),define(J[85],Z([0,1,5]),function(z,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,b.createDecorator)(e.SIGN_SERVICE_ID)}),define(J[208],Z([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class b{constructor(){this.validators=new Map}vsda(){return new Promise((R,L)=>z(["vsda"],R,L))}async createNewMessage(R){try{const L=await this.vsda(),D=new L.validator;if(D){const y=String(b._nextId++);return this.validators.set(y,D),{id:y,data:D.createNewMessage(R)}}}catch{}return{id:"",data:R}}async validate(R,L){if(!R.id)return!0;const D=this.validators.get(R.id);if(!D)return!1;this.validators.delete(R.id);try{return D.validate(L)==="ok"}catch{return!1}}async sign(R){try{const L=await this.vsda(),D=new L.signer;if(D)return D.sign(R)}catch{}return R}}e.SignService=b,b._nextId=1}),define(J[45],Z([0,1,5]),function(z,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateMainService=void 0,e.IStateMainService=(0,b.createDecorator)("stateMainService")}),define(J[21],Z([0,1,14,38,8,3,2,4,36,12,5,6,45]),function(z,e,b,t,R,L,D,y,f,v,E,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.ShutdownReason=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,E.createDecorator)("lifecycleMainService");var w;(function(g){g[g.QUIT=1]="QUIT",g[g.KILL=2]="KILL"})(w=e.ShutdownReason||(e.ShutdownReason={}));var u;(function(g){g[g.Starting=1]="Starting",g[g.Ready=2]="Ready",g[g.AfterWindowOpen=3]="AfterWindowOpen"})(u=e.LifecycleMainPhase||(e.LifecycleMainPhase={}));let m=class yt extends D.Disposable{constructor(I,p){super();this.logService=I,this.stateMainService=p,this._onBeforeShutdown=this._register(new L.Emitter),this.onBeforeShutdown=this._onBeforeShutdown.event,this._onWillShutdown=this._register(new L.Emitter),this.onWillShutdown=this._onWillShutdown.event,this._onWillLoadWindow=this._register(new L.Emitter),this.onWillLoadWindow=this._onWillLoadWindow.event,this._onBeforeCloseWindow=this._register(new L.Emitter),this.onBeforeCloseWindow=this._onBeforeCloseWindow.event,this._quitRequested=!1,this._wasRestarted=!1,this._phase=1,this.windowToCloseRequest=new Set,this.oneTimeListenerTokenGenerator=0,this.windowCounter=0,this.pendingQuitPromise=void 0,this.pendingQuitPromiseResolve=void 0,this.pendingWillShutdownPromise=void 0,this.mapWindowIdToPendingUnload=new Map,this.phaseWhen=new Map,this.resolveRestarted(),this.when(2).then(()=>this.registerListeners())}get quitRequested(){return this._quitRequested}get wasRestarted(){return this._wasRestarted}get phase(){return this._phase}resolveRestarted(){this._wasRestarted=!!this.stateMainService.getItem(yt.QUIT_AND_RESTART_KEY),this._wasRestarted&&this.stateMainService.removeItem(yt.QUIT_AND_RESTART_KEY)}registerListeners(){const I=()=>{this._quitRequested||(this.logService.trace("Lifecycle#app.on(before-quit)"),this._quitRequested=!0,this.logService.trace("Lifecycle#onBeforeShutdown.fire()"),this._onBeforeShutdown.fire(),y.isMacintosh&&this.windowCounter===0&&this.fireOnWillShutdown(1))};b.app.addListener("before-quit",I);const p=()=>{this.logService.trace("Lifecycle#app.on(window-all-closed)"),(this._quitRequested||!y.isMacintosh)&&b.app.quit()};b.app.addListener("window-all-closed",p),b.app.once("will-quit",d=>{this.logService.trace("Lifecycle#app.on(will-quit)"),d.preventDefault(),this.fireOnWillShutdown(1).finally(()=>{this.resolvePendingQuitPromise(!1),b.app.removeListener("before-quit",I),b.app.removeListener("window-all-closed",p),b.app.quit()})})}fireOnWillShutdown(I){if(this.pendingWillShutdownPromise)return this.pendingWillShutdownPromise;this.logService.trace("Lifecycle#onWillShutdown.fire()");const p=[];return this._onWillShutdown.fire({reason:I,join(d){p.push(d)}}),this.pendingWillShutdownPromise=(async()=>{try{await R.Promises.settled(p)}catch(d){this.logService.error(d)}try{await this.stateMainService.close()}catch(d){this.logService.error(d)}})(),this.pendingWillShutdownPromise}set phase(I){if(I<this.phase)throw new Error("Lifecycle cannot go backwards");if(this._phase===I)return;this.logService.trace(`lifecycle (main): phase changed (value: ${I})`),this._phase=I;const p=this.phaseWhen.get(this._phase);p&&(p.open(),this.phaseWhen.delete(this._phase))}async when(I){if(I<=this._phase)return;let p=this.phaseWhen.get(I);p||(p=new R.Barrier,this.phaseWhen.set(I,p)),await p.wait()}registerWindow(I){const p=new D.DisposableStore;this.windowCounter++,p.add(I.onWillLoad(h=>this._onWillLoadWindow.fire({window:I,workspace:h.workspace,reason:h.reason})));const d=(0,v.assertIsDefined)(I.win);d.on("close",h=>{const l=I.id;if(this.windowToCloseRequest.has(l)){this.windowToCloseRequest.delete(l);return}this.logService.trace(`Lifecycle#window.on('close') - window ID ${I.id}`),h.preventDefault(),this.unload(I,1).then(n=>{if(n){this.windowToCloseRequest.delete(l);return}this.windowToCloseRequest.add(l),this.logService.trace(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${l}`),this._onBeforeCloseWindow.fire(I),I.close()})}),d.on("closed",()=>{this.logService.trace(`Lifecycle#window.on('closed') - window ID ${I.id}`),this.windowCounter--,p.dispose(),this.windowCounter===0&&(!y.isMacintosh||this._quitRequested)&&this.fireOnWillShutdown(1)})}async reload(I,p){await this.unload(I,3)||I.reload(p)}unload(I,p){const d=this.mapWindowIdToPendingUnload.get(I.id);if(d)return d;const h=this.doUnload(I,p).finally(()=>{this.mapWindowIdToPendingUnload.delete(I.id)});return this.mapWindowIdToPendingUnload.set(I.id,h),h}async doUnload(I,p){if(!I.isReady)return!1;this.logService.trace(`Lifecycle#unload() - window ID ${I.id}`);const d=this._quitRequested?2:p,h=await this.onBeforeUnloadWindowInRenderer(I,d);return h?(this.logService.trace(`Lifecycle#unload() - veto in renderer (window ID ${I.id})`),this.handleWindowUnloadVeto(h)):(await this.onWillUnloadWindowInRenderer(I,d),!1)}handleWindowUnloadVeto(I){return I?(this.resolvePendingQuitPromise(!0),this._quitRequested=!1,!0):!1}resolvePendingQuitPromise(I){this.pendingQuitPromiseResolve&&(this.pendingQuitPromiseResolve(I),this.pendingQuitPromiseResolve=void 0,this.pendingQuitPromise=void 0)}onBeforeUnloadWindowInRenderer(I,p){return new Promise(d=>{const h=this.oneTimeListenerTokenGenerator++,l=`vscode:ok${h}`,n=`vscode:cancel${h}`;t.validatedIpcMain.once(l,()=>{d(!1)}),t.validatedIpcMain.once(n,()=>{d(!0)}),I.send("vscode:onBeforeUnload",{okChannel:l,cancelChannel:n,reason:p})})}onWillUnloadWindowInRenderer(I,p){return new Promise(d=>{const l=`vscode:reply${this.oneTimeListenerTokenGenerator++}`;t.validatedIpcMain.once(l,()=>d()),I.send("vscode:onWillUnload",{replyChannel:l,reason:p})})}quit(I){return this.pendingQuitPromise?this.pendingQuitPromise:(this.logService.trace(`Lifecycle#quit() - will restart: ${I}`),I&&this.stateMainService.setItem(yt.QUIT_AND_RESTART_KEY,!0),this.pendingQuitPromise=new Promise(p=>{this.pendingQuitPromiseResolve=p,this.logService.trace("Lifecycle#quit() - calling app.quit()"),b.app.quit()}),this.pendingQuitPromise)}async relaunch(I){this.logService.trace("Lifecycle#relaunch()");const p=process.argv.slice(1);if(I?.addArgs&&p.push(...I.addArgs),I?.removeArgs)for(const l of I.removeArgs){const n=p.indexOf(l);n>=0&&p.splice(n,1)}const d=()=>{try{if(y.isWindows){const l=(0,f.cwd)();l!==process.cwd()&&process.chdir(l)}}catch(l){this.logService.error(l)}this.logService.trace("Lifecycle#relaunch() - calling app.relaunch()"),b.app.relaunch({args:p})};b.app.once("quit",d),await this.quit(!0)&&b.app.removeListener("quit",d)}async kill(I){this.logService.trace("Lifecycle#kill()"),await this.fireOnWillShutdown(2),await Promise.race([(0,R.timeout)(1e3),(async()=>{for(const p of b.BrowserWindow.getAllWindows())if(p&&!p.isDestroyed()){let d;p.webContents&&!p.webContents.isDestroyed()?d=new Promise(h=>p.once("closed",h)):d=Promise.resolve(),p.destroy(),await d}})()]),b.app.exit(I)}};m.QUIT_AND_RESTART_KEY="lifecycle.quitAndRestart",m=de([ee(0,P.ILogService),ee(1,S.IStateMainService)],m),e.LifecycleMainService=m}),define(J[209],Z([0,1,4,3,2,5,21]),function(z,e,b,t,R,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,L.createDecorator)("keyboardLayoutMainService");let y=class extends R.Disposable{constructor(E){super();this._onDidChangeKeyboardLayout=this._register(new t.Emitter),this.onDidChangeKeyboardLayout=this._onDidChangeKeyboardLayout.event,this._initPromise=null,this._keyboardLayoutData=null,E.when(3).then(()=>this._initialize())}_initialize(){return this._initPromise||(this._initPromise=this._doInitialize()),this._initPromise}async _doInitialize(){const E=await new Promise((P,S)=>{z(["native-keymap"],P,S)});this._keyboardLayoutData=f(E),b.isCI||E.onDidChangeKeyboardLayout(()=>{this._keyboardLayoutData=f(E),this._onDidChangeKeyboardLayout.fire(this._keyboardLayoutData)})}async getKeyboardLayoutData(){return await this._initialize(),this._keyboardLayoutData}};y=de([ee(0,D.ILifecycleMainService)],y),e.KeyboardLayoutMainService=y;function f(v){const E=v.getKeyMap(),P=v.getCurrentKeyboardLayout();return{keyboardMapping:E,keyboardLayoutInfo:P}}}),define(J[210],Z([0,1,5]),function(z,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=void 0,e.IStateService=(0,b.createDecorator)("stateService")}),define(J[211],Z([0,1,8,19,12,39,15,6]),function(z,e,b,t,R,L,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.FileStorage=void 0;class f{constructor(P,S,w){this.storagePath=P,this.logService=S,this.fileService=w,this.storage=Object.create(null),this.lastSavedStorageContents="",this.flushDelayer=new b.ThrottledDelayer(100),this.initializing=void 0,this.closing=void 0}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(P){P.fileOperationResult!==1&&this.logService.error(P)}}getItem(P,S){const w=this.storage[P];return(0,R.isUndefinedOrNull)(w)?S:w}setItem(P,S){this.setItems([{key:P,data:S}])}setItems(P){let S=!1;for(const{key:w,data:u}of P)this.storage[w]!==u&&((0,R.isUndefinedOrNull)(u)?(0,R.isUndefined)(this.storage[w])||(this.storage[w]=void 0,S=!0):(this.storage[w]=u,S=!0));S&&this.save()}removeItem(P){(0,R.isUndefined)(this.storage[P])||(this.storage[P]=void 0,this.save())}async save(P){if(!this.closing)return this.flushDelayer.trigger(()=>this.doSave(),P)}async doSave(){if(!this.initializing)return;await this.initializing;const P=JSON.stringify(this.storage,null,4);if(P!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,t.VSBuffer.fromString(P)),this.lastSavedStorageContents=P}catch(S){this.logService.error(S)}}async close(){return this.closing||(this.closing=this.flushDelayer.trigger(()=>this.doSave(),0)),this.closing}}e.FileStorage=f;let v=class{constructor(P,S,w){this.fileStorage=new f(P.stateResource,S,w)}async init(){await this.fileStorage.init()}getItem(P,S){return this.fileStorage.getItem(P,S)}};v=de([ee(0,L.IEnvironmentService),ee(1,y.ILogService),ee(2,D.IFileService)],v),e.StateService=v}),define(J[212],Z([0,1,211]),function(z,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateMainService=void 0;class t extends b.StateService{setItem(L,D){this.fileStorage.setItem(L,D)}setItems(L){this.fileStorage.setItems(L)}removeItem(L){this.fileStorage.removeItem(L)}close(){return this.fileStorage.close()}}e.StateMainService=t}),define(J[213],Z([0,1,4,36,7,30]),function(z,e,b,t,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function D(v){if(b.platform===2&&/^penguin(\.|$)/i.test(v))return"chromebook"}async function y(v,E,P,S,w,u,m,g,I,p){const d=Object.create(null);d["common.machineId"]=m,d.sessionID=(0,L.generateUuid)()+Date.now(),d.commitHash=w,d.version=u,d["common.platformVersion"]=(E||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),d["common.platform"]=(0,b.PlatformToString)(b.platform),d["common.nodePlatform"]=t.platform,d["common.nodeArch"]=S,d["common.product"]=p||"desktop";const h=f(g||[]);h&&(d["common.msftInternal"]=h);let l=0;const n=Date.now();Object.defineProperties(d,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-n,enumerable:!0},"common.sequence":{get:()=>l++,enumerable:!0}}),b.isLinuxSnap&&(d["common.snap"]="true");const r=D(P);r&&(d["common.platformDetail"]=r);try{const i=await v.readFile(R.URI.file(I));d["common.source"]=i.value.toString().slice(0,30)}catch{}return d}e.resolveCommonProperties=y;function f(v){const E=t.env.USERDNSDOMAIN;if(!E)return!1;const P=E.toLowerCase();return v.some(S=>P===S)}e.verifyMicrosoftInternalDomain=f}),define(J[35],Z([0,1,5]),function(z,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,b.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,b.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var t;(function(L){L[L.NONE=0]="NONE",L[L.CRASH=1]="CRASH",L[L.ERROR=2]="ERROR",L[L.USAGE=3]="USAGE"})(t=e.TelemetryLevel||(e.TelemetryLevel={}));var R;(function(L){L.OFF="off",L.CRASH="crash",L.ERROR="error",L.ON="all"})(R=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(J[214],Z([0,1,27,53,8,49,11,9,4,7,80,23,94,82,15,20,35]),function(z,e,b,t,R,L,D,y,f,v,E,P,S,w,u,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const I=new Map;async function p(r,i){const s=`${r}::${i.join(":")}`,o=I.get(s);if(o)return o;const a=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],c=new Map,C=new Map,k=2e4;function M(F,q,te,ne){const Q=q.substring(F.length+1);return R.Promises.withAsyncBody(async se=>{let ce;try{ce=await P.Promises.readdir(q,{withFileTypes:!0})}catch{se();return}if(ne.count>=k){ne.count+=ce.length,ne.maxReached=!0,se();return}let H=ce.length;if(H===0){se();return}let oe=ce;ne.count+ce.length>k&&(ne.maxReached=!0,H=k-ne.count,oe=ce.slice(0,H)),ne.count+=ce.length;for(const W of oe)if(W.isDirectory()){if(te.includes(W.name)||await M(F,(0,y.join)(q,W.name),te,ne),--H==0){se();return}}else{const U=W.name.lastIndexOf(".");if(U>=0){const B=W.name.substring(U+1);B&&c.set(B,(c.get(B)??0)+1)}for(const B of a)B.relativePathPattern?.test(Q)!==!1&&B.filePattern.test(W.name)&&C.set(B.tag,(C.get(B.tag)??0)+1);if(--H==0){se();return}}})}const T=R.Promises.withAsyncBody(async F=>{const q={count:0,maxReached:!1};await M(r,r,i,q);const te=await l(r);F({configFiles:d(C),fileTypes:d(c),fileCount:q.count,maxFilesReached:q.maxReached,launchConfigFiles:te})});return I.set(s,T),T}e.collectWorkspaceStats=p;function d(r){return[...t.Iterable.map(r.entries(),([i,s])=>({name:i,count:s}))].sort((i,s)=>s.count-i.count)}function h(){const r={os:`${b.type()} ${b.arch()} ${b.release()}`,memory:`${(b.totalmem()/u.ByteSize.GB).toFixed(2)}GB (${(b.freemem()/u.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(E.virtualMachineHint.value()*100)}%`},i=b.cpus();return i&&i.length>0&&(r.cpus=`${i[0].model} (${i.length} x ${i[0].speed})`),r}e.getMachineInfo=h;async function l(r){try{const i=new Map,s=(0,y.join)(r,".vscode","launch.json"),o=await P.Promises.readFile(s),a=[],c=(0,L.parse)(o.toString(),a);if(a.length)return console.log(`Unable to parse ${s}`),[];if((0,L.getNodeType)(c)==="object"&&c.configurations)for(const C of c.configurations){const k=C.type;k&&(i.has(k)?i.set(k,i.get(k)+1):i.set(k,1))}return d(i)}catch{return[]}}e.collectLaunchConfigs=l;let n=class{constructor(i,s){this.telemetryService=i,this.productService=s}formatMachineInfo(i){const s=[];return s.push(`OS Version:       ${i.os}`),s.push(`CPUs:             ${i.cpus}`),s.push(`Memory (System):  ${i.memory}`),s.push(`VM:               ${i.vmHint}`),s.join(`
`)}formatEnvironment(i){const s=[];s.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),s.push(`OS Version:       ${b.type()} ${b.arch()} ${b.release()}`);const o=b.cpus();return o&&o.length>0&&s.push(`CPUs:             ${o[0].model} (${o.length} x ${o[0].speed})`),s.push(`Memory (System):  ${(b.totalmem()/u.ByteSize.GB).toFixed(2)}GB (${(b.freemem()/u.ByteSize.GB).toFixed(2)}GB free)`),f.isWindows||s.push(`Load (avg):       ${b.loadavg().map(a=>Math.round(a)).join(", ")}`),s.push(`VM:               ${Math.round(E.virtualMachineHint.value()*100)}%`),s.push(`Screen Reader:    ${i.screenReader?"yes":"no"}`),s.push(`Process Argv:     ${i.mainArguments.join(" ")}`),s.push(`GPU Status:       ${this.expandGPUFeatures(i.gpuFeatureStatus)}`),s.join(`
`)}async getPerformanceInfo(i,s){return Promise.all([(0,S.listProcesses)(i.mainPID),this.formatWorkspaceMetadata(i)]).then(async o=>{let[a,c]=o,C=this.formatProcessList(i,a);return s.forEach(k=>{if((0,w.isRemoteDiagnosticError)(k))C+=`
${k.errorMessage}`,c+=`
${k.errorMessage}`;else if(C+=`

Remote: ${k.hostName}`,k.processes&&(C+=`
${this.formatProcessList(i,k.processes)}`),k.workspaceMetadata){c+=`
|  Remote: ${k.hostName}`;for(const M of Object.keys(k.workspaceMetadata)){const T=k.workspaceMetadata[M];let F=`${T.fileCount} files`;T.maxFilesReached&&(F=`more than ${F}`),c+=`|    Folder (${M}): ${F}`,c+=this.formatWorkspaceStats(T)}}}),{processInfo:C,workspaceInfo:c}})}async getSystemInfo(i,s){const{memory:o,vmHint:a,os:c,cpus:C}=h(),k={os:c,memory:o,cpus:C,vmHint:a,processArgs:`${i.mainArguments.join(" ")}`,gpuStatus:i.gpuFeatureStatus,screenReader:`${i.screenReader?"yes":"no"}`,remoteData:s};return f.isWindows||(k.load=`${b.loadavg().map(M=>Math.round(M)).join(", ")}`),f.isLinux&&(k.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(k)}async getDiagnostics(i,s){const o=[];return(0,S.listProcesses)(i.mainPID).then(async a=>(o.push(""),o.push(this.formatEnvironment(i)),o.push(""),o.push(this.formatProcessList(i,a)),i.windows.some(c=>c.folderURIs&&c.folderURIs.length>0&&!c.remoteAuthority)&&(o.push(""),o.push("Workspace Stats: "),o.push(await this.formatWorkspaceMetadata(i))),s.forEach(c=>{if((0,w.isRemoteDiagnosticError)(c))o.push(`
${c.errorMessage}`);else if(o.push(`

`),o.push(`Remote:           ${c.hostName}`),o.push(this.formatMachineInfo(c.machineInfo)),c.processes&&o.push(this.formatProcessList(i,c.processes)),c.workspaceMetadata)for(const C of Object.keys(c.workspaceMetadata)){const k=c.workspaceMetadata[C];let M=`${k.fileCount} files`;k.maxFilesReached&&(M=`more than ${M}`),o.push(`Folder (${C}): ${M}`),o.push(this.formatWorkspaceStats(k))}}),o.push(""),o.push(""),o.join(`
`)))}formatWorkspaceStats(i){const s=[],o=60;let a=0;const c=(T,F)=>{const q=` ${T}(${F})`;a+q.length>o?(s.push(C),C="|                 ",a=C.length):a+=q.length,C+=q};let C="|      File types:";const k=10,M=i.fileTypes.length>k?k:i.fileTypes.length;for(let T=0;T<M;T++){const F=i.fileTypes[T];c(F.name,F.count)}if(s.push(C),i.configFiles.length>=0&&(C="|      Conf files:",a=0,i.configFiles.forEach(T=>{c(T.name,T.count)}),s.push(C)),i.launchConfigFiles.length>0){let T="|      Launch Configs:";i.launchConfigFiles.forEach(F=>{T+=F.count>1?` ${F.name}(${F.count})`:` ${F.name}`}),s.push(T)}return s.join(`
`)}expandGPUFeatures(i){const s=Math.max(...Object.keys(i).map(o=>o.length));return Object.keys(i).map(o=>`${o}:  ${" ".repeat(s-o.length)}  ${i[o]}`).join(`
                  `)}formatWorkspaceMetadata(i){const s=[],o=[];return i.windows.forEach(a=>{a.folderURIs.length===0||!!a.remoteAuthority||(s.push(`|  Window (${a.title})`),a.folderURIs.forEach(c=>{const C=v.URI.revive(c);if(C.scheme===D.Schemas.file){const k=C.fsPath;o.push(p(k,["node_modules",".git"]).then(M=>{let T=`${M.fileCount} files`;M.maxFilesReached&&(T=`more than ${T}`),s.push(`|    Folder (${(0,y.basename)(k)}): ${T}`),s.push(this.formatWorkspaceStats(M))}).catch(M=>{s.push(`|      Error: Unable to collect workspace stats for folder ${k} (${M.toString()})`)}))}else s.push(`|    Folder (${C.toString()}): Workspace stats not available.`)}))}),Promise.all(o).then(a=>s.join(`
`)).catch(a=>`Unable to collect workspace stats: ${a}`)}formatProcessList(i,s){const o=new Map;i.windows.forEach(c=>o.set(c.pid,c.title));const a=[];return a.push("CPU %	Mem MB	   PID	Process"),s&&this.formatProcessItem(i.mainPID,o,a,s,0),a.join(`
`)}formatProcessItem(i,s,o,a,c){const C=c===0;let k;C?k=a.pid===i?`${this.productService.applicationName} main`:"remote agent":(k=`${"  ".repeat(c)} ${a.name}`,a.name==="window"&&(k=`${k} (${s.get(a.pid)})`));const M=process.platform==="win32"?a.mem:b.totalmem()*(a.mem/100);o.push(`${a.load.toFixed(0).padStart(5," ")}	${(M/u.ByteSize.MB).toFixed(0).padStart(6," ")}	${a.pid.toFixed(0).padStart(6," ")}	${k}`),Array.isArray(a.children)&&a.children.forEach(T=>this.formatProcessItem(i,s,o,T,c+1))}async getWorkspaceFileExtensions(i){const s=new Set;for(const{uri:o}of i.folders){const a=v.URI.revive(o);if(a.scheme!==D.Schemas.file)continue;const c=a.fsPath;try{(await p(c,["node_modules",".git"])).fileTypes.forEach(k=>s.add(k.name))}catch{}}return{extensions:[...s]}}async reportWorkspaceStats(i){for(const{uri:s}of i.folders){const o=v.URI.revive(s);if(o.scheme!==D.Schemas.file)continue;const a=o.fsPath;try{const c=await p(a,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":i.telemetryId,rendererSessionId:i.rendererSessionId}),c.fileTypes.forEach(C=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:i.rendererSessionId,type:C.name,count:C.count})}),c.launchConfigFiles.forEach(C=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:i.rendererSessionId,type:C.name,count:C.count})}),c.configFiles.forEach(C=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:i.rendererSessionId,type:C.name,count:C.count})})}catch{}}}};n=de([ee(0,g.ITelemetryService),ee(1,m.IProductService)],n),e.DiagnosticsService=n}),define(J[215],Z([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class b{constructor(L){this.appenders=L}listen(L,D){throw new Error(`Event not found: ${D}`)}call(L,D,{eventName:y,data:f}){return this.appenders.forEach(v=>v.log(y,f)),Promise.resolve(null)}}e.TelemetryAppenderChannel=b;class t{constructor(L){this.channel=L}log(L,D){return this.channel.call("log",{eventName:L,data:D}).then(void 0,y=>`Failed to log telemetry: ${console.warn(y)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=t}),define(J[72],Z([0,1,50,91,12,17,35]),function(z,e,b,t,R,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPiiPathsFromEnvironment=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class y{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=(0,t.staticObservableValue)(0)}publicLog(h,l){return Promise.resolve(void 0)}publicLog2(h,l){return this.publicLog(h,l)}publicLogError(h,l){return Promise.resolve(void 0)}publicLogError2(h,l){return this.publicLogError(h,l)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=y,e.NullTelemetryService=new y;class f{async publicLog(h,l,n){}async publicLogError(h,l,n){}}e.NullEndpointTelemetryService=f,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function v(d,h){return h.onDidChangeConfiguration(l=>{l.source!==6&&d.publicLog2("updateConfiguration",{configurationSource:(0,L.ConfigurationTargetToString)(l.source),configurationKeys:g(l.sourceConfig)})})}e.configurationTelemetry=v;function E(d,h){return!(h.disableTelemetry||!d.enableTelemetry||h.extensionTestsLocationURI)}e.supportsTelemetry=E;function P(d){const h=d.getValue(D.TELEMETRY_SETTING_ID),l=d.getValue("telemetry.enableCrashReporter");if(d.getValue(D.TELEMETRY_OLD_SETTING_ID)===!1||l===!1)return 0;switch(h??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=P;function S(d){const h={},l={},n={};m(d,n);for(let r in n){r=r.length>150?r.substr(r.length-149):r;const i=n[r];typeof i=="number"?l[r]=i:typeof i=="boolean"?l[r]=i?1:0:typeof i=="string"?(i.length>8192&&console.warn(`Telemetry property: ${r} has been trimmed to 8192, the original length is ${i.length}`),h[r]=i.substring(0,8191)):typeof i!="undefined"&&i!==null&&(h[r]=i)}return{properties:h,measurements:l}}e.validateTelemetryData=S;const w=["ssh-remote","dev-container","attached-container","wsl","tunneling"];function u(d){if(!d)return"none";for(const h of w)if(d.startsWith(`${h}+`))return h;return"other"}e.cleanRemoteAuthority=u;function m(d,h,l=0,n){if(!!d)for(const r of Object.getOwnPropertyNames(d)){const i=d[r],s=n?n+r:r;Array.isArray(i)?h[s]=(0,b.safeStringify)(i):i instanceof Date?h[s]=i.toISOString():(0,R.isObject)(i)?l<2?m(i,h,l+1,s+"."):h[s]=(0,b.safeStringify)(i):h[s]=i}}function g(d){if(!d)return[];const h=[];return I(h,"",d),h}function I(d,h,l){l&&typeof l=="object"&&!Array.isArray(l)?Object.keys(l).forEach(n=>I(d,h?`${h}.${n}`:n,l[n])):d.push(h)}function p(d){return[d.appRoot,d.extensionsPath,d.userHome.fsPath,d.tmpDir.fsPath,d.userDataPath]}e.getPiiPathsFromEnvironment=p}),define(J[216],Z([0,1,177,72]),function(z,e,b,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function R(L,D,y,f,v,E,P){const S={"X-Market-Client-Id":`VSCode ${L}`,"User-Agent":`VSCode ${L} (${D.nameShort})`},w=await(0,b.getServiceMachineId)(y,v,E),{sessionId:u}=await P.getTelemetryInfo();return(0,t.supportsTelemetry)(D,y)&&(0,t.getTelemetryLevel)(f)===3&&(S["X-Market-User-Id"]=w,S["VSCode-SessionId"]=u),S}e.resolveMarketplaceHeaders=R}),define(J[217],Z([0,1,2,50,91,4,31,160,17,59,57,20,44,35,72]),function(z,e,b,t,R,L,D,y,f,v,E,P,S,w,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let m=class{constructor(p,d,h){this._configurationService=d,this._productService=h,this._experimentProperties={},this.telemetryLevel=new R.MutableObservableValue(3),this._disposables=new b.DisposableStore,this._cleanupPatterns=[],this._appenders=p.appenders,this._commonProperties=p.commonProperties||Promise.resolve({}),this._piiPaths=p.piiPaths||[],this._sendErrorTelemetry=!!p.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(const l of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,D.escapeRegExpCharacters)(l),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables)}setExperimentProperty(p,d){this._experimentProperties[p]=d}_updateTelemetryLevel(){let p=(0,u.getTelemetryLevel)(this._configurationService);const d=this._productService.enabledTelemetryLevels;if(d){this._sendErrorTelemetry=this.sendErrorTelemetry?d.error:!1;const h=d.usage?3:d.error?2:0;p=Math.min(p,h)}this.telemetryLevel.value=p}get sendErrorTelemetry(){return this._sendErrorTelemetry}async getTelemetryInfo(){const p=await this._commonProperties,d=p.sessionID,h=p["common.machineId"],l=p["common.firstSessionDate"],n=p["common.msftInternal"];return{sessionId:d,machineId:h,firstSessionDate:l,msftInternal:n}}dispose(){this._disposables.dispose()}_log(p,d,h,l){return this.telemetryLevel.value<d?Promise.resolve(void 0):this._commonProperties.then(n=>{h=(0,t.mixin)(h,n),h=(0,t.mixin)(h,this._experimentProperties),h=(0,t.cloneAndChange)(h,r=>{if(typeof r=="string")return this._cleanupInfo(r,l)}),this._appenders.forEach(r=>r.log(p,h))},n=>{console.error(n)})}publicLog(p,d,h){return this._log(p,3,d,h)}publicLog2(p,d,h){return this.publicLog(p,d,h)}publicLogError(p,d){return this._sendErrorTelemetry?this._log(p,2,d,!0):Promise.resolve(void 0)}publicLogError2(p,d){return this.publicLogError(p,d)}_anonymizeFilePaths(p){let d=p;const h=[];for(const i of this._cleanupPatterns)for(;;){const s=i.exec(p);if(!s)break;h.push([s.index,i.lastIndex])}const l=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,n=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let r=0;for(d="";;){const i=n.exec(p);if(!i)break;!l.test(i[0])&&h.every(([s,o])=>i.index<s||i.index>=o)&&(d+=p.substring(r,i.index)+"<REDACTED: user-file-path>",r=n.lastIndex)}return r<p.length&&(d+=p.substr(r)),d}_removePropertiesWithPossibleUserInfo(p){if(!p)return p;const d=p.toLowerCase(),h=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-.]+/}];for(const l of h)if(l.regex.test(d))return`<REDACTED: ${l.label}>`;return p}_cleanupInfo(p,d){let h=p;d&&(h=this._anonymizeFilePaths(h));for(const l of this._cleanupPatterns)h=h.replace(l,"");return h=this._removePropertiesWithPossibleUserInfo(h),h}};m.IDLE_START_EVENT_NAME="UserIdleStart",m.IDLE_STOP_EVENT_NAME="UserIdleStop",m=de([ee(1,f.IConfigurationService),ee(2,P.IProductService)],m),e.TelemetryService=m;function g(){const I=(0,y.localize)(0,null,E.default.nameLong),p=E.default.privacyStatementUrl?(0,y.localize)(2,null,"https://aka.ms/vscode-telemetry",E.default.privacyStatementUrl):(0,y.localize)(1,null,"https://aka.ms/vscode-telemetry"),d=L.isWeb?"":(0,y.localize)(3,null),h=(0,y.localize)(4,null),l=(0,y.localize)(5,null),n=(0,y.localize)(6,null),r=(0,y.localize)(7,null),i=`
|       | ${h} | ${l} | ${n} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,s=(0,y.localize)(8,null);return`
${I} ${p} ${d}

&nbsp;

${r}
${i}

&nbsp;

${s}
`}S.Registry.as(v.Extensions.Configuration).registerConfiguration({id:w.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,y.localize)(9,null),properties:{[w.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,y.localize)(10,null),(0,y.localize)(11,null),(0,y.localize)(12,null),(0,y.localize)(13,null)],markdownDescription:g(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),S.Registry.as(v.Extensions.Configuration).registerConfiguration({id:w.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,y.localize)(14,null),properties:{[w.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:E.default.privacyStatementUrl?(0,y.localize)(16,null,E.default.nameLong,E.default.privacyStatementUrl):(0,y.localize)(15,null,E.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,y.localize)(17,null,`\`#${w.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(J[218],Z([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var b;(function(L){L.DARK="dark",L.LIGHT="light",L.HIGH_CONTRAST_DARK="hcDark",L.HIGH_CONTRAST_LIGHT="hcLight"})(b=e.ColorScheme||(e.ColorScheme={}));function t(L){return L===b.HIGH_CONTRAST_DARK||L===b.HIGH_CONTRAST_LIGHT}e.isHighContrast=t;function R(L){return L===b.DARK||L===b.HIGH_CONTRAST_DARK}e.isDark=R}),define(J[219],Z([0,1,115,3,2,5,44,218]),function(z,e,b,t,R,L,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,L.createDecorator)("themeService");var f;(function(g){function I(p){return p&&typeof p=="object"&&typeof p.id=="string"}g.isThemeColor=I})(f=e.ThemeColor||(e.ThemeColor={}));function v(g){return{id:g}}e.themeColorFromId=v;var E;(function(g){function I(s){return s&&typeof s=="object"&&typeof s.id=="string"&&(typeof s.color=="undefined"||f.isThemeColor(s.color))}g.isThemeIcon=I;const p=new RegExp(`^\\$\\((${b.CSSIcon.iconNameExpression}(?:${b.CSSIcon.iconModifierExpression})?)\\)$`);function d(s){const o=p.exec(s);if(!o)return;const[,a]=o;return{id:a}}g.fromString=d;function h(s){return{id:s}}g.fromId=h;function l(s,o){let a=s.id;const c=a.lastIndexOf("~");return c!==-1&&(a=a.substring(0,c)),o&&(a=`${a}~${o}`),{id:a}}g.modify=l;function n(s){const o=s.id.lastIndexOf("~");if(o!==-1)return s.id.substring(o+1)}g.getModifier=n;function r(s,o){return s.id===o.id&&s.color?.id===o.color?.id}g.isEqual=r;function i(s,o){return{id:s.id,color:o?v(o):void 0}}g.asThemeIcon=i,g.asClassNameArray=b.CSSIcon.asClassNameArray,g.asClassName=b.CSSIcon.asClassName,g.asCSSSelector=b.CSSIcon.asCSSSelector})(E=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=b.Codicon.file,e.FolderThemeIcon=b.Codicon.folder;function P(g){switch(g){case y.ColorScheme.DARK:return"vs-dark";case y.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case y.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=P,e.Extensions={ThemingContribution:"base.contributions.theming"};class S{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new t.Emitter}onColorThemeChange(I){return this.themingParticipants.push(I),this.onThemingParticipantAddedEmitter.fire(I),(0,R.toDisposable)(()=>{const p=this.themingParticipants.indexOf(I);this.themingParticipants.splice(p,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}const w=new S;D.Registry.add(e.Extensions.ThemingContribution,w);function u(g){return w.onColorThemeChange(g)}e.registerThemingParticipant=u;class m extends R.Disposable{constructor(I){super();this.themeService=I,this.theme=I.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(p=>this.onThemeChange(p)))}onThemeChange(I){this.theme=I,this.updateStyles()}updateStyles(){}getColor(I,p){let d=this.theme.getColor(I);return d&&p&&(d=p(d,this.theme)),d?d.toString():null}}e.Themable=m}),define(J[61],Z([0,1,14,3,2,4,17,5,45]),function(z,e,b,t,R,L,D,y,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const v="#FFFFFF",E="#1E1E1E",P="#000000",S="#FFFFFF",w="theme",u="themeBackground",m="windowSplash";e.IThemeMainService=(0,y.createDecorator)("themeMainService");let g=class extends R.Disposable{constructor(p,d){super();this.stateMainService=p,this.configurationService=d,this._onDidChangeColorScheme=this._register(new t.Emitter),this.onDidChangeColorScheme=this._onDidChangeColorScheme.event,b.nativeTheme.on("updated",()=>{this._onDidChangeColorScheme.fire(this.getColorScheme())})}getColorScheme(){if(L.isWindows){if(b.nativeTheme.shouldUseHighContrastColors)return{dark:b.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(L.isMacintosh){if(b.nativeTheme.shouldUseInvertedColorScheme||b.nativeTheme.shouldUseHighContrastColors)return{dark:b.nativeTheme.shouldUseDarkColors!==b.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(L.isLinux&&b.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:b.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const p=this.getColorScheme();if(p.highContrast&&this.configurationService.getValue("window.autoDetectHighContrast"))return p.dark?P:S;let d=this.stateMainService.getItem(u,null);if(!d)switch(this.stateMainService.getItem(w,"vs-dark").split(" ")[0]){case"vs":d=v;break;case"hc-black":d=P;break;case"hc-light":d=S;break;default:d=E}return L.isMacintosh&&d.toUpperCase()===E&&(d="#171717"),d}saveWindowSplash(p,d){this.stateMainService.setItems([{key:w,data:d.baseTheme},{key:u,data:d.colorInfo.background},{key:m,data:d}]),typeof p=="number"&&this.updateBackgroundColor(p,d)}updateBackgroundColor(p,d){for(const h of b.BrowserWindow.getAllWindows())if(h.id===p){h.setBackgroundColor(d.colorInfo.background);break}}getWindowSplash(){return this.stateMainService.getItem(m)}};g=de([ee(0,f.IStateMainService),ee(1,D.IConfigurationService)],g),e.ThemeMainService=g}),define(J[106],Z([0,1,3,4,5,6]),function(z,e,b,t,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,R.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,R.createDecorator)("sharedTunnelsService");var D;(function(m){m.Http="http",m.Https="https"})(D=e.TunnelProtocol||(e.TunnelProtocol={}));var y;(function(m){m.ConstantPrivate="constantPrivate",m.Private="private",m.Public="public"})(y=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var f;(function(m){m[m.Notify=1]="Notify",m[m.OpenBrowser=2]="OpenBrowser",m[m.OpenPreview=3]="OpenPreview",m[m.Silent=4]="Silent",m[m.Ignore=5]="Ignore",m[m.OpenBrowserOnce=6]="OpenBrowserOnce"})(f=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function v(m){if(m.scheme!=="http"&&m.scheme!=="https")return;const g=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(m.authority);if(!!g)return{address:g[1],port:+g[2]}}e.extractLocalHostUriMetaDataForPortMapping=v,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function E(m){return e.LOCALHOST_ADDRESSES.indexOf(m)>=0}e.isLocalhost=E,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function P(m){return e.ALL_INTERFACES_ADDRESSES.indexOf(m)>=0}e.isAllInterfaces=P;function S(m,g){return g?g!==1&&m<1024:!t.isWindows&&m<1024}e.isPortPrivileged=S;class w{constructor(g,I,p){this.remoteAddress=g,this.localAddress=I,this._dispose=p,this._onDispose=new b.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=w;let u=class{constructor(g){this.logService=g,this._onTunnelOpened=new b.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new b.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new b.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(g){return this._tunnelProvider=g,g?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(g){this._canElevate=g.elevation,this._privacyOptions=g.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const g=[],I=Array.from(this._tunnels.values());for(const p of I){const d=Array.from(p.values());for(const h of d){const l=await h.value;l&&g.push(l)}}return g}async dispose(){for(const g of this._tunnels.values()){for(const{value:I}of g.values())await I.then(p=>p?.dispose());g.clear()}this._tunnels.clear()}openTunnel(g,I,p,d,h=!1,l,n){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${I}:${p} on local port ${d}.`),!g)return;if(I||(I="localhost"),this._tunnelProvider&&this._factoryInProgress.has(p)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const r=this.retainOrCreateTunnel(g,I,p,d,h,l,n);return r?r.then(i=>{if(!i){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(I,p);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const s=this.makeTunnel(i);return(i.tunnelRemoteHost!==I||i.tunnelRemotePort!==p)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(s),s}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),r)}makeTunnel(g){return{tunnelRemotePort:g.tunnelRemotePort,tunnelRemoteHost:g.tunnelRemoteHost,tunnelLocalPort:g.tunnelLocalPort,localAddress:g.localAddress,privacy:g.privacy,protocol:g.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${g.tunnelRemoteHost}:${g.tunnelRemotePort} `);const I=this._tunnels.get(g.tunnelRemoteHost);if(I){const p=I.get(g.tunnelRemotePort);p&&(p.refcount--,await this.tryDisposeTunnel(g.tunnelRemoteHost,g.tunnelRemotePort,p))}}}}async tryDisposeTunnel(g,I,p){if(p.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${g}:${I}.`);const d=p.value.then(async h=>{h&&(await h.dispose(!0),this._onTunnelClosed.fire({host:h.tunnelRemoteHost,port:h.tunnelRemotePort}))});return this._tunnels.has(g)&&this._tunnels.get(g).delete(I),d}}async closeTunnel(g,I){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${g}:${I} `);const p=this._tunnels.get(g);if(p&&p.has(I)){const d=p.get(I);d.refcount=0,await this.tryDisposeTunnel(g,I,d)}}addTunnelToMap(g,I,p){this._tunnels.has(g)||this._tunnels.set(g,new Map),this._tunnels.get(g).set(I,{refcount:1,value:p})}async removeEmptyTunnelFromMap(g,I){const p=this._tunnels.get(g);p&&(await p.get(I)||p.delete(I),p.size===0&&this._tunnels.delete(g))}getTunnelFromMap(g,I){const p=[g];E(g)?(p.push(...e.LOCALHOST_ADDRESSES),p.push(...e.ALL_INTERFACES_ADDRESSES)):P(g)&&p.push(...e.ALL_INTERFACES_ADDRESSES);const d=p.map(h=>this._tunnels.get(h));for(const h of d){const l=h?.get(I);if(l)return l}}canTunnel(g){return!!v(g)}createWithProvider(g,I,p,d,h,l,n){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${I}:${p} on local port ${d}.`);const r=p;this._factoryInProgress.add(r);const s={elevationRequired:h?S(d===void 0?p:d):!1},o={remoteAddress:{host:I,port:p},localAddressPort:d,privacy:l,public:l?l!==y.Private:void 0,protocol:n},a=g.forwardPort(o,s);return a?(this.addTunnelToMap(I,p,a),a.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(r)})):this._factoryInProgress.delete(r),a}};u=de([ee(0,L.ILogService)],u),e.AbstractTunnelService=u}),define(J[46],Z([0,1,5]),function(z,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.UpdateType=e.StateType=void 0;var t;(function(L){L.Uninitialized="uninitialized",L.Idle="idle",L.CheckingForUpdates="checking for updates",L.AvailableForDownload="available for download",L.Downloading="downloading",L.Downloaded="downloaded",L.Updating="updating",L.Ready="ready"})(t=e.StateType||(e.StateType={}));var R;(function(L){L[L.Setup=0]="Setup",L[L.Archive=1]="Archive",L[L.Snap=2]="Snap"})(R=e.UpdateType||(e.UpdateType={})),e.State={Uninitialized:{type:"uninitialized"},Idle:(L,D)=>({type:"idle",updateType:L,error:D}),CheckingForUpdates:L=>({type:"checking for updates",explicit:L}),AvailableForDownload:L=>({type:"available for download",update:L}),Downloading:L=>({type:"downloading",update:L}),Downloaded:L=>({type:"downloaded",update:L}),Updating:L=>({type:"updating",update:L}),Ready:L=>({type:"ready",update:L})},e.IUpdateService=(0,b.createDecorator)("updateService")}),define(J[220],Z([0,1,4,161,59,44]),function(z,e,b,t,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),L.Registry.as(R.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,t.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,t.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,t.localize)(2,null),(0,t.localize)(3,null),(0,t.localize)(4,null),(0,t.localize)(5,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:1,description:(0,t.localize)(6,null),deprecationMessage:(0,t.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,t.localize)(8,null),description:(0,t.localize)(9,null),included:b.isWindows&&!b.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,t.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(J[221],Z([0,1,3,46]),function(z,e,b,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class R{constructor(y){this.service=y}listen(y,f){switch(f){case"onStateChange":return this.service.onStateChange}throw new Error(`Event not found: ${f}`)}call(y,f,v){switch(f){case"checkForUpdates":return this.service.checkForUpdates(v);case"downloadUpdate":return this.service.downloadUpdate();case"applyUpdate":return this.service.applyUpdate();case"quitAndInstall":return this.service.quitAndInstall();case"_getInitialState":return Promise.resolve(this.service.state);case"isLatestVersion":return this.service.isLatestVersion()}throw new Error(`Call not found: ${f}`)}}e.UpdateChannel=R;class L{constructor(y){this.channel=y,this._onStateChange=new b.Emitter,this.onStateChange=this._onStateChange.event,this._state=t.State.Uninitialized,this.channel.listen("onStateChange")(f=>this.state=f),this.channel.call("_getInitialState").then(f=>this.state=f)}get state(){return this._state}set state(y){this._state=y,this._onStateChange.fire(y)}checkForUpdates(y){return this.channel.call("checkForUpdates",y)}downloadUpdate(){return this.channel.call("downloadUpdate")}applyUpdate(){return this.channel.call("applyUpdate")}quitAndInstall(){return this.channel.call("quitAndInstall")}isLatestVersion(){return this.channel.call("isLatestVersion")}}e.UpdateChannelClient=L}),define(J[73],Z([0,1,5]),function(z,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,b.createDecorator)("IUriIdentityService")}),define(J[222],Z([0,1,73,178,15,16,121,3,2]),function(z,e,b,t,R,L,D,y,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class v{constructor(S){this.uri=S,this.time=v._clock++}touch(){return this.time=v._clock++,this}}v._clock=0;let E=class{constructor(S){this._fileService=S,this._dispooables=new f.DisposableStore,this._limit=2**16;const w=new Map,u=m=>{let g=w.get(m.scheme);return g===void 0&&(g=S.hasProvider(m)&&!this._fileService.hasCapability(m,1024),w.set(m.scheme,g)),g};this._dispooables.add(y.Event.any(S.onDidChangeFileSystemProviderRegistrations,S.onDidChangeFileSystemProviderCapabilities)(m=>{w.delete(m.scheme)})),this.extUri=new L.ExtUri(u),this._canonicalUris=new D.SkipList((m,g)=>this.extUri.compare(m,g,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(S){this._fileService.hasProvider(S)&&(S=(0,L.normalizePath)(S));const w=this._canonicalUris.get(S);return w?w.touch().uri.with({fragment:S.fragment}):(this._canonicalUris.set(S,new v(S)),this._checkTrim(),S)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const S=[...this._canonicalUris.entries()].sort((u,m)=>u[1].touch<m[1].touch?1:u[1].touch>m[1].touch?-1:0);v._clock=0,this._canonicalUris.clear();const w=this._limit*.5;for(let u=0;u<w;u++)this._canonicalUris.set(S[u][0],S[u][1].touch())}};E=de([ee(0,R.IFileService)],E),e.UriIdentityService=E,(0,t.registerSingleton)(b.IUriIdentityService,E,!0)}),define(J[107],Z([0,1,5]),function(z,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,b.createDecorator)("urlService")}),define(J[223],Z([0,1,7]),function(z,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class t{constructor(y){this.handler=y}listen(y,f){throw new Error(`Event not found: ${f}`)}call(y,f,v){switch(f){case"handleURL":return this.handler.handleURL(b.URI.revive(v[0]),v[1])}throw new Error(`Call not found: ${f}`)}}e.URLHandlerChannel=t;class R{constructor(y){this.channel=y}handleURL(y,f){return this.channel.call("handleURL",[y.toJSON(),f])}}e.URLHandlerChannelClient=R;class L{constructor(y){this.next=y}async routeCall(y,f,v,E){if(f!=="handleURL")throw new Error(`Call not found: ${f}`);if(v){const P=b.URI.revive(v);if(P&&P.query){const S=/\bwindowId=(\d+)/.exec(P.query);if(S){const w=S[1],u=new RegExp(`window:${w}`),m=y.connections.find(g=>u.test(g.ctx));if(m)return m}}}return this.next.routeCall(y,f,v,E)}routeEvent(y,f){throw new Error(`Event not found: ${f}`)}}e.URLHandlerRouter=L}),define(J[224],Z([0,1,8,2,7,20]),function(z,e,b,t,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class D extends t.Disposable{constructor(){super(...arguments);this.handlers=new Set}open(v,E){const P=[...this.handlers.values()];return(0,b.first)(P.map(S=>()=>S.handleURL(v,E)),void 0,!1).then(S=>S||!1)}registerHandler(v){return this.handlers.add(v),(0,t.toDisposable)(()=>this.handlers.delete(v))}}e.AbstractURLService=D;let y=class extends D{constructor(v){super();this.productService=v}create(v){let{authority:E,path:P,query:S,fragment:w}=v||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return E&&P&&P.indexOf("/")!==0&&(P=`/${P}`),R.URI.from({scheme:this.productService.urlProtocol,authority:E,path:P,query:S,fragment:w})}};y=de([ee(0,L.IProductService)],y),e.NativeURLService=y}),define(J[225],Z([0,1,14,8,3,2,4,7]),function(z,e,b,t,R,L,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;function f(E){try{return y.URI.parse(E)}catch{return null}}class v{constructor(P,S,w,u,m){if(this.urlService=S,this.uris=[],this.retryCount=0,this.flushDisposable=L.Disposable.None,this.disposables=new L.DisposableStore,this.uris=P,D.isWindows){const p=u.isBuilt?[]:[`"${u.appRoot}"`];p.push("--open-url","--"),b.app.setAsDefaultProtocolClient(m.urlProtocol,process.execPath,p)}const g=R.Event.map(R.Event.fromNodeEventEmitter(b.app,"open-url",(p,d)=>({event:p,url:d})),({event:p,url:d})=>(p.preventDefault(),d));this.disposables.add(g(p=>{const d=f(p);!d||this.urlService.open(d,{originalUrl:p})})),w.getWindows().filter(p=>p.isReady).length>0?this.flush():R.Event.once(w.onDidSignalReadyWindow)(this.flush,this,this.disposables)}async flush(){if(this.retryCount++>10)return;const P=[];for(const S of this.uris)await this.urlService.open(S.uri,{originalUrl:S.url})||P.push(S);P.length!==0&&(this.uris=P,this.flushDisposable=(0,t.disposableTimeout)(()=>this.flush(),500))}dispose(){this.disposables.dispose(),this.flushDisposable.dispose()}}e.ElectronURLListener=v}),define(J[40],Z([0,1,65,3,2,16,12,7,162,39,15,5,6]),function(z,e,b,t,R,L,D,y,f,v,E,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=e.toUserDataProfile=e.EXTENSIONS_RESOURCE_NAME=e.reviveProfile=e.IUserDataProfilesService=e.PROFILES_ENABLEMENT_CONFIG=e.isUserDataProfile=void 0;function w(I){const p=I;return!!(p&&typeof p=="object"&&typeof p.id=="string"&&typeof p.isDefault=="boolean"&&typeof p.name=="string"&&y.URI.isUri(p.location)&&y.URI.isUri(p.globalStorageHome)&&y.URI.isUri(p.settingsResource)&&y.URI.isUri(p.keybindingsResource)&&y.URI.isUri(p.tasksResource)&&y.URI.isUri(p.snippetsHome)&&((0,D.isUndefined)(p.extensionsResource)||y.URI.isUri(p.extensionsResource)))}e.isUserDataProfile=w,e.PROFILES_ENABLEMENT_CONFIG="workbench.experimental.settingsProfiles.enabled",e.IUserDataProfilesService=(0,P.createDecorator)("IUserDataProfilesService");function u(I,p){return{id:I.id,isDefault:I.isDefault,name:I.name,location:y.URI.revive(I.location).with({scheme:p}),globalStorageHome:y.URI.revive(I.globalStorageHome).with({scheme:p}),settingsResource:y.URI.revive(I.settingsResource).with({scheme:p}),keybindingsResource:y.URI.revive(I.keybindingsResource).with({scheme:p}),tasksResource:y.URI.revive(I.tasksResource).with({scheme:p}),snippetsHome:y.URI.revive(I.snippetsHome).with({scheme:p}),extensionsResource:y.URI.revive(I.extensionsResource)?.with({scheme:p})}}e.reviveProfile=u,e.EXTENSIONS_RESOURCE_NAME="extensions.json";function m(I,p,d){return{id:(0,b.hash)(p.toString()).toString(16),name:I,location:p,isDefault:!1,globalStorageHome:(0,L.joinPath)(p,"globalStorage"),settingsResource:(0,L.joinPath)(p,"settings.json"),keybindingsResource:(0,L.joinPath)(p,"keybindings.json"),tasksResource:(0,L.joinPath)(p,"tasks.json"),snippetsHome:(0,L.joinPath)(p,"snippets"),extensionsResource:(0,L.joinPath)(p,e.EXTENSIONS_RESOURCE_NAME),useDefaultFlags:d}}e.toUserDataProfile=m;let g=class extends R.Disposable{constructor(p,d,h){super();this.environmentService=p,this.fileService=d,this.logService=h,this._defaultProfile=this.createDefaultUserDataProfile(!1),this._onDidChangeProfiles=this._register(new t.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this.profilesHome=(0,L.joinPath)(this.environmentService.userRoamingDataHome,"profiles")}get defaultProfile(){return this.profiles[0]??this._defaultProfile}get profiles(){return[]}newProfile(p,d){return m(p,(0,L.joinPath)(this.profilesHome,(0,b.hash)(p).toString(16)),d)}createDefaultUserDataProfile(p){const d=m((0,f.localize)(0,null),this.environmentService.userRoamingDataHome);return{...d,isDefault:!0,extensionsResource:p?d.extensionsResource:void 0}}createProfile(p,d){throw new Error("Not implemented")}setProfileForWorkspace(p,d){throw new Error("Not implemented")}getProfile(p){throw new Error("Not implemented")}removeProfile(p){throw new Error("Not implemented")}};g=de([ee(0,v.IEnvironmentService),ee(1,E.IFileService),ee(2,S.ILogService)],g),e.UserDataProfilesService=g}),define(J[226],Z([0,1,14,38,2,33,11,9,4,7,30,39,6,40]),function(z,e,b,t,R,L,D,y,f,v,E,P,S,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let u=class extends R.Disposable{constructor(g,I,p){super();this.logService=p,this.validRoots=L.TernarySearchTree.forPaths(!f.isLinux),this.validExtensions=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp"]),this.addValidFileRoot(g.appRoot),this.addValidFileRoot(g.extensionsPath),this.addValidFileRoot(I.defaultProfile.globalStorageHome.fsPath),this.addValidFileRoot(g.workspaceStorageHome.fsPath),this.handleProtocols()}handleProtocols(){const{defaultSession:g}=b.session;g.protocol.registerFileProtocol(D.Schemas.vscodeFileResource,(I,p)=>this.handleResourceRequest(I,p)),g.protocol.interceptFileProtocol(D.Schemas.file,(I,p)=>this.handleFileRequest(I,p)),this._register((0,R.toDisposable)(()=>{g.protocol.unregisterProtocol(D.Schemas.vscodeFileResource),g.protocol.uninterceptProtocol(D.Schemas.file)}))}addValidFileRoot(g){const I=(0,y.normalize)(g);return this.validRoots.get(I)?R.Disposable.None:(this.validRoots.set(I,!0),(0,R.toDisposable)(()=>this.validRoots.delete(I)))}handleFileRequest(g,I){const p=v.URI.parse(g.url);return this.logService.error(`Refused to load resource ${p.fsPath} from ${D.Schemas.file}: protocol (original URL: ${g.url})`),I({error:-3})}handleResourceRequest(g,I){const p=this.requestToNormalizedFilePath(g);return this.validRoots.findSubstr(p)?I({path:p}):this.validExtensions.has((0,y.extname)(p))?I({path:p}):(this.logService.error(`${D.Schemas.vscodeFileResource}: Refused to load resource ${p} from ${D.Schemas.vscodeFileResource}: protocol (original URL: ${g.url})`),I({error:-3}))}requestToNormalizedFilePath(g){const I=v.URI.parse(g.url),p=D.FileAccess.asFileUri(I);return(0,y.normalize)(p.fsPath)}createIPCObjectUrl(){let g;const I=v.URI.from({scheme:"vscode",path:(0,E.generateUuid)()}),p=I.toString(),d=async()=>g;return t.validatedIpcMain.handle(p,d),this.logService.trace(`IPC Object URL: Registered new channel ${p}.`),{resource:I,update:h=>g=h,dispose:()=>{this.logService.trace(`IPC Object URL: Removed channel ${p}.`),t.validatedIpcMain.removeHandler(p)}}}};u=de([ee(0,P.INativeEnvironmentService),ee(1,w.IUserDataProfilesService),ee(2,S.ILogService)],u),e.ProtocolMainService=u}),define(J[108],Z([0,1,8,3,2,70,12,97,5,40]),function(z,e,b,t,R,L,D,y,f,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const E="__$__targetStorageMarker";e.IStorageService=(0,f.createDecorator)("storageService");var P;(function(p){p[p.NONE=0]="NONE",p[p.SHUTDOWN=1]="SHUTDOWN"})(P=e.WillSaveStateReason||(e.WillSaveStateReason={}));var S;(function(p){p[p.APPLICATION=-1]="APPLICATION",p[p.PROFILE=0]="PROFILE",p[p.WORKSPACE=1]="WORKSPACE"})(S=e.StorageScope||(e.StorageScope={}));var w;(function(p){p[p.USER=0]="USER",p[p.MACHINE=1]="MACHINE"})(w=e.StorageTarget||(e.StorageTarget={}));class u extends R.Disposable{constructor(d={flushInterval:u.DEFAULT_FLUSH_INTERVAL}){super();this.options=d,this._onDidChangeValue=this._register(new t.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new t.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new t.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new b.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new R.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,b.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,R.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,L.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,L.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(d,h){if(h===E){switch(d){case-1:this._applicationKeyTargets=void 0;break;case 0:this._profileKeyTargets=void 0;break;case 1:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:d})}else this._onDidChangeValue.fire({scope:d,key:h,target:this.getKeyTargets(d)[h]})}emitWillSaveState(d){this._onWillSaveState.fire({reason:d})}get(d,h,l){return this.getStorage(h)?.get(d,l)}getBoolean(d,h,l){return this.getStorage(h)?.getBoolean(d,l)}getNumber(d,h,l){return this.getStorage(h)?.getNumber(d,l)}store(d,h,l,n){if((0,D.isUndefinedOrNull)(h)){this.remove(d,l);return}this.withPausedEmitters(()=>{this.updateKeyTarget(d,l,n),this.getStorage(l)?.set(d,h)})}remove(d,h){this.withPausedEmitters(()=>{this.updateKeyTarget(d,h,void 0),this.getStorage(h)?.delete(d)})}withPausedEmitters(d){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{d()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(d,h){const l=[],n=this.getKeyTargets(d);for(const r of Object.keys(n))n[r]===h&&l.push(r);return l}updateKeyTarget(d,h,l){const n=this.getKeyTargets(h);typeof l=="number"?n[d]!==l&&(n[d]=l,this.getStorage(h)?.set(E,JSON.stringify(n))):typeof n[d]=="number"&&(delete n[d],this.getStorage(h)?.set(E,JSON.stringify(n)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(0)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(-1)),this._applicationKeyTargets}getKeyTargets(d){switch(d){case-1:return this.applicationKeyTargets;case 0:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(d){const h=this.get(E,d);if(h)try{return JSON.parse(h)}catch{}return Object.create(null)}isNew(d){return this.getBoolean(e.IS_NEW_KEY,d)===!0}async flush(d=P.NONE){this._onWillSaveState.fire({reason:d});const h=this.getStorage(-1),l=this.getStorage(0),n=this.getStorage(1);switch(d){case P.NONE:await b.Promises.settled([h?.whenFlushed()??Promise.resolve(),l?.whenFlushed()??Promise.resolve(),n?.whenFlushed()??Promise.resolve()]);break;case P.SHUTDOWN:await b.Promises.settled([h?.flush(0)??Promise.resolve(),l?.flush(0)??Promise.resolve(),n?.flush(0)??Promise.resolve()]);break}}async log(){const d=this.getStorage(-1)?.items??new Map,h=this.getStorage(0)?.items??new Map,l=this.getStorage(1)?.items??new Map;return I(d,h,l,this.getLogDetails(-1)??"",this.getLogDetails(0)??"",this.getLogDetails(1)??"")}async switch(d,h){return this.emitWillSaveState(P.NONE),(0,v.isUserDataProfile)(d)?this.switchToProfile(d,h):this.switchToWorkspace(d,h)}canSwitchProfile(d,h){return!(d.id===h.id||m(h)&&m(d))}switchData(d,h,l,n){this.withPausedEmitters(()=>{if(n)for(const[r,i]of d)h.set(r,i);else{const r=new Set;for(const[i,s]of d)r.add(i),h.get(i)!==s&&this.emitDidChangeValue(l,i);for(const[i]of h.items)r.has(i)||this.emitDidChangeValue(l,i)}})}}e.AbstractStorageService=u,u.DEFAULT_FLUSH_INTERVAL=60*1e3;function m(p){return p.isDefault||!!p.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=m;class g extends u{constructor(){super();this.applicationStorage=this._register(new y.Storage(new y.InMemoryStorageDatabase)),this.profileStorage=this._register(new y.Storage(new y.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new y.Storage(new y.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(d=>this.emitDidChangeValue(1,d))),this._register(this.profileStorage.onDidChangeStorage(d=>this.emitDidChangeValue(0,d))),this._register(this.applicationStorage.onDidChangeStorage(d=>this.emitDidChangeValue(-1,d)))}getStorage(d){switch(d){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(d){switch(d){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}}e.InMemoryStorageService=g;async function I(p,d,h,l,n,r){const i=F=>{try{return JSON.parse(F)}catch{return F}},s=new Map,o=new Map;p.forEach((F,q)=>{s.set(q,F),o.set(q,i(F))});const a=new Map,c=new Map;d.forEach((F,q)=>{a.set(q,F),c.set(q,i(F))});const C=new Map,k=new Map;h.forEach((F,q)=>{C.set(q,F),k.set(q,i(F))}),console.group(l!==n?`Storage: Application (path: ${l})`:`Storage: Application & Profile (path: ${l}, default profile)`);const M=[];if(s.forEach((F,q)=>{M.push({key:q,value:F})}),console.table(M),console.groupEnd(),console.log(o),l!==n){console.group(`Storage: Profile (path: ${n}, profile specific)`);const F=[];a.forEach((q,te)=>{F.push({key:te,value:q})}),console.table(F),console.groupEnd(),console.log(c)}console.group(`Storage: Workspace (path: ${r})`);const T=[];C.forEach((F,q)=>{T.push({key:q,value:F})}),console.table(T),console.groupEnd(),console.log(k)}e.logStorage=I}),define(J[227],Z([0,1,5]),function(z,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,b.createDecorator)("webviewManagerService")}),define(J[228],Z([0,1,14,2,11,7]),function(z,e,b,t,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class D extends t.Disposable{constructor(){super();const f=this.handleWebviewRequest.bind(this);b.protocol.registerFileProtocol(R.Schemas.vscodeWebview,f)}handleWebviewRequest(f,v){try{const E=L.URI.parse(f.url),P=D.validWebviewFilePaths.get(E.path);if(typeof P=="string"){const S=`vs/workbench/contrib/webview/browser/pre/${P}`,w=R.FileAccess.asFileUri(S,z);return v(decodeURIComponent(w.fsPath))}else return v({error:-10})}catch{}return v({error:-2})}}e.WebviewProtocolProvider=D,D.validWebviewFilePaths=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]])}),define(J[74],Z([0,1,4]),function(z,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.useWindowControlsOverlay=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function t(E){return!!E.workspaceUri}e.isWorkspaceToOpen=t;function R(E){return!!E.folderUri}e.isFolderToOpen=R;function L(E){return!!E.fileUri}e.isFileToOpen=L;function D(E){const P=y(E),S=E.getValue("window.menuBarVisibility");return S==="default"||P==="native"&&S==="compact"||b.isMacintosh&&b.isNative?"classic":S}e.getMenuBarVisibility=D;function y(E){if(b.isWeb)return"custom";const P=E.getValue("window");if(P){if(b.isMacintosh&&P.nativeTabs===!0||b.isMacintosh&&P.nativeFullScreen===!1)return"native";const u=E.getValue("workbench.colorCustomizations");if(u?.["window.activeBorder"]||u?.["window.inactiveBorder"])return"custom";const m=P.titleBarStyle;if(m==="native"||m==="custom")return m}return b.isLinux?"native":"custom"}e.getTitleBarStyle=y;function f(E,P){return!b.isWindows||b.isWeb||!P.isBuilt||y(E)==="native"?!1:E.getValue("window.experimental.windowControlsOverlay.enabled")}e.useWindowControlsOverlay=f;function v(E=0){return Math.pow(1.2,E)}e.zoomLevelToZoomFactor=v}),define(J[109],Z([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.defaultWindowState=e.UnloadReason=e.LoadReason=void 0;var b;(function(y){y[y.INITIAL=1]="INITIAL",y[y.LOAD=2]="LOAD",y[y.RELOAD=3]="RELOAD"})(b=e.LoadReason||(e.LoadReason={}));var t;(function(y){y[y.CLOSE=1]="CLOSE",y[y.QUIT=2]="QUIT",y[y.RELOAD=3]="RELOAD",y[y.LOAD=4]="LOAD"})(t=e.UnloadReason||(e.UnloadReason={}));const R=function(y=1){return{width:1024,height:768,mode:y}};e.defaultWindowState=R;var L;(function(y){y[y.Maximized=0]="Maximized",y[y.Normal=1]="Normal",y[y.Minimized=2]="Minimized",y[y.Fullscreen=3]="Fullscreen"})(L=e.WindowMode||(e.WindowMode={}));var D;(function(y){y[y.UNRESPONSIVE=1]="UNRESPONSIVE",y[y.CRASHED=2]="CRASHED",y[y.LOAD=3]="LOAD"})(D=e.WindowError||(e.WindowError={}))}),define(J[32],Z([0,1,5]),function(z,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenContext=e.IWindowsMainService=void 0,e.IWindowsMainService=(0,b.createDecorator)("windowsMainService");var t;(function(R){R[R.CLI=0]="CLI",R[R.DOCK=1]="DOCK",R[R.MENU=2]="MENU",R[R.DIALOG=3]="DIALOG",R[R.DESKTOP=4]="DESKTOP",R[R.API=5]="API"})(t=e.OpenContext||(e.OpenContext={}))}),define(J[229],Z([0,1,14,22,3,65,2,30,68,99,6,20,32]),function(z,e,b,t,R,L,D,y,f,v,E,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var w;(function(m){m[m.Initial=1]="Initial",m[m.StoredCredentialsUsed=2]="StoredCredentialsUsed",m[m.LoginDialogShown=3]="LoginDialogShown"})(w||(w={}));let u=class extends D.Disposable{constructor(g,I,p,d,h){super();this.logService=g,this.windowsMainService=I,this.credentialsService=p,this.encryptionMainService=d,this.productService=h,this.PROXY_CREDENTIALS_SERVICE_KEY=`${this.productService.urlProtocol}.proxy-credentials`,this.pendingProxyResolve=void 0,this.state=w.Initial,this.sessionCredentials=void 0,this.registerListeners()}registerListeners(){const g=R.Event.fromNodeEventEmitter(b.app,"login",(I,p,d,h,l)=>({event:I,webContents:p,req:d,authInfo:h,callback:l}));this._register(g(this.onLogin,this))}async onLogin({event:g,authInfo:I,req:p,callback:d}){if(!I.isProxy)return;if(!this.pendingProxyResolve&&this.state===w.LoginDialogShown&&p.firstAuthAttempt){this.logService.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}g.preventDefault();let h;if(this.pendingProxyResolve)this.logService.trace("auth#onLogin (proxy) - pending proxy handling found"),h=await this.pendingProxyResolve;else{this.logService.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.pendingProxyResolve=this.resolveProxyCredentials(I);try{h=await this.pendingProxyResolve}finally{this.pendingProxyResolve=void 0}}d(h?.username,h?.password)}async resolveProxyCredentials(g){this.logService.trace("auth#resolveProxyCredentials (proxy) - enter");try{const I=await this.doResolveProxyCredentials(g);if(I)return this.logService.trace("auth#resolveProxyCredentials (proxy) - got credentials"),I;this.logService.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.logService.trace("auth#resolveProxyCredentials (proxy) - exit")}}async doResolveProxyCredentials(g){this.logService.trace("auth#doResolveProxyCredentials - enter",g);const I=String((0,L.hash)({scheme:g.scheme,host:g.host,port:g.port}));let p,d;try{const r=await this.credentialsService.getPassword(this.PROXY_CREDENTIALS_SERVICE_KEY,I);if(r){const i=JSON.parse(await this.encryptionMainService.decrypt(r));p=i.username,d=i.password}}catch(r){this.logService.error(r)}if(this.state!==w.StoredCredentialsUsed&&typeof p=="string"&&typeof d=="string")return this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.state=w.StoredCredentialsUsed,{username:p,password:d};const h=this.windowsMainService.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(!h){this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.logService.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${h.id} to handle proxy login`);const l={authInfo:g,username:this.sessionCredentials?.username??p,password:this.sessionCredentials?.password??d,replyChannel:`vscode:proxyAuthResponse:${(0,y.generateUuid)()}`};h.sendWhenReady("vscode:openProxyAuthenticationDialog",t.CancellationToken.None,l),this.state=w.LoginDialogShown;const n=await new Promise(r=>{const i=async(s,o,a)=>{if(o===l.replyChannel)if(this.logService.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${h.id}`),h.win?.webContents.off("ipc-message",i),a){const c={username:a.username,password:a.password};try{if(a.remember){const C=await this.encryptionMainService.encrypt(JSON.stringify(c));await this.credentialsService.setPassword(this.PROXY_CREDENTIALS_SERVICE_KEY,I,C)}else await this.credentialsService.deletePassword(this.PROXY_CREDENTIALS_SERVICE_KEY,I)}catch(C){this.logService.error(C)}r({username:c.username,password:c.password})}else r(void 0)};h.win?.webContents.on("ipc-message",i)});return this.sessionCredentials=n,n}};u=de([ee(0,E.ILogService),ee(1,S.IWindowsMainService),ee(2,f.ICredentialsMainService),ee(3,v.IEncryptionMainService),ee(4,P.IProductService)],u),e.ProxyAuthHandler=u}),define(J[230],Z([0,1,68,6,39,20,32,189]),function(z,e,b,t,R,L,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CredentialsNativeMainService=void 0;let f=class extends y.BaseCredentialsMainService{constructor(E,P,S,w){super(E);this.environmentMainService=P,this.productService=S,this.windowsMainService=w,this.surfaceKeytarLoadError=u=>{this.windowsMainService.sendToFocused("vscode:showCredentialsError",u.message??u)}}async getSecretStoragePrefix(){return Promise.resolve(this.productService.urlProtocol)}async withKeytar(){if(this._keytarCache)return this._keytarCache;if(this.environmentMainService.disableKeytar)return this.logService.info("Keytar is disabled. Using in-memory credential store instead."),this._keytarCache=new b.InMemoryCredentialsProvider,this._keytarCache;const E=await new Promise((P,S)=>{z(["keytar"],P,S)});return await E.findCredentials("test-keytar-loads"),this._keytarCache=E,this._keytarCache}};f=de([ee(0,t.ILogService),ee(1,R.INativeEnvironmentService),ee(2,L.IProductService),ee(3,D.IWindowsMainService)],f),e.CredentialsNativeMainService=f}),define(J[231],Z([0,1,18,2,3,6,21,78,42,124,8,11,50,4,36,14,32]),function(z,e,b,t,R,L,D,y,f,v,E,P,S,w,u,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostStarter=void 0;const I=m.UtilityProcess,p=typeof I!="undefined";let d=class Rt{constructor(r,i,s){this._logService=r,this._windowsMainService=s,this._shutdown=!1,this._extHosts=new Map,i.onWillShutdown(o=>{this._shutdown=!0,o.join(this._waitForAllExit(6e3))})}dispose(){}_getExtHost(r){const i=this._extHosts.get(r);if(!i)throw new Error("Unknown extension host!");return i}onDynamicStdout(r){return this._getExtHost(r).onStdout}onDynamicStderr(r){return this._getExtHost(r).onStderr}onDynamicMessage(r){return this._getExtHost(r).onMessage}onDynamicError(r){return this._getExtHost(r).onError}onDynamicExit(r){return this._getExtHost(r).onExit}async canUseUtilityProcess(){return p}async createExtensionHost(r){if(this._shutdown)throw(0,b.canceled)();const i=String(++Rt._lastId);let s;if(r){if(!p)throw new Error("Cannot use UtilityProcess!");s=new l(i,this._logService,this._windowsMainService)}else s=new h(i,this._logService);return this._extHosts.set(i,s),s.onExit(({pid:o,code:a,signal:c})=>{this._logService.info(`Extension host with pid ${o} exited with code: ${a}, signal: ${c}.`),setTimeout(()=>{s.dispose(),this._extHosts.delete(i)})}),{id:i}}async start(r,i){if(this._shutdown)throw(0,b.canceled)();return this._getExtHost(r).start(i)}async enableInspectPort(r){if(this._shutdown)throw(0,b.canceled)();const i=this._extHosts.get(r);return i?i.enableInspectPort():!1}async kill(r){if(this._shutdown)throw(0,b.canceled)();const i=this._extHosts.get(r);!i||i.kill()}async _killAllNow(){for(const[,r]of this._extHosts)r.kill()}async _waitForAllExit(r){const i=[];for(const[,s]of this._extHosts)i.push(s.waitForExit(r));return E.Promises.settled(i).then(()=>{})}};d._lastId=0,d=de([ee(0,L.ILogService),ee(1,D.ILifecycleMainService),ee(2,g.IWindowsMainService)],d),e.ExtensionHostStarter=d;let h=class extends t.Disposable{constructor(r,i){super();this.id=r,this._logService=i,this._onStdout=this._register(new R.Emitter),this.onStdout=this._onStdout.event,this._onStderr=this._register(new R.Emitter),this.onStderr=this._onStderr.event,this._onMessage=this._register(new R.Emitter),this.onMessage=this._onMessage.event,this._onError=this._register(new R.Emitter),this.onError=this._onError.event,this._onExit=this._register(new R.Emitter),this.onExit=this._onExit.event,this._process=null,this._hasExited=!1}start(r){w.isCI&&this._logService.info("Calling fork to start extension host...");const i=y.StopWatch.create(!1);this._process=(0,f.fork)(P.FileAccess.asFileUri("bootstrap-fork",z).fsPath,["--type=extensionHost","--skipWorkspaceStorageLock"],(0,S.mixin)({cwd:(0,u.cwd)()},r));const s=i.elapsed(),o=this._process.pid;this._logService.info(`Starting extension host with pid ${o} (fork() took ${s} ms).`);const a=new v.StringDecoder("utf-8");this._process.stdout?.on("data",C=>{const k=typeof C=="string"?C:a.write(C);this._onStdout.fire(k)});const c=new v.StringDecoder("utf-8");this._process.stderr?.on("data",C=>{const k=typeof C=="string"?C:c.write(C);this._onStderr.fire(k)}),this._process.on("message",C=>{this._onMessage.fire(C)}),this._process.on("error",C=>{this._onError.fire({error:(0,b.transformErrorForSerialization)(C)})}),this._process.on("exit",(C,k)=>{this._hasExited=!0,this._onExit.fire({pid:o,code:C,signal:k})})}enableInspectPort(){return this._process?(this._logService.info(`Enabling inspect port on extension host with pid ${this._process.pid}.`),typeof process._debugProcess=="function"?(process._debugProcess(this._process.pid),!0):w.isWindows?!1:(this._process.kill("SIGUSR1"),!0)):!1}kill(){!this._process||(this._logService.info(`Killing extension host with pid ${this._process.pid}.`),this._process.kill())}async waitForExit(r){if(!this._process)return;const i=this._process.pid;this._logService.info(`Waiting for extension host with pid ${i} to exit.`),await Promise.race([R.Event.toPromise(this.onExit),(0,E.timeout)(r)]),this._hasExited||(this._logService.info(`Extension host with pid ${i} did not exit within ${r}ms.`),this._process.kill())}};h=de([ee(1,L.ILogService)],h);let l=class extends t.Disposable{constructor(r,i,s){super();this.id=r,this._logService=i,this._windowsMainService=s,this.onStdout=R.Event.None,this.onStderr=R.Event.None,this.onError=R.Event.None,this._onMessage=this._register(new R.Emitter),this.onMessage=this._onMessage.event,this._onExit=this._register(new R.Emitter),this.onExit=this._onExit.event,this._process=null,this._hasExited=!1}start(r){const i=this._windowsMainService.getWindowById(r.responseWindowId);if(!i){this._logService.info(`UtilityProcess<${this.id}>: Refusing to create new Extension Host UtilityProcess because requesting window cannot be found...`);return}const s=i.win;if(!s||s.isDestroyed()||s.webContents.isDestroyed()){this._logService.info(`UtilityProcess<${this.id}>: Refusing to create new Extension Host UtilityProcess because requesting window cannot be found...`);return}const o=`extensionHost${this.id}`,a=P.FileAccess.asFileUri("bootstrap-fork.js",z).fsPath,c=["--type=extensionHost","--skipWorkspaceStorageLock"],C=r.execArgv||[];C.push("--vscode-utility-kind=extensionHost");const k={...r.env};for(const q of Object.keys(k))k[q]=String(k[q]);this._logService.info(`UtilityProcess<${this.id}>: Creating new...`),this._process=new I(a,c,{serviceName:o,env:k,execArgv:C}),this._register(R.Event.fromNodeEventEmitter(this._process,"spawn")(()=>{this._logService.info(`UtilityProcess<${this.id}>: received spawn event.`)})),this._register(R.Event.fromNodeEventEmitter(this._process,"exit")(q=>{q=q||0,this._logService.info(`UtilityProcess<${this.id}>: received exit event with code ${q}.`),this._hasExited=!0,this._onExit.fire({pid:this._process.pid,code:q,signal:""})}));const M=(q,te)=>{te.type==="Utility"&&te.name===o&&(this._logService.info(`UtilityProcess<${this.id}>: terminated unexpectedly with code ${te.exitCode}.`),this._hasExited=!0,this._onExit.fire({pid:this._process.pid,code:te.exitCode,signal:""}))};m.app.on("child-process-gone",M),this._register((0,t.toDisposable)(()=>{m.app.off("child-process-gone",M)}));const{port1:T,port2:F}=new m.MessageChannelMain;this._process.postMessage("port",null,[F]),s.webContents.postMessage(r.responseChannel,r.responseNonce,[T])}enableInspectPort(){return this._process?(this._logService.info(`UtilityProcess<${this.id}>: Enabling inspect port on extension host with pid ${this._process.pid}.`),typeof process._debugProcess=="function"?(process._debugProcess(this._process.pid),!0):w.isWindows?!1:(this._process.kill("SIGUSR1"),!0)):!1}kill(){!this._process||(this._logService.info(`UtilityProcess<${this.id}>: Killing extension host with pid ${this._process.pid}.`),this._process.kill())}async waitForExit(r){if(!this._process)return;const i=this._process.pid;this._logService.info(`UtilityProcess<${this.id}>: Waiting for extension host with pid ${i} to exit.`),await Promise.race([R.Event.toPromise(this.onExit),(0,E.timeout)(r)]),this._hasExited||(this._logService.info(`UtilityProcess<${this.id}>: Extension host with pid ${i} did not exit within ${r}ms, will kill it now.`),this._process.kill())}};l=de([ee(1,L.ILogService),ee(2,g.IWindowsMainService)],l)}),define(J[232],Z([0,1,14,3,2,228,32]),function(z,e,b,t,R,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let y=class extends R.Disposable{constructor(v){super();this.windowsMainService=v,this._onFoundInFrame=this._register(new t.Emitter),this.onFoundInFrame=this._onFoundInFrame.event,this._register(new L.WebviewProtocolProvider)}async setIgnoreMenuShortcuts(v,E){let P;if(typeof v.windowId=="number"){const{windowId:S}=v,w=this.windowsMainService.getWindowById(S);if(!w?.win)throw new Error(`Invalid windowId: ${S}`);P=w.win.webContents}else{const{webContentsId:S}=v;if(P=b.webContents.fromId(S),!P)throw new Error(`Invalid webContentsId: ${S}`)}P.isDestroyed()||P.setIgnoreMenuShortcuts(E)}async findInFrame(v,E,P,S){const u=this.getFrameByName(v,E);if(typeof u.findInFrame=="function"){u.findInFrame(P,{findNext:S.findNext,forward:S.forward});const m=(g,I)=>{I.finalUpdate&&(this._onFoundInFrame.fire(I),u.removeListener("found-in-frame",m))};u.on("found-in-frame",m)}}async stopFindInFrame(v,E,P){const w=this.getFrameByName(v,E);typeof w.stopFindInFrame=="function"&&w.stopFindInFrame(P.keepSelection?"keepSelection":"clearSelection")}getFrameByName(v,E){const P=this.windowsMainService.getWindowById(v.windowId);if(!P?.win)throw new Error(`Invalid windowId: ${v}`);const S=P.win.webContents.mainFrame.framesInSubtree.find(w=>w.name===E);if(!S)throw new Error(`Unknown frame: ${E}`);return S}};y=de([ee(0,D.IWindowsMainService)],y),e.WebviewMainService=y}),define(J[233],Z([0,1,8,3,2]),function(z,e,b,t,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class L extends R.Disposable{constructor({onDidOpenWindow:y,onDidFocusWindow:f,getActiveWindowId:v}){super();this.disposables=this._register(new R.DisposableStore),t.Event.latch(t.Event.any(y,f))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,b.createCancelablePromise)(()=>v()),(async()=>{try{const P=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:P}catch{}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(y){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=y}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=L}),define(J[24],Z([0,1,165,9,33,16,7,5,11]),function(z,e,b,t,R,L,D,y,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,y.createDecorator)("contextService");function v(i){const s=i;return typeof s?.id=="string"&&D.URI.isUri(s.uri)}e.isSingleFolderWorkspaceIdentifier=v;function E(i){if(i.configuration)return{id:i.id,configPath:i.configuration};if(i.folders.length===1)return{id:i.id,uri:i.folders[0].uri}}e.toWorkspaceIdentifier=E;function P(i){const s=i;return typeof s?.id=="string"&&D.URI.isUri(s.configPath)}e.isWorkspaceIdentifier=P;function S(i){const s=i;if(s?.uri)return{id:s.id,uri:D.URI.revive(s.uri)};const o=i;if(o?.configPath)return{id:o.id,configPath:D.URI.revive(o.configPath)};if(i?.id)return{id:i.id}}e.reviveIdentifier=S;var w;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(w=e.WorkbenchState||(e.WorkbenchState={}));function u(i){const s=i;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&Array.isArray(s.folders))}e.isWorkspace=u;function m(i){const s=i;return!!(s&&typeof s=="object"&&D.URI.isUri(s.uri)&&typeof s.name=="string"&&typeof s.toResource=="function")}e.isWorkspaceFolder=m;class g{constructor(s,o,a,c,C){this._id=s,this._transient=a,this._configuration=c,this._ignorePathCasing=C,this._foldersMap=R.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=o}update(s){this._id=s.id,this._configuration=s.configuration,this._transient=s.transient,this._ignorePathCasing=s._ignorePathCasing,this.folders=s.folders}get folders(){return this._folders}set folders(s){this._folders=s,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(s){this._configuration=s}getFolder(s){return s&&this._foldersMap.findSubstr(s)||null}updateFoldersMap(){this._foldersMap=R.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const s of this.folders)this._foldersMap.set(s.uri,s)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=g;class I{constructor(s,o){this.raw=o,this.uri=s.uri,this.index=s.index,this.name=s.name}toResource(s){return(0,L.joinPath)(this.uri,s)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=I;function p(i){return new I({uri:i,index:0,name:(0,L.basenameOrAuthority)(i)},{uri:i.toString()})}e.toWorkspaceFolder=p,e.WORKSPACE_EXTENSION="code-workspace";const d=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,b.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function h(i,s){return L.extUriBiasedIgnorePathCase.isEqualOrParent(i,s.untitledWorkspacesHome)}e.isUntitledWorkspace=h;function l(i){let s;return D.URI.isUri(i)?s=i:s=i.configuration,s?.scheme===f.Schemas.tmp}e.isTemporaryWorkspace=l;function n(i,s){return!h(i,s)&&!l(i)}e.isSavedWorkspace=n;function r(i){return(typeof i=="string"?(0,t.extname)(i):(0,L.extname)(i))===d}e.hasWorkspaceFileExtension=r}),define(J[52],Z([0,1,14,8,65,34,2,79,4,12,23,146,5,6,24]),function(z,e,b,t,R,L,D,y,f,v,E,P,S,w,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,S.createDecorator)("dialogMainService");let m=class{constructor(I){this.logService=I,this.windowFileDialogLocks=new Map,this.windowDialogQueues=new Map,this.noWindowDialogueQueue=new t.Queue}pickFileFolder(I,p){return this.doPick({...I,pickFolders:!0,pickFiles:!0,title:(0,P.localize)(0,null)},p)}pickFolder(I,p){return this.doPick({...I,pickFolders:!0,title:(0,P.localize)(1,null)},p)}pickFile(I,p){return this.doPick({...I,pickFiles:!0,title:(0,P.localize)(2,null)},p)}pickWorkspace(I,p){const d=(0,P.localize)(3,null),h=(0,L.mnemonicButtonLabel)((0,P.localize)(4,null)),l=u.WORKSPACE_FILTER;return this.doPick({...I,pickFiles:!0,title:d,filters:l,buttonLabel:h},p)}async doPick(I,p){const d={title:I.title,buttonLabel:I.buttonLabel,filters:I.filters,defaultPath:I.defaultPath};(typeof I.pickFiles=="boolean"||typeof I.pickFolders=="boolean")&&(d.properties=void 0,I.pickFiles&&I.pickFolders&&(d.properties=["multiSelections","openDirectory","openFile","createDirectory"])),d.properties||(d.properties=["multiSelections",I.pickFolders?"openDirectory":"openFile","createDirectory"]),f.isMacintosh&&d.properties.push("treatPackageAsDirectory");const h=await this.showOpenDialog(d,(0,v.withNullAsUndefined)(p||b.BrowserWindow.getFocusedWindow()));if(h&&h.filePaths&&h.filePaths.length>0)return h.filePaths}getWindowDialogQueue(I){if(I){let p=this.windowDialogQueues.get(I.id);return p||(p=new t.Queue,this.windowDialogQueues.set(I.id,p)),p}else return this.noWindowDialogueQueue}showMessageBox(I,p){return this.getWindowDialogQueue(p).queue(async()=>p?b.dialog.showMessageBox(p,I):b.dialog.showMessageBox(I))}async showSaveDialog(I,p){const d=this.acquireFileDialogLock(I,p);if(!d)return this.logService.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.getWindowDialogQueue(p).queue(async()=>{let h;return p?h=await b.dialog.showSaveDialog(p,I):h=await b.dialog.showSaveDialog(I),h.filePath=this.normalizePath(h.filePath),h})}finally{(0,D.dispose)(d)}}normalizePath(I){return I&&f.isMacintosh&&(I=(0,y.normalizeNFC)(I)),I}normalizePaths(I){return I.map(p=>this.normalizePath(p))}async showOpenDialog(I,p){I.defaultPath&&(await E.Promises.exists(I.defaultPath)||(I.defaultPath=void 0));const d=this.acquireFileDialogLock(I,p);if(!d)return this.logService.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.getWindowDialogQueue(p).queue(async()=>{let h;return p?h=await b.dialog.showOpenDialog(p,I):h=await b.dialog.showOpenDialog(I),h.filePaths=this.normalizePaths(h.filePaths),h})}finally{(0,D.dispose)(d)}}acquireFileDialogLock(I,p){if(!p)return D.Disposable.None;this.logService.trace("[DialogMainService]: request to acquire file dialog lock",I);let d=this.windowFileDialogLocks.get(p.id);d||(d=new Set,this.windowFileDialogLocks.set(p.id,d));const h=(0,R.hash)(I);if(!d.has(h))return this.logService.trace("[DialogMainService]: new file dialog lock created",I),d.add(h),(0,D.toDisposable)(()=>{this.logService.trace("[DialogMainService]: file dialog lock disposed",I),d?.delete(h),d?.size===0&&this.windowFileDialogLocks.delete(p.id)})}};m=de([ee(0,w.ILogService)],m),e.DialogMainService=m}),define(J[234],Z([0,1,3,2,66,24]),function(z,e,b,t,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class D extends t.Disposable{constructor(f,v){super();this.logService=f,this.storageMainService=v,this.onDidChangeApplicationStorageEmitter=this._register(new b.Emitter),this.mapProfileToOnDidChangeProfileStorageEmitter=new Map,this.registerStorageChangeListeners(v.applicationStorage,this.onDidChangeApplicationStorageEmitter)}registerStorageChangeListeners(f,v){this._register(b.Event.debounce(f.onDidChangeStorage,(E,P)=>(E?E.push(P):E=[P],E),D.STORAGE_CHANGE_DEBOUNCE_TIME)(E=>{E.length&&v.fire(this.serializeStorageChangeEvents(E,f))}))}serializeStorageChangeEvents(f,v){const E=new Map,P=new Set;return f.forEach(S=>{const w=v.get(S.key);typeof w=="string"?E.set(S.key,w):P.add(S.key)}),{changed:Array.from(E.entries()),deleted:Array.from(P.values())}}listen(f,v,E){switch(v){case"onDidChangeStorage":{const P=E.profile?(0,R.revive)(E.profile):void 0;if(!P)return this.onDidChangeApplicationStorageEmitter.event;let S=this.mapProfileToOnDidChangeProfileStorageEmitter.get(P.id);return S||(S=this._register(new b.Emitter),this.registerStorageChangeListeners(this.storageMainService.profileStorage(P),S),this.mapProfileToOnDidChangeProfileStorageEmitter.set(P.id,S)),S.event}}throw new Error(`Event not found: ${v}`)}async call(f,v,E){const P=E.profile?(0,R.revive)(E.profile):void 0,S=(0,L.reviveIdentifier)(E.workspace),w=await this.withStorageInitialized(P,S);switch(v){case"getItems":return Array.from(w.items.entries());case"updateItems":{const u=E;if(u.insert)for(const[m,g]of u.insert)w.set(m,g);u.delete?.forEach(m=>w.delete(m));break}default:throw new Error(`Call not found: ${v}`)}}async withStorageInitialized(f,v){let E;v?E=this.storageMainService.workspaceStorage(v):f?E=this.storageMainService.profileStorage(f):E=this.storageMainService.applicationStorage;try{await E.init()}catch(P){this.logService.error(`StorageIPC#init: Unable to init ${v?"workspace":f?"profile":"application"} storage due to ${P}`)}return E}}e.StorageDatabaseChannel=D,D.STORAGE_CHANGE_DEBOUNCE_TIME=100}),define(J[235],Z([0,1,25,8,3,2,9,78,7,23,97,140,6,108,35,24]),function(z,e,b,t,R,L,D,y,f,v,E,P,S,w,u,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageMain=e.WorkspaceStorageMain=e.ApplicationStorageMain=e.ProfileStorageMain=void 0;class g extends L.Disposable{constructor(r,i){super();this.logService=r,this.fileService=i,this._onDidChangeStorage=this._register(new R.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this._onDidCloseStorage=this._register(new R.Emitter),this.onDidCloseStorage=this._onDidCloseStorage.event,this._storage=new E.Storage(new E.InMemoryStorageDatabase),this.initializePromise=void 0,this.whenInitPromise=new t.DeferredPromise,this.whenInit=this.whenInitPromise.p,this.state=E.StorageState.None}get storage(){return this._storage}init(){return this.initializePromise||(this.initializePromise=(async()=>{if(this.state===E.StorageState.None)try{const r=await this.doCreate();this._storage.dispose(),this._storage=r,this._register(r.onDidChangeStorage(s=>this._onDidChangeStorage.fire({key:s}))),await this.doInit(r);const i=r.getBoolean(w.IS_NEW_KEY);i===void 0?r.set(w.IS_NEW_KEY,!0):i&&r.set(w.IS_NEW_KEY,!1)}catch(r){this.logService.error(`[storage main] initialize(): Unable to init storage due to ${r}`)}finally{this.state=E.StorageState.Initialized,this.whenInitPromise.complete()}})()),this.initializePromise}createLoggingOptions(){return{logTrace:this.logService.getLevel()===S.LogLevel.Trace?r=>this.logService.trace(r):void 0,logError:r=>this.logService.error(r)}}doInit(r){return r.init()}get items(){return this._storage.items}get(r,i){return this._storage.get(r,i)}set(r,i){return this._storage.set(r,i)}delete(r){return this._storage.delete(r)}async close(){const r=new y.StopWatch(!1);await this.doClose(),r.stop(),r.elapsed()>g.LOG_SLOW_CLOSE_THRESHOLD&&await this.logSlowClose(r),this._onDidCloseStorage.fire()}async logSlowClose(r){if(!!this.path)try{const i=(0,b.top)(Array.from(this._storage.items.entries()).map(([o,a])=>({key:o,length:a.length})),(o,a)=>a.length-o.length,5).map(o=>`${o.key}:${o.length}`).join(", "),s=(await this.fileService.stat(f.URI.file(this.path))).size;this.logService.warn(`[storage main] detected slow close() operation: Time: ${r.elapsed()}ms, DB size: ${s}b, Large Keys: ${i}`)}catch(i){this.logService.error("[storage main] figuring out stats for slow DB on close() resulted in an error",i)}}async doClose(){this.initializePromise&&await this.initializePromise,this.state=E.StorageState.Closed,await this._storage.close()}}g.LOG_SLOW_CLOSE_THRESHOLD=2e3;class I extends g{constructor(r,i,s,o){super(s,o);this.profile=r,this.options=i}get path(){if(!this.options.useInMemoryStorage)return(0,D.join)(this.profile.globalStorageHome.fsPath,I.STORAGE_NAME)}async doCreate(){return new E.Storage(new P.SQLiteStorageDatabase(this.path??P.SQLiteStorageDatabase.IN_MEMORY_PATH,{logging:this.createLoggingOptions()}))}}I.STORAGE_NAME="state.vscdb";class p extends I{constructor(r,i,s,o){super(r,i,s,o)}}e.ProfileStorageMain=p;class d extends I{constructor(r,i,s,o){super(i.defaultProfile,r,s,o)}async doInit(r){await super.doInit(r),this.updateTelemetryState(r)}updateTelemetryState(r){r.get(u.firstSessionDateStorageKey,void 0)===void 0&&r.set(u.firstSessionDateStorageKey,new Date().toUTCString());const s=r.get(u.currentSessionDateStorageKey,void 0),o=new Date().toUTCString();r.set(u.lastSessionDateStorageKey,typeof s=="undefined"?null:s),r.set(u.currentSessionDateStorageKey,o)}}e.ApplicationStorageMain=d;class h extends g{constructor(r,i,s,o,a){super(s,a);this.workspace=r,this.options=i,this.environmentService=o}get path(){if(!this.options.useInMemoryStorage)return(0,D.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id,h.WORKSPACE_STORAGE_NAME)}async doCreate(){const{storageFilePath:r,wasCreated:i}=await this.prepareWorkspaceStorageFolder();return new E.Storage(new P.SQLiteStorageDatabase(r,{logging:this.createLoggingOptions()}),{hint:i?E.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async prepareWorkspaceStorageFolder(){if(this.options.useInMemoryStorage)return{storageFilePath:P.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const r=(0,D.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id),i=(0,D.join)(r,h.WORKSPACE_STORAGE_NAME);return await v.Promises.exists(r)?{storageFilePath:i,wasCreated:!1}:(await v.Promises.mkdir(r,{recursive:!0}),this.ensureWorkspaceStorageFolderMeta(r),{storageFilePath:i,wasCreated:!0})}async ensureWorkspaceStorageFolderMeta(r){let i;if((0,m.isSingleFolderWorkspaceIdentifier)(this.workspace)?i={folder:this.workspace.uri.toString()}:(0,m.isWorkspaceIdentifier)(this.workspace)&&(i={workspace:this.workspace.configPath.toString()}),i)try{const s=(0,D.join)(r,h.WORKSPACE_META_NAME);await v.Promises.exists(s)||await v.Promises.writeFile(s,JSON.stringify(i,void 0,2))}catch(s){this.logService.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${s}`)}}}e.WorkspaceStorageMain=h,h.WORKSPACE_STORAGE_NAME="state.vscdb",h.WORKSPACE_META_NAME="workspace.json";class l extends g{get path(){}async doCreate(){return new E.Storage(new E.InMemoryStorageDatabase)}}e.InMemoryStorageMain=l}),define(J[236],Z([0,1,33,66,7,39,15,6,210,73,40,24]),function(z,e,b,t,R,L,D,y,f,v,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=void 0;let S=class kt extends E.UserDataProfilesService{constructor(u,m,g,I,p){super(g,I,p);this.stateService=u,this.uriIdentityService=m,this.enabled=!1}setEnablement(u){this._profilesObject=void 0,this.enabled=u}get profilesObject(){if(!this.enabled)return{profiles:[],workspaces:new b.ResourceMap};if(!this._profilesObject){const u=this.getStoredProfiles().map(I=>(0,E.toUserDataProfile)(I.name,I.location,I.useDefaultFlags));let m;const g=new b.ResourceMap;if(u.length){u.unshift(this.createDefaultUserDataProfile(!0));const I=this.getStoredProfileAssociations();if(I.workspaces)for(const[p,d]of Object.entries(I.workspaces)){const h=R.URI.parse(p),l=R.URI.parse(d),n=u.find(r=>this.uriIdentityService.extUri.isEqual(r.location,l));n&&g.set(h,n)}if(I.emptyWindow){const p=R.URI.parse(I.emptyWindow);m=u.find(d=>this.uriIdentityService.extUri.isEqual(d.location,p))}}this._profilesObject={profiles:u,workspaces:g,emptyWindow:m}}return this._profilesObject}get profiles(){return this.profilesObject.profiles}getProfile(u){const m=this.getWorkspace(u);return(R.URI.isUri(m)?this.profilesObject.workspaces.get(m):this.profilesObject.emptyWindow)??this.defaultProfile}getWorkspace(u){return(0,P.isSingleFolderWorkspaceIdentifier)(u)?u.uri:(0,P.isWorkspaceIdentifier)(u)?u.configPath:"empty-window"}getStoredProfiles(){return(0,t.revive)(this.stateService.getItem(kt.PROFILES_KEY,[]))}getStoredProfileAssociations(){return(0,t.revive)(this.stateService.getItem(kt.PROFILE_ASSOCIATIONS_KEY,{}))}};S.PROFILES_KEY="userDataProfiles",S.PROFILE_ASSOCIATIONS_KEY="profileAssociations",S=de([ee(0,f.IStateService),ee(1,v.IUriIdentityService),ee(2,L.IEnvironmentService),ee(3,D.IFileService),ee(4,y.ILogService)],S),e.UserDataProfilesService=S}),define(J[75],Z([0,1,3,7,39,15,5,6,45,73,40,8,236]),function(z,e,b,t,R,L,D,y,f,v,E,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesMainService=e.IUserDataProfilesMainService=void 0,e.IUserDataProfilesMainService=(0,D.refineServiceDecorator)(E.IUserDataProfilesService);let w=class bt extends S.UserDataProfilesService{constructor(m,g,I,p,d){super(m,g,I,p,d);this.stateMainService=m,this._onWillCreateProfile=this._register(new b.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new b.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event}async createProfile(m,g){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${E.PROFILES_ENABLEMENT_CONFIG}' setting.`);if(m=(0,E.reviveProfile)(m,this.profilesHome.scheme),this.getStoredProfiles().some(p=>p.name===m.name))throw new Error(`Profile with name ${m.name} already exists`);await this.fileService.exists(this.profilesHome)||await this.fileService.createFolder(this.profilesHome);const I=[];return this._onWillCreateProfile.fire({profile:m,join(p){I.push(p)}}),await P.Promises.settled(I),this.updateProfiles([m],[]),g&&await this.setProfileForWorkspace(m,g),this.profiles.find(p=>this.uriIdentityService.extUri.isEqual(p.location,m.location))}async setProfileForWorkspace(m,g){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${E.PROFILES_ENABLEMENT_CONFIG}' setting.`);return m=(0,E.reviveProfile)(m,this.profilesHome.scheme),this.updateWorkspaceAssociation(g,m),this.profiles.find(I=>this.uriIdentityService.extUri.isEqual(I.location,m.location))}async unsetWorkspace(m){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${E.PROFILES_ENABLEMENT_CONFIG}' setting.`);this.updateWorkspaceAssociation(m)}async removeProfile(m){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${E.PROFILES_ENABLEMENT_CONFIG}' setting.`);if(m.isDefault)throw new Error("Cannot remove default profile");if(m=(0,E.reviveProfile)(m,this.profilesHome.scheme),!this.getStoredProfiles().some(I=>this.uriIdentityService.extUri.isEqual(I.location,m.location)))throw new Error(`Profile with name ${m.name} does not exist`);const g=[];this._onWillRemoveProfile.fire({profile:m,join(I){g.push(I)}}),await P.Promises.settled(g),m.id===this.profilesObject.emptyWindow?.id&&(this.profilesObject.emptyWindow=void 0);for(const I of[...this.profilesObject.workspaces.keys()])m.id===this.profilesObject.workspaces.get(I)?.id&&this.profilesObject.workspaces.delete(I);this.saveStoredProfileAssociations(),this.updateProfiles([],[m]);try{this.profiles.length===2?await this.fileService.del(this.profilesHome,{recursive:!0}):await this.fileService.del(m.location,{recursive:!0})}catch(I){this.logService.error(I)}}updateProfiles(m,g){const I=[];for(const p of[...this.profilesObject.profiles,...m])p.isDefault||g.some(d=>p.id===d.id)||I.push({location:p.location,name:p.name,useDefaultFlags:p.useDefaultFlags});this.stateMainService.setItem(bt.PROFILES_KEY,I),this._profilesObject=void 0,this._onDidChangeProfiles.fire({added:m,removed:g,all:this.profiles})}updateWorkspaceAssociation(m,g){const I=this.getWorkspace(m);t.URI.isUri(I)?(this.profilesObject.workspaces.delete(I),g&&!g.isDefault&&this.profilesObject.workspaces.set(I,g)):this.profilesObject.emptyWindow=g?.isDefault?void 0:g,this.saveStoredProfileAssociations()}saveStoredProfileAssociations(){const m={};for(const[I,p]of this.profilesObject.workspaces.entries())m[I.toString()]=p.location.toString();const g=this.profilesObject.emptyWindow?.location.toString();this.stateMainService.setItem(bt.PROFILE_ASSOCIATIONS_KEY,{workspaces:m,emptyWindow:g}),this._profilesObject=void 0}getStoredProfileAssociations(){const m="workspaceAndProfileInfo",g=this.stateMainService.getItem(m,void 0);if(g){this.stateMainService.removeItem(m);const I=g.reduce((p,{workspace:d,profile:h})=>(p[t.URI.revive(d).toString()]=t.URI.revive(h).toString(),p),{});this.stateMainService.setItem(bt.PROFILE_ASSOCIATIONS_KEY,{workspaces:I})}return super.getStoredProfileAssociations()}};w=de([ee(0,f.IStateMainService),ee(1,v.IUriIdentityService),ee(2,R.IEnvironmentService),ee(3,L.IFileService),ee(4,y.ILogService)],w),e.UserDataProfilesMainService=w}),define(J[86],Z([0,1,48,2,39,15,5,21,6,108,235,40,75]),function(z,e,b,t,R,L,D,y,f,v,E,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplicationStorageMainService=e.IApplicationStorageMainService=e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,D.createDecorator)("storageMainService");let w=class extends t.Disposable{constructor(g,I,p,d,h){super();this.logService=g,this.environmentService=I,this.userDataProfilesService=p,this.lifecycleMainService=d,this.fileService=h,this.shutdownReason=void 0,this.applicationStorage=this.createApplicationStorage(),this.mapProfileToStorage=new Map,this.mapWorkspaceToStorage=new Map,this.registerListeners()}getStorageOptions(){return{useInMemoryStorage:!!this.environmentService.extensionTestsLocationURI}}registerListeners(){(async()=>{await this.lifecycleMainService.when(3),this.applicationStorage.init()})(),this._register(this.lifecycleMainService.onWillLoadWindow(g=>{g.window.profile&&this.profileStorage(g.window.profile).init(),g.workspace&&this.workspaceStorage(g.workspace).init()})),this._register(this.lifecycleMainService.onWillShutdown(g=>{this.logService.trace("storageMainService#onWillShutdown()"),this.shutdownReason=g.reason,g.join(this.applicationStorage.close());for(const[,I]of this.mapProfileToStorage)g.join(I.close());for(const[,I]of this.mapWorkspaceToStorage)g.join(I.close())})),this._register(this.userDataProfilesService.onWillCreateProfile(g=>{g.join((async()=>{await this.fileService.exists(g.profile.globalStorageHome)||await this.fileService.createFolder(g.profile.globalStorageHome)})())})),this._register(this.userDataProfilesService.onWillRemoveProfile(g=>{const I=this.mapProfileToStorage.get(g.profile.id);I&&g.join(I.close())}))}createApplicationStorage(){this.logService.trace("StorageMainService: creating application storage");const g=new E.ApplicationStorageMain(this.getStorageOptions(),this.userDataProfilesService,this.logService,this.fileService);return(0,b.once)(g.onDidCloseStorage)(()=>{this.logService.trace("StorageMainService: closed application storage")}),g}profileStorage(g){if((0,v.isProfileUsingDefaultStorage)(g))return this.applicationStorage;let I=this.mapProfileToStorage.get(g.id);return I||(this.logService.trace(`StorageMainService: creating profile storage (${g.name})`),I=this.createProfileStorage(g),this.mapProfileToStorage.set(g.id,I),(0,b.once)(I.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed profile storage (${g.name})`),this.mapProfileToStorage.delete(g.id)})),I}createProfileStorage(g){return this.shutdownReason===2?new E.InMemoryStorageMain(this.logService,this.fileService):new E.ProfileStorageMain(g,this.getStorageOptions(),this.logService,this.fileService)}workspaceStorage(g){let I=this.mapWorkspaceToStorage.get(g.id);return I||(this.logService.trace(`StorageMainService: creating workspace storage (${g.id})`),I=this.createWorkspaceStorage(g),this.mapWorkspaceToStorage.set(g.id,I),(0,b.once)(I.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed workspace storage (${g.id})`),this.mapWorkspaceToStorage.delete(g.id)})),I}createWorkspaceStorage(g){return this.shutdownReason===2?new E.InMemoryStorageMain(this.logService,this.fileService):new E.WorkspaceStorageMain(g,this.getStorageOptions(),this.logService,this.environmentService,this.fileService)}};w=de([ee(0,f.ILogService),ee(1,R.IEnvironmentService),ee(2,S.IUserDataProfilesMainService),ee(3,y.ILifecycleMainService),ee(4,L.IFileService)],w),e.StorageMainService=w,e.IApplicationStorageMainService=(0,D.createDecorator)("applicationStorageMainService");let u=class extends v.AbstractStorageService{constructor(g,I){super();this.userDataProfilesService=g,this.storageMainService=I,this.whenReady=this.storageMainService.applicationStorage.whenInit}doInitialize(){return this.storageMainService.applicationStorage.whenInit}getStorage(g){if(g===-1)return this.storageMainService.applicationStorage.storage}getLogDetails(g){if(g===-1)return this.userDataProfilesService.defaultProfile.globalStorageHome.fsPath}shouldFlushWhenIdle(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}switchToProfile(){throw new Error("Switching storage profile is unsupported from main process")}switchToWorkspace(){throw new Error("Switching storage workspace is unsupported from main process")}};u=de([ee(0,P.IUserDataProfilesService),ee(1,e.IStorageMainService)],u),e.ApplicationStorageMainService=u}),define(J[110],Z([0,1,16,7,24]),function(z,e,b,t,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;function L(f,v,E){for(const S of f){const w=S.openedWorkspace;if((0,R.isWorkspaceIdentifier)(w)){const u=E(w);if(u){if(u.folders.some(m=>b.extUriBiasedIgnorePathCase.isEqualOrParent(v,m.uri)))return S}else if(b.extUriBiasedIgnorePathCase.isEqualOrParent(v,w.configPath))return S}}const P=f.filter(S=>(0,R.isSingleFolderWorkspaceIdentifier)(S.openedWorkspace)&&b.extUriBiasedIgnorePathCase.isEqualOrParent(v,S.openedWorkspace.uri));if(P.length)return P.sort((S,w)=>-(S.openedWorkspace.uri.path.length-w.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=L;function D(f,v){for(const E of f)if((0,R.isWorkspaceIdentifier)(E.openedWorkspace)&&b.extUriBiasedIgnorePathCase.isEqual(E.openedWorkspace.configPath,v)||(0,R.isSingleFolderWorkspaceIdentifier)(E.openedWorkspace)&&b.extUriBiasedIgnorePathCase.isEqual(E.openedWorkspace.uri,v))return E}e.findWindowOnWorkspaceOrFolder=D;function y(f,v){const E=P=>v.some(S=>b.extUriBiasedIgnorePathCase.isEqual(t.URI.file(S),t.URI.file(P)));for(const P of f)if(P.config?.extensionDevelopmentPath?.some(S=>E(S)))return P}e.findWindowOnExtensionDevelopmentPath=y}),define(J[237],Z([0,1,14,2,4,16,7,17,21,6,45,32,109,24]),function(z,e,b,t,R,L,D,y,f,v,E,P,S,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let u=class Mt extends t.Disposable{constructor(h,l,n,r,i){super();this.windowsMainService=h,this.stateMainService=l,this.lifecycleMainService=n,this.logService=r,this.configurationService=i,this._state=m(this.stateMainService.getItem(Mt.windowsStateStorageKey)),this.lastClosedState=void 0,this.shuttingDown=!1,this.registerListeners()}get state(){return this._state}registerListeners(){b.app.on("browser-window-blur",()=>{this.shuttingDown||this.saveWindowsState()}),this.lifecycleMainService.onBeforeCloseWindow(h=>this.onBeforeCloseWindow(h)),this.lifecycleMainService.onBeforeShutdown(()=>this.onBeforeShutdown()),this.windowsMainService.onDidChangeWindowsCount(h=>{h.newCount-h.oldCount>0&&(this.lastClosedState=void 0)}),this.windowsMainService.onDidDestroyWindow(h=>this.onBeforeCloseWindow(h))}onBeforeShutdown(){this.shuttingDown=!0,this.saveWindowsState()}saveWindowsState(){const h={openedWindows:[],lastPluginDevelopmentHostWindow:this._state.lastPluginDevelopmentHostWindow,lastActiveWindow:this.lastClosedState};if(!h.lastActiveWindow){let r=this.windowsMainService.getLastActiveWindow();(!r||r.isExtensionDevelopmentHost)&&(r=this.windowsMainService.getWindows().find(i=>!i.isExtensionDevelopmentHost)),r&&(h.lastActiveWindow=this.toWindowState(r))}const l=this.windowsMainService.getWindows().find(r=>r.isExtensionDevelopmentHost&&!r.isExtensionTestHost);l&&(h.lastPluginDevelopmentHostWindow=this.toWindowState(l)),this.windowsMainService.getWindowCount()>1&&(h.openedWindows=this.windowsMainService.getWindows().filter(r=>!r.isExtensionDevelopmentHost).map(r=>this.toWindowState(r)));const n=I(h);this.stateMainService.setItem(Mt.windowsStateStorageKey,n),this.shuttingDown&&this.logService.trace("[WindowsStateHandler] onBeforeShutdown",n)}onBeforeCloseWindow(h){if(this.lifecycleMainService.quitRequested)return;const l=this.toWindowState(h);h.isExtensionDevelopmentHost&&!h.isExtensionTestHost?this._state.lastPluginDevelopmentHostWindow=l:!h.isExtensionDevelopmentHost&&h.openedWorkspace&&this._state.openedWindows.forEach(n=>{const r=(0,w.isWorkspaceIdentifier)(h.openedWorkspace)&&n.workspace?.id===h.openedWorkspace.id,i=(0,w.isSingleFolderWorkspaceIdentifier)(h.openedWorkspace)&&n.folderUri&&L.extUriBiasedIgnorePathCase.isEqual(n.folderUri,h.openedWorkspace.uri);(r||i)&&(n.uiState=l.uiState)}),this.windowsMainService.getWindowCount()===1&&(this.lastClosedState=l)}toWindowState(h){return{workspace:(0,w.isWorkspaceIdentifier)(h.openedWorkspace)?h.openedWorkspace:void 0,folderUri:(0,w.isSingleFolderWorkspaceIdentifier)(h.openedWorkspace)?h.openedWorkspace.uri:void 0,backupPath:h.backupPath,remoteAuthority:h.remoteAuthority,uiState:h.serializeWindowState()}}getNewWindowState(h){const l=this.doGetNewWindowState(h),n=this.configurationService.getValue("window");let r;return l.hasDefaultState?r=!!(n?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(n.newWindowDimensions)>=0):(r=!!(this.lifecycleMainService.wasRestarted||n?.restoreFullscreen),r&&R.isMacintosh&&this.windowsMainService.getWindows().some(i=>i.isFullScreen)&&(r=!1)),l.mode===3&&!r&&(l.mode=1),l}doGetNewWindowState(h){const l=this.windowsMainService.getLastActiveWindow();if(!h.extensionTestsPath){if(!!h.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const a=h.workspace;if((0,w.isWorkspaceIdentifier)(a)){const C=this.state.openedWindows.filter(k=>k.workspace&&k.workspace.id===a.id).map(k=>k.uiState);if(C.length)return C[0]}if((0,w.isSingleFolderWorkspaceIdentifier)(a)){const C=this.state.openedWindows.filter(k=>k.folderUri&&L.extUriBiasedIgnorePathCase.isEqual(k.folderUri,a.uri)).map(k=>k.uiState);if(C.length)return C[0]}else if(h.backupPath){const C=this.state.openedWindows.filter(k=>k.backupPath===h.backupPath).map(k=>k.uiState);if(C.length)return C[0]}const c=this.lastClosedState||this.state.lastActiveWindow;if(!l&&c)return c.uiState}let n;const r=b.screen.getAllDisplays();if(r.length===1)n=r[0];else{if(R.isMacintosh){const a=b.screen.getCursorScreenPoint();n=b.screen.getDisplayNearestPoint(a)}!n&&l&&(n=b.screen.getDisplayMatching(l.getBounds())),n||(n=b.screen.getPrimaryDisplay()||r[0])}let i=(0,S.defaultWindowState)();i.x=Math.round(n.bounds.x+n.bounds.width/2-i.width/2),i.y=Math.round(n.bounds.y+n.bounds.height/2-i.height/2);const s=this.configurationService.getValue("window");let o=!0;if(s?.newWindowDimensions){if(s.newWindowDimensions==="maximized")i.mode=0,o=!1;else if(s.newWindowDimensions==="fullscreen")i.mode=3,o=!1;else if((s.newWindowDimensions==="inherit"||s.newWindowDimensions==="offset")&&l){const a=l.serializeWindowState();a.mode===3?i.mode=3:i=a,o=i.mode!==3&&s.newWindowDimensions==="offset"}}return o&&(i=this.ensureNoOverlap(i)),i.hasDefaultState=!0,i}ensureNoOverlap(h){if(this.windowsMainService.getWindows().length===0)return h;h.x=typeof h.x=="number"?h.x:0,h.y=typeof h.y=="number"?h.y:0;const l=this.windowsMainService.getWindows().map(n=>n.getBounds());for(;l.some(n=>n.x===h.x||n.y===h.y);)h.x+=30,h.y+=30;return h}};u.windowsStateStorageKey="windowsState",u=de([ee(0,P.IWindowsMainService),ee(1,E.IStateMainService),ee(2,f.ILifecycleMainService),ee(3,v.ILogService),ee(4,y.IConfigurationService)],u),e.WindowsStateHandler=u;function m(d){const h={openedWindows:[]},l=d||{openedWindows:[]};return l.lastActiveWindow&&(h.lastActiveWindow=g(l.lastActiveWindow)),l.lastPluginDevelopmentHostWindow&&(h.lastPluginDevelopmentHostWindow=g(l.lastPluginDevelopmentHostWindow)),Array.isArray(l.openedWindows)&&(h.openedWindows=l.openedWindows.map(n=>g(n))),h}e.restoreWindowsState=m;function g(d){const h={uiState:d.uiState};return d.backupPath&&(h.backupPath=d.backupPath),d.remoteAuthority&&(h.remoteAuthority=d.remoteAuthority),d.folder&&(h.folderUri=D.URI.parse(d.folder)),d.workspaceIdentifier&&(h.workspace={id:d.workspaceIdentifier.id,configPath:D.URI.parse(d.workspaceIdentifier.configURIPath)}),h}function I(d){return{lastActiveWindow:d.lastActiveWindow&&p(d.lastActiveWindow),lastPluginDevelopmentHostWindow:d.lastPluginDevelopmentHostWindow&&p(d.lastPluginDevelopmentHostWindow),openedWindows:d.openedWindows.map(h=>p(h))}}e.getWindowsStateStoreData=I;function p(d){return{workspaceIdentifier:d.workspace&&{id:d.workspace.id,configURIPath:d.workspace.configPath.toString()},folder:d.folderUri&&d.folderUri.toString(),backupPath:d.backupPath,remoteAuthority:d.remoteAuthority,uiState:d.uiState}}}),define(J[87],Z([0,1,29,49,118,34,11,9,4,16,7,5,71,24]),function(z,e,b,t,R,L,D,y,f,v,E,P,S,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isStoredWorkspaceFolder=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=void 0,e.IWorkspacesService=(0,P.createDecorator)("workspacesService");function u(k){return k.hasOwnProperty("workspace")}e.isRecentWorkspace=u;function m(k){return k.hasOwnProperty("folderUri")}e.isRecentFolder=m;function g(k){return k.hasOwnProperty("fileUri")}e.isRecentFile=g;function I(k){return p(k)||d(k)}e.isStoredWorkspaceFolder=I;function p(k){const M=k;return typeof M?.path=="string"&&(!M.name||typeof M.name=="string")}function d(k){const M=k;return typeof M?.uri=="string"&&(!M.name||typeof M.name=="string")}function h(k,M,T,F,q=!f.isWindows,te){if(k.scheme!==F.scheme)return{name:T,uri:k.toString(!0)};let ne=M?void 0:te.relativePath(F,k);if(ne!==void 0)ne.length===0?ne=".":f.isWindows&&k.scheme===D.Schemas.file&&!q&&(ne=ne.replace(/\//g,"\\"));else if(k.scheme===D.Schemas.file)ne=k.fsPath,f.isWindows&&(ne=(0,L.normalizeDriveLetter)(ne),q&&(ne=(0,b.toSlashes)(ne)));else{if(!te.isEqualAuthority(k.authority,F.authority))return{name:T,uri:k.toString(!0)};ne=k.path}return{name:T,path:ne}}e.getStoredWorkspaceFolder=h;function l(k,M,T){const F=[],q=new Set,te=T.dirname(M);for(const ne of k){let Q;if(p(ne))ne.path&&(Q=T.resolvePath(te,ne.path));else if(d(ne))try{Q=E.URI.parse(ne.uri),Q.path[0]!=="/"&&(Q=Q.with({path:"/"+Q.path}))}catch(se){console.warn(se)}if(Q){const se=T.getComparisonKey(Q);if(!q.has(se)){q.add(se);const ce=ne.name||T.basenameOrAuthority(Q);F.push(new w.WorkspaceFolder({uri:Q,name:ce,index:F.length},ne))}}}return F}e.toWorkspaceFolders=l;function n(k,M,T,F,q){const te=r(M,k),ne=q.dirname(M),Q=q.dirname(F),se=[],ce=i(te.folders);for(const U of te.folders){const B=p(U)?q.resolvePath(ne,U.path):E.URI.parse(U.uri);let X;T?X=!1:X=!p(U)||(0,y.isAbsolute)(U.path),se.push(h(B,X,U.name,Q,ce,q))}const H={insertSpaces:!1,tabSize:4,eol:f.isLinux||f.isMacintosh?`
`:`\r
`},oe=R.setProperty(k,["folders"],se,H);let W=R.applyEdits(k,oe);return(0,v.isEqualAuthority)(te.remoteAuthority,(0,S.getRemoteAuthority)(F))&&(W=R.applyEdits(W,R.removeProperty(W,["remoteAuthority"],H))),W}e.rewriteWorkspaceFileForNewLocation=n;function r(k,M){const T=t.parse(M);if(T&&Array.isArray(T.folders))T.folders=T.folders.filter(F=>I(F));else throw new Error(`${k} looks like an invalid workspace file.`);return T}function i(k){return f.isWindows?k.some(M=>p(M)&&M.path.indexOf("/")>=0):!0}e.useSlashForPath=i;function s(k){return k.workspace&&typeof k.workspace=="object"&&typeof k.workspace.id=="string"&&typeof k.workspace.configPath=="string"}function o(k){return typeof k.folderUri=="string"}function a(k){return typeof k.fileUri=="string"}function c(k,M){const T={workspaces:[],files:[]};if(k){const F=function(te,ne){for(let Q=0;Q<te.length;Q++)try{ne(te[Q],Q)}catch(se){M.warn(`Error restoring recent entry ${JSON.stringify(te[Q])}: ${se.toString()}. Skip entry.`)}},q=k;Array.isArray(q.entries)&&F(q.entries,te=>{const ne=te.label,Q=te.remoteAuthority;s(te)?T.workspaces.push({label:ne,remoteAuthority:Q,workspace:{id:te.workspace.id,configPath:E.URI.parse(te.workspace.configPath)}}):o(te)?T.workspaces.push({label:ne,remoteAuthority:Q,folderUri:E.URI.parse(te.folderUri)}):a(te)&&T.files.push({label:ne,remoteAuthority:Q,fileUri:E.URI.parse(te.fileUri)})})}return T}e.restoreRecentlyOpened=c;function C(k){const M={entries:[]};for(const T of k.workspaces)m(T)?M.entries.push({folderUri:T.folderUri.toString(),label:T.label,remoteAuthority:T.remoteAuthority}):M.entries.push({workspace:{id:T.workspace.id,configPath:T.workspace.configPath.toString()},label:T.label,remoteAuthority:T.remoteAuthority});for(const T of k.files)M.entries.push({fileUri:T.fileUri.toString(),label:T.label,remoteAuthority:T.remoteAuthority});return M}e.toStoreData=C}),define(J[111],Z([0,1,63,28,11,4,16]),function(z,e,b,t,R,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=void 0;function y(v){function E(){let P=v.scheme===R.Schemas.file?(0,D.originalFSPath)(v):v.toString();return L.isLinux||(P=P.toLowerCase()),(0,b.createHash)("md5").update(P).digest("hex")}return{id:E(),configPath:v}}e.getWorkspaceIdentifier=y;function f(v,E){function P(){if(v.scheme!==R.Schemas.file)return(0,b.createHash)("md5").update(v.toString()).digest("hex");if(!E)try{E=(0,t.statSync)(v.fsPath)}catch{return}let w;return L.isLinux?w=E.ino:L.isMacintosh?w=E.birthtime.getTime():L.isWindows&&(typeof E.birthtimeMs=="number"?w=Math.floor(E.birthtimeMs):w=E.birthtime.getTime()),(0,b.createHash)("md5").update(v.fsPath).update(w?String(w):"").digest("hex")}const S=P();if(typeof S=="string")return{id:S,uri:v}}e.getSingleFolderWorkspaceIdentifier=f}),define(J[238],Z([0,1,37,8,261,2]),function(z,e,b,t,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativePolicyService=void 0;class D extends b.AbstractPolicyService{constructor(f){super();this.productName=f,this.throttler=new t.Throttler,this.watcher=this._register(new L.MutableDisposable)}async initializePolicies(f){await this.throttler.queue(()=>new Promise((v,E)=>{try{this.watcher.value=(0,R.createWatcher)(this.productName,f,P=>{for(const S in P){const w=P[S];w===void 0?this.policies.delete(S):this.policies.set(S,w)}this._onDidChange.fire(Object.keys(P)),v()})}catch(P){E(P)}}))}}e.NativePolicyService=D}),define(J[88],Z([0,1,63,64,27,19,18,3,2,9,4,30,43,95,239]),function(z,e,b,t,R,L,D,y,f,v,E,P,S,w,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class m{constructor(M,T=""){this.debugLabel=T,this.socket=M,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=F=>{if(this.traceSocketEvent("error",{code:F?.code,message:F?.message}),F){if(F.code==="EPIPE")return;(0,D.onUnexpectedError)(F)}},this.socket.on("error",this._errorListener)}traceSocketEvent(M,T){w.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,M,T)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(M){const T=F=>{this.traceSocketEvent("read",F),M(L.VSBuffer.wrap(F))};return this.socket.on("data",T),{dispose:()=>this.socket.off("data",T)}}onClose(M){const T=F=>{this.traceSocketEvent("close",{hadError:F}),M({type:0,hadError:F,error:void 0})};return this.socket.on("close",T),{dispose:()=>this.socket.off("close",T)}}onEnd(M){const T=()=>{this.traceSocketEvent("nodeEndReceived"),M()};return this.socket.on("end",T),{dispose:()=>this.socket.off("end",T)}}write(M){if(!this.socket.destroyed)try{this.traceSocketEvent("write",M),this.socket.write(M.buffer,T=>{if(T){if(T.code==="EPIPE")return;(0,D.onUnexpectedError)(T)}})}catch(T){if(T.code==="EPIPE")return;(0,D.onUnexpectedError)(T)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((M,T)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),M();return}const F=()=>{this.socket.off("close",F),this.socket.off("end",F),this.socket.off("error",F),this.socket.off("timeout",F),this.socket.off("drain",F),this.traceSocketEvent("nodeDrainEnd"),M()};this.socket.on("close",F),this.socket.on("end",F),this.socket.on("error",F),this.socket.on("timeout",F),this.socket.on("drain",F)})}}e.NodeSocket=m;var g;(function(k){k[k.MinHeaderByteSize=2]="MinHeaderByteSize"})(g||(g={}));var I;(function(k){k[k.PeekHeader=1]="PeekHeader",k[k.ReadHeader=2]="ReadHeader",k[k.ReadBody=3]="ReadBody",k[k.Fin=4]="Fin"})(I||(I={}));class p extends f.Disposable{constructor(M,T,F,q){super();this._onData=this._register(new y.Emitter),this._onClose=this._register(new y.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=M,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:T,inflateBytesLength:F?.byteLength||0,recordInflateBytes:q}),this._flowManager=this._register(new d(this,T,F,q,this._onData,(te,ne)=>this._write(te,ne))),this._register(this._flowManager.onError(te=>{console.error(te),(0,D.onUnexpectedError)(te),this._onClose.fire({type:0,hadError:!0,error:te})})),this._incomingData=new w.ChunkStream,this._register(this.socket.onData(te=>this._acceptChunk(te))),this._register(this.socket.onClose(te=>this._onClose.fire(te)))}get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(M,T){this.socket.traceSocketEvent(M,T)}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(M){return this._onData.event(M)}onClose(M){return this._onClose.event(M)}onEnd(M){return this.socket.onEnd(M)}write(M){this._flowManager.writeMessage(M)}_write(M,T){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",M);let F=2;M.byteLength<126?F+=0:M.byteLength<2**16?F+=2:F+=8;const q=L.VSBuffer.alloc(F);if(T?q.writeUInt8(194,0):q.writeUInt8(130,0),M.byteLength<126)q.writeUInt8(M.byteLength,1);else if(M.byteLength<2**16){q.writeUInt8(126,1);let te=1;q.writeUInt8(M.byteLength>>>8&255,++te),q.writeUInt8(M.byteLength>>>0&255,++te)}else{q.writeUInt8(127,1);let te=1;q.writeUInt8(0,++te),q.writeUInt8(0,++te),q.writeUInt8(0,++te),q.writeUInt8(0,++te),q.writeUInt8(M.byteLength>>>24&255,++te),q.writeUInt8(M.byteLength>>>16&255,++te),q.writeUInt8(M.byteLength>>>8&255,++te),q.writeUInt8(M.byteLength>>>0&255,++te)}this.socket.write(L.VSBuffer.concat([q,M]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(M){if(M.byteLength!==0){for(this._incomingData.acceptChunk(M);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const T=this._incomingData.peek(this._state.readLen),F=T.readUInt8(0),q=(F&128)>>>7,te=(F&64)>>>6,ne=T.readUInt8(1),Q=(ne&128)>>>7,se=ne&127;this._state.state=2,this._state.readLen=2+(Q?4:0)+(se===126?2:0)+(se===127?8:0),this._state.fin=q,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(te)),this._state.firstFrameOfMessage=Boolean(q),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const T=this._incomingData.read(this._state.readLen),F=T.readUInt8(1),q=(F&128)>>>7;let te=F&127,ne=1;te===126?te=T.readUInt8(++ne)*2**8+T.readUInt8(++ne):te===127&&(te=T.readUInt8(++ne)*0+T.readUInt8(++ne)*0+T.readUInt8(++ne)*0+T.readUInt8(++ne)*0+T.readUInt8(++ne)*2**24+T.readUInt8(++ne)*2**16+T.readUInt8(++ne)*2**8+T.readUInt8(++ne));let Q=0;q&&(Q=T.readUInt8(++ne)*2**24+T.readUInt8(++ne)*2**16+T.readUInt8(++ne)*2**8+T.readUInt8(++ne)),this._state.state=3,this._state.readLen=te,this._state.mask=Q,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const T=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",T),n(T,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",T),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(T,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await y.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=p;class d extends f.Disposable{constructor(M,T,F,q,te,ne){super();this._tracer=M,this._onData=te,this._writeFn=ne,this._onError=this._register(new y.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new y.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,T?(this._zlibInflateStream=this._register(new h(this._tracer,q,F,{windowBits:15})),this._zlibDeflateStream=this._register(new l(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(Q=>this._onError.fire(Q))),this._register(this._zlibDeflateStream.onError(Q=>this._onError.fire(Q)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:L.VSBuffer.alloc(0)}writeMessage(M){this._writeQueue.push(M),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const M=this._writeQueue.shift();if(this._zlibDeflateStream){const T=await this._deflateMessage(this._zlibDeflateStream,M);this._writeFn(T,!0)}else this._writeFn(M,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(M,T){return new Promise((F,q)=>{M.write(T),M.flush(te=>F(te))})}acceptFrame(M,T,F){this._readQueue.push({data:M,isCompressed:T,isLastFrameOfMessage:F}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const M=this._readQueue.shift();if(this._zlibInflateStream&&M.isCompressed){const T=await this._inflateFrame(this._zlibInflateStream,M.data,M.isLastFrameOfMessage);this._onData.fire(T)}else this._onData.fire(M.data)}this._isProcessingReadQueue=!1}}_inflateFrame(M,T,F){return new Promise((q,te)=>{M.write(T),F&&M.write(L.VSBuffer.fromByteArray([0,0,255,255])),M.flush(ne=>q(ne))})}}class h extends f.Disposable{constructor(M,T,F,q){super();this._tracer=M,this._recordInflateBytes=T,this._onError=this._register(new y.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=u.createInflateRaw(q),this._zlibInflate.on("error",te=>{this._tracer.traceSocketEvent("zlibInflateError",{message:te?.message,code:te?.code}),this._onError.fire(te)}),this._zlibInflate.on("data",te=>{this._tracer.traceSocketEvent("zlibInflateData",te),this._pendingInflateData.push(L.VSBuffer.wrap(te))}),F&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",F.buffer),this._zlibInflate.write(F.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}get recordedInflateBytes(){return this._recordInflateBytes?L.VSBuffer.concat(this._recordedInflateBytes):L.VSBuffer.alloc(0)}write(M){this._recordInflateBytes&&this._recordedInflateBytes.push(M.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",M),this._zlibInflate.write(M.buffer)}flush(M){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const T=L.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,M(T)})}}class l extends f.Disposable{constructor(M,T){super();this._tracer=M,this._onError=this._register(new y.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=u.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",F=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:F?.message,code:F?.code}),this._onError.fire(F)}),this._zlibDeflate.on("data",F=>{this._tracer.traceSocketEvent("zlibDeflateData",F),this._pendingDeflateData.push(L.VSBuffer.wrap(F))})}write(M){this._tracer.traceSocketEvent("zlibDeflateWrite",M.buffer),this._zlibDeflate.write(M.buffer)}flush(M){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let T=L.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,T=T.slice(0,T.byteLength-4),M(T)})}}function n(k,M){if(M===0)return;const T=k.byteLength>>>2;for(let se=0;se<T;se++){const ce=k.readUInt32BE(se*4);k.writeUInt32BE(ce^M,se*4)}const F=T*4,q=k.byteLength-F,te=M>>>24&255,ne=M>>>16&255,Q=M>>>8&255;q>=1&&k.writeUInt8(k.readUInt8(F)^te,F),q>=2&&k.writeUInt8(k.readUInt8(F+1)^ne,F+1),q>=3&&k.writeUInt8(k.readUInt8(F+2)^Q,F+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const r={[2]:107,[1]:103};function i(){const k=(0,P.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${k}-sock`;let M;return e.XDG_RUNTIME_DIR?M=(0,v.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${k}.sock`):M=(0,v.join)((0,R.tmpdir)(),`vscode-ipc-${k}.sock`),o(M),M}e.createRandomIPCHandle=i;function s(k,M,T){const F=(0,b.createHash)("md5").update(k).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${F}-${T}-${M}-sock`;let q;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?q=(0,v.join)(e.XDG_RUNTIME_DIR,`vscode-${F.substr(0,8)}-${T}-${M}.sock`):q=(0,v.join)(k,`${T}-${M}.sock`),o(q),q}e.createStaticIPCHandle=s;function o(k){const M=r[E.platform];typeof M=="number"&&k.length>=M&&console.warn(`WARNING: IPC handle "${k}" is longer than ${M} chars, try a shorter --user-data-dir`)}class a extends S.IPCServer{constructor(M){super(a.toClientConnectionEvent(M));this.server=M}static toClientConnectionEvent(M){const T=y.Event.fromNodeEventEmitter(M,"connection");return y.Event.map(T,F=>({protocol:new w.Protocol(new m(F,"ipc-server-connection")),onDidClientDisconnect:y.Event.once(y.Event.fromNodeEventEmitter(F,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=a;function c(k){return new Promise((M,T)=>{const F=(0,t.createServer)();F.on("error",T),F.listen(k,()=>{F.removeListener("error",T),M(new a(F))})})}e.serve=c;function C(k,M){return new Promise((T,F)=>{const q=(0,t.createConnection)(k,()=>{q.removeListener("error",F),T(w.Client.fromSocket(new m(q,`ipc-client${M}`),M))});q.once("error",F)})}e.connect=C}),define(J[26],Z([0,1,51,9,88,39,175,5]),function(z,e,b,t,R,L,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,y.refineServiceDecorator)(L.IEnvironmentService);class f extends D.NativeEnvironmentService{get cachedLanguagesPath(){return(0,t.join)(this.userDataPath,"clp")}get backupHome(){return(0,t.join)(this.userDataPath,"Backups")}get backupWorkspacesPath(){return(0,t.join)(this.backupHome,"workspaces.json")}get mainIPCHandle(){return(0,R.createStaticIPCHandle)(this.userDataPath,"main",this.productService.version)}get mainLockfile(){return(0,t.join)(this.userDataPath,"code.lock")}get sandbox(){return!!this.args.__sandbox}get disableUpdates(){return!!this.args["disable-updates"]}get disableKeytar(){return!!this.args["disable-keytar"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}}de([b.memoize],f.prototype,"cachedLanguagesPath",null),de([b.memoize],f.prototype,"backupHome",null),de([b.memoize],f.prototype,"backupWorkspacesPath",null),de([b.memoize],f.prototype,"mainIPCHandle",null),de([b.memoize],f.prototype,"mainLockfile",null),de([b.memoize],f.prototype,"sandbox",null),de([b.memoize],f.prototype,"disableUpdates",null),de([b.memoize],f.prototype,"disableKeytar",null),de([b.memoize],f.prototype,"codeCachePath",null),de([b.memoize],f.prototype,"useCodeCache",null),e.EnvironmentMainService=f}),define(J[240],Z([0,1,63,28,29,11,9,4,16,7,23,169,17,26,15,6,168,24]),function(z,e,b,t,R,L,D,y,f,v,E,P,S,w,u,m,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let p=class{constructor(h,l,n){this.configurationService=l,this.logService=n,this.workspaces=[],this.folders=[],this.emptyWindows=[],this.backupUriComparer=f.extUriBiasedIgnorePathCase,this.backupPathComparer={isEqual:(r,i)=>(0,R.isEqual)(r,i,!y.isLinux)},this.backupHome=h.backupHome,this.workspacesJsonPath=h.backupWorkspacesPath}async initialize(){let h;try{h=JSON.parse(await E.Promises.readFile(this.workspacesJsonPath,"utf8"))}catch{h=Object.create(null)}this.emptyWindows=await this.validateEmptyWorkspaces(h.emptyWorkspaceInfos);let l=[];try{Array.isArray(h.rootURIWorkspaces)&&(l=h.rootURIWorkspaces.map(r=>({workspace:{id:r.id,configPath:v.URI.parse(r.configURIPath)},remoteAuthority:r.remoteAuthority})))}catch{}this.workspaces=await this.validateWorkspaces(l);let n=[];try{Array.isArray(h.folderWorkspaceInfos)?n=h.folderWorkspaceInfos.map(r=>({folderUri:v.URI.parse(r.folderUri),remoteAuthority:r.remoteAuthority})):Array.isArray(h.folderURIWorkspaces)&&(n=h.folderURIWorkspaces.map(r=>({folderUri:v.URI.parse(r),remoteAuthority:void 0})))}catch{}this.folders=await this.validateFolders(n),await this.save()}getWorkspaceBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.workspaces.slice(0)}getFolderBackupPaths(){return this.isHotExitOnExitAndWindowClose()?[]:this.folders.slice(0)}isHotExitEnabled(){return this.getHotExitConfig()!==u.HotExitConfiguration.OFF}isHotExitOnExitAndWindowClose(){return this.getHotExitConfig()===u.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}getHotExitConfig(){return this.configurationService.getValue()?.files?.hotExit||u.HotExitConfiguration.ON_EXIT}getEmptyWindowBackupPaths(){return this.emptyWindows.slice(0)}registerWorkspaceBackupSync(h,l){this.workspaces.some(r=>h.workspace.id===r.workspace.id)||(this.workspaces.push(h),this.saveSync());const n=this.getBackupPath(h.workspace.id);return l&&this.moveBackupFolderSync(n,l),n}moveBackupFolderSync(h,l){if(t.existsSync(h)&&this.convertToEmptyWindowBackupSync(h),t.existsSync(l))try{t.renameSync(l,h)}catch(n){this.logService.error(`Backup: Could not move backup folder to new location: ${n.toString()}`)}}unregisterWorkspaceBackupSync(h){const l=h.id,n=this.workspaces.findIndex(r=>r.workspace.id===l);n!==-1&&(this.workspaces.splice(n,1),this.saveSync())}registerFolderBackupSync(h){return this.folders.some(l=>this.backupUriComparer.isEqual(h.folderUri,l.folderUri))||(this.folders.push(h),this.saveSync()),this.getBackupPath(this.getFolderHash(h))}unregisterFolderBackupSync(h){const l=this.folders.findIndex(n=>this.backupUriComparer.isEqual(h,n.folderUri));l!==-1&&(this.folders.splice(l,1),this.saveSync())}registerEmptyWindowBackupSync(h,l){const n=h||this.getRandomEmptyWindowId();return this.emptyWindows.some(r=>!!r.backupFolder&&this.backupPathComparer.isEqual(r.backupFolder,n))||(this.emptyWindows.push({backupFolder:n,remoteAuthority:l}),this.saveSync()),this.getBackupPath(n)}unregisterEmptyWindowBackupSync(h){const l=this.emptyWindows.findIndex(n=>!!n.backupFolder&&this.backupPathComparer.isEqual(n.backupFolder,h));l!==-1&&(this.emptyWindows.splice(l,1),this.saveSync())}getBackupPath(h){return(0,D.join)(this.backupHome,h)}async validateWorkspaces(h){if(!Array.isArray(h))return[];const l=new Set,n=[];for(const r of h){const i=r.workspace;if(!(0,I.isWorkspaceIdentifier)(i))return[];if(!l.has(i.id)){l.add(i.id);const s=this.getBackupPath(i.id);await this.doHasBackups(s)?i.configPath.scheme!==L.Schemas.file||await E.Promises.exists(i.configPath.fsPath)?n.push(r):await this.convertToEmptyWindowBackup(s):await this.deleteStaleBackup(s)}}return n}async validateFolders(h){if(!Array.isArray(h))return[];const l=[],n=new Set;for(const r of h){const i=r.folderUri,s=this.backupUriComparer.getComparisonKey(i);if(!n.has(s)){n.add(s);const o=this.getBackupPath(this.getFolderHash(r));await this.doHasBackups(o)?i.scheme!==L.Schemas.file||await E.Promises.exists(i.fsPath)?l.push(r):await this.convertToEmptyWindowBackup(o):await this.deleteStaleBackup(o)}}return l}async validateEmptyWorkspaces(h){if(!Array.isArray(h))return[];const l=[],n=new Set;for(const r of h){const i=r.backupFolder;if(typeof i!="string")return[];if(!n.has(i)){n.add(i);const s=this.getBackupPath(i);await this.doHasBackups(s)?l.push(r):await this.deleteStaleBackup(s)}}return l}async deleteStaleBackup(h){try{await E.Promises.exists(h)&&await E.Promises.rm(h,E.RimRafMode.MOVE)}catch(l){this.logService.error(`Backup: Could not delete stale backup: ${l.toString()}`)}}async convertToEmptyWindowBackup(h){let l=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(r=>!!r.backupFolder&&this.backupPathComparer.isEqual(r.backupFolder,l));)l=this.getRandomEmptyWindowId();const n=this.getBackupPath(l);try{await E.Promises.rename(h,n)}catch(r){return this.logService.error(`Backup: Could not rename backup folder: ${r.toString()}`),!1}return this.emptyWindows.push({backupFolder:l}),!0}convertToEmptyWindowBackupSync(h){let l=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(r=>!!r.backupFolder&&this.backupPathComparer.isEqual(r.backupFolder,l));)l=this.getRandomEmptyWindowId();const n=this.getBackupPath(l);try{t.renameSync(h,n)}catch(r){return this.logService.error(`Backup: Could not rename backup folder: ${r.toString()}`),!1}return this.emptyWindows.push({backupFolder:l}),!0}async getDirtyWorkspaces(){const h=[];for(const l of this.workspaces)await this.hasBackups(l)&&h.push(l);for(const l of this.folders)await this.hasBackups(l)&&h.push(l);return h}hasBackups(h){let l;return(0,P.isEmptyWindowBackupInfo)(h)?l=h.backupFolder:(0,g.isFolderBackupInfo)(h)?l=this.getBackupPath(this.getFolderHash(h)):l=this.getBackupPath(h.workspace.id),this.doHasBackups(l)}async doHasBackups(h){try{const l=await E.Promises.readdir(h);for(const n of l)try{if((await E.Promises.readdir((0,D.join)(h,n))).length>0)return!0}catch{}}catch{}return!1}saveSync(){try{(0,E.writeFileSync)(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(h){this.logService.error(`Backup: Could not save workspaces.json: ${h.toString()}`)}}async save(){try{await E.Promises.writeFile(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(h){this.logService.error(`Backup: Could not save workspaces.json: ${h.toString()}`)}}serializeBackups(){return{rootURIWorkspaces:this.workspaces.map(h=>({id:h.workspace.id,configURIPath:h.workspace.configPath.toString(),remoteAuthority:h.remoteAuthority})),folderWorkspaceInfos:this.folders.map(h=>({folderUri:h.folderUri.toString(),remoteAuthority:h.remoteAuthority})),emptyWorkspaceInfos:this.emptyWindows}}getRandomEmptyWindowId(){return(Date.now()+Math.round(Math.random()*1e3)).toString()}getFolderHash(h){const l=h.folderUri;let n;return l.scheme===L.Schemas.file?n=y.isLinux?l.fsPath:l.fsPath.toLowerCase():n=l.toString().toLowerCase(),(0,b.createHash)("md5").update(n).digest("hex")}};p=de([ee(0,w.IEnvironmentMainService),ee(1,S.IConfigurationService),ee(2,m.ILogService)],p),e.BackupMainService=p}),define(J[241],Z([0,1,64,88]),function(z,e,b,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(R,L,D,y,f,v){const E=S=>v(S,void 0),P=b.createConnection({host:R,port:L},()=>{P.removeListener("error",E);const S=Buffer.alloc(16);for(let g=0;g<16;g++)S[g]=Math.round(Math.random()*256);const w=S.toString("base64"),u=[`GET ws://${/:/.test(R)?`[${R}]`:R}:${L}${D}?${y}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${w}`];P.write(u.join(`\r
`)+`\r
\r
`);const m=g=>{g.toString().indexOf(`\r
\r
`)>=0&&(P.off("data",m),v(void 0,new t.NodeSocket(P,f)))};P.on("data",m)});P.setNoDelay(!0),P.once("error",E)}}}),define(J[242],Z([0,1,207,8,19,18,2,12,17,39,105,6,206,239]),function(z,e,b,t,R,L,D,y,f,v,E,P,S,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let u=class extends D.Disposable{constructor(g,I,p){super();this.environmentService=I,this.logService=p,this.configure(g.getValue()),this._register(g.onDidChangeConfiguration(()=>this.configure(g.getValue()),this))}configure(g){this.proxyUrl=g.http&&g.http.proxy,this.strictSSL=!!(g.http&&g.http.proxyStrictSSL),this.authorization=g.http&&g.http.proxyAuthorization}async request(g,I){this.logService.trace("RequestService#request (node) - begin",g.url);const{proxyUrl:p,strictSSL:d}=this;let h;try{h=await(0,E.getResolvedShellEnv)(this.logService,this.environmentService.args,process.env)}catch(r){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("RequestService#request (node) resolving shell environment failed",r))}const l={...process.env,...h},n=g.agent?g.agent:await(0,S.getProxyAgent)(g.url||"",l,{proxyUrl:p,strictSSL:d});g.agent=n,g.strictSSL=d,this.authorization&&(g.headers={...g.headers||{},"Proxy-Authorization":this.authorization});try{const r=await this._request(g,I);return this.logService.trace("RequestService#request (node) - success",g.url),r}catch(r){throw this.logService.trace("RequestService#request (node) - error",g.url,r),r}}async getNodeRequest(g){return((0,b.parse)(g.url).protocol==="https:"?await new Promise((d,h)=>{z(["https"],d,h)}):await new Promise((d,h)=>{z(["http"],d,h)})).request}_request(g,I){return t.Promises.withAsyncBody(async(p,d)=>{const h=(0,b.parse)(g.url),l=g.getRawRequest?g.getRawRequest(g):await this.getNodeRequest(g),n={hostname:h.hostname,port:h.port?parseInt(h.port):h.protocol==="https:"?443:80,protocol:h.protocol,path:h.path,method:g.type||"GET",headers:g.headers,agent:g.agent,rejectUnauthorized:(0,y.isBoolean)(g.strictSSL)?g.strictSSL:!0};g.user&&g.password&&(n.auth=g.user+":"+g.password);const r=l(n,i=>{const s=(0,y.isNumber)(g.followRedirects)?g.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&s>0&&i.headers.location)this._request({...g,url:i.headers.location,followRedirects:s-1},I).then(p,d);else{let o=i;i.headers["content-encoding"]==="gzip"&&(o=i.pipe((0,w.createGunzip)())),p({res:i,stream:(0,R.streamToBufferReadableStream)(o)})}});r.on("error",d),g.timeout&&r.setTimeout(g.timeout),g.data&&typeof g.data=="string"&&r.write(g.data),r.end(),I.onCancellationRequested(()=>{r.abort(),d((0,L.canceled)())})})}async resolveProxy(g){}};u=de([ee(0,f.IConfigurationService),ee(1,v.INativeEnvironmentService),ee(2,P.ILogService)],u),e.RequestService=u}),define(J[243],Z([0,1,14,242]),function(z,e,b,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function R(D){return b.net.request}class L extends t.RequestService{request(y,f){return super.request({...y||{},getRawRequest:R},f)}}e.RequestMainService=L}),define(J[244],Z([0,1,14,38,8,3,2,11,12,96,26,21,6,57,58,61,41,40,37]),function(z,e,b,t,R,L,D,y,f,v,E,P,S,w,u,m,g,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let d=class extends D.Disposable{constructor(l,n,r,i,s,o,a,c,C){super();this.machineId=l,this.userEnv=n,this.environmentMainService=r,this.userDataProfilesService=i,this.lifecycleMainService=s,this.logService=o,this.policyService=a,this.themeMainService=c,this.protocolMainService=C,this.firstWindowConnectionBarrier=new R.Barrier,this.window=void 0,this.windowCloseListener=void 0,this._onDidError=this._register(new L.Emitter),this.onDidError=L.Event.buffer(this._onDidError.event),this._whenReady=void 0,this._whenIpcReady=void 0,this.registerListeners()}registerListeners(){t.validatedIpcMain.on("vscode:createSharedProcessMessageChannel",(l,n)=>this.onWindowConnection(l,n)),t.validatedIpcMain.on("vscode:relaySharedProcessWorkerMessageChannel",(l,n)=>this.onWorkerConnection(l,n)),this._register(this.lifecycleMainService.onWillShutdown(()=>this.onWillShutdown()))}async onWindowConnection(l,n){this.logService.trace("SharedProcess: on vscode:createSharedProcessMessageChannel"),this.firstWindowConnectionBarrier.isOpen()||this.firstWindowConnectionBarrier.open(),await this.whenReady();const r=await this.connect();if(l.sender.isDestroyed())return r.close();l.sender.postMessage("vscode:createSharedProcessMessageChannelResult",n,[r])}onWorkerConnection(l,n){this.logService.trace("SharedProcess: onWorkerConnection",n);const r=new D.DisposableStore,i=o=>{!this.isAlive()||(this.logService.trace(`SharedProcess: disposing worker (reason: '${o}')`,n),r.dispose(),this.send("vscode:electron-main->shared-process=disposeWorker",n))},s=b.BrowserWindow.fromId(n.reply.windowId);if(!s||s.isDestroyed()||s.webContents.isDestroyed()||!n.reply.channel){i("unavailable");return}r.add(L.Event.filter(this.lifecycleMainService.onWillLoadWindow,o=>o.window.win===s)(()=>i("load"))),r.add(L.Event.fromNodeEventEmitter(s,"closed")(()=>i("closed"))),s.webContents.postMessage(n.reply.channel,n.reply.nonce,l.ports)}onWillShutdown(){const l=this.window;!l||(this.send("vscode:electron-main->shared-process=exit"),this.windowCloseListener&&(l.removeListener("close",this.windowCloseListener),this.windowCloseListener=void 0),setTimeout(()=>{try{l.close()}catch{}this.window=void 0},0))}send(l,...n){if(!this.isAlive()){this.logService.warn(`Sending IPC message to channel '${l}' for shared process window that is destroyed`);return}try{this.window?.webContents.send(l,...n)}catch(r){this.logService.warn(`Error sending IPC message to channel '${l}' of shared process: ${(0,g.toErrorMessage)(r)}`)}}whenReady(){return this._whenReady||(this._whenReady=new Promise(l=>t.validatedIpcMain.once("vscode:shared-process->electron-main=init-done",()=>{this.logService.trace("SharedProcess: Overall ready"),l()}))),this._whenReady}get whenIpcReady(){return this._whenIpcReady||(this._whenIpcReady=(async()=>{await this.firstWindowConnectionBarrier.wait(),this.createWindow(),this.registerWindowListeners(),await new Promise(l=>t.validatedIpcMain.once("vscode:shared-process->electron-main=ipc-ready",()=>{this.logService.trace("SharedProcess: IPC ready"),l()}))})()),this._whenIpcReady}createWindow(){const l=this._register(this.protocolMainService.createIPCObjectUrl());this.window=new b.BrowserWindow({show:!1,backgroundColor:this.themeMainService.getBackgroundColor(),webPreferences:{preload:y.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",z).fsPath,additionalArguments:[`--vscode-window-config=${l.resource.toString()}`,"--vscode-window-kind=shared-process"],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",nodeIntegration:!0,nodeIntegrationInWorker:!0,contextIsolation:!1,enableWebSQL:!1,spellcheck:!1,images:!1,webgl:!1}}),l.update({machineId:this.machineId,windowId:this.window.id,appRoot:this.environmentMainService.appRoot,codeCachePath:this.environmentMainService.codeCachePath,backupWorkspacesPath:this.environmentMainService.backupWorkspacesPath,profiles:this.userDataProfilesService.profiles,userEnv:this.userEnv,args:this.environmentMainService.args,logLevel:this.logService.getLevel(),product:w.default,policiesData:this.policyService.serialize()}),this.window.loadURL(y.FileAccess.asBrowserUri("vs/code/electron-browser/sharedProcess/sharedProcess.html",z).toString(!0))}registerWindowListeners(){!this.window||(this.windowCloseListener=l=>{this.logService.trace("SharedProcess#close prevented"),l.preventDefault(),this.window?.isVisible()&&this.window.hide()},this.window.on("close",this.windowCloseListener),this.window.webContents.on("render-process-gone",(l,n)=>this._onDidError.fire({type:2,details:n})),this.window.on("unresponsive",()=>this._onDidError.fire({type:1})),this.window.webContents.on("did-fail-load",(l,n,r)=>this._onDidError.fire({type:3,details:{reason:r,exitCode:n}})))}async connect(){await this.whenIpcReady;const l=(0,f.assertIsDefined)(this.window);return(0,v.connect)(l)}async toggle(){await this.whenIpcReady,!!this.window&&(this.window.isVisible()?(this.window.webContents.closeDevTools(),this.window.hide()):(this.window.show(),this.window.webContents.openDevTools()))}isVisible(){return this.window?.isVisible()??!1}isAlive(){const l=this.window;return l?!l.isDestroyed()&&!l.webContents.isDestroyed():!1}};d=de([ee(2,E.IEnvironmentMainService),ee(3,I.IUserDataProfilesService),ee(4,P.ILifecycleMainService),ee(5,S.ILogService),ee(6,p.IPolicyService),ee(7,m.IThemeMainService),ee(8,u.IProtocolMainService)],d),e.SharedProcess=d}),define(J[245],Z([0,1,64,90,241,8,2,17,6,20,205,106,85]),function(z,e,b,t,R,L,D,y,f,v,E,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function w(p,d,h,l,n){let r;for(let i=3;i&&(r&&r.dispose(),r=await new u(p,d,h,l,n).waitForReady(),!(n&&t.BROWSER_RESTRICTED_PORTS[n]||!t.BROWSER_RESTRICTED_PORTS[r.tunnelLocalPort]));i--);return r}class u extends D.Disposable{constructor(d,h,l,n,r){super();this.defaultTunnelHost=h,this.suggestedLocalPort=r,this.privacy=P.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=d,this._server=b.createServer(),this._barrier=new L.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=i=>this._onConnection(i),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=n,this.tunnelRemoteHost=l}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(h=>{h()})}async waitForReady(){let d=await(0,t.findFreePortFaster)(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),h=null;return this._server.listen(d,this.defaultTunnelHost),await this._barrier.wait(),h=this._server.address(),h||(d=0,this._server.listen(d,this.defaultTunnelHost),await this._barrier.wait(),h=this._server.address()),this.tunnelLocalPort=h.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${h.port}`,this}async _onConnection(d){d.pause();const h=(0,P.isLocalhost)(this.tunnelRemoteHost)||(0,P.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,l=await(0,E.connectRemoteAgentTunnel)(this._options,h,this.tunnelRemotePort),n=l.getSocket().socket,r=l.readEntireBuffer();l.dispose(),r.byteLength>0&&d.write(r.buffer),d.on("end",()=>{d.localAddress&&this._socketsDispose.delete(d.localAddress),n.end()}),d.on("close",()=>n.end()),d.on("error",()=>{d.localAddress&&this._socketsDispose.delete(d.localAddress),n.destroy()}),n.on("end",()=>d.end()),n.on("close",()=>d.end()),n.on("error",()=>{d.destroy()}),d.pipe(n),n.pipe(d),d.localAddress&&this._socketsDispose.set(d.localAddress,()=>{d.end(),n.end()})}}let m=class extends P.AbstractTunnelService{constructor(d,h,l,n,r){super(h);this.socketFactory=d,this.signService=l,this.productService=n,this.configurationService=r}get defaultTunnelHost(){const d=this.configurationService.getValue("remote.localPortHost");return!d||d==="localhost"?"127.0.0.1":"0.0.0.0"}retainOrCreateTunnel(d,h,l,n,r,i,s){const o=this.getTunnelFromMap(h,l);if(o)return++o.refcount,o.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,h,l,n,r,i,s);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${h}:${l} on local port ${n}.`);const a={commit:this.productService.commit,quality:this.productService.quality,socketFactory:this.socketFactory,addressProvider:d,signService:this.signService,logService:this.logService,ipcLogger:null},c=w(a,this.defaultTunnelHost,h,l,n);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(h,l,c),c}}};m=de([ee(1,f.ILogService),ee(2,S.ISignService),ee(3,v.IProductService),ee(4,y.IConfigurationService)],m),e.BaseTunnelService=m;let g=class extends m{constructor(d,h,l,n){super(R.nodeSocketFactory,d,h,l,n)}};g=de([ee(0,f.ILogService),ee(1,S.ISignService),ee(2,v.IProductService),ee(3,y.IConfigurationService)],g),e.TunnelService=g;let I=class extends D.Disposable{constructor(d,h,l,n){super();this.logService=d,this.productService=h,this.signService=l,this.configurationService=n,this._tunnelServices=new Map}async openTunnel(d,h,l,n,r,i,s,o){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${l}:${n} on local port ${r}.`),!this._tunnelServices.has(d)){const a=new g(this.logService,this.signService,this.productService,this.configurationService);this._register(a),this._tunnelServices.set(d,a),a.onTunnelClosed(async()=>{(await a.tunnels).length===0&&(a.dispose(),this._tunnelServices.delete(d))})}return this._tunnelServices.get(d).openTunnel(h,l,n,r,i,s,o)}};I=de([ee(0,f.ILogService),ee(1,v.IProductService),ee(2,S.ISignService),ee(3,y.IConfigurationService)],I),e.SharedTunnelsService=I}),define(J[89],Z([0,1,8,22,3,17,26,21,6,20,60,46]),function(z,e,b,t,R,L,D,y,f,v,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function S(u,m,g){return`${g.updateUrl}/api/update/${u}/${m}/${g.commit}`}e.createUpdateURL=S;let w=class{constructor(m,g,I,p,d,h){this.lifecycleMainService=m,this.configurationService=g,this.environmentMainService=I,this.requestService=p,this.logService=d,this.productService=h,this._state=P.State.Uninitialized,this._onStateChange=new R.Emitter,this.onStateChange=this._onStateChange.event}get state(){return this._state}setState(m){this.logService.info("update#setState",m.type),this._state=m,this._onStateChange.fire(m)}initialize(){if(!this.environmentMainService.isBuilt)return;if(this.environmentMainService.disableUpdates){this.logService.info("update#ctor - updates are disabled by the environment");return}if(!this.productService.updateUrl||!this.productService.commit){this.logService.info("update#ctor - updates are disabled as there is no update URL");return}const m=this.getUpdateMode(),g=this.getProductQuality(m);if(!g){this.logService.info("update#ctor - updates are disabled by user preference");return}if(this.url=this.buildUpdateFeedUrl(g),!this.url){this.logService.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.setState(P.State.Idle(this.getUpdateType())),m==="manual"){this.logService.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}m==="start"?(this.logService.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.scheduleCheckForUpdates(30*1e3).then(void 0,I=>this.logService.error(I))}getUpdateMode(){return(0,L.getMigratedSettingValue)(this.configurationService,"update.mode","update.channel")}getProductQuality(m){return m==="none"?void 0:this.productService.quality}scheduleCheckForUpdates(m=60*60*1e3){return(0,b.timeout)(m).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(m){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(m)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}async doDownloadUpdate(m){}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}async doApplyUpdate(){}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(m=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${m}`),!m&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}async isLatestVersion(){return this.url?await this.getUpdateMode()==="none"?!1:(await this.requestService.request({url:this.url},t.CancellationToken.None)).res.statusCode===204:void 0}getUpdateType(){return 1}doQuitAndInstall(){}};w=de([ee(0,y.ILifecycleMainService),ee(1,L.IConfigurationService),ee(2,D.IEnvironmentMainService),ee(3,E.IRequestService),ee(4,f.ILogService),ee(5,v.IProductService)],w),e.AbstractUpdateService=w}),define(J[246],Z([0,1,14,51,3,2,17,26,21,6,20,60,35,46,89]),function(z,e,b,t,R,L,D,y,f,v,E,P,S,w,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let m=class extends u.AbstractUpdateService{constructor(I,p,d,h,l,n,r){super(I,p,h,l,n,r);this.telemetryService=d,this.disposables=new L.DisposableStore}get onRawError(){return R.Event.fromNodeEventEmitter(b.autoUpdater,"error",(I,p)=>p)}get onRawUpdateNotAvailable(){return R.Event.fromNodeEventEmitter(b.autoUpdater,"update-not-available")}get onRawUpdateAvailable(){return R.Event.fromNodeEventEmitter(b.autoUpdater,"update-available",(I,p,d)=>({url:p,version:d,productVersion:d}))}get onRawUpdateDownloaded(){return R.Event.fromNodeEventEmitter(b.autoUpdater,"update-downloaded",(I,p,d,h)=>({releaseNotes:p,version:d,productVersion:d,date:h}))}initialize(){super.initialize(),this.onRawError(this.onError,this,this.disposables),this.onRawUpdateAvailable(this.onUpdateAvailable,this,this.disposables),this.onRawUpdateDownloaded(this.onUpdateDownloaded,this,this.disposables),this.onRawUpdateNotAvailable(this.onUpdateNotAvailable,this,this.disposables)}onError(I){this.logService.error("UpdateService error:",I);const d=(this.state.type==="checking for updates"?this.state.explicit:!0)?I:void 0;this.setState(w.State.Idle(1,d))}buildUpdateFeedUrl(I){let p;this.productService.darwinUniversalAssetId?p=this.productService.darwinUniversalAssetId:p=process.arch==="x64"?"darwin":"darwin-arm64";const d=(0,u.createUpdateURL)(p,I,this.productService);try{b.autoUpdater.setFeedURL({url:d})}catch(h){this.logService.error("Failed to set update feed URL",h);return}return d}doCheckForUpdates(I){this.setState(w.State.CheckingForUpdates(I)),b.autoUpdater.checkForUpdates()}onUpdateAvailable(I){this.state.type==="checking for updates"&&this.setState(w.State.Downloading(I))}onUpdateDownloaded(I){this.state.type==="downloading"&&(this.telemetryService.publicLog2("update:downloaded",{version:I.version}),this.setState(w.State.Ready(I)))}onUpdateNotAvailable(){this.state.type==="checking for updates"&&(this.telemetryService.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.setState(w.State.Idle(1)))}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),b.autoUpdater.quitAndInstall()}dispose(){this.disposables.dispose()}};de([t.memoize],m.prototype,"onRawError",null),de([t.memoize],m.prototype,"onRawUpdateNotAvailable",null),de([t.memoize],m.prototype,"onRawUpdateAvailable",null),de([t.memoize],m.prototype,"onRawUpdateDownloaded",null),m=de([ee(0,f.ILifecycleMainService),ee(1,D.IConfigurationService),ee(2,S.ITelemetryService),ee(3,y.IEnvironmentMainService),ee(4,P.IRequestService),ee(5,v.ILogService),ee(6,E.IProductService)],m),e.DarwinUpdateService=m}),define(J[247],Z([0,1,42,28,8,3,9,26,21,6,35,46]),function(z,e,b,t,R,L,D,y,f,v,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let S=class{constructor(m,g,I){if(this.lifecycleMainService=m,this.logService=I,this._state=P.State.Uninitialized,this._onStateChange=new L.Emitter,this.onStateChange=this._onStateChange.event,g.disableUpdates){this.logService.info("update#ctor - updates are disabled");return}this.setState(P.State.Idle(this.getUpdateType())),this.scheduleCheckForUpdates(30*1e3).then(void 0,p=>this.logService.error(p))}get state(){return this._state}setState(m){this.logService.info("update#setState",m.type),this._state=m,this._onStateChange.fire(m)}scheduleCheckForUpdates(m=60*60*1e3){return(0,R.timeout)(m).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(m){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(m)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}doDownloadUpdate(m){return Promise.resolve(void 0)}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}doApplyUpdate(){return Promise.resolve(void 0)}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(m=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${m}`),!m&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}getUpdateType(){return 2}doQuitAndInstall(){}};S=de([ee(0,f.ILifecycleMainService),ee(1,y.IEnvironmentMainService),ee(2,v.ILogService)],S);let w=class extends S{constructor(m,g,I,p,d,h){super(I,p,d);this.snap=m,this.snapRevision=g,this.telemetryService=h;const l=(0,t.watch)(D.dirname(this.snap)),n=L.Event.fromNodeEventEmitter(l,"change",(o,a)=>a),r=L.Event.filter(n,o=>o==="current"),s=L.Event.debounce(r,(o,a)=>a,2e3)(()=>this.checkForUpdates(!1));I.onWillShutdown(()=>{s.dispose(),l.close()})}doCheckForUpdates(){this.setState(P.State.CheckingForUpdates(!1)),this.isUpdateAvailable().then(m=>{m?this.setState(P.State.Ready({version:"something",productVersion:"something"})):(this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(P.State.Idle(2)))},m=>{this.logService.error(m),this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(P.State.Idle(2,m.message||m))})}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,b.spawn)("sleep 3 && "+D.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async isUpdateAvailable(){const m=await new Promise((I,p)=>(0,t.realpath)(`${D.dirname(this.snap)}/current`,(d,h)=>d?p(d):I(h))),g=D.basename(m);return this.snapRevision!==g}isLatestVersion(){return this.isUpdateAvailable().then(void 0,m=>{this.logService.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};w=de([ee(2,f.ILifecycleMainService),ee(3,y.IEnvironmentMainService),ee(4,v.ILogService),ee(5,E.ITelemetryService)],w),e.SnapUpdateService=w}),define(J[47],Z([0,1,14,28,3,49,34,2,11,9,4,16,12,23,167,56,52,26,5,6,20,75,110,24,87,111]),function(z,e,b,t,R,L,D,y,f,v,E,P,S,w,u,m,g,I,p,d,h,l,n,r,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,p.createDecorator)("workspacesManagementMainService");let o=class extends y.Disposable{constructor(c,C,k,M,T,F){super();this.environmentMainService=c,this.logService=C,this.userDataProfilesMainService=k,this.backupMainService=M,this.dialogMainService=T,this.productService=F,this.untitledWorkspacesHome=this.environmentMainService.untitledWorkspacesHome,this._onDidDeleteUntitledWorkspace=this._register(new R.Emitter),this.onDidDeleteUntitledWorkspace=this._onDidDeleteUntitledWorkspace.event,this._onDidEnterWorkspace=this._register(new R.Emitter),this.onDidEnterWorkspace=this._onDidEnterWorkspace.event}resolveLocalWorkspaceSync(c){return this.doResolveLocalWorkspace(c,C=>(0,t.readFileSync)(C,"utf8"))}resolveLocalWorkspace(c){return this.doResolveLocalWorkspace(c,C=>w.Promises.readFile(C,"utf8"))}doResolveLocalWorkspace(c,C){if(!!this.isWorkspacePath(c)&&c.scheme===f.Schemas.file)try{const k=C(c.fsPath);return k instanceof Promise?k.then(M=>this.doResolveWorkspace(c,M),M=>{}):this.doResolveWorkspace(c,k)}catch{return}}isWorkspacePath(c){return(0,r.isUntitledWorkspace)(c,this.environmentMainService)||(0,r.hasWorkspaceFileExtension)(c)}doResolveWorkspace(c,C){try{const k=this.doParseStoredWorkspace(c,C),M=(0,s.getWorkspaceIdentifier)(c);return{id:M.id,configPath:M.configPath,folders:(0,i.toWorkspaceFolders)(k.folders,M.configPath,P.extUriBiasedIgnorePathCase),remoteAuthority:k.remoteAuthority,transient:k.transient}}catch(k){this.logService.warn(k.toString())}}doParseStoredWorkspace(c,C){const k=(0,L.parse)(C);if(k&&Array.isArray(k.folders))k.folders=k.folders.filter(M=>(0,i.isStoredWorkspaceFolder)(M));else throw new Error(`${c.toString(!0)} looks like an invalid workspace file.`);return k}async createUntitledWorkspace(c,C){const{workspace:k,storedWorkspace:M}=this.newUntitledWorkspace(c,C),T=k.configPath.fsPath;return await w.Promises.mkdir((0,v.dirname)(T),{recursive:!0}),await w.Promises.writeFile(T,JSON.stringify(M,null,"	")),k}createUntitledWorkspaceSync(c,C){const{workspace:k,storedWorkspace:M}=this.newUntitledWorkspace(c,C),T=k.configPath.fsPath;return(0,t.mkdirSync)((0,v.dirname)(T),{recursive:!0}),(0,w.writeFileSync)(T,JSON.stringify(M,null,"	")),k}newUntitledWorkspace(c=[],C){const k=(Date.now()+Math.round(Math.random()*1e3)).toString(),M=(0,P.joinPath)(this.untitledWorkspacesHome,k),T=(0,P.joinPath)(M,r.UNTITLED_WORKSPACE_NAME),F=[];for(const q of c)F.push((0,i.getStoredWorkspaceFolder)(q.uri,!0,q.name,M,!E.isWindows,P.extUriBiasedIgnorePathCase));return{workspace:(0,s.getWorkspaceIdentifier)(T),storedWorkspace:{folders:F,remoteAuthority:C}}}async getWorkspaceIdentifier(c){return(0,s.getWorkspaceIdentifier)(c)}isUntitledWorkspace(c){return(0,r.isUntitledWorkspace)(c.configPath,this.environmentMainService)}deleteUntitledWorkspaceSync(c){!this.isUntitledWorkspace(c)||(this.doDeleteUntitledWorkspaceSync(c),this.userDataProfilesMainService.unsetWorkspace(c),this._onDidDeleteUntitledWorkspace.fire(c))}async deleteUntitledWorkspace(c){this.deleteUntitledWorkspaceSync(c)}doDeleteUntitledWorkspaceSync(c){const C=(0,P.originalFSPath)(c.configPath);try{(0,w.rimrafSync)((0,v.dirname)(C));const k=(0,v.join)(this.environmentMainService.workspaceStorageHome.fsPath,c.id);(0,t.existsSync)(k)&&(0,w.writeFileSync)((0,v.join)(k,"obsolete"),"")}catch(k){this.logService.warn(`Unable to delete untitled workspace ${C} (${k}).`)}}getUntitledWorkspacesSync(){const c=[];try{const C=(0,w.readdirSync)(this.untitledWorkspacesHome.fsPath).map(k=>(0,P.joinPath)(this.untitledWorkspacesHome,k,r.UNTITLED_WORKSPACE_NAME));for(const k of C){const M=(0,s.getWorkspaceIdentifier)(k),T=this.resolveLocalWorkspaceSync(k);T?c.push({workspace:M,remoteAuthority:T.remoteAuthority}):this.doDeleteUntitledWorkspaceSync(M)}}catch(C){C.code!=="ENOENT"&&this.logService.warn(`Unable to read folders in ${this.untitledWorkspacesHome} (${C}).`)}return c}async enterWorkspace(c,C,k){if(!c||!c.win||!c.isReady||!await this.isValidTargetWorkspacePath(c,C,k))return;const T=this.doEnterWorkspace(c,(0,s.getWorkspaceIdentifier)(k));if(!!T)return this._onDidEnterWorkspace.fire({window:c,workspace:T.workspace}),T}async isValidTargetWorkspacePath(c,C,k){if(!k)return!0;if((0,r.isWorkspaceIdentifier)(c.openedWorkspace)&&P.extUriBiasedIgnorePathCase.isEqual(c.openedWorkspace.configPath,k))return!1;if((0,n.findWindowOnWorkspaceOrFolder)(C,k)){const M={title:this.productService.nameLong,type:"info",buttons:[(0,D.mnemonicButtonLabel)((0,u.localize)(0,null))],message:(0,u.localize)(1,null,(0,P.basename)(k)),detail:(0,u.localize)(2,null),noLink:!0,defaultId:0};return await this.dialogMainService.showMessageBox(M,(0,S.withNullAsUndefined)(b.BrowserWindow.getFocusedWindow())),!1}return!0}doEnterWorkspace(c,C){if(!c.config)return;c.focus();let k;return c.config.extensionDevelopmentPath||(k=this.backupMainService.registerWorkspaceBackupSync({workspace:C,remoteAuthority:c.remoteAuthority},c.config.backupPath)),(0,r.isWorkspaceIdentifier)(c.openedWorkspace)&&this.isUntitledWorkspace(c.openedWorkspace)&&this.deleteUntitledWorkspaceSync(c.openedWorkspace),c.config.workspace=C,c.config.backupPath=k,{workspace:C,backupPath:k}}};o=de([ee(0,I.IEnvironmentMainService),ee(1,d.ILogService),ee(2,l.IUserDataProfilesMainService),ee(3,m.IBackupMainService),ee(4,g.IDialogMainService),ee(5,h.IProductService)],o),e.WorkspacesManagementMainService=o}),define(J[112],Z([0,1,38,22,5,32,24,47]),function(z,e,b,t,R,L,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsMainService=e.IDiagnosticsMainService=e.ID=void 0,e.ID="diagnosticsMainService",e.IDiagnosticsMainService=(0,R.createDecorator)(e.ID);let f=class{constructor(E,P){this.windowsMainService=E,this.workspacesManagementMainService=P}async getRemoteDiagnostics(E){const P=this.windowsMainService.getWindows();return(await Promise.all(P.map(w=>new Promise(u=>{const m=w.remoteAuthority;if(m){const g=`vscode:getDiagnosticInfoResponse${w.id}`,I={includeProcesses:E.includeProcesses,folders:E.includeWorkspaceMetadata?this.getFolderURIs(w):void 0};w.sendWhenReady("vscode:getDiagnosticInfo",t.CancellationToken.None,{replyChannel:g,args:I}),b.validatedIpcMain.once(g,(p,d)=>{d||u({hostName:m,errorMessage:`Unable to resolve connection to '${m}'.`}),u(d)}),setTimeout(()=>{u({hostName:m,errorMessage:`Connection to '${m}' could not be established`})},5e3)}else u(void 0)})))).filter(w=>!!w)}getFolderURIs(E){const P=[],S=E.openedWorkspace;if((0,D.isSingleFolderWorkspaceIdentifier)(S))P.push(S.uri);else if((0,D.isWorkspaceIdentifier)(S)){const w=this.workspacesManagementMainService.resolveLocalWorkspaceSync(S.configPath);w&&w.folders.forEach(m=>{P.push(m.uri)})}return P}};f=de([ee(0,L.IWindowsMainService),ee(1,y.IWorkspacesManagementMainService)],f),e.DiagnosticsMainService=f}),define(J[113],Z([0,1,14,25,4,12,7,23,17,55,5,6,107,32,24,47]),function(z,e,b,t,R,L,D,y,f,v,E,P,S,w,u,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,E.createDecorator)(e.ID);let g=class{constructor(p,d,h,l,n){this.logService=p,this.windowsMainService=d,this.urlService=h,this.workspacesManagementMainService=l,this.configurationService=n}async start(p,d){this.logService.trace("Received data from other instance: ",p,d),R.isMacintosh&&b.app.focus({steal:!0});const h=this.parseOpenUrl(p);if(h.length){let l=Promise.resolve();this.windowsMainService.getWindowCount()===0&&(l=this.windowsMainService.openEmptyWindow({context:4})[0].ready()),l.then(()=>{for(const{uri:n,url:r}of h)this.urlService.open(n,{originalUrl:r})})}else return this.startOpenWindow(p,d)}parseOpenUrl(p){return p["open-url"]&&p._urls&&p._urls.length>0?(0,t.coalesce)(p._urls.map(d=>{try{return{uri:D.URI.parse(d),url:d}}catch{return null}})):[]}async startOpenWindow(p,d){const h=(0,v.isLaunchedFromCli)(d)?0:4;let l=[];const n=p.wait&&p.waitMarkerFilePath?D.URI.file(p.waitMarkerFilePath):void 0,r=p.remote||void 0,i={context:h,cli:p,userEnv:d,waitMarkerFileURI:n,remoteAuthority:r};if(p.extensionDevelopmentPath)this.windowsMainService.openExtensionDevelopmentHostWindow(p.extensionDevelopmentPath,i);else if(!p._.length&&!p["folder-uri"]&&!p["file-uri"]){let s=!1;if(p["new-window"]||p["unity-launch"])s=!0;else if(p["reuse-window"])s=!1;else switch(this.configurationService.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":s=!0;break;case"off":s=!1;break;default:s=!R.isMacintosh}if(s)l=this.windowsMainService.open({...i,forceNewWindow:!0,forceEmpty:!0});else{const o=this.windowsMainService.getLastActiveWindow();o?(this.windowsMainService.openExistingWindow(o,i),l=[o]):l=this.windowsMainService.open({...i,forceEmpty:!0})}}else l=this.windowsMainService.open({...i,forceNewWindow:p["new-window"],preferNewWindow:!p["reuse-window"]&&!p.wait,forceReuseWindow:p["reuse-window"],diffMode:p.diff,addMode:p.add,noRecentEntry:!!p["skip-add-to-recently-opened"],gotoLineMode:p.goto});if(n&&l.length===1&&l[0])return Promise.race([l[0].whenClosedOrLoaded,(0,y.whenDeleted)(n.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.logService.trace("Received request for process ID from other instance."),process.pid}async getMainProcessInfo(){this.logService.trace("Received request for main process info from other instance.");const p=[];return b.BrowserWindow.getAllWindows().forEach(d=>{const h=this.windowsMainService.getWindowById(d.id);h?p.push(this.codeWindowToInfo(h)):p.push(this.browserWindowToInfo(d))}),{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:p,screenReader:!!b.app.accessibilitySupportEnabled,gpuFeatureStatus:b.app.getGPUFeatureStatus()}}getFolderURIs(p){const d=[],h=p.openedWorkspace;if((0,u.isSingleFolderWorkspaceIdentifier)(h))d.push(h.uri);else if((0,u.isWorkspaceIdentifier)(h)){const l=this.workspacesManagementMainService.resolveLocalWorkspaceSync(h.configPath);l&&l.folders.forEach(r=>{d.push(r.uri)})}return d}codeWindowToInfo(p){const d=this.getFolderURIs(p),h=(0,L.assertIsDefined)(p.win);return this.browserWindowToInfo(h,d,p.remoteAuthority)}browserWindowToInfo(p,d=[],h){return{pid:p.webContents.getOSProcessId(),title:p.getTitle(),folderURIs:d,remoteAuthority:h}}};g=de([ee(0,P.ILogService),ee(1,w.IWindowsMainService),ee(2,S.IURLService),ee(3,m.IWorkspacesManagementMainService),ee(4,f.IConfigurationService)],g),e.LaunchMainService=g}),define(J[62],Z([0,1,42,14,27,136,51,3,34,2,11,9,4,7,93,80,23,90,157,52,26,5,21,6,20,61,32,24,47]),function(z,e,b,t,R,L,D,y,f,v,E,P,S,w,u,m,g,I,p,d,h,l,n,r,i,s,o,a,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,l.createDecorator)("nativeHostMainService");let C=class extends v.Disposable{constructor(M,T,F,q,te,ne,Q,se,ce){super();this.sharedProcess=M,this.windowsMainService=T,this.dialogMainService=F,this.lifecycleMainService=q,this.environmentMainService=te,this.logService=ne,this.productService=Q,this.themeMainService=se,this.workspacesManagementMainService=ce,this.onDidOpenWindow=y.Event.map(this.windowsMainService.onDidOpenWindow,H=>H.id),this.onDidMaximizeWindow=y.Event.filter(y.Event.fromNodeEventEmitter(t.app,"browser-window-maximize",(H,oe)=>oe.id),H=>!!this.windowsMainService.getWindowById(H)),this.onDidUnmaximizeWindow=y.Event.filter(y.Event.fromNodeEventEmitter(t.app,"browser-window-unmaximize",(H,oe)=>oe.id),H=>!!this.windowsMainService.getWindowById(H)),this.onDidBlurWindow=y.Event.filter(y.Event.fromNodeEventEmitter(t.app,"browser-window-blur",(H,oe)=>oe.id),H=>!!this.windowsMainService.getWindowById(H)),this.onDidFocusWindow=y.Event.any(y.Event.map(y.Event.filter(y.Event.map(this.windowsMainService.onDidChangeWindowsCount,()=>this.windowsMainService.getLastActiveWindow()),H=>!!H),H=>H.id),y.Event.filter(y.Event.fromNodeEventEmitter(t.app,"browser-window-focus",(H,oe)=>oe.id),H=>!!this.windowsMainService.getWindowById(H))),this.onDidResumeOS=y.Event.fromNodeEventEmitter(t.powerMonitor,"resume"),this.onDidChangeColorScheme=this.themeMainService.onDidChangeColorScheme,this._onDidChangePassword=this._register(new y.Emitter),this.onDidChangePassword=this._onDidChangePassword.event,this.onDidChangeDisplay=y.Event.debounce(y.Event.any(y.Event.filter(y.Event.fromNodeEventEmitter(t.screen,"display-metrics-changed",(H,oe,W)=>W),H=>!(Array.isArray(H)&&H.length===1&&H[0]==="workArea")),y.Event.fromNodeEventEmitter(t.screen,"display-added"),y.Event.fromNodeEventEmitter(t.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.windowsMainService.getWindows().map(T=>({id:T.id,workspace:T.openedWorkspace,title:T.win?.getTitle()??"",filename:T.getRepresentedFilename(),dirty:T.isDocumentEdited()}))}async getWindowCount(M){return this.windowsMainService.getWindowCount()}async getActiveWindowId(M){const T=t.BrowserWindow.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(T)return T.id}openWindow(M,T,F){return Array.isArray(T)?this.doOpenWindow(M,T,F):this.doOpenEmptyWindow(M,T)}async doOpenWindow(M,T,F=Object.create(null)){T.length>0&&this.windowsMainService.open({context:5,contextWindowId:M,urisToOpen:T,cli:this.environmentMainService.args,forceNewWindow:F.forceNewWindow,forceReuseWindow:F.forceReuseWindow,preferNewWindow:F.preferNewWindow,diffMode:F.diffMode,addMode:F.addMode,gotoLineMode:F.gotoLineMode,noRecentEntry:F.noRecentEntry,waitMarkerFileURI:F.waitMarkerFileURI,remoteAuthority:F.remoteAuthority||void 0})}async doOpenEmptyWindow(M,T){this.windowsMainService.openEmptyWindow({context:5,contextWindowId:M},T)}async toggleFullScreen(M){const T=this.windowById(M);T&&T.toggleFullScreen()}async handleTitleDoubleClick(M){const T=this.windowById(M);T&&T.handleTitleDoubleClick()}async isMaximized(M){const T=this.windowById(M);return T?.win?T.win.isMaximized():!1}async maximizeWindow(M){const T=this.windowById(M);T?.win&&T.win.maximize()}async unmaximizeWindow(M){const T=this.windowById(M);T?.win&&T.win.unmaximize()}async minimizeWindow(M){const T=this.windowById(M);T?.win&&T.win.minimize()}async updateTitleBarOverlay(M,T){const F=this.windowById(M);F?.win&&F.win.setTitleBarOverlay({color:T.backgroundColor,symbolColor:T.foregroundColor,height:T.height?T.height-1:void 0})}async focusWindow(M,T){T&&typeof T.windowId=="number"&&(M=T.windowId),this.windowById(M)?.focus({force:T?.force??!1})}async setMinimumSize(M,T,F){const q=this.windowById(M);if(q?.win){const[te,ne]=q.win.getSize(),[Q,se]=q.win.getMinimumSize(),[ce,H]=[T??Q,F??se],[oe,W]=[Math.max(te,ce),Math.max(ne,H)];(Q!==ce||se!==H)&&q.win.setMinimumSize(ce,H),(te!==oe||ne!==W)&&q.win.setSize(oe,W)}}async saveWindowSplash(M,T){this.themeMainService.saveWindowSplash(M,T)}async installShellCommand(M){const{source:T,target:F}=await this.getShellCommandLink();try{const{symbolicLink:q}=await g.SymlinkSupport.stat(T);if(q&&!q.dangling){const te=await(0,u.realpath)(T);if(F===te)return}await g.Promises.unlink(T)}catch(q){if(q.code!=="ENOENT")throw q}try{await g.Promises.symlink(F,T)}catch(q){if(q.code!=="EACCES"&&q.code!=="ENOENT")throw q;const{response:te}=await this.showMessageBox(M,{title:this.productService.nameLong,type:"info",message:(0,p.localize)(0,null,this.productService.nameShort),buttons:[(0,f.mnemonicButtonLabel)((0,p.localize)(1,null)),(0,f.mnemonicButtonLabel)((0,p.localize)(2,null))],noLink:!0,defaultId:0,cancelId:1});if(te===0)try{const ne=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${F}' '${T}'\\" with administrator privileges"`;await(0,L.promisify)(b.exec)(ne)}catch{throw new Error((0,p.localize)(3,null,T))}}}async uninstallShellCommand(M){const{source:T}=await this.getShellCommandLink();try{await g.Promises.unlink(T)}catch(F){switch(F.code){case"EACCES":{const{response:q}=await this.showMessageBox(M,{title:this.productService.nameLong,type:"info",message:(0,p.localize)(4,null,this.productService.nameShort),buttons:[(0,f.mnemonicButtonLabel)((0,p.localize)(5,null)),(0,f.mnemonicButtonLabel)((0,p.localize)(6,null))],noLink:!0,defaultId:0,cancelId:1});if(q===0)try{const te=`osascript -e "do shell script \\"rm '${T}'\\" with administrator privileges"`;await(0,L.promisify)(b.exec)(te)}catch{throw new Error((0,p.localize)(7,null,T))}break}case"ENOENT":break;default:throw F}}}async getShellCommandLink(){const M=(0,P.resolve)(this.environmentMainService.appRoot,"bin","code"),T=`/usr/local/bin/${this.productService.applicationName}`;if(!await g.Promises.exists(M))throw new Error((0,p.localize)(8,null,M));return{source:T,target:M}}async showMessageBox(M,T){return this.dialogMainService.showMessageBox(T,this.toBrowserWindow(M))}async showSaveDialog(M,T){return this.dialogMainService.showSaveDialog(T,this.toBrowserWindow(M))}async showOpenDialog(M,T){return this.dialogMainService.showOpenDialog(T,this.toBrowserWindow(M))}toBrowserWindow(M){const T=this.windowById(M);if(T?.win)return T.win}async pickFileFolderAndOpen(M,T){const F=await this.dialogMainService.pickFileFolder(T);F&&this.doOpenPicked(await Promise.all(F.map(async q=>await g.SymlinkSupport.existsDirectory(q)?{folderUri:w.URI.file(q)}:{fileUri:w.URI.file(q)})),T,M)}async pickFolderAndOpen(M,T){const F=await this.dialogMainService.pickFolder(T);F&&this.doOpenPicked(F.map(q=>({folderUri:w.URI.file(q)})),T,M)}async pickFileAndOpen(M,T){const F=await this.dialogMainService.pickFile(T);F&&this.doOpenPicked(F.map(q=>({fileUri:w.URI.file(q)})),T,M)}async pickWorkspaceAndOpen(M,T){const F=await this.dialogMainService.pickWorkspace(T);F&&this.doOpenPicked(F.map(q=>({workspaceUri:w.URI.file(q)})),T,M)}doOpenPicked(M,T,F){this.windowsMainService.open({context:3,contextWindowId:F,cli:this.environmentMainService.args,urisToOpen:M,forceNewWindow:T.forceNewWindow})}async showItemInFolder(M,T){t.shell.showItemInFolder(T)}async setRepresentedFilename(M,T){this.windowById(M)?.setRepresentedFilename(T)}async setDocumentEdited(M,T){this.windowById(M)?.setDocumentEdited(T)}async openExternal(M,T){return S.isLinuxSnap?this.safeSnapOpenExternal(T):t.shell.openExternal(T),!0}safeSnapOpenExternal(M){const T=process.env.GDK_PIXBUF_MODULE_FILE,F=process.env.GDK_PIXBUF_MODULEDIR;delete process.env.GDK_PIXBUF_MODULE_FILE,delete process.env.GDK_PIXBUF_MODULEDIR,t.shell.openExternal(M),process.env.GDK_PIXBUF_MODULE_FILE=T,process.env.GDK_PIXBUF_MODULEDIR=F}moveItemToTrash(M,T){return t.shell.trashItem(T)}async isAdmin(){let M;return S.isWindows?M=(await new Promise((T,F)=>{z(["native-is-elevated"],T,F)}))():M=process.getuid()===0,M}async writeElevated(M,T,F,q){const te=await new Promise((ne,Q)=>{z(["@vscode/sudo-prompt"],ne,Q)});return new Promise((ne,Q)=>{const se=[`"${this.cliPath}"`];q?.unlock&&se.push("--file-chmod"),se.push("--file-write",`"${T.fsPath}"`,`"${F.fsPath}"`);const ce={name:this.productService.nameLong.replace("-",""),icns:S.isMacintosh&&this.environmentMainService.isBuilt?(0,P.join)((0,P.dirname)(this.environmentMainService.appRoot),`${this.productService.nameShort}.icns`):void 0};te.exec(se.join(" "),ce,(H,oe,W)=>{oe&&this.logService.trace(`[sudo-prompt] received stdout: ${oe}`),W&&this.logService.trace(`[sudo-prompt] received stderr: ${W}`),H?Q(H):ne(void 0)})})}get cliPath(){return S.isWindows?this.environmentMainService.isBuilt?(0,P.join)((0,P.dirname)(process.execPath),"bin",`${this.productService.applicationName}.cmd`):(0,P.join)(this.environmentMainService.appRoot,"scripts","code-cli.bat"):S.isLinux?this.environmentMainService.isBuilt?(0,P.join)((0,P.dirname)(process.execPath),"bin",`${this.productService.applicationName}`):(0,P.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh"):this.environmentMainService.isBuilt?(0,P.join)(this.environmentMainService.appRoot,"bin","code"):(0,P.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,R.totalmem)(),freemem:(0,R.freemem)(),loadavg:(0,R.loadavg)()}}async getOSProperties(){return{arch:(0,R.arch)(),platform:(0,R.platform)(),release:(0,R.release)(),type:(0,R.type)(),cpus:(0,R.cpus)()}}async getOSVirtualMachineHint(){return m.virtualMachineHint.value()}async getOSColorScheme(){return this.themeMainService.getColorScheme()}async killProcess(M,T,F){process.kill(T,F)}async readClipboardText(M,T){return t.clipboard.readText(T)}async writeClipboardText(M,T,F){return t.clipboard.writeText(T,F)}async readClipboardFindText(M){return t.clipboard.readFindText()}async writeClipboardFindText(M,T){return t.clipboard.writeFindText(T)}async writeClipboardBuffer(M,T,F,q){return t.clipboard.writeBuffer(T,Buffer.from(F),q)}async readClipboardBuffer(M,T){return t.clipboard.readBuffer(T)}async hasClipboard(M,T,F){return t.clipboard.has(T,F)}async newWindowTab(){this.windowsMainService.open({context:5,cli:this.environmentMainService.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.environmentMainService.args.remote||void 0})}async showPreviousWindowTab(){t.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){t.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){t.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){t.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){t.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(M,T){this.windowById(M)?.updateTouchBar(T)}async notifyReady(M){const T=this.windowById(M);T&&T.setReady()}async relaunch(M,T){return this.lifecycleMainService.relaunch(T)}async reload(M,T){const F=this.windowById(M);if(F){if((0,a.isWorkspaceIdentifier)(F.openedWorkspace)){const q=F.openedWorkspace.configPath;if(q.scheme===E.Schemas.file&&(await this.workspacesManagementMainService.resolveLocalWorkspace(q))?.transient)return this.openWindow(F.id,{forceReuseWindow:!0})}return this.lifecycleMainService.reload(F,T?.disableExtensions!==void 0?{_:[],"disable-extensions":T.disableExtensions}:void 0)}}async closeWindow(M){this.closeWindowById(M,M)}async closeWindowById(M,T){const F=this.windowById(T);if(F?.win)return F.win.close()}async quit(M){const T=this.windowsMainService.getLastActiveWindow();T?.isExtensionDevelopmentHost&&this.windowsMainService.getWindowCount()>1&&T.win?T.win.close():this.lifecycleMainService.quit()}async exit(M,T){await this.lifecycleMainService.kill(T)}async resolveProxy(M,T){const q=this.windowById(M)?.win?.webContents?.session;if(q)return q.resolveProxy(T)}findFreePort(M,T,F,q,te=1){return(0,I.findFreePort)(T,F,q,te)}async openDevTools(M,T){const F=this.windowById(M);F?.win&&F.win.webContents.openDevTools(T)}async toggleDevTools(M){const T=this.windowById(M);T?.win&&T.win.webContents.toggleDevTools()}async sendInputEvent(M,T){const F=this.windowById(M);F?.win&&(T.type==="mouseDown"||T.type==="mouseUp")&&F.win.webContents.sendInputEvent(T)}async toggleSharedProcessWindow(){return this.sharedProcess.toggle()}async windowsGetStringRegKey(M,T,F,q){if(!S.isWindows)return;const te=await new Promise((ne,Q)=>{z(["@vscode/windows-registry"],ne,Q)});try{return te.GetStringRegKey(T,F,q)}catch{return}}windowById(M){if(typeof M=="number")return this.windowsMainService.getWindowById(M)}};de([D.memoize],C.prototype,"cliPath",null),C=de([ee(1,o.IWindowsMainService),ee(2,d.IDialogMainService),ee(3,n.ILifecycleMainService),ee(4,h.IEnvironmentMainService),ee(5,r.ILogService),ee(6,i.IProductService),ee(7,s.IThemeMainService),ee(8,c.IWorkspacesManagementMainService)],C),e.NativeHostMainService=C}),define(J[248],Z([0,1,14,38,27,34,2,11,4,94,155,82,112,52,26,5,113,6,62,57,20,58,74]),function(z,e,b,t,R,L,D,y,f,v,E,P,S,w,u,m,g,I,p,d,h,l,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=e.IIssueMainService=void 0,e.IIssueMainService=(0,m.createDecorator)("issueMainService");let r=class Lt{constructor(s,o,a,c,C,k,M,T,F,q){this.userEnv=s,this.environmentMainService=o,this.launchMainService=a,this.logService=c,this.diagnosticsService=C,this.diagnosticsMainService=k,this.dialogMainService=M,this.nativeHostMainService=T,this.protocolMainService=F,this.productService=q,this.issueReporterWindow=null,this.issueReporterParentWindow=null,this.processExplorerWindow=null,this.processExplorerParentWindow=null,this.registerListeners()}registerListeners(){t.validatedIpcMain.on("vscode:issueSystemInfoRequest",async s=>{const[o,a]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]),c=await this.diagnosticsService.getSystemInfo(o,a);this.safeSend(s,"vscode:issueSystemInfoResponse",c)}),t.validatedIpcMain.on("vscode:listProcesses",async s=>{const o=[];try{const a=await this.launchMainService.getMainProcessId();o.push({name:(0,E.localize)(0,null),rootProcess:await(0,v.listProcesses)(a)}),(await this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!0})).forEach(C=>{(0,P.isRemoteDiagnosticError)(C)?o.push({name:C.hostName,rootProcess:C}):C.processes&&o.push({name:C.hostName,rootProcess:C.processes})})}catch(a){this.logService.error(`Listing processes failed: ${a}`)}this.safeSend(s,"vscode:listProcessesResponse",o)}),t.validatedIpcMain.on("vscode:issueReporterClipboard",async s=>{const o={title:this.productService.nameLong,message:(0,E.localize)(1,null),type:"warning",buttons:[(0,L.mnemonicButtonLabel)((0,E.localize)(2,null)),(0,L.mnemonicButtonLabel)((0,E.localize)(3,null))],defaultId:0,cancelId:1,noLink:!0};if(this.issueReporterWindow){const a=await this.dialogMainService.showMessageBox(o,this.issueReporterWindow);this.safeSend(s,"vscode:issueReporterClipboardResponse",a.response===0)}}),t.validatedIpcMain.on("vscode:issuePerformanceInfoRequest",async s=>{const o=await this.getPerformanceInfo();this.safeSend(s,"vscode:issuePerformanceInfoResponse",o)}),t.validatedIpcMain.on("vscode:issueReporterConfirmClose",async()=>{const s={title:this.productService.nameLong,message:(0,E.localize)(4,null),type:"warning",buttons:[(0,L.mnemonicButtonLabel)((0,E.localize)(5,null)),(0,L.mnemonicButtonLabel)((0,E.localize)(6,null))],defaultId:0,cancelId:1,noLink:!0};this.issueReporterWindow&&(await this.dialogMainService.showMessageBox(s,this.issueReporterWindow)).response===0&&this.issueReporterWindow&&(this.issueReporterWindow.destroy(),this.issueReporterWindow=null)}),t.validatedIpcMain.on("vscode:workbenchCommand",(s,o)=>{const{id:a,from:c,args:C}=o;let k;switch(c){case"issueReporter":k=this.issueReporterParentWindow;break;case"processExplorer":k=this.processExplorerParentWindow;break;default:throw new Error(`Unexpected command source: ${c}`)}k?.webContents.send("vscode:runAction",{id:a,from:c,args:C})}),t.validatedIpcMain.on("vscode:openExternal",(s,o)=>{this.nativeHostMainService.openExternal(void 0,o)}),t.validatedIpcMain.on("vscode:closeIssueReporter",s=>{this.issueReporterWindow&&this.issueReporterWindow.close()}),t.validatedIpcMain.on("vscode:closeProcessExplorer",s=>{this.processExplorerWindow&&this.processExplorerWindow.close()}),t.validatedIpcMain.on("vscode:windowsInfoRequest",async s=>{const o=await this.launchMainService.getMainProcessInfo();this.safeSend(s,"vscode:windowsInfoResponse",o.windows)})}safeSend(s,o,...a){s.sender.isDestroyed()||s.sender.send(o,...a)}async openReporter(s){if(!this.issueReporterWindow&&(this.issueReporterParentWindow=b.BrowserWindow.getFocusedWindow(),this.issueReporterParentWindow)){const o=new D.DisposableStore,a=o.add(this.protocolMainService.createIPCObjectUrl()),c=this.getWindowPosition(this.issueReporterParentWindow,700,800);this.issueReporterWindow=this.createBrowserWindow(c,a,{backgroundColor:s.styles.backgroundColor,title:(0,E.localize)(7,null),zoomLevel:s.zoomLevel,alwaysOnTop:!1},"issue-reporter"),a.update({appRoot:this.environmentMainService.appRoot,windowId:this.issueReporterWindow.id,userEnv:this.userEnv,data:s,disableExtensions:!!this.environmentMainService.disableExtensions,os:{type:(0,R.type)(),arch:(0,R.arch)(),release:(0,R.release)()},product:d.default}),this.issueReporterWindow.loadURL(y.FileAccess.asBrowserUri("vs/code/electron-sandbox/issue/issueReporter.html",z).toString(!0)),this.issueReporterWindow.on("close",()=>{this.issueReporterWindow=null,o.dispose()}),this.issueReporterParentWindow.on("closed",()=>{this.issueReporterWindow&&(this.issueReporterWindow.close(),this.issueReporterWindow=null,o.dispose())})}this.issueReporterWindow&&this.focusWindow(this.issueReporterWindow)}async openProcessExplorer(s){if(!this.processExplorerWindow&&(this.processExplorerParentWindow=b.BrowserWindow.getFocusedWindow(),this.processExplorerParentWindow)){const o=new D.DisposableStore,a=o.add(this.protocolMainService.createIPCObjectUrl()),c=this.getWindowPosition(this.processExplorerParentWindow,800,500);this.processExplorerWindow=this.createBrowserWindow(c,a,{backgroundColor:s.styles.backgroundColor,title:(0,E.localize)(8,null),zoomLevel:s.zoomLevel,alwaysOnTop:!0},"process-explorer"),a.update({appRoot:this.environmentMainService.appRoot,windowId:this.processExplorerWindow.id,userEnv:this.userEnv,data:s,product:d.default}),this.processExplorerWindow.loadURL(y.FileAccess.asBrowserUri("vs/code/electron-sandbox/processExplorer/processExplorer.html",z).toString(!0)),this.processExplorerWindow.on("close",()=>{this.processExplorerWindow=null,o.dispose()}),this.processExplorerParentWindow.on("close",()=>{this.processExplorerWindow&&(this.processExplorerWindow.close(),this.processExplorerWindow=null,o.dispose())})}this.processExplorerWindow&&this.focusWindow(this.processExplorerWindow)}focusWindow(s){s.isMinimized()&&s.restore(),s.focus()}createBrowserWindow(s,o,a,c){const C=new b.BrowserWindow({fullscreen:!1,skipTaskbar:!0,resizable:!0,width:s.width,height:s.height,minWidth:300,minHeight:200,x:s.x,y:s.y,title:a.title,backgroundColor:a.backgroundColor||Lt.DEFAULT_BACKGROUND_COLOR,webPreferences:{preload:y.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",z).fsPath,additionalArguments:[`--vscode-window-config=${o.resource.toString()}`,`--vscode-window-kind=${c}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,n.zoomLevelToZoomFactor)(a.zoomLevel),sandbox:!0,contextIsolation:!0},alwaysOnTop:a.alwaysOnTop,experimentalDarkMode:!0});return C.setMenuBarVisibility(!1),C}async getSystemStatus(){const[s,o]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.diagnosticsService.getDiagnostics(s,o)}getWindowPosition(s,o,a){let c;const C=b.screen.getAllDisplays();if(C.length===1)c=C[0];else{if(f.isMacintosh){const T=b.screen.getCursorScreenPoint();c=b.screen.getDisplayNearestPoint(T)}!c&&s&&(c=b.screen.getDisplayMatching(s.getBounds())),c||(c=b.screen.getPrimaryDisplay()||C[0])}const k={width:o,height:a},M=c.bounds;return k.x=M.x+M.width/2-k.width/2,k.y=M.y+M.height/2-k.height/2,M.width>0&&M.height>0&&(k.x<M.x&&(k.x=M.x),k.y<M.y&&(k.y=M.y),k.x>M.x+M.width&&(k.x=M.x),k.y>M.y+M.height&&(k.y=M.y),k.width>M.width&&(k.width=M.width),k.height>M.height&&(k.height=M.height)),k}async getPerformanceInfo(){try{const[s,o]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.diagnosticsService.getPerformanceInfo(s,o)}catch(s){throw this.logService.warn("issueService#getPerformanceInfo ",s.message),s}}};r.DEFAULT_BACKGROUND_COLOR="#1E1E1E",r=de([ee(1,u.IEnvironmentMainService),ee(2,g.ILaunchMainService),ee(3,I.ILogService),ee(4,P.IDiagnosticsService),ee(5,S.IDiagnosticsMainService),ee(6,w.IDialogMainService),ee(7,p.INativeHostMainService),ee(8,l.IProtocolMainService),ee(9,h.IProductService)],r),e.IssueMainService=r}),define(J[249],Z([0,1,22,17,26,21,6,62,20,60,35,46,89]),function(z,e,b,t,R,L,D,y,f,v,E,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let w=class extends S.AbstractUpdateService{constructor(m,g,I,p,d,h,l,n){super(m,g,p,d,h,n);this.telemetryService=I,this.nativeHostMainService=l}buildUpdateFeedUrl(m){return(0,S.createUpdateURL)(`linux-${process.arch}`,m,this.productService)}doCheckForUpdates(m){!this.url||(this.setState(P.State.CheckingForUpdates(m)),this.requestService.request({url:this.url},b.CancellationToken.None).then(v.asJson).then(g=>{!g||!g.url||!g.version||!g.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!m}),this.setState(P.State.Idle(1))):this.setState(P.State.AvailableForDownload(g))}).then(void 0,g=>{this.logService.error(g),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!m});const I=m?g.message||g:void 0;this.setState(P.State.Idle(1,I))}))}async doDownloadUpdate(m){this.productService.downloadUrl&&this.productService.downloadUrl.length>0?this.nativeHostMainService.openExternal(void 0,this.productService.downloadUrl):m.update.url&&this.nativeHostMainService.openExternal(void 0,m.update.url),this.setState(P.State.Idle(1))}};w=de([ee(0,L.ILifecycleMainService),ee(1,t.IConfigurationService),ee(2,E.ITelemetryService),ee(3,R.IEnvironmentMainService),ee(4,v.IRequestService),ee(5,D.ILogService),ee(6,y.INativeHostMainService),ee(7,f.IProductService)],w),e.LinuxUpdateService=w}),define(J[250],Z([0,1,42,28,27,8,22,51,9,7,122,23,17,26,15,21,6,62,20,60,35,46,89]),function(z,e,b,t,R,L,D,y,f,v,E,P,S,w,u,m,g,I,p,d,h,l,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function r(a,c=1e3){for(;!a();)await(0,L.timeout)(c)}let i;function s(){return typeof i=="undefined"&&(i=t.existsSync(f.join(f.dirname(process.execPath),"unins000.exe"))?0:1),i}let o=class extends n.AbstractUpdateService{constructor(c,C,k,M,T,F,q,te,ne){super(c,C,M,T,F,ne);this.telemetryService=k,this.fileService=q,this.nativeHostMainService=te}get cachePath(){const c=f.join((0,R.tmpdir)(),`vscode-update-${this.productService.target}-${process.arch}`);return P.Promises.mkdir(c,{recursive:!0}).then(()=>c)}buildUpdateFeedUrl(c){let C="win32";return process.arch!=="ia32"&&(C+=`-${process.arch}`),s()===1?C+="-archive":this.productService.target==="user"&&(C+="-user"),(0,n.createUpdateURL)(C,c,this.productService)}doCheckForUpdates(c){!this.url||(this.setState(l.State.CheckingForUpdates(c)),this.requestService.request({url:this.url},D.CancellationToken.None).then(d.asJson).then(C=>{const k=s();return!C||!C.url||!C.version||!C.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!c}),this.setState(l.State.Idle(k)),Promise.resolve(null)):k===1?(this.setState(l.State.AvailableForDownload(C)),Promise.resolve(null)):(this.setState(l.State.Downloading(C)),this.cleanup(C.version).then(()=>this.getUpdatePackagePath(C.version).then(M=>P.Promises.exists(M).then(T=>{if(T)return Promise.resolve(M);const F=C.url,q=C.hash,te=`${M}.tmp`;return this.requestService.request({url:F},D.CancellationToken.None).then(ne=>this.fileService.writeFile(v.URI.file(te),ne.stream)).then(q?()=>(0,E.checksum)(te,C.hash):()=>{}).then(()=>P.Promises.rename(te,M)).then(()=>M)})).then(M=>{const T=this.configurationService.getValue("update.enableWindowsBackgroundUpdates");this.availableUpdate={packagePath:M},T&&C.supportsFastUpdate?this.productService.target==="user"?this.doApplyUpdate():this.setState(l.State.Downloaded(C)):this.setState(l.State.Ready(C))})))}).then(void 0,C=>{this.logService.error(C),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!c});const k=c?C.message||C:void 0;this.setState(l.State.Idle(s(),k))}))}async doDownloadUpdate(c){c.update.url&&this.nativeHostMainService.openExternal(void 0,c.update.url),this.setState(l.State.Idle(s()))}async getUpdatePackagePath(c){const C=await this.cachePath;return f.join(C,`CodeSetup-${this.productService.quality}-${c}.exe`)}async cleanup(c=null){const C=c?F=>!new RegExp(`${this.productService.quality}-${c}\\.exe$`).test(F):()=>!0,k=await this.cachePath,T=(await P.Promises.readdir(k)).filter(C).map(async F=>{try{await P.Promises.unlink(f.join(k,F))}catch{}});await Promise.all(T)}async doApplyUpdate(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.availableUpdate)return Promise.resolve(void 0);const c=this.state.update;this.setState(l.State.Updating(c));const C=await this.cachePath;this.availableUpdate.updateFilePath=f.join(C,`CodeSetup-${this.productService.quality}-${c.version}.flag`),await P.Promises.writeFile(this.availableUpdate.updateFilePath,"flag"),(0,b.spawn)(this.availableUpdate.packagePath,["/verysilent",`/update="${this.availableUpdate.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.availableUpdate=void 0,this.setState(l.State.Idle(s()))});const M=`${this.productService.win32MutexName}-ready`,T=await new Promise((F,q)=>{z(["windows-mutex"],F,q)});r(()=>T.isActive(M)).then(()=>this.setState(l.State.Ready(c)))}doQuitAndInstall(){this.state.type!=="ready"||!this.availableUpdate||(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.state.update.supportsFastUpdate&&this.availableUpdate.updateFilePath?t.unlinkSync(this.availableUpdate.updateFilePath):(0,b.spawn)(this.availableUpdate.packagePath,["/silent","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}getUpdateType(){return s()}};de([y.memoize],o.prototype,"cachePath",null),o=de([ee(0,m.ILifecycleMainService),ee(1,S.IConfigurationService),ee(2,h.ITelemetryService),ee(3,w.IEnvironmentMainService),ee(4,d.IRequestService),ee(5,g.ILogService),ee(6,u.IFileService),ee(7,I.INativeHostMainService),ee(8,p.IProductService)],o),e.Win32UpdateService=o}),define(J[251],Z([0,1,14,8,22,41,3,34,2,11,9,70,4,7,163,56,17,52,26,55,15,21,6,20,58,216,86,35,219,61,74,32,24,47,109,116,37,40,66]),function(z,e,b,t,R,L,D,y,f,v,E,P,S,w,u,m,g,I,p,d,h,l,n,r,i,s,o,a,c,C,k,M,T,F,q,te,ne,Q,se){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var ce;(function(oe){oe[oe.NONE=0]="NONE",oe[oe.NAVIGATING=1]="NAVIGATING",oe[oe.READY=2]="READY"})(ce||(ce={}));let H=class extends f.Disposable{constructor(W,U,B,X,j,Y,x,A,O,N,V,_,$,G,ie,ae,me,fe){super();this.logService=U,this.environmentMainService=B,this.policyService=X,this.userDataProfilesService=j,this.fileService=Y,this.applicationStorageMainService=x,this.storageMainService=A,this.configurationService=O,this.themeMainService=N,this.workspacesManagementMainService=V,this.backupMainService=_,this.telemetryService=$,this.dialogMainService=G,this.lifecycleMainService=ie,this.productService=ae,this.protocolMainService=me,this.windowsMainService=fe,this._onWillLoad=this._register(new D.Emitter),this.onWillLoad=this._onWillLoad.event,this._onDidSignalReady=this._register(new D.Emitter),this.onDidSignalReady=this._onDidSignalReady.event,this._onDidClose=this._register(new D.Emitter),this.onDidClose=this._onDidClose.event,this._onDidDestroy=this._register(new D.Emitter),this.onDidDestroy=this._onDidDestroy.event,this._lastFocusTime=-1,this.whenReadyCallbacks=[],this.touchBarGroups=[],this.currentHttpProxy=void 0,this.currentNoProxy=void 0,this.configObjectUrl=this._register(this.protocolMainService.createIPCObjectUrl()),this.wasLoaded=!1,this.readyState=0;{const[Pe,Ee]=this.restoreWindowState(W.state);this.windowState=Pe,this.logService.trace("window#ctor: using window state",Pe);const ke=this.windowState.mode===0||this.windowState.mode===3,Oe=this.configurationService.getValue("window"),Ue={width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y,backgroundColor:this.themeMainService.getBackgroundColor(),minWidth:k.WindowMinimumSize.WIDTH,minHeight:k.WindowMinimumSize.HEIGHT,show:!ke,title:this.productService.nameLong,webPreferences:{preload:v.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",z).fsPath,additionalArguments:[`--vscode-window-config=${this.configObjectUrl.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,k.zoomLevelToZoomFactor)(Oe?.zoomLevel),enableBlinkFeatures:"HighlightAPI",...this.environmentMainService.sandbox?{sandbox:!0}:{nodeIntegration:!0,contextIsolation:!1}},experimentalDarkMode:!0};S.isLinux?Ue.icon=(0,E.join)(this.environmentMainService.appRoot,"resources/linux/code.png"):S.isWindows&&!this.environmentMainService.isBuilt&&(Ue.icon=(0,E.join)(this.environmentMainService.appRoot,"resources/win32/code_150x150.png")),S.isMacintosh&&!this.useNativeFullScreen()&&(Ue.fullscreenable=!1),S.isMacintosh&&(Ue.acceptFirstMouse=!0,Oe?.clickThroughInactive===!1&&(Ue.acceptFirstMouse=!1));const le=S.isMacintosh&&Oe?.nativeTabs===!0;le&&(Ue.tabbingIdentifier=this.productService.nameShort);const he=(0,k.getTitleBarStyle)(this.configurationService)==="custom";if(he&&(Ue.titleBarStyle="hidden",this.hiddenTitleBarStyle=!0,S.isMacintosh||(Ue.frame=!1),(0,k.useWindowControlsOverlay)(this.configurationService,this.environmentMainService))){const pe=this.themeMainService.getWindowSplash()?.colorInfo.titleBarBackground??this.themeMainService.getBackgroundColor(),Ie=te.Color.fromHex(pe).isDarker()?"#FFFFFF":"#000000";Ue.titleBarOverlay={height:29,color:pe,symbolColor:Ie}}if((0,P.mark)("code/willCreateCodeBrowserWindow"),this._win=new b.BrowserWindow(Ue),(0,P.mark)("code/didCreateCodeBrowserWindow"),this._id=this._win.id,he&&S.isMacintosh){const pe="window.commandCenter",Ie=()=>{};Ie(),this.configurationService.onDidChangeConfiguration(De=>{De.affectsConfiguration(pe)&&Ie()},void 0,this._store)}if(this.environmentMainService.args["open-devtools"]===!0&&this._win.webContents.openDevTools(),S.isMacintosh&&he&&this._win.setSheetOffset(22),S.isMacintosh&&Ee&&(!le||b.BrowserWindow.getAllWindows().length===1)&&[this.windowState.width,this.windowState.height,this.windowState.x,this.windowState.y].every(pe=>typeof pe=="number")){const pe=this.windowState;this._win.setBounds({width:pe.width,height:pe.height,x:pe.x,y:pe.y})}ke&&((0,P.mark)("code/willMaximizeCodeWindow"),this._win.maximize(),this.windowState.mode===3&&this.setFullScreen(!0),this._win.show(),(0,P.mark)("code/didMaximizeCodeWindow")),this._lastFocusTime=Date.now()}this.onConfigurationUpdated(),this.createTouchBar(),this.registerListeners()}get id(){return this._id}get win(){return this._win}get lastFocusTime(){return this._lastFocusTime}get backupPath(){return this._config?.backupPath}get openedWorkspace(){return this._config?.workspace}get profile(){return this._profile||(this._profile=(0,se.revive)(this._config?.profiles.current)),this._profile}get remoteAuthority(){return this._config?.remoteAuthority}get config(){return this._config}get hasHiddenTitleBarStyle(){return!!this.hiddenTitleBarStyle}get isExtensionDevelopmentHost(){return!!this._config?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this._config?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this._config?.debugId}setRepresentedFilename(W){S.isMacintosh?this._win.setRepresentedFilename(W):this.representedFilename=W}getRepresentedFilename(){return S.isMacintosh?this._win.getRepresentedFilename():this.representedFilename}setDocumentEdited(W){S.isMacintosh&&this._win.setDocumentEdited(W),this.documentEdited=W}isDocumentEdited(){return S.isMacintosh?this._win.isDocumentEdited():!!this.documentEdited}focus(W){S.isMacintosh&&W?.force&&b.app.focus({steal:!0}),!!this._win&&(this._win.isMinimized()&&this._win.restore(),this._win.focus())}setReady(){for(this.logService.trace(`window#load: window reported ready (id: ${this._id})`),this.readyState=2;this.whenReadyCallbacks.length;)this.whenReadyCallbacks.pop()(this);this._onDidSignalReady.fire()}ready(){return new Promise(W=>{if(this.isReady)return W(this);this.whenReadyCallbacks.push(W)})}get isReady(){return this.readyState===2}get whenClosedOrLoaded(){return new Promise(W=>{function U(){B.dispose(),X.dispose(),W()}const B=this.onDidClose(()=>U()),X=this.onWillLoad(()=>U())})}registerListeners(){this._win.on("unresponsive",()=>this.onWindowError(1)),this._win.webContents.on("render-process-gone",(U,B)=>this.onWindowError(2,B)),this._win.webContents.on("did-fail-load",(U,B,X)=>this.onWindowError(3,{reason:X,exitCode:B})),this._win.webContents.on("will-prevent-unload",U=>{U.preventDefault()}),this._win.on("closed",()=>{this._onDidClose.fire(),this.dispose()}),this._win.webContents.on("did-finish-load",()=>{this.pendingLoadConfig&&(this._config=this.pendingLoadConfig,this.pendingLoadConfig=void 0)}),this._win.on("focus",()=>{this._lastFocusTime=Date.now()}),this._win.on("maximize",U=>{this._config&&(this._config.maximized=!0),b.app.emit("browser-window-maximize",U,this._win)}),this._win.on("unmaximize",U=>{this._config&&(this._config.maximized=!1),b.app.emit("browser-window-unmaximize",U,this._win)}),this._win.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",R.CancellationToken.None)}),this._win.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",R.CancellationToken.None)}),this._register(this.configurationService.onDidChangeConfiguration(()=>this.onConfigurationUpdated())),this._register(this.workspacesManagementMainService.onDidDeleteUntitledWorkspace(U=>this.onDidDeleteUntitledWorkspace(U)));const W=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this._win.webContents.session.webRequest.onBeforeSendHeaders({urls:W},async(U,B)=>{const X=await this.getMarketplaceHeaders();B({cancel:!1,requestHeaders:Object.assign(U.requestHeaders,X)})})}getMarketplaceHeaders(){return this.marketplaceHeadersPromise||(this.marketplaceHeadersPromise=(0,s.resolveMarketplaceHeaders)(this.productService.version,this.productService,this.environmentMainService,this.configurationService,this.fileService,this.applicationStorageMainService,this.telemetryService)),this.marketplaceHeadersPromise}async onWindowError(W,U){switch(W){case 2:this.logService.error(`CodeWindow: renderer process crashed (reason: ${U?.reason||"<unknown>"}, code: ${U?.exitCode||"<unknown>"})`);break;case 1:this.logService.error("CodeWindow: detected unresponsive");break;case 3:this.logService.error(`CodeWindow: failed to load (reason: ${U?.reason||"<unknown>"}, code: ${U?.exitCode||"<unknown>"})`);break}switch(this.telemetryService.publicLog2("windowerror",{type:W,reason:U?.reason,code:U?.exitCode}),W){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.lifecycleMainService.kill(1);return}if(this.environmentMainService.args["enable-smoke-test-driver"]){this.destroyWindow(!1,!1);return}if(W===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this._win&&this._win.webContents&&this._win.webContents.isDevToolsOpened())return;const B=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,y.mnemonicButtonLabel)((0,u.localize)(0,null)),(0,y.mnemonicButtonLabel)((0,u.localize)(1,null)),(0,y.mnemonicButtonLabel)((0,u.localize)(2,null))],message:(0,u.localize)(3,null),detail:(0,u.localize)(4,null),noLink:!0,defaultId:0,cancelId:1,checkboxLabel:this._config?.workspace?(0,u.localize)(5,null):void 0},this._win);if(B.response!==1){const X=B.response===0;this.destroyWindow(X,B.checkboxChecked)}}else if(W===2){let B;U?B=(0,u.localize)(7,null,U.reason,U.exitCode??"<unknown>"):B=(0,u.localize)(6,null);const X=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,y.mnemonicButtonLabel)((0,u.localize)(8,null)),(0,y.mnemonicButtonLabel)((0,u.localize)(9,null))],message:B,detail:(0,u.localize)(10,null),noLink:!0,defaultId:0,checkboxLabel:this._config?.workspace?(0,u.localize)(11,null):void 0},this._win),j=X.response===0;this.destroyWindow(j,X.checkboxChecked)}break}}async destroyWindow(W,U){const B=this._config?.workspace;if(U&&B)try{const X=this.storageMainService.workspaceStorage(B);await X.init(),X.delete("memento/workbench.parts.editor"),await X.close()}catch(X){this.logService.error(X)}if(this._onDidDestroy.fire(),this._win?.destroy(),W&&this._config){let X,j;(0,T.isSingleFolderWorkspaceIdentifier)(B)?X={folderUri:B.uri}:(0,T.isWorkspaceIdentifier)(B)?X={workspaceUri:B.configPath}:j=!0;const[Y]=this.windowsMainService.open({context:5,userEnv:this._config.userEnv,cli:{...this.environmentMainService.args,_:[]},urisToOpen:X?[X]:void 0,forceEmpty:j,forceNewWindow:!0,remoteAuthority:this.remoteAuthority});Y.focus()}}onDidDeleteUntitledWorkspace(W){this._config?.workspace?.id===W.id&&this._config&&(this._config.workspace=void 0)}onConfigurationUpdated(){const W=this.getMenuBarVisibility();W!==this.currentMenuBarVisibility&&(this.currentMenuBarVisibility=W,this.setMenuBarVisibility(W));let U=(this.configurationService.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;U?.endsWith("/")&&(U=U.substr(0,U.length-1));const B=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((U||"").indexOf("@")===-1&&(U!==this.currentHttpProxy||B!==this.currentNoProxy)){this.currentHttpProxy=U,this.currentNoProxy=B;const X=U||"",j=B?`${B},<local>`:"<local>";this.logService.trace(`Setting proxy to '${X}', bypassing '${j}'`),this._win.webContents.session.setProxy({proxyRules:X,proxyBypassRules:j,pacScript:""})}}addTabbedWindow(W){S.isMacintosh&&W.win&&this._win.addTabbedWindow(W.win)}load(W,U=Object.create(null)){this.logService.trace(`window#load: attempt to load window (id: ${this._id})`),this.isDocumentEdited()&&(!U.isReload||!this.backupMainService.isHotExitEnabled())&&this.setDocumentEdited(!1),U.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this._win.setTitle(this.productService.nameLong)),this.updateConfiguration(W,U),this.readyState===0?this._config=W:this.pendingLoadConfig=W,this.readyState=1,this._win.loadURL(v.FileAccess.asBrowserUri(this.environmentMainService.sandbox?"vs/code/electron-sandbox/workbench/workbench.html":"vs/code/electron-browser/workbench/workbench.html",z).toString(!0));const B=this.wasLoaded;this.wasLoaded=!0,!this.environmentMainService.isBuilt&&!this.environmentMainService.extensionTestsLocationURI&&this._register(new t.RunOnceScheduler(()=>{this._win&&!this._win.isVisible()&&!this._win.isMinimized()&&(this._win.show(),this.focus({force:!0}),this._win.webContents.openDevTools())},1e4)).schedule(),this._onWillLoad.fire({workspace:W.workspace,reason:U.isReload?3:B?2:1})}updateConfiguration(W,U){const B=(this._config??this.pendingLoadConfig)?.userEnv;if(B){const X=(0,d.isLaunchedFromCli)(B)&&!(0,d.isLaunchedFromCli)(W.userEnv),j=this.isExtensionDevelopmentHost;(X||j)&&(W.userEnv={...B,...W.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(W.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),U.disableExtensions!==void 0&&(W["disable-extensions"]=U.disableExtensions),W.fullscreen=this.isFullScreen,W.maximized=this._win.isMaximized(),W.partsSplash=this.themeMainService.getWindowSplash(),(0,P.mark)("code/willOpenNewWindow"),W.perfMarks=(0,P.getMarks)(),this.configObjectUrl.update(W)}async reload(W){const U=Object.assign({},this._config);U.workspace=await this.validateWorkspaceBeforeReload(U),delete U.filesToOpenOrCreate,delete U.filesToDiff,delete U.filesToWait,this.isExtensionDevelopmentHost&&W&&(U.verbose=W.verbose,U.debugId=W.debugId,U.extensionEnvironment=W.extensionEnvironment,U["inspect-extensions"]=W["inspect-extensions"],U["inspect-brk-extensions"]=W["inspect-brk-extensions"],U["extensions-dir"]=W["extensions-dir"]),U.isInitialStartup=!1,U.policiesData=this.policyService.serialize(),U.editSessionId=this.environmentMainService.editSessionId,U.profiles={all:this.userDataProfilesService.profiles,current:this.userDataProfilesService.getProfile(U.workspace??"empty-window")},this.load(U,{isReload:!0,disableExtensions:W?.["disable-extensions"]})}async validateWorkspaceBeforeReload(W){if((0,T.isWorkspaceIdentifier)(W.workspace)){const U=W.workspace.configPath;if(U.scheme===v.Schemas.file&&!await this.fileService.exists(U))return}else if((0,T.isSingleFolderWorkspaceIdentifier)(W.workspace)){const U=W.workspace.uri;if(U.scheme===v.Schemas.file&&!await this.fileService.exists(U))return}return W.workspace}serializeWindowState(){if(!this._win)return(0,q.defaultWindowState)();if(this.isFullScreen){let B;try{B=b.screen.getDisplayMatching(this.getBounds())}catch{}const X=(0,q.defaultWindowState)();return{mode:3,display:B?B.id:void 0,width:this.windowState.width||X.width,height:this.windowState.height||X.height,x:this.windowState.x||0,y:this.windowState.y||0}}const W=Object.create(null);let U;if(!S.isMacintosh&&this._win.isMaximized()?U=0:U=1,U===0?W.mode=0:W.mode=1,U===1||U===0){let B;U===1?B=this.getBounds():B=this._win.getNormalBounds(),W.x=B.x,W.y=B.y,W.width=B.width,W.height=B.height}return W}restoreWindowState(W){(0,P.mark)("code/willRestoreCodeWindowState");let U=!1;if(W)try{const B=b.screen.getAllDisplays();U=B.length>1,W=this.validateWindowState(W,B)}catch(B){this.logService.warn(`Unexpected error validating window state: ${B}
${B.stack}`)}return(0,P.mark)("code/didRestoreCodeWindowState"),[W||(0,q.defaultWindowState)(),U]}validateWindowState(W,U){if(this.logService.trace(`window#validateWindowState: validating window state on ${U.length} display(s)`,W),typeof W.x!="number"||typeof W.y!="number"||typeof W.width!="number"||typeof W.height!="number"){this.logService.trace("window#validateWindowState: unexpected type of state values");return}if(W.width<=0||W.height<=0){this.logService.trace("window#validateWindowState: unexpected negative values");return}if(U.length===1){const j=this.getWorkingArea(U[0]);if(j){let Y=function(){!W||typeof W.x!="number"||typeof W.y!="number"||!j||(W.x<j.x&&(W.x=j.x),W.y<j.y&&(W.y=j.y))};this.logService.trace("window#validateWindowState: 1 monitor working area",j),Y(),W.width>j.width&&(W.width=j.width),W.height>j.height&&(W.height=j.height),W.x>j.x+j.width-128&&(W.x=j.x+j.width-W.width),W.y>j.y+j.height-128&&(W.y=j.y+j.height-W.height),Y()}return W}if(W.display&&W.mode===3){const j=U.find(Y=>Y.id===W.display);if(j&&typeof j.bounds?.x=="number"&&typeof j.bounds?.y=="number"){this.logService.trace("window#validateWindowState: restoring fullscreen to previous display");const Y=(0,q.defaultWindowState)(3);return Y.x=j.bounds.x,Y.y=j.bounds.y,Y}}let B,X;try{B=b.screen.getDisplayMatching({x:W.x,y:W.y,width:W.width,height:W.height}),X=this.getWorkingArea(B)}catch{}if(B&&X&&W.x+W.width>X.x&&W.y+W.height>X.y&&W.x<X.x+X.width&&W.y<X.y+X.height)return this.logService.trace("window#validateWindowState: multi-monitor working area",X),W}getWorkingArea(W){if(W.workArea.width>0&&W.workArea.height>0)return W.workArea;if(W.bounds.width>0&&W.bounds.height>0)return W.bounds}getBounds(){const[W,U]=this._win.getPosition(),[B,X]=this._win.getSize();return{x:W,y:U,width:B,height:X}}toggleFullScreen(){this.setFullScreen(!this.isFullScreen)}setFullScreen(W){this.useNativeFullScreen()?this.setNativeFullScreen(W):this.setSimpleFullScreen(W),this.sendWhenReady(W?"vscode:enterFullScreen":"vscode:leaveFullScreen",R.CancellationToken.None),this.currentMenuBarVisibility&&this.setMenuBarVisibility(this.currentMenuBarVisibility,!1)}get isFullScreen(){return this._win.isFullScreen()||this._win.isSimpleFullScreen()}setNativeFullScreen(W){this._win.isSimpleFullScreen()&&this._win.setSimpleFullScreen(!1),this._win.setFullScreen(W)}setSimpleFullScreen(W){this._win.isFullScreen()&&this._win.setFullScreen(!1),this._win.setSimpleFullScreen(W),this._win.webContents.focus()}useNativeFullScreen(){const W=this.configurationService.getValue("window");return!W||typeof W.nativeFullScreen!="boolean"||W.nativeTabs?!0:W.nativeFullScreen!==!1}isMinimized(){return this._win.isMinimized()}getMenuBarVisibility(){let W=(0,k.getMenuBarVisibility)(this.configurationService);return["visible","toggle","hidden"].indexOf(W)<0&&(W="classic"),W}setMenuBarVisibility(W,U=!0){S.isMacintosh||(W==="toggle"&&U&&this.send("vscode:showInfoMessage",(0,u.localize)(12,null)),W==="hidden"?setTimeout(()=>{this.doSetMenuBarVisibility(W)}):this.doSetMenuBarVisibility(W))}doSetMenuBarVisibility(W){const U=this.isFullScreen;switch(W){case"classic":this._win.setMenuBarVisibility(!U),this._win.autoHideMenuBar=U;break;case"visible":this._win.setMenuBarVisibility(!0),this._win.autoHideMenuBar=!1;break;case"toggle":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!0;break;case"hidden":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(S.isMacintosh)switch(b.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this._win.minimize();break;case"None":break;case"Maximize":default:this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}else this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}close(){this._win&&this._win.close()}sendWhenReady(W,U,...B){this.isReady?this.send(W,...B):this.ready().then(()=>{U.isCancellationRequested||this.send(W,...B)})}send(W,...U){if(this._win){if(this._win.isDestroyed()||this._win.webContents.isDestroyed()){this.logService.warn(`Sending IPC message to channel '${W}' for window that is destroyed`);return}try{this._win.webContents.send(W,...U)}catch(B){this.logService.warn(`Error sending IPC message to channel '${W}' of window ${this._id}: ${(0,L.toErrorMessage)(B)}`)}}}updateTouchBar(W){!S.isMacintosh||this.touchBarGroups.forEach((U,B)=>{const X=W[B];U.segments=this.createTouchBarGroupSegments(X)})}createTouchBar(){if(!!S.isMacintosh){for(let W=0;W<10;W++){const U=this.createTouchBarGroup();this.touchBarGroups.push(U)}this._win.setTouchBar(new b.TouchBar({items:this.touchBarGroups}))}}createTouchBarGroup(W=[]){const U=this.createTouchBarGroupSegments(W),B=new b.TouchBar.TouchBarSegmentedControl({segments:U,mode:"buttons",segmentStyle:"automatic",change:X=>{this.sendWhenReady("vscode:runAction",R.CancellationToken.None,{id:B.segments[X].id,from:"touchbar"})}});return B}createTouchBarGroupSegments(W=[]){return W.map(B=>{let X;B.icon&&!c.ThemeIcon.isThemeIcon(B.icon)&&B.icon?.dark?.scheme===v.Schemas.file&&(X=b.nativeImage.createFromPath(w.URI.revive(B.icon.dark).fsPath),X.isEmpty()&&(X=void 0));let j;return typeof B.title=="string"?j=B.title:j=B.title.value,{id:B.id,label:X?void 0:j,icon:X}})}dispose(){super.dispose(),this._win=null}};H=de([ee(1,n.ILogService),ee(2,p.IEnvironmentMainService),ee(3,ne.IPolicyService),ee(4,Q.IUserDataProfilesService),ee(5,h.IFileService),ee(6,o.IApplicationStorageMainService),ee(7,o.IStorageMainService),ee(8,g.IConfigurationService),ee(9,C.IThemeMainService),ee(10,F.IWorkspacesManagementMainService),ee(11,m.IBackupMainService),ee(12,a.ITelemetryService),ee(13,I.IDialogMainService),ee(14,l.ILifecycleMainService),ee(15,r.IProductService),ee(16,i.IProtocolMainService),ee(17,M.IWindowsMainService)],H),e.CodeWindow=H}),define(J[76],Z([0,1,14,25,8,3,34,2,11,4,16,7,23,166,5,21,6,86,87,24,47]),function(z,e,b,t,R,L,D,y,f,v,E,P,S,w,u,m,g,I,p,d,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,u.createDecorator)("workspacesHistoryMainService");let l=class tt extends y.Disposable{constructor(r,i,s,o){super();this.logService=r,this.workspacesManagementMainService=i,this.lifecycleMainService=s,this.applicationStorageMainService=o,this._onDidChangeRecentlyOpened=this._register(new L.Emitter),this.onDidChangeRecentlyOpened=this._onDidChangeRecentlyOpened.event,this.macOSRecentDocumentsUpdater=this._register(new R.ThrottledDelayer(800)),this.registerListeners()}registerListeners(){this.lifecycleMainService.when(3).then(()=>this.handleWindowsJumpList()),this._register(this.workspacesManagementMainService.onDidEnterWorkspace(r=>this.addRecentlyOpened([{workspace:r.workspace,remoteAuthority:r.window.remoteAuthority}])))}async addRecentlyOpened(r){const i=[],s=[];for(const o of r)if((0,p.isRecentWorkspace)(o))!this.workspacesManagementMainService.isUntitledWorkspace(o.workspace)&&this.indexOfWorkspace(i,o.workspace)===-1&&i.push(o);else if((0,p.isRecentFolder)(o))this.indexOfFolder(i,o.folderUri)===-1&&i.push(o);else{const a=this.indexOfFile(s,o.fileUri)>=0,c=o.fileUri.scheme===f.Schemas.file&&tt.COMMON_FILES_FILTER.indexOf((0,E.basename)(o.fileUri))>=0;!a&&!c&&(s.push(o),v.isWindows&&o.fileUri.scheme===f.Schemas.file&&b.app.addRecentDocument(o.fileUri.fsPath))}await this.addEntriesFromStorage(i,s),i.length>tt.MAX_TOTAL_RECENT_ENTRIES&&(i.length=tt.MAX_TOTAL_RECENT_ENTRIES),s.length>tt.MAX_TOTAL_RECENT_ENTRIES&&(s.length=tt.MAX_TOTAL_RECENT_ENTRIES),await this.saveRecentlyOpened({workspaces:i,files:s}),this._onDidChangeRecentlyOpened.fire(),v.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments())}async removeRecentlyOpened(r){const i=c=>{const C=this.location(c);for(const k of r)if(E.extUriBiasedIgnorePathCase.isEqual(k,C))return!1;return!0},s=await this.getRecentlyOpened(),o=s.workspaces.filter(i),a=s.files.filter(i);(o.length!==s.workspaces.length||a.length!==s.files.length)&&(await this.saveRecentlyOpened({files:a,workspaces:o}),this._onDidChangeRecentlyOpened.fire(),v.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments()))}async clearRecentlyOpened(){await this.saveRecentlyOpened({workspaces:[],files:[]}),b.app.clearRecentDocuments(),this._onDidChangeRecentlyOpened.fire()}async getRecentlyOpened(r){const i=[],s=[];if(r){const a=r.config?.workspace;(0,d.isWorkspaceIdentifier)(a)&&!this.workspacesManagementMainService.isUntitledWorkspace(a)?i.push({workspace:a,remoteAuthority:r.remoteAuthority}):(0,d.isSingleFolderWorkspaceIdentifier)(a)&&i.push({folderUri:a.uri,remoteAuthority:r.remoteAuthority})}const o=r?.config?.filesToOpenOrCreate;if(o)for(const a of o){const c=a.fileUri;c&&this.indexOfFile(s,c)===-1&&s.push({fileUri:c})}return await this.addEntriesFromStorage(i,s),{workspaces:i,files:s}}async addEntriesFromStorage(r,i){const s=await this.getRecentlyOpenedFromStorage();for(const o of s.workspaces){const a=(0,p.isRecentFolder)(o)?this.indexOfFolder(r,o.folderUri):this.indexOfWorkspace(r,o.workspace);a>=0?r[a].label=r[a].label||o.label:r.push(o)}for(const o of s.files){const a=this.indexOfFile(i,o.fileUri);a>=0?i[a].label=i[a].label||o.label:i.push(o)}}async getRecentlyOpenedFromStorage(){await this.applicationStorageMainService.whenReady;let r;const i=this.applicationStorageMainService.get(tt.RECENTLY_OPENED_STORAGE_KEY,-1);if(typeof i=="string")try{r=JSON.parse(i)}catch(s){this.logService.error("Unexpected error parsing opened paths list",s)}return(0,p.restoreRecentlyOpened)(r,this.logService)}async saveRecentlyOpened(r){await this.applicationStorageMainService.whenReady,this.applicationStorageMainService.store(tt.RECENTLY_OPENED_STORAGE_KEY,JSON.stringify((0,p.toStoreData)(r)),-1,1)}location(r){return(0,p.isRecentFolder)(r)?r.folderUri:(0,p.isRecentFile)(r)?r.fileUri:r.workspace.configPath}indexOfWorkspace(r,i){return r.findIndex(s=>(0,p.isRecentWorkspace)(s)&&s.workspace.id===i.id)}indexOfFolder(r,i){return r.findIndex(s=>(0,p.isRecentFolder)(s)&&E.extUriBiasedIgnorePathCase.isEqual(s.folderUri,i))}indexOfFile(r,i){return r.findIndex(s=>E.extUriBiasedIgnorePathCase.isEqual(s.fileUri,i))}async handleWindowsJumpList(){!v.isWindows||(await this.updateWindowsJumpList(),this._register(this.onDidChangeRecentlyOpened(()=>this.updateWindowsJumpList())))}async updateWindowsJumpList(){if(!v.isWindows)return;const r=[];if(r.push({type:"tasks",items:[{type:"task",title:(0,w.localize)(0,null),description:(0,w.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const i=[];for(const a of b.app.getJumpListSettings().removedItems){const c=a.args;if(c){const C=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(c);C&&i.push(P.URI.parse(C[2]))}}await this.removeRecentlyOpened(i);let s=!1;const o=(0,t.coalesce)((await this.getRecentlyOpened()).workspaces.slice(0,tt.MAX_WINDOWS_JUMP_LIST_ENTRIES).map(a=>{const c=(0,p.isRecentWorkspace)(a)?a.workspace:a.folderUri,{title:C,description:k}=this.getWindowsJumpListLabel(c,a.label);let M;return P.URI.isUri(c)?M=`--folder-uri "${c.toString()}"`:(s=!0,M=`--file-uri "${c.configPath.toString()}"`),{type:"task",title:C.substr(0,255),description:k.substr(0,255),program:process.execPath,args:M,iconPath:"explorer.exe",iconIndex:0}}));o.length>0&&r.push({type:"custom",name:s?(0,w.localize)(2,null):(0,w.localize)(3,null),items:o})}r.push({type:"recent"});try{b.app.setJumpList(r)}catch(i){this.logService.warn("updateWindowsJumpList#setJumpList",i)}}getWindowsJumpListLabel(r,i){if(i)return{title:(0,D.splitName)(i).name,description:i};if(P.URI.isUri(r))return{title:(0,E.basename)(r),description:this.renderJumpListPathDescription(r)};if(this.workspacesManagementMainService.isUntitledWorkspace(r))return{title:(0,w.localize)(4,null),description:""};let s=(0,E.basename)(r.configPath);return s.endsWith(d.WORKSPACE_EXTENSION)&&(s=s.substr(0,s.length-d.WORKSPACE_EXTENSION.length-1)),{title:(0,w.localize)(5,null,s),description:this.renderJumpListPathDescription(r.configPath)}}renderJumpListPathDescription(r){return r.scheme==="file"?(0,D.normalizeDriveLetter)(r.fsPath):r.toString()}async updateMacOSRecentDocuments(){if(!v.isMacintosh)return;b.app.clearRecentDocuments();const r=await this.getRecentlyOpened(),i=[];let s=0;for(let a=0;a<r.workspaces.length&&s<tt.MAX_MACOS_DOCK_RECENT_WORKSPACES;a++){const c=this.location(r.workspaces[a]);if(c.scheme===f.Schemas.file){const C=(0,E.originalFSPath)(c);await S.Promises.exists(C)&&(i.push(C),s++)}}const o=[];for(let a=0;a<r.files.length&&s<tt.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL;a++){const c=this.location(r.files[a]);if(c.scheme===f.Schemas.file){const C=(0,E.originalFSPath)(c);if(tt.COMMON_FILES_FILTER.includes((0,E.basename)(c))||i.includes(C))continue;await S.Promises.exists(C)&&(o.push(C),s++)}}o.reverse().forEach(a=>b.app.addRecentDocument(a)),i.reverse().forEach(a=>b.app.addRecentDocument(a))}};l.MAX_TOTAL_RECENT_ENTRIES=500,l.RECENTLY_OPENED_STORAGE_KEY="history.recentlyOpenedPathsList",l.MAX_MACOS_DOCK_RECENT_WORKSPACES=7,l.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL=10,l.MAX_WINDOWS_JUMP_LIST_ENTRIES=7,l.COMMON_FILES_FILTER=["COMMIT_EDITMSG","MERGE_MSG"],l=de([ee(0,g.ILogService),ee(1,h.IWorkspacesManagementMainService),ee(2,m.ILifecycleMainService),ee(3,I.IApplicationStorageMainService)],l),e.WorkspacesHistoryMainService=l}),define(J[252],Z([0,1,14,8,22,34,4,7,156,17,26,21,6,197,62,20,45,35,46,74,32,76]),function(z,e,b,t,R,L,D,y,f,v,E,P,S,w,u,m,g,I,p,d,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const n="menu";let r=class Dt{constructor(o,a,c,C,k,M,T,F,q,te,ne){this.updateService=o,this.configurationService=a,this.windowsMainService=c,this.environmentMainService=C,this.telemetryService=k,this.workspacesHistoryMainService=M,this.stateMainService=T,this.lifecycleMainService=F,this.logService=q,this.nativeHostMainService=te,this.productService=ne,this.fallbackMenuHandlers=Object.create(null),this.menuUpdater=new t.RunOnceScheduler(()=>this.doUpdateMenu(),0),this.menuGC=new t.RunOnceScheduler(()=>{this.oldMenus=[]},1e4),this.menubarMenus=Object.create(null),this.keybindings=Object.create(null),(D.isMacintosh||(0,d.getTitleBarStyle)(this.configurationService)==="native")&&this.restoreCachedMenubarData(),this.addFallbackHandlers(),this.closedLastWindow=!1,this.noActiveWindow=!1,this.oldMenus=[],this.install(),this.registerListeners()}restoreCachedMenubarData(){const o=this.stateMainService.getItem(Dt.lastKnownMenubarStorageKey);o&&(o.menus&&(this.menubarMenus=o.menus),o.keybindings&&(this.keybindings=o.keybindings))}addFallbackHandlers(){this.fallbackMenuHandlers["workbench.action.files.newUntitledFile"]=(M,T,F)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:T?.id}),this.fallbackMenuHandlers["workbench.action.newWindow"]=(M,T,F)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:T?.id}),this.fallbackMenuHandlers["workbench.action.files.openFileFolder"]=(M,T,F)=>this.nativeHostMainService.pickFileFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(F),telemetryExtraData:{from:n}}),this.fallbackMenuHandlers["workbench.action.files.openFolder"]=(M,T,F)=>this.nativeHostMainService.pickFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(F),telemetryExtraData:{from:n}}),this.fallbackMenuHandlers["workbench.action.openWorkspace"]=(M,T,F)=>this.nativeHostMainService.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.isOptionClick(F),telemetryExtraData:{from:n}}),this.fallbackMenuHandlers["workbench.action.clearRecentFiles"]=()=>this.workspacesHistoryMainService.clearRecentlyOpened();const o=this.productService.twitterUrl;o&&(this.fallbackMenuHandlers["workbench.action.openTwitterUrl"]=()=>this.openUrl(o,"openTwitterUrl"));const a=this.productService.requestFeatureUrl;a&&(this.fallbackMenuHandlers["workbench.action.openRequestFeatureUrl"]=()=>this.openUrl(a,"openUserVoiceUrl"));const c=this.productService.reportIssueUrl;c&&(this.fallbackMenuHandlers["workbench.action.openIssueReporter"]=()=>this.openUrl(c,"openReportIssues"));const C=this.productService.licenseUrl;C&&(this.fallbackMenuHandlers["workbench.action.openLicenseUrl"]=()=>{if(D.language){const M=C.indexOf("?")>0?"&":"?";this.openUrl(`${C}${M}lang=${D.language}`,"openLicenseUrl")}else this.openUrl(C,"openLicenseUrl")});const k=this.productService.privacyStatementUrl;k&&C&&(this.fallbackMenuHandlers["workbench.action.openPrivacyStatementUrl"]=()=>{this.openUrl(k,"openPrivacyStatement")})}registerListeners(){this.lifecycleMainService.onWillShutdown(()=>this.willShutdown=!0),this.windowsMainService.onDidChangeWindowsCount(o=>this.onDidChangeWindowsCount(o)),this.nativeHostMainService.onDidBlurWindow(()=>this.onDidChangeWindowFocus()),this.nativeHostMainService.onDidFocusWindow(()=>this.onDidChangeWindowFocus())}get currentEnableMenuBarMnemonics(){const o=this.configurationService.getValue("window.enableMenuBarMnemonics");return typeof o!="boolean"?!0:o}get currentEnableNativeTabs(){if(!D.isMacintosh)return!1;const o=this.configurationService.getValue("window.nativeTabs");return typeof o!="boolean"?!1:o}updateMenu(o,a){this.menubarMenus=o.menus,this.keybindings=o.keybindings,this.stateMainService.setItem(Dt.lastKnownMenubarStorageKey,o),this.scheduleUpdateMenu()}scheduleUpdateMenu(){this.menuUpdater.schedule()}doUpdateMenu(){this.willShutdown||setTimeout(()=>{this.willShutdown||this.install()},10)}onDidChangeWindowsCount(o){!D.isMacintosh||(o.oldCount===0&&o.newCount>0||o.oldCount>0&&o.newCount===0)&&(this.closedLastWindow=o.newCount===0,this.scheduleUpdateMenu())}onDidChangeWindowFocus(){!D.isMacintosh||(this.noActiveWindow=!b.BrowserWindow.getFocusedWindow(),this.scheduleUpdateMenu())}install(){const o=b.Menu.getApplicationMenu();if(o&&this.oldMenus.push(o),Object.keys(this.menubarMenus).length===0){b.Menu.setApplicationMenu(D.isMacintosh?new b.Menu:null);return}const a=new b.Menu;let c;if(D.isMacintosh){const k=new b.Menu;c=new b.MenuItem({label:this.productService.nameShort,submenu:k}),this.setMacApplicationMenu(k),a.append(c)}if(D.isMacintosh&&!this.appMenuInstalled){this.appMenuInstalled=!0;const k=new b.Menu;k.append(new b.MenuItem({label:this.mnemonicLabel(f.localize(0,null)),click:()=>this.windowsMainService.openEmptyWindow({context:1})})),b.app.dock.setMenu(k)}if(this.shouldDrawMenu("File")){const k=new b.Menu,M=new b.MenuItem({label:this.mnemonicLabel(f.localize(1,null)),submenu:k});this.setMenuById(k,"File"),a.append(M)}if(this.shouldDrawMenu("Edit")){const k=new b.Menu,M=new b.MenuItem({label:this.mnemonicLabel(f.localize(2,null)),submenu:k});this.setMenuById(k,"Edit"),a.append(M)}if(this.shouldDrawMenu("Selection")){const k=new b.Menu,M=new b.MenuItem({label:this.mnemonicLabel(f.localize(3,null)),submenu:k});this.setMenuById(k,"Selection"),a.append(M)}if(this.shouldDrawMenu("View")){const k=new b.Menu,M=new b.MenuItem({label:this.mnemonicLabel(f.localize(4,null)),submenu:k});this.setMenuById(k,"View"),a.append(M)}if(this.shouldDrawMenu("Go")){const k=new b.Menu,M=new b.MenuItem({label:this.mnemonicLabel(f.localize(5,null)),submenu:k});this.setMenuById(k,"Go"),a.append(M)}if(this.shouldDrawMenu("Run")){const k=new b.Menu,M=new b.MenuItem({label:this.mnemonicLabel(f.localize(6,null)),submenu:k});this.setMenuById(k,"Run"),a.append(M)}if(this.shouldDrawMenu("Terminal")){const k=new b.Menu,M=new b.MenuItem({label:this.mnemonicLabel(f.localize(7,null)),submenu:k});this.setMenuById(k,"Terminal"),a.append(M)}let C;if(this.shouldDrawMenu("Window")){const k=new b.Menu;C=new b.MenuItem({label:this.mnemonicLabel(f.localize(8,null)),submenu:k,role:"window"}),this.setMacWindowMenu(k)}if(C&&a.append(C),this.shouldDrawMenu("Help")){const k=new b.Menu,M=new b.MenuItem({label:this.mnemonicLabel(f.localize(9,null)),submenu:k,role:"help"});this.setMenuById(k,"Help"),a.append(M)}a.items&&a.items.length>0?b.Menu.setApplicationMenu(a):b.Menu.setApplicationMenu(null),this.menuGC.schedule()}setMacApplicationMenu(o){const a=this.createMenuItem(f.localize(10,null,this.productService.nameLong),"workbench.action.showAboutDialog"),c=this.getUpdateMenuItems();let C;if(this.shouldDrawMenu("Preferences")){const Q=new b.Menu;this.setMenuById(Q,"Preferences"),C=new b.MenuItem({label:this.mnemonicLabel(f.localize(11,null)),submenu:Q})}const k=new b.Menu,M=new b.MenuItem({label:f.localize(12,null),role:"services",submenu:k}),T=new b.MenuItem({label:f.localize(13,null,this.productService.nameLong),role:"hide",accelerator:"Command+H"}),F=new b.MenuItem({label:f.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),q=new b.MenuItem({label:f.localize(15,null),role:"unhide"}),te=new b.MenuItem(this.likeAction("workbench.action.quit",{label:f.localize(16,null,this.productService.nameLong),click:async(Q,se,ce)=>{const H=this.windowsMainService.getLastActiveWindow();(this.windowsMainService.getWindowCount()===0||!!b.BrowserWindow.getFocusedWindow()||H?.isMinimized())&&await this.confirmBeforeQuit(ce)&&this.nativeHostMainService.quit(void 0)}})),ne=[a];ne.push(...c),C&&ne.push(i(),C),ne.push(i(),M,i(),T,F,q,i(),te),ne.forEach(Q=>o.append(Q))}async confirmBeforeQuit(o){if(this.windowsMainService.getWindowCount()===0)return!0;const a=this.configurationService.getValue("window.confirmBeforeClose");if(a==="always"||a==="keyboardOnly"&&this.isKeyboardEvent(o)){const c={title:this.productService.nameLong,type:"question",buttons:[(0,L.mnemonicButtonLabel)(f.localize(17,null)),(0,L.mnemonicButtonLabel)(f.localize(18,null))],message:f.localize(19,null),noLink:!0,defaultId:0,cancelId:1},{response:C}=await this.nativeHostMainService.showMessageBox(this.windowsMainService.getFocusedWindow()?.id,c);return C===0}return!0}shouldDrawMenu(o){if(!D.isMacintosh&&(0,d.getTitleBarStyle)(this.configurationService)==="custom")return!1;switch(o){case"File":case"Help":if(D.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus&&!!this.menubarMenus[o];case"Window":if(D.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus;default:return this.windowsMainService.getWindowCount()>0&&!!this.menubarMenus&&!!this.menubarMenus[o]}}setMenu(o,a){a.forEach(c=>{if((0,w.isMenubarMenuItemSeparator)(c))o.append(i());else if((0,w.isMenubarMenuItemSubmenu)(c)){const C=new b.Menu,k=new b.MenuItem({label:this.mnemonicLabel(c.label),submenu:C});this.setMenu(C,c.submenu.items),o.append(k)}else(0,w.isMenubarMenuItemRecentAction)(c)?o.append(this.createOpenRecentMenuItem(c)):(0,w.isMenubarMenuItemAction)(c)&&(c.id==="workbench.action.showAboutDialog"&&this.insertCheckForUpdatesItems(o),D.isMacintosh?this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow?this.fallbackMenuHandlers[c.id]?o.append(new b.MenuItem(this.likeAction(c.id,{label:this.mnemonicLabel(c.label),click:this.fallbackMenuHandlers[c.id]}))):o.append(this.createMenuItem(c.label,c.id,!1,c.checked)):o.append(this.createMenuItem(c.label,c.id,c.enabled!==!1,!!c.checked)):o.append(this.createMenuItem(c.label,c.id,c.enabled!==!1,!!c.checked)))})}setMenuById(o,a){this.menubarMenus&&this.menubarMenus[a]&&this.setMenu(o,this.menubarMenus[a].items)}insertCheckForUpdatesItems(o){const a=this.getUpdateMenuItems();a.length&&(a.forEach(c=>o.append(c)),o.append(i()))}createOpenRecentMenuItem(o){const a=y.URI.revive(o.uri),c=o.id,C=c==="openRecentFile"?{fileUri:a}:c==="openRecentWorkspace"?{workspaceUri:a}:{folderUri:a};return new b.MenuItem(this.likeAction(c,{label:o.label,click:(k,M,T)=>{const F=this.isOptionClick(T);this.windowsMainService.open({context:2,cli:this.environmentMainService.args,urisToOpen:[C],forceNewWindow:F,gotoLineMode:!1,remoteAuthority:o.remoteAuthority}).length>0||this.workspacesHistoryMainService.removeRecentlyOpened([a])}},!1))}isOptionClick(o){return!!(o&&(!D.isMacintosh&&(o.ctrlKey||o.shiftKey)||D.isMacintosh&&(o.metaKey||o.altKey)))}isKeyboardEvent(o){return!!(o.triggeredByAccelerator||o.altKey||o.ctrlKey||o.metaKey||o.shiftKey)}createRoleMenuItem(o,a,c){const C={label:this.mnemonicLabel(o),role:c,enabled:!0};return new b.MenuItem(this.withKeybinding(a,C))}setMacWindowMenu(o){const a=new b.MenuItem({label:f.localize(20,null),role:"minimize",accelerator:"Command+M",enabled:this.windowsMainService.getWindowCount()>0}),c=new b.MenuItem({label:f.localize(21,null),role:"zoom",enabled:this.windowsMainService.getWindowCount()>0}),C=new b.MenuItem({label:f.localize(22,null),role:"front",enabled:this.windowsMainService.getWindowCount()>0}),k=this.createMenuItem(f.localize(23,null),"workbench.action.switchWindow"),M=[];this.currentEnableNativeTabs&&(M.push(i()),M.push(this.createMenuItem(f.localize(24,null),"workbench.action.newWindowTab")),M.push(this.createRoleMenuItem(f.localize(25,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),M.push(this.createRoleMenuItem(f.localize(26,null),"workbench.action.showNextWindowTab","selectNextTab")),M.push(this.createRoleMenuItem(f.localize(27,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),M.push(this.createRoleMenuItem(f.localize(28,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[a,c,i(),k,...M,i(),C].forEach(T=>o.append(T))}getUpdateMenuItems(){switch(this.updateService.state.type){case"uninitialized":return[];case"idle":return[new b.MenuItem({label:this.mnemonicLabel(f.localize(29,null)),click:()=>setTimeout(()=>{this.reportMenuActionTelemetry("CheckForUpdate"),this.updateService.checkForUpdates(!0)},0)})];case"checking for updates":return[new b.MenuItem({label:f.localize(30,null),enabled:!1})];case"available for download":return[new b.MenuItem({label:this.mnemonicLabel(f.localize(31,null)),click:()=>{this.updateService.downloadUpdate()}})];case"downloading":return[new b.MenuItem({label:f.localize(32,null),enabled:!1})];case"downloaded":return[new b.MenuItem({label:this.mnemonicLabel(f.localize(33,null)),click:()=>{this.reportMenuActionTelemetry("InstallUpdate"),this.updateService.applyUpdate()}})];case"updating":return[new b.MenuItem({label:f.localize(34,null),enabled:!1})];case"ready":return[new b.MenuItem({label:this.mnemonicLabel(f.localize(35,null)),click:()=>{this.reportMenuActionTelemetry("RestartToUpdate"),this.updateService.quitAndInstall()}})]}}createMenuItem(o,a,c,C){const k=this.mnemonicLabel(o),M=typeof a=="function"?a:(ne,Q,se)=>{const ce=ne?ne.userSettingsLabel:null;let H=a;Array.isArray(a)&&(H=this.isOptionClick(se)?a[1]:a[0]),ce&&se.triggeredByAccelerator?this.runActionInRenderer({type:"keybinding",userSettingsLabel:ce}):this.runActionInRenderer({type:"commandId",commandId:H})},T=typeof c=="boolean"?c:this.windowsMainService.getWindowCount()>0,F=typeof C=="boolean"?C:!1,q={label:k,click:M,enabled:T};F&&(q.type="checkbox",q.checked=F);let te;return typeof a=="string"?te=a:Array.isArray(a)&&(te=a[0]),D.isMacintosh&&(te==="editor.action.clipboardCutAction"?q.role="cut":te==="editor.action.clipboardCopyAction"?q.role="copy":te==="editor.action.clipboardPasteAction"&&(q.role="paste"),te==="undo"?q.click=this.makeContextAwareClickHandler(M,{inDevTools:ne=>ne.undo(),inNoWindow:()=>b.Menu.sendActionToFirstResponder("undo:")}):te==="redo"?q.click=this.makeContextAwareClickHandler(M,{inDevTools:ne=>ne.redo(),inNoWindow:()=>b.Menu.sendActionToFirstResponder("redo:")}):te==="editor.action.selectAll"&&(q.click=this.makeContextAwareClickHandler(M,{inDevTools:ne=>ne.selectAll(),inNoWindow:()=>b.Menu.sendActionToFirstResponder("selectAll:")}))),new b.MenuItem(this.withKeybinding(te,q))}makeContextAwareClickHandler(o,a){return(c,C,k)=>{const M=b.BrowserWindow.getFocusedWindow();if(!M)return a.inNoWindow();if(M.webContents.isDevToolsFocused()&&M.webContents.devToolsWebContents)return a.inDevTools(M.webContents.devToolsWebContents);o(c,C||M,k)}}runActionInRenderer(o){let a=b.BrowserWindow.getFocusedWindow();if(!a){const C=this.windowsMainService.getLastActiveWindow();C?.isMinimized()&&(a=C.win)}const c=a?this.windowsMainService.getWindowById(a.id):void 0;if(c){if(this.logService.trace("menubar#runActionInRenderer",o),D.isMacintosh&&!this.environmentMainService.isBuilt&&!c.isReady&&(o.type==="commandId"&&o.commandId==="workbench.action.toggleDevTools"||o.type!=="commandId"&&o.userSettingsLabel==="alt+cmd+i"))return;if(o.type==="commandId"){const C={id:o.commandId,from:"menu"};c.sendWhenReady("vscode:runAction",R.CancellationToken.None,C)}else{const C={userSettingsLabel:o.userSettingsLabel};c.sendWhenReady("vscode:runKeybinding",R.CancellationToken.None,C)}}else this.logService.trace("menubar#runActionInRenderer: no active window found",o)}withKeybinding(o,a){const c=typeof o=="string"?this.keybindings[o]:void 0;if(c?.label){if(c.isNative!==!1)a.accelerator=c.label,a.userSettingsLabel=c.userSettingsLabel;else if(typeof a.label=="string"){const C=a.label.indexOf("[");C>=0?a.label=`${a.label.substr(0,C)} [${c.label}]`:a.label=`${a.label} [${c.label}]`}}else a.accelerator=void 0;return a}likeAction(o,a,c=!a.accelerator){c&&(a=this.withKeybinding(o,a));const C=a.click;return a.click=(k,M,T)=>{this.reportMenuActionTelemetry(o),C?.(k,M,T)},a}openUrl(o,a){this.nativeHostMainService.openExternal(void 0,o),this.reportMenuActionTelemetry(a)}reportMenuActionTelemetry(o){this.telemetryService.publicLog2("workbenchActionExecuted",{id:o,from:n})}mnemonicLabel(o){return(0,L.mnemonicMenuLabel)(o,!this.currentEnableMenuBarMnemonics)}};r.lastKnownMenubarStorageKey="lastKnownMenubarData",r=de([ee(0,p.IUpdateService),ee(1,v.IConfigurationService),ee(2,h.IWindowsMainService),ee(3,E.IEnvironmentMainService),ee(4,I.ITelemetryService),ee(5,l.IWorkspacesHistoryMainService),ee(6,g.IStateMainService),ee(7,P.ILifecycleMainService),ee(8,S.ILogService),ee(9,u.INativeHostMainService),ee(10,m.IProductService)],r),e.Menubar=r;function i(){return new b.MenuItem({type:"separator"})}}),define(J[253],Z([0,1,5,21,6,252]),function(z,e,b,t,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,b.createDecorator)("menubarMainService");let D=class{constructor(f,v,E){this.instantiationService=f,this.lifecycleMainService=v,this.logService=E,this.menubar=this.installMenuBarAfterWindowOpen()}async installMenuBarAfterWindowOpen(){return await this.lifecycleMainService.when(3),this.instantiationService.createInstance(L.Menubar)}async updateMenubar(f,v){this.logService.trace("menubarService#updateMenubar",f),(await this.menubar).updateMenu(v,f)}};D=de([ee(0,b.IInstantiationService),ee(1,t.ILifecycleMainService),ee(2,R.ILogService)],D),e.MenubarMainService=D}),define(J[254],Z([0,1,14,28,27,25,22,3,29,48,34,2,11,9,70,4,36,16,12,7,164,56,17,52,26,15,5,21,6,57,20,58,71,45,74,251,110,237,24,111,76,47,61,40,37]),function(z,e,b,t,R,L,D,y,f,v,E,P,S,w,u,m,g,I,p,d,h,l,n,r,i,s,o,a,c,C,k,M,T,F,q,te,ne,Q,se,ce,H,oe,W,U,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function X(x){return(0,se.isWorkspaceIdentifier)(x?.workspace)}function j(x){return(0,se.isSingleFolderWorkspaceIdentifier)(x?.workspace)}let Y=class ut extends P.Disposable{constructor(A,O,N,V,_,$,G,ie,ae,me,fe,Pe,Ee,ke,Oe,Ue,le,he){super();this.machineId=A,this.initialUserEnv=O,this.logService=N,this.stateMainService=V,this.policyService=_,this.environmentMainService=$,this.userDataProfilesService=G,this.lifecycleMainService=ie,this.backupMainService=ae,this.configurationService=me,this.workspacesHistoryMainService=fe,this.workspacesManagementMainService=Pe,this.instantiationService=Ee,this.dialogMainService=ke,this.fileService=Oe,this.productService=Ue,this.protocolMainService=le,this.themeMainService=he,this._onDidOpenWindow=this._register(new y.Emitter),this.onDidOpenWindow=this._onDidOpenWindow.event,this._onDidSignalReadyWindow=this._register(new y.Emitter),this.onDidSignalReadyWindow=this._onDidSignalReadyWindow.event,this._onDidDestroyWindow=this._register(new y.Emitter),this.onDidDestroyWindow=this._onDidDestroyWindow.event,this._onDidChangeWindowsCount=this._register(new y.Emitter),this.onDidChangeWindowsCount=this._onDidChangeWindowsCount.event,this.windowsStateHandler=this._register(new Q.WindowsStateHandler(this,this.stateMainService,this.lifecycleMainService,this.logService,this.configurationService)),this.registerListeners()}registerListeners(){this._register(this.workspacesManagementMainService.onDidEnterWorkspace(A=>this._onDidSignalReadyWindow.fire(A.window))),this._register(this.onDidSignalReadyWindow(A=>{if(A.config?.extensionDevelopmentPath||A.config?.extensionTestsPath){const O=new P.DisposableStore;if(O.add(y.Event.any(A.onDidClose,A.onDidDestroy)(()=>O.dispose())),A.config.extensionDevelopmentPath)for(const N of A.config.extensionDevelopmentPath)O.add(this.protocolMainService.addValidFileRoot(N));A.config.extensionTestsPath&&O.add(this.protocolMainService.addValidFileRoot(A.config.extensionTestsPath))}}))}openEmptyWindow(A,O){const N=this.environmentMainService.args,V=O?.remoteAuthority||void 0,_=!0,$=O?.forceReuseWindow,G=!$;return this.open({...A,cli:N,forceEmpty:_,forceNewWindow:G,forceReuseWindow:$,remoteAuthority:V})}openExistingWindow(A,O){A.focus(),this.handleWaitMarkerFile(O,[A])}open(A){this.logService.trace("windowsManager#open"),A.addMode&&(A.initialStartup||!this.getLastActiveWindow())&&(A.addMode=!1);const O=[],N=[],V=[],_=[],$=[];let G,ie=0;const ae=this.getPathsToOpen(A);this.logService.trace("windowsManager#open pathsToOpen",ae);for(const Ee of ae)j(Ee)?A.addMode?O.push(Ee):N.push(Ee):X(Ee)?V.push(Ee):Ee.fileUri?(G||(G={filesToOpenOrCreate:[],filesToDiff:[],remoteAuthority:Ee.remoteAuthority}),G.filesToOpenOrCreate.push(Ee)):Ee.backupPath?$.push({backupFolder:(0,w.basename)(Ee.backupPath),remoteAuthority:Ee.remoteAuthority}):ie++;A.diffMode&&G&&G.filesToOpenOrCreate.length>=2&&(G.filesToDiff=G.filesToOpenOrCreate.slice(0,2),G.filesToOpenOrCreate=[]),G&&A.waitMarkerFileURI&&(G.filesToWait={paths:[...G.filesToDiff,...G.filesToOpenOrCreate],waitMarkerFileUri:A.waitMarkerFileURI}),A.initialStartup?(_.push(...this.workspacesManagementMainService.getUntitledWorkspacesSync()),V.push(..._),$.push(...this.backupMainService.getEmptyWindowBackupPaths())):$.length=0;const{windows:me,filesOpenedInWindow:fe}=this.doOpen(A,V,N,$,ie,G,O);if(this.logService.trace(`windowsManager#open used window count ${me.length} (workspacesToOpen: ${V.length}, foldersToOpen: ${N.length}, emptyToRestore: ${$.length}, emptyToOpen: ${ie})`),me.length>1)if(fe)fe.focus();else{const Ee=this.windowsStateHandler.state.lastActiveWindow&&!A.forceEmpty&&!A.cli._.length&&!A.cli["file-uri"]&&!A.cli["folder-uri"]&&!(A.urisToOpen&&A.urisToOpen.length);let ke=!0,Oe=!0;if(Ee){const Ue=me.filter(le=>this.windowsStateHandler.state.lastActiveWindow&&le.backupPath===this.windowsStateHandler.state.lastActiveWindow.backupPath);Ue.length&&(Ue[0].focus(),ke=!1,Oe=!1)}if(ke)for(let Ue=me.length-1;Ue>=0;Ue--){const le=me[Ue];if(!(le.openedWorkspace&&_.some(he=>le.openedWorkspace&&he.workspace.id===le.openedWorkspace.id)||le.backupPath&&$.some(he=>le.backupPath&&he.backupFolder===(0,w.basename)(le.backupPath)))){le.focus(),Oe=!1;break}}Oe&&me[me.length-1].focus()}const Pe=G&&G.filesToDiff.length>0;if(!me.some(Ee=>Ee.isExtensionDevelopmentHost)&&!Pe&&!A.noRecentEntry){const Ee=[];for(const ke of ae)X(ke)&&!ke.transient?Ee.push({label:ke.label,workspace:ke.workspace,remoteAuthority:ke.remoteAuthority}):j(ke)?Ee.push({label:ke.label,folderUri:ke.workspace.uri,remoteAuthority:ke.remoteAuthority}):ke.fileUri&&Ee.push({label:ke.label,fileUri:ke.fileUri,remoteAuthority:ke.remoteAuthority});this.workspacesHistoryMainService.addRecentlyOpened(Ee)}return this.handleWaitMarkerFile(A,me),me}handleWaitMarkerFile(A,O){const N=A.waitMarkerFileURI;A.context===0&&N&&O.length===1&&O[0]&&(async()=>{await O[0].whenClosedOrLoaded;try{await this.fileService.del(N)}catch{}})()}doOpen(A,O,N,V,_,$,G){const ie=[];let ae;function me(le,he){ie.push(le),he&&(ae=le,$=void 0)}let{openFolderInNewWindow:fe,openFilesInNewWindow:Pe}=this.shouldOpenNewWindow(A);if(!A.initialStartup&&G.length>0){const le=G[0].remoteAuthority,he=this.getLastActiveWindowForAuthority(le);he&&me(this.doAddFoldersToExistingWindow(he,G.map(pe=>pe.workspace.uri)))}const Ee=N.length+O.length+V.length;if($&&Ee===0){const le=$.filesToOpenOrCreate[0]||$.filesToDiff[0],he=this.getWindows().filter(Ie=>$&&(0,I.isEqualAuthority)(Ie.remoteAuthority,$.remoteAuthority));let pe;le?.fileUri&&!Pe&&((A.context===4||A.context===0||A.context===1)&&(pe=(0,ne.findWindowOnFile)(he,le.fileUri,Ie=>Ie.configPath.scheme===S.Schemas.file?this.workspacesManagementMainService.resolveLocalWorkspaceSync(Ie.configPath):void 0)),pe||(pe=this.doGetLastActiveWindow(he))),pe?(0,se.isWorkspaceIdentifier)(pe.openedWorkspace)?O.push({workspace:pe.openedWorkspace,remoteAuthority:pe.remoteAuthority}):(0,se.isSingleFolderWorkspaceIdentifier)(pe.openedWorkspace)?N.push({workspace:pe.openedWorkspace,remoteAuthority:pe.remoteAuthority}):me(this.doOpenFilesInExistingWindow(A,pe,$),!0):me(this.openInBrowserWindow({userEnv:A.userEnv,cli:A.cli,initialStartup:A.initialStartup,filesToOpen:$,forceNewWindow:!0,remoteAuthority:$.remoteAuthority,forceNewTabbedWindow:A.forceNewTabbedWindow}),!0)}const ke=(0,L.distinct)(O,le=>le.workspace.id);if(ke.length>0){const le=(0,L.coalesce)(ke.map(he=>(0,ne.findWindowOnWorkspaceOrFolder)(this.getWindows(),he.workspace.configPath)));if(le.length>0){const he=le[0],pe=(0,I.isEqualAuthority)($?.remoteAuthority,he.remoteAuthority)?$:void 0;me(this.doOpenFilesInExistingWindow(A,he,pe),!!pe),fe=!0}ke.forEach(he=>{if(le.some(De=>De.openedWorkspace&&De.openedWorkspace.id===he.workspace.id))return;const pe=he.remoteAuthority,Ie=(0,I.isEqualAuthority)($?.remoteAuthority,pe)?$:void 0;me(this.doOpenFolderOrWorkspace(A,he,fe,Ie),!!Ie),fe=!0})}const Oe=(0,L.distinct)(N,le=>I.extUriBiasedIgnorePathCase.getComparisonKey(le.workspace.uri));if(Oe.length>0){const le=(0,L.coalesce)(Oe.map(he=>(0,ne.findWindowOnWorkspaceOrFolder)(this.getWindows(),he.workspace.uri)));if(le.length>0){const he=le[0],pe=(0,I.isEqualAuthority)($?.remoteAuthority,he.remoteAuthority)?$:void 0;me(this.doOpenFilesInExistingWindow(A,he,pe),!!pe),fe=!0}Oe.forEach(he=>{if(le.some(De=>(0,se.isSingleFolderWorkspaceIdentifier)(De.openedWorkspace)&&I.extUriBiasedIgnorePathCase.isEqual(De.openedWorkspace.uri,he.workspace.uri)))return;const pe=he.remoteAuthority,Ie=(0,I.isEqualAuthority)($?.remoteAuthority,pe)?$:void 0;me(this.doOpenFolderOrWorkspace(A,he,fe,Ie),!!Ie),fe=!0})}const Ue=(0,L.distinct)(V,le=>le.backupFolder);if(Ue.length>0&&Ue.forEach(le=>{const he=le.remoteAuthority,pe=(0,I.isEqualAuthority)($?.remoteAuthority,he)?$:void 0;me(this.doOpenEmpty(A,!0,he,pe,le),!!pe),fe=!0}),ie.length===0||$){$&&!_&&_++;const le=$?$.remoteAuthority:A.remoteAuthority;for(let he=0;he<_;he++)me(this.doOpenEmpty(A,fe,le,$),!!$),fe=!0}return{windows:(0,L.distinct)(ie),filesOpenedInWindow:ae}}doOpenFilesInExistingWindow(A,O,N){this.logService.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:N}),O.focus();const V={filesToOpenOrCreate:N?.filesToOpenOrCreate,filesToDiff:N?.filesToDiff,filesToWait:N?.filesToWait,termProgram:A?.userEnv?.TERM_PROGRAM};return O.sendWhenReady("vscode:openFiles",D.CancellationToken.None,V),O}doAddFoldersToExistingWindow(A,O){this.logService.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:O}),A.focus();const N={foldersToAdd:O};return A.sendWhenReady("vscode:addFolders",D.CancellationToken.None,N),A}doOpenEmpty(A,O,N,V,_){this.logService.trace("windowsManager#doOpenEmpty",{restore:!!_,remoteAuthority:N,filesToOpen:V,forceNewWindow:O});let $;return!O&&typeof A.contextWindowId=="number"&&($=this.getWindowById(A.contextWindowId)),this.openInBrowserWindow({userEnv:A.userEnv,cli:A.cli,initialStartup:A.initialStartup,remoteAuthority:N,forceNewWindow:O,forceNewTabbedWindow:A.forceNewTabbedWindow,filesToOpen:V,windowToUse:$,emptyWindowBackupInfo:_})}doOpenFolderOrWorkspace(A,O,N,V,_){return this.logService.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:O,filesToOpen:V}),!N&&!_&&typeof A.contextWindowId=="number"&&(_=this.getWindowById(A.contextWindowId)),this.openInBrowserWindow({workspace:O.workspace,userEnv:A.userEnv,cli:A.cli,initialStartup:A.initialStartup,remoteAuthority:O.remoteAuthority,forceNewWindow:N,forceNewTabbedWindow:A.forceNewTabbedWindow,filesToOpen:V,windowToUse:_})}getPathsToOpen(A){let O,N=!1,V=!1;if(A.urisToOpen&&A.urisToOpen.length>0?(O=this.doExtractPathsFromAPI(A),N=!0):A.forceEmpty?O=[Object.create(null)]:A.cli._.length||A.cli["folder-uri"]||A.cli["file-uri"]?(O=this.doExtractPathsFromCLI(A.cli),O.length===0&&O.push(Object.create(null)),N=!0):(O=this.doGetPathsFromLastSession(),O.length===0&&O.push(Object.create(null)),V=!0),!A.addMode&&N){const _=O.filter($=>j($));if(_.length>1){const $=_[0].remoteAuthority;if(_.every(G=>(0,I.isEqualAuthority)(G.remoteAuthority,$))){const G=this.workspacesManagementMainService.createUntitledWorkspaceSync(_.map(ie=>({uri:ie.workspace.uri})));O.push({workspace:G,remoteAuthority:$}),O=O.filter(ie=>!j(ie))}}}return A.initialStartup&&!V&&this.configurationService.getValue("window")?.restoreWindows==="preserve"&&O.unshift(...this.doGetPathsFromLastSession().filter(_=>X(_)||j(_)||_.backupPath)),O}doExtractPathsFromAPI(A){const O=[],N={gotoLineMode:A.gotoLineMode,remoteAuthority:A.remoteAuthority};for(const V of(0,L.coalesce)(A.urisToOpen||[])){const _=this.resolveOpenable(V,N);if(_)_.label=V.label,O.push(_);else{const $=this.resourceFromOpenable(V),G={title:this.productService.nameLong,type:"info",buttons:[(0,E.mnemonicButtonLabel)((0,h.localize)(0,null))],defaultId:0,message:$.scheme===S.Schemas.file?(0,h.localize)(1,null):(0,h.localize)(2,null),detail:$.scheme===S.Schemas.file?(0,h.localize)(3,null,(0,E.getPathLabel)($,{os:m.OS,tildify:this.environmentMainService})):(0,h.localize)(4,null,$.toString(!0)),noLink:!0};this.dialogMainService.showMessageBox(G,(0,p.withNullAsUndefined)(b.BrowserWindow.getFocusedWindow()))}}return O}doExtractPathsFromCLI(A){const O=[],N={ignoreFileNotFound:!0,gotoLineMode:A.goto,remoteAuthority:A.remote||void 0,forceOpenWorkspaceAsFile:!1},V=A["folder-uri"];if(V)for(const G of V){const ie=this.cliArgToUri(G);if(ie){const ae=this.resolveOpenable({folderUri:ie},N);ae&&O.push(ae)}}const _=A["file-uri"];if(_)for(const G of _){const ie=this.cliArgToUri(G);if(ie){const ae=this.resolveOpenable((0,se.hasWorkspaceFileExtension)(G)?{workspaceUri:ie}:{fileUri:ie},N);ae&&O.push(ae)}}const $=A._;for(const G of $){const ie=N.remoteAuthority?this.doResolvePathRemote(G,N):this.doResolveFilePath(G,N);ie&&O.push(ie)}return O}cliArgToUri(A){try{const O=d.URI.parse(A);if(!O.scheme){this.logService.error(`Invalid URI input string, scheme missing: ${A}`);return}return O}catch(O){this.logService.error(`Invalid URI input string: ${A}, ${O.message}`)}}doGetPathsFromLastSession(){const A=this.getRestoreWindowsSetting();switch(A){case"none":return[];case"one":case"all":case"preserve":case"folders":{const O=[];A!=="one"&&O.push(...this.windowsStateHandler.state.openedWindows),this.windowsStateHandler.state.lastActiveWindow&&O.push(this.windowsStateHandler.state.lastActiveWindow);const N=[];for(const V of O)if(V.workspace){const _=this.resolveOpenable({workspaceUri:V.workspace.configPath},{remoteAuthority:V.remoteAuthority,rejectTransientWorkspaces:!0});X(_)&&N.push(_)}else if(V.folderUri){const _=this.resolveOpenable({folderUri:V.folderUri},{remoteAuthority:V.remoteAuthority});j(_)&&N.push(_)}else A!=="folders"&&V.backupPath&&N.push({backupPath:V.backupPath,remoteAuthority:V.remoteAuthority});return N}}}getRestoreWindowsSetting(){let A;return this.lifecycleMainService.wasRestarted?A="all":(A=this.configurationService.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(A)||(A="all")),A}resolveOpenable(A,O=Object.create(null)){const N=this.resourceFromOpenable(A);return N.scheme===S.Schemas.file?((0,q.isFileToOpen)(A)&&(O={...O,forceOpenWorkspaceAsFile:!0}),this.doResolveFilePath(N.fsPath,O)):this.doResolveRemoteOpenable(A,O)}doResolveRemoteOpenable(A,O){let N=this.resourceFromOpenable(A);const V=(0,T.getRemoteAuthority)(N)||O.remoteAuthority;if(N=(0,I.removeTrailingPathSeparator)((0,I.normalizePath)(N)),(0,q.isFileToOpen)(A)){if(O.gotoLineMode){const{path:_,line:$,column:G}=(0,f.parseLineAndColumnAware)(N.path);return{fileUri:N.with({path:_}),options:{selection:$?{startLineNumber:$,startColumn:G||1}:void 0},remoteAuthority:V}}return{fileUri:N,remoteAuthority:V}}else if((0,q.isWorkspaceToOpen)(A))return{workspace:(0,ce.getWorkspaceIdentifier)(N),remoteAuthority:V};return{workspace:(0,ce.getSingleFolderWorkspaceIdentifier)(N),remoteAuthority:V}}resourceFromOpenable(A){return(0,q.isWorkspaceToOpen)(A)?A.workspaceUri:(0,q.isFolderToOpen)(A)?A.folderUri:A.fileUri}doResolveFilePath(A,O){let N,V;O.gotoLineMode&&({path:A,line:N,column:V}=(0,f.parseLineAndColumnAware)(A)),A=(0,f.sanitizeFilePath)((0,w.normalize)(A),(0,g.cwd)());try{const _=(0,t.statSync)(A);if(_.isFile()){if(!O.forceOpenWorkspaceAsFile){const $=this.workspacesManagementMainService.resolveLocalWorkspaceSync(d.URI.file(A));if($)return $.transient&&O.rejectTransientWorkspaces?void 0:{workspace:{id:$.id,configPath:$.configPath},type:s.FileType.File,exists:!0,remoteAuthority:$.remoteAuthority,transient:$.transient}}return{fileUri:d.URI.file(A),type:s.FileType.File,exists:!0,options:{selection:N?{startLineNumber:N,startColumn:V||1}:void 0}}}else{if(_.isDirectory())return{workspace:(0,ce.getSingleFolderWorkspaceIdentifier)(d.URI.file(A),_),type:s.FileType.Directory,exists:!0};if(!m.isWindows&&A==="/dev/null")return{fileUri:d.URI.file(A),type:s.FileType.File,exists:!0}}}catch{const $=d.URI.file(A);if(this.workspacesHistoryMainService.removeRecentlyOpened([$]),O.ignoreFileNotFound)return{fileUri:$,type:s.FileType.File,exists:!1}}}doResolvePathRemote(A,O){const N=A.charCodeAt(0),V=O.remoteAuthority;let _,$;O.gotoLineMode&&({path:A,line:_,column:$}=(0,f.parseLineAndColumnAware)(A)),N!==47&&((0,f.isWindowsDriveLetter)(N)&&A.charCodeAt(A.charCodeAt(1))===58&&(A=(0,f.toSlashes)(A)),A=`/${A}`);const G=d.URI.from({scheme:S.Schemas.vscodeRemote,authority:V,path:A});if(A.charCodeAt(A.length-1)!==47){if((0,se.hasWorkspaceFileExtension)(A))return O.forceOpenWorkspaceAsFile?{fileUri:G,options:{selection:_?{startLineNumber:_,startColumn:$||1}:void 0},remoteAuthority:O.remoteAuthority}:{workspace:(0,ce.getWorkspaceIdentifier)(G),remoteAuthority:V};if(O.gotoLineMode||w.posix.basename(A).indexOf(".")!==-1)return{fileUri:G,options:{selection:_?{startLineNumber:_,startColumn:$||1}:void 0},remoteAuthority:V}}return{workspace:(0,ce.getSingleFolderWorkspaceIdentifier)(G),remoteAuthority:V}}shouldOpenNewWindow(A){const O=this.configurationService.getValue("window"),N=O?.openFoldersInNewWindow||"default",V=O?.openFilesInNewWindow||"off";let _=(A.preferNewWindow||A.forceNewWindow)&&!A.forceReuseWindow;!A.forceNewWindow&&!A.forceReuseWindow&&(N==="on"||N==="off")&&(_=N==="on");let $=!1;return A.forceNewWindow||A.forceReuseWindow?$=!!A.forceNewWindow&&!A.forceReuseWindow:(m.isMacintosh?A.context===1&&($=!0):A.context!==3&&A.context!==2&&!(A.userEnv&&A.userEnv.TERM_PROGRAM==="vscode")&&($=!0),!A.cli.extensionDevelopmentPath&&(V==="on"||V==="off")&&($=V==="on")),{openFolderInNewWindow:!!_,openFilesInNewWindow:$}}openExtensionDevelopmentHostWindow(A,O){const N=(0,ne.findWindowOnExtensionDevelopmentPath)(this.getWindows(),A);if(N)return this.lifecycleMainService.reload(N,O.cli),N.focus(),[N];let V=O.cli["folder-uri"]||[],_=O.cli["file-uri"]||[],$=O.cli._;if(!$.length&&!V.length&&!_.length&&!O.cli.extensionTestsPath){const me=this.windowsStateHandler.state.lastPluginDevelopmentHostWindow,fe=me&&(me.workspace||me.folderUri);fe&&(d.URI.isUri(fe)?fe.scheme===S.Schemas.file?$=[fe.fsPath]:V=[fe.toString()]:fe.configPath.scheme===S.Schemas.file?$=[(0,I.originalFSPath)(fe.configPath)]:_=[fe.configPath.toString()])}let G=O.remoteAuthority;for(const me of A)if(me.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const fe=d.URI.parse(me),Pe=(0,T.getRemoteAuthority)(fe);Pe&&(G?(0,I.isEqualAuthority)(Pe,G)||this.logService.error("more than one extension development path authority"):G=Pe)}$=$.filter(me=>{const fe=d.URI.file(me);return(0,ne.findWindowOnWorkspaceOrFolder)(this.getWindows(),fe)?!1:(0,I.isEqualAuthority)((0,T.getRemoteAuthority)(fe),G)}),V=V.filter(me=>{const fe=this.cliArgToUri(me);return fe&&!!(0,ne.findWindowOnWorkspaceOrFolder)(this.getWindows(),fe)?!1:fe?(0,I.isEqualAuthority)((0,T.getRemoteAuthority)(fe),G):!1}),_=_.filter(me=>{const fe=this.cliArgToUri(me);return fe&&!!(0,ne.findWindowOnWorkspaceOrFolder)(this.getWindows(),fe)?!1:fe?(0,I.isEqualAuthority)((0,T.getRemoteAuthority)(fe),G):!1}),O.cli._=$,O.cli["folder-uri"]=V,O.cli["file-uri"]=_;const ie=!$.length&&!V.length&&!_.length,ae={context:O.context,cli:O.cli,forceNewWindow:!0,forceEmpty:ie,userEnv:O.userEnv,noRecentEntry:!0,waitMarkerFileURI:O.waitMarkerFileURI,remoteAuthority:G};return this.open(ae)}openInBrowserWindow(A){const O=this.configurationService.getValue("window"),N={...this.environmentMainService.args,...A.cli,machineId:this.machineId,windowId:-1,mainPid:process.pid,appRoot:this.environmentMainService.appRoot,execPath:process.execPath,codeCachePath:this.environmentMainService.codeCachePath,backupPath:A.emptyWindowBackupInfo?(0,w.join)(this.environmentMainService.backupHome,A.emptyWindowBackupInfo.backupFolder):void 0,profiles:{all:this.userDataProfilesService.profiles,current:this.userDataProfilesService.getProfile(A.workspace??"empty-window")},homeDir:this.environmentMainService.userHome.fsPath,tmpDir:this.environmentMainService.tmpDir.fsPath,userDataDir:this.environmentMainService.userDataPath,remoteAuthority:A.remoteAuthority,workspace:A.workspace,userEnv:{...this.initialUserEnv,...A.userEnv},filesToOpenOrCreate:A.filesToOpen?.filesToOpenOrCreate,filesToDiff:A.filesToOpen?.filesToDiff,filesToWait:A.filesToOpen?.filesToWait,logLevel:this.logService.getLevel(),logsPath:this.environmentMainService.logsPath,product:C.default,isInitialStartup:A.initialStartup,perfMarks:(0,u.getMarks)(),os:{release:(0,R.release)(),hostname:(0,R.hostname)()},zoomLevel:typeof O?.zoomLevel=="number"?O.zoomLevel:void 0,autoDetectHighContrast:O?.autoDetectHighContrast??!0,autoDetectColorScheme:O?.autoDetectColorScheme??!1,accessibilitySupport:b.app.accessibilitySupportEnabled,colorScheme:this.themeMainService.getColorScheme(),policiesData:this.policyService.serialize(),editSessionId:this.environmentMainService.editSessionId};let V;if(!A.forceNewWindow&&!A.forceNewTabbedWindow&&(V=A.windowToUse||this.getLastActiveWindow(),V&&V.focus()),V){const _=V.config;!N.extensionDevelopmentPath&&_&&!!_.extensionDevelopmentPath&&(N.extensionDevelopmentPath=_.extensionDevelopmentPath,N.verbose=_.verbose,N["inspect-brk-extensions"]=_["inspect-brk-extensions"],N.debugId=_.debugId,N.extensionEnvironment=_.extensionEnvironment,N["inspect-extensions"]=_["inspect-extensions"],N["extensions-dir"]=_["extensions-dir"])}else{const _=this.windowsStateHandler.getNewWindowState(N);(0,u.mark)("code/willCreateCodeWindow");const $=V=this.instantiationService.createInstance(te.CodeWindow,{state:_,extensionDevelopmentPath:N.extensionDevelopmentPath,isExtensionTestHost:!!N.extensionTestsPath});(0,u.mark)("code/didCreateCodeWindow"),A.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow($),ut.WINDOWS.push($),this._onDidOpenWindow.fire($),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,v.once)($.onDidSignalReady)(()=>this._onDidSignalReadyWindow.fire($)),(0,v.once)($.onDidClose)(()=>this.onWindowClosed($)),(0,v.once)($.onDidDestroy)(()=>this._onDidDestroyWindow.fire($));const G=(0,p.assertIsDefined)($.win?.webContents);G.removeAllListeners("devtools-reload-page"),G.on("devtools-reload-page",()=>this.lifecycleMainService.reload($)),this.lifecycleMainService.registerWindow($)}return N.windowId=V.id,V.isReady?this.lifecycleMainService.unload(V,4).then(_=>{_||this.doOpenInBrowserWindow(V,N,A)}):this.doOpenInBrowserWindow(V,N,A),V}doOpenInBrowserWindow(A,O,N){if(!O.extensionDevelopmentPath)if((0,se.isWorkspaceIdentifier)(O.workspace))O.backupPath=this.backupMainService.registerWorkspaceBackupSync({workspace:O.workspace,remoteAuthority:O.remoteAuthority});else if((0,se.isSingleFolderWorkspaceIdentifier)(O.workspace))O.backupPath=this.backupMainService.registerFolderBackupSync({folderUri:O.workspace.uri,remoteAuthority:O.remoteAuthority});else{const V=N.emptyWindowBackupInfo&&N.emptyWindowBackupInfo.backupFolder;O.backupPath=this.backupMainService.registerEmptyWindowBackupSync(V,O.remoteAuthority)}A.load(O)}onWindowClosed(A){const O=ut.WINDOWS.indexOf(A);ut.WINDOWS.splice(O,1),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const A=b.BrowserWindow.getFocusedWindow();if(A)return this.getWindowById(A.id)}getLastActiveWindow(){return this.doGetLastActiveWindow(this.getWindows())}getLastActiveWindowForAuthority(A){return this.doGetLastActiveWindow(this.getWindows().filter(O=>(0,I.isEqualAuthority)(O.remoteAuthority,A)))}doGetLastActiveWindow(A){const O=Math.max.apply(Math,A.map(N=>N.lastFocusTime));return A.find(N=>N.lastFocusTime===O)}sendToFocused(A,...O){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(A,D.CancellationToken.None,...O)}sendToAll(A,O,N){for(const V of this.getWindows())N&&N.indexOf(V.id)>=0||V.sendWhenReady(A,D.CancellationToken.None,O)}getWindows(){return ut.WINDOWS}getWindowCount(){return ut.WINDOWS.length}getWindowById(A){const O=this.getWindows().filter(N=>N.id===A);return(0,L.firstOrDefault)(O)}getWindowByWebContents(A){const O=b.BrowserWindow.fromWebContents(A);if(!!O)return this.getWindowById(O.id)}};Y.WINDOWS=[],Y=de([ee(2,c.ILogService),ee(3,F.IStateMainService),ee(4,B.IPolicyService),ee(5,i.IEnvironmentMainService),ee(6,U.IUserDataProfilesService),ee(7,a.ILifecycleMainService),ee(8,l.IBackupMainService),ee(9,n.IConfigurationService),ee(10,H.IWorkspacesHistoryMainService),ee(11,oe.IWorkspacesManagementMainService),ee(12,o.IInstantiationService),ee(13,r.IDialogMainService),ee(14,s.IFileService),ee(15,k.IProductService),ee(16,M.IProtocolMainService),ee(17,W.IThemeMainService)],Y),e.WindowsMainService=Y}),define(J[255],Z([0,1,56,32,76,47]),function(z,e,b,t,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let D=class{constructor(f,v,E,P){this.workspacesManagementMainService=f,this.windowsMainService=v,this.workspacesHistoryMainService=E,this.backupMainService=P,this.onDidChangeRecentlyOpened=this.workspacesHistoryMainService.onDidChangeRecentlyOpened}async enterWorkspace(f,v){const E=this.windowsMainService.getWindowById(f);if(E)return this.workspacesManagementMainService.enterWorkspace(E,this.windowsMainService.getWindows(),v)}createUntitledWorkspace(f,v,E){return this.workspacesManagementMainService.createUntitledWorkspace(v,E)}deleteUntitledWorkspace(f,v){return this.workspacesManagementMainService.deleteUntitledWorkspace(v)}getWorkspaceIdentifier(f,v){return this.workspacesManagementMainService.getWorkspaceIdentifier(v)}getRecentlyOpened(f){return this.workspacesHistoryMainService.getRecentlyOpened(this.windowsMainService.getWindowById(f))}addRecentlyOpened(f,v){return this.workspacesHistoryMainService.addRecentlyOpened(v)}removeRecentlyOpened(f,v){return this.workspacesHistoryMainService.removeRecentlyOpened(v)}clearRecentlyOpened(f){return this.workspacesHistoryMainService.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.backupMainService.getDirtyWorkspaces()}};D=de([ee(0,L.IWorkspacesManagementMainService),ee(1,t.IWindowsMainService),ee(2,R.IWorkspacesHistoryMainService),ee(3,b.IBackupMainService)],D),e.WorkspacesMainService=D}),define(J[256],Z([0,1,14,38,28,27,19,41,18,29,48,49,34,2,11,9,4,12,7,30,80,128,43,139,96,229,144,56,240,17,68,173,82,112,52,99,171,26,55,105,180,200,181,231,100,182,183,15,193,84,67,5,83,248,209,113,21,6,195,253,62,20,71,244,85,45,234,86,213,35,215,217,72,46,221,246,249,247,250,107,223,224,225,227,232,32,254,233,24,87,76,255,47,230,37,199,75]),function(z,e,b,t,R,L,D,y,f,v,E,P,S,w,u,m,g,I,p,d,h,l,n,r,i,s,o,a,c,C,k,M,T,F,q,te,ne,Q,se,ce,H,oe,W,U,B,X,j,Y,x,A,O,N,V,_,$,G,ie,ae,me,fe,Pe,Ee,ke,Oe,Ue,le,he,pe,Ie,De,Je,Le,Be,Ae,Ye,Qe,Ze,ze,je,K,re,ue,ge,ye,Re,qe,it,et,He,Xe,xe,at,ct,Tt,Wt,Ot,Ft){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let Et=class extends w.Disposable{constructor(we,Se,be,ve,Me,_e,Te,We,Ce,Fe){super();this.mainProcessNodeIpcServer=we,this.userEnv=Se,this.mainInstantiationService=be,this.logService=ve,this.environmentMainService=Me,this.lifecycleMainService=_e,this.configurationService=Te,this.stateMainService=We,this.fileService=Ce,this.productService=Fe,this.configureSession(),this.registerListeners()}configureSession(){const we=Ce=>Ce?.startsWith(`${u.Schemas.vscodeWebview}://`),Se=new Set(["clipboard-read","clipboard-sanitized-write"]);b.session.defaultSession.setPermissionRequestHandler((Ce,Fe,$e,Ge)=>we(Ge.requestingUrl)?$e(Se.has(Fe)):$e(!1)),b.session.defaultSession.setPermissionCheckHandler((Ce,Fe,$e,Ge)=>we(Ge.requestingUrl)?Se.has(Fe):!1);const be=new Set([u.Schemas.file,u.Schemas.vscodeFileResource,u.Schemas.vscodeRemoteResource,"devtools"]),ve=Ce=>{for(let Fe=Ce;Fe;Fe=Fe.parent)if(Fe.url.startsWith(`${u.Schemas.vscodeWebview}://`))return!0;return!1},Me=Ce=>Ce.resourceType==="xhr"||ve(Ce.frame),_e=Ce=>{const Fe=Ce.frame;if(!Fe||!this.windowsMainService)return!1;const $e=b.BrowserWindow.getAllWindows();for(const Ge of $e)if(Fe.processId===Ge.webContents.mainFrame.processId)return!0;return!1},Te=(Ce,Fe)=>{if(Ce.path!=="/index.html")return!0;const $e=Fe.frame;if(!$e||!this.windowsMainService)return!1;for(const Ge of this.windowsMainService.getWindows())if(Ge.win&&$e.processId===Ge.win.webContents.mainFrame.processId)return!0;return!1};b.session.defaultSession.webRequest.onBeforeRequest((Ce,Fe)=>{const $e=p.URI.parse(Ce.url);return $e.scheme===u.Schemas.vscodeWebview&&!Te($e,Ce)?(this.logService.error("Blocked vscode-webview request",Ce.url),Fe({cancel:!0})):$e.scheme===u.Schemas.vscodeFileResource&&!_e(Ce)?(this.logService.error("Blocked vscode-file request",Ce.url),Fe({cancel:!0})):$e.path.endsWith(".svg")&&!be.has($e.scheme)?Fe({cancel:!Me(Ce)}):Fe({cancel:!1})}),b.session.defaultSession.webRequest.onHeadersReceived((Ce,Fe)=>{const $e=Ce.responseHeaders,Ge=$e["content-type"]||$e["Content-Type"];if(Ge&&Array.isArray(Ge)){const nt=p.URI.parse(Ce.url);if(nt.path.endsWith(".svg")&&be.has(nt.scheme))return $e["Content-Type"]=["image/svg+xml"],Fe({cancel:!1,responseHeaders:$e});if(!nt.path.endsWith(u.Schemas.vscodeRemoteResource)&&Ge.some(ht=>ht.toLowerCase().includes("image/svg")))return Fe({cancel:!Me(Ce)})}return Fe({cancel:!1})});const We=b.session.defaultSession;typeof We.setCodeCachePath=="function"&&this.environmentMainService.codeCachePath&&We.setCodeCachePath((0,m.join)(this.environmentMainService.codeCachePath,"chrome"))}registerListeners(){(0,f.setUnexpectedErrorHandler)(be=>this.onUnexpectedError(be)),process.on("uncaughtException",be=>(0,f.onUnexpectedError)(be)),process.on("unhandledRejection",be=>(0,f.onUnexpectedError)(be)),this.lifecycleMainService.onWillShutdown(()=>this.dispose()),(0,l.registerContextMenuListener)(),b.app.on("accessibility-support-changed",(be,ve)=>{this.windowsMainService?.sendToAll("vscode:accessibilitySupportChanged",ve)}),b.app.on("activate",(be,ve)=>{this.logService.trace("app#activate"),ve||this.windowsMainService?.openEmptyWindow({context:1})}),b.app.on("web-contents-created",(be,ve)=>{ve.on("will-navigate",Me=>{this.logService.error("webContents#will-navigate: Prevented webcontent navigation"),Me.preventDefault()}),ve.setWindowOpenHandler(({url:Me})=>(this.nativeHostMainService?.openExternal(void 0,Me),{action:"deny"}))});let we=[],Se;b.app.on("open-file",(be,ve)=>{this.logService.trace("app#open-file: ",ve),be.preventDefault(),we.push(this.getWindowOpenableFromPathSync(ve)),Se!==void 0&&(clearTimeout(Se),Se=void 0),Se=setTimeout(()=>{this.windowsMainService?.open({context:1,cli:this.environmentMainService.args,urisToOpen:we,gotoLineMode:!1,preferNewWindow:!0}),we=[],Se=void 0},100)}),b.app.on("new-window-for-tab",()=>{this.windowsMainService?.openEmptyWindow({context:4})}),t.validatedIpcMain.handle("vscode:fetchShellEnv",be=>{const ve=this.windowsMainService?.getWindowByWebContents(be.sender);let Me,_e;return ve?.config?(Me=ve.config,_e={...process.env,...ve.config.userEnv}):(Me=this.environmentMainService.args,_e=process.env),this.resolveShellEnvironment(Me,_e,!1)}),t.validatedIpcMain.handle("vscode:writeNlsFile",(be,ve,Me)=>{const _e=this.validateNlsPath([ve]);if(!_e||typeof Me!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.fileService.writeFile(_e,D.VSBuffer.fromString(Me))}),t.validatedIpcMain.handle("vscode:readNlsFile",async(be,...ve)=>{const Me=this.validateNlsPath(ve);if(!Me)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.fileService.readFile(Me)).value.toString()}),t.validatedIpcMain.on("vscode:toggleDevTools",be=>be.sender.toggleDevTools()),t.validatedIpcMain.on("vscode:openDevTools",be=>be.sender.openDevTools()),t.validatedIpcMain.on("vscode:reloadWindow",be=>be.sender.reload())}validateNlsPath(we){let Se;for(const be of we)typeof be=="string"&&(typeof Se!="string"?Se=be:Se=(0,m.join)(Se,be));if(!(typeof Se!="string"||!(0,m.isAbsolute)(Se)||!(0,v.isEqualOrParent)(Se,this.environmentMainService.cachedLanguagesPath,!g.isLinux)))return p.URI.file(Se)}onUnexpectedError(we){if(we){const Se={message:`[uncaught exception in main]: ${we.message}`,stack:we.stack};this.windowsMainService?.sendToFocused("vscode:reportError",JSON.stringify(Se))}this.logService.error(`[uncaught exception in main]: ${we}`),we.stack&&this.logService.error(we.stack)}async startup(){this.logService.debug("Starting VS Code"),this.logService.debug(`from: ${this.environmentMainService.appRoot}`),this.logService.debug("args:",this.environmentMainService.args);const we=this.productService.win32AppUserModelId;g.isWindows&&we&&b.app.setAppUserModelId(we);try{g.isMacintosh&&this.configurationService.getValue("window.nativeTabs")===!0&&!b.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&b.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Ce){this.logService.error(Ce)}const Se=new r.Server;this.lifecycleMainService.onWillShutdown(Ce=>{Ce.reason===2&&Se.dispose()}),this.logService.trace("Resolving machine identifier...");const be=await this.resolveMachineId();this.logService.trace(`Resolved machine identifier: ${be}`);const{sharedProcess:ve,sharedProcessReady:Me,sharedProcessClient:_e}=this.setupSharedProcess(be),Te=await this.initServices(be,ve,Me);this._register(Te.createInstance(s.ProxyAuthHandler)),Te.invokeFunction(Ce=>this.initChannels(Ce,Se,_e));const We=Te.invokeFunction(Ce=>this.openFirstWindow(Ce,Se));Te.invokeFunction(Ce=>this.afterWindowOpen(Ce,ve)),this.environmentMainService.args.trace&&Te.invokeFunction(Ce=>this.stopTracingEventually(Ce,We))}async resolveMachineId(){let we=this.stateMainService.getItem(De.machineIdKey);return(!we||g.isMacintosh&&we==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(we=await(0,h.getMachineId)(),this.stateMainService.setItem(De.machineIdKey,we)),we}setupSharedProcess(we){const Se=this._register(this.mainInstantiationService.createInstance(Oe.SharedProcess,we,this.userEnv)),be=(async()=>{this.logService.trace("Main->SharedProcess#connect");const Me=await Se.connect();return this.logService.trace("Main->SharedProcess#connect: connection established"),new i.Client(Me,"main")})(),ve=(async()=>(await Se.whenReady(),be))();return{sharedProcess:Se,sharedProcessReady:ve,sharedProcessClient:be}}async initServices(we,Se,be){const ve=new V.ServiceCollection;switch(process.platform){case"win32":ve.set(Ae.IUpdateService,new O.SyncDescriptor(je.Win32UpdateService));break;case"linux":g.isLinuxSnap?ve.set(Ae.IUpdateService,new O.SyncDescriptor(ze.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):ve.set(Ae.IUpdateService,new O.SyncDescriptor(Ze.LinuxUpdateService));break;case"darwin":ve.set(Ae.IUpdateService,new O.SyncDescriptor(Qe.DarwinUpdateService));break}ve.set(qe.IWindowsMainService,new O.SyncDescriptor(it.WindowsMainService,[we,this.userEnv])),ve.set(q.IDialogMainService,new O.SyncDescriptor(q.DialogMainService)),ve.set(G.ILaunchMainService,new O.SyncDescriptor(G.LaunchMainService)),ve.set(F.IDiagnosticsMainService,new O.SyncDescriptor(F.DiagnosticsMainService)),ve.set(T.IDiagnosticsService,n.ProxyChannel.toService((0,n.getDelayedChannel)(be.then(_e=>_e.getChannel("diagnostics"))))),ve.set(_.IIssueMainService,new O.SyncDescriptor(_.IssueMainService,[this.userEnv])),ve.set(te.IEncryptionMainService,new O.SyncDescriptor(ne.EncryptionMainService,[we])),ve.set($.IKeyboardLayoutMainService,new O.SyncDescriptor($.KeyboardLayoutMainService)),ve.set(Pe.INativeHostMainService,new O.SyncDescriptor(Pe.NativeHostMainService,[Se])),ve.set(k.ICredentialsMainService,new O.SyncDescriptor(Tt.CredentialsNativeMainService)),ve.set(ye.IWebviewManagerService,new O.SyncDescriptor(Re.WebviewMainService)),ve.set(Xe.IWorkspacesService,new O.SyncDescriptor(at.WorkspacesMainService)),ve.set(ct.IWorkspacesManagementMainService,new O.SyncDescriptor(ct.WorkspacesManagementMainService)),ve.set(xe.IWorkspacesHistoryMainService,new O.SyncDescriptor(xe.WorkspacesHistoryMainService)),ve.set(fe.IMenubarMainService,new O.SyncDescriptor(fe.MenubarMainService)),ve.set(H.IExtensionUrlTrustService,new O.SyncDescriptor(oe.ExtensionUrlTrustService)),ve.set(W.IExtensionHostStarter,new O.SyncDescriptor(U.ExtensionHostStarter)),ve.set(pe.IStorageMainService,new O.SyncDescriptor(pe.StorageMainService)),ve.set(pe.IApplicationStorageMainService,new O.SyncDescriptor(pe.ApplicationStorageMainService)),g.isWindows?ve.set(B.IExternalTerminalMainService,new O.SyncDescriptor(X.WindowsExternalTerminalService)):g.isMacintosh?ve.set(B.IExternalTerminalMainService,new O.SyncDescriptor(X.MacExternalTerminalService)):g.isLinux&&ve.set(B.IExternalTerminalMainService,new O.SyncDescriptor(X.LinuxExternalTerminalService));const Me=new c.BackupMainService(this.environmentMainService,this.configurationService,this.logService);if(ve.set(a.IBackupMainService,Me),ve.set(K.IURLService,new O.SyncDescriptor(ue.NativeURLService)),(0,Be.supportsTelemetry)(this.productService,this.environmentMainService)){const _e=(0,n.getDelayedChannel)(be.then($e=>$e.getChannel("telemetryAppender"))),Te=new Je.TelemetryAppenderClient(_e),We=(0,Ie.resolveCommonProperties)(this.fileService,(0,L.release)(),(0,L.hostname)(),process.arch,this.productService.commit,this.productService.version,we,this.productService.msftInternalDomains,this.environmentMainService.installSourcePath),Ce=(0,Be.getPiiPathsFromEnvironment)(this.environmentMainService),Fe={appenders:[Te],commonProperties:We,piiPaths:Ce,sendErrorTelemetry:!0};ve.set(De.ITelemetryService,new O.SyncDescriptor(Le.TelemetryService,[Fe]))}else ve.set(De.ITelemetryService,Be.NullTelemetryService);return await Me.initialize(),this.mainInstantiationService.createChild(ve)}initChannels(we,Se,be){const ve=n.ProxyChannel.fromService(we.get(G.ILaunchMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("launch",ve);const Me=n.ProxyChannel.fromService(we.get(F.IDiagnosticsMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("diagnostics",Me);const _e=new Ot.PolicyChannel(we.get(Wt.IPolicyService));Se.registerChannel("policy",_e),be.then(Ve=>Ve.registerChannel("policy",_e));const Te=this.fileService.getProvider(u.Schemas.file);(0,I.assertType)(Te instanceof A.DiskFileSystemProvider);const We=new x.DiskFileSystemProviderChannel(Te,this.logService,this.environmentMainService);Se.registerChannel(j.LOCAL_FILE_SYSTEM_CHANNEL_NAME,We),be.then(Ve=>Ve.registerChannel(j.LOCAL_FILE_SYSTEM_CHANNEL_NAME,We));const Ce=n.ProxyChannel.fromService(we.get(Ft.IUserDataProfilesMainService));Se.registerChannel("userDataProfiles",Ce),be.then(Ve=>Ve.registerChannel("userDataProfiles",Ce));const Fe=new Ye.UpdateChannel(we.get(Ae.IUpdateService));Se.registerChannel("update",Fe);const $e=n.ProxyChannel.fromService(we.get(_.IIssueMainService));Se.registerChannel("issue",$e);const Ge=n.ProxyChannel.fromService(we.get(te.IEncryptionMainService));Se.registerChannel("encryption",Ge);const nt=n.ProxyChannel.fromService(we.get(k.ICredentialsMainService));Se.registerChannel("credentials",nt);const ht=n.ProxyChannel.fromService(we.get(Ue.ISignService));Se.registerChannel("sign",ht);const Ct=n.ProxyChannel.fromService(we.get($.IKeyboardLayoutMainService));Se.registerChannel("keyboardLayout",Ct),this.nativeHostMainService=we.get(Pe.INativeHostMainService);const Ke=n.ProxyChannel.fromService(this.nativeHostMainService);Se.registerChannel("nativeHost",Ke),be.then(Ve=>Ve.registerChannel("nativeHost",Ke));const wt=n.ProxyChannel.fromService(we.get(Xe.IWorkspacesService));Se.registerChannel("workspaces",wt);const dt=n.ProxyChannel.fromService(we.get(fe.IMenubarMainService));Se.registerChannel("menubar",dt);const ft=n.ProxyChannel.fromService(we.get(K.IURLService));Se.registerChannel("url",ft);const pt=n.ProxyChannel.fromService(we.get(H.IExtensionUrlTrustService));Se.registerChannel("extensionUrlTrust",pt);const vt=n.ProxyChannel.fromService(we.get(ye.IWebviewManagerService));Se.registerChannel("webview",vt);const lt=this._register(new he.StorageDatabaseChannel(this.logService,we.get(pe.IStorageMainService)));Se.registerChannel("storage",lt),be.then(Ve=>Ve.registerChannel("storage",lt));const gt=n.ProxyChannel.fromService(we.get(B.IExternalTerminalMainService));Se.registerChannel("externalTerminal",gt);const mt=new me.LogLevelChannel(we.get(ae.ILogService));Se.registerChannel("logLevel",mt),be.then(Ve=>Ve.registerChannel("logLevel",mt));const Ne=new me.LoggerChannel(we.get(ae.ILoggerService));Se.registerChannel("logger",Ne),be.then(Ve=>Ve.registerChannel("logger",Ne));const rt=new M.ElectronExtensionHostDebugBroadcastChannel(we.get(qe.IWindowsMainService));Se.registerChannel("extensionhostdebugservice",rt);const ot=n.ProxyChannel.fromService(we.get(W.IExtensionHostStarter));Se.registerChannel(W.ipcExtensionHostStarterChannelName,ot)}openFirstWindow(we,Se){const be=this.windowsMainService=we.get(qe.IWindowsMainService),ve=we.get(K.IURLService),Me=we.get(Pe.INativeHostMainService);this.lifecycleMainService.phase=2;const _e=[],Te=[...this.environmentMainService.args["open-url"]?this.environmentMainService.args._urls||[]:[],...global.getOpenUrls()||[]].map(Ne=>{try{return{uri:p.URI.parse(Ne),url:Ne}}catch{return}}).filter(Ne=>{if(!Ne||this.shouldBlockURI(Ne.uri))return!1;const rt=this.getWindowOpenableFromProtocolLink(Ne.uri);return rt?(_e.push(rt),!1):!0}),We=this,Ce=this.environmentMainService,Fe=this.productService,$e=this.logService;ve.registerHandler({async handleURL(Ne,rt){if($e.trace("app#handleURL: ",Ne.toString(!0),rt),Ne.scheme===Fe.urlProtocol&&Ne.path==="workspace"&&(Ne=Ne.with({authority:"file",path:p.URI.parse(Ne.query).path,query:""})),We.shouldBlockURI(Ne))return!0;let ot=!1;const Ve=new URLSearchParams(Ne.query);Ve.get("windowId")==="_blank"&&(Ve.delete("windowId"),Ne=Ne.with({query:Ve.toString()}),ot=!0),ot||(ot=g.isMacintosh&&be.getWindowCount()===0),Ve.get("editSessionId")!==null&&(Ce.editSessionId=Ve.get("editSessionId")??void 0,Ve.delete("editSessionId"),Ne=Ne.with({query:Ve.toString()}));const Pt=We.getWindowOpenableFromProtocolLink(Ne);if($e.trace("app#handleURL: windowOpenableFromProtocolLink = ",Pt),Pt){const[It]=be.open({context:5,cli:{...Ce.args},urisToOpen:[Pt],forceNewWindow:ot,gotoLineMode:!0});return It.focus(),!0}if(ot){const[It]=be.open({context:5,cli:{...Ce.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,ke.getRemoteAuthority)(Ne)});return await It.ready(),ve.open(Ne,rt)}return!1}});const Ge=this._register(new et.ActiveWindowManager({onDidOpenWindow:Me.onDidOpenWindow,onDidFocusWindow:Me.onDidFocusWindow,getActiveWindowId:()=>Me.getActiveWindowId(-1)})),nt=new n.StaticRouter(Ne=>Ge.getActiveClientId().then(rt=>Ne===rt)),ht=new re.URLHandlerRouter(nt),Ct=Se.getChannel("urlHandler",ht);ve.registerHandler(new re.URLHandlerChannelClient(Ct)),this._register(new ge.ElectronURLListener(Te,ve,be,this.environmentMainService,this.productService));const Ke=this.environmentMainService.args,wt=global.macOpenFiles,dt=(0,se.isLaunchedFromCli)(process.env)?0:4,ft=Ke._.length,pt=!!Ke["folder-uri"],vt=!!Ke["file-uri"],lt=Ke["skip-add-to-recently-opened"]===!0,gt=Ke.wait&&Ke.waitMarkerFilePath?p.URI.file(Ke.waitMarkerFilePath):void 0,mt=Ke.remote||void 0;return _e.length>0?be.open({context:dt,cli:Ke,urisToOpen:_e,gotoLineMode:!0,initialStartup:!0}):Ke["new-window"]&&!ft&&!pt&&!vt?be.open({context:dt,cli:Ke,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:lt,waitMarkerFileURI:gt,initialStartup:!0,remoteAuthority:mt}):wt.length&&!ft&&!pt&&!vt?be.open({context:1,cli:Ke,urisToOpen:wt.map(Ne=>this.getWindowOpenableFromPathSync(Ne)),noRecentEntry:lt,waitMarkerFileURI:gt,initialStartup:!0}):be.open({context:dt,cli:Ke,forceNewWindow:Ke["new-window"]||!ft&&Ke["unity-launch"],diffMode:Ke.diff,noRecentEntry:lt,waitMarkerFileURI:gt,gotoLineMode:Ke.goto,initialStartup:!0,remoteAuthority:mt})}shouldBlockURI(we){return!!(we.authority===u.Schemas.file&&g.isWindows&&b.dialog.showMessageBoxSync({title:this.productService.nameLong,type:"question",buttons:[(0,S.mnemonicButtonLabel)((0,o.localize)(0,null)),(0,S.mnemonicButtonLabel)((0,o.localize)(1,null))],defaultId:0,cancelId:1,message:(0,o.localize)(2,null,(0,S.getPathLabel)(we,{os:g.OS,tildify:this.environmentMainService}),this.productService.nameShort),detail:(0,o.localize)(3,null),noLink:!0})===1)}getWindowOpenableFromProtocolLink(we){if(!!we.path){if(we.authority===u.Schemas.file){const Se=p.URI.file(we.fsPath);return(0,He.hasWorkspaceFileExtension)(Se)?{workspaceUri:Se}:{fileUri:Se}}else if(we.authority===u.Schemas.vscodeRemote){const Se=we.path.indexOf(m.posix.sep,1);if(Se!==-1){const be=we.path.substring(1,Se),ve=we.path.substring(Se),Me=p.URI.from({scheme:u.Schemas.vscodeRemote,authority:be,path:ve,query:we.query,fragment:we.fragment});return(0,He.hasWorkspaceFileExtension)(ve)?{workspaceUri:Me}:/:[\d]+$/.test(ve)?{fileUri:Me}:{folderUri:Me}}}}}getWindowOpenableFromPathSync(we){try{if((0,R.statSync)(we).isDirectory())return{folderUri:p.URI.file(we)};if((0,He.hasWorkspaceFileExtension)(we))return{workspaceUri:p.URI.file(we)}}catch{}return{fileUri:p.URI.file(we)}}async afterWindowOpen(we,Se){this.lifecycleMainService.phase=3;let be=!1;(0,E.once)(this.lifecycleMainService.onWillShutdown)(()=>be=!0);const ve=we.get(De.ITelemetryService);this._register(Se.onDidError(({type:Te,details:We})=>{let Ce;switch(Te){case 1:Ce="SharedProcess: detected unresponsive window";break;case 2:Ce=`SharedProcess: crashed (detail: ${We?.reason??"<unknown>"}, code: ${We?.exitCode??"<unknown>"})`;break;case 3:Ce=`SharedProcess: failed to load (detail: ${We?.reason??"<unknown>"}, code: ${We?.exitCode??"<unknown>"})`;break}(0,f.onUnexpectedError)(new Error(Ce)),ve.publicLog2("sharedprocesserror",{type:Te,reason:We?.reason,code:We?.exitCode,visible:Se.isVisible(),shuttingdown:be})}));const Me=this.productService.win32MutexName;if(g.isWindows&&Me)try{const Te=z.__$__nodeRequire("windows-mutex").Mutex,We=new Te(Me);(0,E.once)(this.lifecycleMainService.onWillShutdown)(()=>We.release())}catch(Te){this.logService.error(Te)}b.protocol.registerHttpProtocol(u.Schemas.vscodeRemoteResource,(Te,We)=>{We({url:Te.url.replace(/^vscode-remote-resource:/,"http:"),method:Te.method})});const _e=we.get(Ae.IUpdateService);(_e instanceof je.Win32UpdateService||_e instanceof Ze.LinuxUpdateService||_e instanceof Qe.DarwinUpdateService)&&_e.initialize(),this.resolveShellEnvironment(this.environmentMainService.args,process.env,!0);try{const We=(await this.fileService.readFile(this.environmentMainService.argvResource)).value.toString();if(JSON.parse((0,P.stripComments)(We))["enable-crash-reporter"]===void 0){const $e=(0,Be.getTelemetryLevel)(this.configurationService)>=1,Ge=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${$e},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,d.generateUuid)()}"`,"}"],nt=We.substring(0,We.length-2).concat(`,
`,Ge.join(`
`));await this.fileService.writeFile(this.environmentMainService.argvResource,D.VSBuffer.fromString(nt))}}catch(Te){this.logService.error(Te)}}async resolveShellEnvironment(we,Se,be){try{return await(0,ce.getResolvedShellEnv)(this.logService,we,Se)}catch(ve){const Me=(0,y.toErrorMessage)(ve);be?this.windowsMainService?.sendToFocused("vscode:showResolveShellEnvError",Me):this.logService.error(Me)}return{}}stopTracingEventually(we,Se){this.logService.info("Tracing: waiting for windows to get ready...");const be=we.get(q.IDialogMainService);let ve=!1;const Me=async Te=>{if(ve)return;ve=!0;const We=await b.contentTracing.stopRecording(`${(0,v.randomPath)(this.environmentMainService.userHome.fsPath,this.productService.applicationName)}.trace.txt`);Te?this.logService.info(`Tracing: data recorded (after 30s timeout) to ${We}`):be.showMessageBox({title:this.productService.nameLong,type:"info",message:(0,o.localize)(4,null),detail:(0,o.localize)(5,null,We),buttons:[(0,S.mnemonicButtonLabel)((0,o.localize)(6,null))],defaultId:0,noLink:!0},(0,I.withNullAsUndefined)(b.BrowserWindow.getFocusedWindow()))},_e=setTimeout(()=>Me(!0),3e4);Promise.all(Se.map(Te=>Te.ready())).then(()=>{clearTimeout(_e),Me(!1)})}};Et=de([ee(2,N.IInstantiationService),ee(3,ae.ILogService),ee(4,Q.IEnvironmentMainService),ee(5,ie.ILifecycleMainService),ee(6,C.IConfigurationService),ee(7,le.IStateMainService),ee(8,Y.IFileService),ee(9,Ee.IProductService)],Et),e.CodeApplication=Et}),define(J[262],Z([0,1,14,28,7,25,8,41,18,29,48,34,11,9,70,4,36,31,23,43,88,256,10,17,203,214,26,55,176,15,191,84,67,188,83,21,102,6,196,103,57,20,58,226,106,245,60,243,85,208,45,212,72,61,75,37,238,198,2,73,222,40,220]),function(z,e,b,t,R,L,D,y,f,v,E,P,S,w,u,m,g,I,p,d,h,l,n,r,i,s,o,a,c,C,k,M,T,F,q,te,ne,Q,se,ce,H,oe,W,U,B,X,j,Y,x,A,O,N,V,_,$,G,ie,ae,me,fe,Pe,Ee){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class ke{main(){try{this.startup()}catch(le){console.error(le.message),b.app.exit(1)}}async startup(){(0,f.setUnexpectedErrorHandler)(Ae=>console.error(Ae));const[le,he,pe,Ie,De,Je,Le,Be]=this.createServices();try{try{await this.initServices(pe,Be,Ie,De)}catch(Ae){throw this.handleStartupDataDirError(pe,Le.nameLong,Ae),Ae}await le.invokeFunction(async Ae=>{const Ye=Ae.get(Q.ILogService),Qe=Ae.get(te.ILifecycleMainService),Ze=Ae.get(C.IFileService),ze=await this.claimInstance(Ye,pe,Qe,le,Le,!0);return p.Promises.writeFile(pe.mainLockfile,String(process.pid)).catch(je=>{Ye.warn(`Error writing main lockfile: ${je.stack}`)}),Je.logger=new ce.SpdLogLogger("main",(0,w.join)(pe.logsPath,"main.log"),!0,!1,Je.getLevel()),(0,E.once)(Qe.onWillShutdown)(je=>{Ze.dispose(),Ie.dispose(),je.join(p.Promises.unlink(pe.mainLockfile).catch(()=>{}))}),le.createInstance(l.CodeApplication,ze,he).startup()})}catch(Ae){le.invokeFunction(this.quit,Ae)}}createServices(){const le=new q.ServiceCollection,he=new me.DisposableStore;process.once("exit",()=>he.dispose());const pe={_serviceBrand:void 0,...H.default};le.set(oe.IProductService,pe);const Ie=new o.EnvironmentMainService(this.resolveArgs(),pe),De=this.patchEnvironment(Ie);le.set(o.IEnvironmentMainService,Ie);const Je=new ne.BufferLogService,Le=he.add(new Q.MultiplexLogService([new Q.ConsoleMainLogger((0,Q.getLogLevel)(Ie)),Je]));le.set(Q.ILogService,Le);const Be=new k.FileService(Le);le.set(C.IFileService,Be);const Ae=new M.DiskFileSystemProvider(Le);Be.registerProvider(S.Schemas.file,Ae);const Ye=new Pe.UriIdentityService(Be);le.set(fe.IUriIdentityService,Ye),le.set(Q.ILoggerService,new se.LoggerService(Le,Be));const Qe=new N.StateMainService(Ie,Le,Be);le.set(O.IStateMainService,Qe);const Ze=new $.UserDataProfilesMainService(Qe,Ye,Ie,Be,Le);le.set($.IUserDataProfilesMainService,Ze);const ze=m.isWindows&&pe.win32RegValueName?he.add(new ie.NativePolicyService(pe.win32RegValueName)):Ie.policyFile?he.add(new ae.FilePolicyService(Ie.policyFile,Be,Le)):new G.NullPolicyService;le.set(G.IPolicyService,ze);const je=new i.ConfigurationService(Ze.defaultProfile.settingsResource,Be,ze,Le);return le.set(r.IConfigurationService,je),le.set(te.ILifecycleMainService,new T.SyncDescriptor(te.LifecycleMainService)),le.set(j.IRequestService,new T.SyncDescriptor(Y.RequestMainService)),le.set(_.IThemeMainService,new T.SyncDescriptor(_.ThemeMainService)),le.set(x.ISignService,new T.SyncDescriptor(A.SignService)),le.set(B.ITunnelService,new T.SyncDescriptor(X.TunnelService)),le.set(W.IProtocolMainService,new T.SyncDescriptor(U.ProtocolMainService)),[new F.InstantiationService(le,!0),De,Ie,je,Qe,Je,pe,Ze]}patchEnvironment(le){const he={VSCODE_IPC_HOOK:le.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(pe=>{const Ie=process.env[pe];typeof Ie=="string"&&(he[pe]=Ie)}),Object.assign(process.env,he),he}async initServices(le,he,pe,Ie){await D.Promises.settled([Promise.all([le.extensionsPath,le.codeCachePath,le.logsPath,he.defaultProfile.globalStorageHome.fsPath,le.workspaceStorageHome.fsPath,le.localHistoryHome.fsPath,le.backupHome].map(De=>De?p.Promises.mkdir(De,{recursive:!0}):void 0)),Ie.init(),pe.initialize()]),he.setEnablement(!!pe.getValue(Ee.PROFILES_ENABLEMENT_CONFIG))}async claimInstance(le,he,pe,Ie,De,Je){let Le;try{(0,u.mark)("code/willStartMainServer"),Le=await(0,h.serve)(he.mainIPCHandle),(0,u.mark)("code/didStartMainServer"),(0,E.once)(pe.onWillShutdown)(()=>Le.dispose())}catch(Be){if(Be.code!=="EADDRINUSE")throw this.handleStartupDataDirError(he,De.nameLong,Be),Be;let Ae;try{Ae=await(0,h.connect)(he.mainIPCHandle,"main")}catch(ze){if(!Je||m.isWindows||ze.code!=="ECONNREFUSED")throw ze.code==="EPERM"&&this.showStartupWarningDialog((0,n.localize)(0,null,De.nameShort),(0,n.localize)(1,null),De.nameLong),ze;try{(0,t.unlinkSync)(he.mainIPCHandle)}catch(je){throw le.warn("Could not delete obsolete instance handle",je),je}return this.claimInstance(le,he,pe,Ie,De,!1)}if(he.extensionTestsLocationURI&&!he.debugExtensionHost.break){const ze="Running extension tests from the command line is currently only supported if no other instance of Code is running.";throw le.error(ze),Ae.dispose(),new Error(ze)}let Ye;!he.args.wait&&!he.args.status&&(Ye=setTimeout(()=>{this.showStartupWarningDialog((0,n.localize)(2,null,De.nameShort),(0,n.localize)(3,null),De.nameLong)},1e4));const Qe=d.ProxyChannel.toService(Ae.getChannel("launch"),{disableMarshalling:!0}),Ze=d.ProxyChannel.toService(Ae.getChannel("diagnostics"),{disableMarshalling:!0});if(he.args.status)return Ie.invokeFunction(async()=>{const ze=new s.DiagnosticsService(V.NullTelemetryService,De),je=await Qe.getMainProcessInfo(),K=await Ze.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),re=await ze.getDiagnostics(je,K);throw console.log(re),new f.ExpectedError});throw m.isWindows&&await this.windowsAllowSetForegroundWindow(Qe,le),le.trace("Sending env to running instance..."),await Qe.start(he.args,process.env),Ae.dispose(),Ye&&clearTimeout(Ye),new f.ExpectedError("Sent env to running instance. Terminating...")}if(he.args.status)throw le.warn("Warning: The --status argument can only be used if Code is already running. Please run it again after Code has started."),new f.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),Le}handleStartupDataDirError(le,he,pe){if(pe.code==="EACCES"||pe.code==="EPERM"){const Ie=(0,L.coalesce)([le.userDataPath,le.extensionsPath,h.XDG_RUNTIME_DIR]).map(De=>(0,P.getPathLabel)(R.URI.file(De),{os:m.OS,tildify:le}));this.showStartupWarningDialog((0,n.localize)(4,null),(0,n.localize)(5,null,(0,y.toErrorMessage)(pe),Ie.join(`
`)),he)}}showStartupWarningDialog(le,he,pe){b.dialog.showMessageBoxSync({title:pe,type:"warning",buttons:[(0,P.mnemonicButtonLabel)((0,n.localize)(6,null))],message:le,detail:he,defaultId:0,noLink:!0})}async windowsAllowSetForegroundWindow(le,he){if(m.isWindows){const pe=await le.getMainProcessId();he.trace("Sending some foreground love to the running instance:",pe);try{(await new Promise((Ie,De)=>{z(["windows-foreground-love"],Ie,De)})).allowSetForegroundWindow(pe)}catch(Ie){he.error(Ie)}}}quit(le,he){const pe=le.get(Q.ILogService),Ie=le.get(te.ILifecycleMainService);let De=0;he&&(he.isExpected?he.message&&pe.trace(he.message):(De=1,he.stack?pe.error(he.stack):pe.error(`Startup error: ${he.toString()}`))),Ie.kill(De)}resolveArgs(){const le=this.validatePaths((0,a.parseMainProcessArgv)(process.argv));if(le.wait&&!le.waitMarkerFilePath){const he=(0,c.createWaitMarkerFile)(le.verbose);he&&((0,a.addArg)(process.argv,"--waitMarkerFilePath",he),le.waitMarkerFilePath=he)}return le}validatePaths(le){if(le["open-url"]&&(le._urls=le._,le._=[]),!le.remote){const he=this.doValidatePaths(le._,le.goto);le._=he}return le}doValidatePaths(le,he){const pe=(0,g.cwd)(),Ie=le.map(Le=>{let Be=String(Le),Ae;he&&(Ae=(0,v.parseLineAndColumnAware)(Be),Be=Ae.path),Be&&(Be=this.preparePath(pe,Be));const Ye=(0,v.sanitizeFilePath)(Be,pe),Qe=(0,w.basename)(Ye);return Qe&&!(0,v.isValidBasename)(Qe)?null:he&&Ae?(Ae.path=Ye,this.toPath(Ae)):Ye}),De=m.isWindows||m.isMacintosh,Je=(0,L.distinct)(Ie,Le=>Le&&De?Le.toLowerCase():Le||"");return(0,L.coalesce)(Je)}preparePath(le,he){return m.isWindows&&(he=(0,I.rtrim)(he,'"')),he=(0,I.trim)((0,I.trim)(he," "),"	"),m.isWindows&&(he=(0,w.resolve)(le,he),he=(0,I.rtrim)(he,".")),he}toPath(le){const he=[le.path];return typeof le.line=="number"&&he.push(String(le.line)),typeof le.column=="number"&&he.push(String(le.column)),he.join(":")}}new ke().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/594ef48f32812d72d824ae855cb7a8be674f9704/core/vs/code/electron-main/main.js.map
