/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var De=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostTypes","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypeConverters","vs/base/common/types","vs/base/common/strings","vs/base/common/errors","vs/base/common/network","vs/base/common/async","vs/platform/log/common/log","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/path","vs/base/common/cancellation","vs/base/common/resources","vs/base/common/platform","vs/base/common/buffer","vs/base/common/map","vs/workbench/services/extensions/common/extensions","vs/base/common/objects","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/severity","vs/platform/registry/common/platform","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/glob","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostCommands","vs/base/common/extpath","vs/platform/contextkey/common/contextkey","vs/platform/files/common/files","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/services/search/common/search","vs/base/common/assert","vs/base/common/uuid","vs/base/common/errorMessage","vs/platform/workspace/common/workspace","vs/workbench/contrib/testing/common/testId","vs/workbench/contrib/testing/common/testTypes","vs/editor/common/core/range","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWebview","vs/base/common/decorators","vs/base/common/marshalling","vs/platform/instantiation/common/extensions","vs/platform/configuration/common/configuration","vs/platform/instantiation/common/serviceCollection","vs/base/common/process","vs/platform/theme/common/themeService","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/common/webview","vs/workbench/contrib/testing/common/testItemCollection","vs/editor/common/languages","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/collections","vs/base/common/idGenerator","vs/base/common/mime","vs/base/common/htmlContent","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostDecorations","vs/base/common/hash","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/stream","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/codicons","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/languageSelector","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/editor","vs/workbench/api/common/extHostCodeInsets","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/base/common/iterator","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/base/common/functional","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/base/common/lazy","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/base/common/stopwatch","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.common.services","vs/workbench/services/views/common/treeViewsService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/base/common/linkedList","vs/editor/common/core/position","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/model","vs/workbench/api/worker/extensionHostWorker"],Ce=function(J){for(var e=[],o=0,C=J.length;o<C;o++)e[o]=De[J[o]];return e};define(De[42],Ce([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function o(C,p){if(!C)throw new Error(p?`Assertion failed (${p})`:"Assertion Failed")}e.ok=o}),define(De[72],Ce([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.groupBy=e.forEach=void 0;function o(P,b){for(const[A,R]of Object.entries(P))if(b({key:A,value:R})===!1)return}e.forEach=o;function C(P,b){const A=Object.create(null);for(const R of P){const _=b(R);let m=A[_];m||(m=A[_]=[]),m.push(R)}return A}e.groupBy=C;function p(P,b){const A=[],R=[];for(const _ of P)b.has(_)||A.push(_);for(const _ of b)P.has(_)||R.push(_);return{removed:A,added:R}}e.diffSets=p;function U(P,b){const A=[],R=[];for(const[_,m]of P)b.has(_)||A.push(m);for(const[_,m]of b)P.has(_)||R.push(m);return{removed:A,added:R}}e.diffMaps=U;class I{constructor(){this.map=new Map}add(b,A){let R=this.map.get(b);R||(R=new Set,this.map.set(b,R)),R.add(A)}delete(b,A){const R=this.map.get(b);!R||(R.delete(A),R.size===0&&this.map.delete(b))}forEach(b,A){const R=this.map.get(b);!R||R.forEach(A)}}e.SetMap=I}),define(De[54],Ce([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function o(I){return(P,b,A)=>{let R=null,_=null;if(typeof A.value=="function"?(R="value",_=A.value):typeof A.get=="function"&&(R="get",_=A.get),!_)throw new Error("not supported");A[R]=I(_,b)}}e.createDecorator=o;function C(I,P,b){let A=null,R=null;if(typeof b.value=="function"?(A="value",R=b.value,R.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof b.get=="function"&&(A="get",R=b.get),!R)throw new Error("not supported");const _=`$memoize$${P}`;b[A]=function(...m){return this.hasOwnProperty(_)||Object.defineProperty(this,_,{configurable:!1,enumerable:!1,writable:!1,value:R.apply(this,m)}),this[_]}}e.memoize=C;function p(I,P,b){return o((A,R)=>{const _=`$debounce$${R}`,m=`$debounce$result$${R}`;return function(...T){this[m]||(this[m]=b?b():void 0),clearTimeout(this[_]),P&&(this[m]=P(this[m],...T),T=[this[m]]),this[_]=setTimeout(()=>{A.apply(this,T),this[m]=b?b():void 0},I)}})}e.debounce=p;function U(I,P,b){return o((A,R)=>{const _=`$throttle$timer$${R}`,m=`$throttle$result$${R}`,T=`$throttle$lastRun$${R}`,g=`$throttle$pending$${R}`;return function(...h){if(this[m]||(this[m]=b?b():void 0),(this[T]===null||this[T]===void 0)&&(this[T]=-Number.MAX_VALUE),P&&(this[m]=P(this[m],...h)),this[g])return;const u=this[T]+I;u<=Date.now()?(this[T]=Date.now(),A.apply(this,[this[m]]),this[m]=b?b():void 0):(this[g]=!0,this[_]=setTimeout(()=>{this[g]=!1,this[T]=Date.now(),A.apply(this,[this[m]]),this[m]=b?b():void 0},u-Date.now()))}})}e.throttle=U}),define(De[73],Ce([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class o{constructor(p){this._prefix=p,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=o,e.defaultGenerator=new o("id#")}),define(De[104],Ce([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var o;(function(r){r[r.None=0]="None",r[r.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=2]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",r[r.InvalidUnicode=4]="InvalidUnicode",r[r.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",r[r.InvalidCharacter=6]="InvalidCharacter"})(o=e.ScanError||(e.ScanError={}));var C;(function(r){r[r.OpenBraceToken=1]="OpenBraceToken",r[r.CloseBraceToken=2]="CloseBraceToken",r[r.OpenBracketToken=3]="OpenBracketToken",r[r.CloseBracketToken=4]="CloseBracketToken",r[r.CommaToken=5]="CommaToken",r[r.ColonToken=6]="ColonToken",r[r.NullKeyword=7]="NullKeyword",r[r.TrueKeyword=8]="TrueKeyword",r[r.FalseKeyword=9]="FalseKeyword",r[r.StringLiteral=10]="StringLiteral",r[r.NumericLiteral=11]="NumericLiteral",r[r.LineCommentTrivia=12]="LineCommentTrivia",r[r.BlockCommentTrivia=13]="BlockCommentTrivia",r[r.LineBreakTrivia=14]="LineBreakTrivia",r[r.Trivia=15]="Trivia",r[r.Unknown=16]="Unknown",r[r.EOF=17]="EOF"})(C=e.SyntaxKind||(e.SyntaxKind={}));var p;(function(r){r[r.InvalidSymbol=1]="InvalidSymbol",r[r.InvalidNumberFormat=2]="InvalidNumberFormat",r[r.PropertyNameExpected=3]="PropertyNameExpected",r[r.ValueExpected=4]="ValueExpected",r[r.ColonExpected=5]="ColonExpected",r[r.CommaExpected=6]="CommaExpected",r[r.CloseBraceExpected=7]="CloseBraceExpected",r[r.CloseBracketExpected=8]="CloseBracketExpected",r[r.EndOfFileExpected=9]="EndOfFileExpected",r[r.InvalidCommentToken=10]="InvalidCommentToken",r[r.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=12]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",r[r.InvalidUnicode=14]="InvalidUnicode",r[r.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",r[r.InvalidCharacter=16]="InvalidCharacter"})(p=e.ParseErrorCode||(e.ParseErrorCode={}));var U;(function(r){r.DEFAULT={allowTrailingComma:!0}})(U=e.ParseOptions||(e.ParseOptions={}));function I(r,d=!1){let i=0;const s=r.length;let n="",t=0,c=16,E=0;function f(O){let H=0,te=0;for(;H<O;){const z=r.charCodeAt(i);if(z>=48&&z<=57)te=te*16+z-48;else if(z>=65&&z<=70)te=te*16+z-65+10;else if(z>=97&&z<=102)te=te*16+z-97+10;else break;i++,H++}return H<O&&(te=-1),te}function D(O){i=O,n="",t=0,c=16,E=0}function L(){const O=i;if(r.charCodeAt(i)===48)i++;else for(i++;i<r.length&&A(r.charCodeAt(i));)i++;if(i<r.length&&r.charCodeAt(i)===46)if(i++,i<r.length&&A(r.charCodeAt(i)))for(i++;i<r.length&&A(r.charCodeAt(i));)i++;else return E=3,r.substring(O,i);let H=i;if(i<r.length&&(r.charCodeAt(i)===69||r.charCodeAt(i)===101))if(i++,(i<r.length&&r.charCodeAt(i)===43||r.charCodeAt(i)===45)&&i++,i<r.length&&A(r.charCodeAt(i))){for(i++;i<r.length&&A(r.charCodeAt(i));)i++;H=i}else E=3;return r.substring(O,H)}function W(){let O="",H=i;for(;;){if(i>=s){O+=r.substring(H,i),E=2;break}const te=r.charCodeAt(i);if(te===34){O+=r.substring(H,i),i++;break}if(te===92){if(O+=r.substring(H,i),i++,i>=s){E=2;break}switch(r.charCodeAt(i++)){case 34:O+='"';break;case 92:O+="\\";break;case 47:O+="/";break;case 98:O+="\b";break;case 102:O+="\f";break;case 110:O+=`
`;break;case 114:O+="\r";break;case 116:O+="	";break;case 117:{const $=f(4);$>=0?O+=String.fromCharCode($):E=4;break}default:E=5}H=i;continue}if(te>=0&&te<=31)if(b(te)){O+=r.substring(H,i),E=2;break}else E=6;i++}return O}function N(){if(n="",E=0,t=i,i>=s)return t=s,c=17;let O=r.charCodeAt(i);if(P(O)){do i++,n+=String.fromCharCode(O),O=r.charCodeAt(i);while(P(O));return c=15}if(b(O))return i++,n+=String.fromCharCode(O),O===13&&r.charCodeAt(i)===10&&(i++,n+=`
`),c=14;switch(O){case 123:return i++,c=1;case 125:return i++,c=2;case 91:return i++,c=3;case 93:return i++,c=4;case 58:return i++,c=6;case 44:return i++,c=5;case 34:return i++,n=W(),c=10;case 47:{const H=i-1;if(r.charCodeAt(i+1)===47){for(i+=2;i<s&&!b(r.charCodeAt(i));)i++;return n=r.substring(H,i),c=12}if(r.charCodeAt(i+1)===42){i+=2;const te=s-1;let z=!1;for(;i<te;){if(r.charCodeAt(i)===42&&r.charCodeAt(i+1)===47){i+=2,z=!0;break}i++}return z||(i++,E=1),n=r.substring(H,i),c=13}return n+=String.fromCharCode(O),i++,c=16}case 45:if(n+=String.fromCharCode(O),i++,i===s||!A(r.charCodeAt(i)))return c=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return n+=L(),c=11;default:for(;i<s&&v(O);)i++,O=r.charCodeAt(i);if(t!==i){switch(n=r.substring(t,i),n){case"true":return c=8;case"false":return c=9;case"null":return c=7}return c=16}return n+=String.fromCharCode(O),i++,c=16}}function v(O){if(P(O)||b(O))return!1;switch(O){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function F(){let O;do O=N();while(O>=12&&O<=15);return O}return{setPosition:D,getPosition:()=>i,scan:d?F:N,getToken:()=>c,getTokenValue:()=>n,getTokenOffset:()=>t,getTokenLength:()=>i-t,getTokenError:()=>E}}e.createScanner=I;function P(r){return r===32||r===9||r===11||r===12||r===160||r===5760||r>=8192&&r<=8203||r===8239||r===8287||r===12288||r===65279}function b(r){return r===10||r===13||r===8232||r===8233}function A(r){return r>=48&&r<=57}var R;(function(r){r[r.nullCharacter=0]="nullCharacter",r[r.maxAsciiCharacter=127]="maxAsciiCharacter",r[r.lineFeed=10]="lineFeed",r[r.carriageReturn=13]="carriageReturn",r[r.lineSeparator=8232]="lineSeparator",r[r.paragraphSeparator=8233]="paragraphSeparator",r[r.nextLine=133]="nextLine",r[r.space=32]="space",r[r.nonBreakingSpace=160]="nonBreakingSpace",r[r.enQuad=8192]="enQuad",r[r.emQuad=8193]="emQuad",r[r.enSpace=8194]="enSpace",r[r.emSpace=8195]="emSpace",r[r.threePerEmSpace=8196]="threePerEmSpace",r[r.fourPerEmSpace=8197]="fourPerEmSpace",r[r.sixPerEmSpace=8198]="sixPerEmSpace",r[r.figureSpace=8199]="figureSpace",r[r.punctuationSpace=8200]="punctuationSpace",r[r.thinSpace=8201]="thinSpace",r[r.hairSpace=8202]="hairSpace",r[r.zeroWidthSpace=8203]="zeroWidthSpace",r[r.narrowNoBreakSpace=8239]="narrowNoBreakSpace",r[r.ideographicSpace=12288]="ideographicSpace",r[r.mathematicalSpace=8287]="mathematicalSpace",r[r.ogham=5760]="ogham",r[r._=95]="_",r[r.$=36]="$",r[r._0=48]="_0",r[r._1=49]="_1",r[r._2=50]="_2",r[r._3=51]="_3",r[r._4=52]="_4",r[r._5=53]="_5",r[r._6=54]="_6",r[r._7=55]="_7",r[r._8=56]="_8",r[r._9=57]="_9",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.ampersand=38]="ampersand",r[r.asterisk=42]="asterisk",r[r.at=64]="at",r[r.backslash=92]="backslash",r[r.bar=124]="bar",r[r.caret=94]="caret",r[r.closeBrace=125]="closeBrace",r[r.closeBracket=93]="closeBracket",r[r.closeParen=41]="closeParen",r[r.colon=58]="colon",r[r.comma=44]="comma",r[r.dot=46]="dot",r[r.doubleQuote=34]="doubleQuote",r[r.equals=61]="equals",r[r.exclamation=33]="exclamation",r[r.greaterThan=62]="greaterThan",r[r.lessThan=60]="lessThan",r[r.minus=45]="minus",r[r.openBrace=123]="openBrace",r[r.openBracket=91]="openBracket",r[r.openParen=40]="openParen",r[r.percent=37]="percent",r[r.plus=43]="plus",r[r.question=63]="question",r[r.semicolon=59]="semicolon",r[r.singleQuote=39]="singleQuote",r[r.slash=47]="slash",r[r.tilde=126]="tilde",r[r.backspace=8]="backspace",r[r.formFeed=12]="formFeed",r[r.byteOrderMark=65279]="byteOrderMark",r[r.tab=9]="tab",r[r.verticalTab=11]="verticalTab"})(R||(R={}));function _(r,d){const i=[],s=new Object;let n;const t={value:{},offset:0,length:0,type:"object",parent:void 0};let c=!1;function E(f,D,L,W){t.value=f,t.offset=D,t.length=L,t.type=W,t.colonOffset=void 0,n=t}try{w(r,{onObjectBegin:(f,D)=>{if(d<=f)throw s;n=void 0,c=d>f,i.push("")},onObjectProperty:(f,D,L)=>{if(d<D||(E(f,D,L,"property"),i[i.length-1]=f,d<=D+L))throw s},onObjectEnd:(f,D)=>{if(d<=f)throw s;n=void 0,i.pop()},onArrayBegin:(f,D)=>{if(d<=f)throw s;n=void 0,i.push(0)},onArrayEnd:(f,D)=>{if(d<=f)throw s;n=void 0,i.pop()},onLiteralValue:(f,D,L)=>{if(d<D||(E(f,D,L,y(f)),d<=D+L))throw s},onSeparator:(f,D,L)=>{if(d<=D)throw s;if(f===":"&&n&&n.type==="property")n.colonOffset=D,c=!1,n=void 0;else if(f===","){const W=i[i.length-1];typeof W=="number"?i[i.length-1]=W+1:(c=!0,i[i.length-1]=""),n=void 0}}})}catch(f){if(f!==s)throw f}return{path:i,previousNode:n,isAtPropertyKey:c,matches:f=>{let D=0;for(let L=0;D<f.length&&L<i.length;L++)if(f[D]===i[L]||f[D]==="*")D++;else if(f[D]!=="**")return!1;return D===f.length}}}e.getLocation=_;function m(r,d=[],i=U.DEFAULT){let s=null,n=[];const t=[];function c(f){Array.isArray(n)?n.push(f):s!==null&&(n[s]=f)}return w(r,{onObjectBegin:()=>{const f={};c(f),t.push(n),n=f,s=null},onObjectProperty:f=>{s=f},onObjectEnd:()=>{n=t.pop()},onArrayBegin:()=>{const f=[];c(f),t.push(n),n=f,s=null},onArrayEnd:()=>{n=t.pop()},onLiteralValue:c,onError:(f,D,L)=>{d.push({error:f,offset:D,length:L})}},i),n[0]}e.parse=m;function T(r,d=[],i=U.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function n(f){s.type==="property"&&(s.length=f-s.offset,s=s.parent)}function t(f){return s.children.push(f),f}w(r,{onObjectBegin:f=>{s=t({type:"object",offset:f,length:-1,parent:s,children:[]})},onObjectProperty:(f,D,L)=>{s=t({type:"property",offset:D,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:f,offset:D,length:L,parent:s})},onObjectEnd:(f,D)=>{s.length=f+D-s.offset,s=s.parent,n(f+D)},onArrayBegin:(f,D)=>{s=t({type:"array",offset:f,length:-1,parent:s,children:[]})},onArrayEnd:(f,D)=>{s.length=f+D-s.offset,s=s.parent,n(f+D)},onLiteralValue:(f,D,L)=>{t({type:y(f),offset:D,length:L,parent:s,value:f}),n(D+L)},onSeparator:(f,D,L)=>{s.type==="property"&&(f===":"?s.colonOffset=D:f===","&&n(D))},onError:(f,D,L)=>{d.push({error:f,offset:D,length:L})}},i);const E=s.children[0];return E&&delete E.parent,E}e.parseTree=T;function g(r,d){if(!r)return;let i=r;for(const s of d)if(typeof s=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let n=!1;for(const t of i.children)if(Array.isArray(t.children)&&t.children[0].value===s){i=t.children[1],n=!0;break}if(!n)return}else{const n=s;if(i.type!=="array"||n<0||!Array.isArray(i.children)||n>=i.children.length)return;i=i.children[n]}return i}e.findNodeAtLocation=g;function h(r){if(!r.parent||!r.parent.children)return[];const d=h(r.parent);if(r.parent.type==="property"){const i=r.parent.children[0].value;d.push(i)}else if(r.parent.type==="array"){const i=r.parent.children.indexOf(r);i!==-1&&d.push(i)}return d}e.getNodePath=h;function u(r){switch(r.type){case"array":return r.children.map(u);case"object":{const d=Object.create(null);for(const i of r.children){const s=i.children[1];s&&(d[i.children[0].value]=u(s))}return d}case"null":case"string":case"number":case"boolean":return r.value;default:return}}e.getNodeValue=u;function l(r,d,i=!1){return d>=r.offset&&d<r.offset+r.length||i&&d===r.offset+r.length}e.contains=l;function S(r,d,i=!1){if(l(r,d,i)){const s=r.children;if(Array.isArray(s))for(let n=0;n<s.length&&s[n].offset<=d;n++){const t=S(s[n],d,i);if(t)return t}return r}}e.findNodeAtOffset=S;function w(r,d,i=U.DEFAULT){const s=I(r,!1);function n(Ee){return Ee?()=>Ee(s.getTokenOffset(),s.getTokenLength()):()=>!0}function t(Ee){return Ee?be=>Ee(be,s.getTokenOffset(),s.getTokenLength()):()=>!0}const c=n(d.onObjectBegin),E=t(d.onObjectProperty),f=n(d.onObjectEnd),D=n(d.onArrayBegin),L=n(d.onArrayEnd),W=t(d.onLiteralValue),N=t(d.onSeparator),v=n(d.onComment),F=t(d.onError),O=i&&i.disallowComments,H=i&&i.allowTrailingComma;function te(){for(;;){const Ee=s.scan();switch(s.getTokenError()){case 4:z(14);break;case 5:z(15);break;case 3:z(13);break;case 1:O||z(11);break;case 2:z(12);break;case 6:z(16);break}switch(Ee){case 12:case 13:O?z(10):v();break;case 16:z(1);break;case 15:case 14:break;default:return Ee}}}function z(Ee,be=[],Z=[]){if(F(Ee),be.length+Z.length>0){let ve=s.getToken();for(;ve!==17;){if(be.indexOf(ve)!==-1){te();break}else if(Z.indexOf(ve)!==-1)break;ve=te()}}}function $(Ee){const be=s.getTokenValue();return Ee?W(be):E(be),te(),!0}function ce(){switch(s.getToken()){case 11:{let Ee=0;try{Ee=JSON.parse(s.getTokenValue()),typeof Ee!="number"&&(z(2),Ee=0)}catch{z(2)}W(Ee);break}case 7:W(null);break;case 8:W(!0);break;case 9:W(!1);break;default:return!1}return te(),!0}function le(){return s.getToken()!==10?(z(3,[],[2,5]),!1):($(!1),s.getToken()===6?(N(":"),te(),re()||z(4,[],[2,5])):z(5,[],[2,5]),!0)}function oe(){c(),te();let Ee=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(Ee||z(4,[],[]),N(","),te(),s.getToken()===2&&H)break}else Ee&&z(6,[],[]);le()||z(4,[],[2,5]),Ee=!0}return f(),s.getToken()!==2?z(7,[2],[]):te(),!0}function pe(){D(),te();let Ee=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(Ee||z(4,[],[]),N(","),te(),s.getToken()===4&&H)break}else Ee&&z(6,[],[]);re()||z(4,[],[4,5]),Ee=!0}return L(),s.getToken()!==4?z(8,[4],[]):te(),!0}function re(){switch(s.getToken()){case 3:return pe();case 1:return oe();case 10:return $(!0);default:return ce()}}return te(),s.getToken()===17?i.allowEmptyContent?!0:(z(4,[],[]),!1):re()?(s.getToken()!==17&&z(9,[],[]),!0):(z(4,[],[]),!1)}e.visit=w;function a(r,d){const i=I(r),s=[];let n,t=0,c;do switch(c=i.getPosition(),n=i.scan(),n){case 12:case 13:case 17:t!==c&&s.push(r.substring(t,c)),d!==void 0&&s.push(i.getTokenValue().replace(/[^\r\n]/g,d)),t=i.getPosition();break}while(n!==17);return s.join("")}e.stripComments=a;function y(r){switch(typeof r){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(r){if(Array.isArray(r))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=y}),function(J,e){typeof exports=="object"&&typeof module!="undefined"?e(exports):typeof define=="function"&&define.amd?define(De[105],Ce([0]),e):(J=typeof globalThis!="undefined"?globalThis:J||self,e(J.marked={}))}(this,function(J){"use strict";function e(Ie,Se){for(var Te=0;Te<Se.length;Te++){var se=Se[Te];se.enumerable=se.enumerable||!1,se.configurable=!0,"value"in se&&(se.writable=!0),Object.defineProperty(Ie,se.key,se)}}function o(Ie,Se,Te){return Se&&e(Ie.prototype,Se),Te&&e(Ie,Te),Object.defineProperty(Ie,"prototype",{writable:!1}),Ie}function C(Ie,Se){if(!!Ie){if(typeof Ie=="string")return p(Ie,Se);var Te=Object.prototype.toString.call(Ie).slice(8,-1);if(Te==="Object"&&Ie.constructor&&(Te=Ie.constructor.name),Te==="Map"||Te==="Set")return Array.from(Ie);if(Te==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Te))return p(Ie,Se)}}function p(Ie,Se){(Se==null||Se>Ie.length)&&(Se=Ie.length);for(var Te=0,se=new Array(Se);Te<Se;Te++)se[Te]=Ie[Te];return se}function U(Ie,Se){var Te=typeof Symbol!="undefined"&&Ie[Symbol.iterator]||Ie["@@iterator"];if(Te)return(Te=Te.call(Ie)).next.bind(Te);if(Array.isArray(Ie)||(Te=C(Ie))||Se&&Ie&&typeof Ie.length=="number"){Te&&(Ie=Te);var se=0;return function(){return se>=Ie.length?{done:!0}:{done:!1,value:Ie[se++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function I(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}J.defaults=I();function P(Ie){J.defaults=Ie}var b=/[&<>"']/,A=/[&<>"']/g,R=/[<>"']|&(?!#?\w+;)/,_=/[<>"']|&(?!#?\w+;)/g,m={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},T=function(Se){return m[Se]};function g(Ie,Se){if(Se){if(b.test(Ie))return Ie.replace(A,T)}else if(R.test(Ie))return Ie.replace(_,T);return Ie}var h=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function u(Ie){return Ie.replace(h,function(Se,Te){return Te=Te.toLowerCase(),Te==="colon"?":":Te.charAt(0)==="#"?Te.charAt(1)==="x"?String.fromCharCode(parseInt(Te.substring(2),16)):String.fromCharCode(+Te.substring(1)):""})}var l=/(^|[^\[])\^/g;function S(Ie,Se){Ie=typeof Ie=="string"?Ie:Ie.source,Se=Se||"";var Te={replace:function(ae,G){return G=G.source||G,G=G.replace(l,"$1"),Ie=Ie.replace(ae,G),Te},getRegex:function(){return new RegExp(Ie,Se)}};return Te}var w=/[^\w:]/g,a=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function y(Ie,Se,Te){if(Ie){var se;try{se=decodeURIComponent(u(Te)).replace(w,"").toLowerCase()}catch{return null}if(se.indexOf("javascript:")===0||se.indexOf("vbscript:")===0||se.indexOf("data:")===0)return null}Se&&!a.test(Te)&&(Te=n(Se,Te));try{Te=encodeURI(Te).replace(/%25/g,"%")}catch{return null}return Te}var r={},d=/^[^:]+:\/*[^/]*$/,i=/^([^:]+:)[\s\S]*$/,s=/^([^:]+:\/*[^/]*)[\s\S]*$/;function n(Ie,Se){r[" "+Ie]||(d.test(Ie)?r[" "+Ie]=Ie+"/":r[" "+Ie]=f(Ie,"/",!0)),Ie=r[" "+Ie];var Te=Ie.indexOf(":")===-1;return Se.substring(0,2)==="//"?Te?Se:Ie.replace(i,"$1")+Se:Se.charAt(0)==="/"?Te?Se:Ie.replace(s,"$1")+Se:Ie+Se}var t={exec:function(){}};function c(Ie){for(var Se=1,Te,se;Se<arguments.length;Se++){Te=arguments[Se];for(se in Te)Object.prototype.hasOwnProperty.call(Te,se)&&(Ie[se]=Te[se])}return Ie}function E(Ie,Se){var Te=Ie.replace(/\|/g,function(G,X,k){for(var B=!1,V=X;--V>=0&&k[V]==="\\";)B=!B;return B?"|":" |"}),se=Te.split(/ \|/),ae=0;if(se[0].trim()||se.shift(),se.length>0&&!se[se.length-1].trim()&&se.pop(),se.length>Se)se.splice(Se);else for(;se.length<Se;)se.push("");for(;ae<se.length;ae++)se[ae]=se[ae].trim().replace(/\\\|/g,"|");return se}function f(Ie,Se,Te){var se=Ie.length;if(se===0)return"";for(var ae=0;ae<se;){var G=Ie.charAt(se-ae-1);if(G===Se&&!Te)ae++;else if(G!==Se&&Te)ae++;else break}return Ie.slice(0,se-ae)}function D(Ie,Se){if(Ie.indexOf(Se[1])===-1)return-1;for(var Te=Ie.length,se=0,ae=0;ae<Te;ae++)if(Ie[ae]==="\\")ae++;else if(Ie[ae]===Se[0])se++;else if(Ie[ae]===Se[1]&&(se--,se<0))return ae;return-1}function L(Ie){Ie&&Ie.sanitize&&!Ie.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function W(Ie,Se){if(Se<1)return"";for(var Te="";Se>1;)Se&1&&(Te+=Ie),Se>>=1,Ie+=Ie;return Te+Ie}function N(Ie,Se,Te,se){var ae=Se.href,G=Se.title?g(Se.title):null,X=Ie[1].replace(/\\([\[\]])/g,"$1");if(Ie[0].charAt(0)!=="!"){se.state.inLink=!0;var k={type:"link",raw:Te,href:ae,title:G,text:X,tokens:se.inlineTokens(X,[])};return se.state.inLink=!1,k}return{type:"image",raw:Te,href:ae,title:G,text:g(X)}}function v(Ie,Se){var Te=Ie.match(/^(\s+)(?:```)/);if(Te===null)return Se;var se=Te[1];return Se.split(`
`).map(function(ae){var G=ae.match(/^\s+/);if(G===null)return ae;var X=G[0];return X.length>=se.length?ae.slice(se.length):ae}).join(`
`)}var F=function(){function Ie(Te){this.options=Te||J.defaults}var Se=Ie.prototype;return Se.space=function(se){var ae=this.rules.block.newline.exec(se);if(ae&&ae[0].length>0)return{type:"space",raw:ae[0]}},Se.code=function(se){var ae=this.rules.block.code.exec(se);if(ae){var G=ae[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ae[0],codeBlockStyle:"indented",text:this.options.pedantic?G:f(G,`
`)}}},Se.fences=function(se){var ae=this.rules.block.fences.exec(se);if(ae){var G=ae[0],X=v(G,ae[3]||"");return{type:"code",raw:G,lang:ae[2]?ae[2].trim():ae[2],text:X}}},Se.heading=function(se){var ae=this.rules.block.heading.exec(se);if(ae){var G=ae[2].trim();if(/#$/.test(G)){var X=f(G,"#");(this.options.pedantic||!X||/ $/.test(X))&&(G=X.trim())}var k={type:"heading",raw:ae[0],depth:ae[1].length,text:G,tokens:[]};return this.lexer.inline(k.text,k.tokens),k}},Se.hr=function(se){var ae=this.rules.block.hr.exec(se);if(ae)return{type:"hr",raw:ae[0]}},Se.blockquote=function(se){var ae=this.rules.block.blockquote.exec(se);if(ae){var G=ae[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:ae[0],tokens:this.lexer.blockTokens(G,[]),text:G}}},Se.list=function(se){var ae=this.rules.block.list.exec(se);if(ae){var G,X,k,B,V,j,ne,ue,Y,ge,fe,Ne,ze=ae[1].trim(),ke=ze.length>1,qe={type:"list",raw:"",ordered:ke,start:ke?+ze.slice(0,-1):"",loose:!1,items:[]};ze=ke?"\\d{1,9}\\"+ze.slice(-1):"\\"+ze,this.options.pedantic&&(ze=ke?ze:"[*+-]");for(var K=new RegExp("^( {0,3}"+ze+")((?:[	 ][^\\n]*)?(?:\\n|$))");se&&(Ne=!1,!(!(ae=K.exec(se))||this.rules.block.hr.test(se)));){if(G=ae[0],se=se.substring(G.length),ue=ae[2].split(`
`,1)[0],Y=se.split(`
`,1)[0],this.options.pedantic?(B=2,fe=ue.trimLeft()):(B=ae[2].search(/[^ ]/),B=B>4?1:B,fe=ue.slice(B),B+=ae[1].length),j=!1,!ue&&/^ *$/.test(Y)&&(G+=Y+`
`,se=se.substring(Y.length+1),Ne=!0),!Ne)for(var Q=new RegExp("^ {0,"+Math.min(3,B-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),me=new RegExp("^ {0,"+Math.min(3,B-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)");se&&(ge=se.split(`
`,1)[0],ue=ge,this.options.pedantic&&(ue=ue.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Q.test(ue)||me.test(se)));){if(ue.search(/[^ ]/)>=B||!ue.trim())fe+=`
`+ue.slice(B);else if(!j)fe+=`
`+ue;else break;!j&&!ue.trim()&&(j=!0),G+=ge+`
`,se=se.substring(ge.length+1)}qe.loose||(ne?qe.loose=!0:/\n *\n *$/.test(G)&&(ne=!0)),this.options.gfm&&(X=/^\[[ xX]\] /.exec(fe),X&&(k=X[0]!=="[ ] ",fe=fe.replace(/^\[[ xX]\] +/,""))),qe.items.push({type:"list_item",raw:G,task:!!X,checked:k,loose:!1,text:fe}),qe.raw+=G}qe.items[qe.items.length-1].raw=G.trimRight(),qe.items[qe.items.length-1].text=fe.trimRight(),qe.raw=qe.raw.trimRight();var Le=qe.items.length;for(V=0;V<Le;V++){this.lexer.state.top=!1,qe.items[V].tokens=this.lexer.blockTokens(qe.items[V].text,[]);var Be=qe.items[V].tokens.filter(function(et){return et.type==="space"}),Ze=Be.every(function(et){for(var at=et.raw.split(""),Je=0,He=U(at),nt;!(nt=He()).done;){var st=nt.value;if(st===`
`&&(Je+=1),Je>1)return!0}return!1});!qe.loose&&Be.length&&Ze&&(qe.loose=!0,qe.items[V].loose=!0)}return qe}},Se.html=function(se){var ae=this.rules.block.html.exec(se);if(ae){var G={type:"html",raw:ae[0],pre:!this.options.sanitizer&&(ae[1]==="pre"||ae[1]==="script"||ae[1]==="style"),text:ae[0]};return this.options.sanitize&&(G.type="paragraph",G.text=this.options.sanitizer?this.options.sanitizer(ae[0]):g(ae[0]),G.tokens=[],this.lexer.inline(G.text,G.tokens)),G}},Se.def=function(se){var ae=this.rules.block.def.exec(se);if(ae){ae[3]&&(ae[3]=ae[3].substring(1,ae[3].length-1));var G=ae[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:G,raw:ae[0],href:ae[2],title:ae[3]}}},Se.table=function(se){var ae=this.rules.block.table.exec(se);if(ae){var G={type:"table",header:E(ae[1]).map(function(ne){return{text:ne}}),align:ae[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ae[3]&&ae[3].trim()?ae[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(G.header.length===G.align.length){G.raw=ae[0];var X=G.align.length,k,B,V,j;for(k=0;k<X;k++)/^ *-+: *$/.test(G.align[k])?G.align[k]="right":/^ *:-+: *$/.test(G.align[k])?G.align[k]="center":/^ *:-+ *$/.test(G.align[k])?G.align[k]="left":G.align[k]=null;for(X=G.rows.length,k=0;k<X;k++)G.rows[k]=E(G.rows[k],G.header.length).map(function(ne){return{text:ne}});for(X=G.header.length,B=0;B<X;B++)G.header[B].tokens=[],this.lexer.inline(G.header[B].text,G.header[B].tokens);for(X=G.rows.length,B=0;B<X;B++)for(j=G.rows[B],V=0;V<j.length;V++)j[V].tokens=[],this.lexer.inline(j[V].text,j[V].tokens);return G}}},Se.lheading=function(se){var ae=this.rules.block.lheading.exec(se);if(ae){var G={type:"heading",raw:ae[0],depth:ae[2].charAt(0)==="="?1:2,text:ae[1],tokens:[]};return this.lexer.inline(G.text,G.tokens),G}},Se.paragraph=function(se){var ae=this.rules.block.paragraph.exec(se);if(ae){var G={type:"paragraph",raw:ae[0],text:ae[1].charAt(ae[1].length-1)===`
`?ae[1].slice(0,-1):ae[1],tokens:[]};return this.lexer.inline(G.text,G.tokens),G}},Se.text=function(se){var ae=this.rules.block.text.exec(se);if(ae){var G={type:"text",raw:ae[0],text:ae[0],tokens:[]};return this.lexer.inline(G.text,G.tokens),G}},Se.escape=function(se){var ae=this.rules.inline.escape.exec(se);if(ae)return{type:"escape",raw:ae[0],text:g(ae[1])}},Se.tag=function(se){var ae=this.rules.inline.tag.exec(se);if(ae)return!this.lexer.state.inLink&&/^<a /i.test(ae[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ae[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ae[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ae[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ae[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ae[0]):g(ae[0]):ae[0]}},Se.link=function(se){var ae=this.rules.inline.link.exec(se);if(ae){var G=ae[2].trim();if(!this.options.pedantic&&/^</.test(G)){if(!/>$/.test(G))return;var X=f(G.slice(0,-1),"\\");if((G.length-X.length)%2==0)return}else{var k=D(ae[2],"()");if(k>-1){var B=ae[0].indexOf("!")===0?5:4,V=B+ae[1].length+k;ae[2]=ae[2].substring(0,k),ae[0]=ae[0].substring(0,V).trim(),ae[3]=""}}var j=ae[2],ne="";if(this.options.pedantic){var ue=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(j);ue&&(j=ue[1],ne=ue[3])}else ne=ae[3]?ae[3].slice(1,-1):"";return j=j.trim(),/^</.test(j)&&(this.options.pedantic&&!/>$/.test(G)?j=j.slice(1):j=j.slice(1,-1)),N(ae,{href:j&&j.replace(this.rules.inline._escapes,"$1"),title:ne&&ne.replace(this.rules.inline._escapes,"$1")},ae[0],this.lexer)}},Se.reflink=function(se,ae){var G;if((G=this.rules.inline.reflink.exec(se))||(G=this.rules.inline.nolink.exec(se))){var X=(G[2]||G[1]).replace(/\s+/g," ");if(X=ae[X.toLowerCase()],!X||!X.href){var k=G[0].charAt(0);return{type:"text",raw:k,text:k}}return N(G,X,G[0],this.lexer)}},Se.emStrong=function(se,ae,G){G===void 0&&(G="");var X=this.rules.inline.emStrong.lDelim.exec(se);if(!!X&&!(X[3]&&G.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var k=X[1]||X[2]||"";if(!k||k&&(G===""||this.rules.inline.punctuation.exec(G))){var B=X[0].length-1,V,j,ne=B,ue=0,Y=X[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(Y.lastIndex=0,ae=ae.slice(-1*se.length+B);(X=Y.exec(ae))!=null;)if(V=X[1]||X[2]||X[3]||X[4]||X[5]||X[6],!!V){if(j=V.length,X[3]||X[4]){ne+=j;continue}else if((X[5]||X[6])&&B%3&&!((B+j)%3)){ue+=j;continue}if(ne-=j,!(ne>0)){if(j=Math.min(j,j+ne+ue),Math.min(B,j)%2){var ge=se.slice(1,B+X.index+j);return{type:"em",raw:se.slice(0,B+X.index+j+1),text:ge,tokens:this.lexer.inlineTokens(ge,[])}}var fe=se.slice(2,B+X.index+j-1);return{type:"strong",raw:se.slice(0,B+X.index+j+1),text:fe,tokens:this.lexer.inlineTokens(fe,[])}}}}}},Se.codespan=function(se){var ae=this.rules.inline.code.exec(se);if(ae){var G=ae[2].replace(/\n/g," "),X=/[^ ]/.test(G),k=/^ /.test(G)&&/ $/.test(G);return X&&k&&(G=G.substring(1,G.length-1)),G=g(G,!0),{type:"codespan",raw:ae[0],text:G}}},Se.br=function(se){var ae=this.rules.inline.br.exec(se);if(ae)return{type:"br",raw:ae[0]}},Se.del=function(se){var ae=this.rules.inline.del.exec(se);if(ae)return{type:"del",raw:ae[0],text:ae[2],tokens:this.lexer.inlineTokens(ae[2],[])}},Se.autolink=function(se,ae){var G=this.rules.inline.autolink.exec(se);if(G){var X,k;return G[2]==="@"?(X=g(this.options.mangle?ae(G[1]):G[1]),k="mailto:"+X):(X=g(G[1]),k=X),{type:"link",raw:G[0],text:X,href:k,tokens:[{type:"text",raw:X,text:X}]}}},Se.url=function(se,ae){var G;if(G=this.rules.inline.url.exec(se)){var X,k;if(G[2]==="@")X=g(this.options.mangle?ae(G[0]):G[0]),k="mailto:"+X;else{var B;do B=G[0],G[0]=this.rules.inline._backpedal.exec(G[0])[0];while(B!==G[0]);X=g(G[0]),G[1]==="www."?k="http://"+X:k=X}return{type:"link",raw:G[0],text:X,href:k,tokens:[{type:"text",raw:X,text:X}]}}},Se.inlineText=function(se,ae){var G=this.rules.inline.text.exec(se);if(G){var X;return this.lexer.state.inRawBlock?X=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(G[0]):g(G[0]):G[0]:X=g(this.options.smartypants?ae(G[0]):G[0]),{type:"text",raw:G[0],text:X}}},Ie}(),O={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:t,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};O._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,O._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,O.def=S(O.def).replace("label",O._label).replace("title",O._title).getRegex(),O.bullet=/(?:[*+-]|\d{1,9}[.)])/,O.listItemStart=S(/^( *)(bull) */).replace("bull",O.bullet).getRegex(),O.list=S(O.list).replace(/bull/g,O.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+O.def.source+")").getRegex(),O._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",O._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,O.html=S(O.html,"i").replace("comment",O._comment).replace("tag",O._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),O.paragraph=S(O._paragraph).replace("hr",O.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",O._tag).getRegex(),O.blockquote=S(O.blockquote).replace("paragraph",O.paragraph).getRegex(),O.normal=c({},O),O.gfm=c({},O.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),O.gfm.table=S(O.gfm.table).replace("hr",O.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",O._tag).getRegex(),O.gfm.paragraph=S(O._paragraph).replace("hr",O.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",O.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",O._tag).getRegex(),O.pedantic=c({},O.normal,{html:S(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",O._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:t,paragraph:S(O.normal._paragraph).replace("hr",O.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",O.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var H={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:t,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:t,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};H._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",H.punctuation=S(H.punctuation).replace(/punctuation/g,H._punctuation).getRegex(),H.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,H.escapedEmSt=/\\\*|\\_/g,H._comment=S(O._comment).replace("(?:-->|$)","-->").getRegex(),H.emStrong.lDelim=S(H.emStrong.lDelim).replace(/punct/g,H._punctuation).getRegex(),H.emStrong.rDelimAst=S(H.emStrong.rDelimAst,"g").replace(/punct/g,H._punctuation).getRegex(),H.emStrong.rDelimUnd=S(H.emStrong.rDelimUnd,"g").replace(/punct/g,H._punctuation).getRegex(),H._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,H._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,H._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,H.autolink=S(H.autolink).replace("scheme",H._scheme).replace("email",H._email).getRegex(),H._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,H.tag=S(H.tag).replace("comment",H._comment).replace("attribute",H._attribute).getRegex(),H._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,H._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,H._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,H.link=S(H.link).replace("label",H._label).replace("href",H._href).replace("title",H._title).getRegex(),H.reflink=S(H.reflink).replace("label",H._label).replace("ref",O._label).getRegex(),H.nolink=S(H.nolink).replace("ref",O._label).getRegex(),H.reflinkSearch=S(H.reflinkSearch,"g").replace("reflink",H.reflink).replace("nolink",H.nolink).getRegex(),H.normal=c({},H),H.pedantic=c({},H.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:S(/^!?\[(label)\]\((.*?)\)/).replace("label",H._label).getRegex(),reflink:S(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",H._label).getRegex()}),H.gfm=c({},H.normal,{escape:S(H.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),H.gfm.url=S(H.gfm.url,"i").replace("email",H.gfm._extended_email).getRegex(),H.breaks=c({},H.gfm,{br:S(H.br).replace("{2,}","*").getRegex(),text:S(H.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function te(Ie){return Ie.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function z(Ie){var Se="",Te,se,ae=Ie.length;for(Te=0;Te<ae;Te++)se=Ie.charCodeAt(Te),Math.random()>.5&&(se="x"+se.toString(16)),Se+="&#"+se+";";return Se}var $=function(){function Ie(Te){this.tokens=[],this.tokens.links=Object.create(null),this.options=Te||J.defaults,this.options.tokenizer=this.options.tokenizer||new F,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var se={block:O.normal,inline:H.normal};this.options.pedantic?(se.block=O.pedantic,se.inline=H.pedantic):this.options.gfm&&(se.block=O.gfm,this.options.breaks?se.inline=H.breaks:se.inline=H.gfm),this.tokenizer.rules=se}Ie.lex=function(se,ae){var G=new Ie(ae);return G.lex(se)},Ie.lexInline=function(se,ae){var G=new Ie(ae);return G.inlineTokens(se)};var Se=Ie.prototype;return Se.lex=function(se){se=se.replace(/\r\n|\r/g,`
`),this.blockTokens(se,this.tokens);for(var ae;ae=this.inlineQueue.shift();)this.inlineTokens(ae.src,ae.tokens);return this.tokens},Se.blockTokens=function(se,ae){var G=this;ae===void 0&&(ae=[]),this.options.pedantic?se=se.replace(/\t/g,"    ").replace(/^ +$/gm,""):se=se.replace(/^( *)(\t+)/gm,function(ne,ue,Y){return ue+"    ".repeat(Y.length)});for(var X,k,B,V;se;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(ne){return(X=ne.call({lexer:G},se,ae))?(se=se.substring(X.raw.length),ae.push(X),!0):!1}))){if(X=this.tokenizer.space(se)){se=se.substring(X.raw.length),X.raw.length===1&&ae.length>0?ae[ae.length-1].raw+=`
`:ae.push(X);continue}if(X=this.tokenizer.code(se)){se=se.substring(X.raw.length),k=ae[ae.length-1],k&&(k.type==="paragraph"||k.type==="text")?(k.raw+=`
`+X.raw,k.text+=`
`+X.text,this.inlineQueue[this.inlineQueue.length-1].src=k.text):ae.push(X);continue}if(X=this.tokenizer.fences(se)){se=se.substring(X.raw.length),ae.push(X);continue}if(X=this.tokenizer.heading(se)){se=se.substring(X.raw.length),ae.push(X);continue}if(X=this.tokenizer.hr(se)){se=se.substring(X.raw.length),ae.push(X);continue}if(X=this.tokenizer.blockquote(se)){se=se.substring(X.raw.length),ae.push(X);continue}if(X=this.tokenizer.list(se)){se=se.substring(X.raw.length),ae.push(X);continue}if(X=this.tokenizer.html(se)){se=se.substring(X.raw.length),ae.push(X);continue}if(X=this.tokenizer.def(se)){se=se.substring(X.raw.length),k=ae[ae.length-1],k&&(k.type==="paragraph"||k.type==="text")?(k.raw+=`
`+X.raw,k.text+=`
`+X.raw,this.inlineQueue[this.inlineQueue.length-1].src=k.text):this.tokens.links[X.tag]||(this.tokens.links[X.tag]={href:X.href,title:X.title});continue}if(X=this.tokenizer.table(se)){se=se.substring(X.raw.length),ae.push(X);continue}if(X=this.tokenizer.lheading(se)){se=se.substring(X.raw.length),ae.push(X);continue}if(B=se,this.options.extensions&&this.options.extensions.startBlock&&function(){var ne=1/0,ue=se.slice(1),Y=void 0;G.options.extensions.startBlock.forEach(function(ge){Y=ge.call({lexer:this},ue),typeof Y=="number"&&Y>=0&&(ne=Math.min(ne,Y))}),ne<1/0&&ne>=0&&(B=se.substring(0,ne+1))}(),this.state.top&&(X=this.tokenizer.paragraph(B))){k=ae[ae.length-1],V&&k.type==="paragraph"?(k.raw+=`
`+X.raw,k.text+=`
`+X.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=k.text):ae.push(X),V=B.length!==se.length,se=se.substring(X.raw.length);continue}if(X=this.tokenizer.text(se)){se=se.substring(X.raw.length),k=ae[ae.length-1],k&&k.type==="text"?(k.raw+=`
`+X.raw,k.text+=`
`+X.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=k.text):ae.push(X);continue}if(se){var j="Infinite loop on byte: "+se.charCodeAt(0);if(this.options.silent){console.error(j);break}else throw new Error(j)}}return this.state.top=!0,ae},Se.inline=function(se,ae){this.inlineQueue.push({src:se,tokens:ae})},Se.inlineTokens=function(se,ae){var G=this;ae===void 0&&(ae=[]);var X,k,B,V=se,j,ne,ue;if(this.tokens.links){var Y=Object.keys(this.tokens.links);if(Y.length>0)for(;(j=this.tokenizer.rules.inline.reflinkSearch.exec(V))!=null;)Y.includes(j[0].slice(j[0].lastIndexOf("[")+1,-1))&&(V=V.slice(0,j.index)+"["+W("a",j[0].length-2)+"]"+V.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(j=this.tokenizer.rules.inline.blockSkip.exec(V))!=null;)V=V.slice(0,j.index)+"["+W("a",j[0].length-2)+"]"+V.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(j=this.tokenizer.rules.inline.escapedEmSt.exec(V))!=null;)V=V.slice(0,j.index)+"++"+V.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;se;)if(ne||(ue=""),ne=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(fe){return(X=fe.call({lexer:G},se,ae))?(se=se.substring(X.raw.length),ae.push(X),!0):!1}))){if(X=this.tokenizer.escape(se)){se=se.substring(X.raw.length),ae.push(X);continue}if(X=this.tokenizer.tag(se)){se=se.substring(X.raw.length),k=ae[ae.length-1],k&&X.type==="text"&&k.type==="text"?(k.raw+=X.raw,k.text+=X.text):ae.push(X);continue}if(X=this.tokenizer.link(se)){se=se.substring(X.raw.length),ae.push(X);continue}if(X=this.tokenizer.reflink(se,this.tokens.links)){se=se.substring(X.raw.length),k=ae[ae.length-1],k&&X.type==="text"&&k.type==="text"?(k.raw+=X.raw,k.text+=X.text):ae.push(X);continue}if(X=this.tokenizer.emStrong(se,V,ue)){se=se.substring(X.raw.length),ae.push(X);continue}if(X=this.tokenizer.codespan(se)){se=se.substring(X.raw.length),ae.push(X);continue}if(X=this.tokenizer.br(se)){se=se.substring(X.raw.length),ae.push(X);continue}if(X=this.tokenizer.del(se)){se=se.substring(X.raw.length),ae.push(X);continue}if(X=this.tokenizer.autolink(se,z)){se=se.substring(X.raw.length),ae.push(X);continue}if(!this.state.inLink&&(X=this.tokenizer.url(se,z))){se=se.substring(X.raw.length),ae.push(X);continue}if(B=se,this.options.extensions&&this.options.extensions.startInline&&function(){var fe=1/0,Ne=se.slice(1),ze=void 0;G.options.extensions.startInline.forEach(function(ke){ze=ke.call({lexer:this},Ne),typeof ze=="number"&&ze>=0&&(fe=Math.min(fe,ze))}),fe<1/0&&fe>=0&&(B=se.substring(0,fe+1))}(),X=this.tokenizer.inlineText(B,te)){se=se.substring(X.raw.length),X.raw.slice(-1)!=="_"&&(ue=X.raw.slice(-1)),ne=!0,k=ae[ae.length-1],k&&k.type==="text"?(k.raw+=X.raw,k.text+=X.text):ae.push(X);continue}if(se){var ge="Infinite loop on byte: "+se.charCodeAt(0);if(this.options.silent){console.error(ge);break}else throw new Error(ge)}}return ae},o(Ie,null,[{key:"rules",get:function(){return{block:O,inline:H}}}]),Ie}(),ce=function(){function Ie(Te){this.options=Te||J.defaults}var Se=Ie.prototype;return Se.code=function(se,ae,G){var X=(ae||"").match(/\S*/)[0];if(this.options.highlight){var k=this.options.highlight(se,X);k!=null&&k!==se&&(G=!0,se=k)}return se=se.replace(/\n$/,"")+`
`,X?'<pre><code class="'+this.options.langPrefix+g(X,!0)+'">'+(G?se:g(se,!0))+`</code></pre>
`:"<pre><code>"+(G?se:g(se,!0))+`</code></pre>
`},Se.blockquote=function(se){return`<blockquote>
`+se+`</blockquote>
`},Se.html=function(se){return se},Se.heading=function(se,ae,G,X){if(this.options.headerIds){var k=this.options.headerPrefix+X.slug(G);return"<h"+ae+' id="'+k+'">'+se+"</h"+ae+`>
`}return"<h"+ae+">"+se+"</h"+ae+`>
`},Se.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},Se.list=function(se,ae,G){var X=ae?"ol":"ul",k=ae&&G!==1?' start="'+G+'"':"";return"<"+X+k+`>
`+se+"</"+X+`>
`},Se.listitem=function(se){return"<li>"+se+`</li>
`},Se.checkbox=function(se){return"<input "+(se?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},Se.paragraph=function(se){return"<p>"+se+`</p>
`},Se.table=function(se,ae){return ae&&(ae="<tbody>"+ae+"</tbody>"),`<table>
<thead>
`+se+`</thead>
`+ae+`</table>
`},Se.tablerow=function(se){return`<tr>
`+se+`</tr>
`},Se.tablecell=function(se,ae){var G=ae.header?"th":"td",X=ae.align?"<"+G+' align="'+ae.align+'">':"<"+G+">";return X+se+("</"+G+`>
`)},Se.strong=function(se){return"<strong>"+se+"</strong>"},Se.em=function(se){return"<em>"+se+"</em>"},Se.codespan=function(se){return"<code>"+se+"</code>"},Se.br=function(){return this.options.xhtml?"<br/>":"<br>"},Se.del=function(se){return"<del>"+se+"</del>"},Se.link=function(se,ae,G){if(se=y(this.options.sanitize,this.options.baseUrl,se),se===null)return G;var X='<a href="'+g(se)+'"';return ae&&(X+=' title="'+ae+'"'),X+=">"+G+"</a>",X},Se.image=function(se,ae,G){if(se=y(this.options.sanitize,this.options.baseUrl,se),se===null)return G;var X='<img src="'+se+'" alt="'+G+'"';return ae&&(X+=' title="'+ae+'"'),X+=this.options.xhtml?"/>":">",X},Se.text=function(se){return se},Ie}(),le=function(){function Ie(){}var Se=Ie.prototype;return Se.strong=function(se){return se},Se.em=function(se){return se},Se.codespan=function(se){return se},Se.del=function(se){return se},Se.html=function(se){return se},Se.text=function(se){return se},Se.link=function(se,ae,G){return""+G},Se.image=function(se,ae,G){return""+G},Se.br=function(){return""},Ie}(),oe=function(){function Ie(){this.seen={}}var Se=Ie.prototype;return Se.serialize=function(se){return se.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},Se.getNextSafeSlug=function(se,ae){var G=se,X=0;if(this.seen.hasOwnProperty(G)){X=this.seen[se];do X++,G=se+"-"+X;while(this.seen.hasOwnProperty(G))}return ae||(this.seen[se]=X,this.seen[G]=0),G},Se.slug=function(se,ae){ae===void 0&&(ae={});var G=this.serialize(se);return this.getNextSafeSlug(G,ae.dryrun)},Ie}(),pe=function(){function Ie(Te){this.options=Te||J.defaults,this.options.renderer=this.options.renderer||new ce,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new le,this.slugger=new oe}Ie.parse=function(se,ae){var G=new Ie(ae);return G.parse(se)},Ie.parseInline=function(se,ae){var G=new Ie(ae);return G.parseInline(se)};var Se=Ie.prototype;return Se.parse=function(se,ae){ae===void 0&&(ae=!0);var G="",X,k,B,V,j,ne,ue,Y,ge,fe,Ne,ze,ke,qe,K,Q,me,Le,Be,Ze=se.length;for(X=0;X<Ze;X++){if(fe=se[X],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[fe.type]&&(Be=this.options.extensions.renderers[fe.type].call({parser:this},fe),Be!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(fe.type))){G+=Be||"";continue}switch(fe.type){case"space":continue;case"hr":{G+=this.renderer.hr();continue}case"heading":{G+=this.renderer.heading(this.parseInline(fe.tokens),fe.depth,u(this.parseInline(fe.tokens,this.textRenderer)),this.slugger);continue}case"code":{G+=this.renderer.code(fe.text,fe.lang,fe.escaped);continue}case"table":{for(Y="",ue="",V=fe.header.length,k=0;k<V;k++)ue+=this.renderer.tablecell(this.parseInline(fe.header[k].tokens),{header:!0,align:fe.align[k]});for(Y+=this.renderer.tablerow(ue),ge="",V=fe.rows.length,k=0;k<V;k++){for(ne=fe.rows[k],ue="",j=ne.length,B=0;B<j;B++)ue+=this.renderer.tablecell(this.parseInline(ne[B].tokens),{header:!1,align:fe.align[B]});ge+=this.renderer.tablerow(ue)}G+=this.renderer.table(Y,ge);continue}case"blockquote":{ge=this.parse(fe.tokens),G+=this.renderer.blockquote(ge);continue}case"list":{for(Ne=fe.ordered,ze=fe.start,ke=fe.loose,V=fe.items.length,ge="",k=0;k<V;k++)K=fe.items[k],Q=K.checked,me=K.task,qe="",K.task&&(Le=this.renderer.checkbox(Q),ke?K.tokens.length>0&&K.tokens[0].type==="paragraph"?(K.tokens[0].text=Le+" "+K.tokens[0].text,K.tokens[0].tokens&&K.tokens[0].tokens.length>0&&K.tokens[0].tokens[0].type==="text"&&(K.tokens[0].tokens[0].text=Le+" "+K.tokens[0].tokens[0].text)):K.tokens.unshift({type:"text",text:Le}):qe+=Le),qe+=this.parse(K.tokens,ke),ge+=this.renderer.listitem(qe,me,Q);G+=this.renderer.list(ge,Ne,ze);continue}case"html":{G+=this.renderer.html(fe.text);continue}case"paragraph":{G+=this.renderer.paragraph(this.parseInline(fe.tokens));continue}case"text":{for(ge=fe.tokens?this.parseInline(fe.tokens):fe.text;X+1<Ze&&se[X+1].type==="text";)fe=se[++X],ge+=`
`+(fe.tokens?this.parseInline(fe.tokens):fe.text);G+=ae?this.renderer.paragraph(ge):ge;continue}default:{var et='Token with "'+fe.type+'" type was not found.';if(this.options.silent){console.error(et);return}else throw new Error(et)}}}return G},Se.parseInline=function(se,ae){ae=ae||this.renderer;var G="",X,k,B,V=se.length;for(X=0;X<V;X++){if(k=se[X],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[k.type]&&(B=this.options.extensions.renderers[k.type].call({parser:this},k),B!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(k.type))){G+=B||"";continue}switch(k.type){case"escape":{G+=ae.text(k.text);break}case"html":{G+=ae.html(k.text);break}case"link":{G+=ae.link(k.href,k.title,this.parseInline(k.tokens,ae));break}case"image":{G+=ae.image(k.href,k.title,k.text);break}case"strong":{G+=ae.strong(this.parseInline(k.tokens,ae));break}case"em":{G+=ae.em(this.parseInline(k.tokens,ae));break}case"codespan":{G+=ae.codespan(k.text);break}case"br":{G+=ae.br();break}case"del":{G+=ae.del(this.parseInline(k.tokens,ae));break}case"text":{G+=ae.text(k.text);break}default:{var j='Token with "'+k.type+'" type was not found.';if(this.options.silent){console.error(j);return}else throw new Error(j)}}}return G},Ie}();function re(Ie,Se,Te){if(typeof Ie=="undefined"||Ie===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Ie!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Ie)+", string expected");if(typeof Se=="function"&&(Te=Se,Se=null),Se=c({},re.defaults,Se||{}),L(Se),Te){var se=Se.highlight,ae;try{ae=$.lex(Ie,Se)}catch(B){return Te(B)}var G=function(V){var j;if(!V)try{Se.walkTokens&&re.walkTokens(ae,Se.walkTokens),j=pe.parse(ae,Se)}catch(ne){V=ne}return Se.highlight=se,V?Te(V):Te(null,j)};if(!se||se.length<3||(delete Se.highlight,!ae.length))return G();var X=0;re.walkTokens(ae,function(B){B.type==="code"&&(X++,setTimeout(function(){se(B.text,B.lang,function(V,j){if(V)return G(V);j!=null&&j!==B.text&&(B.text=j,B.escaped=!0),X--,X===0&&G()})},0))}),X===0&&G();return}try{var k=$.lex(Ie,Se);return Se.walkTokens&&re.walkTokens(k,Se.walkTokens),pe.parse(k,Se)}catch(B){if(B.message+=`
Please report this to https://github.com/markedjs/marked.`,Se.silent)return"<p>An error occurred:</p><pre>"+g(B.message+"",!0)+"</pre>";throw B}}re.options=re.setOptions=function(Ie){return c(re.defaults,Ie),P(re.defaults),re},re.getDefaults=I,re.defaults=J.defaults,re.use=function(){for(var Ie=arguments.length,Se=new Array(Ie),Te=0;Te<Ie;Te++)Se[Te]=arguments[Te];var se=c.apply(void 0,[{}].concat(Se)),ae=re.defaults.extensions||{renderers:{},childTokens:{}},G;Se.forEach(function(X){if(X.extensions&&(G=!0,X.extensions.forEach(function(B){if(!B.name)throw new Error("extension name required");if(B.renderer){var V=ae.renderers?ae.renderers[B.name]:null;V?ae.renderers[B.name]=function(){for(var j=arguments.length,ne=new Array(j),ue=0;ue<j;ue++)ne[ue]=arguments[ue];var Y=B.renderer.apply(this,ne);return Y===!1&&(Y=V.apply(this,ne)),Y}:ae.renderers[B.name]=B.renderer}if(B.tokenizer){if(!B.level||B.level!=="block"&&B.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ae[B.level]?ae[B.level].unshift(B.tokenizer):ae[B.level]=[B.tokenizer],B.start&&(B.level==="block"?ae.startBlock?ae.startBlock.push(B.start):ae.startBlock=[B.start]:B.level==="inline"&&(ae.startInline?ae.startInline.push(B.start):ae.startInline=[B.start]))}B.childTokens&&(ae.childTokens[B.name]=B.childTokens)})),X.renderer&&function(){var B=re.defaults.renderer||new ce,V=function(ue){var Y=B[ue];B[ue]=function(){for(var ge=arguments.length,fe=new Array(ge),Ne=0;Ne<ge;Ne++)fe[Ne]=arguments[Ne];var ze=X.renderer[ue].apply(B,fe);return ze===!1&&(ze=Y.apply(B,fe)),ze}};for(var j in X.renderer)V(j);se.renderer=B}(),X.tokenizer&&function(){var B=re.defaults.tokenizer||new F,V=function(ue){var Y=B[ue];B[ue]=function(){for(var ge=arguments.length,fe=new Array(ge),Ne=0;Ne<ge;Ne++)fe[Ne]=arguments[Ne];var ze=X.tokenizer[ue].apply(B,fe);return ze===!1&&(ze=Y.apply(B,fe)),ze}};for(var j in X.tokenizer)V(j);se.tokenizer=B}(),X.walkTokens){var k=re.defaults.walkTokens;se.walkTokens=function(B){X.walkTokens.call(this,B),k&&k.call(this,B)}}G&&(se.extensions=ae),re.setOptions(se)})},re.walkTokens=function(Ie,Se){for(var Te=function(){var X=ae.value;switch(Se.call(re,X),X.type){case"table":{for(var k=U(X.header),B;!(B=k()).done;){var V=B.value;re.walkTokens(V.tokens,Se)}for(var j=U(X.rows),ne;!(ne=j()).done;)for(var ue=ne.value,Y=U(ue),ge;!(ge=Y()).done;){var fe=ge.value;re.walkTokens(fe.tokens,Se)}break}case"list":{re.walkTokens(X.items,Se);break}default:re.defaults.extensions&&re.defaults.extensions.childTokens&&re.defaults.extensions.childTokens[X.type]?re.defaults.extensions.childTokens[X.type].forEach(function(Ne){re.walkTokens(X[Ne],Se)}):X.tokens&&re.walkTokens(X.tokens,Se)}},se=U(Ie),ae;!(ae=se()).done;)Te()},re.parseInline=function(Ie,Se){if(typeof Ie=="undefined"||Ie===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Ie!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Ie)+", string expected");Se=c({},re.defaults,Se||{}),L(Se);try{var Te=$.lexInline(Ie,Se);return Se.walkTokens&&re.walkTokens(Te,Se.walkTokens),pe.parseInline(Te,Se)}catch(se){if(se.message+=`
Please report this to https://github.com/markedjs/marked.`,Se.silent)return"<p>An error occurred:</p><pre>"+g(se.message+"",!0)+"</pre>";throw se}},re.Parser=pe,re.parser=pe.parse,re.Renderer=ce,re.TextRenderer=le,re.Lexer=$,re.lexer=$.lex,re.Tokenizer=F,re.Slugger=oe,re.parse=re;var Ee=re.options,be=re.setOptions,Z=re.use,ve=re.walkTokens,Re=re.parseInline,Fe=re,We=pe.parse,Xe=$.lex;J.Lexer=$,J.Parser=pe,J.Renderer=ce,J.Slugger=oe,J.TextRenderer=le,J.Tokenizer=F,J.getDefaults=I,J.lexer=Xe,J.marked=re,J.options=Ee,J.parse=Fe,J.parseInline=Re,J.parser=We,J.setOptions=be,J.use=Z,J.walkTokens=ve,Object.defineProperty(J,"__esModule",{value:!0})}),define(De[106],Ce([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function o(P,b,A){return Math.min(Math.max(P,b),A)}e.clamp=o;function C(P,b){return(b+P%b)%b}e.rot=C;class p{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=p;class U{constructor(){this._n=1,this._val=0}update(b){return this._val=this._val+(b-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=U;class I{constructor(b){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(b),this._values.fill(0,0,b)}update(b){const A=this._values[this._index];return this._values[this._index]=b,this._index=(this._index+1)%this._values.length,this._sum-=A,this._sum+=b,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=I}),function(){function J(p){const U=[];typeof p=="number"&&U.push("code/timeOrigin",p);function I(b){U.push(b,Date.now())}function P(){const b=[];for(let A=0;A<U.length;A+=2)b.push({name:U[A],startTime:U[A+1]});return b}return{mark:I,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?J():{mark(p){performance.mark(p)},getMarks(){let p=performance.timeOrigin;typeof p!="number"&&(p=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const U=[{name:"code/timeOrigin",startTime:Math.round(p)}];for(const I of performance.getEntriesByType("mark"))U.push({name:I.name,startTime:Math.round(p+I.startTime)});return U}};if(typeof process=="object"){const p=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return J(p)}else return console.trace("perf-util loaded in UNKNOWN environment"),J()}function o(p){return p.MonacoPerformanceMarks||(p.MonacoPerformanceMarks=e()),p.MonacoPerformanceMarks}var C;typeof global=="object"?C=global:typeof self=="object"?C=self:C={},typeof define=="function"?define("vs/base/common/performance",[],function(){return o(C)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=o(C):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),C.perf=o(C))}(),function(J,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var o=e();for(var C in o)(typeof exports=="object"?exports:J)[C]=o[C]}}(typeof self!="undefined"?self:this,function(){return function(J){var e={};function o(C){if(e[C])return e[C].exports;var p=e[C]={i:C,l:!1,exports:{}};return J[C].call(p.exports,p,p.exports,o),p.l=!0,p.exports}return o.m=J,o.c=e,o.d=function(C,p,U){o.o(C,p)||Object.defineProperty(C,p,{enumerable:!0,get:U})},o.r=function(C){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(C,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(C,"__esModule",{value:!0})},o.t=function(C,p){if(1&p&&(C=o(C)),8&p||4&p&&typeof C=="object"&&C&&C.__esModule)return C;var U=Object.create(null);if(o.r(U),Object.defineProperty(U,"default",{enumerable:!0,value:C}),2&p&&typeof C!="string")for(var I in C)o.d(U,I,function(P){return C[P]}.bind(null,I));return U},o.n=function(C){var p=C&&C.__esModule?function(){return C.default}:function(){return C};return o.d(p,"a",p),p},o.o=function(C,p){return Object.prototype.hasOwnProperty.call(C,p)},o.p="",o(o.s=0)}([function(J,e,o){(function(C){var p;e=J.exports=Z,p=typeof C=="object"&&C.env&&C.env.NODE_DEBUG&&/\bsemver\b/i.test(C.env.NODE_DEBUG)?function(){var Y=Array.prototype.slice.call(arguments,0);Y.unshift("SEMVER"),console.log.apply(console,Y)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var U=256,I=Number.MAX_SAFE_INTEGER||9007199254740991,P=e.re=[],b=e.src=[],A=0,R=A++;b[R]="0|[1-9]\\d*";var _=A++;b[_]="[0-9]+";var m=A++;b[m]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var T=A++;b[T]="("+b[R]+")\\.("+b[R]+")\\.("+b[R]+")";var g=A++;b[g]="("+b[_]+")\\.("+b[_]+")\\.("+b[_]+")";var h=A++;b[h]="(?:"+b[R]+"|"+b[m]+")";var u=A++;b[u]="(?:"+b[_]+"|"+b[m]+")";var l=A++;b[l]="(?:-("+b[h]+"(?:\\."+b[h]+")*))";var S=A++;b[S]="(?:-?("+b[u]+"(?:\\."+b[u]+")*))";var w=A++;b[w]="[0-9A-Za-z-]+";var a=A++;b[a]="(?:\\+("+b[w]+"(?:\\."+b[w]+")*))";var y=A++,r="v?"+b[T]+b[l]+"?"+b[a]+"?";b[y]="^"+r+"$";var d="[v=\\s]*"+b[g]+b[S]+"?"+b[a]+"?",i=A++;b[i]="^"+d+"$";var s=A++;b[s]="((?:<|>)?=?)";var n=A++;b[n]=b[_]+"|x|X|\\*";var t=A++;b[t]=b[R]+"|x|X|\\*";var c=A++;b[c]="[v=\\s]*("+b[t]+")(?:\\.("+b[t]+")(?:\\.("+b[t]+")(?:"+b[l]+")?"+b[a]+"?)?)?";var E=A++;b[E]="[v=\\s]*("+b[n]+")(?:\\.("+b[n]+")(?:\\.("+b[n]+")(?:"+b[S]+")?"+b[a]+"?)?)?";var f=A++;b[f]="^"+b[s]+"\\s*"+b[c]+"$";var D=A++;b[D]="^"+b[s]+"\\s*"+b[E]+"$";var L=A++;b[L]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var W=A++;b[W]="(?:~>?)";var N=A++;b[N]="(\\s*)"+b[W]+"\\s+",P[N]=new RegExp(b[N],"g");var v=A++;b[v]="^"+b[W]+b[c]+"$";var F=A++;b[F]="^"+b[W]+b[E]+"$";var O=A++;b[O]="(?:\\^)";var H=A++;b[H]="(\\s*)"+b[O]+"\\s+",P[H]=new RegExp(b[H],"g");var te=A++;b[te]="^"+b[O]+b[c]+"$";var z=A++;b[z]="^"+b[O]+b[E]+"$";var $=A++;b[$]="^"+b[s]+"\\s*("+d+")$|^$";var ce=A++;b[ce]="^"+b[s]+"\\s*("+r+")$|^$";var le=A++;b[le]="(\\s*)"+b[s]+"\\s*("+d+"|"+b[c]+")",P[le]=new RegExp(b[le],"g");var oe=A++;b[oe]="^\\s*("+b[c]+")\\s+-\\s+("+b[c]+")\\s*$";var pe=A++;b[pe]="^\\s*("+b[E]+")\\s+-\\s+("+b[E]+")\\s*$";var re=A++;b[re]="(<|>)?=?\\s*\\*";for(var Ee=0;Ee<35;Ee++)p(Ee,b[Ee]),P[Ee]||(P[Ee]=new RegExp(b[Ee]));function be(Y,ge){if(Y instanceof Z)return Y;if(typeof Y!="string"||Y.length>U||!(ge?P[i]:P[y]).test(Y))return null;try{return new Z(Y,ge)}catch{return null}}function Z(Y,ge){if(Y instanceof Z){if(Y.loose===ge)return Y;Y=Y.version}else if(typeof Y!="string")throw new TypeError("Invalid Version: "+Y);if(Y.length>U)throw new TypeError("version is longer than "+U+" characters");if(!(this instanceof Z))return new Z(Y,ge);p("SemVer",Y,ge),this.loose=ge;var fe=Y.trim().match(ge?P[i]:P[y]);if(!fe)throw new TypeError("Invalid Version: "+Y);if(this.raw=Y,this.major=+fe[1],this.minor=+fe[2],this.patch=+fe[3],this.major>I||this.major<0)throw new TypeError("Invalid major version");if(this.minor>I||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>I||this.patch<0)throw new TypeError("Invalid patch version");fe[4]?this.prerelease=fe[4].split(".").map(function(Ne){if(/^[0-9]+$/.test(Ne)){var ze=+Ne;if(ze>=0&&ze<I)return ze}return Ne}):this.prerelease=[],this.build=fe[5]?fe[5].split("."):[],this.format()}e.parse=be,e.valid=function(Y,ge){var fe=be(Y,ge);return fe?fe.version:null},e.clean=function(Y,ge){var fe=be(Y.trim().replace(/^[=v]+/,""),ge);return fe?fe.version:null},e.SemVer=Z,Z.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Z.prototype.toString=function(){return this.version},Z.prototype.compare=function(Y){return p("SemVer.compare",this.version,this.loose,Y),Y instanceof Z||(Y=new Z(Y,this.loose)),this.compareMain(Y)||this.comparePre(Y)},Z.prototype.compareMain=function(Y){return Y instanceof Z||(Y=new Z(Y,this.loose)),Re(this.major,Y.major)||Re(this.minor,Y.minor)||Re(this.patch,Y.patch)},Z.prototype.comparePre=function(Y){if(Y instanceof Z||(Y=new Z(Y,this.loose)),this.prerelease.length&&!Y.prerelease.length)return-1;if(!this.prerelease.length&&Y.prerelease.length)return 1;if(!this.prerelease.length&&!Y.prerelease.length)return 0;var ge=0;do{var fe=this.prerelease[ge],Ne=Y.prerelease[ge];if(p("prerelease compare",ge,fe,Ne),fe===void 0&&Ne===void 0)return 0;if(Ne===void 0)return 1;if(fe===void 0)return-1;if(fe!==Ne)return Re(fe,Ne)}while(++ge)},Z.prototype.inc=function(Y,ge){switch(Y){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ge);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ge);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ge),this.inc("pre",ge);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ge),this.inc("pre",ge);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var fe=this.prerelease.length;--fe>=0;)typeof this.prerelease[fe]=="number"&&(this.prerelease[fe]++,fe=-2);fe===-1&&this.prerelease.push(0)}ge&&(this.prerelease[0]===ge?isNaN(this.prerelease[1])&&(this.prerelease=[ge,0]):this.prerelease=[ge,0]);break;default:throw new Error("invalid increment argument: "+Y)}return this.format(),this.raw=this.version,this},e.inc=function(Y,ge,fe,Ne){typeof fe=="string"&&(Ne=fe,fe=void 0);try{return new Z(Y,fe).inc(ge,Ne).version}catch{return null}},e.diff=function(Y,ge){if(Ie(Y,ge))return null;var fe=be(Y),Ne=be(ge);if(fe.prerelease.length||Ne.prerelease.length){for(var ze in fe)if((ze==="major"||ze==="minor"||ze==="patch")&&fe[ze]!==Ne[ze])return"pre"+ze;return"prerelease"}for(var ze in fe)if((ze==="major"||ze==="minor"||ze==="patch")&&fe[ze]!==Ne[ze])return ze},e.compareIdentifiers=Re;var ve=/^[0-9]+$/;function Re(Y,ge){var fe=ve.test(Y),Ne=ve.test(ge);return fe&&Ne&&(Y=+Y,ge=+ge),fe&&!Ne?-1:Ne&&!fe?1:Y<ge?-1:Y>ge?1:0}function Fe(Y,ge,fe){return new Z(Y,fe).compare(new Z(ge,fe))}function We(Y,ge,fe){return Fe(Y,ge,fe)>0}function Xe(Y,ge,fe){return Fe(Y,ge,fe)<0}function Ie(Y,ge,fe){return Fe(Y,ge,fe)===0}function Se(Y,ge,fe){return Fe(Y,ge,fe)!==0}function Te(Y,ge,fe){return Fe(Y,ge,fe)>=0}function se(Y,ge,fe){return Fe(Y,ge,fe)<=0}function ae(Y,ge,fe,Ne){var ze;switch(ge){case"===":typeof Y=="object"&&(Y=Y.version),typeof fe=="object"&&(fe=fe.version),ze=Y===fe;break;case"!==":typeof Y=="object"&&(Y=Y.version),typeof fe=="object"&&(fe=fe.version),ze=Y!==fe;break;case"":case"=":case"==":ze=Ie(Y,fe,Ne);break;case"!=":ze=Se(Y,fe,Ne);break;case">":ze=We(Y,fe,Ne);break;case">=":ze=Te(Y,fe,Ne);break;case"<":ze=Xe(Y,fe,Ne);break;case"<=":ze=se(Y,fe,Ne);break;default:throw new TypeError("Invalid operator: "+ge)}return ze}function G(Y,ge){if(Y instanceof G){if(Y.loose===ge)return Y;Y=Y.value}if(!(this instanceof G))return new G(Y,ge);p("comparator",Y,ge),this.loose=ge,this.parse(Y),this.semver===X?this.value="":this.value=this.operator+this.semver.version,p("comp",this)}e.rcompareIdentifiers=function(Y,ge){return Re(ge,Y)},e.major=function(Y,ge){return new Z(Y,ge).major},e.minor=function(Y,ge){return new Z(Y,ge).minor},e.patch=function(Y,ge){return new Z(Y,ge).patch},e.compare=Fe,e.compareLoose=function(Y,ge){return Fe(Y,ge,!0)},e.rcompare=function(Y,ge,fe){return Fe(ge,Y,fe)},e.sort=function(Y,ge){return Y.sort(function(fe,Ne){return e.compare(fe,Ne,ge)})},e.rsort=function(Y,ge){return Y.sort(function(fe,Ne){return e.rcompare(fe,Ne,ge)})},e.gt=We,e.lt=Xe,e.eq=Ie,e.neq=Se,e.gte=Te,e.lte=se,e.cmp=ae,e.Comparator=G;var X={};function k(Y,ge){if(Y instanceof k)return Y.loose===ge?Y:new k(Y.raw,ge);if(Y instanceof G)return new k(Y.value,ge);if(!(this instanceof k))return new k(Y,ge);if(this.loose=ge,this.raw=Y,this.set=Y.split(/\s*\|\|\s*/).map(function(fe){return this.parseRange(fe.trim())},this).filter(function(fe){return fe.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+Y);this.format()}function B(Y){return!Y||Y.toLowerCase()==="x"||Y==="*"}function V(Y,ge,fe,Ne,ze,ke,qe,K,Q,me,Le,Be,Ze){return((ge=B(fe)?"":B(Ne)?">="+fe+".0.0":B(ze)?">="+fe+"."+Ne+".0":">="+ge)+" "+(K=B(Q)?"":B(me)?"<"+(+Q+1)+".0.0":B(Le)?"<"+Q+"."+(+me+1)+".0":Be?"<="+Q+"."+me+"."+Le+"-"+Be:"<="+K)).trim()}function j(Y,ge){for(var fe=0;fe<Y.length;fe++)if(!Y[fe].test(ge))return!1;if(ge.prerelease.length){for(fe=0;fe<Y.length;fe++)if(p(Y[fe].semver),Y[fe].semver!==X&&Y[fe].semver.prerelease.length>0){var Ne=Y[fe].semver;if(Ne.major===ge.major&&Ne.minor===ge.minor&&Ne.patch===ge.patch)return!0}return!1}return!0}function ne(Y,ge,fe){try{ge=new k(ge,fe)}catch{return!1}return ge.test(Y)}function ue(Y,ge,fe,Ne){var ze,ke,qe,K,Q;switch(Y=new Z(Y,Ne),ge=new k(ge,Ne),fe){case">":ze=We,ke=se,qe=Xe,K=">",Q=">=";break;case"<":ze=Xe,ke=Te,qe=We,K="<",Q="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ne(Y,ge,Ne))return!1;for(var me=0;me<ge.set.length;++me){var Le=ge.set[me],Be=null,Ze=null;if(Le.forEach(function(et){et.semver===X&&(et=new G(">=0.0.0")),Be=Be||et,Ze=Ze||et,ze(et.semver,Be.semver,Ne)?Be=et:qe(et.semver,Ze.semver,Ne)&&(Ze=et)}),Be.operator===K||Be.operator===Q||(!Ze.operator||Ze.operator===K)&&ke(Y,Ze.semver)||Ze.operator===Q&&qe(Y,Ze.semver))return!1}return!0}G.prototype.parse=function(Y){var ge=this.loose?P[$]:P[ce],fe=Y.match(ge);if(!fe)throw new TypeError("Invalid comparator: "+Y);this.operator=fe[1],this.operator==="="&&(this.operator=""),fe[2]?this.semver=new Z(fe[2],this.loose):this.semver=X},G.prototype.toString=function(){return this.value},G.prototype.test=function(Y){return p("Comparator.test",Y,this.loose),this.semver===X||(typeof Y=="string"&&(Y=new Z(Y,this.loose)),ae(Y,this.operator,this.semver,this.loose))},G.prototype.intersects=function(Y,ge){if(!(Y instanceof G))throw new TypeError("a Comparator is required");var fe;if(this.operator==="")return fe=new k(Y.value,ge),ne(this.value,fe,ge);if(Y.operator==="")return fe=new k(this.value,ge),ne(Y.semver,fe,ge);var Ne=!(this.operator!==">="&&this.operator!==">"||Y.operator!==">="&&Y.operator!==">"),ze=!(this.operator!=="<="&&this.operator!=="<"||Y.operator!=="<="&&Y.operator!=="<"),ke=this.semver.version===Y.semver.version,qe=!(this.operator!==">="&&this.operator!=="<="||Y.operator!==">="&&Y.operator!=="<="),K=ae(this.semver,"<",Y.semver,ge)&&(this.operator===">="||this.operator===">")&&(Y.operator==="<="||Y.operator==="<"),Q=ae(this.semver,">",Y.semver,ge)&&(this.operator==="<="||this.operator==="<")&&(Y.operator===">="||Y.operator===">");return Ne||ze||ke&&qe||K||Q},e.Range=k,k.prototype.format=function(){return this.range=this.set.map(function(Y){return Y.join(" ").trim()}).join("||").trim(),this.range},k.prototype.toString=function(){return this.range},k.prototype.parseRange=function(Y){var ge=this.loose;Y=Y.trim(),p("range",Y,ge);var fe=ge?P[pe]:P[oe];Y=Y.replace(fe,V),p("hyphen replace",Y),Y=Y.replace(P[le],"$1$2$3"),p("comparator trim",Y,P[le]),Y=(Y=(Y=Y.replace(P[N],"$1~")).replace(P[H],"$1^")).split(/\s+/).join(" ");var Ne=ge?P[$]:P[ce],ze=Y.split(" ").map(function(ke){return function(qe,K){return p("comp",qe),qe=function(Q,me){return Q.trim().split(/\s+/).map(function(Le){return function(Be,Ze){p("caret",Be,Ze);var et=Ze?P[z]:P[te];return Be.replace(et,function(at,Je,He,nt,st){var ot;return p("caret",Be,at,Je,He,nt,st),B(Je)?ot="":B(He)?ot=">="+Je+".0.0 <"+(+Je+1)+".0.0":B(nt)?ot=Je==="0"?">="+Je+"."+He+".0 <"+Je+"."+(+He+1)+".0":">="+Je+"."+He+".0 <"+(+Je+1)+".0.0":st?(p("replaceCaret pr",st),st.charAt(0)!=="-"&&(st="-"+st),ot=Je==="0"?He==="0"?">="+Je+"."+He+"."+nt+st+" <"+Je+"."+He+"."+(+nt+1):">="+Je+"."+He+"."+nt+st+" <"+Je+"."+(+He+1)+".0":">="+Je+"."+He+"."+nt+st+" <"+(+Je+1)+".0.0"):(p("no pr"),ot=Je==="0"?He==="0"?">="+Je+"."+He+"."+nt+" <"+Je+"."+He+"."+(+nt+1):">="+Je+"."+He+"."+nt+" <"+Je+"."+(+He+1)+".0":">="+Je+"."+He+"."+nt+" <"+(+Je+1)+".0.0"),p("caret return",ot),ot})}(Le,me)}).join(" ")}(qe,K),p("caret",qe),qe=function(Q,me){return Q.trim().split(/\s+/).map(function(Le){return function(Be,Ze){var et=Ze?P[F]:P[v];return Be.replace(et,function(at,Je,He,nt,st){var ot;return p("tilde",Be,at,Je,He,nt,st),B(Je)?ot="":B(He)?ot=">="+Je+".0.0 <"+(+Je+1)+".0.0":B(nt)?ot=">="+Je+"."+He+".0 <"+Je+"."+(+He+1)+".0":st?(p("replaceTilde pr",st),st.charAt(0)!=="-"&&(st="-"+st),ot=">="+Je+"."+He+"."+nt+st+" <"+Je+"."+(+He+1)+".0"):ot=">="+Je+"."+He+"."+nt+" <"+Je+"."+(+He+1)+".0",p("tilde return",ot),ot})}(Le,me)}).join(" ")}(qe,K),p("tildes",qe),qe=function(Q,me){return p("replaceXRanges",Q,me),Q.split(/\s+/).map(function(Le){return function(Be,Ze){Be=Be.trim();var et=Ze?P[D]:P[f];return Be.replace(et,function(at,Je,He,nt,st,ot){p("xRange",Be,at,Je,He,nt,st,ot);var lt=B(He),dt=lt||B(nt),kt=dt||B(st);return Je==="="&&kt&&(Je=""),lt?at=Je===">"||Je==="<"?"<0.0.0":"*":Je&&kt?(dt&&(nt=0),kt&&(st=0),Je===">"?(Je=">=",dt?(He=+He+1,nt=0,st=0):kt&&(nt=+nt+1,st=0)):Je==="<="&&(Je="<",dt?He=+He+1:nt=+nt+1),at=Je+He+"."+nt+"."+st):dt?at=">="+He+".0.0 <"+(+He+1)+".0.0":kt&&(at=">="+He+"."+nt+".0 <"+He+"."+(+nt+1)+".0"),p("xRange return",at),at})}(Le,me)}).join(" ")}(qe,K),p("xrange",qe),qe=function(Q,me){return p("replaceStars",Q,me),Q.trim().replace(P[re],"")}(qe,K),p("stars",qe),qe}(ke,ge)}).join(" ").split(/\s+/);return this.loose&&(ze=ze.filter(function(ke){return!!ke.match(Ne)})),ze=ze.map(function(ke){return new G(ke,ge)})},k.prototype.intersects=function(Y,ge){if(!(Y instanceof k))throw new TypeError("a Range is required");return this.set.some(function(fe){return fe.every(function(Ne){return Y.set.some(function(ze){return ze.every(function(ke){return Ne.intersects(ke,ge)})})})})},e.toComparators=function(Y,ge){return new k(Y,ge).set.map(function(fe){return fe.map(function(Ne){return Ne.value}).join(" ").trim().split(" ")})},k.prototype.test=function(Y){if(!Y)return!1;typeof Y=="string"&&(Y=new Z(Y,this.loose));for(var ge=0;ge<this.set.length;ge++)if(j(this.set[ge],Y))return!0;return!1},e.satisfies=ne,e.maxSatisfying=function(Y,ge,fe){var Ne=null,ze=null;try{var ke=new k(ge,fe)}catch{return null}return Y.forEach(function(qe){ke.test(qe)&&(Ne&&ze.compare(qe)!==-1||(ze=new Z(Ne=qe,fe)))}),Ne},e.minSatisfying=function(Y,ge,fe){var Ne=null,ze=null;try{var ke=new k(ge,fe)}catch{return null}return Y.forEach(function(qe){ke.test(qe)&&(Ne&&ze.compare(qe)!==1||(ze=new Z(Ne=qe,fe)))}),Ne},e.validRange=function(Y,ge){try{return new k(Y,ge).range||"*"}catch{return null}},e.ltr=function(Y,ge,fe){return ue(Y,ge,"<",fe)},e.gtr=function(Y,ge,fe){return ue(Y,ge,">",fe)},e.outside=ue,e.prerelease=function(Y,ge){var fe=be(Y,ge);return fe&&fe.prerelease.length?fe.prerelease:null},e.intersects=function(Y,ge,fe){return Y=new k(Y,fe),ge=new k(ge,fe),Y.intersects(ge)},e.coerce=function(Y){if(Y instanceof Z)return Y;if(typeof Y!="string")return null;var ge=Y.match(P[L]);return ge==null?null:be((ge[1]||"0")+"."+(ge[2]||"0")+"."+(ge[3]||"0"))}}).call(this,o(1))},function(J,e){var o,C,p=J.exports={};function U(){throw new Error("setTimeout has not been defined")}function I(){throw new Error("clearTimeout has not been defined")}function P(u){if(o===setTimeout)return setTimeout(u,0);if((o===U||!o)&&setTimeout)return o=setTimeout,setTimeout(u,0);try{return o(u,0)}catch{try{return o.call(null,u,0)}catch{return o.call(this,u,0)}}}(function(){try{o=typeof setTimeout=="function"?setTimeout:U}catch{o=U}try{C=typeof clearTimeout=="function"?clearTimeout:I}catch{C=I}})();var b,A=[],R=!1,_=-1;function m(){R&&b&&(R=!1,b.length?A=b.concat(A):_=-1,A.length&&T())}function T(){if(!R){var u=P(m);R=!0;for(var l=A.length;l;){for(b=A,A=[];++_<l;)b&&b[_].run();_=-1,l=A.length}b=null,R=!1,function(S){if(C===clearTimeout)return clearTimeout(S);if((C===I||!C)&&clearTimeout)return C=clearTimeout,clearTimeout(S);try{C(S)}catch{try{return C.call(null,S)}catch{return C.call(this,S)}}}(u)}}function g(u,l){this.fun=u,this.array=l}function h(){}p.nextTick=function(u){var l=new Array(arguments.length-1);if(arguments.length>1)for(var S=1;S<arguments.length;S++)l[S-1]=arguments[S];A.push(new g(u,l)),A.length!==1||R||P(T)},g.prototype.run=function(){this.fun.apply(null,this.array)},p.title="browser",p.browser=!0,p.env={},p.argv=[],p.version="",p.versions={},p.on=h,p.addListener=h,p.once=h,p.off=h,p.removeListener=h,p.removeAllListeners=h,p.emit=h,p.prependListener=h,p.prependOnceListener=h,p.listeners=function(u){return[]},p.binding=function(u){throw new Error("process.binding is not supported")},p.cwd=function(){return"/"},p.chdir=function(u){throw new Error("process.chdir is not supported")},p.umask=function(){return 0}}])}),define(De[107],Ce([1,0,11,7]),function(J,e,o,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function p(a){const y=a;return y?typeof y.read=="function":!1}e.isReadable=p;function U(a){const y=a;return y?[y.on,y.pause,y.resume,y.destroy].every(r=>typeof r=="function"):!1}e.isReadableStream=U;function I(a){const y=a;return y?U(y.stream)&&Array.isArray(y.buffer)&&typeof y.ended=="boolean":!1}e.isReadableBufferedStream=I;function P(a,y){return new b(a,y)}e.newWriteableStream=P;class b{constructor(y,r){this.reducer=y,this.options=r,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(y){if(!this.state.destroyed){if(this.state.flowing)this.emitData(y);else if(this.buffer.data.push(y),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(r=>this.pendingWritePromises.push(r))}}error(y){this.state.destroyed||(this.state.flowing?this.emitError(y):this.buffer.error.push(y))}end(y){this.state.destroyed||(typeof y!="undefined"&&this.write(y),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(y){this.listeners.data.slice(0).forEach(r=>r(y))}emitError(y){this.listeners.error.length===0?(0,o.onUnexpectedError)(y):this.listeners.error.slice(0).forEach(r=>r(y))}emitEnd(){this.listeners.end.slice(0).forEach(y=>y())}on(y,r){if(!this.state.destroyed)switch(y){case"data":this.listeners.data.push(r),this.resume();break;case"end":this.listeners.end.push(r),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(r),this.state.flowing&&this.flowErrors();break}}removeListener(y,r){if(this.state.destroyed)return;let d;switch(y){case"data":d=this.listeners.data;break;case"end":d=this.listeners.end;break;case"error":d=this.listeners.error;break}if(d){const i=d.indexOf(r);i>=0&&d.splice(i,1)}}flowData(){if(this.buffer.data.length>0){const y=this.reducer(this.buffer.data);this.emitData(y),this.buffer.data.length=0;const r=[...this.pendingWritePromises];this.pendingWritePromises.length=0,r.forEach(d=>d())}}flowErrors(){if(this.listeners.error.length>0){for(const y of this.buffer.error)this.emitError(y);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function A(a,y){const r=[];let d;for(;(d=a.read())!==null;)r.push(d);return y(r)}e.consumeReadable=A;function R(a,y,r){const d=[];let i;for(;(i=a.read())!==null&&d.length<r;)d.push(i);return i===null&&d.length>0?y(d):{read:()=>{if(d.length>0)return d.shift();if(typeof i!="undefined"){const s=i;return i=void 0,s}return a.read()}}}e.peekReadable=R;function _(a,y){return new Promise((r,d)=>{const i=[];m(a,{onData:s=>{y&&i.push(s)},onError:s=>{y?d(s):r(void 0)},onEnd:()=>{r(y?y(i):void 0)}})})}e.consumeStream=_;function m(a,y){let r=!1;return a.on("error",d=>{r||y.onError(d)}),a.on("end",()=>{r||y.onEnd()}),a.on("data",d=>{r||y.onData(d)}),(0,C.toDisposable)(()=>r=!0)}e.listenStream=m;function T(a,y){return new Promise((r,d)=>{const i=new C.DisposableStore,s=[],n=E=>{if(s.push(E),s.length>y)return i.dispose(),a.pause(),r({stream:a,buffer:s,ended:!1})},t=E=>d(E),c=()=>r({stream:a,buffer:s,ended:!0});i.add((0,C.toDisposable)(()=>a.removeListener("error",t))),a.on("error",t),i.add((0,C.toDisposable)(()=>a.removeListener("end",c))),a.on("end",c),i.add((0,C.toDisposable)(()=>a.removeListener("data",n))),a.on("data",n)})}e.peekStream=T;function g(a,y){const r=P(y);return r.end(a),r}e.toStream=g;function h(){const a=P(()=>{throw new Error("not supported")});return a.end(),a}e.emptyStream=h;function u(a){let y=!1;return{read:()=>y?null:(y=!0,a)}}e.toReadable=u;function l(a,y,r){const d=P(r);return m(a,{onData:i=>d.write(y.data(i)),onError:i=>d.error(y.error?y.error(i):i),onEnd:()=>d.end()}),d}e.transform=l;function S(a,y,r){let d=!1;return{read:()=>{const i=y.read();return d?i:(d=!0,i!==null?r([a,i]):a)}}}e.prefixedReadable=S;function w(a,y,r){let d=!1;const i=P(r);return m(y,{onData:s=>d?i.write(s):(d=!0,i.write(r([a,s]))),onError:s=>i.error(s),onEnd:()=>{d||(d=!0,i.write(a)),i.end()}}),i}e.prefixedStream=w}),define(De[23],Ce([1,0,107]),function(J,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const C=typeof Buffer!="undefined";let p,U;class I{constructor(E){this.buffer=E,this.byteLength=this.buffer.byteLength}static alloc(E){return C?new I(Buffer.allocUnsafe(E)):new I(new Uint8Array(E))}static wrap(E){return C&&!Buffer.isBuffer(E)&&(E=Buffer.from(E.buffer,E.byteOffset,E.byteLength)),new I(E)}static fromString(E,f){return!(f?.dontUseNodeBuffer||!1)&&C?new I(Buffer.from(E)):(p||(p=new TextEncoder),new I(p.encode(E)))}static fromByteArray(E){const f=I.alloc(E.length);for(let D=0,L=E.length;D<L;D++)f.buffer[D]=E[D];return f}static concat(E,f){if(typeof f=="undefined"){f=0;for(let W=0,N=E.length;W<N;W++)f+=E[W].byteLength}const D=I.alloc(f);let L=0;for(let W=0,N=E.length;W<N;W++){const v=E[W];D.set(v,L),L+=v.byteLength}return D}clone(){const E=I.alloc(this.byteLength);return E.set(this),E}toString(){return C?this.buffer.toString():(U||(U=new TextDecoder),U.decode(this.buffer))}slice(E,f){return new I(this.buffer.subarray(E,f))}set(E,f){if(E instanceof I)this.buffer.set(E.buffer,f);else if(E instanceof Uint8Array)this.buffer.set(E,f);else if(E instanceof ArrayBuffer)this.buffer.set(new Uint8Array(E),f);else if(ArrayBuffer.isView(E))this.buffer.set(new Uint8Array(E.buffer,E.byteOffset,E.byteLength),f);else throw new Error("Unknown argument 'array'")}readUInt32BE(E){return A(this.buffer,E)}writeUInt32BE(E,f){R(this.buffer,E,f)}readUInt32LE(E){return _(this.buffer,E)}writeUInt32LE(E,f){m(this.buffer,E,f)}readUInt8(E){return T(this.buffer,E)}writeUInt8(E,f){g(this.buffer,E,f)}}e.VSBuffer=I;function P(c,E){return c[E+0]<<0>>>0|c[E+1]<<8>>>0}e.readUInt16LE=P;function b(c,E,f){c[f+0]=E&255,E=E>>>8,c[f+1]=E&255}e.writeUInt16LE=b;function A(c,E){return c[E]*2**24+c[E+1]*2**16+c[E+2]*2**8+c[E+3]}e.readUInt32BE=A;function R(c,E,f){c[f+3]=E,E=E>>>8,c[f+2]=E,E=E>>>8,c[f+1]=E,E=E>>>8,c[f]=E}e.writeUInt32BE=R;function _(c,E){return c[E+0]<<0>>>0|c[E+1]<<8>>>0|c[E+2]<<16>>>0|c[E+3]<<24>>>0}e.readUInt32LE=_;function m(c,E,f){c[f+0]=E&255,E=E>>>8,c[f+1]=E&255,E=E>>>8,c[f+2]=E&255,E=E>>>8,c[f+3]=E&255}e.writeUInt32LE=m;function T(c,E){return c[E]}e.readUInt8=T;function g(c,E,f){c[f]=E}e.writeUInt8=g;function h(c){return o.consumeReadable(c,E=>I.concat(E))}e.readableToBuffer=h;function u(c){return o.toReadable(c)}e.bufferToReadable=u;function l(c){return o.consumeStream(c,E=>I.concat(E))}e.streamToBuffer=l;async function S(c){return c.ended?I.concat(c.buffer):I.concat([...c.buffer,await l(c.stream)])}e.bufferedStreamToBuffer=S;function w(c){return o.toStream(c,E=>I.concat(E))}e.bufferToStream=w;function a(c){return o.transform(c,{data:E=>typeof E=="string"?I.fromString(E):I.wrap(E)},E=>I.concat(E))}e.streamToBufferReadableStream=a;function y(c){return o.newWriteableStream(E=>I.concat(E),c)}e.newWriteableBufferStream=y;function r(c,E){return o.prefixedReadable(c,E,f=>I.concat(f))}e.prefixedBufferReadable=r;function d(c,E){return o.prefixedStream(c,E,f=>I.concat(f))}e.prefixedBufferStream=d;function i(c){let E=0,f=0,D=0;const L=new Uint8Array(Math.floor(c.length/4*3)),W=v=>{switch(f){case 3:L[D++]=E|v,f=0;break;case 2:L[D++]=E|v>>>2,E=v<<6,f=3;break;case 1:L[D++]=E|v>>>4,E=v<<4,f=2;break;default:E=v<<2,f=1}};for(let v=0;v<c.length;v++){const F=c.charCodeAt(v);if(F>=65&&F<=90)W(F-65);else if(F>=97&&F<=122)W(F-97+26);else if(F>=48&&F<=57)W(F-48+52);else if(F===43||F===45)W(62);else if(F===47||F===95)W(63);else{if(F===61)break;throw new SyntaxError(`Unexpected base64 character ${c[v]}`)}}const N=D;for(;f>0;)W(0);return I.wrap(L).slice(0,N)}e.decodeBase64=i;const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function t({buffer:c},E=!0,f=!1){const D=f?n:s;let L="";const W=c.byteLength%3;let N=0;for(;N<c.byteLength-W;N+=3){const v=c[N+0],F=c[N+1],O=c[N+2];L+=D[v>>>2],L+=D[(v<<4|F>>>4)&63],L+=D[(F<<2|O>>>6)&63],L+=D[O&63]}if(W===1){const v=c[N+0];L+=D[v>>>2],L+=D[v<<4&63],E&&(L+="==")}else if(W===2){const v=c[N+0],F=c[N+1];L+=D[v>>>2],L+=D[(v<<4|F>>>4)&63],L+=D[F<<2&63],E&&(L+="=")}return L}e.encodeBase64=t}),define(De[43],Ce([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const o=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function C(p){return o.test(p)}e.isUUID=C,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let p;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?p=crypto.getRandomValues.bind(crypto):p=function(P){for(let b=0;b<P.length;b++)P[b]=Math.floor(Math.random()*256);return P};const U=new Uint8Array(16),I=[];for(let P=0;P<256;P++)I.push(P.toString(16).padStart(2,"0"));return function(){p(U),U[6]=U[6]&15|64,U[8]=U[8]&63|128;let b=0,A="";return A+=I[U[b++]],A+=I[U[b++]],A+=I[U[b++]],A+=I[U[b++]],A+="-",A+=I[U[b++]],A+=I[U[b++]],A+="-",A+=I[U[b++]],A+=I[U[b++]],A+="-",A+=I[U[b++]],A+=I[U[b++]],A+="-",A+=I[U[b++]],A+=I[U[b++]],A+=I[U[b++]],A+=I[U[b++]],A+=I[U[b++]],A+=I[U[b++]],A}}()}),define(De[108],Ce([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(De[109],Ce([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var o;(function(I){I[I.None=0]="None",I[I.Indent=1]="Indent",I[I.IndentOutdent=2]="IndentOutdent",I[I.Outdent=3]="Outdent"})(o=e.IndentAction||(e.IndentAction={}));class C{constructor(P){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=P.open,this.close=P.close,this._inString=!0,this._inComment=!0,this._inRegEx=!0,Array.isArray(P.notIn))for(let b=0,A=P.notIn.length;b<A;b++)switch(P.notIn[b]){case"string":this._inString=!1;break;case"comment":this._inComment=!1;break;case"regex":this._inRegEx=!1;break}}isOK(P){switch(P){case 0:return!0;case 1:return this._inComment;case 2:return this._inString;case 3:return this._inRegEx}}shouldAutoClose(P,b){if(P.getTokenCount()===0)return!0;const A=P.findTokenIndexAtOffset(b-2),R=P.getStandardTokenType(A);return this.isOK(R)}_findNeutralCharacterInRange(P,b){for(let A=P;A<=b;A++){const R=String.fromCharCode(A);if(!this.open.includes(R)&&!this.close.includes(R))return R}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=C;class p{constructor(P){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const b of P)U(this.autoClosingPairsOpenByStart,b.open.charAt(0),b),U(this.autoClosingPairsOpenByEnd,b.open.charAt(b.open.length-1),b),U(this.autoClosingPairsCloseByStart,b.close.charAt(0),b),U(this.autoClosingPairsCloseByEnd,b.close.charAt(b.close.length-1),b),b.close.length===1&&b.open.length===1&&U(this.autoClosingPairsCloseSingleChar,b.close,b)}}e.AutoClosingPairs=p;function U(I,P,b){I.has(P)?I.get(P).push(b):I.set(P,[b])}}),define(De[110],Ce([17,18]),function(J,e){return J.create("vs/base/common/date",e)}),define(De[111],Ce([1,0,110]),function(J,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const C=60,p=C*60,U=p*24,I=U*7,P=U*30,b=U*365;function A(_,m,T){typeof _!="number"&&(_=_.getTime());const g=Math.round((new Date().getTime()-_)/1e3);if(g<-30)return(0,o.localize)(0,null,A(new Date().getTime()+g*1e3,!1));if(g<30)return(0,o.localize)(1,null);let h;return g<C?(h=g,m?h===1?T?(0,o.localize)(2,null,h):(0,o.localize)(3,null,h):T?(0,o.localize)(4,null,h):(0,o.localize)(5,null,h):h===1?T?(0,o.localize)(6,null,h):(0,o.localize)(7,null,h):T?(0,o.localize)(8,null,h):(0,o.localize)(9,null,h)):g<p?(h=Math.floor(g/C),m?h===1?T?(0,o.localize)(10,null,h):(0,o.localize)(11,null,h):T?(0,o.localize)(12,null,h):(0,o.localize)(13,null,h):h===1?T?(0,o.localize)(14,null,h):(0,o.localize)(15,null,h):T?(0,o.localize)(16,null,h):(0,o.localize)(17,null,h)):g<U?(h=Math.floor(g/p),m?h===1?T?(0,o.localize)(18,null,h):(0,o.localize)(19,null,h):T?(0,o.localize)(20,null,h):(0,o.localize)(21,null,h):h===1?T?(0,o.localize)(22,null,h):(0,o.localize)(23,null,h):T?(0,o.localize)(24,null,h):(0,o.localize)(25,null,h)):g<I?(h=Math.floor(g/U),m?h===1?(0,o.localize)(26,null,h):(0,o.localize)(27,null,h):h===1?(0,o.localize)(28,null,h):(0,o.localize)(29,null,h)):g<P?(h=Math.floor(g/I),m?h===1?T?(0,o.localize)(30,null,h):(0,o.localize)(31,null,h):T?(0,o.localize)(32,null,h):(0,o.localize)(33,null,h):h===1?T?(0,o.localize)(34,null,h):(0,o.localize)(35,null,h):T?(0,o.localize)(36,null,h):(0,o.localize)(37,null,h)):g<b?(h=Math.floor(g/P),m?h===1?T?(0,o.localize)(38,null,h):(0,o.localize)(39,null,h):T?(0,o.localize)(40,null,h):(0,o.localize)(41,null,h):h===1?T?(0,o.localize)(42,null,h):(0,o.localize)(43,null,h):T?(0,o.localize)(44,null,h):(0,o.localize)(45,null,h)):(h=Math.floor(g/b),m?h===1?T?(0,o.localize)(46,null,h):(0,o.localize)(47,null,h):T?(0,o.localize)(48,null,h):(0,o.localize)(49,null,h):h===1?T?(0,o.localize)(50,null,h):(0,o.localize)(51,null,h):T?(0,o.localize)(52,null,h):(0,o.localize)(53,null,h))}e.fromNow=A;function R(_){return _.getFullYear()+"-"+String(_.getMonth()+1).padStart(2,"0")+"-"+String(_.getDate()).padStart(2,"0")+"T"+String(_.getHours()).padStart(2,"0")+":"+String(_.getMinutes()).padStart(2,"0")+":"+String(_.getSeconds()).padStart(2,"0")+"."+(_.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=R}),define(De[112],Ce([17,18]),function(J,e){return J.create("vs/base/common/errorMessage",e)}),define(De[44],Ce([1,0,16,9,112]),function(J,e,o,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function U(_,m){return m&&(_.stack||_.stacktrace)?p.localize(0,null,P(_),I(_.stack)||I(_.stacktrace)):P(_)}function I(_){return Array.isArray(_)?_.join(`
`):_}function P(_){return typeof _.code=="string"&&typeof _.errno=="number"&&typeof _.syscall=="string"?p.localize(1,null,_.message):_.message||p.localize(2,null)}function b(_=null,m=!1){if(!_)return p.localize(3,null);if(Array.isArray(_)){const T=o.coalesce(_),g=b(T[0],m);return T.length>1?p.localize(4,null,g,T.length):g}if(C.isString(_))return _;if(_.detail){const T=_.detail;if(T.error)return U(T.error,m);if(T.exception)return U(T.exception,m)}return _.stack?U(_,m):_.message?_.message:p.localize(5,null)}e.toErrorMessage=b;function A(_){const m=_;return m instanceof Error&&Array.isArray(m.actions)}e.isErrorWithActions=A;function R(_,m){let T;return typeof _=="string"?T=new Error(_):T=_,T.actions=m,T}e.createErrorWithActions=R}),define(De[74],Ce([1,0,19]),function(J,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const C={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},p={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function U(R){const _=(0,o.extname)(R),m=C[_.toLowerCase()];return m!==void 0?m:I(R)}e.getMediaOrTextMime=U;function I(R){const _=(0,o.extname)(R);return p[_.toLowerCase()]}e.getMediaMime=I;function P(R){for(const _ in p)if(p[_]===R)return _}e.getExtensionForMimeType=P;const b=/^(.+)\/(.+?)(;.+)?$/;function A(R,_){const m=b.exec(R);return m?`${m[1].toLowerCase()}/${m[2].toLowerCase()}${m[3]??""}`:_?void 0:R}e.normalizeMimeType=A}),define(De[37],Ce([1,0,19,22,10,9]),function(J,e,o,C,p,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function I(n){return n===47||n===92}e.isPathSeparator=I;function P(n){return n.replace(/[\\/]/g,o.posix.sep)}e.toSlashes=P;function b(n){return n.indexOf("/")===-1&&(n=P(n)),/^[a-zA-Z]:(\/|$)/.test(n)&&(n="/"+n),n}e.toPosixPath=b;function A(n,t=o.posix.sep){if(!n)return"";const c=n.length,E=n.charCodeAt(0);if(I(E)){if(I(n.charCodeAt(1))&&!I(n.charCodeAt(2))){let D=3;const L=D;for(;D<c&&!I(n.charCodeAt(D));D++);if(L!==D&&!I(n.charCodeAt(D+1))){for(D+=1;D<c;D++)if(I(n.charCodeAt(D)))return n.slice(0,D+1).replace(/[\\/]/g,t)}}return t}else if(l(E)&&n.charCodeAt(1)===58)return I(n.charCodeAt(2))?n.slice(0,2)+t:n.slice(0,2);let f=n.indexOf("://");if(f!==-1){for(f+=3;f<c;f++)if(I(n.charCodeAt(f)))return n.slice(0,f+1)}return""}e.getRoot=A;function R(n){if(!C.isWindows||!n||n.length<5)return!1;let t=n.charCodeAt(0);if(t!==92||(t=n.charCodeAt(1),t!==92))return!1;let c=2;const E=c;for(;c<n.length&&(t=n.charCodeAt(c),t!==92);c++);return!(E===c||(t=n.charCodeAt(c+1),isNaN(t)||t===92))}e.isUNC=R;const _=/[\\/:\*\?"<>\|]/g,m=/[\\/]/g,T=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function g(n,t=C.isWindows){const c=t?_:m;return!(!n||n.length===0||/^\s+$/.test(n)||(c.lastIndex=0,c.test(n))||t&&T.test(n)||n==="."||n===".."||t&&n[n.length-1]==="."||t&&n.length!==n.trim().length||n.length>255)}e.isValidBasename=g;function h(n,t,c){const E=n===t;return!c||E?E:!n||!t?!1:(0,p.equalsIgnoreCase)(n,t)}e.isEqual=h;function u(n,t,c,E=o.sep){if(n===t)return!0;if(!n||!t||t.length>n.length)return!1;if(c){if(!(0,p.startsWithIgnoreCase)(n,t))return!1;if(t.length===n.length)return!0;let D=t.length;return t.charAt(t.length-1)===E&&D--,n.charAt(D)===E}return t.charAt(t.length-1)!==E&&(t+=E),n.indexOf(t)===0}e.isEqualOrParent=u;function l(n){return n>=65&&n<=90||n>=97&&n<=122}e.isWindowsDriveLetter=l;function S(n,t){return C.isWindows&&n.endsWith(":")&&(n+=o.sep),(0,o.isAbsolute)(n)||(n=(0,o.join)(t,n)),n=(0,o.normalize)(n),C.isWindows?(n=(0,p.rtrim)(n,o.sep),n.endsWith(":")&&(n+=o.sep)):(n=(0,p.rtrim)(n,o.sep),n||(n=o.sep)),n}e.sanitizeFilePath=S;function w(n){const t=(0,o.normalize)(n);return C.isWindows?n.length>3?!1:a(t)&&(n.length===2||t.charCodeAt(2)===92):t===o.posix.sep}e.isRootOrDriveLetter=w;function a(n,t=C.isWindows){return t?l(n.charCodeAt(0))&&n.charCodeAt(1)===58:!1}e.hasDriveLetter=a;function y(n){return a(n)?n[0]:void 0}e.getDriveLetter=y;function r(n,t,c){return t.length>n.length?-1:n===t?0:(c&&(n=n.toLowerCase(),t=t.toLowerCase()),n.indexOf(t))}e.indexOfPath=r;function d(n){const t=n.split(":");let c,E,f;for(const D of t){const L=Number(D);(0,U.isNumber)(L)?E===void 0?E=L:f===void 0&&(f=L):c=c?[c,D].join(":"):D}if(!c)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:c,line:E!==void 0?E:void 0,column:f!==void 0?f:E!==void 0?1:void 0}}e.parseLineAndColumnAware=d;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function s(n,t,c=8){let E="";for(let D=0;D<c;D++)E+=i.charAt(Math.floor(Math.random()*i.length));let f;return t?f=`${t}-${E}`:f=E,n?(0,o.join)(n,f):f}e.randomPath=s});var Ye=this&&this.__classPrivateFieldSet||function(J,e,o,C,p){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!p)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!p:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?p.call(J,o):p?p.value=o:e.set(J,o),o},Ae=this&&this.__classPrivateFieldGet||function(J,e,o,C){if(o==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!C:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?C:o==="a"?C.call(J):C?C.value:e.get(J)};define(De[24],Ce([1,0,16,10]),function(J,e,o,C){"use strict";var p,U,I,P;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function b(n,t,c){let E=n.get(t);return E===void 0&&(E=c,n.set(t,E)),E}e.getOrSet=b;function A(n){const t=[];return n.forEach((c,E)=>{t.push(`${E} => ${c}`)}),`Map(${n.size}) {${t.join(", ")}}`}e.mapToString=A;function R(n){const t=[];return n.forEach(c=>{t.push(c)}),`Set(${n.size}) {${t.join(", ")}}`}e.setToString=R;class _{constructor(){this._value="",this._pos=0}reset(t){return this._value=t,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(t){const c=t.charCodeAt(0),E=this._value.charCodeAt(this._pos);return c-E}value(){return this._value[this._pos]}}e.StringIterator=_;class m{constructor(t=!0){this._caseSensitive=t}reset(t){return this._value=t,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let t=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(t)this._from++;else break;else t=!1;return this}cmp(t){return this._caseSensitive?(0,C.compareSubstring)(t,this._value,0,t.length,this._from,this._to):(0,C.compareSubstringIgnoreCase)(t,this._value,0,t.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=m;class T{constructor(t=!0,c=!0){this._splitOnBackslash=t,this._caseSensitive=c}reset(t){this._from=0,this._to=0,this._value=t,this._valueLen=t.length;for(let c=t.length-1;c>=0;c--,this._valueLen--){const E=this._value.charCodeAt(c);if(!(E===47||this._splitOnBackslash&&E===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let t=!0;for(;this._to<this._valueLen;this._to++){const c=this._value.charCodeAt(this._to);if(c===47||this._splitOnBackslash&&c===92)if(t)this._from++;else break;else t=!1}return this}cmp(t){return this._caseSensitive?(0,C.compareSubstring)(t,this._value,0,t.length,this._from,this._to):(0,C.compareSubstringIgnoreCase)(t,this._value,0,t.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=T;var g;(function(n){n[n.Scheme=1]="Scheme",n[n.Authority=2]="Authority",n[n.Path=3]="Path",n[n.Query=4]="Query",n[n.Fragment=5]="Fragment"})(g||(g={}));class h{constructor(t,c){this._ignorePathCasing=t,this._ignoreQueryAndFragment=c,this._states=[],this._stateIdx=0}reset(t){return this._value=t,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new T(!1,!this._ignorePathCasing(t)),this._pathIterator.reset(t.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(t)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(t){if(this._states[this._stateIdx]===1)return(0,C.compareIgnoreCase)(t,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,C.compareIgnoreCase)(t,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(t);if(this._states[this._stateIdx]===4)return(0,C.compare)(t,this._value.query);if(this._states[this._stateIdx]===5)return(0,C.compare)(t,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=h;class u{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const t=this.right;return this.right=t.left,t.left=this,this.updateHeight(),t.updateHeight(),t}rotateRight(){const t=this.left;return this.left=t.right,t.right=this,this.updateHeight(),t.updateHeight(),t}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var l;(function(n){n[n.Left=-1]="Left",n[n.Mid=0]="Mid",n[n.Right=1]="Right"})(l||(l={}));class S{constructor(t){this._iter=t}static forUris(t=()=>!1,c=()=>!1){return new S(new h(t,c))}static forPaths(t=!1){return new S(new T(void 0,!t))}static forStrings(){return new S(new _)}static forConfigKeys(){return new S(new m)}clear(){this._root=void 0}fill(t,c){if(c){const E=c.slice(0);(0,o.shuffle)(E);for(const f of E)this.set(f,t)}else{const E=t.slice(0);(0,o.shuffle)(E);for(const f of E)this.set(f[0],f[1])}}set(t,c){const E=this._iter.reset(t);let f;this._root||(this._root=new u,this._root.segment=E.value());const D=[];for(f=this._root;;){const W=E.cmp(f.segment);if(W>0)f.left||(f.left=new u,f.left.segment=E.value()),D.push([-1,f]),f=f.left;else if(W<0)f.right||(f.right=new u,f.right.segment=E.value()),D.push([1,f]),f=f.right;else if(E.hasNext())E.next(),f.mid||(f.mid=new u,f.mid.segment=E.value()),D.push([0,f]),f=f.mid;else break}const L=f.value;f.value=c,f.key=t;for(let W=D.length-1;W>=0;W--){const N=D[W][1];N.updateHeight();const v=N.balanceFactor();if(v<-1||v>1){const F=D[W][0],O=D[W+1][0];if(F===1&&O===1)D[W][1]=N.rotateLeft();else if(F===-1&&O===-1)D[W][1]=N.rotateRight();else if(F===1&&O===-1)N.right=D[W+1][1]=D[W+1][1].rotateRight(),D[W][1]=N.rotateLeft();else if(F===-1&&O===1)N.left=D[W+1][1]=D[W+1][1].rotateLeft(),D[W][1]=N.rotateRight();else throw new Error;if(W>0)switch(D[W-1][0]){case-1:D[W-1][1].left=D[W][1];break;case 1:D[W-1][1].right=D[W][1];break;case 0:D[W-1][1].mid=D[W][1];break}else this._root=D[0][1]}}return L}get(t){return this._getNode(t)?.value}_getNode(t){const c=this._iter.reset(t);let E=this._root;for(;E;){const f=c.cmp(E.segment);if(f>0)E=E.left;else if(f<0)E=E.right;else if(c.hasNext())c.next(),E=E.mid;else break}return E}has(t){const c=this._getNode(t);return!(c?.value===void 0&&c?.mid===void 0)}delete(t){return this._delete(t,!1)}deleteSuperstr(t){return this._delete(t,!0)}_delete(t,c){const E=this._iter.reset(t),f=[];let D=this._root;for(;D;){const L=E.cmp(D.segment);if(L>0)f.push([-1,D]),D=D.left;else if(L<0)f.push([1,D]),D=D.right;else if(E.hasNext())E.next(),f.push([0,D]),D=D.mid;else break}if(!!D){if(c?(D.left=void 0,D.mid=void 0,D.right=void 0,D.height=1):(D.key=void 0,D.value=void 0),!D.mid&&!D.value)if(D.left&&D.right){const L=this._min(D.right),{key:W,value:N,segment:v}=L;this._delete(L.key,!1),D.key=W,D.value=N,D.segment=v}else{const L=D.left??D.right;if(f.length>0){const[W,N]=f[f.length-1];switch(W){case-1:N.left=L;break;case 0:N.mid=L;break;case 1:N.right=L;break}}else this._root=L}for(let L=f.length-1;L>=0;L--){const W=f[L][1];W.updateHeight();const N=W.balanceFactor();if(N>1?(W.right.balanceFactor()>=0||(W.right=W.right.rotateRight()),f[L][1]=W.rotateLeft()):N<-1&&(W.left.balanceFactor()<=0||(W.left=W.left.rotateLeft()),f[L][1]=W.rotateRight()),L>0)switch(f[L-1][0]){case-1:f[L-1][1].left=f[L][1];break;case 1:f[L-1][1].right=f[L][1];break;case 0:f[L-1][1].mid=f[L][1];break}else this._root=f[0][1]}}}_min(t){for(;t.left;)t=t.left;return t}findSubstr(t){const c=this._iter.reset(t);let E=this._root,f;for(;E;){const D=c.cmp(E.segment);if(D>0)E=E.left;else if(D<0)E=E.right;else if(c.hasNext())c.next(),f=E.value||f,E=E.mid;else break}return E&&E.value||f}findSuperstr(t){const c=this._iter.reset(t);let E=this._root;for(;E;){const f=c.cmp(E.segment);if(f>0)E=E.left;else if(f<0)E=E.right;else if(c.hasNext())c.next(),E=E.mid;else return E.mid?this._entries(E.mid):void 0}}forEach(t){for(const[c,E]of this)t(E,c)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(t){!t||(t.left&&(yield*this._entries(t.left)),t.value&&(yield[t.key,t.value]),t.mid&&(yield*this._entries(t.mid)),t.right&&(yield*this._entries(t.right)))}_isBalanced(){const t=c=>{if(!c)return!0;const E=c.balanceFactor();return E<-1||E>1?!1:t(c.left)&&t(c.right)};return t(this._root)}}e.TernarySearchTree=S;class w{constructor(t,c){this.uri=t,this.value=c}}class a{constructor(t,c){this[p]="ResourceMap",t instanceof a?(this.map=new Map(t.map),this.toKey=c??a.defaultToKey):(this.map=new Map,this.toKey=t??a.defaultToKey)}set(t,c){return this.map.set(this.toKey(t),new w(t,c)),this}get(t){return this.map.get(this.toKey(t))?.value}has(t){return this.map.has(this.toKey(t))}get size(){return this.map.size}clear(){this.map.clear()}delete(t){return this.map.delete(this.toKey(t))}forEach(t,c){typeof c!="undefined"&&(t=t.bind(c));for(const[E,f]of this.map)t(f.value,f.uri,this)}*values(){for(const t of this.map.values())yield t.value}*keys(){for(const t of this.map.values())yield t.uri}*entries(){for(const t of this.map.values())yield[t.uri,t.value]}*[(p=Symbol.toStringTag,Symbol.iterator)](){for(const[,t]of this.map)yield[t.uri,t.value]}}e.ResourceMap=a,a.defaultToKey=n=>n.toString();class y{constructor(t,c){this[U]="ResourceSet",!t||typeof t=="function"?this._map=new a(t):(this._map=new a(c),t.forEach(this.add,this))}get size(){return this._map.size}add(t){return this._map.set(t,t),this}clear(){this._map.clear()}delete(t){return this._map.delete(t)}forEach(t,c){this._map.forEach((E,f)=>t.call(c,f,f,this))}has(t){return this._map.has(t)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(U=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=y;var r;(function(n){n[n.None=0]="None",n[n.AsOld=1]="AsOld",n[n.AsNew=2]="AsNew"})(r=e.Touch||(e.Touch={}));class d{constructor(){this[I]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(t){return this._map.has(t)}get(t,c=0){const E=this._map.get(t);if(!!E)return c!==0&&this.touch(E,c),E.value}set(t,c,E=0){let f=this._map.get(t);if(f)f.value=c,E!==0&&this.touch(f,E);else{switch(f={key:t,value:c,next:void 0,previous:void 0},E){case 0:this.addItemLast(f);break;case 1:this.addItemFirst(f);break;case 2:this.addItemLast(f);break;default:this.addItemLast(f);break}this._map.set(t,f),this._size++}return this}delete(t){return!!this.remove(t)}remove(t){const c=this._map.get(t);if(!!c)return this._map.delete(t),this.removeItem(c),this._size--,c.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const t=this._head;return this._map.delete(t.key),this.removeItem(t),this._size--,t.value}forEach(t,c){const E=this._state;let f=this._head;for(;f;){if(c?t.bind(c)(f.value,f.key,this):t(f.value,f.key,this),this._state!==E)throw new Error("LinkedMap got modified during iteration.");f=f.next}}keys(){const t=this,c=this._state;let E=this._head;const f={[Symbol.iterator](){return f},next(){if(t._state!==c)throw new Error("LinkedMap got modified during iteration.");if(E){const D={value:E.key,done:!1};return E=E.next,D}else return{value:void 0,done:!0}}};return f}values(){const t=this,c=this._state;let E=this._head;const f={[Symbol.iterator](){return f},next(){if(t._state!==c)throw new Error("LinkedMap got modified during iteration.");if(E){const D={value:E.value,done:!1};return E=E.next,D}else return{value:void 0,done:!0}}};return f}entries(){const t=this,c=this._state;let E=this._head;const f={[Symbol.iterator](){return f},next(){if(t._state!==c)throw new Error("LinkedMap got modified during iteration.");if(E){const D={value:[E.key,E.value],done:!1};return E=E.next,D}else return{value:void 0,done:!0}}};return f}[(I=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(t){if(t>=this.size)return;if(t===0){this.clear();return}let c=this._head,E=this.size;for(;c&&E>t;)this._map.delete(c.key),c=c.next,E--;this._head=c,this._size=E,c&&(c.previous=void 0),this._state++}addItemFirst(t){if(!this._head&&!this._tail)this._tail=t;else if(this._head)t.next=this._head,this._head.previous=t;else throw new Error("Invalid list");this._head=t,this._state++}addItemLast(t){if(!this._head&&!this._tail)this._head=t;else if(this._tail)t.previous=this._tail,this._tail.next=t;else throw new Error("Invalid list");this._tail=t,this._state++}removeItem(t){if(t===this._head&&t===this._tail)this._head=void 0,this._tail=void 0;else if(t===this._head){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this._head=t.next}else if(t===this._tail){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this._tail=t.previous}else{const c=t.next,E=t.previous;if(!c||!E)throw new Error("Invalid list");c.previous=E,E.next=c}t.next=void 0,t.previous=void 0,this._state++}touch(t,c){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(c!==1&&c!==2)){if(c===1){if(t===this._head)return;const E=t.next,f=t.previous;t===this._tail?(f.next=void 0,this._tail=f):(E.previous=f,f.next=E),t.previous=void 0,t.next=this._head,this._head.previous=t,this._head=t,this._state++}else if(c===2){if(t===this._tail)return;const E=t.next,f=t.previous;t===this._head?(E.previous=void 0,this._head=E):(E.previous=f,f.next=E),t.next=void 0,t.previous=this._tail,this._tail.next=t,this._tail=t,this._state++}}}toJSON(){const t=[];return this.forEach((c,E)=>{t.push([E,c])}),t}fromJSON(t){this.clear();for(const[c,E]of t)this.set(c,E)}}e.LinkedMap=d;class i extends d{constructor(t,c=1){super();this._limit=t,this._ratio=Math.min(Math.max(0,c),1)}get limit(){return this._limit}set limit(t){this._limit=t,this.checkTrim()}get ratio(){return this._ratio}set ratio(t){this._ratio=Math.min(Math.max(0,t),1),this.checkTrim()}get(t,c=2){return super.get(t,c)}peek(t){return super.get(t,0)}set(t,c){return super.set(t,c,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=i;class s{constructor(t){P.set(this,void 0),Ye(this,P,t,"f")}get size(){return Ae(this,P,"f").size}forEach(t,c){Ae(this,P,"f").forEach(t,c)}get(t){return Ae(this,P,"f").get(t)}has(t){return Ae(this,P,"f").has(t)}entries(){return Ae(this,P,"f").entries()}keys(){return Ae(this,P,"f").keys()}values(){return Ae(this,P,"f").values()}[(P=new WeakMap,Symbol.iterator)](){return Ae(this,P,"f").entries()}}e.ReadonlyMapView=s}),define(De[113],Ce([1,0,24,10]),function(J,e,o,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function p(...G){return function(X,k){for(let B=0,V=G.length;B<V;B++){const j=G[B](X,k);if(j)return j}return null}}e.or=p,e.matchesStrictPrefix=U.bind(void 0,!1),e.matchesPrefix=U.bind(void 0,!0);function U(G,X,k){if(!k||k.length<X.length)return null;let B;return G?B=C.startsWithIgnoreCase(k,X):B=k.indexOf(X)===0,B?X.length>0?[{start:0,end:X.length}]:[]:null}function I(G,X){const k=X.toLowerCase().indexOf(G.toLowerCase());return k===-1?null:[{start:k,end:k+G.length}]}e.matchesContiguousSubString=I;function P(G,X){return b(G.toLowerCase(),X.toLowerCase(),0,0)}e.matchesSubString=P;function b(G,X,k,B){if(k===G.length)return[];if(B===X.length)return null;if(G[k]===X[B]){let V=null;return(V=b(G,X,k+1,B+1))?l({start:B,end:B+1},V):null}return b(G,X,k,B+1)}function A(G){return 97<=G&&G<=122}function R(G){return 65<=G&&G<=90}e.isUpper=R;function _(G){return 48<=G&&G<=57}function m(G){return G===32||G===9||G===10||G===13}const T=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(G=>T.add(G.charCodeAt(0)));function g(G){return m(G)||T.has(G)}function h(G,X){return G===X||g(G)&&g(X)}function u(G){return A(G)||R(G)||_(G)}function l(G,X){return X.length===0?X=[G]:G.end===X[0].start?X[0].start=G.start:X.unshift(G),X}function S(G,X){for(let k=X;k<G.length;k++){const B=G.charCodeAt(k);if(R(B)||_(B)||k>0&&!u(G.charCodeAt(k-1)))return k}return G.length}function w(G,X,k,B){if(k===G.length)return[];if(B===X.length)return null;if(G[k]!==X[B].toLowerCase())return null;{let V=null,j=B+1;for(V=w(G,X,k+1,B+1);!V&&(j=S(X,j))<X.length;)V=w(G,X,k+1,j),j++;return V===null?null:l({start:B,end:B+1},V)}}function a(G){let X=0,k=0,B=0,V=0,j=0;for(let fe=0;fe<G.length;fe++)j=G.charCodeAt(fe),R(j)&&X++,A(j)&&k++,u(j)&&B++,_(j)&&V++;const ne=X/G.length,ue=k/G.length,Y=B/G.length,ge=V/G.length;return{upperPercent:ne,lowerPercent:ue,alphaPercent:Y,numericPercent:ge}}function y(G){const{upperPercent:X,lowerPercent:k}=G;return k===0&&X>.6}function r(G){const{upperPercent:X,lowerPercent:k,alphaPercent:B,numericPercent:V}=G;return k>.2&&X<.8&&B>.6&&V<.2}function d(G){let X=0,k=0,B=0,V=0;for(let j=0;j<G.length;j++)B=G.charCodeAt(j),R(B)&&X++,A(B)&&k++,m(B)&&V++;return(X===0||k===0)&&V===0?G.length<=30:X<=5}function i(G,X){if(!X||(X=X.trim(),X.length===0)||!d(G)||X.length>60)return null;const k=a(X);if(!r(k)){if(!y(k))return null;X=X.toLowerCase()}let B=null,V=0;for(G=G.toLowerCase();V<X.length&&(B=w(G,X,0,V))===null;)V=S(X,V+1);return B}e.matchesCamelCase=i;function s(G,X,k=!1){if(!X||X.length===0)return null;let B=null,V=0;for(G=G.toLowerCase(),X=X.toLowerCase();V<X.length&&(B=n(G,X,0,V,k))===null;)V=t(X,V+1);return B}e.matchesWords=s;function n(G,X,k,B,V){if(k===G.length)return[];if(B===X.length)return null;if(h(G.charCodeAt(k),X.charCodeAt(B))){let j=null,ne=B+1;if(j=n(G,X,k+1,B+1,V),!V)for(;!j&&(ne=t(X,ne))<X.length;)j=n(G,X,k+1,ne,V),ne++;return j===null?null:l({start:B,end:B+1},j)}else return null}function t(G,X){for(let k=X;k<G.length;k++)if(g(G.charCodeAt(k))||k>0&&g(G.charCodeAt(k-1)))return k;return G.length}const c=p(e.matchesPrefix,i,I),E=p(e.matchesPrefix,i,P),f=new o.LRUCache(1e4);function D(G,X,k=!1){if(typeof G!="string"||typeof X!="string")return null;let B=f.get(G);B||(B=new RegExp(C.convertSimple2RegExpPattern(G),"i"),f.set(G,B));const V=B.exec(X);return V?[{start:V.index,end:V.index+V[0].length}]:k?E(G,X):c(G,X)}e.matchesFuzzy=D;function L(G,X){const k=We(G,G.toLowerCase(),0,X,X.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return k?N(k):null}e.matchesFuzzy2=L;function W(G,X,k,B,V,j){const ne=Math.min(13,G.length);for(;k<ne;k++){const ue=We(G,X,k,B,V,j,{firstMatchCanBeWeak:!1,boostFullMatch:!0});if(ue)return ue}return[0,j]}e.anyScore=W;function N(G){if(typeof G=="undefined")return[];const X=[],k=G[1];for(let B=G.length-1;B>1;B--){const V=G[B]+k,j=X[X.length-1];j&&j.end===V?j.end=V+1:X.push({start:V,end:V+1})}return X}e.createMatches=N;const v=128;function F(){const G=[],X=[];for(let k=0;k<=v;k++)X[k]=0;for(let k=0;k<=v;k++)G.push(X.slice(0));return G}function O(G){const X=[];for(let k=0;k<=G;k++)X[k]=0;return X}const H=O(2*v),te=O(2*v),z=F(),$=F(),ce=F(),le=!1;function oe(G,X,k,B,V){function j(ue,Y,ge=" "){for(;ue.length<Y;)ue=ge+ue;return ue}let ne=` |   |${B.split("").map(ue=>j(ue,3)).join("|")}
`;for(let ue=0;ue<=k;ue++)ue===0?ne+=" |":ne+=`${X[ue-1]}|`,ne+=G[ue].slice(0,V+1).map(Y=>j(Y.toString(),3)).join("|")+`
`;return ne}function pe(G,X,k,B){G=G.substr(X),k=k.substr(B),console.log(oe($,G,G.length,k,k.length)),console.log(oe(ce,G,G.length,k,k.length)),console.log(oe(z,G,G.length,k,k.length))}function re(G,X){if(X<0||X>=G.length)return!1;const k=G.codePointAt(X);switch(k){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!C.isEmojiImprecise(k)}}function Ee(G,X){if(X<0||X>=G.length)return!1;switch(G.charCodeAt(X)){case 32:case 9:return!0;default:return!1}}function be(G,X,k){return X[G]!==k[G]}function Z(G,X,k,B,V,j,ne=!1){for(;X<k&&V<j;)G[X]===B[V]&&(ne&&(H[X]=V),X+=1),V+=1;return X===k}e.isPatternInWord=Z;var ve;(function(G){G[G.Diag=1]="Diag",G[G.Left=2]="Left",G[G.LeftLeft=3]="LeftLeft"})(ve||(ve={}));var Re;(function(G){G.Default=[-100,0];function X(k){return!k||k.length===2&&k[0]===-100&&k[1]===0}G.isDefault=X})(Re=e.FuzzyScore||(e.FuzzyScore={}));class Fe{constructor(X,k){this.firstMatchCanBeWeak=X,this.boostFullMatch=k}}e.FuzzyScoreOptions=Fe,Fe.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function We(G,X,k,B,V,j,ne=Fe.default){const ue=G.length>v?v:G.length,Y=B.length>v?v:B.length;if(k>=ue||j>=Y||ue-k>Y-j||!Z(X,k,ue,V,j,Y,!0))return;Xe(ue,Y,k,j,X,V);let ge=1,fe=1,Ne=k,ze=j;const ke=[!1];for(ge=1,Ne=k;Ne<ue;ge++,Ne++){const Le=H[Ne],Be=te[Ne],Ze=Ne+1<ue?te[Ne+1]:Y;for(fe=Le-j+1,ze=Le;ze<Ze;fe++,ze++){let et=Number.MIN_SAFE_INTEGER,at=!1;ze<=Be&&(et=Ie(G,X,Ne,k,B,V,ze,Y,j,z[ge-1][fe-1]===0,ke));let Je=0;et!==Number.MAX_SAFE_INTEGER&&(at=!0,Je=et+$[ge-1][fe-1]);const He=ze>Le,nt=He?$[ge][fe-1]+(z[ge][fe-1]>0?-5:0):0,st=ze>Le+1&&z[ge][fe-1]>0,ot=st?$[ge][fe-2]+(z[ge][fe-2]>0?-5:0):0;if(st&&(!He||ot>=nt)&&(!at||ot>=Je))$[ge][fe]=ot,ce[ge][fe]=3,z[ge][fe]=0;else if(He&&(!at||nt>=Je))$[ge][fe]=nt,ce[ge][fe]=2,z[ge][fe]=0;else if(at)$[ge][fe]=Je,ce[ge][fe]=1,z[ge][fe]=z[ge-1][fe-1]+1;else throw new Error("not possible")}}if(le&&pe(G,k,B,j),!ke[0]&&!ne.firstMatchCanBeWeak)return;ge--,fe--;const qe=[$[ge][fe],j];let K=0,Q=0;for(;ge>=1;){let Le=fe;do{const Be=ce[ge][Le];if(Be===3)Le=Le-2;else if(Be===2)Le=Le-1;else break}while(Le>=1);K>1&&X[k+ge-1]===V[j+fe-1]&&!be(Le+j-1,B,V)&&K+1>z[ge][Le]&&(Le=fe),Le===fe?K++:K=1,Q||(Q=Le),ge--,fe=Le-1,qe.push(fe)}Y===ue&&ne.boostFullMatch&&(qe[0]+=2);const me=Q-ue;return qe[0]-=me,qe}e.fuzzyScore=We;function Xe(G,X,k,B,V,j){let ne=G-1,ue=X-1;for(;ne>=k&&ue>=B;)V[ne]===j[ue]&&(te[ne]=ue,ne--),ue--}function Ie(G,X,k,B,V,j,ne,ue,Y,ge,fe){if(X[k]!==j[ne])return Number.MIN_SAFE_INTEGER;let Ne=1,ze=!1;return ne===k-B?Ne=G[k]===V[ne]?7:5:be(ne,V,j)&&(ne===0||!be(ne-1,V,j))?(Ne=G[k]===V[ne]?7:5,ze=!0):re(j,ne)&&(ne===0||!re(j,ne-1))?Ne=5:(re(j,ne-1)||Ee(j,ne-1))&&(Ne=5,ze=!0),Ne>1&&k===B&&(fe[0]=!0),ze||(ze=be(ne,V,j)||re(j,ne-1)||Ee(j,ne-1)),k===B?ne>Y&&(Ne-=ze?3:5):ge?Ne+=ze?2:0:Ne+=ze?0:1,ne+1===ue&&(Ne-=ze?3:5),Ne}function Se(G,X,k,B,V,j,ne){return se(G,X,k,B,V,j,!0,ne)}e.fuzzyScoreGracefulAggressive=Se;function Te(G,X,k,B,V,j,ne){return se(G,X,k,B,V,j,!1,ne)}e.fuzzyScoreGraceful=Te;function se(G,X,k,B,V,j,ne,ue){let Y=We(G,X,k,B,V,j,ue);if(Y&&!ne)return Y;if(G.length>=3){const ge=Math.min(7,G.length-1);for(let fe=k+1;fe<ge;fe++){const Ne=ae(G,fe);if(Ne){const ze=We(Ne,Ne.toLowerCase(),k,B,V,j,ue);ze&&(ze[0]-=3,(!Y||ze[0]>Y[0])&&(Y=ze))}}}return Y}function ae(G,X){if(X+1>=G.length)return;const k=G[X],B=G[X+1];if(k!==B)return G.slice(0,X)+B+k+G.slice(X+2)}}),define(De[114],Ce([1,0,115,113,10]),function(J,e,o,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const U=new RegExp(`\\$\\(${o.CSSIcon.iconNameExpression}(?:${o.CSSIcon.iconModifierExpression})?\\)`,"g"),I=new RegExp(o.CSSIcon.iconNameCharacter),P=new RegExp(`(\\\\)?${U.source}`,"g");function b(u){return u.replace(P,(l,S)=>S?l:`\\${l}`)}e.escapeIcons=b;const A=new RegExp(`\\\\${U.source}`,"g");function R(u){return u.replace(A,l=>`\\${l}`)}e.markdownEscapeEscapedIcons=R;const _=new RegExp(`(\\s)?(\\\\)?${U.source}(\\s)?`,"g");function m(u){return u.indexOf(e.iconStartMarker)===-1?u:u.replace(_,(l,S,w,a)=>w?l:S||a||"")}e.stripIcons=m;function T(u){const l=u.indexOf(e.iconStartMarker);return l===-1?{text:u}:g(u,l)}e.parseLabelWithIcons=T;function g(u,l){const S=[];let w="";function a(c){if(c){w+=c;for(const E of c)S.push(d)}}let y=-1,r="",d=0,i,s,n=l;const t=u.length;for(a(u.substr(0,l));n<t;)i=u[n],s=u[n+1],i===e.iconStartMarker[0]&&s===e.iconStartMarker[1]?(y=n,a(r),r=e.iconStartMarker,n++):i===")"&&y!==-1?(d+=n-y+1,y=-1,r=""):y!==-1?I.test(i)?r+=i:(a(r),y=-1,r=""):a(i),n++;return a(r),{text:w,iconOffsets:S}}function h(u,l,S=!1){const{text:w,iconOffsets:a}=l;if(!a||a.length===0)return(0,C.matchesFuzzy)(u,w,S);const y=(0,p.ltrim)(w," "),r=w.length-y.length,d=(0,C.matchesFuzzy)(u,y,S);if(d)for(const i of d){const s=a[i.start+r]+r;i.start+=s,i.end+=s}return d}e.matchesFuzzyIconAware=h}),define(De[29],Ce([1,0,10]),function(J,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var C;(function(p){p[p.Ignore=0]="Ignore",p[p.Info=1]="Info",p[p.Warning=2]="Warning",p[p.Error=3]="Error"})(C||(C={})),function(p){const U="error",I="warning",P="warn",b="info",A="ignore";function R(m){return m?o.equalsIgnoreCase(U,m)?p.Error:o.equalsIgnoreCase(I,m)||o.equalsIgnoreCase(P,m)?p.Warning:o.equalsIgnoreCase(b,m)?p.Info:p.Ignore:p.Ignore}p.fromValue=R;function _(m){switch(m){case p.Error:return U;case p.Warning:return I;case p.Info:return b;default:return A}}p.toString=_}(C||(C={})),e.default=C}),define(De[55],Ce([1,0,23,10,2]),function(J,e,o,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function U(A){return JSON.stringify(A,P)}e.stringify=U;function I(A){let R=JSON.parse(A);return R=b(R),R}e.parse=I;function P(A,R){return R instanceof RegExp?{$mid:2,source:R.source,flags:(0,C.regExpFlags)(R)}:R}function b(A,R=0){if(!A||R>200)return A;if(typeof A=="object"){switch(A.$mid){case 1:return p.URI.revive(A);case 2:return new RegExp(A.source,A.flags);case 14:return new Date(A.source)}if(A instanceof o.VSBuffer||A instanceof Uint8Array)return A;if(Array.isArray(A))for(let _=0;_<A.length;++_)A[_]=b(A[_],R+1);else for(const _ in A)Object.hasOwnProperty.call(A,_)&&(A[_]=b(A[_],R+1))}return A}e.revive=b}),define(De[12],Ce([1,0,22,2]),function(J,e,o,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var p;(function(P){P.inMemory="inmemory",P.vscode="vscode",P.internal="private",P.walkThrough="walkThrough",P.walkThroughSnippet="walkThroughSnippet",P.http="http",P.https="https",P.file="file",P.mailto="mailto",P.untitled="untitled",P.data="data",P.command="command",P.vscodeRemote="vscode-remote",P.vscodeRemoteResource="vscode-remote-resource",P.vscodeUserData="vscode-userdata",P.vscodeCustomEditor="vscode-custom-editor",P.vscodeNotebook="vscode-notebook",P.vscodeNotebookCell="vscode-notebook-cell",P.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",P.vscodeNotebookCellOutput="vscode-notebook-cell-output",P.vscodeInteractive="vscode-interactive",P.vscodeInteractiveInput="vscode-interactive-input",P.vscodeSettings="vscode-settings",P.vscodeWorkspaceTrust="vscode-workspace-trust",P.vscodeTerminal="vscode-terminal",P.webviewPanel="webview-panel",P.vscodeWebview="vscode-webview",P.extension="extension",P.vscodeFileResource="vscode-file",P.tmp="tmp",P.vsls="vsls"})(p=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class U{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${p.vscodeRemoteResource}`}setPreferredWebSchema(b){this._preferredWebSchema=b}setDelegate(b){this._delegate=b}setServerRootPath(b){this._remoteResourcesPath=`${b}/${p.vscodeRemoteResource}`}set(b,A,R){this._hosts[b]=A,this._ports[b]=R}setConnectionToken(b,A){this._connectionTokens[b]=A}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(b){if(this._delegate)return this._delegate(b);const A=b.authority;let R=this._hosts[A];R&&R.indexOf(":")!==-1&&(R=`[${R}]`);const _=this._ports[A],m=this._connectionTokens[A];let T=`path=${encodeURIComponent(b.path)}`;return typeof m=="string"&&(T+=`&${e.connectionTokenQueryName}=${encodeURIComponent(m)}`),C.URI.from({scheme:o.isWeb?this._preferredWebSchema:p.vscodeRemoteResource,authority:`${R}:${_}`,path:this._remoteResourcesPath,query:T})}}e.RemoteAuthorities=new U;class I{asBrowserUri(b,A){const R=this.toUri(b,A);return R.scheme===p.vscodeRemote?e.RemoteAuthorities.rewrite(R):R.scheme===p.file&&(o.isNative||o.isWebWorker&&o.globals.origin===`${p.vscodeFileResource}://${I.FALLBACK_AUTHORITY}`)?R.with({scheme:p.vscodeFileResource,authority:R.authority||I.FALLBACK_AUTHORITY,query:null,fragment:null}):R}asFileUri(b,A){const R=this.toUri(b,A);return R.scheme===p.vscodeFileResource?R.with({scheme:p.file,authority:R.authority!==I.FALLBACK_AUTHORITY?R.authority:null,query:null,fragment:null}):R}toUri(b,A){return C.URI.isUri(b)?b:C.URI.parse(A.toUrl(b))}}I.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new I}),define(De[21],Ce([1,0,37,12,19,22,10,2]),function(J,e,o,C,p,U,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function b(T){return(0,P.uriToFsPath)(T,!0)}e.originalFSPath=b;class A{constructor(g){this._ignorePathCasing=g}compare(g,h,u=!1){return g===h?0:(0,I.compare)(this.getComparisonKey(g,u),this.getComparisonKey(h,u))}isEqual(g,h,u=!1){return g===h?!0:!g||!h?!1:this.getComparisonKey(g,u)===this.getComparisonKey(h,u)}getComparisonKey(g,h=!1){return g.with({path:this._ignorePathCasing(g)?g.path.toLowerCase():void 0,fragment:h?null:void 0}).toString()}ignorePathCasing(g){return this._ignorePathCasing(g)}isEqualOrParent(g,h,u=!1){if(g.scheme===h.scheme){if(g.scheme===C.Schemas.file)return o.isEqualOrParent(b(g),b(h),this._ignorePathCasing(g))&&g.query===h.query&&(u||g.fragment===h.fragment);if((0,e.isEqualAuthority)(g.authority,h.authority))return o.isEqualOrParent(g.path,h.path,this._ignorePathCasing(g),"/")&&g.query===h.query&&(u||g.fragment===h.fragment)}return!1}joinPath(g,...h){return P.URI.joinPath(g,...h)}basenameOrAuthority(g){return(0,e.basename)(g)||g.authority}basename(g){return p.posix.basename(g.path)}extname(g){return p.posix.extname(g.path)}dirname(g){if(g.path.length===0)return g;let h;return g.scheme===C.Schemas.file?h=P.URI.file(p.dirname(b(g))).path:(h=p.posix.dirname(g.path),g.authority&&h.length&&h.charCodeAt(0)!==47&&(console.error(`dirname("${g.toString})) resulted in a relative path`),h="/")),g.with({path:h})}normalizePath(g){if(!g.path.length)return g;let h;return g.scheme===C.Schemas.file?h=P.URI.file(p.normalize(b(g))).path:h=p.posix.normalize(g.path),g.with({path:h})}relativePath(g,h){if(g.scheme!==h.scheme||!(0,e.isEqualAuthority)(g.authority,h.authority))return;if(g.scheme===C.Schemas.file){const S=p.relative(b(g),b(h));return U.isWindows?o.toSlashes(S):S}let u=g.path||"/";const l=h.path||"/";if(this._ignorePathCasing(g)){let S=0;for(const w=Math.min(u.length,l.length);S<w&&!(u.charCodeAt(S)!==l.charCodeAt(S)&&u.charAt(S).toLowerCase()!==l.charAt(S).toLowerCase());S++);u=l.substr(0,S)+u.substr(S)}return p.posix.relative(u,l)}resolvePath(g,h){if(g.scheme===C.Schemas.file){const u=P.URI.file(p.resolve(b(g),h));return g.with({authority:u.authority,path:u.path})}return h=o.toPosixPath(h),g.with({path:p.posix.resolve(g.path,h)})}isAbsolutePath(g){return!!g.path&&g.path[0]==="/"}isEqualAuthority(g,h){return g===h||g!==void 0&&h!==void 0&&(0,I.equalsIgnoreCase)(g,h)}hasTrailingPathSeparator(g,h=p.sep){if(g.scheme===C.Schemas.file){const u=b(g);return u.length>o.getRoot(u).length&&u[u.length-1]===h}else{const u=g.path;return u.length>1&&u.charCodeAt(u.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(g.fsPath)}}removeTrailingPathSeparator(g,h=p.sep){return(0,e.hasTrailingPathSeparator)(g,h)?g.with({path:g.path.substr(0,g.path.length-1)}):g}addTrailingPathSeparator(g,h=p.sep){let u=!1;if(g.scheme===C.Schemas.file){const l=b(g);u=l!==void 0&&l.length===o.getRoot(l).length&&l[l.length-1]===h}else{h="/";const l=g.path;u=l.length===1&&l.charCodeAt(l.length-1)===47}return!u&&!(0,e.hasTrailingPathSeparator)(g,h)?g.with({path:g.path+"/"}):g}}e.ExtUri=A,e.extUri=new A(()=>!1),e.extUriBiasedIgnorePathCase=new A(T=>T.scheme===C.Schemas.file?!U.isLinux:!0),e.extUriIgnorePathCase=new A(T=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function R(T,g){const h=[];for(let u=0;u<T.length;u++){const l=g(T[u]);T.some((S,w)=>w===u?!1:(0,e.isEqualOrParent)(l,g(S)))||h.push(T[u])}return h}e.distinctParents=R;var _;(function(T){T.META_DATA_LABEL="label",T.META_DATA_DESCRIPTION="description",T.META_DATA_SIZE="size",T.META_DATA_MIME="mime";function g(h){const u=new Map;h.path.substring(h.path.indexOf(";")+1,h.path.lastIndexOf(";")).split(";").forEach(w=>{const[a,y]=w.split(":");a&&y&&u.set(a,y)});const S=h.path.substring(0,h.path.indexOf(";"));return S&&u.set(T.META_DATA_MIME,S),u}T.parseMetaData=g})(_=e.DataUri||(e.DataUri={}));function m(T,g,h){if(g){let u=T.path;return u&&u[0]!==p.posix.sep&&(u=p.posix.sep+u),T.with({scheme:h,authority:g,path:u})}return T.with({scheme:h})}e.toLocalResource=m}),define(De[13],Ce([1,0,20,11,4,7,21,22]),function(J,e,o,C,p,U,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function b(be){return!!be&&typeof be.then=="function"}e.isThenable=b;function A(be){const Z=new o.CancellationTokenSource,ve=be(Z.token),Re=new Promise((Fe,We)=>{const Xe=Z.token.onCancellationRequested(()=>{Xe.dispose(),Z.dispose(),We(new C.CancellationError)});Promise.resolve(ve).then(Ie=>{Xe.dispose(),Z.dispose(),Fe(Ie)},Ie=>{Xe.dispose(),Z.dispose(),We(Ie)})});return new class{cancel(){Z.cancel()}then(Fe,We){return Re.then(Fe,We)}catch(Fe){return this.then(void 0,Fe)}finally(Fe){return Re.finally(Fe)}}}e.createCancelablePromise=A;function R(be,Z,ve){return new Promise((Re,Fe)=>{const We=Z.onCancellationRequested(()=>{We.dispose(),Re(ve)});be.then(Re,Fe).finally(()=>We.dispose())})}e.raceCancellation=R;function _(be,Z){return new Promise((ve,Re)=>{const Fe=Z.onCancellationRequested(()=>{Fe.dispose(),Re(new C.CancellationError)});be.then(ve,Re).finally(()=>Fe.dispose())})}e.raceCancellationError=_;async function m(be){let Z=-1;const ve=be.map((Fe,We)=>Fe.then(Xe=>(Z=We,Xe))),Re=await Promise.race(ve);return be.forEach((Fe,We)=>{We!==Z&&Fe.cancel()}),Re}e.raceCancellablePromises=m;function T(be,Z,ve){let Re;const Fe=setTimeout(()=>{Re?.(void 0),ve?.()},Z);return Promise.race([be.finally(()=>clearTimeout(Fe)),new Promise(We=>Re=We)])}e.raceTimeout=T;function g(be){return new Promise((Z,ve)=>{const Re=be();b(Re)?Re.then(Z,ve):Z(Re)})}e.asPromise=g;class h{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(Z){if(this.activePromise){if(this.queuedPromiseFactory=Z,!this.queuedPromise){const ve=()=>{this.queuedPromise=null;const Re=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,Re};this.queuedPromise=new Promise(Re=>{this.activePromise.then(ve,ve).then(Re)})}return new Promise((ve,Re)=>{this.queuedPromise.then(ve,Re)})}return this.activePromise=Z(),new Promise((ve,Re)=>{this.activePromise.then(Fe=>{this.activePromise=null,ve(Fe)},Fe=>{this.activePromise=null,Re(Fe)})})}}e.Throttler=h;class u{constructor(){this.current=Promise.resolve(null)}queue(Z){return this.current=this.current.then(()=>Z(),()=>Z())}}e.Sequencer=u;class l{constructor(){this.promiseMap=new Map}queue(Z,ve){const Fe=(this.promiseMap.get(Z)??Promise.resolve()).catch(()=>{}).then(ve).finally(()=>{this.promiseMap.get(Z)===Fe&&this.promiseMap.delete(Z)});return this.promiseMap.set(Z,Fe),Fe}}e.SequencerByKey=l;const S=(be,Z)=>{let ve=!0;const Re=setTimeout(()=>{ve=!1,Z()},be);return{isTriggered:()=>ve,dispose:()=>{clearTimeout(Re),ve=!1}}},w=be=>{let Z=!0;return queueMicrotask(()=>{Z&&(Z=!1,be())}),{isTriggered:()=>Z,dispose:()=>{Z=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class a{constructor(Z){this.defaultDelay=Z,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(Z,ve=this.defaultDelay){this.task=Z,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((Fe,We)=>{this.doResolve=Fe,this.doReject=We}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const Fe=this.task;return this.task=null,Fe()}}));const Re=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=ve===e.MicrotaskDelay?w(Re):S(ve,Re),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new C.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=a;class y{constructor(Z){this.delayer=new a(Z),this.throttler=new h}trigger(Z,ve){return this.delayer.trigger(()=>this.throttler.queue(Z),ve)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=y;class r{constructor(){this._isOpen=!1,this._promise=new Promise((Z,ve)=>{this._completePromise=Z})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=r;class d extends r{constructor(Z){super();this._timeout=setTimeout(()=>this.open(),Z)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=d;function i(be,Z){return Z?new Promise((ve,Re)=>{const Fe=setTimeout(()=>{We.dispose(),ve()},be),We=Z.onCancellationRequested(()=>{clearTimeout(Fe),We.dispose(),Re(new C.CancellationError)})}):A(ve=>i(be,ve))}e.timeout=i;function s(be,Z=0){const ve=setTimeout(be,Z);return(0,U.toDisposable)(()=>clearTimeout(ve))}e.disposableTimeout=s;function n(be){const Z=[];let ve=0;const Re=be.length;function Fe(){return ve<Re?be[ve++]():null}function We(Xe){Xe!=null&&Z.push(Xe);const Ie=Fe();return Ie?Ie.then(We):Promise.resolve(Z)}return Promise.resolve(null).then(We)}e.sequence=n;function t(be,Z=Re=>!!Re,ve=null){let Re=0;const Fe=be.length,We=()=>{if(Re>=Fe)return Promise.resolve(ve);const Xe=be[Re++];return Promise.resolve(Xe()).then(Se=>Z(Se)?Promise.resolve(Se):We())};return We()}e.first=t;function c(be,Z=Re=>!!Re,ve=null){if(be.length===0)return Promise.resolve(ve);let Re=be.length;const Fe=()=>{Re=-1;for(const We of be)We.cancel?.()};return new Promise((We,Xe)=>{for(const Ie of be)Ie.then(Se=>{--Re>=0&&Z(Se)?(Fe(),We(Se)):Re===0&&We(ve)}).catch(Se=>{--Re>=0&&(Fe(),Xe(Se))})})}e.firstParallel=c;class E{constructor(Z){this._size=0,this.maxDegreeOfParalellism=Z,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new p.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(Z){return this._size++,new Promise((ve,Re)=>{this.outstandingPromises.push({factory:Z,c:ve,e:Re}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const Z=this.outstandingPromises.shift();this.runningPromises++;const ve=Z.factory();ve.then(Z.c,Z.e),ve.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=E;class f extends E{constructor(){super(1)}}e.Queue=f;class D{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const Z=new ce;return this.drainers.add(Z),Z.p}isDrained(){for(const[,Z]of this.queues)if(Z.size>0)return!1;return!0}queueFor(Z,ve=I.extUri){const Re=ve.getComparisonKey(Z);let Fe=this.queues.get(Re);return Fe||(Fe=new f,p.Event.once(Fe.onDrained)(()=>{Fe?.dispose(),this.queues.delete(Re),this.onDidQueueDrain()}),this.queues.set(Re,Fe)),Fe}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const Z of this.drainers)Z.complete();this.drainers.clear()}dispose(){for(const[,Z]of this.queues)Z.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=D;class L{constructor(Z,ve){this._token=-1,typeof Z=="function"&&typeof ve=="number"&&this.setIfNotSet(Z,ve)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(Z,ve){this.cancel(),this._token=setTimeout(()=>{this._token=-1,Z()},ve)}setIfNotSet(Z,ve){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,Z()},ve))}}e.TimeoutTimer=L;class W{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(Z,ve){this.cancel(),this._token=setInterval(()=>{Z()},ve)}}e.IntervalTimer=W;class N{constructor(Z,ve){this.timeoutToken=-1,this.runner=Z,this.timeout=ve,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(Z=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,Z)}get delay(){return this.timeout}set delay(Z){this.timeout=Z}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=N;class v{constructor(Z,ve){ve%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ve}ms is not a multiple of 1000ms.`),this.runner=Z,this.timeout=ve,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(Z=this.timeout){Z%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Z}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(Z/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=v;class F extends N{constructor(Z,ve){super(Z,ve);this.units=[]}work(Z){this.units.push(Z),this.isScheduled()||this.schedule()}doRun(){const Z=this.units;this.units=[],this.runner?.(Z)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=F;class O extends U.Disposable{constructor(Z,ve){super();this.options=Z,this.handler=ve,this.pendingWork=[],this.throttler=this._register(new U.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(Z){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+Z.length>this.options.maxBufferedWork)return!1}else if(this.pending+Z.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...Z),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new N(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=O,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=be=>{(0,P.setTimeout0)(()=>{if(Z)return;const ve=Date.now()+15;be(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ve-Date.now())}}))});let Z=!1;return{dispose(){Z||(Z=!0)}}}:e.runWhenIdle=(be,Z)=>{const ve=requestIdleCallback(be,typeof Z=="number"?{timeout:Z}:void 0);let Re=!1;return{dispose(){Re||(Re=!0,cancelIdleCallback(ve))}}}}();class H{constructor(Z){this._didRun=!1,this._executor=()=>{try{this._value=Z()}catch(ve){this._error=ve}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=H;async function te(be,Z,ve){let Re;for(let Fe=0;Fe<ve;Fe++)try{return await be()}catch(We){Re=We,await i(Z)}throw Re}e.retry=te;class z{hasPending(Z){return this._pending?typeof Z=="number"?this._pending.taskId===Z:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(Z,ve,Re){return this._pending={taskId:Z,cancel:()=>Re?.(),promise:ve},ve.then(()=>this.donePending(Z),()=>this.donePending(Z)),ve}donePending(Z){this._pending&&Z===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const Z=this._next;this._next=void 0,Z.run().then(Z.promiseResolve,Z.promiseReject)}}setNext(Z){if(this._next)this._next.run=Z;else{let ve,Re;const Fe=new Promise((We,Xe)=>{ve=We,Re=Xe});this._next={run:Z,promise:Fe,promiseResolve:ve,promiseReject:Re}}return this._next.promise}}e.TaskSequentializer=z;class ${constructor(Z,ve=()=>Date.now()){this.interval=Z,this.nowFn=ve,this.lastIncrementTime=0,this.value=0}increment(){const Z=this.nowFn();return Z-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=Z,this.value=0),this.value++,this.value}}e.IntervalCounter=$;class ce{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((Z,ve)=>{this.completeCallback=Z,this.errorCallback=ve})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(Z){return new Promise(ve=>{this.completeCallback(Z),this.resolved=!0,ve()})}error(Z){return new Promise(ve=>{this.errorCallback(Z),this.rejected=!0,ve()})}cancel(){new Promise(Z=>{this.errorCallback(new C.CancellationError),this.rejected=!0,Z()})}}e.DeferredPromise=ce;var le;(function(be){async function Z(Re){let Fe;const We=await Promise.all(Re.map(Xe=>Xe.then(Ie=>Ie,Ie=>{Fe||(Fe=Ie)})));if(typeof Fe!="undefined")throw Fe;return We}be.settled=Z;function ve(Re){return new Promise(async(Fe,We)=>{try{await Re(Fe,We)}catch(Xe){We(Xe)}})}be.withAsyncBody=ve})(le=e.Promises||(e.Promises={}));var oe;(function(be){be[be.Initial=0]="Initial",be[be.DoneOK=1]="DoneOK",be[be.DoneError=2]="DoneError"})(oe||(oe={}));class pe{constructor(Z){this._state=0,this._results=[],this._error=null,this._onStateChanged=new p.Emitter,queueMicrotask(async()=>{const ve={emitOne:Re=>this.emitOne(Re),emitMany:Re=>this.emitMany(Re),reject:Re=>this.reject(Re)};try{await Promise.resolve(Z(ve)),this.resolve()}catch(Re){this.reject(Re)}finally{ve.emitOne=void 0,ve.emitMany=void 0,ve.reject=void 0}})}static fromArray(Z){return new pe(ve=>{ve.emitMany(Z)})}static fromPromise(Z){return new pe(async ve=>{ve.emitMany(await Z)})}static fromPromises(Z){return new pe(async ve=>{await Promise.all(Z.map(async Re=>ve.emitOne(await Re)))})}static merge(Z){return new pe(async ve=>{await Promise.all(Z.map(async Re=>{for await(const Fe of Re)ve.emitOne(Fe)}))})}[Symbol.asyncIterator](){let Z=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(Z<this._results.length)return{done:!1,value:this._results[Z++]};if(this._state===1)return{done:!0,value:void 0};await p.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(Z,ve){return new pe(async Re=>{for await(const Fe of Z)Re.emitOne(ve(Fe))})}map(Z){return pe.map(this,Z)}static filter(Z,ve){return new pe(async Re=>{for await(const Fe of Z)ve(Fe)&&Re.emitOne(Fe)})}filter(Z){return pe.filter(this,Z)}static coalesce(Z){return pe.filter(Z,ve=>!!ve)}coalesce(){return pe.coalesce(this)}static async toPromise(Z){const ve=[];for await(const Re of Z)ve.push(Re);return ve}toPromise(){return pe.toPromise(this)}emitOne(Z){this._state===0&&(this._results.push(Z),this._onStateChanged.fire())}emitMany(Z){this._state===0&&(this._results=this._results.concat(Z),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(Z){this._state===0&&(this._state=2,this._error=Z,this._onStateChanged.fire())}}e.AsyncIterableObject=pe,pe.EMPTY=pe.fromArray([]);class re extends pe{constructor(Z,ve){super(ve);this._source=Z}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=re;function Ee(be){const Z=new o.CancellationTokenSource,ve=be(Z.token);return new re(Z,async Re=>{const Fe=Z.token.onCancellationRequested(()=>{Fe.dispose(),Z.dispose(),Re.reject(new C.CancellationError)});try{for await(const We of ve){if(Z.token.isCancellationRequested)return;Re.emitOne(We)}Fe.dispose(),Z.dispose()}catch(We){Fe.dispose(),Z.dispose(),Re.reject(We)}})}e.createCancelableAsyncIterable=Ee}),define(De[116],Ce([1,0,13,19]),function(J,e,o,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const p=new o.IdleValue(()=>{const f=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:f,collatorIsNumeric:f.resolvedOptions().numeric}}),U=new o.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),I=new o.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function P(f,D,L=!1){const W=f||"",N=D||"",v=p.value.collator.compare(W,N);return p.value.collatorIsNumeric&&v===0&&W!==N?W<N?-1:1:v}e.compareFileNames=P;function b(f,D){const L=U.value.collator;return f=f||"",D=D||"",y(L,f,D)}e.compareFileNamesDefault=b;function A(f,D){const L=U.value.collator;return f=f||"",D=D||"",s(f,D)||y(L,f,D)}e.compareFileNamesUpper=A;function R(f,D){const L=U.value.collator;return f=f||"",D=D||"",i(f,D)||y(L,f,D)}e.compareFileNamesLower=R;function _(f,D){return f=f||"",D=D||"",f===D?0:f<D?-1:1}e.compareFileNamesUnicode=_;function m(f,D,L=!1){L||(f=f&&f.toLowerCase(),D=D&&D.toLowerCase());const[W,N]=w(f),[v,F]=w(D);return W!==v?W<v?-1:1:N===F?0:N<F?-1:1}e.noIntlCompareFileNames=m;function T(f,D){const[L,W]=w(f),[N,v]=w(D);let F=p.value.collator.compare(W,v);if(F===0){if(p.value.collatorIsNumeric&&W!==v)return W<v?-1:1;if(F=p.value.collator.compare(L,N),p.value.collatorIsNumeric&&F===0&&L!==N)return L<N?-1:1}return F}e.compareFileExtensions=T;function g(f,D){f=f||"",D=D||"";const L=a(f),W=a(D),N=U.value.collator,v=I.value.collator;return y(v,L,W)||y(N,f,D)}e.compareFileExtensionsDefault=g;function h(f,D){f=f||"",D=D||"";const L=a(f),W=a(D),N=U.value.collator,v=I.value.collator;return y(v,L,W)||s(f,D)||y(N,f,D)}e.compareFileExtensionsUpper=h;function u(f,D){f=f||"",D=D||"";const L=a(f),W=a(D),N=U.value.collator,v=I.value.collator;return y(v,L,W)||i(f,D)||y(N,f,D)}e.compareFileExtensionsLower=u;function l(f,D){f=f||"",D=D||"";const L=a(f).toLowerCase(),W=a(D).toLowerCase();return L!==W?L<W?-1:1:f!==D?f<D?-1:1:0}e.compareFileExtensionsUnicode=l;const S=/^(.*?)(\.([^.]*))?$/;function w(f,D=!1){const L=f?S.exec(f):[];let W=[L&&L[1]||"",L&&L[3]||""];return D&&(!W[0]&&W[1]||W[0]&&W[0].charAt(0)===".")&&(W=[W[0]+"."+W[1],""]),W}function a(f){const D=f?S.exec(f):[];return D&&D[1]&&D[1].charAt(0)!=="."&&D[3]||""}function y(f,D,L){const W=f.compare(D,L);return W!==0?W:D.length!==L.length?D.length<L.length?-1:1:0}function r(f){const D=f.charAt(0);return D.toLocaleUpperCase()!==D}function d(f){const D=f.charAt(0);return D.toLocaleLowerCase()!==D}function i(f,D){return r(f)&&d(D)?-1:d(f)&&r(D)?1:0}function s(f,D){return d(f)&&r(D)?-1:r(f)&&d(D)?1:0}function n(f,D,L=!1){return L||(f=f&&f.toLowerCase(),D=D&&D.toLowerCase()),f===D?0:f<D?-1:1}function t(f,D,L=!1){const W=f.split(C.sep),N=D.split(C.sep),v=W.length-1,F=N.length-1;let O,H;for(let te=0;;te++){if(O=v===te,H=F===te,O&&H)return P(W[te],N[te],L);if(O)return-1;if(H)return 1;const z=n(W[te],N[te],L);if(z!==0)return z}}e.comparePaths=t;function c(f,D,L){const W=f.toLowerCase(),N=D.toLowerCase(),v=E(f,D,L);if(v)return v;const F=W.endsWith(L),O=N.endsWith(L);if(F!==O)return F?-1:1;const H=P(W,N);return H!==0?H:W.localeCompare(N)}e.compareAnything=c;function E(f,D,L){const W=f.toLowerCase(),N=D.toLowerCase(),v=W.startsWith(L),F=N.startsWith(L);if(v!==F)return v?-1:1;if(v&&F){if(W.length<N.length)return-1;if(W.length>N.length)return 1}return 0}e.compareByPrefix=E}),define(De[34],Ce([1,0,16,13,37,24,19,22,10]),function(J,e,o,C,p,U,I,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function A(){return Object.create(null)}e.getEmptyExpression=A,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const R="[/\\\\]",_="[^/\\\\]",m=/\//g;function T(ce,le){switch(ce){case 0:return"";case 1:return`${_}*?`;default:return`(?:${R}|${_}+${R}${le?`|${R}${_}+`:""})*?`}}function g(ce,le){if(!ce)return[];const oe=[];let pe=!1,re=!1,Ee="";for(const be of ce){switch(be){case le:if(!pe&&!re){oe.push(Ee),Ee="";continue}break;case"{":pe=!0;break;case"}":pe=!1;break;case"[":re=!0;break;case"]":re=!1;break}Ee+=be}return Ee&&oe.push(Ee),oe}e.splitGlobAware=g;function h(ce){if(!ce)return"";let le="";const oe=g(ce,e.GLOB_SPLIT);if(oe.every(pe=>pe===e.GLOBSTAR))le=".*";else{let pe=!1;oe.forEach((re,Ee)=>{if(re===e.GLOBSTAR){if(pe)return;le+=T(2,Ee===oe.length-1)}else{let be=!1,Z="",ve=!1,Re="";for(const Fe of re){if(Fe!=="}"&&be){Z+=Fe;continue}if(ve&&(Fe!=="]"||!Re)){let We;Fe==="-"?We=Fe:(Fe==="^"||Fe==="!")&&!Re?We="^":Fe===e.GLOB_SPLIT?We="":We=(0,b.escapeRegExpCharacters)(Fe),Re+=We;continue}switch(Fe){case"{":be=!0;continue;case"[":ve=!0;continue;case"}":{le+=`(?:${g(Z,",").map(Ie=>h(Ie)).join("|")})`,be=!1,Z="";break}case"]":{le+="["+Re+"]",ve=!1,Re="";break}case"?":le+=_;continue;case"*":le+=T(1);continue;default:le+=(0,b.escapeRegExpCharacters)(Fe)}}Ee<oe.length-1&&(oe[Ee+1]!==e.GLOBSTAR||Ee+2<oe.length)&&(le+=R)}pe=re===e.GLOBSTAR})}return le}const u=/^\*\*\/\*\.[\w\.-]+$/,l=/^\*\*\/([\w\.-]+)\/?$/,S=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,w=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,a=/^\*\*((\/[\w\.-]+)+)\/?$/,y=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,r=new U.LRUCache(1e4),d=function(){return!1},i=function(){return null};function s(ce,le){if(!ce)return i;let oe;typeof ce!="string"?oe=ce.pattern:oe=ce,oe=oe.trim();const pe=`${oe}_${!!le.trimForExclusions}`;let re=r.get(pe);if(re)return n(re,ce);let Ee;return u.test(oe)?re=c(oe.substr(4),oe):(Ee=l.exec(t(oe,le)))?re=E(Ee[1],oe):(le.trimForExclusions?w:S).test(oe)?re=f(oe,le):(Ee=a.exec(t(oe,le)))?re=D(Ee[1].substr(1),oe,!0):(Ee=y.exec(t(oe,le)))?re=D(Ee[1],oe,!1):re=L(oe),r.set(pe,re),n(re,ce)}function n(ce,le){if(typeof le=="string")return ce;const oe=function(pe,re){return(0,p.isEqualOrParent)(pe,le.base,!P.isLinux)?ce(pe.substr(le.base.length+1),re):null};return oe.allBasenames=ce.allBasenames,oe.allPaths=ce.allPaths,oe.basenames=ce.basenames,oe.patterns=ce.patterns,oe}function t(ce,le){return le.trimForExclusions&&ce.endsWith("/**")?ce.substr(0,ce.length-2):ce}function c(ce,le){return function(oe,pe){return typeof oe=="string"&&oe.endsWith(ce)?le:null}}function E(ce,le){const oe=`/${ce}`,pe=`\\${ce}`,re=function(be,Z){return typeof be!="string"?null:Z?Z===ce?le:null:be===ce||be.endsWith(oe)||be.endsWith(pe)?le:null},Ee=[ce];return re.basenames=Ee,re.patterns=[le],re.allBasenames=Ee,re}function f(ce,le){const oe=z(ce.slice(1,-1).split(",").map(Z=>s(Z,le)).filter(Z=>Z!==i),ce),pe=oe.length;if(!pe)return i;if(pe===1)return oe[0];const re=function(Z,ve){for(let Re=0,Fe=oe.length;Re<Fe;Re++)if(oe[Re](Z,ve))return ce;return null},Ee=oe.find(Z=>!!Z.allBasenames);Ee&&(re.allBasenames=Ee.allBasenames);const be=oe.reduce((Z,ve)=>ve.allPaths?Z.concat(ve.allPaths):Z,[]);return be.length&&(re.allPaths=be),re}function D(ce,le,oe){const pe=I.sep===I.posix.sep,re=pe?ce:ce.replace(m,I.sep),Ee=I.sep+re,be=I.posix.sep+ce;let Z;return oe?Z=function(ve,Re){return typeof ve=="string"&&(ve===re||ve.endsWith(Ee)||!pe&&(ve===ce||ve.endsWith(be)))?le:null}:Z=function(ve,Re){return typeof ve=="string"&&(ve===re||!pe&&ve===ce)?le:null},Z.allPaths=[(oe?"*/":"./")+ce],Z}function L(ce){try{const le=new RegExp(`^${h(ce)}$`);return function(oe){return le.lastIndex=0,typeof oe=="string"&&le.test(oe)?ce:null}}catch{return i}}function W(ce,le,oe){return!ce||typeof le!="string"?!1:N(ce)(le,void 0,oe)}e.match=W;function N(ce,le={}){if(!ce)return d;if(typeof ce=="string"||v(ce)){const oe=s(ce,le);if(oe===i)return d;const pe=function(re,Ee){return!!oe(re,Ee)};return oe.allBasenames&&(pe.allBasenames=oe.allBasenames),oe.allPaths&&(pe.allPaths=oe.allPaths),pe}return H(ce,le)}e.parse=N;function v(ce){const le=ce;return le?typeof le.base=="string"&&typeof le.pattern=="string":!1}e.isRelativePattern=v;function F(ce){return ce.allBasenames||[]}e.getBasenameTerms=F;function O(ce){return ce.allPaths||[]}e.getPathTerms=O;function H(ce,le){const oe=z(Object.getOwnPropertyNames(ce).map(Z=>te(Z,ce[Z],le)).filter(Z=>Z!==i)),pe=oe.length;if(!pe)return i;if(!oe.some(Z=>!!Z.requiresSiblings)){if(pe===1)return oe[0];const Z=function(Fe,We){let Xe;for(let Ie=0,Se=oe.length;Ie<Se;Ie++){const Te=oe[Ie](Fe,We);if(typeof Te=="string")return Te;(0,C.isThenable)(Te)&&(Xe||(Xe=[]),Xe.push(Te))}return Xe?(async()=>{for(const Ie of Xe){const Se=await Ie;if(typeof Se=="string")return Se}return null})():null},ve=oe.find(Fe=>!!Fe.allBasenames);ve&&(Z.allBasenames=ve.allBasenames);const Re=oe.reduce((Fe,We)=>We.allPaths?Fe.concat(We.allPaths):Fe,[]);return Re.length&&(Z.allPaths=Re),Z}const re=function(Z,ve,Re){let Fe,We;for(let Xe=0,Ie=oe.length;Xe<Ie;Xe++){const Se=oe[Xe];Se.requiresSiblings&&Re&&(ve||(ve=(0,I.basename)(Z)),Fe||(Fe=ve.substr(0,ve.length-(0,I.extname)(Z).length)));const Te=Se(Z,ve,Fe,Re);if(typeof Te=="string")return Te;(0,C.isThenable)(Te)&&(We||(We=[]),We.push(Te))}return We?(async()=>{for(const Xe of We){const Ie=await Xe;if(typeof Ie=="string")return Ie}return null})():null},Ee=oe.find(Z=>!!Z.allBasenames);Ee&&(re.allBasenames=Ee.allBasenames);const be=oe.reduce((Z,ve)=>ve.allPaths?Z.concat(ve.allPaths):Z,[]);return be.length&&(re.allPaths=be),re}function te(ce,le,oe){if(le===!1)return i;const pe=s(ce,oe);if(pe===i)return i;if(typeof le=="boolean")return pe;if(le){const re=le.when;if(typeof re=="string"){const Ee=(be,Z,ve,Re)=>{if(!Re||!pe(be,Z))return null;const Fe=re.replace("$(basename)",ve),We=Re(Fe);return(0,C.isThenable)(We)?We.then(Xe=>Xe?ce:null):We?ce:null};return Ee.requiresSiblings=!0,Ee}}return pe}function z(ce,le){const oe=ce.filter(Z=>!!Z.basenames);if(oe.length<2)return ce;const pe=oe.reduce((Z,ve)=>{const Re=ve.basenames;return Re?Z.concat(Re):Z},[]);let re;if(le){re=[];for(let Z=0,ve=pe.length;Z<ve;Z++)re.push(le)}else re=oe.reduce((Z,ve)=>{const Re=ve.patterns;return Re?Z.concat(Re):Z},[]);const Ee=function(Z,ve){if(typeof Z!="string")return null;if(!ve){let Fe;for(Fe=Z.length;Fe>0;Fe--){const We=Z.charCodeAt(Fe-1);if(We===47||We===92)break}ve=Z.substr(Fe)}const Re=pe.indexOf(ve);return Re!==-1?re[Re]:null};Ee.basenames=pe,Ee.patterns=re,Ee.allBasenames=pe;const be=ce.filter(Z=>!Z.basenames);return be.push(Ee),be}function $(ce,le){return(0,o.equals)(ce,le,(oe,pe)=>typeof oe=="string"&&typeof pe=="string"?oe===pe:typeof oe!="string"&&typeof pe!="string"?oe.base===pe.base&&oe.pattern===pe.pattern:!1)}e.patternsEquals=$}),define(De[75],Ce([1,0,11,114,21,10,2]),function(J,e,o,C,p,U,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var P;(function(u){u[u.Paragraph=0]="Paragraph",u[u.Break=1]="Break"})(P=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class b{constructor(l="",S=!1){if(this.value=l,typeof this.value!="string")throw(0,o.illegalArgument)("value");typeof S=="boolean"?(this.isTrusted=S,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=S.isTrusted??void 0,this.supportThemeIcons=S.supportThemeIcons??!1,this.supportHtml=S.supportHtml??!1)}appendText(l,S=0){return this.value+=m(this.supportThemeIcons?(0,C.escapeIcons)(l):l).replace(/([ \t]+)/g,(w,a)=>"&nbsp;".repeat(a.length)).replace(/\>/gm,"\\>").replace(/\n/g,S===1?`\\
`:`

`),this}appendMarkdown(l){return this.value+=l,this}appendCodeblock(l,S){return this.value+="\n```",this.value+=l,this.value+=`
`,this.value+=S,this.value+="\n```\n",this}appendLink(l,S,w){return this.value+="[",this.value+=this._escape(S,"]"),this.value+="](",this.value+=this._escape(String(l),")"),w&&(this.value+=` "${this._escape(this._escape(w,'"'),")")}"`),this.value+=")",this}_escape(l,S){const w=new RegExp((0,U.escapeRegExpCharacters)(S),"g");return l.replace(w,(a,y)=>l.charAt(y-1)!=="\\"?`\\${a}`:a)}}e.MarkdownString=b;function A(u){return R(u)?!u.value:Array.isArray(u)?u.every(A):!0}e.isEmptyMarkdownString=A;function R(u){return u instanceof b?!0:u&&typeof u=="object"?typeof u.value=="string"&&(typeof u.isTrusted=="boolean"||u.isTrusted===void 0)&&(typeof u.supportThemeIcons=="boolean"||u.supportThemeIcons===void 0):!1}e.isMarkdownString=R;function _(u,l){return u===l?!0:!u||!l?!1:u.value===l.value&&u.isTrusted===l.isTrusted&&u.supportThemeIcons===l.supportThemeIcons&&u.supportHtml===l.supportHtml&&(u.baseUri===l.baseUri||!!u.baseUri&&!!l.baseUri&&(0,p.isEqual)(I.URI.from(u.baseUri),I.URI.from(l.baseUri)))}e.markdownStringEqual=_;function m(u){return u.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=m;function T(u){return u.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=T;function g(u){return u&&u.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=g;function h(u){const l=[],S=u.split("|").map(a=>a.trim());u=S[0];const w=S[1];if(w){const a=/height=(\d+)/.exec(w),y=/width=(\d+)/.exec(w),r=a?a[1]:"",d=y?y[1]:"",i=isFinite(parseInt(d)),s=isFinite(parseInt(r));i&&l.push(`width="${d}"`),s&&l.push(`height="${r}"`)}return{href:u,dimensions:l}}e.parseHrefAndDimensions=h}),define(De[76],Ce([1,0,16,37,19,22,21,10]),function(J,e,o,C,p,U,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function b(i,s){const{os:n,tildify:t,relative:c}=s;if(c){const D=A(i,c,n);if(typeof D=="string")return D}let E=i.fsPath;if(n===1&&!U.isWindows?E=E.replace(/\//g,"\\"):n!==1&&U.isWindows&&(E=E.replace(/\\/g,"/")),n!==1&&t?.userHome){const D=t.userHome.fsPath;let L;i.scheme!==t.userHome.scheme&&i.path.startsWith(p.posix.sep)?L=t.userHome.with({path:i.path}).fsPath:L=i.fsPath,E=m(L,D,n)}return(n===1?p.win32:p.posix).normalize(R(E,n===1))}e.getPathLabel=b;function A(i,s,n){const t=n===1?p.win32:p.posix,c=n===3?I.extUri:I.extUriIgnorePathCase,E=s.getWorkspace(),f=(0,o.firstOrDefault)(E.folders);if(!f)return;i.scheme!==f.uri.scheme&&i.path.startsWith(p.posix.sep)&&(i=f.uri.with({path:i.path}));const D=s.getWorkspaceFolder(i);if(!D)return;let L;if(c.isEqual(D.uri,i)?L="":L=c.relativePath(D.uri,i)??"",L&&(L=t.normalize(L)),E.folders.length>1&&!s.noPrefix){const W=D.name?D.name:c.basenameOrAuthority(D.uri);L=L?`${W} \u2022 ${L}`:W}return L}function R(i,s=U.isWindows){return(0,C.hasDriveLetter)(i,s)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=R;let _=Object.create(null);function m(i,s,n=U.OS){if(n===1||!i||!s)return i;let t=_.original===s?_.normalized:void 0;t||(t=s,U.isWindows&&(t=(0,C.toSlashes)(t)),t=`${(0,P.rtrim)(t,p.posix.sep)}${p.posix.sep}`,_={original:s,normalized:t});let c=i;return U.isWindows&&(c=(0,C.toSlashes)(c)),(n===3?c.startsWith(t):(0,P.startsWithIgnoreCase)(c,t))?`~/${c.substr(t.length)}`:i}e.tildify=m;function T(i,s){return i.replace(/^~($|\/|\\)/,`${s}$1`)}e.untildify=T;const g="\u2026",h="\\\\",u="~";function l(i,s=p.sep){const n=new Array(i.length);let t=!1;for(let c=0;c<i.length;c++){const E=i[c];if(E===""){n[c]=`.${s}`;continue}if(!E){n[c]=E;continue}t=!0;let f="",D=E;D.indexOf(h)===0?(f=D.substr(0,D.indexOf(h)+h.length),D=D.substr(D.indexOf(h)+h.length)):D.indexOf(s)===0?(f=D.substr(0,D.indexOf(s)+s.length),D=D.substr(D.indexOf(s)+s.length)):D.indexOf(u)===0&&(f=D.substr(0,D.indexOf(u)+u.length),D=D.substr(D.indexOf(u)+u.length));const L=D.split(s);for(let W=1;t&&W<=L.length;W++)for(let N=L.length-W;t&&N>=0;N--){t=!1;let v=L.slice(N,N+W).join(s);for(let F=0;!t&&F<i.length;F++)if(F!==c&&i[F]&&i[F].indexOf(v)>-1){const O=N+W===L.length,H=N>0&&i[F].indexOf(s)>-1?s+v:v,te=i[F].endsWith(H);t=!O||te}if(!t){let F="";(L[0].endsWith(":")||f!=="")&&(N===1&&(N=0,W++,v=L[0]+s+v),N>0&&(F=L[0]+s),F=f+F),N>0&&(F=F+g+s),F=F+v,N+W<L.length&&(F=F+s+g),n[c]=F}}t&&(n[c]=E)}return n}e.shorten=l;var S;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(S||(S={}));function w(i,s=Object.create(null)){const n=[];let t=!1,c="";for(const E of i)if(E==="$"||t&&E==="{")c&&n.push({value:c,type:S.TEXT}),c="",t=!0;else if(E==="}"&&t){const f=s[c];if(typeof f=="string")f.length&&n.push({value:f,type:S.VARIABLE});else if(f){const D=n[n.length-1];(!D||D.type!==S.SEPARATOR)&&n.push({value:f.label,type:S.SEPARATOR})}c="",t=!1}else c+=E;return c&&!t&&n.push({value:c,type:S.TEXT}),n.filter((E,f)=>{if(E.type===S.SEPARATOR){const D=n[f-1],L=n[f+1];return[D,L].every(W=>W&&(W.type===S.VARIABLE||W.type===S.TEXT)&&W.value.length>0)}return!0}).map(E=>E.value).join("")}e.template=w;function a(i,s){return U.isMacintosh||s?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,U.isMacintosh?"&":"&&"):i.replace(/&&|&/g,n=>n==="&"?"&&":"&")}e.mnemonicMenuLabel=a;function y(i,s){return U.isMacintosh||s?i.replace(/\(&&\w\)|&&/g,""):U.isWindows?i.replace(/&&|&/g,n=>n==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=y;function r(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=r;function d(i){const s=i.indexOf("/")!==-1?p.posix:p.win32,n=s.basename(i),t=s.dirname(i);return n.length?{name:n,parentPath:t}:{name:t,parentPath:""}}e.splitName=d}),define(De[117],Ce([1,0,2]),function(J,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function C(R){return R.toJSON()}class p{constructor(_){this._uriTransformer=_}transformIncoming(_){const m=this._uriTransformer.transformIncoming(_);return m===_?_:C(o.URI.from(m))}transformOutgoing(_){const m=this._uriTransformer.transformOutgoing(_);return m===_?_:C(o.URI.from(m))}transformOutgoingURI(_){const m=this._uriTransformer.transformOutgoing(_);return m===_?_:o.URI.from(m)}transformOutgoingScheme(_){return this._uriTransformer.transformOutgoingScheme(_)}}e.URITransformer=p,e.DefaultURITransformer=new class{transformIncoming(R){return R}transformOutgoing(R){return R}transformOutgoingURI(R){return R}transformOutgoingScheme(R){return R}};function U(R,_,m){if(!R||m>200)return null;if(typeof R=="object"){if(R instanceof o.URI)return _.transformOutgoing(R);for(const T in R)if(Object.hasOwnProperty.call(R,T)){const g=U(R[T],_,m+1);g!==null&&(R[T]=g)}}return null}function I(R,_){const m=U(R,_,0);return m===null?R:m}e.transformOutgoingURIs=I;function P(R,_,m,T){if(!R||T>200)return null;if(typeof R=="object"){if(R.$mid===1)return m?o.URI.revive(_.transformIncoming(R)):_.transformIncoming(R);for(const g in R)if(Object.hasOwnProperty.call(R,g)){const h=P(R[g],_,m,T+1);h!==null&&(R[g]=h)}}return null}function b(R,_){const m=P(R,_,!1,0);return m===null?R:m}e.transformIncomingURIs=b;function A(R,_){const m=P(R,_,!0,0);return m===null?R:m}e.transformAndReviveIncomingURIs=A}),define(De[118],Ce([1,0,34,19]),function(J,e,o,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function p(U,I,P,b,A,R){if(Array.isArray(U)){let _=0;for(const m of U){const T=p(m,I,P,b,A,R);if(T===10)return T;T>_&&(_=T)}return _}else{if(typeof U=="string")return b?U==="*"?5:U===P?10:0:0;if(U){const{language:_,pattern:m,scheme:T,hasAccessToAllModels:g,notebookType:h}=U;if(!b&&!g)return 0;h&&A&&(I=A);let u=0;if(T)if(T===I.scheme)u=10;else if(T==="*")u=5;else return 0;if(_)if(_===P)u=10;else if(_==="*")u=Math.max(u,5);else return 0;if(h)if(h===R)u=10;else if(h==="*"&&R!==void 0)u=Math.max(u,5);else return 0;if(m){let l;if(typeof m=="string"?l=m:l={...m,base:(0,C.normalize)(m.base)},l===I.fsPath||(0,o.match)(l,I.fsPath))u=10;else return 0}return u}else return 0}}e.score=p}),define(De[77],Ce([1,0,23,22]),function(J,e,o,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var p;(function(_){_[_.Full=1]="Full",_[_.Delta=2]="Delta"})(p||(p={}));function U(_){for(let m=0,T=_.length;m<T;m+=4){const g=_[m+0],h=_[m+1],u=_[m+2],l=_[m+3];_[m+0]=l,_[m+1]=u,_[m+2]=h,_[m+3]=g}}function I(_){const m=new Uint8Array(_.buffer,_.byteOffset,_.length*4);return C.isLittleEndian()||U(m),o.VSBuffer.wrap(m)}function P(_){const m=_.buffer;if(C.isLittleEndian()||U(m),m.byteOffset%4==0)return new Uint32Array(m.buffer,m.byteOffset,m.length/4);{const T=new Uint8Array(m.byteLength);return T.set(m),new Uint32Array(T.buffer,T.byteOffset,T.length/4)}}function b(_){const m=new Uint32Array(A(_));let T=0;if(m[T++]=_.id,_.type==="full")m[T++]=1,m[T++]=_.data.length,m.set(_.data,T),T+=_.data.length;else{m[T++]=2,m[T++]=_.deltas.length;for(const g of _.deltas)m[T++]=g.start,m[T++]=g.deleteCount,g.data?(m[T++]=g.data.length,m.set(g.data,T),T+=g.data.length):m[T++]=0}return I(m)}e.encodeSemanticTokensDto=b;function A(_){let m=0;if(m+=1+1,_.type==="full")m+=1+_.data.length;else{m+=1,m+=(1+1+1)*_.deltas.length;for(const T of _.deltas)T.data&&(m+=T.data.length)}return m}function R(_){const m=P(_);let T=0;const g=m[T++];if(m[T++]===1){const S=m[T++],w=m.subarray(T,T+S);return T+=S,{id:g,type:"full",data:w}}const u=m[T++],l=[];for(let S=0;S<u;S++){const w=m[T++],a=m[T++],y=m[T++];let r;y>0&&(r=m.subarray(T,T+y),T+=y),l[S]={start:w,deleteCount:a,data:r}}return{id:g,type:"delta",deltas:l}}e.decodeSemanticTokensDto=R}),define(De[119],Ce([17,18]),function(J,e){return J.create("vs/editor/common/config/editorOptions",e)}),define(De[120],Ce([1,0,119,22,121,16,26,108]),function(J,e,o,C,p,U,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var b;(function(K){K[K.None=0]="None",K[K.Keep=1]="Keep",K[K.Brackets=2]="Brackets",K[K.Advanced=3]="Advanced",K[K.Full=4]="Full"})(b=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class A{constructor(Q){this._values=Q}hasChanged(Q){return this._values[Q]}}e.ConfigurationChangedEvent=A;class R{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=R;class _{constructor(Q,me,Le,Be){this.id=Q,this.name=me,this.defaultValue=Le,this.schema=Be}applyUpdate(Q,me){return T(Q,me)}compute(Q,me,Le){return Le}}class m{constructor(Q,me){this.newValue=Q,this.didChange=me}}e.ApplyUpdateResult=m;function T(K,Q){if(typeof K!="object"||typeof Q!="object"||!K||!Q)return new m(Q,K!==Q);if(Array.isArray(K)||Array.isArray(Q)){const Le=Array.isArray(K)&&Array.isArray(Q)&&U.equals(K,Q);return new m(Q,Le)}let me=!1;for(const Le in Q)if(Q.hasOwnProperty(Le)){const Be=T(K[Le],Q[Le]);Be.didChange&&(K[Le]=Be.newValue,me=!0)}return new m(K,me)}class g{constructor(Q){this.schema=void 0,this.id=Q,this.name="_never_",this.defaultValue=void 0}applyUpdate(Q,me){return T(Q,me)}validate(Q){return this.defaultValue}}class h{constructor(Q,me,Le,Be){this.id=Q,this.name=me,this.defaultValue=Le,this.schema=Be}applyUpdate(Q,me){return T(Q,me)}validate(Q){return typeof Q=="undefined"?this.defaultValue:Q}compute(Q,me,Le){return Le}}function u(K,Q){return typeof K=="undefined"?Q:K==="false"?!1:Boolean(K)}e.boolean=u;class l extends h{constructor(Q,me,Le,Be=void 0){typeof Be!="undefined"&&(Be.type="boolean",Be.default=Le);super(Q,me,Le,Be)}validate(Q){return u(Q,this.defaultValue)}}function S(K,Q,me,Le){if(typeof K=="undefined")return Q;let Be=parseInt(K,10);return isNaN(Be)?Q:(Be=Math.max(me,Be),Be=Math.min(Le,Be),Be|0)}e.clampedInt=S;class w extends h{constructor(Q,me,Le,Be,Ze,et=void 0){typeof et!="undefined"&&(et.type="integer",et.default=Le,et.minimum=Be,et.maximum=Ze);super(Q,me,Le,et);this.minimum=Be,this.maximum=Ze}static clampedInt(Q,me,Le,Be){return S(Q,me,Le,Be)}validate(Q){return w.clampedInt(Q,this.defaultValue,this.minimum,this.maximum)}}class a extends h{constructor(Q,me,Le,Be,Ze){typeof Ze!="undefined"&&(Ze.type="number",Ze.default=Le);super(Q,me,Le,Ze);this.validationFn=Be}static clamp(Q,me,Le){return Q<me?me:Q>Le?Le:Q}static float(Q,me){if(typeof Q=="number")return Q;if(typeof Q=="undefined")return me;const Le=parseFloat(Q);return isNaN(Le)?me:Le}validate(Q){return this.validationFn(a.float(Q,this.defaultValue))}}class y extends h{static string(Q,me){return typeof Q!="string"?me:Q}constructor(Q,me,Le,Be=void 0){typeof Be!="undefined"&&(Be.type="string",Be.default=Le);super(Q,me,Le,Be)}validate(Q){return y.string(Q,this.defaultValue)}}function r(K,Q,me){return typeof K!="string"||me.indexOf(K)===-1?Q:K}e.stringSet=r;class d extends h{constructor(Q,me,Le,Be,Ze=void 0){typeof Ze!="undefined"&&(Ze.type="string",Ze.enum=Be,Ze.default=Le);super(Q,me,Le,Ze);this._allowedValues=Be}validate(Q){return r(Q,this.defaultValue,this._allowedValues)}}class i extends _{constructor(Q,me,Le,Be,Ze,et,at=void 0){typeof at!="undefined"&&(at.type="string",at.enum=Ze,at.default=Be);super(Q,me,Le,at);this._allowedValues=Ze,this._convert=et}validate(Q){return typeof Q!="string"?this.defaultValue:this._allowedValues.indexOf(Q)===-1?this.defaultValue:this._convert(Q)}}function s(K){switch(K){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class n extends _{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[o.localize(0,null),o.localize(1,null),o.localize(2,null)],default:"auto",description:o.localize(3,null)})}validate(Q){switch(Q){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Q,me,Le){return Le===0?Q.accessibilitySupport:Le}}class t extends _{constructor(){const Q={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",Q,{"editor.comments.insertSpace":{type:"boolean",default:Q.insertSpace,description:o.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Q.ignoreEmptyLines,description:o.localize(5,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const me=Q;return{insertSpace:u(me.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:u(me.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var c;(function(K){K[K.Hidden=0]="Hidden",K[K.Blink=1]="Blink",K[K.Smooth=2]="Smooth",K[K.Phase=3]="Phase",K[K.Expand=4]="Expand",K[K.Solid=5]="Solid"})(c=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function E(K){switch(K){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var f;(function(K){K[K.Line=1]="Line",K[K.Block=2]="Block",K[K.Underline=3]="Underline",K[K.LineThin=4]="LineThin",K[K.BlockOutline=5]="BlockOutline",K[K.UnderlineThin=6]="UnderlineThin"})(f=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function D(K){switch(K){case f.Line:return"line";case f.Block:return"block";case f.Underline:return"underline";case f.LineThin:return"line-thin";case f.BlockOutline:return"block-outline";case f.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=D;function L(K){switch(K){case"line":return f.Line;case"block":return f.Block;case"underline":return f.Underline;case"line-thin":return f.LineThin;case"block-outline":return f.BlockOutline;case"underline-thin":return f.UnderlineThin}}class W extends g{constructor(){super(129)}compute(Q,me,Le){const Be=["monaco-editor"];return me.get(34)&&Be.push(me.get(34)),Q.extraEditorClassName&&Be.push(Q.extraEditorClassName),me.get(67)==="default"?Be.push("mouse-default"):me.get(67)==="copy"&&Be.push("mouse-copy"),me.get(101)&&Be.push("showUnused"),me.get(127)&&Be.push("showDeprecated"),Be.join(" ")}}class N extends l{constructor(){super(33,"emptySelectionClipboard",!0,{description:o.localize(6,null)})}compute(Q,me,Le){return Le&&Q.emptySelectionClipboard}}class v extends _{constructor(){const Q={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(36,"find",Q,{"editor.find.cursorMoveOnType":{type:"boolean",default:Q.cursorMoveOnType,description:o.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Q.seedSearchStringFromSelection,enumDescriptions:[o.localize(8,null),o.localize(9,null),o.localize(10,null)],description:o.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Q.autoFindInSelection,enumDescriptions:[o.localize(12,null),o.localize(13,null),o.localize(14,null)],description:o.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Q.globalFindClipboard,description:o.localize(16,null),included:C.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Q.addExtraSpaceOnTop,description:o.localize(17,null)},"editor.find.loop":{type:"boolean",default:Q.loop,description:o.localize(18,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const me=Q;return{cursorMoveOnType:u(me.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Q.seedSearchStringFromSelection=="boolean"?Q.seedSearchStringFromSelection?"always":"never":r(me.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Q.autoFindInSelection=="boolean"?Q.autoFindInSelection?"always":"never":r(me.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:u(me.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:u(me.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:u(me.loop,this.defaultValue.loop)}}}class F extends _{constructor(){super(46,"fontLigatures",F.OFF,{anyOf:[{type:"boolean",description:o.localize(19,null)},{type:"string",description:o.localize(20,null)}],description:o.localize(21,null),default:!1})}validate(Q){return typeof Q=="undefined"?this.defaultValue:typeof Q=="string"?Q==="false"?F.OFF:Q==="true"?F.ON:Q:Boolean(Q)?F.ON:F.OFF}}e.EditorFontLigatures=F,F.OFF='"liga" off, "calt" off',F.ON='"liga" on, "calt" on';class O extends g{constructor(){super(45)}compute(Q,me,Le){return Q.fontInfo}}class H extends h{constructor(){super(47,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:o.localize(22,null)})}validate(Q){const me=a.float(Q,this.defaultValue);return me===0?e.EDITOR_FONT_DEFAULTS.fontSize:a.clamp(me,6,100)}compute(Q,me,Le){return Q.fontInfo.fontSize}}class te extends _{constructor(){super(48,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:te.MINIMUM_VALUE,maximum:te.MAXIMUM_VALUE,errorMessage:o.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:te.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:o.localize(24,null)})}validate(Q){return Q==="normal"||Q==="bold"?Q:String(w.clampedInt(Q,e.EDITOR_FONT_DEFAULTS.fontWeight,te.MINIMUM_VALUE,te.MAXIMUM_VALUE))}}te.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],te.MINIMUM_VALUE=1,te.MAXIMUM_VALUE=1e3;class z extends _{constructor(){const Q={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},me={type:"string",enum:["peek","gotoAndPeek","goto"],default:Q.multiple,enumDescriptions:[o.localize(25,null),o.localize(26,null),o.localize(27,null)]},Le=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(52,"gotoLocation",Q,{"editor.gotoLocation.multiple":{deprecationMessage:o.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:o.localize(29,null),...me},"editor.gotoLocation.multipleTypeDefinitions":{description:o.localize(30,null),...me},"editor.gotoLocation.multipleDeclarations":{description:o.localize(31,null),...me},"editor.gotoLocation.multipleImplementations":{description:o.localize(32,null),...me},"editor.gotoLocation.multipleReferences":{description:o.localize(33,null),...me},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Q.alternativeDefinitionCommand,enum:Le,description:o.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Q.alternativeTypeDefinitionCommand,enum:Le,description:o.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Q.alternativeDeclarationCommand,enum:Le,description:o.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Q.alternativeImplementationCommand,enum:Le,description:o.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Q.alternativeReferenceCommand,enum:Le,description:o.localize(38,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const me=Q;return{multiple:r(me.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:me.multipleDefinitions??r(me.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:me.multipleTypeDefinitions??r(me.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:me.multipleDeclarations??r(me.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:me.multipleImplementations??r(me.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:me.multipleReferences??r(me.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:y.string(me.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:y.string(me.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:y.string(me.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:y.string(me.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:y.string(me.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class $ extends _{constructor(){const Q={enabled:!0,delay:300,sticky:!0,above:!0};super(54,"hover",Q,{"editor.hover.enabled":{type:"boolean",default:Q.enabled,description:o.localize(39,null)},"editor.hover.delay":{type:"number",default:Q.delay,minimum:0,maximum:1e4,description:o.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:Q.sticky,description:o.localize(41,null)},"editor.hover.above":{type:"boolean",default:Q.above,description:o.localize(42,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const me=Q;return{enabled:u(me.enabled,this.defaultValue.enabled),delay:w.clampedInt(me.delay,this.defaultValue.delay,0,1e4),sticky:u(me.sticky,this.defaultValue.sticky),above:u(me.above,this.defaultValue.above)}}}var ce;(function(K){K[K.None=0]="None",K[K.Text=1]="Text",K[K.Blocks=2]="Blocks"})(ce=e.RenderMinimap||(e.RenderMinimap={}));class le extends g{constructor(){super(132)}compute(Q,me,Le){return le.computeLayout(me,{memory:Q.memory,outerWidth:Q.outerWidth,outerHeight:Q.outerHeight,isDominatedByLongLines:Q.isDominatedByLongLines,lineHeight:Q.fontInfo.lineHeight,viewLineCount:Q.viewLineCount,lineNumbersDigitCount:Q.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Q.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Q.fontInfo.maxDigitWidth,pixelRatio:Q.pixelRatio})}static computeContainedMinimapLineCount(Q){const me=Q.height/Q.lineHeight,Le=Q.scrollBeyondLastLine?me-1:0,Be=(Q.viewLineCount+Le)/(Q.pixelRatio*Q.height),Ze=Math.floor(Q.viewLineCount/Be);return{typicalViewportLineCount:me,extraLinesBeyondLastLine:Le,desiredRatio:Be,minimapLineCount:Ze}}static _computeMinimapLayout(Q,me){const Le=Q.outerWidth,Be=Q.outerHeight,Ze=Q.pixelRatio;if(!Q.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Ze*Be),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Be};const et=me.stableMinimapLayoutInput,at=et&&Q.outerHeight===et.outerHeight&&Q.lineHeight===et.lineHeight&&Q.typicalHalfwidthCharacterWidth===et.typicalHalfwidthCharacterWidth&&Q.pixelRatio===et.pixelRatio&&Q.scrollBeyondLastLine===et.scrollBeyondLastLine&&Q.minimap.enabled===et.minimap.enabled&&Q.minimap.side===et.minimap.side&&Q.minimap.size===et.minimap.size&&Q.minimap.showSlider===et.minimap.showSlider&&Q.minimap.renderCharacters===et.minimap.renderCharacters&&Q.minimap.maxColumn===et.minimap.maxColumn&&Q.minimap.scale===et.minimap.scale&&Q.verticalScrollbarWidth===et.verticalScrollbarWidth&&Q.isViewportWrapping===et.isViewportWrapping,Je=Q.lineHeight,He=Q.typicalHalfwidthCharacterWidth,nt=Q.scrollBeyondLastLine,st=Q.minimap.renderCharacters;let ot=Ze>=2?Math.round(Q.minimap.scale*2):Q.minimap.scale;const lt=Q.minimap.maxColumn,dt=Q.minimap.size,kt=Q.minimap.side,Mt=Q.verticalScrollbarWidth,Dt=Q.viewLineCount,ft=Q.remainingWidth,Ct=Q.isViewportWrapping,Nt=st?2:3;let Pt=Math.floor(Ze*Be);const Ve=Pt/Ze;let At=!1,Lt=!1,Ot=Nt*ot,mt=ot/Ze,yt=1;if(dt==="fill"||dt==="fit"){const{typicalViewportLineCount:Ke,extraLinesBeyondLastLine:Qe,desiredRatio:Ge,minimapLineCount:gt}=le.computeContainedMinimapLineCount({viewLineCount:Dt,scrollBeyondLastLine:nt,height:Be,lineHeight:Je,pixelRatio:Ze});if(Dt/gt>1)At=!0,Lt=!0,ot=1,Ot=1,mt=ot/Ze;else{let _t=!1,vt=ot+1;if(dt==="fit"){const ht=Math.ceil((Dt+Qe)*Ot);Ct&&at&&ft<=me.stableFitRemainingWidth?(_t=!0,vt=me.stableFitMaxMinimapScale):_t=ht>Pt}if(dt==="fill"||_t){At=!0;const ht=ot;Ot=Math.min(Je*Ze,Math.max(1,Math.floor(1/Ge))),Ct&&at&&ft<=me.stableFitRemainingWidth&&(vt=me.stableFitMaxMinimapScale),ot=Math.min(vt,Math.max(1,Math.floor(Ot/Nt))),ot>ht&&(yt=Math.min(2,ot/ht)),mt=ot/Ze/yt,Pt=Math.ceil(Math.max(Ke,Dt+Qe)*Ot),Ct?(me.stableMinimapLayoutInput=Q,me.stableFitRemainingWidth=ft,me.stableFitMaxMinimapScale=ot):(me.stableMinimapLayoutInput=null,me.stableFitRemainingWidth=0)}}}const we=Math.floor(lt*mt),ye=Math.min(we,Math.max(0,Math.floor((ft-Mt-2)*mt/(He+mt)))+e.MINIMAP_GUTTER_WIDTH);let he=Math.floor(Ze*ye);const q=he/Ze;he=Math.floor(he*yt);const Pe=st?1:2,Ue=kt==="left"?0:Le-ye-Mt;return{renderMinimap:Pe,minimapLeft:Ue,minimapWidth:ye,minimapHeightIsEditorHeight:At,minimapIsSampling:Lt,minimapScale:ot,minimapLineHeight:Ot,minimapCanvasInnerWidth:he,minimapCanvasInnerHeight:Pt,minimapCanvasOuterWidth:q,minimapCanvasOuterHeight:Ve}}static computeLayout(Q,me){const Le=me.outerWidth|0,Be=me.outerHeight|0,Ze=me.lineHeight|0,et=me.lineNumbersDigitCount|0,at=me.typicalHalfwidthCharacterWidth,Je=me.maxDigitWidth,He=me.pixelRatio,nt=me.viewLineCount,st=Q.get(124),ot=st==="inherit"?Q.get(123):st,lt=ot==="inherit"?Q.get(119):ot,dt=Q.get(122),kt=Q.get(2),Mt=me.isDominatedByLongLines,Dt=Q.get(51),ft=Q.get(61).renderType!==0,Ct=Q.get(62),Nt=Q.get(95),Pt=Q.get(66),Ve=Q.get(93),At=Ve.verticalScrollbarSize,Lt=Ve.verticalHasArrows,Ot=Ve.arrowSize,mt=Ve.horizontalScrollbarSize,yt=Q.get(59),we=Q.get(38);let ye;if(typeof yt=="string"&&/^\d+(\.\d+)?ch$/.test(yt)){const bt=parseFloat(yt.substr(0,yt.length-2));ye=w.clampedInt(bt*at,0,0,1e3)}else ye=w.clampedInt(yt,0,0,1e3);we&&(ye+=16);let he=0;if(ft){const bt=Math.max(et,Ct);he=Math.round(bt*Je)}let q=0;Dt&&(q=Ze);let Pe=0,Ue=Pe+q,Ke=Ue+he,Qe=Ke+ye;const Ge=Le-q-he-ye;let gt=!1,pt=!1,_t=-1;kt!==2&&(ot==="inherit"&&Mt?(gt=!0,pt=!0):lt==="on"||lt==="bounded"?pt=!0:lt==="wordWrapColumn"&&(_t=dt));const vt=le._computeMinimapLayout({outerWidth:Le,outerHeight:Be,lineHeight:Ze,typicalHalfwidthCharacterWidth:at,pixelRatio:He,scrollBeyondLastLine:Nt,minimap:Pt,verticalScrollbarWidth:At,viewLineCount:nt,remainingWidth:Ge,isViewportWrapping:pt},me.memory||new R);vt.renderMinimap!==0&&vt.minimapLeft===0&&(Pe+=vt.minimapWidth,Ue+=vt.minimapWidth,Ke+=vt.minimapWidth,Qe+=vt.minimapWidth);const ht=Ge-vt.minimapWidth,Gt=Math.max(1,Math.floor((ht-At-2)/at)),Xt=Lt?Ot:0;return pt&&(_t=Math.max(1,Gt),lt==="bounded"&&(_t=Math.min(_t,dt))),{width:Le,height:Be,glyphMarginLeft:Pe,glyphMarginWidth:q,lineNumbersLeft:Ue,lineNumbersWidth:he,decorationsLeft:Ke,decorationsWidth:ye,contentLeft:Qe,contentWidth:ht,minimap:vt,viewportColumn:Gt,isWordWrapMinified:gt,isViewportWrapping:pt,wrappingColumn:_t,verticalScrollbarWidth:At,horizontalScrollbarHeight:mt,overviewRuler:{top:Xt,width:At,height:Be-2*Xt,right:0}}}}e.EditorLayoutInfoComputer=le;class oe extends _{constructor(){const Q={enabled:!0};super(58,"lightbulb",Q,{"editor.lightbulb.enabled":{type:"boolean",default:Q.enabled,description:o.localize(43,null)}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{enabled:u(Q.enabled,this.defaultValue.enabled)}}}class pe extends _{constructor(){const Q={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(128,"inlayHints",Q,{"editor.inlayHints.enabled":{type:"string",default:Q.enabled,description:o.localize(44,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[o.localize(45,null),o.localize(46,null),o.localize(47,null),o.localize(48,null)]},"editor.inlayHints.fontSize":{type:"number",default:Q.fontSize,markdownDescription:o.localize(49,null)},"editor.inlayHints.fontFamily":{type:"string",default:Q.fontFamily,markdownDescription:o.localize(50,null)},"editor.inlayHints.padding":{type:"boolean",default:Q.padding,description:o.localize(51,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const me=Q;return typeof me.enabled=="boolean"&&(me.enabled=me.enabled?"on":"off"),{enabled:r(me.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:w.clampedInt(me.fontSize,this.defaultValue.fontSize,0,100),fontFamily:y.string(me.fontFamily,this.defaultValue.fontFamily),padding:u(me.padding,this.defaultValue.padding)}}}class re extends a{constructor(){super(60,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Q=>a.clamp(Q,0,150),{markdownDescription:o.localize(52,null)})}compute(Q,me,Le){return Q.fontInfo.lineHeight}}class Ee extends _{constructor(){const Q={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(66,"minimap",Q,{"editor.minimap.enabled":{type:"boolean",default:Q.enabled,description:o.localize(53,null)},"editor.minimap.autohide":{type:"boolean",default:Q.autohide,description:o.localize(54,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[o.localize(55,null),o.localize(56,null),o.localize(57,null)],default:Q.size,description:o.localize(58,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Q.side,description:o.localize(59,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Q.showSlider,description:o.localize(60,null)},"editor.minimap.scale":{type:"number",default:Q.scale,minimum:1,maximum:3,enum:[1,2,3],description:o.localize(61,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Q.renderCharacters,description:o.localize(62,null)},"editor.minimap.maxColumn":{type:"number",default:Q.maxColumn,description:o.localize(63,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const me=Q;return{enabled:u(me.enabled,this.defaultValue.enabled),autohide:u(me.autohide,this.defaultValue.autohide),size:r(me.size,this.defaultValue.size,["proportional","fill","fit"]),side:r(me.side,this.defaultValue.side,["right","left"]),showSlider:r(me.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:u(me.renderCharacters,this.defaultValue.renderCharacters),scale:w.clampedInt(me.scale,1,1,3),maxColumn:w.clampedInt(me.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function be(K){return K==="ctrlCmd"?C.isMacintosh?"metaKey":"ctrlKey":"altKey"}class Z extends _{constructor(){super(76,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:o.localize(64,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:o.localize(65,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const me=Q;return{top:w.clampedInt(me.top,0,0,1e3),bottom:w.clampedInt(me.bottom,0,0,1e3)}}}class ve extends _{constructor(){const Q={enabled:!0,cycle:!1};super(77,"parameterHints",Q,{"editor.parameterHints.enabled":{type:"boolean",default:Q.enabled,description:o.localize(66,null)},"editor.parameterHints.cycle":{type:"boolean",default:Q.cycle,description:o.localize(67,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const me=Q;return{enabled:u(me.enabled,this.defaultValue.enabled),cycle:u(me.cycle,this.defaultValue.cycle)}}}class Re extends g{constructor(){super(130)}compute(Q,me,Le){return Q.pixelRatio}}class Fe extends _{constructor(){const Q={other:"on",comments:"off",strings:"off"},me=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[o.localize(68,null),o.localize(69,null),o.localize(70,null)]}];super(80,"quickSuggestions",Q,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:me,default:Q.strings,description:o.localize(71,null)},comments:{anyOf:me,default:Q.comments,description:o.localize(72,null)},other:{anyOf:me,default:Q.other,description:o.localize(73,null)}},default:Q,markdownDescription:o.localize(74,null)});this.defaultValue=Q}validate(Q){if(typeof Q=="boolean"){const He=Q?"on":"off";return{comments:He,strings:He,other:He}}if(!Q||typeof Q!="object")return this.defaultValue;const{other:me,comments:Le,strings:Be}=Q,Ze=["on","inline","off"];let et,at,Je;return typeof me=="boolean"?et=me?"on":"off":et=r(me,this.defaultValue.other,Ze),typeof Le=="boolean"?at=Le?"on":"off":at=r(Le,this.defaultValue.comments,Ze),typeof Be=="boolean"?Je=Be?"on":"off":Je=r(Be,this.defaultValue.strings,Ze),{other:et,comments:at,strings:Je}}}var We;(function(K){K[K.Off=0]="Off",K[K.On=1]="On",K[K.Relative=2]="Relative",K[K.Interval=3]="Interval",K[K.Custom=4]="Custom"})(We=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Xe extends _{constructor(){super(61,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[o.localize(75,null),o.localize(76,null),o.localize(77,null),o.localize(78,null)],default:"on",description:o.localize(79,null)})}validate(Q){let me=this.defaultValue.renderType,Le=this.defaultValue.renderFn;return typeof Q!="undefined"&&(typeof Q=="function"?(me=4,Le=Q):Q==="interval"?me=3:Q==="relative"?me=2:Q==="on"?me=1:me=0),{renderType:me,renderFn:Le}}}function Ie(K){const Q=K.get(88);return Q==="editable"?K.get(82):Q!=="on"}e.filterValidationDecorations=Ie;class Se extends _{constructor(){const Q=[],me={type:"number",description:o.localize(80,null)};super(92,"rulers",Q,{type:"array",items:{anyOf:[me,{type:["object"],properties:{column:me,color:{type:"string",description:o.localize(81,null),format:"color-hex"}}}]},default:Q,description:o.localize(82,null)})}validate(Q){if(Array.isArray(Q)){const me=[];for(const Le of Q)if(typeof Le=="number")me.push({column:w.clampedInt(Le,0,0,1e4),color:null});else if(Le&&typeof Le=="object"){const Be=Le;me.push({column:w.clampedInt(Be.column,0,0,1e4),color:Be.color})}return me.sort((Le,Be)=>Le.column-Be.column),me}return this.defaultValue}}function Te(K,Q){if(typeof K!="string")return Q;switch(K){case"hidden":return 2;case"visible":return 3;default:return 1}}class se extends _{constructor(){const Q={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(93,"scrollbar",Q,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[o.localize(83,null),o.localize(84,null),o.localize(85,null)],default:"auto",description:o.localize(86,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[o.localize(87,null),o.localize(88,null),o.localize(89,null)],default:"auto",description:o.localize(90,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Q.verticalScrollbarSize,description:o.localize(91,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Q.horizontalScrollbarSize,description:o.localize(92,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Q.scrollByPage,description:o.localize(93,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const me=Q,Le=w.clampedInt(me.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Be=w.clampedInt(me.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:w.clampedInt(me.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Te(me.vertical,this.defaultValue.vertical),horizontal:Te(me.horizontal,this.defaultValue.horizontal),useShadows:u(me.useShadows,this.defaultValue.useShadows),verticalHasArrows:u(me.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:u(me.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:u(me.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:u(me.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Le,horizontalSliderSize:w.clampedInt(me.horizontalSliderSize,Le,0,1e3),verticalScrollbarSize:Be,verticalSliderSize:w.clampedInt(me.verticalSliderSize,Be,0,1e3),scrollByPage:u(me.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class ae extends _{constructor(){const Q={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(114,"unicodeHighlight",Q,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.nonBasicASCII,description:o.localize(94,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:Q.invisibleCharacters,description:o.localize(95,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:Q.ambiguousCharacters,description:o.localize(96,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.includeComments,description:o.localize(97,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.includeStrings,description:o.localize(98,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:Q.allowedCharacters,description:o.localize(99,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:Q.allowedLocales,description:o.localize(100,null)}})}applyUpdate(Q,me){let Le=!1;me.allowedCharacters&&Q&&(I.equals(Q.allowedCharacters,me.allowedCharacters)||(Q={...Q,allowedCharacters:me.allowedCharacters},Le=!0)),me.allowedLocales&&Q&&(I.equals(Q.allowedLocales,me.allowedLocales)||(Q={...Q,allowedLocales:me.allowedLocales},Le=!0));const Be=super.applyUpdate(Q,me);return Le?new m(Be.newValue,!0):Be}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const me=Q;return{nonBasicASCII:B(me.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:u(me.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:u(me.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:B(me.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:B(me.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateBooleanMap(Q.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.validateBooleanMap(Q.allowedLocales,this.defaultValue.allowedLocales)}}validateBooleanMap(Q,me){if(typeof Q!="object"||!Q)return me;const Le={};for(const[Be,Ze]of Object.entries(Q))Ze===!0&&(Le[Be]=!0);return Le}}class G extends _{constructor(){const Q={enabled:!0,mode:"subwordSmart"};super(56,"inlineSuggest",Q,{"editor.inlineSuggest.enabled":{type:"boolean",default:Q.enabled,description:o.localize(101,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const me=Q;return{enabled:u(me.enabled,this.defaultValue.enabled),mode:r(me.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class X extends _{constructor(){const Q={enabled:P.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:P.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(12,"bracketPairColorization",Q,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Q.enabled,markdownDescription:o.localize(102,null)},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:Q.independentColorPoolPerBracketType,description:o.localize(103,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const me=Q;return{enabled:u(me.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:u(me.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class k extends _{constructor(){const Q={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",Q,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[o.localize(104,null),o.localize(105,null),o.localize(106,null)],default:Q.bracketPairs,description:o.localize(107,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[o.localize(108,null),o.localize(109,null),o.localize(110,null)],default:Q.bracketPairsHorizontal,description:o.localize(111,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Q.highlightActiveBracketPair,description:o.localize(112,null)},"editor.guides.indentation":{type:"boolean",default:Q.indentation,description:o.localize(113,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[o.localize(114,null),o.localize(115,null),o.localize(116,null)],default:Q.highlightActiveIndentation,description:o.localize(117,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const me=Q;return{bracketPairs:B(me.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:B(me.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:u(me.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:u(me.indentation,this.defaultValue.indentation),highlightActiveIndentation:B(me.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function B(K,Q,me){const Le=me.indexOf(K);return Le===-1?Q:me[Le]}class V extends _{constructor(){const Q={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(107,"suggest",Q,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[o.localize(118,null),o.localize(119,null)],default:Q.insertMode,description:o.localize(120,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Q.filterGraceful,description:o.localize(121,null)},"editor.suggest.localityBonus":{type:"boolean",default:Q.localityBonus,description:o.localize(122,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Q.shareSuggestSelections,markdownDescription:o.localize(123,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Q.snippetsPreventQuickSuggestions,description:o.localize(124,null)},"editor.suggest.showIcons":{type:"boolean",default:Q.showIcons,description:o.localize(125,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Q.showStatusBar,description:o.localize(126,null)},"editor.suggest.preview":{type:"boolean",default:Q.preview,description:o.localize(127,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Q.showInlineDetails,description:o.localize(128,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:o.localize(129,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:o.localize(130,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:o.localize(131,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:o.localize(132,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:o.localize(133,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:o.localize(134,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:o.localize(135,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:o.localize(136,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:o.localize(137,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:o.localize(138,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:o.localize(139,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:o.localize(140,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:o.localize(141,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:o.localize(142,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:o.localize(143,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:o.localize(144,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:o.localize(145,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:o.localize(146,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:o.localize(147,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:o.localize(148,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:o.localize(149,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:o.localize(150,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:o.localize(151,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:o.localize(152,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:o.localize(153,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:o.localize(154,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:o.localize(155,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:o.localize(156,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:o.localize(157,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:o.localize(158,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:o.localize(159,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const me=Q;return{insertMode:r(me.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:u(me.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:u(me.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:u(me.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:u(me.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:u(me.showIcons,this.defaultValue.showIcons),showStatusBar:u(me.showStatusBar,this.defaultValue.showStatusBar),preview:u(me.preview,this.defaultValue.preview),previewMode:r(me.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:u(me.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:u(me.showMethods,this.defaultValue.showMethods),showFunctions:u(me.showFunctions,this.defaultValue.showFunctions),showConstructors:u(me.showConstructors,this.defaultValue.showConstructors),showDeprecated:u(me.showDeprecated,this.defaultValue.showDeprecated),showFields:u(me.showFields,this.defaultValue.showFields),showVariables:u(me.showVariables,this.defaultValue.showVariables),showClasses:u(me.showClasses,this.defaultValue.showClasses),showStructs:u(me.showStructs,this.defaultValue.showStructs),showInterfaces:u(me.showInterfaces,this.defaultValue.showInterfaces),showModules:u(me.showModules,this.defaultValue.showModules),showProperties:u(me.showProperties,this.defaultValue.showProperties),showEvents:u(me.showEvents,this.defaultValue.showEvents),showOperators:u(me.showOperators,this.defaultValue.showOperators),showUnits:u(me.showUnits,this.defaultValue.showUnits),showValues:u(me.showValues,this.defaultValue.showValues),showConstants:u(me.showConstants,this.defaultValue.showConstants),showEnums:u(me.showEnums,this.defaultValue.showEnums),showEnumMembers:u(me.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:u(me.showKeywords,this.defaultValue.showKeywords),showWords:u(me.showWords,this.defaultValue.showWords),showColors:u(me.showColors,this.defaultValue.showColors),showFiles:u(me.showFiles,this.defaultValue.showFiles),showReferences:u(me.showReferences,this.defaultValue.showReferences),showFolders:u(me.showFolders,this.defaultValue.showFolders),showTypeParameters:u(me.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:u(me.showSnippets,this.defaultValue.showSnippets),showUsers:u(me.showUsers,this.defaultValue.showUsers),showIssues:u(me.showIssues,this.defaultValue.showIssues)}}}class j extends _{constructor(){super(103,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:o.localize(160,null),default:!0,type:"boolean"}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:u(Q.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class ne extends g{constructor(){super(131)}compute(Q,me,Le){return me.get(82)?!0:Q.tabFocusMode}}var ue;(function(K){K[K.None=0]="None",K[K.Same=1]="Same",K[K.Indent=2]="Indent",K[K.DeepIndent=3]="DeepIndent"})(ue=e.WrappingIndent||(e.WrappingIndent={}));function Y(K){switch(K){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class ge extends g{constructor(){super(133)}compute(Q,me,Le){const Be=me.get(132);return{isDominatedByLongLines:Q.isDominatedByLongLines,isWordWrapMinified:Be.isWordWrapMinified,isViewportWrapping:Be.isViewportWrapping,wrappingColumn:Be.wrappingColumn}}}const fe="Consolas, 'Courier New', monospace",Ne="Menlo, Monaco, 'Courier New', monospace",ze="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:C.isMacintosh?Ne:C.isLinux?ze:fe,fontWeight:"normal",fontSize:C.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function ke(K){return e.editorOptionsRegistry[K.id]=K,K}var qe;(function(K){K[K.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",K[K.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",K[K.accessibilitySupport=2]="accessibilitySupport",K[K.accessibilityPageSize=3]="accessibilityPageSize",K[K.ariaLabel=4]="ariaLabel",K[K.autoClosingBrackets=5]="autoClosingBrackets",K[K.autoClosingDelete=6]="autoClosingDelete",K[K.autoClosingOvertype=7]="autoClosingOvertype",K[K.autoClosingQuotes=8]="autoClosingQuotes",K[K.autoIndent=9]="autoIndent",K[K.automaticLayout=10]="automaticLayout",K[K.autoSurround=11]="autoSurround",K[K.bracketPairColorization=12]="bracketPairColorization",K[K.guides=13]="guides",K[K.codeLens=14]="codeLens",K[K.codeLensFontFamily=15]="codeLensFontFamily",K[K.codeLensFontSize=16]="codeLensFontSize",K[K.colorDecorators=17]="colorDecorators",K[K.columnSelection=18]="columnSelection",K[K.comments=19]="comments",K[K.contextmenu=20]="contextmenu",K[K.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",K[K.cursorBlinking=22]="cursorBlinking",K[K.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",K[K.cursorStyle=24]="cursorStyle",K[K.cursorSurroundingLines=25]="cursorSurroundingLines",K[K.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",K[K.cursorWidth=27]="cursorWidth",K[K.disableLayerHinting=28]="disableLayerHinting",K[K.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",K[K.domReadOnly=30]="domReadOnly",K[K.dragAndDrop=31]="dragAndDrop",K[K.enableDropIntoEditor=32]="enableDropIntoEditor",K[K.emptySelectionClipboard=33]="emptySelectionClipboard",K[K.extraEditorClassName=34]="extraEditorClassName",K[K.fastScrollSensitivity=35]="fastScrollSensitivity",K[K.find=36]="find",K[K.fixedOverflowWidgets=37]="fixedOverflowWidgets",K[K.folding=38]="folding",K[K.foldingStrategy=39]="foldingStrategy",K[K.foldingHighlight=40]="foldingHighlight",K[K.foldingImportsByDefault=41]="foldingImportsByDefault",K[K.foldingMaximumRegions=42]="foldingMaximumRegions",K[K.unfoldOnClickAfterEndOfLine=43]="unfoldOnClickAfterEndOfLine",K[K.fontFamily=44]="fontFamily",K[K.fontInfo=45]="fontInfo",K[K.fontLigatures=46]="fontLigatures",K[K.fontSize=47]="fontSize",K[K.fontWeight=48]="fontWeight",K[K.formatOnPaste=49]="formatOnPaste",K[K.formatOnType=50]="formatOnType",K[K.glyphMargin=51]="glyphMargin",K[K.gotoLocation=52]="gotoLocation",K[K.hideCursorInOverviewRuler=53]="hideCursorInOverviewRuler",K[K.hover=54]="hover",K[K.inDiffEditor=55]="inDiffEditor",K[K.inlineSuggest=56]="inlineSuggest",K[K.letterSpacing=57]="letterSpacing",K[K.lightbulb=58]="lightbulb",K[K.lineDecorationsWidth=59]="lineDecorationsWidth",K[K.lineHeight=60]="lineHeight",K[K.lineNumbers=61]="lineNumbers",K[K.lineNumbersMinChars=62]="lineNumbersMinChars",K[K.linkedEditing=63]="linkedEditing",K[K.links=64]="links",K[K.matchBrackets=65]="matchBrackets",K[K.minimap=66]="minimap",K[K.mouseStyle=67]="mouseStyle",K[K.mouseWheelScrollSensitivity=68]="mouseWheelScrollSensitivity",K[K.mouseWheelZoom=69]="mouseWheelZoom",K[K.multiCursorMergeOverlapping=70]="multiCursorMergeOverlapping",K[K.multiCursorModifier=71]="multiCursorModifier",K[K.multiCursorPaste=72]="multiCursorPaste",K[K.occurrencesHighlight=73]="occurrencesHighlight",K[K.overviewRulerBorder=74]="overviewRulerBorder",K[K.overviewRulerLanes=75]="overviewRulerLanes",K[K.padding=76]="padding",K[K.parameterHints=77]="parameterHints",K[K.peekWidgetDefaultFocus=78]="peekWidgetDefaultFocus",K[K.definitionLinkOpensInPeek=79]="definitionLinkOpensInPeek",K[K.quickSuggestions=80]="quickSuggestions",K[K.quickSuggestionsDelay=81]="quickSuggestionsDelay",K[K.readOnly=82]="readOnly",K[K.renameOnType=83]="renameOnType",K[K.renderControlCharacters=84]="renderControlCharacters",K[K.renderFinalNewline=85]="renderFinalNewline",K[K.renderLineHighlight=86]="renderLineHighlight",K[K.renderLineHighlightOnlyWhenFocus=87]="renderLineHighlightOnlyWhenFocus",K[K.renderValidationDecorations=88]="renderValidationDecorations",K[K.renderWhitespace=89]="renderWhitespace",K[K.revealHorizontalRightPadding=90]="revealHorizontalRightPadding",K[K.roundedSelection=91]="roundedSelection",K[K.rulers=92]="rulers",K[K.scrollbar=93]="scrollbar",K[K.scrollBeyondLastColumn=94]="scrollBeyondLastColumn",K[K.scrollBeyondLastLine=95]="scrollBeyondLastLine",K[K.scrollPredominantAxis=96]="scrollPredominantAxis",K[K.selectionClipboard=97]="selectionClipboard",K[K.selectionHighlight=98]="selectionHighlight",K[K.selectOnLineNumbers=99]="selectOnLineNumbers",K[K.showFoldingControls=100]="showFoldingControls",K[K.showUnused=101]="showUnused",K[K.snippetSuggestions=102]="snippetSuggestions",K[K.smartSelect=103]="smartSelect",K[K.smoothScrolling=104]="smoothScrolling",K[K.stickyTabStops=105]="stickyTabStops",K[K.stopRenderingLineAfter=106]="stopRenderingLineAfter",K[K.suggest=107]="suggest",K[K.suggestFontSize=108]="suggestFontSize",K[K.suggestLineHeight=109]="suggestLineHeight",K[K.suggestOnTriggerCharacters=110]="suggestOnTriggerCharacters",K[K.suggestSelection=111]="suggestSelection",K[K.tabCompletion=112]="tabCompletion",K[K.tabIndex=113]="tabIndex",K[K.unicodeHighlighting=114]="unicodeHighlighting",K[K.unusualLineTerminators=115]="unusualLineTerminators",K[K.useShadowDOM=116]="useShadowDOM",K[K.useTabStops=117]="useTabStops",K[K.wordSeparators=118]="wordSeparators",K[K.wordWrap=119]="wordWrap",K[K.wordWrapBreakAfterCharacters=120]="wordWrapBreakAfterCharacters",K[K.wordWrapBreakBeforeCharacters=121]="wordWrapBreakBeforeCharacters",K[K.wordWrapColumn=122]="wordWrapColumn",K[K.wordWrapOverride1=123]="wordWrapOverride1",K[K.wordWrapOverride2=124]="wordWrapOverride2",K[K.wrappingIndent=125]="wrappingIndent",K[K.wrappingStrategy=126]="wrappingStrategy",K[K.showDeprecated=127]="showDeprecated",K[K.inlayHints=128]="inlayHints",K[K.editorClassName=129]="editorClassName",K[K.pixelRatio=130]="pixelRatio",K[K.tabFocusMode=131]="tabFocusMode",K[K.layoutInfo=132]="layoutInfo",K[K.wrappingInfo=133]="wrappingInfo"})(qe=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:ke(new l(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:o.localize(161,null)})),acceptSuggestionOnEnter:ke(new d(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",o.localize(162,null),""],markdownDescription:o.localize(163,null)})),accessibilitySupport:ke(new n),accessibilityPageSize:ke(new w(3,"accessibilityPageSize",10,1,1073741824,{description:o.localize(164,null)})),ariaLabel:ke(new y(4,"ariaLabel",o.localize(165,null))),autoClosingBrackets:ke(new d(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",o.localize(166,null),o.localize(167,null),""],description:o.localize(168,null)})),autoClosingDelete:ke(new d(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",o.localize(169,null),""],description:o.localize(170,null)})),autoClosingOvertype:ke(new d(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",o.localize(171,null),""],description:o.localize(172,null)})),autoClosingQuotes:ke(new d(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",o.localize(173,null),o.localize(174,null),""],description:o.localize(175,null)})),autoIndent:ke(new i(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],s,{enumDescriptions:[o.localize(176,null),o.localize(177,null),o.localize(178,null),o.localize(179,null),o.localize(180,null)],description:o.localize(181,null)})),automaticLayout:ke(new l(10,"automaticLayout",!1)),autoSurround:ke(new d(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[o.localize(182,null),o.localize(183,null),o.localize(184,null),""],description:o.localize(185,null)})),bracketPairColorization:ke(new X),bracketPairGuides:ke(new k),stickyTabStops:ke(new l(105,"stickyTabStops",!1,{description:o.localize(186,null)})),codeLens:ke(new l(14,"codeLens",!0,{description:o.localize(187,null)})),codeLensFontFamily:ke(new y(15,"codeLensFontFamily","",{description:o.localize(188,null)})),codeLensFontSize:ke(new w(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:o.localize(189,null)})),colorDecorators:ke(new l(17,"colorDecorators",!0,{description:o.localize(190,null)})),columnSelection:ke(new l(18,"columnSelection",!1,{description:o.localize(191,null)})),comments:ke(new t),contextmenu:ke(new l(20,"contextmenu",!0)),copyWithSyntaxHighlighting:ke(new l(21,"copyWithSyntaxHighlighting",!0,{description:o.localize(192,null)})),cursorBlinking:ke(new i(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],E,{description:o.localize(193,null)})),cursorSmoothCaretAnimation:ke(new l(23,"cursorSmoothCaretAnimation",!1,{description:o.localize(194,null)})),cursorStyle:ke(new i(24,"cursorStyle",f.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],L,{description:o.localize(195,null)})),cursorSurroundingLines:ke(new w(25,"cursorSurroundingLines",0,0,1073741824,{description:o.localize(196,null)})),cursorSurroundingLinesStyle:ke(new d(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[o.localize(197,null),o.localize(198,null)],description:o.localize(199,null)})),cursorWidth:ke(new w(27,"cursorWidth",0,0,1073741824,{markdownDescription:o.localize(200,null)})),disableLayerHinting:ke(new l(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:ke(new l(29,"disableMonospaceOptimizations",!1)),domReadOnly:ke(new l(30,"domReadOnly",!1)),dragAndDrop:ke(new l(31,"dragAndDrop",!0,{description:o.localize(201,null)})),emptySelectionClipboard:ke(new N),enableDropIntoEditor:ke(new l(32,"enableDropIntoEditor",!0)),extraEditorClassName:ke(new y(34,"extraEditorClassName","")),fastScrollSensitivity:ke(new a(35,"fastScrollSensitivity",5,K=>K<=0?5:K,{markdownDescription:o.localize(202,null)})),find:ke(new v),fixedOverflowWidgets:ke(new l(37,"fixedOverflowWidgets",!1)),folding:ke(new l(38,"folding",!0,{description:o.localize(203,null)})),foldingStrategy:ke(new d(39,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[o.localize(204,null),o.localize(205,null)],description:o.localize(206,null)})),foldingHighlight:ke(new l(40,"foldingHighlight",!0,{description:o.localize(207,null)})),foldingImportsByDefault:ke(new l(41,"foldingImportsByDefault",!1,{description:o.localize(208,null)})),foldingMaximumRegions:ke(new w(42,"foldingMaximumRegions",5e3,10,65e3,{description:o.localize(209,null)})),unfoldOnClickAfterEndOfLine:ke(new l(43,"unfoldOnClickAfterEndOfLine",!1,{description:o.localize(210,null)})),fontFamily:ke(new y(44,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:o.localize(211,null)})),fontInfo:ke(new O),fontLigatures2:ke(new F),fontSize:ke(new H),fontWeight:ke(new te),formatOnPaste:ke(new l(49,"formatOnPaste",!1,{description:o.localize(212,null)})),formatOnType:ke(new l(50,"formatOnType",!1,{description:o.localize(213,null)})),glyphMargin:ke(new l(51,"glyphMargin",!0,{description:o.localize(214,null)})),gotoLocation:ke(new z),hideCursorInOverviewRuler:ke(new l(53,"hideCursorInOverviewRuler",!1,{description:o.localize(215,null)})),hover:ke(new $),inDiffEditor:ke(new l(55,"inDiffEditor",!1)),letterSpacing:ke(new a(57,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,K=>a.clamp(K,-5,20),{description:o.localize(216,null)})),lightbulb:ke(new oe),lineDecorationsWidth:ke(new h(59,"lineDecorationsWidth",10)),lineHeight:ke(new re),lineNumbers:ke(new Xe),lineNumbersMinChars:ke(new w(62,"lineNumbersMinChars",5,1,300)),linkedEditing:ke(new l(63,"linkedEditing",!1,{description:o.localize(217,null)})),links:ke(new l(64,"links",!0,{description:o.localize(218,null)})),matchBrackets:ke(new d(65,"matchBrackets","always",["always","near","never"],{description:o.localize(219,null)})),minimap:ke(new Ee),mouseStyle:ke(new d(67,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:ke(new a(68,"mouseWheelScrollSensitivity",1,K=>K===0?1:K,{markdownDescription:o.localize(220,null)})),mouseWheelZoom:ke(new l(69,"mouseWheelZoom",!1,{markdownDescription:o.localize(221,null)})),multiCursorMergeOverlapping:ke(new l(70,"multiCursorMergeOverlapping",!0,{description:o.localize(222,null)})),multiCursorModifier:ke(new i(71,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],be,{markdownEnumDescriptions:[o.localize(223,null),o.localize(224,null)],markdownDescription:o.localize(225,null)})),multiCursorPaste:ke(new d(72,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[o.localize(226,null),o.localize(227,null)],markdownDescription:o.localize(228,null)})),occurrencesHighlight:ke(new l(73,"occurrencesHighlight",!0,{description:o.localize(229,null)})),overviewRulerBorder:ke(new l(74,"overviewRulerBorder",!0,{description:o.localize(230,null)})),overviewRulerLanes:ke(new w(75,"overviewRulerLanes",3,0,3)),padding:ke(new Z),parameterHints:ke(new ve),peekWidgetDefaultFocus:ke(new d(78,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[o.localize(231,null),o.localize(232,null)],description:o.localize(233,null)})),definitionLinkOpensInPeek:ke(new l(79,"definitionLinkOpensInPeek",!1,{description:o.localize(234,null)})),quickSuggestions:ke(new Fe),quickSuggestionsDelay:ke(new w(81,"quickSuggestionsDelay",10,0,1073741824,{description:o.localize(235,null)})),readOnly:ke(new l(82,"readOnly",!1)),renameOnType:ke(new l(83,"renameOnType",!1,{description:o.localize(236,null),markdownDeprecationMessage:o.localize(237,null)})),renderControlCharacters:ke(new l(84,"renderControlCharacters",!0,{description:o.localize(238,null),restricted:!0})),renderFinalNewline:ke(new l(85,"renderFinalNewline",!0,{description:o.localize(239,null)})),renderLineHighlight:ke(new d(86,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",o.localize(240,null)],description:o.localize(241,null)})),renderLineHighlightOnlyWhenFocus:ke(new l(87,"renderLineHighlightOnlyWhenFocus",!1,{description:o.localize(242,null)})),renderValidationDecorations:ke(new d(88,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:ke(new d(89,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",o.localize(243,null),o.localize(244,null),o.localize(245,null),""],description:o.localize(246,null)})),revealHorizontalRightPadding:ke(new w(90,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:ke(new l(91,"roundedSelection",!0,{description:o.localize(247,null)})),rulers:ke(new Se),scrollbar:ke(new se),scrollBeyondLastColumn:ke(new w(94,"scrollBeyondLastColumn",4,0,1073741824,{description:o.localize(248,null)})),scrollBeyondLastLine:ke(new l(95,"scrollBeyondLastLine",!0,{description:o.localize(249,null)})),scrollPredominantAxis:ke(new l(96,"scrollPredominantAxis",!0,{description:o.localize(250,null)})),selectionClipboard:ke(new l(97,"selectionClipboard",!0,{description:o.localize(251,null),included:C.isLinux})),selectionHighlight:ke(new l(98,"selectionHighlight",!0,{description:o.localize(252,null)})),selectOnLineNumbers:ke(new l(99,"selectOnLineNumbers",!0)),showFoldingControls:ke(new d(100,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[o.localize(253,null),o.localize(254,null)],description:o.localize(255,null)})),showUnused:ke(new l(101,"showUnused",!0,{description:o.localize(256,null)})),showDeprecated:ke(new l(127,"showDeprecated",!0,{description:o.localize(257,null)})),inlayHints:ke(new pe),snippetSuggestions:ke(new d(102,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[o.localize(258,null),o.localize(259,null),o.localize(260,null),o.localize(261,null)],description:o.localize(262,null)})),smartSelect:ke(new j),smoothScrolling:ke(new l(104,"smoothScrolling",!1,{description:o.localize(263,null)})),stopRenderingLineAfter:ke(new w(106,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:ke(new V),inlineSuggest:ke(new G),suggestFontSize:ke(new w(108,"suggestFontSize",0,0,1e3,{markdownDescription:o.localize(264,null)})),suggestLineHeight:ke(new w(109,"suggestLineHeight",0,0,1e3,{markdownDescription:o.localize(265,null)})),suggestOnTriggerCharacters:ke(new l(110,"suggestOnTriggerCharacters",!0,{description:o.localize(266,null)})),suggestSelection:ke(new d(111,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[o.localize(267,null),o.localize(268,null),o.localize(269,null)],description:o.localize(270,null)})),tabCompletion:ke(new d(112,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[o.localize(271,null),o.localize(272,null),o.localize(273,null)],description:o.localize(274,null)})),tabIndex:ke(new w(113,"tabIndex",0,-1,1073741824)),unicodeHighlight:ke(new ae),unusualLineTerminators:ke(new d(115,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[o.localize(275,null),o.localize(276,null),o.localize(277,null)],description:o.localize(278,null)})),useShadowDOM:ke(new l(116,"useShadowDOM",!0)),useTabStops:ke(new l(117,"useTabStops",!0,{description:o.localize(279,null)})),wordSeparators:ke(new y(118,"wordSeparators",p.USUAL_WORD_SEPARATORS,{description:o.localize(280,null)})),wordWrap:ke(new d(119,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[o.localize(281,null),o.localize(282,null),o.localize(283,null),o.localize(284,null)],description:o.localize(285,null)})),wordWrapBreakAfterCharacters:ke(new y(120,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:ke(new y(121,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:ke(new w(122,"wordWrapColumn",80,1,1073741824,{markdownDescription:o.localize(286,null)})),wordWrapOverride1:ke(new d(123,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:ke(new d(124,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:ke(new i(125,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],Y,{enumDescriptions:[o.localize(287,null),o.localize(288,null),o.localize(289,null),o.localize(290,null)],description:o.localize(291,null)})),wrappingStrategy:ke(new d(126,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[o.localize(292,null),o.localize(293,null)],description:o.localize(294,null)})),editorClassName:ke(new W),pixelRatio:ke(new Re),tabFocusMode:ke(new ne),layoutInfo:ke(new le),wrappingInfo:ke(new ge)}}),define(De[122],Ce([17,18]),function(J,e){return J.create("vs/platform/configuration/common/configurationRegistry",e)}),define(De[123],Ce([17,18]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(De[124],Ce([17,18]),function(J,e){return J.create("vs/platform/extensions/common/extensionValidator",e)}),define(De[125],Ce([17,18]),function(J,e){return J.create("vs/platform/files/common/files",e)}),define(De[126],Ce([17,18]),function(J,e){return J.create("vs/platform/markers/common/markers",e)}),define(De[127],Ce([17,18]),function(J,e){return J.create("vs/platform/workspace/common/workspace",e)}),define(De[128],Ce([17,18]),function(J,e){return J.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(De[129],Ce([17,18]),function(J,e){return J.create("vs/workbench/api/common/extHostExtensionService",e)}),define(De[130],Ce([17,18]),function(J,e){return J.create("vs/workbench/api/common/extHostProgress",e)}),define(De[131],Ce([17,18]),function(J,e){return J.create("vs/workbench/api/common/extHostStatusBar",e)}),define(De[132],Ce([17,18]),function(J,e){return J.create("vs/workbench/api/common/extHostTerminalService",e)}),define(De[133],Ce([17,18]),function(J,e){return J.create("vs/workbench/api/common/extHostTreeViews",e)}),define(De[134],Ce([17,18]),function(J,e){return J.create("vs/workbench/api/common/extHostWorkspace",e)}),define(De[135],Ce([17,18]),function(J,e){return J.create("vs/workbench/common/editor",e)}),define(De[136],Ce([17,18]),function(J,e){return J.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(De[137],Ce([17,18]),function(J,e){return J.create("vs/workbench/contrib/debug/common/debug",e)}),define(De[138],Ce([17,18]),function(J,e){return J.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(De[139],Ce([17,18]),function(J,e){return J.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(De[140],Ce([17,18]),function(J,e){return J.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(De[141],Ce([17,18]),function(J,e){return J.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(De[142],Ce([17,18]),function(J,e){return J.create("vs/workbench/services/search/common/queryBuilder",e)}),define(De[143],Ce([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionSource=e.TextEditorSelectionRevealType=e.EditorOpenSource=e.EditorResolution=e.EditorActivation=void 0;var o;(function(P){P[P.ACTIVATE=1]="ACTIVATE",P[P.RESTORE=2]="RESTORE",P[P.PRESERVE=3]="PRESERVE"})(o=e.EditorActivation||(e.EditorActivation={}));var C;(function(P){P[P.PICK=0]="PICK",P[P.DISABLED=1]="DISABLED",P[P.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(C=e.EditorResolution||(e.EditorResolution={}));var p;(function(P){P[P.API=0]="API",P[P.USER=1]="USER"})(p=e.EditorOpenSource||(e.EditorOpenSource={}));var U;(function(P){P[P.Center=0]="Center",P[P.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",P[P.NearTop=2]="NearTop",P[P.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(U=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}));var I;(function(P){P.PROGRAMMATIC="api",P.NAVIGATION="code.navigation",P.JUMP="code.jump"})(I=e.TextEditorSelectionSource||(e.TextEditorSelectionSource={}))}),define(De[144],Ce([1,0,21,29,124,238]),function(J,e,o,C,p,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const I=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,P=/^-(\d{4})(\d{2})(\d{2})$/;function b(l){return l=l.trim(),l==="*"||I.test(l)}e.isValidVersionStr=b;function A(l){if(!b(l))return null;if(l=l.trim(),l==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const S=l.match(I);return S?{hasCaret:S[1]==="^",hasGreaterEquals:S[1]===">=",majorBase:S[2]==="x"?0:parseInt(S[2],10),majorMustEqual:S[2]!=="x",minorBase:S[4]==="x"?0:parseInt(S[4],10),minorMustEqual:S[4]!=="x",patchBase:S[6]==="x"?0:parseInt(S[6],10),patchMustEqual:S[6]!=="x",preRelease:S[8]||null}:null}e.parseVersion=A;function R(l){if(!l)return null;const S=l.majorBase,w=l.majorMustEqual,a=l.minorBase;let y=l.minorMustEqual;const r=l.patchBase;let d=l.patchMustEqual;l.hasCaret&&(S===0||(y=!1),d=!1);let i=0;if(l.preRelease){const s=P.exec(l.preRelease);if(s){const[,n,t,c]=s;i=Date.UTC(Number(n),Number(t)-1,Number(c))}}return{majorBase:S,majorMustEqual:w,minorBase:a,minorMustEqual:y,patchBase:r,patchMustEqual:d,isMinimum:l.hasGreaterEquals,notBefore:i}}e.normalizeVersion=R;function _(l,S,w){let a;typeof l=="string"?a=R(A(l)):a=l;let y;S instanceof Date?y=S.getTime():typeof S=="string"&&(y=new Date(S).getTime());let r;if(typeof w=="string"?r=R(A(w)):r=w,!a||!r)return!1;const d=a.majorBase,i=a.minorBase,s=a.patchBase;let n=r.majorBase,t=r.minorBase,c=r.patchBase;const E=r.notBefore;let f=r.majorMustEqual,D=r.minorMustEqual,L=r.patchMustEqual;return r.isMinimum?d>n?!0:d<n?!1:i>t?!0:i<t||y&&y<E?!1:s>=c:(d===1&&n===0&&(!f||!D||!L)&&(n=1,t=0,c=0,f=!0,D=!1,L=!1),d<n?!1:d>n?!f:i<t?!1:i>t?!D:s<c?!1:s>c?!L:!(y&&y<E))}e.isValidVersion=_;function m(l,S,w,a,y){const r=[];if(typeof a.publisher!="undefined"&&typeof a.publisher!="string")return r.push([C.default.Error,p.localize(0,null)]),r;if(typeof a.name!="string")return r.push([C.default.Error,p.localize(1,null,"name")]),r;if(typeof a.version!="string")return r.push([C.default.Error,p.localize(2,null,"version")]),r;if(!a.engines)return r.push([C.default.Error,p.localize(3,null,"engines")]),r;if(typeof a.engines.vscode!="string")return r.push([C.default.Error,p.localize(4,null,"engines.vscode")]),r;if(typeof a.extensionDependencies!="undefined"&&!u(a.extensionDependencies))return r.push([C.default.Error,p.localize(5,null,"extensionDependencies")]),r;if(typeof a.activationEvents!="undefined"){if(!u(a.activationEvents))return r.push([C.default.Error,p.localize(6,null,"activationEvents")]),r;if(typeof a.main=="undefined"&&typeof a.browser=="undefined")return r.push([C.default.Error,p.localize(7,null,"activationEvents","main")]),r}if(typeof a.extensionKind!="undefined"&&typeof a.main=="undefined"&&r.push([C.default.Warning,p.localize(8,null,"extensionKind")]),typeof a.main!="undefined"){if(typeof a.main!="string")return r.push([C.default.Error,p.localize(9,null,"main")]),r;{const s=(0,o.joinPath)(w,a.main);(0,o.isEqualOrParent)(s,w)||r.push([C.default.Warning,p.localize(10,null,s.path,w.path)])}if(typeof a.activationEvents=="undefined")return r.push([C.default.Error,p.localize(11,null,"activationEvents","main")]),r}if(typeof a.browser!="undefined"){if(typeof a.browser!="string")return r.push([C.default.Error,p.localize(12,null,"browser")]),r;{const s=(0,o.joinPath)(w,a.browser);(0,o.isEqualOrParent)(s,w)||r.push([C.default.Warning,p.localize(13,null,s.path,w.path)])}if(typeof a.activationEvents=="undefined")return r.push([C.default.Error,p.localize(14,null,"activationEvents","browser")]),r}if(!U.valid(a.version))return r.push([C.default.Error,p.localize(15,null)]),r;const d=[];if(!T(l,S,a,y,d))for(const s of d)r.push([C.default.Error,s]);return r}e.validateExtensionManifest=m;function T(l,S,w,a,y){return a||typeof w.main=="undefined"&&typeof w.browser=="undefined"?!0:h(l,S,w.engines.vscode,y)}e.isValidExtensionVersion=T;function g(l,S,w){return l==="*"||h(S,w,l)}e.isEngineValid=g;function h(l,S,w,a=[]){const y=R(A(w));if(!y)return a.push(p.localize(16,null,w)),!1;if(y.majorBase===0){if(!y.majorMustEqual||!y.minorMustEqual)return a.push(p.localize(17,null,w)),!1}else if(!y.majorMustEqual)return a.push(p.localize(18,null,w)),!1;return _(l,S,y)?!0:(a.push(p.localize(19,null,l,w)),!1)}function u(l){if(!Array.isArray(l))return!1;for(let S=0,w=l.length;S<w;S++)if(typeof l[S]!="string")return!1;return!0}}),define(De[78],Ce([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class o{constructor(p,U=[],I=!1){this.ctor=p,this.staticArguments=U,this.supportsDelayedInstantiation=I}}e.SyncDescriptor=o}),define(De[56],Ce([1,0,78]),function(J,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const C=[];function p(I,P,b){P instanceof o.SyncDescriptor||(P=new o.SyncDescriptor(P,[],b)),C.push([I,P])}e.registerSingleton=p;function U(){return C}e.getSingletonServiceDescriptors=U}),define(De[145],Ce([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class o{constructor(U){this.incoming=new Map,this.outgoing=new Map,this.data=U}}e.Node=o;class C{constructor(U){this._hashFn=U,this._nodes=new Map}roots(){const U=[];for(const I of this._nodes.values())I.outgoing.size===0&&U.push(I);return U}insertEdge(U,I){const P=this.lookupOrInsertNode(U),b=this.lookupOrInsertNode(I);P.outgoing.set(this._hashFn(I),b),b.incoming.set(this._hashFn(U),P)}removeNode(U){const I=this._hashFn(U);this._nodes.delete(I);for(const P of this._nodes.values())P.outgoing.delete(I),P.incoming.delete(I)}lookupOrInsertNode(U){const I=this._hashFn(U);let P=this._nodes.get(I);return P||(P=new o(U),this._nodes.set(I,P)),P}lookup(U){return this._nodes.get(this._hashFn(U))}isEmpty(){return this._nodes.size===0}toString(){const U=[];for(const[I,P]of this._nodes)U.push(`${I}, (incoming)[${[...P.incoming.keys()].join(", ")}], (outgoing)[${[...P.outgoing.keys()].join(",")}]`);return U.join(`
`)}findCycleSlow(){for(const[U,I]of this._nodes){const P=new Set([U]),b=this._findCycle(I,P);if(b)return b}}_findCycle(U,I){for(const[P,b]of U.outgoing){if(I.has(P))return[...I,P].join(" -> ");I.add(P);const A=this._findCycle(b,I);if(A)return A;I.delete(P)}}}e.Graph=C}),define(De[3],Ce([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var o;(function(I){I.serviceIds=new Map,I.DI_TARGET="$di$target",I.DI_DEPENDENCIES="$di$dependencies";function P(b){return b[I.DI_DEPENDENCIES]||[]}I.getServiceDependencies=P})(o=e._util||(e._util={})),e.IInstantiationService=p("instantiationService");function C(I,P,b){P[o.DI_TARGET]===P?P[o.DI_DEPENDENCIES].push({id:I,index:b}):(P[o.DI_DEPENDENCIES]=[{id:I,index:b}],P[o.DI_TARGET]=P)}function p(I){if(o.serviceIds.has(I))return o.serviceIds.get(I);const P=function(b,A,R){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");C(P,b,R)};return P.toString=()=>I,o.serviceIds.set(I,P),P}e.createDecorator=p;function U(I){return I}e.refineServiceDecorator=U}),define(De[57],Ce([1,0,9,2,3]),function(J,e,o,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,p.createDecorator)("configurationService");function U(l){return l&&typeof l=="object"&&(!l.overrideIdentifier||typeof l.overrideIdentifier=="string")&&(!l.resource||l.resource instanceof C.URI)}e.isConfigurationOverrides=U;function I(l){return l&&typeof l=="object"&&(!l.overrideIdentifiers||o.isArray(l.overrideIdentifiers))&&!l.overrideIdentifier&&(!l.resource||l.resource instanceof C.URI)}e.isConfigurationUpdateOverrides=I;var P;(function(l){l[l.USER=1]="USER",l[l.USER_LOCAL=2]="USER_LOCAL",l[l.USER_REMOTE=3]="USER_REMOTE",l[l.WORKSPACE=4]="WORKSPACE",l[l.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",l[l.DEFAULT=6]="DEFAULT",l[l.MEMORY=7]="MEMORY"})(P=e.ConfigurationTarget||(e.ConfigurationTarget={}));function b(l){switch(l){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=b;function A(l,S){const w=Object.create(null);for(const a in l)R(w,a,l[a],S);return w}e.toValuesTree=A;function R(l,S,w,a){const y=S.split("."),r=y.pop();let d=l;for(let i=0;i<y.length;i++){const s=y[i];let n=d[s];switch(typeof n){case"undefined":n=d[s]=Object.create(null);break;case"object":break;default:a(`Ignoring ${S} as ${y.slice(0,i+1).join(".")} is ${JSON.stringify(n)}`);return}d=n}if(typeof d=="object"&&d!==null)try{d[r]=w}catch{a(`Ignoring ${S} as ${y.join(".")} is ${JSON.stringify(d)}`)}else a(`Ignoring ${S} as ${y.join(".")} is ${JSON.stringify(d)}`)}e.addToValueTree=R;function _(l,S){const w=S.split(".");m(l,w)}e.removeFromValueTree=_;function m(l,S){const w=S.shift();if(S.length===0){delete l[w];return}if(Object.keys(l).indexOf(w)!==-1){const a=l[w];typeof a=="object"&&!Array.isArray(a)&&(m(a,S),Object.keys(a).length===0&&delete l[w])}}function T(l,S,w){function a(d,i){let s=d;for(const n of i){if(typeof s!="object"||s===null)return;s=s[n]}return s}const y=S.split("."),r=a(l,y);return typeof r=="undefined"?w:r}e.getConfigurationValue=T;function g(l,S,w){Object.keys(S).forEach(a=>{a!=="__proto__"&&(a in l?o.isObject(l[a])&&o.isObject(S[a])?g(l[a],S[a],w):w&&(l[a]=S[a]):l[a]=S[a])})}e.merge=g;function h(l,S,w){const a=l.inspect(S),y=l.inspect(w);return typeof a.userValue!="undefined"||typeof a.workspaceValue!="undefined"||typeof a.workspaceFolderValue!="undefined"?a.value:typeof y.userValue!="undefined"||typeof y.workspaceValue!="undefined"||typeof y.workspaceFolderValue!="undefined"?y.value:a.defaultValue}e.getMigratedSettingValue=h;function u(l){return l.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=u}),define(De[38],Ce([1,0,22,10,3]),function(J,e,o,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const U=new Map;U.set("false",!1),U.set("true",!0),U.set("isMac",o.isMacintosh),U.set("isLinux",o.isLinux),U.set("isWindows",o.isWindows),U.set("isWeb",o.isWeb),U.set("isMacNative",o.isMacintosh&&!o.isWeb),U.set("isEdge",o.isEdge),U.set("isFirefox",o.isFirefox),U.set("isChrome",o.isChrome),U.set("isSafari",o.isSafari);const I=Object.prototype.hasOwnProperty;var P;(function(N){N[N.False=0]="False",N[N.True=1]="True",N[N.Defined=2]="Defined",N[N.Not=3]="Not",N[N.Equals=4]="Equals",N[N.NotEquals=5]="NotEquals",N[N.And=6]="And",N[N.Regex=7]="Regex",N[N.NotRegex=8]="NotRegex",N[N.Or=9]="Or",N[N.In=10]="In",N[N.NotIn=11]="NotIn",N[N.Greater=12]="Greater",N[N.GreaterEquals=13]="GreaterEquals",N[N.Smaller=14]="Smaller",N[N.SmallerEquals=15]="SmallerEquals"})(P=e.ContextKeyExprType||(e.ContextKeyExprType={}));class b{static false(){return _.INSTANCE}static true(){return m.INSTANCE}static has(v){return T.create(v)}static equals(v,F){return g.create(v,F)}static notEquals(v,F){return l.create(v,F)}static regex(v,F){return i.create(v,F)}static in(v,F){return h.create(v,F)}static not(v){return S.create(v)}static and(...v){return t.create(v,null)}static or(...v){return c.create(v,null,!0)}static greater(v,F){return a.create(v,F)}static greaterEquals(v,F){return y.create(v,F)}static smaller(v,F){return r.create(v,F)}static smallerEquals(v,F){return d.create(v,F)}static deserialize(v,F=!1){if(!!v)return this._deserializeOrExpression(v,F)}static _deserializeOrExpression(v,F){const O=v.split("||");return c.create(O.map(H=>this._deserializeAndExpression(H,F)),null,!0)}static _deserializeAndExpression(v,F){const O=v.split("&&");return t.create(O.map(H=>this._deserializeOne(H,F)),null)}static _deserializeOne(v,F){if(v=v.trim(),v.indexOf("!=")>=0){const O=v.split("!=");return l.create(O[0].trim(),this._deserializeValue(O[1],F))}if(v.indexOf("==")>=0){const O=v.split("==");return g.create(O[0].trim(),this._deserializeValue(O[1],F))}if(v.indexOf("=~")>=0){const O=v.split("=~");return i.create(O[0].trim(),this._deserializeRegexValue(O[1],F))}if(v.indexOf(" in ")>=0){const O=v.split(" in ");return h.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(v)){const O=v.split(">=");return y.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(v)){const O=v.split(">");return a.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(v)){const O=v.split("<=");return d.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(v)){const O=v.split("<");return r.create(O[0].trim(),O[1].trim())}return/^\!\s*/.test(v)?S.create(v.substr(1).trim()):T.create(v)}static _deserializeValue(v,F){if(v=v.trim(),v==="true")return!0;if(v==="false")return!1;const O=/^'([^']*)'$/.exec(v);return O?O[1].trim():v}static _deserializeRegexValue(v,F){if((0,C.isFalsyOrWhitespace)(v)){if(F)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}const O=v.indexOf("/"),H=v.lastIndexOf("/");if(O===H||O<0){if(F)throw new Error(`bad regexp-value '${v}', missing /-enclosure`);return console.warn(`bad regexp-value '${v}', missing /-enclosure`),null}const te=v.slice(O+1,H),z=v[H+1]==="i"?"i":"";try{return new RegExp(te,z)}catch($){if(F)throw new Error(`bad regexp-value '${v}', parse error: ${$}`);return console.warn(`bad regexp-value '${v}', parse error: ${$}`),null}}}e.ContextKeyExpr=b;function A(N,v){const F=N?N.substituteConstants():void 0,O=v?v.substituteConstants():void 0;return!F&&!O?!0:!F||!O?!1:F.equals(O)}e.expressionsAreEqualWithConstantSubstitution=A;function R(N,v){return N.cmp(v)}class _{constructor(){this.type=0}cmp(v){return this.type-v.type}equals(v){return v.type===this.type}substituteConstants(){return this}evaluate(v){return!1}serialize(){return"false"}keys(){return[]}map(v){return this}negate(){return m.INSTANCE}}e.ContextKeyFalseExpr=_,_.INSTANCE=new _;class m{constructor(){this.type=1}cmp(v){return this.type-v.type}equals(v){return v.type===this.type}substituteConstants(){return this}evaluate(v){return!0}serialize(){return"true"}keys(){return[]}map(v){return this}negate(){return _.INSTANCE}}e.ContextKeyTrueExpr=m,m.INSTANCE=new m;class T{constructor(v,F){this.key=v,this.negated=F,this.type=2}static create(v,F=null){const O=U.get(v);return typeof O=="boolean"?O?m.INSTANCE:_.INSTANCE:new T(v,F)}cmp(v){return v.type!==this.type?this.type-v.type:f(this.key,v.key)}equals(v){return v.type===this.type?this.key===v.key:!1}substituteConstants(){const v=U.get(this.key);return typeof v=="boolean"?v?m.INSTANCE:_.INSTANCE:this}evaluate(v){return!!v.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(v){return v.mapDefined(this.key)}negate(){return this.negated||(this.negated=S.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=T;class g{constructor(v,F,O){this.key=v,this.value=F,this.negated=O,this.type=4}static create(v,F,O=null){if(typeof F=="boolean")return F?T.create(v,O):S.create(v,O);const H=U.get(v);return typeof H=="boolean"?F===(H?"true":"false")?m.INSTANCE:_.INSTANCE:new g(v,F,O)}cmp(v){return v.type!==this.type?this.type-v.type:D(this.key,this.value,v.key,v.value)}equals(v){return v.type===this.type?this.key===v.key&&this.value===v.value:!1}substituteConstants(){const v=U.get(this.key);if(typeof v=="boolean"){const F=v?"true":"false";return this.value===F?m.INSTANCE:_.INSTANCE}return this}evaluate(v){return v.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(v){return v.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=l.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=g;class h{constructor(v,F){this.key=v,this.valueKey=F,this.type=10,this.negated=null}static create(v,F){return new h(v,F)}cmp(v){return v.type!==this.type?this.type-v.type:D(this.key,this.valueKey,v.key,v.valueKey)}equals(v){return v.type===this.type?this.key===v.key&&this.valueKey===v.valueKey:!1}substituteConstants(){return this}evaluate(v){const F=v.getValue(this.valueKey),O=v.getValue(this.key);return Array.isArray(F)?F.includes(O):typeof O=="string"&&typeof F=="object"&&F!==null?I.call(F,O):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(v){return v.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=u.create(this)),this.negated}}e.ContextKeyInExpr=h;class u{constructor(v){this._actual=v,this.type=11}static create(v){return new u(v)}cmp(v){return v.type!==this.type?this.type-v.type:this._actual.cmp(v._actual)}equals(v){return v.type===this.type?this._actual.equals(v._actual):!1}substituteConstants(){return this}evaluate(v){return!this._actual.evaluate(v)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(v){return new u(this._actual.map(v))}negate(){return this._actual}}e.ContextKeyNotInExpr=u;class l{constructor(v,F,O){this.key=v,this.value=F,this.negated=O,this.type=5}static create(v,F,O=null){if(typeof F=="boolean")return F?S.create(v,O):T.create(v,O);const H=U.get(v);return typeof H=="boolean"?F===(H?"true":"false")?_.INSTANCE:m.INSTANCE:new l(v,F,O)}cmp(v){return v.type!==this.type?this.type-v.type:D(this.key,this.value,v.key,v.value)}equals(v){return v.type===this.type?this.key===v.key&&this.value===v.value:!1}substituteConstants(){const v=U.get(this.key);if(typeof v=="boolean"){const F=v?"true":"false";return this.value===F?_.INSTANCE:m.INSTANCE}return this}evaluate(v){return v.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(v){return v.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=g.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=l;class S{constructor(v,F){this.key=v,this.negated=F,this.type=3}static create(v,F=null){const O=U.get(v);return typeof O=="boolean"?O?_.INSTANCE:m.INSTANCE:new S(v,F)}cmp(v){return v.type!==this.type?this.type-v.type:f(this.key,v.key)}equals(v){return v.type===this.type?this.key===v.key:!1}substituteConstants(){const v=U.get(this.key);return typeof v=="boolean"?v?_.INSTANCE:m.INSTANCE:this}evaluate(v){return!v.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(v){return v.mapNot(this.key)}negate(){return this.negated||(this.negated=T.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=S;function w(N,v){if(typeof N=="string"){const F=parseFloat(N);isNaN(F)||(N=F)}return typeof N=="string"||typeof N=="number"?v(N):_.INSTANCE}class a{constructor(v,F,O){this.key=v,this.value=F,this.negated=O,this.type=12}static create(v,F,O=null){return w(F,H=>new a(v,H,O))}cmp(v){return v.type!==this.type?this.type-v.type:D(this.key,this.value,v.key,v.value)}equals(v){return v.type===this.type?this.key===v.key&&this.value===v.value:!1}substituteConstants(){return this}evaluate(v){return typeof this.value=="string"?!1:parseFloat(v.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(v){return v.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=d.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=a;class y{constructor(v,F,O){this.key=v,this.value=F,this.negated=O,this.type=13}static create(v,F,O=null){return w(F,H=>new y(v,H,O))}cmp(v){return v.type!==this.type?this.type-v.type:D(this.key,this.value,v.key,v.value)}equals(v){return v.type===this.type?this.key===v.key&&this.value===v.value:!1}substituteConstants(){return this}evaluate(v){return typeof this.value=="string"?!1:parseFloat(v.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(v){return v.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=r.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=y;class r{constructor(v,F,O){this.key=v,this.value=F,this.negated=O,this.type=14}static create(v,F,O=null){return w(F,H=>new r(v,H,O))}cmp(v){return v.type!==this.type?this.type-v.type:D(this.key,this.value,v.key,v.value)}equals(v){return v.type===this.type?this.key===v.key&&this.value===v.value:!1}substituteConstants(){return this}evaluate(v){return typeof this.value=="string"?!1:parseFloat(v.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(v){return v.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=y.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=r;class d{constructor(v,F,O){this.key=v,this.value=F,this.negated=O,this.type=15}static create(v,F,O=null){return w(F,H=>new d(v,H,O))}cmp(v){return v.type!==this.type?this.type-v.type:D(this.key,this.value,v.key,v.value)}equals(v){return v.type===this.type?this.key===v.key&&this.value===v.value:!1}substituteConstants(){return this}evaluate(v){return typeof this.value=="string"?!1:parseFloat(v.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(v){return v.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=a.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=d;class i{constructor(v,F){this.key=v,this.regexp=F,this.type=7,this.negated=null}static create(v,F){return new i(v,F)}cmp(v){if(v.type!==this.type)return this.type-v.type;if(this.key<v.key)return-1;if(this.key>v.key)return 1;const F=this.regexp?this.regexp.source:"",O=v.regexp?v.regexp.source:"";return F<O?-1:F>O?1:0}equals(v){if(v.type===this.type){const F=this.regexp?this.regexp.source:"",O=v.regexp?v.regexp.source:"";return this.key===v.key&&F===O}return!1}substituteConstants(){return this}evaluate(v){const F=v.getValue(this.key);return this.regexp?this.regexp.test(F):!1}serialize(){const v=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${v}`}keys(){return[this.key]}map(v){return v.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=s.create(this)),this.negated}}e.ContextKeyRegexExpr=i;class s{constructor(v){this._actual=v,this.type=8}static create(v){return new s(v)}cmp(v){return v.type!==this.type?this.type-v.type:this._actual.cmp(v._actual)}equals(v){return v.type===this.type?this._actual.equals(v._actual):!1}substituteConstants(){return this}evaluate(v){return!this._actual.evaluate(v)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(v){return new s(this._actual.map(v))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=s;function n(N){let v=null;for(let F=0,O=N.length;F<O;F++){const H=N[F].substituteConstants();if(N[F]!==H&&v===null){v=[];for(let te=0;te<F;te++)v[te]=N[te]}v!==null&&(v[F]=H)}return v===null?N:v}class t{constructor(v,F){this.expr=v,this.negated=F,this.type=6}static create(v,F){return t._normalizeArr(v,F)}cmp(v){if(v.type!==this.type)return this.type-v.type;if(this.expr.length<v.expr.length)return-1;if(this.expr.length>v.expr.length)return 1;for(let F=0,O=this.expr.length;F<O;F++){const H=R(this.expr[F],v.expr[F]);if(H!==0)return H}return 0}equals(v){if(v.type===this.type){if(this.expr.length!==v.expr.length)return!1;for(let F=0,O=this.expr.length;F<O;F++)if(!this.expr[F].equals(v.expr[F]))return!1;return!0}return!1}substituteConstants(){const v=n(this.expr);return v===this.expr?this:t.create(v,this.negated)}evaluate(v){for(let F=0,O=this.expr.length;F<O;F++)if(!this.expr[F].evaluate(v))return!1;return!0}static _normalizeArr(v,F){const O=[];let H=!1;for(const te of v)if(!!te){if(te.type===1){H=!0;continue}if(te.type===0)return _.INSTANCE;if(te.type===6){O.push(...te.expr);continue}O.push(te)}if(O.length===0&&H)return m.INSTANCE;if(O.length!==0){if(O.length===1)return O[0];O.sort(R);for(let te=1;te<O.length;te++)O[te-1].equals(O[te])&&(O.splice(te,1),te--);if(O.length===1)return O[0];for(;O.length>1;){const te=O[O.length-1];if(te.type!==9)break;O.pop();const z=O.pop(),$=O.length===0,ce=c.create(te.expr.map(le=>t.create([le,z],null)),null,$);ce&&(O.push(ce),O.sort(R))}return O.length===1?O[0]:new t(O,F)}}serialize(){return this.expr.map(v=>v.serialize()).join(" && ")}keys(){const v=[];for(const F of this.expr)v.push(...F.keys());return v}map(v){return new t(this.expr.map(F=>F.map(v)),null)}negate(){if(!this.negated){const v=[];for(const F of this.expr)v.push(F.negate());this.negated=c.create(v,this,!0)}return this.negated}}class c{constructor(v,F){this.expr=v,this.negated=F,this.type=9}static create(v,F,O){return c._normalizeArr(v,F,O)}cmp(v){if(v.type!==this.type)return this.type-v.type;if(this.expr.length<v.expr.length)return-1;if(this.expr.length>v.expr.length)return 1;for(let F=0,O=this.expr.length;F<O;F++){const H=R(this.expr[F],v.expr[F]);if(H!==0)return H}return 0}equals(v){if(v.type===this.type){if(this.expr.length!==v.expr.length)return!1;for(let F=0,O=this.expr.length;F<O;F++)if(!this.expr[F].equals(v.expr[F]))return!1;return!0}return!1}substituteConstants(){const v=n(this.expr);return v===this.expr?this:c.create(v,this.negated,!1)}evaluate(v){for(let F=0,O=this.expr.length;F<O;F++)if(this.expr[F].evaluate(v))return!0;return!1}static _normalizeArr(v,F,O){let H=[],te=!1;if(v){for(let z=0,$=v.length;z<$;z++){const ce=v[z];if(!!ce){if(ce.type===0){te=!0;continue}if(ce.type===1)return m.INSTANCE;if(ce.type===9){H=H.concat(ce.expr);continue}H.push(ce)}}if(H.length===0&&te)return _.INSTANCE;H.sort(R)}if(H.length!==0){if(H.length===1)return H[0];for(let z=1;z<H.length;z++)H[z-1].equals(H[z])&&(H.splice(z,1),z--);if(H.length===1)return H[0];if(O){for(let z=0;z<H.length;z++)for(let $=z+1;$<H.length;$++)L(H[z],H[$])&&(H.splice($,1),$--);if(H.length===1)return H[0]}return new c(H,F)}}serialize(){return this.expr.map(v=>v.serialize()).join(" || ")}keys(){const v=[];for(const F of this.expr)v.push(...F.keys());return v}map(v){return new c(this.expr.map(F=>F.map(v)),null)}negate(){if(!this.negated){const v=[];for(const F of this.expr)v.push(F.negate());for(;v.length>1;){const F=v.shift(),O=v.shift(),H=[];for(const z of W(F))for(const $ of W(O))H.push(t.create([z,$],null));const te=v.length===0;v.unshift(c.create(H,null,te))}this.negated=v[0]}return this.negated}}class E extends T{constructor(v,F,O){super(v,null);this._defaultValue=F,typeof O=="object"?E._info.push({...O,key:v}):O!==!0&&E._info.push({key:v,description:O,type:F!=null?typeof F:void 0})}static all(){return E._info.values()}bindTo(v){return v.createKey(this.key,this._defaultValue)}getValue(v){return v.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(v){return g.create(this.key,v)}notEqualsTo(v){return l.create(this.key,v)}}e.RawContextKey=E,E._info=[],e.IContextKeyService=(0,p.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function f(N,v){return N<v?-1:N>v?1:0}function D(N,v,F,O){return N<F?-1:N>F?1:v<O?-1:v>O?1:0}function L(N,v){if(v.type===6&&N.type!==9&&N.type!==6){for(const H of v.expr)if(N.equals(H))return!0}const F=N.negate(),O=W(F).concat(W(v));O.sort(R);for(let H=0;H<O.length;H++){const z=O[H].negate();for(let $=H+1;$<O.length;$++){const ce=O[$];if(z.equals(ce))return!0}}return!1}e.implies=L;function W(N){return N.type===9?N.expr:[N]}}),define(De[146],Ce([1,0,3]),function(J,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,o.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,o.refineServiceDecorator)(e.IEnvironmentService)}),define(De[79],Ce([1,0,123,3]),function(J,e,o,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IServerExtensionManagementService=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function p(l){switch(l){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=p;function U(l){switch(l){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=U;function I(l,S){switch(l){case 3:return S==="x64"?"win32-x64":S==="ia32"?"win32-ia32":S==="arm64"?"win32-arm64":"unknown";case 2:return S==="x64"?"linux-x64":S==="arm64"?"linux-arm64":S==="arm"?"linux-armhf":"unknown";case"alpine":return S==="x64"?"alpine-x64":S==="arm64"?"alpine-arm64":"unknown";case 1:return S==="x64"?"darwin-x64":S==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=I;function P(l,S){return S==="web"&&!l.includes("web")}e.isNotWebExtensionInWebTargetPlatform=P;function b(l,S,w){return P(S,w)?!1:l==="undefined"||l==="universal"?!0:l==="unknown"?!1:l===w?!0:A(w).includes(l)}e.isTargetPlatformCompatible=b;function A(l){switch(l){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=A;function R(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(!l.uuid||typeof l.uuid=="string")}e.isIExtensionIdentifier=R;var _;(function(l){l[l.NoneOrRelevance=0]="NoneOrRelevance",l[l.LastUpdatedDate=1]="LastUpdatedDate",l[l.Title=2]="Title",l[l.PublisherName=3]="PublisherName",l[l.InstallCount=4]="InstallCount",l[l.PublishedDate=10]="PublishedDate",l[l.AverageRating=6]="AverageRating",l[l.WeightedRating=12]="WeightedRating"})(_=e.SortBy||(e.SortBy={}));var m;(function(l){l[l.Default=0]="Default",l[l.Ascending=1]="Ascending",l[l.Descending=2]="Descending"})(m=e.SortOrder||(e.SortOrder={}));var T;(function(l){l.Install="install",l.Uninstall="uninstall"})(T=e.StatisticType||(e.StatisticType={}));var g;(function(l){l[l.None=1]="None",l[l.Install=2]="Install",l[l.Update=3]="Update",l[l.Migrate=4]="Migrate"})(g=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,C.createDecorator)("extensionGalleryService");var h;(function(l){l.Unsupported="Unsupported",l.Deprecated="Deprecated",l.Malicious="Malicious",l.Incompatible="Incompatible",l.IncompatiblePreRelease="IncompatiblePreRelease",l.IncompatibleTargetPlatform="IncompatibleTargetPlatform",l.ReleaseVersionNotFound="ReleaseVersionNotFound",l.Invalid="Invalid",l.Download="Download",l.Extract="Extract",l.Delete="Delete",l.Rename="Rename",l.CorruptZip="CorruptZip",l.IncompleteZip="IncompleteZip",l.Internal="Internal"})(h=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class u extends Error{constructor(S,w){super(S);this.code=w,this.name=w}}e.ExtensionManagementError=u,e.IExtensionManagementService=(0,C.createDecorator)("extensionManagementService"),e.IServerExtensionManagementService=(0,C.refineServiceDecorator)(e.IExtensionManagementService),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,C.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,C.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,o.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,o.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,C.createDecorator)("IExtensionManagementCLIService")}),define(De[39],Ce([1,0,24,19,10,9,2,125,3]),function(J,e,o,C,p,U,I,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,b.createDecorator)("fileService");function A(z){return z.create===!0}e.isFileOpenForWriteOptions=A;var R;(function(z){z[z.Unknown=0]="Unknown",z[z.File=1]="File",z[z.Directory=2]="Directory",z[z.SymbolicLink=64]="SymbolicLink"})(R=e.FileType||(e.FileType={}));var _;(function(z){z[z.Readonly=1]="Readonly"})(_=e.FilePermission||(e.FilePermission={}));var m;(function(z){z[z.FileReadWrite=2]="FileReadWrite",z[z.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",z[z.FileReadStream=16]="FileReadStream",z[z.FileFolderCopy=8]="FileFolderCopy",z[z.PathCaseSensitive=1024]="PathCaseSensitive",z[z.Readonly=2048]="Readonly",z[z.Trash=4096]="Trash",z[z.FileWriteUnlock=8192]="FileWriteUnlock",z[z.FileAtomicRead=16384]="FileAtomicRead",z[z.FileClone=32768]="FileClone"})(m=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function T(z){return!!(z.capabilities&2)}e.hasReadWriteCapability=T;function g(z){return!!(z.capabilities&8)}e.hasFileFolderCopyCapability=g;function h(z){return!!(z.capabilities&32768)}e.hasFileCloneCapability=h;function u(z){return!!(z.capabilities&4)}e.hasOpenReadWriteCloseCapability=u;function l(z){return!!(z.capabilities&16)}e.hasFileReadStreamCapability=l;function S(z){return T(z)?!!(z.capabilities&16384):!1}e.hasFileAtomicReadCapability=S;var w;(function(z){z.FileExists="EntryExists",z.FileNotFound="EntryNotFound",z.FileNotADirectory="EntryNotADirectory",z.FileIsADirectory="EntryIsADirectory",z.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",z.FileTooLarge="EntryTooLarge",z.FileWriteLocked="EntryWriteLocked",z.NoPermissions="NoPermissions",z.Unavailable="Unavailable",z.Unknown="Unknown"})(w=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class a extends Error{constructor($,ce){super($);this.code=ce}}e.FileSystemProviderError=a;function y(z,$){const ce=new a(z.toString(),$);return d(ce,$),ce}e.createFileSystemProviderError=y;function r(z){return z||y((0,P.localize)(0,null),w.Unknown)}e.ensureFileSystemProviderError=r;function d(z,$){return z.name=$?`${$} (FileSystemError)`:"FileSystemError",z}e.markAsFileSystemProviderError=d;function i(z){if(!z)return w.Unknown;if(z instanceof a)return z.code;const $=/^(.+) \(FileSystemError\)$/.exec(z.name);if(!$)return w.Unknown;switch($[1]){case w.FileExists:return w.FileExists;case w.FileIsADirectory:return w.FileIsADirectory;case w.FileNotADirectory:return w.FileNotADirectory;case w.FileNotFound:return w.FileNotFound;case w.FileExceedsMemoryLimit:return w.FileExceedsMemoryLimit;case w.FileTooLarge:return w.FileTooLarge;case w.FileWriteLocked:return w.FileWriteLocked;case w.NoPermissions:return w.NoPermissions;case w.Unavailable:return w.Unavailable}return w.Unknown}e.toFileSystemProviderErrorCode=i;function s(z){if(z instanceof D)return z.fileOperationResult;switch(i(z)){case w.FileNotFound:return 1;case w.FileIsADirectory:return 0;case w.FileNotADirectory:return 10;case w.FileWriteLocked:return 5;case w.NoPermissions:return 6;case w.FileExists:return 4;case w.FileExceedsMemoryLimit:return 9;case w.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=s;var n;(function(z){z[z.CREATE=0]="CREATE",z[z.DELETE=1]="DELETE",z[z.MOVE=2]="MOVE",z[z.COPY=3]="COPY",z[z.WRITE=4]="WRITE"})(n=e.FileOperation||(e.FileOperation={}));class t{constructor($,ce,le){this.resource=$,this.operation=ce,this.target=le}isOperation($){return this.operation===$}}e.FileOperationEvent=t;var c;(function(z){z[z.UPDATED=0]="UPDATED",z[z.ADDED=1]="ADDED",z[z.DELETED=2]="DELETED"})(c=e.FileChangeType||(e.FileChangeType={}));class E{constructor($,ce){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=$;const le=new Map;for(const oe of $){const pe=le.get(oe.type);switch(pe?pe.push([oe.resource,oe]):le.set(oe.type,[[oe.resource,oe]]),oe.type){case 1:this.rawAdded.push(oe.resource);break;case 0:this.rawUpdated.push(oe.resource);break;case 2:this.rawDeleted.push(oe.resource);break}}for(const[oe,pe]of le)switch(oe){case 1:this.added=o.TernarySearchTree.forUris(()=>ce),this.added.fill(pe);break;case 0:this.updated=o.TernarySearchTree.forUris(()=>ce),this.updated.fill(pe);break;case 2:this.deleted=o.TernarySearchTree.forUris(()=>ce),this.deleted.fill(pe);break}}contains($,...ce){return this.doContains($,{includeChildren:!1},...ce)}affects($,...ce){return this.doContains($,{includeChildren:!0},...ce)}doContains($,ce,...le){if(!$)return!1;const oe=le.length>0;return!!((!oe||le.includes(1))&&(this.added?.get($)||ce.includeChildren&&this.added?.findSuperstr($))||(!oe||le.includes(0))&&(this.updated?.get($)||ce.includeChildren&&this.updated?.findSuperstr($))||(!oe||le.includes(2))&&(this.deleted?.findSubstr($)||ce.includeChildren&&this.deleted?.findSuperstr($)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=E;function f(z,$,ce){return!z||!$||z===$||$.length>z.length?!1:($.charAt($.length-1)!==C.sep&&($+=C.sep),ce?(0,p.startsWithIgnoreCase)(z,$):z.indexOf($)===0)}e.isParent=f;class D extends Error{constructor($,ce,le){super($);this.fileOperationResult=ce,this.options=le}}e.FileOperationError=D;class L extends D{constructor($,ce,le){super($,2,le);this.stat=ce}}e.NotModifiedSinceFileOperationError=L;var W;(function(z){z[z.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",z[z.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",z[z.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",z[z.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",z[z.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",z[z.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",z[z.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",z[z.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",z[z.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",z[z.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",z[z.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",z[z.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(W=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var N;(function(z){z[z.FILE=0]="FILE",z[z.FOLDER=1]="FOLDER",z[z.ROOT_FOLDER=2]="ROOT_FOLDER"})(N=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function v(z){if(!(typeof z.size!="number"||typeof z.mtime!="number"))return z.mtime.toString(29)+z.size.toString(31)}e.etag=v;async function F(z,$){if(!$.hasProvider(I.URI.from({scheme:z.scheme})))return new Promise(ce=>{const le=$.onDidChangeFileSystemProviderRegistrations(oe=>{oe.scheme===z.scheme&&oe.added&&(le.dispose(),ce())})})}e.whenProviderRegistered=F,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class O{static formatSize($){return(0,U.isNumber)($)||($=0),$<O.KB?(0,P.localize)(1,null,$.toFixed(0)):$<O.MB?(0,P.localize)(2,null,($/O.KB).toFixed(2)):$<O.GB?(0,P.localize)(3,null,($/O.MB).toFixed(2)):$<O.TB?(0,P.localize)(4,null,($/O.GB).toFixed(2)):(0,P.localize)(5,null,($/O.TB).toFixed(2))}}e.ByteSize=O,O.KB=1024,O.MB=O.KB*O.KB,O.GB=O.MB*O.KB,O.TB=O.GB*O.KB;var H;(function(z){z[z.IA32=0]="IA32",z[z.OTHER=1]="OTHER"})(H=e.Arch||(e.Arch={}));function te(z){return{maxFileSize:z===0?300*O.MB:16*O.GB,maxHeapSize:z===0?700*O.MB:2*700*O.MB}}e.getPlatformLimits=te}),define(De[58],Ce([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class o{constructor(...p){this._entries=new Map;for(const[U,I]of p)this.set(U,I)}set(p,U){const I=this._entries.get(p);return this._entries.set(p,U),I}has(p){return this._entries.has(p)}get(p){return this._entries.get(p)}}e.ServiceCollection=o}),define(De[147],Ce([1,0,13,11,78,145,3,58]),function(J,e,o,C,p,U,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const b=!1;class A extends Error{constructor(g){super("cyclic dependency between services");this.message=g.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${g.toString()}`}}class R{constructor(g=new P.ServiceCollection,h=!1,u){this._activeInstantiations=new Set,this._services=g,this._strict=h,this._parent=u,this._services.set(I.IInstantiationService,this)}createChild(g){return new R(g,this._strict,this)}invokeFunction(g,...h){const u=m.traceInvocation(g);let l=!1;try{return g({get:w=>{if(l)throw(0,C.illegalState)("service accessor is only valid during the invocation of its target method");const a=this._getOrCreateServiceInstance(w,u);if(!a)throw new Error(`[invokeFunction] unknown service '${w}'`);return a}},...h)}finally{l=!0,u.stop()}}createInstance(g,...h){let u,l;return g instanceof p.SyncDescriptor?(u=m.traceCreation(g.ctor),l=this._createInstance(g.ctor,g.staticArguments.concat(h),u)):(u=m.traceCreation(g),l=this._createInstance(g,h,u)),u.stop(),l}_createInstance(g,h=[],u){const l=I._util.getServiceDependencies(g).sort((a,y)=>a.index-y.index),S=[];for(const a of l){const y=this._getOrCreateServiceInstance(a.id,u);y||this._throwIfStrict(`[createInstance] ${g.name} depends on UNKNOWN service ${a.id}.`,!1),S.push(y)}const w=l.length>0?l[0].index:h.length;if(h.length!==w){console.trace(`[createInstance] First service dependency of ${g.name} at position ${w+1} conflicts with ${h.length} static arguments`);const a=w-h.length;a>0?h=h.concat(new Array(a)):h=h.slice(0,w)}return new g(...[...h,...S])}_setServiceInstance(g,h){if(this._services.get(g)instanceof p.SyncDescriptor)this._services.set(g,h);else if(this._parent)this._parent._setServiceInstance(g,h);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(g){const h=this._services.get(g);return!h&&this._parent?this._parent._getServiceInstanceOrDescriptor(g):h}_getOrCreateServiceInstance(g,h){const u=this._getServiceInstanceOrDescriptor(g);return u instanceof p.SyncDescriptor?this._safeCreateAndCacheServiceInstance(g,u,h.branch(g,!0)):(h.branch(g,!1),u)}_safeCreateAndCacheServiceInstance(g,h,u){if(this._activeInstantiations.has(g))throw new Error(`illegal state - RECURSIVELY instantiating service '${g}'`);this._activeInstantiations.add(g);try{return this._createAndCacheServiceInstance(g,h,u)}finally{this._activeInstantiations.delete(g)}}_createAndCacheServiceInstance(g,h,u){const l=new U.Graph(a=>a.id.toString());let S=0;const w=[{id:g,desc:h,_trace:u}];for(;w.length;){const a=w.pop();if(l.lookupOrInsertNode(a),S++>1e3)throw new A(l);for(const y of I._util.getServiceDependencies(a.desc.ctor)){const r=this._getServiceInstanceOrDescriptor(y.id);if(r||this._throwIfStrict(`[createInstance] ${g} depends on ${y.id} which is NOT registered.`,!0),r instanceof p.SyncDescriptor){const d={id:y.id,desc:r,_trace:a._trace.branch(y.id,!0)};l.insertEdge(a,d),w.push(d)}}}for(;;){const a=l.roots();if(a.length===0){if(!l.isEmpty())throw new A(l);break}for(const{data:y}of a){if(this._getServiceInstanceOrDescriptor(y.id)instanceof p.SyncDescriptor){const d=this._createServiceInstanceWithOwner(y.id,y.desc.ctor,y.desc.staticArguments,y.desc.supportsDelayedInstantiation,y._trace);this._setServiceInstance(y.id,d)}l.removeNode(y)}}return this._getServiceInstanceOrDescriptor(g)}_createServiceInstanceWithOwner(g,h,u=[],l,S){if(this._services.get(g)instanceof p.SyncDescriptor)return this._createServiceInstance(h,u,l,S);if(this._parent)return this._parent._createServiceInstanceWithOwner(g,h,u,l,S);throw new Error(`illegalState - creating UNKNOWN service instance ${h.name}`)}_createServiceInstance(g,h=[],u,l){if(u){const S=new o.IdleValue(()=>this._createInstance(g,h,l));return new Proxy(Object.create(null),{get(w,a){if(a in w)return w[a];const y=S.value;let r=y[a];return typeof r!="function"||(r=r.bind(y),w[a]=r),r},set(w,a,y){return S.value[a]=y,!0}})}else return this._createInstance(g,h,l)}_throwIfStrict(g,h){if(h&&console.warn(h),this._strict)throw new Error(g)}}e.InstantiationService=R;var _;(function(T){T[T.Creation=0]="Creation",T[T.Invocation=1]="Invocation",T[T.Branch=2]="Branch"})(_||(_={}));class m{constructor(g,h){this.type=g,this.name=h,this._start=Date.now(),this._dep=[]}static traceInvocation(g){return b?new m(1,g.name||g.toString().substring(0,42).replace(/\n/g,"")):m._None}static traceCreation(g){return b?new m(0,g.name):m._None}branch(g,h){const u=new m(2,g.toString());return this._dep.push([g,h,u]),u}stop(){const g=Date.now()-this._start;m._totals+=g;let h=!1;function u(S,w){const a=[],y=new Array(S+1).join("	");for(const[r,d,i]of w._dep)if(d&&i){h=!0,a.push(`${y}CREATES -> ${r}`);const s=u(S+1,i);s&&a.push(s)}else a.push(`${y}uses -> ${r}`);return a.join(`
`)}const l=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${u(1,this)}`,`DONE, took ${g.toFixed(2)}ms (grand total ${m._totals.toFixed(2)}ms)`];(g>2||h)&&console.log(l.join(`
`))}}e.Trace=m,m._None=new class extends m{constructor(){super(-1,null)}stop(){}branch(){return this}},m._totals=0}),define(De[14],Ce([1,0,44,4,7,22,3]),function(J,e,o,C,p,U,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,I.createDecorator)("logService"),e.ILoggerService=(0,I.createDecorator)("loggerService");function P(){return new Date().toISOString()}var b;(function(d){d[d.Trace=0]="Trace",d[d.Debug=1]="Debug",d[d.Info=2]="Info",d[d.Warning=3]="Warning",d[d.Error=4]="Error",d[d.Critical=5]="Critical",d[d.Off=6]="Off"})(b=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=b.Info;function A(d,i,s){switch(i){case b.Trace:d.trace(s);break;case b.Debug:d.debug(s);break;case b.Info:d.info(s);break;case b.Warning:d.warn(s);break;case b.Error:d.error(s);break;case b.Critical:d.critical(s);break;default:throw new Error("Invalid log level")}}e.log=A;function R(d){let i="";for(let s=0;s<d.length;s++){let n=d[s];if(typeof n=="object")try{n=JSON.stringify(n)}catch{}i+=(s>0?" ":"")+n}return i}e.format=R;class _ extends p.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new C.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(i){this.level!==i&&(this.level=i,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=_;class m extends _{constructor(i){super();this.logAlways=i}checkLogLevel(i){return this.logAlways||this.getLevel()<=i}trace(i,...s){this.checkLogLevel(b.Trace)&&this.log(b.Trace,R([i,...s]))}debug(i,...s){this.checkLogLevel(b.Debug)&&this.log(b.Debug,R([i,...s]))}info(i,...s){this.checkLogLevel(b.Info)&&this.log(b.Info,R([i,...s]))}warn(i,...s){this.checkLogLevel(b.Warning)&&this.log(b.Warning,R([i,...s]))}error(i,...s){if(this.checkLogLevel(b.Error))if(i instanceof Error){const n=Array.prototype.slice.call(arguments);n[0]=i.stack,this.log(b.Error,R(n))}else this.log(b.Error,R([i,...s]))}critical(i,...s){this.checkLogLevel(b.Critical)&&this.log(b.Critical,R([i,...s]))}flush(){}}e.AbstractMessageLogger=m;class T extends _{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i),this.useColors=!U.isWindows}trace(i,...s){this.getLevel()<=b.Trace&&(this.useColors?console.log(`[90m[main ${P()}][0m`,i,...s):console.log(`[main ${P()}]`,i,...s))}debug(i,...s){this.getLevel()<=b.Debug&&(this.useColors?console.log(`[90m[main ${P()}][0m`,i,...s):console.log(`[main ${P()}]`,i,...s))}info(i,...s){this.getLevel()<=b.Info&&(this.useColors?console.log(`[90m[main ${P()}][0m`,i,...s):console.log(`[main ${P()}]`,i,...s))}warn(i,...s){this.getLevel()<=b.Warning&&(this.useColors?console.warn(`[93m[main ${P()}][0m`,i,...s):console.warn(`[main ${P()}]`,i,...s))}error(i,...s){this.getLevel()<=b.Error&&(this.useColors?console.error(`[91m[main ${P()}][0m`,i,...s):console.error(`[main ${P()}]`,i,...s))}critical(i,...s){this.getLevel()<=b.Critical&&(this.useColors?console.error(`[90m[main ${P()}][0m`,i,...s):console.error(`[main ${P()}]`,i,...s))}dispose(){}flush(){}}e.ConsoleMainLogger=T;class g extends _{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i)}trace(i,...s){this.getLevel()<=b.Trace&&console.log("%cTRACE","color: #888",i,...s)}debug(i,...s){this.getLevel()<=b.Debug&&console.log("%cDEBUG","background: #eee; color: #888",i,...s)}info(i,...s){this.getLevel()<=b.Info&&console.log("%c INFO","color: #33f",i,...s)}warn(i,...s){this.getLevel()<=b.Warning&&console.log("%c WARN","color: #993",i,...s)}error(i,...s){this.getLevel()<=b.Error&&console.log("%c  ERR","color: #f33",i,...s)}critical(i,...s){this.getLevel()<=b.Critical&&console.log("%cCRITI","background: #f33; color: white",i,...s)}dispose(){}flush(){}}e.ConsoleLogger=g;class h extends _{constructor(i,s=e.DEFAULT_LOG_LEVEL){super();this.adapter=i,this.setLevel(s)}trace(i,...s){this.getLevel()<=b.Trace&&this.adapter.log(b.Trace,[this.extractMessage(i),...s])}debug(i,...s){this.getLevel()<=b.Debug&&this.adapter.log(b.Debug,[this.extractMessage(i),...s])}info(i,...s){this.getLevel()<=b.Info&&this.adapter.log(b.Info,[this.extractMessage(i),...s])}warn(i,...s){this.getLevel()<=b.Warning&&this.adapter.log(b.Warning,[this.extractMessage(i),...s])}error(i,...s){this.getLevel()<=b.Error&&this.adapter.log(b.Error,[this.extractMessage(i),...s])}critical(i,...s){this.getLevel()<=b.Critical&&this.adapter.log(b.Critical,[this.extractMessage(i),...s])}extractMessage(i){return typeof i=="string"?i:(0,o.toErrorMessage)(i,this.getLevel()<=b.Trace)}dispose(){}flush(){}}e.AdapterLogger=h;class u extends _{constructor(i){super();this.logServices=i,i.length&&this.setLevel(i[0].getLevel())}setLevel(i){for(const s of this.logServices)s.setLevel(i);super.setLevel(i)}trace(i,...s){for(const n of this.logServices)n.trace(i,...s)}debug(i,...s){for(const n of this.logServices)n.debug(i,...s)}info(i,...s){for(const n of this.logServices)n.info(i,...s)}warn(i,...s){for(const n of this.logServices)n.warn(i,...s)}error(i,...s){for(const n of this.logServices)n.error(i,...s)}critical(i,...s){for(const n of this.logServices)n.critical(i,...s)}flush(){for(const i of this.logServices)i.flush()}dispose(){for(const i of this.logServices)i.dispose()}}e.MultiplexLogService=u;class l extends p.Disposable{constructor(i){super();this.logger=i,this._register(i)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(i){this.logger.setLevel(i)}getLevel(){return this.logger.getLevel()}trace(i,...s){this.logger.trace(i,...s)}debug(i,...s){this.logger.debug(i,...s)}info(i,...s){this.logger.info(i,...s)}warn(i,...s){this.logger.warn(i,...s)}error(i,...s){this.logger.error(i,...s)}critical(i,...s){this.logger.critical(i,...s)}flush(){this.logger.flush()}}e.LogService=l;class S extends p.Disposable{constructor(i,s){super();this.logLevel=i,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(s(n=>{this.logLevel=n,this.logLevelChangeableLoggers.forEach(t=>t.setLevel(n))}))}getLogger(i){return this.loggers.get(i.toString())}createLogger(i,s){let n=this.loggers.get(i.toString());return n||(n=this.doCreateLogger(i,s?.always?b.Trace:this.logLevel,s),this.loggers.set(i.toString(),n),s?.always||this.logLevelChangeableLoggers.push(n)),n}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(i=>i.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=S;class w{constructor(){this.onDidChangeLogLevel=new C.Emitter().event}setLevel(i){}getLevel(){return b.Info}trace(i,...s){}debug(i,...s){}info(i,...s){}warn(i,...s){}error(i,...s){}critical(i,...s){}dispose(){}flush(){}}e.NullLogService=w;function a(d){if(d.verbose)return b.Trace;if(typeof d.logLevel=="string"){const i=y(d.logLevel.toLowerCase());if(i!==void 0)return i}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=a;function y(d){switch(d){case"trace":return b.Trace;case"debug":return b.Debug;case"info":return b.Info;case"warn":return b.Warning;case"error":return b.Error;case"critical":return b.Critical;case"off":return b.Off}}e.parseLogLevel=y;function r(d){switch(d){case b.Trace:return"trace";case b.Debug:return"debug";case b.Info:return"info";case b.Warning:return"warn";case b.Error:return"error";case b.Critical:return"critical";case b.Off:return"off"}}e.LogLevelToString=r}),define(De[80],Ce([1,0,29,126,3]),function(J,e,o,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var U;(function(b){b[b.Unnecessary=1]="Unnecessary",b[b.Deprecated=2]="Deprecated"})(U=e.MarkerTag||(e.MarkerTag={}));var I;(function(b){b[b.Hint=1]="Hint",b[b.Info=2]="Info",b[b.Warning=4]="Warning",b[b.Error=8]="Error"})(I=e.MarkerSeverity||(e.MarkerSeverity={})),function(b){function A(g,h){return h-g}b.compare=A;const R=Object.create(null);R[b.Error]=(0,C.localize)(0,null),R[b.Warning]=(0,C.localize)(1,null),R[b.Info]=(0,C.localize)(2,null);function _(g){return R[g]||""}b.toString=_;function m(g){switch(g){case o.default.Error:return b.Error;case o.default.Warning:return b.Warning;case o.default.Info:return b.Info;case o.default.Ignore:return b.Hint}}b.fromSeverity=m;function T(g){switch(g){case b.Error:return o.default.Error;case b.Warning:return o.default.Warning;case b.Info:return o.default.Info;case b.Hint:return o.default.Ignore}}b.toSeverity=T}(I=e.MarkerSeverity||(e.MarkerSeverity={}));var P;(function(b){const A="";function R(m){return _(m,!0)}b.makeKey=R;function _(m,T){const g=[A];return m.source?g.push(m.source.replace("\xA6","\\\xA6")):g.push(A),m.code?typeof m.code=="string"?g.push(m.code.replace("\xA6","\\\xA6")):g.push(m.code.value.replace("\xA6","\\\xA6")):g.push(A),m.severity!==void 0&&m.severity!==null?g.push(I.toString(m.severity)):g.push(A),m.message&&T?g.push(m.message.replace("\xA6","\\\xA6")):g.push(A),m.startLineNumber!==void 0&&m.startLineNumber!==null?g.push(m.startLineNumber.toString()):g.push(A),m.startColumn!==void 0&&m.startColumn!==null?g.push(m.startColumn.toString()):g.push(A),m.endLineNumber!==void 0&&m.endLineNumber!==null?g.push(m.endLineNumber.toString()):g.push(A),m.endColumn!==void 0&&m.endColumn!==null?g.push(m.endColumn.toString()):g.push(A),g.push(A),g.join("\xA6")}b.makeKeyOptionalMessage=_})(P=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,p.createDecorator)("markerService")}),define(De[148],Ce([1,0,4,29,3]),function(J,e,o,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=C.default,e.INotificationService=(0,p.createDecorator)("notificationService");var U;(function(A){A[A.WORKSPACE=0]="WORKSPACE",A[A.PROFILE=1]="PROFILE",A[A.APPLICATION=2]="APPLICATION"})(U=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var I;(function(A){A[A.OFF=0]="OFF",A[A.SILENT=1]="SILENT",A[A.ERROR=2]="ERROR"})(I=e.NotificationsFilter||(e.NotificationsFilter={}));class P{constructor(){this.progress=new b,this.onDidClose=o.Event.None,this.onDidChangeVisibility=o.Event.None}updateSeverity(R){}updateMessage(R){}updateActions(R){}close(){}}e.NoOpNotification=P;class b{infinite(){}done(){}total(R){}worked(R){}}e.NoOpProgress=b}),define(De[81],Ce([1,0,7,10,2,3]),function(J,e,o,C,p,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,U.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return o.Disposable.None},registerValidator(){return o.Disposable.None},registerExternalUriResolver(){return o.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return o.Disposable.None},async open(){return!1},async resolveExternalUri(R){return{resolved:R,dispose(){}}}});function I(R,_){return p.URI.isUri(R)?(0,C.equalsIgnoreCase)(R.scheme,_):(0,C.startsWithIgnoreCase)(R,_+":")}e.matchesScheme=I;function P(R,..._){return _.some(m=>I(R,m))}e.matchesSomeScheme=P;function b(R,_){return R.with({fragment:`${_.startLineNumber},${_.startColumn}${_.endLineNumber?`-${_.endLineNumber}${_.endColumn?`,${_.endColumn}`:""}`:""}`})}e.withSelection=b;function A(R){let _;const m=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(R.fragment);return m&&(_={startLineNumber:parseInt(m[1]),startColumn:m[2]?parseInt(m[2]):1,endLineNumber:m[4]?parseInt(m[4]):void 0,endColumn:m[4]?m[5]?parseInt(m[5]):1:void 0},R=R.with({fragment:""})),{selection:_,uri:R}}e.extractSelection=A}),define(De[149],Ce([1,0,3]),function(J,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,o.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var $e=this&&this.__decorate||function(J,e,o,C){var p=arguments.length,U=p<3?e:C===null?C=Object.getOwnPropertyDescriptor(e,o):C,I;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")U=Reflect.decorate(J,e,o,C);else for(var P=J.length-1;P>=0;P--)(I=J[P])&&(U=(p<3?I(U):p>3?I(e,o,U):I(e,o))||U);return p>3&&U&&Object.defineProperty(e,o,U),U},xe=this&&this.__param||function(J,e){return function(o,C){e(o,C,J)}};define(De[150],Ce([1,0,13,20,7,3]),function(J,e,o,C,p,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,U.createDecorator)("progressService");var I;(function(R){R[R.Explorer=1]="Explorer",R[R.Scm=3]="Scm",R[R.Extensions=5]="Extensions",R[R.Window=10]="Window",R[R.Notification=15]="Notification",R[R.Dialog=20]="Dialog"})(I=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class P{constructor(_){this.callback=_}get value(){return this._value}report(_){this._value=_,this.callback(this._value)}}e.Progress=P,P.None=Object.freeze({report(){}});let b=class extends p.Disposable{constructor(_,m){super();this.deferred=new o.DeferredPromise,m.withProgress(_,T=>(this.reporter=T,this.lastStep&&T.report(this.lastStep),this.deferred.p)),this._register((0,p.toDisposable)(()=>this.deferred.complete()))}report(_){this.reporter?this.reporter.report(_):this.lastStep=_}};b=$e([xe(1,e.IProgressService)],b),e.UnmanagedProgress=b;class A extends p.Disposable{constructor(_){super();this.progressIndicator=_,this.currentOperationId=0,this.currentOperationDisposables=this._register(new p.DisposableStore)}start(_){this.stop();const m=++this.currentOperationId,T=new C.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{m===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},_),this.currentOperationDisposables.add((0,p.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,p.toDisposable)(()=>T.cancel())),this.currentOperationDisposables.add((0,p.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:m,token:T.token,stop:()=>this.doStop(m),isCurrent:()=>this.currentOperationId===m}}stop(){this.doStop(this.currentOperationId)}doStop(_){this.currentOperationId===_&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=A,e.IEditorProgressService=(0,U.createDecorator)("editorProgressService")}),define(De[30],Ce([1,0,42,9]),function(J,e,o,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class p{constructor(){this.data=new Map}add(I,P){o.ok(C.isString(I)),o.ok(C.isObject(P)),o.ok(!this.data.has(I),"There is already an extension with this id"),this.data.set(I,P)}knows(I){return this.data.has(I)}as(I){return this.data.get(I)||null}}e.Registry=new p}),define(De[82],Ce([1,0,4,30]),function(J,e,o,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function p(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class U{constructor(){this._onDidChangeSchema=new o.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(b,A){this.schemasById[p(b)]=A,this._onDidChangeSchema.fire(b)}notifySchemaChanged(b){this._onDidChangeSchema.fire(b)}getSchemaContributions(){return{schemas:this.schemasById}}}const I=new U;C.Registry.add(e.Extensions.JSONContribution,I)}),define(De[83],Ce([1,0,16,4,9,122,57,82,30]),function(J,e,o,C,p,U,I,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var A;(function(y){y.Multiline="multilineText",y.Singleline="singlelineText"})(A=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var R;(function(y){y[y.APPLICATION=1]="APPLICATION",y[y.MACHINE=2]="MACHINE",y[y.WINDOW=3]="WINDOW",y[y.RESOURCE=4]="RESOURCE",y[y.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",y[y.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(R=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const _=b.Registry.as(P.Extensions.JSONContribution);class m{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new C.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new C.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:U.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},_.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(r,d=!0){this.registerConfigurations([r],d)}registerConfigurations(r,d=!0){const i=this.doRegisterConfigurations(r,d);_.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:i})}deregisterConfigurations(r){const d=this.doDeregisterConfigurations(r);_.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:d})}updateConfigurations({add:r,remove:d}){const i=[];i.push(...this.doDeregisterConfigurations(d)),i.push(...this.doRegisterConfigurations(r,!1)),_.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,o.distinct)(i)})}registerDefaultConfigurations(r){const d=[],i=[];for(const{overrides:s,source:n}of r)for(const t in s)if(d.push(t),e.OVERRIDE_PROPERTY_REGEX.test(t)){const c=this.configurationDefaultsOverrides.get(t),E=c?.valuesSources??new Map;if(n)for(const W of Object.keys(s[t]))E.set(W,n);const f={...c?.value||{},...s[t]};this.configurationDefaultsOverrides.set(t,{source:n,value:f,valuesSources:E});const D=(0,I.getLanguageTagSettingPlainKey)(t),L={type:"object",default:f,description:U.localize(1,null,D),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:f,source:p.isString(n)?void 0:n,defaultValueSource:n};i.push(...h(t)),this.configurationProperties[t]=L,this.defaultLanguageConfigurationOverridesNode.properties[t]=L}else{this.configurationDefaultsOverrides.set(t,{value:s[t],source:n});const c=this.configurationProperties[t];c&&(this.updatePropertyDefaultValue(t,c),this.updateSchema(t,c))}this.registerOverrideIdentifiers(i),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:d,defaultsOverrides:!0})}deregisterDefaultConfigurations(r){const d=[];for(const{overrides:i,source:s}of r)for(const n in i){const t=this.configurationDefaultsOverrides.get(n),c=p.isString(s)?s:s?.id,E=p.isString(t?.source)?t?.source:t?.source?.id;if(c===E)if(d.push(n),this.configurationDefaultsOverrides.delete(n),e.OVERRIDE_PROPERTY_REGEX.test(n))delete this.configurationProperties[n],delete this.defaultLanguageConfigurationOverridesNode.properties[n];else{const f=this.configurationProperties[n];f&&(this.updatePropertyDefaultValue(n,f),this.updateSchema(n,f))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:d,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...r){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(r){for(const d of r)this.overrideIdentifiers.add(d);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(r,d){const i=[];return r.forEach(s=>{i.push(...this.validateAndRegisterProperties(s,d,s.extensionInfo,s.restrictedProperties)),this.configurationContributors.push(s),this.registerJSONConfiguration(s)}),i}doDeregisterConfigurations(r){const d=[],i=s=>{if(s.properties)for(const n in s.properties){d.push(n);const t=this.configurationProperties[n];t?.policy?.name&&this.policyConfigurations.delete(t.policy.name),delete this.configurationProperties[n],this.removeFromSchema(n,s.properties[n])}s.allOf?.forEach(n=>i(n))};for(const s of r){i(s);const n=this.configurationContributors.indexOf(s);n!==-1&&this.configurationContributors.splice(n,1)}return d}validateAndRegisterProperties(r,d=!0,i,s,n=3){n=p.isUndefinedOrNull(r.scope)?n:r.scope;const t=[],c=r.properties;if(c)for(const f in c){const D=c[f];if(d&&w(f,D)){delete c[f];continue}if(D.source=i,D.defaultDefaultValue=c[f].default,this.updatePropertyDefaultValue(f,D),e.OVERRIDE_PROPERTY_REGEX.test(f)?D.scope=void 0:(D.scope=p.isUndefinedOrNull(D.scope)?n:D.scope,D.restricted=p.isUndefinedOrNull(D.restricted)?!!s?.includes(f):D.restricted),c[f].hasOwnProperty("included")&&!c[f].included){this.excludedConfigurationProperties[f]=c[f],delete c[f];continue}else this.configurationProperties[f]=c[f],c[f].policy?.name&&this.policyConfigurations.set(c[f].policy.name,f);!c[f].deprecationMessage&&c[f].markdownDeprecationMessage&&(c[f].deprecationMessage=c[f].markdownDeprecationMessage),t.push(f)}const E=r.allOf;if(E)for(const f of E)t.push(...this.validateAndRegisterProperties(f,d,i,s,n));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(r){const d=i=>{const s=i.properties;if(s)for(const t in s)this.updateSchema(t,s[t]);i.allOf?.forEach(d)};d(r)}updateSchema(r,d){switch(e.allSettings.properties[r]=d,d.scope){case 1:e.applicationSettings.properties[r]=d;break;case 2:e.machineSettings.properties[r]=d;break;case 6:e.machineOverridableSettings.properties[r]=d;break;case 3:e.windowSettings.properties[r]=d;break;case 4:e.resourceSettings.properties[r]=d;break;case 5:e.resourceSettings.properties[r]=d,this.resourceLanguageSettingsSchema.properties[r]=d;break}}removeFromSchema(r,d){switch(delete e.allSettings.properties[r],d.scope){case 1:delete e.applicationSettings.properties[r];break;case 2:delete e.machineSettings.properties[r];break;case 6:delete e.machineOverridableSettings.properties[r];break;case 3:delete e.windowSettings.properties[r];break;case 4:case 5:delete e.resourceSettings.properties[r],delete this.resourceLanguageSettingsSchema.properties[r];break}}updateOverridePropertyPatternKey(){for(const r of this.overrideIdentifiers.values()){const d=`[${r}]`,i={type:"object",description:U.localize(2,null),errorMessage:U.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(d,i),e.allSettings.properties[d]=i,e.applicationSettings.properties[d]=i,e.machineSettings.properties[d]=i,e.machineOverridableSettings.properties[d]=i,e.windowSettings.properties[d]=i,e.resourceSettings.properties[d]=i}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const r={type:"object",description:U.localize(4,null),errorMessage:U.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(r,d){const i=this.configurationDefaultsOverrides.get(r);let s=i?.value,n=i?.source;p.isUndefined(s)&&(s=d.defaultDefaultValue,n=void 0),p.isUndefined(s)&&(s=l(d.type)),d.default=s,d.defaultValueSource=n}}const T="\\[([^\\]]+)\\]",g=new RegExp(T,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${T})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function h(y){const r=[];if(e.OVERRIDE_PROPERTY_REGEX.test(y)){let d=g.exec(y);for(;d?.length;){const i=d[1].trim();i&&r.push(i),d=g.exec(y)}}return(0,o.distinct)(r)}e.overrideIdentifiersFromKey=h;function u(y){return y.reduce((r,d)=>`${r}[${d}]`,"")}e.keyFromOverrideIdentifiers=u;function l(y){switch(Array.isArray(y)?y[0]:y){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=l;const S=new m;b.Registry.add(e.Extensions.Configuration,S);function w(y,r){return y.trim()?e.OVERRIDE_PROPERTY_REGEX.test(y)?U.localize(7,null,y):S.getConfigurationProperties()[y]!==void 0?U.localize(8,null,y):r.policy?.name&&S.getPolicyConfigurations().get(r.policy?.name)!==void 0?U.localize(9,null,y,r.policy?.name,S.getPolicyConfigurations().get(r.policy?.name)):null:U.localize(6,null)}e.validateProperty=w;function a(){const y=[],r=S.getConfigurationProperties();for(const d of Object.keys(r))y.push([d,r[d].scope]);return y.push(["launch",4]),y.push(["task",4]),y}e.getScopes=a}),define(De[151],Ce([1,0,16,4,104,7,24,26,9,2,57,83,30]),function(J,e,o,C,p,U,I,P,b,A,R,_,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class T{constructor(d={},i=[],s=[]){this._contents=d,this._keys=i,this._overrides=s,this.frozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}isFrozen(){return this.frozen}getValue(d){return d?(0,R.getConfigurationValue)(this.contents,d):this.contents}getOverrideValue(d,i){const s=this.getContentsForOverrideIdentifer(i);return s?d?(0,R.getConfigurationValue)(s,d):s:void 0}getKeysForOverrideIdentifier(d){const i=[];for(const s of this.overrides)s.identifiers.includes(d)&&i.push(...s.keys);return o.distinct(i)}getAllOverrideIdentifiers(){const d=[];for(const i of this.overrides)d.push(...i.identifiers);return o.distinct(d)}override(d){let i=this.overrideConfigurations.get(d);return i||(i=this.createOverrideConfigurationModel(d),this.overrideConfigurations.set(d,i)),i}merge(...d){const i=P.deepClone(this.contents),s=P.deepClone(this.overrides),n=[...this.keys];for(const t of d)if(!t.isEmpty()){this.mergeContents(i,t.contents);for(const c of t.overrides){const[E]=s.filter(f=>o.equals(f.identifiers,c.identifiers));E?(this.mergeContents(E.contents,c.contents),E.keys.push(...c.keys),E.keys=o.distinct(E.keys)):s.push(P.deepClone(c))}for(const c of t.keys)n.indexOf(c)===-1&&n.push(c)}return new T(i,n,s)}freeze(){return this.frozen=!0,this}clone(){return new T(P.deepClone(this.contents),[...this.keys],P.deepClone(this.overrides))}createOverrideConfigurationModel(d){const i=this.getContentsForOverrideIdentifer(d);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const s={};for(const n of o.distinct([...Object.keys(this.contents),...Object.keys(i)])){let t=this.contents[n];const c=i[n];c&&(typeof t=="object"&&typeof c=="object"?(t=P.deepClone(t),this.mergeContents(t,c)):t=c),s[n]=t}return new T(s,this.keys,this.overrides)}mergeContents(d,i){for(const s of Object.keys(i)){if(s in d&&b.isObject(d[s])&&b.isObject(i[s])){this.mergeContents(d[s],i[s]);continue}d[s]=P.deepClone(i[s])}}checkAndFreeze(d){return this.frozen&&!Object.isFrozen(d)?P.deepFreeze(d):d}getContentsForOverrideIdentifer(d){let i=null,s=null;const n=t=>{t&&(s?this.mergeContents(s,t):s=P.deepClone(t))};for(const t of this.overrides)o.equals(t.identifiers,[d])?i=t.contents:t.identifiers.includes(d)&&n(t.contents);return n(i),s}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(d,i){this.addKey(d),(0,R.addToValueTree)(this.contents,d,i,s=>{throw new Error(s)})}removeValue(d){this.removeKey(d)&&(0,R.removeFromValueTree)(this.contents,d)}addKey(d){let i=this.keys.length;for(let s=0;s<i;s++)d.indexOf(this.keys[s])===0&&(i=s);this.keys.splice(i,1,d)}removeKey(d){const i=this.keys.indexOf(d);return i!==-1?(this.keys.splice(i,1),!0):!1}}e.ConfigurationModel=T;class g{constructor(d){this._name=d,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new T}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(d,i){if(!b.isUndefinedOrNull(d)){const s=this.doParseContent(d);this.parseRaw(s,i)}}reparse(d){this._raw&&this.parseRaw(this._raw,d)}parseRaw(d,i){this._raw=d;const{contents:s,keys:n,overrides:t,restricted:c}=this.doParseRaw(d,i);this._configurationModel=new T(s,n,t),this._restrictedConfigurations=c||[]}doParseContent(d){let i={},s=null,n=[];const t=[],c=[];function E(D){Array.isArray(n)?n.push(D):s!==null&&(n[s]=D)}const f={onObjectBegin:()=>{const D={};E(D),t.push(n),n=D,s=null},onObjectProperty:D=>{s=D},onObjectEnd:()=>{n=t.pop()},onArrayBegin:()=>{const D=[];E(D),t.push(n),n=D,s=null},onArrayEnd:()=>{n=t.pop()},onLiteralValue:E,onError:(D,L,W)=>{c.push({error:D,offset:L,length:W})}};if(d)try{p.visit(d,f),i=n[0]||{}}catch(D){console.error(`Error while parsing settings file ${this._name}: ${D}`),this._parseErrors=[D]}return i}doParseRaw(d,i){const s=m.Registry.as(_.Extensions.Configuration).getConfigurationProperties(),n=this.filter(d,s,!0,i);d=n.raw;const t=(0,R.toValuesTree)(d,f=>console.error(`Conflict in settings file ${this._name}: ${f}`)),c=Object.keys(d),E=this.toOverrides(d,f=>console.error(`Conflict in settings file ${this._name}: ${f}`));return{contents:t,keys:c,overrides:E,restricted:n.restricted}}filter(d,i,s,n){if(!n?.scopes&&!n?.skipRestricted)return{raw:d,restricted:[]};const t={},c=[];for(const E in d)if(_.OVERRIDE_PROPERTY_REGEX.test(E)&&s){const f=this.filter(d[E],i,!1,n);t[E]=f.raw,c.push(...f.restricted)}else{const f=i[E],D=f?typeof f.scope!="undefined"?f.scope:3:void 0;f?.restricted&&c.push(E),(D===void 0||n.scopes===void 0||n.scopes.includes(D))&&(n.skipRestricted&&f?.restricted||(t[E]=d[E]))}return{raw:t,restricted:c}}toOverrides(d,i){const s=[];for(const n of Object.keys(d))if(_.OVERRIDE_PROPERTY_REGEX.test(n)){const t={};for(const c in d[n])t[c]=d[n][c];s.push({identifiers:(0,_.overrideIdentifiersFromKey)(n),keys:Object.keys(t),contents:(0,R.toValuesTree)(t,i)})}return s}}e.ConfigurationModelParser=g;class h extends U.Disposable{constructor(d,i,s,n){super();this.userSettingsResource=d,this.scopes=i,this.fileService=n,this._onDidChange=this._register(new C.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new g(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(C.Event.any(C.Event.filter(this.fileService.onDidFilesChange,t=>t.contains(this.userSettingsResource)),C.Event.filter(this.fileService.onDidRunOperation,t=>(t.isOperation(0)||t.isOperation(3)||t.isOperation(1)||t.isOperation(4))&&s.isEqual(t.resource,d)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const d=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(d.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new T}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=h;class u{constructor(d,i,s,n,t=new T,c=new T,E=new I.ResourceMap,f=new T,D=new I.ResourceMap,L=!0){this._defaultConfiguration=d,this._policyConfiguration=i,this._applicationConfiguration=s,this._localUserConfiguration=n,this._remoteUserConfiguration=t,this._workspaceConfiguration=c,this._folderConfigurations=E,this._memoryConfiguration=f,this._memoryConfigurationByResource=D,this._freeze=L,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new I.ResourceMap,this._userConfiguration=null}getValue(d,i,s){return this.getConsolidatedConfigurationModel(d,i,s).getValue(d)}updateValue(d,i,s={}){let n;s.resource?(n=this._memoryConfigurationByResource.get(s.resource),n||(n=new T,this._memoryConfigurationByResource.set(s.resource,n))):n=this._memoryConfiguration,i===void 0?n.removeValue(d):n.setValue(d,i),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(d,i,s){const n=this.getConsolidatedConfigurationModel(d,i,s),t=this.getFolderConfigurationModelForResource(i.resource,s),c=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,E=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(d):this._defaultConfiguration.freeze().getValue(d),f=this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration.freeze().getValue(d),D=this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze().getValue(d),L=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(d):this.userConfiguration.freeze().getValue(d),W=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(d):this.localUserConfiguration.freeze().getValue(d),N=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(d):this.remoteUserConfiguration.freeze().getValue(d),v=s?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(d):this._workspaceConfiguration.freeze().getValue(d):void 0,F=t?i.overrideIdentifier?t.freeze().override(i.overrideIdentifier).getValue(d):t.freeze().getValue(d):void 0,O=i.overrideIdentifier?c.override(i.overrideIdentifier).getValue(d):c.getValue(d),H=n.getValue(d),te=o.distinct(n.overrides.map(z=>z.identifiers).flat()).filter(z=>n.getOverrideValue(d,z)!==void 0);return{defaultValue:E,policyValue:f,applicationValue:D,userValue:L,userLocalValue:W,userRemoteValue:N,workspaceValue:v,workspaceFolderValue:F,memoryValue:O,value:H,default:E!==void 0?{value:this._defaultConfiguration.freeze().getValue(d),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(d,i.overrideIdentifier):void 0}:void 0,policy:f!==void 0?{value:f}:void 0,application:D!==void 0?{value:D,override:i.overrideIdentifier?this.applicationConfiguration.freeze().getOverrideValue(d,i.overrideIdentifier):void 0}:void 0,user:L!==void 0?{value:this.userConfiguration.freeze().getValue(d),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(d,i.overrideIdentifier):void 0}:void 0,userLocal:W!==void 0?{value:this.localUserConfiguration.freeze().getValue(d),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(d,i.overrideIdentifier):void 0}:void 0,userRemote:N!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(d),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(d,i.overrideIdentifier):void 0}:void 0,workspace:v!==void 0?{value:this._workspaceConfiguration.freeze().getValue(d),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(d,i.overrideIdentifier):void 0}:void 0,workspaceFolder:F!==void 0?{value:t?.freeze().getValue(d),override:i.overrideIdentifier?t?.freeze().getOverrideValue(d,i.overrideIdentifier):void 0}:void 0,memory:O!==void 0?{value:c.getValue(d),override:i.overrideIdentifier?c.getOverrideValue(d,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:te.length?te:void 0}}keys(d){const i=this.getFolderConfigurationModelForResource(void 0,d);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(d){this._defaultConfiguration=d,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(d){this._policyConfiguration=d}updateApplicationConfiguration(d){this._applicationConfiguration=d,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(d){this._localUserConfiguration=d,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(d){this._remoteUserConfiguration=d,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(d){this._workspaceConfiguration=d,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(d,i){this._folderConfigurations.set(d,i),this._foldersConsolidatedConfigurations.delete(d)}deleteFolderConfiguration(d){this.folderConfigurations.delete(d),this._foldersConsolidatedConfigurations.delete(d)}compareAndUpdateDefaultConfiguration(d,i){const s=[];if(!i){const{added:n,updated:t,removed:c}=a(this._defaultConfiguration,d);i=[...n,...t,...c]}for(const n of i)for(const t of(0,_.overrideIdentifiersFromKey)(n)){const c=this._defaultConfiguration.getKeysForOverrideIdentifier(t),E=d.getKeysForOverrideIdentifier(t),f=[...E.filter(D=>c.indexOf(D)===-1),...c.filter(D=>E.indexOf(D)===-1),...c.filter(D=>!P.equals(this._defaultConfiguration.override(t).getValue(D),d.override(t).getValue(D)))];s.push([t,f])}return this.updateDefaultConfiguration(d),{keys:i,overrides:s}}compareAndUpdatePolicyConfiguration(d){const{added:i,updated:s,removed:n}=a(this._policyConfiguration,d),t=[...i,...s,...n];return t.length&&this.updatePolicyConfiguration(d),{keys:t,overrides:[]}}compareAndUpdateApplicationConfiguration(d){const{added:i,updated:s,removed:n,overrides:t}=a(this.applicationConfiguration,d),c=[...i,...s,...n];return c.length&&this.updateApplicationConfiguration(d),{keys:c,overrides:t}}compareAndUpdateLocalUserConfiguration(d){const{added:i,updated:s,removed:n,overrides:t}=a(this.localUserConfiguration,d),c=[...i,...s,...n];return c.length&&this.updateLocalUserConfiguration(d),{keys:c,overrides:t}}compareAndUpdateRemoteUserConfiguration(d){const{added:i,updated:s,removed:n,overrides:t}=a(this.remoteUserConfiguration,d),c=[...i,...s,...n];return c.length&&this.updateRemoteUserConfiguration(d),{keys:c,overrides:t}}compareAndUpdateWorkspaceConfiguration(d){const{added:i,updated:s,removed:n,overrides:t}=a(this.workspaceConfiguration,d),c=[...i,...s,...n];return c.length&&this.updateWorkspaceConfiguration(d),{keys:c,overrides:t}}compareAndUpdateFolderConfiguration(d,i){const s=this.folderConfigurations.get(d),{added:n,updated:t,removed:c,overrides:E}=a(s,i),f=[...n,...t,...c];return(f.length||!s)&&this.updateFolderConfiguration(d,i),{keys:f,overrides:E}}compareAndDeleteFolderConfiguration(d){const i=this.folderConfigurations.get(d);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(d);const{added:s,updated:n,removed:t,overrides:c}=a(i,void 0);return{keys:[...s,...n,...t],overrides:c}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(d,i,s){let n=this.getConsolidatedConfigurationModelForResource(i,s);return i.overrideIdentifier&&(n=n.override(i.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(d)!==void 0&&(n=n.merge(this._policyConfiguration)),n}getConsolidatedConfigurationModelForResource({resource:d},i){let s=this.getWorkspaceConsolidatedConfiguration();if(i&&d){const n=i.getFolder(d);n&&(s=this.getFolderConsolidatedConfiguration(n.uri)||s);const t=this._memoryConfigurationByResource.get(d);t&&(s=s.merge(t))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(d){let i=this._foldersConsolidatedConfigurations.get(d);if(!i){const s=this.getWorkspaceConsolidatedConfiguration(),n=this._folderConfigurations.get(d);n?(i=s.merge(n),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(d,i)):i=s}return i}getFolderConfigurationModelForResource(d,i){if(i&&d){const s=i.getFolder(d);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((d,i)=>{const{contents:s,overrides:n,keys:t}=this._folderConfigurations.get(i);return d.push([i,{contents:s,overrides:n,keys:t}]),d},[])}}allKeys(){const d=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>d.add(i)),this.userConfiguration.freeze().keys.forEach(i=>d.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>d.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(s=>d.add(s))),[...d.values()]}allOverrideIdentifiers(){const d=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>d.add(i)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>d.add(i)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>d.add(i)),this._folderConfigurations.forEach(i=>i.freeze().getAllOverrideIdentifiers().forEach(s=>d.add(s))),[...d.values()]}getAllKeysForOverrideIdentifier(d){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(d).forEach(s=>i.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(d).forEach(s=>i.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(d).forEach(s=>i.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(d).forEach(n=>i.add(n))),[...i.values()]}static parse(d){const i=this.parseConfigurationModel(d.defaults),s=this.parseConfigurationModel(d.policy),n=this.parseConfigurationModel(d.application),t=this.parseConfigurationModel(d.user),c=this.parseConfigurationModel(d.workspace),E=d.folders.reduce((f,D)=>(f.set(A.URI.revive(D[0]),this.parseConfigurationModel(D[1])),f),new I.ResourceMap);return new u(i,s,n,t,new T,c,E,new T,new I.ResourceMap,!1)}static parseConfigurationModel(d){return new T(d.contents,d.keys,d.overrides).freeze()}}e.Configuration=u;function l(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const d=new Set,i=new Map;for(const n of r)n.keys.forEach(t=>d.add(t)),n.overrides.forEach(([t,c])=>{const E=(0,I.getOrSet)(i,t,new Set);c.forEach(f=>E.add(f))});const s=[];return i.forEach((n,t)=>s.push([t,[...n.values()]])),{keys:[...d.values()],overrides:s}}e.mergeChanges=l;class S{constructor(d,i,s,n){this.change=d,this.previous=i,this.currentConfiguraiton=s,this.currentWorkspace=n,this._previousConfiguration=void 0;const t=new Set;d.keys.forEach(E=>t.add(E)),d.overrides.forEach(([,E])=>E.forEach(f=>t.add(f))),this.affectedKeys=[...t.values()];const c=new T;this.affectedKeys.forEach(E=>c.setValue(E,{})),this.affectedKeysTree=c.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=u.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(d,i){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,d)){if(i){const s=this.previousConfiguration?this.previousConfiguration.getValue(d,i,this.previous?.workspace):void 0,n=this.currentConfiguraiton.getValue(d,i,this.currentWorkspace);return!P.equals(s,n)}return!0}return!1}doesAffectedKeysTreeContains(d,i){let s=(0,R.toValuesTree)({[i]:!0},()=>{}),n;for(;typeof s=="object"&&(n=Object.keys(s)[0]);){if(d=d[n],!d)return!1;s=s[n]}return!0}}e.ConfigurationChangeEvent=S;class w extends S{constructor(d,i,s,n){super({keys:d.allKeys(),overrides:[]},void 0,d,i);this.source=s,this.sourceConfig=n}}e.AllKeysConfigurationChangeEvent=w;function a(r,d){const{added:i,removed:s,updated:n}=y(d,r),t=[],c=r?.getAllOverrideIdentifiers()||[],E=d?.getAllOverrideIdentifiers()||[];if(d){const f=E.filter(D=>!c.includes(D));for(const D of f)t.push([D,d.getKeysForOverrideIdentifier(D)])}if(r){const f=c.filter(D=>!E.includes(D));for(const D of f)t.push([D,r.getKeysForOverrideIdentifier(D)])}if(d&&r){for(const f of c)if(E.includes(f)){const D=y({contents:r.getOverrideValue(void 0,f)||{},keys:r.getKeysForOverrideIdentifier(f)},{contents:d.getOverrideValue(void 0,f)||{},keys:d.getKeysForOverrideIdentifier(f)});t.push([f,[...D.added,...D.removed,...D.updated]])}}return{added:i,removed:s,updated:n,overrides:t}}function y(r,d){const i=r?d?r.keys.filter(t=>d.keys.indexOf(t)===-1):[...r.keys]:[],s=d?r?d.keys.filter(t=>r.keys.indexOf(t)===-1):[...d.keys]:[],n=[];if(r&&d){for(const t of d.keys)if(r.keys.indexOf(t)!==-1){const c=(0,R.getConfigurationValue)(d.contents,t),E=(0,R.getConfigurationValue)(r.contents,t);P.equals(c,E)||n.push(t)}}return{added:i,removed:s,updated:n}}}),define(De[84],Ce([1,0,11,3]),function(J,e,o,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,C.createDecorator)("remoteAuthorityResolverService");var p;(function(I){I.Unknown="Unknown",I.NotAvailable="NotAvailable",I.TemporarilyNotAvailable="TemporarilyNotAvailable",I.NoResolverFound="NoResolverFound"})(p=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class U extends o.ErrorNoTelemetry{constructor(P,b=p.Unknown,A){super(P);this._message=P,this._code=b,this._detail=A,this.isHandled=b===p.NotAvailable&&A===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,U.prototype)}static isTemporarilyNotAvailable(P){return P instanceof U&&P._code===p.TemporarilyNotAvailable}static isNoResolverFound(P){return P instanceof U&&P._code===p.NoResolverFound}static isHandled(P){return P instanceof U&&P.isHandled}}e.RemoteAuthorityResolverError=U}),define(De[85],Ce([1,0,12]),function(J,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function C(A){return A.scheme===o.Schemas.vscodeRemote?A.authority:void 0}e.getRemoteAuthority=C;function p(A){if(!A)return;const R=A.indexOf("+");return R<0?A:A.substr(0,R)}e.getRemoteName=p;function U(A){return`/${A.quality??"oss"}-${A.commit??"dev"}`}e.getRemoteServerRootPath=U;function I(A){const{host:R,port:_}=b(A);if(typeof _=="undefined")throw new Error("Remote authority doesn't contain a port!");return{host:R,port:_}}e.parseAuthorityWithPort=I;function P(A,R){let{host:_,port:m}=b(A);return typeof m=="undefined"&&(m=R),{host:_,port:m}}e.parseAuthorityWithOptionalPort=P;function b(A){const R=A.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(R)return{host:R[1],port:parseInt(R[2],10)};const _=A.match(/^(\[[0-9a-z:]+\])$/);if(_)return{host:_[1],port:void 0};const m=A.match(/(.*):(\d+)$/);return m?{host:m[1],port:parseInt(m[2],10)}:{host:A,port:void 0}}}),define(De[27],Ce([1,0,10,3,85]),function(J,e,o,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function U(g){if(typeof g=="object"&&g!==null&&g.supported!==!0)return g.description}e.getWorkspaceSupportTypeMessage=U;function I(g){return g&&typeof g=="object"&&typeof g.id=="string"&&(!g.uuid||typeof g.uuid=="string")}e.isIExtensionIdentifier=I,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var P;(function(g){g[g.System=0]="System",g[g.User=1]="User"})(P=e.ExtensionType||(e.ExtensionType={}));var b;(function(g){g.WIN32_X64="win32-x64",g.WIN32_IA32="win32-ia32",g.WIN32_ARM64="win32-arm64",g.LINUX_X64="linux-x64",g.LINUX_ARM64="linux-arm64",g.LINUX_ARMHF="linux-armhf",g.ALPINE_X64="alpine-x64",g.ALPINE_ARM64="alpine-arm64",g.DARWIN_X64="darwin-x64",g.DARWIN_ARM64="darwin-arm64",g.WEB="web",g.UNIVERSAL="universal",g.UNKNOWN="unknown",g.UNDEFINED="undefined"})(b=e.TargetPlatform||(e.TargetPlatform={}));class A{constructor(h){this.value=h,this._lower=h.toLowerCase()}static equals(h,u){if(typeof h=="undefined"||h===null)return typeof u=="undefined"||u===null;if(typeof u=="undefined"||u===null)return!1;if(typeof h=="string"||typeof u=="string"){const l=typeof h=="string"?h:h.value,S=typeof u=="string"?u:u.value;return o.equalsIgnoreCase(l,S)}return h._lower===u._lower}static toKey(h){return typeof h=="string"?h.toLowerCase():h._lower}}e.ExtensionIdentifier=A;function R(g){return _(g)}e.isApplicationScopedExtension=R;function _(g){return g.contributes&&g.contributes.localizations?g.contributes.localizations.length>0:!1}e.isLanguagePackExtension=_;function m(g){return g.contributes&&g.contributes.authentication?g.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=m;function T(g,h){if(h){const u=`onResolveRemoteAuthority:${(0,p.getRemoteName)(h)}`;return g.activationEvents?.indexOf(u)!==-1}return!1}e.isResolverExtension=T,e.IBuiltinExtensionsScannerService=(0,C.createDecorator)("IBuiltinExtensionsScannerService")}),define(De[152],Ce([1,0,10,79,27,22,2,11,59]),function(J,e,o,C,p,U,I,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function A(i,s){return i.uuid&&s.uuid?i.uuid===s.uuid:i.id===s.id?!0:(0,o.compareIgnoreCase)(i.id,s.id)===0}e.areSameExtensions=A;const R=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class _{constructor(s,n,t="undefined"){this.version=n,this.targetPlatform=t,this.id=s.id}static create(s){const n=s.manifest?s.manifest.version:s.version,t=s.manifest?s.targetPlatform:s.properties.targetPlatform;return new _(s.identifier,n,t)}static parse(s){const n=R.exec(s);return n&&n[1]&&n[2]?new _({id:n[1]},n[2],n[4]||void 0):null}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(s){return s instanceof _?A(this,s)&&this.version===s.version&&this.targetPlatform===s.targetPlatform:!1}}e.ExtensionKey=_;const m=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function T(i){const s=m.exec(i);return s&&s[1]?[h(s[1]),s[2]]:[h(i),void 0]}e.getIdAndVersion=T;function g(i,s){return`${i}.${s}`}e.getExtensionId=g;function h(i){return i.toLocaleLowerCase()}e.adoptToGalleryExtensionId=h;function u(i,s){return h(g(i,s))}e.getGalleryExtensionId=u;function l(i,s){const n=[],t=c=>{for(const E of n)if(E.some(f=>A(s(f),s(c))))return E;return null};for(const c of i){const E=t(c);E?E.push(c):n.push([c])}return n}e.groupByExtension=l;function S(i){return{id:i.identifier.id,name:i.manifest.name,galleryId:null,publisherId:i.publisherId,publisherName:i.manifest.publisher,publisherDisplayName:i.publisherDisplayName,dependencies:i.manifest.extensionDependencies&&i.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=S;function w(i){return{id:i.identifier.id,name:i.name,galleryId:i.identifier.uuid,publisherId:i.publisherId,publisherName:i.publisher,publisherDisplayName:i.publisherDisplayName,isPreReleaseVersion:i.properties.isPreReleaseVersion,dependencies:!!(i.properties.dependencies&&i.properties.dependencies.length>0),...i.telemetryData}}e.getGalleryExtensionTelemetryData=w,e.BetterMergeId=new p.ExtensionIdentifier("pprice.better-merge");function a(i){const s=new Set;if(i.malicious)for(const n of i.malicious)s.add(n.id);return s}e.getMaliciousExtensionsSet=a;function y(i,s){const n=[],t=s.manifest.extensionDependencies?.slice(0)??[];for(;t.length;){const c=t.shift();if(c&&n.every(E=>!A(E.identifier,{id:c}))){const E=i.filter(f=>A(f.identifier,{id:c}));E.length===1&&(n.push(E[0]),t.push(...E[0].manifest.extensionDependencies?.slice(0)??[]))}}return n}e.getExtensionDependencies=y;async function r(i,s){if(!U.isLinux)return!1;let n;try{n=(await i.readFile(I.URI.file("/etc/os-release"))).value.toString()}catch{try{n=(await i.readFile(I.URI.file("/usr/lib/os-release"))).value.toString()}catch(c){s.debug("Error while getting the os-release file.",(0,P.getErrorMessage)(c))}}return!!n&&(n.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=r;async function d(i,s){const n=await r(i,s),t=(0,C.getTargetPlatform)(n?"alpine":U.platform,b.arch);return s.debug("ComputeTargetPlatform:",t),t}e.computeTargetPlatform=d}),define(De[153],Ce([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class o{constructor(p){this._callback=p,this._terminalBufferMap=new Map}dispose(){for(const p of this._terminalBufferMap.values())p.dispose()}startBuffering(p,U,I=5){const P=U(b=>{const A=typeof b=="string"?b:b.data;let R=this._terminalBufferMap.get(p);if(R){R.data.push(A);return}const _=setTimeout(()=>this.flushBuffer(p),I);R={data:[A],timeoutId:_,dispose:()=>{clearTimeout(_),this.flushBuffer(p),P.dispose()}},this._terminalBufferMap.set(p,R)});return P}stopBuffering(p){const U=this._terminalBufferMap.get(p);U&&U.dispose()}flushBuffer(p){const U=this._terminalBufferMap.get(p);U&&(this._terminalBufferMap.delete(p),this._callback(p,U.data.join("")))}}e.TerminalDataBufferer=o}),define(De[154],Ce([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var o;(function(U){U.DARK="dark",U.LIGHT="light",U.HIGH_CONTRAST_DARK="hcDark",U.HIGH_CONTRAST_LIGHT="hcLight"})(o=e.ColorScheme||(e.ColorScheme={}));function C(U){return U===o.HIGH_CONTRAST_DARK||U===o.HIGH_CONTRAST_LIGHT}e.isHighContrast=C;function p(U){return U===o.DARK||U===o.HIGH_CONTRAST_DARK}e.isDark=p}),define(De[60],Ce([1,0,115,4,7,3,30,154]),function(J,e,o,C,p,U,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,U.createDecorator)("themeService");var b;(function(u){function l(S){return S&&typeof S=="object"&&typeof S.id=="string"}u.isThemeColor=l})(b=e.ThemeColor||(e.ThemeColor={}));function A(u){return{id:u}}e.themeColorFromId=A;var R;(function(u){function l(s){return s&&typeof s=="object"&&typeof s.id=="string"&&(typeof s.color=="undefined"||b.isThemeColor(s.color))}u.isThemeIcon=l;const S=new RegExp(`^\\$\\((${o.CSSIcon.iconNameExpression}(?:${o.CSSIcon.iconModifierExpression})?)\\)$`);function w(s){const n=S.exec(s);if(!n)return;const[,t]=n;return{id:t}}u.fromString=w;function a(s){return{id:s}}u.fromId=a;function y(s,n){let t=s.id;const c=t.lastIndexOf("~");return c!==-1&&(t=t.substring(0,c)),n&&(t=`${t}~${n}`),{id:t}}u.modify=y;function r(s){const n=s.id.lastIndexOf("~");if(n!==-1)return s.id.substring(n+1)}u.getModifier=r;function d(s,n){return s.id===n.id&&s.color?.id===n.color?.id}u.isEqual=d;function i(s,n){return{id:s.id,color:n?A(n):void 0}}u.asThemeIcon=i,u.asClassNameArray=o.CSSIcon.asClassNameArray,u.asClassName=o.CSSIcon.asClassName,u.asCSSSelector=o.CSSIcon.asCSSSelector})(R=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=o.Codicon.file,e.FolderThemeIcon=o.Codicon.folder;function _(u){switch(u){case P.ColorScheme.DARK:return"vs-dark";case P.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case P.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=_,e.Extensions={ThemingContribution:"base.contributions.theming"};class m{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new C.Emitter}onColorThemeChange(l){return this.themingParticipants.push(l),this.onThemingParticipantAddedEmitter.fire(l),(0,p.toDisposable)(()=>{const S=this.themingParticipants.indexOf(l);this.themingParticipants.splice(S,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}const T=new m;I.Registry.add(e.Extensions.ThemingContribution,T);function g(u){return T.onColorThemeChange(u)}e.registerThemingParticipant=g;class h extends p.Disposable{constructor(l){super();this.themeService=l,this.theme=l.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(S=>this.onThemeChange(S)))}onThemeChange(l){this.theme=l,this.updateStyles()}updateStyles(){}getColor(l,S){let w=this.theme.getColor(l);return w&&S&&(w=S(w,this.theme)),w?w.toString():null}}e.Themable=h}),define(De[155],Ce([1,0,4,22,3,14]),function(J,e,o,C,p,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,p.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,p.createDecorator)("sharedTunnelsService");var I;(function(h){h.Http="http",h.Https="https"})(I=e.TunnelProtocol||(e.TunnelProtocol={}));var P;(function(h){h.ConstantPrivate="constantPrivate",h.Private="private",h.Public="public"})(P=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var b;(function(h){h[h.Notify=1]="Notify",h[h.OpenBrowser=2]="OpenBrowser",h[h.OpenPreview=3]="OpenPreview",h[h.Silent=4]="Silent",h[h.Ignore=5]="Ignore",h[h.OpenBrowserOnce=6]="OpenBrowserOnce"})(b=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function A(h){if(h.scheme!=="http"&&h.scheme!=="https")return;const u=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(h.authority);if(!!u)return{address:u[1],port:+u[2]}}e.extractLocalHostUriMetaDataForPortMapping=A,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function R(h){return e.LOCALHOST_ADDRESSES.indexOf(h)>=0}e.isLocalhost=R,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function _(h){return e.ALL_INTERFACES_ADDRESSES.indexOf(h)>=0}e.isAllInterfaces=_;function m(h,u){return u?u!==1&&h<1024:!C.isWindows&&h<1024}e.isPortPrivileged=m;class T{constructor(u,l,S){this.remoteAddress=u,this.localAddress=l,this._dispose=S,this._onDispose=new o.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=T;let g=class{constructor(u){this.logService=u,this._onTunnelOpened=new o.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new o.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new o.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(u){return this._tunnelProvider=u,u?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(u){this._canElevate=u.elevation,this._privacyOptions=u.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const u=[],l=Array.from(this._tunnels.values());for(const S of l){const w=Array.from(S.values());for(const a of w){const y=await a.value;y&&u.push(y)}}return u}async dispose(){for(const u of this._tunnels.values()){for(const{value:l}of u.values())await l.then(S=>S?.dispose());u.clear()}this._tunnels.clear()}openTunnel(u,l,S,w,a=!1,y,r){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${l}:${S} on local port ${w}.`),!u)return;if(l||(l="localhost"),this._tunnelProvider&&this._factoryInProgress.has(S)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const d=this.retainOrCreateTunnel(u,l,S,w,a,y,r);return d?d.then(i=>{if(!i){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(l,S);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const s=this.makeTunnel(i);return(i.tunnelRemoteHost!==l||i.tunnelRemotePort!==S)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(s),s}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),d)}makeTunnel(u){return{tunnelRemotePort:u.tunnelRemotePort,tunnelRemoteHost:u.tunnelRemoteHost,tunnelLocalPort:u.tunnelLocalPort,localAddress:u.localAddress,privacy:u.privacy,protocol:u.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${u.tunnelRemoteHost}:${u.tunnelRemotePort} `);const l=this._tunnels.get(u.tunnelRemoteHost);if(l){const S=l.get(u.tunnelRemotePort);S&&(S.refcount--,await this.tryDisposeTunnel(u.tunnelRemoteHost,u.tunnelRemotePort,S))}}}}async tryDisposeTunnel(u,l,S){if(S.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${u}:${l}.`);const w=S.value.then(async a=>{a&&(await a.dispose(!0),this._onTunnelClosed.fire({host:a.tunnelRemoteHost,port:a.tunnelRemotePort}))});return this._tunnels.has(u)&&this._tunnels.get(u).delete(l),w}}async closeTunnel(u,l){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${u}:${l} `);const S=this._tunnels.get(u);if(S&&S.has(l)){const w=S.get(l);w.refcount=0,await this.tryDisposeTunnel(u,l,w)}}addTunnelToMap(u,l,S){this._tunnels.has(u)||this._tunnels.set(u,new Map),this._tunnels.get(u).set(l,{refcount:1,value:S})}async removeEmptyTunnelFromMap(u,l){const S=this._tunnels.get(u);S&&(await S.get(l)||S.delete(l),S.size===0&&this._tunnels.delete(u))}getTunnelFromMap(u,l){const S=[u];R(u)?(S.push(...e.LOCALHOST_ADDRESSES),S.push(...e.ALL_INTERFACES_ADDRESSES)):_(u)&&S.push(...e.ALL_INTERFACES_ADDRESSES);const w=S.map(a=>this._tunnels.get(a));for(const a of w){const y=a?.get(l);if(y)return y}}canTunnel(u){return!!A(u)}createWithProvider(u,l,S,w,a,y,r){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${l}:${S} on local port ${w}.`);const d=S;this._factoryInProgress.add(d);const s={elevationRequired:a?m(w===void 0?S:w):!1},n={remoteAddress:{host:l,port:S},localAddressPort:w,privacy:y,public:y?y!==P.Private:void 0,protocol:r},t=u.forwardPort(n,s);return t?(this.addTunnelToMap(l,S,t),t.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(d)})):this._factoryInProgress.delete(d),t}};g=$e([xe(0,U.ILogService)],g),e.AbstractTunnelService=g}),define(De[156],Ce([1,0,12]),function(J,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function C(b){return b.scheme!==o.Schemas.file&&b.scheme!==o.Schemas.vscodeRemote}e.isVirtualResource=C;function p(b){if(b.folders.length)return b.folders.every(A=>C(A.uri))?b.folders[0].uri:void 0;if(b.configuration&&C(b.configuration))return b.configuration}e.getVirtualWorkspaceLocation=p;function U(b){return p(b)?.scheme}e.getVirtualWorkspaceScheme=U;function I(b){return p(b)?.authority}e.getVirtualWorkspaceAuthority=I;function P(b){return p(b)!==void 0}e.isVirtualWorkspace=P}),define(De[45],Ce([1,0,127,19,24,21,2,3,12]),function(J,e,o,C,p,U,I,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,P.createDecorator)("contextService");function A(i){const s=i;return typeof s?.id=="string"&&I.URI.isUri(s.uri)}e.isSingleFolderWorkspaceIdentifier=A;function R(i){if(i.configuration)return{id:i.id,configPath:i.configuration};if(i.folders.length===1)return{id:i.id,uri:i.folders[0].uri}}e.toWorkspaceIdentifier=R;function _(i){const s=i;return typeof s?.id=="string"&&I.URI.isUri(s.configPath)}e.isWorkspaceIdentifier=_;function m(i){const s=i;if(s?.uri)return{id:s.id,uri:I.URI.revive(s.uri)};const n=i;if(n?.configPath)return{id:n.id,configPath:I.URI.revive(n.configPath)};if(i?.id)return{id:i.id}}e.reviveIdentifier=m;var T;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(T=e.WorkbenchState||(e.WorkbenchState={}));function g(i){const s=i;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&Array.isArray(s.folders))}e.isWorkspace=g;function h(i){const s=i;return!!(s&&typeof s=="object"&&I.URI.isUri(s.uri)&&typeof s.name=="string"&&typeof s.toResource=="function")}e.isWorkspaceFolder=h;class u{constructor(s,n,t,c,E){this._id=s,this._transient=t,this._configuration=c,this._ignorePathCasing=E,this._foldersMap=p.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=n}update(s){this._id=s.id,this._configuration=s.configuration,this._transient=s.transient,this._ignorePathCasing=s._ignorePathCasing,this.folders=s.folders}get folders(){return this._folders}set folders(s){this._folders=s,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(s){this._configuration=s}getFolder(s){return s&&this._foldersMap.findSubstr(s)||null}updateFoldersMap(){this._foldersMap=p.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const s of this.folders)this._foldersMap.set(s.uri,s)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=u;class l{constructor(s,n){this.raw=n,this.uri=s.uri,this.index=s.index,this.name=s.name}toResource(s){return(0,U.joinPath)(this.uri,s)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=l;function S(i){return new l({uri:i,index:0,name:(0,U.basenameOrAuthority)(i)},{uri:i.toString()})}e.toWorkspaceFolder=S,e.WORKSPACE_EXTENSION="code-workspace";const w=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,o.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function a(i,s){return U.extUriBiasedIgnorePathCase.isEqualOrParent(i,s.untitledWorkspacesHome)}e.isUntitledWorkspace=a;function y(i){let s;return I.URI.isUri(i)?s=i:s=i.configuration,s?.scheme===b.Schemas.tmp}e.isTemporaryWorkspace=y;function r(i,s){return!a(i,s)&&!y(i)}e.isSavedWorkspace=r;function d(i){return(typeof i=="string"?(0,C.extname)(i):(0,U.extname)(i))===w}e.hasWorkspaceFileExtension=d}),define(De[61],Ce([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class o{constructor(p){this.id=p,this._data=new Map,this._idPool=1}add(p){const U=this._idPool++;return this._data.set(U,p),this.logDebugInfo(),U}get(p,U){return this._data.has(p)?this._data.get(p)[U]:void 0}delete(p){this._data.delete(p),this.logDebugInfo()}logDebugInfo(){!o.enableDebugLogging||console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=o,o.enableDebugLogging=!1}),define(De[35],Ce([1,0,12,21,3]),function(J,e,o,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class U{constructor(){this._systemSchemes=new Set(Object.keys(o.Schemas)),this._providerInfo=new Map,this.extUri=new C.ExtUri(P=>{const b=this._providerInfo.get(P.scheme);return!(b===void 0||b&1024)})}$acceptProviderInfos(P,b){b===null?this._providerInfo.delete(P.scheme):this._providerInfo.set(P.scheme,b)}isFreeScheme(P){return!this._providerInfo.has(P)&&!this._systemSchemes.has(P)}getCapabilities(P){return this._providerInfo.get(P)}}e.ExtHostFileSystemInfo=U,e.IExtHostFileSystemInfo=(0,p.createDecorator)("IExtHostFileSystemInfo")}),define(De[28],Ce([1,0,3]),function(J,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,o.createDecorator)("IExtHostInitDataService")}),define(De[157],Ce([1,0,13]),function(J,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class C{constructor(I,P,b){this._deferredPromises=new Map,this._id=I,this._shared=P,this._storage=b,this._init=this._storage.initializeExtensionStorage(this._shared,this._id,Object.create(null)).then(A=>(this._value=A,this)),this._storageListener=this._storage.onDidChangeStorage(A=>{A.shared===this._shared&&A.key===this._id&&(this._value=A.value)}),this._scheduler=new o.RunOnceScheduler(()=>{const A=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const R of A.values())R.complete()}catch(R){for(const _ of A.values())_.error(R)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,I])=>I!==void 0).map(([I])=>I)}get whenReady(){return this._init}get(I,P){let b=this._value[I];return typeof b=="undefined"&&(b=P),b}update(I,P){this._value[I]=P;const b=this._deferredPromises.get(I);if(b!==void 0)return b.p;const A=new o.DeferredPromise;return this._deferredPromises.set(I,A),this._scheduler.isScheduled()||this._scheduler.schedule(),A.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=C;class p extends C{constructor(I,P){super(I.identifier.value,!0,P);this._extension=I}setKeysForSync(I){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},I)}}e.ExtensionGlobalMemento=p}),define(De[158],Ce([1,0,4,2]),function(J,e,o,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class p{constructor(I){this._notebooksAndEditors=I,this._onDidSaveNotebookDocument=new o.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeNotebookDocument=new o.Emitter,this.onDidChangeNotebookDocument=this._onDidChangeNotebookDocument.event}$acceptModelChanged(I,P,b,A){const _=this._notebooksAndEditors.getNotebookDocument(C.URI.revive(I)).acceptModelChanged(P.value,b,A);this._onDidChangeNotebookDocument.fire(_)}$acceptDirtyStateChanged(I,P){this._notebooksAndEditors.getNotebookDocument(C.URI.revive(I)).acceptDirty(P)}$acceptModelSaved(I){const P=this._notebooksAndEditors.getNotebookDocument(C.URI.revive(I));this._onDidSaveNotebookDocument.fire(P.apiNotebook)}}e.ExtHostNotebookDocuments=p}),define(De[15],Ce([1,0,3]),function(J,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,o.createDecorator)("IExtHostRpcService");class C{constructor(U){this.getProxy=U.getProxy.bind(U),this.set=U.set.bind(U),this.dispose=U.dispose.bind(U),this.assertRegistered=U.assertRegistered.bind(U),this.drain=U.drain.bind(U)}}e.ExtHostRpcService=C});var Ye=this&&this.__classPrivateFieldSet||function(J,e,o,C,p){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!p)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!p:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?p.call(J,o):p?p.value=o:e.set(J,o),o},Ae=this&&this.__classPrivateFieldGet||function(J,e,o,C){if(o==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!C:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?C:o==="a"?C.call(J):C?C.value:e.get(J)};define(De[159],Ce([1,0,27,4]),function(J,e,o,C){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class U{constructor(P,b){p.set(this,void 0),this._onDidChange=new C.Emitter,this.onDidChange=this._onDidChange.event,this._id=o.ExtensionIdentifier.toKey(P.identifier),Ye(this,p,b,"f"),Ae(this,p,"f").onDidChangePassword(A=>{A.extensionId===this._id&&this._onDidChange.fire({key:A.key})})}get(P){return Ae(this,p,"f").get(this._id,P)}store(P,b){return Ae(this,p,"f").store(this._id,P,b)}delete(P){return Ae(this,p,"f").delete(this._id,P)}}e.ExtensionSecrets=U,p=new WeakMap}),define(De[86],Ce([1,0,3,4]),function(J,e,o,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class p{constructor(){this._onDidChangeTelemetryEnabled=new C.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._onDidChangeTelemetryConfiguration=new C.Emitter,this.onDidChangeTelemetryConfiguration=this._onDidChangeTelemetryConfiguration.event,this._productConfig={usage:!0,error:!0},this._level=0}getTelemetryConfiguration(){return this._level===3}getTelemetryDetails(){return{isCrashEnabled:this._level>=1,isErrorsEnabled:this._productConfig.error?this._level>=2:!1,isUsageEnabled:this._productConfig.usage?this._level>=3:!1}}$initializeTelemetryLevel(I,P){this._level=I,this._productConfig=P||{usage:!0,error:!0}}$onDidChangeTelemetryLevel(I){this._oldTelemetryEnablement=this.getTelemetryConfiguration(),this._level=I,this._oldTelemetryEnablement!==this.getTelemetryConfiguration()&&this._onDidChangeTelemetryEnabled.fire(this.getTelemetryConfiguration()),this._onDidChangeTelemetryConfiguration.fire(this.getTelemetryDetails())}}e.ExtHostTelemetry=p,e.IExtHostTelemetry=(0,o.createDecorator)("IExtHostTelemetry")}),define(De[62],Ce([1,0,3,155,4,15]),function(J,e,o,C,p,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var I;(function(b){function A(_){return{remoteAddress:_.remoteAddress,localAddress:_.localAddress,public:!!_.public,privacy:_.privacy??(_.public?C.TunnelPrivacyId.Public:C.TunnelPrivacyId.Private),protocol:_.protocol}}b.fromApiTunnel=A;function R(_){return{remoteAddress:{host:_.tunnelRemoteHost,port:_.tunnelRemotePort},localAddress:_.localAddress,public:_.privacy!==C.TunnelPrivacyId.ConstantPrivate&&_.privacy!==C.TunnelPrivacyId.ConstantPrivate,privacy:_.privacy,protocol:_.protocol}}b.fromServiceTunnel=R})(I=e.TunnelDtoConverter||(e.TunnelDtoConverter={})),e.IExtHostTunnelService=(0,o.createDecorator)("IExtHostTunnelService");let P=class{constructor(A){this.onDidChangeTunnels=new p.Emitter().event}async $applyCandidateFilter(A){return A}async openTunnel(A,R){}async getTunnels(){return[]}async setTunnelFactory(A){return{dispose:()=>{}}}registerPortsAttributesProvider(A,R){return{dispose:()=>{}}}async $providePortAttributes(A,R,_,m,T){return[]}async $forwardPort(A,R){}async $closeTunnel(A){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};P=$e([xe(0,U.IExtHostRpcService)],P),e.ExtHostTunnelService=P});var Ye=this&&this.__classPrivateFieldSet||function(J,e,o,C,p){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!p)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!p:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?p.call(J,o):p?p.value=o:e.set(J,o),o},Ae=this&&this.__classPrivateFieldGet||function(J,e,o,C){if(o==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!C:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?C:o==="a"?C.call(J):C?C.value:e.get(J)};define(De[6],Ce([1,0,16,11,75,24,74,10,9,2,43,39,84]),function(J,e,o,C,p,U,I,P,b,A,R,_,m){"use strict";var T,g,h,u,l,S,w,a,y,r,d,i,s,n,t,c,E,f,D,L,W,N;Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKindNew=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferItem=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionsNew=e.InlineSuggestionNew=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function v(x){function M(){return Reflect.construct(x,arguments,this.constructor)}return Object.defineProperty(M,"name",Object.getOwnPropertyDescriptor(x,"name")),Object.setPrototypeOf(M,x),Object.setPrototypeOf(M.prototype,x.prototype),M}let F=S=class{constructor(M){T.set(this,void 0),Ye(this,T,M,"f")}static from(...M){let ee=M;return new S(function(){if(ee){for(const _e of ee)_e&&typeof _e.dispose=="function"&&_e.dispose();ee=void 0}})}dispose(){typeof Ae(this,T,"f")=="function"&&(Ae(this,T,"f").call(this),Ye(this,T,void 0,"f"))}};T=new WeakMap,F=S=$e([v],F),e.Disposable=F;let O=w=class{constructor(M,ee){if(M<0)throw(0,C.illegalArgument)("line must be non-negative");if(ee<0)throw(0,C.illegalArgument)("character must be non-negative");this._line=M,this._character=ee}static Min(...M){if(M.length===0)throw new TypeError;let ee=M[0];for(let _e=1;_e<M.length;_e++){const je=M[_e];je.isBefore(ee)&&(ee=je)}return ee}static Max(...M){if(M.length===0)throw new TypeError;let ee=M[0];for(let _e=1;_e<M.length;_e++){const je=M[_e];je.isAfter(ee)&&(ee=je)}return ee}static isPosition(M){if(!M)return!1;if(M instanceof w)return!0;const{line:ee,character:_e}=M;return typeof ee=="number"&&typeof _e=="number"}static of(M){if(M instanceof w)return M;if(this.isPosition(M))return new w(M.line,M.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this._line}get character(){return this._character}isBefore(M){return this._line<M._line?!0:M._line<this._line?!1:this._character<M._character}isBeforeOrEqual(M){return this._line<M._line?!0:M._line<this._line?!1:this._character<=M._character}isAfter(M){return!this.isBeforeOrEqual(M)}isAfterOrEqual(M){return!this.isBefore(M)}isEqual(M){return this._line===M._line&&this._character===M._character}compareTo(M){return this._line<M._line?-1:this._line>M.line?1:this._character<M._character?-1:this._character>M._character?1:0}translate(M,ee=0){if(M===null||ee===null)throw(0,C.illegalArgument)();let _e;return typeof M=="undefined"?_e=0:typeof M=="number"?_e=M:(_e=typeof M.lineDelta=="number"?M.lineDelta:0,ee=typeof M.characterDelta=="number"?M.characterDelta:0),_e===0&&ee===0?this:new w(this.line+_e,this.character+ee)}with(M,ee=this.character){if(M===null||ee===null)throw(0,C.illegalArgument)();let _e;return typeof M=="undefined"?_e=this.line:typeof M=="number"?_e=M:(_e=typeof M.line=="number"?M.line:this.line,ee=typeof M.character=="number"?M.character:this.character),_e===this.line&&ee===this.character?this:new w(_e,ee)}toJSON(){return{line:this.line,character:this.character}}};O=w=$e([v],O),e.Position=O;let H=a=class{constructor(M,ee,_e,je){let tt,rt;if(typeof M=="number"&&typeof ee=="number"&&typeof _e=="number"&&typeof je=="number"?(tt=new O(M,ee),rt=new O(_e,je)):O.isPosition(M)&&O.isPosition(ee)&&(tt=O.of(M),rt=O.of(ee)),!tt||!rt)throw new Error("Invalid arguments");tt.isBefore(rt)?(this._start=tt,this._end=rt):(this._start=rt,this._end=tt)}static isRange(M){return M instanceof a?!0:M?O.isPosition(M.start)&&O.isPosition(M.end):!1}static of(M){if(M instanceof a)return M;if(this.isRange(M))return new a(M.start,M.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this._start}get end(){return this._end}contains(M){return a.isRange(M)?this.contains(M.start)&&this.contains(M.end):O.isPosition(M)?!(O.of(M).isBefore(this._start)||this._end.isBefore(M)):!1}isEqual(M){return this._start.isEqual(M._start)&&this._end.isEqual(M._end)}intersection(M){const ee=O.Max(M.start,this._start),_e=O.Min(M.end,this._end);if(!ee.isAfter(_e))return new a(ee,_e)}union(M){if(this.contains(M))return this;if(M.contains(this))return M;const ee=O.Min(M.start,this._start),_e=O.Max(M.end,this.end);return new a(ee,_e)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(M,ee=this.end){if(M===null||ee===null)throw(0,C.illegalArgument)();let _e;return M?O.isPosition(M)?_e=M:(_e=M.start||this.start,ee=M.end||this.end):_e=this.start,_e.isEqual(this._start)&&ee.isEqual(this.end)?this:new a(_e,ee)}toJSON(){return[this.start,this.end]}};H=a=$e([v],H),e.Range=H;let te=y=class extends H{constructor(M,ee,_e,je){let tt,rt;if(typeof M=="number"&&typeof ee=="number"&&typeof _e=="number"&&typeof je=="number"?(tt=new O(M,ee),rt=new O(_e,je)):O.isPosition(M)&&O.isPosition(ee)&&(tt=O.of(M),rt=O.of(ee)),!tt||!rt)throw new Error("Invalid arguments");super(tt,rt);this._anchor=tt,this._active=rt}static isSelection(M){return M instanceof y?!0:M?H.isRange(M)&&O.isPosition(M.anchor)&&O.isPosition(M.active)&&typeof M.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};te=y=$e([v],te),e.Selection=te;class z{constructor(M,ee,_e){if(typeof M!="string"||M.length===0)throw(0,C.illegalArgument)("host");if(typeof ee!="number"||ee===0||Math.round(ee)!==ee)throw(0,C.illegalArgument)("port");if(typeof _e!="undefined"&&(typeof _e!="string"||_e.length===0||!/^[0-9A-Za-z\-]+$/.test(_e)))throw(0,C.illegalArgument)("connectionToken");this.host=M,this.port=Math.round(ee),this.connectionToken=_e}}e.ResolvedAuthority=z;class $ extends Error{constructor(M,ee=m.RemoteAuthorityResolverErrorCode.Unknown,_e){super(M);this._message=M,this._code=ee,this._detail=_e,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,$.prototype)}static NotAvailable(M,ee){return new $(M,m.RemoteAuthorityResolverErrorCode.NotAvailable,ee)}static TemporarilyNotAvailable(M){return new $(M,m.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=$;var ce;(function(x){x[x.LF=1]="LF",x[x.CRLF=2]="CRLF"})(ce=e.EndOfLine||(e.EndOfLine={}));var le;(function(x){x[x.Replace=1]="Replace",x[x.Append=2]="Append",x[x.Prepend=3]="Prepend"})(le=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let oe=r=class{constructor(M,ee){this._range=M,this._newText=ee}static isTextEdit(M){return M instanceof r?!0:M?H.isRange(M)&&typeof M.newText=="string":!1}static replace(M,ee){return new r(M,ee)}static insert(M,ee){return r.replace(new H(M,M),ee)}static delete(M){return r.replace(M,"")}static setEndOfLine(M){const ee=new r(new H(new O(0,0),new O(0,0)),"");return ee.newEol=M,ee}get range(){return this._range}set range(M){if(M&&!H.isRange(M))throw(0,C.illegalArgument)("range");this._range=M}get newText(){return this._newText||""}set newText(M){if(M&&typeof M!="string")throw(0,C.illegalArgument)("newText");this._newText=M}get newEol(){return this._newEol}set newEol(M){if(M&&typeof M!="number")throw(0,C.illegalArgument)("newEol");this._newEol=M}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};oe=r=$e([v],oe),e.TextEdit=oe;let pe=d=class{constructor(M,ee){this.range=M,this.newCells=ee}static isNotebookCellEdit(M){return M instanceof d?!0:M?zt.isNotebookRange(M)&&Array.isArray(M.newCells):!1}static replaceCells(M,ee){return new d(M,ee)}static insertCells(M,ee){return new d(new zt(M,M),ee)}static deleteCells(M){return new d(M,[])}static updateCellMetadata(M,ee){const _e=new d(new zt(M,M),[]);return _e.newCellMetadata=ee,_e}static updateNotebookMetadata(M){const ee=new d(new zt(0,0),[]);return ee.newNotebookMetadata=M,ee}};pe=d=$e([v],pe),e.NotebookEdit=pe;var re;(function(x){x[x.File=1]="File",x[x.Text=2]="Text",x[x.Cell=3]="Cell",x[x.CellReplace=5]="CellReplace"})(re=e.FileEditType||(e.FileEditType={}));let Ee=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(M,ee,_e,je){this._edits.push({_type:1,from:M,to:ee,options:_e,metadata:je})}createFile(M,ee,_e){this._edits.push({_type:1,from:void 0,to:M,options:ee,metadata:_e})}deleteFile(M,ee,_e){this._edits.push({_type:1,from:M,to:void 0,options:ee,metadata:_e})}replaceNotebookMetadata(M,ee,_e){this._edits.push({_type:3,metadata:_e,uri:M,edit:{editType:5,metadata:ee},notebookMetadata:ee})}replaceNotebookCells(M,ee,_e,je,tt){let rt,ct,St=[],Rt;if(zt.isNotebookRange(ee)&&jt.isNotebookCellDataArray(_e)&&!jt.isNotebookCellDataArray(je)?(rt=ee.start,ct=ee.end,St=_e,Rt=je):typeof ee=="number"&&typeof _e=="number"&&jt.isNotebookCellDataArray(je)&&(rt=ee,ct=_e,St=je,Rt=tt),rt===void 0||ct===void 0)throw new Error("Invalid arguments");(rt!==ct||St.length>0)&&this._edits.push({_type:5,uri:M,index:rt,count:ct-rt,cells:St,metadata:Rt})}replaceNotebookCellMetadata(M,ee,_e,je){this._edits.push({_type:3,metadata:je,uri:M,edit:{editType:8,index:ee,metadata:_e}})}replace(M,ee,_e,je){this._edits.push({_type:2,uri:M,edit:new oe(ee,_e),metadata:je})}insert(M,ee,_e,je){this.replace(M,new H(ee,ee),_e,je)}delete(M,ee,_e){this.replace(M,ee,"",_e)}has(M){return this._edits.some(ee=>ee._type===2&&ee.uri.toString()===M.toString())}set(M,ee){if(ee)for(const _e of ee)_e&&(pe.isNotebookCellEdit(_e)?_e.newCellMetadata?this.replaceNotebookCellMetadata(M,_e.range.start,_e.newCellMetadata):_e.newNotebookMetadata?this.replaceNotebookMetadata(M,_e.newNotebookMetadata):this.replaceNotebookCells(M,_e.range,_e.newCells):this._edits.push({_type:2,uri:M,edit:_e}));else{for(let _e=0;_e<this._edits.length;_e++){const je=this._edits[_e];je._type===2&&je.uri.toString()===M.toString()&&(this._edits[_e]=void 0)}(0,o.coalesceInPlace)(this._edits)}}get(M){const ee=[];for(const _e of this._edits)_e._type===2&&_e.uri.toString()===M.toString()&&ee.push(_e.edit);return ee}entries(){const M=new U.ResourceMap;for(const ee of this._edits)if(ee._type===2){let _e=M.get(ee.uri);_e||(_e=[ee.uri,[]],M.set(ee.uri,_e)),_e[1].push(ee.edit)}return[...M.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};Ee=$e([v],Ee),e.WorkspaceEdit=Ee;let be=i=class{constructor(M){this._tabstop=1,this.value=M||""}static isSnippetString(M){return M instanceof i?!0:M?typeof M.value=="string":!1}static _escape(M){return M.replace(/\$|}|\\/g,"\\$&")}appendText(M){return this.value+=i._escape(M),this}appendTabstop(M=this._tabstop++){return this.value+="$",this.value+=M,this}appendPlaceholder(M,ee=this._tabstop++){if(typeof M=="function"){const _e=new i;_e._tabstop=this._tabstop,M(_e),this._tabstop=_e._tabstop,M=_e.value}else M=i._escape(M);return this.value+="${",this.value+=ee,this.value+=":",this.value+=M,this.value+="}",this}appendChoice(M,ee=this._tabstop++){const _e=M.map(je=>je.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ee,this.value+="|",this.value+=_e,this.value+="|}",this}appendVariable(M,ee){if(typeof ee=="function"){const _e=new i;_e._tabstop=this._tabstop,ee(_e),this._tabstop=_e._tabstop,ee=_e.value}else typeof ee=="string"&&(ee=ee.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=M,ee&&(this.value+=":",this.value+=ee),this.value+="}",this}};be=i=$e([v],be),e.SnippetString=be;var Z;(function(x){x[x.Unnecessary=1]="Unnecessary",x[x.Deprecated=2]="Deprecated"})(Z=e.DiagnosticTag||(e.DiagnosticTag={}));var ve;(function(x){x[x.Hint=3]="Hint",x[x.Information=2]="Information",x[x.Warning=1]="Warning",x[x.Error=0]="Error"})(ve=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let Re=s=class{constructor(M,ee){if(this.uri=M,ee)if(H.isRange(ee))this.range=H.of(ee);else if(O.isPosition(ee))this.range=new H(ee,ee);else throw new Error("Illegal argument")}static isLocation(M){return M instanceof s?!0:M?H.isRange(M.range)&&A.URI.isUri(M.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};Re=s=$e([v],Re),e.Location=Re;let Fe=class{constructor(M,ee){this.location=M,this.message=ee}static is(M){return M?typeof M.message=="string"&&M.location&&H.isRange(M.location.range)&&A.URI.isUri(M.location.uri):!1}static isEqual(M,ee){return M===ee?!0:!M||!ee?!1:M.message===ee.message&&M.location.range.isEqual(ee.location.range)&&M.location.uri.toString()===ee.location.uri.toString()}};Fe=$e([v],Fe),e.DiagnosticRelatedInformation=Fe;let We=class{constructor(M,ee,_e=ve.Error){if(!H.isRange(M))throw new TypeError("range must be set");if(!ee)throw new TypeError("message must be set");this.range=M,this.message=ee,this.severity=_e}toJSON(){return{severity:ve[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(M,ee){return M===ee?!0:!M||!ee?!1:M.message===ee.message&&M.severity===ee.severity&&M.code===ee.code&&M.severity===ee.severity&&M.source===ee.source&&M.range.isEqual(ee.range)&&(0,o.equals)(M.tags,ee.tags)&&(0,o.equals)(M.relatedInformation,ee.relatedInformation,Fe.isEqual)}};We=$e([v],We),e.Diagnostic=We;let Xe=class{constructor(M,ee){if(!M)throw new Error("Illegal argument, contents must be defined");Array.isArray(M)?this.contents=M:this.contents=[M],this.range=ee}};Xe=$e([v],Xe),e.Hover=Xe;var Ie;(function(x){x[x.Text=0]="Text",x[x.Read=1]="Read",x[x.Write=2]="Write"})(Ie=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Se=class{constructor(M,ee=Ie.Text){this.range=M,this.kind=ee}toJSON(){return{range:this.range,kind:Ie[this.kind]}}};Se=$e([v],Se),e.DocumentHighlight=Se;var Te;(function(x){x[x.File=0]="File",x[x.Module=1]="Module",x[x.Namespace=2]="Namespace",x[x.Package=3]="Package",x[x.Class=4]="Class",x[x.Method=5]="Method",x[x.Property=6]="Property",x[x.Field=7]="Field",x[x.Constructor=8]="Constructor",x[x.Enum=9]="Enum",x[x.Interface=10]="Interface",x[x.Function=11]="Function",x[x.Variable=12]="Variable",x[x.Constant=13]="Constant",x[x.String=14]="String",x[x.Number=15]="Number",x[x.Boolean=16]="Boolean",x[x.Array=17]="Array",x[x.Object=18]="Object",x[x.Key=19]="Key",x[x.Null=20]="Null",x[x.EnumMember=21]="EnumMember",x[x.Struct=22]="Struct",x[x.Event=23]="Event",x[x.Operator=24]="Operator",x[x.TypeParameter=25]="TypeParameter"})(Te=e.SymbolKind||(e.SymbolKind={}));var se;(function(x){x[x.Deprecated=1]="Deprecated"})(se=e.SymbolTag||(e.SymbolTag={}));let ae=n=class{constructor(M,ee,_e,je,tt){this.name=M,this.kind=ee,this.containerName=tt,typeof _e=="string"&&(this.containerName=_e),je instanceof Re?this.location=je:_e instanceof H&&(this.location=new Re(je,_e)),n.validate(this)}static validate(M){if(!M.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:Te[this.kind],location:this.location,containerName:this.containerName}}};ae=n=$e([v],ae),e.SymbolInformation=ae;let G=t=class{constructor(M,ee,_e,je,tt){this.name=M,this.detail=ee,this.kind=_e,this.range=je,this.selectionRange=tt,this.children=[],t.validate(this)}static validate(M){if(!M.name)throw new Error("name must not be falsy");if(!M.range.contains(M.selectionRange))throw new Error("selectionRange must be contained in fullRange");M.children?.forEach(t.validate)}};G=t=$e([v],G),e.DocumentSymbol=G;var X;(function(x){x[x.Invoke=1]="Invoke",x[x.Automatic=2]="Automatic"})(X=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let k=class{constructor(M,ee){this.title=M,this.kind=ee}};k=$e([v],k),e.CodeAction=k;let B=c=class{constructor(M){this.value=M}append(M){return new c(this.value?this.value+c.sep+M:M)}intersects(M){return this.contains(M)||M.contains(this)}contains(M){return this.value===M.value||M.value.startsWith(this.value+c.sep)}};B.sep=".",B=c=$e([v],B),e.CodeActionKind=B,B.Empty=new B(""),B.QuickFix=B.Empty.append("quickfix"),B.Refactor=B.Empty.append("refactor"),B.RefactorExtract=B.Refactor.append("extract"),B.RefactorInline=B.Refactor.append("inline"),B.RefactorRewrite=B.Refactor.append("rewrite"),B.Source=B.Empty.append("source"),B.SourceOrganizeImports=B.Source.append("organizeImports"),B.SourceFixAll=B.Source.append("fixAll");let V=class{constructor(M,ee){if(this.range=M,this.parent=ee,ee&&!ee.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};V=$e([v],V),e.SelectionRange=V;class j{constructor(M,ee,_e,je,tt,rt){this.kind=M,this.name=ee,this.detail=_e,this.uri=je,this.range=tt,this.selectionRange=rt}}e.CallHierarchyItem=j;class ne{constructor(M,ee){this.fromRanges=ee,this.from=M}}e.CallHierarchyIncomingCall=ne;class ue{constructor(M,ee){this.fromRanges=ee,this.to=M}}e.CallHierarchyOutgoingCall=ue;var Y;(function(x){x[x.Information=0]="Information",x[x.Warning=1]="Warning",x[x.Error=2]="Error"})(Y=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let ge=class{constructor(M,ee){this.range=M,this.command=ee}get isResolved(){return!!this.command}};ge=$e([v],ge),e.CodeLens=ge;let fe=E=class{constructor(M,ee=!1){g.set(this,void 0),Ye(this,g,new p.MarkdownString(M,{supportThemeIcons:ee}),"f")}static isMarkdownString(M){return M instanceof E?!0:M&&M.appendCodeblock&&M.appendMarkdown&&M.appendText&&M.value!==void 0}get value(){return Ae(this,g,"f").value}set value(M){Ae(this,g,"f").value=M}get isTrusted(){return Ae(this,g,"f").isTrusted}set isTrusted(M){Ae(this,g,"f").isTrusted=M}get supportThemeIcons(){return Ae(this,g,"f").supportThemeIcons}set supportThemeIcons(M){Ae(this,g,"f").supportThemeIcons=M}get supportHtml(){return Ae(this,g,"f").supportHtml}set supportHtml(M){Ae(this,g,"f").supportHtml=M}get baseUri(){return Ae(this,g,"f").baseUri}set baseUri(M){Ae(this,g,"f").baseUri=M}appendText(M){return Ae(this,g,"f").appendText(M),this}appendMarkdown(M){return Ae(this,g,"f").appendMarkdown(M),this}appendCodeblock(M,ee){return Ae(this,g,"f").appendCodeblock(ee??"",M),this}};g=new WeakMap,fe=E=$e([v],fe),e.MarkdownString=fe;let Ne=class{constructor(M,ee){this.label=M,this.documentation=ee}};Ne=$e([v],Ne),e.ParameterInformation=Ne;let ze=class{constructor(M,ee){this.label=M,this.documentation=ee,this.parameters=[]}};ze=$e([v],ze),e.SignatureInformation=ze;let ke=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};ke=$e([v],ke),e.SignatureHelp=ke;var qe;(function(x){x[x.Invoke=1]="Invoke",x[x.TriggerCharacter=2]="TriggerCharacter",x[x.ContentChange=3]="ContentChange"})(qe=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var K;(function(x){x[x.Type=1]="Type",x[x.Parameter=2]="Parameter"})(K=e.InlayHintKind||(e.InlayHintKind={}));let Q=class{constructor(M){this.value=M}};Q=$e([v],Q),e.InlayHintLabelPart=Q;let me=class{constructor(M,ee,_e){this.position=M,this.label=ee,this.kind=_e}};me=$e([v],me),e.InlayHint=me;var Le;(function(x){x[x.Invoke=0]="Invoke",x[x.TriggerCharacter=1]="TriggerCharacter",x[x.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Le=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Be;(function(x){x[x.Text=0]="Text",x[x.Method=1]="Method",x[x.Function=2]="Function",x[x.Constructor=3]="Constructor",x[x.Field=4]="Field",x[x.Variable=5]="Variable",x[x.Class=6]="Class",x[x.Interface=7]="Interface",x[x.Module=8]="Module",x[x.Property=9]="Property",x[x.Unit=10]="Unit",x[x.Value=11]="Value",x[x.Enum=12]="Enum",x[x.Keyword=13]="Keyword",x[x.Snippet=14]="Snippet",x[x.Color=15]="Color",x[x.File=16]="File",x[x.Reference=17]="Reference",x[x.Folder=18]="Folder",x[x.EnumMember=19]="EnumMember",x[x.Constant=20]="Constant",x[x.Struct=21]="Struct",x[x.Event=22]="Event",x[x.Operator=23]="Operator",x[x.TypeParameter=24]="TypeParameter",x[x.User=25]="User",x[x.Issue=26]="Issue"})(Be=e.CompletionItemKind||(e.CompletionItemKind={}));var Ze;(function(x){x[x.Deprecated=1]="Deprecated"})(Ze=e.CompletionItemTag||(e.CompletionItemTag={}));let et=class{constructor(M,ee){this.label=M,this.kind=ee}toJSON(){return{label:this.label,kind:this.kind&&Be[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};et=$e([v],et),e.CompletionItem=et;let at=class{constructor(M=[],ee=!1){this.items=M,this.isIncomplete=ee}};at=$e([v],at),e.CompletionList=at;let Je=class{constructor(M,ee,_e){this.insertText=M,this.range=ee,this.command=_e}};Je=$e([v],Je),e.InlineSuggestion=Je;let He=class{constructor(M){this.commands=void 0,this.items=M}};He=$e([v],He),e.InlineSuggestionList=He;let nt=class{constructor(M,ee,_e){this.insertText=M,this.range=ee,this.command=_e}};nt=$e([v],nt),e.InlineSuggestionNew=nt;let st=class{constructor(M,ee){this.items=M,this.commands=ee}};st=$e([v],st),e.InlineSuggestionsNew=st;var ot;(function(x){x[x.Active=-1]="Active",x[x.Beside=-2]="Beside",x[x.One=1]="One",x[x.Two=2]="Two",x[x.Three=3]="Three",x[x.Four=4]="Four",x[x.Five=5]="Five",x[x.Six=6]="Six",x[x.Seven=7]="Seven",x[x.Eight=8]="Eight",x[x.Nine=9]="Nine"})(ot=e.ViewColumn||(e.ViewColumn={}));var lt;(function(x){x[x.Left=1]="Left",x[x.Right=2]="Right"})(lt=e.StatusBarAlignment||(e.StatusBarAlignment={}));var dt;(function(x){x[x.Off=0]="Off",x[x.On=1]="On",x[x.Relative=2]="Relative"})(dt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var kt;(function(x){x[x.Manual=1]="Manual",x[x.AfterDelay=2]="AfterDelay",x[x.FocusOut=3]="FocusOut"})(kt=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Mt;(function(x){x[x.Default=0]="Default",x[x.InCenter=1]="InCenter",x[x.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",x[x.AtTop=3]="AtTop"})(Mt=e.TextEditorRevealType||(e.TextEditorRevealType={}));var Dt;(function(x){x[x.Keyboard=1]="Keyboard",x[x.Mouse=2]="Mouse",x[x.Command=3]="Command"})(Dt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var ft;(function(x){x[x.Undo=1]="Undo",x[x.Redo=2]="Redo"})(ft=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var Ct;(function(x){x[x.OpenOpen=0]="OpenOpen",x[x.ClosedClosed=1]="ClosedClosed",x[x.OpenClosed=2]="OpenClosed",x[x.ClosedOpen=3]="ClosedOpen"})(Ct=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(x){function M(ee){switch(ee){case"keyboard":return x.Keyboard;case"mouse":return x.Mouse;case"api":return x.Command}}x.fromValue=M}(Dt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Nt=class{constructor(M,ee){if(ee&&!A.URI.isUri(ee))throw(0,C.illegalArgument)("target");if(!H.isRange(M)||M.isEmpty)throw(0,C.illegalArgument)("range");this.range=M,this.target=ee}};Nt=$e([v],Nt),e.DocumentLink=Nt;let Pt=class{constructor(M,ee,_e,je){this.red=M,this.green=ee,this.blue=_e,this.alpha=je}};Pt=$e([v],Pt),e.Color=Pt;let Ve=class{constructor(M,ee){if(ee&&!(ee instanceof Pt))throw(0,C.illegalArgument)("color");if(!H.isRange(M)||M.isEmpty)throw(0,C.illegalArgument)("range");this.range=M,this.color=ee}};Ve=$e([v],Ve),e.ColorInformation=Ve;let At=class{constructor(M){if(!M||typeof M!="string")throw(0,C.illegalArgument)("label");this.label=M}};At=$e([v],At),e.ColorPresentation=At;var Lt;(function(x){x[x.RGB=0]="RGB",x[x.HEX=1]="HEX",x[x.HSL=2]="HSL"})(Lt=e.ColorFormat||(e.ColorFormat={}));var Ot;(function(x){x[x.Error=0]="Error",x[x.Warning=1]="Warning",x[x.Information=2]="Information"})(Ot=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class mt{constructor(M,ee,_e){if(this.startIndex=M,this.length=ee,this.tooltip=_e,typeof M!="number"||M<0)throw(0,C.illegalArgument)("startIndex");if(typeof ee!="number"||ee<1)throw(0,C.illegalArgument)("length");if(_e!==void 0&&typeof _e!="string")throw(0,C.illegalArgument)("tooltip")}}e.TerminalLink=mt;var yt;(function(x){x[x.Panel=1]="Panel",x[x.Editor=2]="Editor"})(yt=e.TerminalLocation||(e.TerminalLocation={}));class we{constructor(M){if(this.options=M,typeof M!="object")throw(0,C.illegalArgument)("options")}}e.TerminalProfile=we;var ye;(function(x){x[x.Always=1]="Always",x[x.Silent=2]="Silent",x[x.Never=3]="Never"})(ye=e.TaskRevealKind||(e.TaskRevealKind={}));var he;(function(x){x[x.Shared=1]="Shared",x[x.Dedicated=2]="Dedicated",x[x.New=3]="New"})(he=e.TaskPanelKind||(e.TaskPanelKind={}));let q=f=class{constructor(M,ee){if(this.label=ee,typeof M!="string"||typeof ee!="string")throw(0,C.illegalArgument)("name");this._id=M}static from(M){switch(M){case"clean":return f.Clean;case"build":return f.Build;case"rebuild":return f.Rebuild;case"test":return f.Test;default:return}}get id(){return this._id}};q.Clean=new f("clean","Clean"),q.Build=new f("build","Build"),q.Rebuild=new f("rebuild","Rebuild"),q.Test=new f("test","Test"),q=f=$e([v],q),e.TaskGroup=q;function Pe(x){let M="";for(let ee=0;ee<x.length;ee++)M+=x[ee].replace(/,/g,",,")+",";return M}let Ue=class{constructor(M,ee,_e){if(typeof M!="string")throw(0,C.illegalArgument)("process");this._args=[],this._process=M,ee!==void 0&&(Array.isArray(ee)?(this._args=ee,this._options=_e):this._options=ee)}get process(){return this._process}set process(M){if(typeof M!="string")throw(0,C.illegalArgument)("process");this._process=M}get args(){return this._args}set args(M){Array.isArray(M)||(M=[]),this._args=M}get options(){return this._options}set options(M){this._options=M}computeId(){const M=[];if(M.push("process"),this._process!==void 0&&M.push(this._process),this._args&&this._args.length>0)for(const ee of this._args)M.push(ee);return Pe(M)}};Ue=$e([v],Ue),e.ProcessExecution=Ue;let Ke=class{constructor(M,ee,_e){if(this._args=[],Array.isArray(ee)){if(!M)throw(0,C.illegalArgument)("command can't be undefined or null");if(typeof M!="string"&&typeof M.value!="string")throw(0,C.illegalArgument)("command");this._command=M,this._args=ee,this._options=_e}else{if(typeof M!="string")throw(0,C.illegalArgument)("commandLine");this._commandLine=M,this._options=ee}}get commandLine(){return this._commandLine}set commandLine(M){if(typeof M!="string")throw(0,C.illegalArgument)("commandLine");this._commandLine=M}get command(){return this._command?this._command:""}set command(M){if(typeof M!="string"&&typeof M.value!="string")throw(0,C.illegalArgument)("command");this._command=M}get args(){return this._args}set args(M){this._args=M||[]}get options(){return this._options}set options(M){this._options=M}computeId(){const M=[];if(M.push("shell"),this._commandLine!==void 0&&M.push(this._commandLine),this._command!==void 0&&M.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(const ee of this._args)M.push(typeof ee=="string"?ee:ee.value);return Pe(M)}};Ke=$e([v],Ke),e.ShellExecution=Ke;var Qe;(function(x){x[x.Escape=1]="Escape",x[x.Strong=2]="Strong",x[x.Weak=3]="Weak"})(Qe=e.ShellQuoting||(e.ShellQuoting={}));var Ge;(function(x){x[x.Global=1]="Global",x[x.Workspace=2]="Workspace"})(Ge=e.TaskScope||(e.TaskScope={}));class gt{constructor(M){this._callback=M}computeId(){return"customExecution"+(0,R.generateUuid)()}set callback(M){this._callback=M}get callback(){return this._callback}}e.CustomExecution=gt;let pt=D=class{constructor(M,ee,_e,je,tt,rt){this.__deprecated=!1,this._definition=this.definition=M;let ct;typeof ee=="string"?(this._name=this.name=ee,this._source=this.source=_e,this.execution=je,ct=tt,this.__deprecated=!0):ee===Ge.Global||ee===Ge.Workspace?(this.target=ee,this._name=this.name=_e,this._source=this.source=je,this.execution=tt,ct=rt):(this.target=ee,this._name=this.name=_e,this._source=this.source=je,this.execution=tt,ct=rt),typeof ct=="string"?(this._problemMatchers=[ct],this._hasDefinedMatchers=!0):Array.isArray(ct)?(this._problemMatchers=ct,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(M){this.__id=M}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Ue?this._definition={type:D.ProcessType,id:this._execution.computeId()}:this._execution instanceof Ke?this._definition={type:D.ShellType,id:this._execution.computeId()}:this._execution instanceof gt?this._definition={type:D.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:D.EmptyType,id:(0,R.generateUuid)()}}get definition(){return this._definition}set definition(M){if(M==null)throw(0,C.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=M}get scope(){return this._scope}set target(M){this.clear(),this._scope=M}get name(){return this._name}set name(M){if(typeof M!="string")throw(0,C.illegalArgument)("name");this.clear(),this._name=M}get execution(){return this._execution}set execution(M){M===null&&(M=void 0),this.clear(),this._execution=M;const ee=this._definition.type;(D.EmptyType===ee||D.ProcessType===ee||D.ShellType===ee||D.ExtensionCallbackType===ee)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(M){if(Array.isArray(M))this.clear(),this._problemMatchers=M,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(M){M!==!0&&M!==!1&&(M=!1),this.clear(),this._isBackground=M}get source(){return this._source}set source(M){if(typeof M!="string"||M.length===0)throw(0,C.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=M}get group(){return this._group}set group(M){M===null&&(M=void 0),this.clear(),this._group=M}get detail(){return this._detail}set detail(M){M===null&&(M=void 0),this._detail=M}get presentationOptions(){return this._presentationOptions}set presentationOptions(M){M==null&&(M=Object.create(null)),this.clear(),this._presentationOptions=M}get runOptions(){return this._runOptions}set runOptions(M){M==null&&(M=Object.create(null)),this.clear(),this._runOptions=M}};pt.ExtensionCallbackType="customExecution",pt.ProcessType="process",pt.ShellType="shell",pt.EmptyType="$empty",pt=D=$e([v],pt),e.Task=pt;var _t;(function(x){x[x.SourceControl=1]="SourceControl",x[x.Window=10]="Window",x[x.Notification=15]="Notification"})(_t=e.ProgressLocation||(e.ProgressLocation={}));let vt=class{constructor(M,ee=ht.None){this.collapsibleState=ee,A.URI.isUri(M)?this.resourceUri=M:this.label=M}};vt=$e([v],vt),e.TreeItem=vt;var ht;(function(x){x[x.None=0]="None",x[x.Collapsed=1]="Collapsed",x[x.Expanded=2]="Expanded"})(ht=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let Gt=class{constructor(M){this.value=M}async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}};Gt=$e([v],Gt),e.DataTransferItem=Gt;let Xt=class{constructor(M){h.set(this,new Map);for(const[ee,_e]of M??[]){const je=Ae(this,h,"f").get(ee);je?je.push(_e):Ae(this,h,"f").set(ee,[_e])}}get(M){return Ae(this,h,"f").get(M)?.[0]}set(M,ee){Ae(this,h,"f").set(M,[ee])}forEach(M,ee){for(const[_e,je]of Ae(this,h,"f"))for(const tt of je)M.call(ee,tt,_e,this)}*[(h=new WeakMap,Symbol.iterator)](){for(const[M,ee]of Ae(this,h,"f"))for(const _e of ee)yield[M,_e]}};Xt=$e([v],Xt),e.DataTransfer=Xt;let bt=class{constructor(M){this.insertText=M}};bt=$e([v],bt),e.DocumentDropEdit=bt;let ni=class{constructor(M){this.insertText=M}};ni=$e([v],ni),e.DocumentPasteEdit=ni;let Ut=class{constructor(M,ee){this.id=M,this.color=ee}};Ut=$e([v],Ut),e.ThemeIcon=Ut,Ut.File=new Ut("file"),Ut.Folder=new Ut("folder");let ri=class{constructor(M){this.id=M}};ri=$e([v],ri),e.ThemeColor=ri;var Ii;(function(x){x[x.Global=1]="Global",x[x.Workspace=2]="Workspace",x[x.WorkspaceFolder=3]="WorkspaceFolder"})(Ii=e.ConfigurationTarget||(e.ConfigurationTarget={}));let It=class{constructor(M,ee){if(typeof M!="string"&&(!M||!A.URI.isUri(M)&&!A.URI.isUri(M.uri)))throw(0,C.illegalArgument)("base");if(typeof ee!="string")throw(0,C.illegalArgument)("pattern");typeof M=="string"?this.baseUri=A.URI.file(M):A.URI.isUri(M)?this.baseUri=M:this.baseUri=M.uri,this.pattern=ee}get base(){return this._base}set base(M){this._base=M,this._baseUri=A.URI.file(M)}get baseUri(){return this._baseUri}set baseUri(M){this._baseUri=M,this._base=M.fsPath}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};It=$e([v],It),e.RelativePattern=It;let Ht=class{constructor(M,ee,_e,je){this.enabled=typeof M=="boolean"?M:!0,typeof ee=="string"&&(this.condition=ee),typeof _e=="string"&&(this.hitCondition=_e),typeof je=="string"&&(this.logMessage=je)}get id(){return this._id||(this._id=(0,R.generateUuid)()),this._id}};Ht=$e([v],Ht),e.Breakpoint=Ht;let hi=class extends Ht{constructor(M,ee,_e,je,tt){super(ee,_e,je,tt);if(M===null)throw(0,C.illegalArgument)("location");this.location=M}};hi=$e([v],hi),e.SourceBreakpoint=hi;let Qt=class extends Ht{constructor(M,ee,_e,je,tt){super(ee,_e,je,tt);this.functionName=M}};Qt=$e([v],Qt),e.FunctionBreakpoint=Qt;let Yt=class extends Ht{constructor(M,ee,_e,je,tt,rt,ct){super(je,tt,rt,ct);if(!ee)throw(0,C.illegalArgument)("dataId");this.label=M,this.dataId=ee,this.canPersist=_e}};Yt=$e([v],Yt),e.DataBreakpoint=Yt;let ut=class{constructor(M,ee,_e){this.command=M,this.args=ee||[],this.options=_e}};ut=$e([v],ut),e.DebugAdapterExecutable=ut;let fi=class{constructor(M,ee){this.port=M,this.host=ee}};fi=$e([v],fi),e.DebugAdapterServer=fi;let Bt=class{constructor(M){this.path=M}};Bt=$e([v],Bt),e.DebugAdapterNamedPipeServer=Bt;let Vt=class{constructor(M){this.implementation=M}};Vt=$e([v],Vt),e.DebugAdapterInlineImplementation=Vt;let si=class{constructor(M,ee){this.range=M,this.expression=ee}};si=$e([v],si),e.EvaluatableExpression=si;var Ti;(function(x){x[x.Invoke=0]="Invoke",x[x.Automatic=1]="Automatic"})(Ti=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var _i;(function(x){x[x.Invoke=0]="Invoke",x[x.Automatic=1]="Automatic"})(_i=e.InlineCompletionTriggerKindNew||(e.InlineCompletionTriggerKindNew={}));let mi=class{constructor(M,ee){this.range=M,this.text=ee}};mi=$e([v],mi),e.InlineValueText=mi;let oi=class{constructor(M,ee,_e=!0){this.range=M,this.variableName=ee,this.caseSensitiveLookup=_e}};oi=$e([v],oi),e.InlineValueVariableLookup=oi;let Jt=class{constructor(M,ee){this.range=M,this.expression=ee}};Jt=$e([v],Jt),e.InlineValueEvaluatableExpression=Jt;let gi=class{constructor(M,ee){this.frameId=M,this.stoppedLocation=ee}};gi=$e([v],gi),e.InlineValueContext=gi;var pi;(function(x){x[x.Changed=1]="Changed",x[x.Created=2]="Created",x[x.Deleted=3]="Deleted"})(pi=e.FileChangeType||(e.FileChangeType={}));let Zt=L=class extends Error{constructor(M,ee=_.FileSystemProviderErrorCode.Unknown,_e){super(A.URI.isUri(M)?M.toString(!0):M);this.code=_e?.name??"Unknown",(0,_.markAsFileSystemProviderError)(this,ee),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,L.prototype),typeof Error.captureStackTrace=="function"&&typeof _e=="function"&&Error.captureStackTrace(this,_e)}static FileExists(M){return new L(M,_.FileSystemProviderErrorCode.FileExists,L.FileExists)}static FileNotFound(M){return new L(M,_.FileSystemProviderErrorCode.FileNotFound,L.FileNotFound)}static FileNotADirectory(M){return new L(M,_.FileSystemProviderErrorCode.FileNotADirectory,L.FileNotADirectory)}static FileIsADirectory(M){return new L(M,_.FileSystemProviderErrorCode.FileIsADirectory,L.FileIsADirectory)}static NoPermissions(M){return new L(M,_.FileSystemProviderErrorCode.NoPermissions,L.NoPermissions)}static Unavailable(M){return new L(M,_.FileSystemProviderErrorCode.Unavailable,L.Unavailable)}};Zt=L=$e([v],Zt),e.FileSystemError=Zt;let vi=class{constructor(M,ee,_e){this.start=M,this.end=ee,this.kind=_e}};vi=$e([v],vi),e.FoldingRange=vi;var ki;(function(x){x[x.Comment=1]="Comment",x[x.Imports=2]="Imports",x[x.Region=3]="Region"})(ki=e.FoldingRangeKind||(e.FoldingRangeKind={}));var ei;(function(x){x[x.Collapsed=0]="Collapsed",x[x.Expanded=1]="Expanded"})(ei=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Pi;(function(x){x[x.Editing=0]="Editing",x[x.Preview=1]="Preview"})(Pi=e.CommentMode||(e.CommentMode={}));var Ai;(function(x){x[x.Unresolved=0]="Unresolved",x[x.Resolved=1]="Resolved"})(Ai=e.CommentThreadState||(e.CommentThreadState={}));class Ri{constructor(M,ee=[]){this.tokenTypes=M,this.tokenModifiers=ee}}e.SemanticTokensLegend=Ri;function Oi(x){return typeof x=="undefined"||(0,b.isStringArray)(x)}class ti{constructor(M){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,M){this._hasLegend=!0;for(let ee=0,_e=M.tokenTypes.length;ee<_e;ee++)this._tokenTypeStrToInt.set(M.tokenTypes[ee],ee);for(let ee=0,_e=M.tokenModifiers.length;ee<_e;ee++)this._tokenModifierStrToInt.set(M.tokenModifiers[ee],ee)}}push(M,ee,_e,je,tt){if(typeof M=="number"&&typeof ee=="number"&&typeof _e=="number"&&typeof je=="number"&&(typeof tt=="number"||typeof tt=="undefined"))return typeof tt=="undefined"&&(tt=0),this._pushEncoded(M,ee,_e,je,tt);if(H.isRange(M)&&typeof ee=="string"&&Oi(_e))return this._push(M,ee,_e);throw(0,C.illegalArgument)()}_push(M,ee,_e){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(M.start.line!==M.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(ee))throw new Error("`tokenType` is not in the provided legend");const je=M.start.line,tt=M.start.character,rt=M.end.character-M.start.character,ct=this._tokenTypeStrToInt.get(ee);let St=0;if(_e)for(const Rt of _e){if(!this._tokenModifierStrToInt.has(Rt))throw new Error("`tokenModifier` is not in the provided legend");const $t=this._tokenModifierStrToInt.get(Rt);St|=1<<$t>>>0}this._pushEncoded(je,tt,rt,ct,St)}_pushEncoded(M,ee,_e,je,tt){if(this._dataIsSortedAndDeltaEncoded&&(M<this._prevLine||M===this._prevLine&&ee<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const St=this._data.length/5|0;let Rt=0,$t=0;for(let Wt=0;Wt<St;Wt++){let qt=this._data[5*Wt],bi=this._data[5*Wt+1];qt===0?(qt=Rt,bi+=$t):qt+=Rt,this._data[5*Wt]=qt,this._data[5*Wt+1]=bi,Rt=qt,$t=bi}}let rt=M,ct=ee;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(rt-=this._prevLine,rt===0&&(ct-=this._prevChar)),this._data[this._dataLen++]=rt,this._data[this._dataLen++]=ct,this._data[this._dataLen++]=_e,this._data[this._dataLen++]=je,this._data[this._dataLen++]=tt,this._prevLine=M,this._prevChar=ee}static _sortAndDeltaEncode(M){const ee=[],_e=M.length/5|0;for(let ct=0;ct<_e;ct++)ee[ct]=ct;ee.sort((ct,St)=>{const Rt=M[5*ct],$t=M[5*St];if(Rt===$t){const Wt=M[5*ct+1],qt=M[5*St+1];return Wt-qt}return Rt-$t});const je=new Uint32Array(M.length);let tt=0,rt=0;for(let ct=0;ct<_e;ct++){const St=5*ee[ct],Rt=M[St+0],$t=M[St+1],Wt=M[St+2],qt=M[St+3],bi=M[St+4],Gi=Rt-tt,gn=Gi===0?$t-rt:$t,wi=5*ct;je[wi+0]=Gi,je[wi+1]=gn,je[wi+2]=Wt,je[wi+3]=qt,je[wi+4]=bi,tt=Rt,rt=$t}return je}build(M){return this._dataIsSortedAndDeltaEncoded?new ai(new Uint32Array(this._data),M):new ai(ti._sortAndDeltaEncode(this._data),M)}}e.SemanticTokensBuilder=ti;class ai{constructor(M,ee){this.resultId=ee,this.data=M}}e.SemanticTokens=ai;class Si{constructor(M,ee,_e){this.start=M,this.deleteCount=ee,this.data=_e}}e.SemanticTokensEdit=Si;class Me{constructor(M,ee){this.resultId=ee,this.edits=M}}e.SemanticTokensEdits=Me;var xt;(function(x){x[x.Separate=0]="Separate",x[x.MergeWithParent=1]="MergeWithParent"})(xt=e.DebugConsoleMode||(e.DebugConsoleMode={}));let ii=class{constructor(){}};ii.Back={iconPath:new Ut("arrow-left")},ii=$e([v],ii),e.QuickInputButtons=ii;var Et;(function(x){x[x.Separator=-1]="Separator",x[x.Default=0]="Default"})(Et=e.QuickPickItemKind||(e.QuickPickItemKind={}));var Fi;(function(x){x[x.Info=1]="Info",x[x.Warning=2]="Warning",x[x.Error=3]="Error"})(Fi=e.InputBoxValidationSeverity||(e.InputBoxValidationSeverity={}));var Ni;(function(x){x[x.UI=1]="UI",x[x.Workspace=2]="Workspace"})(Ni=e.ExtensionKind||(e.ExtensionKind={}));class yi{constructor(M,ee,_e){this.badge=M,this.tooltip=ee,this.color=_e}static validate(M){if(M.badge){let ee=(0,P.nextCharLength)(M.badge,0);if(ee<M.badge.length&&(ee+=(0,P.nextCharLength)(M.badge,ee)),M.badge.length>ee)throw new Error("The 'badge'-property must be undefined or a short character")}if(!M.color&&!M.badge&&!M.tooltip)throw new Error("The decoration is empty");return!0}}e.FileDecoration=yi;let Ei=class{constructor(M){this.kind=M}};Ei=$e([v],Ei),e.ColorTheme=Ei;var ci;(function(x){x[x.Light=1]="Light",x[x.Dark=2]="Dark",x[x.HighContrast=3]="HighContrast",x[x.HighContrastLight=4]="HighContrastLight"})(ci=e.ColorThemeKind||(e.ColorThemeKind={}));class zt{constructor(M,ee){if(M<0)throw(0,C.illegalArgument)("start must be positive");if(ee<0)throw(0,C.illegalArgument)("end must be positive");M<=ee?(this._start=M,this._end=ee):(this._start=ee,this._end=M)}static isNotebookRange(M){return M instanceof zt?!0:M?typeof M.start=="number"&&typeof M.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(M){let ee=this._start,_e=this._end;return M.start!==void 0&&(ee=M.start),M.end!==void 0&&(_e=M.end),ee===this._start&&_e===this._end?this:new zt(ee,_e)}}e.NotebookRange=zt;class jt{constructor(M,ee,_e,je,tt,rt,ct){this.kind=M,this.value=ee,this.languageId=_e,this.mime=je,this.outputs=tt??[],this.metadata=rt,this.executionSummary=ct,jt.validate(this)}static validate(M){if(typeof M.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof M.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof M.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(M){return Array.isArray(M)&&M.every(ee=>jt.isNotebookCellData(ee))}static isNotebookCellData(M){return!0}}e.NotebookCellData=jt;class Mi{constructor(M){this.cells=M}}e.NotebookData=Mi;class Ft{constructor(M,ee){this.data=M,this.mime=ee;const _e=(0,I.normalizeMimeType)(ee,!0);if(!_e)throw new Error(`INVALID mime type: ${ee}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=_e}static isNotebookCellOutputItem(M){return M instanceof Ft?!0:M?typeof M.mime=="string"&&M.data instanceof Uint8Array:!1}static error(M){const ee={name:M.name,message:M.message,stack:M.stack};return Ft.json(ee,"application/vnd.code.notebook.error")}static stdout(M){return Ft.text(M,"application/vnd.code.notebook.stdout")}static stderr(M){return Ft.text(M,"application/vnd.code.notebook.stderr")}static bytes(M,ee="application/octet-stream"){return new Ft(M,ee)}static text(M,ee=I.Mimes.text){const _e=Ae(Ft,u,"f",l).encode(String(M));return new Ft(_e,ee)}static json(M,ee="text/x-json"){const _e=JSON.stringify(M,void 0,"	");return Ft.text(_e,ee)}}e.NotebookCellOutputItem=Ft,u=Ft,l={value:new TextEncoder};class li{constructor(M,ee,_e){this.items=li.ensureUniqueMimeTypes(M,!0),typeof ee=="string"?(this.id=ee,this.metadata=_e):(this.id=(0,R.generateUuid)(),this.metadata=ee??_e)}static isNotebookCellOutput(M){return M instanceof li?!0:!M||typeof M!="object"?!1:typeof M.id=="string"&&(0,b.isArray)(M.items)}static ensureUniqueMimeTypes(M,ee=!1){const _e=new Set,je=new Set;for(let tt=0;tt<M.length;tt++){const rt=M[tt],ct=(0,I.normalizeMimeType)(rt.mime);if(!_e.has(ct)){_e.add(ct);continue}je.add(tt),ee&&console.warn(`DUPLICATED mime type '${rt.mime}' will be dropped`)}return je.size===0?M:M.filter((tt,rt)=>!je.has(rt))}}e.NotebookCellOutput=li;var Li;(function(x){x[x.Markup=1]="Markup",x[x.Code=2]="Code"})(Li=e.NotebookCellKind||(e.NotebookCellKind={}));var Ui;(function(x){x[x.Idle=1]="Idle",x[x.Pending=2]="Pending",x[x.Executing=3]="Executing"})(Ui=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Bi;(function(x){x[x.Left=1]="Left",x[x.Right=2]="Right"})(Bi=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var zi;(function(x){x[x.Default=0]="Default",x[x.InCenter=1]="InCenter",x[x.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",x[x.AtTop=3]="AtTop"})(zi=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class ie{constructor(M,ee){this.text=M,this.alignment=ee}}e.NotebookCellStatusBarItem=ie;var de;(function(x){x[x.Default=1]="Default",x[x.Preferred=2]="Preferred"})(de=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class Oe{constructor(M,ee=[]){this.uri=M,this.provides=(0,o.asArray)(ee)}}e.NotebookRendererScript=Oe;let it=class{constructor(M,ee){this.label=M,this.timestamp=ee}};it=$e([v],it),e.TimelineItem=it;var wt;(function(x){x[x.Production=1]="Production",x[x.Development=2]="Development",x[x.Test=3]="Test"})(wt=e.ExtensionMode||(e.ExtensionMode={}));var Tt;(function(x){x[x.Node=1]="Node",x[x.Webworker=2]="Webworker"})(Tt=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Ji;(function(x){x[x.Other=0]="Other",x[x.Comment=1]="Comment",x[x.String=2]="String",x[x.RegEx=3]="RegEx"})(Ji=e.StandardTokenType||(e.StandardTokenType={}));class Zi{constructor(M,ee){this.ranges=M,this.wordPattern=ee}}e.LinkedEditingRanges=Zi;class en{constructor(M,ee){this._port=M,this._autoForwardAction=ee}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=en;var tn;(function(x){x[x.Queued=1]="Queued",x[x.Running=2]="Running",x[x.Passed=3]="Passed",x[x.Failed=4]="Failed",x[x.Skipped=5]="Skipped",x[x.Errored=6]="Errored"})(tn=e.TestResultState||(e.TestResultState={}));var nn;(function(x){x[x.Run=1]="Run",x[x.Debug=2]="Debug",x[x.Coverage=3]="Coverage"})(nn=e.TestRunProfileKind||(e.TestRunProfileKind={}));let $i=class{constructor(M=void 0,ee=void 0,_e=void 0){this.include=M,this.exclude=ee,this.profile=_e}};$i=$e([v],$i),e.TestRunRequest=$i;let xi=W=class{constructor(M){this.message=M}static diff(M,ee,_e){const je=new W(M);return je.expectedOutput=ee,je.actualOutput=_e,je}};xi=W=$e([v],xi),e.TestMessage=xi;let Wi=class{constructor(M){this.id=M}};Wi=$e([v],Wi),e.TestTag=Wi;let ui=class{constructor(M,ee){this.covered=M,this.total=ee}};ui=$e([v],ui),e.CoveredCount=ui;let Hi=N=class{constructor(M,ee,_e,je){this.uri=M,this.statementCoverage=ee,this.branchCoverage=_e,this.functionCoverage=je}static fromDetails(M,ee){const _e=new ui(0,0),je=new ui(0,0),tt=new ui(0,0);for(const ct of ee)if("branches"in ct){_e.total+=1,_e.covered+=ct.executionCount>0?1:0;for(const St of ct.branches)je.total+=1,je.covered+=St.executionCount>0?1:0}else tt.total+=1,tt.covered+=ct.executionCount>0?1:0;const rt=new N(M,_e,je.total>0?je:void 0,tt.total>0?tt:void 0);return rt.detailedCoverage=ee,rt}};Hi=N=$e([v],Hi),e.FileCoverage=Hi;let Vi=class{constructor(M,ee,_e=[]){this.executionCount=M,this.location=ee,this.branches=_e}};Vi=$e([v],Vi),e.StatementCoverage=Vi;let ji=class{constructor(M,ee){this.executionCount=M,this.location=ee}};ji=$e([v],ji),e.BranchCoverage=ji;let qi=class{constructor(M,ee){this.executionCount=M,this.location=ee}};qi=$e([v],qi),e.FunctionCoverage=qi;var rn;(function(x){x[x.None=0]="None",x[x.Option=1]="Option",x[x.Default=2]="Default",x[x.Preferred=3]="Preferred"})(rn=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var sn;(function(x){x[x.Untrusted=0]="Untrusted",x[x.Trusted=1]="Trusted",x[x.Unspecified=2]="Unspecified"})(sn=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var on;(function(x){x[x.Notify=1]="Notify",x[x.OpenBrowser=2]="OpenBrowser",x[x.OpenPreview=3]="OpenPreview",x[x.Silent=4]="Silent",x[x.Ignore=5]="Ignore",x[x.OpenBrowserOnce=6]="OpenBrowserOnce"})(on=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class an{constructor(M,ee,_e,je,tt,rt){this.kind=M,this.name=ee,this.detail=_e,this.uri=je,this.range=tt,this.selectionRange=rt}}e.TypeHierarchyItem=an;class cn{constructor(M){this.uri=M}}e.TextTabInput=cn;class ln{constructor(M,ee){this.original=M,this.modified=ee}}e.TextDiffTabInput=ln;class un{constructor(M,ee){this.uri=M,this.viewType=ee}}e.CustomEditorTabInput=un;class dn{constructor(M){this.viewType=M}}e.WebviewEditorTabInput=dn;class hn{constructor(M,ee){this.uri=M,this.notebookType=ee}}e.NotebookEditorTabInput=hn;class fn{constructor(M,ee,_e){this.original=M,this.modified=ee,this.notebookType=_e}}e.NotebookDiffEditorTabInput=fn;class mn{constructor(){}}e.TerminalEditorTabInput=mn}),define(De[87],Ce([1,0,42,12,10,239,121,6,16]),function(J,e,o,C,p,U,I,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const A=new Map;function R(g,h){h?A.set(g,h):A.delete(g)}e.setWordDefinitionFor=R;function _(g){return A.get(g)}e.getWordDefinitionFor=_;class m extends U.MirrorTextModel{constructor(h,u,l,S,w,a,y,r){super(u,l,S,w);this._proxy=h,this._languageId=a,this._isDirty=y,this.notebook=r,this._isDisposed=!1}dispose(){(0,o.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(h){return(0,b.equals)(this._lines,h)}get document(){if(!this._document){const h=this;this._document={get uri(){return h._uri},get fileName(){return h._uri.fsPath},get isUntitled(){return h._uri.scheme===C.Schemas.untitled},get languageId(){return h._languageId},get version(){return h._versionId},get isClosed(){return h._isDisposed},get isDirty(){return h._isDirty},save(){return h._save()},getText(u){return u?h._getTextInRange(u):h.getText()},get eol(){return h._eol===`
`?P.EndOfLine.LF:P.EndOfLine.CRLF},get lineCount(){return h._lines.length},lineAt(u){return h._lineAt(u)},offsetAt(u){return h._offsetAt(u)},positionAt(u){return h._positionAt(u)},validateRange(u){return h._validateRange(u)},validatePosition(u){return h._validatePosition(u)},getWordRangeAtPosition(u,l){return h._getWordRangeAtPosition(u,l)}}}return Object.freeze(this._document)}_acceptLanguageId(h){(0,o.ok)(!this._isDisposed),this._languageId=h}_acceptIsDirty(h){(0,o.ok)(!this._isDisposed),this._isDirty=h}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(h){const u=this._validateRange(h);if(u.isEmpty)return"";if(u.isSingleLine)return this._lines[u.start.line].substring(u.start.character,u.end.character);const l=this._eol,S=u.start.line,w=u.end.line,a=[];a.push(this._lines[S].substring(u.start.character));for(let y=S+1;y<w;y++)a.push(this._lines[y]);return a.push(this._lines[w].substring(0,u.end.character)),a.join(l)}_lineAt(h){let u;if(h instanceof P.Position?u=h.line:typeof h=="number"&&(u=h),typeof u!="number"||u<0||u>=this._lines.length||Math.floor(u)!==u)throw new Error("Illegal value for `line`");return new T(u,this._lines[u],u===this._lines.length-1)}_offsetAt(h){return h=this._validatePosition(h),this._ensureLineStarts(),this._lineStarts.getPrefixSum(h.line-1)+h.character}_positionAt(h){h=Math.floor(h),h=Math.max(0,h),this._ensureLineStarts();const u=this._lineStarts.getIndexOf(h),l=this._lines[u.index].length;return new P.Position(u.index,Math.min(u.remainder,l))}_validateRange(h){if(!(h instanceof P.Range))throw new Error("Invalid argument");const u=this._validatePosition(h.start),l=this._validatePosition(h.end);return u===h.start&&l===h.end?h:new P.Range(u.line,u.character,l.line,l.character)}_validatePosition(h){if(!(h instanceof P.Position))throw new Error("Invalid argument");if(this._lines.length===0)return h.with(0,0);let{line:u,character:l}=h,S=!1;if(u<0)u=0,l=0,S=!0;else if(u>=this._lines.length)u=this._lines.length-1,l=this._lines[u].length,S=!0;else{const w=this._lines[u].length;l<0?(l=0,S=!0):l>w&&(l=w,S=!0)}return S?new P.Position(u,l):h}_getWordRangeAtPosition(h,u){const l=this._validatePosition(h);if(!u)u=_(this._languageId);else if((0,p.regExpLeadsToEndlessLoop)(u))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${u.source}' because it matches the empty string.`);const S=(0,I.getWordAtText)(l.character+1,(0,I.ensureValidWordDefinition)(u),this._lines[l.line],0);if(S)return new P.Range(l.line,S.startColumn-1,l.line,S.endColumn-1)}}e.ExtHostDocumentData=m;class T{constructor(h,u,l){this._line=h,this._text=u,this._isLastLine=l}get lineNumber(){return this._line}get text(){return this._text}get range(){return new P.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new P.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=T}),define(De[160],Ce([1,0,6,15,4]),function(J,e,o,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let U=class{constructor(P){this._actual=new o.ColorTheme(o.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new p.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(P){let b;switch(P){case"light":b=o.ColorThemeKind.Light;break;case"hcDark":b=o.ColorThemeKind.HighContrast;break;case"hcLight":b=o.ColorThemeKind.HighContrastLight;break;default:b=o.ColorThemeKind.Dark}this._actual=new o.ColorTheme(b),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};U=$e([xe(0,C.IExtHostRpcService)],U),e.ExtHostTheming=U}),define(De[63],Ce([1,0,3]),function(J,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,o.createDecorator)("IURITransformerService");class C{constructor(U){U?(this.transformIncoming=U.transformIncoming.bind(U),this.transformOutgoing=U.transformOutgoing.bind(U),this.transformOutgoingURI=U.transformOutgoingURI.bind(U),this.transformOutgoingScheme=U.transformOutgoingScheme.bind(U)):(this.transformIncoming=I=>I,this.transformOutgoing=I=>I,this.transformOutgoingURI=I=>I,this.transformOutgoingScheme=I=>I)}}e.URITransformerService=C}),define(De[161],Ce([1,0,23]),function(J,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class C{constructor(){this.buffers=[]}add(b){let A=this.buffers.indexOf(b);return A<0&&(A=this.buffers.length,this.buffers.push(b)),A}}function p(P,b){if(b.serializeBuffersForPostMessage){const A=new C,R=(T,g)=>{if(g instanceof ArrayBuffer){const h=A.add(g);return{$$vscode_array_buffer_reference$$:!0,index:h}}else if(ArrayBuffer.isView(g)){const h=U(g);if(h){const u=A.add(g.buffer);return{$$vscode_array_buffer_reference$$:!0,index:u,view:{type:h,byteLength:g.byteLength,byteOffset:g.byteOffset}}}}return g},_=JSON.stringify(P,R),m=A.buffers.map(T=>{const g=new Uint8Array(T);return o.VSBuffer.wrap(g)});return{message:_,buffers:m}}else return{message:JSON.stringify(P),buffers:[]}}e.serializeWebviewMessage=p;function U(P){switch(P.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function I(P,b){const A=b.map(m=>{const T=new ArrayBuffer(m.byteLength);return new Uint8Array(T).set(m.buffer),T}),R=b.length?(m,T)=>{if(T&&typeof T=="object"&&T.$$vscode_array_buffer_reference$$){const g=T,{index:h}=g,u=A[h];if(g.view)switch(g.view.type){case 1:return new Int8Array(u,g.view.byteOffset,g.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(u,g.view.byteOffset,g.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(u,g.view.byteOffset,g.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(u,g.view.byteOffset,g.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(u,g.view.byteOffset,g.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(u,g.view.byteOffset,g.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(u,g.view.byteOffset,g.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(u,g.view.byteOffset,g.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(u,g.view.byteOffset,g.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(u,g.view.byteOffset,g.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(u,g.view.byteOffset,g.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return u}return T}:void 0;return{message:JSON.parse(P,R),arrayBuffers:A}}e.deserializeWebviewMessage=I}),define(De[162],Ce([1,0,135,9,2,7,3,30,39,16,12]),function(J,e,o,C,p,U,I,P,b,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,o.localize)(0,null),providerDisplayName:(0,o.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var _;(function(z){z[z.PROGRAMMATIC=1]="PROGRAMMATIC",z[z.USER=2]="USER",z[z.EDIT=3]="EDIT",z[z.NAVIGATION=4]="NAVIGATION",z[z.JUMP=5]="JUMP"})(_=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var m;(function(z){z[z.IDENTICAL=1]="IDENTICAL",z[z.SIMILAR=2]="SIMILAR",z[z.DIFFERENT=3]="DIFFERENT"})(m=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function T(z){const $=z;return!!$&&typeof $.getSelection=="function"&&!!$.onDidChangeSelection}e.isEditorPaneWithSelection=T;function g(z,$,ce){for(const le of ce.visibleEditorPanes)if(le.group.id===$&&z.matches(le.input))return le.getViewState()}e.findViewStateForEditor=g;function h(z){if(i(z))return!1;const $=z;return p.URI.isUri($?.resource)}e.isResourceEditorInput=h;function u(z){if(i(z))return!1;const $=z;return $?.original!==void 0&&$.modified!==void 0}e.isResourceDiffEditorInput=u;function l(z){if(i(z)||u(z))return!1;const $=z;return $?.primary!==void 0&&$.secondary!==void 0}e.isResourceSideBySideEditorInput=l;function S(z){if(i(z))return!1;const $=z;return $?$.resource===void 0||$.resource.scheme===R.Schemas.untitled||$.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=S;var w;(function(z){z[z.SHORT=0]="SHORT",z[z.MEDIUM=1]="MEDIUM",z[z.LONG=2]="LONG"})(w=e.Verbosity||(e.Verbosity={}));var a;(function(z){z[z.EXPLICIT=1]="EXPLICIT",z[z.AUTO=2]="AUTO",z[z.FOCUS_CHANGE=3]="FOCUS_CHANGE",z[z.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(a=e.SaveReason||(e.SaveReason={}));class y{constructor(){this.mapIdToSaveSource=new Map}registerSource($,ce){let le=this.mapIdToSaveSource.get($);return le||(le={source:$,label:ce},this.mapIdToSaveSource.set($,le)),le.source}getSourceLabel($){return this.mapIdToSaveSource.get($)?.label??$}}e.SaveSourceRegistry=new y;var r;(function(z){z[z.None=0]="None",z[z.Readonly=2]="Readonly",z[z.Untitled=4]="Untitled",z[z.Singleton=8]="Singleton",z[z.RequiresTrust=16]="RequiresTrust",z[z.CanSplitInGroup=32]="CanSplitInGroup",z[z.ForceDescription=64]="ForceDescription",z[z.CanDropIntoEditor=128]="CanDropIntoEditor"})(r=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class d extends U.Disposable{}e.AbstractEditorInput=d;function i(z){return z instanceof d}e.isEditorInput=i;function s(z){const $=z;return p.URI.isUri($?.preferredResource)}function n(z){const $=z;return i($?.primary)&&i($?.secondary)}e.isSideBySideEditorInput=n;function t(z){const $=z;return i($?.modified)&&i($?.original)}e.isDiffEditorInput=t;function c(z){return i(z?.editor)}e.isEditorInputWithOptions=c;function E(z){const $=z;return c(z)&&$?.group!==void 0}e.isEditorInputWithOptionsAndGroup=E;function f(z){const $=z;return typeof $?.groupId=="number"&&i($.editor)}e.isEditorIdentifier=f;var D;(function(z){z[z.UNKNOWN=0]="UNKNOWN",z[z.REPLACE=1]="REPLACE",z[z.MOVE=2]="MOVE",z[z.UNPIN=3]="UNPIN"})(D=e.EditorCloseContext||(e.EditorCloseContext={}));var L;(function(z){z[z.GROUP_ACTIVE=0]="GROUP_ACTIVE",z[z.GROUP_INDEX=1]="GROUP_INDEX",z[z.GROUP_LOCKED=2]="GROUP_LOCKED",z[z.EDITOR_OPEN=3]="EDITOR_OPEN",z[z.EDITOR_CLOSE=4]="EDITOR_CLOSE",z[z.EDITOR_MOVE=5]="EDITOR_MOVE",z[z.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",z[z.EDITOR_LABEL=7]="EDITOR_LABEL",z[z.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",z[z.EDITOR_PIN=9]="EDITOR_PIN",z[z.EDITOR_STICKY=10]="EDITOR_STICKY",z[z.EDITOR_DIRTY=11]="EDITOR_DIRTY",z[z.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(L=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var W;(function(z){z[z.PRIMARY=1]="PRIMARY",z[z.SECONDARY=2]="SECONDARY",z[z.BOTH=3]="BOTH",z[z.ANY=4]="ANY"})(W=e.SideBySideEditor||(e.SideBySideEditor={}));class N{getOriginalUri($,ce){if(!$)return;if(ce?.supportSideBySide){const{primary:oe,secondary:pe}=this.getSideEditors($);if(oe&&pe){if(ce?.supportSideBySide===W.BOTH)return{primary:this.getOriginalUri(oe,{filterByScheme:ce.filterByScheme}),secondary:this.getOriginalUri(pe,{filterByScheme:ce.filterByScheme})};if(ce?.supportSideBySide===W.ANY)return this.getOriginalUri(oe,{filterByScheme:ce.filterByScheme})??this.getOriginalUri(pe,{filterByScheme:ce.filterByScheme});$=ce.supportSideBySide===W.PRIMARY?oe:pe}}if(u($)||l($))return;const le=s($)?$.preferredResource:$.resource;return!le||!ce||!ce.filterByScheme?le:this.filterUri(le,ce.filterByScheme)}getSideEditors($){return n($)||l($)?{primary:$.primary,secondary:$.secondary}:t($)||u($)?{primary:$.modified,secondary:$.original}:{primary:void 0,secondary:void 0}}getCanonicalUri($,ce){if(!$)return;if(ce?.supportSideBySide){const{primary:oe,secondary:pe}=this.getSideEditors($);if(oe&&pe){if(ce?.supportSideBySide===W.BOTH)return{primary:this.getCanonicalUri(oe,{filterByScheme:ce.filterByScheme}),secondary:this.getCanonicalUri(pe,{filterByScheme:ce.filterByScheme})};if(ce?.supportSideBySide===W.ANY)return this.getCanonicalUri(oe,{filterByScheme:ce.filterByScheme})??this.getCanonicalUri(pe,{filterByScheme:ce.filterByScheme});$=ce.supportSideBySide===W.PRIMARY?oe:pe}}if(u($)||l($))return;const le=$.resource;return!le||!ce||!ce.filterByScheme?le:this.filterUri(le,ce.filterByScheme)}filterUri($,ce){if(Array.isArray(ce)){if(ce.some(le=>$.scheme===le))return $}else if(ce===$.scheme)return $}}e.EditorResourceAccessor=new N;var v;(function(z){z[z.LEFT=0]="LEFT",z[z.RIGHT=1]="RIGHT"})(v=e.CloseDirection||(e.CloseDirection={}));class F{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start($){const ce=this.instantiationService=$.get(I.IInstantiationService);for(const[le,oe]of this.editorSerializerConstructors)this.createEditorSerializer(le,oe,ce);this.editorSerializerConstructors.clear()}createEditorSerializer($,ce,le){const oe=le.createInstance(ce);this.editorSerializerInstances.set($,oe)}registerFileEditorFactory($){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=$}getFileEditorFactory(){return(0,C.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer($,ce){if(this.editorSerializerConstructors.has($)||this.editorSerializerInstances.has($))throw new Error(`A editor serializer with type ID '${$}' was already registered.`);return this.instantiationService?this.createEditorSerializer($,ce,this.instantiationService):this.editorSerializerConstructors.set($,ce),(0,U.toDisposable)(()=>{this.editorSerializerConstructors.delete($),this.editorSerializerInstances.delete($)})}getEditorSerializer($){return this.editorSerializerInstances.get(typeof $=="string"?$:$.typeId)}}P.Registry.add(e.EditorExtensions.EditorFactory,new F);async function O(z,$){if(!z||!z.length)return[];const ce=await Promise.all(z.map(async le=>{const oe=p.URI.revive(le.fileUri);if(!oe||!await $.canHandleResource(oe))return;let re=le.exists,Ee=le.type;if(typeof re!="boolean"||typeof Ee!="number")try{Ee=(await $.stat(oe)).isDirectory?b.FileType.Directory:b.FileType.Unknown,re=!0}catch{re=!1}if(!re&&le.openOnlyIfExists||Ee===b.FileType.Directory)return;const be={...le.options,pinned:!0};let Z;return re?Z={resource:oe,options:be}:Z={resource:oe,options:be,forceUntitled:!0},Z}));return(0,A.coalesce)(ce)}e.pathsToEditors=O;var H;(function(z){z[z.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",z[z.SEQUENTIAL=1]="SEQUENTIAL"})(H=e.EditorsOrder||(e.EditorsOrder={}));function te(z){const $=z;if(!$)return!1;const ce=$;if(ce.modified)return te(ce.modified);const le=$;return!!(le.contributionsState&&le.viewState&&Array.isArray(le.cursorState))}e.isTextEditorViewState=te}),define(De[64],Ce([1,0,12,2]),function(J,e,o,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function p(P,b){return P.scheme===o.Schemas.http||P.scheme===o.Schemas.https?P:(b&&b.authority&&b.isRemote&&P.scheme===o.Schemas.file&&(P=C.URI.from({scheme:o.Schemas.vscodeRemote,authority:b.authority,path:P.path})),C.URI.from({scheme:o.Schemas.https,authority:`${P.scheme}+${U(P.authority)}.${e.webviewRootResourceAuthority}`,path:P.path,fragment:P.fragment,query:P.query}))}e.asWebviewUri=p;function U(P){return P.replace(/./g,b=>{const A=b.charCodeAt(0);return A>=97&&A<=122||A>=65&&A<=90||A>=48&&A<=57?b:"-"+A.toString(16).padStart(4,"0")})}function I(P){return P.replace(/-([0-9a-f]{4})/g,(b,A)=>String.fromCharCode(parseInt(A,16)))}e.decodeAuthority=I}),define(De[163],Ce([1,0,4,7,64]),function(J,e,o,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class U{constructor(P,b,A){this._proxy=P,this._editors=b,this._remoteInfo=A,this._handlePool=0,this._disposables=new C.DisposableStore,this._insets=new Map,this._disposables.add(b.onDidChangeVisibleTextEditors(()=>{const R=b.getVisibleTextEditors();for(const _ of this._insets.values())R.indexOf(_.editor)<0&&_.inset.dispose()}))}dispose(){this._insets.forEach(P=>P.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(P,b,A,R,_){let m;for(const w of this._editors.getVisibleTextEditors(!0))if(w.value===P){m=w;break}if(!m)throw new Error("not a visible editor");const T=this,g=this._handlePool++,h=new o.Emitter,u=new o.Emitter,l=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(w){return(0,p.asWebviewUri)(w,T._remoteInfo)}get cspSource(){return p.webviewGenericCspSource}set options(w){this._options=w,T._proxy.$setOptions(g,w)}get options(){return this._options}set html(w){this._html=w,T._proxy.$setHtml(g,w)}get html(){return this._html}get onDidReceiveMessage(){return h.event}postMessage(w){return T._proxy.$postMessage(g,w)}},S=new class{constructor(){this.editor=P,this.line=b,this.height=A,this.webview=l,this.onDidDispose=u.event}dispose(){T._insets.has(g)&&(T._insets.delete(g),T._proxy.$disposeEditorInset(g),u.fire(),u.dispose(),h.dispose())}};return this._proxy.$createEditorInset(g,m.id,m.value.document.uri,b+1,A,R||{},_.identifier,_.extensionLocation),this._insets.set(g,{editor:P,inset:S,onDidReceiveMessage:h}),S}$onDidDispose(P){const b=this._insets.get(P);b&&b.inset.dispose()}$onDidReceiveMessage(P,b){this._insets.get(P)?.onDidReceiveMessage.fire(b)}}e.ExtHostEditorInsets=U}),define(De[164],Ce([1,0,4,13,136]),function(J,e,o,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class U{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new o.Emitter,this._onExit=new o.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(P){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=P}onEvent(P){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=P}onRequest(P){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=P}sendResponse(P){P.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${P.command}`)):this.internalSend("response",P)}sendRequest(P,b,A,R){const _={command:P};if(b&&Object.keys(b).length>0&&(_.arguments=b),this.internalSend("request",_),typeof R=="number"){const m=setTimeout(()=>{clearTimeout(m);const T=this.pendingRequests.get(_.seq);if(T){this.pendingRequests.delete(_.seq);const g={type:"response",seq:0,request_seq:_.seq,success:!1,command:P,message:(0,p.localize)(0,null,R,P)};T(g)}},R)}return A&&this.pendingRequests.set(_.seq,A),_.seq}acceptMessage(P){this.messageCallback?this.messageCallback(P):(this.queue.push(P),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(P,b){return P.type!=="event"||b.type!=="event"}async processQueue(){let P;for(;this.queue.length;){if((!P||this.needsTaskBoundaryBetween(this.queue[0],P))&&await(0,C.timeout)(0),P=this.queue.shift(),!P)return;switch(P.type){case"event":this.eventCallback?.(P);break;case"request":this.requestCallback?.(P);break;case"response":{const b=P,A=this.pendingRequests.get(b.request_seq);A&&(this.pendingRequests.delete(b.request_seq),A(b));break}}}}internalSend(P,b){b.type=P,b.seq=this.sequence++,this.sendMessage(b)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const P=new Map;this.pendingRequests.forEach((b,A)=>P.set(A,b)),await(0,C.timeout)(500),P.forEach((b,A)=>{b({type:"response",seq:0,request_seq:A,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(A)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=U}),define(De[165],Ce([1,0,137,38,3]),function(J,e,o,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebuggerUiMessage=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ACCESS_TYPE=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.DEBUG_SERVICE_ID=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.DEBUG_SERVICE_ID="debugService",e.CONTEXT_DEBUG_TYPE=new C.RawContextKey("debugType",void 0,{type:"string",description:o.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new C.RawContextKey("debugConfigurationType",void 0,{type:"string",description:o.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new C.RawContextKey("debugState","inactive",{type:"string",description:o.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new C.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:o.localize(3,null)}),e.CONTEXT_IN_DEBUG_MODE=new C.RawContextKey("inDebugMode",!1,{type:"boolean",description:o.localize(4,null)}),e.CONTEXT_IN_DEBUG_REPL=new C.RawContextKey("inDebugRepl",!1,{type:"boolean",description:o.localize(5,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new C.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:o.localize(6,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new C.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:o.localize(7,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new C.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:o.localize(8,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new C.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:o.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new C.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:o.localize(10,null)}),e.CONTEXT_VARIABLES_FOCUSED=new C.RawContextKey("variablesFocused",!0,{type:"boolean",description:o.localize(11,null)}),e.CONTEXT_EXPRESSION_SELECTED=new C.RawContextKey("expressionSelected",!1,{type:"boolean",description:o.localize(12,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new C.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:o.localize(13,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new C.RawContextKey("callStackItemType",void 0,{type:"string",description:o.localize(14,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new C.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:o.localize(15,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new C.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:o.localize(16,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new C.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:o.localize(17,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new C.RawContextKey("watchItemType",void 0,{type:"string",description:o.localize(18,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new C.RawContextKey("canViewMemory",void 0,{type:"boolean",description:o.localize(19,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new C.RawContextKey("breakpointItemType",void 0,{type:"string",description:o.localize(20,null)}),e.CONTEXT_BREAKPOINT_ACCESS_TYPE=new C.RawContextKey("breakpointAccessType",void 0,{type:"string",description:o.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new C.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:o.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new C.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:o.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new C.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:o.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new C.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:o.localize(25,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new C.RawContextKey("stepBackSupported",!1,{type:"boolean",description:o.localize(26,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new C.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:o.localize(27,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new C.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:o.localize(28,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new C.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:o.localize(29,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new C.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:o.localize(30,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new C.RawContextKey("breakpointsExist",!1,{type:"boolean",description:o.localize(31,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new C.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:o.localize(32,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new C.RawContextKey("debugExtensionAvailable",!1,{type:"boolean",description:o.localize(33,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new C.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:o.localize(34,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new C.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:o.localize(35,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new C.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:o.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new C.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:o.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new C.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:o.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new C.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:o.localize(39,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new C.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:o.localize(40,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new C.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:o.localize(41,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new C.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:o.localize(42,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new C.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:o.localize(43,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new C.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:o.localize(44,null)}),e.CONTEXT_MULTI_SESSION_REPL=new C.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:o.localize(45,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new C.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:o.localize(46,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new C.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:o.localize(47,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new C.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:o.localize(48,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new C.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:o.localize(49,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new C.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:o.localize(50,null)});const U=m=>o.localize(51,null,m);e.debuggerDisabledMessage=U,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:o.localize(52,null)};var I;(function(m){m[m.Inactive=0]="Inactive",m[m.Initializing=1]="Initializing",m[m.Stopped=2]="Stopped",m[m.Running=3]="Running"})(I=e.State||(e.State={}));function P(m){switch(m){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=P;var b;(function(m){m[m.Valid=0]="Valid",m[m.Unreadable=1]="Unreadable",m[m.Error=2]="Error"})(b=e.MemoryRangeType||(e.MemoryRangeType={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var A;(function(m){m[m.Initial=1]="Initial",m[m.Dynamic=2]="Dynamic"})(A=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));var R;(function(m){m.UnverifiedBreakpoints="unverifiedBreakpoints"})(R=e.DebuggerUiMessage||(e.DebuggerUiMessage={})),e.IDebugService=(0,p.createDecorator)(e.DEBUG_SERVICE_ID);var _;(function(m){m[m.CONDITION=0]="CONDITION",m[m.HIT_COUNT=1]="HIT_COUNT",m[m.LOG_MESSAGE=2]="LOG_MESSAGE"})(_=e.BreakpointWidgetContext||(e.BreakpointWidgetContext={}))}),define(De[166],Ce([1,0,10,2,19,26,12]),function(J,e,o,C,p,U,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const P=/{([^}]+)}/g;function b(i,s,n){return i.replace(P,function(t,c){return s&&c.length>0&&c[0]!=="_"?t:n&&n.hasOwnProperty(c)?n[c]:t})}e.formatPII=b;function A(i){const s={};for(const n of Object.keys(i))n.startsWith("!")||(s[n]=i[n]);return s}e.filterExceptionsFromTelemetry=A;function R(i){return i.configuration.request==="attach"&&!_(i)&&(!i.parentSession||R(i.parentSession))}e.isSessionAttach=R;function _(i){let s=i.configuration.type;if(!!s)return s==="vslsShare"&&(s=i.configuration.adapterProxy.configuration.type),(0,o.equalsIgnoreCase)(s,"extensionhost")||(0,o.equalsIgnoreCase)(s,"pwa-extensionhost")?i:i.parentSession?_(i.parentSession):void 0}e.getExtensionHostDebugSession=_;function m(i){return i.type&&(i.label||i.program||i.runtime)}e.isDebuggerMainContribution=m;function T(i,s,n){let t,c=0;const E=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let f=null;for(;f=E.exec(i);){const D=f.index+1,L=D+f[0].length;if(D<=s&&L>=n){t=f[0],c=D;break}}if(t){const D=/\w+/g;let L=null;for(;(L=D.exec(t))&&!(L.index+1+c+L[0].length>=n););L&&(t=t.substring(0,D.lastIndex))}return t?{start:c,end:c+t.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=T;const g=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function h(i){return!!(i&&i.match(g))}e.isUri=h;function u(i){if(typeof i.path=="string"&&!(typeof i.sourceReference=="number"&&i.sourceReference>0)){if(h(i.path))return C.URI.parse(i.path);if((0,p.isAbsolute)(i.path))return C.URI.file(i.path)}return i.path}function l(i){if(typeof i.path=="object"){const s=C.URI.revive(i.path);if(s)return s.scheme===I.Schemas.file?s.fsPath:s.toString()}return i.path}function S(i,s){const n=s?u:l,t=(0,U.deepClone)(i);return a(t,(c,E)=>{c&&E&&(E.path=n(E))}),t}e.convertToDAPaths=S;function w(i,s){const n=s?u:l,t=(0,U.deepClone)(i);return a(t,(c,E)=>{!c&&E&&(E.path=n(E))}),t}e.convertToVSCPaths=w;function a(i,s){switch(i.type){case"event":{const n=i;switch(n.event){case"output":s(!1,n.body.source);break;case"loadedSource":s(!1,n.body.source);break;case"breakpoint":s(!1,n.body.breakpoint.source);break;default:break}break}case"request":{const n=i;switch(n.command){case"setBreakpoints":s(!0,n.arguments.source);break;case"breakpointLocations":s(!0,n.arguments.source);break;case"source":s(!0,n.arguments.source);break;case"gotoTargets":s(!0,n.arguments.source);break;case"launchVSCode":n.arguments.args.forEach(t=>s(!1,t));break;default:break}break}case"response":{const n=i;if(n.success&&n.body)switch(n.command){case"stackTrace":n.body.stackFrames.forEach(t=>s(!1,t.source));break;case"loadedSources":n.body.sources.forEach(t=>s(!1,t));break;case"scopes":n.body.scopes.forEach(t=>s(!1,t.source));break;case"setFunctionBreakpoints":n.body.breakpoints.forEach(t=>s(!1,t.source));break;case"setBreakpoints":n.body.breakpoints.forEach(t=>s(!1,t.source));break;case"disassemble":n.body?.instructions.forEach(c=>s(!1,c.location));break;default:break}break}}}function y(i){return i.filter(s=>!s.presentation?.hidden).sort((s,n)=>s.presentation?n.presentation?s.presentation.group?n.presentation.group?s.presentation.group!==n.presentation.group?s.presentation.group.localeCompare(n.presentation.group):r(s.presentation.order,n.presentation.order):-1:n.presentation.group?1:r(s.presentation.order,n.presentation.order):-1:n.presentation?1:0)}e.getVisibleAndSorted=y;function r(i,s){return typeof i!="number"?typeof s!="number"?0:1:typeof s!="number"?-1:i-s}async function d(i,s){const n=i.getValue("debug.saveBeforeStart",{overrideIdentifier:s.activeTextEditorLanguageId});if(n!=="none"&&(await s.saveAll(),n==="allEditorsInActiveGroup")){const t=s.activeEditorPane;t&&t.input.resource?.scheme===I.Schemas.untitled&&await s.save({editor:t.input,groupId:t.group.id})}await i.reloadConfiguration()}e.saveAllBeforeDebugStart=d}),define(De[88],Ce([1,0,34,167,74,12,19,22,38]),function(J,e,o,C,p,U,I,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor";var A;(function(n){n[n.Markup=1]="Markup",n[n.Code=2]="Code"})(A=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",p.Mimes.latex,p.Mimes.markdown,"image/png","image/jpeg",p.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[p.Mimes.latex,p.Mimes.markdown,"application/json",p.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var R;(function(n){n[n.Running=1]="Running",n[n.Idle=2]="Idle"})(R=e.NotebookRunState||(e.NotebookRunState={}));var _;(function(n){n[n.Unconfirmed=1]="Unconfirmed",n[n.Pending=2]="Pending",n[n.Executing=3]="Executing"})(_=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var m;(function(n){n[n.WithHardKernelDependency=0]="WithHardKernelDependency",n[n.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",n[n.Pure=2]="Pure",n[n.Never=3]="Never"})(m=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var T;(function(n){n.Always="always",n.Never="never",n.Optional="optional"})(T=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var g;(function(n){n[n.ModelChange=1]="ModelChange",n[n.Move=2]="Move",n[n.ChangeCellLanguage=5]="ChangeCellLanguage",n[n.Initialize=6]="Initialize",n[n.ChangeCellMetadata=7]="ChangeCellMetadata",n[n.Output=8]="Output",n[n.OutputItem=9]="OutputItem",n[n.ChangeCellContent=10]="ChangeCellContent",n[n.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",n[n.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",n[n.ChangeCellMime=13]="ChangeCellMime",n[n.Unknown=100]="Unknown"})(g=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var h;(function(n){n[n.Handle=0]="Handle",n[n.Index=1]="Index"})(h=e.SelectionStateType||(e.SelectionStateType={}));var u;(function(n){n[n.Replace=1]="Replace",n[n.Output=2]="Output",n[n.Metadata=3]="Metadata",n[n.CellLanguage=4]="CellLanguage",n[n.DocumentMetadata=5]="DocumentMetadata",n[n.Move=6]="Move",n[n.OutputItems=7]="OutputItems",n[n.PartialMetadata=8]="PartialMetadata",n[n.PartialInternalMetadata=9]="PartialInternalMetadata"})(u=e.CellEditType||(e.CellEditType={}));var l;(function(n){n.scheme=U.Schemas.vscodeNotebookCell;const t=/^ch(\d{7,})/;function c(N,v){return N.with({scheme:n.scheme,fragment:`ch${v.toString().padStart(7,"0")}${N.scheme!==U.Schemas.file?N.scheme:""}`})}n.generate=c;function E(N){if(N.scheme!==n.scheme)return;const v=t.exec(N.fragment);return v?{handle:Number(v[1]),notebook:N.with({scheme:N.fragment.substring(v[0].length)||U.Schemas.file,fragment:null})}:void 0}n.parse=E;function f(N,v){return N.with({scheme:U.Schemas.vscodeNotebookCellOutput,fragment:`op${v??""},${N.scheme!==U.Schemas.file?N.scheme:""}`})}n.generateCellOutputUri=f;function D(N){if(N.scheme!==U.Schemas.vscodeNotebookCellOutput)return;const v=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(N.fragment);if(!v)return;const F=v[1]&&v[1]!==""?v[1]:void 0,O=v[2];return{outputId:F,notebook:N.with({scheme:O||U.Schemas.file,fragment:null})}}n.parseCellOutputUri=D;function L(N,v,F){return N.with({scheme:F,fragment:`ch${v.toString().padStart(7,"0")}${N.scheme!==U.Schemas.file?N.scheme:""}`})}n.generateCellUri=L;function W(N,v){if(N.scheme!==v)return;const F=t.exec(N.fragment);return F?{handle:Number(F[1]),notebook:N.with({scheme:N.fragment.substring(F[0].length)||U.Schemas.file,fragment:null})}:void 0}n.parseCellUri=W})(l=e.CellUri||(e.CellUri={}));const S=n=>P.isWindows?n.replace(/\//g,"\\"):n;class w{constructor(t=[],c=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=c,this.order=[...new Set(t)].map(E=>({pattern:E,matches:o.parse(S(E))}))}sort(t){const c=new Map(C.Iterable.map(t,f=>[f,S(f)]));let E=[];for(const{matches:f}of this.order)for(const[D,L]of c)if(f(L)){E.push(D),c.delete(D);break}return c.size&&(E=E.concat([...c.keys()].sort((f,D)=>this.defaultOrder.indexOf(f)-this.defaultOrder.indexOf(D)))),E}prioritize(t,c){const E=this.findIndex(t);if(E===-1){this.order.unshift({pattern:t,matches:o.parse(S(t))});return}const f=new Set(c.map(L=>this.findIndex(L,E)));f.delete(-1);const D=Array.from(f).sort();this.order.splice(E+1,0,...D.map(L=>this.order[L]));for(let L=D.length-1;L>=0;L--)this.order.splice(D[L],1)}toArray(){return this.order.map(t=>t.pattern)}findIndex(t,c=this.order.length){const E=S(t);for(let f=0;f<c;f++)if(this.order[f].matches(E))return f;return-1}}e.MimeTypeDisplayOrder=w;function a(n,t,c,E=(f,D)=>f===D){const f=[];function D(N,v,F){if(v===0&&F.length===0)return;const O=f[f.length-1];O&&O.start+O.deleteCount===N?(O.deleteCount+=v,O.toInsert.push(...F)):f.push({start:N,deleteCount:v,toInsert:F})}let L=0,W=0;for(;;){if(L===n.length){D(L,0,t.slice(W));break}if(W===t.length){D(L,n.length-L,[]);break}const N=n[L],v=t[W];if(E(N,v)){L+=1,W+=1;continue}c(v)?(D(L,1,[]),L+=1):(D(L,0,[v]),W+=1)}return f}e.diff=a,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new b.RawContextKey("notebookEditorCursorAtBoundary","none");var y;(function(n){n.default="default",n.option="option"})(y=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function r(n){const t=n;return!!((typeof t.include=="string"||o.isRelativePattern(t.include))&&(typeof t.exclude=="string"||o.isRelativePattern(t.exclude)))}e.isDocumentExcludePattern=r;function d(n,t,c){if(Array.isArray(n.viewType)&&n.viewType.indexOf(t)>=0||n.viewType===t)return!0;if(n.filenamePattern){const E=r(n.filenamePattern)?n.filenamePattern.include:n.filenamePattern,f=r(n.filenamePattern)?n.filenamePattern.exclude:void 0;if(o.match(E,(0,I.basename)(c.fsPath).toLowerCase()))return!(f&&o.match(f,(0,I.basename)(c.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=d,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputLineHeight:"notebook.outputLineHeight",outputFontSize:"notebook.outputFontSize",outputFontFamily:"notebook.outputFontFamily",interactiveWindowAlwaysScrollOnNewCell:"interactiveWindow.alwaysScrollOnNewCell"};var i;(function(n){n[n.Left=1]="Left",n[n.Right=2]="Right"})(i=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class s{static create(t){return`${s._prefix}${t}`}static parse(t){if(t.startsWith(s._prefix))return t.substring(s._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=s,s._prefix="notebook/"}),define(De[168],Ce([1,0,3]),function(J,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var C;(function(p){p[p.Output=1]="Output",p[p.OutputItems=2]="OutputItems",p[p.ExecutionState=3]="ExecutionState"})(C=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,o.createDecorator)("INotebookExecutionService")}),define(De[169],Ce([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function o(I){return[...I.entries()]}e.serializeEnvironmentVariableCollection=o;function C(I){return new Map(I)}e.deserializeEnvironmentVariableCollection=C;function p(I){return Array.from(I.entries()).map(P=>[P[0],o(P[1].map)])}e.serializeEnvironmentVariableCollections=p;function U(I){return new Map(I.map(P=>[P[0],{map:C(P[1])}]))}e.deserializeEnvironmentVariableCollections=U}),define(De[46],Ce([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var o;(function(U){U.Delimiter="\0"})(o=e.TestIdPathParts||(e.TestIdPathParts={}));var C;(function(U){U[U.IsSame=0]="IsSame",U[U.Disconnected=1]="Disconnected",U[U.IsChild=2]="IsChild",U[U.IsParent=3]="IsParent"})(C=e.TestPosition||(e.TestPosition={}));class p{constructor(I,P=I.length){if(this.path=I,this.viewEnd=P,I.length===0||P<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(I,P,b=I.parent){if(I.id===P)return new p([P]);const A=[I.id];for(let R=b;R&&R.id!==P;R=R.parent)A.push(R.id);return A.push(P),new p(A.reverse())}static isRoot(I){return!I.includes("\0")}static root(I){const P=I.indexOf("\0");return P===-1?I:I.slice(0,P)}static fromString(I){return new p(I.split("\0"))}static join(I,P){return new p([...I.path,P])}static joinToString(I,P){return I.toString()+"\0"+P}static compare(I,P){return I===P?0:P.startsWith(I+"\0")?2:I.startsWith(P+"\0")?3:1}get parentId(){return this.viewEnd>1?new p(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let I=1;I<=this.viewEnd;I++)yield new p(this.path,I)}compare(I){if(typeof I=="string")return p.compare(this.toString(),I);for(let P=0;P<I.viewEnd&&P<this.viewEnd;P++)if(I.path[P]!==this.path[P])return 1;return I.viewEnd>this.viewEnd?2:I.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let I=1;I<this.viewEnd;I++)this.stringifed+="\0",this.stringifed+=this.path[I]}return this.stringifed}}e.TestId=p}),define(De[47],Ce([1,0,2,48]),function(J,e,o,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var p;(function(n){n[n.Unset=0]="Unset",n[n.Queued=1]="Queued",n[n.Running=2]="Running",n[n.Passed=3]="Passed",n[n.Failed=4]="Failed",n[n.Skipped=5]="Skipped",n[n.Errored=6]="Errored"})(p=e.TestResultState||(e.TestResultState={}));var U;(function(n){n[n.Run=2]="Run",n[n.Debug=4]="Debug",n[n.Coverage=8]="Coverage",n[n.HasNonDefaultProfile=16]="HasNonDefaultProfile",n[n.HasConfigurable=32]="HasConfigurable"})(U=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var I;(function(n){n.serialize=t=>({range:t.range.toJSON(),uri:t.uri.toJSON()}),n.deserialize=t=>({range:C.Range.lift(t.range),uri:o.URI.revive(t.uri)})})(I=e.IRichLocation||(e.IRichLocation={}));var P;(function(n){n[n.Error=0]="Error",n[n.Output=1]="Output"})(P=e.TestMessageType||(e.TestMessageType={}));var b;(function(n){n.serialize=t=>({message:t.message,type:0,expected:t.expected,actual:t.actual,location:t.location&&I.serialize(t.location)}),n.deserialize=t=>({message:t.message,type:0,expected:t.expected,actual:t.actual,location:t.location&&I.deserialize(t.location)})})(b=e.ITestErrorMessage||(e.ITestErrorMessage={}));var A;(function(n){n.serialize=t=>({message:t.message,type:1,offset:t.offset,location:t.location&&I.serialize(t.location)}),n.deserialize=t=>({message:t.message,type:1,offset:t.offset,location:t.location&&I.deserialize(t.location)})})(A=e.ITestOutputMessage||(e.ITestOutputMessage={}));var R;(function(n){n.serialize=t=>t.type===0?b.serialize(t):A.serialize(t),n.deserialize=t=>t.type===0?b.deserialize(t):A.deserialize(t)})(R=e.ITestMessage||(e.ITestMessage={}));var _;(function(n){n.serialize=t=>({state:t.state,duration:t.duration,messages:t.messages.map(R.serialize)}),n.deserialize=t=>({state:t.state,duration:t.duration,messages:t.messages.map(R.deserialize)})})(_=e.ITestTaskState||(e.ITestTaskState={}));const m="\0",T=(n,t)=>n+m+t;e.namespaceTestTag=T;const g=n=>{const t=n.indexOf(m);return{ctrlId:n.slice(0,t),tagId:n.slice(t+1)}};e.denamespaceTestTag=g;var h;(function(n){n.serialize=t=>({extId:t.extId,label:t.label,tags:t.tags,busy:t.busy,children:void 0,uri:t.uri?.toJSON(),range:t.range?.toJSON()||null,description:t.description,error:t.error,sortText:t.sortText}),n.deserialize=t=>({extId:t.extId,label:t.label,tags:t.tags,busy:t.busy,children:void 0,uri:t.uri?o.URI.revive(t.uri):void 0,range:t.range?C.Range.lift(t.range):null,description:t.description,error:t.error,sortText:t.sortText})})(h=e.ITestItem||(e.ITestItem={}));var u;(function(n){n[n.NotExpandable=0]="NotExpandable",n[n.Expandable=1]="Expandable",n[n.BusyExpanding=2]="BusyExpanding",n[n.Expanded=3]="Expanded"})(u=e.TestItemExpandState||(e.TestItemExpandState={}));var l;(function(n){n.serialize=t=>({controllerId:t.controllerId,expand:t.expand,parent:t.parent,item:h.serialize(t.item)}),n.deserialize=t=>({controllerId:t.controllerId,expand:t.expand,parent:t.parent,item:h.deserialize(t.item)})})(l=e.InternalTestItem||(e.InternalTestItem={}));var S;(function(n){n.serialize=t=>{let c;return t.item&&(c={},t.item.label!==void 0&&(c.label=t.item.label),t.item.tags!==void 0&&(c.tags=t.item.tags),t.item.busy!==void 0&&(c.busy=t.item.busy),t.item.uri!==void 0&&(c.uri=t.item.uri?.toJSON()),t.item.range!==void 0&&(c.range=t.item.range?.toJSON()),t.item.description!==void 0&&(c.description=t.item.description),t.item.error!==void 0&&(c.error=t.item.error),t.item.sortText!==void 0&&(c.sortText=t.item.sortText)),{extId:t.extId,expand:t.expand,item:c}},n.deserialize=t=>{let c;return t.item&&(c={},t.item.label!==void 0&&(c.label=t.item.label),t.item.tags!==void 0&&(c.tags=t.item.tags),t.item.busy!==void 0&&(c.busy=t.item.busy),t.item.range!==void 0&&(c.range=t.item.range?C.Range.lift(t.item.range):null),t.item.description!==void 0&&(c.description=t.item.description),t.item.error!==void 0&&(c.error=t.item.error),t.item.sortText!==void 0&&(c.sortText=t.item.sortText)),{extId:t.extId,expand:t.expand,item:c}}})(S=e.ITestItemUpdate||(e.ITestItemUpdate={}));const w=(n,t)=>{t.expand!==void 0&&(n.expand=t.expand),t.item!==void 0&&(n.item=n.item?Object.assign(n.item,t.item):t.item)};e.applyTestItemUpdate=w;var a;(function(n){n.serialize=(t,c)=>({...l.serialize(t),children:c,ownComputedState:t.ownComputedState,computedState:t.computedState,tasks:t.tasks.map(_.serialize)})})(a=e.TestResultItem||(e.TestResultItem={}));var y;(function(n){n[n.Function=0]="Function",n[n.Statement=1]="Statement"})(y=e.DetailType||(e.DetailType={}));var r;(function(n){n[n.Add=0]="Add",n[n.Update=1]="Update",n[n.Remove=2]="Remove",n[n.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",n[n.Retire=4]="Retire",n[n.AddTag=5]="AddTag",n[n.RemoveTag=6]="RemoveTag"})(r=e.TestDiffOpType||(e.TestDiffOpType={}));var d;(function(n){n.deserialize=t=>t.op===0?{op:t.op,item:l.deserialize(t.item)}:t.op===1?{op:t.op,item:S.deserialize(t.item)}:t,n.serialize=t=>t.op===0?{op:t.op,item:l.serialize(t.item)}:t.op===1?{op:t.op,item:S.serialize(t.item)}:t})(d=e.TestsDiffOp||(e.TestsDiffOp={}));class i{add(t){}update(t){}remove(t,c){}complete(){}}e.IncrementalChangeCollector=i;class s{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(t){const c=this.createChangeCollector();for(const E of t)switch(E.op){case 0:{const f=l.deserialize(E.item);if(f.parent){if(this.items.has(f.parent)){const D=this.items.get(f.parent);D.children.add(f.item.extId);const L=this.createItem(f,D);this.items.set(f.item.extId,L),c.add(L)}}else{const D=this.createItem(f);this.roots.add(D),this.items.set(f.item.extId,D),c.add(D)}f.expand===2&&this.busyControllerCount++;break}case 1:{const f=S.deserialize(E.item),D=this.items.get(f.extId);if(!D)break;f.expand!==void 0&&(D.expand===2&&this.busyControllerCount--,f.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(D,f),c.update(D);break}case 2:{const f=this.items.get(E.itemId);if(!f)break;f.parent?this.items.get(f.parent).children.delete(f.item.extId):this.roots.delete(f);const D=[[E.itemId]];for(;D.length;)for(const L of D.pop()){const W=this.items.get(L);W&&(D.push(W.children),this.items.delete(L),c.remove(W,W!==f),W.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(E.itemId);break;case 3:this.updatePendingRoots(E.amount);break;case 5:this._tags.set(E.tag.id,E.tag);break;case 6:this._tags.delete(E.id);break}c.complete()}retireTest(t){}updatePendingRoots(t){this.pendingRootCount+=t}createChangeCollector(){return new i}}e.AbstractIncrementalTestCollection=s}),define(De[65],Ce([1,0,13,4,7,9,47,46]),function(J,e,o,C,p,U,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var b;(function(l){l[l.Upsert=0]="Upsert",l[l.SetTags=1]="SetTags",l[l.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",l[l.RemoveChild=3]="RemoveChild",l[l.SetProp=4]="SetProp",l[l.Bulk=5]="Bulk"})(b=e.TestItemEventOp||(e.TestItemEventOp={}));const A=(l,S)=>l===S,R={range:(l,S)=>l===S?!0:!l||!S?!1:l.equalsRange(S),busy:A,label:A,description:A,error:A,tags:(l,S)=>!(l.length!==S.length||l.some(w=>!S.includes(w)))},_=(l,S)=>{let w;for(const[a,y]of Object.entries(R))y(l[a],S[a])||(w?w[a]=S[a]:w={[a]:S[a]});return w};class m extends p.Disposable{constructor(S){super();this.options=S,this.debounceSendDiff=this._register(new o.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new C.Emitter),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}get root(){return this.options.root}set resolveHandler(S){this._resolveHandler=S;for(const w of this.tree.values())this.updateExpandability(w)}collectDiff(){const S=this.diff;return this.diff=[],S}pushDiff(S){const w=this.diff[this.diff.length-1];if(w&&S.op===1){if(w.op===1&&w.item.extId===S.item.extId){(0,I.applyTestItemUpdate)(w.item,S.item);return}if(w.op===0&&w.item.item.extId===S.item.extId){(0,I.applyTestItemUpdate)(w.item,S.item);return}}this.diff.push(S),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(S,w){const a=this.tree.get(S);if(!!a){if((a.expandLevels===void 0||w>a.expandLevels)&&(a.expandLevels=w),a.expand===1){const y=this.resolveChildren(a);return y.isOpen()?this.expandChildren(a,w-1):y.wait().then(()=>this.expandChildren(a,w-1))}else if(a.expand===3)return a.resolveBarrier?.isOpen()===!1?a.resolveBarrier.wait().then(()=>this.expandChildren(a,w-1)):this.expandChildren(a,w-1)}}dispose(){for(const S of this.tree.values())this.options.getApiFor(S.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(S,w){switch(w.op){case 3:this.removeItem(P.TestId.joinToString(S.fullId,w.id));break;case 0:this.upsertItem(w.item,S);break;case 5:for(const a of w.ops)this.onTestItemEvent(S,a);break;case 1:this.diffTagRefs(w.new,w.old,S.fullId.toString());break;case 2:this.updateExpandability(S);break;case 4:this.pushDiff({op:1,item:{extId:S.fullId.toString(),item:w.update}});break;default:(0,U.assertNever)(w)}}upsertItem(S,w){const a=P.TestId.fromExtHostTestItem(S,this.root.id,w?.actual),y=this.options.getApiFor(S);y.parent&&y.parent!==w?.actual&&this.options.getChildren(y.parent).delete(S.id);let r=this.tree.get(a.toString());if(!r){r={fullId:a,actual:S,parent:w?a.parentId:null,expandLevels:w?.expandLevels?w.expandLevels-1:void 0,expand:0},S.tags.forEach(this.incrementTagRefs,this),this.tree.set(r.fullId.toString(),r),this.setItemParent(S,w),this.pushDiff({op:0,item:{parent:r.parent&&r.parent.toString(),controllerId:this.options.controllerId,expand:r.expand,item:this.options.toITestItem(S)}}),this.connectItemAndChildren(S,r,w);return}if(r.actual===S){this.connectItem(S,r,w);return}const d=this.options.getChildren(r.actual),i=r.actual,s=_(this.options.toITestItem(i),this.options.toITestItem(S));this.options.getApiFor(i).listener=void 0,r.actual=S,r.expand=0,s&&(s.hasOwnProperty("tags")&&(this.diffTagRefs(S.tags,i.tags,a.toString()),delete s.tags),this.onTestItemEvent(r,{op:4,update:s})),this.connectItemAndChildren(S,r,w);for(const[n,t]of d)this.options.getChildren(S).get(t.id)||this.removeItem(P.TestId.joinToString(a,t.id))}diffTagRefs(S,w,a){const y=new Set(w.map(r=>r.id));for(const r of S)y.delete(r.id)||this.incrementTagRefs(r);this.pushDiff({op:1,item:{extId:a,item:{tags:S.map(r=>(0,I.namespaceTestTag)(this.options.controllerId,r.id))}}}),y.forEach(this.decrementTagRefs,this)}incrementTagRefs(S){const w=this.tags.get(S.id);w?w.refCount++:(this.tags.set(S.id,{refCount:1}),this.pushDiff({op:5,tag:{id:(0,I.namespaceTestTag)(this.options.controllerId,S.id)}}))}decrementTagRefs(S){const w=this.tags.get(S);w&&!--w.refCount&&(this.tags.delete(S),this.pushDiff({op:6,id:(0,I.namespaceTestTag)(this.options.controllerId,S)}))}setItemParent(S,w){this.options.getApiFor(S).parent=w&&w.actual!==this.root?w.actual:void 0}connectItem(S,w,a){this.setItemParent(S,a);const y=this.options.getApiFor(S);y.parent=a?.actual,y.listener=r=>this.onTestItemEvent(w,r),this.updateExpandability(w)}connectItemAndChildren(S,w,a){this.connectItem(S,w,a);for(const[y,r]of this.options.getChildren(S))this.upsertItem(r,w)}updateExpandability(S){let w;this._resolveHandler?S.resolveBarrier?w=S.resolveBarrier.isOpen()?3:2:w=S.actual.canResolveChildren?1:0:w=0,w!==S.expand&&(S.expand=w,this.pushDiff({op:1,item:{extId:S.fullId.toString(),expand:w}}),w===1&&S.expandLevels!==void 0&&this.resolveChildren(S))}expandChildren(S,w){if(w<0)return;const a=[];for(const[y,r]of this.options.getChildren(S.actual)){const d=this.expand(P.TestId.joinToString(S.fullId,r.id),w);(0,o.isThenable)(d)&&a.push(d)}if(a.length)return Promise.all(a).then(()=>{})}resolveChildren(S){if(S.resolveBarrier)return S.resolveBarrier;if(!this._resolveHandler){const r=new o.Barrier;return r.open(),r}S.expand=2,this.pushExpandStateUpdate(S);const w=S.resolveBarrier=new o.Barrier,a=r=>{console.error(`Unhandled error in resolveHandler of test controller "${this.options.controllerId}"`,r)};let y;try{y=this._resolveHandler(S.actual===this.root?void 0:S.actual)}catch(r){a(r)}return(0,o.isThenable)(y)?y.catch(a).then(()=>{w.open(),this.updateExpandability(S)}):(w.open(),this.updateExpandability(S)),S.resolveBarrier}pushExpandStateUpdate(S){this.pushDiff({op:1,item:{extId:S.fullId.toString(),expand:S.expand}})}removeItem(S){const w=this.tree.get(S);if(!w)throw new Error("attempting to remove non-existent child");this.pushDiff({op:2,itemId:S});const a=[w];for(;a.length;){const y=a.pop();if(!!y){this.options.getApiFor(y.actual).listener=void 0;for(const r of y.actual.tags)this.decrementTagRefs(r.id);this.tree.delete(y.fullId.toString());for(const[r,d]of this.options.getChildren(y.actual))a.push(this.tree.get(P.TestId.joinToString(y.fullId,d.id)))}}}flushDiff(){const S=this.collectDiff();S.length&&this.diffOpEmitter.fire(S)}}e.TestItemCollection=m;class T extends Error{constructor(S){super(`Attempted to insert a duplicate test item ID ${S}`)}}e.DuplicateTestItemError=T;class g extends Error{constructor(S){super(`TestItem with ID "${S}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=g;class h extends Error{constructor(S,w,a){super(`TestItem with ID "${S}" is from controller "${w}" and cannot be added as a child of an item from controller "${a}".`)}}e.MixedTestItemController=h;const u=(l,S,w)=>{let a=new Map;return{get size(){return a.size},forEach(y,r){for(const d of a.values())y.call(r,d,this)},[Symbol.iterator](){return a.entries()},replace(y){const r=new Map,d=new Set(a.keys()),i={op:5,ops:[]};for(const s of y){if(!(s instanceof w))throw new g(s.id);const n=S(s).controllerId;if(n!==l.controllerId)throw new h(s.id,n,l.controllerId);if(r.has(s.id))throw new T(s.id);r.set(s.id,s),d.delete(s.id),i.ops.push({op:0,item:s})}for(const s of d.keys())i.ops.push({op:3,id:s});l.listener?.(i),a=r},add(y){if(!(y instanceof w))throw new g(y.id);a.set(y.id,y),l.listener?.({op:0,item:y})},delete(y){a.delete(y)&&l.listener?.({op:3,id:y})},get(y){return a.get(y)},toJSON(){return Array.from(a.values())}}};e.createTestItemChildren=u}),define(De[89],Ce([1,0,65]),function(J,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const C=new WeakMap,p=(I,P)=>{const b={controllerId:P};return C.set(I,b),b};e.createPrivateApiFor=p;const U=I=>{const P=C.get(I);if(!P)throw new o.InvalidTestItemError(I?.id||"<unknown>");return P};e.getPrivateApiFor=U}),define(De[170],Ce([1,0,19,59,9,26,22,76,140,10]),function(J,e,o,C,p,U,I,P,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class R{constructor(m,T,g,h){this._contributedVariables=new Map,this._context=m,this._labelService=T,this._userHomePromise=g,h&&(this._envVariablesPromise=h.then(u=>this.prepareEnv(u)))}prepareEnv(m){if(I.isWindows){const T=Object.create(null);return Object.keys(m).forEach(g=>{T[g.toLowerCase()]=m[g]}),T}return m}resolveWithEnvironment(m,T,g){return this.recursiveResolve({env:this.prepareEnv(m),userHome:void 0},T?T.uri:void 0,g)}async resolveAsync(m,T){const g={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(g,m?m.uri:void 0,T)}async resolveAnyBase(m,T,g,h){const u=U.deepClone(T);I.isWindows&&u.windows?Object.keys(u.windows).forEach(S=>u[S]=u.windows[S]):I.isMacintosh&&u.osx?Object.keys(u.osx).forEach(S=>u[S]=u.osx[S]):I.isLinux&&u.linux&&Object.keys(u.linux).forEach(S=>u[S]=u.linux[S]),delete u.windows,delete u.osx,delete u.linux;const l={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(l,m?m.uri:void 0,u,g,h)}async resolveAnyAsync(m,T,g){return this.resolveAnyBase(m,T,g)}async resolveAnyMap(m,T,g){const h=new Map;return{newConfig:await this.resolveAnyBase(m,T,g,h),resolvedVariables:h}}resolveWithInteractionReplace(m,T,g,h){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(m,T,g,h){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(m,T){if(this._contributedVariables.has(m))throw new Error("Variable "+m+" is contributed twice.");this._contributedVariables.set(m,T)}async recursiveResolve(m,T,g,h,u){if(p.isString(g))return this.resolveString(m,T,g,h,u);if(p.isArray(g))return Promise.all(g.map(l=>this.recursiveResolve(m,T,l,h,u)));if(p.isObject(g)){const l=Object.create(null),S=await Promise.all(Object.keys(g).map(async w=>[await this.resolveString(m,T,w,h,u),await this.recursiveResolve(m,T,g[w],h,u)]));for(const[w,a]of S)l[w]=a;return l}return g}resolveString(m,T,g,h,u){return(0,A.replaceAsync)(g,R.VARIABLE_REGEXP,async(l,S)=>{if(S.includes(R.VARIABLE_LHS))return l;let w=await this.evaluateSingleVariable(m,l,S,T,h);return u?.set(S,w),w!==l&&p.isString(w)&&w.match(R.VARIABLE_REGEXP)&&(w=await this.resolveString(m,T,w,h,u)),w})}fsPath(m){return this._labelService?this._labelService.getUriLabel(m,{noPrefix:!0}):m.fsPath}async evaluateSingleVariable(m,T,g,h,u){let l;const S=g.split(":");S.length>1&&(g=S[0],l=S[1]);const w=()=>{const r=this._context.getFilePath();if(r)return r;throw new Error((0,b.localize)(0,null,T))},a=()=>{const r=w();if(this._context.getWorkspaceFolderPathForFile){const d=this._context.getWorkspaceFolderPathForFile();if(d)return d}throw new Error((0,b.localize)(1,null,T,o.basename(r)))},y=()=>{if(l){const r=this._context.getFolderUri(l);if(r)return r;throw new Error((0,b.localize)(2,null,T,l))}if(h)return h;throw this._context.getWorkspaceFolderCount()>1?new Error((0,b.localize)(3,null,T)):new Error((0,b.localize)(4,null,T))};switch(g){case"env":if(l){if(m.env){const r=m.env[I.isWindows?l.toLowerCase():l];if(p.isString(r))return r}return""}throw new Error((0,b.localize)(5,null,T));case"config":if(l){const r=this._context.getConfigurationValue(h,l);if(p.isUndefinedOrNull(r))throw new Error((0,b.localize)(6,null,T,l));if(p.isObject(r))throw new Error((0,b.localize)(7,null,T,l));return r}throw new Error((0,b.localize)(8,null,T));case"command":return this.resolveFromMap(T,l,u,"command");case"input":return this.resolveFromMap(T,l,u,"input");case"extensionInstallFolder":if(l){const r=await this._context.getExtension(l);if(!r)throw new Error((0,b.localize)(9,null,T,l));return this.fsPath(r.extensionLocation)}throw new Error((0,b.localize)(10,null,T));default:switch(g){case"workspaceRoot":case"workspaceFolder":return(0,P.normalizeDriveLetter)(this.fsPath(y()));case"cwd":return h||l?(0,P.normalizeDriveLetter)(this.fsPath(y())):C.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return o.basename(this.fsPath(y()));case"userHome":{if(m.userHome)return m.userHome;throw new Error((0,b.localize)(11,null,T))}case"lineNumber":{const r=this._context.getLineNumber();if(r)return r;throw new Error((0,b.localize)(12,null,T))}case"selectedText":{const r=this._context.getSelectedText();if(r)return r;throw new Error((0,b.localize)(13,null,T))}case"file":return w();case"fileWorkspaceFolder":return a();case"relativeFile":return h||l?o.relative(this.fsPath(y()),w()):w();case"relativeFileDirname":{const r=o.dirname(w());if(h||l){const d=o.relative(this.fsPath(y()),r);return d.length===0?".":d}return r}case"fileDirname":return o.dirname(w());case"fileExtname":return o.extname(w());case"fileBasename":return o.basename(w());case"fileBasenameNoExtension":{const r=o.basename(w());return r.slice(0,r.length-o.extname(r).length)}case"fileDirnameBasename":return o.basename(o.dirname(w()));case"execPath":{const r=this._context.getExecPath();return r||T}case"execInstallFolder":{const r=this._context.getAppRoot();return r||T}case"pathSeparator":return o.sep;default:try{const r=l?`${g}:${l}`:g;return this.resolveFromMap(T,r,u,void 0)}catch{return T}}}}resolveFromMap(m,T,g,h){if(T&&g){const u=h===void 0?g[T]:g[h+":"+T];if(typeof u=="string")return u;throw new Error((0,b.localize)(14,null,m))}return m}}e.AbstractVariableResolverService=R,R.VARIABLE_LHS="${",R.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(De[90],Ce([1,0,3,162]),function(J,e,o,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,o.createDecorator)("editorGroupsService");var p;(function(g){g[g.UP=0]="UP",g[g.DOWN=1]="DOWN",g[g.LEFT=2]="LEFT",g[g.RIGHT=3]="RIGHT"})(p=e.GroupDirection||(e.GroupDirection={}));var U;(function(g){g[g.HORIZONTAL=0]="HORIZONTAL",g[g.VERTICAL=1]="VERTICAL"})(U=e.GroupOrientation||(e.GroupOrientation={}));var I;(function(g){g[g.FIRST=0]="FIRST",g[g.LAST=1]="LAST",g[g.NEXT=2]="NEXT",g[g.PREVIOUS=3]="PREVIOUS"})(I=e.GroupLocation||(e.GroupLocation={}));var P;(function(g){g[g.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",g[g.EVEN=1]="EVEN",g[g.TOGGLE=2]="TOGGLE"})(P=e.GroupsArrangement||(e.GroupsArrangement={}));var b;(function(g){g[g.COPY_EDITORS=0]="COPY_EDITORS",g[g.MOVE_EDITORS=1]="MOVE_EDITORS"})(b=e.MergeGroupMode||(e.MergeGroupMode={}));function A(g){const h=g;return(0,C.isEditorInput)(h?.editor)&&(0,C.isEditorInput)(h?.replacement)}e.isEditorReplacement=A;var R;(function(g){g[g.CREATION_TIME=0]="CREATION_TIME",g[g.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",g[g.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(R=e.GroupsOrder||(e.GroupsOrder={}));var _;(function(g){g[g.NEW_EDITOR=1]="NEW_EDITOR",g[g.MOVE_EDITOR=2]="MOVE_EDITOR",g[g.COPY_EDITOR=3]="COPY_EDITOR"})(_=e.OpenEditorContext||(e.OpenEditorContext={}));function m(g){const h=g;return!!h&&typeof h.id=="number"&&Array.isArray(h.editors)}e.isEditorGroup=m;function T(g){return g.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=T}),define(De[171],Ce([1,0,3,90]),function(J,e,o,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,o.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function p(U){const I=U;return typeof U=="number"||(0,C.isEditorGroup)(I)}e.isPreferredGroup=p}),define(De[8],Ce([1,0,16,23,75,24,105,55,26,9,2,48,66,143,80,89,88,46,47,171,6,172]),function(J,e,o,C,p,U,I,P,b,A,R,_,m,T,g,h,u,l,S,w,a,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var r;(function(we){function ye(q){const{selectionStartLineNumber:Pe,selectionStartColumn:Ue,positionLineNumber:Ke,positionColumn:Qe}=q,Ge=new a.Position(Pe-1,Ue-1),gt=new a.Position(Ke-1,Qe-1);return new a.Selection(Ge,gt)}we.to=ye;function he(q){const{anchor:Pe,active:Ue}=q;return{selectionStartLineNumber:Pe.line+1,selectionStartColumn:Pe.character+1,positionLineNumber:Ue.line+1,positionColumn:Ue.character+1}}we.from=he})(r=e.Selection||(e.Selection={}));var d;(function(we){function ye(q){if(!q)return;const{start:Pe,end:Ue}=q;return{startLineNumber:Pe.line+1,startColumn:Pe.character+1,endLineNumber:Ue.line+1,endColumn:Ue.character+1}}we.from=ye;function he(q){if(!q)return;const{startLineNumber:Pe,startColumn:Ue,endLineNumber:Ke,endColumn:Qe}=q;return new a.Range(Pe-1,Ue-1,Ke-1,Qe-1)}we.to=he})(d=e.Range||(e.Range={}));var i;(function(we){function ye(he){switch(he){case 1:return a.StandardTokenType.Comment;case 0:return a.StandardTokenType.Other;case 3:return a.StandardTokenType.RegEx;case 2:return a.StandardTokenType.String}}we.to=ye})(i=e.TokenType||(e.TokenType={}));var s;(function(we){function ye(q){return new a.Position(q.lineNumber-1,q.column-1)}we.to=ye;function he(q){return{lineNumber:q.line+1,column:q.character+1}}we.from=he})(s=e.Position||(e.Position={}));var n;(function(we){function ye(Pe,Ue){return(0,o.coalesce)((0,o.asArray)(Pe).map(Ke=>he(Ke,Ue)))}we.from=ye;function he(Pe,Ue){if(typeof Pe=="string")return{$serialized:!0,language:Pe};if(Pe)return{$serialized:!0,language:Pe.language,scheme:q(Pe.scheme,Ue),pattern:Be.from(Pe.pattern)??void 0,exclusive:Pe.exclusive,notebookType:Pe.notebookType}}function q(Pe,Ue){return Ue&&typeof Pe=="string"?Ue.transformOutgoingScheme(Pe):Pe}})(n=e.DocumentSelector||(e.DocumentSelector={}));var t;(function(we){function ye(q){switch(q){case a.DiagnosticTag.Unnecessary:return 1;case a.DiagnosticTag.Deprecated:return 2}}we.from=ye;function he(q){switch(q){case 1:return a.DiagnosticTag.Unnecessary;case 2:return a.DiagnosticTag.Deprecated;default:return}}we.to=he})(t=e.DiagnosticTag||(e.DiagnosticTag={}));var c;(function(we){function ye(q){let Pe;return q.code&&((0,A.isString)(q.code)||(0,A.isNumber)(q.code)?Pe=String(q.code):Pe={value:String(q.code.value),target:q.code.target}),{...d.from(q.range),message:q.message,source:q.source,code:Pe,severity:f.from(q.severity),relatedInformation:q.relatedInformation&&q.relatedInformation.map(E.from),tags:Array.isArray(q.tags)?(0,o.coalesce)(q.tags.map(t.from)):void 0}}we.from=ye;function he(q){const Pe=new a.Diagnostic(d.to(q),q.message,f.to(q.severity));return Pe.source=q.source,Pe.code=(0,A.isString)(q.code)?q.code:q.code?.value,Pe.relatedInformation=q.relatedInformation&&q.relatedInformation.map(E.to),Pe.tags=q.tags&&(0,o.coalesce)(q.tags.map(t.to)),Pe}we.to=he})(c=e.Diagnostic||(e.Diagnostic={}));var E;(function(we){function ye(q){return{...d.from(q.location.range),message:q.message,resource:q.location.uri}}we.from=ye;function he(q){return new a.DiagnosticRelatedInformation(new a.Location(q.resource,d.to(q)),q.message)}we.to=he})(E=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var f;(function(we){function ye(q){switch(q){case a.DiagnosticSeverity.Error:return g.MarkerSeverity.Error;case a.DiagnosticSeverity.Warning:return g.MarkerSeverity.Warning;case a.DiagnosticSeverity.Information:return g.MarkerSeverity.Info;case a.DiagnosticSeverity.Hint:return g.MarkerSeverity.Hint}return g.MarkerSeverity.Error}we.from=ye;function he(q){switch(q){case g.MarkerSeverity.Info:return a.DiagnosticSeverity.Information;case g.MarkerSeverity.Warning:return a.DiagnosticSeverity.Warning;case g.MarkerSeverity.Error:return a.DiagnosticSeverity.Error;case g.MarkerSeverity.Hint:return a.DiagnosticSeverity.Hint;default:return a.DiagnosticSeverity.Error}}we.to=he})(f=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var D;(function(we){function ye(q){return typeof q=="number"&&q>=a.ViewColumn.One?q-1:q===a.ViewColumn.Beside?w.SIDE_GROUP:w.ACTIVE_GROUP}we.from=ye;function he(q){if(typeof q=="number"&&q>=0)return q+1;throw new Error("invalid 'EditorGroupColumn'")}we.to=he})(D=e.ViewColumn||(e.ViewColumn={}));function L(we){return typeof we.range!="undefined"}function W(we){return we.length===0?!0:!!L(we[0])}e.isDecorationOptionsArr=W;var N;(function(we){function ye(Qe){return Qe.map(we.from)}we.fromMany=ye;function he(Qe){return Qe&&typeof Qe=="object"&&typeof Qe.language=="string"&&typeof Qe.value=="string"}function q(Qe){let Ge;if(he(Qe)){const{language:vt,value:ht}=Qe;Ge={value:"```"+vt+`
`+ht+"\n```\n"}}else a.MarkdownString.isMarkdownString(Qe)?Ge={value:Qe.value,isTrusted:Qe.isTrusted,supportThemeIcons:Qe.supportThemeIcons,supportHtml:Qe.supportHtml,baseUri:Qe.baseUri}:typeof Qe=="string"?Ge={value:Qe}:Ge={value:""};const gt=Object.create(null);Ge.uris=gt;const pt=vt=>{try{let ht=R.URI.parse(vt,!0);ht=ht.with({query:Pe(ht.query,gt)}),gt[vt]=ht}catch{}return""},_t=new I.marked.Renderer;return _t.link=pt,_t.image=vt=>typeof vt=="string"?pt(p.parseHrefAndDimensions(vt).href):"",(0,I.marked)(Ge.value,{renderer:_t}),Ge}we.from=q;function Pe(Qe,Ge){if(!Qe)return Qe;let gt;try{gt=(0,P.parse)(Qe)}catch{}if(!gt)return Qe;let pt=!1;return gt=(0,b.cloneAndChange)(gt,_t=>{if(R.URI.isUri(_t)){const vt=`__uri_${Math.random().toString(16).slice(2,8)}`;return Ge[vt]=_t,pt=!0,vt}else return}),pt?JSON.stringify(gt):Qe}function Ue(Qe){const Ge=new a.MarkdownString(Qe.value,Qe.supportThemeIcons);return Ge.isTrusted=Qe.isTrusted,Ge.supportHtml=Qe.supportHtml,Ge.baseUri=Qe.baseUri?R.URI.from(Qe.baseUri):void 0,Ge}we.to=Ue;function Ke(Qe){if(!!Qe)return typeof Qe=="string"?Qe:we.from(Qe)}we.fromStrict=Ke})(N=e.MarkdownString||(e.MarkdownString={}));function v(we){return W(we)?we.map(ye=>({range:d.from(ye.range),hoverMessage:Array.isArray(ye.hoverMessage)?N.fromMany(ye.hoverMessage):ye.hoverMessage?N.from(ye.hoverMessage):void 0,renderOptions:ye.renderOptions})):we.map(ye=>({range:d.from(ye)}))}e.fromRangeOrRangeWithMessage=v;function F(we){return typeof we=="undefined"?we:typeof we=="string"?R.URI.file(we):we}e.pathOrURIToURI=F;var O;(function(we){function ye(he){return typeof he=="undefined"?he:{contentText:he.contentText,contentIconPath:he.contentIconPath?F(he.contentIconPath):void 0,border:he.border,borderColor:he.borderColor,fontStyle:he.fontStyle,fontWeight:he.fontWeight,textDecoration:he.textDecoration,color:he.color,backgroundColor:he.backgroundColor,margin:he.margin,width:he.width,height:he.height}}we.from=ye})(O=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var H;(function(we){function ye(he){return typeof he=="undefined"?he:{backgroundColor:he.backgroundColor,outline:he.outline,outlineColor:he.outlineColor,outlineStyle:he.outlineStyle,outlineWidth:he.outlineWidth,border:he.border,borderColor:he.borderColor,borderRadius:he.borderRadius,borderSpacing:he.borderSpacing,borderStyle:he.borderStyle,borderWidth:he.borderWidth,fontStyle:he.fontStyle,fontWeight:he.fontWeight,textDecoration:he.textDecoration,cursor:he.cursor,color:he.color,opacity:he.opacity,letterSpacing:he.letterSpacing,gutterIconPath:he.gutterIconPath?F(he.gutterIconPath):void 0,gutterIconSize:he.gutterIconSize,overviewRulerColor:he.overviewRulerColor,before:he.before?O.from(he.before):void 0,after:he.after?O.from(he.after):void 0}}we.from=ye})(H=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var te;(function(we){function ye(he){if(typeof he=="undefined")return he;switch(he){case a.DecorationRangeBehavior.OpenOpen:return 0;case a.DecorationRangeBehavior.ClosedClosed:return 1;case a.DecorationRangeBehavior.OpenClosed:return 2;case a.DecorationRangeBehavior.ClosedOpen:return 3}}we.from=ye})(te=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var z;(function(we){function ye(he){return{isWholeLine:he.isWholeLine,rangeBehavior:he.rangeBehavior?te.from(he.rangeBehavior):void 0,overviewRulerLane:he.overviewRulerLane,light:he.light?H.from(he.light):void 0,dark:he.dark?H.from(he.dark):void 0,backgroundColor:he.backgroundColor,outline:he.outline,outlineColor:he.outlineColor,outlineStyle:he.outlineStyle,outlineWidth:he.outlineWidth,border:he.border,borderColor:he.borderColor,borderRadius:he.borderRadius,borderSpacing:he.borderSpacing,borderStyle:he.borderStyle,borderWidth:he.borderWidth,fontStyle:he.fontStyle,fontWeight:he.fontWeight,textDecoration:he.textDecoration,cursor:he.cursor,color:he.color,opacity:he.opacity,letterSpacing:he.letterSpacing,gutterIconPath:he.gutterIconPath?F(he.gutterIconPath):void 0,gutterIconSize:he.gutterIconSize,overviewRulerColor:he.overviewRulerColor,before:he.before?O.from(he.before):void 0,after:he.after?O.from(he.after):void 0}}we.from=ye})(z=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var $;(function(we){function ye(q){return{text:q.newText,eol:q.newEol&&qe.from(q.newEol),range:d.from(q.range)}}we.from=ye;function he(q){const Pe=new a.TextEdit(d.to(q.range),q.text);return Pe.newEol=typeof q.eol=="undefined"?void 0:qe.to(q.eol),Pe}we.to=he})($=e.TextEdit||(e.TextEdit={}));var ce;(function(we){function ye(q,Pe,Ue){const Ke={edits:[]};if(q instanceof a.WorkspaceEdit){const Qe=new U.ResourceSet;for(const Ge of q._allEntries())Ge._type===1&&R.URI.isUri(Ge.to)&&Ge.from===void 0&&Qe.add(Ge.to);for(const Ge of q._allEntries())if(Ge._type===1)Ke.edits.push({_type:1,oldUri:Ge.from,newUri:Ge.to,options:Ge.options,metadata:Ge.metadata});else if(Ge._type===2){const gt={_type:2,resource:Ge.uri,edit:$.from(Ge.edit),modelVersionId:Qe.has(Ge.uri)?void 0:Pe?.getTextDocumentVersion(Ge.uri),metadata:Ge.metadata};Ue&&Ge.edit.newText2 instanceof a.SnippetString&&(gt.edit.insertAsSnippet=!0,gt.edit.text=Ge.edit.newText2.value),Ke.edits.push(gt)}else Ge._type===3?Ke.edits.push({_type:3,metadata:Ge.metadata,resource:Ge.uri,edit:Ge.edit,notebookMetadata:Ge.notebookMetadata,notebookVersionId:Pe?.getNotebookDocumentVersion(Ge.uri)}):Ge._type===5&&Ke.edits.push({_type:3,metadata:Ge.metadata,resource:Ge.uri,notebookVersionId:Pe?.getNotebookDocumentVersion(Ge.uri),edit:{editType:1,index:Ge.index,count:Ge.count,cells:Ge.cells.map(st.from)}})}return Ke}we.from=ye;function he(q){const Pe=new a.WorkspaceEdit;for(const Ue of q.edits)Ue.edit?Pe.replace(R.URI.revive(Ue.resource),d.to(Ue.edit.range),Ue.edit.text):Pe.renameFile(R.URI.revive(Ue.oldUri),R.URI.revive(Ue.newUri),Ue.options);return Pe}we.to=he})(ce=e.WorkspaceEdit||(e.WorkspaceEdit={}));var le;(function(we){const ye=Object.create(null);ye[a.SymbolKind.File]=0,ye[a.SymbolKind.Module]=1,ye[a.SymbolKind.Namespace]=2,ye[a.SymbolKind.Package]=3,ye[a.SymbolKind.Class]=4,ye[a.SymbolKind.Method]=5,ye[a.SymbolKind.Property]=6,ye[a.SymbolKind.Field]=7,ye[a.SymbolKind.Constructor]=8,ye[a.SymbolKind.Enum]=9,ye[a.SymbolKind.Interface]=10,ye[a.SymbolKind.Function]=11,ye[a.SymbolKind.Variable]=12,ye[a.SymbolKind.Constant]=13,ye[a.SymbolKind.String]=14,ye[a.SymbolKind.Number]=15,ye[a.SymbolKind.Boolean]=16,ye[a.SymbolKind.Array]=17,ye[a.SymbolKind.Object]=18,ye[a.SymbolKind.Key]=19,ye[a.SymbolKind.Null]=20,ye[a.SymbolKind.EnumMember]=21,ye[a.SymbolKind.Struct]=22,ye[a.SymbolKind.Event]=23,ye[a.SymbolKind.Operator]=24,ye[a.SymbolKind.TypeParameter]=25;function he(Pe){return typeof ye[Pe]=="number"?ye[Pe]:6}we.from=he;function q(Pe){for(const Ue in ye)if(ye[Ue]===Pe)return Number(Ue);return a.SymbolKind.Property}we.to=q})(le=e.SymbolKind||(e.SymbolKind={}));var oe;(function(we){function ye(q){switch(q){case a.SymbolTag.Deprecated:return 1}}we.from=ye;function he(q){switch(q){case 1:return a.SymbolTag.Deprecated}}we.to=he})(oe=e.SymbolTag||(e.SymbolTag={}));var pe;(function(we){function ye(q){return{name:q.name,kind:le.from(q.kind),tags:q.tags&&q.tags.map(oe.from),containerName:q.containerName,location:ve.from(q.location)}}we.from=ye;function he(q){const Pe=new a.SymbolInformation(q.name,le.to(q.kind),q.containerName,ve.to(q.location));return Pe.tags=q.tags&&q.tags.map(oe.to),Pe}we.to=he})(pe=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var re;(function(we){function ye(q){const Pe={name:q.name||"!!MISSING: name!!",detail:q.detail,range:d.from(q.range),selectionRange:d.from(q.selectionRange),kind:le.from(q.kind),tags:q.tags?.map(oe.from)??[]};return q.children&&(Pe.children=q.children.map(ye)),Pe}we.from=ye;function he(q){const Pe=new a.DocumentSymbol(q.name,q.detail,le.to(q.kind),d.to(q.range),d.to(q.selectionRange));return(0,o.isNonEmptyArray)(q.tags)&&(Pe.tags=q.tags.map(oe.to)),q.children&&(Pe.children=q.children.map(he)),Pe}we.to=he})(re=e.DocumentSymbol||(e.DocumentSymbol={}));var Ee;(function(we){function ye(q){const Pe=new a.CallHierarchyItem(le.to(q.kind),q.name,q.detail||"",R.URI.revive(q.uri),d.to(q.range),d.to(q.selectionRange));return Pe._sessionId=q._sessionId,Pe._itemId=q._itemId,Pe}we.to=ye;function he(q,Pe,Ue){if(Pe=Pe??q._sessionId,Ue=Ue??q._itemId,Pe===void 0||Ue===void 0)throw new Error("invalid item");return{_sessionId:Pe,_itemId:Ue,name:q.name,detail:q.detail,kind:le.from(q.kind),uri:q.uri,range:d.from(q.range),selectionRange:d.from(q.selectionRange),tags:q.tags?.map(oe.from)}}we.from=he})(Ee=e.CallHierarchyItem||(e.CallHierarchyItem={}));var be;(function(we){function ye(he){return new a.CallHierarchyIncomingCall(Ee.to(he.from),he.fromRanges.map(q=>d.to(q)))}we.to=ye})(be=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var Z;(function(we){function ye(he){return new a.CallHierarchyOutgoingCall(Ee.to(he.to),he.fromRanges.map(q=>d.to(q)))}we.to=ye})(Z=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var ve;(function(we){function ye(q){return{range:q.range&&d.from(q.range),uri:q.uri}}we.from=ye;function he(q){return new a.Location(R.URI.revive(q.uri),d.to(q.range))}we.to=he})(ve=e.location||(e.location={}));var Re;(function(we){function ye(q){const Pe=q,Ue=q;return{originSelectionRange:Pe.originSelectionRange?d.from(Pe.originSelectionRange):void 0,uri:Pe.targetUri?Pe.targetUri:Ue.uri,range:d.from(Pe.targetRange?Pe.targetRange:Ue.range),targetSelectionRange:Pe.targetSelectionRange?d.from(Pe.targetSelectionRange):void 0}}we.from=ye;function he(q){return{targetUri:R.URI.revive(q.uri),targetRange:d.to(q.range),targetSelectionRange:q.targetSelectionRange?d.to(q.targetSelectionRange):void 0,originSelectionRange:q.originSelectionRange?d.to(q.originSelectionRange):void 0}}we.to=he})(Re=e.DefinitionLink||(e.DefinitionLink={}));var Fe;(function(we){function ye(q){return{range:d.from(q.range),contents:N.fromMany(q.contents)}}we.from=ye;function he(q){return new a.Hover(q.contents.map(N.to),d.to(q.range))}we.to=he})(Fe=e.Hover||(e.Hover={}));var We;(function(we){function ye(q){return{range:d.from(q.range),expression:q.expression}}we.from=ye;function he(q){return new a.EvaluatableExpression(d.to(q.range),q.expression)}we.to=he})(We=e.EvaluatableExpression||(e.EvaluatableExpression={}));var Xe;(function(we){function ye(q){if(q instanceof a.InlineValueText)return{type:"text",range:d.from(q.range),text:q.text};if(q instanceof a.InlineValueVariableLookup)return{type:"variable",range:d.from(q.range),variableName:q.variableName,caseSensitiveLookup:q.caseSensitiveLookup};if(q instanceof a.InlineValueEvaluatableExpression)return{type:"expression",range:d.from(q.range),expression:q.expression};throw new Error("Unknown 'InlineValue' type")}we.from=ye;function he(q){switch(q.type){case"text":return{range:d.to(q.range),text:q.text};case"variable":return{range:d.to(q.range),variableName:q.variableName,caseSensitiveLookup:q.caseSensitiveLookup};case"expression":return{range:d.to(q.range),expression:q.expression}}}we.to=he})(Xe=e.InlineValue||(e.InlineValue={}));var Ie;(function(we){function ye(q){return{frameId:q.frameId,stoppedLocation:d.from(q.stoppedLocation)}}we.from=ye;function he(q){return new a.InlineValueContext(q.frameId,d.to(q.stoppedLocation))}we.to=he})(Ie=e.InlineValueContext||(e.InlineValueContext={}));var Se;(function(we){function ye(q){return{range:d.from(q.range),kind:q.kind}}we.from=ye;function he(q){return new a.DocumentHighlight(d.to(q.range),q.kind)}we.to=he})(Se=e.DocumentHighlight||(e.DocumentHighlight={}));var Te;(function(we){function ye(he){switch(he){case 1:return a.CompletionTriggerKind.TriggerCharacter;case 2:return a.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return a.CompletionTriggerKind.Invoke}}we.to=ye})(Te=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var se;(function(we){function ye(he){return{triggerKind:Te.to(he.triggerKind),triggerCharacter:he.triggerCharacter}}we.to=ye})(se=e.CompletionContext||(e.CompletionContext={}));var ae;(function(we){function ye(q){switch(q){case a.CompletionItemTag.Deprecated:return 1}}we.from=ye;function he(q){switch(q){case 1:return a.CompletionItemTag.Deprecated}}we.to=he})(ae=e.CompletionItemTag||(e.CompletionItemTag={}));var G;(function(we){const ye=new Map([[a.CompletionItemKind.Method,0],[a.CompletionItemKind.Function,1],[a.CompletionItemKind.Constructor,2],[a.CompletionItemKind.Field,3],[a.CompletionItemKind.Variable,4],[a.CompletionItemKind.Class,5],[a.CompletionItemKind.Interface,7],[a.CompletionItemKind.Struct,6],[a.CompletionItemKind.Module,8],[a.CompletionItemKind.Property,9],[a.CompletionItemKind.Unit,12],[a.CompletionItemKind.Value,13],[a.CompletionItemKind.Constant,14],[a.CompletionItemKind.Enum,15],[a.CompletionItemKind.EnumMember,16],[a.CompletionItemKind.Keyword,17],[a.CompletionItemKind.Snippet,27],[a.CompletionItemKind.Text,18],[a.CompletionItemKind.Color,19],[a.CompletionItemKind.File,20],[a.CompletionItemKind.Reference,21],[a.CompletionItemKind.Folder,23],[a.CompletionItemKind.Event,10],[a.CompletionItemKind.Operator,11],[a.CompletionItemKind.TypeParameter,24],[a.CompletionItemKind.Issue,26],[a.CompletionItemKind.User,25]]);function he(Ue){return ye.get(Ue)??9}we.from=he;const q=new Map([[0,a.CompletionItemKind.Method],[1,a.CompletionItemKind.Function],[2,a.CompletionItemKind.Constructor],[3,a.CompletionItemKind.Field],[4,a.CompletionItemKind.Variable],[5,a.CompletionItemKind.Class],[7,a.CompletionItemKind.Interface],[6,a.CompletionItemKind.Struct],[8,a.CompletionItemKind.Module],[9,a.CompletionItemKind.Property],[12,a.CompletionItemKind.Unit],[13,a.CompletionItemKind.Value],[14,a.CompletionItemKind.Constant],[15,a.CompletionItemKind.Enum],[16,a.CompletionItemKind.EnumMember],[17,a.CompletionItemKind.Keyword],[27,a.CompletionItemKind.Snippet],[18,a.CompletionItemKind.Text],[19,a.CompletionItemKind.Color],[20,a.CompletionItemKind.File],[21,a.CompletionItemKind.Reference],[23,a.CompletionItemKind.Folder],[10,a.CompletionItemKind.Event],[11,a.CompletionItemKind.Operator],[24,a.CompletionItemKind.TypeParameter],[25,a.CompletionItemKind.User],[26,a.CompletionItemKind.Issue]]);function Pe(Ue){return q.get(Ue)??a.CompletionItemKind.Property}we.to=Pe})(G=e.CompletionItemKind||(e.CompletionItemKind={}));var X;(function(we){function ye(he,q){const Pe=new a.CompletionItem(he.label);return Pe.insertText=he.insertText,Pe.kind=G.to(he.kind),Pe.tags=he.tags?.map(ae.to),Pe.detail=he.detail,Pe.documentation=p.isMarkdownString(he.documentation)?N.to(he.documentation):he.documentation,Pe.sortText=he.sortText,Pe.filterText=he.filterText,Pe.preselect=he.preselect,Pe.commitCharacters=he.commitCharacters,_.Range.isIRange(he.range)?Pe.range=d.to(he.range):typeof he.range=="object"&&(Pe.range={inserting:d.to(he.range.insert),replacing:d.to(he.range.replace)}),Pe.keepWhitespace=typeof he.insertTextRules=="undefined"?!1:Boolean(he.insertTextRules&1),typeof he.insertTextRules!="undefined"&&he.insertTextRules&4?Pe.insertText=new a.SnippetString(he.insertText):(Pe.insertText=he.insertText,Pe.textEdit=Pe.range instanceof a.Range?new a.TextEdit(Pe.range,Pe.insertText):void 0),he.additionalTextEdits&&he.additionalTextEdits.length>0&&(Pe.additionalTextEdits=he.additionalTextEdits.map(Ue=>$.to(Ue))),Pe.command=q&&he.command?q.fromInternal(he.command):void 0,Pe}we.to=ye})(X=e.CompletionItem||(e.CompletionItem={}));var k;(function(we){function ye(q){return{label:q.label,documentation:N.fromStrict(q.documentation)}}we.from=ye;function he(q){return{label:q.label,documentation:p.isMarkdownString(q.documentation)?N.to(q.documentation):q.documentation}}we.to=he})(k=e.ParameterInformation||(e.ParameterInformation={}));var B;(function(we){function ye(q){return{label:q.label,documentation:N.fromStrict(q.documentation),parameters:Array.isArray(q.parameters)?q.parameters.map(k.from):[],activeParameter:q.activeParameter}}we.from=ye;function he(q){return{label:q.label,documentation:p.isMarkdownString(q.documentation)?N.to(q.documentation):q.documentation,parameters:Array.isArray(q.parameters)?q.parameters.map(k.to):[],activeParameter:q.activeParameter}}we.to=he})(B=e.SignatureInformation||(e.SignatureInformation={}));var V;(function(we){function ye(q){return{activeSignature:q.activeSignature,activeParameter:q.activeParameter,signatures:Array.isArray(q.signatures)?q.signatures.map(B.from):[]}}we.from=ye;function he(q){return{activeSignature:q.activeSignature,activeParameter:q.activeParameter,signatures:Array.isArray(q.signatures)?q.signatures.map(B.to):[]}}we.to=he})(V=e.SignatureHelp||(e.SignatureHelp={}));var j;(function(we){function ye(he,q){const Pe=new a.InlayHint(s.to(q.position),typeof q.label=="string"?q.label:q.label.map(ne.to.bind(void 0,he)),q.kind&&ue.to(q.kind));return Pe.textEdits=q.textEdits&&q.textEdits.map($.to),Pe.tooltip=p.isMarkdownString(q.tooltip)?N.to(q.tooltip):q.tooltip,Pe.paddingLeft=q.paddingLeft,Pe.paddingRight=q.paddingRight,Pe}we.to=ye})(j=e.InlayHint||(e.InlayHint={}));var ne;(function(we){function ye(he,q){const Pe=new a.InlayHintLabelPart(q.label);return Pe.tooltip=p.isMarkdownString(q.tooltip)?N.to(q.tooltip):q.tooltip,m.Command.is(q.command)&&(Pe.command=he.fromInternal(q.command)),q.location&&(Pe.location=ve.to(q.location)),Pe}we.to=ye})(ne=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var ue;(function(we){function ye(q){return q}we.from=ye;function he(q){return q}we.to=he})(ue=e.InlayHintKind||(e.InlayHintKind={}));var Y;(function(we){function ye(q){return{range:d.from(q.range),url:q.target,tooltip:q.tooltip}}we.from=ye;function he(q){let Pe;if(q.url)try{Pe=typeof q.url=="string"?R.URI.parse(q.url,!0):R.URI.revive(q.url)}catch{}return new a.DocumentLink(d.to(q.range),Pe)}we.to=he})(Y=e.DocumentLink||(e.DocumentLink={}));var ge;(function(we){function ye(q){const Pe=new a.ColorPresentation(q.label);return q.textEdit&&(Pe.textEdit=$.to(q.textEdit)),q.additionalTextEdits&&(Pe.additionalTextEdits=q.additionalTextEdits.map(Ue=>$.to(Ue))),Pe}we.to=ye;function he(q){return{label:q.label,textEdit:q.textEdit?$.from(q.textEdit):void 0,additionalTextEdits:q.additionalTextEdits?q.additionalTextEdits.map(Pe=>$.from(Pe)):void 0}}we.from=he})(ge=e.ColorPresentation||(e.ColorPresentation={}));var fe;(function(we){function ye(q){return new a.Color(q[0],q[1],q[2],q[3])}we.to=ye;function he(q){return[q.red,q.green,q.blue,q.alpha]}we.from=he})(fe=e.Color||(e.Color={}));var Ne;(function(we){function ye(q){return{range:d.from(q.range)}}we.from=ye;function he(q){return new a.SelectionRange(d.to(q.range))}we.to=he})(Ne=e.SelectionRange||(e.SelectionRange={}));var ze;(function(we){function ye(he){switch(he){case 2:return a.TextDocumentSaveReason.AfterDelay;case 1:return a.TextDocumentSaveReason.Manual;case 3:case 4:return a.TextDocumentSaveReason.FocusOut}}we.to=ye})(ze=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var ke;(function(we){function ye(q){switch(q){case a.TextEditorLineNumbersStyle.Off:return 0;case a.TextEditorLineNumbersStyle.Relative:return 2;case a.TextEditorLineNumbersStyle.On:default:return 1}}we.from=ye;function he(q){switch(q){case 0:return a.TextEditorLineNumbersStyle.Off;case 2:return a.TextEditorLineNumbersStyle.Relative;case 1:default:return a.TextEditorLineNumbersStyle.On}}we.to=he})(ke=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var qe;(function(we){function ye(q){if(q===a.EndOfLine.CRLF)return 1;if(q===a.EndOfLine.LF)return 0}we.from=ye;function he(q){if(q===1)return a.EndOfLine.CRLF;if(q===0)return a.EndOfLine.LF}we.to=he})(qe=e.EndOfLine||(e.EndOfLine={}));var K;(function(we){function ye(he){if(typeof he=="object")return he.viewId;switch(he){case a.ProgressLocation.SourceControl:return 3;case a.ProgressLocation.Window:return 10;case a.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}we.from=ye})(K=e.ProgressLocation||(e.ProgressLocation={}));var Q;(function(we){function ye(he){const q={start:he.start+1,end:he.end+1};return he.kind&&(q.kind=me.from(he.kind)),q}we.from=ye})(Q=e.FoldingRange||(e.FoldingRange={}));var me;(function(we){function ye(he){if(he)switch(he){case a.FoldingRangeKind.Comment:return m.FoldingRangeKind.Comment;case a.FoldingRangeKind.Imports:return m.FoldingRangeKind.Imports;case a.FoldingRangeKind.Region:return m.FoldingRangeKind.Region}}we.from=ye})(me=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Le;(function(we){function ye(he){if(he)return{pinned:typeof he.preview=="boolean"?!he.preview:void 0,inactive:he.background,preserveFocus:he.preserveFocus,selection:typeof he.selection=="object"?d.from(he.selection):void 0,override:typeof he.override=="boolean"?T.EditorResolution.DISABLED:void 0}}we.from=ye})(Le=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var Be;(function(we){function ye(Ue){return Ue instanceof a.RelativePattern?Ue.toJSON():typeof Ue=="string"?Ue:he(Ue)||q(Ue)?new a.RelativePattern(Ue.baseUri??Ue.base,Ue.pattern).toJSON():Ue}we.from=ye;function he(Ue){const Ke=Ue;return Ke?R.URI.isUri(Ke.baseUri)&&typeof Ke.pattern=="string":!1}function q(Ue){const Ke=Ue;return Ke?typeof Ke.base=="string"&&typeof Ke.pattern=="string":!1}function Pe(Ue){return typeof Ue=="string"?Ue:new a.RelativePattern(R.URI.revive(Ue.baseUri),Ue.pattern)}we.to=Pe})(Be=e.GlobPattern||(e.GlobPattern={}));var Ze;(function(we){function ye(he){if(he){if(Array.isArray(he))return he.map(ye);if(typeof he=="string")return he;{const q=he;return{language:q.language,scheme:q.scheme,pattern:Be.from(q.pattern),exclusive:q.exclusive,notebookType:q.notebookType}}}else return}we.from=ye})(Ze=e.LanguageSelector||(e.LanguageSelector={}));var et;(function(we){function ye(q){return{start:q.start,end:q.end}}we.from=ye;function he(q){return new a.NotebookRange(q.start,q.end)}we.to=he})(et=e.NotebookRange||(e.NotebookRange={}));var at;(function(we){function ye(q){return{timing:typeof q.runStartTime=="number"&&typeof q.runEndTime=="number"?{startTime:q.runStartTime,endTime:q.runEndTime}:void 0,executionOrder:q.executionOrder,success:q.lastRunSuccess}}we.to=ye;function he(q){return{lastRunSuccess:q.success,runStartTime:q.timing?.startTime,runEndTime:q.timing?.endTime,executionOrder:q.executionOrder}}we.from=he})(at=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var Je;(function(we){function ye(he){if(he===u.NotebookCellExecutionState.Executing)return a.NotebookCellExecutionState.Executing;if(he===u.NotebookCellExecutionState.Pending)return a.NotebookCellExecutionState.Pending;if(he===u.NotebookCellExecutionState.Unconfirmed)return a.NotebookCellExecutionState.Pending;throw new Error(`Unknown state: ${he}`)}we.to=ye})(Je=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var He;(function(we){function ye(q){switch(q){case a.NotebookCellKind.Markup:return u.CellKind.Markup;case a.NotebookCellKind.Code:default:return u.CellKind.Code}}we.from=ye;function he(q){switch(q){case u.CellKind.Markup:return a.NotebookCellKind.Markup;case u.CellKind.Code:default:return a.NotebookCellKind.Code}}we.to=he})(He=e.NotebookCellKind||(e.NotebookCellKind={}));var nt;(function(we){function ye(q){const Pe={metadata:q.metadata??Object.create(null),cells:[]};for(const Ue of q.cells)a.NotebookCellData.validate(Ue),Pe.cells.push(st.from(Ue));return Pe}we.from=ye;function he(q){const Pe=new a.NotebookData(q.cells.map(st.to));return(0,A.isEmptyObject)(q.metadata)||(Pe.metadata=q.metadata),Pe}we.to=he})(nt=e.NotebookData||(e.NotebookData={}));var st;(function(we){function ye(q){return{cellKind:He.from(q.kind),language:q.languageId,mime:q.mime,source:q.value,metadata:q.metadata,internalMetadata:at.from(q.executionSummary??{}),outputs:q.outputs?q.outputs.map(lt.from):[]}}we.from=ye;function he(q){return new a.NotebookCellData(He.to(q.cellKind),q.source,q.language,q.mime,q.outputs?q.outputs.map(lt.to):void 0,q.metadata,q.internalMetadata?at.to(q.internalMetadata):void 0)}we.to=he})(st=e.NotebookCellData||(e.NotebookCellData={}));var ot;(function(we){function ye(q){return{mime:q.mime,valueBytes:C.VSBuffer.wrap(q.data)}}we.from=ye;function he(q){return new a.NotebookCellOutputItem(q.valueBytes.buffer,q.mime)}we.to=he})(ot=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var lt;(function(we){function ye(q){return{outputId:q.id,items:q.items.map(ot.from),metadata:q.metadata}}we.from=ye;function he(q){const Pe=q.items.map(ot.to);return new a.NotebookCellOutput(Pe,q.outputId,q.metadata)}we.to=he})(lt=e.NotebookCellOutput||(e.NotebookCellOutput={}));var dt;(function(we){function ye(Pe){return q(Pe)?{include:(0,A.withNullAsUndefined)(Be.from(Pe.include)),exclude:(0,A.withNullAsUndefined)(Be.from(Pe.exclude))}:(0,A.withNullAsUndefined)(Be.from(Pe))}we.from=ye;function he(Pe){return q(Pe)?{include:Be.to(Pe.include),exclude:Be.to(Pe.exclude)}:Be.to(Pe)}we.to=he;function q(Pe){const Ue=Pe;return Ue?!(0,A.isUndefinedOrNull)(Ue.include)&&!(0,A.isUndefinedOrNull)(Ue.exclude):!1}})(dt=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var kt;(function(we){function ye(he,q,Pe){const Ue=typeof he.command=="string"?{title:"",command:he.command}:he.command;return{alignment:he.alignment===a.NotebookCellStatusBarAlignment.Left?1:2,command:q.toInternal(Ue,Pe),text:he.text,tooltip:he.tooltip,accessibilityInformation:he.accessibilityInformation,priority:he.priority}}we.from=ye})(kt=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var Mt;(function(we){function ye(he){return{transientOutputs:he?.transientOutputs??!1,transientCellMetadata:he?.transientCellMetadata??{},transientDocumentMetadata:he?.transientDocumentMetadata??{}}}we.from=ye})(Mt=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var Dt;(function(we){function ye(q){return{uri:q.uri,provides:q.provides}}we.from=ye;function he(q){return new a.NotebookRendererScript(R.URI.revive(q.uri),q.provides)}we.to=he})(Dt=e.NotebookRendererScript||(e.NotebookRendererScript={}));var ft;(function(we){function ye(q){return{message:N.fromStrict(q.message)||"",type:0,expected:q.expectedOutput,actual:q.actualOutput,location:q.location&&{range:d.from(q.location.range),uri:q.location.uri}}}we.from=ye;function he(q){const Pe=new a.TestMessage(typeof q.message=="string"?q.message:N.to(q.message));return Pe.actualOutput=q.actual,Pe.expectedOutput=q.expected,Pe.location=q.location?ve.to(q.location):void 0,Pe}we.to=he})(ft=e.TestMessage||(e.TestMessage={}));var Ct;(function(we){we.namespace=S.namespaceTestTag,we.denamespace=S.denamespaceTestTag})(Ct=e.TestTag||(e.TestTag={}));var Nt;(function(we){function ye(q){const Pe=(0,h.getPrivateApiFor)(q).controllerId;return{extId:l.TestId.fromExtHostTestItem(q,Pe).toString(),label:q.label,uri:R.URI.revive(q.uri),busy:!1,tags:q.tags.map(Ue=>Ct.namespace(Pe,Ue.id)),range:_.Range.lift(d.from(q.range)),description:q.description||null,sortText:q.sortText||null,error:q.error&&N.fromStrict(q.error)||null}}we.from=ye;function he(q){return{parent:void 0,error:void 0,id:l.TestId.fromString(q.extId).localId,label:q.label,uri:R.URI.revive(q.uri),tags:(q.tags||[]).map(Pe=>{const{tagId:Ue}=Ct.denamespace(Pe);return new a.TestTag(Ue)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:d.to(q.range||void 0),canResolveChildren:!1,busy:!1,description:q.description||void 0,sortText:q.sortText||void 0}}we.toPlain=he})(Nt=e.TestItem||(e.TestItem={})),function(we){function ye(q){return{id:q.id}}we.from=ye;function he(q){return new a.TestTag(q.id)}we.to=he}(Ct=e.TestTag||(e.TestTag={}));var Pt;(function(we){const ye=(q,Pe)=>{const Ue={...Nt.toPlain(q.item),parent:void 0,taskStates:q.tasks.map(Ke=>({state:Ke.state,duration:Ke.duration,messages:Ke.messages.filter(Qe=>Qe.type===0).map(ft.to)})),children:q.children.map(Ke=>Pe.get(Ke)).filter(A.isDefined).map(Ke=>ye(Ke,Pe))};for(const Ke of Ue.children)Ke.parent=Ue;return Ue};function he(q){const Pe=[],Ue=new Map;for(const Ke of q.items)Ue.set(Ke.item.extId,Ke),q.request.targets.some(Qe=>Qe.controllerId===Ke.controllerId&&Qe.testIds.includes(Ke.item.extId))&&Pe.push(Ke);return{completedAt:q.completedAt,results:Pe.map(Ke=>ye(Ke,Ue))}}we.to=he})(Pt=e.TestResults||(e.TestResults={}));var Ve;(function(we){function ye(Ue){return{covered:Ue.covered,total:Ue.covered}}function he(Ue){return"line"in Ue?s.from(Ue):d.from(Ue)}function q(Ue){return"branches"in Ue?{count:Ue.executionCount,location:he(Ue.location),type:1,branches:Ue.branches.length?Ue.branches.map(Ke=>({count:Ke.executionCount,location:Ke.location&&he(Ke.location)})):void 0}:{type:0,count:Ue.executionCount,location:he(Ue.location)}}we.fromDetailed=q;function Pe(Ue){return{uri:Ue.uri,statement:ye(Ue.statementCoverage),branch:Ue.branchCoverage&&ye(Ue.branchCoverage),function:Ue.functionCoverage&&ye(Ue.functionCoverage),details:Ue.detailedCoverage?.map(q)}}we.fromFile=Pe})(Ve=e.TestCoverage||(e.TestCoverage={}));var At;(function(we){function ye(he){switch(he){case 1:return a.CodeActionTriggerKind.Invoke;case 2:return a.CodeActionTriggerKind.Automatic}}we.to=ye})(At=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Lt;(function(we){function ye(q){const Pe=new a.TypeHierarchyItem(le.to(q.kind),q.name,q.detail||"",R.URI.revive(q.uri),d.to(q.range),d.to(q.selectionRange));return Pe._sessionId=q._sessionId,Pe._itemId=q._itemId,Pe}we.to=ye;function he(q,Pe,Ue){if(Pe=Pe??q._sessionId,Ue=Ue??q._itemId,Pe===void 0||Ue===void 0)throw new Error("invalid item");return{_sessionId:Pe,_itemId:Ue,kind:le.from(q.kind),name:q.name,detail:q.detail??"",uri:q.uri,range:d.from(q.range),selectionRange:d.from(q.selectionRange),tags:q.tags?.map(oe.from)}}we.from=he})(Lt=e.TypeHierarchyItem||(e.TypeHierarchyItem={}));var Ot;(function(we){function ye(he){if(!!he)return{value:he.value,tooltip:he.tooltip}}we.from=ye})(Ot=e.ViewBadge||(e.ViewBadge={}));var mt;(function(we){function ye(he,q){const Pe=he.fileData;return Pe?new class extends a.DataTransferItem{asFile(){return{name:Pe.name,uri:R.URI.revive(Pe.uri),data:(0,y.once)(()=>q())}}}(""):new a.DataTransferItem(he.asString)}we.toDataTransferItem=ye})(mt=e.DataTransferItem||(e.DataTransferItem={}));var yt;(function(we){function ye(q,Pe){const Ue=q.items.map(([Ke,Qe],Ge)=>[Ke,mt.toDataTransferItem(Qe,()=>Pe(Ge))]);return new a.DataTransfer(Ue)}we.toDataTransfer=ye;async function he(q){const Pe={items:[]},Ue=[];return q.forEach((Ke,Qe)=>{Ue.push((async()=>{const Ge=await Ke.asString(),gt=Ke.asFile();Pe.items.push([Qe,{asString:Ge,fileData:gt?{name:gt.name,uri:gt.uri}:void 0}])})())}),await Promise.all(Ue),Pe}we.toDataTransferDTO=he})(yt=e.DataTransfer||(e.DataTransfer={}))}),define(De[173],Ce([1,0,2,11,6,8,240]),function(J,e,o,C,p,U,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class P{constructor(A,R,_,m={timeout:1500,errors:3}){this._logService=A,this._documents=R,this._mainThreadBulkEdits=_,this._thresholds=m,this._callbacks=new I.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(A){return(R,_,m)=>{const g={dispose:this._callbacks.push([R,_,A])};return Array.isArray(m)&&m.push(g),g}}async $participateInSave(A,R){const _=o.URI.revive(A);let m=!1;const T=setTimeout(()=>m=!0,this._thresholds.timeout),g=[];try{for(const h of[...this._callbacks]){if(m)break;const u=this._documents.getDocument(_),l=await this._deliverEventAsyncAndBlameBadListeners(h,{document:u,reason:U.TextDocumentSaveReason.to(R)});g.push(l)}}finally{clearTimeout(T)}return g}_deliverEventAsyncAndBlameBadListeners([A,R,_],m){const T=this._badListeners.get(A);return typeof T=="number"&&T>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(_,A,R,m).then(()=>!0,g=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${_.identifier.value}' threw ERROR`),this._logService.error(g),!(g instanceof Error)||g.message!=="concurrent_edits"){const h=this._badListeners.get(A);this._badListeners.set(A,h?h+1:1),typeof h=="number"&&h>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${_.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(A,R,_,m){const T=[],g=Date.now(),{document:h,reason:u}=m,{version:l}=h,S=Object.freeze({document:h,reason:u,waitUntil(w){if(Object.isFrozen(T))throw(0,C.illegalState)("waitUntil can not be called async");T.push(Promise.resolve(w))}});try{R.apply(_,[S])}catch(w){return Promise.reject(w)}return Object.freeze(T),new Promise((w,a)=>{const y=setTimeout(()=>a(new Error("timeout")),this._thresholds.timeout);return Promise.all(T).then(r=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${A.identifier.value}' finished after ${Date.now()-g}ms`),clearTimeout(y),w(r)}).catch(r=>{clearTimeout(y),a(r)})}).then(w=>{const a={edits:[]};for(const y of w)if(Array.isArray(y)&&y.every(r=>r instanceof p.TextEdit))for(const{newText:r,newEol:d,range:i}of y)a.edits.push({_type:2,resource:h.uri,edit:{range:i&&U.Range.from(i),text:r,eol:d&&U.EndOfLine.from(d)}});if(a.edits.length!==0)return l===h.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(a):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=P}),define(De[174],Ce([1,0,12,2,8,6,88]),function(J,e,o,C,p,U,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class P{constructor(_,m,T,g){this.start=_,this.deletedCount=m,this.deletedItems=T,this.items=g}asApiEvent(){return{range:new U.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(_=>_.apiCell),removedCells:this.deletedItems}}}class b{constructor(_,m,T){this.notebook=_,this._extHostDocument=m,this._cellData=T,this.handle=T.handle,this.uri=C.URI.revive(T.uri),this.cellKind=T.cellKind,this._outputs=T.outputs.map(p.NotebookCellOutput.to),this._internalMetadata=T.internalMetadata??{},this._metadata=Object.freeze(T.metadata??{}),this._previousResult=Object.freeze(p.NotebookCellExecutionSummary.to(T.internalMetadata??{}))}static asModelAddData(_,m){return{EOL:m.eol,lines:m.source,languageId:m.language,uri:m.uri,isDirty:!1,versionId:1,notebook:_}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const _=this,m=this._extHostDocument.getDocument(this.uri);if(!m)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const T={get index(){return _.notebook.getCellIndex(_)},notebook:_.notebook.apiNotebook,kind:p.NotebookCellKind.to(this._cellData.cellKind),document:m.document,get mime(){return _._mime},set mime(g){_._mime=g},get outputs(){return _._outputs.slice(0)},get metadata(){return _._metadata},get executionSummary(){return _._previousResult}};this._apiCell=Object.freeze(T)}return this._apiCell}setOutputs(_){this._outputs=_.map(p.NotebookCellOutput.to)}setOutputItems(_,m,T){const g=T.map(p.NotebookCellOutputItem.to),h=this._outputs.find(u=>u.id===_);h&&(m||(h.items.length=0),h.items.push(...g))}setMetadata(_){this._metadata=Object.freeze(_)}setInternalMetadata(_){this._internalMetadata=_,this._previousResult=Object.freeze(p.NotebookCellExecutionSummary.to(_))}setMime(_){}}e.ExtHostCell=b;class A{constructor(_,m,T,g,h){this._proxy=_,this._textDocumentsAndEditors=m,this._textDocuments=T,this.uri=g,this.handle=A._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=h.viewType,this._metadata=Object.freeze(h.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,h.cells]],!0,void 0),this._versionId=h.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const _=this,m={get uri(){return _.uri},get version(){return _._versionId},get notebookType(){return _._notebookType},get isDirty(){return _._isDirty},get isUntitled(){return _.uri.scheme===o.Schemas.untitled},get isClosed(){return _._disposed},get metadata(){return _._metadata},get cellCount(){return _._cells.length},cellAt(T){return T=_._validateIndex(T),_._cells[T].apiCell},getCells(T){return(T?_._getCells(T):_._cells).map(h=>h.apiCell)},save(){return _._save()}};this._notebook=Object.freeze(m)}return this._notebook}updateBackup(_){this._backup?.delete(),this._backup=_}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(_){_.metadata&&(this._metadata=Object.freeze({...this._metadata,..._.metadata}))}acceptDirty(_){this._isDirty=_}acceptModelChanged(_,m,T){this._versionId=_.versionId,this._isDirty=m,this.acceptDocumentPropertiesChanged({metadata:T});const g={notebook:this.apiNotebook,metadata:T,cellChanges:[],contentChanges:[]},h=[];for(const l of _.rawEvents)l.kind===I.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(l.changes,!1,g.contentChanges):l.kind===I.NotebookCellsChangeType.Move?this._moveCell(l.index,l.newIdx,g.contentChanges):l.kind===I.NotebookCellsChangeType.Output?(this._setCellOutputs(l.index,l.outputs),h.push({cell:this._cells[l.index].apiCell,outputs:this._cells[l.index].apiCell.outputs})):l.kind===I.NotebookCellsChangeType.OutputItem?(this._setCellOutputItems(l.index,l.outputId,l.append,l.outputItems),h.push({cell:this._cells[l.index].apiCell,outputs:this._cells[l.index].apiCell.outputs})):l.kind===I.NotebookCellsChangeType.ChangeCellLanguage?(this._changeCellLanguage(l.index,l.language),h.push({cell:this._cells[l.index].apiCell,document:this._cells[l.index].apiCell.document})):l.kind===I.NotebookCellsChangeType.ChangeCellContent?h.push({cell:this._cells[l.index].apiCell,document:this._cells[l.index].apiCell.document}):l.kind===I.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(l.index,l.mime):l.kind===I.NotebookCellsChangeType.ChangeCellMetadata?(this._changeCellMetadata(l.index,l.metadata),h.push({cell:this._cells[l.index].apiCell,metadata:this._cells[l.index].apiCell.metadata})):l.kind===I.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this._changeCellInternalMetadata(l.index,l.internalMetadata),h.push({cell:this._cells[l.index].apiCell,executionSummary:this._cells[l.index].apiCell.executionSummary}));const u=new Map;for(let l=0;l<h.length;l++){const S=h[l],w=u.get(S.cell);if(w===void 0){const a=g.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...S});u.set(S.cell,a-1)}else g.cellChanges[w]={...g.cellChanges[w],...S}}return Object.freeze(g),Object.freeze(g.cellChanges),Object.freeze(g.contentChanges),g}_validateIndex(_){return _=_|0,_<0?0:_>=this._cells.length?this._cells.length-1:_}_validateRange(_){let m=_.start|0,T=_.end|0;return m<0&&(m=0),T>this._cells.length&&(T=this._cells.length),_.with({start:m,end:T})}_getCells(_){_=this._validateRange(_);const m=[];for(let T=_.start;T<_.end;T++)m.push(this._cells[T]);return m}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(_,m,T){if(this._disposed)return;const g=[],h=[],u=[];if(_.reverse().forEach(l=>{const w=l[2].map(r=>{const d=new b(this,this._textDocumentsAndEditors,r);return m||h.push(b.asModelAddData(this.apiNotebook,r)),d}),a=new P(l[0],l[1],[],w),y=this._cells.splice(l[0],l[1],...w);for(const r of y)u.push(r.uri),a.deletedItems.push(r.apiCell);g.push(a)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:h,removedDocuments:u}),T)for(const l of g)T.push(l.asApiEvent())}_moveCell(_,m,T){const g=this._cells.splice(_,1);this._cells.splice(m,0,...g);const h=[new P(_,1,g.map(u=>u.apiCell),[]),new P(m,0,[],g)];for(const u of h)T.push(u.asApiEvent())}_setCellOutputs(_,m){this._cells[_].setOutputs(m)}_setCellOutputItems(_,m,T,g){this._cells[_].setOutputItems(m,T,g)}_changeCellLanguage(_,m){const T=this._cells[_];T.apiCell.document.languageId!==m&&this._textDocuments.$acceptModelLanguageChanged(T.uri,m)}_changeCellMime(_,m){const T=this._cells[_];T.apiCell.mime=m}_changeCellMetadata(_,m){this._cells[_].setMetadata(m)}_changeCellInternalMetadata(_,m){this._cells[_].setInternalMetadata(m)}getCellFromApiCell(_){return this._cells.find(m=>m.apiCell===_)}getCellFromIndex(_){return this._cells[_]}getCell(_){return this._cells.find(m=>m.handle===_)}getCellIndex(_){return this._cells.indexOf(_)}}e.ExtHostNotebookDocument=A,A._handlePool=0}),define(De[91],Ce([1,0,6,8,11]),function(J,e,o,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class U{constructor(b){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=b}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(b){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:b})}replaceCellMetadata(b,A){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:b,metadata:A})}replaceCells(b,A,R){this._throwIfFinalized(),!(b===A&&R.length===0)&&this._collectedEdits.push({editType:1,index:b,count:A-b,cells:R.map(C.NotebookCellData.from)})}}class I{constructor(b,A,R,_,m,T){this.id=b,this._proxy=A,this.notebookData=R,this._selections=[],this._visibleRanges=[],this._visible=!1,this._selections=m,this._visibleRanges=_,this._viewColumn=T}get apiEditor(){if(!this._editor){const b=this;this._editor={get document(){return b.notebookData.apiNotebook},get notebook(){return b.notebookData.apiNotebook},get selection(){return b._selections[0]},set selection(A){this.selections=[A]},get selections(){return b._selections},set selections(A){if(!Array.isArray(A)||!A.every(o.NotebookRange.isNotebookRange))throw(0,p.illegalArgument)("selections");b._selections=A,b._trySetSelections(A)},get visibleRanges(){return b._visibleRanges},revealRange(A,R){b._proxy.$tryRevealRange(b.id,C.NotebookRange.from(A),R??o.NotebookEditorRevealType.Default)},get viewColumn(){return b._viewColumn},edit(A){const R=new U(this.document.version);return A(R),b._applyEdit(R.finalize())}},I.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(b){this._visible=b}_acceptVisibleRanges(b){this._visibleRanges=b}_acceptSelections(b){this._selections=b}_trySetSelections(b){this._proxy.$trySetSelections(this.id,b.map(C.NotebookRange.from))}_acceptViewColumn(b){this._viewColumn=b}_applyEdit(b){if(b.cellEdits.length===0)return Promise.resolve(!0);const A=[];let R=-1;for(let _=0;_<b.cellEdits.length;_++){if(R<0){A.push(b.cellEdits[_]),R++;continue}const T=A[R],g=b.cellEdits[_];if(T.editType===1&&g.editType===1&&T.index===g.index){T.cells.push(...b.cellEdits[_].cells),T.count+=b.cellEdits[_].count;continue}A.push(b.cellEdits[_]),R++}return this._proxy.$tryApplyEdits(this.id,b.documentVersionId,A)}}e.ExtHostNotebookEditor=I,I.apiEditorsToExtHost=new WeakMap}),define(De[175],Ce([1,0,4,14,8]),function(J,e,o,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let U=class{constructor(P,b){this._logService=P,this._notebooksAndEditors=b,this._onDidChangeNotebookEditorSelection=new o.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new o.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}$acceptEditorPropertiesChanged(P,b){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",P,b);const A=this._notebooksAndEditors.getEditorById(P);b.visibleRanges&&A._acceptVisibleRanges(b.visibleRanges.ranges.map(p.NotebookRange.to)),b.selections&&A._acceptSelections(b.selections.selections.map(p.NotebookRange.to)),b.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:A.apiEditor,visibleRanges:A.apiEditor.visibleRanges}),b.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:A.apiEditor,selections:A.apiEditor.selections}))}$acceptEditorViewColumns(P){for(const b in P)this._notebooksAndEditors.getEditorById(b)._acceptViewColumn(p.ViewColumn.to(P[b]))}};U=$e([xe(0,C.ILogService)],U),e.ExtHostNotebookEditors=U}),define(De[176],Ce([1,0,8,150,130,20,54,11]),function(J,e,o,C,p,U,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class b{constructor(m){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=m}async withProgress(m,T,g){const h=this._handles++,{title:u,location:l,cancellable:S}=T,w={label:(0,p.localize)(0,null,m.displayName||m.name),id:m.identifier.value};return this._proxy.$startProgress(h,{location:o.ProgressLocation.from(l),title:u,source:w,cancellable:S},m.isUnderDevelopment?void 0:m.identifier.value).catch(P.onUnexpectedExternalError),this._withProgress(h,g,!!S)}_withProgress(m,T,g){let h;g&&(h=new U.CancellationTokenSource,this._mapHandleToCancellationSource.set(m,h));const u=S=>{this._proxy.$progressEnd(S),this._mapHandleToCancellationSource.delete(S),h&&h.dispose()};let l;try{l=T(new R(this._proxy,m),g&&h?h.token:U.CancellationToken.None)}catch(S){throw u(m),S}return l.then(S=>u(m),S=>u(m)),l}$acceptProgressCanceled(m){const T=this._mapHandleToCancellationSource.get(m);T&&(T.cancel(),this._mapHandleToCancellationSource.delete(m))}}e.ExtHostProgress=b;function A(_,m){return _.message=m.message,typeof m.increment=="number"&&(typeof _.increment=="number"?_.increment+=m.increment:_.increment=m.increment),_}class R extends C.Progress{constructor(m,T){super(g=>this.throttledReport(g));this._proxy=m,this._handle=T}throttledReport(m){this._proxy.$progressReport(this._handle,m)}}$e([(0,I.throttle)(100,(_,m)=>A(_,m),()=>Object.create(null))],R.prototype,"throttledReport",null)}),define(De[92],Ce([1,0,48,89,46,65,47,8,2]),function(J,e,o,C,p,U,I,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const A=(w,a,y,r)=>{let d=a;return{enumerable:!0,configurable:!1,get(){return d},set(i){if(!y(d,i)){const s=d;d=i,w.listener?.(r(i,s))}}}},R=(w,a)=>w===a,_={range:(w,a)=>w===a?!0:!w||!a?!1:w.isEqual(a),label:R,description:R,sortText:R,busy:R,error:R,canResolveChildren:R,tags:(w,a)=>!(w.length!==a.length||w.some(y=>!a.find(r=>y.id===r.id)))},m=w=>a=>({op:4,update:w(a)}),T=(w,a)=>({range:A(w,void 0,_.range,m(y=>({range:o.Range.lift(P.Range.from(y))}))),label:A(w,a,_.label,m(y=>({label:y}))),description:A(w,void 0,_.description,m(y=>({description:y}))),sortText:A(w,void 0,_.sortText,m(y=>({sortText:y}))),canResolveChildren:A(w,!1,_.canResolveChildren,y=>({op:2,state:y})),busy:A(w,!1,_.busy,m(y=>({busy:y}))),error:A(w,void 0,_.error,m(y=>({error:P.MarkdownString.fromStrict(y)||null}))),tags:A(w,[],_.tags,(y,r)=>({op:1,new:y.map(P.TestTag.from),old:r.map(P.TestTag.from)}))}),g=w=>{const a=p.TestId.fromString(w.extId),y=new u(a.controllerId,a.localId,w.label,b.URI.revive(w.uri)||void 0);return y.range=P.Range.to(w.range||void 0),y.description=w.description||void 0,y.sortText=w.sortText||void 0,y.tags=w.tags.map(r=>P.TestTag.to({id:(0,I.denamespaceTestTag)(r).tagId})),y},h=w=>{let a;for(const y of w.tests){const r=g(y.item);(0,C.getPrivateApiFor)(r).parent=a,a=r}return a};e.toItemFromContext=h;class u{constructor(a,y,r,d){if(y.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(y)} symbol`);const i=(0,C.createPrivateApiFor)(this,a);Object.defineProperties(this,{id:{value:y,enumerable:!0,writable:!1},uri:{value:d,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return i.parent instanceof l?void 0:i.parent}},children:{value:(0,U.createTestItemChildren)(i,C.getPrivateApiFor,u),enumerable:!0,writable:!1},...T(i,r)})}}e.TestItemImpl=u;class l extends u{constructor(a,y){super(a,a,y,void 0)}}e.TestItemRootImpl=l;class S extends U.TestItemCollection{constructor(a,y){super({controllerId:a,getApiFor:C.getPrivateApiFor,getChildren:r=>r.children,root:new l(a,y),toITestItem:P.TestItem.from})}}e.ExtHostTestItemCollection=S}),define(De[93],Ce([1,0,42,11,73,8,6]),function(J,e,o,C,p,U,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class P{constructor(m,T,g){const h=P._Keys.nextId();m.$registerTextEditorDecorationType(T.identifier,h,U.DecorationRenderOptions.from(g)),this.value=Object.freeze({key:h,dispose(){m.$removeTextEditorDecorationType(h)}})}}e.TextEditorDecorationType=P,P._Keys=new p.IdGenerator("TextEditorDecorationType");class b{constructor(m,T){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=m,this._documentVersionId=m.version,this._undoStopBefore=T.undoStopBefore,this._undoStopAfter=T.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(m,T){this._throwIfFinalized();let g=null;if(m instanceof I.Position)g=new I.Range(m,m);else if(m instanceof I.Range)g=m;else throw new Error("Unrecognized location");this._pushEdit(g,T,!1)}insert(m,T){this._throwIfFinalized(),this._pushEdit(new I.Range(m,m),T,!0)}delete(m){this._throwIfFinalized();let T=null;if(m instanceof I.Range)T=m;else throw new Error("Unrecognized location");this._pushEdit(T,null,!0)}_pushEdit(m,T,g){const h=this._document.validateRange(m);this._collectedEdits.push({range:h,text:T,forceMoveMarkers:g})}setEndOfLine(m){if(this._throwIfFinalized(),m!==I.EndOfLine.LF&&m!==I.EndOfLine.CRLF)throw(0,C.illegalArgument)("endOfLine");this._setEndOfLine=m}}e.TextEditorEdit=b;class A{constructor(m,T,g,h){this._proxy=m,this._id=T,this._accept(g),this._logService=h;const u=this;this.value={get tabSize(){return u._tabSize},set tabSize(l){u._setTabSize(l)},get insertSpaces(){return u._insertSpaces},set insertSpaces(l){u._setInsertSpaces(l)},get cursorStyle(){return u._cursorStyle},set cursorStyle(l){u._setCursorStyle(l)},get lineNumbers(){return u._lineNumbers},set lineNumbers(l){u._setLineNumbers(l)}}}_accept(m){this._tabSize=m.tabSize,this._insertSpaces=m.insertSpaces,this._cursorStyle=m.cursorStyle,this._lineNumbers=U.TextEditorLineNumbersStyle.to(m.lineNumbers)}_validateTabSize(m){if(m==="auto")return"auto";if(typeof m=="number"){const T=Math.floor(m);return T>0?T:null}if(typeof m=="string"){const T=parseInt(m,10);return isNaN(T)?null:T>0?T:null}return null}_setTabSize(m){const T=this._validateTabSize(m);if(T!==null){if(typeof T=="number"){if(this._tabSize===T)return;this._tabSize=T}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:T}))}}_validateInsertSpaces(m){return m==="auto"?"auto":m==="false"?!1:Boolean(m)}_setInsertSpaces(m){const T=this._validateInsertSpaces(m);if(typeof T=="boolean"){if(this._insertSpaces===T)return;this._insertSpaces=T}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:T}))}_setCursorStyle(m){this._cursorStyle!==m&&(this._cursorStyle=m,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:m})))}_setLineNumbers(m){this._lineNumbers!==m&&(this._lineNumbers=m,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:U.TextEditorLineNumbersStyle.from(m)})))}assign(m){const T={};let g=!1;if(typeof m.tabSize!="undefined"){const h=this._validateTabSize(m.tabSize);h==="auto"?(g=!0,T.tabSize=h):typeof h=="number"&&this._tabSize!==h&&(this._tabSize=h,g=!0,T.tabSize=h)}if(typeof m.insertSpaces!="undefined"){const h=this._validateInsertSpaces(m.insertSpaces);h==="auto"?(g=!0,T.insertSpaces=h):this._insertSpaces!==h&&(this._insertSpaces=h,g=!0,T.insertSpaces=h)}typeof m.cursorStyle!="undefined"&&this._cursorStyle!==m.cursorStyle&&(this._cursorStyle=m.cursorStyle,g=!0,T.cursorStyle=m.cursorStyle),typeof m.lineNumbers!="undefined"&&this._lineNumbers!==m.lineNumbers&&(this._lineNumbers=m.lineNumbers,g=!0,T.lineNumbers=U.TextEditorLineNumbersStyle.from(m.lineNumbers)),g&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,T))}_warnOnError(m,T){T.catch(g=>{this._logService.warn(`ExtHostTextEditorOptions '${m}' failed:'`),this._logService.warn(g)})}}e.ExtHostTextEditorOptions=A;class R{constructor(m,T,g,h,u,l,S,w){this.id=m,this._proxy=T,this._logService=g,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=u,this._options=new A(this._proxy,this.id,l,g),this._visibleRanges=S,this._viewColumn=w;const a=this;this.value=Object.freeze({get document(){return h.getValue()},set document(y){throw(0,C.readonly)("document")},get selection(){return a._selections&&a._selections[0]},set selection(y){if(!(y instanceof I.Selection))throw(0,C.illegalArgument)("selection");a._selections=[y],a._trySetSelection()},get selections(){return a._selections},set selections(y){if(!Array.isArray(y)||y.some(r=>!(r instanceof I.Selection)))throw(0,C.illegalArgument)("selections");a._selections=y,a._trySetSelection()},get visibleRanges(){return a._visibleRanges},set visibleRanges(y){throw(0,C.readonly)("visibleRanges")},get options(){return a._options.value},set options(y){a._disposed||a._options.assign(y)},get viewColumn(){return a._viewColumn},set viewColumn(y){throw(0,C.readonly)("viewColumn")},edit(y,r={undoStopBefore:!0,undoStopAfter:!0}){if(a._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const d=new b(h.getValue(),r);return y(d),a._applyEdit(d)},insertSnippet(y,r,d={undoStopBefore:!0,undoStopAfter:!0}){if(a._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let i;if(!r||Array.isArray(r)&&r.length===0)i=a._selections.map(s=>U.Range.from(s));else if(r instanceof I.Position){const{lineNumber:s,column:n}=U.Position.from(r);i=[{startLineNumber:s,startColumn:n,endLineNumber:s,endColumn:n}]}else if(r instanceof I.Range)i=[U.Range.from(r)];else{i=[];for(const s of r)if(s instanceof I.Range)i.push(U.Range.from(s));else{const{lineNumber:n,column:t}=U.Position.from(s);i.push({startLineNumber:n,startColumn:t,endLineNumber:n,endColumn:t})}}return T.$tryInsertSnippet(m,h.getValue().version,y.value,i,d)},setDecorations(y,r){const d=r.length===0;d&&!a._hasDecorationsForKey.has(y.key)||(d?a._hasDecorationsForKey.delete(y.key):a._hasDecorationsForKey.add(y.key),a._runOnProxy(()=>{if(U.isDecorationOptionsArr(r))return T.$trySetDecorations(m,y.key,U.fromRangeOrRangeWithMessage(r));{const i=new Array(4*r.length);for(let s=0,n=r.length;s<n;s++){const t=r[s];i[4*s]=t.start.line+1,i[4*s+1]=t.start.character+1,i[4*s+2]=t.end.line+1,i[4*s+3]=t.end.character+1}return T.$trySetDecorationsFast(m,y.key,i)}}))},revealRange(y,r){a._runOnProxy(()=>T.$tryRevealRange(m,U.Range.from(y),r||I.TextEditorRevealType.Default))},show(y){T.$tryShowEditor(m,U.ViewColumn.from(y))},hide(){T.$tryHideEditor(m)}})}dispose(){(0,o.ok)(!this._disposed),this._disposed=!0}_acceptOptions(m){(0,o.ok)(!this._disposed),this._options._accept(m)}_acceptVisibleRanges(m){(0,o.ok)(!this._disposed),this._visibleRanges=m}_acceptViewColumn(m){(0,o.ok)(!this._disposed),this._viewColumn=m}_acceptSelections(m){(0,o.ok)(!this._disposed),this._selections=m}async _trySetSelection(){const m=this._selections.map(U.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,m)),this.value}_applyEdit(m){const T=m.finalize();if(T.edits.length===0&&!T.setEndOfLine)return Promise.resolve(!0);const g=T.edits.map(u=>u.range);g.sort((u,l)=>u.end.line===l.end.line?u.end.character===l.end.character?u.start.line===l.start.line?u.start.character-l.start.character:u.start.line-l.start.line:u.end.character-l.end.character:u.end.line-l.end.line);for(let u=0,l=g.length-1;u<l;u++){const S=g[u].end;if(g[u+1].start.isBefore(S))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const h=T.edits.map(u=>({range:U.Range.from(u.range),text:u.text,forceMoveMarkers:u.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,T.documentVersionId,h,{setEndOfLine:typeof T.setEndOfLine=="number"?U.EndOfLine.from(T.setEndOfLine):void 0,undoStopBefore:T.undoStopBefore,undoStopAfter:T.undoStopAfter})}_runOnProxy(m){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):m().then(()=>this,T=>(T instanceof Error&&T.name==="DISPOSED"||this._logService.warn(T),null))}}e.ExtHostTextEditor=R}),define(De[177],Ce([1,0,3,146]),function(J,e,o,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,o.refineServiceDecorator)(C.IEnvironmentService)}),define(De[178],Ce([1,0,27,4,19]),function(J,e,o,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class U{constructor(_){this.removedDueToLooping=_}}e.DeltaExtensionsResult=U;class I{constructor(_){this._onDidChange=new C.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=_,this._initialize()}_initialize(){this._extensionDescriptions.sort(b),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const _ of this._extensionDescriptions){if(this._extensionsMap.has(o.ExtensionIdentifier.toKey(_.identifier))){console.error("Extension `"+_.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(o.ExtensionIdentifier.toKey(_.identifier),_),this._extensionsArr.push(_),Array.isArray(_.activationEvents))for(let m of _.activationEvents)m==="onUri"&&(m=`onUri:${o.ExtensionIdentifier.toKey(_.identifier)}`),this._activationMap.has(m)||this._activationMap.set(m,[]),this._activationMap.get(m).push(_)}}set(_){this._extensionDescriptions=_,this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(_,m){this._extensionDescriptions=A(this._extensionDescriptions,m),this._extensionDescriptions=this._extensionDescriptions.concat(_);const T=I._findLoopingExtensions(this._extensionDescriptions);return this._extensionDescriptions=A(this._extensionDescriptions,T.map(g=>g.identifier)),this._initialize(),this._onDidChange.fire(void 0),new U(T)}static _findLoopingExtensions(_){const m=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(l){this._nodesSet.has(l)||(this._nodesSet.add(l),this._nodesArr.push(l))}addArc(l,S){this.addNode(l),this.addNode(S),this._arcs.has(l)?this._arcs.get(l).push(S):this._arcs.set(l,[S])}getArcs(l){return this._arcs.has(l)?this._arcs.get(l):[]}hasOnlyGoodArcs(l,S){const w=m.getArcs(l);for(let a=0;a<w.length;a++)if(!S.has(w[a]))return!1;return!0}getNodes(){return this._nodesArr}},T=new Map;for(const l of _){const S=o.ExtensionIdentifier.toKey(l.identifier);if(T.set(S,l),l.extensionDependencies)for(const w of l.extensionDependencies){const a=o.ExtensionIdentifier.toKey(w);m.addArc(S,a)}}const g=new Set;m.getNodes().filter(l=>m.getArcs(l).length===0).forEach(l=>g.add(l));const h=m.getNodes().filter(l=>!g.has(l));let u;do{u=!1;for(let l=0;l<h.length;l++){const S=h[l];m.hasOnlyGoodArcs(S,g)&&(h.splice(l,1),l--,g.add(S),u=!0)}}while(u);return h.map(l=>T.get(l))}containsActivationEvent(_){return this._activationMap.has(_)}containsExtension(_){return this._extensionsMap.has(o.ExtensionIdentifier.toKey(_))}getExtensionDescriptionsForActivationEvent(_){const m=this._activationMap.get(_);return m?m.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(_){const m=this._extensionsMap.get(o.ExtensionIdentifier.toKey(_));return m||void 0}getExtensionDescriptionByUUID(_){for(const m of this._extensionsArr)if(m.uuid===_)return m}getExtensionDescriptionByIdOrUUID(_,m){return this.getExtensionDescription(_)??(m?this.getExtensionDescriptionByUUID(m):void 0)}}e.ExtensionDescriptionRegistry=I;var P;(function(R){R[R.Builtin=0]="Builtin",R[R.User=1]="User",R[R.Dev=2]="Dev"})(P||(P={}));function b(R,_){const m=R.isBuiltin?0:R.isUnderDevelopment?2:1,T=_.isBuiltin?0:_.isUnderDevelopment?2:1;if(m!==T)return m-T;const g=p.posix.basename(R.extensionLocation.path),h=p.posix.basename(_.extensionLocation.path);return g<h?-1:g>h?1:0}function A(R,_){const m=new Set;return _.forEach(T=>m.add(o.ExtensionIdentifier.toKey(T))),R.filter(T=>!m.has(o.ExtensionIdentifier.toKey(T.identifier)))}}),define(De[94],Ce([1,0,23]),function(J,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var C;(function(A){A[A.Desktop=1]="Desktop",A[A.Web=2]="Web"})(C=e.UIKind||(e.UIKind={}));var p;(function(A){A[A.VersionMismatch=55]="VersionMismatch",A[A.UnexpectedError=81]="UnexpectedError"})(p=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var U;(function(A){A[A.Initialized=0]="Initialized",A[A.Ready=1]="Ready",A[A.Terminate=2]="Terminate"})(U=e.MessageType||(e.MessageType={}));function I(A){const R=o.VSBuffer.alloc(1);switch(A){case 0:R.writeUInt8(1,0);break;case 1:R.writeUInt8(2,0);break;case 2:R.writeUInt8(3,0);break}return R}e.createMessageOfType=I;function P(A,R){if(A.byteLength!==1)return!1;switch(A.readUInt8(0)){case 1:return R===0;case 2:return R===1;case 3:return R===2;default:return!1}}e.isMessageOfType=P;var b;(function(A){A.Start="START_NATIVE_LOG",A.End="END_NATIVE_LOG"})(b=e.NativeLogMarkers||(e.NativeLogMarkers={}))}),define(De[25],Ce([1,0,4,2,3,27,152]),function(J,e,o,C,p,U,I){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionIdentifiersArrayToSet=e.ExtensionIdentifierSet=e.ExtensionHostExtensions=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.RemoteRunningLocation=e.LocalWebWorkerRunningLocation=e.LocalProcessRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new U.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:C.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,p.createDecorator)("extensionService");class b{constructor(t){this.affinity=t,this.kind=1}equals(t){return this.kind===t.kind&&this.affinity===t.affinity}asString(){return this.affinity===0?"LocalProcess":`LocalProcess${this.affinity}`}}e.LocalProcessRunningLocation=b;class A{constructor(){this.kind=2,this.affinity=0}equals(t){return this.kind===t.kind}asString(){return"LocalWebWorker"}}e.LocalWebWorkerRunningLocation=A;class R{constructor(){this.kind=3,this.affinity=0}equals(t){return this.kind===t.kind}asString(){return"Remote"}}e.RemoteRunningLocation=R;class _{constructor(t){this.dependency=t}}e.MissingExtensionDependency=_;var m;(function(n){n[n.LocalProcess=1]="LocalProcess",n[n.LocalWebWorker=2]="LocalWebWorker",n[n.Remote=3]="Remote"})(m=e.ExtensionHostKind||(e.ExtensionHostKind={}));function T(n){if(n===null)return"None";switch(n){case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionHostKindToString=T;class g{constructor(){this._allExtensions=[],this._myExtensions=[]}toDelta(){return{toRemove:[],toAdd:this._allExtensions,myToRemove:[],myToAdd:this._myExtensions}}set(t,c){const E=[],f=[],D=[],L=[],W=l(this._allExtensions),N=l(t),v=(te,z)=>te.extensionLocation.toString()===z.extensionLocation.toString()||te.isBuiltin===z.isBuiltin||te.isUserBuiltin===z.isUserBuiltin||te.isUnderDevelopment===z.isUnderDevelopment;for(const te of this._allExtensions){const z=N.get(U.ExtensionIdentifier.toKey(te.identifier));if(!z){E.push(te.identifier),W.delete(U.ExtensionIdentifier.toKey(te.identifier));continue}if(!v(te,z)){E.push(te.identifier),W.delete(U.ExtensionIdentifier.toKey(te.identifier));continue}}for(const te of t){const z=W.get(U.ExtensionIdentifier.toKey(te.identifier));if(!z){f.push(te);continue}if(!v(z,te)){E.push(z.identifier),W.delete(U.ExtensionIdentifier.toKey(z.identifier));continue}}const F=u(this._myExtensions),O=u(c);for(const te of this._myExtensions)O.has(U.ExtensionIdentifier.toKey(te))||D.push(te);for(const te of c)F.has(U.ExtensionIdentifier.toKey(te))||L.push(te);const H={toRemove:E,toAdd:f,myToRemove:D,myToAdd:L};return this.delta(H),H}delta(t){const{toRemove:c,toAdd:E,myToRemove:f,myToAdd:D}=t,L=u(c),W=u(f);for(let N=0;N<this._allExtensions.length;N++)L.has(U.ExtensionIdentifier.toKey(this._allExtensions[N].identifier))&&(this._allExtensions.splice(N,1),N--);for(let N=0;N<this._myExtensions.length;N++)W.has(U.ExtensionIdentifier.toKey(this._myExtensions[N]))&&(this._myExtensions.splice(N,1),N--);for(const N of E)this._allExtensions.push(N);for(const N of D)this._myExtensions.push(N)}containsExtension(t){for(const c of this._myExtensions)if(U.ExtensionIdentifier.equals(c,t))return!0;return!1}}e.ExtensionHostExtensions=g;class h{constructor(t){if(this[P]="ExtensionIdentifierSet",this._map=new Map,this._toKey=U.ExtensionIdentifier.toKey,t)for(const c of t)this.add(c)}get size(){return this._map.size}add(t){return this._map.set(this._toKey(t),t),this}clear(){this._map.clear()}delete(t){return this._map.delete(this._toKey(t))}has(t){return this._map.has(this._toKey(t))}forEach(t,c){this._map.forEach(E=>t.call(c,E,E,this))}*entries(){for(const[t,c]of this._map)yield[c,c]}keys(){return this._map.values()}values(){return this._map.values()}[(P=Symbol.toStringTag,Symbol.iterator)](){return this._map.values()}}e.ExtensionIdentifierSet=h;function u(n){const t=new Set;for(const c of n)t.add(U.ExtensionIdentifier.toKey(c));return t}e.extensionIdentifiersArrayToSet=u;function l(n){const t=new Map;for(const c of n)t.set(U.ExtensionIdentifier.toKey(c.identifier),c);return t}function S(n,t){return n.enabledApiProposals?n.enabledApiProposals.includes(t):!1}e.isProposedApiEnabled=S;function w(n,t){if(!S(n,t))throw new Error(`Extension '${n.identifier.value}' CANNOT use API proposal: ${t}.
Its package.json#enabledApiProposals-property declares: ${n.enabledApiProposals?.join(", ")??"[]"} but NOT ${t}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${n.identifier.value}`)}e.checkProposedApiEnabled=w;class a{constructor(t,c,E,f){this.codeLoadingTime=t,this.activateCallTime=c,this.activateResolvedTime=E,this.activationReason=f}}e.ActivationTimes=a;class y{constructor(t,c){this.description=t,this.value=c}}e.ExtensionPointContribution=y,e.ExtensionHostLogFileName="exthost";var r;(function(n){n[n.Normal=0]="Normal",n[n.Immediate=1]="Immediate"})(r=e.ActivationKind||(e.ActivationKind={}));function d(n){return{type:n.isBuiltin?0:1,isBuiltin:n.isBuiltin||n.isUserBuiltin,identifier:{id:(0,I.getGalleryExtensionId)(n.publisher,n.name),uuid:n.uuid},manifest:n,location:n.extensionLocation,targetPlatform:n.targetPlatform,validations:[],isValid:!0}}e.toExtension=d;function i(n,t){return{identifier:new U.ExtensionIdentifier((0,I.getExtensionId)(n.manifest.publisher,n.manifest.name)),isBuiltin:n.type===0,isUserBuiltin:n.type===1&&n.isBuiltin,isUnderDevelopment:!!t,extensionLocation:n.location,...n.manifest,uuid:n.identifier.uuid,targetPlatform:n.targetPlatform}}e.toExtensionDescription=i;class s{constructor(){this.onDidRegisterExtensions=o.Event.None,this.onDidChangeExtensionsStatus=o.Event.None,this.onDidChangeExtensions=o.Event.None,this.onWillActivateByEvent=o.Event.None,this.onDidChangeResponsiveChange=o.Event.None}activateByEvent(t){return Promise.resolve(void 0)}activationEventIsDone(t){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(t){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(t,c){return Promise.resolve(0)}getInspectPorts(t,c){return Promise.resolve([])}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(t){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(t,c){return Promise.resolve()}}e.NullExtensionService=s}),define(De[179],Ce([1,0,11,27,25,14,13]),function(J,e,o,C,p,U,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class P{constructor(u,l,S,w){this.startup=u,this.codeLoadingTime=l,this.activateCallTime=S,this.activateResolvedTime=w}}e.ExtensionActivationTimes=P,P.NONE=new P(!1,-1,-1,-1);class b{constructor(u){this._startup=u,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(u,l){return u===-1||l===-1?-1:l-u}build(){return new P(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=b;class A{constructor(u,l,S,w,a,y){this.activationFailed=u,this.activationFailedError=l,this.activationTimes=S,this.module=w,this.exports=a,this.subscriptions=y}}e.ActivatedExtension=A;class R extends A{constructor(u){super(!1,null,u,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=R;class _ extends A{constructor(){super(!1,null,P.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=_;class m extends A{constructor(u){super(!0,u,P.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=m;let T=class{constructor(u,l,S,w,a){this._logService=a,this._registry=u,this._resolvedExtensionsSet=new Set,l.forEach(y=>this._resolvedExtensionsSet.add(C.ExtensionIdentifier.toKey(y))),this._externalExtensionsMap=new Map,S.forEach(y=>this._externalExtensionsMap.set(C.ExtensionIdentifier.toKey(y),y)),this._host=w,this._operations=new Map,this._alreadyActivatedEvents=Object.create(null)}dispose(){for(const[u,l]of this._operations)l.dispose()}isActivated(u){const l=this._operations.get(C.ExtensionIdentifier.toKey(u));return Boolean(l&&l.value)}getActivatedExtension(u){const l=this._operations.get(C.ExtensionIdentifier.toKey(u));if(!l||!l.value)throw new Error(`Extension '${u.value}' is not known or not activated`);return l.value}async activateByEvent(u,l){if(this._alreadyActivatedEvents[u])return;const S=this._registry.getExtensionDescriptionsForActivationEvent(u);await this._activateExtensions(S.map(w=>({id:w.identifier,reason:{startup:l,extensionId:w.identifier,activationEvent:u}}))),this._alreadyActivatedEvents[u]=!0}activateById(u,l){const S=this._registry.getExtensionDescription(u);if(!S)throw new Error(`Extension '${u}' is not known`);return this._activateExtensions([{id:S.identifier,reason:l}])}async _activateExtensions(u){const l=u.filter(S=>!this.isActivated(S.id)).map(S=>this._handleActivationRequest(S));await Promise.all(l.map(S=>S.wait()))}_handleActivationRequest(u){if(this._operations.has(C.ExtensionIdentifier.toKey(u.id)))return this._operations.get(C.ExtensionIdentifier.toKey(u.id));if(this._externalExtensionsMap.has(C.ExtensionIdentifier.toKey(u.id)))return this._createAndSaveOperation(u,null,[],null);const l=this._registry.getExtensionDescription(u.id);if(!l){const a=new Error(`Cannot activate unknown extension '${u.id.value}'`),y=this._createAndSaveOperation(u,null,[],new m(a));return this._host.onExtensionActivationError(u.id,a,new p.MissingExtensionDependency(u.id.value)),y}const S=[],w=typeof l.extensionDependencies=="undefined"?[]:l.extensionDependencies;for(const a of w){if(this._resolvedExtensionsSet.has(C.ExtensionIdentifier.toKey(a)))continue;const y=this._operations.get(C.ExtensionIdentifier.toKey(a));if(y){S.push(y);continue}if(this._externalExtensionsMap.has(C.ExtensionIdentifier.toKey(a))){S.push(this._handleActivationRequest({id:this._externalExtensionsMap.get(C.ExtensionIdentifier.toKey(a)),reason:u.reason}));continue}const r=this._registry.getExtensionDescription(a);if(r){if(!r.main&&!r.browser)continue;S.push(this._handleActivationRequest({id:r.identifier,reason:u.reason}));continue}const d=l.displayName||l.identifier.value,i=new Error(`Cannot activate the '${d}' extension because it depends on unknown extension '${a}'`),s=this._createAndSaveOperation(u,l.displayName,[],new m(i));return this._host.onExtensionActivationError(l.identifier,i,new p.MissingExtensionDependency(a)),s}return this._createAndSaveOperation(u,l.displayName,S,null)}_createAndSaveOperation(u,l,S,w){const a=new g(u.id,l,u.reason,S,w,this._host,this._logService);return this._operations.set(C.ExtensionIdentifier.toKey(u.id),a),a}};T=$e([xe(4,U.ILogService)],T),e.ExtensionsActivator=T;let g=class{constructor(u,l,S,w,a,y,r){this._id=u,this._displayName=l,this._reason=S,this._deps=w,this._value=a,this._host=y,this._logService=r,this._barrier=new I.Barrier,this._isDisposed=!1,this._initialize()}get value(){return this._value}get friendlyName(){return this._displayName||this._id.value}dispose(){this._isDisposed=!0}wait(){return this._barrier.wait()}async _initialize(){await this._waitForDepsThenActivate(),this._barrier.open()}async _waitForDepsThenActivate(){if(!this._value){for(;this._deps.length>0;){for(let u=0;u<this._deps.length;u++){const l=this._deps[u];if(l.value&&!l.value.activationFailed){this._deps.splice(u,1),u--;continue}if(l.value&&l.value.activationFailed){const S=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${l.friendlyName}' failed to activate`);S.detail=l.value.activationFailedError,this._value=new m(S),this._host.onExtensionActivationError(this._id,S,null);return}}this._deps.length>0&&await Promise.race(this._deps.map(u=>u.wait()))}await this._activate()}}async _activate(){try{this._value=await this._host.actualActivateExtension(this._id,this._reason)}catch(u){const l=new Error;if(u&&u.name&&(l.name=u.name),u&&u.message?l.message=`Activating extension '${this._id.value}' failed: ${u.message}.`:l.message=`Activating extension '${this._id.value}' failed: ${u}.`,u&&u.stack&&(l.stack=u.stack),this._value=new m(l),this._isDisposed&&o.isCancellationError(u))return;this._host.onExtensionActivationError(this._id,l,null),this._logService.error(`Activating extension ${this._id.value} failed due to an error:`),this._logService.error(u)}}};g=$e([xe(6,U.ILogService)],g)}),define(De[180],Ce([1,0,14,28,25]),function(J,e,o,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let U=class extends o.LogService{constructor(P,b){super(P.createLogger(b.logFile,{name:p.ExtensionHostLogFileName}))}};U=$e([xe(0,o.ILoggerService),xe(1,C.IExtHostInitDataService)],U),e.ExtHostLogService=U}),define(De[181],Ce([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",badges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.badges.d.ts",commentsResolvedState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsResolvedState.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorToolbar:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorToolbar.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",inlineCompletionsNew:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsNew.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookContentProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookContentProvider.d.ts",notebookControllerKind:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerKind.d.ts",notebookDebugOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDebugOptions.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookEditor.d.ts",notebookEditorEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookEditorEdit.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookWorkspaceEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookWorkspaceEdit.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",snippetWorkspaceEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.snippetWorkspaceEdit.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalNameChangeEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalNameChangeEvent.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textEditorDrop:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textEditorDrop.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(De[182],Ce([1,0,141,11,29,79,82,30,27,181,149]),function(J,e,o,C,p,U,I,P,b,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const _=P.Registry.as(I.Extensions.JSONContribution);class m{constructor(a,y,r){this._messageHandler=a,this._extension=y,this._extensionPointId=r}_msg(a,y){this._messageHandler({type:a,message:y,extensionId:this._extension.identifier,extensionPointId:this._extensionPointId})}error(a){this._msg(p.default.Error,a)}warn(a){this._msg(p.default.Warning,a)}info(a){this._msg(p.default.Info,a)}}e.ExtensionMessageCollector=m;class T{constructor(a,y){this.added=a,this.removed=y}static _toSet(a){const y=new Set;for(let r=0,d=a.length;r<d;r++)y.add(b.ExtensionIdentifier.toKey(a[r].description.identifier));return y}static compute(a,y){if(!a||!a.length)return new T(y,[]);if(!y||!y.length)return new T([],a);const r=this._toSet(a),d=this._toSet(y),i=y.filter(n=>!r.has(b.ExtensionIdentifier.toKey(n.description.identifier))),s=a.filter(n=>!d.has(b.ExtensionIdentifier.toKey(n.description.identifier)));return new T(i,s)}}e.ExtensionPointUserDelta=T;class g{constructor(a,y){this.name=a,this.defaultExtensionKind=y,this._handler=null,this._users=null,this._delta=null}setHandler(a){if(this._handler!==null)throw new Error("Handler already set!");this._handler=a,this._handle()}acceptUsers(a){this._delta=T.compute(this._users,a),this._users=a,this._handle()}_handle(){if(!(this._handler===null||this._users===null||this._delta===null))try{this._handler(this._users,this._delta)}catch(a){(0,C.onUnexpectedError)(a)}}}e.ExtensionPoint=g;const h={type:"string",enum:["ui","workspace"],enumDescriptions:[o.localize(0,null),o.localize(1,null)]},u="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:o.localize(2,null),properties:{vscode:{type:"string",description:o.localize(3,null),default:"^1.22.0"}}},publisher:{description:o.localize(4,null),type:"string"},displayName:{description:o.localize(5,null),type:"string"},categories:{description:o.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:b.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:o.localize(7,null)}]}},galleryBanner:{type:"object",description:o.localize(8,null),properties:{color:{description:o.localize(9,null),type:"string"},theme:{description:o.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:o.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:o.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:o.localize(13,null)},enabledApiProposals:{markdownDescription:o.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(A.allApiProposals),markdownEnumDescriptions:Object.values(A.allApiProposals)}},activationEvents:{description:o.localize(15,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:o.localize(16,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:o.localize(17,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:o.localize(18,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:o.localize(19,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:o.localize(20,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:o.localize(21,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:o.localize(22,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:o.localize(23,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:o.localize(24,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:o.localize(25,null),body:"onStartupFinished"},{label:"onTaskType",description:o.localize(26,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:o.localize(27,null),body:"onFileSystem:${1:scheme}"},{label:"onSearch",description:o.localize(28,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:o.localize(29,null)},{label:"onIdentity",body:"onIdentity:${8:identity}",description:o.localize(30,null)},{label:"onUri",body:"onUri",description:o.localize(31,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:o.localize(32,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:o.localize(33,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:o.localize(34,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:o.localize(35,null)},{label:"onRenderer",description:o.localize(36,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:o.localize(37,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:o.localize(38,null)},{label:"*",description:o.localize(39,null),body:"*"}]}},badges:{type:"array",description:o.localize(40,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:o.localize(41,null)},href:{type:"string",description:o.localize(42,null)},description:{type:"string",description:o.localize(43,null)}}}},markdown:{type:"string",description:o.localize(44,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:o.localize(45,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:o.localize(46,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:U.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:o.localize(47,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:U.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:o.localize(48,null),type:"array",items:h,default:["workspace"],defaultSnippets:[{body:["ui"],description:o.localize(49,null)},{body:["workspace"],description:o.localize(50,null)},{body:["ui","workspace"],description:o.localize(51,null)},{body:["workspace","ui"],description:o.localize(52,null)},{body:[],description:o.localize(53,null)}]},capabilities:{description:o.localize(54,null),type:"object",properties:{virtualWorkspaces:{description:o.localize(55,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:o.localize(56,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[o.localize(57,null),o.localize(58,null),o.localize(59,null)]},description:{type:"string",markdownDescription:o.localize(60,null)}}},untrustedWorkspaces:{description:o.localize(61,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:o.localize(62,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[o.localize(63,null),o.localize(64,null),o.localize(65,null)]},restrictedConfigurations:{description:o.localize(66,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:o.localize(67,null)}}}}},sponsor:{description:o.localize(68,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:o.localize(69,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:o.localize(70,null),type:"string"},"vscode:uninstall":{description:o.localize(71,null),type:"string"}}},icon:{type:"string",description:o.localize(72,null)}}};class l{constructor(){this._extensionPoints=new Map}registerExtensionPoint(a){if(this._extensionPoints.has(a.extensionPoint))throw new Error("Duplicate extension point: "+a.extensionPoint);const y=new g(a.extensionPoint,a.defaultExtensionKind);return this._extensionPoints.set(a.extensionPoint,y),e.schema.properties.contributes.properties[a.extensionPoint]=a.jsonSchema,_.registerSchema(u,e.schema),y}getExtensionPoints(){return Array.from(this._extensionPoints.values())}}e.ExtensionsRegistryImpl=l;const S={ExtensionsRegistry:"ExtensionsRegistry"};P.Registry.add(S.ExtensionsRegistry,new l),e.ExtensionsRegistry=P.Registry.as(S.ExtensionsRegistry),_.registerSchema(u,e.schema),_.registerSchema(R.productSchemaId,{properties:{extensionEnabledApiProposals:{description:o.localize(73,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(A.allApiProposals),markdownEnumDescriptions:Object.values(A.allApiProposals)}}]}}}})}),define(De[183],Ce([1,0,138,9,26,182,38,4]),function(J,e,o,C,p,U,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=e.TaskDefinitionRegistryImpl=void 0;const b={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:o.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:o.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:o.localize(2,null),default:""}}};var A;(function(m){function T(g,h,u){if(!g)return;const l=C.isString(g.type)?g.type:void 0;if(!l||l.length===0){u.error(o.localize(3,null));return}const S=[];if(Array.isArray(g.required))for(const w of g.required)C.isString(w)&&S.push(w);return{extensionId:h.value,taskType:l,required:S,properties:g.properties?p.deepClone(g.properties):{},when:g.when?I.ContextKeyExpr.deserialize(g.when):void 0}}m.from=T})(A||(A={}));const R=U.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",jsonSchema:{description:o.localize(4,null),type:"array",items:b}});class _{constructor(){this._onDefinitionsChanged=new P.Emitter,this.onDefinitionsChanged=this._onDefinitionsChanged.event,this.taskTypes=Object.create(null),this.readyPromise=new Promise((T,g)=>{R.setHandler((h,u)=>{this._schema=void 0;try{for(const l of u.removed){const S=l.value;for(const w of S)this.taskTypes&&w.type&&this.taskTypes[w.type]&&delete this.taskTypes[w.type]}for(const l of u.added){const S=l.value;for(const w of S){const a=A.from(w,l.description.identifier,l.collector);a&&(this.taskTypes[a.taskType]=a)}}(u.removed.length>0||u.added.length>0)&&this._onDefinitionsChanged.fire()}catch{}T(void 0)})})}onReady(){return this.readyPromise}get(T){return this.taskTypes[T]}all(){return Object.keys(this.taskTypes).map(T=>this.taskTypes[T])}getJsonSchema(){if(this._schema===void 0){const T=[];for(const g of this.all()){const h={type:"object",additionalProperties:!1};g.required.length>0&&(h.required=g.required.slice(0)),g.properties!==void 0?h.properties=p.deepClone(g.properties):h.properties=Object.create(null),h.properties.type={type:"string",enum:[g.taskType]},T.push(h)}this._schema={oneOf:T}}return this._schema}}e.TaskDefinitionRegistryImpl=_,e.TaskDefinitionRegistry=new _}),define(De[184],Ce([1,0,139,9,21,26,38,183]),function(J,e,o,C,p,U,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new I.RawContextKey("taskRunning",!1,o.localize(0,null)),e.TASKS_CATEGORY={value:o.localize(1,null),original:"Tasks"};var b;(function(F){F[F.Escape=1]="Escape",F[F.Strong=2]="Strong",F[F.Weak=3]="Weak"})(b=e.ShellQuoting||(e.ShellQuoting={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(F){function O(H){if(!H)return F.Strong;switch(H.toLowerCase()){case"escape":return F.Escape;case"strong":return F.Strong;case"weak":return F.Weak;default:return F.Strong}}F.from=O}(b=e.ShellQuoting||(e.ShellQuoting={}));var A;(function(F){F.defaults={cwd:"${workspaceFolder}"}})(A=e.CommandOptions||(e.CommandOptions={}));var R;(function(F){F[F.Always=1]="Always",F[F.Silent=2]="Silent",F[F.Never=3]="Never"})(R=e.RevealKind||(e.RevealKind={})),function(F){function O(H){switch(H.toLowerCase()){case"always":return F.Always;case"silent":return F.Silent;case"never":return F.Never;default:return F.Always}}F.fromString=O}(R=e.RevealKind||(e.RevealKind={}));var _;(function(F){F[F.Never=1]="Never",F[F.OnProblem=2]="OnProblem",F[F.Always=3]="Always"})(_=e.RevealProblemKind||(e.RevealProblemKind={})),function(F){function O(H){switch(H.toLowerCase()){case"always":return F.Always;case"never":return F.Never;case"onproblem":return F.OnProblem;default:return F.OnProblem}}F.fromString=O}(_=e.RevealProblemKind||(e.RevealProblemKind={}));var m;(function(F){F[F.Shared=1]="Shared",F[F.Dedicated=2]="Dedicated",F[F.New=3]="New"})(m=e.PanelKind||(e.PanelKind={})),function(F){function O(H){switch(H.toLowerCase()){case"shared":return F.Shared;case"dedicated":return F.Dedicated;case"new":return F.New;default:return F.Shared}}F.fromString=O}(m=e.PanelKind||(e.PanelKind={}));var T;(function(F){F.defaults={echo:!0,reveal:R.Always,revealProblems:_.Never,focus:!1,panel:m.Shared,showReuseMessage:!0,clear:!1}})(T=e.PresentationOptions||(e.PresentationOptions={}));var g;(function(F){F[F.Shell=1]="Shell",F[F.Process=2]="Process",F[F.CustomExecution=3]="CustomExecution"})(g=e.RuntimeType||(e.RuntimeType={})),function(F){function O(te){switch(te.toLowerCase()){case"shell":return F.Shell;case"process":return F.Process;case"customExecution":return F.CustomExecution;default:return F.Process}}F.fromString=O;function H(te){switch(te){case F.Shell:return"shell";case F.Process:return"process";case F.CustomExecution:return"customExecution";default:return"process"}}F.toString=H}(g=e.RuntimeType||(e.RuntimeType={}));var h;(function(F){function O(H){return C.isString(H)?H:H.value}F.value=O})(h=e.CommandString||(e.CommandString={}));var u;(function(F){F.Clean={_id:"clean",isDefault:!1},F.Build={_id:"build",isDefault:!1},F.Rebuild={_id:"rebuild",isDefault:!1},F.Test={_id:"test",isDefault:!1};function O(te){return te===F.Clean._id||te===F.Build._id||te===F.Rebuild._id||te===F.Test._id}F.is=O;function H(te){if(te!==void 0)return C.isString(te)?O(te)?{_id:te,isDefault:!1}:void 0:te}F.from=H})(u=e.TaskGroup||(e.TaskGroup={}));var l;(function(F){F[F.Global=1]="Global",F[F.Workspace=2]="Workspace",F[F.Folder=3]="Folder"})(l=e.TaskScope||(e.TaskScope={}));var S;(function(F){F.Workspace="workspace",F.Extension="extension",F.InMemory="inMemory",F.WorkspaceFile="workspaceFile",F.User="user";function O(H){switch(H){case F.User:return 1;case F.WorkspaceFile:return 4;default:return 5}}F.toConfigurationTarget=O})(S=e.TaskSourceKind||(e.TaskSourceKind={}));var w;(function(F){F.parallel="parallel",F.sequence="sequence"})(w=e.DependsOrder||(e.DependsOrder={}));var a;(function(F){F[F.default=1]="default",F[F.folderOpen=2]="folderOpen"})(a=e.RunOnOptions||(e.RunOnOptions={}));var y;(function(F){F.defaults={reevaluateOnRerun:!0,runOn:a.default,instanceLimit:1}})(y=e.RunOptions||(e.RunOptions={}));class r{constructor(O,H,te,z,$,ce){this._label="",this._id=O,H&&(this._label=H),te&&(this.type=te),this.runOptions=z,this.configurationProperties=$,this._source=ce}getDefinition(O){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const O={folder:this.getFolderId(),id:this._id};return JSON.stringify(O)}clone(){return this.fromObject(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(O,H=!1){if(O===void 0)return!1;if(C.isString(O))return O===this._label||O===this.configurationProperties.identifier||H&&O===this._id;const te=this.getDefinition(!0);return te!==void 0&&te._key===O._key}getQualifiedLabel(){const O=this.getWorkspaceFolder();return O?`${this._label} (${O.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(O){this._taskLoadMessages===void 0&&(this._taskLoadMessages=[]),O&&(this._taskLoadMessages=this._taskLoadMessages.concat(O))}get taskLoadMessages(){return this._taskLoadMessages}}e.CommonTask=r;class d extends r{constructor(O,H,te,z,$,ce,le,oe){super(O,te,void 0,le,oe,H);this.command={},this._source=H,this.hasDefinedMatchers=ce,$&&(this.command=$)}clone(){return new d(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(O=!1){if(O&&this._source.customizes!==void 0)return this._source.customizes;{let H;switch(this.command?this.command.runtime:void 0){case g.Shell:H="shell";break;case g.Process:H="process";break;case g.CustomExecution:H="customExecution";break;case void 0:H="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:H,_key:this._id,id:this._id}}}static is(O){return O instanceof d}getMapKey(){const O=this._source.config.workspaceFolder;return O?`${O.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}getFolderId(){return this._source.kind===S.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const O=this.getFolderId();if(!O)return;let H=this.configurationProperties.identifier;this._source.kind!==S.Workspace&&(H+=this._source.kind);const te={type:e.CUSTOMIZED_TASK_TYPE,folder:O,id:H};return JSON.stringify(te)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?p.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}fromObject(O){return new d(O._id,O._source,O._label,O.type,O.command,O.hasDefinedMatchers,O.runOptions,O.configurationProperties)}}e.CustomTask=d;class i extends r{constructor(O,H,te,z,$,ce,le){super(O,te,z,ce,le,H);this._source=H,this.configures=$}static is(O){return O instanceof i}fromObject(O){return O}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?p.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}getFolderId(){return this._source.kind===S.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const O=this.getFolderId();if(!O)return;let H=this.configurationProperties.identifier;this._source.kind!==S.Workspace&&(H+=this._source.kind);const te={type:e.CUSTOMIZED_TASK_TYPE,folder:O,id:H};return JSON.stringify(te)}}e.ConfiguringTask=i;class s extends r{constructor(O,H,te,z,$,ce,le,oe,pe){super(O,te,z,oe,pe,H);this.defines=$,this.hasDefinedMatchers=le,this.command=ce,this.icon=pe.icon}clone(){return new s(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(O){return O instanceof s}getMapKey(){const O=this._source.workspaceFolder;return O?`${this._source.scope.toString()}|${O.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}getFolderId(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const O={type:"contributed",scope:this._source.scope,id:this._id};return O.folder=this.getFolderId(),JSON.stringify(O)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}fromObject(O){return new s(O._id,O._source,O._label,O.type,O.defines,O.command,O.hasDefinedMatchers,O.runOptions,O.configurationProperties)}}e.ContributedTask=s;class n extends r{constructor(O,H,te,z,$,ce){super(O,te,z,$,ce,H);this._source=H}clone(){return new n(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(O){return O instanceof n}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}getFolderId(){}fromObject(O){return new n(O._id,O._source,O._label,O.type,O.runOptions,O.configurationProperties)}}e.InMemoryTask=n;var t;(function(F){F[F.Process=1]="Process",F[F.Terminal=2]="Terminal"})(t=e.ExecutionEngine||(e.ExecutionEngine={})),function(F){F._default=F.Terminal}(t=e.ExecutionEngine||(e.ExecutionEngine={}));var c;(function(F){F[F.V0_1_0=1]="V0_1_0",F[F.V2_0_0=2]="V2_0_0"})(c=e.JsonSchemaVersion||(e.JsonSchemaVersion={}));class E{constructor(O){this._order=new Map;for(let H=0;H<O.length;H++)this._order.set(O[H].uri.toString(),H)}compare(O,H){const te=O.getWorkspaceFolder(),z=H.getWorkspaceFolder();if(te&&z){let $=this._order.get(te.uri.toString());$=$===void 0?0:$+1;let ce=this._order.get(z.uri.toString());return ce=ce===void 0?0:ce+1,$===ce?O._label.localeCompare(H._label):$-ce}else return!te&&z?-1:te&&!z?1:0}}e.TaskSorter=E;var f;(function(F){F.DependsOnStarted="dependsOnStarted",F.AcquiredInput="acquiredInput",F.Start="start",F.ProcessStarted="processStarted",F.Active="active",F.Inactive="inactive",F.Changed="changed",F.Terminated="terminated",F.ProcessEnded="processEnded",F.End="end"})(f=e.TaskEventKind||(e.TaskEventKind={}));var D;(function(F){F.SingleRun="singleRun",F.Background="background"})(D=e.TaskRunType||(e.TaskRunType={}));var L;(function(F){F[F.System=0]="System",F[F.User=1]="User",F[F.FolderOpen=2]="FolderOpen",F[F.ConfigurationChange=3]="ConfigurationChange"})(L=e.TaskRunSource||(e.TaskRunSource={}));var W;(function(F){function O(H,te,z,$){if(te){const ce={kind:H,taskId:te._id,taskName:te.configurationProperties.name,runType:te.configurationProperties.isBackground?"background":"singleRun",group:te.configurationProperties.group,processId:void 0,exitCode:void 0,terminalId:void 0,__task:te};return H==="start"?(ce.terminalId=z,ce.resolvedVariables=$):H==="processStarted"?ce.processId=z:H==="processEnded"&&(ce.exitCode=z),Object.freeze(ce)}else return Object.freeze({kind:"changed"})}F.create=O})(W=e.TaskEvent||(e.TaskEvent={}));var N;(function(F){function O(te){const z=Object.keys(te).sort();let $="";for(const ce of z){let le=te[ce];le instanceof Object?le=O(le):typeof le=="string"&&(le=le.replace(/,/g,",,")),$+=ce+","+le+","}return $}function H(te){const $={_key:O(te),type:te.taskType};return Object.assign($,te),$}F.create=H})(N=e.KeyedTaskIdentifier||(e.KeyedTaskIdentifier={}));var v;(function(F){function O(H,te){const z=P.TaskDefinitionRegistry.get(H.type);if(z===void 0){const oe=U.deepClone(H);return delete oe._key,N.create(oe)}const $=Object.create(null);$.type=z.taskType;const ce=new Set;z.required.forEach(oe=>ce.add(oe));const le=z.properties;for(const oe of Object.keys(le)){const pe=H[oe];if(pe!=null)$[oe]=pe;else if(ce.has(oe)){const re=le[oe];if(re.default!==void 0)$[oe]=U.deepClone(re.default);else switch(re.type){case"boolean":$[oe]=!1;break;case"number":case"integer":$[oe]=0;break;case"string":$[oe]="";break;default:te.error(o.localize(2,null,JSON.stringify(H,void 0,0),oe));return}}}return N.create($)}F.createTaskIdentifier=O})(v=e.TaskDefinition||(e.TaskDefinition={}))}),define(De[185],Ce([1,0,11]),function(J,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class C{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((I,P)=>{this._actualOk=I,this._actualErr=P,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(I){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=I,this._actual&&this._actualOk(I))}resolveErr(I){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=I,this._actual?this._actualErr(I):(0,o.onUnexpectedError)(I))}then(I,P){return this._ensureActual().then(I,P)}catch(I){return this._ensureActual().then(void 0,I)}finally(I){return this._ensureActual().finally(I)}}e.LazyPromise=C;class p extends C{constructor(){super();this._hasErr=!0,this._err=new o.CancellationError}}e.CanceledLazyPromise=p}),define(De[40],Ce([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class o{constructor(b){this._proxyIdentifierBrand=void 0,this.sid=b,this.nid=++o.count}}e.ProxyIdentifier=o,o.count=0;const C=[];function p(P){const b=new o(P);return C[b.nid]=b,b}e.createProxyIdentifier=p;function U(P){return C[P].sid}e.getStringIdentifierForProxy=U;class I{constructor(b){this.value=b}}e.SerializableObjectWithBuffers=I}),define(De[5],Ce([1,0,55,2,40]),function(J,e,o,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var U;(function(w){w[w.Default=0]="Default",w[w.InCenter=1]="InCenter",w[w.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",w[w.AtTop=3]="AtTop"})(U=e.TextEditorRevealType||(e.TextEditorRevealType={}));var I;(function(w){w[w.UnknownInput=0]="UnknownInput",w[w.TextInput=1]="TextInput",w[w.TextDiffInput=2]="TextDiffInput",w[w.NotebookInput=3]="NotebookInput",w[w.NotebookDiffInput=4]="NotebookDiffInput",w[w.CustomEditorInput=5]="CustomEditorInput",w[w.WebviewEditorInput=6]="WebviewEditorInput",w[w.TerminalEditorInput=7]="TerminalEditorInput"})(I=e.TabInputKind||(e.TabInputKind={}));var P;(function(w){w[w.TAB_OPEN=0]="TAB_OPEN",w[w.TAB_CLOSE=1]="TAB_CLOSE",w[w.TAB_UPDATE=2]="TAB_UPDATE",w[w.TAB_MOVE=3]="TAB_MOVE"})(P=e.TabModelOperationKind||(e.TabModelOperationKind={}));var b;(function(w){w[w.Editable=0]="Editable",w[w.SupportsHotExit=1]="SupportsHotExit"})(b=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var A;(function(w){w[w.Int8Array=1]="Int8Array",w[w.Uint8Array=2]="Uint8Array",w[w.Uint8ClampedArray=3]="Uint8ClampedArray",w[w.Int16Array=4]="Int16Array",w[w.Uint16Array=5]="Uint16Array",w[w.Int32Array=6]="Int32Array",w[w.Uint32Array=7]="Uint32Array",w[w.Float32Array=8]="Float32Array",w[w.Float64Array=9]="Float64Array",w[w.BigInt64Array=10]="BigInt64Array",w[w.BigUint64Array=11]="BigUint64Array"})(A=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var R;(function(w){w[w.Text=1]="Text",w[w.Error=2]="Error",w[w.Rich=3]="Rich"})(R=e.CellOutputKind||(e.CellOutputKind={}));var _;(function(w){w[w.Default=0]="Default",w[w.InCenter=1]="InCenter",w[w.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",w[w.AtTop=3]="AtTop"})(_=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var m;(function(w){w[w.None=0]="None",w[w.Process=1]="Process",w[w.Output=2]="Output"})(m=e.CandidatePortSource||(e.CandidatePortSource={}));class T{static mixin(a){return a._id=T._n++,a}}e.IdObject=T,T._n=0;var g;(function(w){w.label="a",w.kind="b",w.detail="c",w.documentation="d",w.sortText="e",w.filterText="f",w.preselect="g",w.insertText="h",w.insertTextRules="i",w.range="j",w.commitCharacters="k",w.additionalTextEdits="l",w.command="m",w.kindModifier="n"})(g=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var h;(function(w){w.defaultRanges="a",w.completions="b",w.isIncomplete="c",w.duration="d"})(h=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var u;(function(w){w[w.File=1]="File",w[w.Text=2]="Text",w[w.Cell=3]="Cell"})(u=e.WorkspaceEditType||(e.WorkspaceEditType={}));function l(w){if(w&&w.edits)for(const a of w.edits)typeof a.resource=="object"?a.resource=C.URI.revive(a.resource):(a.newUri=C.URI.revive(a.newUri),a.oldUri=C.URI.revive(a.oldUri)),a.metadata&&a.metadata.iconPath&&(a.metadata=(0,o.revive)(a.metadata));return w}e.reviveWorkspaceEditDto=l;var S;(function(w){w[w.Workspace=0]="Workspace",w[w.TextDocument=1]="TextDocument"})(S=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,p.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,p.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,p.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,p.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,p.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,p.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,p.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,p.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,p.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,p.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,p.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,p.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,p.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,p.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,p.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,p.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,p.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,p.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,p.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,p.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,p.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,p.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,p.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,p.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,p.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,p.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,p.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,p.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,p.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,p.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,p.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,p.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,p.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,p.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,p.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,p.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,p.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,p.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,p.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,p.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,p.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,p.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,p.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,p.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,p.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,p.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,p.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,p.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,p.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,p.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,p.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,p.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,p.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,p.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,p.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,p.createProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,p.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,p.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,p.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,p.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,p.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,p.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,p.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,p.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,p.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,p.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,p.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,p.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,p.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,p.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,p.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,p.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,p.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,p.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,p.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,p.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,p.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,p.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,p.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,p.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,p.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,p.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,p.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,p.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,p.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,p.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,p.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,p.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,p.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,p.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,p.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,p.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,p.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,p.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,p.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,p.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,p.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,p.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,p.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,p.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,p.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,p.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,p.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,p.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,p.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,p.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,p.createProxyIdentifier)("ExtHostTelemetry")}}),define(De[67],Ce([1,0,5,4,3]),function(J,e,o,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class U{constructor(P){this._onDidChangePassword=new C.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=P.getProxy(o.MainContext.MainThreadSecretState)}async $onDidChangePassword(P){this._onDidChangePassword.fire(P)}get(P,b){return this._proxy.$getPassword(P,b)}store(P,b,A){return this._proxy.$setPassword(P,b,A)}delete(P,b){return this._proxy.$deletePassword(P,b)}}e.ExtHostSecretState=U,e.IExtHostSecretState=(0,p.createDecorator)("IExtHostSecretState")}),define(De[68],Ce([1,0,3,14,5,15]),function(J,e,o,C,p,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,o.createDecorator)("IExtHostApiDeprecationService");let I=class{constructor(b,A){this._extHostLogService=A,this._reportedUsages=new Set,this._telemetryShape=b.getProxy(p.MainContext.MainThreadTelemetry)}report(b,A,R){const _=this.getUsageKey(b,A);this._reportedUsages.has(_)||(this._reportedUsages.add(_),A.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${b}' is deprecated. ${R}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:A.identifier.value,apiId:b}))}getUsageKey(b,A){return`${b}-${A.identifier.value}`}};I=$e([xe(0,U.IExtHostRpcService),xe(1,C.ILogService)],I),e.ExtHostApiDeprecationService=I,e.NullApiDeprecationService=Object.freeze(new class{report(P,b,A){}})}),define(De[186],Ce([1,0,4,5,6,27]),function(J,e,o,C,p,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class I{constructor(b){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new o.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=b.getProxy(C.MainContext.MainThreadAuthentication)}$setProviders(b){return this._providers=b,Promise.resolve()}async getSession(b,A,R,_={}){const m=U.ExtensionIdentifier.toKey(b.identifier),T=this._inFlightRequests.get(m)||[],g=[...R].sort().join(" ");let h=T.find(u=>u.providerId===A&&u.scopes===g);if(h)return h.result;{const u=this._getSession(b,m,A,R,_);h={providerId:A,scopes:g,result:u},T.push(h),this._inFlightRequests.set(m,T);try{await u}finally{const l=T.findIndex(S=>S.providerId===A&&S.scopes===g);l>-1&&(T.splice(l),this._inFlightRequests.set(m,T))}return u}}async _getSession(b,A,R,_,m={}){await this._proxy.$ensureProvider(R);const T=b.displayName||b.name;return this._proxy.$getSession(R,_,A,T,m)}async removeSession(b,A){const R=this._authenticationProviders.get(b);return R?R.provider.removeSession(A):this._proxy.$removeSession(b,A)}registerAuthenticationProvider(b,A,R,_){if(this._authenticationProviders.get(b))throw new Error(`An authentication provider with id '${b}' is already registered.`);this._authenticationProviders.set(b,{label:A,provider:R,options:_??{supportsMultipleAccounts:!1}}),this._providers.find(T=>T.id===b)||this._providers.push({id:b,label:A});const m=R.onDidChangeSessions(T=>{this._proxy.$sendDidChangeSessions(b,{added:T.added??[],changed:T.changed??[],removed:T.removed??[]})});return this._proxy.$registerAuthenticationProvider(b,A,_?.supportsMultipleAccounts??!1),new p.Disposable(()=>{m.dispose(),this._authenticationProviders.delete(b);const T=this._providers.findIndex(g=>g.id===b);T>-1&&this._providers.splice(T),this._proxy.$unregisterAuthenticationProvider(b)})}$createSession(b,A){const R=this._authenticationProviders.get(b);if(R)return Promise.resolve(R.provider.createSession(A));throw new Error(`Unable to find authentication provider with handle: ${b}`)}$removeSession(b,A){const R=this._authenticationProviders.get(b);if(R)return Promise.resolve(R.provider.removeSession(A));throw new Error(`Unable to find authentication provider with handle: ${b}`)}$getSessions(b,A){const R=this._authenticationProviders.get(b);if(R)return Promise.resolve(R.provider.getSessions(A));throw new Error(`Unable to find authentication provider with handle: ${b}`)}$onDidChangeAuthenticationSessions(b,A){return this._onDidChangeSessions.fire({provider:{id:b,label:A}}),Promise.resolve()}}e.ExtHostAuthentication=I}),define(De[187],Ce([1,0,5,15,8,25]),function(J,e,o,C,p,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let I=class{constructor(b,A){this._proxy=b.getProxy(o.MainContext.MainThreadBulkEdits),this._versionInformationProvider={getTextDocumentVersion:R=>A.getDocument(R)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(b,A){const R=(0,U.isProposedApiEnabled)(A,"snippetWorkspaceEdit"),_=p.WorkspaceEdit.from(b,this._versionInformationProvider,R);return this._proxy.$tryApplyWorkspaceEdit(_)}};I=$e([xe(0,C.IExtHostRpcService)],I),e.ExtHostBulkEdits=I}),define(De[188],Ce([1,0,5]),function(J,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class C{constructor(U){const I=U.getProxy(o.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return I.$readText()},writeText(P){return I.$writeText(P)}})}}e.ExtHostClipboard=C});var Ye=this&&this.__classPrivateFieldSet||function(J,e,o,C,p){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!p)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!p:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?p.call(J,o):p?p.value=o:e.set(J,o),o},Ae=this&&this.__classPrivateFieldGet||function(J,e,o,C){if(o==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!C:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?C:o==="a"?C.call(J):C?C.value:e.get(J)};define(De[36],Ce([1,0,9,6,8,26,5,16,14,55,48,241,2,7,3,15,92,23,40,44]),function(J,e,o,C,p,U,I,P,b,A,R,_,m,T,g,h,u,l,S,w){"use strict";var a,y;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let r=class{constructor(c,E){a.set(this,void 0),this._commands=new Map,this._apiCommands=new Map,y.set(this,void 0),Ye(this,a,c.getProxy(I.MainContext.MainThreadCommands),"f"),this._logService=E,Ye(this,y,c.getProxy(I.MainContext.MainThreadTelemetry),"f"),this.converter=new d(this,f=>{const D=this._apiCommands.get(f);return D?.result===s.Void?D:void 0},E),this._argumentProcessors=[{processArgument(f){return(0,A.revive)(f)}},{processArgument(f){return(0,U.cloneAndChange)(f,function(D){if(R.Range.isIRange(D))return p.Range.to(D);if(_.Position.isIPosition(D))return p.Position.to(D);if(R.Range.isIRange(D.range)&&m.URI.isUri(D.uri))return p.location.to(D);if(D instanceof l.VSBuffer)return D.buffer.buffer;if(!Array.isArray(D))return D})}}]}registerArgumentProcessor(c){this._argumentProcessors.push(c)}registerApiCommand(c){const E=this.registerCommand(!1,c.id,async(...f)=>{const D=c.args.map((W,N)=>{if(!W.validate(f[N]))throw new Error(`Invalid argument '${W.name}' when running '${c.id}', received: ${f[N]}`);return W.convert(f[N])}),L=await this.executeCommand(c.internalId,...D);return c.result.convert(L,f,this.converter)},void 0,{description:c.description,args:c.args,returns:c.result.description});return this._apiCommands.set(c.id,c),new C.Disposable(()=>{E.dispose(),this._apiCommands.delete(c.id)})}registerCommand(c,E,f,D,L,W){if(this._logService.trace("ExtHostCommands#registerCommand",E),!E.trim().length)throw new Error("invalid id");if(this._commands.has(E))throw new Error(`command '${E}' already exists`);return this._commands.set(E,{callback:f,thisArg:D,description:L,extension:W}),c&&Ae(this,a,"f").$registerCommand(E),new C.Disposable(()=>{this._commands.delete(E)&&c&&Ae(this,a,"f").$unregisterCommand(E)})}executeCommand(c,...E){return this._logService.trace("ExtHostCommands#executeCommand",c),this._doExecuteCommand(c,E,!0)}async _doExecuteCommand(c,E,f){if(this._commands.has(c))return Ae(this,a,"f").$fireCommandActivationEvent(c),this._executeContributedCommand(c,E,!1);{let D=!1;const L=(0,U.cloneAndChange)(E,function(W){if(W instanceof C.Position)return p.Position.from(W);if(W instanceof C.Range)return p.Range.from(W);if(W instanceof C.Location)return p.location.from(W);if(C.NotebookRange.isNotebookRange(W))return p.NotebookRange.from(W);if(W instanceof ArrayBuffer)return D=!0,l.VSBuffer.wrap(new Uint8Array(W));if(W instanceof Uint8Array)return D=!0,l.VSBuffer.wrap(W);if(W instanceof l.VSBuffer)return D=!0,W;if(!Array.isArray(W))return W});try{const W=await Ae(this,a,"f").$executeCommand(c,D?new S.SerializableObjectWithBuffers(L):L,f);return(0,A.revive)(W)}catch(W){if(W instanceof Error&&W.message==="$executeCommand:retry")return this._doExecuteCommand(c,E,!1);throw W}}}async _executeContributedCommand(c,E,f){const D=this._commands.get(c);if(!D)throw new Error("Unknown command");this._reportTelemetry(D,c);const{callback:L,thisArg:W,description:N}=D;if(N)for(let v=0;v<N.args.length;v++)try{(0,o.validateConstraint)(E[v],N.args[v].constraint)}catch{throw new Error(`Running the contributed command: '${c}' failed. Illegal argument '${N.args[v].name}' - ${N.args[v].description}`)}try{return await L.apply(W,E)}catch(v){if(c===this.converter.delegatingCommandId){const F=this.converter.getActualCommand(...E);F&&(c=F.command)}throw this._logService.error(v,c,D.extension?.identifier),f?new class extends Error{constructor(){super((0,w.toErrorMessage)(v));this.id=c,this.source=D.extension?.displayName??D.extension?.name}}:v}}_reportTelemetry(c,E){!c.extension||c.extension.isBuiltin||Ae(this,y,"f").$publicLog2("Extension:ActionExecuted",{extensionId:c.extension.identifier.value,id:E})}$executeContributedCommand(c,...E){return this._logService.trace("ExtHostCommands#$executeContributedCommand",c),this._commands.has(c)?(E=E.map(f=>this._argumentProcessors.reduce((D,L)=>L.processArgument(D),f)),this._executeContributedCommand(c,E,!0)):Promise.reject(new Error(`Contributed command '${c}' does not exist.`))}getCommands(c=!1){return this._logService.trace("ExtHostCommands#getCommands",c),Ae(this,a,"f").$getCommands().then(E=>(c&&(E=E.filter(f=>f[0]!=="_")),E))}$getContributedCommandHandlerDescriptions(){const c=Object.create(null);for(const[E,f]of this._commands){const{description:D}=f;D&&(c[E]=D)}return Promise.resolve(c)}};a=new WeakMap,y=new WeakMap,r=$e([xe(0,h.IExtHostRpcService),xe(1,b.ILogService)],r),e.ExtHostCommands=r,e.IExtHostCommands=(0,g.createDecorator)("IExtHostCommands");class d{constructor(c,E,f){this._commands=c,this._lookupApiCommand=E,this._logService=f,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(c,E){if(!c)return;const f={$ident:void 0,id:c.command,title:c.title,tooltip:c.tooltip};if(!c.command)return f;const D=this._lookupApiCommand(c.command);if(D)f.id=D.internalId,f.arguments=D.args.map((L,W)=>L.convert(c.arguments&&c.arguments[W]));else if((0,P.isNonEmptyArray)(c.arguments)){const L=++this._cachIdPool;this._cache.set(L,c),E.add((0,T.toDisposable)(()=>{this._cache.delete(L),this._logService.trace("CommandsConverter#DISPOSE",L)})),f.$ident=L,f.id=this.delegatingCommandId,f.arguments=[L],this._logService.trace("CommandsConverter#CREATE",c.command,L)}return f}fromInternal(c){return typeof c.$ident=="number"?this._cache.get(c.$ident):{command:c.id,title:c.title,arguments:c.arguments}}getActualCommand(...c){return this._cache.get(c[0])}_executeConvertedCommand(...c){const E=this.getActualCommand(...c);return this._logService.trace("CommandsConverter#EXECUTE",c[0],E?E.command:"MISSING"),E?this._commands.executeCommand(E.command,...E.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=d;class i{constructor(c,E,f,D){this.name=c,this.description=E,this.validate=f,this.convert=D}optional(){return new i(this.name,`(optional) ${this.description}`,c=>c==null||this.validate(c),c=>c===void 0?void 0:c===null?null:this.convert(c))}with(c,E){return new i(c??this.name,E??this.description,this.validate,this.convert)}}e.ApiCommandArgument=i,i.Uri=new i("uri","Uri of a text document",t=>m.URI.isUri(t),t=>t),i.Position=new i("position","A position in a text document",t=>C.Position.isPosition(t),p.Position.from),i.Range=new i("range","A range in a text document",t=>C.Range.isRange(t),p.Range.from),i.Selection=new i("selection","A selection in a text document",t=>C.Selection.isSelection(t),p.Selection.from),i.Number=new i("number","",t=>typeof t=="number",t=>t),i.String=new i("string","",t=>typeof t=="string",t=>t),i.CallHierarchyItem=new i("item","A call hierarchy item",t=>t instanceof C.CallHierarchyItem,p.CallHierarchyItem.from),i.TypeHierarchyItem=new i("item","A type hierarchy item",t=>t instanceof C.TypeHierarchyItem,p.TypeHierarchyItem.from),i.TestItem=new i("testItem","A VS Code TestItem",t=>t instanceof u.TestItemImpl,p.TestItem.from);class s{constructor(c,E){this.description=c,this.convert=E}}e.ApiCommandResult=s,s.Void=new s("no result",t=>t);class n{constructor(c,E,f,D,L){this.id=c,this.internalId=E,this.description=f,this.args=D,this.result=L}}e.ApiCommand=n}),define(De[189],Ce([1,0,2,8,6,66,36,16,77,81,12]),function(J,e,o,C,p,U,I,P,b,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const _=[new I.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",T(C.DocumentHighlight.to))),new I.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[I.ApiCommandArgument.Uri],new I.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(h,u)=>{if((0,P.isFalsyOrEmpty)(h))return;class l extends p.SymbolInformation{static to(w){const a=new l(w.name,C.SymbolKind.to(w.kind),w.containerName||"",new p.Location(u[0],C.Range.to(w.range)));return a.detail=w.detail,a.range=a.location.range,a.selectionRange=C.Range.to(w.selectionRange),a.children=w.children?w.children.map(l.to):[],a}}return h.map(l.to)})),new I.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[I.ApiCommandArgument.Uri,new I.ApiCommandArgument("options","Formatting options",h=>!0,h=>h)],new I.ApiCommandResult("A promise that resolves to an array of TextEdits.",T(C.TextEdit.to))),new I.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Range,new I.ApiCommandArgument("options","Formatting options",h=>!0,h=>h)],new I.ApiCommandResult("A promise that resolves to an array of TextEdits.",T(C.TextEdit.to))),new I.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position,new I.ApiCommandArgument("ch","Trigger character",h=>typeof h=="string",h=>h),new I.ApiCommandArgument("options","Formatting options",h=>!0,h=>h)],new I.ApiCommandResult("A promise that resolves to an array of TextEdits.",T(C.TextEdit.to))),new I.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",g)),new I.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",g)),new I.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",g)),new I.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",g)),new I.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of Location-instances.",T(C.location.to))),new I.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of Hover-instances.",T(C.Hover.to))),new I.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[I.ApiCommandArgument.Uri,new I.ApiCommandArgument("position","A position in a text document",h=>Array.isArray(h)&&h.every(u=>p.Position.isPosition(u)),h=>h.map(C.Position.from))],new I.ApiCommandResult("A promise that resolves to an array of ranges.",h=>h.map(u=>{let l;for(const S of u.reverse())l=new p.SelectionRange(C.Range.to(S),l);return l}))),new I.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[I.ApiCommandArgument.String.with("query","Search string")],new I.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",h=>h.map(C.WorkspaceSymbol.to))),new I.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A CallHierarchyItem or undefined",h=>h.map(C.CallHierarchyItem.to))),new I.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[I.ApiCommandArgument.CallHierarchyItem],new I.ApiCommandResult("A CallHierarchyItem or undefined",h=>h.map(C.CallHierarchyIncomingCall.to))),new I.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[I.ApiCommandArgument.CallHierarchyItem],new I.ApiCommandResult("A CallHierarchyItem or undefined",h=>h.map(C.CallHierarchyOutgoingCall.to))),new I.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to a range and placeholder text.",h=>{if(!!h)return{range:C.Range.to(h.range),placeholder:h.text}})),new I.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position,I.ApiCommandArgument.String.with("newName","The new symbol name")],new I.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",h=>{if(!!h){if(h.rejectReason)throw new Error(h.rejectReason);return C.WorkspaceEdit.to(h)}})),new I.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new I.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",h=>h.map(C.DocumentLink.to))),new I.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[I.ApiCommandArgument.Uri],new I.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",h=>{if(!!h)return new p.SemanticTokensLegend(h.tokenTypes,h.tokenModifiers)})),new I.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[I.ApiCommandArgument.Uri],new I.ApiCommandResult("A promise that resolves to SemanticTokens.",h=>{if(!h)return;const u=(0,b.decodeSemanticTokensDto)(h);if(u.type==="full")return new p.SemanticTokens(u.data,void 0)})),new I.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Range.optional()],new I.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",h=>{if(!!h)return new p.SemanticTokensLegend(h.tokenTypes,h.tokenModifiers)})),new I.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Range],new I.ApiCommandResult("A promise that resolves to SemanticTokens.",h=>{if(!h)return;const u=(0,b.decodeSemanticTokensDto)(h);if(u.type==="full")return new p.SemanticTokens(u.data,void 0)})),new I.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position,I.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),I.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new I.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(h,u,l)=>{if(!h)return new p.CompletionList([]);const S=h.suggestions.map(w=>C.CompletionItem.to(w,l));return new p.CompletionList(S,h.incomplete)})),new I.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position,I.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new I.ApiCommandResult("A promise that resolves to SignatureHelp.",h=>{if(h)return C.SignatureHelp.to(h)})),new I.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new I.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(h,u,l)=>T(S=>new p.CodeLens(C.Range.to(S.range),S.command&&l.fromInternal(S.command)))(h))),new I.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[I.ApiCommandArgument.Uri,new I.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",h=>p.Range.isRange(h),h=>p.Selection.isSelection(h)?C.Selection.from(h):C.Range.from(h)),I.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),I.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new I.ApiCommandResult("A promise that resolves to an array of Command-instances.",(h,u,l)=>T(S=>{if(S._isSynthetic){if(!S.command)throw new Error("Synthetic code actions must have a command");return l.fromInternal(S.command)}else{const w=new p.CodeAction(S.title,S.kind?new p.CodeActionKind(S.kind):void 0);return S.edit&&(w.edit=C.WorkspaceEdit.to(S.edit)),S.command&&(w.command=l.fromInternal(S.command)),w.isPreferred=S.isPreferred,w}})(h))),new I.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[I.ApiCommandArgument.Uri],new I.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",h=>h?h.map(u=>new p.ColorInformation(C.Range.to(u.range),C.Color.to(u.color))):[])),new I.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new I.ApiCommandArgument("color","The color to show and insert",h=>h instanceof p.Color,C.Color.from),new I.ApiCommandArgument("context","Context object with uri and range",h=>!0,h=>({uri:h.uri,range:C.Range.from(h.range)}))],new I.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",h=>h?h.map(C.ColorPresentation.to):[])),new I.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Range],new I.ApiCommandResult("A promise that resolves to an array of Inlay objects",(h,u,l)=>h.map(C.InlayHint.to.bind(void 0,l)))),new I.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new I.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",T(h=>({viewType:h.viewType,displayName:h.displayName,options:{transientOutputs:h.options.transientOutputs,transientCellMetadata:h.options.transientCellMetadata,transientDocumentMetadata:h.options.transientDocumentMetadata},filenamePattern:h.filenamePattern.map(u=>C.NotebookExclusiveDocumentPattern.to(u))})))),new I.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Range],new I.ApiCommandResult("A promise that resolves to an array of InlineValue objects",h=>h.map(C.InlineValue.to))),new I.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new I.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",h=>o.URI.isUri(h)||typeof h=="string"&&(0,A.matchesSomeScheme)(h,R.Schemas.http,R.Schemas.https),h=>h),new I.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",h=>h===void 0||typeof h=="number"||typeof h=="object",h=>h&&(typeof h=="number"?[C.ViewColumn.from(h),void 0]:[C.ViewColumn.from(h.viewColumn),C.TextEditorOpenOptions.from(h)])).optional(),I.ApiCommandArgument.String.with("label","").optional()],I.ApiCommandResult.Void),new I.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[I.ApiCommandArgument.Uri.with("resource","Resource to open"),I.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new I.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",h=>h===void 0||typeof h=="number"||typeof h=="object",h=>h&&(typeof h=="number"?[C.ViewColumn.from(h),void 0]:[C.ViewColumn.from(h.viewColumn),C.TextEditorOpenOptions.from(h)])).optional()],I.ApiCommandResult.Void),new I.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[I.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),I.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),I.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new I.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",h=>h===void 0||typeof h=="object",h=>h&&[C.ViewColumn.from(h.viewColumn),C.TextEditorOpenOptions.from(h)]).optional()],I.ApiCommandResult.Void),new I.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A TypeHierarchyItem or undefined",h=>h.map(C.TypeHierarchyItem.to))),new I.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[I.ApiCommandArgument.TypeHierarchyItem],new I.ApiCommandResult("A TypeHierarchyItem or undefined",h=>h.map(C.TypeHierarchyItem.to))),new I.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[I.ApiCommandArgument.TypeHierarchyItem],new I.ApiCommandResult("A TypeHierarchyItem or undefined",h=>h.map(C.TypeHierarchyItem.to))),new I.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[I.ApiCommandArgument.TestItem],I.ApiCommandResult.Void),new I.ApiCommand("vscode.experimental.editSession.continue","_workbench.experimental.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[I.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],I.ApiCommandResult.Void)];class m{static register(u){_.forEach(u.registerApiCommand,u)}}e.ExtHostApiCommands=m;function T(h){return u=>{if(Array.isArray(u))return u.map(h)}}function g(h){if(!Array.isArray(h))return;const u=[];for(const l of h)U.isLocationLink(l)?u.push(C.DefinitionLink.to(l)):u.push(C.location.to(l));return u}}),define(De[190],Ce([1,0,13,54,4,7,2,66,27,8,6,25,5]),function(J,e,o,C,p,U,I,P,b,A,R,_,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function T(g,h,u){const l=g.getProxy(m.MainContext.MainThreadComments);class S{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,h.registerArgumentProcessor({processArgument:t=>{if(t&&t.$mid===6){const c=this._commentControllers.get(t.handle);return c?c.value:t}else if(t&&t.$mid===7){const c=this._commentControllers.get(t.commentControlHandle);if(!c)return t;const E=c.getCommentThread(t.commentThreadHandle);return E?E.value:t}else if(t&&t.$mid===8){const c=this._commentControllers.get(t.thread.commentControlHandle);if(!c)return t;const E=c.getCommentThread(t.thread.commentThreadHandle);return E?{thread:E.value,text:t.text}:t}else if(t&&t.$mid===9){const c=this._commentControllers.get(t.thread.commentControlHandle);if(!c)return t;const E=c.getCommentThread(t.thread.commentThreadHandle);if(!E)return t;const f=t.commentUniqueId,D=E.getCommentByUniqueId(f);return D||t}else if(t&&t.$mid===10){const c=this._commentControllers.get(t.thread.commentControlHandle);if(!c)return t;const E=c.getCommentThread(t.thread.commentThreadHandle);if(!E)return t;const f=t.text,D=t.commentUniqueId,L=E.getCommentByUniqueId(D);return L?(L.body=f,L):t}return t}})}createCommentController(t,c,E){const f=S.handlePool++,D=new a(t,f,c,E);this._commentControllers.set(D.handle,D);const L=this._commentControllersByExtension.get(b.ExtensionIdentifier.toKey(t.identifier))||[];return L.push(D),this._commentControllersByExtension.set(b.ExtensionIdentifier.toKey(t.identifier),L),D.value}$createCommentThreadTemplate(t,c,E){const f=this._commentControllers.get(t);!f||f.$createCommentThreadTemplate(c,E)}async $updateCommentThreadTemplate(t,c,E){const f=this._commentControllers.get(t);!f||f.$updateCommentThreadTemplate(c,E)}$deleteCommentThread(t,c){this._commentControllers.get(t)?.$deleteCommentThread(c)}$provideCommentingRanges(t,c,E){const f=this._commentControllers.get(t);if(!f||!f.commentingRangeProvider)return Promise.resolve(void 0);const D=u.getDocument(I.URI.revive(c));return(0,o.asPromise)(()=>f.commentingRangeProvider.provideCommentingRanges(D,E)).then(L=>L?L.map(W=>A.Range.from(W)):void 0)}$toggleReaction(t,c,E,f,D){const L=this._commentControllers.get(t);return!L||!L.reactionHandler?Promise.resolve(void 0):(0,o.asPromise)(()=>{const W=L.getCommentThread(c);if(W){const N=W.getCommentByUniqueId(f.uniqueIdInThread);if(L!==void 0&&N&&L.reactionHandler)return L.reactionHandler(N,d(D))}return Promise.resolve(void 0)})}dispose(){}}S.handlePool=0;class w{constructor(t,c,E,f,D,L,W,N){this._commentControllerHandle=c,this._id=E,this._uri=f,this._range=D,this._comments=L,this.extensionDescription=W,this._isTemplate=N,this.handle=w._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new p.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new U.MutableDisposable,this._acceptInputDisposables.value=new U.DisposableStore,this._id===void 0&&(this._id=`${t}.${this.handle}`),l.$createCommentThread(c,this.handle,this._id,this._uri,A.Range.from(this._range),W.identifier,this._isTemplate),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=L,this._localDisposables.push({dispose:()=>{l.$deleteCommentThread(c,this.handle)}});const v=this;this.value={get uri(){return v.uri},get range(){return v.range},set range(F){v.range=F},get comments(){return v.comments},set comments(F){v.comments=F},get collapsibleState(){return v.collapsibleState},set collapsibleState(F){v.collapsibleState=F},get canReply(){return v.canReply},set canReply(F){v.canReply=F},get contextValue(){return v.contextValue},set contextValue(F){v.contextValue=F},get label(){return v.label},set label(F){v.label=F},get state(){return v.state},set state(F){v.state=F},dispose:()=>{v.dispose()}}}set threadId(t){this._id=t}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(t){t.isEqual(this._range)||(this._range=t,this.modifications.range=t,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(t){this._canReply!==t&&(this._canReply=t,this.modifications.canReply=t,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(t){this._label=t,this.modifications.label=t,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(t){this._contextValue=t,this.modifications.contextValue=t,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(t){this._comments=t,this.modifications.comments=t,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(t){this._collapseState=t,this.modifications.collapsibleState=t,this._onDidUpdateCommentThread.fire()}get state(){return(0,_.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this._state}set state(t){(0,_.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this._state=t,this.modifications.state=t,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}updateIsTemplate(){this._isTemplate&&(this._isTemplate=!1,this.modifications.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this.updateIsTemplate(),this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new U.DisposableStore);const t=E=>Object.prototype.hasOwnProperty.call(this.modifications,E),c={};t("range")&&(c.range=A.Range.from(this._range)),t("label")&&(c.label=this.label),t("contextValue")&&(c.contextValue=this.contextValue??null),t("comments")&&(c.comments=this._comments.map(E=>y(this,E,this._commentsMap))),t("collapsibleState")&&(c.collapseState=i(this._collapseState)),t("canReply")&&(c.canReply=this.canReply),t("state")&&(c.state=s(this._state)),t("isTemplate")&&(c.isTemplate=this._isTemplate),this.modifications={},l.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,c)}getCommentByUniqueId(t){for(const c of this._commentsMap){const E=c[0],f=c[1];if(t===f)return E}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(t=>t.dispose())}}w._handlePool=0,$e([(0,C.debounce)(100)],w.prototype,"eventuallyUpdateCommentThread",null);class a{constructor(t,c,E,f){this._extension=t,this._handle=c,this._id=E,this._label=f,this._threads=new Map,l.$registerCommentController(this.handle,E,f);const D=this;this.value=Object.freeze({id:D.id,label:D.label,get options(){return D.options},set options(L){D.options=L},get commentingRangeProvider(){return D.commentingRangeProvider},set commentingRangeProvider(L){D.commentingRangeProvider=L},get reactionHandler(){return D.reactionHandler},set reactionHandler(L){D.reactionHandler=L},createCommentThread(L,W,N){return D.createCommentThread(L,W,N).value},dispose:()=>{D.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{l.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(t){this._commentingRangeProvider=t,l.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(t){this._reactionHandler=t,l.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!t})}get options(){return this._options}set options(t){this._options=t,l.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(t,c,E,f){if(typeof t=="string"){const D=new w(this.id,this.handle,t,c,E,f,this._extension,!1);return this._threads.set(D.handle,D),D}else{const D=new w(this.id,this.handle,void 0,t,c,E,this._extension,!1);return this._threads.set(D.handle,D),D}}$createCommentThreadTemplate(t,c){const E=new w(this.id,this.handle,void 0,I.URI.revive(t),A.Range.to(c),[],this._extension,!0);return E.collapsibleState=P.CommentThreadCollapsibleState.Expanded,this._threads.set(E.handle,E),E}$updateCommentThreadTemplate(t,c){const E=this._threads.get(t);E&&(E.range=A.Range.to(c))}$deleteCommentThread(t){const c=this._threads.get(t);c&&c.dispose(),this._threads.delete(t)}getCommentThread(t){return this._threads.get(t)}dispose(){this._threads.forEach(t=>{t.dispose()}),this._localDisposables.forEach(t=>t.dispose())}}function y(n,t,c){let E=c.get(t);E||(E=++n.commentHandle,c.set(t,E));const f=t.author&&t.author.iconPath?t.author.iconPath.toString():void 0;return{mode:t.mode,contextValue:t.contextValue,uniqueIdInThread:E,body:typeof t.body=="string"?t.body:A.MarkdownString.from(t.body),userName:t.author.name,userIconPath:f,label:t.label,commentReactions:t.reactions?t.reactions.map(D=>r(D)):void 0,timestamp:t.timestamp?.toJSON()}}function r(n){return{label:n.label,iconPath:n.iconPath?A.pathOrURIToURI(n.iconPath):void 0,count:n.count,hasReacted:n.authorHasReacted}}function d(n){return{label:n.label||"",count:n.count||0,iconPath:n.iconPath?I.URI.revive(n.iconPath):"",authorHasReacted:n.hasReacted||!1}}function i(n){if(n!==void 0)switch(n){case R.CommentThreadCollapsibleState.Expanded:return P.CommentThreadCollapsibleState.Expanded;case R.CommentThreadCollapsibleState.Collapsed:return P.CommentThreadCollapsibleState.Collapsed}return P.CommentThreadCollapsibleState.Collapsed}function s(n){if(n!==void 0)switch(n){case R.CommentThreadState.Unresolved:return P.CommentThreadState.Unresolved;case R.CommentThreadState.Resolved:return P.CommentThreadState.Resolved}return P.CommentThreadState.Unresolved}return new S}e.createExtHostComments=T}),define(De[191],Ce([1,0,26,5,28,15]),function(J,e,o,C,p,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let I=class{constructor(R,_){this._mainThreadConsole=R.getProxy(C.MainContext.MainThreadConsole),this._includeStack=_.consoleForward.includeStack,this._logNative=_.consoleForward.logNative,this._wrapConsoleMethod("info","log"),this._wrapConsoleMethod("log","log"),this._wrapConsoleMethod("warn","warn"),this._wrapConsoleMethod("error","error")}_wrapConsoleMethod(R,_){const m=this,T=console[R];Object.defineProperty(console,R,{set:()=>{},get:()=>function(){m._handleConsoleCall(R,_,T,arguments)}})}_handleConsoleCall(R,_,m,T){this._mainThreadConsole.$logExtensionHostMessage({type:"__$console",severity:_,arguments:b(T,this._includeStack)}),this._logNative&&this._nativeConsoleLogMessage(R,m,T)}};I=$e([xe(0,U.IExtHostRpcService),xe(1,p.IExtHostInitDataService)],I),e.AbstractExtHostConsoleForwarder=I;const P=1e5;function b(A,R){const _=[];if(A.length)for(let m=0;m<A.length;m++){let T=A[m];if(typeof T=="undefined")T="undefined";else if(T instanceof Error){const g=T;g.stack?T=g.stack:T=g.toString()}_.push(T)}if(R){const m=new Error().stack;m&&_.push({__$stack:m.split(`
`).slice(3).join(`
`)})}try{const m=(0,o.safeStringify)(_);return m.length>P?"Output omitted for a large object that exceeds the limits":m}catch(m){return`Output omitted for an object that cannot be inspected ('${m.toString()}')`}}}),define(De[95],Ce([1,0,2,5,6,3,15,14,16,10,19]),function(J,e,o,C,p,U,I,P,b,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let _=class Di{constructor(T,g){this._logService=g,this._provider=new Map,this._proxy=T.getProxy(C.MainContext.MainThreadDecorations)}registerFileDecorationProvider(T,g){const h=Di._handlePool++;this._provider.set(h,{provider:T,extensionId:g}),this._proxy.$registerDecorationProvider(h,g.value);const u=T.onDidChangeFileDecorations&&T.onDidChangeFileDecorations(l=>{if(!l){this._proxy.$onDidChange(h,null);return}const S=(0,b.asArray)(l);if(S.length<=Di._maxEventSize){this._proxy.$onDidChange(h,S);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",g.value,S.length);const w=S.map(r=>({uri:r,rank:(0,A.count)(r.path,"/")})),a=(0,b.groupBy)(w,(r,d)=>r.rank-d.rank||(0,A.compare)(r.uri.path,d.uri.path)),y=[];e:for(const r of a){let d;for(const i of r){const s=(0,R.dirname)(i.uri.path);if(d!==s&&(d=s,y.push(i.uri)>=Di._maxEventSize))break e}}this._proxy.$onDidChange(h,y)});return new p.Disposable(()=>{u?.dispose(),this._proxy.$unregisterDecorationProvider(h),this._provider.delete(h)})}async $provideDecorations(T,g,h){if(!this._provider.has(T))return Object.create(null);const u=Object.create(null),{provider:l,extensionId:S}=this._provider.get(T);return await Promise.all(g.map(async w=>{try{const{uri:a,id:y}=w,r=await Promise.resolve(l.provideFileDecoration(o.URI.revive(a),h));if(!r)return;try{p.FileDecoration.validate(r),u[y]=[r.propagate,r.tooltip,r.badge,r.color]}catch(d){this._logService.warn(`INVALID decoration from extension '${S.value}': ${d}`)}}catch(a){this._logService.error(a)}})),u}};_._handlePool=0,_._maxEventSize=250,_=$e([xe(0,I.IExtHostRpcService),xe(1,P.ILogService)],_),e.ExtHostDecorations=_,e.IExtHostDecorations=(0,U.createDecorator)("IExtHostDecorations")});var Ye=this&&this.__classPrivateFieldSet||function(J,e,o,C,p){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!p)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!p:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?p.call(J,o):p?p.value=o:e.set(J,o),o},Ae=this&&this.__classPrivateFieldGet||function(J,e,o,C){if(o==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!C:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?C:o==="a"?C.call(J):C?C.value:e.get(J)};define(De[192],Ce([1,0,128,80,2,5,6,8,4,14,24,35]),function(J,e,o,C,p,U,I,P,b,A,R,_){"use strict";var m,T,g;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class h{constructor(S,w,a,y,r,d){this._name=S,this._owner=w,this._maxDiagnosticsPerFile=a,m.set(this,void 0),T.set(this,void 0),g.set(this,void 0),this._isDisposed=!1,Ye(this,g,new R.ResourceMap(i=>y.getComparisonKey(i)),"f"),Ye(this,m,r,"f"),Ye(this,T,d,"f")}dispose(){this._isDisposed||(Ae(this,T,"f").fire([...Ae(this,g,"f").keys()]),Ae(this,m,"f")?.$clear(this._owner),Ae(this,g,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(S,w){if(!S){this.clear();return}this._checkDisposed();let a=[];if(p.URI.isUri(S)){if(!w){this.delete(S);return}Ae(this,g,"f").set(S,w.slice()),a=[S]}else if(Array.isArray(S)){a=[];let r;S=[...S].sort(h._compareIndexedTuplesByUri);for(const d of S){const[i,s]=d;if((!r||i.toString()!==r.toString())&&(r&&Ae(this,g,"f").get(r).length===0&&Ae(this,g,"f").delete(r),r=i,a.push(i),Ae(this,g,"f").set(i,[])),s)Ae(this,g,"f").get(i)?.push(...s);else{const n=Ae(this,g,"f").get(i);n&&(n.length=0)}}}if(Ae(this,T,"f").fire(a),!Ae(this,m,"f"))return;const y=[];for(const r of a){let d=[];const i=Ae(this,g,"f").get(r);if(i)if(i.length>this._maxDiagnosticsPerFile){d=[];const s=[I.DiagnosticSeverity.Error,I.DiagnosticSeverity.Warning,I.DiagnosticSeverity.Information,I.DiagnosticSeverity.Hint];e:for(let n=0;n<4;n++)for(const t of i)if(t.severity===s[n]&&d.push(P.Diagnostic.from(t))===this._maxDiagnosticsPerFile)break e;d.push({severity:C.MarkerSeverity.Info,message:(0,o.localize)(0,null,i.length-this._maxDiagnosticsPerFile),startLineNumber:d[d.length-1].startLineNumber,startColumn:d[d.length-1].startColumn,endLineNumber:d[d.length-1].endLineNumber,endColumn:d[d.length-1].endColumn})}else d=i.map(s=>P.Diagnostic.from(s));y.push([r,d])}Ae(this,m,"f").$changeMany(this._owner,y)}delete(S){this._checkDisposed(),Ae(this,T,"f").fire([S]),Ae(this,g,"f").delete(S),Ae(this,m,"f")?.$changeMany(this._owner,[[S,void 0]])}clear(){this._checkDisposed(),Ae(this,T,"f").fire([...Ae(this,g,"f").keys()]),Ae(this,g,"f").clear(),Ae(this,m,"f")?.$clear(this._owner)}forEach(S,w){this._checkDisposed();for(const[a,y]of this)S.call(w,a,y,this)}*[(m=new WeakMap,T=new WeakMap,g=new WeakMap,Symbol.iterator)](){this._checkDisposed();for(const S of Ae(this,g,"f").keys())yield[S,this.get(S)]}get(S){this._checkDisposed();const w=Ae(this,g,"f").get(S);return Array.isArray(w)?Object.freeze(w.slice(0)):[]}has(S){return this._checkDisposed(),Array.isArray(Ae(this,g,"f").get(S))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(S,w){return S[0].toString()<w[0].toString()?-1:S[0].toString()>w[0].toString()?1:0}}e.DiagnosticCollection=h;let u=class di{constructor(S,w,a){this._logService=w,this._fileSystemInfoService=a,this._collections=new Map,this._onDidChangeDiagnostics=new b.DebounceEmitter({merge:y=>y.flat(),delay:50}),this.onDidChangeDiagnostics=b.Event.map(this._onDidChangeDiagnostics.event,di._mapper),this._proxy=S.getProxy(U.MainContext.MainThreadDiagnostics)}static _mapper(S){const w=new R.ResourceMap;for(const a of S)w.set(a,a);return{uris:Object.freeze(Array.from(w.values()))}}createDiagnosticCollection(S,w){const{_collections:a,_proxy:y,_onDidChangeDiagnostics:r,_logService:d,_fileSystemInfoService:i}=this,s=new class{$changeMany(c,E){y.$changeMany(c,E),d.trace("[DiagnosticCollection] change many (extension, owner, uris)",S.value,c,E.length===0?"CLEARING":E)}$clear(c){y.$clear(c),d.trace("[DiagnosticCollection] remove all (extension, owner)",S.value,c)}dispose(){y.dispose()}};let n;if(!w)w="_generated_diagnostic_collection_name_#"+di._idPool++,n=w;else if(!a.has(w))n=w;else{this._logService.warn(`DiagnosticCollection with name '${w}' does already exist.`);do n=w+di._idPool++;while(a.has(n))}return new class extends h{constructor(){super(w,n,di._maxDiagnosticsPerFile,i.extUri,s,r);a.set(n,this)}dispose(){super.dispose(),a.delete(n)}}}getDiagnostics(S){if(S)return this._getDiagnostics(S);{const w=new Map,a=[];for(const y of this._collections.values())y.forEach((r,d)=>{let i=w.get(r.toString());typeof i=="undefined"&&(i=a.length,w.set(r.toString(),i),a.push([r,[]])),a[i][1]=a[i][1].concat(...d)});return a}}_getDiagnostics(S){let w=[];for(const a of this._collections.values())a.has(S)&&(w=w.concat(a.get(S)));return w}$acceptMarkersChange(S){if(!this._mirrorCollection){const w="_generated_mirror",a=new h(w,w,di._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(w,a),this._mirrorCollection=a}for(const[w,a]of S)this._mirrorCollection.set(p.URI.revive(w),a.map(P.Diagnostic.to))}};u._idPool=0,u._maxDiagnosticsPerFile=1e3,u=$e([xe(1,A.ILogService),xe(2,_.IExtHostFileSystemInfo)],u),e.ExtHostDiagnostics=u}),define(De[193],Ce([1,0,2,5]),function(J,e,o,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class p{constructor(I){this._proxy=I.getProxy(C.MainContext.MainThreadDialogs)}showOpenDialog(I){return this._proxy.$showOpenDialog(I).then(P=>P?P.map(b=>o.URI.revive(b)):void 0)}showSaveDialog(I){return this._proxy.$showSaveDialog(I).then(P=>P?o.URI.revive(P):void 0)}}e.ExtHostDialogs=p}),define(De[194],Ce([1,0,11,2,6,5,12,20,10]),function(J,e,o,C,p,U,I,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class A{constructor(_,m,T){this._documentsAndEditors=m,this._logService=T,this._documentContentProviders=new Map,this._proxy=_.getProxy(U.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(_,m){if(Object.keys(I.Schemas).indexOf(_)>=0)throw new Error(`scheme '${_}' already registered`);const T=A._handlePool++;this._documentContentProviders.set(T,m),this._proxy.$registerTextContentProvider(T,_);let g;return typeof m.onDidChange=="function"&&(g=m.onDidChange(h=>{if(h.scheme!==_){this._logService.warn(`Provider for scheme '${_}' is firing event for schema '${h.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(h)&&this.$provideTextDocumentContent(T,h).then(u=>{if(!u&&typeof u!="string")return;const l=this._documentsAndEditors.getDocument(h);if(!l)return;const S=(0,b.splitLines)(u);if(!l.equalLines(S))return this._proxy.$onVirtualDocumentChange(h,u)},o.onUnexpectedError)})),new p.Disposable(()=>{this._documentContentProviders.delete(T)&&this._proxy.$unregisterTextContentProvider(T),g&&(g.dispose(),g=void 0)})}$provideTextDocumentContent(_,m){const T=this._documentContentProviders.get(_);return T?Promise.resolve(T.provideTextDocumentContent(C.URI.revive(m),P.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${m.scheme}`))}}e.ExtHostDocumentContentProvider=A,A._handlePool=0}),define(De[195],Ce([1,0,4,7,2,5,87,8,9,26,6]),function(J,e,o,C,p,U,I,P,b,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class _{constructor(T,g){this._onDidAddDocument=new o.Emitter,this._onDidRemoveDocument=new o.Emitter,this._onDidChangeDocument=new o.Emitter,this._onDidSaveDocument=new o.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new C.DisposableStore,this._documentLoader=new Map,this._proxy=T.getProxy(U.MainContext.MainThreadDocuments),this._documentsAndEditors=g,this._documentsAndEditors.onDidRemoveDocuments(h=>{for(const u of h)this._onDidRemoveDocument.fire(u.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(h=>{for(const u of h)this._onDidAddDocument.fire(u.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(T){if(!T)return;const g=this._documentsAndEditors.getDocument(T);if(g)return g}getDocument(T){const g=this.getDocumentData(T);if(!g?.document)throw new Error(`Unable to retrieve document from URI '${T}'`);return g.document}ensureDocumentData(T){const g=this._documentsAndEditors.getDocument(T);if(g)return Promise.resolve(g);let h=this._documentLoader.get(T.toString());return h||(h=this._proxy.$tryOpenDocument(T).then(u=>{this._documentLoader.delete(T.toString());const l=p.URI.revive(u);return(0,b.assertIsDefined)(this._documentsAndEditors.getDocument(l))},u=>(this._documentLoader.delete(T.toString()),Promise.reject(u))),this._documentLoader.set(T.toString(),h)),h}createDocumentData(T){return this._proxy.$tryCreateDocument(T).then(g=>p.URI.revive(g))}$acceptModelLanguageChanged(T,g){const h=p.URI.revive(T),u=this._documentsAndEditors.getDocument(h);if(!u)throw new Error("unknown document");this._onDidRemoveDocument.fire(u.document),u._acceptLanguageId(g),this._onDidAddDocument.fire(u.document)}$acceptModelSaved(T){const g=p.URI.revive(T),h=this._documentsAndEditors.getDocument(g);if(!h)throw new Error("unknown document");this.$acceptDirtyStateChanged(T,!1),this._onDidSaveDocument.fire(h.document)}$acceptDirtyStateChanged(T,g){const h=p.URI.revive(T),u=this._documentsAndEditors.getDocument(h);if(!u)throw new Error("unknown document");u._acceptIsDirty(g),this._onDidChangeDocument.fire({document:u.document,contentChanges:[],reason:void 0})}$acceptModelChanged(T,g,h){const u=p.URI.revive(T),l=this._documentsAndEditors.getDocument(u);if(!l)throw new Error("unknown document");l._acceptIsDirty(h),l.onEvents(g);let S;g.isUndoing?S=R.TextDocumentChangeReason.Undo:g.isRedoing&&(S=R.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,A.deepFreeze)({document:l.document,contentChanges:g.changes.map(w=>({range:P.Range.to(w.range),rangeOffset:w.rangeOffset,rangeLength:w.rangeLength,text:w.text})),reason:S}))}setWordDefinitionFor(T,g){(0,I.setWordDefinitionFor)(T,g)}}e.ExtHostDocuments=_}),define(De[49],Ce([1,0,42,4,7,2,3,5,87,15,93,8,14,24,12,167,196]),function(J,e,o,C,p,U,I,P,b,A,R,_,m,T,g,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class l{constructor(a){this.value=a,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let S=class{constructor(a,y){this._extHostRpc=a,this._logService=y,this._activeEditorId=null,this._editors=new Map,this._documents=new T.ResourceMap,this._onDidAddDocuments=new C.Emitter,this._onDidRemoveDocuments=new C.Emitter,this._onDidChangeVisibleTextEditors=new C.Emitter,this._onDidChangeActiveTextEditor=new C.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(a){this.acceptDocumentsAndEditorsDelta(a)}acceptDocumentsAndEditorsDelta(a){const y=[],r=[],d=[];if(a.removedDocuments)for(const i of a.removedDocuments){const s=U.URI.revive(i),n=this._documents.get(s);n?.unref()&&(this._documents.delete(s),y.push(n.value))}if(a.addedDocuments)for(const i of a.addedDocuments){const s=U.URI.revive(i.uri);let n=this._documents.get(s);if(n&&s.scheme!==g.Schemas.vscodeNotebookCell&&s.scheme!==g.Schemas.vscodeInteractiveInput)throw new Error(`document '${s} already exists!'`);n||(n=new l(new b.ExtHostDocumentData(this._extHostRpc.getProxy(P.MainContext.MainThreadDocuments),s,i.lines,i.EOL,i.versionId,i.languageId,i.isDirty,i.notebook)),this._documents.set(s,n),r.push(n.value)),n.ref()}if(a.removedEditors)for(const i of a.removedEditors){const s=this._editors.get(i);this._editors.delete(i),s&&d.push(s)}if(a.addedEditors)for(const i of a.addedEditors){const s=U.URI.revive(i.documentUri);o.ok(this._documents.has(s),`document '${s}' does not exist`),o.ok(!this._editors.has(i.id),`editor '${i.id}' already exists!`);const n=this._documents.get(s).value,t=new R.ExtHostTextEditor(i.id,this._extHostRpc.getProxy(P.MainContext.MainThreadTextEditors),this._logService,new u.Lazy(()=>n.document),i.selections.map(_.Selection.to),i.options,i.visibleRanges.map(c=>_.Range.to(c)),typeof i.editorPosition=="number"?_.ViewColumn.to(i.editorPosition):void 0);this._editors.set(i.id,t)}a.newActiveEditor!==void 0&&(o.ok(a.newActiveEditor===null||this._editors.has(a.newActiveEditor),`active editor '${a.newActiveEditor}' does not exist`),this._activeEditorId=a.newActiveEditor),(0,p.dispose)(y),(0,p.dispose)(d),a.removedDocuments&&this._onDidRemoveDocuments.fire(y),a.addedDocuments&&this._onDidAddDocuments.fire(r),(a.removedEditors||a.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(i=>i.value)),a.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(a){return this._documents.get(a)?.value}allDocuments(){return h.Iterable.map(this._documents.values(),a=>a.value)}getEditor(a){return this._editors.get(a)}activeEditor(a){if(!this._activeEditorId)return;const y=this._editors.get(this._activeEditorId);return a?y:y?.value}allEditors(){return[...this._editors.values()]}};S=$e([xe(0,A.IExtHostRpcService),xe(1,m.ILogService)],S),e.ExtHostDocumentsAndEditors=S,e.IExtHostDocumentsAndEditors=(0,I.createDecorator)("IExtHostDocumentsAndEditors")}),define(De[50],Ce([1,0,8,5,2,4,3,6,15,9,72]),function(J,e,o,C,p,U,I,P,b,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,I.createDecorator)("IExtHostEditorTabs");class _{constructor(u,l,S){this._activeTabIdGetter=S,this._parentGroup=l,this.acceptDtoUpdate(u)}get apiObject(){if(!this._apiObject){const u=this,l={get isActive(){return u._dto.id===u._activeTabIdGetter()},get label(){return u._dto.label},get input(){return u._input},get isDirty(){return u._dto.isDirty},get isPinned(){return u._dto.isPinned},get isPreview(){return u._dto.isPreview},get group(){return u._parentGroup.apiObject}};this._apiObject=Object.freeze(l)}return this._apiObject}get tabId(){return this._dto.id}acceptDtoUpdate(u){this._dto=u,this._input=this._initInput()}_initInput(){switch(this._dto.input.kind){case 1:return new P.TextTabInput(p.URI.revive(this._dto.input.uri));case 2:return new P.TextDiffTabInput(p.URI.revive(this._dto.input.original),p.URI.revive(this._dto.input.modified));case 5:return new P.CustomEditorTabInput(p.URI.revive(this._dto.input.uri),this._dto.input.viewType);case 6:return new P.WebviewEditorTabInput(this._dto.input.viewType);case 3:return new P.NotebookEditorTabInput(p.URI.revive(this._dto.input.uri),this._dto.input.notebookType);case 4:return new P.NotebookDiffEditorTabInput(p.URI.revive(this._dto.input.original),p.URI.revive(this._dto.input.modified),this._dto.input.notebookType);case 7:return new P.TerminalEditorTabInput;default:return}}}class m{constructor(u,l,S){this._tabs=[],this._activeTabId="",this._dto=u,this._activeGroupIdGetter=S;for(const w of u.tabs)w.isActive&&(this._activeTabId=w.id),this._tabs.push(new _(w,this,()=>this.activeTabId()))}get apiObject(){if(!this._apiObject){const u=this,l={get isActive(){return u._dto.groupId===u._activeGroupIdGetter()},get viewColumn(){return o.ViewColumn.to(u._dto.viewColumn)},get activeTab(){return u._tabs.find(S=>S.tabId===u._activeTabId)?.apiObject},get tabs(){return Object.freeze(u._tabs.map(S=>S.apiObject))}};this._apiObject=Object.freeze(l)}return this._apiObject}get groupId(){return this._dto.groupId}get tabs(){return this._tabs}acceptGroupDtoUpdate(u){this._dto=u}acceptTabOperation(u){if(u.kind===0){const S=new _(u.tabDto,this,()=>this.activeTabId());return this._tabs.splice(u.index,0,S),u.tabDto.isActive&&(this._activeTabId=S.tabId),S}else if(u.kind===1){const S=this._tabs.splice(u.index,1)[0];if(!S)throw new Error(`Tab close updated received for index ${u.index} which does not exist`);return S.tabId===this._activeTabId&&(this._activeTabId=""),S}else if(u.kind===3){if(u.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const S=this._tabs.splice(u.oldIndex,1)[0];if(!S)throw new Error(`Tab move updated received for index ${u.oldIndex} which does not exist`);return this._tabs.splice(u.index,0,S),S}const l=this._tabs.find(S=>S.tabId===u.tabDto.id);if(!l)throw new Error("INVALID tab");return u.tabDto.isActive?this._activeTabId=u.tabDto.id:this._activeTabId===u.tabDto.id&&!u.tabDto.isActive&&(this._activeTabId=""),l.acceptDtoUpdate(u.tabDto),l}activeTabId(){return this._activeTabId}}let T=class{constructor(u){this._onDidChangeTabs=new U.Emitter,this._onDidChangeTabGroups=new U.Emitter,this._extHostTabGroups=[],this._proxy=u.getProxy(C.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this._apiObject){const u=this,l={onDidChangeTabGroups:u._onDidChangeTabGroups.event,onDidChangeTabs:u._onDidChangeTabs.event,get all(){return Object.freeze(u._extHostTabGroups.map(S=>S.apiObject))},get activeTabGroup(){const S=u._activeGroupId;return(0,A.assertIsDefined)(u._extHostTabGroups.find(a=>a.groupId===S)?.apiObject)},close:async(S,w)=>{const a=Array.isArray(S)?S:[S];return a.length?g(a[0])?this._closeGroups(a,w):this._closeTabs(a,w):!0}};this._apiObject=Object.freeze(l)}return this._apiObject}$acceptEditorTabModel(u){const l=new Set(this._extHostTabGroups.map(i=>i.groupId)),S=new Set(u.map(i=>i.groupId)),w=(0,R.diffSets)(l,S),a=this._extHostTabGroups.filter(i=>w.removed.includes(i.groupId)).map(i=>i.apiObject),y=[],r=[];this._extHostTabGroups=u.map(i=>{const s=new m(i,this._proxy,()=>this._activeGroupId);return w.added.includes(s.groupId)?y.push(s.apiObject):r.push(s.apiObject),s});const d=(0,A.assertIsDefined)(u.find(i=>i.isActive===!0)?.groupId);d!==void 0&&this._activeGroupId!==d&&(this._activeGroupId=d),this._onDidChangeTabGroups.fire(Object.freeze({opened:y,closed:a,changed:r}))}$acceptTabGroupUpdate(u){const l=this._extHostTabGroups.find(S=>S.groupId===u.groupId);if(!l)throw new Error("Update Group IPC call received before group creation.");l.acceptGroupDtoUpdate(u),u.isActive&&(this._activeGroupId=u.groupId),this._onDidChangeTabGroups.fire(Object.freeze({changed:[l.apiObject],opened:[],closed:[]}))}$acceptTabOperation(u){const l=this._extHostTabGroups.find(w=>w.groupId===u.groupId);if(!l)throw new Error("Update Tabs IPC call received before group creation.");const S=l.acceptTabOperation(u);switch(u.kind){case 0:this._onDidChangeTabs.fire(Object.freeze({opened:[S.apiObject],closed:[],changed:[]}));return;case 1:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[S.apiObject],changed:[]}));return;case 3:case 2:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[],changed:[S.apiObject]}));return}}_findExtHostTabFromApi(u){for(const l of this._extHostTabGroups)for(const S of l.tabs)if(S.apiObject===u)return S}_findExtHostTabGroupFromApi(u){return this._extHostTabGroups.find(l=>l.apiObject===u)}async _closeTabs(u,l){const S=[];for(const w of u){const a=this._findExtHostTabFromApi(w);if(!a)throw new Error("Tab close: Invalid tab not found!");S.push(a.tabId)}return this._proxy.$closeTab(S,l)}async _closeGroups(u,l){const S=[];for(const w of u){const a=this._findExtHostTabGroupFromApi(w);if(!a)throw new Error("Group close: Invalid group not found!");S.push(a.groupId)}return this._proxy.$closeGroup(S,l)}};T=$e([xe(0,b.IExtHostRpcService)],T),e.ExtHostEditorTabs=T;function g(h){return h.tabs!==void 0}}),define(De[197],Ce([1,0,2,5,7,6,8,242,10,23,25]),function(J,e,o,C,p,U,I,P,b,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class _{constructor(){this._schemes=[]}add(g){this._stateMachine=void 0,this._schemes.push(g)}delete(g){const h=this._schemes.indexOf(g);h>=0&&(this._schemes.splice(h,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const g=this._schemes.sort(),h=[];let u,l,S=14,w=14;for(const a of g){let y=u?(0,b.commonPrefixLength)(u,a):0;for(y===0?l=1:l=w;y<a.length;y++)y+1===a.length?(S=w,w=9):w+=1,h.push([l,a.toUpperCase().charCodeAt(y),w]),h.push([l,a.toLowerCase().charCodeAt(y),w]),l=w;u=a,w=S}h.push([9,58,10]),h.push([10,47,12]),this._stateMachine=new P.StateMachine(h)}}provideDocumentLinks(g){this._initStateMachine();const h=[],u=P.LinkComputer.computeLinks({getLineContent(l){return g.lineAt(l-1).text},getLineCount(){return g.lineCount}},this._stateMachine);for(const l of u){const S=I.DocumentLink.to(l);S.target&&h.push(S)}return h}}class m{constructor(g,h){this._extHostLanguageFeatures=h,this._linkProvider=new _,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=g.getProxy(C.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}registerFileSystemProvider(g,h,u,l={}){if(this._registeredSchemes.has(h))throw new Error(`a provider for the scheme '${h}' is already registered`);this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(g,"*",this._linkProvider));const S=this._handlePool++;this._linkProvider.add(h),this._registeredSchemes.add(h),this._fsProvider.set(S,u);let w=2;l.isCaseSensitive&&(w+=1024),l.isReadonly&&(w+=2048),typeof u.copy=="function"&&(w+=8),typeof u.open=="function"&&typeof u.close=="function"&&typeof u.read=="function"&&typeof u.write=="function"&&((0,R.checkProposedApiEnabled)(g,"fsChunks"),w+=4),this._proxy.$registerFileSystemProvider(S,h,w).catch(y=>{console.error(`FAILED to register filesystem provider of ${g.identifier.value}-extension for the scheme ${h}`),console.error(y)});const a=u.onDidChangeFile(y=>{const r=[];for(const d of y){const{uri:i,type:s}=d;if(i.scheme!==h)continue;let n;switch(s){case U.FileChangeType.Changed:n=0;break;case U.FileChangeType.Created:n=1;break;case U.FileChangeType.Deleted:n=2;break;default:throw new Error("Unknown FileChangeType")}r.push({resource:i,type:n})}this._proxy.$onFileSystemChange(S,r)});return(0,p.toDisposable)(()=>{a.dispose(),this._linkProvider.delete(h),this._registeredSchemes.delete(h),this._fsProvider.delete(S),this._proxy.$unregisterProvider(S)})}static _asIStat(g){const{type:h,ctime:u,mtime:l,size:S,permissions:w}=g;return{type:h,ctime:u,mtime:l,size:S,permissions:w}}$stat(g,h){return Promise.resolve(this._getFsProvider(g).stat(o.URI.revive(h))).then(u=>m._asIStat(u))}$readdir(g,h){return Promise.resolve(this._getFsProvider(g).readDirectory(o.URI.revive(h)))}$readFile(g,h){return Promise.resolve(this._getFsProvider(g).readFile(o.URI.revive(h))).then(u=>A.VSBuffer.wrap(u))}$writeFile(g,h,u,l){return Promise.resolve(this._getFsProvider(g).writeFile(o.URI.revive(h),u.buffer,l))}$delete(g,h,u){return Promise.resolve(this._getFsProvider(g).delete(o.URI.revive(h),u))}$rename(g,h,u,l){return Promise.resolve(this._getFsProvider(g).rename(o.URI.revive(h),o.URI.revive(u),l))}$copy(g,h,u,l){const S=this._getFsProvider(g);if(!S.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(S.copy(o.URI.revive(h),o.URI.revive(u),l))}$mkdir(g,h){return Promise.resolve(this._getFsProvider(g).createDirectory(o.URI.revive(h)))}$watch(g,h,u,l){const S=this._getFsProvider(g).watch(o.URI.revive(u),l);this._watches.set(h,S)}$unwatch(g,h){const u=this._watches.get(h);u&&(u.dispose(),this._watches.delete(h))}$open(g,h,u){const l=this._getFsProvider(g);if(!l.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(l.open(o.URI.revive(h),u))}$close(g,h){const u=this._getFsProvider(g);if(!u.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(u.close(h))}$read(g,h,u,l){const S=this._getFsProvider(g);if(!S.read)throw new Error('FileSystemProvider does not implement "read"');const w=A.VSBuffer.alloc(l);return Promise.resolve(S.read(h,u,w.buffer,0,l)).then(a=>w.slice(0,a))}$write(g,h,u,l){const S=this._getFsProvider(g);if(!S.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(S.write(h,u,l.buffer,0,l.byteLength))}_getFsProvider(g){const h=this._fsProvider.get(g);if(!h){const u=new Error;throw u.name="ENOPRO",u.message="no provider",u}return h}}e.ExtHostFileSystem=m}),define(De[51],Ce([1,0,5,39,6,23,3,15,35,7]),function(J,e,o,C,p,U,I,P,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let R=class Kt{constructor(m,T){this._fileSystemProvider=new Map,this._proxy=m.getProxy(o.MainContext.MainThreadFileSystem);const g=this;this.value=Object.freeze({async stat(h){try{const u=g._fileSystemProvider.get(h.scheme);if(!u)return await g._proxy.$stat(h);await g._proxy.$ensureActivation(h.scheme);const l=await u.stat(h);return{type:l.type,ctime:l.ctime,mtime:l.mtime,size:l.size,permissions:l.permissions}}catch(u){Kt._handleError(u)}},async readDirectory(h){try{const u=g._fileSystemProvider.get(h.scheme);return u?(await g._proxy.$ensureActivation(h.scheme),(await u.readDirectory(h)).slice()):await g._proxy.$readdir(h)}catch(u){return Kt._handleError(u)}},async createDirectory(h){try{return await g._proxy.$mkdir(h)}catch(u){return Kt._handleError(u)}},async readFile(h){try{const u=g._fileSystemProvider.get(h.scheme);return u?(await g._proxy.$ensureActivation(h.scheme),(await u.readFile(h)).slice()):(await g._proxy.$readFile(h)).buffer}catch(u){return Kt._handleError(u)}},async writeFile(h,u){try{return await g._proxy.$writeFile(h,U.VSBuffer.wrap(u))}catch(l){return Kt._handleError(l)}},async delete(h,u){try{const l=g._fileSystemProvider.get(h.scheme);return l?(await g._proxy.$ensureActivation(h.scheme),await l.delete(h,{recursive:!1,...u})):await g._proxy.$delete(h,{recursive:!1,useTrash:!1,...u})}catch(l){return Kt._handleError(l)}},async rename(h,u,l){try{return await g._proxy.$rename(h,u,{overwrite:!1,...l})}catch(S){return Kt._handleError(S)}},async copy(h,u,l){try{return await g._proxy.$copy(h,u,{overwrite:!1,...l})}catch(S){return Kt._handleError(S)}},isWritableFileSystem(h){const u=T.getCapabilities(h);if(typeof u=="number")return!(u&2048)}})}static _handleError(m){if(m instanceof p.FileSystemError)throw m;if(!(m instanceof Error))throw new p.FileSystemError(String(m));if(m.name==="ENOPRO")throw p.FileSystemError.Unavailable(m.message);switch(m.name){case C.FileSystemProviderErrorCode.FileExists:throw p.FileSystemError.FileExists(m.message);case C.FileSystemProviderErrorCode.FileNotFound:throw p.FileSystemError.FileNotFound(m.message);case C.FileSystemProviderErrorCode.FileNotADirectory:throw p.FileSystemError.FileNotADirectory(m.message);case C.FileSystemProviderErrorCode.FileIsADirectory:throw p.FileSystemError.FileIsADirectory(m.message);case C.FileSystemProviderErrorCode.NoPermissions:throw p.FileSystemError.NoPermissions(m.message);case C.FileSystemProviderErrorCode.Unavailable:throw p.FileSystemError.Unavailable(m.message);default:throw new p.FileSystemError(m.message,m.name)}}addFileSystemProvider(m,T){return this._fileSystemProvider.set(m,T),(0,A.toDisposable)(()=>this._fileSystemProvider.delete(m))}};R=$e([xe(0,P.IExtHostRpcService),xe(1,b.IExtHostFileSystemInfo)],R),e.ExtHostConsumerFileSystem=R,e.IExtHostConsumerFileSystem=(0,I.createDecorator)("IExtHostConsumerFileSystem")}),define(De[198],Ce([1,0,4,34,2,5,8,6]),function(J,e,o,C,p,U,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class b{constructor(_,m,T,g,h,u,l,S){this._onDidCreate=new o.Emitter,this._onDidChange=new o.Emitter,this._onDidDelete=new o.Emitter;const w=this.ensureWatching(_,T,h);this._config=0,u&&(this._config+=1),l&&(this._config+=2),S&&(this._config+=4);const a=(0,C.parse)(h),y=typeof h=="string",r=g(d=>{if(!u)for(const i of d.created){const s=p.URI.revive(i);a(s.fsPath)&&(!y||m.getWorkspaceFolder(s))&&this._onDidCreate.fire(s)}if(!l)for(const i of d.changed){const s=p.URI.revive(i);a(s.fsPath)&&(!y||m.getWorkspaceFolder(s))&&this._onDidChange.fire(s)}if(!S)for(const i of d.deleted){const s=p.URI.revive(i);a(s.fsPath)&&(!y||m.getWorkspaceFolder(s))&&this._onDidDelete.fire(s)}});this._disposable=P.Disposable.from(w,this._onDidCreate,this._onDidChange,this._onDidDelete,r)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}ensureWatching(_,m,T){const g=P.Disposable.from();if(typeof T=="string")return g;const h=_.getProxy(U.MainContext.MainThreadFileSystem);let u=!1;(T.pattern.includes(C.GLOBSTAR)||T.pattern.includes(C.GLOB_SPLIT))&&(u=!0);const l=Math.random();return h.$watch(m.identifier.value,l,T.baseUri,{recursive:u,excludes:[]}),P.Disposable.from({dispose:()=>h.$unwatch(l)})}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class A{constructor(_,m,T){this._mainContext=_,this._logService=m,this._extHostDocumentsAndEditors=T,this._onFileSystemEvent=new o.Emitter,this._onDidRenameFile=new o.Emitter,this._onDidCreateFile=new o.Emitter,this._onDidDeleteFile=new o.Emitter,this._onWillRenameFile=new o.AsyncEmitter,this._onWillCreateFile=new o.AsyncEmitter,this._onWillDeleteFile=new o.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(_,m,T,g,h,u){return new b(this._mainContext,_,m,this._onFileSystemEvent.event,I.GlobPattern.from(T),g,h,u)}$onFileEvent(_){this._onFileSystemEvent.fire(_)}$onDidRunFileOperation(_,m){switch(_){case 2:this._onDidRenameFile.fire(Object.freeze({files:m.map(T=>({oldUri:p.URI.revive(T.source),newUri:p.URI.revive(T.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:m.map(T=>p.URI.revive(T.target))}));break;case 0:case 3:this._onDidCreateFile.fire(Object.freeze({files:m.map(T=>p.URI.revive(T.target))}));break;default:}}getOnWillRenameFileEvent(_){return this._createWillExecuteEvent(_,this._onWillRenameFile)}getOnWillCreateFileEvent(_){return this._createWillExecuteEvent(_,this._onWillCreateFile)}getOnWillDeleteFileEvent(_){return this._createWillExecuteEvent(_,this._onWillDeleteFile)}_createWillExecuteEvent(_,m){return(T,g,h)=>{const u=function(S){T.call(g,S)};return u.extension=_,m.event(u,void 0,h)}}async $onWillRunFileOperation(_,m,T,g){switch(_){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:m.map(h=>({oldUri:p.URI.revive(h.source),newUri:p.URI.revive(h.target)}))},T,g);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:m.map(h=>p.URI.revive(h.target))},T,g);case 0:case 3:return await this._fireWillEvent(this._onWillCreateFile,{files:m.map(h=>p.URI.revive(h.target))},T,g)}}async _fireWillEvent(_,m,T,g){const h=new Set,u=[];if(await _.fireAsync(m,g,async(S,w)=>{const a=Date.now(),y=await Promise.resolve(S);y instanceof P.WorkspaceEdit&&(u.push(y),h.add(w.extension.displayName??w.extension.identifier.value)),Date.now()-a>T&&this._logService.warn("SLOW file-participant",w.extension.identifier)}),g.isCancellationRequested||u.length===0)return;const l={edits:[]};for(const S of u){const{edits:w}=I.WorkspaceEdit.from(S,{getTextDocumentVersion:a=>this._extHostDocumentsAndEditors.getDocument(a)?.version,getNotebookDocumentVersion:()=>{}});l.edits=l.edits.concat(w)}return{edit:l,extensionNames:Array.from(h)}}}e.ExtHostFileSystemEventService=A}),define(De[199],Ce([1,0,2,36]),function(J,e,o,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class p{constructor(I,P,b,A,R){this._extHostNotebooks=P,this._textDocumentsAndEditors=b,this._commands=A;const _=new C.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new C.ApiCommandArgument("showOptions","Show Options",m=>!0,m=>m),new C.ApiCommandArgument("resource","Interactive resource Uri",m=>!0,m=>m),new C.ApiCommandArgument("controllerId","Notebook controller Id",m=>!0,m=>m),new C.ApiCommandArgument("title","Interactive editor title",m=>!0,m=>m)],new C.ApiCommandResult("Notebook and input URI",m=>{if(R.debug("[ExtHostInteractive] open iw with notebook editor id",m.notebookEditorId),m.notebookEditorId!==void 0){const T=this._extHostNotebooks.getEditorById(m.notebookEditorId);return R.debug("[ExtHostInteractive] notebook editor found",T.id),{notebookUri:o.URI.revive(m.notebookUri),inputUri:o.URI.revive(m.inputUri),notebookEditor:T.apiEditor}}return R.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",m.notebookUri,m.inputUri),{notebookUri:o.URI.revive(m.notebookUri),inputUri:o.URI.revive(m.inputUri)}}));this._commands.registerApiCommand(_)}$willAddInteractiveDocument(I,P,b,A){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:P,lines:[""],languageId:b,uri:I,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(o.URI.revive(A))?.apiNotebook}]})}$willRemoveInteractiveDocument(I,P){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[I]})}}e.ExtHostInteractive=p}),define(De[200],Ce([1,0,7,5]),function(J,e,o,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class p{constructor(I){this._handlePool=0,this._proxy=I.getProxy(C.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(I){const P=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(P,I),(0,o.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(P)})}}e.ExtHostLabelService=p}),define(De[201],Ce([1,0,2,26,8,6,66,5,10,48,16,9,243,20,7,77,73,61,202,11,13,25]),function(J,e,o,C,p,U,I,P,b,A,R,_,m,T,g,h,u,l,S,w,a,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class r{constructor(k,B){this._documents=k,this._provider=B}async provideDocumentSymbols(k,B){const V=this._documents.getDocument(k),j=await this._provider.provideDocumentSymbols(V,B);if(!(0,R.isFalsyOrEmpty)(j))return j[0]instanceof U.DocumentSymbol?j.map(p.DocumentSymbol.from):r._asDocumentSymbolTree(j)}static _asDocumentSymbolTree(k){k=k.slice(0).sort((j,ne)=>{let ue=j.location.range.start.compareTo(ne.location.range.start);return ue===0&&(ue=ne.location.range.end.compareTo(j.location.range.end)),ue});const B=[],V=[];for(const j of k){const ne={name:j.name||"!!MISSING: name!!",kind:p.SymbolKind.from(j.kind),tags:j.tags?.map(p.SymbolTag.from)||[],detail:"",containerName:j.containerName,range:p.Range.from(j.location.range),selectionRange:p.Range.from(j.location.range),children:[]};for(;;){if(V.length===0){V.push(ne),B.push(ne);break}const ue=V[V.length-1];if(A.Range.containsRange(ue.range,ne.range)&&!A.Range.equalsRange(ue.range,ne.range)){ue.children?.push(ne),V.push(ne);break}V.pop()}}return B}}class d{constructor(k,B,V){this._documents=k,this._commands=B,this._provider=V,this._cache=new l.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(k,B){const V=this._documents.getDocument(k),j=await this._provider.provideCodeLenses(V,B);if(!j||B.isCancellationRequested)return;const ne=this._cache.add(j),ue=new g.DisposableStore;this._disposables.set(ne,ue);const Y={cacheId:ne,lenses:[]};for(let ge=0;ge<j.length;ge++)Y.lenses.push({cacheId:[ne,ge],range:p.Range.from(j[ge].range),command:this._commands.toInternal(j[ge].command,ue)});return Y}async resolveCodeLens(k,B){const V=k.cacheId&&this._cache.get(...k.cacheId);if(!V)return;let j;if(typeof this._provider.resolveCodeLens!="function"||V.isResolved?j=V:j=await this._provider.resolveCodeLens(V,B),j||(j=V),B.isCancellationRequested)return;const ne=k.cacheId&&this._disposables.get(k.cacheId[0]);if(!!ne)return k.command=this._commands.toInternal(j.command??d._badCmd,ne),k}releaseCodeLenses(k){this._disposables.get(k)?.dispose(),this._disposables.delete(k),this._cache.delete(k)}}d._badCmd={command:"missing",title:"!!MISSING: command!!"};function i(X){return Array.isArray(X)?X.map(p.DefinitionLink.from):X?[p.DefinitionLink.from(X)]:[]}class s{constructor(k,B){this._documents=k,this._provider=B}async provideDefinition(k,B,V){const j=this._documents.getDocument(k),ne=p.Position.to(B),ue=await this._provider.provideDefinition(j,ne,V);return i(ue)}}class n{constructor(k,B){this._documents=k,this._provider=B}async provideDeclaration(k,B,V){const j=this._documents.getDocument(k),ne=p.Position.to(B),ue=await this._provider.provideDeclaration(j,ne,V);return i(ue)}}class t{constructor(k,B){this._documents=k,this._provider=B}async provideImplementation(k,B,V){const j=this._documents.getDocument(k),ne=p.Position.to(B),ue=await this._provider.provideImplementation(j,ne,V);return i(ue)}}class c{constructor(k,B){this._documents=k,this._provider=B}async provideTypeDefinition(k,B,V){const j=this._documents.getDocument(k),ne=p.Position.to(B),ue=await this._provider.provideTypeDefinition(j,ne,V);return i(ue)}}class E{constructor(k,B){this._documents=k,this._provider=B}async provideHover(k,B,V){const j=this._documents.getDocument(k),ne=p.Position.to(B),ue=await this._provider.provideHover(j,ne,V);if(!(!ue||(0,R.isFalsyOrEmpty)(ue.contents)))return ue.range||(ue.range=j.getWordRangeAtPosition(ne)),ue.range||(ue.range=new U.Range(ne,ne)),p.Hover.from(ue)}}class f{constructor(k,B){this._documents=k,this._provider=B}async provideEvaluatableExpression(k,B,V){const j=this._documents.getDocument(k),ne=p.Position.to(B),ue=await this._provider.provideEvaluatableExpression(j,ne,V);if(ue)return p.EvaluatableExpression.from(ue)}}class D{constructor(k,B){this._documents=k,this._provider=B}async provideInlineValues(k,B,V,j){const ne=this._documents.getDocument(k),ue=await this._provider.provideInlineValues(ne,p.Range.to(B),p.InlineValueContext.to(V),j);if(Array.isArray(ue))return ue.map(Y=>p.InlineValue.from(Y))}}class L{constructor(k,B){this._documents=k,this._provider=B}async provideDocumentHighlights(k,B,V){const j=this._documents.getDocument(k),ne=p.Position.to(B),ue=await this._provider.provideDocumentHighlights(j,ne,V);if(Array.isArray(ue))return ue.map(p.DocumentHighlight.from)}}class W{constructor(k,B){this._documents=k,this._provider=B}async provideLinkedEditingRanges(k,B,V){const j=this._documents.getDocument(k),ne=p.Position.to(B),ue=await this._provider.provideLinkedEditingRanges(j,ne,V);if(ue&&Array.isArray(ue.ranges))return{ranges:(0,R.coalesce)(ue.ranges.map(p.Range.from)),wordPattern:ue.wordPattern}}}class N{constructor(k,B){this._documents=k,this._provider=B}async provideReferences(k,B,V,j){const ne=this._documents.getDocument(k),ue=p.Position.to(B),Y=await this._provider.provideReferences(ne,ue,V,j);if(Array.isArray(Y))return Y.map(p.location.from)}}class v{constructor(k,B,V,j,ne,ue,Y){this._documents=k,this._commands=B,this._diagnostics=V,this._provider=j,this._logService=ne,this._extension=ue,this._apiDeprecation=Y,this._cache=new l.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(k,B,V,j){const ne=this._documents.getDocument(k),ue=m.Selection.isISelection(B)?p.Selection.to(B):p.Range.to(B),Y=[];for(const qe of this._diagnostics.getDiagnostics(k))if(ue.intersection(qe.range)&&Y.push(qe)>v._maxCodeActionsPerFile)break;const ge={diagnostics:Y,only:V.only?new U.CodeActionKind(V.only):void 0,triggerKind:p.CodeActionTriggerKind.to(V.trigger)},fe=await this._provider.provideCodeActions(ne,ue,ge,j);if(!(0,R.isNonEmptyArray)(fe)||j.isCancellationRequested)return;const Ne=this._cache.add(fe),ze=new g.DisposableStore;this._disposables.set(Ne,ze);const ke=[];for(let qe=0;qe<fe.length;qe++){const K=fe[qe];!K||(v._isCommand(K)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),ke.push({_isSynthetic:!0,title:K.title,command:this._commands.toInternal(K,ze)})):(ge.only&&(K.kind?ge.only.contains(K.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${ge.only.value} 'requested but returned code action is of kind '${K.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${ge.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),ke.push({cacheId:[Ne,qe],title:K.title,command:K.command&&this._commands.toInternal(K.command,ze),diagnostics:K.diagnostics&&K.diagnostics.map(p.Diagnostic.from),edit:K.edit&&p.WorkspaceEdit.from(K.edit),kind:K.kind&&K.kind.value,isPreferred:K.isPreferred,disabled:K.disabled?.reason})))}return{cacheId:Ne,actions:ke}}async resolveCodeAction(k,B){const[V,j]=k,ne=this._cache.get(V,j);if(!ne||v._isCommand(ne)||!this._provider.resolveCodeAction)return;const ue=await this._provider.resolveCodeAction(ne,B)??ne;return ue?.edit?p.WorkspaceEdit.from(ue.edit):void 0}releaseCodeActions(k){this._disposables.get(k)?.dispose(),this._disposables.delete(k),this._cache.delete(k)}static _isCommand(k){return typeof k.command=="string"&&typeof k.title=="string"}}v._maxCodeActionsPerFile=1e3;class F{constructor(k,B,V,j){this._proxy=k,this._documents=B,this._provider=V,this._handle=j}async prepareDocumentPaste(k,B,V,j){if(!this._provider.prepareDocumentPaste)return;const ne=this._documents.getDocument(k),ue=B.map(ge=>p.Range.to(ge)),Y=p.DataTransfer.toDataTransfer(V,()=>{throw new w.NotImplementedError});return await this._provider.prepareDocumentPaste(ne,ue,Y,j),p.DataTransfer.toDataTransferDTO(Y)}async providePasteEdits(k,B,V,j,ne){const ue=this._documents.getDocument(B),Y=V.map(Ne=>p.Range.to(Ne)),ge=p.DataTransfer.toDataTransfer(j,async Ne=>(await this._proxy.$resolveDocumentOnDropFileData(this._handle,k,Ne)).buffer),fe=await this._provider.provideDocumentPasteEdits(ue,Y,ge,ne);if(!!fe)return{insertText:typeof fe.insertText=="string"?fe.insertText:{snippet:fe.insertText.value},additionalEdit:fe.additionalEdit?p.WorkspaceEdit.from(fe.additionalEdit):void 0}}}class O{constructor(k,B){this._documents=k,this._provider=B}async provideDocumentFormattingEdits(k,B,V){const j=this._documents.getDocument(k),ne=await this._provider.provideDocumentFormattingEdits(j,B,V);if(Array.isArray(ne))return ne.map(p.TextEdit.from)}}class H{constructor(k,B){this._documents=k,this._provider=B}async provideDocumentRangeFormattingEdits(k,B,V,j){const ne=this._documents.getDocument(k),ue=p.Range.to(B),Y=await this._provider.provideDocumentRangeFormattingEdits(ne,ue,V,j);if(Array.isArray(Y))return Y.map(p.TextEdit.from)}}class te{constructor(k,B){this._documents=k,this._provider=B,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(k,B,V,j,ne){const ue=this._documents.getDocument(k),Y=p.Position.to(B),ge=await this._provider.provideOnTypeFormattingEdits(ue,Y,V,j,ne);if(Array.isArray(ge))return ge.map(p.TextEdit.from)}}class z{constructor(k,B){this._provider=k,this._logService=B,this._cache=new l.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(k,B){const V=await this._provider.provideWorkspaceSymbols(k,B);if(!(0,R.isNonEmptyArray)(V))return{symbols:[]};const j=this._cache.add(V),ne={cacheId:j,symbols:[]};for(let ue=0;ue<V.length;ue++){const Y=V[ue];if(!Y||!Y.name){this._logService.warn("INVALID SymbolInformation",Y);continue}ne.symbols.push({...p.WorkspaceSymbol.from(Y),cacheId:[j,ue]})}return ne}async resolveWorkspaceSymbol(k,B){if(typeof this._provider.resolveWorkspaceSymbol!="function"||!k.cacheId)return k;const V=this._cache.get(...k.cacheId);if(V){const j=await this._provider.resolveWorkspaceSymbol(V,B);return j&&(0,C.mixin)(k,p.WorkspaceSymbol.from(j),!0)}}releaseWorkspaceSymbols(k){this._cache.delete(k)}}class ${constructor(k,B,V){this._documents=k,this._provider=B,this._logService=V}static supportsResolving(k){return typeof k.prepareRename=="function"}async provideRenameEdits(k,B,V,j){const ne=this._documents.getDocument(k),ue=p.Position.to(B);try{const Y=await this._provider.provideRenameEdits(ne,ue,V,j);return Y?p.WorkspaceEdit.from(Y):void 0}catch(Y){const ge=$._asMessage(Y);return ge?{rejectReason:ge,edits:void 0}:Promise.reject(Y)}}async resolveRenameLocation(k,B,V){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const j=this._documents.getDocument(k),ne=p.Position.to(B);try{const ue=await this._provider.prepareRename(j,ne,V);let Y,ge;if(U.Range.isRange(ue)?(Y=ue,ge=j.getText(ue)):(0,_.isObject)(ue)&&(Y=ue.range,ge=ue.placeholder),!Y||!ge)return;if(Y.start.line>ne.line||Y.end.line<ne.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:p.Range.from(Y),text:ge}}catch(ue){const Y=$._asMessage(ue);return Y?{rejectReason:Y,range:void 0,text:void 0}:Promise.reject(ue)}}static _asMessage(k){return typeof k=="string"?k:k instanceof Error&&typeof k.message=="string"?k.message:void 0}}class ce{constructor(k,B){this.resultId=k,this.tokens=B}}class le{constructor(k,B){this._documents=k,this._provider=B,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(k,B,V){const j=this._documents.getDocument(k),ne=B!==0?this._previousResults.get(B):null;let ue=typeof ne?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(j,ne.resultId,V):await this._provider.provideDocumentSemanticTokens(j,V);return ne&&this._previousResults.delete(B),ue?(ue=le._fixProvidedSemanticTokens(ue),this._send(le._convertToEdits(ne,ue),ue)):null}async releaseDocumentSemanticColoring(k){this._previousResults.delete(k)}static _fixProvidedSemanticTokens(k){return le._isSemanticTokens(k)?le._isCorrectSemanticTokens(k)?k:new U.SemanticTokens(new Uint32Array(k.data),k.resultId):le._isSemanticTokensEdits(k)?le._isCorrectSemanticTokensEdits(k)?k:new U.SemanticTokensEdits(k.edits.map(B=>new U.SemanticTokensEdit(B.start,B.deleteCount,B.data?new Uint32Array(B.data):B.data)),k.resultId):k}static _isSemanticTokens(k){return k&&!!k.data}static _isCorrectSemanticTokens(k){return k.data instanceof Uint32Array}static _isSemanticTokensEdits(k){return k&&Array.isArray(k.edits)}static _isCorrectSemanticTokensEdits(k){for(const B of k.edits)if(!(B.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(k,B){if(!le._isSemanticTokens(B)||!k||!k.tokens)return B;const V=k.tokens,j=V.length,ne=B.data,ue=ne.length;let Y=0;const ge=Math.min(j,ue);for(;Y<ge&&V[Y]===ne[Y];)Y++;if(Y===j&&Y===ue)return new U.SemanticTokensEdits([],B.resultId);let fe=0;const Ne=ge-Y;for(;fe<Ne&&V[j-fe-1]===ne[ue-fe-1];)fe++;return new U.SemanticTokensEdits([{start:Y,deleteCount:j-Y-fe,data:ne.subarray(Y,ue-fe)}],B.resultId)}_send(k,B){if(le._isSemanticTokens(k)){const V=this._nextResultId++;return this._previousResults.set(V,new ce(k.resultId,k.data)),(0,h.encodeSemanticTokensDto)({id:V,type:"full",data:k.data})}if(le._isSemanticTokensEdits(k)){const V=this._nextResultId++;return le._isSemanticTokens(B)?this._previousResults.set(V,new ce(B.resultId,B.data)):this._previousResults.set(V,new ce(k.resultId)),(0,h.encodeSemanticTokensDto)({id:V,type:"delta",deltas:(k.edits||[]).map(j=>({start:j.start,deleteCount:j.deleteCount,data:j.data}))})}return null}}e.DocumentSemanticTokensAdapter=le;class oe{constructor(k,B){this._documents=k,this._provider=B}async provideDocumentRangeSemanticTokens(k,B,V){const j=this._documents.getDocument(k),ne=await this._provider.provideDocumentRangeSemanticTokens(j,p.Range.to(B),V);return ne?this._send(ne):null}_send(k){return(0,h.encodeSemanticTokensDto)({id:0,type:"full",data:k.data})}}e.DocumentRangeSemanticTokensAdapter=oe;class pe{constructor(k,B,V,j,ne){this._documents=k,this._commands=B,this._provider=V,this._apiDeprecation=j,this._extension=ne,this._cache=new l.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(k){return typeof k.resolveCompletionItem=="function"}async provideCompletionItems(k,B,V,j){const ne=this._documents.getDocument(k),ue=p.Position.to(B),Y=ne.getWordRangeAtPosition(ue)||new U.Range(ue,ue),ge=Y.with({end:ue}),fe=new S.StopWatch(!0),Ne=await this._provider.provideCompletionItems(ne,ue,j,p.CompletionContext.to(V));if(!Ne||j.isCancellationRequested)return;const ze=Array.isArray(Ne)?new U.CompletionList(Ne):Ne,ke=pe.supportsResolving(this._provider)?this._cache.add(ze.items):this._cache.add([]),qe=new g.DisposableStore;this._disposables.set(ke,qe);const K=[],Q={x:ke,b:K,a:{replace:p.Range.from(Y),insert:p.Range.from(ge)},c:ze.isIncomplete||void 0,d:fe.elapsed()};for(let me=0;me<ze.items.length;me++){const Le=ze.items[me],Be=this._convertCompletionItem(Le,[ke,me],ge,Y);K.push(Be)}return Q}async resolveCompletionItem(k,B){if(typeof this._provider.resolveCompletionItem!="function")return;const V=this._cache.get(...k);if(!V)return;const j=await this._provider.resolveCompletionItem(V,B);if(!!j)return this._convertCompletionItem(j,k)}releaseCompletionItems(k){this._disposables.get(k)?.dispose(),this._disposables.delete(k),this._cache.delete(k)}_convertCompletionItem(k,B,V,j){const ne=this._disposables.get(B[0]);if(!ne)throw Error("DisposableStore is missing...");const ue={x:B,a:k.label,b:k.kind!==void 0?p.CompletionItemKind.from(k.kind):void 0,n:k.tags&&k.tags.map(p.CompletionItemTag.from),c:k.detail,d:typeof k.documentation=="undefined"?void 0:p.MarkdownString.fromStrict(k.documentation),e:k.sortText!==k.label?k.sortText:void 0,f:k.filterText!==k.label?k.filterText:void 0,g:k.preselect||void 0,i:k.keepWhitespace?1:0,k:k.commitCharacters,l:k.additionalTextEdits&&k.additionalTextEdits.map(p.TextEdit.from),m:this._commands.toInternal(k.command,ne)};k.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ue.h=k.textEdit.newText):typeof k.insertText=="string"?ue.h=k.insertText:k.insertText instanceof U.SnippetString&&(ue.h=k.insertText.value,ue.i|=4);let Y;return k.textEdit?Y=k.textEdit.range:k.range&&(Y=k.range),U.Range.isRange(Y)?ue.j=p.Range.from(Y):Y&&(!V?.isEqual(Y.inserting)||!j?.isEqual(Y.replacing))&&(ue.j={insert:p.Range.from(Y.inserting),replace:p.Range.from(Y.replacing)}),ue}}class re{async provideInlineCompletions(k,B,V,j){}disposeCompletions(k){}handleDidShowCompletionItem(k,B){}}class Ee extends re{constructor(k,B,V,j){super();this._extension=k,this._documents=B,this._provider=V,this._commands=j,this._references=new Z,this._isAdditionsProposedApiEnabled=(0,y.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions"),this.languageTriggerKindToVSCodeTriggerKind={[I.InlineCompletionTriggerKind.Automatic]:U.InlineCompletionTriggerKind.Automatic,[I.InlineCompletionTriggerKind.Explicit]:U.InlineCompletionTriggerKind.Invoke}}get supportsHandleDidShowCompletionItem(){return(0,y.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions")&&typeof this._provider.handleDidShowCompletionItem=="function"}async provideInlineCompletions(k,B,V,j){const ne=this._documents.getDocument(k),ue=p.Position.to(B),Y=await this._provider.provideInlineCompletionItems(ne,ue,{selectedCompletionInfo:V.selectedSuggestionInfo?{range:p.Range.to(V.selectedSuggestionInfo.range),text:V.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[V.triggerKind]},j);if(!Y||j.isCancellationRequested)return;const ge=(0,_.isArray)(Y)?Y:Y.items,fe=this._isAdditionsProposedApiEnabled?(0,_.isArray)(Y)?[]:Y.commands||[]:[];let Ne;return{pid:this._references.createReferenceId({dispose(){Ne&&Ne.dispose()},items:ge}),items:ge.map((ke,qe)=>{let K;ke.command&&(Ne||(Ne=new g.DisposableStore),K=this._commands.toInternal(ke.command,Ne));const Q=ke.insertText;return{insertText:typeof Q=="string"?Q:{snippet:Q.value},filterText:ke.filterText,range:ke.range?p.Range.from(ke.range):void 0,command:K,idx:qe,completeBracketPairs:this._isAdditionsProposedApiEnabled?ke.completeBracketPairs:!1}}),commands:fe.map(ke=>(Ne||(Ne=new g.DisposableStore),this._commands.toInternal(ke,Ne)))}}disposeCompletions(k){this._references.disposeReferenceId(k)?.dispose()}handleDidShowCompletionItem(k,B){const V=this._references.get(k)?.items[B];V&&this._provider.handleDidShowCompletionItem&&this._isAdditionsProposedApiEnabled&&this._provider.handleDidShowCompletionItem(V)}}class be extends re{constructor(k,B,V,j){super();this.extension=k,this._documents=B,this._provider=V,this._commands=j,this._references=new Z,this.isAdditionProposedApiEnabled=(0,y.isProposedApiEnabled)(this.extension,"inlineCompletionsAdditions"),this.languageTriggerKindToVSCodeTriggerKind={[I.InlineCompletionTriggerKind.Automatic]:U.InlineCompletionTriggerKindNew.Automatic,[I.InlineCompletionTriggerKind.Explicit]:U.InlineCompletionTriggerKindNew.Invoke}}async provideInlineCompletions(k,B,V,j){const ne=this._documents.getDocument(k),ue=p.Position.to(B),Y=await this._provider.provideInlineCompletionItems(ne,ue,{selectedCompletionInfo:V.selectedSuggestionInfo?{range:p.Range.to(V.selectedSuggestionInfo.range),text:V.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[V.triggerKind]},j);if(!Y||j.isCancellationRequested)return;const ge=(0,_.isArray)(Y)?Y:Y.items,fe=(0,_.isArray)(Y)?[]:Y.commands||[];let Ne;return{pid:this._references.createReferenceId({dispose(){Ne&&Ne.dispose()},items:ge}),items:ge.map((ke,qe)=>{let K;ke.command&&(Ne||(Ne=new g.DisposableStore),K=this._commands.toInternal(ke.command,Ne));const Q=ke.insertText;return{insertText:typeof Q=="string"?Q:{snippet:Q.value},filterText:ke.filterText,range:ke.range?p.Range.from(ke.range):void 0,command:K,idx:qe,completeBracketPairs:this.isAdditionProposedApiEnabled?ke.completeBracketPairs:!1}}),commands:fe.map(ke=>(Ne||(Ne=new g.DisposableStore),this._commands.toInternal(ke,Ne)))}}disposeCompletions(k){this._references.disposeReferenceId(k)?.dispose()}handleDidShowCompletionItem(k,B){const V=this._references.get(k)?.items[B];V&&this._provider.handleDidShowCompletionItem&&this.isAdditionProposedApiEnabled&&this._provider.handleDidShowCompletionItem(V)}}class Z{constructor(){this._references=new Map,this._idPool=1}createReferenceId(k){const B=this._idPool++;return this._references.set(B,k),B}disposeReferenceId(k){const B=this._references.get(k);return this._references.delete(k),B}get(k){return this._references.get(k)}}class ve{constructor(k,B){this._documents=k,this._provider=B,this._cache=new l.Cache("SignatureHelp")}async provideSignatureHelp(k,B,V,j){const ne=this._documents.getDocument(k),ue=p.Position.to(B),Y=this.reviveContext(V),ge=await this._provider.provideSignatureHelp(ne,ue,j,Y);if(ge){const fe=this._cache.add([ge]);return{...p.SignatureHelp.from(ge),id:fe}}}reviveContext(k){let B;if(k.activeSignatureHelp){const V=p.SignatureHelp.to(k.activeSignatureHelp),j=this._cache.get(k.activeSignatureHelp.id,0);j?(B=j,B.activeSignature=V.activeSignature,B.activeParameter=V.activeParameter):B=V}return{...k,activeSignatureHelp:B}}releaseSignatureHelp(k){this._cache.delete(k)}}class Re{constructor(k,B,V,j,ne){this._documents=k,this._commands=B,this._provider=V,this._logService=j,this._extension=ne,this._cache=new l.Cache("InlayHints"),this._disposables=new Map}async provideInlayHints(k,B,V){const j=this._documents.getDocument(k),ne=p.Range.to(B),ue=await this._provider.provideInlayHints(j,ne,V);if(!Array.isArray(ue)||ue.length===0){this._logService.trace(`[InlayHints] NO inlay hints from '${this._extension.identifier.value}' for ${B}`);return}if(V.isCancellationRequested)return;const Y=this._cache.add(ue);this._disposables.set(Y,new g.DisposableStore);const ge={hints:[],cacheId:Y};for(let fe=0;fe<ue.length;fe++)this._isValidInlayHint(ue[fe],ne)&&ge.hints.push(this._convertInlayHint(ue[fe],[Y,fe]));return this._logService.trace(`[InlayHints] ${ge.hints.length} inlay hints from '${this._extension.identifier.value}' for ${B}`),ge}async resolveInlayHint(k,B){if(typeof this._provider.resolveInlayHint!="function")return;const V=this._cache.get(...k);if(!V)return;const j=await this._provider.resolveInlayHint(V,B);if(!!j&&!!this._isValidInlayHint(j))return this._convertInlayHint(j,k)}releaseHints(k){this._disposables.get(k)?.dispose(),this._disposables.delete(k),this._cache.delete(k)}_isValidInlayHint(k,B){return k.label.length===0||Array.isArray(k.label)&&k.label.every(V=>V.value.length===0)?(console.log("INVALID inlay hint, empty label",k),!1):!(B&&!B.contains(k.position))}_convertInlayHint(k,B){const V=this._disposables.get(B[0]);if(!V)throw Error("DisposableStore is missing...");const j={label:"",cacheId:B,tooltip:p.MarkdownString.fromStrict(k.tooltip),position:p.Position.from(k.position),textEdits:k.textEdits&&k.textEdits.map(p.TextEdit.from),kind:k.kind&&p.InlayHintKind.from(k.kind),paddingLeft:k.paddingLeft,paddingRight:k.paddingRight};return typeof k.label=="string"?j.label=k.label:j.label=k.label.map(ne=>{const ue={label:ne.value};return ue.tooltip=p.MarkdownString.fromStrict(ne.tooltip),U.Location.isLocation(ne.location)&&(ue.location=p.location.from(ne.location)),ne.command&&(ue.command=this._commands.toInternal(ne.command,V)),ue}),j}}class Fe{constructor(k,B){this._documents=k,this._provider=B,this._cache=new l.Cache("DocumentLink")}async provideLinks(k,B){const V=this._documents.getDocument(k),j=await this._provider.provideDocumentLinks(V,B);if(!(!Array.isArray(j)||j.length===0)&&!B.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:j.filter(Fe._validateLink).map(p.DocumentLink.from)};{const ne=this._cache.add(j),ue={links:[],cacheId:ne};for(let Y=0;Y<j.length;Y++){if(!Fe._validateLink(j[Y]))continue;const ge=p.DocumentLink.from(j[Y]);ge.cacheId=[ne,Y],ue.links.push(ge)}return ue}}}static _validateLink(k){return k.target&&k.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(k,B){if(typeof this._provider.resolveDocumentLink!="function")return;const V=this._cache.get(...k);if(!V)return;const j=await this._provider.resolveDocumentLink(V,B);if(!(!j||!Fe._validateLink(j)))return p.DocumentLink.from(j)}releaseLinks(k){this._cache.delete(k)}}class We{constructor(k,B){this._documents=k,this._provider=B}async provideColors(k,B){const V=this._documents.getDocument(k),j=await this._provider.provideDocumentColors(V,B);return Array.isArray(j)?j.map(ue=>({color:p.Color.from(ue.color),range:p.Range.from(ue.range)})):[]}async provideColorPresentations(k,B,V){const j=this._documents.getDocument(k),ne=p.Range.to(B.range),ue=p.Color.to(B.color),Y=await this._provider.provideColorPresentations(ue,{document:j,range:ne},V);if(!!Array.isArray(Y))return Y.map(p.ColorPresentation.from)}}class Xe{constructor(k,B){this._documents=k,this._provider=B}async provideFoldingRanges(k,B,V){const j=this._documents.getDocument(k),ne=await this._provider.provideFoldingRanges(j,B,V);if(!!Array.isArray(ne))return ne.map(p.FoldingRange.from)}}class Ie{constructor(k,B,V){this._documents=k,this._provider=B,this._logService=V}async provideSelectionRanges(k,B,V){const j=this._documents.getDocument(k),ne=B.map(p.Position.to),ue=await this._provider.provideSelectionRanges(j,ne,V);if(!(0,R.isNonEmptyArray)(ue))return[];if(ue.length!==ne.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const Y=[];for(let ge=0;ge<ne.length;ge++){const fe=[];Y.push(fe);let Ne=ne[ge],ze=ue[ge];for(;;){if(!ze.range.contains(Ne))throw new Error("INVALID selection range, must contain the previous range");if(fe.push(p.SelectionRange.from(ze)),!ze.parent)break;Ne=ze.range,ze=ze.parent}}return Y}}class Se{constructor(k,B){this._documents=k,this._provider=B,this._idPool=new u.IdGenerator(""),this._cache=new Map}async prepareSession(k,B,V){const j=this._documents.getDocument(k),ne=p.Position.to(B),ue=await this._provider.prepareCallHierarchy(j,ne,V);if(!ue)return;const Y=this._idPool.nextId();return this._cache.set(Y,new Map),Array.isArray(ue)?ue.map(ge=>this._cacheAndConvertItem(Y,ge)):[this._cacheAndConvertItem(Y,ue)]}async provideCallsTo(k,B,V){const j=this._itemFromCache(k,B);if(!j)throw new Error("missing call hierarchy item");const ne=await this._provider.provideCallHierarchyIncomingCalls(j,V);if(!!ne)return ne.map(ue=>({from:this._cacheAndConvertItem(k,ue.from),fromRanges:ue.fromRanges.map(Y=>p.Range.from(Y))}))}async provideCallsFrom(k,B,V){const j=this._itemFromCache(k,B);if(!j)throw new Error("missing call hierarchy item");const ne=await this._provider.provideCallHierarchyOutgoingCalls(j,V);if(!!ne)return ne.map(ue=>({to:this._cacheAndConvertItem(k,ue.to),fromRanges:ue.fromRanges.map(Y=>p.Range.from(Y))}))}releaseSession(k){this._cache.delete(k)}_cacheAndConvertItem(k,B){const V=this._cache.get(k),j=p.CallHierarchyItem.from(B,k,V.size.toString(36));return V.set(j._itemId,B),j}_itemFromCache(k,B){return this._cache.get(k)?.get(B)}}class Te{constructor(k,B){this._documents=k,this._provider=B,this._idPool=new u.IdGenerator(""),this._cache=new Map}async prepareSession(k,B,V){const j=this._documents.getDocument(k),ne=p.Position.to(B),ue=await this._provider.prepareTypeHierarchy(j,ne,V);if(!ue)return;const Y=this._idPool.nextId();return this._cache.set(Y,new Map),Array.isArray(ue)?ue.map(ge=>this._cacheAndConvertItem(Y,ge)):[this._cacheAndConvertItem(Y,ue)]}async provideSupertypes(k,B,V){const j=this._itemFromCache(k,B);if(!j)throw new Error("missing type hierarchy item");const ne=await this._provider.provideTypeHierarchySupertypes(j,V);if(!!ne)return ne.map(ue=>this._cacheAndConvertItem(k,ue))}async provideSubtypes(k,B,V){const j=this._itemFromCache(k,B);if(!j)throw new Error("missing type hierarchy item");const ne=await this._provider.provideTypeHierarchySubtypes(j,V);if(!!ne)return ne.map(ue=>this._cacheAndConvertItem(k,ue))}releaseSession(k){this._cache.delete(k)}_cacheAndConvertItem(k,B){const V=this._cache.get(k),j=p.TypeHierarchyItem.from(B,k,V.size.toString(36));return V.set(j._itemId,B),j}_itemFromCache(k,B){return this._cache.get(k)?.get(B)}}class se{constructor(k,B,V,j){this._proxy=k,this._documents=B,this._provider=V,this._handle=j}async provideDocumentOnDropEdits(k,B,V,j,ne){const ue=this._documents.getDocument(B),Y=p.Position.to(V),ge=p.DataTransfer.toDataTransfer(j,async Ne=>(await this._proxy.$resolveDocumentOnDropFileData(this._handle,k,Ne)).buffer),fe=await this._provider.provideDocumentOnDropEdits(ue,Y,ge,ne);if(!!fe)return{insertText:typeof fe.insertText=="string"?fe.insertText:{snippet:fe.insertText.value},additionalEdit:fe.additionalEdit?p.WorkspaceEdit.from(fe.additionalEdit):void 0}}}class ae{constructor(k,B){this.adapter=k,this.extension=B}}class G{constructor(k,B,V,j,ne,ue,Y){this._adapter=new Map,this._uriTransformer=B,this._proxy=k.getProxy(P.MainContext.MainThreadLanguageFeatures),this._documents=V,this._commands=j,this._diagnostics=ne,this._logService=ue,this._apiDeprecation=Y}_transformDocumentSelector(k){return p.DocumentSelector.from(k,this._uriTransformer)}_createDisposable(k){return new U.Disposable(()=>{this._adapter.delete(k),this._proxy.$unregister(k)})}_nextHandle(){return G._handlePool++}async _withAdapter(k,B,V,j,ne,ue=!1){const Y=this._adapter.get(k);if(!Y||!(Y.adapter instanceof B))return j;const ge=Date.now();ue||this._logService.trace(`[${Y.extension.identifier.value}] INVOKE provider '${V.toString().replace(/[\r\n]/g,"")}'`);const fe=V(Y.adapter,Y.extension);return Promise.resolve(fe).catch(Ne=>{(0,w.isCancellationError)(Ne)||(this._logService.error(`[${Y.extension.identifier.value}] provider FAILED`),this._logService.error(Ne))}).finally(()=>{ue||this._logService.trace(`[${Y.extension.identifier.value}] provider DONE after ${Date.now()-ge}ms`)}),T.CancellationToken.isCancellationToken(ne)?(0,a.raceCancellationError)(fe,ne):fe}_addNewAdapter(k,B){const V=this._nextHandle();return this._adapter.set(V,new ae(k,B)),V}static _extLabel(k){return k.displayName||k.name}registerDocumentSymbolProvider(k,B,V,j){const ne=this._addNewAdapter(new r(this._documents,V),k),ue=j&&j.label||G._extLabel(k);return this._proxy.$registerDocumentSymbolProvider(ne,this._transformDocumentSelector(B),ue),this._createDisposable(ne)}$provideDocumentSymbols(k,B,V){return this._withAdapter(k,r,j=>j.provideDocumentSymbols(o.URI.revive(B),V),void 0,V)}registerCodeLensProvider(k,B,V){const j=this._nextHandle(),ne=typeof V.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(j,new ae(new d(this._documents,this._commands.converter,V),k)),this._proxy.$registerCodeLensSupport(j,this._transformDocumentSelector(B),ne);let ue=this._createDisposable(j);if(ne!==void 0){const Y=V.onDidChangeCodeLenses(ge=>this._proxy.$emitCodeLensEvent(ne));ue=U.Disposable.from(ue,Y)}return ue}$provideCodeLenses(k,B,V){return this._withAdapter(k,d,j=>j.provideCodeLenses(o.URI.revive(B),V),void 0,V)}$resolveCodeLens(k,B,V){return this._withAdapter(k,d,j=>j.resolveCodeLens(B,V),void 0,void 0)}$releaseCodeLenses(k,B){this._withAdapter(k,d,V=>Promise.resolve(V.releaseCodeLenses(B)),void 0,void 0)}registerDefinitionProvider(k,B,V){const j=this._addNewAdapter(new s(this._documents,V),k);return this._proxy.$registerDefinitionSupport(j,this._transformDocumentSelector(B)),this._createDisposable(j)}$provideDefinition(k,B,V,j){return this._withAdapter(k,s,ne=>ne.provideDefinition(o.URI.revive(B),V,j),[],j)}registerDeclarationProvider(k,B,V){const j=this._addNewAdapter(new n(this._documents,V),k);return this._proxy.$registerDeclarationSupport(j,this._transformDocumentSelector(B)),this._createDisposable(j)}$provideDeclaration(k,B,V,j){return this._withAdapter(k,n,ne=>ne.provideDeclaration(o.URI.revive(B),V,j),[],j)}registerImplementationProvider(k,B,V){const j=this._addNewAdapter(new t(this._documents,V),k);return this._proxy.$registerImplementationSupport(j,this._transformDocumentSelector(B)),this._createDisposable(j)}$provideImplementation(k,B,V,j){return this._withAdapter(k,t,ne=>ne.provideImplementation(o.URI.revive(B),V,j),[],j)}registerTypeDefinitionProvider(k,B,V){const j=this._addNewAdapter(new c(this._documents,V),k);return this._proxy.$registerTypeDefinitionSupport(j,this._transformDocumentSelector(B)),this._createDisposable(j)}$provideTypeDefinition(k,B,V,j){return this._withAdapter(k,c,ne=>ne.provideTypeDefinition(o.URI.revive(B),V,j),[],j)}registerHoverProvider(k,B,V,j){const ne=this._addNewAdapter(new E(this._documents,V),k);return this._proxy.$registerHoverProvider(ne,this._transformDocumentSelector(B)),this._createDisposable(ne)}$provideHover(k,B,V,j){return this._withAdapter(k,E,ne=>ne.provideHover(o.URI.revive(B),V,j),void 0,j)}registerEvaluatableExpressionProvider(k,B,V,j){const ne=this._addNewAdapter(new f(this._documents,V),k);return this._proxy.$registerEvaluatableExpressionProvider(ne,this._transformDocumentSelector(B)),this._createDisposable(ne)}$provideEvaluatableExpression(k,B,V,j){return this._withAdapter(k,f,ne=>ne.provideEvaluatableExpression(o.URI.revive(B),V,j),void 0,j)}registerInlineValuesProvider(k,B,V,j){const ne=typeof V.onDidChangeInlineValues=="function"?this._nextHandle():void 0,ue=this._addNewAdapter(new D(this._documents,V),k);this._proxy.$registerInlineValuesProvider(ue,this._transformDocumentSelector(B),ne);let Y=this._createDisposable(ue);if(ne!==void 0){const ge=V.onDidChangeInlineValues(fe=>this._proxy.$emitInlineValuesEvent(ne));Y=U.Disposable.from(Y,ge)}return Y}$provideInlineValues(k,B,V,j,ne){return this._withAdapter(k,D,ue=>ue.provideInlineValues(o.URI.revive(B),V,j,ne),void 0,ne)}registerDocumentHighlightProvider(k,B,V){const j=this._addNewAdapter(new L(this._documents,V),k);return this._proxy.$registerDocumentHighlightProvider(j,this._transformDocumentSelector(B)),this._createDisposable(j)}$provideDocumentHighlights(k,B,V,j){return this._withAdapter(k,L,ne=>ne.provideDocumentHighlights(o.URI.revive(B),V,j),void 0,j)}registerLinkedEditingRangeProvider(k,B,V){const j=this._addNewAdapter(new W(this._documents,V),k);return this._proxy.$registerLinkedEditingRangeProvider(j,this._transformDocumentSelector(B)),this._createDisposable(j)}$provideLinkedEditingRanges(k,B,V,j){return this._withAdapter(k,W,async ne=>{const ue=await ne.provideLinkedEditingRanges(o.URI.revive(B),V,j);if(ue)return{ranges:ue.ranges,wordPattern:ue.wordPattern?G._serializeRegExp(ue.wordPattern):void 0}},void 0,j)}registerReferenceProvider(k,B,V){const j=this._addNewAdapter(new N(this._documents,V),k);return this._proxy.$registerReferenceSupport(j,this._transformDocumentSelector(B)),this._createDisposable(j)}$provideReferences(k,B,V,j,ne){return this._withAdapter(k,N,ue=>ue.provideReferences(o.URI.revive(B),V,j,ne),void 0,ne)}registerCodeActionProvider(k,B,V,j){const ne=new g.DisposableStore,ue=this._addNewAdapter(new v(this._documents,this._commands.converter,this._diagnostics,V,this._logService,k,this._apiDeprecation),k);return this._proxy.$registerQuickFixSupport(ue,this._transformDocumentSelector(B),{providedKinds:j?.providedCodeActionKinds?.map(Y=>Y.value),documentation:j?.documentation?.map(Y=>({kind:Y.kind.value,command:this._commands.converter.toInternal(Y.command,ne)}))},G._extLabel(k),Boolean(V.resolveCodeAction)),ne.add(this._createDisposable(ue)),ne}$provideCodeActions(k,B,V,j,ne){return this._withAdapter(k,v,ue=>ue.provideCodeActions(o.URI.revive(B),V,j,ne),void 0,ne)}$resolveCodeAction(k,B,V){return this._withAdapter(k,v,j=>j.resolveCodeAction(B,V),void 0,void 0)}$releaseCodeActions(k,B){this._withAdapter(k,v,V=>Promise.resolve(V.releaseCodeActions(B)),void 0,void 0)}registerDocumentFormattingEditProvider(k,B,V){const j=this._addNewAdapter(new O(this._documents,V),k);return this._proxy.$registerDocumentFormattingSupport(j,this._transformDocumentSelector(B),k.identifier,k.displayName||k.name),this._createDisposable(j)}$provideDocumentFormattingEdits(k,B,V,j){return this._withAdapter(k,O,ne=>ne.provideDocumentFormattingEdits(o.URI.revive(B),V,j),void 0,j)}registerDocumentRangeFormattingEditProvider(k,B,V){const j=this._addNewAdapter(new H(this._documents,V),k);return this._proxy.$registerRangeFormattingSupport(j,this._transformDocumentSelector(B),k.identifier,k.displayName||k.name),this._createDisposable(j)}$provideDocumentRangeFormattingEdits(k,B,V,j,ne){return this._withAdapter(k,H,ue=>ue.provideDocumentRangeFormattingEdits(o.URI.revive(B),V,j,ne),void 0,ne)}registerOnTypeFormattingEditProvider(k,B,V,j){const ne=this._addNewAdapter(new te(this._documents,V),k);return this._proxy.$registerOnTypeFormattingSupport(ne,this._transformDocumentSelector(B),j,k.identifier),this._createDisposable(ne)}$provideOnTypeFormattingEdits(k,B,V,j,ne,ue){return this._withAdapter(k,te,Y=>Y.provideOnTypeFormattingEdits(o.URI.revive(B),V,j,ne,ue),void 0,ue)}registerWorkspaceSymbolProvider(k,B){const V=this._addNewAdapter(new z(B,this._logService),k);return this._proxy.$registerNavigateTypeSupport(V,typeof B.resolveWorkspaceSymbol=="function"),this._createDisposable(V)}$provideWorkspaceSymbols(k,B,V){return this._withAdapter(k,z,j=>j.provideWorkspaceSymbols(B,V),{symbols:[]},V)}$resolveWorkspaceSymbol(k,B,V){return this._withAdapter(k,z,j=>j.resolveWorkspaceSymbol(B,V),void 0,void 0)}$releaseWorkspaceSymbols(k,B){this._withAdapter(k,z,V=>V.releaseWorkspaceSymbols(B),void 0,void 0)}registerRenameProvider(k,B,V){const j=this._addNewAdapter(new $(this._documents,V,this._logService),k);return this._proxy.$registerRenameSupport(j,this._transformDocumentSelector(B),$.supportsResolving(V)),this._createDisposable(j)}$provideRenameEdits(k,B,V,j,ne){return this._withAdapter(k,$,ue=>ue.provideRenameEdits(o.URI.revive(B),V,j,ne),void 0,ne)}$resolveRenameLocation(k,B,V,j){return this._withAdapter(k,$,ne=>ne.resolveRenameLocation(o.URI.revive(B),V,j),void 0,j)}registerDocumentSemanticTokensProvider(k,B,V,j){const ne=this._addNewAdapter(new le(this._documents,V),k),ue=typeof V.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._proxy.$registerDocumentSemanticTokensProvider(ne,this._transformDocumentSelector(B),j,ue);let Y=this._createDisposable(ne);if(ue){const ge=V.onDidChangeSemanticTokens(fe=>this._proxy.$emitDocumentSemanticTokensEvent(ue));Y=U.Disposable.from(Y,ge)}return Y}$provideDocumentSemanticTokens(k,B,V,j){return this._withAdapter(k,le,ne=>ne.provideDocumentSemanticTokens(o.URI.revive(B),V,j),null,j)}$releaseDocumentSemanticTokens(k,B){this._withAdapter(k,le,V=>V.releaseDocumentSemanticColoring(B),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(k,B,V,j){const ne=this._addNewAdapter(new oe(this._documents,V),k);return this._proxy.$registerDocumentRangeSemanticTokensProvider(ne,this._transformDocumentSelector(B),j),this._createDisposable(ne)}$provideDocumentRangeSemanticTokens(k,B,V,j){return this._withAdapter(k,oe,ne=>ne.provideDocumentRangeSemanticTokens(o.URI.revive(B),V,j),null,j)}registerCompletionItemProvider(k,B,V,j){const ne=this._addNewAdapter(new pe(this._documents,this._commands.converter,V,this._apiDeprecation,k),k);return this._proxy.$registerCompletionsProvider(ne,this._transformDocumentSelector(B),j,pe.supportsResolving(V),`${k.identifier.value}(${j.join("")})`),this._createDisposable(ne)}$provideCompletionItems(k,B,V,j,ne){return this._withAdapter(k,pe,ue=>ue.provideCompletionItems(o.URI.revive(B),V,j,ne),void 0,ne)}$resolveCompletionItem(k,B,V){return this._withAdapter(k,pe,j=>j.resolveCompletionItem(B,V),void 0,V)}$releaseCompletionItems(k,B){this._withAdapter(k,pe,V=>V.releaseCompletionItems(B),void 0,void 0)}registerInlineCompletionsProvider(k,B,V){const j=new Ee(k,this._documents,V,this._commands.converter),ne=this._addNewAdapter(j,k);return this._proxy.$registerInlineCompletionsSupport(ne,this._transformDocumentSelector(B),j.supportsHandleDidShowCompletionItem),this._createDisposable(ne)}registerInlineCompletionsProviderNew(k,B,V){const j=this._addNewAdapter(new be(k,this._documents,V,this._commands.converter),k);return this._proxy.$registerInlineCompletionsSupport(j,this._transformDocumentSelector(B),!0),this._createDisposable(j)}$provideInlineCompletions(k,B,V,j,ne){return this._withAdapter(k,re,ue=>ue.provideInlineCompletions(o.URI.revive(B),V,j,ne),void 0,ne)}$handleInlineCompletionDidShow(k,B,V){this._withAdapter(k,re,async j=>{j.handleDidShowCompletionItem(B,V)},void 0,void 0)}$freeInlineCompletionsList(k,B){this._withAdapter(k,re,async V=>{V.disposeCompletions(B)},void 0,void 0)}registerSignatureHelpProvider(k,B,V,j){const ne=Array.isArray(j)?{triggerCharacters:j,retriggerCharacters:[]}:j,ue=this._addNewAdapter(new ve(this._documents,V),k);return this._proxy.$registerSignatureHelpProvider(ue,this._transformDocumentSelector(B),ne),this._createDisposable(ue)}$provideSignatureHelp(k,B,V,j,ne){return this._withAdapter(k,ve,ue=>ue.provideSignatureHelp(o.URI.revive(B),V,j,ne),void 0,ne)}$releaseSignatureHelp(k,B){this._withAdapter(k,ve,V=>V.releaseSignatureHelp(B),void 0,void 0)}registerInlayHintsProvider(k,B,V){const j=typeof V.onDidChangeInlayHints=="function"?this._nextHandle():void 0,ne=this._addNewAdapter(new Re(this._documents,this._commands.converter,V,this._logService,k),k);this._proxy.$registerInlayHintsProvider(ne,this._transformDocumentSelector(B),typeof V.resolveInlayHint=="function",j,G._extLabel(k));let ue=this._createDisposable(ne);if(j!==void 0){const Y=V.onDidChangeInlayHints(ge=>this._proxy.$emitInlayHintsEvent(j));ue=U.Disposable.from(ue,Y)}return ue}$provideInlayHints(k,B,V,j){return this._withAdapter(k,Re,ne=>ne.provideInlayHints(o.URI.revive(B),V,j),void 0,j)}$resolveInlayHint(k,B,V){return this._withAdapter(k,Re,j=>j.resolveInlayHint(B,V),void 0,V)}$releaseInlayHints(k,B){this._withAdapter(k,Re,V=>V.releaseHints(B),void 0,void 0)}registerDocumentLinkProvider(k,B,V){const j=this._addNewAdapter(new Fe(this._documents,V),k);return this._proxy.$registerDocumentLinkProvider(j,this._transformDocumentSelector(B),typeof V.resolveDocumentLink=="function"),this._createDisposable(j)}$provideDocumentLinks(k,B,V){return this._withAdapter(k,Fe,j=>j.provideLinks(o.URI.revive(B),V),void 0,V,B.scheme==="output")}$resolveDocumentLink(k,B,V){return this._withAdapter(k,Fe,j=>j.resolveLink(B,V),void 0,void 0,!0)}$releaseDocumentLinks(k,B){this._withAdapter(k,Fe,V=>V.releaseLinks(B),void 0,void 0,!0)}registerColorProvider(k,B,V){const j=this._addNewAdapter(new We(this._documents,V),k);return this._proxy.$registerDocumentColorProvider(j,this._transformDocumentSelector(B)),this._createDisposable(j)}$provideDocumentColors(k,B,V){return this._withAdapter(k,We,j=>j.provideColors(o.URI.revive(B),V),[],V)}$provideColorPresentations(k,B,V,j){return this._withAdapter(k,We,ne=>ne.provideColorPresentations(o.URI.revive(B),V,j),void 0,j)}registerFoldingRangeProvider(k,B,V){const j=this._nextHandle(),ne=typeof V.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(j,new ae(new Xe(this._documents,V),k)),this._proxy.$registerFoldingRangeProvider(j,this._transformDocumentSelector(B),ne);let ue=this._createDisposable(j);if(ne!==void 0){const Y=V.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(ne));ue=U.Disposable.from(ue,Y)}return ue}$provideFoldingRanges(k,B,V,j){return this._withAdapter(k,Xe,ne=>ne.provideFoldingRanges(o.URI.revive(B),V,j),void 0,j)}registerSelectionRangeProvider(k,B,V){const j=this._addNewAdapter(new Ie(this._documents,V,this._logService),k);return this._proxy.$registerSelectionRangeProvider(j,this._transformDocumentSelector(B)),this._createDisposable(j)}$provideSelectionRanges(k,B,V,j){return this._withAdapter(k,Ie,ne=>ne.provideSelectionRanges(o.URI.revive(B),V,j),[],j)}registerCallHierarchyProvider(k,B,V){const j=this._addNewAdapter(new Se(this._documents,V),k);return this._proxy.$registerCallHierarchyProvider(j,this._transformDocumentSelector(B)),this._createDisposable(j)}$prepareCallHierarchy(k,B,V,j){return this._withAdapter(k,Se,ne=>Promise.resolve(ne.prepareSession(o.URI.revive(B),V,j)),void 0,j)}$provideCallHierarchyIncomingCalls(k,B,V,j){return this._withAdapter(k,Se,ne=>ne.provideCallsTo(B,V,j),void 0,j)}$provideCallHierarchyOutgoingCalls(k,B,V,j){return this._withAdapter(k,Se,ne=>ne.provideCallsFrom(B,V,j),void 0,j)}$releaseCallHierarchy(k,B){this._withAdapter(k,Se,V=>Promise.resolve(V.releaseSession(B)),void 0,void 0)}registerTypeHierarchyProvider(k,B,V){const j=this._addNewAdapter(new Te(this._documents,V),k);return this._proxy.$registerTypeHierarchyProvider(j,this._transformDocumentSelector(B)),this._createDisposable(j)}$prepareTypeHierarchy(k,B,V,j){return this._withAdapter(k,Te,ne=>Promise.resolve(ne.prepareSession(o.URI.revive(B),V,j)),void 0,j)}$provideTypeHierarchySupertypes(k,B,V,j){return this._withAdapter(k,Te,ne=>ne.provideSupertypes(B,V,j),void 0,j)}$provideTypeHierarchySubtypes(k,B,V,j){return this._withAdapter(k,Te,ne=>ne.provideSubtypes(B,V,j),void 0,j)}$releaseTypeHierarchy(k,B){this._withAdapter(k,Te,V=>Promise.resolve(V.releaseSession(B)),void 0,void 0)}registerDocumentOnDropEditProvider(k,B,V){const j=this._nextHandle();return this._adapter.set(j,new ae(new se(this._proxy,this._documents,V,j),k)),this._proxy.$registerDocumentOnDropEditProvider(j,this._transformDocumentSelector(B)),this._createDisposable(j)}$provideDocumentOnDropEdits(k,B,V,j,ne,ue){return this._withAdapter(k,se,Y=>Promise.resolve(Y.provideDocumentOnDropEdits(B,o.URI.revive(V),j,ne,ue)),void 0,void 0)}registerDocumentPasteEditProvider(k,B,V,j){const ne=this._nextHandle();return this._adapter.set(ne,new ae(new F(this._proxy,this._documents,V,ne),k)),this._proxy.$registerPasteEditProvider(ne,this._transformDocumentSelector(B),!!V.prepareDocumentPaste,j.pasteMimeTypes),this._createDisposable(ne)}$prepareDocumentPaste(k,B,V,j,ne){return this._withAdapter(k,F,ue=>ue.prepareDocumentPaste(o.URI.revive(B),V,j,ne),void 0,ne)}$providePasteEdits(k,B,V,j,ne){return this._withAdapter(k,F,ue=>ue.providePasteEdits(0,o.URI.revive(B),V,j,ne),void 0,ne)}static _serializeRegExp(k){return{pattern:k.source,flags:(0,b.regExpFlags)(k)}}static _serializeIndentationRule(k){return{decreaseIndentPattern:G._serializeRegExp(k.decreaseIndentPattern),increaseIndentPattern:G._serializeRegExp(k.increaseIndentPattern),indentNextLinePattern:k.indentNextLinePattern?G._serializeRegExp(k.indentNextLinePattern):void 0,unIndentedLinePattern:k.unIndentedLinePattern?G._serializeRegExp(k.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(k){return{beforeText:G._serializeRegExp(k.beforeText),afterText:k.afterText?G._serializeRegExp(k.afterText):void 0,previousLineText:k.previousLineText?G._serializeRegExp(k.previousLineText):void 0,action:k.action}}static _serializeOnEnterRules(k){return k.map(G._serializeOnEnterRule)}setLanguageConfiguration(k,B,V){const{wordPattern:j}=V;if(j&&(0,b.regExpLeadsToEndlessLoop)(j))throw new Error(`Invalid language configuration: wordPattern '${j}' is not allowed to match the empty string.`);j?this._documents.setWordDefinitionFor(B,j):this._documents.setWordDefinitionFor(B,void 0),V.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",k,"Do not use."),V.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",k,"Do not use.");const ne=this._nextHandle(),ue={comments:V.comments,brackets:V.brackets,wordPattern:V.wordPattern?G._serializeRegExp(V.wordPattern):void 0,indentationRules:V.indentationRules?G._serializeIndentationRule(V.indentationRules):void 0,onEnterRules:V.onEnterRules?G._serializeOnEnterRules(V.onEnterRules):void 0,__electricCharacterSupport:V.__electricCharacterSupport,__characterPairSupport:V.__characterPairSupport};return this._proxy.$setLanguageConfiguration(ne,B,ue),this._createDisposable(ne)}$setWordDefinitions(k){for(const B of k)this._documents.setWordDefinitionFor(B.languageId,new RegExp(B.regexSource,B.regexFlags))}}e.ExtHostLanguageFeatures=G,G._handlePool=0}),define(De[203],Ce([1,0,5,8,6,29,13,7]),function(J,e,o,C,p,U,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class b{constructor(R,_,m,T){this._documents=_,this._commands=m,this._uriTransformer=T,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=R.getProxy(o.MainContext.MainThreadLanguages)}$acceptLanguageIds(R){this._languageIds=R}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(R,_){await this._proxy.$changeLanguage(R,_);const m=this._documents.getDocumentData(R);if(!m)throw new Error(`document '${R.toString()}' NOT found`);return m.document}async tokenAtPosition(R,_){const m=R.version,T=C.Position.from(_),g=await this._proxy.$tokensAtPosition(R.uri,T),h={type:p.StandardTokenType.Other,range:R.getWordRangeAtPosition(_)??new p.Range(_.line,_.character,_.line,_.character)};if(!g)return h;const u={range:C.Range.to(g.range),type:C.TokenType.to(g.type)};return!u.range.contains(_)||m!==R.version?h:u}createLanguageStatusItem(R,_,m){const T=this._handlePool++,g=this._proxy,h=this._ids,u=`${R.identifier.value}/${_}`;if(h.has(u))throw new Error(`LanguageStatusItem with id '${_}' ALREADY exists`);h.add(u);const l={selector:m,id:_,name:R.displayName??R.name,severity:p.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let S;const w=new P.DisposableStore,a=()=>{S?.dispose(),S=(0,I.disposableTimeout)(()=>{w.clear(),this._proxy.$setLanguageStatus(T,{id:u,name:l.name??R.displayName??R.name,source:R.displayName??R.name,selector:C.DocumentSelector.from(l.selector,this._uriTransformer),label:l.text,detail:l.detail??"",severity:l.severity===p.LanguageStatusSeverity.Error?U.default.Error:l.severity===p.LanguageStatusSeverity.Warning?U.default.Warning:U.default.Info,command:l.command&&this._commands.toInternal(l.command,w),accessibilityInfo:l.accessibilityInformation,busy:l.busy})},0)},y={dispose(){w.dispose(),S?.dispose(),g.$removeLanguageStatus(T),h.delete(u)},get id(){return l.id},get name(){return l.name},set name(r){l.name=r,a()},get selector(){return l.selector},set selector(r){l.selector=r,a()},get text(){return l.text},set text(r){l.text=r,a()},get detail(){return l.detail},set detail(r){l.detail=r,a()},get severity(){return l.severity},set severity(r){l.severity=r,a()},get accessibilityInformation(){return l.accessibilityInformation},set accessibilityInformation(r){l.accessibilityInformation=r,a()},get command(){return l.command},set command(r){l.command=r,a()},get busy(){return l.busy},set busy(r){l.busy=r,a()}};return a(),y}}e.ExtHostLanguages=b}),define(De[204],Ce([1,0,14,5,28,15,4]),function(J,e,o,C,p,U,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let P=class extends o.AbstractLoggerService{constructor(R,_){const m=new I.Emitter;super(_.logLevel,m.event);this._proxy=R.getProxy(C.MainContext.MainThreadLogger),this._onDidChangeLogLevel=this._register(m)}$setLevel(R){this._onDidChangeLogLevel.fire(R)}doCreateLogger(R,_,m){return new b(this._proxy,R,_,m)}};P=$e([xe(0,U.IExtHostRpcService),xe(1,p.IExtHostInitDataService)],P),e.ExtHostLoggerService=P;class b extends o.AbstractMessageLogger{constructor(R,_,m,T){super(T?.always);this.proxy=R,this.file=_,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(m),this.proxy.$createLogger(_,T).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(R,_){const m=[[R,_]];this.isLoggerCreated?this.doLog(m):this.buffer.push(...m)}doLog(R){this.proxy.$log(this.file,R)}}}),define(De[205],Ce([1,0,5,14,25]),function(J,e,o,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function U(P){return P&&P.title}let I=class{constructor(b,A){this._logService=A,this._proxy=b.getProxy(o.MainContext.MainThreadMessageService)}showMessage(b,A,R,_,m){const T={source:{identifier:b.identifier,label:b.displayName||b.name}};let g;typeof _=="string"||U(_)?g=[_,...m]:(T.modal=_?.modal,T.useCustom=_?.useCustom,T.detail=_?.detail,g=m),T.useCustom&&(0,p.checkProposedApiEnabled)(b,"resolvers");const h=[];for(let u=0;u<g.length;u++){const l=g[u];if(typeof l=="string")h.push({title:l,handle:u,isCloseAffordance:!1});else if(typeof l=="object"){const{title:S,isCloseAffordance:w}=l;h.push({title:S,isCloseAffordance:!!w,handle:u})}else this._logService.warn("Invalid message item:",l)}return this._proxy.$showMessage(A,R,T,h).then(u=>{if(typeof u=="number")return g[u]})}};I=$e([xe(1,C.ILogService)],I),e.ExtHostMessageService=I}),define(De[206],Ce([1,0,23,4,96,7,24,10,9,2,61,5,36,8,6,40,174,91]),function(J,e,o,C,p,U,I,P,b,A,R,_,m,T,g,h,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class S{constructor(a,y,r,d,i){this._textDocumentsAndEditors=r,this._textDocuments=d,this._extensionStoragePaths=i,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new I.ResourceMap,this._editors=new Map,this._onDidChangeActiveNotebookEditor=new C.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new C.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new C.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new C.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new R.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=a.getProxy(_.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=a.getProxy(_.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=a.getProxy(_.MainContext.MainThreadNotebookEditors),this._commandsConverter=y.converter,y.registerArgumentProcessor({processArgument:s=>{if(s&&s.$mid===12){const n=s.notebookEditor?.notebookUri,t=s.cell.handle,E=this._documents.get(n)?.getCell(t);if(E)return E.apiCell}return s}}),S._registerApiCommands(y)}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(a=>a.apiEditor)}getEditorById(a){const y=this._editors.get(a);if(!y)throw new Error(`unknown text editor: ${a}. known editors: ${[...this._editors.keys()]} `);return y}getIdByEditor(a){for(const[y,r]of this._editors)if(r.apiEditor===a)return y}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(a,y){const r=this._documents.get(a);if(!r&&!y)throw new Error(`NO notebook document for '${a}'`);return r}_getProviderData(a){const y=this._notebookContentProviders.get(a);if(!y)throw new Error(`NO provider for '${a}'`);return y}registerNotebookContentProvider(a,y,r,d,i){if((0,P.isFalsyOrWhitespace)(y))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(y))throw new Error(`Notebook provider for '${y}' already registered`);this._notebookContentProviders.set(y,{extension:a,provider:r});let s;return r.onDidChangeNotebookContentOptions&&(s=r.onDidChangeNotebookContentOptions(()=>{const n=T.NotebookDocumentContentOptions.from(r.options);this._notebookProxy.$updateNotebookProviderOptions(y,n)})),this._notebookProxy.$registerNotebookProvider({id:a.identifier,location:a.extensionLocation},y,T.NotebookDocumentContentOptions.from(d),S._convertNotebookRegistrationData(a,i)),new g.Disposable(()=>{s?.dispose(),this._notebookContentProviders.delete(y),this._notebookProxy.$unregisterNotebookProvider(y)})}static _convertNotebookRegistrationData(a,y){if(!y)return;const r=y.filenamePattern.map(d=>T.NotebookExclusiveDocumentPattern.from(d)).filter(d=>d!==void 0);if(y.filenamePattern&&!r){console.warn(`Notebook content provider view options file name pattern is invalid ${y.filenamePattern}`);return}return{extension:a.identifier,providerDisplayName:a.displayName||a.name,displayName:y.displayName,filenamePattern:r,exclusive:y.exclusive||!1}}registerNotebookCellStatusBarItemProvider(a,y,r){const d=S._notebookStatusBarItemProviderHandlePool++,i=typeof r.onDidChangeCellStatusBarItems=="function"?S._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(d,r),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(d,i,y);let s;return i!==void 0&&(s=r.onDidChangeCellStatusBarItems(n=>this._notebookProxy.$emitCellStatusBarEvent(i))),new g.Disposable(()=>{this._notebookStatusBarItemProviders.delete(d),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(d,i),s&&s.dispose()})}async createNotebookDocument(a){const y=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:a.viewType,content:a.content&&T.NotebookData.from(a.content)});return A.URI.revive(y)}async openNotebookDocument(a){const y=this._documents.get(a);if(y)return y.apiNotebook;const r=await this._notebookDocumentsProxy.$tryOpenNotebook(a),d=this._documents.get(A.URI.revive(r));return(0,b.assertIsDefined)(d?.apiNotebook)}async showNotebookDocument(a,y){A.URI.isUri(a)&&(a=await this.openNotebookDocument(a));let r;typeof y=="object"?r={position:T.ViewColumn.from(y.viewColumn),preserveFocus:y.preserveFocus,selections:y.selections&&y.selections.map(T.NotebookRange.from),pinned:typeof y.preview=="boolean"?!y.preview:void 0}:r={preserveFocus:!1};const d=await this._notebookEditorsProxy.$tryShowNotebookDocument(a.uri,a.notebookType,r),i=d&&this._editors.get(d)?.apiEditor;if(i)return i;throw d?new Error(`Could NOT open editor for "${a.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${a.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(a,y,r,d){const i=this._notebookStatusBarItemProviders.get(a),s=A.URI.revive(y),n=this._documents.get(s);if(!n||!i)return;const t=n.getCellFromIndex(r);if(!t)return;const c=await i.provideCellStatusBarItems(t.apiCell,d);if(!c)return;const E=new U.DisposableStore,f=this._statusBarCache.add([E]),L=(Array.isArray(c)?c:[c]).map(W=>T.NotebookStatusBarItem.from(W,this._commandsConverter,E));return{cacheId:f,items:L}}$releaseNotebookCellStatusBarItems(a){this._statusBarCache.delete(a)}registerNotebookSerializer(a,y,r,d,i){if((0,P.isFalsyOrWhitespace)(y))throw new Error("viewType cannot be empty or just whitespace");const s=this._handlePool++;return this._notebookSerializer.set(s,r),this._notebookProxy.$registerNotebookSerializer(s,{id:a.identifier,location:a.extensionLocation},y,T.NotebookDocumentContentOptions.from(d),S._convertNotebookRegistrationData(a,i)),(0,U.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(s)})}async $dataToNotebook(a,y,r){const d=this._notebookSerializer.get(a);if(!d)throw new Error("NO serializer found");const i=await d.deserializeNotebook(y.buffer,r);return new h.SerializableObjectWithBuffers(T.NotebookData.from(i))}async $notebookToData(a,y,r){const d=this._notebookSerializer.get(a);if(!d)throw new Error("NO serializer found");const i=await d.serializeNotebook(T.NotebookData.to(y.value),r);return o.VSBuffer.wrap(i)}async $openNotebook(a,y,r,d,i){const{provider:s}=this._getProviderData(a),n=await s.openNotebook(A.URI.revive(y),{backupId:r,untitledDocumentData:d?.buffer},i);return new h.SerializableObjectWithBuffers({metadata:n.metadata??Object.create(null),cells:n.cells.map(T.NotebookCellData.from)})}async $saveNotebook(a,y,r){const d=this.getNotebookDocument(A.URI.revive(y)),{provider:i}=this._getProviderData(a);return await i.saveNotebook(d.apiNotebook,r),!0}async $saveNotebookAs(a,y,r,d){const i=this.getNotebookDocument(A.URI.revive(y)),{provider:s}=this._getProviderData(a);return await s.saveNotebookAs(A.URI.revive(r),i.apiNotebook,d),!0}async $backupNotebook(a,y,r){const d=this.getNotebookDocument(A.URI.revive(y)),i=this._getProviderData(a),s=this._extensionStoragePaths.workspaceValue(i.extension)??this._extensionStoragePaths.globalValue(i.extension),n=String((0,p.hash)([d.uri.toString(),this._backupIdPool++])),t=A.URI.joinPath(s,n),c=await i.provider.backupNotebook(d.apiNotebook,{destination:t},r);return d.updateBackup(c),c.id}_createExtHostEditor(a,y,r){if(this._editors.has(y))throw new Error(`editor with id ALREADY EXSIST: ${y}`);const d=new l.ExtHostNotebookEditor(y,this._notebookEditorsProxy,a,r.visibleRanges.map(T.NotebookRange.to),r.selections.map(T.NotebookRange.to),typeof r.viewColumn=="number"?T.ViewColumn.to(r.viewColumn):void 0);this._editors.set(y,d)}$acceptDocumentAndEditorsDelta(a){if(a.value.removedDocuments)for(const r of a.value.removedDocuments){const d=A.URI.revive(r),i=this._documents.get(d);i&&(i.dispose(),this._documents.delete(d),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:i.apiNotebook.getCells().map(s=>s.document.uri)}),this._onDidCloseNotebookDocument.fire(i.apiNotebook));for(const s of this._editors.values())s.notebookData.uri.toString()===d.toString()&&this._editors.delete(s.id)}if(a.value.addedDocuments){const r=[];for(const d of a.value.addedDocuments){const i=A.URI.revive(d.uri);if(this._documents.has(i))throw new Error(`adding EXISTING notebook ${i} `);const s=new u.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,i,d);r.push(...d.cells.map(n=>u.ExtHostCell.asModelAddData(s.apiNotebook,n))),this._documents.get(i)?.dispose(),this._documents.set(i,s),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:r}),this._onDidOpenNotebookDocument.fire(s.apiNotebook)}}if(a.value.addedEditors)for(const r of a.value.addedEditors){if(this._editors.has(r.id))return;const d=A.URI.revive(r.documentUri),i=this._documents.get(d);i&&this._createExtHostEditor(i,r.id,r)}const y=[];if(a.value.removedEditors)for(const r of a.value.removedEditors){const d=this._editors.get(r);d&&(this._editors.delete(r),this._activeNotebookEditor?.id===d.id&&(this._activeNotebookEditor=void 0),y.push(d))}if(a.value.visibleEditors){this._visibleNotebookEditors=a.value.visibleEditors.map(d=>this._editors.get(d)).filter(d=>!!d);const r=new Set;this._visibleNotebookEditors.forEach(d=>r.add(d.id));for(const d of this._editors.values()){const i=r.has(d.id);d._acceptVisibility(i)}this._visibleNotebookEditors=[...this._editors.values()].map(d=>d).filter(d=>d.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}a.value.newActiveEditor===null?this._activeNotebookEditor=void 0:a.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(a.value.newActiveEditor)),a.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}static _registerApiCommands(a){const y=m.ApiCommandArgument.String.with("notebookType","A notebook type"),r=new m.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[y,new m.ApiCommandArgument("data","Bytes to convert to data",i=>i instanceof Uint8Array,i=>o.VSBuffer.wrap(i))],new m.ApiCommandResult("Notebook Data",i=>T.NotebookData.to(i.value))),d=new m.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[y,new m.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",i=>!0,i=>new h.SerializableObjectWithBuffers(T.NotebookData.from(i)))],new m.ApiCommandResult("Bytes",i=>i.buffer));a.registerApiCommand(r),a.registerApiCommand(d)}}e.ExtHostNotebookController=S,S._notebookStatusBarItemProviderHandlePool=0}),define(De[207],Ce([1,0,16,13,20,4,7,24,2,27,14,5,36,8,6,64,168,25,40]),function(J,e,o,C,p,U,I,P,b,A,R,_,m,T,g,h,u,l,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let w=class{constructor(s,n,t,c,E){this._initData=n,this._extHostNotebook=t,this._commands=c,this._logService=E,this._activeExecutions=new P.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._onDidChangeCellExecutionState=new U.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._proxy=s.getProxy(_.MainContext.MainThreadNotebookKernels);const f=new m.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new m.ApiCommandArgument("options","Select kernel options",D=>!0,D=>{if(D&&"notebookEditor"in D&&"id"in D){const L=this._extHostNotebook.getIdByEditor(D.notebookEditor);return{id:D.id,extension:D.extension,notebookEditorId:L}}else if(D&&"notebookEditor"in D){const L=this._extHostNotebook.getIdByEditor(D.notebookEditor);if(L===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${D.notebookEditor.document.uri.toString()}`);return{notebookEditorId:L}}return D})],m.ApiCommandResult.Void);this._commands.registerApiCommand(f)}createNotebookController(s,n,t,c,E,f){for(const pe of this._kernelData.values())if(pe.controller.id===n&&A.ExtensionIdentifier.equals(s.identifier,pe.extensionId))throw new Error(`notebook controller with id '${n}' ALREADY exist`);const D=this._handlePool++,L=this;this._logService.trace(`NotebookController[${D}], CREATED by ${s.identifier.value}, ${n}`);const W=()=>console.warn(`NO execute handler from notebook controller '${H.id}' of extension: '${s.identifier}'`);let N=!1;const v=new I.DisposableStore,F=new U.Emitter,O=new U.Emitter,H={id:d(s.identifier,n),notebookType:t,extensionId:s.identifier,extensionLocation:s.extensionLocation,label:c||s.identifier.value,preloads:f?f.map(T.NotebookRendererScript.from):[]};let te=E??W,z;this._proxy.$addKernel(D,H).catch(pe=>{console.log(pe),N=!0});let $=0;const ce=()=>{if(N)return;const pe=++$;Promise.resolve().then(()=>{pe===$&&this._proxy.$updateKernel(D,H)})},le=new P.ResourceMap,oe={get id(){return n},get notebookType(){return H.notebookType},onDidChangeSelectedNotebooks:F.event,get label(){return H.label},set label(pe){H.label=pe??s.displayName??s.name,ce()},get detail(){return H.detail??""},set detail(pe){H.detail=pe,ce()},get description(){return H.description??""},set description(pe){H.description=pe,ce()},get kind(){return(0,l.checkProposedApiEnabled)(s,"notebookControllerKind"),H.kind??""},set kind(pe){(0,l.checkProposedApiEnabled)(s,"notebookControllerKind"),H.kind=pe,ce()},get supportedLanguages(){return H.supportedLanguages},set supportedLanguages(pe){H.supportedLanguages=pe,ce()},get supportsExecutionOrder(){return H.supportsExecutionOrder??!1},set supportsExecutionOrder(pe){H.supportsExecutionOrder=pe,ce()},get rendererScripts(){return H.preloads?H.preloads.map(T.NotebookRendererScript.to):[]},get executeHandler(){return te},set executeHandler(pe){te=pe??W},get interruptHandler(){return z},set interruptHandler(pe){z=pe,H.supportsInterrupt=Boolean(pe),ce()},createNotebookCellExecution(pe){if(N)throw new Error("notebook controller is DISPOSED");if(!le.has(pe.notebook.uri))throw L._logService.trace(`NotebookController[${D}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(le.keys()).map(re=>re.toString())),new Error(`notebook controller is NOT associated to notebook: ${pe.notebook.uri.toString()}`);return L._createNotebookCellExecution(pe,d(s.identifier,this.id))},dispose:()=>{N||(this._logService.trace(`NotebookController[${D}], DISPOSED`),N=!0,this._kernelData.delete(D),v.dispose(),F.dispose(),O.dispose(),this._proxy.$removeKernel(D))},updateNotebookAffinity(pe,re){L._proxy.$updateNotebookPriority(D,pe.uri,re)},onDidReceiveMessage:O.event,postMessage(pe,re){return(0,l.checkProposedApiEnabled)(s,"notebookMessaging"),L._proxy.$postMessage(D,re&&L._extHostNotebook.getIdByEditor(re),pe)},asWebviewUri(pe){return(0,l.checkProposedApiEnabled)(s,"notebookMessaging"),(0,h.asWebviewUri)(pe,L._initData.remote)}};return this._kernelData.set(D,{extensionId:s.identifier,controller:oe,onDidReceiveMessage:O,onDidChangeSelection:F,associatedNotebooks:le}),oe}getIdByController(s){for(const[n,t]of this._kernelData)if(t.controller===s)return d(t.extensionId,s.id);return null}$acceptNotebookAssociation(s,n,t){const c=this._kernelData.get(s);if(c){const E=this._extHostNotebook.getNotebookDocument(b.URI.revive(n));t?c.associatedNotebooks.set(E.uri,!0):c.associatedNotebooks.delete(E.uri),this._logService.trace(`NotebookController[${s}] ASSOCIATE notebook`,E.uri.toString(),t),c.onDidChangeSelection.fire({selected:t,notebook:E.apiNotebook})}}async $executeCells(s,n,t){const c=this._kernelData.get(s);if(!c)return;const E=this._extHostNotebook.getNotebookDocument(b.URI.revive(n)),f=[];for(const D of t){const L=E.getCell(D);L&&f.push(L.apiCell)}try{this._logService.trace(`NotebookController[${s}] EXECUTE cells`,E.uri.toString(),f.length),await c.controller.executeHandler.call(c.controller,f,E.apiNotebook,c.controller)}catch(D){this._logService.error(`NotebookController[${s}] execute cells FAILED`,D),console.error(D)}}async $cancelCells(s,n,t){const c=this._kernelData.get(s);if(!c)return;const E=this._extHostNotebook.getNotebookDocument(b.URI.revive(n));if(c.controller.interruptHandler)await c.controller.interruptHandler.call(c.controller,E.apiNotebook);else for(const f of t){const D=E.getCell(f);D&&this._activeExecutions.get(D.uri)?.cancel()}}$acceptKernelMessageFromRenderer(s,n,t){const c=this._kernelData.get(s);if(!c)return;const E=this._extHostNotebook.getEditorById(n);c.onDidReceiveMessage.fire(Object.freeze({editor:E.apiEditor,message:t}))}$cellExecutionChanged(s,n,t){const E=this._extHostNotebook.getNotebookDocument(b.URI.revive(s)).getCell(n);E&&this._onDidChangeCellExecutionState.fire({cell:E.apiCell,state:t?T.NotebookCellExecutionState.to(t):g.NotebookCellExecutionState.Idle})}_createNotebookCellExecution(s,n){if(s.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const c=this._extHostNotebook.getNotebookDocument(s.notebook.uri).getCellFromApiCell(s);if(!c)throw new Error("invalid cell");if(this._activeExecutions.has(c.uri))throw new Error(`duplicate execution for ${c.uri}`);const E=new y(n,c,this._proxy);this._activeExecutions.set(c.uri,E);const f=E.onDidChangeState(()=>{E.state===a.Resolved&&(E.dispose(),f.dispose(),this._activeExecutions.delete(c.uri))});return E.asApiObject()}};w=$e([xe(4,R.ILogService)],w),e.ExtHostNotebookKernels=w;var a;(function(i){i[i.Init=0]="Init",i[i.Started=1]="Started",i[i.Resolved=2]="Resolved"})(a||(a={}));class y extends I.Disposable{constructor(s,n,t){super();this._cell=n,this._proxy=t,this._handle=y.HANDLE++,this._onDidChangeState=new U.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=a.Init,this._tokenSource=this._register(new p.CancellationTokenSource),this._collector=new r(10,c=>this.update(c)),this._executionOrder=n.internalMetadata.executionOrder,this._proxy.$createExecution(this._handle,s,this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(s){await this._collector.addItem(s)}async update(s){const n=Array.isArray(s)?s:[s];return this._proxy.$updateExecution(this._handle,new S.SerializableObjectWithBuffers(n))}verifyStateForOutput(){if(this._state===a.Init)throw new Error("Must call start before modifying cell output");if(this._state===a.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(s){let n=this._cell;if(s&&(n=this._cell.notebook.getCellFromApiCell(s)),!n)throw new Error("INVALID cell");return n.handle}validateAndConvertOutputs(s){return s.map(n=>{const t=g.NotebookCellOutput.ensureUniqueMimeTypes(n.items,!0);return t===n.items?T.NotebookCellOutput.from(n):T.NotebookCellOutput.from({items:t,id:n.id,metadata:n.metadata})})}async updateOutputs(s,n,t){const c=this.cellIndexToHandle(n),E=this.validateAndConvertOutputs((0,o.asArray)(s));return this.updateSoon({editType:u.CellExecutionUpdateType.Output,cellHandle:c,append:t,outputs:E})}async updateOutputItems(s,n,t){return s=g.NotebookCellOutput.ensureUniqueMimeTypes((0,o.asArray)(s),!0),this.updateSoon({editType:u.CellExecutionUpdateType.OutputItems,items:s.map(T.NotebookCellOutputItem.from),outputId:n.id,append:t})}asApiObject(){const s=this;return Object.freeze({get token(){return s._tokenSource.token},get cell(){return s._cell.apiCell},get executionOrder(){return s._executionOrder},set executionOrder(t){s._executionOrder=t,s.update([{editType:u.CellExecutionUpdateType.ExecutionState,executionOrder:s._executionOrder}])},start(t){if(s._state===a.Resolved||s._state===a.Started)throw new Error("Cannot call start again");s._state=a.Started,s._onDidChangeState.fire(),s.update({editType:u.CellExecutionUpdateType.ExecutionState,runStartTime:t})},end(t,c){if(s._state===a.Resolved)throw new Error("Cannot call resolve twice");s._state=a.Resolved,s._onDidChangeState.fire(),s._collector.flush(),s._proxy.$completeExecution(s._handle,new S.SerializableObjectWithBuffers({runEndTime:c,lastRunSuccess:t}))},clearOutput(t){return s.verifyStateForOutput(),s.updateOutputs([],t,!1)},appendOutput(t,c){return s.verifyStateForOutput(),s.updateOutputs(t,c,!0)},replaceOutput(t,c){return s.verifyStateForOutput(),s.updateOutputs(t,c,!1)},appendOutputItems(t,c){return s.verifyStateForOutput(),s.updateOutputItems(t,c,!0)},replaceOutputItems(t,c){return s.verifyStateForOutput(),s.updateOutputItems(t,c,!1)}})}}y.HANDLE=0;class r{constructor(s,n){this.delay=s,this.callback=n,this.batch=[],this.startedTimer=Date.now()}addItem(s){return this.batch.push(s),this.currentDeferred||(this.currentDeferred=new C.DeferredPromise,this.startedTimer=Date.now(),(0,C.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const s=this.currentDeferred;this.currentDeferred=void 0;const n=this.batch;return this.batch=[],this.callback(n).finally(()=>s.complete())}}function d(i,s){return`${i.value}/${s}`}e.createKernelId=d}),define(De[208],Ce([1,0,4,5,91]),function(J,e,o,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class U{constructor(P,b){this._extHostNotebook=b,this._rendererMessageEmitters=new Map,this.proxy=P.getProxy(C.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(P,b,A){const R=this._extHostNotebook.getEditorById(P);this._rendererMessageEmitters.get(b)?.fire({editor:R.apiEditor,message:A})}createRendererMessaging(P,b){if(!P.contributes?.notebookRenderer?.some(R=>R.id===b))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${b})`);return{onDidReceiveMessage:(R,_,m)=>this.getOrCreateEmitterFor(b).event(R,_,m),postMessage:(R,_)=>{p.ExtHostNotebookEditor.apiEditorsToExtHost.has(R)&&([R,_]=[_,R]);const m=_&&p.ExtHostNotebookEditor.apiEditorsToExtHost.get(_);return this.proxy.$postMessage(m?.id,b,R)}}}getOrCreateEmitterFor(P){let b=this._rendererMessageEmitters.get(P);return b||(b=new o.Emitter({onLastListenerRemove:()=>{b?.dispose(),this._rendererMessageEmitters.delete(P)}}),this._rendererMessageEmitters.set(P,b),b)}}e.ExtHostNotebookRenderers=U}),define(De[209],Ce([1,0,20,4,7,5,2,6,11,16,29,60]),function(J,e,o,C,p,U,I,P,b,A,R,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function m(T,g,h){const u=T.getProxy(U.MainContext.MainThreadQuickOpen);class l{constructor(n,t){this._sessions=new Map,this._instances=0,this._workspace=n,this._commands=t}showQuickPick(n,t,c=o.CancellationToken.None){this._onDidSelectItem=void 0;const E=Promise.resolve(n),f=++this._instances,D=u.$show(f,{title:t?.title,placeHolder:t?.placeHolder,matchOnDescription:t?.matchOnDescription,matchOnDetail:t?.matchOnDetail,ignoreFocusLost:t?.ignoreFocusOut,canPickMany:t?.canPickMany},c),L={},W=D.then(()=>L);return Promise.race([W,E]).then(N=>{if(N!==L)return E.then(v=>{const F=[];for(let O=0;O<v.length;O++){const H=v[O];typeof H=="string"?F.push({label:H,handle:O}):H.kind===P.QuickPickItemKind.Separator?F.push({type:"separator",label:H.label}):F.push({label:H.label,description:H.description,detail:H.detail,picked:H.picked,alwaysShow:H.alwaysShow,handle:O})}return t&&typeof t.onDidSelectItem=="function"&&(this._onDidSelectItem=O=>{t.onDidSelectItem(v[O])}),u.$setItems(f,F),D.then(O=>{if(typeof O=="number")return v[O];if(Array.isArray(O))return O.map(H=>v[H])})})}).then(void 0,N=>{if(!(0,b.isCancellationError)(N))return u.$setError(f,N),Promise.reject(N)})}$onItemSelected(n){this._onDidSelectItem?.(n)}showInput(n,t=o.CancellationToken.None){return this._validateInput=n?.validateInput,u.$input(n,typeof this._validateInput=="function",t).then(void 0,c=>{if(!(0,b.isCancellationError)(c))return Promise.reject(c)})}async $validateInput(n){if(!this._validateInput)return;const t=await this._validateInput(n);if(!t||typeof t=="string")return t;let c;switch(t.severity){case P.InputBoxValidationSeverity.Info:c=R.default.Info;break;case P.InputBoxValidationSeverity.Warning:c=R.default.Warning;break;case P.InputBoxValidationSeverity.Error:c=R.default.Error;break;default:c=t.message?R.default.Error:R.default.Ignore;break}return{content:t.message,severity:c}}async showWorkspaceFolderPick(n,t=o.CancellationToken.None){const c=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[n]);if(!c)return;const E=await this._workspace.getWorkspaceFolders2();if(!!E)return E.find(f=>f.uri.toString()===c.uri.toString())}createQuickPick(n){const t=new d(n,()=>this._sessions.delete(t._id));return this._sessions.set(t._id,t),t}createInputBox(n){const t=new i(n,()=>this._sessions.delete(t._id));return this._sessions.set(t._id,t),t}$onDidChangeValue(n,t){this._sessions.get(n)?._fireDidChangeValue(t)}$onDidAccept(n){const t=this._sessions.get(n);t&&t._fireDidAccept()}$onDidChangeActive(n,t){const c=this._sessions.get(n);c instanceof d&&c._fireDidChangeActive(t)}$onDidChangeSelection(n,t){const c=this._sessions.get(n);c instanceof d&&c._fireDidChangeSelection(t)}$onDidTriggerButton(n,t){this._sessions.get(n)?._fireDidTriggerButton(t)}$onDidTriggerItemButton(n,t,c){const E=this._sessions.get(n);E instanceof d&&E._fireDidTriggerItemButton(t,c)}$onDidHide(n){const t=this._sessions.get(n);t&&t._fireDidHide()}}class S{constructor(n,t){this._extensionId=n,this._onDidDispose=t,this._id=d._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new C.Emitter,this._onDidChangeValueEmitter=new C.Emitter,this._onDidTriggerButtonEmitter=new C.Emitter,this._onDidHideEmitter=new C.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(n){this._title=n,this.update({title:n})}get step(){return this._steps}set step(n){this._steps=n,this.update({step:n})}get totalSteps(){return this._totalSteps}set totalSteps(n){this._totalSteps=n,this.update({totalSteps:n})}get enabled(){return this._enabled}set enabled(n){this._enabled=n,this.update({enabled:n})}get busy(){return this._busy}set busy(n){this._busy=n,this.update({busy:n})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(n){this._ignoreFocusOut=n,this.update({ignoreFocusOut:n})}get value(){return this._value}set value(n){this._value=n,this.update({value:n})}get placeholder(){return this._placeholder}set placeholder(n){this._placeholder=n,this.update({placeholder:n})}get buttons(){return this._buttons}set buttons(n){this._buttons=n.slice(),this._handlesToButtons.clear(),n.forEach((t,c)=>{const E=t===P.QuickInputButtons.Back?-1:c;this._handlesToButtons.set(E,t)}),this.update({buttons:n.map((t,c)=>({...r(t),tooltip:t.tooltip,handle:t===P.QuickInputButtons.Back?-1:c}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(n){this._value=n,this._onDidChangeValueEmitter.fire(n)}_fireDidTriggerButton(n){const t=this._handlesToButtons.get(n);t&&this._onDidTriggerButtonEmitter.fire(t)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,p.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),u.$dispose(this._id))}update(n){if(!this._disposed){for(const t of Object.keys(n)){const c=n[t];this._pendingUpdate[t]=c===void 0?null:c}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){u.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}S._nextId=1;function w(s){if(s instanceof P.ThemeIcon)return{id:s.id};const n=y(s),t=a(s);return{dark:typeof n=="string"?I.URI.file(n):n,light:typeof t=="string"?I.URI.file(t):t}}function a(s){return typeof s=="object"&&"light"in s?s.light:s}function y(s){return typeof s=="object"&&"dark"in s?s.dark:s}function r(s){const n=w(s.iconPath);let t,c;return"id"in n?c=_.ThemeIcon.asClassName(n):t=n,{iconPath:t,iconClass:c}}class d extends S{constructor(n,t){super(n.identifier,t);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new C.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new C.Emitter,this._onDidTriggerItemButtonEmitter=new C.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(n){this._items=n.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),n.forEach((c,E)=>{this._handlesToItems.set(E,c),this._itemsToHandles.set(c,E)});const t=[];for(let c=0;c<n.length;c++){const E=n[c];E.kind===P.QuickPickItemKind.Separator?t.push({type:"separator",label:E.label}):t.push({handle:c,label:E.label,description:E.description,detail:E.detail,picked:E.picked,alwaysShow:E.alwaysShow,buttons:E.buttons?.map((f,D)=>({...r(f),tooltip:f.tooltip,handle:D}))})}this.update({items:t})}get canSelectMany(){return this._canSelectMany}set canSelectMany(n){this._canSelectMany=n,this.update({canSelectMany:n})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(n){this._matchOnDescription=n,this.update({matchOnDescription:n})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(n){this._matchOnDetail=n,this.update({matchOnDetail:n})}get sortByLabel(){return this._sortByLabel}set sortByLabel(n){this._sortByLabel=n,this.update({sortByLabel:n})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(n){this._keepScrollPosition=n,this.update({keepScrollPosition:n})}get activeItems(){return this._activeItems}set activeItems(n){this._activeItems=n.filter(t=>this._itemsToHandles.has(t)),this.update({activeItems:this._activeItems.map(t=>this._itemsToHandles.get(t))})}get selectedItems(){return this._selectedItems}set selectedItems(n){this._selectedItems=n.filter(t=>this._itemsToHandles.has(t)),this.update({selectedItems:this._selectedItems.map(t=>this._itemsToHandles.get(t))})}_fireDidChangeActive(n){const t=(0,A.coalesce)(n.map(c=>this._handlesToItems.get(c)));this._activeItems=t,this._onDidChangeActiveEmitter.fire(t)}_fireDidChangeSelection(n){const t=(0,A.coalesce)(n.map(c=>this._handlesToItems.get(c)));this._selectedItems=t,this._onDidChangeSelectionEmitter.fire(t)}_fireDidTriggerItemButton(n,t){const c=this._handlesToItems.get(n);if(!c||!c.buttons||!c.buttons.length)return;const E=c.buttons[t];E&&this._onDidTriggerItemButtonEmitter.fire({button:E,item:c})}}class i extends S{constructor(n,t){super(n.identifier,t);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(n){this._password=n,this.update({password:n})}get prompt(){return this._prompt}set prompt(n){this._prompt=n,this.update({prompt:n})}get validationMessage(){return this._validationMessage}set validationMessage(n){this._validationMessage=n,n?typeof n=="string"?this.update({validationMessage:n,severity:R.default.Error}):this.update({validationMessage:n.message,severity:n.severity??R.default.Error}):this.update({validationMessage:void 0,severity:R.default.Ignore})}}return new l(g,h)}e.createExtHostQuickOpen=m});var Ye=this&&this.__classPrivateFieldSet||function(J,e,o,C,p){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!p)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!p:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?p.call(J,o):p?p.value=o:e.set(J,o),o},Ae=this&&this.__classPrivateFieldGet||function(J,e,o,C){if(o==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!C:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?C:o==="a"?C.call(J):C?C.value:e.get(J)};define(De[210],Ce([1,0,2,4,54,7,13,5,16,116,14,27,60,8,25]),function(J,e,o,C,p,U,I,P,b,A,R,_,m,T,g){"use strict";var h,u;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function l(E){if(E)return typeof E.iconPath=="string"?o.URI.file(E.iconPath):o.URI.isUri(E.iconPath)||m.ThemeIcon.isThemeIcon(E.iconPath)?E.iconPath:void 0}function S(E,f){if(!E.iconPath&&!f.iconPath)return 0;if(E.iconPath){if(!f.iconPath)return 1}else return-1;const D=typeof E.iconPath=="string"?E.iconPath:o.URI.isUri(E.iconPath)?E.iconPath.fsPath:E.iconPath.id,L=typeof f.iconPath=="string"?f.iconPath:o.URI.isUri(f.iconPath)?f.iconPath.fsPath:f.iconPath.id;return(0,A.comparePaths)(D,L)}function w(E,f){let D=0;if(E.strikeThrough!==f.strikeThrough)return E.strikeThrough?1:-1;if(E.faded!==f.faded)return E.faded?1:-1;if(E.tooltip!==f.tooltip)return(E.tooltip||"").localeCompare(f.tooltip||"");if(D=S(E,f),D!==0)return D;if(E.light&&f.light)D=S(E.light,f.light);else{if(E.light)return 1;if(f.light)return-1}if(D!==0)return D;if(E.dark&&f.dark)D=S(E.dark,f.dark);else{if(E.dark)return 1;if(f.dark)return-1}return D}function a(E,f){if(E.command!==f.command)return E.command<f.command?-1:1;if(E.title!==f.title)return E.title<f.title?-1:1;if(E.tooltip!==f.tooltip){if(E.tooltip!==void 0&&f.tooltip!==void 0)return E.tooltip<f.tooltip?-1:1;if(E.tooltip!==void 0)return 1;if(f.tooltip!==void 0)return-1}if(E.arguments===f.arguments)return 0;if(E.arguments)if(f.arguments){if(E.arguments.length!==f.arguments.length)return E.arguments.length-f.arguments.length}else return 1;else return-1;for(let D=0;D<E.arguments.length;D++){const L=E.arguments[D],W=f.arguments[D];if(L!==W)return L<W?-1:1}return 0}function y(E,f){let D=(0,A.comparePaths)(E.resourceUri.fsPath,f.resourceUri.fsPath,!0);if(D!==0)return D;if(E.command&&f.command)D=a(E.command,f.command);else{if(E.command)return 1;if(f.command)return-1}if(D!==0)return D;if(E.decorations&&f.decorations)D=w(E.decorations,f.decorations);else{if(E.decorations)return 1;if(f.decorations)return-1}return D}function r(E,f){for(let D=0;D<E.length;D++)if(E[D]!==f[D])return!1;return!0}function d(E,f){return E.command===f.command&&E.title===f.title&&E.tooltip===f.tooltip&&(E.arguments&&f.arguments?r(E.arguments,f.arguments):E.arguments===f.arguments)}function i(E,f){return(0,b.equals)(E,f,d)}class s{constructor(f,D,L){this._extension=f,this._sourceControlHandle=L,h.set(this,void 0),this._value="",this._onDidChange=new C.Emitter,this._placeholder="",this._enabled=!0,this._visible=!0,Ye(this,h,D,"f")}get value(){return this._value}set value(f){f=f??"",Ae(this,h,"f").$setInputBoxValue(this._sourceControlHandle,f),this.updateValue(f)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(f){Ae(this,h,"f").$setInputBoxPlaceholder(this._sourceControlHandle,f),this._placeholder=f}get validateInput(){return(0,g.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(f){if((0,g.checkProposedApiEnabled)(this._extension,"scmValidation"),f&&typeof f!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=f,Ae(this,h,"f").$setValidationProviderIsEnabled(this._sourceControlHandle,!!f)}get enabled(){return this._enabled}set enabled(f){f=!!f,this._enabled!==f&&(this._enabled=f,Ae(this,h,"f").$setInputBoxEnablement(this._sourceControlHandle,f))}get visible(){return this._visible}set visible(f){f=!!f,this._visible!==f&&(this._visible=f,Ae(this,h,"f").$setInputBoxVisibility(this._sourceControlHandle,f))}showValidationMessage(f,D){(0,g.checkProposedApiEnabled)(this._extension,"scmValidation"),Ae(this,h,"f").$showValidationMessage(this._sourceControlHandle,f,D)}$onInputBoxValueChange(f){this.updateValue(f)}updateValue(f){this._value=f,this._onDidChange.fire(f)}}e.ExtHostSCMInputBox=s,h=new WeakMap;class n{constructor(f,D,L,W,N){this._proxy=f,this._commands=D,this._sourceControlHandle=L,this._id=W,this._label=N,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new C.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new C.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=n._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(f){this._label=f,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,f)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(f){this._hideWhenEmpty=f,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(f){this._resourceStates=[...f],this._onDidUpdateResourceStates.fire()}getResourceState(f){return this._resourceStatesMap.get(f)}$executeResourceCommand(f,D){const L=this._resourceStatesCommandsMap.get(f);return L?(0,I.asPromise)(()=>this._commands.executeCommand(L.command,...L.arguments||[],D)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const f=[...this._resourceStates].sort(y),L=(0,b.sortedDiff)(this._resourceSnapshot,f,y).map(v=>{const F=v.toInsert.map(O=>{const H=this._resourceHandlePool++;this._resourceStatesMap.set(H,O);const te=O.resourceUri;let z;if(O.command)if(O.command.command==="vscode.open"||O.command.command==="vscode.diff"){const ve=new U.DisposableStore;z=this._commands.converter.toInternal(O.command,ve),this._resourceStatesDisposablesMap.set(H,ve)}else this._resourceStatesCommandsMap.set(H,O.command);const $=l(O.decorations),ce=O.decorations&&l(O.decorations.light)||$,le=O.decorations&&l(O.decorations.dark)||$,oe=[ce,le],pe=O.decorations&&O.decorations.tooltip||"",re=O.decorations&&!!O.decorations.strikeThrough,Ee=O.decorations&&!!O.decorations.faded,be=O.contextValue||"";return{rawResource:[H,te,oe,pe,re,Ee,be,z],handle:H}});return{start:v.start,deleteCount:v.deleteCount,toInsert:F}}),W=L.map(({start:v,deleteCount:F,toInsert:O})=>[v,F,O.map(H=>H.rawResource)]),N=L.reverse();for(const{start:v,deleteCount:F,toInsert:O}of N){const H=O.map(z=>z.handle),te=this._handlesSnapshot.splice(v,F,...H);for(const z of te)this._resourceStatesMap.delete(z),this._resourceStatesCommandsMap.delete(z),this._resourceStatesDisposablesMap.get(z)?.dispose(),this._resourceStatesDisposablesMap.delete(z)}return this._resourceSnapshot=f,W}dispose(){this._disposed=!0,this._onDidDispose.fire()}}n._handlePool=0;class t{constructor(f,D,L,W,N,v){this._extension=f,this._commands=L,this._id=W,this._label=N,this._rootUri=v,u.set(this,void 0),this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new U.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new U.MutableDisposable,this._statusBarDisposables=new U.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new C.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=t._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,Ye(this,u,D,"f"),this._inputBox=new s(f,Ae(this,u,"f"),this.handle),Ae(this,u,"f").$registerSourceControl(this.handle,W,N,v)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(f){this._count!==f&&(this._count=f,Ae(this,u,"f").$updateSourceControl(this.handle,{count:f}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(f){this._quickDiffProvider=f,Ae(this,u,"f").$updateSourceControl(this.handle,{hasQuickDiffProvider:!!f})}get commitTemplate(){return this._commitTemplate}set commitTemplate(f){f!==this._commitTemplate&&(this._commitTemplate=f,Ae(this,u,"f").$updateSourceControl(this.handle,{commitTemplate:f}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(f){this._acceptInputDisposables.value=new U.DisposableStore,this._acceptInputCommand=f;const D=this._commands.converter.toInternal(f,this._acceptInputDisposables.value);Ae(this,u,"f").$updateSourceControl(this.handle,{acceptInputCommand:D})}get actionButton(){return(0,g.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(f){(0,g.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new U.DisposableStore,this._actionButton=f;const D=f!==void 0?{command:this._commands.converter.toInternal(f.command,this._actionButtonDisposables.value),secondaryCommands:f.secondaryCommands?.map(L=>L.map(W=>this._commands.converter.toInternal(W,this._actionButtonDisposables.value))),description:f.description,enabled:f.enabled}:void 0;Ae(this,u,"f").$updateSourceControl(this.handle,{actionButton:D??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(f){if(this._statusBarCommands&&f&&i(this._statusBarCommands,f))return;this._statusBarDisposables.value=new U.DisposableStore,this._statusBarCommands=f;const D=(f||[]).map(L=>this._commands.converter.toInternal(L,this._statusBarDisposables.value));Ae(this,u,"f").$updateSourceControl(this.handle,{statusBarCommands:D})}get selected(){return this._selected}createResourceGroup(f,D){const L=new n(Ae(this,u,"f"),this._commands,this.handle,f,D),W=C.Event.once(L.onDidDispose)(()=>this.createdResourceGroups.delete(L));return this.createdResourceGroups.set(L,W),this.eventuallyAddResourceGroups(),L}eventuallyAddResourceGroups(){const f=[],D=[];for(const[L,W]of this.createdResourceGroups){W.dispose();const N=L.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(L),this.eventuallyUpdateResourceStates()});C.Event.once(L.onDidDispose)(()=>{this.updatedResourceGroups.delete(L),N.dispose(),this._groups.delete(L.handle),Ae(this,u,"f").$unregisterGroup(this.handle,L.handle)}),f.push([L.handle,L.id,L.label,L.features]);const v=L._takeResourceStateSnapshot();v.length>0&&D.push([L.handle,v]),this._groups.set(L.handle,L)}Ae(this,u,"f").$registerGroups(this.handle,f,D),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const f=[];this.updatedResourceGroups.forEach(D=>{const L=D._takeResourceStateSnapshot();L.length!==0&&f.push([D.handle,L])}),f.length>0&&Ae(this,u,"f").$spliceResourceStates(this.handle,f),this.updatedResourceGroups.clear()}getResourceGroup(f){return this._groups.get(f)}setSelectionState(f){this._selected=f,this._onDidChangeSelection.fire(f)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(f=>f.dispose()),Ae(this,u,"f").$unregisterSourceControl(this.handle)}}u=new WeakMap,t._handlePool=0,$e([(0,p.debounce)(100)],t.prototype,"eventuallyAddResourceGroups",null),$e([(0,p.debounce)(100)],t.prototype,"eventuallyUpdateResourceStates",null);let c=class Xi{constructor(f,D,L){this._commands=D,this.logService=L,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new C.Emitter,this._proxy=f.getProxy(P.MainContext.MainThreadSCM),this._telemetry=f.getProxy(P.MainContext.MainThreadTelemetry),D.registerArgumentProcessor({processArgument:W=>{if(W&&W.$mid===3){const N=this._sourceControls.get(W.sourceControlHandle);if(!N)return W;const v=N.getResourceGroup(W.groupHandle);return v?v.getResourceState(W.handle):W}else if(W&&W.$mid===4){const N=this._sourceControls.get(W.sourceControlHandle);return N?N.getResourceGroup(W.groupHandle):W}else if(W&&W.$mid===5){const N=this._sourceControls.get(W.handle);return N||W}return W}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(f,D,L,W){this.logService.trace("ExtHostSCM#createSourceControl",f.identifier.value,D,L,W),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:f.identifier.value});const N=Xi._handlePool++,v=new t(f,this._proxy,this._commands,D,L,W);this._sourceControls.set(N,v);const F=this._sourceControlsByExtension.get(_.ExtensionIdentifier.toKey(f.identifier))||[];return F.push(v),this._sourceControlsByExtension.set(_.ExtensionIdentifier.toKey(f.identifier),F),v}getLastInputBox(f){this.logService.trace("ExtHostSCM#getLastInputBox",f.identifier.value);const D=this._sourceControlsByExtension.get(_.ExtensionIdentifier.toKey(f.identifier)),L=D&&D[D.length-1];return L&&L.inputBox}$provideOriginalResource(f,D,L){const W=o.URI.revive(D);this.logService.trace("ExtHostSCM#$provideOriginalResource",f,W.toString());const N=this._sourceControls.get(f);return!N||!N.quickDiffProvider||!N.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,I.asPromise)(()=>N.quickDiffProvider.provideOriginalResource(W,L)).then(v=>v||null)}$onInputBoxValueChange(f,D){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",f);const L=this._sourceControls.get(f);return L&&L.inputBox.$onInputBoxValueChange(D),Promise.resolve(void 0)}$executeResourceCommand(f,D,L,W){this.logService.trace("ExtHostSCM#$executeResourceCommand",f,D,L);const N=this._sourceControls.get(f);if(!N)return Promise.resolve(void 0);const v=N.getResourceGroup(D);return v?v.$executeResourceCommand(L,W):Promise.resolve(void 0)}$validateInput(f,D,L){this.logService.trace("ExtHostSCM#$validateInput",f);const W=this._sourceControls.get(f);return!W||!W.inputBox.validateInput?Promise.resolve(void 0):(0,I.asPromise)(()=>W.inputBox.validateInput(D,L)).then(N=>{if(!N)return Promise.resolve(void 0);const v=T.MarkdownString.fromStrict(N.message);return v?Promise.resolve([v,N.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(f){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",f),f!==void 0&&this._sourceControls.get(f)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=f,Promise.resolve(void 0)}};c._handlePool=0,c=$e([xe(2,R.ILogService)],c),e.ExtHostSCM=c});var Ye=this&&this.__classPrivateFieldSet||function(J,e,o,C,p){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!p)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!p:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?p.call(J,o):p?p.value=o:e.set(J,o),o},Ae=this&&this.__classPrivateFieldGet||function(J,e,o,C){if(o==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!C:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?C:o==="a"?C.call(J):C?C.value:e.get(J)};define(De[211],Ce([1,0,6,5,131,7,8,9]),function(J,e,o,C,p,U,I,P){"use strict";var b,A;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class R{constructor(g,h,u,l,S=o.StatusBarAlignment.Left,w){b.set(this,void 0),A.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new U.DisposableStore,Ye(this,b,g,"f"),Ye(this,A,h,"f"),this._entryId=R.ID_GEN++,this._extension=u,this._id=l,this._alignment=S,this._priority=this.validatePriority(w)}validatePriority(g){if(!!(0,P.isNumber)(g))return g===Number.POSITIVE_INFINITY?Number.MAX_VALUE:g===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:g}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(g){this._text=g,this.update()}set name(g){this._name=g,this.update()}set tooltip(g){this._tooltip=g,this.update()}set color(g){this._color=g,this.update()}set backgroundColor(g){g&&!R.ALLOWED_BACKGROUND_COLORS.has(g.id)&&(g=void 0),this._backgroundColor=g,this.update()}set command(g){this._command?.fromApi!==g&&(this._internalCommandRegistration.clear(),typeof g=="string"?this._command={fromApi:g,internal:Ae(this,A,"f").toInternal({title:"",command:g},this._internalCommandRegistration)}:g?this._command={fromApi:g,internal:Ae(this,A,"f").toInternal(g,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(g){this._accessibilityInformation=g,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Ae(this,b,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let g;this._extension?this._id?g=`${this._extension.identifier.value}.${this._id}`:g=this._extension.identifier.value:g=this._id;let h;this._name?h=this._name:h=(0,p.localize)(0,null,this._extension.displayName||this._extension.name);let u=this._color;this._backgroundColor&&(u=R.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const l=I.MarkdownString.fromStrict(this._tooltip);Ae(this,b,"f").$setEntry(this._entryId,g,h,this._text,l,this._command?.internal,u,this._backgroundColor,this._alignment===o.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=R,b=new WeakMap,A=new WeakMap,R.ID_GEN=0,R.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new o.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new o.ThemeColor("statusBarItem.warningForeground")]]);class _{constructor(g){this._messages=[],this._item=g.createStatusBarEntry(void 0,"status.extensionMessage",o.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,p.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(g){const h={message:g};return this._messages.unshift(h),this._update(),new o.Disposable(()=>{const u=this._messages.indexOf(h);u>=0&&(this._messages.splice(u,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class m{constructor(g,h){this._proxy=g.getProxy(C.MainContext.MainThreadStatusBar),this._commands=h,this._statusMessage=new _(this)}createStatusBarEntry(g,h,u,l){return new R(this._proxy,this._commands,g,h,u,l)}setStatusBarMessage(g,h){const u=this._statusMessage.setMessage(g);let l;return typeof h=="number"?l=setTimeout(()=>u.dispose(),h):typeof h!="undefined"&&h.then(()=>u.dispose(),()=>u.dispose()),new o.Disposable(()=>{u.dispose(),clearTimeout(l)})}}e.ExtHostStatusBar=m}),define(De[69],Ce([1,0,5,4,3]),function(J,e,o,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class U{constructor(P){this._onDidChangeStorage=new C.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=P.getProxy(o.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(P,b){this._proxy.$registerExtensionStorageKeysToSync(P,b)}initializeExtensionStorage(P,b,A){return this._proxy.$initializeExtensionStorage(P,b).then(R=>R||A)}setValue(P,b,A){return this._proxy.$setValue(P,b,A)}$acceptValue(P,b,A){this._onDidChangeStorage.fire({shared:P,key:b,value:A})}}e.ExtHostStorage=U,e.IExtHostStorage=(0,p.createDecorator)("IExtHostStorage")}),define(De[70],Ce([1,0,3,28,14,51,2]),function(J,e,o,C,p,U,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,o.createDecorator)("IExtensionStoragePaths");let P=class{constructor(A,R,_){this._logService=R,this._extHostFileSystem=_,this._workspace=A.workspace??void 0,this._environment=A.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(m=>this._value=m)}async _getWorkspaceStorageURI(A){return I.URI.joinPath(this._environment.workspaceStorageHome,A)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const A=this._workspace.id,R=await this._getWorkspaceStorageURI(A);try{return await this._extHostFileSystem.value.stat(R),this._logService.trace("[ExtHostStorage] storage dir already exists",R),R}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",R),await this._extHostFileSystem.value.createDirectory(R),await this._extHostFileSystem.value.writeFile(I.URI.joinPath(R,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:I.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),R}catch(_){this._logService.error("[ExtHostStorage]",_);return}}workspaceValue(A){if(this._value)return I.URI.joinPath(this._value,A.identifier.value)}globalValue(A){return I.URI.joinPath(this._environment.globalStorageHome,A.identifier.value.toLowerCase())}onWillDeactivateAll(){}};P=$e([xe(0,C.IExtHostInitDataService),xe(1,p.ILogService),xe(2,U.IExtHostConsumerFileSystem)],P),e.ExtensionStoragePaths=P}),define(De[52],Ce([1,0,4,5,3,2,15,7,6,132,11,169,20,43,153,60,9,13]),function(J,e,o,C,p,U,I,P,b,A,R,_,m,T,g,h,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,p.createDecorator)("IExtHostTerminalService");class S{constructor(t,c,E,f){this._proxy=t,this._id=c,this._creationOptions=E,this._name=f,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(L=>this._pidPromiseComplete=L);const D=this;this.value={get name(){return D._name||""},get processId(){return D._pidPromise},get creationOptions(){return D._creationOptions},get exitStatus(){return D._exitStatus},get state(){return D._state},sendText(L,W=!0){D._checkDisposed(),D._proxy.$sendText(D._id,L,W)},show(L){D._checkDisposed(),D._proxy.$show(D._id,L)},hide(){D._checkDisposed(),D._proxy.$hide(D._id)},dispose(){D._disposed||(D._disposed=!0,D._proxy.$dispose(D._id))},get dimensions(){if(!(D._cols===void 0||D._rows===void 0))return{columns:D._cols,rows:D._rows}}}}async create(t,c){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:t.name,shellPath:(0,u.withNullAsUndefined)(t.shellPath),shellArgs:(0,u.withNullAsUndefined)(t.shellArgs),cwd:(0,u.withNullAsUndefined)(t.cwd),env:(0,u.withNullAsUndefined)(t.env),icon:(0,u.withNullAsUndefined)(i(t.iconPath)),color:h.ThemeColor.isThemeColor(t.color)?t.color.id:void 0,initialText:(0,u.withNullAsUndefined)(t.message),strictEnv:(0,u.withNullAsUndefined)(t.strictEnv),hideFromUser:(0,u.withNullAsUndefined)(t.hideFromUser),isFeatureTerminal:(0,u.withNullAsUndefined)(c?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,u.withNullAsUndefined)(c?.useShellEnvironment),location:c?.location||this._serializeParentTerminal(t.location,c?.resolvedExtHostIdentifier),isTransient:(0,u.withNullAsUndefined)(t.isTransient)})}async createExtensionTerminal(t,c,E,f){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:E,color:h.ThemeColor.isThemeColor(f)?f.id:void 0,location:this._serializeParentTerminal(t,c),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(t,c){return typeof t=="object"?"parentTerminal"in t&&t.parentTerminal&&c?{parentTerminal:c}:"viewColumn"in t?{viewColumn:t.viewColumn,preserveFocus:t.preserveFocus}:void 0:t}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(t){this._name=t}setExitCode(t){this._exitStatus=Object.freeze({code:t})}setDimensions(t,c){return t===this._cols&&c===this._rows||t===0||c===0?!1:(this._cols=t,this._rows=c,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(t){this._pidPromiseComplete?(this._pidPromiseComplete(t),this._pidPromiseComplete=void 0):this._pidPromise.then(c=>{c!==t&&(this._pidPromise=Promise.resolve(t))})}}e.ExtHostTerminal=S;class w{constructor(t){this._pty=t,this.id=0,this.shouldPersist=!1,this._onProcessData=new o.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new o.Emitter,this._onDidChangeProperty=new o.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new o.Emitter,this.onProcessExit=this._onProcessExit.event}get onProcessReady(){return this._onProcessReady.event}refreshProperty(t){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${t}`)}updateProperty(t,c){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${t}, value: ${c}`)}async start(){}shutdown(){this._pty.close()}input(t){this._pty.handleInput?.(t)}resize(t,c){this._pty.setDimensions?.({columns:t,rows:c})}async processBinary(t){}acknowledgeDataEvent(t){}async setUnicodeVersion(t){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(t){this._pty.onDidWrite(c=>this._onProcessData.fire(c)),this._pty.onDidClose?.((c=void 0)=>{this._onProcessExit.fire(c===void 0?void 0:c)}),this._pty.onDidOverrideDimensions?.(c=>{c&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:c.columns,rows:c.rows}})}),this._pty.onDidChangeName?.(c=>{this._onDidChangeProperty.fire({type:"title",value:c})}),this._pty.open(t||void 0),t&&this._pty.setDimensions?.(t),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=w;let a=1,y=class extends P.Disposable{constructor(t,c){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new o.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new o.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new o.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new o.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new o.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=c.getProxy(C.MainContext.MainThreadTerminalService),this._bufferer=new g.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new o.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(t),this._register({dispose:()=>{for(const[E,f]of this._terminalProcesses)f.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(t=>t.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(t){return(t?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(t){return(t?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(t,c){const E=new S(this._proxy,(0,T.generateUuid)(),t,t.name),f=new w(t.pty);return E.createExtensionTerminal(t.location,this._serializeParentTerminal(t,c).resolvedExtHostIdentifier,i(t.iconPath),s(t.color)).then(D=>{const L=this._setupExtHostProcessListeners(D,f);this._terminalProcessDisposables[D]=L}),this._terminals.push(E),E.value}_serializeParentTerminal(t,c){if(c=c||{},t.location&&typeof t.location=="object"&&"parentTerminal"in t.location){const E=t.location.parentTerminal;if(E){const f=this._terminals.find(D=>D.value===E);f&&(c.resolvedExtHostIdentifier=f._id)}}else t.location&&typeof t.location!="object"?c.location=t.location:c.location&&typeof c.location=="object"&&"splitActiveTerminal"in c.location&&(c.location={splitActiveTerminal:!0});return c}attachPtyToTerminal(t,c){if(!this._getTerminalById(t))throw new Error(`Cannot resolve terminal with id ${t} for virtual process`);const f=new w(c),D=this._setupExtHostProcessListeners(t,f);this._terminalProcessDisposables[t]=D}async $acceptActiveTerminalChanged(t){const c=this._activeTerminal;if(t===null){this._activeTerminal=void 0,c!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const E=this._getTerminalById(t);E&&(this._activeTerminal=E,c!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(t,c){const E=this._getTerminalById(t);E&&this._onDidWriteTerminalData.fire({terminal:E.value,data:c})}async $acceptTerminalDimensions(t,c,E){const f=this._getTerminalById(t);f&&f.setDimensions(c,E)&&this._onDidChangeTerminalDimensions.fire({terminal:f.value,dimensions:f.value.dimensions})}async $acceptTerminalMaximumDimensions(t,c,E){this._terminalProcesses.get(t)?.resize(c,E)}async $acceptTerminalTitleChange(t,c){const E=this._getTerminalById(t);E&&(E.name=c)}async $acceptTerminalClosed(t,c){const E=this._getTerminalObjectIndexById(this._terminals,t);if(E!==null){const f=this._terminals.splice(E,1)[0];f.setExitCode(c),this._onDidCloseTerminal.fire(f.value)}}$acceptTerminalOpened(t,c,E,f){if(c){const W=this._getTerminalObjectIndexById(this._terminals,c);if(W!==null){this._terminals[W]._id=t,this._onDidOpenTerminal.fire(this.terminals[W]),this._terminals[W].isOpen=!0;return}}const D={name:f.name,shellPath:f.executable,shellArgs:f.args,cwd:typeof f.cwd=="string"?f.cwd:U.URI.revive(f.cwd),env:f.env,hideFromUser:f.hideFromUser},L=new S(this._proxy,t,D,E);this._terminals.push(L),this._onDidOpenTerminal.fire(L.value),L.isOpen=!0}async $acceptTerminalProcessId(t,c){this._getTerminalById(t)?._setProcessId(c)}async $startExtensionTerminal(t,c){const E=this._getTerminalById(t);if(!E)return{message:(0,A.localize)(0,null,t)};E.isOpen||await new Promise(D=>{const L=this.onDidOpenTerminal(async W=>{W===E.value&&(L.dispose(),D())})});const f=this._terminalProcesses.get(t);f?f.startSendingEvents(c):this._extensionTerminalAwaitingStart[t]={initialDimensions:c}}_setupExtHostProcessListeners(t,c){const E=new P.DisposableStore;E.add(c.onProcessReady(D=>this._proxy.$sendProcessReady(t,D.pid,D.cwd))),E.add(c.onDidChangeProperty(D=>this._proxy.$sendProcessProperty(t,D))),this._bufferer.startBuffering(t,c.onProcessData),E.add(c.onProcessExit(D=>this._onProcessExit(t,D))),this._terminalProcesses.set(t,c);const f=this._extensionTerminalAwaitingStart[t];return f&&c instanceof w&&(c.startSendingEvents(f.initialDimensions),delete this._extensionTerminalAwaitingStart[t]),E}$acceptProcessAckDataEvent(t,c){this._terminalProcesses.get(t)?.acknowledgeDataEvent(c)}$acceptProcessInput(t,c){this._terminalProcesses.get(t)?.input(c)}$acceptTerminalInteraction(t){const c=this._getTerminalById(t);c?.setInteractedWith()&&this._onDidChangeTerminalState.fire(c.value)}$acceptProcessResize(t,c,E){try{this._terminalProcesses.get(t)?.resize(c,E)}catch(f){if(f.code!=="EPIPE"&&f.code!=="ERR_IPC_CHANNEL_CLOSED")throw f}}$acceptProcessShutdown(t,c){this._terminalProcesses.get(t)?.shutdown(c)}$acceptProcessRequestInitialCwd(t){this._terminalProcesses.get(t)?.getInitialCwd().then(c=>this._proxy.$sendProcessProperty(t,{type:"initialCwd",value:c}))}$acceptProcessRequestCwd(t){this._terminalProcesses.get(t)?.getCwd().then(c=>this._proxy.$sendProcessProperty(t,{type:"cwd",value:c}))}$acceptProcessRequestLatency(t){return Promise.resolve(t)}registerLinkProvider(t){return this._linkProviders.add(t),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new b.Disposable(()=>{this._linkProviders.delete(t),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(t,c,E){if(this._profileProviders.has(c))throw new Error(`Terminal profile provider "${c}" already registered`);return this._profileProviders.set(c,E),this._proxy.$registerProfileProvider(c,t.identifier.value),new b.Disposable(()=>{this._profileProviders.delete(c),this._proxy.$unregisterProfileProvider(c)})}async $createContributedProfileTerminal(t,c){const E=new m.CancellationTokenSource().token;let f=await this._profileProviders.get(t)?.provideTerminalProfile(E);if(!E.isCancellationRequested){if(f&&!("options"in f)&&(f={options:f}),!f||!("options"in f))throw new Error(`No terminal profile options provided for id "${t}"`);if("pty"in f.options){this.createExtensionTerminal(f.options,c);return}this.createTerminalFromOptions(f.options,c)}}async $provideLinks(t,c){const E=this._getTerminalById(t);if(!E)return[];this._terminalLinkCache.delete(t),this._terminalLinkCancellationSource.get(t)?.dispose(!0);const D=new m.CancellationTokenSource;this._terminalLinkCancellationSource.set(t,D);const L=[],W={terminal:E.value,line:c},N=[];for(const O of this._linkProviders)N.push(l.Promises.withAsyncBody(async H=>{D.token.onCancellationRequested(()=>H({provider:O,links:[]}));const te=await O.provideTerminalLinks(W,D.token)||[];D.token.isCancellationRequested||H({provider:O,links:te})}));const v=await Promise.all(N);if(D.token.isCancellationRequested)return[];const F=new Map;for(const O of v)O&&O.links.length>0&&L.push(...O.links.map(H=>{const te={id:a++,startIndex:H.startIndex,length:H.length,label:H.tooltip};return F.set(te.id,{provider:O.provider,link:H}),te}));return this._terminalLinkCache.set(t,F),L}$activateLink(t,c){const E=this._terminalLinkCache.get(t)?.get(c);!E||E.provider.handleTerminalLink(E.link)}_onProcessExit(t,c){this._bufferer.stopBuffering(t),this._terminalProcesses.delete(t),delete this._extensionTerminalAwaitingStart[t];const E=this._terminalProcessDisposables[t];E&&(E.dispose(),delete this._terminalProcessDisposables[t]),this._proxy.$sendProcessExit(t,c)}_getTerminalById(t){return this._getTerminalObjectById(this._terminals,t)}_getTerminalObjectById(t,c){const E=this._getTerminalObjectIndexById(t,c);return E!==null?t[E]:null}_getTerminalObjectIndexById(t,c){let E=null;return t.some((f,D)=>f._id===c?(E=D,!0):!1),E}getEnvironmentVariableCollection(t){let c=this._environmentVariableCollections.get(t.identifier.value);return c||(c=new r,this._setEnvironmentVariableCollection(t.identifier.value,c)),c}_syncEnvironmentVariableCollection(t,c){const E=(0,_.serializeEnvironmentVariableCollection)(c.map);this._proxy.$setEnvironmentVariableCollection(t,c.persistent,E.length===0?void 0:E)}$initEnvironmentVariableCollections(t){t.forEach(c=>{const E=c[0],f=new r(c[1]);this._setEnvironmentVariableCollection(E,f)})}$acceptDefaultProfile(t,c){this._defaultProfile=t,this._defaultAutomationProfile=c}_setEnvironmentVariableCollection(t,c){this._environmentVariableCollections.set(t,c),c.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(t,c)})}};y=$e([xe(1,I.IExtHostRpcService)],y),e.BaseExtHostTerminalService=y;class r{constructor(t){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new o.Emitter,this.map=new Map(t)}get persistent(){return this._persistent}set persistent(t){this._persistent=t,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(t,c){this._setIfDiffers(t,{value:c,type:b.EnvironmentVariableMutatorType.Replace})}append(t,c){this._setIfDiffers(t,{value:c,type:b.EnvironmentVariableMutatorType.Append})}prepend(t,c){this._setIfDiffers(t,{value:c,type:b.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(t,c){const E=this.map.get(t);(!E||E.value!==c.value||E.type!==c.type)&&(this.map.set(t,c),this._onDidChangeCollection.fire())}get(t){return this.map.get(t)}forEach(t,c){this.map.forEach((E,f)=>t.call(c,f,E,this))}[Symbol.iterator](){return this.map.entries()}delete(t){this.map.delete(t),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=r;let d=class extends y{constructor(t){super(!1,t)}createTerminal(t,c,E){throw new R.NotSupportedError}createTerminalFromOptions(t,c){throw new R.NotSupportedError}};d=$e([xe(0,I.IExtHostRpcService)],d),e.WorkerExtHostTerminalService=d;function i(n){if(!(!n||typeof n=="string"))return"id"in n?{id:n.id,color:n.color}:n}function s(n){return h.ThemeColor.isThemeColor(n)?n:void 0}});var Ye=this&&this.__classPrivateFieldSet||function(J,e,o,C,p){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!p)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!p:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?p.call(J,o):p?p.value=o:e.set(J,o),o},Ae=this&&this.__classPrivateFieldGet||function(J,e,o,C){if(o==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!C:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?C:o==="a"?C.call(J):C?C.value:e.get(J)};define(De[212],Ce([1,0,16,23,20,4,172,96,7,26,9,43,5,15,92,8,6,46,65,47]),function(J,e,o,C,p,U,I,P,b,A,R,_,m,T,g,h,u,l,S,w){"use strict";var a,y;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let r=class{constructor(N,v){this.resultsChangedEmitter=new U.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=N.getProxy(m.MainContext.MainThreadTesting),this.observer=new f(this.proxy),this.runTracker=new i(this.proxy),v.registerArgumentProcessor({processArgument:F=>F?.$mid===13?(0,g.toItemFromContext)(F):F})}createTestController(N,v,F){if(this.controllers.has(N))throw new Error(`Attempt to insert a duplicate controller with ID "${N}"`);const O=new b.DisposableStore,H=O.add(new g.ExtHostTestItemCollection(N,v));H.root.label=v;const te=new Map,z=this.proxy,$={items:H.root.children,get label(){return v},set label(le){v=le,H.root.label=le,z.$updateController(N,{label:v})},get refreshHandler(){return F},set refreshHandler(le){F=le,z.$updateController(N,{canRefresh:!!le})},get id(){return N},createRunProfile:(le,oe,pe,re,Ee)=>{let be=(0,P.hash)(le);for(;te.has(be);)be++;return new D(this.proxy,te,N,be,le,oe,pe,re,Ee)},createTestItem(le,oe,pe){return new g.TestItemImpl(N,le,oe,pe)},createTestRun:(le,oe,pe=!0)=>this.runTracker.createTestRun(N,H,le,oe,pe),set resolveHandler(le){H.resolveHandler=le},get resolveHandler(){return H.resolveHandler},dispose:()=>{O.dispose()}};z.$registerTestController(N,v,!!F),O.add((0,b.toDisposable)(()=>z.$unregisterTestController(N)));const ce={controller:$,collection:H,profiles:te};return this.controllers.set(N,ce),O.add((0,b.toDisposable)(()=>this.controllers.delete(N))),O.add(H.onDidGenerateDiff(le=>z.$publishDiff(N,le.map(w.TestsDiffOp.serialize)))),$}createTestObserver(){return this.observer.checkout()}async runTests(N,v=p.CancellationToken.None){const F=s(N);if(!F)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const O=this.controllers.get(F.controllerId);if(!O)throw new Error("Controller not found");await this.proxy.$runTests({isUiTriggered:!1,targets:[{testIds:N.include?.map(H=>l.TestId.fromExtHostTestItem(H,O.collection.root.id).toString())??[O.collection.root.id],profileGroup:L[F.kind],profileId:F.profileId,controllerId:F.controllerId}],exclude:N.exclude?.map(H=>H.id)},v)}$provideFileCoverage(N,v,F){return(0,o.mapFind)(this.runTracker.trackers,H=>H.id===N?H.getCoverage(v):void 0)?.provideFileCoverage(F)??Promise.resolve([])}$resolveFileCoverage(N,v,F,O){return(0,o.mapFind)(this.runTracker.trackers,te=>te.id===N?te.getCoverage(v):void 0)?.resolveFileCoverage(F,O)??Promise.resolve([])}$configureRunProfile(N,v){this.controllers.get(N)?.profiles.get(v)?.configureHandler?.()}async $refreshTests(N,v){await this.controllers.get(N)?.controller.refreshHandler?.(v)}$publishTestResults(N){this.results=Object.freeze(N.map(v=>(0,A.deepFreeze)(h.TestResults.to(v))).concat(this.results).sort((v,F)=>F.completedAt-v.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(N,v){const F=this.controllers.get(l.TestId.fromString(N).controllerId)?.collection;F&&(await F.expand(N,v<0?1/0:v),F.flushDiff())}$acceptDiff(N){this.observer.applyDiff(N.map(w.TestsDiffOp.deserialize))}async $runControllerTests(N,v){const F=this.controllers.get(N.controllerId);if(!F)return;const{collection:O,profiles:H}=F,te=H.get(N.profileId);if(!te)return;const z=N.testIds.map(oe=>O.tree.get(oe)).filter(R.isDefined),$=N.excludeExtIds.map(oe=>F.collection.tree.get(oe)).filter(R.isDefined).filter(oe=>z.some(pe=>pe.fullId.compare(oe.fullId)===2));if(!z.length)return;const ce=new u.TestRunRequest(z.some(oe=>oe.actual instanceof g.TestItemRootImpl)?void 0:z.map(oe=>oe.actual),$.map(oe=>oe.actual),te),le=this.runTracker.prepareForMainThreadTestRun(ce,n.fromInternal(N,F.collection),v);try{await te.runHandler(ce,v)}finally{le.isRunning&&!v.isCancellationRequested&&await U.Event.toPromise(le.onEnd),le.dispose()}}$cancelExtensionTestRun(N){N===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(N)}};r=$e([xe(0,T.IExtHostRpcService)],r),e.ExtHostTesting=r;class d extends b.Disposable{constructor(N,v,F){super();this.dto=N,this.proxy=v,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new U.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new p.CancellationTokenSource(F)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:O}of this.tasks.values())O.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(N){return this.tasks.get(N)?.coverage}createRun(N){const v=this.dto.id,F=this.dto.controllerId,O=(0,_.generateUuid)(),H=new t(this.proxy,v,O),te=le=>(oe,...pe)=>{if($){console.warn(`Setting the state of test "${oe.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(oe)||(this.ensureTestIsKnown(oe),le(oe,...pe))},z=(le,oe)=>{const pe=oe instanceof Array?oe.map(h.TestMessage.from):[h.TestMessage.from(oe)];if(le.uri&&le.range){const re={range:h.Range.from(le.range),uri:le.uri};for(const Ee of pe)Ee.location=Ee.location||re}this.proxy.$appendTestMessagesInRun(v,O,l.TestId.fromExtHostTestItem(le,F).toString(),pe)};let $=!1;const ce={isPersisted:this.dto.isPersisted,token:this.cts.token,name:N,get coverageProvider(){return H.coverageProvider},set coverageProvider(le){H.coverageProvider=le},enqueued:te(le=>{this.proxy.$updateTestStateInRun(v,O,l.TestId.fromExtHostTestItem(le,F).toString(),1)}),skipped:te(le=>{this.proxy.$updateTestStateInRun(v,O,l.TestId.fromExtHostTestItem(le,F).toString(),5)}),started:te(le=>{this.proxy.$updateTestStateInRun(v,O,l.TestId.fromExtHostTestItem(le,F).toString(),2)}),errored:te((le,oe,pe)=>{z(le,oe),this.proxy.$updateTestStateInRun(v,O,l.TestId.fromExtHostTestItem(le,F).toString(),6,pe)}),failed:te((le,oe,pe)=>{z(le,oe),this.proxy.$updateTestStateInRun(v,O,l.TestId.fromExtHostTestItem(le,F).toString(),4,pe)}),passed:te((le,oe)=>{this.proxy.$updateTestStateInRun(v,O,l.TestId.fromExtHostTestItem(le,this.dto.controllerId).toString(),3,oe)}),appendOutput:(le,oe,pe)=>{$||(pe&&(this.dto.isIncluded(pe)?this.ensureTestIsKnown(pe):pe=void 0),this.proxy.$appendOutputToRun(v,O,C.VSBuffer.fromString(le),oe&&h.location.from(oe),pe&&l.TestId.fromExtHostTestItem(pe,F).toString()))},end:()=>{$||($=!0,this.proxy.$finishedTestRunTask(v,O),this.tasks.delete(O),this.isRunning||this.dispose())}};return this.tasks.set(O,{run:ce,coverage:H}),this.proxy.$startedTestRunTask(v,{id:O,name:N,running:!0}),ce}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(N){if(!(N instanceof g.TestItemImpl))throw new S.InvalidTestItemError(N.id);if(this.sharedTestIds.has(l.TestId.fromExtHostTestItem(N,this.dto.controllerId).toString()))return;const v=[],F=this.dto.colllection.root;for(;;){const O=h.TestItem.from(N);if(v.unshift(O),this.sharedTestIds.has(O.extId)||(this.sharedTestIds.add(O.extId),N===F))break;N=N.parent||F}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,v)}}class i{constructor(N){this.proxy=N,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(N,v,F){return this.getTracker(N,v,F)}cancelRunById(N){for(const v of this.tracked.values())if(v.id===N){v.dispose();return}}cancelAllRuns(){for(const N of this.tracked.values())N.dispose()}createTestRun(N,v,F,O,H){const te=this.tracked.get(F);if(te)return te.createRun(O);const z=n.fromPublic(N,v,F,H),$=s(F);this.proxy.$startedExtensionTestRun({controllerId:N,profile:$&&{group:L[$.kind],id:$.profileId},exclude:F.exclude?.map(le=>l.TestId.fromExtHostTestItem(le,v.root.id).toString())??[],id:z.id,include:F.include?.map(le=>l.TestId.fromExtHostTestItem(le,v.root.id).toString())??[v.root.id],persist:H});const ce=this.getTracker(F,z);return ce.onEnd(()=>this.proxy.$finishedExtensionTestRun(z.id)),ce.createRun(O)}getTracker(N,v,F){const O=new d(v,this.proxy,F);return this.tracked.set(N,O),O.onEnd(()=>this.tracked.delete(N)),O}}e.TestRunCoordinator=i;const s=W=>{if(!!W.profile){if(!(W.profile instanceof D))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return W.profile}};class n{constructor(N,v,F,O,H,te){this.controllerId=N,this.id=v,this.isPersisted=H,this.colllection=te,this.includePrefix=F.map(z=>z+"\0"),this.excludePrefix=O.map(z=>z+"\0")}static fromPublic(N,v,F,O){return new n(N,(0,_.generateUuid)(),F.include?.map(H=>l.TestId.fromExtHostTestItem(H,N).toString())??[N],F.exclude?.map(H=>l.TestId.fromExtHostTestItem(H,N).toString())??[],O,v)}static fromInternal(N,v){return new n(N.controllerId,N.runId,N.testIds,N.excludeExtIds,!0,v)}isIncluded(N){const v=l.TestId.fromExtHostTestItem(N,this.controllerId).toString()+"\0";for(const F of this.excludePrefix)if(v===F||v.startsWith(F))return!1;for(const F of this.includePrefix)if(v===F||v.startsWith(F))return!0;return!1}}e.TestRunDto=n;class t{constructor(N,v,F){this.proxy=N,this.runId=v,this.taskId=F}set coverageProvider(N){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!N||(this._coverageProvider=N,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(N){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(N))());try{return(await this.fileCoverage)?.map(h.TestCoverage.fromFile)??[]}catch(v){throw this.fileCoverage=void 0,v}}async resolveFileCoverage(N,v){const F=await this.fileCoverage;let O=F?.[N];return!this._coverageProvider||!F||!O?[]:(O.detailedCoverage||(O=F[N]=await this._coverageProvider.resolveFileCoverage?.(O,v)??O),O.detailedCoverage?.map(h.TestCoverage.fromDetailed)??[])}}class c extends w.IncrementalChangeCollector{constructor(N){super();this.emitter=N,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(N){this.added.add(N)}update(N){Object.assign(N.revived,h.TestItem.toPlain(N.item)),this.added.has(N)||this.updated.add(N)}remove(N){if(this.added.has(N)){this.added.delete(N);return}if(this.updated.delete(N),N.parent&&this.alreadyRemoved.has(N.parent)){this.alreadyRemoved.add(N.item.extId);return}this.removed.add(N)}getChangeEvent(){const{added:N,updated:v,removed:F}=this;return{get added(){return[...N].map(O=>O.revived)},get updated(){return[...v].map(O=>O.revived)},get removed(){return[...F].map(O=>O.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class E extends w.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new U.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(N){return this.items.get(N)}getMirroredTestDataByReference(N){return this.items.get(N.id)}createItem(N,v){return{...N,revived:h.TestItem.toPlain(N.item),depth:v?v.depth+1:0,children:new Set}}createChangeCollector(){return new c(this.changeEmitter)}}e.MirroredTestCollection=E;class f{constructor(N){this.proxy=N}checkout(){this.current||(this.current=this.createObserverData());const N=this.current;return N.observers++,{onDidChangeTest:N.tests.onDidChangeTests,get tests(){return[...N.tests.rootTests].map(v=>v.revived)},dispose:(0,I.once)(()=>{--N.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(N){return this.current?.tests.getMirroredTestDataByReference(N)}applyDiff(N){this.current?.tests.apply(N)}createObserverData(){const N=new E;return this.proxy.$subscribeToDiffs(),{observers:0,tests:N}}}class D{constructor(N,v,F,O,H,te,z,$=!1,ce=void 0){this.controllerId=F,this.profileId=O,this._label=H,this.kind=te,this.runHandler=z,this._isDefault=$,this._tag=ce,a.set(this,void 0),y.set(this,void 0),Ye(this,a,N,"f"),Ye(this,y,v,"f"),v.set(O,this);const le=L[te];if(typeof le!="number")throw new Error(`Unknown TestRunProfile.group ${te}`);Ae(this,a,"f").$publishTestRunProfile({profileId:O,controllerId:F,tag:ce?h.TestTag.namespace(this.controllerId,ce.id):null,label:H,group:le,isDefault:$,hasConfigurationHandler:!1})}get label(){return this._label}set label(N){N!==this._label&&(this._label=N,Ae(this,a,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:N}))}get isDefault(){return this._isDefault}set isDefault(N){N!==this._isDefault&&(this._isDefault=N,Ae(this,a,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:N}))}get tag(){return this._tag}set tag(N){N?.id!==this._tag?.id&&(this._tag=N,Ae(this,a,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:N?h.TestTag.namespace(this.controllerId,N.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(N){N!==this._configureHandler&&(this._configureHandler=N,Ae(this,a,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!N}))}dispose(){Ae(this,y,"f")?.delete(this.profileId)&&(Ye(this,y,void 0,"f"),Ae(this,a,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=D,a=new WeakMap,y=new WeakMap;const L={[u.TestRunProfileKind.Coverage]:8,[u.TestRunProfileKind.Debug]:4,[u.TestRunProfileKind.Run]:2}}),define(De[213],Ce([1,0,16,4,5,93,8,6]),function(J,e,o,C,p,U,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class b{constructor(R,_){this._extHostDocumentsAndEditors=_,this._onDidChangeTextEditorSelection=new C.Emitter,this._onDidChangeTextEditorOptions=new C.Emitter,this._onDidChangeTextEditorVisibleRanges=new C.Emitter,this._onDidChangeTextEditorViewColumn=new C.Emitter,this._onDidChangeActiveTextEditor=new C.Emitter,this._onDidChangeVisibleTextEditors=new C.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=R.getProxy(p.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(m=>this._onDidChangeVisibleTextEditors.fire(m)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(m=>this._onDidChangeActiveTextEditor.fire(m))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(R){const _=this._extHostDocumentsAndEditors.allEditors();return R?_:_.map(m=>m.value)}async showTextDocument(R,_,m){let T;typeof _=="number"?T={position:I.ViewColumn.from(_),preserveFocus:m}:typeof _=="object"?T={position:I.ViewColumn.from(_.viewColumn),preserveFocus:_.preserveFocus,selection:typeof _.selection=="object"?I.Range.from(_.selection):void 0,pinned:typeof _.preview=="boolean"?!_.preview:void 0}:T={preserveFocus:!1};const g=await this._proxy.$tryShowTextDocument(R.uri,T),h=g&&this._extHostDocumentsAndEditors.getEditor(g);if(h)return h.value;throw g?new Error(`Could NOT open editor for "${R.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${R.uri.toString()}".`)}createTextEditorDecorationType(R,_){return new U.TextEditorDecorationType(this._proxy,R,_).value}$acceptEditorPropertiesChanged(R,_){const m=this._extHostDocumentsAndEditors.getEditor(R);if(!m)throw new Error("unknown text editor");if(_.options&&m._acceptOptions(_.options),_.selections){const T=_.selections.selections.map(I.Selection.to);m._acceptSelections(T)}if(_.visibleRanges){const T=o.coalesce(_.visibleRanges.map(I.Range.to));m._acceptVisibleRanges(T)}if(_.options&&this._onDidChangeTextEditorOptions.fire({textEditor:m.value,options:{..._.options,lineNumbers:I.TextEditorLineNumbersStyle.to(_.options.lineNumbers)}}),_.selections){const T=P.TextEditorSelectionChangeKind.fromValue(_.selections.source),g=_.selections.selections.map(I.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:m.value,selections:g,kind:T})}if(_.visibleRanges){const T=o.coalesce(_.visibleRanges.map(I.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:m.value,visibleRanges:T})}}$acceptEditorPositionData(R){for(const _ in R){const m=this._extHostDocumentsAndEditors.getEditor(_);if(!m)throw new Error("Unknown text editor");const T=I.ViewColumn.to(R[_]);m.value.viewColumn!==T&&(m._acceptViewColumn(T),this._onDidChangeTextEditorViewColumn.fire({textEditor:m.value,viewColumn:T}))}}getDiffInformation(R){return Promise.resolve(this._proxy.$getDiffInformation(R))}}e.ExtHostEditors=b}),define(De[214],Ce([1,0,2,3,5,7,6,8,9]),function(J,e,o,C,p,U,I,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,C.createDecorator)("IExtHostTimeline");class A{constructor(m,T){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=m.getProxy(p.MainContext.MainThreadTimeline),T.registerArgumentProcessor({processArgument:g=>{if(g&&g.$mid===11){const h=g.uri===void 0?void 0:o.URI.revive(g.uri);return this._itemsBySourceAndUriMap.get(g.source)?.get(R(h))?.get(g.handle)}return g}})}async $getTimeline(m,T,g,h){return this._providers.get(m)?.provideTimeline(o.URI.revive(T),g,h)}registerTimelineProvider(m,T,g,h){const u=new U.DisposableStore,l=this.convertTimelineItem(T.id,h,u).bind(this);let S;T.onDidChange&&(S=T.onDidChange(a=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...a,id:T.id}),this));const w=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...T,scheme:m,onDidChange:void 0,async provideTimeline(a,y,r){y?.resetCache&&(u.clear(),w.get(T.id)?.clear());const d=await T.provideTimeline(a,y,r);if(d==null)return;const i=l(a,y);return{...d,source:T.id,items:d.items.map(i)}},dispose(){for(const a of w.values())a.get(T.id)?.clear();S?.dispose(),u.dispose()}})}convertTimelineItem(m,T,g){return(h,u)=>{let l;if(u?.cacheResults){let S=this._itemsBySourceAndUriMap.get(m);S===void 0&&(S=new Map,this._itemsBySourceAndUriMap.set(m,S));const w=R(h);l=S.get(w),l===void 0&&(l=new Map,S.set(w,l))}return S=>{const{iconPath:w,...a}=S,y=`${m}|${S.id??S.timestamp}`;l?.set(y,S);let r,d,i;S.iconPath&&(w instanceof I.ThemeIcon?i={id:w.id,color:w.color}:o.URI.isUri(w)?(r=w,d=w):{light:r,dark:d}=w);let s;return I.MarkdownString.isMarkdownString(a.tooltip)?s=P.MarkdownString.from(a.tooltip):(0,b.isString)(a.tooltip)?s=a.tooltip:I.MarkdownString.isMarkdownString(a.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),s=P.MarkdownString.from(a.detail)):(0,b.isString)(a.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),s=a.detail),{...a,id:a.id??void 0,handle:y,source:m,command:S.command?T.toInternal(S.command,g):void 0,icon:r,iconDark:d,themeIcon:i,tooltip:s,accessibilityInformation:S.accessibilityInformation}}}}registerTimelineProviderCore(m){if(this._providers.get(m.id))throw new Error(`Timeline Provider ${m.id} already exists.`);return this._proxy.$registerTimelineProvider({id:m.id,label:m.label,scheme:m.scheme}),this._providers.set(m.id,m),(0,U.toDisposable)(()=>{for(const g of this._itemsBySourceAndUriMap.values())g.get(m.id)?.clear();this._providers.delete(m.id),this._proxy.$unregisterTimelineProvider(m.id),m.dispose()})}}e.ExtHostTimeline=A;function R(_){return _?.toString()}}),define(De[215],Ce([1,0,7,12,2,5]),function(J,e,o,C,p,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class I{constructor(b){this._openers=new Map,this._proxy=b.getProxy(U.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(b,A,R,_){if(this._openers.has(A))throw new Error(`Opener with id '${A}' already registered`);const m=_.schemes.find(T=>!I.supportedSchemes.has(T));if(m)throw new Error(`Scheme '${m}' is not supported. Only http and https are currently supported.`);return this._openers.set(A,R),this._proxy.$registerUriOpener(A,_.schemes,b,_.label),(0,o.toDisposable)(()=>{this._openers.delete(A),this._proxy.$unregisterUriOpener(A)})}async $canOpenUri(b,A,R){const _=this._openers.get(b);if(!_)throw new Error(`Unknown opener with id: ${b}`);const m=p.URI.revive(A);return _.canOpenExternalUri(m,R)}async $openUri(b,A,R){const _=this._openers.get(b);if(!_)throw new Error(`Unknown opener id: '${b}'`);return _.openExternalUri(p.URI.revive(A.resolvedUri),{sourceUri:p.URI.revive(A.sourceUri)},R)}}e.ExtHostUriOpeners=I,I.supportedSchemes=new Set([C.Schemas.http,C.Schemas.https])}),define(De[216],Ce([1,0,5,2,7,11,27]),function(J,e,o,C,p,U,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class P{constructor(A){this.handles=new Set,this.handlers=new Map,this._proxy=A.getProxy(o.MainContext.MainThreadUrls)}registerUriHandler(A,R){if(this.handles.has(I.ExtensionIdentifier.toKey(A)))throw new Error(`Protocol handler already registered for extension ${A}`);const _=P.HandlePool++;return this.handles.add(I.ExtensionIdentifier.toKey(A)),this.handlers.set(_,R),this._proxy.$registerUriHandler(_,A),(0,p.toDisposable)(()=>{this.handles.delete(I.ExtensionIdentifier.toKey(A)),this.handlers.delete(_),this._proxy.$unregisterUriHandler(_)})}$handleExternalUri(A,R){const _=this.handlers.get(A);if(!_)return Promise.resolve(void 0);try{_.handleUri(C.URI.revive(R))}catch(m){(0,U.onUnexpectedError)(m)}return Promise.resolve(void 0)}async createAppUri(A){return C.URI.revive(await this._proxy.$createAppUri(A))}}e.ExtHostUrls=P,P.HandlePool=0});var Ye=this&&this.__classPrivateFieldSet||function(J,e,o,C,p){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!p)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!p:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?p.call(J,o):p?p.value=o:e.set(J,o),o},Ae=this&&this.__classPrivateFieldGet||function(J,e,o,C){if(o==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!C:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?C:o==="a"?C.call(J):C?C.value:e.get(J)};define(De[53],Ce([1,0,4,12,2,144,161,64,5]),function(J,e,o,C,p,U,I,P,b){"use strict";var A,R,_,m,T,g,h,u,l,S,w,a;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class y{constructor(E,f,D,L,W,N,v){A.set(this,void 0),R.set(this,void 0),_.set(this,void 0),m.set(this,void 0),T.set(this,void 0),g.set(this,void 0),h.set(this,""),u.set(this,void 0),l.set(this,!1),S.set(this,!1),w.set(this,!1),this._onMessageEmitter=new o.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,a.set(this,new o.Emitter),this._onDidDispose=Ae(this,a,"f").event,Ye(this,A,E,"f"),Ye(this,R,f,"f"),Ye(this,u,D,"f"),Ye(this,m,L,"f"),Ye(this,T,W,"f"),Ye(this,g,N,"f"),Ye(this,w,r(N),"f"),Ye(this,_,v,"f")}dispose(){Ye(this,l,!0,"f"),Ae(this,a,"f").fire(),Ae(this,a,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(E){return Ye(this,S,!0,"f"),(0,P.asWebviewUri)(E,Ae(this,m,"f"))}get cspSource(){const E=Ae(this,g,"f").extensionLocation;if(E.scheme===C.Schemas.https||E.scheme===C.Schemas.http){let f=E.toString();return f.endsWith("/")||(f+="/"),f+" "+P.webviewGenericCspSource}return P.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Ae(this,h,"f")}set html(E){this.assertNotDisposed(),Ae(this,h,"f")!==E&&(Ye(this,h,E,"f"),!Ae(this,S,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(E)&&(Ye(this,S,!0,"f"),Ae(this,_,"f").report("Webview vscode-resource: uris",Ae(this,g,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Ae(this,R,"f").$setHtml(Ae(this,A,"f"),E))}get options(){return this.assertNotDisposed(),Ae(this,u,"f")}set options(E){this.assertNotDisposed(),Ae(this,R,"f").$setOptions(Ae(this,A,"f"),s(Ae(this,g,"f"),Ae(this,T,"f"),E)),Ye(this,u,E,"f")}async postMessage(E){if(Ae(this,l,"f"))return!1;const f=(0,I.serializeWebviewMessage)(E,{serializeBuffersForPostMessage:Ae(this,w,"f")});return Ae(this,R,"f").$postMessage(Ae(this,A,"f"),f.message,...f.buffers)}assertNotDisposed(){if(Ae(this,l,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=y,A=new WeakMap,R=new WeakMap,_=new WeakMap,m=new WeakMap,T=new WeakMap,g=new WeakMap,h=new WeakMap,u=new WeakMap,l=new WeakMap,S=new WeakMap,w=new WeakMap,a=new WeakMap;function r(c){try{const E=(0,U.normalizeVersion)((0,U.parseVersion)(c.engines.vscode));return!!E&&E.majorBase>=1&&E.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=r;class d{constructor(E,f,D,L,W){this.remoteInfo=f,this.workspace=D,this._logService=L,this._deprecationService=W,this._webviews=new Map,this._webviewProxy=E.getProxy(b.MainContext.MainThreadWebviews)}$onMessage(E,f,D){const L=this.getWebview(E);if(L){const{message:W}=(0,I.deserializeWebviewMessage)(f,D.value);L._onMessageEmitter.fire(W)}}$onMissingCsp(E,f){this._logService.warn(`${f} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(E,f,D){const L=new y(E,this._webviewProxy,n(f),this.remoteInfo,this.workspace,D,this._deprecationService);return this._webviews.set(E,L),L._onDidDispose(()=>{this._webviews.delete(E)}),L}deleteWebview(E){this._webviews.delete(E)}getWebview(E){return this._webviews.get(E)}}e.ExtHostWebviews=d;function i(c){return{id:c.identifier,location:c.extensionLocation}}e.toExtensionData=i;function s(c,E,f){return{enableCommandUris:f.enableCommandUris,enableScripts:f.enableScripts,enableForms:f.enableForms,portMapping:f.portMapping,localResourceRoots:f.localResourceRoots||t(c,E)}}e.serializeWebviewOptions=s;function n(c){return{enableCommandUris:c.enableCommandUris,enableScripts:c.enableScripts,enableForms:c.enableForms,portMapping:c.portMapping,localResourceRoots:c.localResourceRoots?.map(E=>p.URI.from(E))}}e.reviveOptions=n;function t(c,E){return[...(E?.getWorkspaceFolders()||[]).map(f=>f.uri),c.extensionLocation]}}),define(De[217],Ce([1,0,20,96,7,12,21,2,8,53,61,5,6]),function(J,e,o,C,p,U,I,P,b,A,R,_,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class T{constructor(r,d){this.document=r,this._storagePath=d,this._backupCounter=1,this._edits=new R.Cache("custom documents")}addEdit(r){return this._edits.add([r])}async undo(r,d){await this.getEdit(r).undo(),d||this.disposeBackup()}async redo(r,d){await this.getEdit(r).redo(),d||this.disposeBackup()}disposeEdits(r){for(const d of r)this._edits.delete(d)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const r=a(this.document.uri)+this._backupCounter++;return(0,I.joinPath)(this._storagePath,r)}updateBackup(r){this._backup?.delete(),this._backup=r}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(r){const d=this._edits.get(r,0);if(!d)throw new Error("No edit found");return d}}class g{constructor(){this._documents=new Map}get(r,d){return this._documents.get(this.key(r,d))}add(r,d,i){const s=this.key(r,d.uri);if(this._documents.has(s))throw new Error(`Document already exists for viewType:${r} resource:${d.uri}`);const n=new T(d,i);return this._documents.set(s,n),n}delete(r,d){const i=this.key(r,d.uri);this._documents.delete(i)}key(r,d){return`${r}@@@${d}`}}var h;(function(y){y[y.Text=0]="Text",y[y.Custom=1]="Custom"})(h||(h={}));class u{constructor(){this._providers=new Map}addTextProvider(r,d,i){return this.add(0,r,d,i)}addCustomProvider(r,d,i){return this.add(1,r,d,i)}get(r){return this._providers.get(r)}add(r,d,i,s){if(this._providers.has(d))throw new Error(`Provider for viewType:${d} already registered`);return this._providers.set(d,{type:r,extension:i,provider:s}),new m.Disposable(()=>this._providers.delete(d))}}class l{constructor(r,d,i,s,n){this._extHostDocuments=d,this._extensionStoragePaths=i,this._extHostWebview=s,this._extHostWebviewPanels=n,this._editorProviders=new u,this._documents=new g,this._proxy=r.getProxy(_.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(r,d,i,s){const n=new p.DisposableStore;return S(i)?(n.add(this._editorProviders.addTextProvider(d,r,i)),this._proxy.$registerTextEditorProvider((0,A.toExtensionData)(r),d,s.webviewOptions||{},{supportsMove:!!i.moveCustomTextEditor},(0,A.shouldSerializeBuffersForPostMessage)(r))):(n.add(this._editorProviders.addCustomProvider(d,r,i)),this.supportEditing(i)&&n.add(i.onDidChangeCustomDocument(t=>{const c=this.getCustomDocumentEntry(d,t.document.uri);if(w(t)){const E=c.addEdit(t);this._proxy.$onDidEdit(t.document.uri,d,E,t.label)}else this._proxy.$onContentChange(t.document.uri,d)})),this._proxy.$registerCustomEditorProvider((0,A.toExtensionData)(r),d,s.webviewOptions||{},!!s.supportsMultipleEditorsPerDocument,(0,A.shouldSerializeBuffersForPostMessage)(r))),m.Disposable.from(n,new m.Disposable(()=>{this._proxy.$unregisterEditorProvider(d)}))}async $createCustomDocument(r,d,i,s,n){const t=this._editorProviders.get(d);if(!t)throw new Error(`No provider found for '${d}'`);if(t.type!==1)throw new Error(`Invalid provide type for '${d}'`);const c=P.URI.revive(r),E=await t.provider.openCustomDocument(c,{backupId:i,untitledDocumentData:s?.buffer},n);let f;return this.supportEditing(t.provider)&&this._extensionStoragePaths&&(f=this._extensionStoragePaths.workspaceValue(t.extension)??this._extensionStoragePaths.globalValue(t.extension)),this._documents.add(d,E,f),{editable:this.supportEditing(t.provider)}}async $disposeCustomDocument(r,d){const i=this._editorProviders.get(d);if(!i)throw new Error(`No provider found for '${d}'`);if(i.type!==1)throw new Error(`Invalid provider type for '${d}'`);const s=P.URI.revive(r),{document:n}=this.getCustomDocumentEntry(d,s);this._documents.delete(d,n),n.dispose()}async $resolveWebviewEditor(r,d,i,s,n,t){const c=this._editorProviders.get(i);if(!c)throw new Error(`No provider found for '${i}'`);const E=b.ViewColumn.to(n),f=this._extHostWebview.createNewWebview(d,s.webviewOptions,c.extension),D=this._extHostWebviewPanels.createNewWebviewPanel(d,i,s.title,E,s.panelOptions,f,!0),L=P.URI.revive(r);switch(c.type){case 1:{const{document:W}=this.getCustomDocumentEntry(i,L);return c.provider.resolveCustomEditor(W,D,t)}case 0:{const W=this._extHostDocuments.getDocument(L);return c.provider.resolveCustomTextEditor(W,D,t)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(r,d,i){this.getCustomDocumentEntry(d,r).disposeEdits(i)}async $onMoveCustomEditor(r,d,i){const s=this._editorProviders.get(i);if(!s)throw new Error(`No provider found for '${i}'`);if(!s.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${i}'`);const n=this._extHostWebviewPanels.getWebviewPanel(r);if(!n)throw new Error("No webview found");const t=P.URI.revive(d),c=this._extHostDocuments.getDocument(t);await s.provider.moveCustomTextEditor(c,n,o.CancellationToken.None)}async $undo(r,d,i,s){return this.getCustomDocumentEntry(d,r).undo(i,s)}async $redo(r,d,i,s){return this.getCustomDocumentEntry(d,r).redo(i,s)}async $revert(r,d,i){const s=this.getCustomDocumentEntry(d,r);await this.getCustomEditorProvider(d).revertCustomDocument(s.document,i),s.disposeBackup()}async $onSave(r,d,i){const s=this.getCustomDocumentEntry(d,r);await this.getCustomEditorProvider(d).saveCustomDocument(s.document,i),s.disposeBackup()}async $onSaveAs(r,d,i,s){const n=this.getCustomDocumentEntry(d,r);return this.getCustomEditorProvider(d).saveCustomDocumentAs(n.document,P.URI.revive(i),s)}async $backup(r,d,i){const s=this.getCustomDocumentEntry(d,r),t=await this.getCustomEditorProvider(d).backupCustomDocument(s.document,{destination:s.getNewBackupUri()},i);return s.updateBackup(t),t.id}getCustomDocumentEntry(r,d){const i=this._documents.get(r,P.URI.revive(d));if(!i)throw new Error("No custom document found");return i}getCustomEditorProvider(r){const i=this._editorProviders.get(r)?.provider;if(!i||!this.supportEditing(i))throw new Error("Custom document is not editable");return i}supportEditing(r){return!!r.onDidChangeCustomDocument}}e.ExtHostCustomEditors=l;function S(y){return typeof y.resolveCustomTextEditor=="function"}function w(y){return typeof y.undo=="function"&&typeof y.redo=="function"}function a(y){const r=y.scheme===U.Schemas.file||y.scheme===U.Schemas.untitled?y.fsPath:y.toString();return(0,C.hash)(r)+""}});var Ye=this&&this.__classPrivateFieldSet||function(J,e,o,C,p){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!p)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!p:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?p.call(J,o):p?p.value=o:e.set(J,o),o},Ae=this&&this.__classPrivateFieldGet||function(J,e,o,C){if(o==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!C:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?C:o==="a"?C.call(J):C?C.value:e.get(J)};define(De[218],Ce([1,0,4,7,2,43,8,53,5,6]),function(J,e,o,C,p,U,I,P,b,A){"use strict";var R,_,m,T,g,h,u,l,S,w,a,y,r;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class d extends C.Disposable{constructor(t,c,E,f){super();R.set(this,void 0),_.set(this,void 0),m.set(this,void 0),T.set(this,void 0),g.set(this,void 0),h.set(this,void 0),u.set(this,void 0),l.set(this,void 0),S.set(this,!0),w.set(this,void 0),a.set(this,!1),y.set(this,this._register(new o.Emitter)),this.onDidDispose=Ae(this,y,"f").event,r.set(this,this._register(new o.Emitter)),this.onDidChangeViewState=Ae(this,r,"f").event,Ye(this,R,t,"f"),Ye(this,_,c,"f"),Ye(this,T,E,"f"),Ye(this,m,f.viewType,"f"),Ye(this,g,f.panelOptions,"f"),Ye(this,l,f.viewColumn,"f"),Ye(this,h,f.title,"f"),Ye(this,w,f.active,"f")}dispose(){Ae(this,a,"f")||(Ye(this,a,!0,"f"),Ae(this,y,"f").fire(),Ae(this,_,"f").$disposeWebview(Ae(this,R,"f")),Ae(this,T,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Ae(this,T,"f")}get viewType(){return this.assertNotDisposed(),Ae(this,m,"f")}get title(){return this.assertNotDisposed(),Ae(this,h,"f")}set title(t){this.assertNotDisposed(),Ae(this,h,"f")!==t&&(Ye(this,h,t,"f"),Ae(this,_,"f").$setTitle(Ae(this,R,"f"),t))}get iconPath(){return this.assertNotDisposed(),Ae(this,u,"f")}set iconPath(t){this.assertNotDisposed(),Ae(this,u,"f")!==t&&(Ye(this,u,t,"f"),Ae(this,_,"f").$setIconPath(Ae(this,R,"f"),p.URI.isUri(t)?{light:t,dark:t}:t))}get options(){return Ae(this,g,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Ae(this,l,"f")=="number"&&Ae(this,l,"f")<0))return Ae(this,l,"f")}get active(){return this.assertNotDisposed(),Ae(this,w,"f")}get visible(){return this.assertNotDisposed(),Ae(this,S,"f")}_updateViewState(t){Ae(this,a,"f")||(this.active!==t.active||this.visible!==t.visible||this.viewColumn!==t.viewColumn)&&(Ye(this,w,t.active,"f"),Ye(this,S,t.visible,"f"),Ye(this,l,t.viewColumn,"f"),Ae(this,r,"f").fire({webviewPanel:this}))}reveal(t,c){this.assertNotDisposed(),Ae(this,_,"f").$reveal(Ae(this,R,"f"),{viewColumn:typeof t=="undefined"?void 0:I.ViewColumn.from(t),preserveFocus:!!c})}assertNotDisposed(){if(Ae(this,a,"f"))throw new Error("Webview is disposed")}}R=new WeakMap,_=new WeakMap,m=new WeakMap,T=new WeakMap,g=new WeakMap,h=new WeakMap,u=new WeakMap,l=new WeakMap,S=new WeakMap,w=new WeakMap,a=new WeakMap,y=new WeakMap,r=new WeakMap;class i{constructor(t,c,E){this.webviews=c,this.workspace=E,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=t.getProxy(b.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,U.generateUuid)()}createWebviewPanel(t,c,E,f,D={}){const L=typeof f=="object"?f.viewColumn:f,W={viewColumn:I.ViewColumn.from(L),preserveFocus:typeof f=="object"&&!!f.preserveFocus},N=(0,P.shouldSerializeBuffersForPostMessage)(t),v=i.newHandle();this._proxy.$createWebviewPanel((0,P.toExtensionData)(t),v,c,{title:E,panelOptions:s(D),webviewOptions:(0,P.serializeWebviewOptions)(t,this.workspace,D),serializeBuffersForPostMessage:N},W);const F=this.webviews.createNewWebview(v,D,t);return this.createNewWebviewPanel(v,c,E,L,D,F,!0)}$onDidChangeWebviewPanelViewStates(t){const c=Object.keys(t);c.sort((E,f)=>{const D=t[E],L=t[f];return D.active?1:L.active?-1:+D.visible-+L.visible});for(const E of c){const f=this.getWebviewPanel(E);if(!f)continue;const D=t[E];f._updateViewState({active:D.active,visible:D.visible,viewColumn:I.ViewColumn.to(D.position)})}}async $onDidDisposeWebviewPanel(t){this.getWebviewPanel(t)?.dispose(),this._webviewPanels.delete(t),this.webviews.deleteWebview(t)}registerWebviewPanelSerializer(t,c,E){if(this._serializers.has(c))throw new Error(`Serializer for '${c}' already registered`);return this._serializers.set(c,{serializer:E,extension:t}),this._proxy.$registerSerializer(c,{serializeBuffersForPostMessage:(0,P.shouldSerializeBuffersForPostMessage)(t)}),new A.Disposable(()=>{this._serializers.delete(c),this._proxy.$unregisterSerializer(c)})}async $deserializeWebviewPanel(t,c,E,f){const D=this._serializers.get(c);if(!D)throw new Error(`No serializer found for '${c}'`);const{serializer:L,extension:W}=D,N=this.webviews.createNewWebview(t,E.webviewOptions,W),v=this.createNewWebviewPanel(t,c,E.title,f,E.panelOptions,N,E.active);await L.deserializeWebviewPanel(v,E.state)}createNewWebviewPanel(t,c,E,f,D,L,W){const N=new d(t,this._proxy,L,{viewType:c,title:E,viewColumn:f,panelOptions:D,active:W});return this._webviewPanels.set(t,N),N}getWebviewPanel(t){return this._webviewPanels.get(t)}}e.ExtHostWebviewPanels=i;function s(n){return{enableFindWidget:n.enableFindWidget,retainContextWhenHidden:n.retainContextWhenHidden}}});var Ye=this&&this.__classPrivateFieldSet||function(J,e,o,C,p){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!p)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!p:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?p.call(J,o):p?p.value=o:e.set(J,o),o},Ae=this&&this.__classPrivateFieldGet||function(J,e,o,C){if(o==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!C:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?C:o==="a"?C.call(J):C?C.value:e.get(J)};define(De[219],Ce([1,0,4,7,53,25,8,5,6]),function(J,e,o,C,p,U,I,P,b){"use strict";var A,R,_,m,T,g,h,u,l,S,w,a;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class y extends C.Disposable{constructor(i,s,n,t,c,E,f){super();A.set(this,void 0),R.set(this,void 0),_.set(this,void 0),m.set(this,void 0),T.set(this,void 0),g.set(this,!1),h.set(this,void 0),u.set(this,void 0),l.set(this,void 0),S.set(this,void 0),w.set(this,this._register(new o.Emitter)),this.onDidChangeVisibility=Ae(this,w,"f").event,a.set(this,this._register(new o.Emitter)),this.onDidDispose=Ae(this,a,"f").event,Ye(this,_,n,"f"),Ye(this,u,t,"f"),Ye(this,A,i,"f"),Ye(this,R,s,"f"),Ye(this,m,c,"f"),Ye(this,T,E,"f"),Ye(this,h,f,"f")}dispose(){Ae(this,g,"f")||(Ye(this,g,!0,"f"),Ae(this,a,"f").fire(),Ae(this,m,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Ae(this,u,"f")}set title(i){this.assertNotDisposed(),Ae(this,u,"f")!==i&&(Ye(this,u,i,"f"),Ae(this,R,"f").$setWebviewViewTitle(Ae(this,A,"f"),i))}get description(){return this.assertNotDisposed(),Ae(this,l,"f")}set description(i){this.assertNotDisposed(),Ae(this,l,"f")!==i&&(Ye(this,l,i,"f"),Ae(this,R,"f").$setWebviewViewDescription(Ae(this,A,"f"),i))}get visible(){return Ae(this,h,"f")}get webview(){return Ae(this,m,"f")}get viewType(){return Ae(this,_,"f")}_setVisible(i){i===Ae(this,h,"f")||Ae(this,g,"f")||(Ye(this,h,i,"f"),Ae(this,w,"f").fire())}get badge(){return this.assertNotDisposed(),(0,U.checkProposedApiEnabled)(Ae(this,T,"f"),"badges"),Ae(this,S,"f")}set badge(i){this.assertNotDisposed(),(0,U.checkProposedApiEnabled)(Ae(this,T,"f"),"badges"),!(i?.value===Ae(this,S,"f")?.value&&i?.tooltip===Ae(this,S,"f")?.tooltip)&&(Ye(this,S,I.ViewBadge.from(i),"f"),Ae(this,R,"f").$setWebviewViewBadge(Ae(this,A,"f"),i))}show(i){this.assertNotDisposed(),Ae(this,R,"f").$show(Ae(this,A,"f"),!!i)}assertNotDisposed(){if(Ae(this,g,"f"))throw new Error("Webview is disposed")}}A=new WeakMap,R=new WeakMap,_=new WeakMap,m=new WeakMap,T=new WeakMap,g=new WeakMap,h=new WeakMap,u=new WeakMap,l=new WeakMap,S=new WeakMap,w=new WeakMap,a=new WeakMap;class r{constructor(i,s){this._extHostWebview=s,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=i.getProxy(P.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(i,s,n,t){if(this._viewProviders.has(s))throw new Error(`View provider for '${s}' already registered`);return this._viewProviders.set(s,{provider:n,extension:i}),this._proxy.$registerWebviewViewProvider((0,p.toExtensionData)(i),s,{retainContextWhenHidden:t?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,p.shouldSerializeBuffersForPostMessage)(i)}),new b.Disposable(()=>{this._viewProviders.delete(s),this._proxy.$unregisterWebviewViewProvider(s)})}async $resolveWebviewView(i,s,n,t,c){const E=this._viewProviders.get(s);if(!E)throw new Error(`No view provider found for '${s}'`);const{provider:f,extension:D}=E,L=this._extHostWebview.createNewWebview(i,{},D),W=new y(i,this._proxy,s,n,L,D,!0);this._webviewViews.set(i,W),await f.resolveWebviewView(W,{state:t},c)}async $onDidChangeWebviewViewVisibility(i,s){this.getWebviewView(i)._setVisible(s)}async $disposeWebviewView(i){const s=this.getWebviewView(i);this._webviewViews.delete(i),s.dispose(),this._extHostWebview.deleteWebview(i)}getWebviewView(i){const s=this._webviewViews.get(i);if(!s)throw new Error("No webview found");return s}}e.ExtHostWebviewViews=r}),define(De[97],Ce([1,0,4,5,2,12,10,3,15]),function(J,e,o,C,p,U,I,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let A=class Qi{constructor(_){this._onDidChangeWindowState=new o.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Qi.InitialState,this._proxy=_.getProxy(C.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(m=>this.$onDidChangeWindowFocus(m))}get state(){return this._state}$onDidChangeWindowFocus(_){_!==this._state.focused&&(this._state={...this._state,focused:_},this._onDidChangeWindowState.fire(this._state))}openUri(_,m){let T;if(typeof _=="string"){T=_;try{_=p.URI.parse(_)}catch{return Promise.reject(`Invalid uri - '${_}'`)}}return(0,I.isFalsyOrWhitespace)(_.scheme)?Promise.reject("Invalid scheme - cannot be empty"):_.scheme===U.Schemas.command?Promise.reject(`Invalid scheme '${_.scheme}'`):this._proxy.$openUri(_,T,m)}async asExternalUri(_,m){if((0,I.isFalsyOrWhitespace)(_.scheme))return Promise.reject("Invalid scheme - cannot be empty");const T=await this._proxy.$asExternalUri(_,m);return p.URI.from(T)}};A.InitialState={focused:!0},A=$e([xe(0,b.IExtHostRpcService)],A),e.ExtHostWindow=A,e.IExtHostWindow=(0,P.createDecorator)("IExtHostWindow")}),define(De[220],Ce([1,0,191,28,15]),function(J,e,o,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;let U=class extends o.AbstractExtHostConsoleForwarder{constructor(P,b){super(P,b)}_nativeConsoleLogMessage(P,b,A){b.apply(console,A)}};U=$e([xe(0,p.IExtHostRpcService),xe(1,C.IExtHostInitDataService)],U),e.ExtHostConsoleForwarder=U}),define(De[221],Ce([1,0,13,23,20,11,4,7,117,185,40]),function(J,e,o,C,p,U,I,P,b,A,R){"use strict";var _;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function m(D,L){try{return JSON.stringify(D,L)}catch{return"null"}}const T="$$ref$$",g={[T]:-1};class h{constructor(L,W){this.jsonString=L,this.referencedBuffers=W}}function u(D,L=null,W=!1){const N=[];return{jsonString:(W?m:JSON.stringify)(D,(F,O)=>{if(typeof O=="undefined")return g;if(typeof O=="object"){if(O instanceof C.VSBuffer){const H=N.push(O)-1;return{[T]:H}}if(L)return L(F,O)}return O}),referencedBuffers:N}}e.stringifyJsonWithBufferRefs=u;function l(D,L,W){return JSON.parse(D,(N,v)=>{if(v){const F=v[T];if(typeof F=="number")return L[F];if(W&&v.$mid===1)return W.transformIncoming(v)}return v})}e.parseJsonAndRestoreBufferRefs=l;function S(D,L){return JSON.stringify(D,L)}function w(D){return D?(L,W)=>W&&W.$mid===1?D.transformOutgoing(W):W:null}var a;(function(D){D[D.LocalSide=0]="LocalSide",D[D.OtherSide=1]="OtherSide"})(a=e.RequestInitiator||(e.RequestInitiator={}));var y;(function(D){D[D.Responsive=0]="Responsive",D[D.Unresponsive=1]="Unresponsive"})(y=e.ResponsiveState||(e.ResponsiveState={}));const r=()=>{},d=Symbol.for("rpcProtocol"),i=Symbol.for("rpcProxy");class s extends P.Disposable{constructor(L,W=null,N=null){super();this[_]=!0,this._onDidChangeResponsiveState=this._register(new I.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=L,this._logger=W,this._uriTransformer=N,this._uriReplacer=w(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let v=0,F=R.ProxyIdentifier.count;v<F;v++)this._locals[v]=null,this._proxies[v]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new o.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(v=>this._receiveOneMessage(v))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(L=>{this._pendingRPCReplies[L].resolveErr(U.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(L){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+s.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(L){this._unresponsiveTime=Date.now()+s.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(L){this._responsiveState!==L&&(this._responsiveState=L,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(L){return this._uriTransformer?(0,b.transformIncomingURIs)(L,this._uriTransformer):L}getProxy(L){const{nid:W,sid:N}=L;return this._proxies[W]||(this._proxies[W]=this._createProxy(W,N)),this._proxies[W]}_createProxy(L,W){const N={get:(v,F)=>(typeof F=="string"&&!v[F]&&F.charCodeAt(0)===36&&(v[F]=(...O)=>this._remoteCall(L,F,O)),F===i?W:v[F])};return new Proxy(Object.create(null),N)}set(L,W){return this._locals[L.nid]=W,W}assertRegistered(L){for(let W=0,N=L.length;W<N;W++){const v=L[W];if(!this._locals[v.nid])throw new Error(`Missing proxy instance ${v.sid}`)}}_receiveOneMessage(L){if(this._isDisposed)return;const W=L.byteLength,N=n.read(L,0),v=N.readUInt8(),F=N.readUInt32();switch(v){case 1:case 2:{let{rpcId:O,method:H,args:te}=c.deserializeRequestJSONArgs(N);this._uriTransformer&&(te=(0,b.transformIncomingURIs)(te,this._uriTransformer)),this._receiveRequest(W,F,O,H,te,v===2);break}case 3:case 4:{let{rpcId:O,method:H,args:te}=c.deserializeRequestMixedArgs(N);this._uriTransformer&&(te=(0,b.transformIncomingURIs)(te,this._uriTransformer)),this._receiveRequest(W,F,O,H,te,v===4);break}case 5:{this._logger?.logIncoming(W,F,0,"ack"),this._onDidReceiveAcknowledge(F);break}case 6:{this._receiveCancel(W,F);break}case 7:{this._receiveReply(W,F,void 0);break}case 9:{let O=c.deserializeReplyOKJSON(N);this._uriTransformer&&(O=(0,b.transformIncomingURIs)(O,this._uriTransformer)),this._receiveReply(W,F,O);break}case 10:{const O=c.deserializeReplyOKJSONWithBuffers(N,this._uriTransformer);this._receiveReply(W,F,O);break}case 8:{const O=c.deserializeReplyOKVSBuffer(N);this._receiveReply(W,F,O);break}case 11:{let O=c.deserializeReplyErrError(N);this._uriTransformer&&(O=(0,b.transformIncomingURIs)(O,this._uriTransformer)),this._receiveReplyErr(W,F,O);break}case 12:{this._receiveReplyErr(W,F,void 0);break}default:console.error("received unexpected message"),console.error(L)}}_receiveRequest(L,W,N,v,F,O){this._logger?.logIncoming(L,W,1,`receiveRequest ${(0,R.getStringIdentifierForProxy)(N)}.${v}(`,F);const H=String(W);let te,z;if(O){const ce=new p.CancellationTokenSource;F.push(ce.token),te=this._invokeHandler(N,v,F),z=()=>ce.cancel()}else te=this._invokeHandler(N,v,F),z=r;this._cancelInvokedHandlers[H]=z;const $=c.serializeAcknowledged(W);this._logger?.logOutgoing($.byteLength,W,1,"ack"),this._protocol.send($),te.then(ce=>{delete this._cancelInvokedHandlers[H];const le=c.serializeReplyOK(W,ce,this._uriReplacer);this._logger?.logOutgoing(le.byteLength,W,1,"reply:",ce),this._protocol.send(le)},ce=>{delete this._cancelInvokedHandlers[H];const le=c.serializeReplyErr(W,ce);this._logger?.logOutgoing(le.byteLength,W,1,"replyErr:",ce),this._protocol.send(le)})}_receiveCancel(L,W){this._logger?.logIncoming(L,W,1,"receiveCancel");const N=String(W);this._cancelInvokedHandlers[N]?.()}_receiveReply(L,W,N){this._logger?.logIncoming(L,W,0,"receiveReply:",N);const v=String(W);if(!this._pendingRPCReplies.hasOwnProperty(v))return;const F=this._pendingRPCReplies[v];delete this._pendingRPCReplies[v],F.resolveOk(N)}_receiveReplyErr(L,W,N){this._logger?.logIncoming(L,W,0,"receiveReplyErr:",N);const v=String(W);if(!this._pendingRPCReplies.hasOwnProperty(v))return;const F=this._pendingRPCReplies[v];delete this._pendingRPCReplies[v];let O;N&&(N.$isError?(O=new Error,O.name=N.name,O.message=N.message,O.stack=N.stack):O=N),F.resolveErr(O)}_invokeHandler(L,W,N){try{return Promise.resolve(this._doInvokeHandler(L,W,N))}catch(v){return Promise.reject(v)}}_doInvokeHandler(L,W,N){const v=this._locals[L];if(!v)throw new Error("Unknown actor "+(0,R.getStringIdentifierForProxy)(L));const F=v[W];if(typeof F!="function")throw new Error("Unknown method "+W+" on actor "+(0,R.getStringIdentifierForProxy)(L));return F.apply(v,N)}_remoteCall(L,W,N){if(this._isDisposed)return new A.CanceledLazyPromise;let v=null;if(N.length>0&&p.CancellationToken.isCancellationToken(N[N.length-1])&&(v=N.pop()),v&&v.isCancellationRequested)return Promise.reject(U.canceled());const F=c.serializeRequestArguments(N,this._uriReplacer),O=++this._lastMessageId,H=String(O),te=new A.LazyPromise;v&&v.onCancellationRequested(()=>{const $=c.serializeCancel(O);this._logger?.logOutgoing($.byteLength,O,0,"cancel"),this._protocol.send(c.serializeCancel(O))}),this._pendingRPCReplies[H]=te,this._onWillSendRequest(O);const z=c.serializeRequest(O,L,W,F,!!v);return this._logger?.logOutgoing(z.byteLength,O,0,`request: ${(0,R.getStringIdentifierForProxy)(L)}.${W}(`,N),this._protocol.send(z),te}}e.RPCProtocol=s,_=d,s.UNRESPONSIVE_TIME=3*1e3;class n{constructor(L,W){this._buff=L,this._offset=W}static alloc(L,W,N){const v=new n(C.VSBuffer.alloc(N+1+4),0);return v.writeUInt8(L),v.writeUInt32(W),v}static read(L,W){return new n(L,W)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(L){this._buff.writeUInt8(L,this._offset),this._offset+=1}readUInt8(){const L=this._buff.readUInt8(this._offset);return this._offset+=1,L}writeUInt32(L){this._buff.writeUInt32BE(L,this._offset),this._offset+=4}readUInt32(){const L=this._buff.readUInt32BE(this._offset);return this._offset+=4,L}static sizeShortString(L){return 1+L.byteLength}writeShortString(L){this._buff.writeUInt8(L.byteLength,this._offset),this._offset+=1,this._buff.set(L,this._offset),this._offset+=L.byteLength}readShortString(){const L=this._buff.readUInt8(this._offset);this._offset+=1;const N=this._buff.slice(this._offset,this._offset+L).toString();return this._offset+=L,N}static sizeLongString(L){return 4+L.byteLength}writeLongString(L){this._buff.writeUInt32BE(L.byteLength,this._offset),this._offset+=4,this._buff.set(L,this._offset),this._offset+=L.byteLength}readLongString(){const L=this._buff.readUInt32BE(this._offset);this._offset+=4;const N=this._buff.slice(this._offset,this._offset+L).toString();return this._offset+=L,N}writeBuffer(L){this._buff.writeUInt32BE(L.byteLength,this._offset),this._offset+=4,this._buff.set(L,this._offset),this._offset+=L.byteLength}static sizeVSBuffer(L){return 4+L.byteLength}writeVSBuffer(L){this._buff.writeUInt32BE(L.byteLength,this._offset),this._offset+=4,this._buff.set(L,this._offset),this._offset+=L.byteLength}readVSBuffer(){const L=this._buff.readUInt32BE(this._offset);this._offset+=4;const W=this._buff.slice(this._offset,this._offset+L);return this._offset+=L,W}static sizeMixedArray(L){let W=0;W+=1;for(let N=0,v=L.length;N<v;N++){const F=L[N];switch(W+=1,F.type){case 1:W+=this.sizeLongString(F.value);break;case 2:W+=this.sizeVSBuffer(F.value);break;case 3:W+=this.sizeUInt32,W+=this.sizeLongString(F.value);for(let O=0;O<F.buffers.length;++O)W+=this.sizeVSBuffer(F.buffers[O]);break;case 4:break}}return W}writeMixedArray(L){this._buff.writeUInt8(L.length,this._offset),this._offset+=1;for(let W=0,N=L.length;W<N;W++){const v=L[W];switch(v.type){case 1:this.writeUInt8(1),this.writeLongString(v.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(v.value);break;case 3:this.writeUInt8(3),this.writeUInt32(v.buffers.length),this.writeLongString(v.value);for(let F=0;F<v.buffers.length;++F)this.writeBuffer(v.buffers[F]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const L=this._buff.readUInt8(this._offset);this._offset+=1;const W=new Array(L);for(let N=0;N<L;N++)switch(this.readUInt8()){case 1:W[N]=this.readLongString();break;case 2:W[N]=this.readVSBuffer();break;case 3:{const F=this.readUInt32(),O=this.readLongString(),H=[];for(let te=0;te<F;++te)H.push(this.readVSBuffer());W[N]=new R.SerializableObjectWithBuffers(l(O,H,null));break}case 4:W[N]=void 0;break}return W}}n.sizeUInt32=4;var t;(function(D){D[D.Simple=0]="Simple",D[D.Mixed=1]="Mixed"})(t||(t={}));class c{static _useMixedArgSerialization(L){for(let W=0,N=L.length;W<N;W++)if(L[W]instanceof C.VSBuffer||L[W]instanceof R.SerializableObjectWithBuffers||typeof L[W]=="undefined")return!0;return!1}static serializeRequestArguments(L,W){if(this._useMixedArgSerialization(L)){const N=[];for(let v=0,F=L.length;v<F;v++){const O=L[v];if(O instanceof C.VSBuffer)N[v]={type:2,value:O};else if(typeof O=="undefined")N[v]={type:4};else if(O instanceof R.SerializableObjectWithBuffers){const{jsonString:H,referencedBuffers:te}=u(O.value,W);N[v]={type:3,value:C.VSBuffer.fromString(H),buffers:te}}else N[v]={type:1,value:C.VSBuffer.fromString(S(O,W))}}return{type:1,args:N}}return{type:0,args:S(L,W)}}static serializeRequest(L,W,N,v,F){switch(v.type){case 0:return this._requestJSONArgs(L,W,N,v.args,F);case 1:return this._requestMixedArgs(L,W,N,v.args,F)}}static _requestJSONArgs(L,W,N,v,F){const O=C.VSBuffer.fromString(N),H=C.VSBuffer.fromString(v);let te=0;te+=n.sizeUInt8(),te+=n.sizeShortString(O),te+=n.sizeLongString(H);const z=n.alloc(F?2:1,L,te);return z.writeUInt8(W),z.writeShortString(O),z.writeLongString(H),z.buffer}static deserializeRequestJSONArgs(L){const W=L.readUInt8(),N=L.readShortString(),v=L.readLongString();return{rpcId:W,method:N,args:JSON.parse(v)}}static _requestMixedArgs(L,W,N,v,F){const O=C.VSBuffer.fromString(N);let H=0;H+=n.sizeUInt8(),H+=n.sizeShortString(O),H+=n.sizeMixedArray(v);const te=n.alloc(F?4:3,L,H);return te.writeUInt8(W),te.writeShortString(O),te.writeMixedArray(v),te.buffer}static deserializeRequestMixedArgs(L){const W=L.readUInt8(),N=L.readShortString(),v=L.readMixedArray(),F=new Array(v.length);for(let O=0,H=v.length;O<H;O++){const te=v[O];typeof te=="string"?F[O]=JSON.parse(te):F[O]=te}return{rpcId:W,method:N,args:F}}static serializeAcknowledged(L){return n.alloc(5,L,0).buffer}static serializeCancel(L){return n.alloc(6,L,0).buffer}static serializeReplyOK(L,W,N){if(typeof W=="undefined")return this._serializeReplyOKEmpty(L);if(W instanceof C.VSBuffer)return this._serializeReplyOKVSBuffer(L,W);if(W instanceof R.SerializableObjectWithBuffers){const{jsonString:v,referencedBuffers:F}=u(W.value,N,!0);return this._serializeReplyOKJSONWithBuffers(L,v,F)}else return this._serializeReplyOKJSON(L,m(W,N))}static _serializeReplyOKEmpty(L){return n.alloc(7,L,0).buffer}static _serializeReplyOKVSBuffer(L,W){let N=0;N+=n.sizeVSBuffer(W);const v=n.alloc(8,L,N);return v.writeVSBuffer(W),v.buffer}static deserializeReplyOKVSBuffer(L){return L.readVSBuffer()}static _serializeReplyOKJSON(L,W){const N=C.VSBuffer.fromString(W);let v=0;v+=n.sizeLongString(N);const F=n.alloc(9,L,v);return F.writeLongString(N),F.buffer}static _serializeReplyOKJSONWithBuffers(L,W,N){const v=C.VSBuffer.fromString(W);let F=0;F+=n.sizeUInt32,F+=n.sizeLongString(v);for(const H of N)F+=n.sizeVSBuffer(H);const O=n.alloc(10,L,F);O.writeUInt32(N.length),O.writeLongString(v);for(const H of N)O.writeBuffer(H);return O.buffer}static deserializeReplyOKJSON(L){const W=L.readLongString();return JSON.parse(W)}static deserializeReplyOKJSONWithBuffers(L,W){const N=L.readUInt32(),v=L.readLongString(),F=[];for(let O=0;O<N;++O)F.push(L.readVSBuffer());return new R.SerializableObjectWithBuffers(l(v,F,W))}static serializeReplyErr(L,W){const N=W?m(U.transformErrorForSerialization(W),null):void 0;if(typeof N!="string")return this._serializeReplyErrEmpty(L);const v=C.VSBuffer.fromString(N);let F=0;F+=n.sizeLongString(v);const O=n.alloc(11,L,F);return O.writeLongString(v),O.buffer}static deserializeReplyErrError(L){const W=L.readLongString();return JSON.parse(W)}static _serializeReplyErrEmpty(L){return n.alloc(12,L,0).buffer}}var E;(function(D){D[D.RequestJSONArgs=1]="RequestJSONArgs",D[D.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",D[D.RequestMixedArgs=3]="RequestMixedArgs",D[D.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",D[D.Acknowledged=5]="Acknowledged",D[D.Cancel=6]="Cancel",D[D.ReplyOKEmpty=7]="ReplyOKEmpty",D[D.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",D[D.ReplyOKJSON=9]="ReplyOKJSON",D[D.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",D[D.ReplyErrError=11]="ReplyErrError",D[D.ReplyErrEmpty=12]="ReplyErrEmpty"})(E||(E={}));var f;(function(D){D[D.String=1]="String",D[D.VSBuffer=2]="VSBuffer",D[D.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",D[D.Undefined=4]="Undefined"})(f||(f={}))}),define(De[222],Ce([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const o=function(U){const I=P=>{self.removeEventListener("message",I);const b=P.data;Object.defineProperties(self,{postMessage:{value(A,R){b.postMessage(A,R)}},onmessage:{get(){return b.onmessage},set(A){b.onmessage=A}}}),b.addEventListener("message",A=>{self.dispatchEvent(new MessageEvent("message",{data:A.data}))}),b.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(U)};self.addEventListener("message",I)}.toString();class C extends EventTarget{constructor(U,I,P){super();this.onmessage=null,this.onmessageerror=null,this.onerror=null;const b=`((${o})('${I}'))`,A=new Blob([b],{type:"application/javascript"}),R=URL.createObjectURL(A),_=new MessageChannel,m=R,T={type:"_newWorker",id:m,port:_.port2,url:R,options:P};U(T,[_.port2]),this.postMessage=_.port1.postMessage.bind(_.port1),this.terminate=()=>{U({type:"_terminateWorker",id:m}),URL.revokeObjectURL(R),_.port1.close(),_.port2.close()},Object.defineProperties(this,{onmessage:{get(){return _.port1.onmessage},set(g){_.port1.onmessage=g}},onmessageerror:{get(){return _.port1.onmessageerror},set(g){_.port1.onmessageerror=g}}}),_.port1.addEventListener("messageerror",g=>{const h=new MessageEvent("messageerror",{data:g.data});this.dispatchEvent(h)}),_.port1.addEventListener("message",g=>{const h=new MessageEvent("message",{data:g.data});this.dispatchEvent(h)}),_.port1.start()}}e.NestedWorker=C}),define(De[223],Ce([1,0,4,30,38,3,39,11,13]),function(J,e,o,C,p,U,I,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerLogChannel=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new p.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new p.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new p.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,U.createDecorator)(e.OUTPUT_SERVICE_ID);var A;(function(T){T[T.Append=1]="Append",T[T.Replace=2]="Replace",T[T.Clear=3]="Clear"})(A=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class R{constructor(){this.channels=new Map,this._onDidRegisterChannel=new o.Emitter,this.onDidRegisterChannel=this._onDidRegisterChannel.event,this._onDidRemoveChannel=new o.Emitter,this.onDidRemoveChannel=this._onDidRemoveChannel.event}registerChannel(g){this.channels.has(g.id)||(this.channels.set(g.id,g),this._onDidRegisterChannel.fire(g.id))}getChannels(){const g=[];return this.channels.forEach(h=>g.push(h)),g}getChannel(g){return this.channels.get(g)}removeChannel(g){this.channels.delete(g),this._onDidRemoveChannel.fire(g)}}C.Registry.add(e.Extensions.OutputChannels,new R);function _(T,g,h,u,l){return(0,b.createCancelablePromise)(async S=>{await(0,I.whenProviderRegistered)(h,u);const w=C.Registry.as(e.Extensions.OutputChannels);try{await m(h,1,u,l,S),w.registerChannel({id:T,label:g,file:h,log:!0})}catch(a){(0,P.isCancellationError)(a)||l.error("Error while registering log channel",h.toString(),(0,P.getErrorMessage)(a))}})}e.registerLogChannel=_;async function m(T,g,h,u,l){if(!await h.exists(T)){if(l.isCancellationRequested)throw new P.CancellationError;if(g>10)throw new Error("Timed out while waiting for file to be created");u.debug("[Registering Log Channel] File does not exist. Waiting for 1s to retry.",T.toString()),await(0,b.timeout)(1e3,l),await m(T,g+1,h,u,l)}}}),define(De[98],Ce([1,0,5,7,3,15,14,223,51,28,35,111,23,9]),function(J,e,o,C,p,U,I,P,b,A,R,_,m,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.ExtHostOutputChannel=void 0;class g extends C.Disposable{constructor(l,S,w,a){super();this.id=l,this.name=S,this.logger=w,this.proxy=a,this.offset=0,this.visible=!1,this._disposed=!1}get disposed(){return this._disposed}appendLine(l){this.append(l+`
`)}append(l){this.write(l),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,P.OutputChannelUpdateMode.Append))}clear(){const l=this.offset;this.logger.flush(),this.proxy.$update(this.id,P.OutputChannelUpdateMode.Clear,l)}replace(l){const S=this.offset;this.write(l),this.proxy.$update(this.id,P.OutputChannelUpdateMode.Replace,S),this.visible&&this.logger.flush()}show(l,S){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof l=="boolean"?l:S))}hide(){this.proxy.$close(this.id)}write(l){this.offset+=m.VSBuffer.fromString(l).byteLength,this.logger.info(l)}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}e.ExtHostOutputChannel=g;let h=class{constructor(l,S,w,a,y){this.extHostFileSystem=w,this.extHostFileSystemInfo=a,this.loggerService=y,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=l.getProxy(o.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(S.logsLocation,`output_logging_${(0,_.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(l){this.visibleChannelId=l;for(const[S,w]of this.channels)w.visible=S===this.visibleChannelId}createOutputChannel(l,S,w){if(l=l.trim(),!l)throw new Error("illegal argument `name`. must not be falsy");if((0,T.isString)(S)&&!S.trim())throw new Error("illegal argument `languageId`. must not be empty");const a=this.doCreateOutputChannel(l,S,w);return a.then(y=>{this.channels.set(y.id,y),y.visible=y.id===this.visibleChannelId}),this.createExtHostOutputChannel(l,a)}async doCreateOutputChannel(l,S,w){const a=await this.createOutputDirectory(),y=this.extHostFileSystemInfo.extUri.joinPath(a,`${this.namePool++}-${l.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),r=this.loggerService.createLogger(y,{always:!0,donotRotate:!0,donotUseFormatters:!0}),d=await this.proxy.$register(l,!1,y,S,w.identifier.value);return new g(d,l,r,this.proxy)}createOutputDirectory(){return this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation)),this.outputDirectoryPromise}createExtHostOutputChannel(l,S){let w=!1;const a=()=>{if(w)throw new Error("Channel has been closed")};return{get name(){return l},append(y){a(),S.then(r=>r.append(y))},appendLine(y){a(),S.then(r=>r.appendLine(y))},clear(){a(),S.then(y=>y.clear())},replace(y){a(),S.then(r=>r.replace(y))},show(y,r){a(),S.then(d=>d.show(y,r))},hide(){a(),S.then(y=>y.hide())},dispose(){w=!0,S.then(y=>y.dispose())}}}};h=$e([xe(0,U.IExtHostRpcService),xe(1,A.IExtHostInitDataService),xe(2,b.IExtHostConsumerFileSystem),xe(3,R.IExtHostFileSystemInfo),xe(4,I.ILoggerService)],h),e.ExtHostOutputService=h,e.IExtHostOutputService=(0,p.createDecorator)("IExtHostOutputService")}),define(De[224],Ce([1,0,3]),function(J,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,o.createDecorator)("remoteAgentService")}),define(De[225],Ce([1,0,37,12,19,22,21,2,3,156,45,177,224]),function(J,e,o,C,p,U,I,P,b,A,R,_,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,b.createDecorator)("pathService");let T=class Yi{constructor(h,u,l,S){this.localUserHome=h,this.remoteAgentService=u,this.environmentService=l,this.contextService=S,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||U.OS)(),this.resolveUserHome=(async()=>{const w=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=w?.userHome??h})()}hasValidBasename(h,u,l){return typeof u=="string"||typeof u=="undefined"?this.resolveOS.then(S=>this.doHasValidBasename(h,S,u)):this.doHasValidBasename(h,u,l)}doHasValidBasename(h,u,l){return h.scheme===C.Schemas.file||h.scheme===C.Schemas.vscodeRemote?(0,o.isValidBasename)(l??(0,I.basename)(h),u===1):!0}get defaultUriScheme(){return Yi.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(h,u){if(h.remoteAuthority)return C.Schemas.vscodeRemote;const l=(0,A.getVirtualWorkspaceScheme)(u.getWorkspace());if(l)return l;const S=u.getWorkspace().folders[0];if(S)return S.uri.scheme;const w=u.getWorkspace().configuration;return w?w.scheme:C.Schemas.file}userHome(h){return h?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(h=>h===1?p.win32:p.posix)}async fileURI(h){let u="";if(await this.resolveOS===1&&(h=h.replace(/\\/g,"/")),h[0]==="/"&&h[1]==="/"){const S=h.indexOf("/",2);S===-1?(u=h.substring(2),h="/"):(u=h.substring(2,S),h=h.substring(S)||"/")}return P.URI.from({scheme:C.Schemas.file,authority:u,path:h,query:"",fragment:""})}};T=$e([xe(1,m.IRemoteAgentService),xe(2,_.IWorkbenchEnvironmentService),xe(3,R.IWorkspaceContextService)],T),e.AbstractPathService=T}),define(De[99],Ce([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class o{constructor(I,P){this.line=I,this.character=P}isBefore(I){return!1}isBeforeOrEqual(I){return!1}isAfter(I){return!1}isAfterOrEqual(I){return!1}isEqual(I){return!1}compareTo(I){return 0}translate(I,P){return new o(0,0)}with(I){return new o(0,0)}}e.Position=o;class C{constructor(I,P,b,A){this.isEmpty=!1,this.isSingleLine=!1,this.start=new o(I,P),this.end=new o(b,A)}contains(I){return!1}isEqual(I){return!1}intersection(I){}union(I){return new C(0,0,0,0)}with(I){return new C(0,0,0,0)}}e.Range=C;var p;(function(U){U[U.Information=1]="Information",U[U.Warning=2]="Warning"})(p=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(De[41],Ce([1,0,16,34,26,37,10,3,19,11,99,13]),function(J,e,o,C,p,U,I,P,b,A,R,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return R.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const m="\u27EA ",T=" characters skipped \u27EB",g=(m.length+T.length+5)*2;e.ISearchService=(0,P.createDecorator)("searchService");var h;(function(oe){oe[oe.file=0]="file",oe[oe.text=1]="text"})(h=e.SearchProviderType||(e.SearchProviderType={}));var u;(function(oe){oe[oe.File=1]="File",oe[oe.Text=2]="Text"})(u=e.QueryType||(e.QueryType={}));function l(oe){return!!oe.preview}e.resultIsMatch=l;function S(oe){return!!oe.resource}e.isFileMatch=S;function w(oe){return!!oe.message}e.isProgressMessage=w;var a;(function(oe){oe[oe.Normal=0]="Normal",oe[oe.NewSearchStarted=1]="NewSearchStarted"})(a=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class y{constructor(pe){this.resource=pe,this.results=[]}}e.FileMatch=y;class r{constructor(pe,re,Ee){this.ranges=re;const be=Array.isArray(re)?re:[re];if(Ee&&Ee.matchLines===1&&d(be)){pe=(0,I.getNLines)(pe,Ee.matchLines);let Z="",ve=0,Re=0;const Fe=Math.floor(Ee.charsPerLine/5),We=[];for(const Xe of be){const Ie=Math.max(Xe.startColumn-Fe,0),Se=Xe.startColumn+Ee.charsPerLine;if(Ie>Re+Fe+g){const Te=m+(Ie-Re)+T;Z+=Te+pe.slice(Ie,Se),ve+=Ie-(Re+Te.length)}else Z+=pe.slice(Re,Se);We.push(new s(0,Xe.startColumn-ve,Xe.endColumn-ve)),Re=Se}this.preview={text:Z,matches:Array.isArray(this.ranges)?We:We[0]}}else{const Z=Array.isArray(re)?re[0].startLineNumber:re.startLineNumber;this.preview={text:pe,matches:(0,o.mapArrayOrNot)(re,ve=>new i(ve.startLineNumber-Z,ve.startColumn,ve.endLineNumber-Z,ve.endColumn))}}}}e.TextSearchMatch=r;function d(oe){const pe=oe[0].startLineNumber;for(const re of oe)if(re.startLineNumber!==pe||re.endLineNumber!==pe)return!1;return!0}class i{constructor(pe,re,Ee,be){this.startLineNumber=pe,this.startColumn=re,this.endLineNumber=Ee,this.endColumn=be}}e.SearchRange=i;class s extends i{constructor(pe,re,Ee){super(pe,re,pe,Ee)}}e.OneLineRange=s;var n;(function(oe){oe.Default="default",oe.FileNames="fileNames",oe.Type="type",oe.Modified="modified",oe.CountDescending="countDescending",oe.CountAscending="countAscending"})(n=e.SearchSortOrder||(e.SearchSortOrder={}));function t(oe,pe=!0){const re=oe&&oe.files&&oe.files.exclude,Ee=pe&&oe&&oe.search&&oe.search.exclude;if(!re&&!Ee)return;if(!re||!Ee)return re||Ee;let be=Object.create(null);return be=p.mixin(be,p.deepClone(re)),be=p.mixin(be,p.deepClone(Ee),!0),be}e.getExcludes=t;function c(oe,pe){return oe.excludePattern&&C.match(oe.excludePattern,pe)?!1:oe.includePattern||oe.usingSearchPaths?oe.includePattern&&C.match(oe.includePattern,pe)?!0:oe.usingSearchPaths?!!oe.folderQueries&&oe.folderQueries.some(re=>{const Ee=re.folder.fsPath;if(U.isEqualOrParent(pe,Ee)){const be=b.relative(Ee,pe);return!re.includePattern||!!C.match(re.includePattern,be)}else return!1}):!1:!0}e.pathIncludedInQuery=c;var E;(function(oe){oe[oe.unknownEncoding=1]="unknownEncoding",oe[oe.regexParseError=2]="regexParseError",oe[oe.globParseError=3]="globParseError",oe[oe.invalidLiteral=4]="invalidLiteral",oe[oe.rgProcessError=5]="rgProcessError",oe[oe.other=6]="other",oe[oe.canceled=7]="canceled"})(E=e.SearchErrorCode||(e.SearchErrorCode={}));class f extends Error{constructor(pe,re){super(pe);this.code=re}}e.SearchError=f;function D(oe){const pe=oe.message;if((0,A.isCancellationError)(oe))return new f(pe,E.canceled);try{const re=JSON.parse(pe);return new f(re.message,re.code)}catch{return new f(pe,E.other)}}e.deserializeSearchError=D;function L(oe){const pe={message:oe.message,code:oe.code};return new Error(JSON.stringify(pe))}e.serializeSearchError=L;function W(oe){return oe.type==="error"?!0:oe.type==="success"}e.isSerializedSearchComplete=W;function N(oe){return oe.type==="success"}e.isSerializedSearchSuccess=N;function v(oe){return!!oe.path}e.isSerializedFileMatch=v;function F(oe,pe){const re=oe.searchPath?oe.searchPath:oe.relativePath;return(0,I.fuzzyContains)(re,pe)}e.isFilePatternMatch=F;class O{constructor(pe){this.path=pe,this.results=[]}addMatch(pe){this.results.push(pe)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=O;function H(oe,pe){const re={...oe||{},...pe||{}};return Object.keys(re).filter(Ee=>{const be=re[Ee];return typeof be=="boolean"&&be})}e.resolvePatternsForProvider=H;class te{constructor(pe,re){this._parsedIncludeExpression=null,this._excludeExpression={...pe.excludePattern||{},...re.excludePattern||{}},this._parsedExcludeExpression=C.parse(this._excludeExpression);let Ee=pe.includePattern;re.includePattern&&(Ee?Ee={...Ee,...re.includePattern}:Ee=re.includePattern),Ee&&(this._parsedIncludeExpression=C.parse(Ee))}matchesExcludesSync(pe,re,Ee){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(pe,re,Ee))}includedInQuerySync(pe,re,Ee){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(pe,re,Ee)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(pe,re,Ee))}includedInQuery(pe,re,Ee){const be=this._parsedExcludeExpression(pe,re,Ee),Z=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(pe,re,Ee):!0;return(0,_.isThenable)(be)?be.then(ve=>ve?!1:Z()):Z()}hasSiblingExcludeClauses(){return z(this._excludeExpression)}}e.QueryGlobTester=te;function z(oe){for(const pe in oe)if(typeof oe[pe]!="boolean")return!0;return!1}function $(oe){if(!oe)return;let pe;return re=>(pe||(pe=(oe()||Promise.resolve([])).then(Ee=>Ee?le(Ee):{})),pe.then(Ee=>!!Ee[re]))}e.hasSiblingPromiseFn=$;function ce(oe){if(!oe)return;let pe;return re=>{if(!pe){const Ee=oe();pe=Ee?le(Ee):{}}return!!pe[re]}}e.hasSiblingFn=ce;function le(oe){const pe={};for(const re of oe)pe[re]=!0;return pe}}),define(De[31],Ce([1,0,16,13,20,4,24,12,106,21,10,9,2,134,3,14,148,45,35,28,15,8,6,41,5]),function(J,e,o,C,p,U,I,P,b,A,R,_,m,T,g,h,u,l,S,w,a,y,r,d,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function s(W,N,v){return new A.ExtUri(F=>E(F,v)).isEqual(W,N)}function n(W,N,v){return s(W.uri,N.uri,v)?0:(0,R.compare)(W.uri.toString(),N.uri.toString())}function t(W,N,v){return W.index!==N.index?W.index<N.index?-1:1:s(W.uri,N.uri,v)?(0,R.compare)(W.name,N.name):(0,R.compare)(W.uri.toString(),N.uri.toString())}function c(W,N,v,F){const O=W.slice(0).sort((te,z)=>v(te,z,F)),H=N.slice(0).sort((te,z)=>v(te,z,F));return(0,o.delta)(O,H,(te,z)=>v(te,z,F))}function E(W,N){const v=N.getCapabilities(W.scheme);return!(v&&v&1024)}class f extends l.Workspace{constructor(N,v,F,O,H,te,z){super(N,F.map($=>new l.WorkspaceFolder($)),O,H,z);this._name=v,this._isUntitled=te,this._workspaceFolders=[],this._structure=I.TernarySearchTree.forUris(z),F.forEach($=>{this._workspaceFolders.push($),this._structure.set($.uri,$)})}static toExtHostWorkspace(N,v,F,O){if(!N)return{workspace:null,added:[],removed:[]};const{id:H,name:te,folders:z,configuration:$,transient:ce,isUntitled:le}=N,oe=[],pe=v;v?z.forEach((Z,ve)=>{const Re=m.URI.revive(Z.uri),Fe=f._findFolder(F||v,Re,O);Fe?(Fe.name=Z.name,Fe.index=Z.index,oe.push(Fe)):oe.push({uri:Re,name:Z.name,index:ve})}):oe.push(...z.map(({uri:Z,name:ve,index:Re})=>({uri:m.URI.revive(Z),name:ve,index:Re}))),oe.sort((Z,ve)=>Z.index<ve.index?-1:1);const re=new f(H,te,oe,!!ce,$?m.URI.revive($):null,!!le,Z=>E(Z,O)),{added:Ee,removed:be}=c(pe?pe.workspaceFolders:[],re.workspaceFolders,n,O);return{workspace:re,added:Ee,removed:be}}static _findFolder(N,v,F){for(let O=0;O<N.folders.length;O++){const H=N.workspaceFolders[O];if(s(H.uri,v,F))return H}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(N,v){return v&&this._structure.get(N)&&(N=(0,A.dirname)(N)),this._structure.findSubstr(N)}resolveWorkspaceFolder(N){return this._structure.get(N)}}let D=class{constructor(N,v,F,O){this._onDidChangeWorkspace=new U.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new U.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=O,this._extHostFileSystemInfo=F,this._requestIdProvider=new b.Counter,this._barrier=new C.Barrier,this._proxy=N.getProxy(i.MainContext.MainThreadWorkspace),this._messageService=N.getProxy(i.MainContext.MainThreadMessageService);const H=v.workspace;this._confirmedWorkspace=H?new f(H.id,H.name,[],!!H.transient,H.configuration?m.URI.revive(H.configuration):null,!!H.isUntitled,te=>E(te,F)):void 0}$initializeWorkspace(N,v){this._trusted=v,this.$acceptWorkspaceData(N),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?m.URI.from({scheme:P.Schemas.untitled,path:(0,A.basename)((0,A.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(N,v,F,...O){const H=[];if(Array.isArray(O)&&O.forEach(le=>{m.URI.isUri(le.uri)&&!H.some(oe=>s(oe.uri,le.uri,this._extHostFileSystemInfo))&&H.push({uri:le.uri,name:le.name||(0,A.basenameOrAuthority)(le.uri)})}),this._unconfirmedWorkspace||[v,F].some(le=>typeof le!="number"||le<0)||F===0&&H.length===0)return!1;const te=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(v+F>te.length)return!1;const z=te.slice(0);z.splice(v,F,...H.map(le=>({uri:le.uri,name:le.name||(0,A.basenameOrAuthority)(le.uri),index:void 0})));for(let le=0;le<z.length;le++){const oe=z[le];if(z.some((pe,re)=>re!==le&&s(oe.uri,pe.uri,this._extHostFileSystemInfo)))return!1}z.forEach((le,oe)=>le.index=oe);const{added:$,removed:ce}=c(te,z,t,this._extHostFileSystemInfo);if($.length===0&&ce.length===0)return!1;if(this._proxy){const le=N.displayName||N.name;this._proxy.$updateWorkspaceFolders(le,v,F,H).then(void 0,oe=>{this._unconfirmedWorkspace=void 0;const pe={source:{identifier:N.identifier,label:N.displayName||N.name}};this._messageService.$showMessage(u.Severity.Error,(0,T.localize)(0,null,le,oe.toString()),pe,[])})}return this.trySetWorkspaceFolders(z),!0}getWorkspaceFolder(N,v){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(N,v)}async getWorkspaceFolder2(N,v){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(N,v)}async resolveWorkspaceFolder(N){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(N)}getPath(){if(!this._actualWorkspace)return;const{folders:N}=this._actualWorkspace;if(N.length!==0)return N[0].uri.fsPath}getRelativePath(N,v){let F,O="";if(typeof N=="string"?(F=m.URI.file(N),O=N):typeof N!="undefined"&&(F=N,O=N.fsPath),!F)return O;const H=this.getWorkspaceFolder(F,!0);if(!H)return O;typeof v=="undefined"&&this._actualWorkspace&&(v=this._actualWorkspace.folders.length>1);let te=(0,A.relativePath)(H.uri,F);return v&&H.name&&(te=`${H.name}/${te}`),te}trySetWorkspaceFolders(N){this._actualWorkspace&&(this._unconfirmedWorkspace=f.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:N,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(N){const{workspace:v,added:F,removed:O}=f.toExtHostWorkspace(N,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=v||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:F,removed:O}))}findFiles(N,v,F,O,H=p.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${O.value}, entryPoint: findFiles`);let te;if(v===null?te=!1:v&&(typeof v=="string"?te=v:te=v.pattern),H&&H.isCancellationRequested)return Promise.resolve([]);const{includePattern:z,folder:$}=L(y.GlobPattern.from(N));return this._proxy.$startFileSearch((0,_.withUndefinedAsNull)(z),(0,_.withUndefinedAsNull)($),(0,_.withUndefinedAsNull)(te),(0,_.withUndefinedAsNull)(F),H).then(ce=>Array.isArray(ce)?ce.map(le=>m.URI.revive(le)):[])}async findTextInFiles(N,v,F,O,H=p.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${O.value}, entryPoint: findTextInFiles`);const te=this._requestIdProvider.getNext(),z=typeof v.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:v.previewOptions,{includePattern:$,folder:ce}=L(y.GlobPattern.from(v.include)),le=typeof v.exclude=="string"?v.exclude:v.exclude?v.exclude.pattern:void 0,oe={ignoreSymlinks:typeof v.followSymlinks=="boolean"?!v.followSymlinks:void 0,disregardIgnoreFiles:typeof v.useIgnoreFiles=="boolean"?!v.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof v.useGlobalIgnoreFiles=="boolean"?!v.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof v.useParentIgnoreFiles=="boolean"?!v.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof v.useDefaultExcludes=="boolean"?!v.useDefaultExcludes:!0,fileEncoding:v.encoding,maxResults:v.maxResults,previewOptions:z,afterContext:v.afterContext,beforeContext:v.beforeContext,includePattern:$,excludePattern:le},pe=!1;if(this._activeSearchCallbacks[te]=re=>{if(pe)return;const Ee=m.URI.revive(re.resource);re.results.forEach(be=>{(0,d.resultIsMatch)(be)?F({uri:Ee,preview:{text:be.preview.text,matches:(0,o.mapArrayOrNot)(be.preview.matches,Z=>new r.Range(Z.startLineNumber,Z.startColumn,Z.endLineNumber,Z.endColumn))},ranges:(0,o.mapArrayOrNot)(be.ranges,Z=>new r.Range(Z.startLineNumber,Z.startColumn,Z.endLineNumber,Z.endColumn))}):F({uri:Ee,text:be.text,lineNumber:be.lineNumber})})},H.isCancellationRequested)return{};try{const re=await this._proxy.$startTextSearch(N,(0,_.withUndefinedAsNull)(ce),oe,te,H);return delete this._activeSearchCallbacks[te],re||{}}catch(re){throw delete this._activeSearchCallbacks[te],re}}$handleTextSearchResult(N,v){this._activeSearchCallbacks[v]?.(N)}saveAll(N){return this._proxy.$saveAll(N)}resolveProxy(N){return this._proxy.$resolveProxy(N)}get trusted(){return this._trusted}requestWorkspaceTrust(N){return this._proxy.$requestWorkspaceTrust(N)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};D=$e([xe(0,a.IExtHostRpcService),xe(1,w.IExtHostInitDataService),xe(2,S.IExtHostFileSystemInfo),xe(3,h.ILogService)],D),e.ExtHostWorkspace=D,e.IExtHostWorkspace=(0,g.createDecorator)("IExtHostWorkspace");function L(W){let N,v;return W&&(typeof W=="string"?N=W:(N=W.pattern,v=m.URI.revive(W.baseUri))),{includePattern:N,folder:v}}}),define(De[32],Ce([1,0,26,4,31,5,6,151,83,9,13,3,15,14,2]),function(J,e,o,C,p,U,I,P,b,A,R,_,m,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function h(d,i){if(i){const s=i.split(".");let n=d;for(let t=0;n&&t<s.length;t++)n=n[s[t]];return n}}function u(d){return d instanceof g.URI}function l(d){return d&&d.uri instanceof g.URI&&d.languageId&&typeof d.languageId=="string"}function S(d){return d&&!d.uri&&d.languageId&&typeof d.languageId=="string"}function w(d){return d&&d.uri instanceof g.URI&&(!d.name||typeof d.name=="string")&&(!d.index||typeof d.index=="number")}function a(d){if(u(d))return{resource:d};if(l(d))return{resource:d.uri,overrideIdentifier:d.languageId};if(S(d))return{overrideIdentifier:d.languageId};if(w(d))return{resource:d.uri};if(d===null)return{resource:null}}let y=class{constructor(i,s,n){this._proxy=i.getProxy(U.MainContext.MainThreadConfiguration),this._extHostWorkspace=s,this._logService=n,this._barrier=new R.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(i=>this._actual)}$initializeConfiguration(i){this._actual=new r(this._proxy,this._extHostWorkspace,i,this._logService),this._barrier.open()}$acceptConfigurationChanged(i,s){this.getConfigProvider().then(n=>n.$acceptConfigurationChanged(i,s))}};y=$e([xe(0,m.IExtHostRpcService),xe(1,p.IExtHostWorkspace),xe(2,T.ILogService)],y),e.ExtHostConfiguration=y;class r{constructor(i,s,n,t){this._onDidChangeConfiguration=new C.Emitter,this._proxy=i,this._logService=t,this._extHostWorkspace=s,this._configuration=P.Configuration.parse(n),this._configurationScopes=this._toMap(n.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(i,s){const n={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=P.Configuration.parse(i),this._configurationScopes=this._toMap(i.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(s,n))}getConfiguration(i,s,n){const t=a(s)||{},c=this._toReadonlyValue(i?h(this._configuration.getValue(void 0,t,this._extHostWorkspace.workspace),i):this._configuration.getValue(void 0,t,this._extHostWorkspace.workspace));i&&this._validateConfigurationAccess(i,t,n?.identifier);function E(D){if(D==null)return null;if(typeof D=="boolean")return D?1:4;switch(D){case I.ConfigurationTarget.Global:return 1;case I.ConfigurationTarget.Workspace:return 4;case I.ConfigurationTarget.WorkspaceFolder:return 5}}const f={has(D){return typeof h(c,D)!="undefined"},get:(D,L)=>{this._validateConfigurationAccess(i?`${i}.${D}`:D,t,n?.identifier);let W=h(c,D);if(typeof W=="undefined")W=L;else{let N;const v=(F,O)=>{let H;const te=()=>{N=N||(0,o.deepClone)(c),H=H||h(N,O)};return(0,A.isObject)(F)?new Proxy(F,{get:(z,$)=>{if(typeof $=="string"&&$.toLowerCase()==="tojson")return te(),()=>H;if(N)return H=H||h(N,O),H[$];const ce=z[$];return typeof $=="string"?v(ce,`${O}.${$}`):ce},set:(z,$,ce)=>(te(),H&&(H[$]=ce),!0),deleteProperty:(z,$)=>(te(),H&&delete H[$],!0),defineProperty:(z,$,ce)=>(te(),H&&Object.defineProperty(H,$,ce),!0)}):F};W=v(W,D)}return W},update:(D,L,W,N)=>{D=i?`${i}.${D}`:D;const v=E(W);return L!==void 0?this._proxy.$updateConfigurationOption(v,D,L,t,N):this._proxy.$removeConfigurationOption(v,D,t,N)},inspect:D=>{D=i?`${i}.${D}`:D;const L=(0,o.deepClone)(this._configuration.inspect(D,t,this._extHostWorkspace.workspace));if(L)return{key:D,defaultValue:L.policy?.value??L.default?.value,globalValue:L.user?.value??L.application?.value,workspaceValue:L.workspace?.value,workspaceFolderValue:L.workspaceFolder?.value,defaultLanguageValue:L.default?.override,globalLanguageValue:L.user?.override??L.application?.override,workspaceLanguageValue:L.workspace?.override,workspaceFolderLanguageValue:L.workspaceFolder?.override,languageIds:L.overrideIdentifiers}}};return typeof c=="object"&&(0,o.mixin)(f,c,!1),Object.freeze(f)}_toReadonlyValue(i){const s=n=>(0,A.isObject)(n)?new Proxy(n,{get:(t,c)=>s(t[c]),set:(t,c,E)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(c)}' of object`)},deleteProperty:(t,c)=>{throw new Error(`TypeError: Cannot delete read only property '${String(c)}' of object`)},defineProperty:(t,c)=>{throw new Error(`TypeError: Cannot define property '${String(c)}' for a readonly object`)},setPrototypeOf:t=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):n;return s(i)}_validateConfigurationAccess(i,s,n){const t=b.OVERRIDE_PROPERTY_REGEX.test(i)?4:this._configurationScopes.get(i),c=n?`[${n.value}] `:"";if(t===4){typeof s?.resource=="undefined"&&this._logService.warn(`${c}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${i}', provide the URI of a resource or 'null' for any resource.`);return}if(t===3){s?.resource&&this._logService.warn(`${c}Accessing a window scoped configuration for a resource is not expected. To associate '${i}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(i,s){const n=new P.ConfigurationChangeEvent(i,s,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(t,c)=>n.affectsConfiguration(t,a(c))})}_toMap(i){return i.reduce((s,n)=>(s.set(n[0],n[1]),s),new Map)}}e.ExtHostConfigProvider=r,e.IExtHostConfiguration=(0,_.createDecorator)("IExtHostConfiguration")});var Ye=this&&this.__classPrivateFieldSet||function(J,e,o,C,p){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!p)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!p:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?p.call(J,o):p?p.value=o:e.set(J,o),o},Ae=this&&this.__classPrivateFieldGet||function(J,e,o,C){if(o==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!C:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?C:o==="a"?C.call(J):C?C.value:e.get(J)};define(De[100],Ce([1,0,2,13,4,5,6,31,49,32,20,52,15,28,3,12,22,14,68,184,11]),function(J,e,o,C,p,U,I,P,b,A,R,_,m,T,g,h,u,l,S,w,a){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var r;(function(O){function H(z){if(z!=null)return z}O.from=H;function te(z){if(z!=null)return z}O.to=te})(r=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var d;(function(O){function H(z){if(z!=null)return z}O.from=H;function te(z){if(z!=null)return z}O.to=te})(d=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var i;(function(O){function H(z){if(z!=null)return z}O.from=H;function te(z){if(z!=null)return z}O.to=te})(i=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var s;(function(O){function H($){if($){const ce=$;return ce&&!!ce.process}else return!1}O.is=H;function te($){if($==null)return;const ce={process:$.process,args:$.args};return $.options&&(ce.options=i.from($.options)),ce}O.from=te;function z($){if($!=null)return new I.ProcessExecution($.process,$.args,$.options)}O.to=z})(s=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var n;(function(O){function H(z){if(z!=null)return z}O.from=H;function te(z){if(z!=null)return z}O.to=te})(n=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var t;(function(O){function H($){if($){const ce=$;return ce&&(!!ce.commandLine||!!ce.command)}else return!1}O.is=H;function te($){if($==null)return;const ce={};return $.commandLine!==void 0?ce.commandLine=$.commandLine:(ce.command=$.command,ce.args=$.args),$.options&&(ce.options=n.from($.options)),ce}O.from=te;function z($){if(!($==null||$.command===void 0&&$.commandLine===void 0))return $.commandLine?new I.ShellExecution($.commandLine,$.options):new I.ShellExecution($.command,$.args?$.args:[],$.options)}O.to=z})(t=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var c;(function(O){function H($){if($){const ce=$;return ce&&ce.customExecution==="customExecution"}else return!1}O.is=H;function te($){return{customExecution:"customExecution"}}O.from=te;function z($,ce){return ce.get($)}O.to=z})(c=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var E;(function(O){function H(te,z){let $;return te.scope!==void 0&&typeof te.scope!="number"?$=te.scope.uri:te.scope!==void 0&&typeof te.scope=="number"&&(te.scope===I.TaskScope.Workspace&&z&&z.workspaceFile?$=z.workspaceFile:$=w.USER_TASKS_GROUP_KEY),{id:te._id,workspaceFolder:$}}O.from=H})(E=e.TaskHandleDTO||(e.TaskHandleDTO={}));var f;(function(O){function H(te){if(te!=null)return{_id:te.id,isDefault:te.isDefault}}O.from=H})(f=e.TaskGroupDTO||(e.TaskGroupDTO={}));var D;(function(O){function H($,ce){if($==null)return[];const le=[];for(const oe of $){const pe=te(oe,ce);pe&&le.push(pe)}return le}O.fromMany=H;function te($,ce){if($==null)return;let le;$.execution instanceof I.ProcessExecution?le=s.from($.execution):$.execution instanceof I.ShellExecution?le=t.from($.execution):$.execution&&$.execution instanceof I.CustomExecution&&(le=c.from($.execution));const oe=r.from($.definition);let pe;return $.scope?typeof $.scope=="number"?pe=$.scope:pe=$.scope.uri:pe=I.TaskScope.Workspace,!oe||!pe?void 0:{_id:$._id,definition:oe,name:$.name,source:{extensionId:ce.identifier.value,label:$.source,scope:pe},execution:le,isBackground:$.isBackground,group:f.from($.group),presentationOptions:d.from($.presentationOptions),problemMatchers:$.problemMatchers,hasDefinedMatchers:$.hasDefinedMatchers,runOptions:$.runOptions?$.runOptions:{reevaluateOnRerun:!0},detail:$.detail}}O.from=te;async function z($,ce,le){if($==null)return;let oe;s.is($.execution)?oe=s.to($.execution):t.is($.execution)?oe=t.to($.execution):c.is($.execution)&&(oe=c.to($._id,le));const pe=r.to($.definition);let re;if($.source&&($.source.scope!==void 0?typeof $.source.scope=="number"?re=$.source.scope:re=await ce.resolveWorkspaceFolder(o.URI.revive($.source.scope)):re=I.TaskScope.Workspace),!pe||!re)return;const Ee=new I.Task(pe,re,$.name,$.source.label,oe,$.problemMatchers);return $.isBackground!==void 0&&(Ee.isBackground=$.isBackground),$.group!==void 0&&(Ee.group=I.TaskGroup.from($.group._id),Ee.group&&$.group.isDefault&&(Ee.group=new I.TaskGroup(Ee.group.id,Ee.group.label),$.group.isDefault===!0&&(Ee.group.isDefault=$.group.isDefault))),$.presentationOptions&&(Ee.presentationOptions=d.to($.presentationOptions)),$._id&&(Ee._id=$._id),$.detail&&(Ee.detail=$.detail),Ee}O.to=z})(D=e.TaskDTO||(e.TaskDTO={}));var L;(function(O){function H(z){return z}O.from=H;function te(z){if(!!z)return Object.assign(Object.create(null),z)}O.to=te})(L=e.TaskFilterDTO||(e.TaskFilterDTO={}));class W{constructor(H,te,z){this._id=te,this._task=z,y.set(this,void 0),Ye(this,y,H,"f")}get task(){return this._task}terminate(){Ae(this,y,"f").terminateTask(this)}fireDidStartProcess(H){}fireDidEndProcess(H){}}y=new WeakMap;var N;(function(O){function H(te){return{id:te._id,task:void 0}}O.from=H})(N=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let v=class{constructor(H,te,z,$,ce,le,oe,pe){this._onDidExecuteTask=new p.Emitter,this._onDidTerminateTask=new p.Emitter,this._onDidTaskProcessStarted=new p.Emitter,this._onDidTaskProcessEnded=new p.Emitter,this._proxy=H.getProxy(U.MainContext.MainThreadTask),this._workspaceProvider=z,this._editorService=$,this._configurationService=ce,this._terminalService=le,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=oe,this._deprecationService=pe,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(H,te,z){if(!z)return new I.Disposable(()=>{});const $=this.nextHandle();return this._handlers.set($,{type:te,provider:z,extension:H}),this._proxy.$registerTaskProvider($,te),new I.Disposable(()=>{this._handlers.delete($),this._proxy.$unregisterTaskProvider($)})}registerTaskSystem(H,te){this._proxy.$registerTaskSystem(H,te)}fetchTasks(H){return this._proxy.$fetchTasks(L.from(H)).then(async te=>{const z=[];for(const $ of te){const ce=await D.to($,this._workspaceProvider,this._providedCustomExecutions2);ce&&z.push(ce)}return z})}get taskExecutions(){const H=[];return this._taskExecutions.forEach(te=>H.push(te)),H}terminateTask(H){if(!(H instanceof W))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(H._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(H,te,z){const $=this._providedCustomExecutions2.get(H.id);$&&(this._activeCustomExecutions2.set(H.id,$),this._terminalService.attachPtyToTerminal(te,await $.callback(z))),this._lastStartedTask=H.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(H)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(H){const te=await this.getTaskExecution(H);this._taskExecutionPromises.delete(H.id),this._taskExecutions.delete(H.id),this.customExecutionComplete(H),this._onDidTerminateTask.fire({execution:te})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(H){const te=await this.getTaskExecution(H.id);this._onDidTaskProcessStarted.fire({execution:te,processId:H.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(H){const te=await this.getTaskExecution(H.id);this._onDidTaskProcessEnded.fire({execution:te,exitCode:H.exitCode})}$provideTasks(H,te){const z=this._handlers.get(H);if(!z)return Promise.reject(new Error("no handler found"));const $=[],ce=(0,C.asPromise)(()=>z.provider.provideTasks(R.CancellationToken.None)).then(le=>this.provideTasksInternal(te,$,z,le));return new Promise(le=>{ce.then(oe=>{Promise.all($).then(()=>{le(oe)})})})}async $resolveTask(H,te){const z=this._handlers.get(H);if(!z)return Promise.reject(new Error("no handler found"));if(te.definition.type!==z.type)throw new Error(`Unexpected: Task of type [${te.definition.type}] cannot be resolved by provider of type [${z.type}].`);const $=await D.to(te,this._workspaceProvider,this._providedCustomExecutions2);if(!$)throw new Error("Unexpected: Task cannot be resolved.");const ce=await z.provider.resolveTask($,R.CancellationToken.None);if(!ce)return;this.checkDeprecation(ce,z);const le=D.from(ce,z.extension);if(!le)throw new Error("Unexpected: Task cannot be resolved.");if(ce.definition!==$.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return c.is(le.execution)&&await this.addCustomExecution(le,ce,!0),await this.resolveTaskInternal(le)}nextHandle(){return this._handleCounter++}async addCustomExecution(H,te,z){const $=await this._proxy.$createTaskId(H);!z&&!this._providedCustomExecutions2.has($)&&(this._notProvidedCustomExecutions.add($),this._activeCustomExecutions2.set($,te.execution)),this._providedCustomExecutions2.set($,te.execution)}async getTaskExecution(H,te){if(typeof H=="string"){const ce=this._taskExecutionPromises.get(H);if(!ce)throw new Error("Unexpected: The specified task is missing an execution");return ce}const z=this._taskExecutionPromises.get(H.id);if(z)return z;const $=new Promise((ce,le)=>{function oe(pe,re,Ee){Ee?ce(new W(pe,re.id,Ee)):le("Unexpected: Task does not exist.")}te?oe(this,H,te):D.to(H.task,this._workspaceProvider,this._providedCustomExecutions2).then(pe=>oe(this,H,pe))});return this._taskExecutionPromises.set(H.id,$),$.then(ce=>(this._taskExecutions.set(H.id,ce),ce),ce=>Promise.reject(ce))}checkDeprecation(H,te){H._deprecated&&this._deprecationService.report("Task.constructor",te.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(H){this._activeCustomExecutions2.get(H.id)&&this._activeCustomExecutions2.delete(H.id),this._notProvidedCustomExecutions.has(H.id)&&this._lastStartedTask!==H.id&&(this._providedCustomExecutions2.delete(H.id),this._notProvidedCustomExecutions.delete(H.id));const z=this._notProvidedCustomExecutions.values();let $=z.next();for(;!$.done;)!this._activeCustomExecutions2.has($.value)&&this._lastStartedTask!==$.value&&(this._providedCustomExecutions2.delete($.value),this._notProvidedCustomExecutions.delete($.value)),$=z.next()}};v=$e([xe(0,m.IExtHostRpcService),xe(1,T.IExtHostInitDataService),xe(2,P.IExtHostWorkspace),xe(3,b.IExtHostDocumentsAndEditors),xe(4,A.IExtHostConfiguration),xe(5,_.IExtHostTerminalService),xe(6,l.ILogService),xe(7,S.IExtHostApiDeprecationService)],v),e.ExtHostTaskBase=v;let F=class extends v{constructor(H,te,z,$,ce,le,oe,pe){super(H,te,z,$,ce,le,oe,pe);this.registerTaskSystem(h.Schemas.vscodeRemote,{scheme:h.Schemas.vscodeRemote,authority:"",platform:u.PlatformToString(0)})}async executeTask(H,te){if(!te.execution)throw new Error("Tasks to execute must include an execution");const z=D.from(te,H);if(z===void 0)throw new Error("Task is not valid");if(c.is(z.execution))await this.addCustomExecution(z,te,!1);else throw new a.NotSupportedError;const $=await this.getTaskExecution(await this._proxy.$getTaskExecution(z),te);return this._proxy.$executeTask(z).catch(ce=>{throw new Error(ce)}),$}provideTasksInternal(H,te,z,$){const ce=[];if($)for(const le of $){this.checkDeprecation(le,z),(!le.definition||!H[le.definition.type])&&this._logService.warn(`The task [${le.source}, ${le.name}] uses an undefined task type. The task will be ignored in the future.`);const oe=D.from(le,z.extension);oe&&c.is(oe.execution)?(ce.push(oe),te.push(this.addCustomExecution(oe,le,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:ce,extension:z.extension}}async resolveTaskInternal(H){if(c.is(H.execution))return H;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(H,te){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(H,te,z){}};F=$e([xe(0,m.IExtHostRpcService),xe(1,T.IExtHostInitDataService),xe(2,P.IExtHostWorkspace),xe(3,b.IExtHostDocumentsAndEditors),xe(4,A.IExtHostConfiguration),xe(5,_.IExtHostTerminalService),xe(6,l.ILogService),xe(7,S.IExtHostApiDeprecationService)],F),e.WorkerExtHostTask=F,e.IExtHostTask=(0,g.createDecorator)("IExtHostTask")}),define(De[226],Ce([1,0,19,20,44,34,21,202,41]),function(J,e,o,C,p,U,I,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class A{constructor(m,T,g){this.config=m,this.provider=T,this.sessionToken=g,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=m.filePattern,this.includePattern=m.includePattern&&U.parse(m.includePattern),this.maxResults=m.maxResults||void 0,this.exists=m.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=m.excludePattern&&U.parse(m.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(m=>m.cancel()),this.activeCancellationTokens=new Set}search(m){const T=this.config.folderQueries||[];return new Promise((g,h)=>{const u=l=>{this.resultCount++,m(l)};if(this.isCanceled)return g({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(l=>{const S=l.toString(),w=o.basename(S);this.globalExcludePattern&&this.globalExcludePattern(S,w)||this.matchFile(u,{base:l,basename:w})}),Promise.all(T.map(l=>this.searchInFolder(l,u))).then(l=>{g({limitHit:this.isLimitHit,stats:l[0]||void 0})},l=>{h(new Error((0,p.toErrorMessage)(l)))})})}async searchInFolder(m,T){const g=new C.CancellationTokenSource,h=this.getSearchOptionsForFolder(m),u=this.initDirectoryTree(),l=new b.QueryGlobTester(this.config,m),S=!l.hasSiblingExcludeClauses();let w;try{this.activeCancellationTokens.add(g),w=P.StopWatch.create();const a=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},h,g.token),y=w.elapsed(),r=P.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(a&&a.forEach(d=>{const i=o.posix.relative(m.folder.path,d.path);if(S){const s=o.basename(d.path);this.matchFile(T,{base:m.folder,relativePath:i,basename:s});return}this.addDirectoryEntries(u,m.folder,i,T)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(u,l,T),{providerTime:y,postProcessTime:r.elapsed()})}finally{g.dispose(),this.activeCancellationTokens.delete(g)}}getSearchOptionsForFolder(m){const T=(0,b.resolvePatternsForProvider)(this.config.includePattern,m.includePattern),g=(0,b.resolvePatternsForProvider)(this.config.excludePattern,m.excludePattern);return{folder:m.folder,excludes:g,includes:T,useIgnoreFiles:!m.disregardIgnoreFiles,useGlobalIgnoreFiles:!m.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!m.disregardParentIgnoreFiles,followSymlinks:!m.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const m={rootEntries:[],pathToEntries:Object.create(null)};return m.pathToEntries["."]=m.rootEntries,m}addDirectoryEntries({pathToEntries:m},T,g,h){if(g===this.filePattern){const l=o.basename(this.filePattern);this.matchFile(h,{base:T,relativePath:this.filePattern,basename:l})}function u(l){const S=o.basename(l),w=o.dirname(l);let a=m[w];a||(a=m[w]=[],u(w)),a.push({base:T,relativePath:l,basename:S})}u(g)}matchDirectoryTree({rootEntries:m,pathToEntries:T},g,h){const u=this,l=this.filePattern;function S(w){const a=(0,b.hasSiblingFn)(()=>w.map(y=>y.basename));for(let y=0,r=w.length;y<r;y++){const d=w[y],{relativePath:i,basename:s}=d;if(g.matchesExcludesSync(i,s,l!==s?a:void 0))continue;const n=T[i];if(n)S(n);else{if(i===l)continue;u.matchFile(h,d)}if(u.isLimitHit)break}}S(m)}matchFile(m,T){(!this.includePattern||T.relativePath&&this.includePattern(T.relativePath,T.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||m(T))}}class R{constructor(){this.sessions=new Map}fileSearch(m,T,g,h){const u=this.getSessionTokenSource(m.cacheKey),l=new A(m,T,u&&u.token);let S=0;const w=a=>{S+=a.length,g(a.map(y=>this.rawMatchToSearchItem(y)))};return this.doSearch(l,R.BATCH_SIZE,w,h).then(a=>({limitHit:a.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:S,detailStats:a.stats}}))}clearCache(m){const T=this.getSessionTokenSource(m);T&&T.cancel()}getSessionTokenSource(m){if(!!m)return this.sessions.has(m)||this.sessions.set(m,new C.CancellationTokenSource),this.sessions.get(m)}rawMatchToSearchItem(m){return m.relativePath?{resource:I.joinPath(m.base,m.relativePath)}:{resource:m.base}}doSearch(m,T,g,h){h.onCancellationRequested(()=>{m.cancel()});const u=S=>{S&&(l.push(S),T>0&&l.length>=T&&(g(l),l=[]))};let l=[];return m.search(u).then(S=>(l.length&&g(l),S),S=>(l.length&&g(l),Promise.reject(S)))}}e.FileSearchManager=R,R.BATCH_SIZE=512}),define(De[227],Ce([1,0,16,72,34,76,24,12,19,21,10,9,2,244,142,57,14,45,90,225,41]),function(J,e,o,C,p,U,I,P,b,A,R,_,m,T,g,h,u,l,S,w,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let y=class{constructor(f,D,L,W,N){this.configurationService=f,this.workspaceContextService=D,this.editorGroupsService=L,this.logService=W,this.pathService=N}text(f,D,L={}){f=this.getContentPattern(f,L);const W=this.configurationService.getValue(),N=D&&D.some(F=>!this.configurationService.getValue({resource:F}).search.useRipgrep);return{...this.commonQuery(D?.map(l.toWorkspaceFolder),L),type:2,contentPattern:f,previewOptions:L.previewOptions,maxFileSize:L.maxFileSize,usePCRE2:W.search.usePCRE2||N||!1,beforeContext:L.beforeContext,afterContext:L.afterContext,userDisabledExcludesAndIgnoreFiles:L.disregardExcludeSettings&&L.disregardIgnoreFiles}}getContentPattern(f,D){const L=this.configurationService.getValue();f.isRegExp&&(f.pattern=f.pattern.replace(/\r?\n/g,"\\n"));const W={...f,wordSeparators:L.editor.wordSeparators};return this.isCaseSensitive(f,D)&&(W.isCaseSensitive=!0),this.isMultiline(f)&&(W.isMultiline=!0),W}file(f,D={}){return{...this.commonQuery(f,D),type:1,filePattern:D.filePattern?D.filePattern.trim():D.filePattern,exists:D.exists,sortByScore:D.sortByScore,cacheKey:D.cacheKey}}handleIncludeExclude(f,D){return f?(f=Array.isArray(f)?f.map(n):n(f),D?this.parseSearchPaths(f):{pattern:d(...Array.isArray(f)?f:[f])}):{}}commonQuery(f=[],D={}){const L=this.handleIncludeExclude(D.includePattern,D.expandPatterns),W=this.handleIncludeExclude(D.excludePattern,D.expandPatterns),N=f.length>1,v=(L.searchPaths&&L.searchPaths.length?L.searchPaths.map(H=>this.getFolderQueryForSearchPath(H,D,W)):f.map(H=>this.getFolderQueryForRoot(H,D,W,N))).filter(H=>!!H),F={_reason:D._reason,folderQueries:v,usingSearchPaths:!!(L.searchPaths&&L.searchPaths.length),extraFileResources:D.extraFileResources,excludePattern:W.pattern,includePattern:L.pattern,onlyOpenEditors:D.onlyOpenEditors,maxResults:D.maxResults};if(D.onlyOpenEditors){const H=o.coalesce(o.flatten(this.editorGroupsService.groups.map($=>$.editors.map(ce=>ce.resource))));this.logService.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(H));const te=H.filter($=>(0,a.pathIncludedInQuery)(F,$.fsPath)),z=this.commonQueryFromFileList(te);return this.logService.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(z)),{...F,...z}}const O=D.extraFileResources&&D.extraFileResources.filter(H=>(0,a.pathIncludedInQuery)(F,H.fsPath));return F.extraFileResources=O&&O.length?O:void 0,F}commonQueryFromFileList(f){const D=[],L=new I.ResourceMap,W={};let N=!1;return f.forEach(v=>{if(v.scheme===P.Schemas.walkThrough)return;if((0,A.isAbsolutePath)(v)){const O=this.workspaceContextService.getWorkspaceFolder(v)?.uri??v.with({path:b.dirname(v.fsPath)});let H=L.get(O);H||(N=!0,H={folder:O,includePattern:{}},D.push(H),L.set(O,H));const te=b.relative(O.fsPath,v.fsPath);(0,_.assertIsDefined)(H.includePattern)[te.replace(/\\/g,"/")]=!0}else v.fsPath&&(N=!0,W[v.fsPath]=!0)}),{folderQueries:D,includePattern:W,usingSearchPaths:!0,excludePattern:N?void 0:{"**/*":!0}}}isCaseSensitive(f,D){if(D.isSmartCase){if(f.isRegExp){if(R.containsUppercaseCharacter(f.pattern,!0))return!0}else if(R.containsUppercaseCharacter(f.pattern))return!0}return!!f.isCaseSensitive}isMultiline(f){return f.isMultiline||f.isRegExp&&(0,T.isMultilineRegexSource)(f.pattern)||f.pattern.indexOf(`
`)>=0?!0:!!f.isMultiline}parseSearchPaths(f){const D=z=>b.isAbsolute(z)||/^\.\.?([\/\\]|$)/.test(z),W=(Array.isArray(f)?f:i(f)).map(z=>{const $=this.pathService.resolvedUserHome;return $?(0,U.untildify)(z,$.scheme===P.Schemas.file?$.fsPath:$.path):z}),N=C.groupBy(W,z=>D(z)?"searchPaths":"exprSegments"),v=(N.exprSegments||[]).map(z=>R.rtrim(z,"/")).map(z=>R.rtrim(z,"\\")).map(z=>(z[0]==="."&&(z="*"+z),s(z))),F={},O=this.expandSearchPathPatterns(N.searchPaths||[]);O&&O.length&&(F.searchPaths=O);const H=o.flatten(v),te=d(...H);return te&&(F.pattern=te),F}getExcludesForFolder(f,D){return D.disregardExcludeSettings?void 0:(0,a.getExcludes)(f,!D.disregardSearchExcludeSettings)}expandSearchPathPatterns(f){if(!f||!f.length)return[];const D=o.flatten(f.map(W=>{let{pathPortion:N,globPortion:v}=r(W);v&&(v=t(v));const F=this.expandOneSearchPath(N);return o.flatten(F.map(O=>this.resolveOneSearchPathPattern(O,v)))})),L=new Map;return D.forEach(W=>{const N=W.searchPath.toString(),v=L.get(N);v?W.pattern&&(v.pattern=v.pattern||{},v.pattern[W.pattern]=!0):L.set(N,{searchPath:W.searchPath,pattern:W.pattern?d(W.pattern):void 0})}),Array.from(L.values())}expandOneSearchPath(f){if(b.isAbsolute(f)){const D=this.workspaceContextService.getWorkspace().folders;return D[0]&&D[0].uri.scheme!==P.Schemas.file?[{searchPath:D[0].uri.with({path:f})}]:[{searchPath:m.URI.file(b.normalize(f))}]}if(this.workspaceContextService.getWorkbenchState()===2){const D=this.workspaceContextService.getWorkspace().folders[0].uri;if(f=n(f),f.startsWith("../")||f===".."){const W=b.posix.resolve(D.path,f);return[{searchPath:D.with({path:W})}]}const L=t(f);return[{searchPath:D,pattern:L}]}else{if(f==="./"||f===".\\")return[];{const D=f.replace(/^\.[\/\\]/,""),W=this.workspaceContextService.getWorkspace().folders.map(N=>{const v=D.match(new RegExp(`^${R.escapeRegExpCharacters(N.name)}(?:/(.*)|$)`));return v?{match:v,folder:N}:null}).filter(_.isDefined);if(W.length)return W.map(N=>{const v=N.match[1];return{searchPath:N.folder.uri,pattern:v&&t(v)}});{const N=f.match(/\.[\/\\](.+)[\/\\]?/),v=N?N[1]:f,F=g.localize(0,null,v);throw new Error(F)}}}}resolveOneSearchPathPattern(f,D){const L=f.pattern&&D?`${f.pattern}/${D}`:f.pattern||D,W=[{searchPath:f.searchPath,pattern:L}];return L&&!L.endsWith("**")&&W.push({searchPath:f.searchPath,pattern:L+"/**"}),W}getFolderQueryForSearchPath(f,D,L){const W=this.getFolderQueryForRoot((0,l.toWorkspaceFolder)(f.searchPath),D,L,!1);return W?{...W,includePattern:f.pattern}:null}getFolderQueryForRoot(f,D,L,W){let N;const v=m.URI.isUri(f)?f:f.uri;if(L.searchPaths){const z=L.searchPaths.filter($=>(0,A.isEqual)($.searchPath,v))[0];if(z&&!z.pattern)return null;z&&(N=z.pattern)}const F=this.configurationService.getValue({resource:v}),H={...this.getExcludesForFolder(F,D)||{},...N||{}},te=m.URI.isUri(f)?(0,A.basename)(f):f.name;return{folder:v,folderName:W?te:void 0,excludePattern:Object.keys(H).length>0?H:void 0,fileEncoding:F.files&&F.files.encoding,disregardIgnoreFiles:typeof D.disregardIgnoreFiles=="boolean"?D.disregardIgnoreFiles:!F.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof D.disregardGlobalIgnoreFiles=="boolean"?D.disregardGlobalIgnoreFiles:!F.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof D.disregardParentIgnoreFiles=="boolean"?D.disregardParentIgnoreFiles:!F.search.useParentIgnoreFiles,ignoreSymlinks:typeof D.ignoreSymlinks=="boolean"?D.ignoreSymlinks:!F.search.followSymlinks}}};y=$e([xe(0,h.IConfigurationService),xe(1,l.IWorkspaceContextService),xe(2,S.IEditorGroupsService),xe(3,u.ILogService),xe(4,w.IPathService)],y),e.QueryBuilder=y;function r(E){const f=E.match(/[\*\{\}\(\)\[\]\?]/);if(f){const D=f.index,L=E.substr(0,D).match(/[/|\\][^/\\]*$/);if(L){let W=E.substr(0,L.index);return W.match(/[/\\]/)||(W+="/"),{pathPortion:W,globPortion:E.substr((L.index||0)+1)}}}return{pathPortion:E}}function d(...E){return E.length?E.reduce((f,D)=>(f[D]=!0,f),Object.create(null)):void 0}function i(E){return p.splitGlobAware(E,",").map(f=>f.trim()).filter(f=>!!f.length)}function s(E){return[`**/${E}/**`,`**/${E}`].map(D=>D.replace(/\*\*\/\*\*/g,"**"))}function n(E){return E.replace(/\\/g,"/")}function t(E){return n(E).replace(/^\.\//,"").replace(/\/+$/g,"")}function c(E,f){E=o.distinct(E,W=>W.toString());const D=[],L=f.getWorkspace();return E&&E.forEach(W=>{let N;if(f.getWorkbenchState()===2)N=(0,A.relativePath)(L.folders[0].uri,W),N&&N!=="."&&(N="./"+N);else{const v=f.getWorkspaceFolder(W);if(v){const F=v.name;if(L.folders.filter(H=>H.name===F).length===1){const H=(0,A.relativePath)(v.uri,W);H===""?N=`./${v.name}`:N=`./${v.name}/${H}`}else N=W.fsPath}}N&&D.push(N)}),D}e.resolveResourcesForSearchIncludes=c}),define(De[228],Ce([1,0,21,2,20,11,3,227,41,45]),function(J,e,o,C,p,U,I,P,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const R=7e3;function _(h,u){const l=u.activationEvents;if(!l)return Promise.resolve(void 0);const S=[],w=[];for(const s of l)if(/^workspaceContains:/.test(s)){const n=s.substr("workspaceContains:".length);n.indexOf("*")>=0||n.indexOf("?")>=0||h.forceUsingSearch?w.push(n):S.push(n)}if(S.length===0&&w.length===0)return Promise.resolve(void 0);let a;const y=new Promise((s,n)=>{a=s}),r=s=>a({activationEvent:s}),d=Promise.all(S.map(s=>m(h,s,r))).then(()=>{}),i=T(h,u.identifier,w,r);return Promise.all([d,i]).then(()=>{a(void 0)}),y}e.checkActivateWorkspaceContainsExtension=_;async function m(h,u,l){for(const S of h.folders)if(await h.exists(o.joinPath(C.URI.revive(S),u))){l(`workspaceContains:${u}`);return}}async function T(h,u,l,S){if(l.length===0)return Promise.resolve(void 0);const w=new p.CancellationTokenSource,a=h.checkExists(h.folders,l,w.token),y=setTimeout(async()=>{w.cancel(),h.logService.info(`Not activating extension '${u.value}': Timed out while searching for 'workspaceContains' pattern ${l.join(",")}`)},R);let r=!1;try{r=await a}catch(d){U.isCancellationError(d)||U.onUnexpectedError(d)}w.dispose(),clearTimeout(y),r&&S(`workspaceContains:${l.join(",")}`)}function g(h,u,l,S){const w=h.get(I.IInstantiationService),a=h.get(b.ISearchService),r=w.createInstance(P.QueryBuilder).file(u.map(d=>(0,A.toWorkspaceFolder)(C.URI.revive(d))),{_reason:"checkExists",includePattern:l,exists:!0});return a.fileSearch(r,S).then(d=>!!d.limitHit,d=>U.isCancellationError(d)?!1:Promise.reject(d))}e.checkGlobFileExists=g});var Ye=this&&this.__classPrivateFieldSet||function(J,e,o,C,p){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!p)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!p:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?p.call(J,o):p?p.value=o:e.set(J,o),o},Ae=this&&this.__classPrivateFieldGet||function(J,e,o,C){if(o==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!C:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?C:o==="a"?C.call(J):C?C.value:e.get(J)};define(De[33],Ce([1,0,129,19,71,21,13,7,24,2,14,5,32,179,69,31,25,178,11,27,23,157,6,84,3,28,70,15,58,62,52,4,228,67,159,12]),function(J,e,o,C,p,U,I,P,b,A,R,_,m,T,g,h,u,l,S,w,a,y,r,d,i,s,n,t,c,E,f,D,L,W,N,v){"use strict";var F,O,H;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,i.createDecorator)("IHostUtils");let te=class Ci extends P.Disposable{constructor(re,Ee,be,Z,ve,Re,Fe,We,Xe,Ie){super();this._onDidChangeRemoteConnectionData=this._register(new D.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._isTerminating=!1,this._hostUtils=Ee,this._extHostContext=be,this._initData=Fe,this._extHostWorkspace=Z,this._extHostConfiguration=ve,this._logService=Re,this._extHostTunnelService=Xe,this._extHostTerminalService=Ie,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(_.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(_.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(_.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new I.Barrier,this._readyToStartExtensionHost=new I.Barrier,this._readyToRunExtensions=new I.Barrier,this._eagerExtensionsActivated=new I.Barrier,this._globalRegistry=new l.ExtensionDescriptionRegistry(this._initData.allExtensions);const Se=(0,u.extensionIdentifiersArrayToSet)(this._initData.myExtensions);this._myRegistry=new l.ExtensionDescriptionRegistry(ce(this._globalRegistry,Se)),this._storage=new g.ExtHostStorage(this._extHostContext),this._secretState=new W.ExtHostSecretState(this._extHostContext),this._storagePath=We,this._instaService=re.createChild(new c.ServiceCollection([g.IExtHostStorage,this._storage],[W.IExtHostSecretState,this._secretState]));let Te=[],se=[];this._initData.remote.isRemote&&(Te=this._initData.allExtensions.filter(G=>!G.main&&!G.browser).map(G=>G.identifier),se=this._initData.allExtensions.filter(G=>!Se.has(w.ExtensionIdentifier.toKey(G.identifier.value))).filter(G=>(G.main||G.browser)&&G.api==="none").map(G=>G.identifier));const ae=(0,u.extensionIdentifiersArrayToSet)(se);this._activator=this._register(new T.ExtensionsActivator(this._myRegistry,Te,se,{onExtensionActivationError:(G,X,k)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(G,S.transformErrorForSerialization(X),k)},actualActivateExtension:async(G,X)=>{if(ae.has(w.ExtensionIdentifier.toKey(G)))return await this._mainThreadExtensionsProxy.$activateExtension(G,X),new T.HostExtension;const k=this._myRegistry.getExtensionDescription(G);return this._activateExtension(k,X)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),p.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(re){S.onUnexpectedError(re)}}async _deactivateAll(){this._storagePath.onWillDeactivateAll();let re=[];try{re=this._myRegistry.getAllExtensionDescriptions().map(ve=>ve.identifier).filter(ve=>this.isActivated(ve)).map(ve=>this._deactivate(ve))}catch{}await Promise.all(re)}terminate(re,Ee=0){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`Extension host terminating: ${re}`),this._logService.flush(),this._extHostTerminalService.dispose(),this._activator.dispose(),S.setUnexpectedErrorHandler(Z=>{this._logService.error(Z)}),this._extHostContext.dispose();const be=this._deactivateAll();Promise.race([(0,I.timeout)(5e3),be]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${Ee}`):this._logService.info(`Extension host exiting with code ${Ee}`),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(Ee)})}isActivated(re){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(re):!1}async getExtension(re){const Ee=await this._mainThreadExtensionsProxy.$getExtension(re);return Ee&&{...Ee,identifier:new w.ExtensionIdentifier(Ee.identifier.value),extensionLocation:A.URI.revive(Ee.extensionLocation)}}_activateByEvent(re,Ee){return this._activator.activateByEvent(re,Ee)}_activateById(re,Ee){return this._activator.activateById(re,Ee)}activateByIdWithErrors(re,Ee){return this._activateById(re,Ee).then(()=>{const be=this._activator.getActivatedExtension(re);if(be.activationFailed)return Promise.reject(be.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(re=>this._myRegistry)}getExtensionExports(re){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(re).exports:null}async _realPathExtensionUri(re){if(re.scheme!==v.Schemas.file)return re;const Ee=await this._hostUtils.realpath(re.fsPath);return A.URI.file(Ee)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=this._createExtensionPathIndex(this._myRegistry.getAllExtensionDescriptions()).then(re=>new oe(re))),this._extensionPathIndex}async _createExtensionPathIndex(re){const Ee=b.TernarySearchTree.forUris(be=>U.extUriBiasedIgnorePathCase.ignorePathCasing(be));return await Promise.all(re.map(async be=>{if(this._getEntryPoint(be)){const Z=await this._realPathExtensionUri(be.extensionLocation);Ee.set(Z,be)}})),Ee}_deactivate(re){let Ee=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(re))return Ee;const be=this._activator.getActivatedExtension(re);if(!be)return Ee;try{typeof be.module.deactivate=="function"&&(Ee=Promise.resolve(be.module.deactivate()).then(void 0,Z=>(this._logService.error(Z),Promise.resolve(void 0))))}catch(Z){this._logService.error(`An error occurred when deactivating the extension '${re.value}':`),this._logService.error(Z)}try{(0,P.dispose)(be.subscriptions)}catch(Z){this._logService.error(`An error occurred when deactivating the subscriptions for extension '${re.value}':`),this._logService.error(Z)}return Ee}async _activateExtension(re,Ee){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(re.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(re.identifier),this._doActivateExtension(re,Ee).then(be=>{const Z=be.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(re.identifier,Z.codeLoadingTime,Z.activateCallTime,Z.activateResolvedTime,Ee),this._logExtensionActivationTimes(re,Ee,"success",Z),be},be=>{throw this._logExtensionActivationTimes(re,Ee,"failure"),be})}_logExtensionActivationTimes(re,Ee,be,Z){const ve=z(re,Ee);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...ve,...Z||{},outcome:be})}_doActivateExtension(re,Ee){const be=z(re,Ee);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",be);const Z=this._getEntryPoint(re);if(!Z)return Promise.resolve(new T.EmptyExtension(T.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${re.identifier.value}, startup: ${Ee.startup}, activationEvent: '${Ee.activationEvent}'${re.identifier.value!==Ee.extensionId.value?`, root cause: ${Ee.extensionId.value}`:""}`),this._logService.flush();const ve=new T.ExtensionActivationTimesBuilder(Ee.startup);return Promise.all([this._loadCommonJSModule(re.identifier,(0,U.joinPath)(re.extensionLocation,Z),ve),this._loadExtensionContext(re)]).then(Re=>(p.mark(`code/extHost/willActivateExtension/${re.identifier.value}`),Ci._callActivate(this._logService,re.identifier,Re[0],Re[1],ve))).then(Re=>(p.mark(`code/extHost/didActivateExtension/${re.identifier.value}`),Re))}_loadExtensionContext(re){const Ee=new y.ExtensionGlobalMemento(re,this._storage),be=new y.ExtensionMemento(re.identifier.value,!1,this._storage),Z=new N.ExtensionSecrets(re,this._secretState),ve=re.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?r.ExtensionMode.Test:r.ExtensionMode.Development:r.ExtensionMode.Production,Re=this._initData.remote.isRemote?r.ExtensionKind.Workspace:r.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${re.identifier.value}`),Promise.all([Ee.whenReady,be.whenReady,this._storagePath.whenReady]).then(()=>{const Fe=this;let We,Xe;const Ie=(0,u.isProposedApiEnabled)(re,"ipc")?this._initData.messagePorts?.get(w.ExtensionIdentifier.toKey(re.identifier)):void 0;return Object.freeze({globalState:Ee,workspaceState:be,secrets:Z,subscriptions:[],get extensionUri(){return re.extensionLocation},get extensionPath(){return re.extensionLocation.fsPath},asAbsolutePath(Se){return C.join(re.extensionLocation.fsPath,Se)},get storagePath(){return Fe._storagePath.workspaceValue(re)?.fsPath},get globalStoragePath(){return Fe._storagePath.globalValue(re).fsPath},get logPath(){return C.join(Fe._initData.logsLocation.fsPath,re.identifier.value)},get logUri(){return A.URI.joinPath(Fe._initData.logsLocation,re.identifier.value)},get storageUri(){return Fe._storagePath.workspaceValue(re)},get globalStorageUri(){return Fe._storagePath.globalValue(re)},get extensionMode(){return ve},get extension(){return We===void 0&&(We=new $(Fe,re.identifier,re,Re,!1)),We},get extensionRuntime(){return(0,u.checkProposedApiEnabled)(re,"extensionRuntime"),Fe.extensionRuntime},get environmentVariableCollection(){return Fe._extHostTerminalService.getEnvironmentVariableCollection(re)},get messagePassingProtocol(){if(!Xe){if(!Ie)return;const Se=D.Event.buffer(D.Event.fromDOMEventEmitter(Ie,"message",Te=>Te.data));Ie.start(),Xe={onDidReceiveMessage:Se,postMessage:Ie.postMessage.bind(Ie)}}return Xe}})})}static _callActivate(re,Ee,be,Z,ve){return be=be||{activate:void 0,deactivate:void 0},this._callActivateOptional(re,Ee,be,Z,ve).then(Re=>new T.ActivatedExtension(!1,null,ve.build(),be,Re,Z.subscriptions))}static _callActivateOptional(re,Ee,be,Z,ve){if(typeof be.activate=="function")try{ve.activateCallStart(),re.trace(`ExtensionService#_callActivateOptional ${Ee.value}`);const Re=typeof global=="object"?global:self,Fe=be.activate.apply(Re,[Z]);return ve.activateCallStop(),ve.activateResolveStart(),Promise.resolve(Fe).then(We=>(ve.activateResolveStop(),We))}catch(Re){return Promise.reject(Re)}else return Promise.resolve(be)}_activateOneStartupFinished(re,Ee){this._activateById(re.identifier,{startup:!1,extensionId:re.identifier,activationEvent:Ee}).then(void 0,be=>{this._logService.error(be)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(p.getMarks());for(const re of this._myRegistry.getAllExtensionDescriptions())if(re.activationEvents)for(const Ee of re.activationEvents)Ee==="onStartupFinished"&&this._activateOneStartupFinished(re,Ee)}_handleEagerExtensions(){const re=this._activateByEvent("*",!0).then(void 0,ve=>{this._logService.error(ve)});this._register(this._extHostWorkspace.onDidChangeWorkspace(ve=>this._handleWorkspaceContainsEagerExtensions(ve.added)));const Ee=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],be=this._handleWorkspaceContainsEagerExtensions(Ee),Z=Promise.all([re,be]).then(()=>{});return Promise.race([Z,(0,I.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),Z}_handleWorkspaceContainsEagerExtensions(re){return re.length===0?Promise.resolve(void 0):Promise.all(this._myRegistry.getAllExtensionDescriptions().map(Ee=>this._handleWorkspaceContainsEagerExtension(re,Ee))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(re,Ee){if(this.isActivated(Ee.identifier))return;const be=!this._initData.remote.isRemote&&!!this._initData.remote.authority,Z={logService:this._logService,folders:re.map(Re=>Re.uri),forceUsingSearch:be,exists:Re=>this._hostUtils.exists(Re.fsPath),checkExists:(Re,Fe,We)=>this._mainThreadWorkspaceProxy.$checkExists(Re,Fe,We)},ve=await(0,L.checkActivateWorkspaceContainsExtension)(Z,Ee);if(!!ve)return this._activateById(Ee.identifier,{startup:!0,extensionId:Ee.identifier,activationEvent:ve.activationEvent}).then(void 0,Re=>this._logService.error(Re))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(re){throw console.error(re),re}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:re,extensionTestsLocationURI:Ee}=this._initData.environment;if(!re||!Ee)throw new Error(o.localize(0,null));const be=await this._loadCommonJSModule(null,Ee,new T.ExtensionActivationTimesBuilder(!1));if(!be||typeof be.run!="function")throw new Error(o.localize(1,null,Ee.toString()));return new Promise((Z,ve)=>{const Re=(Xe,Ie)=>{Xe?ve(Xe):Z(typeof Ie=="number"&&Ie>0?1:0)},Fe=(0,U.originalFSPath)(Ee),We=be.run(Fe,Re);We&&We.then&&We.then(()=>{Z(0)}).catch(Xe=>{ve(Xe instanceof Error&&Xe.stack?Xe.stack:String(Xe))})})}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(re,Ee){return this._resolvers[re]=Ee,(0,P.toDisposable)(()=>{delete this._resolvers[re]})}async _activateAndGetResolver(re){const Ee=re.indexOf("+");if(Ee===-1)throw new Error("Not an authority that can be resolved!");const be=re.substr(0,Ee);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${be}`,!1),{authorityPrefix:be,resolver:this._resolvers[be]}}async $resolveAuthority(re,Ee){this._logService.info(`$resolveAuthority invoked for authority (${le(re)})`);const{authorityPrefix:be,resolver:Z}=await this._activateAndGetResolver(re);if(!Z)return{type:"error",error:{code:d.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${be}.`,detail:void 0}};try{this._register(await this._extHostTunnelService.setTunnelFactory(Z)),p.mark(`code/extHost/willResolveAuthority/${be}`);const ve=await Z.resolve(re,{resolveAttempt:Ee});p.mark(`code/extHost/didResolveAuthorityOK/${be}`);const Re={authority:re,host:ve.host,port:ve.port,connectionToken:ve.connectionToken},Fe={extensionHostEnv:ve.extensionHostEnv,isTrusted:ve.isTrusted,authenticationSession:ve.authenticationSessionForInitializingExtensions?{id:ve.authenticationSessionForInitializingExtensions.id,providerId:ve.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:Re,options:Fe,tunnelInformation:{environmentTunnels:ve.environmentTunnels,features:ve.tunnelFeatures}}}}catch(ve){if(p.mark(`code/extHost/didResolveAuthorityError/${be}`),ve instanceof r.RemoteAuthorityResolverError)return{type:"error",error:{code:ve._code,message:ve._message,detail:ve._detail}};throw ve}}async $getCanonicalURI(re,Ee){this._logService.info(`$getCanonicalURI invoked for authority (${le(re)})`);const{resolver:be}=await this._activateAndGetResolver(re);if(!be)return null;const Z=A.URI.revive(Ee);if(typeof be.getCanonicalURI=="undefined")return Z;const ve=await(0,I.asPromise)(()=>be.getCanonicalURI(Z));return ve||Z}static _applyExtensionsDelta(re,Ee,be){const Z=new l.ExtensionDescriptionRegistry(re.getAllExtensionDescriptions());Z.deltaExtensions(be.toAdd,be.toRemove);const ve=(0,u.extensionIdentifiersArrayToSet)(Ee.getAllExtensionDescriptions().map(Fe=>Fe.identifier));for(const Fe of be.myToRemove)ve.delete(w.ExtensionIdentifier.toKey(Fe));for(const Fe of be.myToAdd)ve.add(w.ExtensionIdentifier.toKey(Fe));const Re=ce(Z,ve);return{globalRegistry:Z,myExtensions:Re}}$startExtensionHost(re){re.toAdd.forEach(Z=>Z.extensionLocation=A.URI.revive(Z.extensionLocation));const{globalRegistry:Ee,myExtensions:be}=Ci._applyExtensionsDelta(this._globalRegistry,this._myRegistry,re);return this._globalRegistry.set(Ee.getAllExtensionDescriptions()),this._myRegistry.set(be),this._startExtensionHost()}$activateByEvent(re,Ee){return Ee===1?this._activateByEvent(re,!1):this._readyToRunExtensions.wait().then(be=>this._activateByEvent(re,!1))}async $activate(re,Ee){return await this._readyToRunExtensions.wait(),this._myRegistry.getExtensionDescription(re)?(await this._activateById(re,Ee),!0):!1}async $deltaExtensions(re){re.toAdd.forEach(Re=>Re.extensionLocation=A.URI.revive(Re.extensionLocation));const{globalRegistry:Ee,myExtensions:be}=Ci._applyExtensionsDelta(this._globalRegistry,this._myRegistry,re),Z=await this._createExtensionPathIndex(be);return(await this.getExtensionPathIndex()).setSearchTree(Z),this._globalRegistry.set(Ee.getAllExtensionDescriptions()),this._myRegistry.set(be),Promise.resolve(void 0)}async $test_latency(re){return re}async $test_up(re){return re.byteLength}async $test_down(re){const Ee=a.VSBuffer.alloc(re),be=Math.random()%256;for(let Z=0;Z<re;Z++)Ee.writeUInt8(be,Z);return Ee}async $updateRemoteConnectionData(re){this._remoteConnectionData=re,this._onDidChangeRemoteConnectionData.fire()}};te=$e([xe(0,i.IInstantiationService),xe(1,e.IHostUtils),xe(2,t.IExtHostRpcService),xe(3,h.IExtHostWorkspace),xe(4,m.IExtHostConfiguration),xe(5,R.ILogService),xe(6,s.IExtHostInitDataService),xe(7,n.IExtensionStoragePaths),xe(8,E.IExtHostTunnelService),xe(9,f.IExtHostTerminalService)],te),e.AbstractExtHostExtensionService=te;function z(pe,re){return{id:pe.identifier.value,name:pe.name,extensionVersion:pe.version,publisherDisplayName:pe.publisher,activationEvents:pe.activationEvents?pe.activationEvents.join(","):null,isBuiltin:pe.isBuiltin,reason:re.activationEvent,reasonId:re.extensionId.value}}e.IExtHostExtensionService=(0,i.createDecorator)("IExtHostExtensionService");class ${constructor(re,Ee,be,Z,ve){F.set(this,void 0),O.set(this,void 0),H.set(this,void 0),Ye(this,F,re,"f"),Ye(this,O,Ee,"f"),Ye(this,H,be.identifier,"f"),this.id=be.identifier.value,this.extensionUri=be.extensionLocation,this.extensionPath=C.normalize((0,U.originalFSPath)(be.extensionLocation)),this.packageJSON=be,this.extensionKind=Z,this.isFromDifferentExtensionHost=ve}get isActive(){return Ae(this,F,"f").isActivated(Ae(this,H,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return Ae(this,F,"f").getExtensionExports(Ae(this,H,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await Ae(this,F,"f").activateByIdWithErrors(Ae(this,H,"f"),{startup:!1,extensionId:Ae(this,O,"f"),activationEvent:"api"}),this.exports}}e.Extension=$,F=new WeakMap,O=new WeakMap,H=new WeakMap;function ce(pe,re){return pe.getAllExtensionDescriptions().filter(Ee=>re.has(w.ExtensionIdentifier.toKey(Ee.identifier)))}function le(pe){const re=pe.indexOf("+");return re===-1?pe:pe.substring(0,re)}class oe{constructor(re){this._searchTree=re}setSearchTree(re){this._searchTree=re}findSubstr(re){return this._searchTree.findSubstr(re)}forEach(re){return this._searchTree.forEach(re)}}e.ExtensionPaths=oe}),define(De[229],Ce([1,0,71,2,5,32,25,27,15,28,3,33,59,14,10]),function(J,e,o,C,p,U,I,P,b,A,R,_,m,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let h=class{constructor(y,r,d,i,s,n,t){this._apiFactory=y,this._extensionRegistry=r,this._instaService=d,this._extHostConfiguration=i,this._extHostExtensionService=s,this._initData=n,this._logService=t,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),o.mark("code/extHost/willWaitForConfig");const y=await this._extHostConfiguration.getConfigProvider();o.mark("code/extHost/didWaitForConfig");const r=await this._extHostExtensionService.getExtensionPathIndex();this.register(new l(this._apiFactory,r,this._extensionRegistry,y,this._logService)),this.register(this._instaService.createInstance(S,r)),this.register(this._instaService.createInstance(u)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(w,r,this._initData.environment.appUriScheme))}register(y){if("nodeModuleName"in y)if(Array.isArray(y.nodeModuleName))for(const r of y.nodeModuleName)this._factories.set(r,y);else this._factories.set(y.nodeModuleName,y);typeof y.alternativeModuleName=="function"&&this._alternatives.push(r=>y.alternativeModuleName(r))}};h=$e([xe(2,R.IInstantiationService),xe(3,U.IExtHostConfiguration),xe(4,_.IExtHostExtensionService),xe(5,A.IExtHostInitDataService),xe(6,T.ILogService)],h),e.RequireInterceptor=h;let u=class Ki{constructor(y){if(y.environment.appRoot&&Ki.aliased.size){const r=(0,g.escapeRegExpCharacters)(this.forceForwardSlashes(y.environment.appRoot.fsPath)),d="[a-z0-9_.-]",i=`@${d}+\\/${d}+|${d}+`,s="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.re=new RegExp(`^(${r}/${s}\\/)(${i})(.*)$`,"i")}}alternativeModuleName(y){if(!this.re)return;const r=this.re.exec(this.forceForwardSlashes(y));if(!r)return;const[,d,i,s]=r,n=Ki.aliased.get(i);if(n!==void 0)return console.warn(`${i} as been renamed to ${n}, please update your imports`),d+n+s}forceForwardSlashes(y){return y.replace(/\\/g,"/")}};u.aliased=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),u=$e([xe(0,A.IExtHostInitDataService)],u);class l{constructor(y,r,d,i,s){this._apiFactory=y,this._extensionPaths=r,this._extensionRegistry=d,this._configProvider=i,this._logService=s,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(y,r){const d=this._extensionPaths.findSubstr(r);if(d){let i=this._extApiImpl.get(P.ExtensionIdentifier.toKey(d.identifier));return i||(i=this._apiFactory(d,this._extensionRegistry,this._configProvider),this._extApiImpl.set(P.ExtensionIdentifier.toKey(d.identifier),i)),i}if(!this._defaultApiImpl){let i="";this._extensionPaths.forEach((s,n)=>i+=`	${n} -> ${s.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${r}. These are the extension path mappings: 
${i}`),this._defaultApiImpl=this._apiFactory(I.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let S=class{constructor(y,r,d){this._extensionPaths=y,this.nodeModuleName="keytar",this._mainThreadTelemetry=r.getProxy(p.MainContext.MainThreadTelemetry);const{environment:i}=d,s=r.getProxy(p.MainContext.MainThreadKeytar);if(i.appRoot){let n=i.appRoot.fsPath;m.platform==="win32"&&(n=n.replace(/\\/g,"/")),n[n.length-1]==="/"&&(n=n.substr(0,n.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${n}/node_modules.asar/keytar`),this.alternativeNames.add(`${n}/node_modules/keytar`)}this._impl={getPassword:(n,t)=>s.$getPassword(n,t),setPassword:(n,t,c)=>s.$setPassword(n,t,c),deletePassword:(n,t)=>s.$deletePassword(n,t),findPassword:n=>s.$findPassword(n),findCredentials(n){return s.$findCredentials(n)}}}load(y,r){const d=this._extensionPaths.findSubstr(r);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:d?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(y){const r=y.length;if(r<=7||!this.alternativeNames)return;const d=r-7;if((y.charAt(d)==="/"||y.charAt(d)==="\\")&&y.endsWith("keytar")&&(y=y.replace(/\\/g,"/"),this.alternativeNames.has(y)))return"keytar"}};S=$e([xe(1,b.IExtHostRpcService),xe(2,A.IExtHostInitDataService)],S);let w=class{constructor(y,r,d){this._extensionPaths=y,this._appUriScheme=r,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=d.getProxy(p.MainContext.MainThreadTelemetry);const i=d.getProxy(p.MainContext.MainThreadWindow);this._impl=(s,n)=>{const t=C.URI.parse(s);return n?this.callOriginal(s,n):t.scheme==="http"||t.scheme==="https"?i.$openUri(t,s,{allowTunneling:!0}):t.scheme==="mailto"||t.scheme===this._appUriScheme?i.$openUri(t,s,{}):this.callOriginal(s,n)}}load(y,r,d){const i=this._extensionPaths.findSubstr(r);return i&&(this._extensionId=i.identifier.value,this.sendShimmingTelemetry()),this._original=d(y),this._impl}callOriginal(y,r){return this.sendNoForwardTelemetry(),this._original(y,r)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};w=$e([xe(2,b.IExtHostRpcService)],w)}),define(De[101],Ce([1,0,196,7,19,59,3,49,50,33,6,31,170,32]),function(J,e,o,C,p,U,I,P,b,A,R,_,m,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,I.createDecorator)("IExtHostVariableResolverProvider");class g extends m.AbstractVariableResolverService{constructor(l,S,w,a,y,r,d){function i(){if(w){const s=w.activeEditor();if(s)return s.document.uri;const n=a.tabGroups.all.find(t=>t.isActive)?.activeTab;if(n!==void 0){if(n.input instanceof R.TextDiffTabInput||n.input instanceof R.NotebookDiffEditorTabInput)return n.input.modified;if(n.input instanceof R.TextTabInput||n.input instanceof R.NotebookEditorTabInput||n.input instanceof R.CustomEditorTabInput)return n.input.uri}}}super({getFolderUri:s=>{const n=r.folders.filter(t=>t.name===s);if(n&&n.length>0)return n[0].uri},getWorkspaceFolderCount:()=>r.folders.length,getConfigurationValue:(s,n)=>y.getConfiguration(void 0,s).get(n),getAppRoot:()=>U.cwd(),getExecPath:()=>U.env.VSCODE_EXEC_PATH,getFilePath:()=>{const s=i();if(s)return p.normalize(s.fsPath)},getWorkspaceFolderPathForFile:()=>{if(S){const s=i();if(s){const n=S.getWorkspaceFolder(s);if(n)return p.normalize(n.uri.fsPath)}}},getSelectedText:()=>{if(w){const s=w.activeEditor();if(s&&!s.selection.isEmpty)return s.document.getText(s.selection)}},getLineNumber:()=>{if(w){const s=w.activeEditor();if(s)return String(s.selection.end.line+1)}},getExtension:s=>l.getExtension(s)},void 0,d?Promise.resolve(d):void 0,Promise.resolve(U.env))}}let h=class extends C.Disposable{constructor(l,S,w,a,y){super();this.extensionService=l,this.workspaceService=S,this.editorService=w,this.configurationService=a,this.editorTabs=y,this._resolver=new o.Lazy(async()=>{const r=await this.configurationService.getConfigProvider(),i={folders:await this.workspaceService.getWorkspaceFolders2()||[]};return this._register(this.workspaceService.onDidChangeWorkspace(async s=>{i.folders=await this.workspaceService.getWorkspaceFolders2()||[]})),new g(this.extensionService,this.workspaceService,this.editorService,this.editorTabs,r,i,this.homeDir())})}getResolver(){return this._resolver.getValue()}homeDir(){}};h=$e([xe(0,A.IExtHostExtensionService),xe(1,_.IExtHostWorkspace),xe(2,P.IExtHostDocumentsAndEditors),xe(3,T.IExtHostConfiguration),xe(4,b.IExtHostEditorTabs)],h),e.ExtHostVariableResolverProviderService=h}),define(De[102],Ce([1,0,13,4,9,2,3,5,50,33,15,6,31,164,166,32,101]),function(J,e,o,C,p,U,I,P,b,A,R,_,m,T,g,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,I.createDecorator)("IExtHostDebugService");let l=class{constructor(i,s,n,t,c,E){this._workspaceService=s,this._extensionService=n,this._configurationService=t,this._editorTabs=c,this._variableResolver=E,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new C.Emitter,this._onDidTerminateDebugSession=new C.Emitter,this._onDidChangeActiveDebugSession=new C.Emitter,this._onDidReceiveDebugSessionCustomEvent=new C.Emitter,this._debugServiceProxy=i.getProxy(P.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new C.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new w(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(f=>{f.onDidChange(D=>{this.registerAllDebugTypes(f)}),this.registerAllDebugTypes(f)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(i,s){const n=i;if(typeof n.sourceReference=="number"&&n.sourceReference>0){let t=`debug:${encodeURIComponent(n.path||"")}`,c="?";return s&&(t+=`${c}session=${encodeURIComponent(s.id)}`,c="&"),t+=`${c}ref=${n.sourceReference}`,U.URI.parse(t)}else{if(n.path)return U.URI.file(n.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(i){const s=[];for(const n of i.getAllExtensionDescriptions())if(n.contributes){const t=n.contributes.debuggers;if(t&&t.length>0)for(const c of t)(0,g.isDebuggerMainContribution)(c)&&s.push(c.type)}this._debugServiceProxy.$registerDebugTypes(s)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const i=[];return this._breakpoints.forEach(s=>i.push(s)),i}addBreakpoints(i){this.startBreakpoints();const s=i.filter(c=>{const E=c.id;return this._breakpoints.has(E)?!1:(this._breakpoints.set(E,c),!0)});this.fireBreakpointChanges(s,[],[]);const n=[],t=new Map;for(const c of s)if(c instanceof _.SourceBreakpoint){let E=t.get(c.location.uri.toString());E||(E={type:"sourceMulti",uri:c.location.uri,lines:[]},t.set(c.location.uri.toString(),E),n.push(E)),E.lines.push({id:c.id,enabled:c.enabled,condition:c.condition,hitCondition:c.hitCondition,logMessage:c.logMessage,line:c.location.range.start.line,character:c.location.range.start.character})}else c instanceof _.FunctionBreakpoint&&n.push({type:"function",id:c.id,enabled:c.enabled,hitCondition:c.hitCondition,logMessage:c.logMessage,condition:c.condition,functionName:c.functionName});return this._debugServiceProxy.$registerBreakpoints(n)}removeBreakpoints(i){this.startBreakpoints();const s=i.filter(E=>this._breakpoints.delete(E.id));this.fireBreakpointChanges([],s,[]);const n=s.filter(E=>E instanceof _.SourceBreakpoint).map(E=>E.id),t=s.filter(E=>E instanceof _.FunctionBreakpoint).map(E=>E.id),c=s.filter(E=>E instanceof _.DataBreakpoint).map(E=>E.id);return this._debugServiceProxy.$unregisterBreakpoints(n,t,c)}startDebugging(i,s,n){return this._debugServiceProxy.$startDebugging(i?i.uri:void 0,s,{parentSessionID:n.parentSession?n.parentSession.id:void 0,lifecycleManagedByParent:n.lifecycleManagedByParent,repl:n.consoleMode===_.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:n.noDebug,compact:n.compact,debugUI:n.debugUI,suppressSaveBeforeStart:n.suppressSaveBeforeStart})}stopDebugging(i){return this._debugServiceProxy.$stopDebugging(i?i.id:void 0)}registerDebugConfigurationProvider(i,s,n){if(!s)return new _.Disposable(()=>{});const t=this._configProviderHandleCounter++;return this._configProviders.push({type:i,handle:t,provider:s}),this._debugServiceProxy.$registerDebugConfigurationProvider(i,n,!!s.provideDebugConfigurations,!!s.resolveDebugConfiguration,!!s.resolveDebugConfigurationWithSubstitutedVariables,t),new _.Disposable(()=>{this._configProviders=this._configProviders.filter(c=>c.provider!==s),this._debugServiceProxy.$unregisterDebugConfigurationProvider(t)})}registerDebugAdapterDescriptorFactory(i,s,n){if(!n)return new _.Disposable(()=>{});if(!this.definesDebugType(i,s))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${s}' debugger.`);if(this.getAdapterDescriptorFactoryByType(s))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const t=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:s,handle:t,factory:n}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(s,t),new _.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(c=>c.factory!==n),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(t)})}registerDebugAdapterTrackerFactory(i,s){if(!s)return new _.Disposable(()=>{});const n=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:i,handle:n,factory:s}),new _.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(t=>t.factory!==s)})}async $runInTerminal(i,s){return Promise.resolve(void 0)}async $substituteVariables(i,s){let n;const t=await this.getFolder(i);return t&&(n={uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}}),(await this._variableResolver.getResolver()).resolveAnyAsync(n,s)}createDebugAdapter(i,s){if(i.type==="implementation")return new y(i.implementation)}createSignService(){}async $startDASession(i,s){const n=this,t=await this.getSession(s);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(t.type),t).then(c=>{if(!c)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${t.type}' (extension might have failed to activate)`);const E=this.convertToDto(c),f=this.createDebugAdapter(E,t);if(!f)throw new Error(`Couldn't create a debug adapter for type '${t.type}'.`);const D=f;return this._debugAdapters.set(i,D),this.getDebugAdapterTrackers(t).then(L=>(L&&this._debugAdaptersTrackers.set(i,L),D.onMessage(async W=>{if(W.type==="request"&&W.command==="handshake"){const N=W,v={type:"response",seq:0,command:N.command,request_seq:N.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const F=await this._signService.sign(N.arguments.value);v.body={signature:F},D.sendResponse(v)}else throw new Error("no signer")}catch(F){v.success=!1,v.message=F.message,D.sendResponse(v)}}else L&&L.onDidSendMessage&&L.onDidSendMessage(W),W=(0,g.convertToVSCPaths)(W,!0),n._debugServiceProxy.$acceptDAMessage(i,W)}),D.onError(W=>{L&&L.onError&&L.onError(W),this._debugServiceProxy.$acceptDAError(i,W.name,W.message,W.stack)}),D.onExit(W=>{L&&L.onExit&&L.onExit((0,p.withNullAsUndefined)(W),void 0),this._debugServiceProxy.$acceptDAExit(i,(0,p.withNullAsUndefined)(W),void 0)}),L&&L.onWillStartSession&&L.onWillStartSession(),D.startSession()))})}$sendDAMessage(i,s){s=(0,g.convertToDAPaths)(s,!1);const n=this._debugAdaptersTrackers.get(i);n&&n.onWillReceiveMessage&&n.onWillReceiveMessage(s),this._debugAdapters.get(i)?.sendMessage(s)}$stopDASession(i){const s=this._debugAdaptersTrackers.get(i);this._debugAdaptersTrackers.delete(i),s&&s.onWillStopSession&&s.onWillStopSession();const n=this._debugAdapters.get(i);return this._debugAdapters.delete(i),n?n.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(i){const s=[],n=[],t=[];if(i.added)for(const c of i.added){const E=c.id;if(E&&!this._breakpoints.has(E)){let f;if(c.type==="function")f=new _.FunctionBreakpoint(c.functionName,c.enabled,c.condition,c.hitCondition,c.logMessage);else if(c.type==="data")f=new _.DataBreakpoint(c.label,c.dataId,c.canPersist,c.enabled,c.hitCondition,c.condition,c.logMessage);else{const D=U.URI.revive(c.uri);f=new _.SourceBreakpoint(new _.Location(D,new _.Position(c.line,c.character)),c.enabled,c.condition,c.hitCondition,c.logMessage)}f._id=E,this._breakpoints.set(E,f),s.push(f)}}if(i.removed)for(const c of i.removed){const E=this._breakpoints.get(c);E&&(this._breakpoints.delete(c),n.push(E))}if(i.changed){for(const c of i.changed)if(c.id){const E=this._breakpoints.get(c.id);if(E){if(E instanceof _.FunctionBreakpoint&&c.type==="function"){const f=E;f.enabled=c.enabled,f.condition=c.condition,f.hitCondition=c.hitCondition,f.logMessage=c.logMessage,f.functionName=c.functionName}else if(E instanceof _.SourceBreakpoint&&c.type==="source"){const f=E;f.enabled=c.enabled,f.condition=c.condition,f.hitCondition=c.hitCondition,f.logMessage=c.logMessage,f.location=new _.Location(U.URI.revive(c.uri),new _.Position(c.line,c.character))}t.push(E)}}}this.fireBreakpointChanges(s,n,t)}$provideDebugConfigurations(i,s,n){return(0,o.asPromise)(async()=>{const t=this.getConfigProviderByHandle(i);if(!t)throw new Error("no DebugConfigurationProvider found");if(!t.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const c=await this.getFolder(s);return t.provideDebugConfigurations(c,n)}).then(t=>{if(!t)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return t})}$resolveDebugConfiguration(i,s,n,t){return(0,o.asPromise)(async()=>{const c=this.getConfigProviderByHandle(i);if(!c)throw new Error("no DebugConfigurationProvider found");if(!c.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const E=await this.getFolder(s);return c.resolveDebugConfiguration(E,n,t)})}$resolveDebugConfigurationWithSubstitutedVariables(i,s,n,t){return(0,o.asPromise)(async()=>{const c=this.getConfigProviderByHandle(i);if(!c)throw new Error("no DebugConfigurationProvider found");if(!c.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const E=await this.getFolder(s);return c.resolveDebugConfigurationWithSubstitutedVariables(E,n,t)})}async $provideDebugAdapter(i,s){const n=this.getAdapterDescriptorFactoryByHandle(i);if(!n)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const t=await this.getSession(s);return this.getAdapterDescriptor(n,t).then(c=>{if(!c)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${t.type}'`);return this.convertToDto(c)})}async $acceptDebugSessionStarted(i){const s=await this.getSession(i);this._onDidStartDebugSession.fire(s)}async $acceptDebugSessionTerminated(i){const s=await this.getSession(i);s&&(this._onDidTerminateDebugSession.fire(s),this._debugSessions.delete(s.id))}async $acceptDebugSessionActiveChanged(i){this._activeDebugSession=i?await this.getSession(i):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(i,s){(await this.getSession(i))?._acceptNameChanged(s)}async $acceptDebugSessionCustomEvent(i,s){const t={session:await this.getSession(i),event:s.event,body:s.body};this._onDidReceiveDebugSessionCustomEvent.fire(t)}convertToDto(i){if(i instanceof _.DebugAdapterExecutable)return{type:"executable",command:i.command,args:i.args,options:i.options};if(i instanceof _.DebugAdapterServer)return{type:"server",port:i.port,host:i.host};if(i instanceof _.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:i.path};if(i instanceof _.DebugAdapterInlineImplementation)return{type:"implementation",implementation:i.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(i){const s=this._adapterFactories.filter(n=>n.type===i);if(s.length>0)return s[0].factory}getAdapterDescriptorFactoryByHandle(i){const s=this._adapterFactories.filter(n=>n.handle===i);if(s.length>0)return s[0].factory}getConfigProviderByHandle(i){const s=this._configProviders.filter(n=>n.handle===i);if(s.length>0)return s[0].provider}definesDebugType(i,s){if(i.contributes){const n=i.contributes.debuggers;if(n&&n.length>0){for(const t of n)if(t.label&&t.type&&t.type===s)return!0}}return!1}getDebugAdapterTrackers(i){const n=i.configuration.type,t=this._trackerFactories.filter(c=>c.type===n||c.type==="*").map(c=>(0,o.asPromise)(()=>c.factory.createDebugAdapterTracker(i)).then(E=>E,E=>null));return Promise.race([Promise.all(t).then(c=>{const E=c.filter(f=>!!f);if(E.length>0)return new a(E)}),new Promise((c,E)=>{const f=setTimeout(()=>{clearTimeout(f),E(new Error("timeout"))},1e3)})]).catch(c=>{})}async getAdapterDescriptor(i,s){const n=s.configuration.debugServer;if(typeof n=="number")return Promise.resolve(new _.DebugAdapterServer(n));if(i){const c=await this._extensionService.getExtensionRegistry();return(0,o.asPromise)(()=>i.createDebugAdapterDescriptor(s,this.daExecutableFromPackage(s,c))).then(E=>{if(E)return E})}const t=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(s,t))}daExecutableFromPackage(i,s){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(i,s,n){(i.length>0||s.length>0||n.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:i,removed:s,changed:n}))}async getSession(i){if(i)if(typeof i=="string"){const s=this._debugSessions.get(i);if(s)return s}else{let s=this._debugSessions.get(i.id);if(!s){const n=await this.getFolder(i.folderUri),t=i.parent?this._debugSessions.get(i.parent):void 0;s=new S(this._debugServiceProxy,i.id,i.type,i.name,n,i.configuration,t),this._debugSessions.set(s.id,s),this._debugServiceProxy.$sessionCached(s.id)}return s}throw new Error("cannot find session")}getFolder(i){if(i){const s=U.URI.revive(i);return this._workspaceService.resolveWorkspaceFolder(s)}return Promise.resolve(void 0)}};l=$e([xe(0,R.IExtHostRpcService),xe(1,m.IExtHostWorkspace),xe(2,A.IExtHostExtensionService),xe(3,h.IExtHostConfiguration),xe(4,b.IExtHostEditorTabs),xe(5,u.IExtHostVariableResolverProvider)],l),e.ExtHostDebugServiceBase=l;class S{constructor(i,s,n,t,c,E,f){this._debugServiceProxy=i,this._id=s,this._type=n,this._name=t,this._workspaceFolder=c,this._configuration=E,this._parentSession=f}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(i){this._name=i,this._debugServiceProxy.$setDebugSessionName(this._id,i)}get parentSession(){return this._parentSession}_acceptNameChanged(i){this._name=i}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(i,s){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,i,s)}getDebugProtocolBreakpoint(i){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,i.id)}}e.ExtHostDebugSession=S;class w{constructor(i){this.value=Object.freeze({append(s){i.$appendDebugConsole(s)},appendLine(s){this.append(s+`
`)}})}}e.ExtHostDebugConsole=w;class a{constructor(i){this.trackers=i}onWillStartSession(){this.trackers.forEach(i=>i.onWillStartSession?i.onWillStartSession():void 0)}onWillReceiveMessage(i){this.trackers.forEach(s=>s.onWillReceiveMessage?s.onWillReceiveMessage(i):void 0)}onDidSendMessage(i){this.trackers.forEach(s=>s.onDidSendMessage?s.onDidSendMessage(i):void 0)}onWillStopSession(){this.trackers.forEach(i=>i.onWillStopSession?i.onWillStopSession():void 0)}onError(i){this.trackers.forEach(s=>s.onError?s.onError(i):void 0)}onExit(i,s){this.trackers.forEach(n=>n.onExit?n.onExit(i,s):void 0)}}class y extends T.AbstractDebugAdapter{constructor(i){super();this.implementation=i,i.onDidSendMessage(s=>{this.acceptMessage(s)})}startSession(){return Promise.resolve(void 0)}sendMessage(i){this.implementation.handleMessage(i)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let r=class extends l{constructor(i,s,n,t,c,E){super(i,s,n,t,c,E)}};r=$e([xe(0,R.IExtHostRpcService),xe(1,m.IExtHostWorkspace),xe(2,A.IExtHostExtensionService),xe(3,h.IExtHostConfiguration),xe(4,b.IExtHostEditorTabs),xe(5,u.IExtHostVariableResolverProvider)],r),e.WorkerExtHostDebugService=r}),define(De[230],Ce([1,0,11,71,2,5,221,14,56,58,28,147,15,63,33]),function(J,e,o,C,p,U,I,P,b,A,R,_,m,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class h{constructor(l,S,w,a,y){this._hostUtils=w,this._rpcProtocol=new I.RPCProtocol(l,null,a),S=h._transform(S,this._rpcProtocol);const r=new A.ServiceCollection(...(0,b.getSingletonServiceDescriptors)());r.set(R.IExtHostInitDataService,{_serviceBrand:void 0,...S,messagePorts:y}),r.set(m.IExtHostRpcService,new m.ExtHostRpcService(this._rpcProtocol)),r.set(T.IURITransformerService,new T.URITransformerService(a)),r.set(g.IHostUtils,w);const d=new _.InstantiationService(r,!0);this._logService=d.invokeFunction(t=>t.get(P.ILogService)),C.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",S),this._extensionService=d.invokeFunction(t=>t.get(g.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const i=new WeakMap;this._extensionService.getExtensionPathIndex().then(t=>{Error.prepareStackTrace=(c,E)=>{let f="",D,L;for(const W of E)f+=`
	at ${W.toString()}`,L=W.getFileName(),!D&&L&&(D=t.findSubstr(p.URI.file(L)));return i.set(c,D),`${c.name||"Error"}: ${c.message||""}${f}`}});const s=this._rpcProtocol.getProxy(U.MainContext.MainThreadExtensionService),n=this._rpcProtocol.getProxy(U.MainContext.MainThreadErrors);o.setUnexpectedErrorHandler(t=>{const c=o.transformErrorForSerialization(t),E=i.get(t);E?s.$onExtensionRuntimeError(E.identifier,c):n.$onUnexpectedError(c)})}async asBrowserUri(l){const S=this._rpcProtocol.getProxy(U.MainContext.MainThreadExtensionService);return p.URI.revive(await S.$asBrowserUri(l))}terminate(l){this._extensionService.terminate(l)}static _transform(l,S){l.allExtensions.forEach(a=>a.extensionLocation=p.URI.revive(S.transformIncomingURIs(a.extensionLocation))),l.environment.appRoot=p.URI.revive(S.transformIncomingURIs(l.environment.appRoot));const w=l.environment.extensionDevelopmentLocationURI;return w&&(l.environment.extensionDevelopmentLocationURI=w.map(a=>p.URI.revive(S.transformIncomingURIs(a)))),l.environment.extensionTestsLocationURI=p.URI.revive(S.transformIncomingURIs(l.environment.extensionTestsLocationURI)),l.environment.globalStorageHome=p.URI.revive(S.transformIncomingURIs(l.environment.globalStorageHome)),l.environment.workspaceStorageHome=p.URI.revive(S.transformIncomingURIs(l.environment.workspaceStorageHome)),l.logsLocation=p.URI.revive(S.transformIncomingURIs(l.logsLocation)),l.logFile=p.URI.revive(S.transformIncomingURIs(l.logFile)),l.workspace=S.transformIncomingURIs(l.workspace),l}}e.ExtensionHostMain=h}),define(De[231],Ce([1,0,16,13,20,44,12,19,21,9,2,41]),function(J,e,o,C,p,U,I,P,b,A,R,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class m{constructor(w,a,y,r){this.query=w,this.provider=a,this.fileUtils=y,this.processType=r,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(w,a){const y=this.query.folderQueries||[],r=new p.CancellationTokenSource;return a.onCancellationRequested(()=>r.cancel()),new Promise((d,i)=>{this.collector=new g(w);let s=!1;const n=(t,c)=>{if(!s&&!this.isLimitHit){const E=this.resultSize(t);u(t)&&typeof this.query.maxResults=="number"&&this.resultCount+E>this.query.maxResults&&(this.isLimitHit=!0,s=!0,r.cancel(),t=this.trimResultToSize(t,this.query.maxResults-this.resultCount));const f=this.resultSize(t);this.resultCount+=f,(f>0||!u(t))&&this.collector.add(t,c)}};Promise.all(y.map((t,c)=>this.searchInFolder(t,E=>n(E,c),r.token))).then(t=>{r.dispose(),this.collector.flush();const c=t.some(E=>!!E&&!!E.limitHit);d({limitHit:this.isLimitHit||c,messages:(0,o.flatten)(t.map(E=>E?.message?(0,A.isArray)(E.message)?E.message:[E.message]:[])),stats:{type:this.processType}})},t=>{r.dispose();const c=(0,U.toErrorMessage)(t);i(new Error(c))})})}resultSize(w){return u(w)?Array.isArray(w.ranges)?w.ranges.length:1:0}trimResultToSize(w,a){const y=Array.isArray(w.ranges)?w.ranges:[w.ranges],r=Array.isArray(w.preview.matches)?w.preview.matches:[w.preview.matches];return{ranges:y.slice(0,a),preview:{matches:r.slice(0,a),text:w.preview.text},uri:w.uri}}async searchInFolder(w,a,y){const r=new _.QueryGlobTester(this.query,w),d=[],i={report:t=>{if(!this.validateProviderResult(t))return;const c=w.folder.scheme===I.Schemas.file?(0,_.hasSiblingPromiseFn)(()=>this.fileUtils.readdir(b.dirname(t.uri))):void 0,E=b.relativePath(w.folder,t.uri);if(E){const f=r.includedInQuery(E,P.basename(E),c);(0,C.isThenable)(f)?d.push(f.then(D=>{D&&a(t)})):f&&a(t)}}},s=this.getSearchOptionsForFolder(w),n=await this.provider.provideTextSearchResults(T(this.query.contentPattern),s,i,y);return d.length&&await Promise.all(d),n}validateProviderResult(w){if(u(w)){if(Array.isArray(w.ranges)){if(!Array.isArray(w.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(w.preview.matches.length!==w.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(w.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(w){const a=(0,_.resolvePatternsForProvider)(this.query.includePattern,w.includePattern),y=(0,_.resolvePatternsForProvider)(this.query.excludePattern,w.excludePattern),r={folder:R.URI.from(w.folder),excludes:y,includes:a,useIgnoreFiles:!w.disregardIgnoreFiles,useGlobalIgnoreFiles:!w.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!w.disregardParentIgnoreFiles,followSymlinks:!w.ignoreSymlinks,encoding:w.fileEncoding&&this.fileUtils.toCanonicalName(w.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return r.usePCRE2=this.query.usePCRE2,r}}e.TextSearchManager=m;function T(S){return{isCaseSensitive:S.isCaseSensitive||!1,isRegExp:S.isRegExp||!1,isWordMatch:S.isWordMatch||!1,isMultiline:S.isMultiline||!1,pattern:S.pattern}}class g{constructor(w){this._onResult=w,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new l(512,a=>this.sendItems(a))}add(w,a){this._currentFileMatch&&(this._currentFolderIdx!==a||!b.isEqual(this._currentUri,w.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=a,this._currentFileMatch={resource:w.uri,results:[]}),this._currentFileMatch.results.push(h(w))}pushToCollector(){const w=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,w)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(w){this._onResult(w)}}e.TextSearchResultsCollector=g;function h(S){return u(S)?{preview:{matches:(0,o.mapArrayOrNot)(S.preview.matches,w=>({startLineNumber:w.start.line,startColumn:w.start.character,endLineNumber:w.end.line,endColumn:w.end.character})),text:S.preview.text},ranges:(0,o.mapArrayOrNot)(S.ranges,w=>({startLineNumber:w.start.line,startColumn:w.start.character,endLineNumber:w.end.line,endColumn:w.end.character}))}:{text:S.text,lineNumber:S.lineNumber}}function u(S){return!!S.preview}e.extensionResultIsMatch=u;class l{constructor(w,a){this.maxBatchSize=w,this.cb=a,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(w,a){!w||this.addItemToBatch(w,a)}addItems(w,a){!w||this.addItemsToBatch(w,a)}addItemToBatch(w,a){this.batch.push(w),this.batchSize+=a,this.onUpdate()}addItemsToBatch(w,a){this.batch=this.batch.concat(w),this.batchSize+=a,this.onUpdate()}onUpdate(){this.totalNumberCompleted<l.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},l.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=l,l.TIMEOUT=4e3,l.START_BATCH_AFTER_COUNT=50}),define(De[103],Ce([1,0,7,5,3,226,15,63,14,2,231]),function(J,e,o,C,p,U,I,P,b,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,p.createDecorator)("IExtHostSearch");let _=class{constructor(h,u,l){this.extHostRpc=h,this._uriTransformer=u,this._logService=l,this._proxy=this.extHostRpc.getProxy(C.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new U.FileSearchManager}_transformScheme(h){return this._uriTransformer.transformOutgoingScheme(h)}registerTextSearchProvider(h,u){if(this._textSearchUsedSchemes.has(h))throw new Error(`a text search provider for the scheme '${h}' is already registered`);this._textSearchUsedSchemes.add(h);const l=this._handlePool++;return this._textSearchProvider.set(l,u),this._proxy.$registerTextSearchProvider(l,this._transformScheme(h)),(0,o.toDisposable)(()=>{this._textSearchUsedSchemes.delete(h),this._textSearchProvider.delete(l),this._proxy.$unregisterProvider(l)})}registerFileSearchProvider(h,u){if(this._fileSearchUsedSchemes.has(h))throw new Error(`a file search provider for the scheme '${h}' is already registered`);this._fileSearchUsedSchemes.add(h);const l=this._handlePool++;return this._fileSearchProvider.set(l,u),this._proxy.$registerFileSearchProvider(l,this._transformScheme(h)),(0,o.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(h),this._fileSearchProvider.delete(l),this._proxy.$unregisterProvider(l)})}$provideFileSearchResults(h,u,l,S){const w=m(l),a=this._fileSearchProvider.get(h);if(a)return this._fileSearchManager.fileSearch(w,a,y=>{this._proxy.$handleFileMatch(h,u,y.map(r=>r.resource))},S);throw new Error("unknown provider: "+h)}$clearCache(h){return this._fileSearchManager.clearCache(h),Promise.resolve(void 0)}$provideTextSearchResults(h,u,l,S){const w=this._textSearchProvider.get(h);if(!w||!w.provideTextSearchResults)throw new Error(`Unknown provider ${h}`);const a=m(l);return this.createTextSearchManager(a,w).search(r=>this._proxy.$handleTextMatch(h,u,r),S)}$enableExtensionHostSearch(){}createTextSearchManager(h,u){return new R.TextSearchManager(h,u,{readdir:l=>Promise.resolve([]),toCanonicalName:l=>l},"textSearchProvider")}};_=$e([xe(0,I.IExtHostRpcService),xe(1,P.IURITransformerService),xe(2,b.ILogService)],_),e.ExtHostSearch=_;function m(g){return{...g,folderQueries:g.folderQueries&&g.folderQueries.map(T),extraFileResources:g.extraFileResources&&g.extraFileResources.map(h=>A.URI.revive(h))}}e.reviveQuery=m;function T(g){return{...g,folder:A.URI.revive(g.folder)}}}),define(De[232],Ce([1,0,56,98,31,95,32,36,49,52,100,102,103,69,62,68,97,51,35,67,86,50,204,14,180,101]),function(J,e,o,C,p,U,I,P,b,A,R,_,m,T,g,h,u,l,S,w,a,y,r,d,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,o.registerSingleton)(d.ILoggerService,r.ExtHostLoggerService),(0,o.registerSingleton)(d.ILogService,i.ExtHostLogService),(0,o.registerSingleton)(h.IExtHostApiDeprecationService,h.ExtHostApiDeprecationService),(0,o.registerSingleton)(P.IExtHostCommands,P.ExtHostCommands),(0,o.registerSingleton)(I.IExtHostConfiguration,I.ExtHostConfiguration),(0,o.registerSingleton)(l.IExtHostConsumerFileSystem,l.ExtHostConsumerFileSystem),(0,o.registerSingleton)(_.IExtHostDebugService,_.WorkerExtHostDebugService),(0,o.registerSingleton)(U.IExtHostDecorations,U.ExtHostDecorations),(0,o.registerSingleton)(b.IExtHostDocumentsAndEditors,b.ExtHostDocumentsAndEditors),(0,o.registerSingleton)(S.IExtHostFileSystemInfo,S.ExtHostFileSystemInfo),(0,o.registerSingleton)(C.IExtHostOutputService,C.ExtHostOutputService),(0,o.registerSingleton)(m.IExtHostSearch,m.ExtHostSearch),(0,o.registerSingleton)(T.IExtHostStorage,T.ExtHostStorage),(0,o.registerSingleton)(R.IExtHostTask,R.WorkerExtHostTask),(0,o.registerSingleton)(A.IExtHostTerminalService,A.WorkerExtHostTerminalService),(0,o.registerSingleton)(g.IExtHostTunnelService,g.ExtHostTunnelService),(0,o.registerSingleton)(u.IExtHostWindow,u.ExtHostWindow),(0,o.registerSingleton)(p.IExtHostWorkspace,p.ExtHostWorkspace),(0,o.registerSingleton)(w.IExtHostSecretState,w.ExtHostSecretState),(0,o.registerSingleton)(a.IExtHostTelemetry,a.ExtHostTelemetry),(0,o.registerSingleton)(y.IExtHostEditorTabs,y.ExtHostEditorTabs),(0,o.registerSingleton)(s.IExtHostVariableResolverProvider,s.ExtHostVariableResolverProviderService)}),define(De[233],Ce([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeviewsService=void 0;class o{constructor(){this._dragOperations=new Map,this._renderedElements=new Map}removeDragOperationTransfer(p){if(p&&this._dragOperations.has(p)){const U=this._dragOperations.get(p);return this._dragOperations.delete(p),U}}addDragOperationTransfer(p,U){this._dragOperations.set(p,U)}getRenderedTreeElement(p){if(this._renderedElements.has(p))return this._renderedElements.get(p)}addRenderedTreeItemElement(p,U){this._renderedElements.set(p,U)}removeRenderedTreeItemElement(p){this._renderedElements.has(p)&&this._renderedElements.delete(p)}}e.TreeviewsService=o}),define(De[234],Ce([1,0,133,6,21,2,4,7,13,6,9,16,8,20,233,25]),function(J,e,o,C,p,U,I,P,b,A,R,_,m,T,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function u(w,a){if((0,R.isString)(w))return{label:w};if(w&&typeof w=="object"&&typeof w.label=="string"){let y;return Array.isArray(w.highlights)&&(y=w.highlights.filter(r=>r.length===2&&typeof r[0]=="number"&&typeof r[1]=="number"),y=y.length?y:void 0),{label:w.label,highlights:y}}}class l{constructor(a,y,r){this._proxy=a,this.commands=y,this.logService=r,this.treeViews=new Map,this.treeDragAndDropService=new g.TreeviewsService;function d(i){return i&&i.$treeViewId&&i.$treeItemHandle}y.registerArgumentProcessor({processArgument:i=>d(i)?this.convertArgument(i):Array.isArray(i)&&i.length>0?i.map(s=>d(s)?this.convertArgument(s):s):i})}registerTreeDataProvider(a,y,r){const d=this.createTreeView(a,{treeDataProvider:y},r);return{dispose:()=>d.dispose()}}createTreeView(a,y,r){if(!y||!y.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const d=y.dragAndDropController?.dropMimeTypes??[],i=y.dragAndDropController?.dragMimeTypes??[],s=!!y.dragAndDropController?.handleDrag,n=!!y.dragAndDropController?.handleDrop,t=this._proxy.$registerTreeViewDataProvider(a,{showCollapseAll:!!y.showCollapseAll,canSelectMany:!!y.canSelectMany,dropMimeTypes:d,dragMimeTypes:i,hasHandleDrag:s,hasHandleDrop:n}),c=this.createExtHostTreeView(a,y,r);return{get onDidCollapseElement(){return c.onDidCollapseElement},get onDidExpandElement(){return c.onDidExpandElement},get selection(){return c.selectedElements},get onDidChangeSelection(){return c.onDidChangeSelection},get visible(){return c.visible},get onDidChangeVisibility(){return c.onDidChangeVisibility},get message(){return c.message},set message(E){c.message=E},get title(){return c.title},set title(E){c.title=E},get description(){return c.description},set description(E){c.description=E},get badge(){return(0,h.checkProposedApiEnabled)(r,"badges"),c.badge},set badge(E){(0,h.checkProposedApiEnabled)(r,"badges"),c.badge=E},reveal:(E,f)=>c.reveal(E,f),dispose:async()=>{await t,this.treeViews.delete(a),c.dispose()}}}$getChildren(a,y){const r=this.treeViews.get(a);return r?r.getChildren(y):Promise.reject(new Error((0,o.localize)(0,null,a)))}async $handleDrop(a,y,r,d,i,s,n,t){const c=this.treeViews.get(a);if(!c)return Promise.reject(new Error((0,o.localize)(1,null,a)));const E=m.DataTransfer.toDataTransfer(r,async f=>(await this._proxy.$resolveDropFileData(a,y,f)).buffer);return n===a&&t&&await this.addAdditionalTransferItems(E,c,t,i,s),c.onDrop(E,d,i)}async addAdditionalTransferItems(a,y,r,d,i){const s=this.treeDragAndDropService.removeDragOperationTransfer(i);if(s)(await s)?.forEach((n,t)=>{n&&a.set(t,n)});else if(i&&y.handleDrag){const n=y.handleDrag(r,a,d);this.treeDragAndDropService.addDragOperationTransfer(i,n),await n}return a}async $handleDrag(a,y,r,d){const i=this.treeViews.get(a);if(!i)return Promise.reject(new Error((0,o.localize)(2,null,a)));const s=await this.addAdditionalTransferItems(new C.DataTransfer,i,y,d,r);if(!!s)return m.DataTransfer.toDataTransferDTO(s)}async $hasResolve(a){const y=this.treeViews.get(a);if(!y)throw new Error((0,o.localize)(3,null,a));return y.hasResolve}$resolve(a,y,r){const d=this.treeViews.get(a);if(!d)throw new Error((0,o.localize)(4,null,a));return d.resolveTreeItem(y,r)}$setExpanded(a,y,r){const d=this.treeViews.get(a);if(!d)throw new Error((0,o.localize)(5,null,a));d.setExpanded(y,r)}$setSelection(a,y){const r=this.treeViews.get(a);if(!r)throw new Error((0,o.localize)(6,null,a));r.setSelection(y)}$setVisible(a,y){const r=this.treeViews.get(a);if(!r)throw new Error((0,o.localize)(7,null,a));r.setVisible(y)}createExtHostTreeView(a,y,r){const d=new S(a,y,this._proxy,this.commands.converter,this.logService,r);return this.treeViews.set(a,d),d}convertArgument(a){const y=this.treeViews.get(a.$treeViewId);return y?y.getExtensionElement(a.$treeItemHandle):null}}e.ExtHostTreeViews=l;class S extends P.Disposable{constructor(a,y,r,d,i,s){super();if(this.viewId=a,this.proxy=r,this.commands=d,this.logService=i,this.extension=s,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new I.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new I.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new I.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new I.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new I.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new T.CancellationTokenSource,s.contributes&&s.contributes.views)for(const c in s.contributes.views)for(const E of s.contributes.views[c])E.id===a&&(this._title=E.name);this.dataProvider=y.treeDataProvider,this.dndController=y.dragAndDropController,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(c=>this._onDidChangeData.fire({message:!1,element:c})));let n,t;this._register(I.Event.debounce(this._onDidChangeData.event,(c,E)=>(c||(c={message:!1,elements:[]}),E.element!==!1&&(n||(n=new Promise(f=>t=f),this.refreshPromise=this.refreshPromise.then(()=>n)),Array.isArray(E.element)?c.elements.push(...E.element):c.elements.push(E.element)),E.message&&(c.message=!0),c),200,!0)(({message:c,elements:E})=>{E.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const f=t;return n=null,this.refresh(E).then(()=>f())})),c&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(a=>this.getExtensionElement(a)).filter(a=>!(0,R.isUndefinedOrNull)(a))}async getChildren(a){const y=a?this.getExtensionElement(a):void 0;if(a&&!y)return this.logService.error(`No tree item with id '${a}' found.`),Promise.resolve([]);let r=this.getChildrenNodes(a);return r||(r=await this.fetchChildrenNodes(y)),r?r.map(d=>d.item):void 0}getExtensionElement(a){return this.elements.get(a)}reveal(a,y){y=y||{select:!0,focus:!1};const r=(0,R.isUndefinedOrNull)(y.select)?!0:y.select,d=(0,R.isUndefinedOrNull)(y.focus)?!1:y.focus,i=(0,R.isUndefinedOrNull)(y.expand)?!1:y.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):a?this.refreshPromise.then(()=>this.resolveUnknownParentChain(a)).then(s=>this.resolveTreeNode(a,s[s.length-1]).then(n=>this.proxy.$reveal(this.viewId,{item:n.item,parentChain:s.map(t=>t.item)},{select:r,focus:d,expand:i})),s=>this.logService.error(s)):this.proxy.$reveal(this.viewId,void 0,{select:r,focus:d,expand:i})}get message(){return this._message}set message(a){this._message=a,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(a){this._title=a,this.proxy.$setTitle(this.viewId,a,this._description)}get description(){return this._description}set description(a){this._description=a,this.proxy.$setTitle(this.viewId,this._title,a)}get badge(){return this._badge}set badge(a){this._badge?.value===a?.value&&this._badge?.tooltip===a?.tooltip||(this._badge=m.ViewBadge.from(a),this.proxy.$setBadge(this.viewId,a))}setExpanded(a,y){const r=this.getExtensionElement(a);r&&(y?this._onDidExpandElement.fire(Object.freeze({element:r})):this._onDidCollapseElement.fire(Object.freeze({element:r})))}setSelection(a){(0,_.equals)(this._selectedHandles,a)||(this._selectedHandles=a,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(a){a!==this._visible&&(this._visible=a,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async handleDrag(a,y,r){const d=[];for(const i of a){const s=this.getExtensionElement(i);s&&d.push(s)}if(!(!this.dndController?.handleDrag||d.length===0))return await this.dndController.handleDrag(d,y,r),y}get hasHandleDrag(){return!!this.dndController?.handleDrag}async onDrop(a,y,r){const d=y?this.getExtensionElement(y):void 0;if(!(!d&&y||!this.dndController?.handleDrop))return(0,b.asPromise)(()=>this.dndController?.handleDrop?this.dndController.handleDrop(d,a,r):void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(a,y){if(!this.dataProvider.resolveTreeItem)return;const r=this.elements.get(a);if(r){const d=this.nodes.get(r);if(d){const i=await this.dataProvider.resolveTreeItem(d.extensionItem,r,y)??d.extensionItem;return d.item.tooltip=this.getTooltip(i.tooltip),d.item.command=this.getCommand(d.disposableStore,i.command),d.item}}}resolveUnknownParentChain(a){return this.resolveParent(a).then(y=>y?this.resolveUnknownParentChain(y).then(r=>this.resolveTreeNode(y,r[r.length-1]).then(d=>(r.push(d),r))):Promise.resolve([]))}resolveParent(a){const y=this.nodes.get(a);return y?Promise.resolve(y.parent?this.elements.get(y.parent.item.handle):void 0):(0,b.asPromise)(()=>this.dataProvider.getParent(a))}resolveTreeNode(a,y){const r=this.nodes.get(a);return r?Promise.resolve(r):(0,b.asPromise)(()=>this.dataProvider.getTreeItem(a)).then(d=>this.createHandle(a,d,y,!0)).then(d=>this.getChildren(y?y.item.handle:void 0).then(()=>{const i=this.getExtensionElement(d);if(i){const s=this.nodes.get(i);if(s)return Promise.resolve(s)}throw new Error(`Cannot resolve tree item for element ${d}`)}))}getChildrenNodes(a){if(a){let y;if(typeof a=="string"){const r=this.getExtensionElement(a);y=r?this.nodes.get(r):void 0}else y=a;return y&&y.children||void 0}return this.roots}async fetchChildrenNodes(a){this.clearChildren(a);const y=new T.CancellationTokenSource(this._refreshCancellationSource.token);try{const r=a?this.nodes.get(a):void 0,d=await this.dataProvider.getChildren(a);if(y.token.isCancellationRequested)return;const i=await Promise.all((0,_.coalesce)(d||[]).map(async s=>{const n=await this.dataProvider.getTreeItem(s);return n&&!y.token.isCancellationRequested?this.createAndRegisterTreeNode(s,n,r):null}));return y.token.isCancellationRequested?void 0:(0,_.coalesce)(i)}finally{y.dispose()}}refresh(a){if(a.some(r=>!r))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new T.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const r=this.getHandlesToRefresh(a);if(r.length)return this.refreshHandles(r)}return Promise.resolve(void 0)}getHandlesToRefresh(a){const y=new Set,r=a.map(i=>this.nodes.get(i));for(const i of r)if(i&&!y.has(i.item.handle)){let s=i;for(;s&&s.parent&&r.findIndex(n=>s&&s.parent&&n&&n.item.handle===s.parent.item.handle)===-1;){const n=this.elements.get(s.parent.item.handle);s=n?this.nodes.get(n):void 0}s&&!s.parent&&y.add(i.item.handle)}const d=[];return y.forEach(i=>{const s=this.elements.get(i);if(s){const n=this.nodes.get(s);n&&(!n.parent||!y.has(n.parent.item.handle))&&d.push(i)}}),d}refreshHandles(a){const y={};return Promise.all(a.map(r=>this.refreshNode(r).then(d=>{d&&(y[r]=d.item)}))).then(()=>Object.keys(y).length?this.proxy.$refresh(this.viewId,y):void 0)}refreshNode(a){const y=this.getExtensionElement(a);if(y){const r=this.nodes.get(y);if(r)return this.clearChildren(y),(0,b.asPromise)(()=>this.dataProvider.getTreeItem(y)).then(d=>{if(d){const i=this.createTreeNode(y,d,r.parent);return this.updateNodeCache(y,i,r,r.parent),r.dispose(),i}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(a,y,r){const d=this.createTreeNode(a,y,r);if(y.id&&this.elements.has(d.item.handle))throw new Error((0,o.localize)(8,null,y.id));return this.addNodeToCache(a,d),this.addNodeToParentCache(d,r),d}getTooltip(a){return A.MarkdownString.isMarkdownString(a)?m.MarkdownString.from(a):a}getCommand(a,y){return y?this.commands.toInternal(y,a):void 0}createTreeNode(a,y,r){const d=new P.DisposableStore,i=this.createHandle(a,y,r),s=this.getLightIconPath(y);return{item:{handle:i,parentHandle:r?r.item.handle:void 0,label:u(y.label,this.extension),description:y.description,resourceUri:y.resourceUri,tooltip:this.getTooltip(y.tooltip),command:this.getCommand(d,y.command),contextValue:y.contextValue,icon:s,iconDark:this.getDarkIconPath(y)||s,themeIcon:this.getThemeIcon(y),collapsibleState:(0,R.isUndefinedOrNull)(y.collapsibleState)?A.TreeItemCollapsibleState.None:y.collapsibleState,accessibilityInformation:y.accessibilityInformation},extensionItem:y,parent:r,children:void 0,disposableStore:d,dispose(){d.dispose()}}}getThemeIcon(a){return a.iconPath instanceof A.ThemeIcon?a.iconPath:void 0}createHandle(a,{id:y,label:r,resourceUri:d},i,s){if(y)return`${S.ID_HANDLE_PREFIX}/${y}`;const n=u(r,this.extension),t=i?i.item.handle:S.LABEL_HANDLE_PREFIX;let c=n?n.label:d?(0,p.basename)(d):"";c=c.indexOf("/")!==-1?c.replace("/","//"):c;const E=this.nodes.has(a)?this.nodes.get(a).item.handle:void 0,f=this.getChildrenNodes(i)||[];let D,L=0;do{if(D=`${t}/${L}:${c}`,s||!this.elements.has(D)||E===D)break;L++}while(L<=f.length);return D}getLightIconPath(a){if(a.iconPath&&!(a.iconPath instanceof A.ThemeIcon))return typeof a.iconPath=="string"||U.URI.isUri(a.iconPath)?this.getIconPath(a.iconPath):this.getIconPath(a.iconPath.light)}getDarkIconPath(a){if(a.iconPath&&!(a.iconPath instanceof A.ThemeIcon)&&a.iconPath.dark)return this.getIconPath(a.iconPath.dark)}getIconPath(a){return U.URI.isUri(a)?a:U.URI.file(a)}addNodeToCache(a,y){this.elements.set(y.item.handle,a),this.nodes.set(a,y)}updateNodeCache(a,y,r,d){this.elements.delete(y.item.handle),this.nodes.delete(a),y.item.handle!==r.item.handle&&this.elements.delete(r.item.handle),this.addNodeToCache(a,y);const i=this.getChildrenNodes(d)||[],s=i.filter(n=>n.item.handle===r.item.handle)[0];s&&i.splice(i.indexOf(s),1,y)}addNodeToParentCache(a,y){y?(y.children||(y.children=[]),y.children.push(a)):(this.roots||(this.roots=[]),this.roots.push(a))}clearChildren(a){if(a){const y=this.nodes.get(a);if(y){if(y.children)for(const r of y.children){const d=this.elements.get(r.item.handle);d&&this.clear(d)}y.children=void 0}}else this.clearAll()}clear(a){const y=this.nodes.get(a);if(y){if(y.children)for(const r of y.children){const d=this.elements.get(r.item.handle);d&&this.clear(d)}this.nodes.delete(a),this.elements.delete(y.item.handle),y.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(a=>a.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}S.LABEL_HANDLE_PREFIX="0",S.ID_HANDLE_PREFIX="1"}),define(De[235],Ce([1,0,20,11,4,29,2,120,245,109,118,39,5,94,189,188,36,190,32,192,193,194,173,195,49,33,197,198,201,203,205,98,176,209,210,211,69,52,213,234,8,6,216,53,97,31,163,200,85,95,100,102,103,14,63,15,28,206,160,62,68,186,214,70,51,219,217,218,187,35,212,215,67,50,86,207,99,208,12,81,175,158,199,7,25,165,10]),function(J,e,o,C,p,U,I,P,b,A,R,_,m,T,g,h,u,l,S,w,a,y,r,d,i,s,n,t,c,E,f,D,L,W,N,v,F,O,H,te,z,$,ce,le,oe,pe,re,Ee,be,Z,ve,Re,Fe,We,Xe,Ie,Se,Te,se,ae,G,X,k,B,V,j,ne,ue,Y,ge,fe,Ne,ze,ke,qe,K,Q,me,Le,Be,Ze,et,at,Je,He,nt,st){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function ot(lt){const dt=lt.get(Se.IExtHostInitDataService),kt=lt.get(ge.IExtHostFileSystemInfo),Mt=lt.get(V.IExtHostConsumerFileSystem),Dt=lt.get(s.IExtHostExtensionService),ft=lt.get(pe.IExtHostWorkspace),Ct=lt.get(qe.IExtHostTelemetry),Nt=lt.get(S.IExtHostConfiguration),Pt=lt.get(Xe.IURITransformerService),Ve=lt.get(Ie.IExtHostRpcService),At=lt.get(F.IExtHostStorage),Lt=lt.get(B.IExtensionStoragePaths),Ot=lt.get(We.ILoggerService),mt=lt.get(We.ILogService),yt=lt.get(ae.IExtHostTunnelService),we=lt.get(G.IExtHostApiDeprecationService),ye=lt.get(oe.IExtHostWindow),he=lt.get(ze.IExtHostSecretState),q=lt.get(ke.IExtHostEditorTabs);Ve.set(m.ExtHostContext.ExtHostFileSystemInfo,kt),Ve.set(m.ExtHostContext.ExtHostLogLevelServiceShape,Ot),Ve.set(m.ExtHostContext.ExtHostWorkspace,ft),Ve.set(m.ExtHostContext.ExtHostConfiguration,Nt),Ve.set(m.ExtHostContext.ExtHostExtensionService,Dt),Ve.set(m.ExtHostContext.ExtHostStorage,At),Ve.set(m.ExtHostContext.ExtHostTunnelService,yt),Ve.set(m.ExtHostContext.ExtHostWindow,ye),Ve.set(m.ExtHostContext.ExtHostSecretState,he),Ve.set(m.ExtHostContext.ExtHostTelemetry,Ct),Ve.set(m.ExtHostContext.ExtHostEditorTabs,q);const Pe=Ve.set(m.ExtHostContext.ExtHostDecorations,lt.get(Z.IExtHostDecorations)),Ue=Ve.set(m.ExtHostContext.ExtHostDocumentsAndEditors,lt.get(i.IExtHostDocumentsAndEditors)),Ke=Ve.set(m.ExtHostContext.ExtHostCommands,lt.get(u.IExtHostCommands)),Qe=Ve.set(m.ExtHostContext.ExtHostTerminalService,lt.get(O.IExtHostTerminalService)),Ge=Ve.set(m.ExtHostContext.ExtHostDebugService,lt.get(Re.IExtHostDebugService)),gt=Ve.set(m.ExtHostContext.ExtHostSearch,lt.get(Fe.IExtHostSearch)),pt=Ve.set(m.ExtHostContext.ExtHostTask,lt.get(ve.IExtHostTask)),_t=Ve.set(m.ExtHostContext.ExtHostOutputService,lt.get(D.IExtHostOutputService)),vt=Ve.set(m.ExtHostContext.ExtHostUrls,new ce.ExtHostUrls(Ve)),ht=Ve.set(m.ExtHostContext.ExtHostDocuments,new d.ExtHostDocuments(Ve,Ue)),Gt=Ve.set(m.ExtHostContext.ExtHostDocumentContentProviders,new y.ExtHostDocumentContentProvider(Ve,Ue,mt)),Xt=Ve.set(m.ExtHostContext.ExtHostDocumentSaveParticipant,new r.ExtHostDocumentSaveParticipant(mt,ht,Ve.getProxy(m.MainContext.MainThreadBulkEdits))),bt=Ve.set(m.ExtHostContext.ExtHostNotebook,new Te.ExtHostNotebookController(Ve,Ke,Ue,ht,Lt)),ni=Ve.set(m.ExtHostContext.ExtHostNotebookDocuments,new et.ExtHostNotebookDocuments(bt)),Ut=Ve.set(m.ExtHostContext.ExtHostNotebookEditors,new Ze.ExtHostNotebookEditors(mt,bt)),ri=Ve.set(m.ExtHostContext.ExtHostNotebookKernels,new K.ExtHostNotebookKernels(Ve,dt,bt,Ke,mt)),Ii=Ve.set(m.ExtHostContext.ExtHostNotebookRenderers,new me.ExtHostNotebookRenderers(Ve,bt)),It=Ve.set(m.ExtHostContext.ExtHostEditors,new H.ExtHostEditors(Ve,Ue)),Ht=Ve.set(m.ExtHostContext.ExtHostTreeViews,new te.ExtHostTreeViews(Ve.getProxy(m.MainContext.MainThreadTreeViews),Ke,mt)),hi=Ve.set(m.ExtHostContext.ExtHostEditorInsets,new re.ExtHostEditorInsets(Ve.getProxy(m.MainContext.MainThreadEditorInsets),It,dt.remote)),Qt=Ve.set(m.ExtHostContext.ExtHostDiagnostics,new w.ExtHostDiagnostics(Ve,mt,kt)),Yt=Ve.set(m.ExtHostContext.ExtHostLanguages,new E.ExtHostLanguages(Ve,ht,Ke.converter,Pt)),ut=Ve.set(m.ExtHostContext.ExtHostLanguageFeatures,new c.ExtHostLanguageFeatures(Ve,Pt,ht,Ke,Qt,mt,we)),fi=Ve.set(m.ExtHostContext.ExtHostFileSystem,new n.ExtHostFileSystem(Ve,ut)),Bt=Ve.set(m.ExtHostContext.ExtHostFileSystemEventService,new t.ExtHostFileSystemEventService(Ve,mt,Ue)),Vt=Ve.set(m.ExtHostContext.ExtHostQuickOpen,(0,W.createExtHostQuickOpen)(Ve,ft,Ke)),si=Ve.set(m.ExtHostContext.ExtHostSCM,new N.ExtHostSCM(Ve,Ke,mt)),Ti=Ve.set(m.ExtHostContext.ExtHostComments,(0,l.createExtHostComments)(Ve,Ke,ht)),_i=Ve.set(m.ExtHostContext.ExtHostProgress,new L.ExtHostProgress(Ve.getProxy(m.MainContext.MainThreadProgress))),mi=Ve.set(m.ExtHostContext.ExtHosLabelService,new Ee.ExtHostLabelService(Ve)),oi=Ve.set(m.ExtHostContext.ExtHostTheming,new se.ExtHostTheming(Ve)),Jt=Ve.set(m.ExtHostContext.ExtHostAuthentication,new X.ExtHostAuthentication(Ve)),gi=Ve.set(m.ExtHostContext.ExtHostTimeline,new k.ExtHostTimeline(Ve,Ke)),pi=Ve.set(m.ExtHostContext.ExtHostWebviews,new le.ExtHostWebviews(Ve,dt.remote,ft,mt,we)),Zt=Ve.set(m.ExtHostContext.ExtHostWebviewPanels,new ue.ExtHostWebviewPanels(Ve,pi,ft)),vi=Ve.set(m.ExtHostContext.ExtHostCustomEditors,new ne.ExtHostCustomEditors(Ve,ht,Lt,pi,Zt)),ki=Ve.set(m.ExtHostContext.ExtHostWebviewViews,new j.ExtHostWebviewViews(Ve,pi)),ei=Ve.set(m.ExtHostContext.ExtHostTesting,new fe.ExtHostTesting(Ve,Ke)),Pi=Ve.set(m.ExtHostContext.ExtHostUriOpeners,new Ne.ExtHostUriOpeners(Ve));Ve.set(m.ExtHostContext.ExtHostInteractive,new at.ExtHostInteractive(Ve,bt,Ue,Ke,mt));const Ai=Object.values(m.ExtHostContext);Ve.assertRegistered(Ai);const Ri=new Y.ExtHostBulkEdits(Ve,Ue),Oi=new h.ExtHostClipboard(Ve),ti=new f.ExtHostMessageService(Ve,mt),ai=new a.ExtHostDialogs(Ve),Si=new v.ExtHostStatusBar(Ve,Ke.converter);return g.ExtHostApiCommands.register(Ke),function(Me,xt,ii){const Et=function(){let ie=!Me.isUnderDevelopment;function de(){ie||(mt.info(`Extension '${Me.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ie=!0)}return function Oe(it){if(Array.isArray(it))it.forEach(Oe);else if(typeof it=="string")de();else{const wt=it;typeof wt.scheme=="undefined"&&de(),typeof wt.exclusive=="boolean"&&(0,He.checkProposedApiEnabled)(Me,"documentFiltersExclusive")}return it}}(),Fi={getSession(ie,de,Oe){return Jt.getSession(Me,ie,de,Oe)},async hasSession(ie,de){return(0,He.checkProposedApiEnabled)(Me,"authSession"),!!await Jt.getSession(Me,ie,de,{silent:!0})},get onDidChangeSessions(){return Jt.onDidChangeSessions},registerAuthenticationProvider(ie,de,Oe,it){return Jt.registerAuthenticationProvider(ie,de,Oe,it)}},Ni={registerCommand(ie,de,Oe){return Ke.registerCommand(!0,ie,de,Oe,void 0,Me)},registerTextEditorCommand(ie,de,Oe){return Ke.registerCommand(!0,ie,(...it)=>{const wt=It.getActiveTextEditor();if(!wt){mt.warn("Cannot execute "+ie+" because there is no active text editor.");return}return wt.edit(Tt=>{de.apply(Oe,[wt,Tt,...it])}).then(Tt=>{Tt||mt.warn("Edits from command "+ie+" were not applied.")},Tt=>{mt.warn("An error occurred while running command "+ie,Tt)})},void 0,void 0,Me)},registerDiffInformationCommand:(ie,de,Oe)=>((0,He.checkProposedApiEnabled)(Me,"diffCommand"),Ke.registerCommand(!0,ie,async(...it)=>{const wt=Ue.activeEditor(!0);if(!wt){mt.warn("Cannot execute "+ie+" because there is no active text editor.");return}const Tt=await It.getDiffInformation(wt.id);de.apply(Oe,[Tt,...it])},void 0,void 0,Me)),executeCommand(ie,...de){return Ke.executeCommand(ie,...de)},getCommands(ie=!1){return Ke.getCommands(ie)}},yi={get machineId(){return dt.telemetryInfo.machineId},get sessionId(){return dt.telemetryInfo.sessionId},get language(){return dt.environment.appLanguage},get appName(){return dt.environment.appName},get appRoot(){return dt.environment.appRoot?.fsPath??""},get appHost(){return dt.environment.appHost},get uriScheme(){return dt.environment.appUriScheme},get clipboard(){return Oi.value},get shell(){return Qe.getDefaultShell(!1)},get isTelemetryEnabled(){return Ct.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return Ct.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,He.checkProposedApiEnabled)(Me,"telemetry"),Ct.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,He.checkProposedApiEnabled)(Me,"telemetry"),Ct.onDidChangeTelemetryConfiguration},get isNewAppInstall(){const ie=Date.now()-new Date(dt.telemetryInfo.firstSessionDate).getTime();return isNaN(ie)?!1:ie<1e3*60*60*24},openExternal(ie,de){return ye.openUri(ie,{allowTunneling:!!dt.remote.authority,allowContributedOpeners:de?.allowContributedOpeners})},async asExternalUri(ie){if(ie.scheme===dt.environment.appUriScheme)return vt.createAppUri(ie);try{return await ye.asExternalUri(ie,{allowTunneling:!!dt.remote.authority})}catch(de){if((0,Be.matchesScheme)(ie,Le.Schemas.http)||(0,Be.matchesScheme)(ie,Le.Schemas.https))return ie;throw de}},get remoteName(){return(0,be.getRemoteName)(dt.remote.authority)},get remoteAuthority(){return(0,He.checkProposedApiEnabled)(Me,"resolvers"),dt.remote.authority},get uiKind(){return dt.uiKind}};dt.environment.extensionTestsLocationURI||Object.freeze(yi);const Ei={createTestController(ie,de,Oe){return ei.createTestController(ie,de,Oe)},createTestObserver(){return(0,He.checkProposedApiEnabled)(Me,"testObserver"),ei.createTestObserver()},runTests(ie){return(0,He.checkProposedApiEnabled)(Me,"testObserver"),ei.runTests(ie)},get onDidChangeTestResults(){return(0,He.checkProposedApiEnabled)(Me,"testObserver"),ei.onResultsChanged},get testResults(){return(0,He.checkProposedApiEnabled)(Me,"testObserver"),ei.results}},ci=dt.remote.isRemote?$.ExtensionKind.Workspace:$.ExtensionKind.UI,zt={getExtension(ie,de){(0,st.equalsIgnoreCase)(ie,"ms-vscode.references-view")&&(we.report("The extension 'ms-vscode.references-view' has been renamed.",Me,"Use 'vscode.references-view' instead."),ie="vscode.references-view"),(0,He.isProposedApiEnabled)(Me,"extensionsAny")||(de=!1);const Oe=xt.mine.getExtensionDescription(ie);if(Oe)return new s.Extension(Dt,Me.identifier,Oe,ci,!1);if(de){const it=xt.all.getExtensionDescription(ie);if(it)return new s.Extension(Dt,Me.identifier,it,ci,!0)}},get all(){const ie=[];for(const de of xt.mine.getAllExtensionDescriptions())ie.push(new s.Extension(Dt,Me.identifier,de,ci,!1));return ie},get allAcrossExtensionHosts(){(0,He.checkProposedApiEnabled)(Me,"extensionsAny");const ie=new He.ExtensionIdentifierSet(xt.mine.getAllExtensionDescriptions().map(Oe=>Oe.identifier)),de=[];for(const Oe of xt.all.getAllExtensionDescriptions()){const it=!ie.has(Oe.identifier);de.push(new s.Extension(Dt,Me.identifier,Oe,ci,it))}return de},get onDidChange(){return(0,He.isProposedApiEnabled)(Me,"extensionsAny")?p.Event.any(xt.mine.onDidChange,xt.all.onDidChange):xt.mine.onDidChange}},jt={createDiagnosticCollection(ie){return Qt.createDiagnosticCollection(Me.identifier,ie)},get onDidChangeDiagnostics(){return Qt.onDidChangeDiagnostics},getDiagnostics:ie=>Qt.getDiagnostics(ie),getLanguages(){return Yt.getLanguages()},setTextDocumentLanguage(ie,de){return Yt.changeLanguage(ie.uri,de)},match(ie,de){const Oe=ht.getDocumentData(de.uri)?.notebook;return(0,R.score)(z.LanguageSelector.from(ie),de.uri,de.languageId,!0,Oe?.uri,Oe?.notebookType)},registerCodeActionsProvider(ie,de,Oe){return ut.registerCodeActionProvider(Me,Et(ie),de,Oe)},registerDocumentPasteEditProvider(ie,de,Oe){return(0,He.checkProposedApiEnabled)(Me,"documentPaste"),ut.registerDocumentPasteEditProvider(Me,Et(ie),de,Oe)},registerCodeLensProvider(ie,de){return ut.registerCodeLensProvider(Me,Et(ie),de)},registerDefinitionProvider(ie,de){return ut.registerDefinitionProvider(Me,Et(ie),de)},registerDeclarationProvider(ie,de){return ut.registerDeclarationProvider(Me,Et(ie),de)},registerImplementationProvider(ie,de){return ut.registerImplementationProvider(Me,Et(ie),de)},registerTypeDefinitionProvider(ie,de){return ut.registerTypeDefinitionProvider(Me,Et(ie),de)},registerHoverProvider(ie,de){return ut.registerHoverProvider(Me,Et(ie),de,Me.identifier)},registerEvaluatableExpressionProvider(ie,de){return ut.registerEvaluatableExpressionProvider(Me,Et(ie),de,Me.identifier)},registerInlineValuesProvider(ie,de){return ut.registerInlineValuesProvider(Me,Et(ie),de,Me.identifier)},registerDocumentHighlightProvider(ie,de){return ut.registerDocumentHighlightProvider(Me,Et(ie),de)},registerLinkedEditingRangeProvider(ie,de){return ut.registerLinkedEditingRangeProvider(Me,Et(ie),de)},registerReferenceProvider(ie,de){return ut.registerReferenceProvider(Me,Et(ie),de)},registerRenameProvider(ie,de){return ut.registerRenameProvider(Me,Et(ie),de)},registerDocumentSymbolProvider(ie,de,Oe){return ut.registerDocumentSymbolProvider(Me,Et(ie),de,Oe)},registerWorkspaceSymbolProvider(ie){return ut.registerWorkspaceSymbolProvider(Me,ie)},registerDocumentFormattingEditProvider(ie,de){return ut.registerDocumentFormattingEditProvider(Me,Et(ie),de)},registerDocumentRangeFormattingEditProvider(ie,de){return ut.registerDocumentRangeFormattingEditProvider(Me,Et(ie),de)},registerOnTypeFormattingEditProvider(ie,de,Oe,...it){return ut.registerOnTypeFormattingEditProvider(Me,Et(ie),de,[Oe].concat(it))},registerDocumentSemanticTokensProvider(ie,de,Oe){return ut.registerDocumentSemanticTokensProvider(Me,Et(ie),de,Oe)},registerDocumentRangeSemanticTokensProvider(ie,de,Oe){return ut.registerDocumentRangeSemanticTokensProvider(Me,Et(ie),de,Oe)},registerSignatureHelpProvider(ie,de,Oe,...it){return typeof Oe=="object"?ut.registerSignatureHelpProvider(Me,Et(ie),de,Oe):ut.registerSignatureHelpProvider(Me,Et(ie),de,typeof Oe=="undefined"?[]:[Oe,...it])},registerCompletionItemProvider(ie,de,...Oe){return ut.registerCompletionItemProvider(Me,Et(ie),de,Oe)},registerInlineCompletionItemProvider(ie,de){return de.handleDidShowCompletionItem&&(0,He.checkProposedApiEnabled)(Me,"inlineCompletionsAdditions"),ut.registerInlineCompletionsProvider(Me,Et(ie),de)},registerInlineCompletionItemProviderNew(ie,de){if((0,He.checkProposedApiEnabled)(Me,"inlineCompletionsNew"),de.handleDidShowCompletionItem&&!(0,He.isProposedApiEnabled)(Me,"inlineCompletionsAdditions"))throw new Error(`When the method "handleDidShowCompletionItem" is implemented on a provider, the usage of the proposed api 'inlineCompletionsAdditions' must be declared!`);return ut.registerInlineCompletionsProviderNew(Me,Et(ie),de)},registerDocumentLinkProvider(ie,de){return ut.registerDocumentLinkProvider(Me,Et(ie),de)},registerColorProvider(ie,de){return ut.registerColorProvider(Me,Et(ie),de)},registerFoldingRangeProvider(ie,de){return ut.registerFoldingRangeProvider(Me,Et(ie),de)},registerSelectionRangeProvider(ie,de){return ut.registerSelectionRangeProvider(Me,ie,de)},registerCallHierarchyProvider(ie,de){return ut.registerCallHierarchyProvider(Me,ie,de)},registerTypeHierarchyProvider(ie,de){return ut.registerTypeHierarchyProvider(Me,ie,de)},setLanguageConfiguration:(ie,de)=>ut.setLanguageConfiguration(Me,ie,de),getTokenInformationAtPosition(ie,de){return(0,He.checkProposedApiEnabled)(Me,"tokenInformation"),Yt.tokenAtPosition(ie,de)},registerInlayHintsProvider(ie,de){return ut.registerInlayHintsProvider(Me,ie,de)},createLanguageStatusItem(ie,de){return Yt.createLanguageStatusItem(Me,ie,de)},registerDocumentOnDropEditProvider(ie,de){return(0,He.checkProposedApiEnabled)(Me,"textEditorDrop"),ut.registerDocumentOnDropEditProvider(Me,ie,de)}},Mi={get activeTextEditor(){return It.getActiveTextEditor()},get visibleTextEditors(){return It.getVisibleTextEditors()},get activeTerminal(){return Qe.activeTerminal},get terminals(){return Qe.terminals},async showTextDocument(ie,de,Oe){const it=await(I.URI.isUri(ie)?Promise.resolve(Ft.openTextDocument(ie)):Promise.resolve(ie));return It.showTextDocument(it,de,Oe)},createTextEditorDecorationType(ie){return It.createTextEditorDecorationType(Me,ie)},onDidChangeActiveTextEditor(ie,de,Oe){return It.onDidChangeActiveTextEditor(ie,de,Oe)},onDidChangeVisibleTextEditors(ie,de,Oe){return It.onDidChangeVisibleTextEditors(ie,de,Oe)},onDidChangeTextEditorSelection(ie,de,Oe){return It.onDidChangeTextEditorSelection(ie,de,Oe)},onDidChangeTextEditorOptions(ie,de,Oe){return It.onDidChangeTextEditorOptions(ie,de,Oe)},onDidChangeTextEditorVisibleRanges(ie,de,Oe){return It.onDidChangeTextEditorVisibleRanges(ie,de,Oe)},onDidChangeTextEditorViewColumn(ie,de,Oe){return It.onDidChangeTextEditorViewColumn(ie,de,Oe)},onDidCloseTerminal(ie,de,Oe){return Qe.onDidCloseTerminal(ie,de,Oe)},onDidOpenTerminal(ie,de,Oe){return Qe.onDidOpenTerminal(ie,de,Oe)},onDidChangeActiveTerminal(ie,de,Oe){return Qe.onDidChangeActiveTerminal(ie,de,Oe)},onDidChangeTerminalDimensions(ie,de,Oe){return(0,He.checkProposedApiEnabled)(Me,"terminalDimensions"),Qe.onDidChangeTerminalDimensions(ie,de,Oe)},onDidChangeTerminalState(ie,de,Oe){return Qe.onDidChangeTerminalState(ie,de,Oe)},onDidWriteTerminalData(ie,de,Oe){return(0,He.checkProposedApiEnabled)(Me,"terminalDataWriteEvent"),Qe.onDidWriteTerminalData(ie,de,Oe)},get state(){return ye.state},onDidChangeWindowState(ie,de,Oe){return ye.onDidChangeWindowState(ie,de,Oe)},showInformationMessage(ie,...de){return ti.showMessage(Me,U.default.Info,ie,de[0],de.slice(1))},showWarningMessage(ie,...de){return ti.showMessage(Me,U.default.Warning,ie,de[0],de.slice(1))},showErrorMessage(ie,...de){return ti.showMessage(Me,U.default.Error,ie,de[0],de.slice(1))},showQuickPick(ie,de,Oe){return Vt.showQuickPick(ie,de,Oe)},showWorkspaceFolderPick(ie){return Vt.showWorkspaceFolderPick(ie)},showInputBox(ie,de){return Vt.showInput(ie,de)},showOpenDialog(ie){return ai.showOpenDialog(ie)},showSaveDialog(ie){return ai.showSaveDialog(ie)},createStatusBarItem(ie,de,Oe){let it,wt,Tt;return typeof ie=="string"?(it=ie,wt=de,Tt=Oe):(wt=ie,Tt=de),Si.createStatusBarEntry(Me,it,wt,Tt)},setStatusBarMessage(ie,de){return Si.setStatusBarMessage(ie,de)},withScmProgress(ie){return we.report("window.withScmProgress",Me,"Use 'withProgress' instead."),_i.withProgress(Me,{location:$.ProgressLocation.SourceControl},(de,Oe)=>ie({report(it){}}))},withProgress(ie,de){return _i.withProgress(Me,ie,de)},createOutputChannel(ie,de){return _t.createOutputChannel(ie,de,Me)},createWebviewPanel(ie,de,Oe,it){return Zt.createWebviewPanel(Me,ie,de,Oe,it)},createWebviewTextEditorInset(ie,de,Oe,it){return(0,He.checkProposedApiEnabled)(Me,"editorInsets"),hi.createWebviewEditorInset(ie,de,Oe,it,Me)},createTerminal(ie,de,Oe){return typeof ie=="object"?"pty"in ie?Qe.createExtensionTerminal(ie):Qe.createTerminalFromOptions(ie):Qe.createTerminal(ie,de,Oe)},registerTerminalLinkProvider(ie){return Qe.registerLinkProvider(ie)},registerTerminalProfileProvider(ie,de){return Qe.registerProfileProvider(Me,ie,de)},registerTreeDataProvider(ie,de){return Ht.registerTreeDataProvider(ie,de,Me)},createTreeView(ie,de){return Ht.createTreeView(ie,de,Me)},registerWebviewPanelSerializer:(ie,de)=>Zt.registerWebviewPanelSerializer(Me,ie,de),registerCustomEditorProvider:(ie,de,Oe={})=>vi.registerCustomEditorProvider(Me,ie,de,Oe),registerFileDecorationProvider(ie){return Pe.registerFileDecorationProvider(ie,Me.identifier)},registerUriHandler(ie){return vt.registerUriHandler(Me.identifier,ie)},createQuickPick(){return Vt.createQuickPick(Me)},createInputBox(){return Vt.createInputBox(Me)},get activeColorTheme(){return oi.activeColorTheme},onDidChangeActiveColorTheme(ie,de,Oe){return oi.onDidChangeActiveColorTheme(ie,de,Oe)},registerWebviewViewProvider(ie,de,Oe){return ki.registerWebviewViewProvider(Me,ie,de,Oe?.webviewOptions)},get activeNotebookEditor(){return bt.activeNotebookEditor},onDidChangeActiveNotebookEditor(ie,de,Oe){return bt.onDidChangeActiveNotebookEditor(ie,de,Oe)},get visibleNotebookEditors(){return bt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return bt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(ie,de,Oe){return Ut.onDidChangeNotebookEditorSelection(ie,de,Oe)},onDidChangeNotebookEditorVisibleRanges(ie,de,Oe){return Ut.onDidChangeNotebookEditorVisibleRanges(ie,de,Oe)},showNotebookDocument(ie,de){return I.URI.isUri(ie)&&we.report("window.showNotebookDocument(uri)",Me,"Please use 'window.openNotebookDocument' and 'window.showTextDocument'"),bt.showNotebookDocument(ie,de)},registerExternalUriOpener(ie,de,Oe){return(0,He.checkProposedApiEnabled)(Me,"externalUriOpener"),Pi.registerExternalUriOpener(Me.identifier,ie,de,Oe)},get tabGroups(){return q.tabGroups}},Ft={get rootPath(){return we.report("workspace.rootPath",Me,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ft.getPath()},set rootPath(ie){throw C.readonly()},getWorkspaceFolder(ie){return ft.getWorkspaceFolder(ie)},get workspaceFolders(){return ft.getWorkspaceFolders()},get name(){return ft.name},set name(ie){throw C.readonly()},get workspaceFile(){return ft.workspaceFile},set workspaceFile(ie){throw C.readonly()},updateWorkspaceFolders:(ie,de,...Oe)=>ft.updateWorkspaceFolders(Me,ie,de||0,...Oe),onDidChangeWorkspaceFolders:function(ie,de,Oe){return ft.onDidChangeWorkspace(ie,de,Oe)},asRelativePath:(ie,de)=>ft.getRelativePath(ie,de),findFiles:(ie,de,Oe,it)=>ft.findFiles(ie,de,Oe,Me.identifier,it),findTextInFiles:(ie,de,Oe,it)=>{(0,He.checkProposedApiEnabled)(Me,"findTextInFiles");let wt,Tt;return typeof de=="object"?(wt=de,Tt=Oe):(wt={},Tt=de,it=Oe),ft.findTextInFiles(ie,wt||{},Tt,Me.identifier,it)},saveAll:ie=>ft.saveAll(ie),applyEdit(ie){return Ri.applyWorkspaceEdit(ie,Me)},createFileSystemWatcher:(ie,de,Oe,it)=>Bt.createFileSystemWatcher(ft,Me,ie,de,Oe,it),get textDocuments(){return ht.getAllDocumentData().map(ie=>ie.document)},set textDocuments(ie){throw C.readonly()},openTextDocument(ie){let de;const Oe=ie;if(typeof ie=="string")de=Promise.resolve(I.URI.file(ie));else if(I.URI.isUri(ie))de=Promise.resolve(ie);else if(!Oe||typeof Oe=="object")de=ht.createDocumentData(Oe);else throw new Error("illegal argument - uriOrFileNameOrOptions");return de.then(it=>ht.ensureDocumentData(it).then(wt=>wt.document))},onDidOpenTextDocument:(ie,de,Oe)=>ht.onDidAddDocument(ie,de,Oe),onDidCloseTextDocument:(ie,de,Oe)=>ht.onDidRemoveDocument(ie,de,Oe),onDidChangeTextDocument:(ie,de,Oe)=>ht.onDidChangeDocument(ie,de,Oe),onDidSaveTextDocument:(ie,de,Oe)=>ht.onDidSaveDocument(ie,de,Oe),onWillSaveTextDocument:(ie,de,Oe)=>Xt.getOnWillSaveTextDocumentEvent(Me)(ie,de,Oe),get notebookDocuments(){return bt.notebookDocuments.map(ie=>ie.apiNotebook)},async openNotebookDocument(ie,de){let Oe;if(I.URI.isUri(ie))Oe=ie,await bt.openNotebookDocument(ie);else if(typeof ie=="string")Oe=I.URI.revive(await bt.createNotebookDocument({viewType:ie,content:de}));else throw new Error("Invalid arguments");return bt.getNotebookDocument(Oe).apiNotebook},onDidSaveNotebookDocument(ie,de,Oe){return ni.onDidSaveNotebookDocument(ie,de,Oe)},onDidChangeNotebookDocument(ie,de,Oe){return ni.onDidChangeNotebookDocument(ie,de,Oe)},get onDidOpenNotebookDocument(){return bt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return bt.onDidCloseNotebookDocument},registerNotebookSerializer(ie,de,Oe,it){return bt.registerNotebookSerializer(Me,ie,de,Oe,(0,He.isProposedApiEnabled)(Me,"notebookLiveShare")?it:void 0)},registerNotebookContentProvider:(ie,de,Oe,it)=>((0,He.checkProposedApiEnabled)(Me,"notebookContentProvider"),we.report("workspace.registerNotebookContentProvider",Me,"The notebookContentProvider API is not on track for finalization and will be removed."),bt.registerNotebookContentProvider(Me,ie,de,Oe,(0,He.isProposedApiEnabled)(Me,"notebookLiveShare")?it:void 0)),onDidChangeConfiguration:(ie,de,Oe)=>ii.onDidChangeConfiguration(ie,de,Oe),getConfiguration(ie,de){return de=arguments.length===1?void 0:de,ii.getConfiguration(ie,de,Me)},registerTextDocumentContentProvider(ie,de){return Gt.registerTextDocumentContentProvider(ie,de)},registerTaskProvider:(ie,de)=>(we.report("window.registerTaskProvider",Me,"Use the corresponding function on the 'tasks' namespace instead"),pt.registerTaskProvider(Me,ie,de)),registerFileSystemProvider(ie,de,Oe){return(0,Je.combinedDisposable)(fi.registerFileSystemProvider(Me,ie,de,Oe),Mt.addFileSystemProvider(ie,de))},get fs(){return Mt.value},registerFileSearchProvider:(ie,de)=>((0,He.checkProposedApiEnabled)(Me,"fileSearchProvider"),gt.registerFileSearchProvider(ie,de)),registerTextSearchProvider:(ie,de)=>((0,He.checkProposedApiEnabled)(Me,"textSearchProvider"),gt.registerTextSearchProvider(ie,de)),registerRemoteAuthorityResolver:(ie,de)=>((0,He.checkProposedApiEnabled)(Me,"resolvers"),Dt.registerRemoteAuthorityResolver(ie,de)),registerResourceLabelFormatter:ie=>((0,He.checkProposedApiEnabled)(Me,"resolvers"),mi.$registerResourceLabelFormatter(ie)),onDidCreateFiles:(ie,de,Oe)=>Bt.onDidCreateFile(ie,de,Oe),onDidDeleteFiles:(ie,de,Oe)=>Bt.onDidDeleteFile(ie,de,Oe),onDidRenameFiles:(ie,de,Oe)=>Bt.onDidRenameFile(ie,de,Oe),onWillCreateFiles:(ie,de,Oe)=>Bt.getOnWillCreateFileEvent(Me)(ie,de,Oe),onWillDeleteFiles:(ie,de,Oe)=>Bt.getOnWillDeleteFileEvent(Me)(ie,de,Oe),onWillRenameFiles:(ie,de,Oe)=>Bt.getOnWillRenameFileEvent(Me)(ie,de,Oe),openTunnel:ie=>((0,He.checkProposedApiEnabled)(Me,"resolvers"),yt.openTunnel(Me,ie).then(de=>{if(!de)throw new Error("cannot open tunnel");return de})),get tunnels(){return(0,He.checkProposedApiEnabled)(Me,"resolvers"),yt.getTunnels()},onDidChangeTunnels:(ie,de,Oe)=>((0,He.checkProposedApiEnabled)(Me,"resolvers"),yt.onDidChangeTunnels(ie,de,Oe)),registerPortAttributesProvider:(ie,de)=>((0,He.checkProposedApiEnabled)(Me,"portsAttributes"),yt.registerPortsAttributesProvider(ie,de)),registerTimelineProvider:(ie,de)=>((0,He.checkProposedApiEnabled)(Me,"timeline"),gi.registerTimelineProvider(ie,de,Me.identifier,Ke.converter)),get isTrusted(){return ft.trusted},requestWorkspaceTrust:ie=>((0,He.checkProposedApiEnabled)(Me,"workspaceTrust"),ft.requestWorkspaceTrust(ie)),onDidGrantWorkspaceTrust:(ie,de,Oe)=>ft.onDidGrantWorkspaceTrust(ie,de,Oe)},li={get inputBox(){return we.report("scm.inputBox",Me,"Use 'SourceControl.inputBox' instead"),si.getLastInputBox(Me)},createSourceControl(ie,de,Oe){return si.createSourceControl(Me,ie,de,Oe)}},Li={createCommentController(ie,de){return Ti.createCommentController(Me,ie,de)}},Ui={get activeDebugSession(){return Ge.activeDebugSession},get activeDebugConsole(){return Ge.activeDebugConsole},get breakpoints(){return Ge.breakpoints},onDidStartDebugSession(ie,de,Oe){return Ge.onDidStartDebugSession(ie,de,Oe)},onDidTerminateDebugSession(ie,de,Oe){return Ge.onDidTerminateDebugSession(ie,de,Oe)},onDidChangeActiveDebugSession(ie,de,Oe){return Ge.onDidChangeActiveDebugSession(ie,de,Oe)},onDidReceiveDebugSessionCustomEvent(ie,de,Oe){return Ge.onDidReceiveDebugSessionCustomEvent(ie,de,Oe)},onDidChangeBreakpoints(ie,de,Oe){return Ge.onDidChangeBreakpoints(ie,de,Oe)},registerDebugConfigurationProvider(ie,de,Oe){return Ge.registerDebugConfigurationProvider(ie,de,Oe||nt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ie,de){return Ge.registerDebugAdapterDescriptorFactory(Me,ie,de)},registerDebugAdapterTrackerFactory(ie,de){return Ge.registerDebugAdapterTrackerFactory(ie,de)},startDebugging(ie,de,Oe){return!Oe||typeof Oe=="object"&&"configuration"in Oe?Ge.startDebugging(ie,de,{parentSession:Oe}):Ge.startDebugging(ie,de,Oe||{})},stopDebugging(ie){return Ge.stopDebugging(ie)},addBreakpoints(ie){return Ge.addBreakpoints(ie)},removeBreakpoints(ie){return Ge.removeBreakpoints(ie)},asDebugSourceUri(ie,de){return Ge.asDebugSourceUri(ie,de)}},Bi={registerTaskProvider:(ie,de)=>pt.registerTaskProvider(Me,ie,de),fetchTasks:ie=>pt.fetchTasks(ie),executeTask:ie=>pt.executeTask(Me,ie),get taskExecutions(){return pt.taskExecutions},onDidStartTask:(ie,de,Oe)=>pt.onDidStartTask(ie,de,Oe),onDidEndTask:(ie,de,Oe)=>pt.onDidEndTask(ie,de,Oe),onDidStartTaskProcess:(ie,de,Oe)=>pt.onDidStartTaskProcess(ie,de,Oe),onDidEndTaskProcess:(ie,de,Oe)=>pt.onDidEndTaskProcess(ie,de,Oe)},zi={createNotebookController(ie,de,Oe,it,wt){return ri.createNotebookController(Me,ie,de,Oe,it,(0,He.isProposedApiEnabled)(Me,"notebookMessaging")?wt:void 0)},registerNotebookCellStatusBarItemProvider:(ie,de)=>bt.registerNotebookCellStatusBarItemProvider(Me,ie,de),createRendererMessaging(ie){return Ii.createRendererMessaging(Me,ie)},onDidChangeNotebookCellExecutionState(ie,de,Oe){return(0,He.checkProposedApiEnabled)(Me,"notebookCellExecutionState"),ri.onDidChangeNotebookCellExecutionState(ie,de,Oe)}};return{version:dt.version,authentication:Fi,commands:Ni,comments:Li,debug:Ui,env:yi,extensions:zt,languages:jt,notebooks:zi,scm:li,tasks:Bi,tests:Ei,window:Mi,workspace:Ft,Breakpoint:$.Breakpoint,CallHierarchyIncomingCall:$.CallHierarchyIncomingCall,CallHierarchyItem:$.CallHierarchyItem,CallHierarchyOutgoingCall:$.CallHierarchyOutgoingCall,CancellationError:C.CancellationError,CancellationTokenSource:o.CancellationTokenSource,CandidatePortSource:m.CandidatePortSource,CodeAction:$.CodeAction,CodeActionKind:$.CodeActionKind,CodeActionTriggerKind:$.CodeActionTriggerKind,CodeLens:$.CodeLens,Color:$.Color,ColorInformation:$.ColorInformation,ColorPresentation:$.ColorPresentation,ColorThemeKind:$.ColorThemeKind,CommentMode:$.CommentMode,CommentThreadCollapsibleState:$.CommentThreadCollapsibleState,CommentThreadState:$.CommentThreadState,CompletionItem:$.CompletionItem,CompletionItemKind:$.CompletionItemKind,CompletionItemTag:$.CompletionItemTag,CompletionList:$.CompletionList,CompletionTriggerKind:$.CompletionTriggerKind,ConfigurationTarget:$.ConfigurationTarget,CustomExecution:$.CustomExecution,DebugAdapterExecutable:$.DebugAdapterExecutable,DebugAdapterInlineImplementation:$.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:$.DebugAdapterNamedPipeServer,DebugAdapterServer:$.DebugAdapterServer,DebugConfigurationProviderTriggerKind:nt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:$.DebugConsoleMode,DecorationRangeBehavior:$.DecorationRangeBehavior,Diagnostic:$.Diagnostic,DiagnosticRelatedInformation:$.DiagnosticRelatedInformation,DiagnosticSeverity:$.DiagnosticSeverity,DiagnosticTag:$.DiagnosticTag,Disposable:$.Disposable,DocumentHighlight:$.DocumentHighlight,DocumentHighlightKind:$.DocumentHighlightKind,DocumentLink:$.DocumentLink,DocumentSymbol:$.DocumentSymbol,EndOfLine:$.EndOfLine,EnvironmentVariableMutatorType:$.EnvironmentVariableMutatorType,EvaluatableExpression:$.EvaluatableExpression,InlineValueText:$.InlineValueText,InlineValueVariableLookup:$.InlineValueVariableLookup,InlineValueEvaluatableExpression:$.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:$.InlineCompletionTriggerKind,InlineCompletionTriggerKindNew:$.InlineCompletionTriggerKindNew,EventEmitter:p.Emitter,ExtensionKind:$.ExtensionKind,ExtensionMode:$.ExtensionMode,ExternalUriOpenerPriority:$.ExternalUriOpenerPriority,FileChangeType:$.FileChangeType,FileDecoration:$.FileDecoration,FileSystemError:$.FileSystemError,FileType:_.FileType,FilePermission:_.FilePermission,FoldingRange:$.FoldingRange,FoldingRangeKind:$.FoldingRangeKind,FunctionBreakpoint:$.FunctionBreakpoint,InlineCompletionItem:$.InlineSuggestion,InlineCompletionItemNew:$.InlineSuggestionNew,InlineCompletionList:$.InlineSuggestionList,InlineCompletionListNew:$.InlineSuggestionsNew,Hover:$.Hover,IndentAction:A.IndentAction,Location:$.Location,MarkdownString:$.MarkdownString,OverviewRulerLane:b.OverviewRulerLane,ParameterInformation:$.ParameterInformation,PortAutoForwardAction:$.PortAutoForwardAction,Position:$.Position,ProcessExecution:$.ProcessExecution,ProgressLocation:$.ProgressLocation,QuickInputButtons:$.QuickInputButtons,Range:$.Range,RelativePattern:$.RelativePattern,Selection:$.Selection,SelectionRange:$.SelectionRange,SemanticTokens:$.SemanticTokens,SemanticTokensBuilder:$.SemanticTokensBuilder,SemanticTokensEdit:$.SemanticTokensEdit,SemanticTokensEdits:$.SemanticTokensEdits,SemanticTokensLegend:$.SemanticTokensLegend,ShellExecution:$.ShellExecution,ShellQuoting:$.ShellQuoting,SignatureHelp:$.SignatureHelp,SignatureHelpTriggerKind:$.SignatureHelpTriggerKind,SignatureInformation:$.SignatureInformation,SnippetString:$.SnippetString,SourceBreakpoint:$.SourceBreakpoint,StandardTokenType:$.StandardTokenType,StatusBarAlignment:$.StatusBarAlignment,SymbolInformation:$.SymbolInformation,SymbolKind:$.SymbolKind,SymbolTag:$.SymbolTag,Task:$.Task,TaskGroup:$.TaskGroup,TaskPanelKind:$.TaskPanelKind,TaskRevealKind:$.TaskRevealKind,TaskScope:$.TaskScope,TerminalLink:$.TerminalLink,TerminalLocation:$.TerminalLocation,TerminalProfile:$.TerminalProfile,TextDocumentSaveReason:$.TextDocumentSaveReason,TextEdit:$.TextEdit,TextEditorCursorStyle:P.TextEditorCursorStyle,TextEditorLineNumbersStyle:$.TextEditorLineNumbersStyle,TextEditorRevealType:$.TextEditorRevealType,TextEditorSelectionChangeKind:$.TextEditorSelectionChangeKind,TextDocumentChangeReason:$.TextDocumentChangeReason,ThemeColor:$.ThemeColor,ThemeIcon:$.ThemeIcon,TreeItem:$.TreeItem,TreeItemCollapsibleState:$.TreeItemCollapsibleState,TypeHierarchyItem:$.TypeHierarchyItem,UIKind:T.UIKind,Uri:I.URI,ViewColumn:$.ViewColumn,WorkspaceEdit:$.WorkspaceEdit,DocumentDropEdit:$.DocumentDropEdit,DocumentPasteEdit:$.DocumentPasteEdit,InlayHint:$.InlayHint,InlayHintLabelPart:$.InlayHintLabelPart,InlayHintKind:$.InlayHintKind,RemoteAuthorityResolverError:$.RemoteAuthorityResolverError,ResolvedAuthority:$.ResolvedAuthority,SourceControlInputBoxValidationType:$.SourceControlInputBoxValidationType,ExtensionRuntime:$.ExtensionRuntime,TimelineItem:$.TimelineItem,NotebookRange:$.NotebookRange,NotebookCellKind:$.NotebookCellKind,NotebookCellExecutionState:$.NotebookCellExecutionState,NotebookCellData:$.NotebookCellData,NotebookData:$.NotebookData,NotebookRendererScript:$.NotebookRendererScript,NotebookCellStatusBarAlignment:$.NotebookCellStatusBarAlignment,NotebookEditorRevealType:$.NotebookEditorRevealType,NotebookCellOutput:$.NotebookCellOutput,NotebookCellOutputItem:$.NotebookCellOutputItem,NotebookCellStatusBarItem:$.NotebookCellStatusBarItem,NotebookControllerAffinity:$.NotebookControllerAffinity,NotebookEdit:$.NotebookEdit,PortAttributes:$.PortAttributes,LinkedEditingRanges:$.LinkedEditingRanges,TestResultState:$.TestResultState,TestRunRequest:$.TestRunRequest,TestMessage:$.TestMessage,TestTag:$.TestTag,TestRunProfileKind:$.TestRunProfileKind,TextSearchCompleteMessageType:Q.TextSearchCompleteMessageType,DataTransfer:$.DataTransfer,DataTransferItem:$.DataTransferItem,CoveredCount:$.CoveredCount,FileCoverage:$.FileCoverage,StatementCoverage:$.StatementCoverage,BranchCoverage:$.BranchCoverage,FunctionCoverage:$.FunctionCoverage,WorkspaceTrustState:$.WorkspaceTrustState,LanguageStatusSeverity:$.LanguageStatusSeverity,QuickPickItemKind:$.QuickPickItemKind,InputBoxValidationSeverity:$.InputBoxValidationSeverity,TabInputText:$.TextTabInput,TabInputTextDiff:$.TextDiffTabInput,TabInputCustom:$.CustomEditorTabInput,TabInputNotebook:$.NotebookEditorTabInput,TabInputNotebookDiff:$.NotebookDiffEditorTabInput,TabInputWebview:$.WebviewEditorTabInput,TabInputTerminal:$.TerminalEditorTabInput}}}e.createApiFactoryAndRegisterActors=ot}),define(De[236],Ce([1,0,235,33,2,229,6,13,220]),function(J,e,o,C,p,U,I,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class A extends U.RequireInterceptor{_installInterceptor(){}getModule(T,g){for(const h of this._alternatives){const u=h(T);if(u){T=u;break}}if(this._factories.has(T))return this._factories.get(T).load(T,g,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class R extends C.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=I.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){this._instaService.createInstance(b.ExtHostConsoleForwarder);const T=this._instaService.invokeFunction(o.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(A,T,{mine:this._myRegistry,all:this._globalRegistry}),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(T){return T.browser}async _loadCommonJSModule(T,g,h){g=g.with({path:_(g.path,".js")}),T&&performance.mark(`code/extHost/willFetchExtensionCode/${T.value}`);const u=p.URI.revive(await this._mainThreadExtensionsProxy.$asBrowserUri(g)),l=await fetch(u.toString(!0));if(T&&performance.mark(`code/extHost/didFetchExtensionCode/${T.value}`),l.status!==200)throw new Error(l.statusText);const S=await l.text(),w=`${g.toString(!0)}#vscode-extension`,a=`${S}
//# sourceURL=${w}`;let y;try{y=new Function("module","exports","require",a)}catch(s){throw console.error(T?`Loading code for extension ${T.value} failed: ${s.message}`:`Loading code failed: ${s.message}`),console.error(`${g.toString(!0)}${typeof s.line=="number"?` line ${s.line}`:""}${typeof s.column=="number"?` column ${s.column}`:""}`),console.error(s),s}const r={},d={exports:r},i=s=>{const n=this._fakeModules.getModule(s,g);if(n===void 0)throw new Error(`Cannot load module '${s}'`);return n};try{return h.codeLoadingStart(),T&&performance.mark(`code/extHost/willLoadExtensionCode/${T.value}`),y(d,r,i),d.exports!==r?d.exports:r}finally{T&&performance.mark(`code/extHost/didLoadExtensionCode/${T.value}`),h.codeLoadingStop()}}async $setRemoteEnvironment(T){}async _waitForDebuggerAttachment(T=5e3){if(!this._initData.environment.isExtensionDevelopmentDebug)return;const g=Date.now()+T;for(;Date.now()<g&&!("__jsDebugIsReady"in globalThis);)await(0,P.timeout)(10)}}e.ExtHostExtensionService=R;function _(m,T){return m.endsWith(T)?m:m+T}}),define(De[237],Ce([1,0,56,33,70,236]),function(J,e,o,C,p,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,o.registerSingleton)(C.IExtHostExtensionService,U.ExtHostExtensionService),(0,o.registerSingleton)(p.IExtensionStoragePaths,p.ExtensionStoragePaths)}),define(De[246],Ce([1,0,23,4,94,230,222,19,71,12,2,232,237]),function(J,e,o,C,p,U,I,P,b,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const _=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const m=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function T(r){return/^(file|vscode-remote):/i.test(r)}const g=fetch.bind(self);function h(r){self.fetch=async function(d,i){return d instanceof Request||T(String(d))&&(d=(await r(R.URI.parse(String(d)))).toString(!0)),g(d,i)},self.XMLHttpRequest=class extends XMLHttpRequest{open(d,i,s,n,t){(async()=>{T(i.toString())&&(i=(await r(R.URI.parse(i.toString()))).toString(!0)),super.open(d,i,s??!0,n,t)})()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const r=self.Worker;Worker=function(d,i){if(/^file:/i.test(d.toString()))d=A.FileAccess.asBrowserUri(R.URI.parse(d.toString())).toString(!0);else if(/^vscode-remote:/i.test(d.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const n=`(${function(f){function D(N){return typeof N=="string"||N instanceof URL?String(N).replace(/^file:\/\//i,"vscode-file://vscode-app"):N}const L=fetch.bind(self);self.fetch=function(N,v){return N instanceof Request?L(N,v):L(D(N),v)},self.XMLHttpRequest=class extends XMLHttpRequest{open(N,v,F,O,H){return super.open(N,D(v),F??!0,O,H)}};const W=importScripts.bind(self);self.importScripts=(...N)=>{W(...N.map(D))},W(f)}.toString()}('${d}'))`;i=i||{},i.name=i.name||P.basename(d.toString());const t=new Blob([n],{type:"application/javascript"}),c=URL.createObjectURL(t);return new r(c,i)}}else self.Worker=class extends I.NestedWorker{constructor(r,d){super(m,r,{name:P.basename(r.toString()),...d})}};const u=new class{constructor(){this.pid=void 0}exit(r){_()}async exists(r){return!0}async realpath(r){return r}};class l{constructor(){const d=new MessageChannel,i=new C.Emitter;let s=!1;m(d.port2,[d.port2]),d.port1.onmessage=n=>{const{data:t}=n;if(!(t instanceof ArrayBuffer)){console.warn("UNKNOWN data received",t);return}const c=o.VSBuffer.wrap(new Uint8Array(t,0,t.byteLength));if((0,p.isMessageOfType)(c,2)){s=!0,w("received terminate message from renderer");return}i.fire(c)},this.protocol={onMessage:i.event,send:n=>{if(!s){const t=n.buffer.buffer.slice(n.buffer.byteOffset,n.buffer.byteOffset+n.buffer.byteLength);d.port1.postMessage(t,[t])}}}}}function S(r){return new Promise(d=>{const i=r.onMessage(s=>{i.dispose();const n=JSON.parse(s.toString());r.send((0,p.createMessageOfType)(0)),d({protocol:r,initData:n})});r.send((0,p.createMessageOfType)(1))})}let w=r=>_();function a(r){return!!r&&typeof r=="object"&&r.type==="vscode.init"&&r.data instanceof Map}function y(){b.mark("code/extHost/willConnectToRenderer");const r=new l;return{onmessage(d){!a(d)||S(r.protocol).then(i=>{b.mark("code/extHost/didWaitForInitData");const s=new U.ExtensionHostMain(i.protocol,i.initData,u,null,d.data);h(n=>s.asBrowserUri(n)),w=n=>s.terminate(n)})}}}e.create=y})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/594ef48f32812d72d824ae855cb7a8be674f9704/core/vs/workbench/api/worker/extensionHostWorker.js.map
